unit ZLEBrakiDBDetailFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Modu dostarczajcy aktualizacje bazy.
Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2007-11-19 Tomjen   Utworzone
---------------------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBDetailFormUnit, Menus, UNIComponentsUnit, Db, ToolWin, ComCtrls,
  StdCtrls, ExtCtrls, Mask, DBCtrls,UNIStaleUnit, UNIDataModuleUnit;

type
  TZLEBrakiDBDetailForm = class(TUNIDBDetailForm)
    SymbolLabel: TUNILabel;
    NazwaLabel: TUNILabel;
    NazwaDBEdit: TUNIDBEdit;
    SymbolDBEdit: TUNIDBEdit;
    SkladnikCzasuPanel: TUNIPanel;
    SkladnikCzasuLabel: TUNILabel;
    SkladnikOpisLabel: TUNILabel;
    SkladnikCzasuPracyDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    function SkladnikCzasuPracyDBLookupAliasEditGetQuery: TUNIQuery;
    procedure SkladnikCzasuPracyDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function SkladnikCzasuPracyDBLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    function SkladnikCzasuPracyDBLookupAliasEditGetDataField: string;
    procedure SkladnikCzasuPracyDBLookupAliasEditDelKey(Sender: TObject);
  protected
    function  CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure BeforeShow; override;
  end;

var
  ZLEBrakiDBDetailForm: TZLEBrakiDBDetailForm;

implementation

{$R *.DFM}

uses
  FormManagerUnit,
  SQLManagerUnit,
  UNIDataManagerUnit,
  ZLEBrakiUnit,
  KDPRADefUnit,
  KDECPDataManagerExtUnit,
  KDDefUnit,
  KDDataManagerExtUnit,
  UNISysDataManagerUnit,
  FKDefUnit,
  ZLEDefUnit,
  Dodatki;

procedure TZLEBrakiDBDetailForm.BeforeShow;
begin
  inherited;
end;

function TZLEBrakiDBDetailForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  Result := TZLEBrakiDataModule.CreateOpen( self, DefaultMasterKeyValues, AOpenMode);
end;

procedure TZLEBrakiDBDetailForm.SkladnikCzasuPracyDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  SkladnikOpisLabel.Caption := '';
end;

function TZLEBrakiDBDetailForm.SkladnikCzasuPracyDBLookupAliasEditGetDataField: string;
begin
  result := sKDSKLADNIKCZASU_ID;
end;

function TZLEBrakiDBDetailForm.SkladnikCzasuPracyDBLookupAliasEditGetQuery: TUNIQuery;
begin
  Result := nil;
  if not DataManagers.Available(sKDPRAModulID) then Exit;

  Result := KDDM.KDPokazIObsluzDane(sKDSKLADNIKCZASU,
                                     sKDAlias_SKLADNIKCZASU_ID + ';' +
                                     sKDAlias_SKLADNIKCZASU_SYMBOL + ';' +
                                     sKDAlias_SKLADNIKCZASU_NAZWA,
                                     '@' + sKDAlias_SKLADNIKCZASU_ID + ' IN (SELECT ' + sKDSKLADNIKCZASU_ID + ' ' +
                                                                            'FROM ' + SQLManager.GetTableName(sZLESKLADNIKIECPDEF) + ') AND '
                                                                            + sKDSKLADNIKCZASU_TYPPOLA1 + ' = ' + QuotedStr(sTYPPOLA_GODZINY),
                                     true,
                                     false,
                                     UNISYSDM.vAktywnaFirma);
end;

procedure TZLEBrakiDBDetailForm.SkladnikCzasuPracyDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  if DataManagers.Available(sKDPRAModulID) then begin
    with SkladnikCzasuPracyDBLookupAliasEdit do begin
      AliasManager := KDDM.AliasManager;
      Alias_ID := sKDAlias_SKLADNIKCZASU_ID;
      Alias_Name := sKDAlias_SKLADNIKCZASU_SYMBOL;
      AdditionalAliases := sKDAlias_SKLADNIKCZASU_NAZWA;
      AdditionalCondition := '@' + sKDAlias_SKLADNIKCZASU_ID + ' IN (SELECT ' + sKDSKLADNIKCZASU_ID + ' ' +
                                                                    'FROM ' + SQLManager.GetTableName(sZLESKLADNIKIECPDEF) + ') AND '
                                                                            + sKDSKLADNIKCZASU_TYPPOLA1 + ' = ' + QuotedStr(sTYPPOLA_GODZINY);
    end;
  end;
end;

function TZLEBrakiDBDetailForm.SkladnikCzasuPracyDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  inherited;
  if AliasSrc <> nil then begin
     SkladnikOpisLabel.Caption := AliasSrc.FieldByName(sKDSKLADNIKCZASU_NAZWA).AsString;
  end;
  result := True;
end;

initialization
  FormManager.RegisterForm(TZLEBrakiDBDetailForm, sZLEModulID);
end.
