unit ZLEBrakiDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Modu dostarczajcy aktualizacje bazy.
Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2007-11-19 Tomjen   Utworzone
2010-09-06 Adam     Dodane funkcjonalnoci do brakw
---------------------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls, UNIStaleUnit, UNIDataModuleUnit;

type
  TZleBrakiDBGridForm = class(TUNIDBGridForm)
  private
    procedure OpenDetail(AOpenMode: TOpenMode);
  protected
    procedure New(); override;
    procedure Open(); override;
    procedure View(); override;
    procedure Delete(); override;
    function  CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure SetUserRights; override;
  public
    procedure InternalOpen(); override;
  end;

var
  ZleBrakiDBGridForm: TZleBrakiDBGridForm;

implementation
uses
  Dodatki,
  FormManagerUnit,
  SecurityManagerUnit,
  UNIDBDetailFormUnit,
  KeyManagerUnit,
  ZLEdefUnit,
  ZleBrakiUnit,
  ZLEDataManagerUnit,
  UNISysDefUnit;


{$R *.DFM}

function TZleBrakiDBGridForm.CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZleBrakiDataModule.CreateOpen(Self, DefaultMasterKeyValues, AOpenMode);
end;

procedure TZleBrakiDBGridForm.Delete;
begin
  OpenDetail(omDelete);
end;

procedure TZleBrakiDBGridForm.InternalOpen;
begin
  if Parameters <> nil then
     if Parameters.Values[cFORM_CAPTION] <> '' then
        Caption := Parameters.Values[cFORM_CAPTION];
  inherited;
end;

procedure TZleBrakiDBGridForm.New;
begin
  OpenDetail(omNew);
end;

procedure TZleBrakiDBGridForm.Open;
begin
  OpenDetail(omEdit);
end;

procedure TZleBrakiDBGridForm.OpenDetail(AOpenMode: TOpenMode);
var
  oParams: TKeyValues;
begin
  inherited;
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add(cFORM_CAPTION+'='+'Szczegy rejestracji czasu pracy');
  end;

  AOpenMode := AOpenMode;
  FormManager.OpenDBDetail(Self, 'TZleBrakiDBDetailForm', AOpenMode, oParams);
end;

procedure TZleBrakiDBGridForm.View;
begin
  OpenDetail(omView);
end;

procedure TZleBrakiDBGridForm.SetUserRights;
begin
  with SecurityManager do begin
    Switch_View_HotKey(SM_UserCanDo(sZLE_USTAW_SLOW_BRAKI_POKAZ));
    Switch_New_HotKey(SM_UserCanDo(sZLE_USTAW_SLOW_BRAKI_DOPISZ));
    Switch_Open_HotKey(SM_UserCanDo(sZLE_USTAW_SLOW_BRAKI_ZMIEN));
    Switch_Delete_HotKey(SM_UserCanDo(sZLE_USTAW_SLOW_BRAKI_USUN));
  end;
end;

initialization
  FormManager.RegisterForm( TZleBrakiDBGridForm, 'Rejestracja czasu pracy', sZLEModulID );
end.
