unit ZLEBrakiUnit;
{
 Copyright Unisoft Sp. z o.o.

Modu dostarczajcy aktualizacje bazy.
Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2007-11-19 Tomjen   Utworzone
---------------------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLEBrakiDataModule = class(TUNIDataModule)
  protected
    procedure GetKeys; override;
    function  GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;
  public
    procedure Post; override;
  private
    m_sZleBrakiId   : string;
    m_iZleBrakiIdx  : integer;

    procedure ComposeConditions();
  end;

var
  ZLEBrakiDataModule: TZLEBrakiDataModule;

implementation

{$R *.DFM}

uses ZLEDefUnit, SQLManagerUnit, UNIStaleUnit, Dodatki,
     ZLEBrakiDBDetailFormUnit, UNISysDefUnit, KeyManagerUnit, UNIFormUnit;

procedure TZLEBrakiDataModule.GetKeys;
begin
  with FKeys do begin
    Clear;
    Add(sZLEBraki_ID);
  end;
end;

function TZLEBrakiDataModule.GetTableName: string;
begin
  Result:=sZLEBraki;
end;

procedure TZLEBrakiDataModule.InitializeGridQueryDefs;
begin
  if GridColDefs.Count = 0 then with GridColDefs do begin
    AddRequired(sZLEBRAKI_ID,   'K','', False, taLeftJustify,0);
    Add(sZLEBraki_SYMBOL,  'K','Symbol',True,True, taLeftJustify,90);
    Add(sZLEBraki_NAZWA,   'K','Nazwa',True,True,  taLeftJustify,450);
  end;

  if GridTabDefs.Count=0 then with GridTabDefs do begin
    Clear;
    Add('K',GetTableName);
  end;

  with GridJoinDefs do begin
    Clear;
    m_iZleBrakiIdx := AddEmptyCondition();
  end;

  ComposeConditions();
  inherited;
end;

procedure TZLEBrakiDataModule.Post;
  var
    trans:boolean;
begin
  trans:= not SQLManager.InTransaction;
  if trans then SQLManager.StartTransaction;
  try
    inherited;
    if trans then SQLManager.Commit;
  except
    on EDMException do begin
      if trans then SQLManager.Rollback;
      if FLastDBError.SQLObjectName=sZLEBraki+'1'+c_UNK then begin
        Komunikat( cError,'Istnieje ju taki element');
        {with owner as TZLEBrakiDBDetailForm do
           ActiveControl:= SymbolDBEdit;}
        abort;
      end else raise;
    end else begin
      if trans then SQLManager.Rollback;
      raise;
    end;
  end;

end;

procedure TZLEBrakiDataModule.ComposeConditions();
var
  oParams:        TKeyValues;
begin
  if(not ParamIsNotEmpty(MasterKeyValues, sZLEBRAKI_ID, m_sZleBrakiId)) then begin
    oParams := TKeyValues.CreateEmpty();
    try
      (Owner as TUNIForm).GetParametersForForm((Owner as TUNIForm), oParams);
      ParamIsNotEmpty(oParams, sZLEBraki_ID, m_sZleBrakiId);
    finally
      oParams.Free();
    end;
  end;  // if nie ma id zlecenia w MasterKeyValues
  if(Length(m_sZleBrakiId) > 0) then begin
    GridJoinDefs.ExchangeCondition(m_iZleBrakiIdx, 'K.' + sZLEBraki_ID  + ' = ' + m_sZleBrakiId, true);
  end else begin
    GridJoinDefs.ExchangeCondition(m_iZleBrakiIdx, '', false);
  end;
end;

end.
