unit ZLEDataManagerExtUnit;
{$I ..\!\defines.inc}
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-18 gdeyk    Utworzone
2008-03-14 Adam     Dodana funkcja ZLEDopiszZlecenieZPozycjiZapytan
2008-09-18 Adam     Dodany parametr ac_iTypZlecId do funkcji ZLEDopiszZlecenieZPozycjiZapotrzebowan,
                    ZLEDopiszZlecenieZPozycjiZamowien i ZLEDopiszZlecenieZPozycjiZapytan
2010-05-21 Adam     Moliwo wysyania do partnera wybranych elementw planu produkcji
2011-01-05 Adam     Dodana funkcja ZLEDopiszZlecenieNieProdZPozycjiZamowien
2011-03-04 Adam     Dodana funkcja ZLEDopiszZlecenieNieProdZPozycjiZapotrzebowan
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, DB,
  UNIDataManagerUnit, Menus, UNIComponentsUnit, ZLEDefUnit, LFKDefUnit, UNIDBGridFormUnit,
  UNIDBDetailFormUnit, UniStaleUnit, AliasManagerUnit, KeyManagerUnit;

type
  TZLEDataManagerExt = class(TUNIDataManager)
  private
    function GetZLEDomyslnyStatusZlecenia: String;
    function GetZLEDomyslnyTypZlecenia: Integer;
    function GetZLEInstalacjeTypZlec: Integer;
    function GetZLEWymaganaOsobaZamykajacaZlecenie: Boolean;
    function GetZLESprawyPodpowiadanie: Boolean;
    function GetZLESprawyKontrahent: String;
    function GetZLESprawyWydzial: String;
    function GetZLESprawyPrefix: String;
    function GetZLENarzuty: Boolean;
    function GetZLEPoziomNarzutowJednOrg: Boolean;
    function GetZLEPoziomNarzutowOddzial: Boolean;
    function GetZLEPoziomNarzutowTypZlec: Boolean;
    function GetZLEStawkaRegula: String;
    function GetZLEUnikalnoscElemInf: Boolean;
    function GetZLEKosztyMatZakupWlaczone: Boolean;
    function GetZLEZleceniaBezPozycjiZeSpraw: Boolean;
    function GetAliasManager(): TAliasManager;
  public
    function ZLEOdpytajODaneSQL( sTabela, sAtrybuty, sWarunek: string;
                                 bUnikalne: boolean) : string;

    function ZLEOdpytajODane( sTabela, sAtrybuty, sWarunek: string;
                              bUnikalne: boolean) : TUNIQuery;
    function ZLEZlecenieOtwarte( sSymbol: String; dData: TDate ): Boolean;
    function ZLEPokazIObsluzDane( sTabela, sAtrybuty, sWarunek: string;
                                  bBlok, bWyborWielu: Boolean;
                                  iModulZSIID: Integer = 0;
                                  iLocateID: integer = 0;
                                  iFirmaID: integer = 0;
                                  sPola: String = '';
                                  oSelected: TStrings = nil;
                                  oLocateContained: TStrings = nil;
                                  oParams: TKeyValues = nil ): TUNIQuery;
    function ZLEPokazIObsluzDaneGrid( const oOwner:TComponent;
                                      sTabela, sAtrybuty, sWarunek: string;
                                      bBlok, bWyborWielu: Boolean;
                                      iOpenMode: TOpenMode;
                                      iModulZSIID: Integer = 0;
                                      iLocateID: integer = 0;
                                      iFirmaID: integer = 0;
                                      oLocateContained: TStrings = nil;
                                      oParams: TKeyValues = nil;
                                      sSufiksKlasy: String = '' ): TUNIDBGridForm;
    function ZLEPokazIObsluzTypZlecenia( sAtrybuty, sWarunek: string;
                                         bBlok, bWyborWielu: Boolean;
                                         iModulZSIID: Integer = 0;
                                         iLocateID: integer = 0;
                                         iFirmaID: integer = 0): TUNIQuery;
    function ZLEPokazIObsluzTypZleceniaGrid(const oOwner:TComponent; sAtrybuty, sWarunek: string;
                                             bBlok, bWyborWielu: Boolean;
                                             iOpenMode: TOpenMode;
                                             iModulZSIID: Integer = 0;
                                             iLocateID: integer = 0;
                                             iFirmaID: integer = 0 ): TUNIDBGridForm;
    function ZLEPokazIObsluzZleceniaGrid( const oOwner:TComponent; sAtrybuty, sWarunek: string;
                                          bBlok, bWyborWielu: Boolean;
                                          iOpenMode: TOpenMode;
                                          iModulZSIID: Integer;
                                          iLocateID: integer = 0;
                                          iFirmaID: integer = 0;
                                          oLocateContained: TStrings = nil;
                                          oParams: TKeyValues = nil;
                                          sSufiksKlasy: String = '' ): TUNIDBGridForm;
    function ZLEPokazIObsluzZlecenia( sAtrybuty, sWarunek: string;
                                      bBlok, bWyborWielu: Boolean;
                                      iModulZSIID: Integer;
                                      iLocateID: integer = 0;
                                      iFirmaID: integer = 0;
                                      oSelected: TStrings = nil;
                                      oLocateContained: TStrings = nil;
                                      oParams: TKeyValues = nil ): TUNIQuery;

    function UNIPokazIObsluzSlownik(sAtrybuty, sTabela, sPole, sTekst: string;
                                     iMnemonikID:integer=0;
                                     iPozycjonowanie: Integer = 0;
                                     bWyborWielu:boolean = false;
                                     a_oSelectedId : TStringList = nil;
                                     oParams: TKeyValues = nil): TUNIQuery; override;

    function ZLEKontrolaZlecenia( iZlecenieID: Integer;
                                  sAtrybuty: string;
                                  bBlok: Boolean;
                                  iModulZSIID: Integer;
                                  iFirmaID: integer = 0): TUNIQuery;
    function ZLEKontrolaZleceniaGrid(const oOwner:TComponent; iZlecenieID: Integer;
                                      sAtrybuty: string;
                                      bBlok: Boolean;
                                      iOpenMode: TOpenMode;
                                      iModulZSIID: Integer;
                                      iFirmaID: integer = 0): TUNIDBDetailForm;
    function ZLEDopiszZlecenie( const cTypOperacji: TSposobNadaniaGrupy;
                                var iGrupaID: Integer;
                                iTypZleceniaID: Integer;
                                iModulZSIID: Integer;
                                iFirmaID: Integer = 0 ): Integer;
    function ZLEKontrolaUnikalnosciElemInf( iTypZleceniaID: Integer;
                                            iInfElementID: Integer;
                                            sPoziomInf: String;
                                            iZlecenieID: Integer): Boolean;
    function ZLEDopiszZlecenieGrupujace( iTypZleceniaID, iModulZSIID: Integer;
                                         sSymbol, sNazwa, sOpis: String;
                                         dDataOtwarcia: TDate;
                                         iFirmaID: Integer = 0 ): Integer;
    function ZLEDajIdTypElemGrup( iTypZleceniaID: Integer;
                               iFirmaID: Integer = 0 ): Integer;
    function ZLEDajIdElemGrup( iZlecenieID: Integer;
                            iFirmaID: Integer = 0 ): Integer;
    function ZLEDajListeSkladTypu( iGrupaID, iTypZleceniaID: Integer;
                                iFirmaID: Integer = 0 ): TUNIQuery;
    function ZLEDajListeWartSklad( iGrupaID, iZlecenieID: Integer;
                                iFirmaID: Integer = 0 ): TUNIQuery;
    function ZLEZapiszWartSklad(  iGrupaID, iZlecenieID, iZleceniePozID: Integer;
                              Skladniki: TZLEListaSkladnikow;
                              iFirmaID: Integer = 0 ): Boolean;
    procedure ZLEPokazIObsluzDetail(
                      const ac_sTabela:     string;
                      const ac_iId:         integer;
                      const ac_iOpenMode:   TOpenMode;
                      const ac_iModulID:    integer = cZLEMODULZSI_ID;
                            a_oParams:      TKeyValues  = nil
              );
    function  ZLEDopiszZlecenieZPozycjiZapotrzebowan(
                      const ac_sZapotrzPozId: string;
                      const ac_iTypZlecId:    integer // domylny typ zlecenia
              ):  TIntegerArray;
    function  ZLEDopiszZlecenieZPozycjiZamowien(
                      const ac_sZamowieniePozId:string;
                      const ac_iTypZlecId:      integer // domylny typ zlecenia
              ):  TIntegerArray;
      {
        Funkcja dopisuje wizualnie JEDNO zlecenie nieprodukcyjne z pozycjami utworzonymi
        z przekazanych pozycji zamwie
      }
    function  ZLEDopiszZlecenieNieProdZPozycjiZamowien(
                      const ac_iAdmIdFunkId:    integer;// funkcja z ADMID gdzie s zapisane idki pozycji zamwie z ktrych ma by utworzone zlecenie
                      const ac_iTypZlecId:      integer // domylny typ zlecenia
              ):  integer;
      {
        Funkcja dopisuje wizualnie JEDNO zlecenie nieprodukcyjne z pozycjami utworzonymi
        z przekazanych pozycji zapotrzebowa
      }
    function  ZLEDopiszZlecenieNieProdZPozycjiZapotrzebowan(
                      const ac_iAdmIdFunkId:    integer;// funkcja z ADMID gdzie s zapisane idki pozycji zapotrzebowa z ktrych ma by utworzone zlecenie
                      const ac_iTypZlecId:      integer // domylny typ zlecenia
              ):  integer;
    function  ZLEDopiszZlecenieZPozycjiZapytan(
                      const ac_sZapytaniePozId: string;
                      const ac_iTypZlecId:      integer // domylny typ zlecenia
              ):  TIntegerArray;
    function  ZLEDopiszZlecenieNieProdZPozycjiZapytan(
                      const ac_iAdmIdFunkId:    integer;// funkcja z ADMID gdzie s zapisane idki pozycji zapyta wejciowych z ktrych ma by utworzone zlecenie
                      const ac_iTypZlecId:      integer // domylny typ zlecenia
              ):  integer;
    function ZLEDajWartoscPracy(iZLECENIE_ID, iUNIOKRES_ID: Integer;
                                RODZAJECP: string = '';
                                RODZAJZASOBU: String = ''): Extended;
    function ZLEDajKosztyZleceniaSzczegolowo(iZLECENIE_ID, iUNIOKRES_ID: Integer;
                                             aRodzajKosztow: TZleRodzajKosztow;
                                             a_oParams: TKeyValues  = nil): TUNIQuery;
    function ZleDajKosztyZleceniaSzczegolowoSuma(iZLECENIE_ID, iUNIOKRES_ID: Integer;
                                                 a_oParams: TKeyValues  = nil): Extended;

    procedure ZLEPokazZasob(
                              const ac_iZasobId:  integer
              );

    function ZLEDajWartoscKryterium(iFirmaID: integer;
             sKryteriaSymbol: string; iFKMnemonikiID: integer; sZakres,
             sKrytPozWartoscTyp, sKryteriaRodzaj: string;
             iOkresID:integer; bAnalizy:boolean = false): TUNIQuery;

    function ZLEMnemonikiDlaZlecenia(iZlecenieID : Integer;
                                     var av_aMnem: TaMnemValue): Integer;

    procedure ZLEListaMnemonikow(slMnemZle: TStringList;
                                 iFirmaID: Integer = 0);

      {
        Funkcja ustawia podanemu zleceniu status na ac_sNowyStatus
        @param  ac_iZlecenieId  - id zlecenia, ktremu ma by zmieniony status
        @param  ac_sNowyStatus  - nowy status ktry ma mie zlecenie
      }
    procedure ZmienStatusZlecenia(
                      const ac_iZlecenieId:     integer;
                      const ac_sNowyStatus:     string
              );
      {
        Funkcja sprawdza czy podane zlecenie zostao wysane do partnera (istnieje zapis w ZLEZLECENIEOBCY).
        @param  ac_iZlecenieId  - id zlecenia
      }
    function  ZlecenieWyslaneDoPartnera(
                      const ac_iZlecenieId:     integer
              ):  boolean;
      {
        Funkcja sprawdza czy podana receptura zostaa wysana do partnera (istnieje zapis w ZLEZLECENIEOBCY).
        @param  ac_iRecepturaId - id receptury
      }
    function  RecepturaWyslanaDoPartnera(
                      const ac_iRecepturaId:    integer
              ):  boolean;
      {
        Funkcja sprawdza czy podana pozycja receptury zostaa wysana do partnera (istnieje zapis w ZLEZLECENIEOBCY).
        @param  ac_iRecepturaPozId - id pozycji receptury
      }
    function  RecepturaPozWyslanaDoPartnera(
                      const ac_iRecepturaPozId: integer
              ):  boolean;
      {
        Funkcja sprawdza czy podany element planu zosta wysana do partnera (istnieje zapis w ZLEZLECENIEOBCY).
        @param  ac_iPlanProdElId  - id elementu planu produkcji
      }
    function  PlanProdElWyslanyDoPartnera(
                      const ac_iPlanProdElId:   integer
              ):  boolean;

    //Funkcja dla analiz zwracajca Wartosc pozycji dla okreslonego opisu parametrw
    function ZLEFunAnalizy_ZLEDanePozycji(
                       iFirmaID: integer;
                       sRok, sOpisParametrow: string;
                       var iLiczbaSlownikow:integer;
                       bSymulacja:boolean=false;
                       iAktywnyOkresNr:integer=0;
                       bTylkoNiezerowe:boolean=false;
                       bZestawienieZDokumentami:boolean=false): TUNIQuery;
      {
        Wysya do partnera zlecenia, ktrych id znajduj si na licie ac_oZlecIds
      }
    procedure WyslijPlanProdukcjiZlec(
                        const ac_oZlecIds:            TStringList;
                        const ac_sKontekst:           string;
                        const ac_oPlanProdElId:       TStringList = nil // identyfikatory elementw planu produkcji podawane jeeli maj by wysane tylko te elementy a nie cae zlecenia
              );
      {
        Wycofuje z systemu partnera zlecenia, ktrych id znajduj si na licie ac_oZlecIds
      }
    procedure WycofajPlanProdukcjiZlec(
                        const ac_oZlecIds:            TStringList;
                        const ac_sKontekst:           string;
                        const ac_oPlanProdElId:       TStringList = nil // identyfikatory elementw planu produkcji podawane jeeli maj by wysane tylko te elementy a nie cae zlecenia
              );
      {
        Funkcja sprawdza czy mona modyfikowa podane zlecenie produkcyjne. Sprawdza czy
        nie jest umieszczone na planie produkcji.
        Zwraca '' jeeli mona edytowa lub komunikat dlaczego edycja nie jest dozwolona.
      }
    function  MoznaEdytowacZlecenieProdukcyjne(
                      const ac_iZlecenieId:       integer
              ):  string;

    property vZLEDomyslnyStatusZlecenia: String read GetZLEDomyslnyStatusZlecenia;
    property vZLEDomyslnyTypZlecenia: Integer read GetZLEDomyslnyTypZlecenia;
    property vZLEInstalacjeTypZlec: Integer read GetZLEInstalacjeTypZlec;
    property vZLEWymaganaOsobaZamykajacaZlecenie: Boolean read GetZLEWymaganaOsobaZamykajacaZlecenie;
    property vZLEKosztyMatZakupWlaczone: Boolean read GetZLEKosztyMatZakupWlaczone;

    property vZLESprawyPodpowiadanie: Boolean read GetZLESprawyPodpowiadanie;
    property vZLESprawyKontrahent: String read GetZLESprawyKontrahent;
    property vZLESprawyWydzial: String read GetZLESprawyWydzial;
    property vZLESprawyPrefix: String read GetZLESprawyPrefix;
    property vZLENarzuty: Boolean read GetZLENarzuty;
    property vZLEPoziomNarzutowJednOrg: Boolean read GetZLEPoziomNarzutowJednOrg;
    property vZLEPoziomNarzutowOddzial: Boolean read GetZLEPoziomNarzutowOddzial;
    property vZLEPoziomNarzutowTypZlec: Boolean read GetZLEPoziomNarzutowTypZlec;
    property vZLEStawkaRegula: String read GetZLEStawkaRegula;
    property vZLEUnikalnoscElemInf: Boolean read GetZLEUnikalnoscElemInf;
    property vZLEZleceniaBezPozycjiZeSpraw: Boolean read GetZLEZleceniaBezPozycjiZeSpraw;
    property AliasManager: TAliasManager read GetAliasManager;
  end;

  EOF_ZLEException = class(EOFException)
    constructor Create( const Msg: string); overload;
  end;

var
  ZLEDataManager : TZLEDataManagerExt;
  ZLEDM : TZLEDataManagerExt;

implementation

uses
  UniSysDataManagerUnit,
  UniSysDefUnit;


{$R *.DFM}

constructor EOF_ZLEException.Create( const Msg: string);
begin
  inherited Create(msg);
  Module:= sZLEModulID;
end;

{ TZLEDataManagerExt }

function TZLEDataManagerExt.ZLEDajWartoscKryterium(iFirmaID: integer;
            sKryteriaSymbol: string; iFKMnemonikiID: integer; sZakres,
            sKrytPozWartoscTyp, sKryteriaRodzaj: string;
            iOkresID:integer; bAnalizy:boolean = false): TUNIQuery;
var
   p: function(iFirmaID: integer;
            sKryteriaSymbol: string; iFKMnemonikiID: integer; sZakres,
            sKrytPozWartoscTyp, sKryteriaRodzaj: string;
            iOkresID:integer; bAnalizy:boolean = false): TUNIQuery;

begin
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEDajWartoscKryterium');
  if @p<>nil then result := p(iFirmaID,
            sKryteriaSymbol, iFKMnemonikiID, sZakres,
            sKrytPozWartoscTyp, sKryteriaRodzaj,
            iOkresID, bAnalizy)
  else Result := nil;
end;

function TZLEDataManagerExt.ZLEMnemonikiDlaZlecenia(iZlecenieID : Integer;
                                                    var av_aMnem: TaMnemValue): Integer;
var
   p: function(iZlecenieID : Integer;
               var av_aMnem: TaMnemValue): Integer;

begin
  result := 0;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEMnemonikiDlaZlecenia');
  if @p<>nil then result := p(iZlecenieID, av_aMnem);
end;

procedure TZLEDataManagerExt.ZLEListaMnemonikow(slMnemZle: TStringList;
                                                iFirmaID: Integer = 0);
var
  p:  procedure(slMnemZle: TStringList;
                iFirmaID: Integer = 0);
begin
  @p:= GetProcAddress(DataManagers.GetHandle(sZLEModulID), 'DLL_ZLEListaMnemonikow');
  if @p<>nil then p(slMnemZle, iFirmaID);
end;

{
  Funkcja ustawia podanemu zleceniu status na ac_sNowyStatus
  @param  ac_iZlecenieId  - id zlecenia, ktremu ma by zmieniony status
  @param  ac_sNowyStatus  - nowy status ktry ma mie zlecenie
}
procedure TZLEDataManagerExt.ZmienStatusZlecenia(
  const ac_iZlecenieId:     integer;
  const ac_sNowyStatus:     string
);
var
  p:  procedure(
          const ac_iZlecenieId:     integer;
          const ac_sNowyStatus:     string
      );
begin
  @p  := GetProcAddress(DataManagers.GetHandle(sZLEModulID), 'DLL_ZmienStatusZlecenia');
  if(@p <> nil) then
    p(ac_iZlecenieId, ac_sNowyStatus);
end;

{
  Funkcja sprawdza czy podane zlecenie zostao wysane do partnera (istnieje zapis w ZLEZLECENIEOBCY).
  @param  ac_iZlecenieId  - id zlecenia
}
function  TZLEDataManagerExt.ZlecenieWyslaneDoPartnera(
  const ac_iZlecenieId:     integer
):  boolean;
var
  p:  function(
          const ac_iZlecenieId:     integer
      ):  boolean;
begin
  @p  := GetProcAddress(DataManagers.GetHandle(sZLEModulID), 'DLL_ZlecenieWyslaneDoPartnera');
  if(@p <> nil) then
    result  := p(ac_iZlecenieId)
  else
    result  := false;
end;

{
  Funkcja sprawdza czy podana receptura zostaa wysana do partnera (istnieje zapis w ZLEZLECENIEOBCY).
  @param  ac_iRecepturaId - id receptury
}
function  TZLEDataManagerExt.RecepturaWyslanaDoPartnera(
  const ac_iRecepturaId:    integer
):  boolean;
var
  p:  function(
          const ac_iRecepturaId:    integer
      ):  boolean;
begin
  @p  := GetProcAddress(DataManagers.GetHandle(sZLEModulID), 'DLL_RecepturaWyslanaDoPartnera');
  if(@p <> nil) then
    result  := p(ac_iRecepturaId)
  else
    result  := false;
end;

{
  Funkcja sprawdza czy podana pozycja receptury zostaa wysana do partnera (istnieje zapis w ZLEZLECENIEOBCY).
  @param  ac_iRecepturaPozId - id pozycji receptury
}
function  TZLEDataManagerExt.RecepturaPozWyslanaDoPartnera(
  const ac_iRecepturaPozId: integer
):  boolean;
var
  p:  function(
          const ac_iRecepturaPozId: integer
      ):  boolean;
begin
  @p  := GetProcAddress(DataManagers.GetHandle(sZLEModulID), 'DLL_RecepturaPozWyslanaDoPartnera');
  if(@p <> nil) then
    result  := p(ac_iRecepturaPozId)
  else
    result  := false;
end;

{
  Funkcja sprawdza czy podany element planu zosta wysana do partnera (istnieje zapis w ZLEZLECENIEOBCY).
  @param  ac_iPlanProdElId  - id elementu planu produkcji
}
function  TZLEDataManagerExt.PlanProdElWyslanyDoPartnera(
  const ac_iPlanProdElId:   integer
):  boolean;
var
  p:  function(
          const ac_iPlanProdElId:   integer
      ):  boolean;
begin
  @p  := GetProcAddress(DataManagers.GetHandle(sZLEModulID), 'DLL_PlanProdElWyslanyDoPartnera');
  if(@p <> nil) then
    result  := p(ac_iPlanProdElId)
  else
    result  := false;
end;

function TZLEDataManagerExt.GetZLEDomyslnyStatusZlecenia: String;
var
  p:  function : string;
begin
  result := '';
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_vZLEDomyslnyStatusZlecenia');
  if @p<>nil then result := p;
end;

function TZLEDataManagerExt.GetZLEDomyslnyTypZlecenia: Integer;
var
  p:  function : Integer;
begin
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_vZLEDomyslnyTypZlecenia');
  if @p<>nil then result := p
  else Result := 0;
end;

function TZLEDataManagerExt.GetZLEInstalacjeTypZlec: Integer;
var
  p:  function : Integer;
begin
  result := 0;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_vZLEInstalacjeTypZlec');
  if @p<>nil then result := p;
end;

function TZLEDataManagerExt.GetZLEWymaganaOsobaZamykajacaZlecenie: Boolean;
var
  p: function : boolean;
begin
  result := false;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_vZLEWymaganaOsobaZamykajacaZlecenie');
  if @p<>nil then result := p;
end;

function TZLEDataManagerExt.GetZLEKosztyMatZakupWlaczone: Boolean;
var
  p: function : boolean;
begin
  result := false;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_vZLEKosztyMatZakupWlaczone');
  if @p<>nil then result := p;
end;

function TZLEDataManagerExt.GetZLESprawyPodpowiadanie: Boolean;
var
  p: function : boolean;
begin
  Result := false;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_vZLESprawyPodpowiadanie');
  if @p<>nil then result := p;
end;

function TZLEDataManagerExt.GetZLESprawyKontrahent: String;
var
  p:  function : string;
begin
  result := '';
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_vZLESprawyKontrahent');
  if @p<>nil then result := p;
end;

function TZLEDataManagerExt.GetZLESprawyWydzial: String;
var
  p:  function : string;
begin
  result := '';
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_vZLESprawyWydzial');
  if @p<>nil then result := p;
end;

function TZLEDataManagerExt.GetZLESprawyPrefix: String;
var
  p:  function : string;
begin
  result := '';
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_vZLESprawyPrefix');
  if @p<>nil then result := p;
end;

function TZLEDataManagerExt.GetZLEStawkaRegula: String;
var
  p:  function : string;
begin
  result := '';
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_vZLEStawkaRegula');
  if @p<>nil then result := p;
end;

function TZLEDataManagerExt.GetZLENarzuty: Boolean;
var
  p: function : boolean;
begin
  result := false;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_vZLENarzuty');
  if @p<>nil then result := p;
end;

function TZLEDataManagerExt.GetZLEPoziomNarzutowJednOrg: Boolean;
var
  p: function : boolean;
begin
  Result := false;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_vZLEPoziomNarzutowJednOrg');
  if @p<>nil then result := p;
end;

function TZLEDataManagerExt.GetZLEPoziomNarzutowOddzial: Boolean;
var
  p: function : boolean;
begin
  Result := false;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_vZLEPoziomNarzutowOddzial');
  if @p<>nil then result := p;
end;

function TZLEDataManagerExt.GetZLEPoziomNarzutowtypZlec: Boolean;
var
  p: function : boolean;
begin
  Result := false;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_vZLEPoziomNarzutowtypZlec');
  if @p<>nil then result := p;
end;

function TZLEDataManagerExt.GetZLEUnikalnoscElemInf: Boolean;
var
  p: function : boolean;
begin
  Result := false;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_vZLEUnikalnoscElemInf');
  if @p<>nil then result := p;
end;

function TZLEDataManagerExt.GetZLEZleceniaBezPozycjiZeSpraw: Boolean;
var
  p: function : boolean;
begin
  Result := false;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_vZLEZleceniaBezPozycjiZeSpraw');
  if @p<>nil then result := p;
end;

function TZLEDataManagerExt.ZLEDajIdElemGrup( iZlecenieID, iFirmaID: Integer): Integer;
var
  p: function ( iZlecenieID, iFirmaID: Integer ): Integer;
begin
  Result := 0;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEDajIdElemGrup');
  if @p<>nil then result := p( iZlecenieID, iFirmaID );
end;

function TZLEDataManagerExt.ZLEDajIdTypElemGrup( iTypZleceniaID, iFirmaID: Integer): Integer;
var
  p: function ( iTypZleceniaID, iFirmaID: Integer ): Integer;
begin
  Result := 0;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEDajIdTypElemGrup');
  if @p<>nil then result := p( iTypZleceniaID, iFirmaID );
end;

function TZLEDataManagerExt.ZLEDajListeSkladTypu( iGrupaID, iTypZleceniaID,
                                                  iFirmaID: Integer ): TUNIQuery;
var
  p: function ( iGrupaID, iTypZleceniaID, iFirmaID: Integer ): TUNIQuery;
begin
  Result := nil;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEDajIdTypElemGrup');
  if @p<>nil then result := p( iGrupaID, iTypZleceniaID, iFirmaID );
end;

function TZLEDataManagerExt.ZLEDajListeWartSklad( iGrupaID, iZlecenieID,
                                                  iFirmaID: Integer): TUNIQuery;
var
  p: function ( iGrupaID, iZlecenieID, iFirmaID: Integer ): TUNIQuery;
begin
  Result := nil;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEDajListeWartSklad');
  if @p<>nil then result := p( iGrupaID, iZlecenieID, iFirmaID );
end;

function TZLEDataManagerExt.ZLEDopiszZlecenie( const cTypOperacji: TSposobNadaniaGrupy;
                                               var iGrupaID: Integer;
                                               iTypZleceniaID, iModulZSIID,
                                               iFirmaID: Integer): Integer;
var
  p: function ( const cTypOperacji: TSposobNadaniaGrupy;
                var iGrupaID: Integer;
                iTypZleceniaID, iModulZSIID,
                iFirmaID: Integer): Integer;
begin
  result := 0;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEDopiszZlecenie');
  if @p<>nil then result := p( cTypOperacji, iGrupaID, iTypZleceniaID,
                               iModulZSIID, iFirmaID );
end;

function TZLEDataManagerExt.ZLEKontrolaUnikalnosciElemInf(iTypZleceniaID: Integer;
                                                          iInfElementID: Integer;
                                                          sPoziomInf: String;
                                                          iZlecenieID: Integer): Boolean;
var
  p: function (iTypZleceniaID: Integer; iInfElementID: Integer;
               sPoziomInf: String; iZlecenieID: Integer): Boolean;
begin
  result := False;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEKontrolaUnikalnosciElemInf');
  if @p<>nil then result := p(iTypZleceniaID, iInfElementID,
                              sPoziomInf, iZlecenieID);
end;

function TZLEDataManagerExt.ZLEDopiszZlecenieGrupujace( iTypZleceniaID,
                                                        iModulZSIID: Integer;
                                                        sSymbol, sNazwa, sOpis: String;
                                                        dDataOtwarcia: TDate;
                                                        iFirmaID: Integer): Integer;
var
  p: function ( iTypZleceniaID, iModulZSIID: Integer;
                sSymbol, sNazwa, sOpis: String;
                dDataOtwarcia: TDate;
                iFirmaID: Integer ): Integer;
begin
  Result := 0;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEDopiszZlecenieGrupujace');
  if @p<>nil then result := p( iTypZleceniaID, iModulZSIID, sSymbol, sNazwa, sOpis,
                               dDataOtwarcia, iFirmaID );
end;

function TZLEDataManagerExt.ZLEOdpytajODane(sTabela, sAtrybuty,
  sWarunek: string; bUnikalne: boolean): TUNIQuery;
var
  p1: function (sTabela, sAtrybuty, sWarunek: string; bUnikalne: boolean): TUNIQuery;
  {$ifndef build_UNISYS}
  p2: function (sTabela, sAtrybuty, sWarunek: string; bUnikalne: boolean; iFirmaID: Integer): TUNIQuery;
  {$endif}
begin
  result := nil;
  if DataManagers.Available(sZLEModulID) then begin
    @p1:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEOdpytajODane');
    if @p1<>nil then result := p1( sTabela, sAtrybuty, sWarunek, bUnikalne );
  end else begin
    {$ifdef build_UNISYS}
    result := UniSysDM.UNIOdpytajODane( sTabela, sAtrybuty, sWarunek, bUnikalne,
                                        vAktywnaFirma );
    {$else}
    @p2:= GetProcAddress( DataManagers.GetHandle(sUniSysModulID),'DLL_UNIOdpytajODane');
    if @p2<>nil then result := p2( sTabela, sAtrybuty, sWarunek, bUnikalne, vAktywnaFirma );
    {$endif}
  end;
end;

function TZLEDataManagerExt.ZLEOdpytajODaneSQL(sTabela, sAtrybuty,
  sWarunek: string; bUnikalne: boolean): string;
var
  p1: function (sTabela, sAtrybuty, sWarunek: string; bUnikalne: boolean): string;
  {$ifndef build_UNISYS}
  p2: function (sTabela, sAtrybuty, sWarunek: string; bUnikalne: boolean; iFirmaID: Integer): string;
  {$endif}  
begin
  Result := '';
  if DataManagers.Available(sZLEModulID) then begin
    @p1:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEOdpytajODaneSQL');
    if @p1<>nil then result := p1( sTabela, sAtrybuty, sWarunek, bUnikalne );
  end else begin
    {$ifdef build_UNISYS}
    result := UniSysDM.UNIOdpytajODaneSQL( sTabela, sAtrybuty, sWarunek, bUnikalne,
                                           vAktywnaFirma );
    {$else}
    @p2:= GetProcAddress( DataManagers.GetHandle(sUniSysModulID),'DLL_UNIOdpytajODaneSQL');
    if @p2<>nil then result := p2( sTabela, sAtrybuty, sWarunek, bUnikalne, vAktywnaFirma );
    {$endif}
  end;
end;

function TZLEDataManagerExt.ZLEPokazIObsluzDane(sTabela, sAtrybuty,
  sWarunek: string; bBlok, bWyborWielu: Boolean; iModulZSIID, iLocateID,
  iFirmaID: integer; sPola: String; oSelected: TStrings;
  oLocateContained: TStrings; oParams: TKeyValues): TUNIQuery;
var
  p: function (sTabela, sAtrybuty,sWarunek: string; bBlok, bWyborWielu: Boolean; iModulZSIID, iLocateID,
              iFirmaID: integer; sPola: String; oSelected: TStrings;
              oLocateContained: TStrings; oParams: TKeyValues): TUNIQuery;
  {$ifndef build_UNISYS}
  r: function (sTabela, sAtrybuty,sWarunek: string; bBlok, bWyborWielu: Boolean; iModulZSIID, iLocateID,
              iFirmaID: integer): TUNIQuery;
  {$endif}
begin
  Result := nil;
  if DataManagers.Available(sZLEModulID) then begin
    @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEPokazIObsluzDane');
    if @p<>nil then result := p( sTabela, sAtrybuty, sWarunek, bBlok,
                                 bWyborWielu, iModulZSIID, iLocateID, iFirmaID,
                                 sPola, oSelected, oLocateContained, oParams );
  end else begin
    {$ifdef build_UNISYS}
    result := UniSysDM.ZLEPokazIObsluzDane( sTabela, sAtrybuty, sWarunek, bBlok,
                                            bWyborWielu, iModulZSIID, iLocateID, iFirmaID );
    {$else}
    @r:= GetProcAddress( DataManagers.GetHandle(sUniSysModulID),'DLL_ZLEPokazIObsluzDane');
    if @r<>nil then result := r( sTabela, sAtrybuty, sWarunek, bBlok,
                                 bWyborWielu, iModulZSIID, iLocateID, iFirmaID );
    {$endif}
  end;
end;

function TZLEDataManagerExt.ZLEPokazIObsluzDaneGrid(const oOwner:TComponent; sTabela, sAtrybuty,
  sWarunek: string; bBlok, bWyborWielu: Boolean; iOpenMode: TOpenMode; iModulZSIID, iLocateID,
  iFirmaID: integer; oLocateContained: TStrings; oParams: TKeyValues;
  sSufiksKlasy: String): TUNIDBGridForm;
var
  p: function ( const oOwner:TComponent; sTabela, sAtrybuty,sWarunek: string;
                bBlok, bWyborWielu: Boolean;
                iOpenMode: TOpenMode;
                iModulZSIID, iLocateID,
                iFirmaID: integer;
                oLocateContained: TStrings;
                oParams: TKeyValues;
                sSufiksKlasy: String ): TUNIDBGridForm;
begin
  Result := nil;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEPokazIObsluzDaneGrid');
  if @p<>nil then result := p(oOwner, sTabela, sAtrybuty, sWarunek, bBlok,
                               bWyborWielu, iOpenMode, iModulZSIID, iLocateID,
                               iFirmaID, oLocateContained, oParams, sSufiksKlasy );
end;

function TZLEDataManagerExt.ZLEPokazIObsluzTypZlecenia(sAtrybuty,
  sWarunek: string; bBlok, bWyborWielu: Boolean;
  iModulZSIID, iLocateID, iFirmaID: integer): TUNIQuery;
var
  p: function( sAtrybuty, sWarunek: string; bBlok, bWyborWielu: Boolean;
               iModulZSIID, iLocateID, iFirmaID: integer): TUNIQuery;
begin
  if DataManagers.Available(sZLEModulID) then begin
    @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEPokazIObsluzTypZlecenia');
    if @p<>nil then result := p( sAtrybuty, sWarunek, bBlok, bWyborWielu,
                                 iModulZSIID, iLocateID, iFirmaID )
    else Result := nil;
  end else begin
    {$ifdef build_UNISYS}
    result := UniSysDM.ZLEPokazIObsluzTypZlecenia( sAtrybuty, sWarunek, bBlok, bWyborWielu,
                                                   iModulZSIID, iLocateID, iFirmaID );
    {$else}
    @p:= GetProcAddress( DataManagers.GetHandle(sUniSysModulID),'DLL_ZLEPokazIObsluzTypZlecenia');
    if @p<>nil then result := p( sAtrybuty, sWarunek, bBlok, bWyborWielu,
                                 iModulZSIID, iLocateID, iFirmaID )
    else Result := nil;
    {$endif}
  end;
end;

function TZLEDataManagerExt.ZLEPokazIObsluzTypZleceniaGrid(const oOwner:TComponent; sAtrybuty,
  sWarunek: string; bBlok, bWyborWielu: Boolean;     iOpenMode: TOpenMode; iModulZSIID, iLocateID,
  iFirmaID: integer): TUNIDBGridForm;
var
  p: function(const oOwner:TComponent; sAtrybuty, sWarunek: string; bBlok, bWyborWielu: Boolean; iOpenMode: TOpenMode;
               iModulZSIID, iLocateID, iFirmaID: integer): TUNIDBGridForm;
begin
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEPokazIObsluzTypZleceniaGrid');
  if @p<>nil then result := p(oOwner, sAtrybuty, sWarunek, bBlok, bWyborWielu, iOpenMode,
                               iModulZSIID, iLocateID, iFirmaID )
  else Result := nil;
end;

function TZLEDataManagerExt.ZLEPokazIObsluzZlecenia(sAtrybuty,
  sWarunek: string; bBlok, bWyborWielu: Boolean; iModulZSIID, iLocateID,
  iFirmaID: integer; oSelected: TStrings; oLocateContained: TStrings;
  oParams: TKeyValues): TUNIQuery;
var
  p: function (sAtrybuty, sWarunek: string; bBlok, bWyborWielu: Boolean; iModulZSIID, iLocateID,
                iFirmaID: integer; oSelected: TStrings; oLocateContained: TStrings;
                oParams: TKeyValues): TUNIQuery;
  {$ifndef build_UNISYS}
  r: function (sAtrybuty, sWarunek: string; bBlok, bWyborWielu: Boolean; iModulZSIID, iLocateID,
                iFirmaID: integer): TUNIQuery;
  {$endif}
begin
  if DataManagers.Available(sZLEModulID) then begin
    @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEPokazIObsluzZlecenia');
    if @p<>nil then result := p( sAtrybuty, sWarunek, bBlok, bWyborWielu,
                                 iModulZSIID, iLocateID, iFirmaID,
                                 oSelected, oLocateContained, oParams )
    else Result := nil;
  end else begin
    {$ifdef build_UNISYS}
    result := UniSysDM.ZLEPokazIObsluzZlecenia( sAtrybuty, sWarunek, bBlok, bWyborWielu,
                                                iModulZSIID, iLocateID, iFirmaID );
    {$else}
    @r:= GetProcAddress( DataManagers.GetHandle(sUniSysModulID),'DLL_ZLEPokazIObsluzZlecenia');
    if @r<>nil then result := r( sAtrybuty, sWarunek, bBlok, bWyborWielu,
                                 iModulZSIID, iLocateID, iFirmaID )
    else Result := nil;
    {$endif}
  end;
end;

function TZLEDataManagerExt.UNIPokazIObsluzSlownik(sAtrybuty, sTabela, sPole, sTekst: string;
                                                   iMnemonikID:integer=0;
                                                   iPozycjonowanie: Integer = 0;
                                                   bWyborWielu:boolean = false;
                                                   a_oSelectedId : TStringList = nil;
                                                   oParams: TKeyValues = nil): TUNIQuery;
var
  p: function (sAtrybuty, sTabela, sPole, sWarunek: string;
               iMnemonikID:integer=0;
               iPozycjonowanie: Integer = 0;
               bWyborWielu:boolean = false;
               a_oSelectedId : TStringList = nil;
               oParams: TKeyValues = nil): TUNIQuery;
begin
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_UNIPokazIObsluzSlownik');
  if @p<>nil then begin
    Result := p(sAtrybuty, sTabela, sPole, sTekst, iMnemonikID,
                iPozycjonowanie, bWyborWielu, a_oSelectedId, oParams);
  end else
    result  := nil;
end;


function TZLEDataManagerExt.ZLEPokazIObsluzZleceniaGrid( const oOwner:TComponent;
                                                         sAtrybuty, sWarunek: string;
                                                         bBlok, bWyborWielu: Boolean;
                                                         iOpenMode: TOpenMode;
                                                         iModulZSIID, iLocateID, iFirmaID: integer;
                                                         oLocateContained: TStrings;
                                                         oParams: TKeyValues;
                                                         sSufiksKlasy: String ): TUNIDBGridForm;
var
  p: function ( const oOwner: TComponent; sAtrybuty, sWarunek: string;
                bBlok, bWyborWielu: Boolean;
                iOpenMode: TOpenMode;
                iModulZSIID, iLocateID,
                iFirmaID: integer;
                oLocateContained: TStrings;
                oParams: TKeyValues;
                sSufiksKlasy: String ): TUNIDBGridForm;
  {$ifndef build_UNISYS}
  r: function ( const oOwner: TComponent;
                sAtrybuty, sWarunek: string;
                bBlok, bWyborWielu: Boolean;
                iOpenMode: TOpenMode;
                iModulZSIID, iLocateID,
                iFirmaID: integer;
                oParams: TKeyValues;
                sSufiksKlasy: String ): TUNIDBGridForm;
  {$endif}
begin
  if DataManagers.Available(sZLEModulID) then begin
    @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEPokazIObsluzZleceniaGrid');
    if @p<>nil then result := p( oOwner, sAtrybuty, sWarunek, bBlok, bWyborWielu,
                                 iOpenMode, iModulZSIID, iLocateID, iFirmaID,
                                 oLocateContained, oParams, sSufiksKlasy )
    else Result := nil;
  end else begin
    {$ifdef build_UNISYS}
    result := UniSysDM.ZLEPokazIObsluzZleceniaGrid( oOwner, sAtrybuty, sWarunek, bBlok, bWyborWielu,
                                                    iOpenMode, iModulZSIID, iLocateID, iFirmaID,
                                                    oParams, sSufiksKlasy );
    {$else}
    @r:= GetProcAddress( DataManagers.GetHandle(sUniSysModulID),'DLL_ZLEPokazIObsluzZleceniaGrid');
    if @r<>nil then result := r( oOwner, sAtrybuty, sWarunek, bBlok, bWyborWielu,
                                 iOpenMode, iModulZSIID, iLocateID, iFirmaID,
                                 oParams, sSufiksKlasy )
    else Result := nil;
    {$endif}
  end;
end;

function TZLEDataManagerExt.ZLEKontrolaZlecenia(iZlecenieID: Integer;
  sAtrybuty: string; bBlok: Boolean; iModulZSIID, iFirmaID: integer): TUNIQuery;
var
  p: function ( iZlecenieID: Integer; sAtrybuty: string; bBlok: Boolean;
                iModulZSIID, iFirmaID: integer): TUNIQuery;
begin
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEKontrolaZlecenia');
  if @p<>nil then result := p( iZlecenieID, sAtrybuty, bBlok, iModulZSIID, iFirmaID )
  else Result := nil;
end;

function TZLEDataManagerExt.ZLEKontrolaZleceniaGrid(const oOwner:TComponent; iZlecenieID: Integer;
  sAtrybuty: string; bBlok: Boolean; iOpenMode: TOpenMode; iModulZSIID, iFirmaID: integer): TUNIDBDetailForm;
var
  p: function (const oOwner:TComponent; iZlecenieID: Integer; sAtrybuty: string; bBlok: Boolean; iOpenMode: TOpenMode;
                iModulZSIID, iFirmaID: integer): TUNIDBDetailForm;
begin
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEKontrolaZleceniaGrid');
  if @p<>nil then result := p(oOwner, iZlecenieID, sAtrybuty, bBlok, iOpenMode, iModulZSIID, iFirmaID )
  else Result := nil;
end;

function TZLEDataManagerExt.ZLEZapiszWartSklad(iGrupaID, iZlecenieID,
  iZleceniePozID: Integer; Skladniki: TZLEListaSkladnikow;
  iFirmaID: Integer): Boolean;
begin
 Result := false;
end;

procedure TZLEDataManagerExt.ZLEPokazIObsluzDetail(
  const ac_sTabela:     string;
  const ac_iId:         integer;
  const ac_iOpenMode:   TOpenMode;
  const ac_iModulID:    integer;
        a_oParams:      TKeyValues
);
var
  p:  procedure(
            const ac_sTabela:     string;
            const ac_iId:         integer;
            const ac_iOpenMode:   TOpenMode;
            const ac_iModulID:    integer;
                  a_oParams:      TKeyValues
  );
begin
  if DataManagers.Available(sZLEModulID) then begin
    @p  := GetProcAddress(DataManagers.GetHandle(sZLEModulID), 'DLL_ZLEPokazIObsluzDetail');
    if(@p <> nil) then begin
      p(
        ac_sTabela,
        ac_iId,
        ac_iOpenMode,
        ac_iModulID,
        a_oParams
      );
    end;
  end else begin
    {$ifdef build_UNISYS}
    UniSysDM.ZLEPokazIObsluzDetail( ac_sTabela, ac_iId, ac_iOpenMode, ac_iModulID, a_oParams);
    {$else}
    @p := GetProcAddress( DataManagers.GetHandle(sUniSysModulID), 'DLL_ZLEPokazIObsluzDetail');
    if @p<>nil then p( ac_sTabela, ac_iId, ac_iOpenMode, ac_iModulID, a_oParams);
    {$endif}
  end;
end;


//Funkcja dla analiz zwracajca Wartosc pozycji dla okreslonego opisu parametrw
function TZLEDataManagerExt.ZLEFunAnalizy_ZLEDanePozycji(
                       iFirmaID: integer;
                       sRok, sOpisParametrow: string;
                       var iLiczbaSlownikow:integer;
                       bSymulacja:boolean=false;
                       iAktywnyOkresNr:integer=0;
                       bTylkoNiezerowe:boolean=false;
                       bZestawienieZDokumentami:boolean=false): TUNIQuery;
var
  p: function (iFirmaID: integer;
               sRok, sOpisParametrow: string;
               var iLiczbaSlownikow:integer;
               bSymulacja:boolean=false;
               iAktywnyOkresNr:integer=0;
               bTylkoNiezerowe:boolean=false;
               bZestawienieZDokumentami:boolean=false): TUNIQuery;
begin
  result:=NIL;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEFunAnalizy_ZLEDanePozycji');
  if @p<>nil then
    result:= p(iFirmaID, sRok, sOpisParametrow, iLiczbaSlownikow, bSymulacja,
               iAktywnyOkresNr, bTylkoNiezerowe, bZestawienieZDokumentami);
end;

  {
    Wysya do partnera zlecenia, ktrych id znajduj si na licie ac_oZlecIds
  }
procedure TZLEDataManagerExt.WyslijPlanProdukcjiZlec(
  const ac_oZlecIds:            TStringList;
  const ac_sKontekst:           string;
  const ac_oPlanProdElId:       TStringList = nil // identyfikatory elementw planu produkcji podawane jeeli maj by wysane tylko te elementy a nie cae zlecenia
);
var
  p:  procedure(
        const ac_oZlecIds:            TStringList;
        const ac_sKontekst:           string;
        const ac_oPlanProdElId:       TStringList // identyfikatory elementw planu produkcji podawane jeeli maj by wysane tylko te elementy a nie cae zlecenia
      );
begin
  @p  := GetProcAddress( DataManagers.GetHandle(sZLEModulID), 'DLL_WyslijPlanProdukcjiZlec');
  if(@p <> nil) then
    p(ac_oZlecIds, ac_sKontekst, ac_oPlanProdElId);
end;

  {
    Wycofuje z systemu partnera zlecenia, ktrych id znajduj si na licie ac_oZlecIds
  }
procedure TZLEDataManagerExt.WycofajPlanProdukcjiZlec(
  const ac_oZlecIds:            TStringList;
  const ac_sKontekst:           string;
  const ac_oPlanProdElId:       TStringList = nil // identyfikatory elementw planu produkcji podawane jeeli maj by wysane tylko te elementy a nie cae zlecenia
);
var
  p:  procedure(
        const ac_oZlecIds:            TStringList;
        const ac_sKontekst:           string;
        const ac_oPlanProdElId:       TStringList
      );
begin
  @p  := GetProcAddress( DataManagers.GetHandle(sZLEModulID), 'DLL_WycofajPlanProdukcjiZlec');
  if(@p <> nil) then
    p(ac_oZlecIds, ac_sKontekst, ac_oPlanProdElId);
end;

  {
    Funkcja sprawdza czy mona modyfikowa podane zlecenie produkcyjne. Sprawdza czy
    nie jest umieszczone na planie produkcji.
    Zwraca '' jeeli mona edytowa lub komunikat dlaczego edycja nie jest dozwolona.
  }
function  TZLEDataManagerExt.MoznaEdytowacZlecenieProdukcyjne(
  const ac_iZlecenieId:       integer
):  string;
var
  p:  function(
            const ac_iZlecenieId:       integer
  ):  string;
begin
  @p  := GetProcAddress(DataManagers.GetHandle(sZLEModulID), 'DLL_MoznaEdytowacZlecenieProdukcyjne');
  if(@p <> nil) then
    result  := p(ac_iZlecenieId)
  else
    result  := '';
end;

function  TZLEDataManagerExt.ZLEDopiszZlecenieZPozycjiZapotrzebowan(
  const ac_sZapotrzPozId: string;
  const ac_iTypZlecId:    integer // domylny typ zlecenia
):  TIntegerArray;
var
  p:  function(
            const ac_sZapotrzPozId: string;
            const ac_iTypZlecId:    integer
  ):  TIntegerArray;
begin
  @p  := GetProcAddress(DataManagers.GetHandle(sZLEModulID), 'DLL_ZLEDopiszZlecenieZPozycjiZapotrzebowan');
  if(@p <> nil) then
    result  := p(ac_sZapotrzPozId, ac_iTypZlecId)
  else
    SetLength(result, 0);
end;

function  TZLEDataManagerExt.ZLEDopiszZlecenieZPozycjiZamowien(
  const ac_sZamowieniePozId:string;
  const ac_iTypZlecId:      integer // domylny typ zlecenia
):  TIntegerArray;
var
  p:  function(
            const ac_sZamowieniePozId:string;
            const ac_iTypZlecId:      integer // domylny typ zlecenia
  ):  TIntegerArray;
begin
  @p  := GetProcAddress(DataManagers.GetHandle(sZLEModulID), 'DLL_ZLEDopiszZlecenieZPozycjiZamowien');
  if(@p <> nil) then
    result  := p(ac_sZamowieniePozId, ac_iTypZlecId)
  else
    SetLength(result, 0);
end;

  {
    Funkcja dopisuje wizualnie JEDNO zlecenie nieprodukcyjne z pozycjami utworzonymi
    z przekazanych pozycji zamwie
  }
function  TZLEDataManagerExt.ZLEDopiszZlecenieNieProdZPozycjiZamowien(
  const ac_iAdmIdFunkId:    integer;// funkcja z ADMID gdzie s zapisane idki pozycji zamwie z ktrych ma by utworzone zlecenie
  const ac_iTypZlecId:      integer // domylny typ zlecenia
):  integer;
var
  p:  function(
            const ac_iAdmIdFunkId:    integer;// funkcja z ADMID gdzie s zapisane idki pozycji zamwie z ktrych ma by utworzone zlecenie
            const ac_iTypZlecId:      integer // domylny typ zlecenia
  ):  integer;
begin
  @p  := GetProcAddress(DataManagers.GetHandle(sZLEModulID), 'DLL_ZLEDopiszZlecenieNieProdZPozycjiZamowien');
  if(@p <> nil) then
    result  := p(ac_iAdmIdFunkId, ac_iTypZlecId)
  else
    result  := 0;
end;

  {
    Funkcja dopisuje wizualnie JEDNO zlecenie nieprodukcyjne z pozycjami utworzonymi
    z przekazanych pozycji zapotrzebowa
  }
function  TZLEDataManagerExt.ZLEDopiszZlecenieNieProdZPozycjiZapotrzebowan(
  const ac_iAdmIdFunkId:    integer;// funkcja z ADMID gdzie s zapisane idki pozycji zapotrzebowa z ktrych ma by utworzone zlecenie
  const ac_iTypZlecId:      integer // domylny typ zlecenia
):  integer;
var
  p:  function(
            const ac_iAdmIdFunkId:    integer;// funkcja z ADMID gdzie s zapisane idki pozycji zapotrzebowa z ktrych ma by utworzone zlecenie
            const ac_iTypZlecId:      integer // domylny typ zlecenia
  ):  integer;
begin
  @p  := GetProcAddress(DataManagers.GetHandle(sZLEModulID), 'DLL_ZLEDopiszZlecenieNieProdZPozycjiZapotrzebowan');
  if(@p <> nil) then
    result  := p(ac_iAdmIdFunkId, ac_iTypZlecId)
  else
    result  := 0;
end;

function  TZLEDataManagerExt.ZLEDopiszZlecenieZPozycjiZapytan(
  const ac_sZapytaniePozId: string;
  const ac_iTypZlecId:      integer // domylny typ zlecenia
):  TIntegerArray;
var
  p:  function(
            const ac_sZapytaniePozId: string;
            const ac_iTypZlecId:      integer // domylny typ zlecenia
  ):  TIntegerArray;
begin
  @p  := GetProcAddress(DataManagers.GetHandle(sZLEModulID), 'DLL_ZLEDopiszZlecenieZPozycjiZapytan');
  if(@p <> nil) then
    result  := p(ac_sZapytaniePozId, ac_iTypZlecId)
  else
    SetLength(result, 0);
end;

function TZLEDataManagerExt.ZLEZlecenieOtwarte( sSymbol: String;
                                                dData: TDate): Boolean;
var
  p: function ( sSymbol: String; dData: TDate ): Boolean;
begin
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEZlecenieOtwarte');
  if @p<>nil then result := p( sSymbol, dData )
  else Result := false;
end;

function TZLEDataManagerExt.GetAliasManager: TAliasManager;
begin
  if not DataManagers.Available( sZLEModulID ) then
    result := UniSysDM.AliasManager
  else result := inherited AliasManager;
end;

function TZLEDataManagerExt.ZLEDajKosztyZleceniaSzczegolowo(iZLECENIE_ID, iUNIOKRES_ID: Integer;
                                                            aRodzajKosztow: TZleRodzajKosztow;
                                                            a_oParams: TKeyValues  = nil): TUNIQuery;
var
  p: function (iZLECENIE_ID, iUNIOKRES_ID: Integer;
               aRodzajKosztow: TZleRodzajKosztow;
               a_oParams: TKeyValues  = nil): TUNIQuery;
begin
  Result := nil;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEDajKosztyZleceniaSzczegolowo');
  if @p<>nil then result := p( iZLECENIE_ID, iUNIOKRES_ID, aRodzajKosztow, a_oParams);
end;

function TZLEDataManagerExt.ZleDajKosztyZleceniaSzczegolowoSuma(iZLECENIE_ID, iUNIOKRES_ID: Integer;
                                                                a_oParams: TKeyValues  = nil): Extended;
var
  p: function ( iZLECENIE_ID, iUNIOKRES_ID: Integer;
                a_oParams: TKeyValues  = nil): Extended;
begin
  Result := 0.00;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEDajKosztyZleceniaSzczegolowoSuma');
  if @p<>nil then result := p( iZLECENIE_ID, iUNIOKRES_ID, a_oParams );
end;

procedure TZLEDataManagerExt.ZLEPokazZasob(
  const ac_iZasobId:  integer
);
var
  p:  procedure(const ac_iZasobId:  integer);
begin
  @p:= GetProcAddress(DataManagers.GetHandle(sZLEModulID), 'DLL_ZLEPokazZasob');
  if @p<>nil then
    p(ac_iZasobId);
end;

function  TZLEDataManagerExt.ZLEDopiszZlecenieNieProdZPozycjiZapytan(
  const ac_iAdmIdFunkId:    integer;// funkcja z ADMID gdzie s zapisane idki pozycji zapyta wejciowych z ktrych ma by utworzone zlecenie
  const ac_iTypZlecId:      integer // domylny typ zlecenia
):  integer;
var
  p:  function(
            const ac_iAdmIdFunkId:    integer;// funkcja z ADMID gdzie s zapisane idki pozycji zapotrzebowa z ktrych ma by utworzone zlecenie
            const ac_iTypZlecId:      integer // domylny typ zlecenia
  ):  integer;
begin
  @p  := GetProcAddress(DataManagers.GetHandle(sZLEModulID), 'DLL_ZLEDopiszZlecenieNieProdZPozycjiZapytan');
  if(@p <> nil) then
    result  := p(ac_iAdmIdFunkId, ac_iTypZlecId)
  else
    result  := 0;
end;

function TZLEDataManagerExt.ZLEDajWartoscPracy( iZLECENIE_ID, iUNIOKRES_ID: Integer;
                                                RODZAJECP: string = '';
                                                RODZAJZASOBU: String = '' ): Extended;
var
  p: function ( iZLECENIE_ID, iUNIOKRES_ID: Integer;
                RODZAJECP: string = '';
                RODZAJZASOBU: String = '' ): Extended;
begin
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEDajWartoscPracy');
  if @p<>nil then
       result := p( iZLECENIE_ID, iUNIOKRES_ID, RODZAJECP, RODZAJZASOBU )
  else Result := 0;
end;

initialization
  ZLEDataManager:= TZLEDataManagerExt.Create( sZLEModulID, cZLEMODULZSI_ID);
  ZLEDM:= ZLEDataManager;

finalization
  ZLEDM.Free;
end.


