unit ZLEDefUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-16 gdeyk    Utworzone
}

{$ifdef build_all}
  {$define build_zle}
{$endif}

interface

uses
  Classes, SysUtils, UNIDBConstComboBoxUnit;

type
  TSposobNadaniaGrupy = ( sngReczny, sngParametr, sngAutomat );

  TZleRodzajKosztow = (rkMaterialy, rkRobocizna, rkWszystkie);
  TZLEFormECP = (fZLEFormBrakID {0}, fZLEFormOsobyID{1},
                 fZLEFormKadryECPID{2}, fZLEFormListaRCPID{3});

  TZLESkladnik = class(TCollectionItem)
  private
    iID: Integer;
    eValue: Extended;
    sTable: String;
    procedure SetID(const Value: Integer);
    procedure SetValue(const Value: Extended);
    procedure SetTable(const Value: String);
  public
    property ID: Integer read iID write SetID;
    property Value: Extended read eValue write SetValue;
    property Table: String read sTable write SetTable;
  end;

  TZLEListaSkladnikow = class(TCollection)
  private
    function GetItem( Index: Integer ): TZLESkladnik;
    procedure SetItem( Index: Integer; Value: TZLESkladnik );
  public
    function Add: TZLESkladnik;
    property Items[Index: Integer]: TZLESkladnik read GetItem write SetItem; default;
  end;

  TZLEPrzeliczone = class(TCollectionItem)
  private
    FZLEZlecenieID: Integer;    //ZLEZlecenie_ID
    FPrzeliczone: Boolean; // Czy zostao przeliczone
  public
  //  constructor Create(aZLEZlecenieID: Integer; aPrzeliczone: Boolean);
    property ZLEZlecenieID: Integer read FZLEZlecenieID write FZLEZlecenieID;
    property Przeliczone  : Boolean read FPrzeliczone   write FPrzeliczone;
  end;

  TZLEPrzeliczoneLista = class(TCollection)
  private
    function GetItem( Index: Integer ): TZLEPrzeliczone;
    procedure SetItem( Index: Integer; Value: TZLEPrzeliczone );
  public
    function Add: TZLEPrzeliczone;
    Constructor Create();
    function GetItemByValue(aZLEZlecenieID: Integer): TZLEPrzeliczone;
    property Items[Index: Integer]: TZLEPrzeliczone read GetItem write SetItem; default;
  end;

  TZLEWarunek = class(TCollectionItem)
  private
    FFKMnemonikiID: Integer;    //FKMnemoniki_ID
    FListaID: String;
  public
  //  constructor Create(aZLEZlecenieID: Integer; aPrzeliczone: Boolean);
    property FKMnemonikiID: Integer read FFKMnemonikiID write FFKMnemonikiID;
    property ListaID      : String  read FListaID       write FListaID;
  end;

  TZLEWarunekLista = class(TCollection)
  private
    function  GetItem(Index: Integer): TZLEWarunek;
    procedure SetItem(Index: Integer; Value: TZLEWarunek );
  public
    function Add: TZLEwarunek;
    Constructor Create();
    function GetItemByValue(aFKMnemonikiID: Integer): TZLEWarunek;
    property Items[Index: Integer]: TZLEWarunek read GetItem write SetItem; default;
  end;

  {$I 'ConstsZLEDef.inc'}

const
  //sZLEModulID     = 'ZLE';
  cZLEModulZSI_ID = 33;
  cZLEHelpFile    = 'Zlecenia.chm';
  cZLEDLL         = 'zle.dll';

  //rodzaj skadnika wartociowego i ilociowego dla zlecenia
  cZLERodzajSklad_RecznyID  = 'E';  //wprowadzania rczne
  cZLERodzajSklad_RegulaID  = 'G';  //okrelone regu
  cZLERodzajSklad_Reczny   = 'wprowadzane rcznie';
  cZLERodzajSklad_Regula   = 'okrelone regu';

  //status zlecenia
  cZLEStatusZlecenia_AnulowaneID   = 'A';
  cZLEStatusZlecenia_OczekujaceID  = 'O';
  cZLEStatusZlecenia_WRealizacjiID = 'R';
  cZLEStatusZlecenia_WstrzymaneID  = 'W';
  cZLEStatusZlecenia_ZakonczoneID  = 'Z';
  cZLEStatusZlecenia_Anulowane     = 'anulowane';
  cZLEStatusZlecenia_Oczekujace    = 'oczekujce';
  cZLEStatusZlecenia_WRealizacji   = 'w realizacji';
  cZLEStatusZlecenia_Wstrzymane    = 'wstrzymane';
  cZLEStatusZlecenia_Zakonczone    = 'zakoczone';

  //Parametry wywoania listy zlecen
  cZLELista_Optymalizacja          = 'ZLELista_Optymalizacja';
  cZLELista_WylaczPrzyciski        = 1;
  cZLELista_WylaczPolaUzytk        = 2;
  cZLELista_WylaczPanel            = 4; //Wyaczamy widoczno panelu bocznego
  cZLELista_WlaczPrzyciskPoz       = 128;

  //aktywno parametru
  cZLEAktywnosc_NieAktywnyID = 'A';
  cZLEAktywnosc_OpcjonalnyID = 'O';
  cZLEAktywnosc_WymaganyID   = 'W';
  cZLEAktywnosc_NieAktywny   = 'nieaktywny';
  cZLEAktywnosc_Opcjonalny   = 'opcjonalny';
  cZLEAktywnosc_Wymagany     = 'wymagany';

  //rodzaj zasobu
  cZLERodzajZasobu_PracownikID = 'P';
  cZLERodzajZasobu_MaszynaID   = 'M';
  cZLERodzajZasobu_Pracownik   = 'Pracownik';
  cZLERodzajZasobu_Maszyna     = 'Maszyna';

  //rodzaj ECP
  cZLERodzajECP_OsobaID     = 'O';
  cZLERodzajECP_ZasobID     = 'Z';
  cZLERodzajECP_RozliczID   = 'R';
  cZLERodzajECP_ProdukcjaID = 'P';
  cZLERodzajECP_Osoba       = 'ECP Osb';
  cZLERodzajECP_Zasob       = 'ECP Zasobw';
  cZLERodzajECP_Rozlicz     = 'Rozliczenia';
  cZLERodzajECP_Produkcja   = 'Produkcja';

  //Formatka Osb osadzona na RCP zasobw
  cZLEFormatkaBrakID     = 0;
  cZLEFormatkaOsobyID    = 1;
  cZLEFormatkaKadryECPID = 2;
  cZLEFormatkaListaRCPID = 3;

  // Pola uzytkownika State
  cZLEPolaUzState_TextOfUnUsed    = 'Nieaktywne';
  cZLEPolaUzState_TextOfCanUse    = 'Opcja';
  cZLEPolaUzState_TextOfHaveToUse = 'Wymagane';

  cZLEPolaUzState_IDOfUnUsed      = '0';
  cZLEPolaUzState_IDOfCanUse      = '1';
  cZLEPolaUzState_IDOfHaveToUse   = '2';

  cZLETypDanych_Integer           = 'Integer';
  cZLETypDanych_Float             = 'Float';
  cZLETypDanych_String            = 'String';
  cZLETypDanych_Date              = 'Date';

  cZLETypDanych_IntegerID         = 'I';
  cZLETypDanych_FloatID           = 'F';
  cZLETypDanych_StringID          = 'S';
  cZLETypDanych_DateID            = 'D';

  {Bdy parsera}
  cZLEParserBlad_Brak             = 'Brak bdu';
  cZLEParserBlad_DzielZero        = 'Dzielenie przez 0';
  cZLEParserBlad_BladInny         = 'Nieznany bd';

  cZLEParserBlad_BrakID           = '0';
  cZLEParserBlad_DzielZeroID      = '1';
  cZLEParserBlad_BladInnyID       = '2';

  cZLEConstPrefix_Prefix          = 'ZLEPREFIX';
  cZLEConstPrefix_PrefixID        = '0';
  cZLEConstPrefix_Oddzial         = 'UNIODDZIAL';
  cZLEConstPrefix_OddzialID       = '1';

  cZLEConstZasobPracaStatus_Wprowadzony     = 'Wprowadzony';
  cZLEConstZasobPracaStatus_WprowadzonyID   = 'W';
  cZLEConstZasobPracaStatus_Zaakceptowany   = 'Zaakceptowany';
  cZLEConstZasobPracaStatus_ZaakceptowanyID = 'Z';

  cZLEConstZleWycenaStatus_Wprowadzony      = 'Wprowadzony';
  cZLEConstZleWycenaStatus_WprowadzonyID    = 'W';
  cZLEConstZleWycenaStatus_Zaakceptowany    = 'Zaakceptowany';
  cZLEConstZleWycenaStatus_ZaakceptowanyID  = 'Z';

  cZLEConstZasobyPracaRapStatus_Zgodny      = 'Zgodny';
  cZLEConstZasobyPracaRapStatus_ZgodnyID    = 'Z';
  cZLEConstZasobyPracaRapStatus_Niezgodny   = 'Niezgodny';
  cZLEConstZasobyPracaRapStatus_NiezgodnyID = 'N';

  cZLEDlugoscPola_NazwaZlec  = 150;
  cZLEDlugoscPola_Nazwa  = 50;
  cZLEDlugoscPola_Uwagi  = 150;
  cZLEDlugoscPola_Symbol = 20;

  // staa dodawana do indeksu pl uytkownika pozycji
  gciZLEPolaUZPozIndeks = 100;
  sZLEParam_PolaUZGrid  = 'ZLEParamPolaUzGrid';

  cSuffixPola_ID         = '_ID';
  cSuffixPola_Symbol     = '_SYMBOL';
  cSuffixPola_Nazwa      = '_NAZWA';
  cSuffixPola_Rodzaj     = '_RODZAJ';
  cSuffixPola_Regula     = '_REGULA';
  cSuffixPola_Kolejnosc  = '_KOLEJNOSC';

  cKlasaZlecenie            = 'TZLEZlecenie';
  cKlasaZlecenieUpr         = 'TZLEZlecenieUpr';
  cKlasaPozycje             = 'TZLEPozycje';
  cKlasaKontrolaRealizacji  = 'TZLEKontrolaRealizacji';
  cKlasaKontrolaRealizacjiW = 'TZLEKontrolaRealizacjiWartosciowej';
  cKlasaKontrolaRealizacjiI = 'TZLEKontrolaRealizacjiIlosciowej';
  cKlasaSkladnikWartosciowy = 'TZLESkladnikKontroliWartosciowej';
  cKlasaSkladnikIlosciowy   = 'TZLESkladnikKontroliIlosciowej';
  cKlasaSkladnikRealRWart   = 'TZLEKontrolaRealizacjiRecznaWartosciowa';
  cKlasaSkladnikRealRIlosc  = 'TZLEKontrolaRealizacjiRecznaIlosciowa';
  cKlasaTypZlecenia         = 'TZLETypZlecenia';
  cKlasaParametry           = 'TZLEParametry';
  cKlasaZakresZlecen        = 'TZLEZakres';
  cKlasaZakresZlecenUpr     = 'TZLEZlecenieUprZakres';
  cKlasaOsobyGodz           = 'TZLEOsobyGodz';
  cKlasaZasob               = 'TZLEZasob';
  cKlasaBraki               = 'TZLEBraki';
  cKlasaZlecenieZasob       = 'TZLEZlecenieZasob';
  cKlasaZlecenieRozl        = 'TZLEZlecenieRozl';
  cKlasaPrefix              = 'TZLEPrefix';
  cKlasaKrytPoz             = 'TZLEKrytPoz';

  cSuffixKlasyDBDetail   = 'DBDetailForm';
  cSuffixKlasyDBGrid     = 'DBGridForm';
  cSuffixKlasySelect     = 'SelectForm';
  cSuffixKlasyRange      = 'RangeForm';
  cSuffizKlasyTreeForm   = 'TreeForm';

  cSuffixZlecenie_SAN             = '_SAN';
  cSuffixZlecenie_SANOdbiorcy     = '_SANOdbiorcy';
  cSuffixZlecenie_SANFakturowanie = '_SANFakturowanie';

  cFORM_CAPTION          = 'FORM_CAPTION';
  cFORM_ENABLED          = 'FORM_ENABLED';
  cFORM_ANALIZA          = 'FORM_ANALIZA';

  //rodzaj wykonywanej funkcji przez list zlece
  cZLEFuncRodzaj             = 'RodzajFunkcji';
  cZLEFuncZlecenie           = 'Z';
  cZLEFuncKontrolaRealizacji = 'K';

  cZLERozliczenieZasobow = 'RozliczenieZasobow';

  {Funkcje osadzone}
  sZLE_POBIERZ_ID_OBCY   = 'ZLE_POBIERZ_ID_OBCY';

  {Wyzwalacze}
  sZLEZLECENIE_INS_AFTER = 'ZLEZLECENIE_INS_AFTER';

  //nazwy parametrw dla regu
  cZLEParamIndeksAsort   = ':IndeksAsort';
  cZLEParamSymbolZlec    = ':SymbolZlec';
  cZLEMnem               = ':ZLEMNEM';
  cTypDokSp              = ':TYPDOKSP';

  {Parametry dla Pol uzytkownika}
  cParam_ZLEPOLAZMDEF_TYP        = 'Param_ZLEPOLAZMDEF_TYP';
  cParam_FKMNEMONIKI_ID          = 'Param_FKMNEMONIKI_ID';
  cParam_UNICONSTDEF_DOMENA      = 'Param_UNICONSTDEF_DOMENA';
  cParam_ZLEPOLAZMDEF_DLUG       = 'Param_ZLEPOLAZMDEF_DLUG';
  cParam_ZLEPOLAZMDEF_TYPDANYCH  = 'Param_ZLEPOLAZMDEF_TYPDANYCH';
  cParam_ZLEPOLAZMDEF_ZNAKI      = 'Param_ZLEPOLAZMDEF_ZNAKI';


  //parametru do obsugi zakresu
  sParam_ZLESymbolOd     = 'ZLESymbolOd';
  sParam_ZLESymbolDo     = 'ZLESymbolDo';
  sParam_ZLESymbol2Od    = 'ZLESymbol2Od';
  sParam_ZLESymbol2Do    = 'ZLESymbol2Do';
  sParam_ZLENazwaOd      = 'ZLENazwaOd';
  sParam_ZLENazwaDo      = 'ZLENazwaDo';
  sParam_ZLENazwa2Od     = 'ZLENazwa2Od';
  sParam_ZLENazwa2Do     = 'ZLENazwa2Do';
  sParam_ZLEDataOd       = 'ZLEDataOd';
  sParam_ZLEDataDo       = 'ZLEDataDo';
  sParam_ZLEDataOtwOd    = 'ZLEDataOtwarciaOd';
  sParam_ZLEDataOtwDo    = 'ZLEDataOtwarciaDo';
  sParam_ZLEDataZakOd    = 'ZLEDataZakonczeniaOd';
  sParam_ZLEDataZakDo    = 'ZLEDataZakonczeniaDo';
  sParam_ZLEStatusZlec   = 'ZLEStatusZlecenia';
  sParam_ZLETypZlecAkt   = 'ZLETypZleceniaAktywny';
  sParam_ZLETypZlec      = 'ZLETypZlecenia';
  sParam_ZLEModulZSIAkt  = 'ZLEModulZSIAktywny';
  sParam_ZLEModulZSI     = 'ZLEModulZSI';
  sParam_ZLEOsobaOdp     = 'ZLEOsobaOdp';
  sParam_ZLEOsoba        = 'ZLEOsoba';
  sParam_ZLEOperatorWprowadz = 'ZLEOperatorWprowadz';
  sParam_ZLEZlecenieID   = 'ZLEZlecenieID';
  sParam_ZLEAsortID      = 'ZLEAsortID';
  sParam_ZLESprawaID     = 'ZLESprawaID';
  sParam_ZLEZasZleZLEID  = 'ZLEZasZleZLEID';
  sParam_ZLEZasID        = 'ZLEZasID';
  sParam_ZLEZasobZLEID   = 'ZLEZasobZLEID';
  sParam_ZLEZasobZLEID2  = 'ZLEZasobZLEID2';
  sParam_ZLEZasobRodzID  = 'ZLEZasobRodzID';
  sParam_ZLEDataRozlOd   = 'ZLEDataRozlOd';
  sParam_ZLEDataRozlDo   = 'ZLEDataRozlDo';
  sParam_ZLEKlientId     = 'ZLEKlientId';
  sParam_ZLEPrefixId     = 'ZLEPrefixId';
  sParam_ZLEZasobID      = 'ZLEZasobID';
  sParam_ZLEOsobaID      = 'ZLEOsobaID';
  sParam_ZLEOkresID      = 'ZLEOkresID';
  sParam_ZLEPOjazdID     = 'ZLEPojazdID';
  sParam_ZLEPrzelicz     = 'ZLEPrzelicz';
  sParam_ZLEWykonawcaID  = 'ZLEWykonawcaID';
  sParam_ZLEKontekst     = 'ZLEKontekst';
  sParam_ZLESkladCzasuID = 'ZLESkladCzasuID';
  sParam_ZlecNadrzedneID = 'ZlecNadrzedneID';
  sParam_ZlecNadrzednePokaz = 'ZlecNadrzednePokaz';
  sParam_ZleceniaPodrzedne = 'ZlecZleceniaPodrzedne';

  {Uytkownicy zaangaowani}
  sParam_ZLEOsobaAkcept    = 'ZLEOsobaAkcept';
  sParam_ZLEOsobaReal      = 'ZLEOsobaReal';
  sParam_ZLEOsobaPotwReal  = 'ZLEOsobaPotwReal';
  sParam_ZLEOperAkcept     = 'ZLEOperAkcept';
  sParam_ZLEOperOdp        = 'ZLEOperOdp';
  sParam_ZLEOperReal       = 'ZLEOperReal';
  sParam_ZLEOperPotwReal   = 'ZLEOperPotwReal';

  //szczegowe koszty
  sZLESZCZEGOLY_DATA     = 'ZLESzczegolyData';
  sZLESZCZEGOLY_CENA     = 'ZLESzczegolyCena';
  sZLESZCZEGOLY_ILOSC    = 'ZLESzczegolyIlosc';
  sZLESZCZEGOLY_WARTOSC  = 'ZLESzczegolyWartosc';

  sZLESZCZEGOLY_RODZAJ   = 'ZLESzczegolyRodzaj';
  sZLESZCZEGOLY_RODZAJ_M = 'ZLESzczegolyRodzajM';
  sZLESZCZEGOLY_RODZAJ_R = 'ZLESzczegolyRodzajR';

  {Formy osadzone zlecenia}
  cFormPozycjeZlecenia   = 'PozycjeZlecenia';
  cFormZasobyPowiazane   = 'ZasobyPowiazane';
  cFormZapotrzebPierw    = 'ZapotrzebPierw';
  cFormZapotrzebWtorne   = 'ZapotrzebWtorne';
  cFormZamowienia        = 'Zamowienia';
  cFormZapytania         = 'Zapytania';
  cFormMaterialy         = 'Materiay';



//definicje parametrw systemowych i uytkownika
sINIZLEPozycjeWlaczone                 = 'ZLEPozycjeWlaczone';
sINIZLEKontrolaKosztowWlaczona         = 'ZLEKontrolaKosztowWlaczona';
sINIZLEKontrolaIlosciWlaczona          = 'ZLEKontrolaIlosciWlaczona';
sINIZLEKosztyMaterialoweWlaczone       = 'ZLEKosztyMaterialoweWlaczone';
sINIZLEKosztyMatZakupWlaczone          = 'ZLEKosztyMatZakupWlaczone';
sINIZLEKosztyRobociznyWlaczone         = 'ZLEKosztyRobociznyWlaczone';
sINIZLEWystawioneFakturyWlaczone       = 'ZLEWystawioneFakturyWlaczone';
sINIZLEWystawioneFakturyZakupuWlaczone = 'ZLEWystawioneFakturyZakupuWlaczone';
sINIZLEZasobyWlaczone                  = 'ZLEZasobyWlaczone';
sINIZLERozliczenieWlaczone             = 'ZLERozliczenieWlaczone';
sINIZLEWycenaPracyZasobowWlaczona      = 'ZLEWycenaPracyZasobowWlaczona';
sINIZLEKosztyZakupuWlaczone            = 'ZLEKosztyZakupuWlaczone';
sINIZLEDopiszKosztyZakupuWlaczone      = 'ZLEDopiszKosztyZakupuWlaczone';
sINIZLEKosztyKDECPWlaczone             = 'ZLEKosztyKDECPWlaczone';
sINIZLESrodkiTrwaleWlaczone            = 'ZLESrodkiTrwaleWlaczone';
sINIZLEUwzglednijBlokadeKDECP          = 'ZLEUwzglednijBlokadeKDECP';
sINIZLEUproszczonySlownikZlecenWlaczony= 'ZLEUproszczonySlownikZlecenWlaczony';

sINIZLEDomyslnyStatusZlecenia          = 'ZLEDomyslnyStatusZlecenia';
sINIZLEDomyslnyTypZlecenia             = 'ZLEDomyslnyTypZlecenia';
sINIZLEInstalacjeTypZlec               = 'ZLEInstalacjeTypZlec';
sINIZLEWymaganaOsobaZamykajacaZlecenie = 'ZLEWymaganaOsobaZamykajacaZlecenie';
sINIZLEAsoReg_ID                       = 'INIZLEAsoReg_ID';
sINIZLEZlecenieRozl_ZuzPaliwa          = 'ZLEZlecenieRozl_ZuzPaliwa';
sINIZLEZleceniePoz_RenumeracjaLP       = 'ZLEZleceniePoz_RenumeracjaLP';
sINIZLEWymaganyOddzial                 = 'ZLEWymaganyOddzial';
sINIZLEDomyslnyOddzialID               = 'ZLEDomyslnyOddzialID';
sINIZLEWymaganaStawkaZasobu            = 'ZLEWymaganaStawkaZasobu';
sINIZLEPrzeliczanieWlaczone            = 'ZLEPrzeliczanieWlaczone';
sINIZLEPrzeliczanieGodzina             = 'ZLEPrzeliczanieGodzina';
sINIZLEGrupowanieDanych                = 'ZLEGrupowanieDanych';
sINIZLENumeratorZasobow                = 'ZLENumeratorZasobow';
sINIZLEOgraniczonaListaZasobow         = 'ZLEOgraniczonaListaZasobow';
sINIZLEWspolneZlecenia                 = 'ZLEWspolneZlecenia';
sINIZLEFormatGodzinLiczba              = 'ZLEFormatGodzinLiczba';
sINIZLEWylaczonyFiltrDlaTypu           = 'ZLEWylaczonyFiltrDlaTypu';
sINIZLENumeratorExt                    = 'ZLENumeratorExt';
sINIZLEPrefixSlownikID                 = 'ZLEPrefixSlownikID';
sINIZLESuffixDefinicja                 = 'ZLESuffixDefinicja';
sINIZLEOsobnaNum                       = 'ZLEOsobnaNum';
sINIZLEWymaganaPozycjaEwid             = 'INIZLEWymaganaPozycjaEwid';
sINIZLEZamkniecieKont                  = 'ZLEZamkniecieKont';
sINIZLESprawyPodpowiadanie             = 'ZLESprawyPodpowiadanie';
sINIZLESprawyKontrahent                = 'ZLESprawyKontrahent';
sINIZLESprawyWydzial                   = 'ZLESprawyWydzial';
sINIZLESprawyPrefix                    = 'ZLESprawyPrefix';
sINIZLENarzuty                         = 'ZLENarzuty';
sINIZLEPoziomNarzutowJednOrg           = 'ZLEPoziomNarzutowJednOrg';
sINIZLEPoziomNarzutowOddzial           = 'ZLEPoziomNarzutowOddzial';
sINIZLEPoziomNarzutowTypZlec           = 'ZLEPoziomNarzutowTypZlec';
sINIZLEZleceniaNadrzedne               = 'ZLEZleceniaNadrzedne';
sINIZLEWydrukZlecenia                  = 'ZLEWydrukZlecenia';
sINIZLERozliczAktStawka                = 'ZLERozliczAktStawka';
sINIZLEKopiujZlecenieBezPozycji        = 'ZLEKopiujZlecenieBezPozycji';
sINIZLEPrzeliczOkresID                 = 'ZLEPrzeliczOkresID';
sINIZLEWlaczAktywnePrzyciki            = 'ZLEWlaczAktywnePrzyciki';
sINIZLEKontrolaUprawnionych            = 'ZLEKontrolaUprawnionych';
sINIZLEWysylanieECPWlaczone            = 'ZLEWysylanieECPWlaczone';
sINIZLEWysylanieRozliczECPWlaczone     = 'ZLEWysylanieRozliczECPWlaczone';
sINIZLESkladnikECPDomyslnyID           = 'ZLESkladnikECPDomyslnyID';
sINIZLEStawkaRegula                    = 'ZLEStawkaRegula';
sINIZLEBlokadaZmianySymbolu            = 'ZLEBlokadaZmianySymbolu';
sINIZLEReczneWprowadzanieSymbolu       = 'ZLEReczneWprowadzanieSymbolu';
sINIZLETransportWlaczony               = 'ZLETransportWlaczony';
sINIZLEMaskaSymboluWlaczona            = 'ZLEMaskaSymboluWlaczona';
sINIZLEMaskaSymbolu                    = 'ZLEMaskaSymbolu';
sINIZLEDataBlokadyECP                  = 'ZLEDataBlokadyECP';
sINIZLEBlokadaEdycjiZakoncz            = 'ZLEBlokadaEdycjiZakoncz';
sINIZLEECPPracownicyWieleFirm          = 'ZLEECPPracownicyWieleFirm';
sINIZLEUnikalnoscElemInf               = 'ZLEUnikalnoscElemInf';
sINIZLEZleceniaPodrzedneWlaczone       = 'ZLEZleceniaPodrzedneWlaczone';
sINIZLETworzZapotrzWlaczone            = 'ZLETworzZapotrzWlaczone';
sINIZLERozliczanieAkorduECPWlaczone    = 'ZLERozliczanieAkorduECPWlaczone';
sINIZLESlownikStanowiskMnemID          = 'ZLESlownikStanowiskMnemID';
sINIZLEZleceniaBezPozycjiZeSpraw       = 'ZLEZleceniaBezPozycjiZeSpraw';

//ID funkcji dla mechanizmu ADMID
cADMIDFuncZLEZlecenie   = 1;
cADMIDFuncZLEAsortyment = 2;
cADMIDFuncZLESprawa     = 3;
cADMIDFuncZLEZasobZLE   = 4;
cADMIDFuncZLEOsoba      = 5;
cADMIDFuncZLEZasob      = 6;
cADMIDFuncZLEZasZle     = 7;
cADMIDFuncZLEOperWpr    = 8;
cADMIDFuncZLEZasZle2    = 9;
cADMIDFuncZLEOsoba2     = 10;
cADMIDFuncZLEZasob2     = 11;
cADMIDFunZLEZlecenie    = 12;
cADMIDFunZLESkladCzasu2 = 13;

{Zaangaowani}
cADMIDFuncZLEOperAkcept    = 13;
cADMIDFuncZLEOperOdp       = 14;
cADMIDFuncZLEOperReal      = 15;
cADMIDFuncZLEOperPotwReal  = 16;
cADMIDFuncZLEOsobaAkcept   = 17;
cADMIDFuncZLEOsobaOdp      = 18;
cADMIDFuncZLEOsobaReal     = 19;
cADMIDFuncZLEOsobaPotwReal = 20;

cFunkcjaBOKDopiszZlecenie = 'FunkcjaBOKDopiszZlecenie';

//kody bdw mogcych wystpi w module
cError_BrakIDFirmy                  = 1;
cError_BrakIDModulu                 = 2;
cError_BrakModulu                   = 3;
cError_TabelaNieobslugiwana         = 4;
cError_BlednyOkres                  = 5;
cError_BrakZlecenia                 = 10;
cError_BrakGrupy                    = 20;
cError_BrakTypuZlecenia             = 21;
cError_BladDodaniaElemGrup          = 30;
cError_BladDodaniaElemGrupIstnieje  = 31;
cError_BrakSkladnika                = 40;
cError_BladTypuSkladnika            = 41;
cError_SkladnikNiePrzeliczony       = 42;
cError_WpisIstnieje                 = 43;


//Stae dla parametru sParam_ZLEKontekst
sParam_ZLEKontekst_KlientInfo       = 'Kontekst_KlientInfo';
sParam_ZLEKontekst_Umowy            = 'Kontekst_Umowy';
sParam_ZLEKontekst_Sprawy           = 'Kontekst_Sprawy';

//nazwy funkcji dla analiz
cAgregateFunction_ZLEDanePozycji    = 'ZLEDANEPOZ';
//cAgregateFunctionParam_ZPozycji   = 'ZPOZYCJI';
//cAgregateFunctionParam_WARTOSC      = 'WARTOSC';

cAgregateFunctionParam_ZakPOWT      = 'ZAKRESPOWT';
cAgregateFunctionParam_ZakSUM       = 'ZAKRESSUM';
cAgregateFunctionParam_Zrodlo       = 'ZRODLO';
cAgregateFunctionParam_Funkcja      = 'FUNKCJA';

cParam_ZrodloWartosc                = 'WART';
cParam_ZrodloRobocizna              = 'ROB';
//cParam_ZrodloMaterialy              = 'MAT';
cParam_ZrodloFunkcja                = 'FUNK';

//Stale SecurityManagera
sZLE                                 = 'ZLE';
sZLE_USTAW                           = 'ZLE_USTAW';
sZLE_USTAW_PARAM                     = 'ZLE_USTAW_PARAM';
sZLE_USTAW_DEF                       = 'ZLE_USTAW_DEF';
sZLE_USTAW_DEF_SKL_KONTR_WART        = 'ZLE_USTAW_DEF_SKL_KONTR_WART';
sZLE_USTAW_DEF_SKL_KONTR_WART_POKAZ  = 'ZLE_USTAW_DEF_SKL_KONTR_WART_POKAZ';
sZLE_USTAW_DEF_SKL_KONTR_WART_DOPISZ = 'ZLE_USTAW_DEF_SKL_KONTR_WART_DOPISZ';
sZLE_USTAW_DEF_SKL_KONTR_WART_ZMIEN  = 'ZLE_USTAW_DEF_SKL_KONTR_WART_ZMIEN';
sZLE_USTAW_DEF_SKL_KONTR_WART_USUN   = 'ZLE_USTAW_DEF_SKL_KONTR_WART_USUN';
sZLE_USTAW_DEF_SKL_KONTR_IL          = 'ZLE_USTAW_DEF_SKL_KONTR_IL';
sZLE_USTAW_DEF_SKL_KONTR_IL_POKAZ    = 'ZLE_USTAW_DEF_SKL_KONTR_IL_POKAZ';
sZLE_USTAW_DEF_SKL_KONTR_IL_DOPISZ   = 'ZLE_USTAW_DEF_SKL_KONTR_IL_DOPISZ';
sZLE_USTAW_DEF_SKL_KONTR_IL_ZMIEN    = 'ZLE_USTAW_DEF_SKL_KONTR_IL_ZMIEN';
sZLE_USTAW_DEF_SKL_KONTR_IL_USUN     = 'ZLE_USTAW_DEF_SKL_KONTR_IL_USUN';
sZLE_USTAW_DEF_TYP_ZLEC              = 'ZLE_USTAW_DEF_TYP_ZLEC';
sZLE_USTAW_DEF_TYP_ZLEC_POKAZ        = 'ZLE_USTAW_DEF_TYP_ZLEC_POKAZ';
sZLE_USTAW_DEF_TYP_ZLEC_DOPISZ       = 'ZLE_USTAW_DEF_TYP_ZLEC_DOPISZ';
sZLE_USTAW_DEF_TYP_ZLEC_ZMIEN        = 'ZLE_USTAW_DEF_TYP_ZLEC_ZMIEN';
sZLE_USTAW_DEF_TYP_ZLEC_ZMIEN_UPR    = 'ZLE_USTAW_DEF_TYP_ZLEC_ZMIEN_UPR';
sZLE_USTAW_DEF_TYP_ZLEC_USUN         = 'ZLE_USTAW_DEF_TYP_ZLEC_USUN';
sZLE_USTAW_DEF_NUM_ZLEC              = 'ZLE_USTAW_DEF_NUM_ZLEC';
sZLE_USTAW_DEF_NUM_ZLEC_POKAZ        = 'ZLE_USTAW_DEF_NUM_ZLEC_POKAZ';
sZLE_USTAW_DEF_NUM_ZLEC_DOPISZ       = 'ZLE_USTAW_DEF_NUM_ZLEC_DOPISZ';
sZLE_USTAW_DEF_NUM_ZLEC_ZMIEN        = 'ZLE_USTAW_DEF_NUM_ZLEC_ZMIEN';
sZLE_USTAW_DEF_NUM_ZLEC_USUN         = 'ZLE_USTAW_DEF_NUM_ZLEC_USUN';
sZLE_USTAW_DEF_NUM_ZASOBOW           = 'ZLE_USTAW_DEF_NUM_ZASOBOW';
sZLE_USTAW_DEF_NUM_ZASOBOW_POKAZ     = 'ZLE_USTAW_DEF_NUM_ZASOBOW_POKAZ';
sZLE_USTAW_DEF_NUM_ZASOBOW_DOPISZ    = 'ZLE_USTAW_DEF_NUM_ZASOBOW_DOPISZ';
sZLE_USTAW_DEF_NUM_ZASOBOW_ZMIEN     = 'ZLE_USTAW_DEF_NUM_ZASOBOW_ZMIEN';
sZLE_USTAW_DEF_NUM_ZASOBOW_USUN      = 'ZLE_USTAW_DEF_NUM_ZASOBOW_USUN';
sZLE_USTAW_SLOW                      = 'ZLE_USTAW_SLOW';
sZLE_USTAW_SLOW_ZASOBY               = 'ZLE_USTAW_SLOW_ZASOBY';
sZLE_USTAW_SLOW_ZASOBY_POKAZ         = 'ZLE_USTAW_SLOW_ZASOBY_POKAZ';
sZLE_USTAW_SLOW_ZASOBY_DOPISZ        = 'ZLE_USTAW_SLOW_ZASOBY_DOPISZ';
sZLE_USTAW_SLOW_ZASOBY_ZMIEN         = 'ZLE_USTAW_SLOW_ZASOBY_ZMIEN';
sZLE_USTAW_SLOW_ZASOBY_USUN          = 'ZLE_USTAW_SLOW_ZASOBY_USUN';
sZLE_USTAW_SLOW_BRAKI                = 'ZLE_USTAW_SLOW_BRAKI';
sZLE_USTAW_SLOW_BRAKI_POKAZ          = 'ZLE_USTAW_SLOW_BRAKI_POKAZ';
sZLE_USTAW_SLOW_BRAKI_DOPISZ         = 'ZLE_USTAW_SLOW_BRAKI_DOPISZ';
sZLE_USTAW_SLOW_BRAKI_ZMIEN          = 'ZLE_USTAW_SLOW_BRAKI_ZMIEN';
sZLE_USTAW_SLOW_BRAKI_USUN           = 'ZLE_USTAW_SLOW_BRAKI_USUN';
sZLE_USTAW_SLOW_PREFIX               = 'ZLE_USTAW_SLOW_PREFIX';
sZLE_USTAW_SLOW_PREFIX_POKAZ         = 'ZLE_USTAW_SLOW_PREFIX_POKAZ';
sZLE_USTAW_SLOW_PREFIX_DOPISZ        = 'ZLE_USTAW_SLOW_PREFIX_DOPISZ';
sZLE_USTAW_SLOW_PREFIX_ZMIEN         = 'ZLE_USTAW_SLOW_PREFIX_ZMIEN';
sZLE_USTAW_SLOW_PREFIX_USUN          = 'ZLE_USTAW_SLOW_PREFIX_USUN';

sZLE_KART_ZLECEN                     = 'ZLE_KART_ZLECEN';
sZLE_KART_ZLECEN_POKAZ               = 'ZLE_KART_ZLECEN_POKAZ';
sZLE_KART_ZLECEN_DOPISZ              = 'ZLE_KART_ZLECEN_DOPISZ';
sZLE_KART_ZLECEN_ZMIEN               = 'ZLE_KART_ZLECEN_ZMIEN';
sZLE_KART_ZLECEN_ZMIEN_ZAKONCZ       = 'ZLE_KART_ZLECEN_ZMIEN_ZAKONCZ';
sZLE_KART_ZLECEN_USUN                = 'ZLE_KART_ZLECEN_USUN';
sZLE_KART_ZLECEN_POZYCJE             = 'ZLE_KART_ZLECEN_POZYCJE';
sZLE_KART_ZLECEN_KONTR_KOSZTOW       = 'ZLE_KART_ZLECEN_KONTR_KOSZTOW';
sZLE_KART_ZLECEN_KONTR_ILOSCI        = 'ZLE_KART_ZLECEN_KONTR_ILOSCI';
sZLE_KART_ZLECEN_KOSZTY_MAT          = 'ZLE_KART_ZLECEN_KOSZTY_MAT';
sZLE_KART_ZLECEN_KOSZTY_ROB          = 'ZLE_KART_ZLECEN_KOSZTY_ROB';
sZLE_KART_ZLECEN_FAKTURY             = 'ZLE_KART_ZLECEN_FAKTURY';
sZLE_KART_ZLECEN_ZASOBY              = 'ZLE_KART_ZLECEN_ZASOBY';
sZLE_KART_ZLECEN_KOSZTZAKUPU         = 'ZLE_KART_ZLECEN_KOSZTZAKUPU';
sZLE_KART_ZLECEN_POTW_EXT_ZLEC       = 'ZLE_KART_ZLECEN_POTW_EXT_ZLEC';
sZLE_KART_ZLECEN_SRODKITRWALE        = 'ZLE_KART_ZLECEN_SRODKITRWALE';
sZLE_KART_ZLECEN_CZASPRACYECP        = 'ZLE_KART_ZLECEN_CZASPRACYECP';
sZLE_KART_ZLECEN_TRANSPORT           = 'ZLE_KART_ZLECEN_TRANSPORT';
{sZLE_KART_ZLECEN_AKCEPT_EXT_ZLEC     = 'ZLE_KART_ZLECEN_AKCEPT_EXT_ZLEC';
sZLE_KART_ZLECEN_ODP_EXT_ZLEC        = 'ZLE_KART_ZLECEN_ODP_EXT_ZLEC';
sZLE_KART_ZLECEN_REAL_EXT_ZLEC       = 'ZLE_KART_ZLECEN_REAL_EXT_ZLEC';}
sZLE_KART_ZLECEN_ROZL_ZASOBOW        = 'ZLE_KART_ZLECEN_ROZL_ZASOBOW';
sZLE_KART_ZLECEN_ROZL_ZASOBOW_DOPISZ = 'ZLE_KART_ZLECEN_ROZL_ZASOBOW_DOPISZ';
sZLE_KART_ZLECEN_ROZL_ZASOBOW_ROZL   = 'ZLE_KART_ZLECEN_ROZL_ZASOBOW_ROZL';
sZLE_KART_ZLECEN_ROZL_ZASOBOW_ZMIEN  = 'ZLE_KART_ZLECEN_ROZL_ZASOBOW_ZMIEN';
sZLE_KART_ZLECEN_UTWORZ_ZAPOTRZ      = 'ZLE_KART_ZLECEN_UTWORZ_ZAPOTRZ';
sZLE_KART_ZLECEN_WYCENA              = 'ZLE_KART_ZLECEN_WYCENA';
sZLE_KART_ZLECEN_WYCENA_POKAZ        = 'ZLE_KART_ZLECEN_WYCENA_POKAZ';
sZLE_KART_ZLECEN_WYCENA_ZMIEN        = 'ZLE_KART_ZLECEN_WYCENA_ZMIEN';
sZLE_KART_ZLECEN_WYCENA_AKTUALIZUJ   = 'ZLE_KART_ZLECEN_WYCENA_AKTUALIZUJ';
sZLE_KART_ZLECEN_WYCENA_AKCEPTUJ     = 'ZLE_KART_ZLECEN_WYCENA_AKCEPTUJ';
sZLE_KART_ZLECEN_WYCENA_COFNIJ_AKCEPT= 'ZLE_KART_ZLECEN_WYCENA_COFNIJ_AKCEPTUJ';
sZLE_KART_ZLECEN_WYSLIJ              = 'ZLE_KART_ZLECEN_WYSLIJ';
sZLE_KART_ZLECEN_WYCOFAJ             = 'ZLE_KART_ZLECEN_WYCOFAJ';
sZLE_KART_ZLECEN_WYSLIJ_PLAN         = 'ZLE_KART_ZLECEN_WYSLIJ_PLAN';
sZLE_KART_ZLECEN_PLAN_WYCOFAJ        = 'ZLE_KART_ZLECEN_PLAN_WYCOFAJ';
sZLE_KART_ZLECEN_ZMIEN_STATUS        = 'ZLE_KART_ZLECEN_ZMIEN_STATUS';

sZLE_KART_ZLECEN_UPR                 = 'ZLE_KART_ZLECEN_UPR';
sZLE_KART_ZLECEN_UPR_POKAZ           = 'ZLE_KART_ZLECEN_UPR_POKAZ';

sZLE_REJ_CZASU_PRACY                 = 'ZLE_REJ_CZASU_PRACY';
sZLE_REJ_CZASU_PRACY_POKAZ           = 'ZLE_REJ_CZASU_PRACY_POKAZ';
sZLE_REJ_CZASU_PRACY_DOPISZ          = 'ZLE_REJ_CZASU_PRACY_DOPISZ';
sZLE_REJ_CZASU_PRACY_ZMIEN           = 'ZLE_REJ_CZASU_PRACY_ZMIEN';
sZLE_REJ_CZASU_PRACY_USUN            = 'ZLE_REJ_CZASU_PRACY_USUN';
sZLE_REJ_CZASU_PRACY_AKCEPTACJA      = 'ZLE_REJ_CZASU_PRACY_AKCEPTACJA';
sZLE_REJ_CZASU_PRACY_UTWORZ_Z_MAG    = 'ZLE_REJ_CZASU_PRACY_UTWORZ_Z_MAG';
sZLE_REJ_CZASU_PRACY_DATA_BLOKADY    = 'ZLE_REJ_CZASU_PRACY_DATA_BLOKADY';
sZLE_ANALIZY                         = 'ZLE_ANALIZY';
sZLE_ANALIZY_ROZL_ZASOBOW            = 'ZLE_ANALIZY_ROZL_ZASOBOW';
sZLE_STOPIEN_REALIZACJI_ZLECEN       = 'ZLE_STOPIEN_REALIZACJI_ZLECEN';
{sZLE_ANALIZY_ROZL_ZASOBOW_POKAZ      = 'ZLE_ANALIZY_ROZL_ZASOBOW_POKAZ';
sZLE_ANALIZY_ROZL_ZASOBOW_DOPISZ     = 'ZLE_ANALIZY_ROZL_ZASOBOW_DOPISZ';
sZLE_ANALIZY_ROZL_ZASOBOW_ZMIEN      = 'ZLE_ANALIZY_ROZL_ZASOBOW_ZMIEN';
sZLE_ANALIZY_ROZL_ZASOBOW_USUN       = 'ZLE_ANALIZY_ROZL_ZASOBOW_USUN';}
sZLE_PARAM                           = 'ZLE_PARAM';
sZLE_USTAW_DEF_POLAUZ_DOPISZ         = 'ZLE_USTAW_DEF_POLAUZ_DOPISZ';
sZLE_USTAW_DEF_POLAUZ_ZMIEN          = 'ZLE_USTAW_DEF_POLAUZ_ZMIEN';
sZLE_USTAW_DEF_POLAUZ_POKAZ          = 'ZLE_USTAW_DEF_POLAUZ_POKAZ';
sZLE_USTAW_DEF_POLAUZ_USUN           = 'ZLE_USTAW_DEF_POLAUZ_USUN';

sZLE_USTAW_KRYTERIA                  = 'ZLE_USTAW_KRYTERIA';
sZLE_USTAW_KRYTERIA_DOPISZ           = 'ZLE_USTAW_KRYTERIA_DOPISZ';
sZLE_USTAW_KRYTERIA_ZMIEN            = 'ZLE_USTAW_KRYTERIA_ZMIEN';
sZLE_USTAW_KRYTERIA_POKAZ            = 'ZLE_USTAW_KRYTERIA_POKAZ';
sZLE_USTAW_KRYTERIA_USUN             = 'ZLE_USTAW_KRYTERIA_USUN';
sZLE_USTAW_KRYTERIA_PRZELICZ         = 'ZLE_USTAW_KRYTERIA_PRZELICZ';
sZLE_USTAW_KRYTERIA_POZYCJE          = 'ZLE_USTAW_KRYTERIA_POZYCJE';

sZLE_USTAW_DEF_NARZUTY               = 'ZLE_USTAW_DEF_NARZUTY';
sZLE_USTAW_DEF_NARZUTY_DOPISZ        = 'ZLE_USTAW_DEF_NARZUTY_DOPISZ';
sZLE_USTAW_DEF_NARZUTY_ZMIEN         = 'ZLE_USTAW_DEF_NARZUTY_ZMIEN';
sZLE_USTAW_DEF_NARZUTY_POKAZ         = 'ZLE_USTAW_DEF_NARZUTY_POKAZ';
sZLE_USTAW_DEF_NARZUTY_USUN          = 'ZLE_USTAW_DEF_NARZUTY_USUN';
sZLE_USTAW_DEF_POLAUZ                = 'ZLE_USTAW_DEF_POLAUZ';

sZLE_USTAW_SLOW_GRUPYKALEND            = 'ZLE_USTAW_SLOW_GRUPYKALEND';
sZLE_USTAW_SLOW_GRUPYKALEND_POKAZ      = 'ZLE_USTAW_SLOW_GRUPYKALEND_POKAZ';
sZLE_USTAW_SLOW_GRUPYKALEND_DOPISZ     = 'ZLE_USTAW_SLOW_GRUPYKALEND_DOPISZ';
sZLE_USTAW_SLOW_GRUPYKALEND_ZMIEN      = 'ZLE_USTAW_SLOW_GRUPYKALEND_ZMIEN';
sZLE_USTAW_SLOW_GRUPYKALEND_USUN       = 'ZLE_USTAW_SLOW_GRUPYKALEND_USUN';
sZLE_USTAW_SLOW_GRUPYKALEND_PRZYWROC   = 'ZLE_USTAW_SLOW_GRUPYKALEND_PRZYWROC';
sZLE_USTAW_SLOW_SYSTEMYZMIANOWE        = 'ZLE_USTAW_SLOW_SYSTEMYZMIANOWE';
sZLE_USTAW_SLOW_SYSTEMYZMIANOWE_POKAZ  = 'ZLE_USTAW_SLOW_SYSTEMYZMIANOWE_POKAZ';
sZLE_USTAW_SLOW_SYSTEMYZMIANOWE_DOPISZ = 'ZLE_USTAW_SLOW_SYSTEMYZMIANOWE_DOPISZ';
sZLE_USTAW_SLOW_SYSTEMYZMIANOWE_ZMIEN  = 'ZLE_USTAW_SLOW_SYSTEMYZMIANOWE_ZMIEN';
sZLE_USTAW_SLOW_SYSTEMYZMIANOWE_USUN   = 'ZLE_USTAW_SLOW_SYSTEMYZMIANOWE_USUN';
sZLE_USTAW_SLOW_KALENDARZ              = 'ZLE_USTAW_SLOW_KALENDARZ';
sZLE_USTAW_SLOW_KALENDARZ_POKAZ        = 'ZLE_USTAW_SLOW_KALENDARZ_POKAZ';
sZLE_USTAW_SLOW_KALENDARZ_ZMIEN        = 'ZLE_USTAW_SLOW_KALENDARZ_ZMIEN';
sZLE_USTAW_SLOW_KALENDARZ_KOPIUJ       = 'ZLE_USTAW_SLOW_KALENDARZ_KOPIUJ';
sZLE_USTAW_SLOW_KALENDARZ_GENERUJ      = 'ZLE_USTAW_SLOW_KALENDARZ_GENERUJ';
sZLE_USTAW_SLOW_KALENDARZ_IMPORT       = 'ZLE_USTAW_SLOW_KALENDARZ_IMPORT'; 

{------------------ stae do kierunku zczenia pomidzy rezerwacjami a zleceniami --------}
  cZLECENIE_KIERUNEK_ZLECREZERW   = 1;  // rezerwacja utworzona na podstawie zlecenia
  cZLECENIE_KIERUNEK_REZERWZLEC   = 2;  // zlecenie utworzone na podstawie rezerwacji

type

  TStanSkladnikaKontroli = ( sskIstniejacy, sskNowy, sskUsuniety );
  TIntegerArray = array of Integer;
  TExtendedArray = array of Extended;

  TSkladnikKontroli = class
  private
    FStanSkladnika: TStanSkladnikaKontroli;
    FKolejnosc: Integer;
    FSkladnikID: Integer;
  public
    constructor Create( AOwner: TObject; Stan: TStanSkladnikaKontroli; ID: Integer; iKolejnosc: Integer);
    property StanSkladnika: TStanSkladnikaKontroli read FStanSkladnika write FStanSkladnika;
    property Kolejnosc: Integer read FKolejnosc;
    property SkladnikID: Integer read FSkladnikID;
  end;

  TListaSkladnikowKontroli = class(TStringList)
  private
    function GetSkladniki( Stan: TStanSkladnikaKontroli ): TIntegerArray;
    function GetSkladnikiNowe( ): TIntegerArray;
    function GetSkladnikiUsuniete( ): TIntegerArray;
    function GetSkladnikiAktywne( ): TIntegerArray;
  public
    constructor Create();
    destructor Destroy(); override;
    function Add( var Stan: TStanSkladnikaKontroli; ID: Integer; iKolejnosc: Integer ): Integer; reintroduce; overload;
    function GetKolejnosc(ID: Integer): Integer;
    function SetKolejnosc(ID: Integer; iKolejnosc: Integer): Integer;
    function GetNextKolejnosc():Integer;
    procedure Delete( ID: Integer ); override;
    property SkladnikiNowe: TIntegerArray read GetSkladnikiNowe;
    property SkladnikiUsuniete: TIntegerArray read GetSkladnikiUsuniete;
    property SkladnikiAktywne: TIntegerArray read GetSkladnikiAktywne;
  end;

  TZLETypKontroli = class
  private
    FWartosciowa: Boolean;
    FIlosciowa: Boolean;
    FWartosciowaOkresowa: Boolean;
    FIlosciowaOkresowa: Boolean;
  public
    property Wartosciowa: Boolean read FWartosciowa write FWartosciowa;
    property Ilosciowa: Boolean read FIlosciowa write FIlosciowa;
    property WartosciowaOkresowa: Boolean read FWartosciowaOkresowa write FWartosciowaOkresowa;
    property IlosciowaOkresowa: Boolean read FIlosciowaOkresowa write FIlosciowaOkresowa;

    constructor Create( bWart, bWartOkres, bIl, bIlOkres: Boolean );
  end;

var
  cslZLERodzajSklad     : TConstStringList;
  cslZLEStatusZlecenia  : TConstStringList;
  cslZLEAktywnosc       : TConstStringList;
  cslZLERodzajZasobu    : TConstStringList;
  cslZLETabelePowiazane : TConstStringList;
  cslZLEPolaUzState     : TConstStringList;
  cslZLETypDanych       : TConstStringList;
  cslZLEParserBlad      : TConstStringList;
  cslZLE_INFMnemoniki   : TConstStringList;
  cslZLEConstPrefix     : TConstStringList;
  cslZLEConstZasobPracaStatus:  TConstStringList;
  cslZLEConstZleWycenaStatus:   TConstStringList;
  cslZLERodzajECP       : TConstStringList;
  cslZLEConstZasobyPracaRapStatus:  TConstStringList;

implementation
uses
  BOKDefUnit,
  UNISysDefUnit,
{$ifdef build_zle}
  ZLEDataManagerUnit;
{$else}
  ZLEDataManagerExtUnit;
{$endif}

{ TSkladnikKontroli }

constructor TSkladnikKontroli.Create(AOwner: TObject;
                Stan: TStanSkladnikaKontroli;
                ID: Integer;
                iKolejnosc: Integer);
begin
  inherited Create();
  FStanSkladnika := Stan;
  FSkladnikID := ID;
  FKolejnosc := iKolejnosc;
end;

{ TListaSkladnikowKontroli }

constructor TListaSkladnikowKontroli.Create;
begin
  inherited;
  Duplicates := dupError;
  Sorted := true;
end;

function TListaSkladnikowKontroli.Add(var Stan: TStanSkladnikaKontroli;
                                      ID: Integer;
                                      iKolejnosc: Integer): Integer;
begin
  //dodaje skadnik do listy, istniejce pomija przy czym w tej sytuacji zwraca -1
  result := IndexOf( IntToStr(ID) );
  if result <> -1 then begin
    if (Objects[result] as TSkladnikKontroli).StanSkladnika = sskUsuniety then begin
      (Objects[result] as TSkladnikKontroli).StanSkladnika := sskIstniejacy;
      Stan := sskIstniejacy;
    end else result := -1;
    Exit;
  end;
  try
    result := AddObject( IntToStr(ID), TSkladnikKontroli.Create(Self, Stan, ID, iKolejnosc) );
  except
    on EStringListError do result := -1;
  end;
end;

function TListaSkladnikowKontroli.GetKolejnosc(ID: Integer): Integer;
var oSkladnik: TSkladnikKontroli;
    iIndex: Integer;
begin
  result := -1;
  iIndex := IndexOf(IntToStr(ID));
  if (iIndex <> -1) then
     if (Objects[iIndex] <> nil) then begin
        oSkladnik := (Objects[iIndex] as TSkladnikKontroli);
        if (oSkladnik.StanSkladnika = sskIstniejacy) or (oSkladnik.StanSkladnika = sskNowy) then
            //oSkladnik.StanSkladnika := sskUsuniety
           result := oSkladnik.Kolejnosc;
     end;
end;

function TListaSkladnikowKontroli.SetKolejnosc(ID: Integer; iKolejnosc: Integer): Integer;
var oSkladnik: TSkladnikKontroli;
    iIndex: Integer;
begin
  result := -1;
  iIndex := IndexOf(IntToStr(ID));
  if (iIndex <> -1) then
     if (Objects[iIndex] <> nil) then begin
        oSkladnik := (Objects[iIndex] as TSkladnikKontroli);
        if (oSkladnik.StanSkladnika = sskIstniejacy) or (oSkladnik.StanSkladnika = sskNowy) then
            //oSkladnik.StanSkladnika := sskUsuniety
           oSkladnik.FKolejnosc := iKolejnosc;
           result := 0; //OK
     end;
end;

function TListaSkladnikowKontroli.GetNextKolejnosc():Integer;
var oSkladnik: TSkladnikKontroli;
    iIndex: Integer;
begin
  result := 0; //Dla pustej listy zwrci 1
  for iIndex := 0 to Count-1 do begin
    if Objects[iIndex] = nil then continue;
    oSkladnik := (Objects[iIndex] as TSkladnikKontroli);
    if (oSkladnik.StanSkladnika = sskNowy) or (oSkladnik.StanSkladnika = sskIstniejacy) then begin
      if result < oSkladnik.FKolejnosc then
         result := oSkladnik.FKolejnosc;
    end;
  end;
  result := result + 1;
end;

procedure TListaSkladnikowKontroli.Delete(ID: Integer);
var oSkladnik: TSkladnikKontroli;
    iIndex: Integer;
begin
  iIndex := IndexOf( IntToStr(ID) );
  if iIndex = -1 then Exit;
  if Objects[iIndex] = nil then begin
    inherited Delete(iIndex);
    Exit;
  end;
  oSkladnik := (Objects[iIndex] as TSkladnikKontroli);
  if oSkladnik.StanSkladnika = sskIstniejacy then
    oSkladnik.StanSkladnika := sskUsuniety
  else if oSkladnik.StanSkladnika = sskNowy then begin
    oSkladnik.Free;
    Objects[iIndex] := nil;
    inherited Delete(iIndex);
  end;
end;

function TListaSkladnikowKontroli.GetSkladnikiNowe: TIntegerArray;
begin
  result := GetSkladniki( sskNowy );
end;

function TListaSkladnikowKontroli.GetSkladnikiUsuniete: TIntegerArray;
begin
  result := GetSkladniki( sskUsuniety );
end;

function TListaSkladnikowKontroli.GetSkladnikiAktywne: TIntegerArray;
var iIndex, iLength: Integer;
    oSkladnik: TSkladnikKontroli;
begin
  iLength := 0;
  SetLength( result, 0);
  for iIndex := 0 to Count-1 do begin
    if Objects[iIndex] = nil then continue;
    oSkladnik := (Objects[iIndex] as TSkladnikKontroli);
    if (oSkladnik.StanSkladnika = sskNowy) or (oSkladnik.StanSkladnika = sskIstniejacy) then begin
      Inc( iLength );
      SetLength( result, iLength );
      result[iLength-1] := oSkladnik.SkladnikID;
    end;
  end;
end;

function TListaSkladnikowKontroli.GetSkladniki( Stan: TStanSkladnikaKontroli): TIntegerArray;
var iIndex, iLength: Integer;
    oSkladnik: TSkladnikKontroli;
begin
  iLength := 0;
  SetLength( result, 0);
  for iIndex := 0 to Count-1 do begin
    if Objects[iIndex] = nil then continue;
    oSkladnik := (Objects[iIndex] as TSkladnikKontroli);
    if oSkladnik.StanSkladnika = Stan then begin
      Inc( iLength );
      SetLength( result, iLength );
      result[iLength-1] := oSkladnik.SkladnikID;
    end;
  end;
end;

destructor TListaSkladnikowKontroli.Destroy;
var iIndex: Integer;
begin
  for iIndex := 0 to Count-1 do begin
    if Objects[iIndex] <> nil then begin
      Objects[iIndex].Free;
      Objects[iIndex] := nil;
    end;
  end;
  inherited;
end;

{ TZLETypKontroli }

constructor TZLETypKontroli.Create(bWart, bWartOkres, bIl, bIlOkres: Boolean);
begin
  FWartosciowa := bWart;
  FWartosciowaOkresowa := bWartOkres;
  FIlosciowa := bIl;
  FIlosciowaOkresowa := bIlOkres;
end;

{ TSkladnik }

procedure TZLESkladnik.SetID(const Value: Integer);
begin
  iID := Value;
end;

procedure TZLESkladnik.SetTable(const Value: String);
begin
  if (Value = sZLEWART)or(Value = sZLEIL) then
    sTable := Value;
end;

procedure TZLESkladnik.SetValue(const Value: Extended);
begin
  eValue := Value;
end;

{ TListaSkladnikow }

function TZLEListaSkladnikow.Add: TZLESkladnik;
begin
  Result := TZLESkladnik(inherited Add);
end;

function TZLEListaSkladnikow.GetItem(Index: Integer): TZLESkladnik;
begin
  result := TZLESkladnik(inherited GetItem(Index));
end;

procedure TZLEListaSkladnikow.SetItem(Index: Integer; Value: TZLESkladnik);
begin
  inherited SetItem( Index, Value );
end;


(****************** Wyrzucone *********
{ TZLEPrzeliczone }
constructor TZLEPrzeliczone.Create(aZLEZlecenieID: Integer; aPrzeliczone: Boolean);
begin
//  inherited Create(Self);
  FZLEZlecenieID := aZLEZlecenieID;
  FPrzeliczone   := aPrzeliczone;
end;
***************************************)

{ TZLEPrzeliczoneLista }
function TZLEPrzeliczoneLista.Add: TZLEPrzeliczone;
begin
  Result := TZLEPrzeliczone(inherited Add);
end;

function TZLEPrzeliczoneLista.GetItem(Index: Integer): TZLEPrzeliczone;
begin
  result := TZLEPrzeliczone(inherited GetItem(Index));
end;

procedure TZLEPrzeliczoneLista.SetItem(Index: Integer; Value: TZLEPrzeliczone);
begin
  inherited SetItem( Index, Value );
end;

Constructor TZLEPrzeliczoneLista.Create();
begin
    inherited Create(TZLEPrzeliczone);
end;

function TZLEPrzeliczoneLista.GetItemByValue(aZleZlecenieID: Integer): TZLEPrzeliczone;
var
  i: Integer;
begin
  result := nil;
  for i := 0 to Count - 1 do
     if (Items[i].ZleZlecenieID = aZleZlecenieID) then begin
         result := Items[i];
         break;
     end;
end;


{ TZLEWarunekLista }
function TZLEWarunekLista.Add: TZLEWarunek;
begin
  Result := TZLEWarunek(inherited Add);
end;

function TZLEWarunekLista.GetItem(Index: Integer): TZLEWarunek;
begin
  result := TZLEWarunek(inherited GetItem(Index));
end;

procedure TZLEWarunekLista.SetItem(Index: Integer; Value: TZLEWarunek);
begin
  inherited SetItem( Index, Value );
end;

Constructor TZLEWarunekLista.Create();
begin
    inherited Create(TZLEWarunek);
end;

function TZLEWarunekLista.GetItemByValue(aFKMnemonikiID: Integer): TZLEWarunek;
var
  i: Integer;
begin
  result := nil;
  for i := 0 to Count - 1 do
     if (Items[i].FKMnemonikiID = aFKMnemonikiID) then begin
         result := Items[i];
         break;
     end;
end;

initialization
  cslZLERodzajSklad := TConstStringList.Create();
  with cslZLERodzajSklad do begin
    Add( cZLERodzajSklad_Reczny,  cZLERodzajSklad_RecznyID );
    Add( cZLERodzajSklad_Regula,  cZLERodzajSklad_RegulaID );
//    Add( cZLERodzajSklad_ElemWyl, cZLERodzajSklad_ElemWylID )
  end;
  cslZLEStatusZlecenia := TConstStringList.Create();
  with cslZLEStatusZlecenia do begin
    Add( cZLEStatusZlecenia_Oczekujace,  cZLEStatusZlecenia_OczekujaceID );
    Add( cZLEStatusZlecenia_WRealizacji, cZLEStatusZlecenia_WRealizacjiID );
    Add( cZLEStatusZlecenia_Wstrzymane,  cZLEStatusZlecenia_WstrzymaneID );
    Add( cZLEStatusZlecenia_Zakonczone,  cZLEStatusZlecenia_ZakonczoneID );
    Add( cZLEStatusZlecenia_Anulowane,   cZLEStatusZlecenia_AnulowaneID );
  end;
  cslZLEAktywnosc := TConstStringList.Create();
  with cslZLEAktywnosc do begin
    Add( cZLEAktywnosc_NieAktywny, cZLEAktywnosc_NieAktywnyID );
    Add( cZLEAktywnosc_Opcjonalny, cZLEAktywnosc_OpcjonalnyID );
    Add( cZLEAktywnosc_Wymagany, cZLEAktywnosc_WymaganyID );
  end;
  cslZLERodzajZasobu := TconstStringList.Create();
  with cslZLERodzajZasobu do begin
    Add( cZLERodzajZasobu_Pracownik, cZLERodzajZasobu_PracownikID );
    Add( cZLERodzajZasobu_Maszyna, cZLERodzajZasobu_MaszynaID );
  end;
  cslZLETabelePowiazane := TConstStringList.Create();
  with cslZLETabelePowiazane do begin
    Add( 'Brak powizania', sUNICONST_ALTERNATYWA_NIE );
    Add( 'Zgoszenia', sBOKSPRAWA );
  end;

  cslZLEPolaUzState := TConstStringList.Create;
  with cslZLEPolaUzState do begin
    Add(cZLEPolaUzState_TextOfUnUsed, cZLEPolaUzState_IDOfUnUsed);
    Add(cZLEPolaUzState_TextOfCanUse, cZLEPolaUzState_IDOfCanUse);
    Add(cZLEPolaUzState_TextOfHaveToUse, cZLEPolaUzState_IDOfHaveToUse);
  end;

  cslZLETypDanych := TConstStringList.Create();
  with cslZLETypDanych do begin
    Add(cZLETypDanych_Integer, cZLETypDanych_IntegerID);
    Add(cZLETypDanych_Float,   cZLETypDanych_FloatID);
    Add(cZLETypDanych_String,  cZLETypDanych_StringID);
    Add(cZLETypDanych_Date,    cZLETypDanych_DateID);
  end;

  cslZLEParserBlad := TConstStringList.Create();
  with cslZLEParserBlad do begin
    Add(cZLEParserBlad_Brak, cZLEParserBlad_BrakID);
    Add(cZLEParserBlad_DzielZero, cZLEParserBlad_DzielZeroID);
    Add(cZLEParserBlad_BladInny, cZLEParserBlad_BladInnyID);
  end;

  cslZLE_INFMnemoniki := TConstStringList.Create();
  with cslZLE_INFMnemoniki do begin
    Add( 'ILO' {sMnemonikLokale}, '0' );
    Add( 'IZA' {sMnemonikZasoby}, '1' );  //Zasb = sownik zasobw a nie rodzajw zasobw ISZ
    Add( 'IKL' {sMnemonikKlatki}, '2' );
    Add( 'IBR' {sMnemonikBramy}, '3' );
    Add( 'IBU' {sMnemonikBudynki}, '4' );
    Add( 'INI' {sMnemonikNieruchomosci}, '5' );
    Add( 'IWS' {Wspolnota}, '6' );
    Add( 'IRE' {sMnemonikRejony}, '7' );
    Add( 'IUL' {sMnemonikUlice}, '8' );
    Add( 'ISE' {sMnemonikElemSieci}, '9' );
    {Tylko do ograniczenia poziomu w kryteriach}
    //Add( 'BKM' {Miasto}, 'M' );
    //Add( 'BKW' {Wojewdztwo}, 'W' );
    //Add( 'IPO', '10' ); //Jak pojawi si bd to odkomentowa to
    Add( 'ISS' {sMnemonikSkladnikElemSieci}, '11' );
  end;

  cslZLEConstPrefix := TConstStringList.Create();
  with cslZLEConstPrefix do begin
    Add(cZLEConstPrefix_Prefix,  cZLEConstPrefix_PrefixID);
    Add(cZLEConstPrefix_Oddzial, cZLEConstPrefix_OddzialID);
  end;

  cslZLEConstZasobPracaStatus := TConstStringList.Create();
  with(cslZLEConstZasobPracaStatus) do begin
    Add(cZLEConstZasobPracaStatus_Wprowadzony   ,  cZLEConstZasobPracaStatus_WprowadzonyID);
    Add(cZLEConstZasobPracaStatus_Zaakceptowany ,  cZLEConstZasobPracaStatus_ZaakceptowanyID);
  end;  // with(cslZLEConstZasobPracaStatus)

  cslZLEConstZleWycenaStatus  := TConstStringList.Create();
  with(cslZLEConstZleWycenaStatus) do begin
    Add(cZLEConstZleWycenaStatus_Wprowadzony   ,  cZLEConstZleWycenaStatus_WprowadzonyID);
    Add(cZLEConstZleWycenaStatus_Zaakceptowany ,  cZLEConstZleWycenaStatus_ZaakceptowanyID);
  end;  // with(cslZLEConstZleWycenaStatus)

  cslZLERodzajECP := TconstStringList.Create();
  with cslZLERodzajECP do begin
    Add( cZLERodzajECP_Osoba, cZLERodzajECP_OsobaID );
    Add( cZLERodzajECP_Zasob, cZLERodzajECP_ZasobID );
    Add( cZLERodzajECP_Rozlicz, cZLERodzajECP_RozliczID );
    Add( cZLERodzajECP_Produkcja, cZLERodzajECP_ProdukcjaID );
  end;

  cslZLEConstZasobyPracaRapStatus := TConstStringList.Create();
  with(cslZLEConstZasobyPracaRapStatus) do begin
    Add(cZLEConstZasobyPracaRapStatus_Zgodny   ,  cZLEConstZasobyPracaRapStatus_ZgodnyID);
    Add(cZLEConstZasobyPracaRapStatus_Niezgodny,  cZLEConstZasobyPracaRapStatus_NiezgodnyID);
  end;  // with(cslZLEConstZasobPracaRapStatus)

finalization
  cslZLERodzajSklad.Free;
  cslZLEStatusZlecenia.Free;
  cslZLEAktywnosc.Free;
  cslZLERodzajZasobu.Free;
  cslZLETabelePowiazane.Free;
  cslZLEPolaUzState.Free;
  cslZLETypDanych.Free;
  cslZLEParserBlad.Free;
  cslZLE_INFMnemoniki.Free;
  cslZLEConstZasobPracaStatus.Free();
  cslZLERodzajECP.Free();
  cslZLEConstZasobyPracaRapStatus.Free();
end.



