unit ZLEFunkcjeAnalizyUnit;
{
Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
  When     Who      What
---------------------------------------------------------------------------------------------
2009-07-27 Tomjen   Utworzone
}

interface

uses
  SysUtils, Classes, UNIComponentsUnit;

function ZLEFunkcjeAnalizy_SQLPrepare(
           sAgregateFunction: string;
           iAktualOkresNr: integer;
           iAktywnaFirmaID: integer;
           sRokObrachunkowy: string;
           bSymulacja: boolean;
           bZestawienieZDokumentami: boolean;
           var sSQL: string;
           var sErrorMessage: string;
           var iLiczbaSlownikow:integer):boolean;

implementation

uses
  ASODefUnit,
  PECDefUnit,
  GZkDefUnit,
  SANDefUnit,
  BKDefUnit,
  SpDefUnit,
  CenDefUnit,
  INFDefUnit,
  ZLEDefUnit,
  MFSDefUnit,
  FKDefUnit,
  FKDataManagerUnit,
  Dodatki,
  KeyManagerUnit,
  MFSDataManagerUnit,
  SQLManagerUnit,
  UNIDataManagerUnit,
  UNISysDataManagerUnit,
  UNISysDefUnit,
  ZLEDataManagerUnit;

const
  cOddzialAlias = 'ODD';

function FKMnemonikiDajPoleMnemonikaDlaSymbolu( sPole, sMnemonikiSymbol:string;
                                                iIndex: Integer = 0):Variant;
var
  sResult:string;
  sSQL   :string;
begin
  if length(trim(sMnemonikiSymbol)) = 0 then begin
    //pusty symbol moze by wielokrotny, bo to jest tzw mnemonik lokalny
    Result:=-1;
  end
  else begin
    sSQL:= SQLManager.GetSelectWithInnerJoins(
              sPole,[sFKMNEMONIKI],[''],[''],
              '('+sFKMNEMONIKI_MNEMONIK + ' = ' + '''' + sMnemonikiSymbol + ''')and'+
              '('+sFKMNEMONIKI_INDEKS + ' = ' + IntToStr(iIndex)+')');
    sResult:=SQLManager.OpenQueryWithResult( sSQL ,['']);
    if sResult='' then
      Result:=0
    else
      Result:=StrToInt(sResult);
  end;
end;

function FKMnemonikiDajIDMnemonikaDlaSymbolu( sMnemonikiSymbol:string;
                                              iIndex: Integer = 0):integer;
begin
  result := FKMnemonikiDajPoleMnemonikaDlaSymbolu( sFKMNEMONIKI_ID, sMnemonikiSymbol, iIndex );
end;

//metoda zwraca flag obecnoci mnemonika o podanym symbolu (3-znakowym)
//UWAGA - mnemonik o pustym symbolu zawsze zwraca TRUE
function FKMnemonikiCzyMnemonikIstniejeDlaSymbolu(sMnemonikiSymbol:string):boolean;
begin
  if length(trim(sMnemonikiSymbol)) = 0 then
    result := true
  else
    result := (FKMnemonikiDajIDMnemonikaDlaSymbolu(sMnemonikiSymbol) > 0);
end;

//Kontrola szczegolowa parametrw
function KontrolaParametrow(
           sRokObrachunkowy:string;
           iAktualOkresNr:integer;
           var sErrorMessage:string;
           var kvParametryWywolania:TKeyValues):boolean;
var
  iLicznik            :integer;
  iPos                :integer;
  kvValidParam        :TStringList;
  sParamMin           :string;
  sParamName          :string;

  //Kontrola parametrw wewntrz zakresu SUM lub POWT
  function KontrolaParametrowZakresPOWT_SUM(sParamString:string{;
                                            bCzyJestPierwszyParametr:boolean=true;
                                            sSzablonZnakow:string='';
                                            bCzyJestDopuszczalnyMnemonik:boolean=true}):boolean;
  var
    iLicznik     :integer;
    iPos         :integer;
    sFirstParam  :string;
    sParam       :string;
    kvParametry  :TStringList;
    Spl          :TSplit;

    function KontrolaParametrowZakresPOWT_SUM_CzyZnakiPoprawne(sKontrolowanyString:string):boolean;
    var
      bFindFirstNoSpaceCharacter:boolean;
      iLicznik                  :integer;
      sChar                     :string;
    begin
      //string ju jest zamieniony na due litery
      bFindFirstNoSpaceCharacter:=false;
      Result:=true;
      for iLicznik:=length(sKontrolowanyString) downto 1 do begin
        sChar:=copy(sKontrolowanyString,iLicznik,1);  //pobieram kolejny znak
        if ((sChar <> ' ') and (Pos(sChar, sUNICONST_SLOWNIK_SYMBOL)>0) ) then
           bFindFirstNoSpaceCharacter:=true
        else begin
          //wewntrz stringu nie moe by spacji, a kocowe usunem trim-em
          //tu trafi rwnie inne niedopuszczalne znaki
          //oraz *
          if not bFindFirstNoSpaceCharacter then
          begin
            //przypadek do przyjcia
          end
          else begin
            result := false;
            break;
          end;
        end;
      end;
    end; //of ZZBKontrolaParametrowZakresPOWT_SUM_CzyZnakiPoprawne

  begin
    //Poszukiwanie pierwszego parametru
    iPos:=Pos(';',sParamString);
    if iPos = 0 then begin
      //jest tylko JEDNA warto
      sFirstParam :='';
      result := false;
    end
    else begin
      //Jest wicej parametrw - oddzielamy pierwszy od pozostalych
      sFirstParam:=copy(sParamString,1,iPos-1);
      sParamString:=copy(sParamString,iPos+1,length(sParamString)-iPos);
      result := true;
    end;

    //jako pierwszy parametr podano mnemonik - sprawdzi, czy jest poprawny
    if result then
      result := FKMnemonikiCzyMnemonikIstniejeDlaSymbolu(sFirstParam);

    //przystpujemy do kontroli poszczeglnych wartoci z listy
    if result and (sFirstParam <> sMnemonikZlecenie) then begin
      //wydzieli pozostae parametry
      kvParametry:=TStringList.Create();
      if Pos(';',sParamString) = 0 then  //pojedynczy parametr
        kvParametry.add(sParamString)
      else begin                              //wiele parametrw
        Spl:=TSplit.Create(sParamString,';','');
        try
          for iLicznik:=0 to Spl.Count-1 do
            kvParametry.add(Spl[iLicznik]);
        finally
          Spl.Free;
        end;
      end;

      try
        if (kvParametry.Count = 0) then
          //Warunek na znaki - przynajmniej jeden podcig
          result := false
        else begin
          //parametry wrzucone do struktury - zaczynam kontrol poszczeglnych parametrw
          for iLicznik:=0 to kvParametry.Count-1 do begin
            //Albo zakres od-do albo pojedynczy znak
            sParam:=kvParametry[iLicznik];
            iPos:=Pos('-',sParam);
            if iPos > 0 then begin
              //zakres - naley go rozbi na dwie czsci
              //pierwsza cz to tylko znaki
              //spacje nie mog wystpowac wewntrz stringu.
              sFirstParam:=trim(copy(sParam,1,iPos-1));
              result:=KontrolaParametrowZakresPOWT_SUM_CzyZnakiPoprawne(sFirstParam);
              if result then begin
                //druga cz - jak niej
                sFirstParam:=copy(sParam,iPos+1,length(sParam)-iPos);
                result:=KontrolaParametrowZakresPOWT_SUM_CzyZnakiPoprawne(sFirstParam);
              end;
            end
            else
              //pojedynczy parametr.
              result:=KontrolaParametrowZakresPOWT_SUM_CzyZnakiPoprawne(sParam);

            if not result then
              break; //parametr jest bdny
          end;
        end;
      finally
        kvParametry.Free;
      end;
    end;
  end;

begin
  result := true;

  //Lista dopuszczalnych parametrw do wywolania w funkcji
  kvValidParam:=TStringList.Create();
  try
    (**************
    kvValidParam.add(cAgregateFunctionParam_WARTOSC);
    kvValidParam.add(cAgregateFunctionParam_ZPozycji);
    *****************)

    kvValidParam.add(cAgregateFunctionParam_ZakSUM);
    kvValidParam.add(cAgregateFunctionParam_ZakPOWT);
    kvValidParam.add(cAgregateFunctionParam_Zrodlo);
    kvValidParam.add(cAgregateFunctionParam_Funkcja);

    //Sprawdzenie czy we wskazanych parametrach wywolania wystpuj tylko dopuszczalne
    for iLicznik := 0 to kvParametryWywolania.Count-1 do begin
      sParamName := kvParametryWywolania.Names[iLicznik];
      if kvValidParam.IndexOf(sParamName) < 0 then
        result:=false;

      if not result then begin
        sErrorMessage:='Nieobsugiwany parametr '+sParamName;
        break;
      end;
    end;
  finally
    kvValidParam.free;
  end;

  //Sprawdzenie poprawnosci wartosci parametrw
  if result then begin
      //Sprawdzenie wszystkich parametrw podanych jako ZakresSUM lub ZakresPOWT
      for iLicznik := 0 to kvParametryWywolania.Count-1 do begin
        sParamName:=kvParametryWywolania.Names[iLicznik];
        if (sParamName = cAgregateFunctionParam_ZakPOWT) or
           (sParamName = cAgregateFunctionParam_ZakSUM) then begin
          //Parametr postaci ZAKRES(SUM lub POWT)=[....]
          sParamName:=kvParametryWywolania[iLicznik];

          //Wydobycie wntrza nawiasw prostoktnych
          iPos:=Pos('=',sParamName);
          sParamMin := copy(sParamName,iPos+1,length(sParamName)-iPos);
          sParamMin := copy(sParamMin,2,length(sParamMin)-2);

          //Kontrola poprawnosci wntrza nawiasu
          result := KontrolaParametrowZakresPOWT_SUM(sParamMin);
          if not result then begin
            sErrorMessage:='Parametr '+sParamName+' ma niepoprawn skadni ';
            break;
          end;
        end else
        if (sParamName = cAgregateFunctionParam_Zrodlo) then begin
          //Parametr postaci ZRODLO=SRC
          sParamName:=kvParametryWywolania[iLicznik];
          //Wydobycie wartoci parametru po znaku =
          iPos:=Pos('=',sParamName);
          sParamMin := copy(sParamName,iPos+1,length(sParamName)-iPos);
          result := ((sParamMin = cParam_ZrodloWartosc) or
                     (sParamMin = cParam_ZrodloRobocizna) or
                     (sParamMin = cParam_ZrodloFunkcja));
          if not result then begin
            sErrorMessage:='Parametr '+sParamName+' ma niepoprawn skadni ';
            break;
          end;
        end else
        if (sParamName = cAgregateFunctionParam_Funkcja) then begin
          //Parametr postaci ZRODLO=SRC
          sParamName:=kvParametryWywolania[iLicznik];
          //Wydobycie wartoci parametru po znaku =
          iPos:=Pos('=',sParamName);
          sParamMin := copy(sParamName,iPos+1,length(sParamName)-iPos);
          result := (length(sParamMin) > 0) and (iPos > 0);  //istnieje cos po znaku =
          if not result then begin
            sErrorMessage:='Parametr '+sParamName+' ma niepoprawn skadni ';
            break;
          end;
        end;
      end;
  end;
end;

//Kontrola poprawnosci podanych parametrw
function AgregateFunctionParametersControl(
           sAgregateFunctionName:string;
           sRokObrachunkowy:string;
           iAktualOkresNr:integer;
           var kvAgregateFunctionParam:TKeyValues;
           var sErrorMessage:string):boolean;
begin
  //Kontrola kadego z parametrw
  result:=true;
  if kvAgregateFunctionParam.Count > 0 then begin
    //Okreslenie dopuszczalnosci okreslonych parametrw w zalenosci od nazwy funkcji
    //Funkcje zwizane z obrotami liczymy na podstawie roku i okresu
    result:= KontrolaParametrow(sRokObrachunkowy, iAktualOkresNr, sErrorMessage,
                                kvAgregateFunctionParam);

    //W przypadku bledu zwracana jest wartosc kodu bldu
    if not result then
    begin
      sErrorMessage := 'Funkcja: '+sAgregateFunctionName+#10+sErrorMessage;
      exit;
    end;
  end;
end;

//Generacja zakresu na podstawie parametru slownika
function GenerateWhereForSlownik(sParam:string;sPole:string;sAlias:string):string;
var
  iPos    :integer;
  sWhere  :string;
  sParamOd:string;
  sParamDo:string;
  sPole2: String;
begin
  sWhere:='';

  if sAlias <> '' then
       sPole2 := sAlias + '.' + sPole
  else sPole2 := sPole;

  if  (sPole2 <> '') then begin
    iPos:=Pos('-',sParam);
    if iPos > 0 then begin
      //Zakresowym jest od do
      sParamOd:=trim(copy(sParam,1,iPos-1));
      sParamDo:=trim(copy(sParam,iPos+1,length(sParam)-iPos));
      if Trim(sParamOd) = '' then begin
         sWhere:='(substr(' + sPole2 + ', 1, ' + IntToStr(length(sParam)) + ')<=' + QuotedStr(sParamDo) + ')';
      end else
      if Trim(sParamDo) = '' then begin
         sWhere:='(substr(' + sPole2 + ', 1, ' + IntToStr(length(sParam)) + ')>=' + QuotedStr(sParamOd) + ')';
      end else begin
         sWhere := '('+
                      '(substr(' + sPole2 + ', 1, ' + IntToStr(length(sParamOd)) + ')>=' + QuotedStr(sParamOd) + ')' + ' and '+
                      '(substr(' + sPole2 + ', 1, ' + IntToStr(length(sParamDo)) + ')<=' + QuotedStr(sParamDo) + ')' +
                    ')';
      end;
    end
    else begin
      //Zakres ograniczony pojedynczym parametrem
      sWhere:='(substr(' + sPole2 + ', 1, ' + IntToStr(length(sParam)) + ')=' + QuotedStr(sParam) + ')';
    end;
  end;
  result := sWhere;
end;

//Budowa SQL-a na podstawie parametrw
function AgregateFunctionCreateSQL(
           sAgregateFunctionName:string;
           kvAgregateFunctionParam:TKeyValues;
           iAktualOkresNr:integer;
           iAktywnaFirmaID:integer;
           sRokObrachunkowy:string;
           var iLiczbaSlownikow:integer;
           var ErrorC : integer;
           var sZPozycjiBledy:string;
           bSymulacja:boolean=true;
           bZestawienieZDokumentami:boolean=false):string;
var
  sSelectZew,
  sSelectWew,
  sWhereZew,
  sWhereWew,
  sJoinZew,
  //sJoinWew,
  sHavingZew,
  sListaTabZew,
  sListaTabWew,
  sListaGroupBy,
  sDodatkoweTabele,
  sMnemTab:           string;
//  bDodanoPozycje,
//  bPozycje           :boolean;
  bBylMnemInf        :Boolean;

  iLicznikPowt,
  iLicznikSum        :integer;
  iMnemonikiID       :Integer;
  bZakresPowt        :Boolean;
  qMnem              :TUniQuery;

  iLicznik           :integer;
  iLicznikZakresParam:integer;
  iLP_DICTPOWT       :integer; //niezbdna do wyapania ZakresSUM
  iPos               :integer;
//  iTempInteger       :integer;
  sFirstParam        :string;
  sParam             :string;
  sParamName         :string;
  sWhereZakres       :string;
  Spl                :TSplit;
  sPole              :string;
  sAlias             :string;
  //Dla zakresu powt
//  bCzyPunkt,
//  bSprawdzZgodnoscZPoz : boolean;
  //bMnemFirmowy         : Boolean;
  sLicznikSlownik      : string;
  sPoziomInf           : String;
  bHavingJoin          : Boolean;
  sHavingTmp           : String;
  sGroupBy             : String;

  bJestFunkcja       : Boolean;
  sFunkcjaNazwa      : string;
  sZrodlo            : string;
  sTmpParam          : String;

  iOkresID           : Integer;

  function UstalOkresID(sRok: String; iOkresNr: Integer) : Integer;
  var
    sRokTmp, sWynik: String;
  begin
    result := 0;
    if iOkresNr > 0 then begin
       sRokTmp := iifs(sRok = '', UNISYSDM.vAktywnyRokObrachunkowy, sRok);

       sWynik := SQLManager.OpenQueryWithResult('SELECT o.' + sUNIOKRES_ID + ' ' +
                                                'FROM %s o, %s r ' +
                                                'WHERE o.' + sUNIROK_ID + '=R.' + sUNIROK_ID + ' ' +
                                                 ' AND r.' + sUNIROK_ROK + '=' + QuotedStr(sRokTmp) + ' '+
                                                 ' AND o.' + sUNIOKRES_OKRES_NR + '=' + IntToStr(iOkresNr),
                                                [sUNIOKRES, sUNIROK]);

       try
         result := StrToInt(sWynik);
       except
         result := 0;
       end;
    end;
  end;
  (* Zapytanie wynikowe
   SELECT
     Sum(SUMA) AS SUMA,
     IDSLOW1,
     ..
     IDSLOWK,
     SYMB1,
     ..
     SYMBK
   FROM (
     SELECT
       SUM(NVL(ZLEZLECENIEPOZ_WARTOSC, 0)) AS SUMA,
       SelectZew [==  IDSLOW1,
                      ..
                      IDSLOWK,
                      SYMB1,
                      ..
                      SYMBK,
                      IDSLOW_1,
                      ..
                      IDSLOW_S,
                      SYMB_1,
                      ..
                      SYMB_S]
     FROM (
       SELECT
          ZP1.ZLEZLECENIEPOZ_WARTOSC as ZLEZLECENIEPOZ_WARTOSC,
          SelectWew
       FROM
          ListaTabWew
       WHERE
          WhereWew
       )
     GROUP BY
        ListaGroupBy =
       [IDSLOW1,
        ..
        IDSLOWK,
        SYMB1,
        ..
        SYMBK,
        IDSLOW_1,
        ..
        IDSLOW_S,
        SYMB_1,
        ..
        SYMB_S]
     HAVING
       HavingZew
    )
   GROUP BY
     IDSLOW1,
     ..
     IDSLOWK,
     SYMB1,
     ..
     SYMBK
  ****************)

begin
  Result  := '';
  ErrorC          := 0;
  sSelectZew      := '';
  sSelectWew      := '';
  sWhereZew       := '';
  sWhereWew       := '';
  sJoinZew        := '';
  //sJoinWew        := '';
  sHavingZew      := '';
  sListaTabZew    := '';
  sListaTabWew    := '';
  sListaGroupBy   := '';
  sDodatkoweTabele:= '';
  iLicznikPowt    := 0;
  iLicznikSum     := 0;
  //bMnemFirmowy    := True;
  sPoziomInf      := '';
  sHavingTmp      := '';
  sGroupBy        := '';
  bBylMnemInf     := False;
  sZPozycjiBledy  := ''; //??
  iLiczbaSlownikow:= 0;

  bJestFunkcja    := False;
  sFunkcjaNazwa   := '';
  sZrodlo         := cParam_ZrodloWartosc;  //Domylnie warto z pozycji zlecenia

{
  if sAgregateFunctionName = cAgregateFunction_ZLEDanePozycji then
     bPozycje := true;
}

  //Analiza parametrw typu ZakresSUM lub ZakresPowt
  iLp_DictPowt := 0;
//  bDodanoPozycje := FALSE;
  sListaTabWew := SQLManager.GetTableName(sZLEZLECENIE) + ' ZL, ' +
                  SQLManager.GetTableName(sZLEZLECENIEPOZ) + ' ZP1 ';

  sWhereWew     := ' (ZL.' + sZLEZLECENIE_ID + ' = ZP1.' + sZLEZLECENIE_ID + ')';

  for iLicznik := 0 to kvAgregateFunctionParam.Count-1 do begin

    sParamName:=kvAgregateFunctionParam.Names[iLicznik];
    if (sParamName = cAgregateFunctionParam_ZakPOWT) or
       (sParamName = cAgregateFunctionParam_ZakSUM) then begin
      //Odddzielenie nazwy parametru od wartosci
      sParamName:=kvAgregateFunctionParam[iLicznik];
      iPos      := Pos('=',sParamName);

      //Wartosc parametru bez nawiasw okrglych
      sParam    := copy(sParamName,iPos+1,length(sParamName)-iPos);
      sParam    := copy(sParam,2,length(sParam)-2);

      //Nazwa parametru (zakres sum lub powt)
      sParamName := kvAgregateFunctionParam.Names[iLicznik];

      //ZakresPowt - numer uytego elementu slownika
      if sParamName = cAgregateFunction_ZakPOWT then begin
         Inc(iLicznikPowt);
         bZakresPowt := True;
      end else begin
         Inc(iLicznikSum);
         bZakresPowt := False;
      end;

      //Separacja slownika od przyjmowanych przez niego wartosci
      iPos        := Pos(';',sParam);
      sFirstParam := copy(sParam,1,iPos-1);              //Slownik
      sParam:=copy(sParam,iPos+1,length(sParam)-iPos); //Dalsze parametry

      {Analiza parametru
       Specjalnia obsuga mnemonikw:
           ZLE - zlecenie,
           XTZ - typ zlecenia,
           XPF - prefix zlecenia,
           ODZ, FIR - oddzia/firma,
           oraz mnemoniki INF  }
      //Ustalenie mnemonika na podstawie symbolu
      iMnemonikiID := FKMnemonikiDajIDMnemonikaDlaSymbolu(sFirstParam);
      qMnem := ZLEDM.ListaMnemonikow(sFirstParam);
      try
         sMnemTab := qMnem.FieldByName(sFKMNEMONIKI_TABELA).AsString;
         {if vWielofirmowosc then
            bMnemFirmowy := (qMnem.FieldByName(sFKMNEMONIKI_CZY_FIRM).AsString = sTak);}
      finally
         if qMnem <> nil then FreeAndNil(qMnem);
      end;

      if (sFirstParam = sMnemonikZlecenie) then begin
          if sSelectWew <> '' then
             sSelectWew := sSelectWew + ', ';

          if bZakresPowt then begin
             Inc(iLp_DictPowt); //To bd sowniki IDSLOWx, SYMBx
             sSelectWew := sSelectWew +   'ZL.' + sZLEZLECENIE_ID + ' AS IDSLOW' + IntToStr(iLicznikPowt) +
                                        ', ZL.' + sZLEZLECENIE_SYMBOL + ' AS SYMB' + IntToStr(iLicznikPowt);
          end else begin
             sSelectWew := sSelectWew +   'ZL.' + sZLEZLECENIE_ID + ' AS IDSLOW_' + IntToStr(iLicznikSum) +
                                        ', ZL.' + sZLEZLECENIE_SYMBOL + ' AS SYMB_' + IntToStr(iLicznikSum);
          end;

          bHavingJoin := False;
          sPole  := sZLEZLECENIE_SYMBOL;
          sAlias := 'ZL';
      end else
      if (sFirstParam = sMnemonikTypZlecenia) then begin
          if sSelectWew <> '' then
             sSelectWew := sSelectWew + ', ';

          if bZakresPowt then begin
             Inc(iLp_DictPowt); //To bd sowniki IDSLOWx, SYMBx
             sSelectWew := sSelectWew +   'ZL.' + sZLETYPZLEC_ID + ' AS IDSLOW' + IntToStr(iLicznikPowt) +
                                        ', ZT.' + sZLETYPZLEC_SYMBOL + ' AS SYMB' + IntToStr(iLicznikPowt);
          end else begin
             sSelectWew := sSelectWew +   'ZL.' + sZLETYPZLEC_ID + ' AS IDSLOW_' + IntToStr(iLicznikSum) +
                                        ', ZT.' + sZLETYPZLEC_SYMBOL + ' AS SYMB_' + IntToStr(iLicznikSum);
          end;

          sListaTabWew := sListaTabWew + ', ' + SQLManager.GetTableName(sZLETYPZLEC) + ' ZT ';
          sWhereWew := sWhereWew + ' AND ZT.' + sZLETYPZLEC_ID + ' = ZL.' + sZLETYPZLEC_ID;
          bHavingJoin := False;
          sPole  := sZLETYPZLEC_SYMBOL;
          sAlias := 'ZT';
      end else
      if (sFirstParam = sMnemonikZLEPrefix) then begin
          if sSelectWew <> '' then
             sSelectWew := sSelectWew + ', ';

          if bZakresPowt then begin
             Inc(iLp_DictPowt); //To bd sowniki IDSLOWx, SYMBx
             sSelectWew := sSelectWew +   'ZL.' + sZLEPREFIX_ID + ' AS IDSLOW' + IntToStr(iLicznikPowt) +
                                        ', PF.' + sZLEPREFIX_SYMBOL + ' AS SYMB' + IntToStr(iLicznikPowt);
          end else begin
             sSelectWew := sSelectWew +   'ZL.' + sZLEPREFIX_ID + ' AS IDSLOW_' + IntToStr(iLicznikSum) +
                                        ', PF.' + sZLEPREFIX_SYMBOL + ' AS SYMB_' + IntToStr(iLicznikSum);
          end;

          sListaTabWew := sListaTabWew + ', ' + SQLManager.GetTableName(sZLEPREFIX) + ' PF ';
          sWhereWew := sWhereWew + ' AND PF.' + sZLEPREFIX_ID + ' = ZL.' + sZLEPREFIX_ID;
          bHavingJoin := False;
          sPole  := sZLEPREFIX_SYMBOL;
          sAlias := 'PF';
      end else
      if (sFirstParam = sMnemonikOddzialy) or (sFirstParam = sMnemonikFirmy) then begin
          if sSelectWew <> '' then
             sSelectWew := sSelectWew + ', ';

          if bZakresPowt then begin
             Inc(iLp_DictPowt); //To bd sowniki IDSLOWx, SYMBx
             sSelectWew := sSelectWew +   'ZL.' + sUNIODDZIAL_ID + ' AS IDSLOW' + IntToStr(iLicznikPowt) +
                                        ', ODD.' + sUNIODDZIAL_SYMBOL + ' AS SYMB' + IntToStr(iLicznikPowt);
          end else begin
             sSelectWew := sSelectWew +   'ZL.' + sUNIODDZIAL_ID + ' AS IDSLOW_' + IntToStr(iLicznikSum) +
                                        ', ODD.' + sUNIODDZIAL_SYMBOL + ' AS SYMB_' + IntToStr(iLicznikSum);
          end;

          sListaTabWew := sListaTabWew + ', ' + SQLManager.GetTableName(sUNIODDZIAL) + ' ODD ';
          sWhereWew := sWhereWew + ' AND ODD.' + sUNIODDZIAL_ID + ' = ZL.' + sUNIODDZIAL_ID;
          bHavingJoin := False;
          sPole  := sUNIODDZIAL_SYMBOL;
          sAlias := 'ODD';
      end else {Infrastruktura}

      if (not bBylMnemInf) and (cslZLE_INFMnemoniki.IndexOf(sFirstParam) > 0) then begin
          bBylMnemInf := True;
          sPoziomInf := cslZLE_INFMnemoniki.ZwrocSkrot(cslZLE_INFMnemoniki.IndexOf(sFirstParam));
          if sSelectWew <> '' then
             sSelectWew := sSelectWew + ', ';

          if bZakresPowt then begin
             Inc(iLp_DictPowt); //To bd sowniki IDSLOWx, SYMBx
             sSelectWew := sSelectWew + '(CASE WHEN ZP1.' + sZLEZLECENIEPOZ_POZIOMINF + ' = ' + QuotedStr(sPoziomInf) + ' THEN ' +
                                                   'ZP1.' + sZLEZLECENIEPOZ_INF_ID + ' ' +
                                              'ELSE NULL ' +
                                         'END) AS IDSLOW' + IntToStr(iLicznikPowt) + ', ' +
                                        '(CASE WHEN ZP1.' + sZLEZLECENIEPOZ_POZIOMINF + ' = ' + QuotedStr(sPoziomInf) + ' THEN ' +
                                                    SQLManager.GetTableName('INF_DAJSYMBOLOBIEKTU') + '(ZP1.' + sZLEZLECENIEPOZ_POZIOMINF + ', ZP1.' + sZLEZLECENIEPOZ_INF_ID + ') ' +
                                              'ELSE NULL ' +
                                         'END) AS SYMB' + IntToStr(iLicznikPowt);

             sPole  := 'SYMB' + IntToStr(iLicznikPowt);
          end else begin
             sSelectWew := sSelectWew + '(CASE WHEN ZP1.' + sZLEZLECENIEPOZ_POZIOMINF + ' = ' + QuotedStr(sPoziomInf) + ' THEN ' +
                                                   'ZP1.' + sZLEZLECENIEPOZ_INF_ID + ' ' +
                                              'ELSE NULL ' +
                                         'END) AS IDSLOW_' + IntToStr(iLicznikSum) + ', ' +
                                        '(CASE WHEN ZP1.' + sZLEZLECENIEPOZ_POZIOMINF + ' = ' + QuotedStr(sPoziomInf) + ' THEN ' +
                                                    SQLManager.GetTableName('INF_DAJSYMBOLOBIEKTU') + '(ZP1.' + sZLEZLECENIEPOZ_POZIOMINF + ', ZP1.' + sZLEZLECENIEPOZ_INF_ID + ') ' +
                                              'ELSE NULL ' +
                                         'END) AS SYMB_' + IntToStr(iLicznikSum);
             sPole  := 'SYMB_' + IntToStr(iLicznikSum);
          end;

          bHavingJoin := True;
          sAlias := '';
          (***********************
          if bINIandIBU then begin
             if (sFirstParam = 'INI') then begin
                {A tu drobna zmiana - Nieruchomo na podstawie Budynku}
                if (sObiekt = '4') then begin
          if sSelectWew <> '' then
             sSelectWew := sSelectWew + ', ';
                    sSelectWew := sSelectWew + ' ' + '(SELECT NN.' + sINFNIERUCHOMOSC_SYMBOL + ' ' +
                                          'FROM ' + SQLManager.GetTableName(sINFBUDYNEK) + ' NB, ' +
                                                    SQLManager.GetTableName(sINFNIERUCHOMOSC) + ' NN ' +
                                          'WHERE  NN.' + sINFNIERUCHOMOSC_ID + ' = NB.' + sINFNIERUCHOMOSC_ID + ' AND ' +
                                                 'NB.' + sINFBUDYNEK_ID + ' = ZP1.' + sZLEZLECENIEPOZ_INF_ID + ') AS ' + Copy(Trim(oSplit.Items[i]), 1, 3) + '_SYMBOL';

                    vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
                    if vWarItem <> nil then
                        if vWarItem.ListaID <> '' then begin
                           if sWarunekWhere <> '' then
                              sWarunekWhere := sWarunekWhere + ' AND ';
                           sWarunekWhere := sWarunekWhere +
                              'SEL.' + Copy(Trim(oSplit.Items[i]), 1, 3) + '_SYMBOL' + ' IN (SELECT ' + sMnemTab + '_SYMBOL' +
                                                                               ' FROM ' + SQLManager.GetTableName(sMnemTab) +
                                                                               ' WHERE ' + sMnemTab + '_ID' + ' IN (' + vWarItem.ListaID + ')) ';
                        end;
                end else begin
          if sSelectWew <> '' then
             sSelectWew := sSelectWew + ', ';
                    sSelectWew := sSelectWew + ' ' + SQLManager.GetTableName('INF_DAJSYMBOLOBIEKTU') + '(ZP1.' + sZLEZLECENIEPOZ_POZIOMINF + ', ZP1.' + sZLEZLECENIEPOZ_INF_ID + ') AS ' + Copy(Trim(oSplit.Items[i]), 1, 3) + '_SYMBOL';
                    vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
                    if vWarItem <> nil then
                       if vWarItem.ListaID <> '' then begin
                          if sWarunekWhere <> '' then
                             sWarunekWhere := sWarunekWhere + ' AND ';
                          sWarunekWhere := sWarunekWhere +
                             'SEL.' + Copy(Trim(oSplit.Items[i]), 1, 3) + '_SYMBOL' + ' IN (SELECT ' + sMnemTab + '_SYMBOL' +
                                                                              ' FROM ' + SQLManager.GetTableName(sMnemTab) +
                                                                              ' WHERE ' + sMnemTab + '_ID' + ' IN (' + vWarItem.ListaID + ')) ';
                       end;
                end;
             end else
             if sFirstParam = 'IBU' then begin
                 if sObiekt = '4' then begin //Poziom budynek
          if sSelectWew <> '' then
             sSelectWew := sSelectWew + ', ';
                     sSelectWew := sSelectWew + ' ' + SQLManager.GetTableName('INF_DAJSYMBOLOBIEKTU') + '(ZP1.' + sZLEZLECENIEPOZ_POZIOMINF + ', ZP1.' + sZLEZLECENIEPOZ_INF_ID + ') AS ' + Copy(Trim(oSplit.Items[i]), 1, 3) + '_SYMBOL';
                     vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
                     if vWarItem <> nil then
                        if vWarItem.ListaID <> '' then begin
                           if sWarunekWhere <> '' then
                              sWarunekWhere := sWarunekWhere + ' AND ';
                           sWarunekWhere := sWarunekWhere +
                              'SEL.' + Copy(Trim(oSplit.Items[i]), 1, 3) + '_SYMBOL' + ' IN (SELECT ' + sMnemTab + '_SYMBOL' +
                                                                               ' FROM ' + SQLManager.GetTableName(sMnemTab) +
                                                                               ' WHERE ' + sMnemTab + '_ID' + ' IN (' + vWarItem.ListaID + ')) ';
                        end;
                 end else begin
                     {Poziom infrastruktury <> 'Budynek' - szukamy budynku w polach uytkownika zlecenia}
          if sSelectWew <> '' then
             sSelectWew := sSelectWew + ', ';
                     sSelectWew := sSelectWew + ' (SELECT ZM.' + sZLEPOLAZM_WART + ' ' +
                                      'FROM ' + SQLManager.GetTableName(sZLEPOLAZM) + ' ZM, ' +
                                                SQLManager.GetTableName(sZLEPOLAZMDEF) + ' ZD, ' +
                                                SQLManager.GetTableName(sFKMNEMONIKI) + ' FM ' +
                                      'WHERE ZM.' + sZLEZLECENIEPOZ_ID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ' AND ' +
                                            'ZM.' + sZLEPOLAZMDEF_ID + ' = ZD.' + sZLEPOLAZMDEF_ID + ' AND ' +
                                            'FM.' + sFKMNEMONIKI_ID + ' = ZD.' + sFKMNEMONIKI_ID + ' AND ' +
                                            'FM.' + sFKMNEMONIKI_TABELA + ' = ' + QuotedStr(sMnemTab) + ' AND ' +
                                            'FM.' + sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr(Copy(Trim(oSplit.Items[i]), 1, 3)) + ') AS ' + Copy(Trim(oSplit.Items[i]), 1, 3) + '_SYMBOL';

                     vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
                     if vWarItem <> nil then
                        if vWarItem.ListaID <> '' then begin
                           if sWarunekWhere <> '' then
                              sWarunekWhere := sWarunekWhere + ' AND ';
                           sWarunekWhere := sWarunekWhere +
                              'SEL.' + Copy(Trim(oSplit.Items[i]), 1, 3) + '_SYMBOL' + ' IN (SELECT ' + sMnemTab + '_SYMBOL' +
                                                                               ' FROM ' + SQLManager.GetTableName(sMnemTab) +
                                                                               ' WHERE ' + sMnemTab + '_ID' + ' IN (' + vWarItem.ListaID + ')) ';
                        end;
                 end;
             end;

             sListaGroupBy := sListaGroupBy + Copy(Trim(oSplit.Items[i]), 1, 3) + '_SYMBOL';
          end else begin
          ***************************************)
      end else
      if sMnemTab = sFKUZ then begin
          if sSelectWew <> '' then
             sSelectWew := sSelectWew + ', ';

          if bZakresPowt then begin
             Inc(iLp_DictPowt); //To bd sowniki IDSLOWx, SYMBx
             sSelectWew := sSelectWew + ' (SELECT ZM.' + sFKUZ_ID + ' ' +
                                          'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                                                    SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                                                    SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                                          'WHERE ZM.' + sUNIPOLAUZ_FSUBELEMID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ' AND ' +
                                                'WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                                                'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                                                'ZD.'  + sUNIPOLAUZDEF_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEPozycja) + ' AND ' +
                                                'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemonikiID) + ') AS IDSLOW' + IntToStr(iLicznikPowt) + ', ' +
                                         '(SELECT ' + SQLManager.GetTableName('FKDAJ_SYMBOL_MNEMONIKA') + '(NVL(ZD.' + sFKMNEMONIKI_ID + ', 0), NVL(ZM.' + sFKUZ_ID + ', 0)) ' +
                                          'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                                                    SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                                                    SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                                          'WHERE ZM.' + sUNIPOLAUZ_FSUBELEMID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ' AND ' +
                                                'WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                                                'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                                                'ZD.'  + sUNIPOLAUZDEF_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEPozycja) + ' AND ' +
                                                'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemonikiID) + ') AS SYMB' + IntToStr(iLicznikPowt);

             sPole  := 'SYMB' + IntToStr(iLicznikPowt);
          end else begin
             sSelectWew := sSelectWew + ' (SELECT ZM.' + sFKUZ_ID + ' ' +
                                          'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                                                    SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                                                    SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                                          'WHERE ZM.' + sUNIPOLAUZ_FSUBELEMID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ' AND ' +
                                                'WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                                                'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                                                'ZD.'  + sUNIPOLAUZDEF_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEPozycja) + ' AND ' +
                                                'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemonikiID) + ') AS IDSLOW_' + IntToStr(iLicznikSum) + ', ' +
                                         '(SELECT ' + SQLManager.GetTableName('FKDAJ_SYMBOL_MNEMONIKA') + '(NVL(ZD.' + sFKMNEMONIKI_ID + ', 0), NVL(ZM.' + sFKUZ_ID + ', 0)) ' +
                                          'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                                                    SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                                                    SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                                          'WHERE ZM.' + sUNIPOLAUZ_FSUBELEMID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ' AND ' +
                                                'WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                                                'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                                                'ZD.'  + sUNIPOLAUZDEF_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEPozycja) + ' AND ' +
                                                'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemonikiID) + ') AS SYMB_' + IntToStr(iLicznikSum);

             sPole  := 'SYMB_' + IntToStr(iLicznikSum);
          end;

          bHavingJoin := True;
          sAlias := '';
      end else begin
          if sSelectWew <> '' then
             sSelectWew := sSelectWew + ', ';

          {np RKO - nie mamy ID tylko symbol w polu sZLEPOLAZM_WART,
          !!! - w uniwersalnych polach jest juz ID, wiec nie trzeba kombinowac}
          if bZakresPowt then begin
             Inc(iLp_DictPowt); //To bd sowniki IDSLOWx, SYMBx
             sSelectWew := sSelectWew + ' (SELECT ZM.' + sUNIPOLAUZ_WARTID + ' ' +
                                          'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                                                    SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                                                    SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                                          'WHERE ZM.' + sUNIPOLAUZ_FSUBELEMID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ' AND ' +
                                                'WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                                                'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                                                'ZD.'  + sUNIPOLAUZDEF_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEPozycja) + ' AND ' +
                                                'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemonikiID) + ') AS IDSLOW' + IntToStr(iLicznikPowt) + ', ' +
                                         '(SELECT ZM.' + sUNIPOLAUZ_WART + ' ' +
                                          'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                                                    SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                                                    SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                                          'WHERE ZM.' + sUNIPOLAUZ_FSUBELEMID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ' AND ' +
                                                'WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                                                'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                                                'ZD.'  + sUNIPOLAUZDEF_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEPozycja) + ' AND ' +
                                                'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemonikiID) + ') AS SYMB' + IntToStr(iLicznikPowt);

             sPole  := 'SYMB' + IntToStr(iLicznikPowt);
          end else begin
             sSelectWew := sSelectWew + ' (SELECT ZM.' + sUNIPOLAUZ_WARTID + ' ' +
                                          'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                                                    SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                                                    SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                                          'WHERE ZM.' + sUNIPOLAUZ_FSUBELEMID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ' AND ' +
                                                'WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                                                'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                                                'ZD.'  + sUNIPOLAUZDEF_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEPozycja) + ' AND ' +
                                                'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemonikiID) + ') AS IDSLOW_' + IntToStr(iLicznikSum) + ', ' +
                                         '(SELECT ZM.' + sUNIPOLAUZ_WART + ' ' +
                                          'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                                                    SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                                                    SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                                          'WHERE ZM.' + sUNIPOLAUZ_FSUBELEMID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ' AND ' +
                                                'WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                                                'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                                                'ZD.'  + sUNIPOLAUZDEF_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEPozycja) + ' AND ' +
                                                'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemonikiID) + ') AS SYMB_' + IntToStr(iLicznikSum);

             sPole  := 'SYMB_' + IntToStr(iLicznikSum);
          end;

          bHavingJoin := True;
          sAlias := '';
      end; //if (sFirstParam = sMnemonikZlecenie)

      //Analiza parametru (gdy jest slownikiem)
      Spl:=TSplit.Create(sParam,';','');
      try
//        iTempInteger:=0;  //licznik zoe warunkw
        sLicznikSlownik :=  IntToSTR(iLicznik);
        //bSprawdzZgodnoscZPoz := false;
         // bCzyPunkt := false;

        //Warunki zakresowe
        sWhereZakres:='';
        for iLicznikZakresParam:=0 to Spl.Count-1 do begin
          if Trim(Spl[iLicznikZakresParam]) = '' then Continue;

          //Dopisanie do zakresu kolejnego elementu z parametru ZAKRESU SUM lub POWT
//          inc(iTempInteger);
          if sWhereZakres <> '' then
            sWhereZakres:=sWhereZakres + ' or ';

          //Generacja zakresu dla elementu
          sWhereZakres := sWhereZakres +
            GenerateWhereForSlownik(Spl[iLicznikZakresParam],sPole,sAlias);
        end;

        //Dopisanie warunkw zakresowych do Where
        if sWhereZakres <> '' then begin
          if bHavingJoin then begin
             if sHavingZew <> '' then
                sHavingZew := sHavingZew + ' AND ';
             sHavingZew := sHavingZew + '(' + sWhereZakres + ')';
          end else begin
            if sWhereWew <> '' then
              sWhereWew := sWhereWew + ' AND ';
            sWhereWew := sWhereWew + '(' +sWhereZakres + ')';
          end;
        end;
      finally
        Spl.Free;
      end; //try

    end  //if (sParamName = cAgregateFunctionParam_ZakPOWT) or (sParamName = cAgregateFunctionParam_ZakSUM) then begin
    else //Inne funkcje. Np. ZRODLO lub FUNKCJA
    if (sParamName = cAgregateFunctionParam_Zrodlo) then begin
        //Odddzielenie nazwy parametru od wartosci
        sParamName:=kvAgregateFunctionParam[iLicznik];
        iPos      := Pos('=',sParamName);

        sParam    := copy(sParamName,iPos+1,length(sParamName)-iPos);
        sParamName := kvAgregateFunctionParam.Names[iLicznik];  //cAgregateFunctionParam_Zrodlo

        //Separacja slownika od przyjmowanych przez niego wartosci
        {iPos        := Pos(';',sParam);
        sFirstParam := copy(sParam,1,iPos-1);              //Slownik
        sParam:=copy(sParam,iPos+1,length(sParam)-iPos); //Dalsze parametry}


        bJestFunkcja  := False;
        sZrodlo       := cParam_ZrodloWartosc;  //Domylnie warto z pozycji zlecenia
        if sParam = cParam_ZrodloRobocizna then
           sZrodlo := cParam_ZrodloRobocizna
        else
        if sParam = cParam_ZrodloFunkcja then begin
           sZrodlo := cParam_ZrodloFunkcja;
           bJestFunkcja  := True;
        end;
    end
    else
    if (sParamName = cAgregateFunctionParam_Funkcja) then begin
        //Odddzielenie nazwy parametru od wartosci
        sParamName:=kvAgregateFunctionParam[iLicznik];
        iPos      := Pos('=',sParamName);

        sParam    := copy(sParamName,iPos+1,length(sParamName)-iPos);
        sParamName := kvAgregateFunctionParam.Names[iLicznik];  //cAgregateFunctionParam_Funkcja

        //Separacja slownika od przyjmowanych przez niego wartosci
        {iPos        := Pos(';',sParam);
        sFirstParam := copy(sParam,1,iPos-1);              //Slownik
        sParam:=copy(sParam,iPos+1,length(sParam)-iPos); //Dalsze parametry}
        sFunkcjaNazwa := sParam;
    end;
  end;  //for iLicznik := 0 to kvAgregateFunctionParam.Count-1 do begin

  if bJestFunkcja and (sFunkcjaNazwa = '') then begin
     //zrdem wartoci jest funkcja osadzona oracle'a, ale nie podano jej nazwy
     //Bd!!
     ErrorC := 10; //Na razie taki kod bdu
  end;

  result := 'SELECT ' +
               'Sum(SUMA) AS SUMA';

  for iLicznik := 1 to iLp_DictPowt do
      Result := Result + ', ' + 'IDSLOW' + IntToStr(iLicznik);

  for iLicznik := 1 to iLp_DictPowt do
      Result := Result + ', ' + 'SYMB' + IntToStr(iLicznik);

  Result := Result + ' ' +
            'FROM ( ' +
               'SELECT  ' +
                 'SUM(NVL(' + sZLEZLECENIEPOZ_WARTOSC + ', 0)) AS SUMA';

  for iLicznik := 1 to iLicznikPowt do
      Result := Result + ', ' + 'IDSLOW' + IntToStr(iLicznik);

  for iLicznik := 1 to iLicznikSum do
      Result := Result + ', ' + 'IDSLOW_' + IntToStr(iLicznik);

  for iLicznik := 1 to iLicznikPowt do
      Result := Result + ', ' + 'SYMB' + IntToStr(iLicznik);

  for iLicznik := 1 to iLicznikSum do
      Result := Result + ', ' + 'SYMB_' + IntToStr(iLicznik);

  Result := Result + ' ' +
               'FROM ( ' +
                 'SELECT ';

  {Tu wstawka dotyczca rda wartoci}
  if sZrodlo = cParam_ZrodloWartosc then begin
     Result := Result + ' ' +
        'ZP1.' + sZLEZLECENIEPOZ_WARTOSC + ' AS ' + sZLEZLECENIEPOZ_WARTOSC;
  end else
  if sZrodlo = cParam_ZrodloRobocizna then begin
     iOkresID := UstalOkresID(sRokObrachunkowy, iAktualOkresNr);
     if ZLEDM.vZLEFormatGodzinLiczba then
          sTmpParam := ',0))'
     else sTmpParam := ',0)/60)';

     Result := Result + ' ' +
        '(SELECT Nvl(SUM((' + SQLManager.GetSPName('Zaokraglij') + '(( Nvl(' + sZLEZASOBYPRACA_CZAS_PRACY + sTmpParam + '* Nvl(' + sZLEZASOBYPRACA_STAWKA + ', 0), 2) )), 0) ' +
         'FROM   ' + SQLManager.GetTableName(sZLEZASOBYPRACA) + ' ZZP ' +
         'WHERE ' + iifs(iOkresID > 0, 'ZZP.' + sUNIOKRES_ID + '=' + IntToStr(iOkresID) + ' AND ', '') +
               ' ZZP.' + sZLEZLECENIEPOZ_ID + '= ZP1.' + sZLEZLECENIEPOZ_ID + ') AS ' + sZLEZLECENIEPOZ_WARTOSC;
  end else
  if sZrodlo = cParam_ZrodloFunkcja then begin
     {
       wywoujemy podan funkcj z 3 parametrami
       warto = sFunkcjaNazwa(iZLEZLECENIE_ID, iZLEZLECENIEPOZ_ID, iUNIOKRES_ID)
     }                 //iAktualOkresNr
     iOkresID := UstalOkresID(sRokObrachunkowy, iAktualOkresNr);

     Result := Result + ' ' +
        SQLManager.GetSPName(sFunkcjaNazwa) + '(ZP1.' + sZLEZLECENIE_ID + ', ZP1.' + sZLEZLECENIEPOZ_ID + ', ' + IntToStr(iOkresID) + ') AS ' + sZLEZLECENIEPOZ_WARTOSC;
  end;

  if sSelectWew <> '' then
     Result := Result + ', ' + sSelectWew;

  Result := Result + ' ' +
                 'FROM ' +
                    sListaTabWew + ' ' +
                 'WHERE ' +
                    sWhereWew + ' ' +
                 ') ';

  if (iLicznikPowt > 0) or (iLicznikSum > 0) then begin
      sGroupBy := '';

      for iLicznik := 1 to iLicznikPowt do begin
          if sGroupBy <> '' then sGroupBy := sGroupBy + ',';
          sGroupBy := sGroupBy + 'IDSLOW' + IntToStr(iLicznik);
      end;

      for iLicznik := 1 to iLicznikSum do begin
          if sGroupBy <> '' then sGroupBy := sGroupBy + ',';
          sGroupBy := sGroupBy + 'IDSLOW_' + IntToStr(iLicznik);
      end;

      for iLicznik := 1 to iLicznikPowt do begin
          if sGroupBy <> '' then sGroupBy := sGroupBy + ',';
          sGroupBy := sGroupBy + 'SYMB' + IntToStr(iLicznik);

      end;

      for iLicznik := 1 to iLicznikSum do begin
          if sGroupBy <> '' then sGroupBy := sGroupBy + ',';
          sGroupBy := sGroupBy + 'SYMB_' + IntToStr(iLicznik);
      end;
      if sGroupBy <> '' then
         Result := Result + ' GROUP BY ' + sGroupBy;

  end;

  if (sHavingZew <> '') or (iLicznikPowt > 0) or (iLicznikSum > 0) then begin
      Result := Result + ' HAVING ';

      sHavingTmp := '';
      for iLicznik := 1 to iLicznikPowt do begin
          if sHavingTmp <> '' then
             sHavingTmp := sHavingTmp + ' AND ';
          sHavingTmp := sHavingTmp  + '(SYMB' + IntToStr(iLicznik) + ' IS NOT NULL) ';
      end;

      for iLicznik := 1 to iLicznikSum do begin
          if sHavingTmp <> '' then
             sHavingTmp := sHavingTmp + ' AND ';
          sHavingTmp := sHavingTmp  + '(SYMB_' + IntToStr(iLicznik) + ' IS NOT NULL) ';
      end;

      if (sHavingTmp <> '') and (sHavingZew <> '') then
         sHavingTmp := sHavingTmp + ' AND (' + sHavingZew + ')'
      else if (sHavingZew <> '') then
         sHavingTmp := sHavingZew;

      if sHavingTmp <> '' then
         Result := Result + sHavingTmp;
  end;

  Result := Result +
            ')';

  if (iLicznikPowt > 0) then begin
      sGroupBy := '';

      for iLicznik := 1 to iLicznikPowt do begin
          if sGroupBy <> '' then sGroupBy := sGroupBy + ',';
          sGroupBy := sGroupBy + 'IDSLOW' + IntToStr(iLicznik);
      end;

      for iLicznik := 1 to iLicznikPowt do begin
          if sGroupBy <> '' then sGroupBy := sGroupBy + ',';
          sGroupBy := sGroupBy + 'SYMB' + IntToStr(iLicznik);
      end;

      if sGroupBy <> '' then
         Result := Result + ' GROUP BY ' + sGroupBy;
  end;

  iLiczbaSlownikow := iLp_DictPowt;
end; // AgregateFunctionCreateSQL()

function ZLEFunkcjeAnalizy_SQLPrepare(
           sAgregateFunction: string;
           iAktualOkresNr: integer;
           iAktywnaFirmaID: integer;
           sRokObrachunkowy: string;
           bSymulacja: boolean;
           bZestawienieZDokumentami: boolean;
           var sSQL: string;
           var sErrorMessage: string;
           var iLiczbaSlownikow:integer):boolean;
{
  2008-04-08  i_okres_nr=0 oznacza, e naliczenie dla analizy rocznej
}
var
  iPos                   :integer;
  ErrorCd,
  iErrorCode             :integer;
  sParametr              :string;
  sFunctionName          :string;
  sSelfFunctionName      :string;
  sParametrWithValue     :string;
  sTempKod_Znaleziony    :string;
  kvParametryWywolania   :TKeyValues;

  sZPozycjiBledne    :string;

begin
  //kontrola parametrw rodowiskowych
  sSelfFunctionName:='ZLEFunkcjeAnalizy_SQLPrepare';

  //Kontrola poprawnosci firmy
  if vWielofirmowosc and (iAktywnaFirmaID<>0) then begin
    iErrorCode:=UNISysDataManager.UNIKontrolaPoprawnosciIDFirmy(iAktywnaFirmaID);
    if iErrorCode <> 0 then
      raise EOF_ZLEException.Create(iErrorCode,
                            UNISysDataManager.UNIPodajSlowneRozwiniecieKoduBledu(sSelfFunctionName,iErrorCode),
                            sSelfFunctionName);
  end;

  //Zastpienie przecinkw srednikami i zamieniam wszystko na wielkie litery
  sAgregateFunction:=upperCase(StringReplace(sAgregateFunction, #39, '',[rfReplaceAll]));
  sAgregateFunction:=upperCase(StringReplace(sAgregateFunction, '(;', '(',[rfReplaceAll]));
  sAgregateFunction:=upperCase(StringReplace(sAgregateFunction, ',', ';',[rfReplaceAll]));


  //Odcicie nazwy funkcji i analiza parametrw
  iPos:=pos('(',sAgregateFunction);


  if iPos > 0 then begin
    //Oddzielenie nazwy funkcji agregujacej od wiersza wywolania
    sFunctionName:=copy(sAgregateFunction,1,iPos-1);
    sTempKod_Znaleziony:=copy(sAgregateFunction,iPos+1,
                              length(sAgregateFunction)-(length(sFunctionName)+1));

    iPos:=pos(')',sTempKod_Znaleziony);
    //Poszukiwanie nawiasu zamykajcego (w przypadku braku bld)

    if iPos = 0 then begin
      //nie znaleziono nawiasu zamykajcego. Bd skadni wyraenia
      sErrorMessage:='Brak nawiasu zamykajcego w wyraeniu '+sAgregateFunction;
      result:=false;
    end
    else begin
      //Wycicie wyraenia bez kocowego nawiasu (wntrza funkcji)
      sTempKod_Znaleziony:=copy(sTempKod_Znaleziony,1,iPos-1);

      //Sprawdzenie czy funkcja agregujca jest jedn z dopuszczalnych
      if not (sFunctionName = cAgregateFunction_ZLEDanePozycji) then begin
        sErrorMessage:='Niedopuszczalna funkcja '+sFunctionName;
        result:=false;
        exit;
      end;

      //Tworzenie struktury parametrw na podstawie wntrza funkcji
      kvParametryWywolania := TKeyValues.CreateEmpty();
      try
        //Parametry analizowane na podstawie znaku '='
        iPos:=pos('=',sTempKod_Znaleziony);
        while (iPos > 0) do begin
          //Pobranie nazwy parametru
          sParametr:=copy(sTempKod_Znaleziony,1,iPos-1);

          //Sprawdzenie typu parametru (zakres sum czy powt wymagaj dodatkowej analizy)
          if (sParametr = cAgregateFunctionParam_ZakPOWT) or
             (sParametr = cAgregateFunctionParam_ZakSUM) then begin
            //Sprawdzenie czy podano nawias kwadratowy zamykajcy
            iPos:=pos(']',sTempKod_Znaleziony);
            if iPos = 0 then begin
              sErrorMessage:='Niepoprawna skadnia (brak znaku "]" w parametrze '+ sParametr+')';
              result:=false;
              exit;
            end;

            //Odczyt parametru wraz z wartosci w zalenosci od poloenia srednika
            //(na koncu parametru lub w jego srodku)
            if iPos = length(sTempKod_Znaleziony) then begin
              iPos:=0;
              sParametrWithValue:=sTempKod_Znaleziony
            end
            else begin
              sParametrWithValue:=copy(sTempKod_Znaleziony,1,iPos);
              iPos:=iPos+1;
            end;
          end
          else begin
            //Zwykly parametr - pobranie nazwy i wartosci bez srednika
            //Doloyc warunki na parametry zamykane w nawiasach kwadratowych
            iPos:=pos(';',sTempKod_Znaleziony);
            if iPos = 0 then
              sParametrWithValue:=sTempKod_Znaleziony
            else
              sParametrWithValue:=copy(sTempKod_Znaleziony,1,iPos-1);
          end;

          //Dodanie parametru wraz z wartosci do struktury
          kvParametryWywolania.Add(sParametrWithValue);

          //odcicie odczytanego parametru z listy
          if iPos = 0 then
            sTempKod_Znaleziony :=''
          else
            sTempKod_Znaleziony:=trim(copy(sTempKod_Znaleziony,iPos+1,
                                      length(sTempKod_Znaleziony)-iPos));

          //Analiza nastpnego parametru
          iPos:=pos('=',sTempKod_Znaleziony);
        end;

        //Kontrola poprawnosci parametrw dla wskazanej nazwy funkcji
        result :=AgregateFunctionParametersControl(
                   sFunctionName,sRokObrachunkowy,iAktualOkresNr,
                   kvParametryWywolania,sErrorMessage);

        //Budowa zapytania gdy skladnia funkcji jest poprawna
        if result then
          sSQL := AgregateFunctionCreateSQL(
                    sFunctionName,kvParametryWywolania,iAktualOkresNr,iAktywnaFirmaID,
                    sRokObrachunkowy, iLiczbaSlownikow, ErrorCd, sZPozycjiBledne,
                    bSymulacja,bZestawienieZDokumentami );
        if ErrorCd  <> 0 then begin
          if ErrorCd = 1 then
            sErrorMessage:='Nieprawidowa warto parametru: ZPozycji='+ sZPozycjiBledne
          else
            sErrorMessage:='Prba budowy zapytania SQL zakoczona niepowodzeniem';
          result:=false;
          exit;
        end;

        //Sprawdzenie czy udalo si zbudowac zapytanie
        if sSQL = '' then begin
          if sErrorMessage = '' then
            sErrorMessage:='Prba budowy zapytania SQL zakoczona niepowodzeniem';
          result:=false;
          exit;
        end;
      finally
        kvParametryWywolania.free;
      end;
    end;
  end
  else begin
    //nie znalazem funkcji agregujcej (brak nawiasu otwierajcego)
    sErrorMessage:='Brak nawiasu otwierajcego w wyraeniu '+sAgregateFunction;
    result:=false;
  end;
end;

end.
