unit ZLEKRYTPOZDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who     What
---------------------------------------------------------------------------------------------
2008-01-24 Tomjen  Utworzenie
}
interface

uses
  UNIStaleUnit,  UNIDataModuleUnit, UNIFormUnit, KeyManagerUnit,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls;

type
  TZLEKRYTPOZDBGridForm = class(TUNIDBGridForm)
    ZakresButton: TUNIButton;
    procedure DBGridDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure ZakresButtonClick(Sender: TObject);
  protected
    function  CreateDataModule(const AOpenMode:  TOpenMode): TUNIDataModule; override;
    procedure InternalOpen; override;

  public
    iKryteriumID: Integer;
    //sTabelaMnemonika: String;

    procedure SetUserRights; override;
    procedure GetParametersForForm(a_oForm:    TUNIForm;
                                   a_oParams:  TKeyValues);  override;
  end;

var
  ZLEKRYTPOZDBGridForm: TZLEKRYTPOZDBGridForm;

implementation
uses
  FormManagerUnit,
  SQLManagerUnit,
  ZLEKRYTPOZUnit,
  FKDefUnit,
  ZLEDefUnit;

{$R *.DFM}

function  TZLEKRYTPOZDBGridForm.CreateDataModule(
  const AOpenMode:  TOpenMode): TUNIDataModule;
begin
  result := TZLEKRYTPOZDataModule.CreateOpen( self, nil, AOpenMode);
end;

procedure TZLEKRYTPOZDBGridForm.InternalOpen;
begin
 iKryteriumID := -1;
 //sTabelaMnemonika := sZLEKRYTPOZ;
 if Parameters <> nil then begin
    if Parameters.Values[sZLEKRYTERIA_ID] <> '' then begin
       iKryteriumID     := StrToInt(Parameters.Values[sZLEKRYTERIA_ID]);
       {sTabelaMnemonika := SQLManager.OpenQueryWithResult('SELECT FM.' + sFKMNEMONIKI_TABELA + ' ' +
                                                         'FROM %s KR, %s FM ' +
                                                         'WHERE KR.' + sFKMNEMONIKI_ID + ' = FM.' + sFKMNEMONIKI_ID + ' AND ' +
                                                               'FM.' + sFKMNEMONIKI_INDEKS + ' = 0 AND ' +
                                                               'KR.' + sZLEKRYTERIA_ID + ' = ' + IntToStr(iKryteriumID),
                                                         [sZLEKRYTERIA, sFKMNEMONIKI]);}
    end;
 end;

  if (OpenModeFlags and omContained) = omContained then
    Switch_View_HotKey(false);
  inherited;
end;

procedure TZLEKRYTPOZDBGridForm.SetUserRights;
begin
  inherited;
  Switch_View_HotKey(false);
  Switch_New_HotKey(false);
  Switch_Open_HotKey(false);
  Switch_Delete_HotKey(false);
end;

procedure TZLEKRYTPOZDBGridForm.GetParametersForForm(
  a_oForm:    TUNIForm;
  a_oParams:  TKeyValues);
begin
  //a_oParams.Values[sZLEKRYTERIA_ID] := Parameters.Values[sZLEKRYTERIA_ID];
  a_oParams.Assign(Self.Parameters);
end;

procedure TZLEKRYTPOZDBGridForm.DBGridDrawColumnCell(
  Sender: TObject; const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
  s: string;
begin
  inherited;
  if Column.Field <> Nil then begin
    s:= Column.Field.AsString;
    if (Uppercase(Column.FieldName) = Uppercase(sZLEKRYTPOZ_WARTOSC)) then begin
      s := FormatFloat('### ##0.00', DMAQFbN(sZLEKRYTPOZ_WARTOSC).AsFloat);
      DBGrid.WriteText(DBGrid.Canvas, Rect, s, Column.Alignment);
    end else begin
      DBGrid.WriteText(DBGrid.Canvas, Rect, Column.Field.DisplayText, Column.Alignment);
    end;
  end;
end;

procedure TZLEKRYTPOZDBGridForm.ZakresButtonClick(Sender: TObject);
begin
  if OpenRangeForm() then
    DataModule.ReOpenDataSets();
  DBGrid.SetFocus;
end;

initialization
  FormManager.RegisterForm(TZLEKRYTPOZDBGridForm, sZLEModulID);
end.
