unit ZLEKRYTPOZUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2008-01-24 Tomjen   Utworzenie
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables, UNIExtDataModuleUnit;

type
  TZLEKRYTPOZDataModule = class(TUNIDataModule)
    procedure DataModuleCreate(Sender: TObject);
  private
    iZakresConditionIdx: Integer;
    procedure UstawZakres();
  protected
    procedure GetKeys;                  override;
    function  GetTableName: string;     override;
    procedure InitializeGridQueryDefs;  override;
  public
    iKryteriumID: Integer;
    procedure Post;   override;
    procedure Delete; override;
    constructor Create( AOwner: TComponent); override;
    procedure OpenDataSets(); override;
  end;

var
  ZLEKRYTPOZDataModule: TZLEKRYTPOZDataModule;

implementation
uses
  Dodatki,
  SQLManagerUnit,
  SecurityManagerUnit,
  UNIDBGridFormUnit,
  UNIDBFormUnit,
  UNIStaleUnit,
  UNIFormUnit,
  KeyManagerUnit,
  UNISysDefUnit,
  ZLEKRYTPOZDBGridFormUnit,
  ZLEDefUnit;

{$R *.DFM}

constructor TZLEKRYTPOZDataModule.Create(AOwner: TComponent);
begin
  iZakresConditionIdx := -1;
  inherited;
end;

procedure TZLEKRYTPOZDataModule.GetKeys;
begin
  FKeys.Add(sZLEKRYTPOZ_ID);
  //FKeys.Add(TableName + '_ID');
end;

function  TZLEKRYTPOZDataModule.GetTableName: string;
begin
  result  := sZLEKRYTPOZ;
  {if Owner is TZLEKRYTPOZDBGridForm then
     result := sTableMnemonika;}
end;

procedure TZLEKRYTPOZDataModule.InitializeGridQueryDefs;
begin
 if Owner is TZLEKRYTPOZDBGridForm then begin
    iKryteriumID    := TZLEKRYTPOZDBGridForm(Owner).iKryteriumID;
    //sTableMnemonika := TZLEKRYTPOZDBGridForm(Owner).sTabelaMnemonika;
 end;

  with GridColDefs do
  begin
    Clear;
    AddRequiredAndUnvisible(sZLEKRYTPOZ_ID, 'KP', '');
    AddRequiredAndUnvisible(sZLEKRYTERIA_ID, 'KP', '');
    AddRequiredAndUnvisible(sUNIOKRES_ID, 'KP', '');
    AddRequiredAndUnvisible(sUNIROK_ID, 'KP', '');
    AddRequiredAndUnvisible(sZLEKRYTERIA_FORMAT, 'KR', '');
    Add(sUNIROK_ROK_TEXT    , 'R' , 'Rok'     , true , true , taLeftJustify ,  40);
    Add(sUNIOKRES_OKRES_NR  , 'O' , 'Numer'   , true , true , taLeftJustify ,  20);
    Add(sUNIOKRES_NAZWA     , 'O' , 'Okres'   , true , true , taLeftJustify ,  80);
    Add(sZLEKRYTPOZ_SYMBOL, 'KP', 'Symbol'  , true , true , taLeftJustify , 100);
    Add(sZLEKRYTPOZ_WARTOSC, 'KP', 'Warto' , true , true , taRightJustify, 100);
  end;
  with GridTabDefs do
  begin
    Clear;
    Add('KP', TableName);
    Add('KR', sZLEKRYTERIA);
    Add('O',  sUNIOKRES);
    Add('R',  sUNIROK);
  end;
  with GridJoinDefs do
  begin
    Clear;
    if iKryteriumID > 0 then
       AddCondition('KP.' + sZLEKRYTERIA_ID + ' = ' + IntToStr(iKryteriumID), true);
    AddCondition('KP.' + sUNIOKRES_ID + ' = ' + 'O.'+ sUNIOKRES_ID , true);
    AddCondition('KP.' + sUNIROK_ID + ' = ' + 'R.'+ sUNIROK_ID , true);
    AddCondition('KP.' + sZLEKRYTERIA_ID + ' = ' + 'KR.'+ sZLEKRYTERIA_ID, true);

    iZakresConditionIdx := AddEmptyCondition();
  end;
  inherited;
end;


procedure TZLEKRYTPOZDataModule.Post;
var
  bTrans: boolean;
begin
  bTrans  := not SQLManager.InTransaction;
  if bTrans then SQLManager.StartTransaction;
  try
    inherited;
    if bTrans then SQLManager.Commit;
  except
    if bTrans then SQLManager.Rollback;
    raise;
  end;
end;

procedure TZLEKRYTPOZDataModule.Delete;
var
  bTrans: boolean;
begin
  bTrans  := not SQLManager.InTransaction;
  if bTrans then SQLManager.StartTransaction;
  try
    inherited;
    if bTrans then SQLManager.Commit;
  except
    if bTrans then SQLManager.Rollback;
    raise;
  end;
end;

procedure TZLEKRYTPOZDataModule.DataModuleCreate(Sender: TObject);
var
  oParams:    TKeyValues;
begin
  inherited;
  oParams := TKeyValues.CreateEmpty;
  (Owner as TUNIForm).GetParametersForForm( (Owner as TUNIForm), oParams);
  iKryteriumID := StrToInt(oParams.Values[sZLEKRYTERIA_ID]);
  oParams.Free;
end;

procedure TZLEKRYTPOZDataModule.UstawZakres;
var
    oParams: TKeyValues;
    sWhere: String;

begin
  oParams := nil;
  sWhere := '';

  if (Owner is TUNIDBGridForm) then begin
    try
      oParams := TKeyValues.CreateEmpty();
      (Owner as TUNIDBForm).GetParametersForForm( (Owner as TUNIDBForm), oParams );
      if oParams = nil then exit;
      if oParams.Values[sUNIOKRES_ID] <> '' then begin
         if (oParams.Values[sUNIOKRES_ID] <> '0') and (oParams.Values[sUNIOKRES_ID] <> '-1') then
            DopiszDoWhere('KP.' + sUNIOKRES_ID + ' IN ('+ oParams.Values[sUNIOKRES_ID] + ')', sWhere);
      end;

      if oParams.Values['UKRYJ_ZEROWE'] <> '' then begin
         if (oParams.Values['UKRYJ_ZEROWE'] = sTak) then
            DopiszDoWhere('(KP.' + sZLEKRYTPOZ_WARTOSC + ' <> 0.00)', sWhere);
      end;

      if sWhere <> '' then
        GridJoinDefs.ExchangeCondition(iZakresConditionIdx, sWhere, true )
      else
        GridJoinDefs.Items[iZakresConditionIdx].Required := false;
    finally
      if oParams <> nil then oParams.Free;
    end;
  end;
end;

procedure TZLEKRYTPOZDataModule.OpenDataSets;
begin
  UstawZakres();
  inherited;
end;

end.
