unit ZLEKontrolaRealizacjiDBDetailFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-25 gdeyk    Utworzone
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBDetailFormUnit, Menus, UNIComponentsUnit, Db, ToolWin, ComCtrls,
  StdCtrls, ExtCtrls, Mask, DBCtrls, UNIStaleUnit, UNIDataModuleUnit,
  UNIDBConstComboBoxUnit, DBClient,
  ZLEKontrolaRealizacjiDBGridFormUnit;

type
  TZLEKontrolaRealizacjiDBDetailForm = class(TUNIDBDetailForm)
    DaneZleceniaPanel: TUNIPanel;
    SymbolLabel: TUNILabel;
    SymbolDBEdit: TUNIDBEdit;
    NazwaLabel: TUNILabel;
    NazwaDBEdit: TUNIDBEdit;
    KontrolaFormPanel: TUNIPanel;
    OpisGrupowaniaLabel: TUNILabel;
    KontrolaWartosciowaPanel: TPanel;
    OkresKontrolaWartosciowaLabel: TUNILabel;
    OkresKontrolaWartosciowaComboBox: TUNIComboBox;
    KontrolaIlosciowaPanel: TPanel;
    OkresKontrolaIlosciowaLabel: TUNILabel;
    AsortymentLabel: TUNILabel;
    OkresKontrolaIlosciowaComboBox: TUNIComboBox;
    AsortymentLookupAliasEdit: TUNILookupAliasEdit;
    ZLEGrupowanieDanychCheckBox: TUNICheckBox;
    procedure AsortymentLookupAliasEditDelKey(Sender: TObject);
    procedure AsortymentLookupAliasEditButtonClick(Sender: TObject);
    function AsortymentLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure OkresKontrolaWartosciowaComboBoxChange(Sender: TObject);
    procedure OkresKontrolaIlosciowaComboBoxChange(Sender: TObject);
    procedure ZLEGrupowanieDanychCheckBoxClick(Sender: TObject);
  private
    iKontrolaFormIndex: Integer;
    iAsortymentID: Integer;
    FKontrolaWartosciowa: Boolean;
    FKontrolaWartosciowaOkresowa: Boolean;
    FKontrolaIlosciowa: Boolean;
    FKontrolaIlosciowaOkresowa: Boolean;
    FParamUwagi: Boolean;
    FZLEGrupowanieDanych: Boolean;
    FParamAsoMag: Boolean;
    oListaOkresow: TConstStringList;
    bInitialize: Boolean;

    procedure WczytajDaneTypuZlecenia();
    procedure InitializeControls();
    procedure InitializeObjectFields();
    procedure AddContainedForms();
    property KontrolaWartosciowa: Boolean read FKontrolaWartosciowa write FKontrolaWartosciowa;
    property KontrolaIlosciowa: Boolean read FKontrolaIlosciowa write FKontrolaIlosciowa;
  protected
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure InternalOpen; override;
    procedure BeforeShow; override;
    procedure GetPositionAndParentForContainedForm( const nr:integer ; var APosition: TRect ; var AParent: TWinControl ; var AAlign:TAlign); override;
    procedure UstawPrzyciski();
  public
    destructor Destroy(); override;
    procedure ReOpen; override;
    function Validate(): Boolean; override;
    procedure CancelButtonPressed; override;
    function GetGrid: TZLEKontrolaRealizacjiDBGridForm;
    property ListaOkresow: TConstStringList read oListaOkresow;
    property KontrolaWartosciowaOkresowa: Boolean read FKontrolaWartosciowaOkresowa write FKontrolaWartosciowaOkresowa;
    property KontrolaIlosciowaOkresowa: Boolean read fKontrolaIlosciowaOkresowa write fKontrolaIlosciowaOkresowa;
    property ParamUwagi: Boolean read FParamUwagi write FParamUwagi;
    property ParamAsoMag: Boolean read FParamAsoMag write FParamAsoMag;
    property ZLEGrupowanieDanych: Boolean read FZLEGrupowanieDanych write FZLEGrupowanieDanych;
  end;

implementation

{$R *.DFM}

uses
  FormManagerUnit,
  KeyManagerUnit,
  SQLManagerUnit,
  UNIDBFormUnit,
  UNISysDefUnit,
  UNIDataManagerUnit,
  UNISysDataManagerUnit,
  ASODefUnit,
  Dodatki,
  ASODataManagerExtUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit,
  ZLEZlecenieDBGridFormUnit,
  ZLEKontrolaRealizacjiIlosciowejDBGridFormUnit,
  ZLEZlecenieUnit;

{ TZLEKontrolaRealizacjiDBDetailForm }

procedure TZLEKontrolaRealizacjiDBDetailForm.AddContainedForms;
var
  oParams: TKeyValues;
  omOpenMode: TOpenMode;
begin
  omOpenMode := omList or omContained or omMultiSelect;

  if OpenMode = omView then
    omOpenMode := omOpenMode or omReadOnly;

  with FContainedForms do begin
    //kontrola realizacji wartociowej
    oParams := TKeyValues.CreateEmpty();
    with oParams do begin
      Add(sZLEZLECENIE_ID+'='+DMAQFbN(sZLEZLECENIE_ID).AsString);
      Add(sZLEZLECENIE_SYMBOL+'='+DMAQFbN(sZLEZLECENIE_SYMBOL).AsString);
      Add(sZLETYPZLEC_ID+'='+DMAQFbN(sZLETYPZLEC_ID).AsString);
      if (vWieloodzialowosc or vWielofirmowosc)and(not DMAQFbN(sUNIODDZIAL_ID).IsNull) then
        Add(sUNIODDZIAL_ID+'='+DMAQFbN(sUNIODDZIAL_ID).AsString)
      else if (vWielofirmowosc) then
        Add(sUNIODDZIAL_ID+'='+IntToStr(vAktywnaFirma))
      else
        Add(sUNIODDZIAL_ID+'=0');
      if Parameters.Values[sZLETYPZLEC_KOSZTY] = sUNICONST_ALTERNATYWA_TAK then begin
        Add(cFORM_CAPTION+'='+'Kontrola realizacji wartociowej');
        Add(sUNIOKRES_ID+'='+oListaOkresow.ZwrocSkrot(OkresKontrolaWartosciowaComboBox.ItemIndex));
        if KontrolaWartosciowaOkresowa then
          Add(sZLETYPZLEC_KOSZTY_OKRES+'='+sUNICONST_ALTERNATYWA_TAK)
        else
          Add(sZLETYPZLEC_KOSZTY_OKRES+'='+sUNICONST_ALTERNATYWA_NIE);
      end else if Parameters.Values[sZLETYPZLEC_ILOSCI] = sUNICONST_ALTERNATYWA_TAK then begin
        Add(cFORM_CAPTION+'='+'Kontrola realizacji ilociowej');
        Add(sUNIOKRES_ID+'='+oListaOkresow.ZwrocSkrot(OkresKontrolaIlosciowaComboBox.ItemIndex));
        Add(sASOASORT_ID+'='+IntToStr(iAsortymentID));
        if KontrolaIlosciowaOkresowa then
          Add(sZLETYPZLEC_ILOSCI_OKRES+'='+sUNICONST_ALTERNATYWA_TAK)
        else
          Add(sZLETYPZLEC_ILOSCI_OKRES+'='+sUNICONST_ALTERNATYWA_NIE);
      end;
    end;
    iKontrolaFormIndex := 0;
    if Parameters.Values[sZLETYPZLEC_KOSZTY] = sUNICONST_ALTERNATYWA_TAK then
      AddObject( 'Kontrola wartociowa', FormManager.OpenDBGrid( Self,
                 cKlasaKontrolaRealizacjiW+cSuffixKlasyDBGrid,
                 omOpenMode, oParams ) )
    else if Parameters.Values[sZLETYPZLEC_ILOSCI] = sUNICONST_ALTERNATYWA_TAK then
      AddObject( 'Kontrola ilociowa', FormManager.OpenDBGrid( Self,
                 cKlasaKontrolaRealizacjiI+cSuffixKlasyDBGrid,
                 omOpenMode, oParams ) );
  end;
end;

function TZLEKontrolaRealizacjiDBDetailForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLEZlecenieDataModule.CreateOpen( Self, DefaultMasterKeyValues, AOpenMode );
end;

destructor TZLEKontrolaRealizacjiDBDetailForm.Destroy;
begin
  if oListaOkresow <> nil then oListaOkresow.Free;
  inherited;
end;

procedure TZLEKontrolaRealizacjiDBDetailForm.GetPositionAndParentForContainedForm(
  const nr: integer; var APosition: TRect; var AParent: TWinControl;
  var AAlign: TAlign);
begin
  if nr = iKontrolaFormIndex then begin  //kontrola budetu lub iloci
    AParent := KontrolaFormPanel;
    APosition := KontrolaFormPanel.ClientRect;
    AAlign := alClient;
  end;
end;

procedure TZLEKontrolaRealizacjiDBDetailForm.InitializeControls;
var sSubSQL: String;
begin
  bInitialize := True;
  if (OpenModeFlags and omContained)<>0 then begin
    BorderStyle := bsNone;
    ToolBar.Visible :=false;
    TopPanel.Visible := false;
    BottomPanel.Visible := false;
  end;

  //ustawienia pl dla kontrolek
  SymbolDBEdit.DataField := sZLEZLECENIE_SYMBOL;
  NazwaDBEdit.DataField := sZLEZLECENIE_NAZWA;


  if Parameters.Values['ZLEGRUPOWANIEDANYCH'] = sTak then begin
     ZLEGrupowanieDanychCheckBox.Enabled := True;
     ZLEGrupowanieDanychCheckBox.Checked := True;
     ZLEGrupowanieDanych := false; {Tu trzeba jeszcze przetestowa czy nie wstawi True}
  end else begin
     ZLEGrupowanieDanychCheckBox.Enabled := False;
     ZLEGrupowanieDanychCheckBox.Checked := False;
     ZLEGrupowanieDanych := false;
  end;

  //ustawienia aliasw
  if DataManagers.Available(sASOModulID) then begin
    with AsortymentLookupAliasEdit do begin
      AliasManager := ASODM.AliasManager;
      Alias_ID := sASOAlias_Asort_ID;
      Alias_Name := sASOAlias_Asort_Indeks;
      sSubSQL := ZLEDM.ZLEOdpytajODaneSQL( sZLEZLECENIEPOZ,
                                           sZLEALIAS_ZLECENIEPOZ_ASORT_ID,
                                           '@'+sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID+'='+Parameters.Values[sZLEZLECENIE_ID],
                                           false );
      AdditionalCondition := '@'+sASOAlias_Asort_ID+' in ('+sSubSQL+')';
    end;
  end else begin
    AsortymentLookupAliasEdit.Visible := False;
    AsortymentLabel.Visible := False;
  end;

  //wczytanie wartoci do combo box'w okresowych
  oListaOkresow := nil;
  oListaOkresow := ZLEDM.WczytajOkresy();
  with OkresKontrolaWartosciowaComboBox do begin
    Items.AddStrings(oListaOkresow);
    ItemIndex := 0;
  end;
  with OkresKontrolaIlosciowaComboBox do begin
    Items.AddStrings(oListaOkresow);
    ItemIndex := 0;
  end;

  //sprawdzenie czy kontrola okresowa
  WczytajDaneTypuZlecenia();

  if (OpenModeFlags and omContained) = omContained then
    DaneZleceniaPanel.Visible := False;

  SelectButtonPanel.Visible := false;
  CancelButton.Caption := 'Zamknij';
  bInitialize := False;
end;

procedure TZLEKontrolaRealizacjiDBDetailForm.InitializeObjectFields;
begin
  iKontrolaFormIndex := -1;
  iAsortymentID := -1;
end;

procedure TZLEKontrolaRealizacjiDBDetailForm.InternalOpen;
var sSymbolGrupy: String;
begin
  {if Parameters = nil then
    Parameters := TKeyValues.CreateEmpty();
  if Parameters.Values[sZLEZLECENIE_ID] = '' then
    Parameters.Values[sZLEZLECENIE_ID] := '0';
  if Parameters.Values[sZLETYPZLEC_ID] = '' then
    Parameters.Values[sZLETYPZLEC_ID] := '0';}
  //inicjalizacja pl obiektu
  InitializeObjectFields();
  //inicjalizacja kontrolek
  InitializeControls();

  if Parameters.Values[cFORM_CAPTION] <> '' then begin
    Caption := Parameters.Values[cFORM_CAPTION];
  end;

  inherited;

  //dodanie form osadzonych
  AddContainedForms();

  //ustawienie formatu kontrolek
  if DataManagers.Available(sASOModulID) then
     AsortymentLookupAliasEdit.EditMask := LowerCase(ASODM.vAsoMaskaIndeksu+';0;_');

  //ustawienie informacji o grupowaniu
  OpisGrupowaniaLabel.Caption := '';
  if SQLManager.OpenQueryWithResult( ZLEDM.ZLEOdpytajODaneSQL( sZLEZLECENIE,
                                     sZLEALIAS_TYPZLECENIA_GRUPUJACE,
                                     '@'+sZLEALIAS_TYPZLECENIA_ID+'='+DMAQFbN(sZLETYPZLEC_ID).AsString,
                                     false ) ) = sUNICONST_ALTERNATYWA_TAK then
    OpisGrupowaniaLabel.Caption := OpisGrupowaniaLabel.Caption+
                                   'Zlecenie grupujce. ';
  if not DMAQFbN(sZLEZLECENIE_GRUPA_ID).IsNull then begin
    sSymbolGrupy := SQLManager.OpenQueryWithResult( ZLEDM.ZLEOdpytajODaneSQL( sZLEZLECENIE,
                                                    sZLEALIAS_ZLECENIE_SYMBOL,
                                                    '@'+sZLEALIAS_ZLECENIE_ID+'='+DMAQFbN(sZLEZLECENIE_GRUPA_ID).AsString,
                                                    false ) );
    OpisGrupowaniaLabel.Caption := OpisGrupowaniaLabel.Caption+
                                   'Element grupy o symbolu '+sSymbolGrupy+'.';
  end;

end;

function TZLEKontrolaRealizacjiDBDetailForm.Validate: Boolean;
begin
  result := inherited Validate();
end;

procedure TZLEKontrolaRealizacjiDBDetailForm.AsortymentLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  if not DataManagers.Available(sASOModulID) then Exit;

  AsortymentLookupAliasEdit.Clear;
  //AsortymentLookupAliasEdit.Text := '';
  iAsortymentID := -1;
  ContainedForms[iKontrolaFormIndex].Parameters.Values[sASOASORT_ID] :=
  IntToStr(iAsortymentID);
  DataModule.ContainedDataModules[iKontrolaFormIndex].ReOpenDataSets();
end;

procedure TZLEKontrolaRealizacjiDBDetailForm.AsortymentLookupAliasEditButtonClick(
  Sender: TObject);
var oQuery: TUNIQuery;
    sWhere: String;
    sSubSQL: String;
begin
  oQuery := nil;
  if not DataManagers.Available(sASOModulID) then Exit;

  try
    sSubSQL := ZLEDM.ZLEOdpytajODaneSQL( sZLEZLECENIEPOZ,
                                         sZLEALIAS_ZLECENIEPOZ_ASORT_ID,
                                         '@'+sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID+'='+Parameters.Values[sZLEZLECENIE_ID],
                                         false );
    sWhere := '@'+sASOAlias_Asort_ID+' in ('+sSubSQL+')';
    oQuery := ASODM.PokazIObsluzAsortyment( sASOAlias_Asort_ID+';'+
                                            sASOAlias_Asort_Indeks,
                                            sWhere, false, false,
                                            '@'+sASOAlias_Asort_ID+'='+IntToStr(iAsortymentID),
                                            cZLEModulZSI_ID );
    AsortymentLookupAliasEditSetData(oQuery);
  finally
    if oQuery <> nil then oQuery.Free;
  end;
end;

function TZLEKontrolaRealizacjiDBDetailForm.AsortymentLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  result := true;
  if not DataManagers.Available(sASOModulID) then Exit;

  if AliasSrc <> nil then
    with AliasSrc do begin
      iAsortymentID := Fields[0].AsInteger;
      AsortymentLookupAliasEdit.Text := Fields[1].AsString;
      ContainedForms[iKontrolaFormIndex].Parameters.Values[sASOASORT_ID] :=
      IntToStr(iAsortymentID);
      DataModule.ContainedDataModules[iKontrolaFormIndex].ReOpenDataSets();
    end;
end;

procedure TZLEKontrolaRealizacjiDBDetailForm.OkresKontrolaWartosciowaComboBoxChange(
  Sender: TObject);
begin
  ContainedForms[iKontrolaFormIndex].Parameters.Values[sUNIOKRES_ID] :=
  oListaOkresow.ZwrocSkrot( OkresKontrolaWartosciowaComboBox.ItemIndex );
  DataModule.ContainedDataModules[iKontrolaFormIndex].ReOpenDataSets();
end;

procedure TZLEKontrolaRealizacjiDBDetailForm.OkresKontrolaIlosciowaComboBoxChange(
  Sender: TObject);
begin
  ContainedForms[iKontrolaFormIndex].Parameters.Values[sUNIOKRES_ID] :=
  oListaOkresow.ZwrocSkrot( OkresKontrolaIlosciowaComboBox.ItemIndex );
  DataModule.ContainedDataModules[iKontrolaFormIndex].ReOpenDataSets();
end;

procedure TZLEKontrolaRealizacjiDBDetailForm.WczytajDaneTypuZlecenia;
var oQuery: TUNIQuery;
begin
  oQuery := nil;
  try
    oQuery := ZLEDM.ZLEOdpytajODane( sZLETYPZLEC,
                                     sZLEALIAS_TYPZLECENIA_KOSZTY+';'+
                                     sZLEALIAS_TYPZLECENIA_KOSZTY_OKRES+';'+
                                     sZLEALIAS_TYPZLECENIA_ILOSCI+';'+
                                     sZLEALIAS_TYPZLECENIA_ILOSCI_OKRES+';'+
                                     sZLEALIAS_TYPZLECENIA_ILOSCI_ASOMAG+';'+
                                     sZLEALIAS_TYPZLECENIA_UWAGI,
                                     '@'+sZLEALIAS_TYPZLECENIA_ID+'='+Parameters.Values[sZLETYPZLEC_ID],
                                     true );
    if oQuery <> nil then with oQuery do begin
      KontrolaWartosciowa := FieldByName(sZLETYPZLEC_KOSZTY).AsString = sUNICONST_ALTERNATYWA_TAK;
      KontrolaWartosciowaOkresowa := FieldByName(sZLETYPZLEC_KOSZTY_OKRES).AsString = sUNICONST_ALTERNATYWA_TAK;
      KontrolaIlosciowa := FieldByName(sZLETYPZLEC_ILOSCI).AsString = sUNICONST_ALTERNATYWA_TAK;
      KontrolaIlosciowaOkresowa := FieldByName(sZLETYPZLEC_ILOSCI_OKRES).AsString = sUNICONST_ALTERNATYWA_TAK;
      ParamAsoMag := FieldByName(sZLETYPZLEC_ILOSCI_ASOMAG).AsString = sUNICONST_ALTERNATYWA_TAK;
      ParamUwagi := FieldByName(sZLETYPZLEC_UWAGI).AsString = sUNICONST_ALTERNATYWA_TAK;
    end;
  finally
    if oQuery <> nil then oQuery.Free;
  end;

  if Parameters.Values[sZLETYPZLEC_KOSZTY] = sUNICONST_ALTERNATYWA_TAK then begin
    if KontrolaWartosciowa then begin
      KontrolaWartosciowaPanel.Visible := True;
      KontrolaFormPanel.Visible := True;
    end else begin
      KontrolaWartosciowaPanel.Visible := False;
      KontrolaFormPanel.Visible := False;
    end;
    KontrolaIlosciowa := False;
    KontrolaIlosciowaPanel.Visible := False;
  end else if Parameters.Values[sZLETYPZLEC_ILOSCI] = sUNICONST_ALTERNATYWA_TAK then begin
    if KontrolaIlosciowa then begin
      KontrolaIlosciowaPanel.Visible := True;
      KontrolaFormPanel.Visible := True;
    end else begin
      KontrolaIlosciowaPanel.Visible := False;
      KontrolaFormPanel.Visible := False;
    end;
    KontrolaWartosciowa := False;
    KontrolaWartosciowaPanel.Visible := False;
  end;

  OkresKontrolaWartosciowaComboBox.Enabled := FKontrolaWartosciowaOkresowa;
  OkresKontrolaIlosciowaComboBox.Enabled   := FKontrolaIlosciowaOkresowa;

  // Moliwo grupowania tylko dla kontroli ilociowej okresowej
  if Parameters.Values['ZLEGRUPOWANIEDANYCH'] = sTak then begin
     ZLEGrupowanieDanychCheckBox.Enabled := KontrolaIlosciowaOkresowa;

     if KontrolaIlosciowaOkresowa
        {ZLEGrupowanieDanychCheckBox.Enabled and ZLEGrupowanieDanychCheckBox.Checked} then
          ZLEGrupowanieDanych := True
     else ZLEGrupowanieDanych := False;
  end else begin
     ZLEGrupowanieDanychCheckBox.Enabled := KontrolaIlosciowaOkresowa;
     //ZLEGrupowanieDanychCheckBox.Checked := False;
     ZLEGrupowanieDanych                 := False;
  end;
end;

procedure TZLEKontrolaRealizacjiDBDetailForm.CancelButtonPressed;
begin
  NiePytajPrzyRezygnacji := true;
  inherited;
end;

procedure TZLEKontrolaRealizacjiDBDetailForm.BeforeShow;
begin
  inherited;
end;

procedure TZLEKontrolaRealizacjiDBDetailForm.ReOpen;
var
  oGridForm: TUNIDBForm;
begin
  oGridForm := (ContainedForms[iKontrolaFormIndex] as TUNIDBForm);

  oGridForm.Parameters.Values[sZLEZLECENIE_ID] := Parameters.Values[sZLEZLECENIE_ID];
  oGridForm.Parameters.Values[sZLETYPZLEC_ID]  := Parameters.Values[sZLETYPZLEC_ID];
  oGridForm.Parameters.Values['PRZELICZANIE'] :=  Parameters.Values['PRZELICZANIE'];

  WczytajDaneTypuZlecenia();

  if KontrolaWartosciowa then
    oGridForm.Parameters.Values[sZLETYPZLEC_KOSZTY] := sUNICONST_ALTERNATYWA_TAK
  else
    oGridForm.Parameters.Values[sZLETYPZLEC_KOSZTY] := sUNICONST_ALTERNATYWA_NIE;

  if KontrolaWartosciowaOkresowa then
    oGridForm.Parameters.Values[sZLETYPZLEC_KOSZTY_OKRES] := sUNICONST_ALTERNATYWA_TAK
  else
    oGridForm.Parameters.Values[sZLETYPZLEC_KOSZTY_OKRES] := sUNICONST_ALTERNATYWA_NIE;

  if KontrolaIlosciowa then
    oGridForm.Parameters.Values[sZLETYPZLEC_ILOSCI] := sUNICONST_ALTERNATYWA_TAK
  else
    oGridForm.Parameters.Values[sZLETYPZLEC_ILOSCI] := sUNICONST_ALTERNATYWA_NIE;

  if KontrolaIlosciowaOkresowa then
    oGridForm.Parameters.Values[sZLETYPZLEC_ILOSCI_OKRES] := sUNICONST_ALTERNATYWA_TAK
  else
    oGridForm.Parameters.Values[sZLETYPZLEC_ILOSCI_OKRES] := sUNICONST_ALTERNATYWA_NIE;

  if ParamAsoMag then
    oGridForm.Parameters.Values[sZLETYPZLEC_ILOSCI_ASOMAG] := sUNICONST_ALTERNATYWA_TAK
  else
    oGridForm.Parameters.Values[sZLETYPZLEC_ILOSCI_ASOMAG] := sUNICONST_ALTERNATYWA_NIE;

  if ParamUwagi then
    oGridForm.Parameters.Values[sZLETYPZLEC_UWAGI] := sUNICONST_ALTERNATYWA_TAK
  else
    oGridForm.Parameters.Values[sZLETYPZLEC_UWAGI] := sUNICONST_ALTERNATYWA_NIE;

   if Parameters.Values['ZLEGRUPOWANIEDANYCH'] = sTak then
      oGridForm.Parameters.Values['ZLEGRUPOWANIEDANYCH'] := sUNICONST_ALTERNATYWA_TAK
  else
      oGridForm.Parameters.Values['ZLEGRUPOWANIEDANYCH'] := sUNICONST_ALTERNATYWA_NIE;

  if Owner is TZLEZlecenieDBGridForm and Self.Visible then
    TZLEZlecenieDBGridForm(Owner).PrzeliczWszystkieButton.Enabled := (Parameters.Values['ZLEGRUPOWANIEDANYCH'] = sNie);

  inherited;
  (ContainedForms[iKontrolaFormIndex] as TZLEKontrolaRealizacjiDBGridForm).SetGridColumns();

  if (Parameters.Values['PRZELICZANIE'] = sTak) and (not ZLEGrupowanieDanych) then
     (ContainedForms[iKontrolaFormIndex] as TZLEKontrolaRealizacjiDBGridForm).AktualizujDane();
end;

function TZLEKontrolaRealizacjiDBDetailForm.GetGrid: TZLEKontrolaRealizacjiDBGridForm;
begin
  result := (ContainedForms[iKontrolaFormIndex] as TZLEKontrolaRealizacjiDBGridForm);
end;


procedure TZLEKontrolaRealizacjiDBDetailForm.UstawPrzyciski();
begin
  if Owner is TZLEZlecenieDBGridForm then
     TZLEZlecenieDBGridForm(Owner).PrzeliczWszystkieButton.Enabled := (Parameters.Values['ZLEGRUPOWANIEDANYCH'] = sNie);

  if iKontrolaFormIndex<> -1 then begin
      if ContainedForms[iKontrolaFormIndex] is TZLEKontrolaRealizacjiIlosciowejDBGridForm then
         (ContainedForms[iKontrolaFormIndex] as TZLEKontrolaRealizacjiIlosciowejDBGridForm).UstalWidocznosc();
  end;
end;

procedure TZLEKontrolaRealizacjiDBDetailForm.ZLEGrupowanieDanychCheckBoxClick(
  Sender: TObject);
begin
  inherited;
  {Ta zmienna jest ustawiona na w funkcji WczytajDaneTypuZlecenia}
  //ZLEGrupowanieDanych := ZLEGrupowanieDanychCheckBox.Checked;
  if ZLEGrupowanieDanychCheckBox.Checked then
       Parameters.Values['ZLEGRUPOWANIEDANYCH'] := sTak
  else Parameters.Values['ZLEGRUPOWANIEDANYCH'] := sNie;
  UstawPrzyciski();
  
  if not bInitialize then
     ReOpen();
end;

initialization
  FormManager.RegisterForm( TZLEKontrolaRealizacjiDBDetailForm, 'Kontrola realizacji zlecenia', sZLEModulID );

end.
