unit ZLEKontrolaRealizacjiDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-29 gdeyk    Utworzone
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls, UNIStaleUnit, ZLEParserUnit;

type
  TZLEKontrolaRealizacjiDBGridForm = class(TUNIDBGridForm)
    RightButtonPanel: TUNIPanel;
    AktualizujRealizacjeButton: TUNIButton;
    ZmienRealizacjeButton: TUNIButton;
    ImportdanychzplikuMenuItem: TMenuItem;
    procedure AktualizujRealizacjeButtonClick(Sender: TObject);
    procedure ZmienRealizacjeButtonClick(Sender: TObject);
    procedure ImportdanychzplikuMenuItemClick(Sender: TObject);
  private
    FParser: TZLEParser;
    FKontrolaWartosciowa: Boolean;
    procedure InitializeControls(); virtual;
    procedure InitializeObjectFields(); virtual;
    procedure SetKontrolaWartosciowa(const Value: Boolean);
  protected
    procedure Open(); override;
    procedure AktualizujRealizacje(); virtual; abstract;
    procedure OpenDetail( AOpenMode: TOpenMode ); virtual; abstract;
    function WyliczWartoscZReguly( sRegula: String; iOkresId: Integer; var sBlad: String;
                                   bSymulacja: Boolean = False ): Extended; virtual;
    property Parser: TZLEParser read FParser;
    property KontrolaWartosciowa: Boolean read FKontrolaWartosciowa write SetKontrolaWartosciowa;

  public
    procedure AktualizujDane(); 
    procedure SetGridColumns(); override;
    procedure InternalOpen(); override;
    destructor Destroy(); override;

    procedure RefreshSG; override; //virtual;
    function GetSummableFields( ifObject: boolean = false): TStringList; override;// virtual;
  end;

implementation

{$R *.DFM}

uses
  variants,
  Dodatki,
  FormManagerUnit,
  SQLManagerUnit,
  UNISysDefUnit,
  UNISysDataManagerUnit,
  UNIParserMainUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit,
  ZLEKontrolaRealizacjiUnit;

{ TZLEKontrolaRealizacjiDBGridForm }

procedure TZLEKontrolaRealizacjiDBGridForm.InitializeControls;
begin
  if (omReadOnly and OpenModeFlags)=omReadOnly then begin
    AktualizujRealizacjeButton.Enabled := false;
    ZmienRealizacjeButton.Enabled := false;
  end;

  Switch_New_HotKey(false);
  Switch_View_HotKey(false);
  Switch_Delete_HotKey(false);
end;


function TZLEKontrolaRealizacjiDBGridForm.GetSummableFields;
var
  i: integer;
  oField: TField;
begin
  Result := TStringList.Create;
  for i := 0 to DBGrid.Columns.Count-1 do begin
    oField := DBGrid.DataSource.DataSet.FindField(DBGrid.Columns[i].FieldName);
    if (oField<>nil)and(oField.DataType in [ftInteger, ftFloat]) then
      if ifObject then Result.AddObject(DBGrid.Columns[i].FieldName, TDouble.Create(0) )
      else Result.Add(DBGrid.Columns[i].FieldName);
  end;
end;


procedure TZLEKontrolaRealizacjiDBGridForm.RefreshSG;
var
  i,p:  integer;
begin
  for i:=0 to DBGrid.Columns.count-1 do begin
    p:= Summables.IndexOf( DBGrid.Columns[i].FieldName);
    if p<>-1 then SG.Cells[ i+1,0]:= FormatFloat( cMaskaKwoty,TDouble(Summables.Objects[p]).v);
  end;
end;


procedure TZLEKontrolaRealizacjiDBGridForm.InitializeObjectFields;
begin
  FParser := TZLEParser.Create(Self, KontrolaWartosciowa);
  with FParser do begin
    bSymulacja := False;
    if vWielofirmowosc then iFirmaID:= vAktywnaFirma;
    iOkresNr:= 1;
    sRok:= UNISysDM.vAktywnyRokObrachunkowy;
    sRokId:= inttostr(UNISysDM.vAktywnyRokObrachunkowyID);
  end;
end;

procedure TZLEKontrolaRealizacjiDBGridForm.InternalOpen;
begin
  //inicjalizacja kontrolek
  InitializeControls();
  //inicjalizacja pl obiektu
  InitializeObjectFields();

  if Parameters.Values[cFORM_CAPTION] <> '' then begin
    Caption := Parameters.Values[cFORM_CAPTION];
  end;

  if Parameters.Values[cFORM_ENABLED] = sUNICONST_ALTERNATYWA_NIE then begin
    AktualizujRealizacjeButton.Enabled := false;
    ZmienRealizacjeButton.Enabled := false;
  end;

  inherited;

  if (Parameters.Values['PRZELICZANIE'] = sTak) and (Parameters.Values['ZLEGRUPOWANIEDANYCH'] = sNie) then
     AktualizujDane();

end;

procedure TZLEKontrolaRealizacjiDBGridForm.Open;
begin
  try
    OpenDetail( omEdit );
  except
    on E:EOF_ZLEException do
      Komunikat( cInformation, E.Message );
  end;
end;
{
procedure TZLEKontrolaRealizacjiDBGridForm.SetGridColumns;
var
  i:      integer;
  col:    TColumn;
  s:      string;
begin
  FColWidthsChanged_off := true;
  try
    if (AutoFilter <> nil) and ( not EnvironmentManager.ifSimpleBehaviour_of_Grid) then begin
      Komunikat(
        cWarning,
        'Przy wyczeniu ustawienia "Standardowe zachowanie list - jeden zestaw kolumn" w parametrach uytkownika'#13+
        'aktywny autofiltr zostanie zamknity.');
      AutoFilterOff;
    end;
    s:= UtnijNazweKorelacji(DataModule.OrderByCol);
    DBGrid.Columns.Clear;
    for i:=0 to DataModule.GridColDefs.Count-1 do begin
      with DataModule.GridColDefs[i] do begin
        if Active and Visible then begin
          Col:= DBGrid.Columns.Add;
          Col.FieldName:= FieldName;
          Col.Width:= Width;
          Col.Alignment:= Alignment;
          Col.Title.Caption:= Name;
          Col.Title.Alignment:= taLeftJustify;
          Col.Color := Color;
          if FieldName=s then
            Col.Title.Font.Style:= [fsBold]
          else
            if (Pos(FieldName+',',DataModule.OrderByCols)>0) or
               (copy(DataModule.OrderByCols,length(DataModule.OrderByCols)-length(FieldName)+1,length(FieldName))=FieldName)
            then Col.Title.Font.Style:= [fsItalic];
        end;
      end;
    end;
  finally
    FColWidthsChanged_off := false;
  end;
  if DBGrid.Focused then SetDBGridTitleColor( clEditing );
  if AutoFilter <> nil then TAutoFilter(AutoFilter).ColWidthsChanged;
end;
}

procedure TZLEKontrolaRealizacjiDBGridForm.SetGridColumns;
var i: Integer;
begin
   {Zakomentuje to na prb}
  inherited;

  {Tworzymy nowa liste pl}
  if SG <> nil then FreeAndNil(SG);
  if Summables <> nil then FreeAndNil(Summables);

  if SumowanieMenuItem.Checked then begin
      SG:= TUNIStringGrid.Create( self);
      with SG do begin
        Parent:= GridPanel;
        Align:= alBottom;
        RowCount:= 1;
        DefaultRowHeight:= 20;
        Height:= 22;
        ScrollBars:= ssNone;
        for i:=0 to DBGrid.Columns.count-1 do
          DodajKolumne( '', DBGrid.Columns[i].Alignment, DBGrid.Columns[i].Width);
        Summables:= GetSummableFields(true);
      end;
      RefreshSG;
  end else begin
      FreeAndNil(SG);
      FreeAndNil(Summables);
  end;
  //podczas dopisywania rekordw do ClientDataSet'a ustawiamy dla kadego pola
  //kolor i przekazujemy przez warto Tag
  {for iIndex := 0 to DBGrid.Columns.Count-1 do begin
    if DBGrid.Columns[iIndex].Field <> nil then
      DBGrid.Columns[iIndex].Title.Font.Color := DBGrid.Columns[iIndex].Field.Tag;
  end;}
end;

procedure TZLEKontrolaRealizacjiDBGridForm.AktualizujRealizacjeButtonClick(
  Sender: TObject);
begin
  inherited;
  try
    if DataModule.ActiveQuery <> nil then DataModule.ActiveQuery.DisableControls;
    ZLEDM.FPrzeliczoneKoszty.Clear(); {Wyczyszczenie listy}
    ZLEDM.FPrzeliczoneIlosci.Clear();
    AktualizujRealizacje();
    ZLEDM.FPrzeliczoneKoszty.Clear(); {Wyczyszczenie listy}
    ZLEDM.FPrzeliczoneIlosci.Clear();
    {Sprobuje to zakomentowac.. - odkomentowane ?}
    FormManager.SaveProperties(self);
    DataModule.ReOpenDataSets();

    {Kolejno!!}
    FormManager.LoadProperties(self);
    SetGridColumns();

  finally
    if DataModule.ActiveQuery <> nil then DataModule.ActiveQuery.EnableControls;
  end;
end;

procedure TZLEKontrolaRealizacjiDBGridForm.AktualizujDane();
begin
  if AktualizujRealizacjeButton.Enabled then begin
    try
      if DBGrid.DataSource.DataSet <> nil then DBGrid.DataSource.DataSet.DisableControls;
    //  if DataModule.ActiveQuery <> nil then DataModule.ActiveQuery.DisableControls;
      AktualizujRealizacje();
      {Sprobuje to zakomentowac.. - odkomentowane ?}
   //   FormManager.SaveProperties(self);
      DataModule.ReOpenDataSets();

      {Kolejno!!}
      FormManager.LoadProperties(self);
      SetGridColumns();

    finally
     // if DataModule.ActiveQuery <> nil then DataModule.ActiveQuery.EnableControls;
      if DBGrid.DataSource.DataSet <> nil then DBGrid.DataSource.DataSet.EnableControls;
    end;
  end;
end;

destructor TZLEKontrolaRealizacjiDBGridForm.Destroy;
begin
  if FParser <> nil then FParser.Free;
  inherited;
end;

function TZLEKontrolaRealizacjiDBGridForm.WyliczWartoscZReguly(
  sRegula: String; iOkresId: Integer; var sBlad: String; bSymulacja: Boolean ): Extended;
var oSplit: TSplit;
    oRegula: TStringList;
    iIndex: Integer;
    s: String;
    sOkresNr: String;
    sOkresSQL: String;
begin
  result := 0.0;
  oSplit := nil;
  oRegula := nil;
  sOkresNr := '';
  sBlad := cZLEParserBlad_BrakID;
  FParser.iZlecenieId := StrToInt(Parameters.Values[sZLEZLECENIE_ID]);

  try
    oSplit := TSplit.Create( StringReplace( Trim(sRegula),#10,'',[rfReplaceAll]), #13, '' );
    if oSplit.Count = 0 then Exit;
    oRegula := TStringList.Create();
    for iIndex := 0 to oSplit.Count-1 do begin
      oRegula.Add(oSplit[iIndex]);
    end;
    if oRegula.Count = 0 then begin
      raise EOF_ZLEException.Create( 'Brak reguy');
    end;

    sOkresSQL := UNISysDM.UNIOdpytajODaneSQL( sUNIOKRES,
                                              sUNISYSALIAS_Okres_Obrachunkowy_Numer,
                                              '@'+sUNISYSALIAS_Okres_Obrachunkowy_ID+'='+
                                              IntToStr(iOkresId), true,
                                              Parser.iFirmaID );

    sOkresNr := SQLManager.OpenQueryWithResult( sOkresSQL );
    Parser.iOkresNr := 0;
    if sOkresNr <> '' then Parser.iOkresNr := StrToInt(sOkresNr);

    if Parser.ScriptExecute( 'Kontrola realizacji zlecenia', oRegula, False) = 0 then begin
      s := '';
      case VarType(Parser.ResultOfScript) of
        varSmallint, varInteger: s := IntToStr(Parser.ResultOfScript);
        varSingle, varDouble, varCurrency: s := FloatToStr(Parser.ResultOfScript);
        varDate: s := DateToStr(Parser.ResultOfScript);
        varBoolean: if Parser.ResultOfScript = True then s := 'TRUE' else s := 'FALSE';
        varString: s := Parser.ResultOfScript;
      end;
    end else begin
      if Parser.Errors[Parser.Errors.Count - 1].ErrorMessage = cplDzieleniePrzezZero then
           sBlad := cZLEParserBlad_DzielZeroID
      else sBlad := cZLEParserBlad_BladInnyID;

      raise EOF_ZLEException.Create( 'Linia: ' +
                                     IntToStr(Parser.Errors[Parser.Errors.Count - 1].Line) + '. ' +
                                     'Kolumna: ' + IntToStr(Parser.Errors[Parser.Errors.Count - 1].Column) + '. ' +
                                     Parser.Errors[Parser.Errors.Count - 1].ErrorMessage );
    end;
    result := StrToFloat(s);
  finally
    if oSplit <> nil then oSplit.Free;
    if oRegula <> nil then oRegula.Free;
  end;
end;

procedure TZLEKontrolaRealizacjiDBGridForm.ZmienRealizacjeButtonClick(
  Sender: TObject);
begin
  inherited;
  Open();
end;

procedure TZLEKontrolaRealizacjiDBGridForm.SetKontrolaWartosciowa(
  const Value: Boolean);
begin
  FKontrolaWartosciowa := Value;
end;

procedure TZLEKontrolaRealizacjiDBGridForm.ImportdanychzplikuMenuItemClick(
  Sender: TObject);
var
  OpenDialog: TOpenDialog;
  sNazwaPliku: String;

begin
  OpenDialog := TOpenDialog.Create(Self);
  try { OpenDialog }
    if OpenDialog.Execute then
    begin
         sNazwaPliku := OpenDialog.FileName;
         ZLEDM.ImportSkladnikowZPlikuTxt(sNazwaPliku {, sSeparator: String = ';'});
         DataModule.ReOpenDataSets();
         SetGridColumns();
    end;
  finally
    OpenDialog.Destroy;
  end;
end;

end.
