unit ZLEKontrolaRealizacjiIlosciowejDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-29 gdeyk    Utworzone
}
{$I ..\!\defines.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ZLEKontrolaRealizacjiDBGridFormUnit, Db, DBTables, UNIComponentsUnit,
  URDataSet, UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls,
  DBCtrls, ToolWin, ExtCtrls, UNIStaleUnit, UNIDataModuleUnit, UNIDBConstComboBoxUnit;

type
  TZLEKontrolaRealizacjiIlosciowejDBGridForm = class(TZLEKontrolaRealizacjiDBGridForm)
    ZmienUwagiButton: TUNIButton;
    procedure ZmienUwagiButtonClick(Sender: TObject);
  private
  protected
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure AktualizujRealizacje(); override;
    procedure OpenDetail( AOpenMode: TOpenMode ); override;
    procedure BeforeShow; override;
  public
    procedure InternalOpen; override;
    procedure UstalWidocznosc();
  end;

implementation

{$R *.DFM}

uses
  variants,
  Dodatki,
  FormManagerUnit,
  KeyManagerUnit,
  SecurityManagerUnit,
  SQLManagerUnit,
  UNIFormUnit,
  UNISysDefUnit,
  UniqueKeyUnit,
  ASODefUnit,
  ASODataManagerExtUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit,
  ZLEKontrolaRealizacjiIlosciowejUnit,
  ZLEKontrolaRealizacjiDBDetailFormUnit;

{ TZLEKontrolaRealizacjiIlosciowejDBGridForm }

{
procedure TZLEKontrolaRealizacjiIlosciowejDBGridForm.DBGridDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
begin
  inherited;
  if Column.Field <> Nil then
    if (Column.FieldName = sZLEPOLAZMDEF_TYP) then
      if not Column.Field.IsNull then
        DBGrid.WriteText(
          DBGrid.Canvas,
          Rect,
          cslZLEPolaUzState[Column.Field.Value],
          Column.Alignment
        );
end;
}

procedure TZLEKontrolaRealizacjiIlosciowejDBGridForm.BeforeShow;
begin
   inherited;
   UstalWidocznosc();
end;


procedure TZLEKontrolaRealizacjiIlosciowejDBGridForm.UstalWidocznosc();
var
   bVisible: Boolean;
begin
   bVisible := False;
   if Owner is TZLEKontrolaRealizacjiDBDetailForm then
      bVisible := TZLEKontrolaRealizacjiDBDetailForm(Owner).ParamUwagi;
   ZmienUwagiButton.Visible := bVisible;

   if Owner is TZLEKontrolaRealizacjiDBDetailForm then
      if TZLEKontrolaRealizacjiDBDetailForm(Owner).Parameters.Values['ZLEGRUPOWANIEDANYCH'] = sTak then begin
         AktualizujRealizacjeButton.Enabled := false;
         ZmienRealizacjeButton.Enabled := false;
      end else begin
         if (omReadOnly and OpenModeFlags)=omReadOnly then begin
            AktualizujRealizacjeButton.Enabled := false;
            ZmienRealizacjeButton.Enabled := false;
         end else begin
            AktualizujRealizacjeButton.Enabled := True;
            ZmienRealizacjeButton.Enabled := True;
         end;
      end;

end;


procedure TZLEKontrolaRealizacjiIlosciowejDBGridForm.AktualizujRealizacje;
begin
  ZLEDM.AktualizujRealizacjeZleceniaExt( StrToInt(Parameters.Values[sZLEZLECENIE_ID]),
                                         StrToInt(Parameters.Values[sZLETYPZLEC_ID]),
                                         StrToInt(Parameters.Values[sUNIOKRES_ID]),
                                         StrToInt(Parameters.Values[sASOASORT_ID]),
                                         StrToInt(Parameters.Values[sUNIODDZIAL_ID]),
                                         False, //kontrola kosztw
                                         Parameters.Values[sZLETYPZLEC_ILOSCI_OKRES]=sUNICONST_ALTERNATYWA_TAK );
end;

function TZLEKontrolaRealizacjiIlosciowejDBGridForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLEKontrolaRealizacjiIlosciowejDataModule.CreateOpen( Self,
                                                                     InheritedMasterKeyValues,
                                                                     AOpenMode );
end;

procedure TZLEKontrolaRealizacjiIlosciowejDBGridForm.InternalOpen;
begin
  KontrolaWartosciowa := false;
  inherited;
  UstalWidocznosc();
end;

procedure TZLEKontrolaRealizacjiIlosciowejDBGridForm.OpenDetail(
  AOpenMode: TOpenMode);
var oParams: TKeyValues;
    sKlasa: String;
    sLocateId, sAsortId: String;
begin
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add( cFORM_CAPTION+'='+'Rczna edycja skadnikw kontroli ilociowej');
    Add(sZLEZLECENIEPOZ_ID+'='+DMAQFbN(sZLEZLECENIEPOZ_ID).AsString);
    Add(sUNIOKRES_ID+'='+DMAQFbN(sUNIOKRES_ID).AsString);
  end;
  sKlasa := cKlasaSkladnikRealRIlosc+cSuffixKlasyDBGrid;

  AOpenMode := omVirtual or omList or omInPlaceEdit or omShowModal;
  FormManager.OpenForm( Self, sKlasa, AOpenMode, oParams );
  with DBGrid.DataSource.DataSet do
    try
      DisableControls;
      sLocateId := FieldByName(sUNIOKRES_ID).AsString;
      sAsortId := FieldByName(sASOASORT_ID).AsString;
      DataModule.ReOpenDataSets();
      if sLocateId <> '' then
        Locate( sUNIOKRES_ID+';'+sASOASORT_ID, VarArrayOf([sLocateId,sAsortId]), [] )
      else Locate( sASOASORT_ID, sAsortId, [] );
    finally
      EnableControls;
    end;
  DBGrid.SetFocus;
end;

procedure TZLEKontrolaRealizacjiIlosciowejDBGridForm.ZmienUwagiButtonClick(
  Sender: TObject);
var
  sUwagiStr: String;
  oUpdateQuery, oInsertQuery, q: TUNIQuery;
  sWarunek: String;
  iZLEILOpisID: Integer;
begin
  inherited;
  if DataModule.ActiveQuery.RecordCount <= 0 then exit;

  sUwagiStr := DMAQFbN(sZLEILOPIS_UWAGI).AsString;

//  function PobierzTekst(var sText: String): Integer;
  if ZLEDM.PobierzTekst(sUwagiStr) = 0 then begin
       sWarunek := sZLEZLECENIEPOZ_ID + ' = ' + IntToStr(DMAQFbN(sZLEZLECENIEPOZ_ID).AsInteger);
       if Parameters.Values[sZLETYPZLEC_ILOSCI_OKRES] = sUNICONST_ALTERNATYWA_TAK then
          sWarunek := sWarunek + ' AND ' +
                          sUNIOKRES_ID + ' = ' + IntToStr(DMAQFbN(sUNIOKRES_ID).AsInteger);

       {Aktualizacja lub dopisanie nowych uwag}
       {1. Sprawdzamy czy ju jest wpis}
       q := SQLManager.CreateQuery('SELECT ' + sZLEILOPIS_ID +
                                  ' FROM %s ' +
                                  ' WHERE ' + sWarunek,
                                  [sZLEILOPIS]);

       iZLEILOpisID := -1;
       try
         q.Open;
         if not q.IsEmpty then
            iZLEILOpisID := q.FieldByName(sZLEILOPIS_ID).AsInteger;
         q.Close;
       finally
         if q <> nil then FreeAndNil(q);
       end;

       if iZLEILOpisID > 0 then begin
          {Update}
          try
            oUpdateQuery := SQLManager.UpdateQueryStep1(sZLEILOPIS,
                                                        sZLEILOPIS_UWAGI + ',' +
                                                        sZLEILOPIS_UZ_ZM_ID + ',' +
                                                        sZLEILOPIS_DATA_ZM,
                                                        sWarunek);

            oUpdateQuery.ParamByName(sZLEILOPIS_UWAGI).DataType := ftString;
            oUpdateQuery.ParamByName(sZLEILOPIS_UZ_ZM_ID).DataType := ftInteger;
            oUpdateQuery.ParamByName(sZLEILOPIS_DATA_ZM).DataType := ftDate;

            if sUwagiStr <> '' then
                 oUpdateQuery.ParamByName(sZLEILOPIS_UWAGI).AsString := sUwagiStr
            else oUpdateQuery.ParamByName(sZLEILOPIS_UWAGI).Clear;

            oUpdateQuery.ParamByName(sZLEILOPIS_UZ_ZM_ID).AsInteger := SecurityManager.UserId;
            oUpdateQuery.ParamByName(sZLEILOPIS_DATA_ZM).AsDateTime := UNINow;

            SQLManager.UpdateQueryStep2(oUpdateQuery);
          finally
            if oUpdateQuery <> nil then FreeAndNil(oUpdateQuery);
          end;

       end else begin
         {Insert}
         try
            oInsertQuery := SQLManager.InsertQueryStep1( sZLEILOPIS,
                                                         sZLEILOPIS_ID+','+
                                                         sZLEZLECENIEPOZ_ID+','+
                                                         sUNIOKRES_ID+','+
                                                         sZLEILOPIS_UWAGI+','+
                                                         sZLEILOPIS_UZ_AU_ID+','+
                                                         sZLEILOPIS_DATA_AU);

            with oInsertQuery do begin
              ParamByName(sZLEILOPIS_ID).DataType := ftInteger;
              ParamByName(sZLEZLECENIEPOZ_ID).DataType := ftInteger;
              ParamByName(sUNIOKRES_ID).DataType := ftInteger;
              ParamByName(sZLEILOPIS_UWAGI).DataType := ftString;
              ParamByName(sZLEILOPIS_UZ_AU_ID).DataType := ftInteger;
              ParamByName(sZLEILOPIS_DATA_AU).DataType := ftDate;

              ParamByName(sZLEILOPIS_ID).AsInteger := UniqueKey[sZLEILOPIS];
              ParamByName(sZLEZLECENIEPOZ_ID).AsInteger := DMAQFbN(sZLEZLECENIEPOZ_ID).AsInteger;
              ParamByName(sUNIOKRES_ID).AsInteger := DMAQFbN(sUNIOKRES_ID).AsInteger;
              if sUwagiStr <> '' then
                   oInsertQuery.ParamByName(sZLEILOPIS_UWAGI).AsString := sUwagiStr
              else oInsertQuery.ParamByName(sZLEILOPIS_UWAGI).Clear;

              ParamByName(sZLEILOPIS_UZ_AU_ID).AsInteger := SecurityManager.UserId;
              ParamByName(sZLEILOPIS_DATA_AU).AsDateTime := UNINow;
            end;
            SQLManager.InsertQueryStep2( oInsertQuery, '' );

         finally
            if oInsertQuery <> nil then FreeAndNil(oInsertQuery);
         end;

       end;

     DataModule.ReOpenDataSets();
  end;

end;

initialization
  FormManager.RegisterForm( TZLEKontrolaRealizacjiIlosciowejDBGridForm,
                            'Lista kontroli realizacji ilociowej', sZLEModulID );

end.
