unit ZLEKontrolaRealizacjiRecznaDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-04-23 gdeyk    Utworzone
}
{$I ..\!\defines.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls, dbClient, UNIDBConstComboBoxUnit;

type
  TZLEKontrolaRealizacjiRecznaDBGridForm = class(TUNIDBGridForm)
    OkresPanel: TUNIPanel;
    OkresLabel: TUNILabel;
    OkresComboBox: TUNIComboBox;
    KontrolaRecznaDBNavigator: TUNIDBNavigator;
    procedure OkresComboBoxChange(Sender: TObject);
  private
    procedure SetFields();
  protected
    sEditField: String;
    oListaOkresow: TConstStringList;
    procedure InitializeControls(); virtual;
    procedure InitializeObjectFields(); virtual;
    procedure SelectButtonPressed; override;
    procedure SetGridColumns; override;
    procedure BeforePost(DataSet: TDataSet); virtual; abstract;
    procedure ZatwierdzZmiany();
  public
    procedure InternalOpen(); override;
    destructor Destroy(); override;
  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  UNIDataModuleUnit,
  UNISysDefUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit;

{ TZLEKontrolaRealizacjiRecznaDBGridForm }

destructor TZLEKontrolaRealizacjiRecznaDBGridForm.Destroy;
begin
  if oListaOkresow <> nil then oListaOkresow.Free;
  inherited;
end;

procedure TZLEKontrolaRealizacjiRecznaDBGridForm.InitializeControls;
begin
  with OkresComboBox do begin
    Enabled := Parameters.Values[sUNIOKRES_ID] <> '';
    Items.Clear;
    Items.AddStrings(oListaOkresow);
    if Parameters.Values[sUNIOKRES_ID] = '' then
      ItemIndex := 0
    else
      ItemIndex := oListaOkresow.IndexOfSkrot(Parameters.Values[sUNIOKRES_ID]);
  end;
end;

procedure TZLEKontrolaRealizacjiRecznaDBGridForm.InitializeObjectFields;
begin
  oListaOkresow := nil;
  oListaOkresow := ZLEDM.WczytajOkresy();
end;

procedure TZLEKontrolaRealizacjiRecznaDBGridForm.InternalOpen;
begin
  //inicjalizacja pl obiektu
  InitializeObjectFields();
  //inicjalizacja kontrolek
  InitializeControls();

  if Parameters.Values[cFORM_CAPTION] <> '' then begin
    Caption := Parameters.Values[cFORM_CAPTION];
  end;

  inherited;

  if DataModule.ActiveQuery.IsEmpty then begin
    Komunikat( cInformation, 'Brak skadnikw wprowadzanych rcznie' );
    ModalResult := mrCancel;
    Abort;
  end;

  SetFields();

  DataModule.ActiveQuery.BeforePost := BeforePost;
  if (Owner is TUNIDBGridForm) then
    KontrolaRecznaDBNavigator.DataSource := (Owner as TUNIDBGridForm).DBGrid.DataSource;
  SwitchEditorKeys(False);

end;

procedure TZLEKontrolaRealizacjiRecznaDBGridForm.SelectButtonPressed;
begin
  inherited;
end;

procedure TZLEKontrolaRealizacjiRecznaDBGridForm.OkresComboBoxChange(
  Sender: TObject);
begin
  inherited;
  ZatwierdzZmiany();
  if Parameters.Values[sUNIOKRES_ID] <> oListaOkresow.ZwrocSkrot(OkresComboBox.ItemIndex) then begin
    Parameters.Values[sUNIOKRES_ID] := oListaOkresow.ZwrocSkrot(OkresComboBox.ItemIndex);
    DataModule.ReOpenDataSets;
  end;
end;

procedure TZLEKontrolaRealizacjiRecznaDBGridForm.ZatwierdzZmiany;
begin
  if (DataModule.ActiveQuery.State in dsEditModes) then DataModule.ActiveQuery.Post;
  if ((DataModule.ActiveQuery as TVirtualDataSet).AreRecordsModified)and
     (Komunikat( cConfirmation, 'Zatwierdzi zmiany?', MB_YESNO+MB_DEFBUTTON1) = IDYES) then begin
    (DataModule.ActiveQuery as TVirtualDataSet).VState := vsNormal;
    DataModule.Post;
  end;
end;

procedure TZLEKontrolaRealizacjiRecznaDBGridForm.SetGridColumns;
begin
  inherited;
  DBGrid.SelectedField := DataModule.ActiveQuery.FindField(sEditField);
end;

procedure TZLEKontrolaRealizacjiRecznaDBGridForm.SetFields;
var iIndex: Integer;
begin
  if DataModule.ActiveQuery <> nil then
    with DataModule.ActiveQuery do begin
      for iIndex := 0 to Fields.Count-1 do
        Fields[iIndex].ReadOnly := True;
      if FindField(sEditField) <> nil then FindField(sEditField).ReadOnly := false;
    end
end;

end.
