unit ZLEKontrolaRealizacjiRecznaIlosciowaDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-04-27 gdeyk    Utworzone
}
{$I ..\!\defines.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ZLEKontrolaRealizacjiRecznaDBGridFormUnit, Db, DBTables,
  UNIComponentsUnit, URDataSet, UniDesigner, Menus, Grids, DBGrids,
  StdCtrls, ComCtrls, DBCtrls, ToolWin, ExtCtrls, UNIStaleUnit,
  UNIDataModuleUnit, UNIDBConstComboBoxUnit;

type
  TZLEKontrolaRealizacjiRecznaIlosciowaDBGridForm = class(TZLEKontrolaRealizacjiRecznaDBGridForm)
    PozycjaLabel: TUNILabel;
    PozycjaComboBox: TUNIComboBox;
    procedure KontrolaRecznaDBNavigatorClick(Sender: TObject;
      Button: TNavigateBtn);
    procedure PozycjaComboBoxChange(Sender: TObject);
  private
    oListaPozycji: TConstStringList;
  protected
    procedure InitializeControls(); override;
    procedure InitializeObjectFields(); override;
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure BeforePost(DataSet: TDataSet); override;
  public
    //procedure InternalOpen; override;
    destructor Destroy(); override;
  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  FormManagerUnit,
  UNIDBGridFormUnit,
  UNISysDefUnit,
  ASODefUnit,
  ASODataManagerExtUnit,
  ZLEDefUnit,
  ZLEKontrolaRealizacjiRecznaIlosciowaUnit;

{ TZLEKontrolaRealizacjiRecznaIlosciowaDBGridForm }

function TZLEKontrolaRealizacjiRecznaIlosciowaDBGridForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLEKontrolaRealizacjiRecznaIlosciowaDataModule.CreateOpen( Self,
                                                                     InheritedMasterKeyValues,
                                                                     AOpenMode );
end;

procedure TZLEKontrolaRealizacjiRecznaIlosciowaDBGridForm.BeforePost(
  DataSet: TDataSet);
begin
  if DataSet.FieldByName(sZLEIL_ILOSC).IsNull then begin
    Komunikat( cWarning, 'Naley poda warto' );
    Abort;
  end;
end;

procedure TZLEKontrolaRealizacjiRecznaIlosciowaDBGridForm.KontrolaRecznaDBNavigatorClick(
  Sender: TObject; Button: TNavigateBtn);
begin
  inherited;
  ZatwierdzZmiany();
  with Parameters do begin
    Values[sZLEZLECENIEPOZ_ID] := (Owner as TUNIDBGridForm).DMAQFbN(sZLEZLECENIEPOZ_ID).AsString;
    Values[sUNIOKRES_ID] := (Owner as TUNIDBGridForm).DMAQFbN(sUNIOKRES_ID).AsString;
    OkresComboBox.ItemIndex := oListaOkresow.IndexOfSkrot(Values[sUNIOKRES_ID]);
    PozycjaComboBox.ItemIndex := oListaPozycji.IndexOfSkrot(Values[sZLEZLECENIEPOZ_ID]);
  end;
  DataModule.ReOpenDataSets();
end;

destructor TZLEKontrolaRealizacjiRecznaIlosciowaDBGridForm.Destroy;
begin
  if oListaPozycji <> nil then oListaPozycji.Free;
  inherited;
end;

procedure TZLEKontrolaRealizacjiRecznaIlosciowaDBGridForm.InitializeControls;
begin
  inherited;
  with PozycjaComboBox do begin
    Enabled := Parameters.Values[sZLEZLECENIEPOZ_ID] <> '';
    Items.Clear;
    Items.AddStrings(oListaPozycji);
    if Parameters.Values[sZLEZLECENIEPOZ_ID] = '' then
      ItemIndex := 0
    else
      ItemIndex := oListaPozycji.IndexOfSkrot(Parameters.Values[sZLEZLECENIEPOZ_ID]);
  end;
end;

procedure TZLEKontrolaRealizacjiRecznaIlosciowaDBGridForm.InitializeObjectFields;
var oDataSet: TDataSet;
    oMark: TBookmark;
begin
  inherited;
  oListaPozycji := nil;
  oListaPozycji := TConstStringList.Create();
  with oListaPozycji do begin
    Duplicates := dupIgnore;
    Sorted := True;
    if (Owner is TUNIDBGridForm) then begin
      oDataSet := (Owner as TUNIDBGridForm).DataModule.ActiveQuery;
      oMark := oDataSet.GetBookmark;
      oDataSet.DisableControls;
      try
        oDataSet.First;
        while not oDataSet.Eof do begin
          Add( oDataSet.FieldByName(sZLEZLECENIEPOZ_OPIS).AsString+' - '+ASODM.WstawWMaske(oDataSet.FieldByName(sASOASORT_INDEKS).AsString,ASODM.vAsoMaskaIndeksu+';0;_'),
               oDataSet.FieldByName(sZLEZLECENIEPOZ_ID).AsString );
          oDataSet.Next;
        end;
      finally
        oDataSet.EnableControls;
        oDataSet.GotoBookmark(oMark);
        oDataSet.FreeBookmark(oMark);
      end;
    end;
  end;

  sEditField := sZLEIL_ILOSC;
end;

procedure TZLEKontrolaRealizacjiRecznaIlosciowaDBGridForm.PozycjaComboBoxChange(
  Sender: TObject);
begin
  inherited;
  ZatwierdzZmiany();
  if Parameters.Values[sZLEZLECENIEPOZ_ID] <> oListaPozycji.ZwrocSkrot(PozycjaComboBox.ItemIndex) then begin
    Parameters.Values[sZLEZLECENIEPOZ_ID] := oListaPozycji.ZwrocSkrot(PozycjaComboBox.ItemIndex);
    DataModule.ReOpenDataSets;
  end;
end;

initialization
  FormManager.RegisterForm( TZLEKontrolaRealizacjiRecznaIlosciowaDBGridForm,
                            'Lista skadnikw rcznych kontroli realizacji ilociowej',
                            sZLEModulID );

end.
