unit ZLEKontrolaRealizacjiRecznaIlosciowaUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-04-27 gdeyk    Utworzone
}
{$I ..\!\defines.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ZLEKontrolaRealizacjiRecznaUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLEKontrolaRealizacjiRecznaIlosciowaDataModule = class(TZLEKontrolaRealizacjiRecznaDataModule)
  private
  protected
    function GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;
  public
    constructor Create( AOwner: TComponent); override;
    destructor Destroy(); override;
    procedure Open(); override;
  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  FormManagerUnit,
  QueryBuilderUnit,
  UNIStaleUnit,
  UNISysDefUnit,
  ASODefUnit,
  ASODataManagerExtUnit,
  ZLEDefUnit;

{ TZLEKontrolaRealizacjiRecznaIlosciowaDataModule }

constructor TZLEKontrolaRealizacjiRecznaIlosciowaDataModule.Create(
  AOwner: TComponent);
begin
  inherited;
end;

destructor TZLEKontrolaRealizacjiRecznaIlosciowaDataModule.Destroy;
begin
  inherited;

end;

function TZLEKontrolaRealizacjiRecznaIlosciowaDataModule.GetTableName: string;
begin
  result := sZLEIL;
end;

procedure TZLEKontrolaRealizacjiRecznaIlosciowaDataModule.InitializeGridQueryDefs;
begin
  if GridColDefs.Count = 0 then with GridColDefs do begin
    AddRequiredAndUnvisible( TableName+cSuffixPola_ID, 'M', '');
    AddRequiredAndUnvisible( sUNIOKRES_ID, 'M', '');
    AddRequired( sUNIROK_ROK, 'R', 'Rok', KontrolaOkresowa, taLeftJustify, 100 );
    Add( sUNIOKRES_OKRES_NR, 'O', 'Nr okresu', True, KontrolaOkresowa, taLeftJustify, 50 );
    AddRequired( sUNIOKRES_NAZWA, 'O', 'Okres', KontrolaOkresowa, taLeftJustify, 150 );
    AddRequiredAndUnvisible( sASOASORT_ID, 'M', '');
    AddRequired( sASOASORT_INDEKS, 'A', 'Indeks asort.', True, taLeftJustify, 150);
    Add( sASOASORT_NAZWA, 'A', 'Nazwa asort.', True, True, taLeftJustify, 200);
    AddRequiredAndUnvisible( sZLEZLECENIEPOZ_ID, 'M', '');
    Add( sZLEZLECENIEPOZ_OPIS, 'Z', 'Opis', True, True, taLeftJustify, 200);
    AddRequiredAndUnvisible( sZLESKLADIL_ID, 'M', '');
    AddRequired( sZLESKLADIL_NAZWA, 'S', 'Nazwa skadnika', True, taLeftJustify, 150 );
    AddRequired( sZLEIL_ILOSC, 'M', 'Ilo', True, taRightJustify, 150 );
  end;
  if GridTabDefs.Count = 0 then with GridTabDefs do begin
    Add( 'M', TableName );
    Add( 'O', sUNIOKRES );
    Add( 'R', sUNIROK );
    Add( 'S', sZLESKLADIL );
    Add( 'A', sASOASORT );
    Add( 'Z', sZLEZLECENIEPOZ );
    Add( 'ZLE', sZLEZLECENIE );
    Add( 'TZ', sZLETYPZLEC );
    Add( 'TS', sZlETYPSKLADIL );
  end;
  if GridJoinDefs.Count = 0 then with GridJoinDefs do begin
    AddSimple( 'M', 'O', 'M.'+sUNIOKRES_ID+'=O.'+sUNIOKRES_ID, qjkLeftOuter, True );
    AddSimple( 'M', 'S', 'M.'+sZLESKLADIL_ID+'=S.'+sZLESKLADIL_ID, qjkInner, True );
    AddCondition( 'S.'+sZLESKLADIL_RODZAJ+'='+QuotedStr(cZLERodzajSklad_RecznyID), True );
    AddSimple( 'O', 'R', 'O.'+sUNIROK_ID+'=R.'+sUNIROK_ID, qjkLeftOuter, True );
    AddSimple( 'M', 'Z', 'M.'+sZLEZLECENIEPOZ_ID+'=Z.'+sZLEZLECENIEPOZ_ID, qjkInner, True );
    AddSimple( 'Z', 'A', 'Z.'+sASOASORT_ID+'=A.'+sASOASORT_ID, qjkInner, True );
    AddSimple( 'Z', 'ZLE', 'Z.'+sZLEZLECENIE_ID+'=ZLE.'+sZLEZLECENIE_ID, qjkInner, True );
    AddSimple( 'ZLE', 'TZ', 'ZLE.'+sZLETYPZLEC_ID+'=TZ.'+sZLETYPZLEC_ID, qjkInner, True );
    AddSimple( 'TZ', 'TS', 'TZ.'+sZLETYPZLEC_ID+'=TS.'+sZLETYPZLEC_ID, qjkInner, True );
    AddSimple( 'TS', 'S', 'TS.'+sZLESKLADIL_ID+'=S.'+sZLESKLADIL_ID, qjkInner, True );
  end;
  inherited;
end;

procedure TZLEKontrolaRealizacjiRecznaIlosciowaDataModule.Open;
begin
  inherited;
  (ActiveQuery.FieldByName(sZLEIL_ILOSC) as TNumericField).DisplayFormat := UNIGetMaskFromFormat( ASODM.vAsoFormatIlosci );
  (ActiveQuery.FieldByName(sZLEIL_ILOSC) as TNumericField).EditFormat := UNIGetMaskFromFormat( ASODM.vAsoFormatIlosci, True );
  ActiveQuery.FieldByName(sASOASORT_INDEKS).EditMask := ASODM.vAsoMaskaIndeksu+';0;_';
end;

initialization
  FormManager.RegisterForm( TZLEKontrolaRealizacjiRecznaIlosciowaDataModule,
                            'Modu danych dla kontroli rcznej', sZLEModulID );

end.
