unit ZLEKontrolaRealizacjiRecznaSelectFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-04-02 gdeyk    Utworzone
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNISelectFormUnit, Menus, UNIComponentsUnit, Db, ToolWin, ComCtrls,
  StdCtrls, ExtCtrls, UNIDBDetailFormUnit, UNIDBConstComboBoxUnit, Mask;

type
  TZLEKontrolaRealizacjiRecznaSelectForm = class(TUNISelectForm)
    SkladnikComboBox: TUNIComboBox;
    SkladnikLabel: TUNILabel;
    WartoscLabel: TUNILabel;
    WartoscEdit: TUNIEdit;
    procedure SkladnikComboBoxChange(Sender: TObject);
    procedure WartoscEditChange(Sender: TObject);
  private
    oSkladnikiKontroli: TConstStringList;
    oWartosciSkladnikow: TConstStringList;
    procedure InitializeControls();
    procedure InitializeObjectFields();
    procedure WczytajSkladnik();
    procedure ZapiszSkladnik();
  protected
    procedure WczytajSkladnikiKontroli(oSkladniki, oWartosci: TConstStringList); virtual;
    function Validate(): Boolean; override;
    procedure InternalOpen; override;
  public
    destructor Destroy(); override;
    property WartosciSkladnikow: TConstStringList read oWartosciSkladnikow;
  end;

implementation

{$R *.DFM}

uses
  FormManagerUnit,
  UNIStaleUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit;

{ TZLEKontrolaRealizacjiRecznaDBDetailForm }

destructor TZLEKontrolaRealizacjiRecznaSelectForm.Destroy;
begin
  if oSkladnikiKontroli <> nil then oSkladnikiKontroli.Free;
  if oWartosciSkladnikow <> nil then oWartosciSkladnikow.Free;
  inherited;
end;

procedure TZLEKontrolaRealizacjiRecznaSelectForm.InitializeControls;
begin
  SkladnikComboBox.Items.AddStrings(oSkladnikiKontroli);
  SkladnikComboBox.ItemIndex := 0;
  WczytajSkladnik();
end;

procedure TZLEKontrolaRealizacjiRecznaSelectForm.InitializeObjectFields;
begin
  oSkladnikiKontroli := TConstStringList.Create();
  oWartosciSkladnikow := TConstStringList.Create();
  WczytajSkladnikiKontroli( oSkladnikiKontroli, oWartosciSkladnikow);
end;

procedure TZLEKontrolaRealizacjiRecznaSelectForm.InternalOpen;
begin
  //inicjalizacja pl obiektu
  InitializeObjectFields();
  //inicjalizacja kontrolek
  InitializeControls();

  if Parameters.Values[cFORM_CAPTION] <> '' then begin
    Caption := Parameters.Values[cFORM_CAPTION];
  end;

  inherited;

end;

function TZLEKontrolaRealizacjiRecznaSelectForm.Validate: Boolean;
begin
  result := inherited Validate();
end;

procedure TZLEKontrolaRealizacjiRecznaSelectForm.SkladnikComboBoxChange(
  Sender: TObject);
begin
  inherited;
  WczytajSkladnik();
end;

procedure TZLEKontrolaRealizacjiRecznaSelectForm.ZapiszSkladnik;
var sSkladnikID: String;
    iIndex: Integer;
begin
  sSkladnikID := oSkladnikiKontroli.ZwrocSkrot(SkladnikComboBox.ItemIndex);
  iIndex := oWartosciSkladnikow.IndexOfSkrot(sSkladnikID);
  if iIndex = -1 then
    oWartosciSkladnikow.Add( WartoscEdit.Text, sSkladnikID )
  else
    oWartosciSkladnikow[iIndex] := WartoscEdit.Text;
end;

procedure TZLEKontrolaRealizacjiRecznaSelectForm.WczytajSkladnik;
var sSkladnikID: String;
    iIndex: Integer;
begin
  sSkladnikID := oSkladnikiKontroli.ZwrocSkrot(SkladnikComboBox.ItemIndex);
  iIndex := oWartosciSkladnikow.IndexOfSkrot(sSkladnikID);
  if iIndex <> -1 then WartoscEdit.Text := oWartosciSkladnikow[iIndex]
  else WartoscEdit.Text := '';
end;

procedure TZLEKontrolaRealizacjiRecznaSelectForm.WartoscEditChange(
  Sender: TObject);
begin
  inherited;
  ZapiszSkladnik();
end;

procedure TZLEKontrolaRealizacjiRecznaSelectForm.WczytajSkladnikiKontroli(
  oSkladniki, oWartosci: TConstStringList);
begin
  if oSkladniki.Count = 0 then
    raise EOF_ZLEException.Create( 'Brak skadnikw wypenianych rcznie' );
end;

end.
