unit ZLEKontrolaRealizacjiRecznaUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-04-23 gdeyk    Utworzone
}
{$I ..\!\defines.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLEKontrolaRealizacjiRecznaDataModule = class(TUNIDataModule)
  private
    iZlecenieCondIdx: Integer;
    iZleceniePozCondIdx: Integer;
    iOkresCondIdx: Integer;
    bKontrolaOkresowa: Boolean;
  protected
    procedure SetMasterJoins(); virtual;
    procedure OpenDataSets(); override;
    procedure GetKeys; override;
    procedure InitializeGridQueryDefs; override;
    property KontrolaOkresowa: Boolean read bKontrolaOkresowa;
  public
    constructor Create( AOwner: TComponent); override;
    destructor Destroy(); override;
    procedure Post; override;
  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  UNIDBGridFormUnit,
  SQLManagerUnit,
  UNISysDefUnit,
  ASODefUnit,
  ZLEDefUnit;

{ TZLEKontrolaRealizacjiRecznaDataModule }

constructor TZLEKontrolaRealizacjiRecznaDataModule.Create(
  AOwner: TComponent);
begin
  inherited;
  iZlecenieCondIdx := -1;
  iOkresCondIdx := -1;
  iZleceniePozCondIdx := -1;
  bKontrolaOkresowa := false;
  if (Owner is TUNIDBGridForm) then
     bKontrolaOkresowa := ((Owner as TUNIDBGridForm).Parameters.Values[sUNIOKRES_ID] <> '');
end;

destructor TZLEKontrolaRealizacjiRecznaDataModule.Destroy;
begin
  inherited;

end;

procedure TZLEKontrolaRealizacjiRecznaDataModule.GetKeys;
begin
  with FKeys do begin
    AddPrimary( TableName+cSuffixPola_ID );
  end;
end;

procedure TZLEKontrolaRealizacjiRecznaDataModule.InitializeGridQueryDefs;
begin
  inherited;
end;

procedure TZLEKontrolaRealizacjiRecznaDataModule.OpenDataSets;
begin
  SetMasterJoins();
  inherited;
end;

procedure TZLEKontrolaRealizacjiRecznaDataModule.Post;
var bLocalTrans: Boolean;
begin
  bLocalTrans := not SQLManager.InTransaction;
  if bLocalTrans then SQLManager.StartTransaction;
  try
    inherited;
    if bLocalTrans then SQLManager.Commit;
  except
    on E:EDMException do begin
      if bLocalTrans then SQLManager.Rollback;
      Komunikat( cError, LastDBError.OrgMess );
      abort;
    end else begin
      if bLocalTrans then SQLManager.Rollback;
      Komunikat( cError, (ExceptObject as Exception).Message+#13#10+
                         (ExceptObject as Exception).ClassName );
      abort;
    end;
  end;

end;

procedure TZLEKontrolaRealizacjiRecznaDataModule.SetMasterJoins;
begin
  with (Owner as TUNIDBGridForm) do begin
    //ograniczenie skadnikw do zlecenia
    if (iZlecenieCondIdx = -1) then
      iZlecenieCondIdx := GridJoinDefs.AddCondition( 'M.'+sZLEZLECENIE_ID+'='+Parameters.Values[sZLEZLECENIE_ID], false );
    GridJoinDefs.ExchangeCondition( iZlecenieCondIdx, 'M.'+sZLEZLECENIE_ID+'='+Parameters.Values[sZLEZLECENIE_ID], Parameters.Values[sZLEZLECENIE_ID] <> '' );

    //ograniczenie skadnikw do pozycji zlecenia
    if (iZleceniePozCondIdx = -1) then
      iZleceniePozCondIdx := GridJoinDefs.AddCondition( 'Z.'+sZLEZLECENIEPOZ_ID+'='+Parameters.Values[sZLEZLECENIEPOZ_ID], false );
    GridJoinDefs.ExchangeCondition( iZleceniePozCondIdx, 'Z.'+sZLEZLECENIEPOZ_ID+'='+Parameters.Values[sZLEZLECENIEPOZ_ID], Parameters.Values[sZLEZLECENIEPOZ_ID] <> '' );

    //ograniczenie skadnikw do okresu
    if (iOkresCondIdx = -1) then
      iOkresCondIdx := GridJoinDefs.AddCondition( 'M.'+sUNIOKRES_ID+'='+Parameters.Values[sUNIOKRES_ID], false );
    if Parameters.Values[sUNIOKRES_ID] = '' then
      GridJoinDefs.ExchangeCondition( iOkresCondIdx, 'M.'+sUNIOKRES_ID+' is null', True )
    else if Parameters.Values[sUNIOKRES_ID] = '-1' then
      GridJoinDefs.ExchangeCondition( iOkresCondIdx, 'M.'+sUNIOKRES_ID+'='+Parameters.Values[sUNIOKRES_ID], false )
    else GridJoinDefs.ExchangeCondition( iOkresCondIdx, 'M.'+sUNIOKRES_ID+'='+Parameters.Values[sUNIOKRES_ID], true );
  end;
end;

end.
