unit ZLEKontrolaRealizacjiRecznaWartosciowaDBGridFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ZLEKontrolaRealizacjiRecznaDBGridFormUnit, Db, DBTables,
  UNIComponentsUnit, URDataSet, UniDesigner, Menus, Grids, DBGrids,
  StdCtrls, ComCtrls, DBCtrls, ToolWin, ExtCtrls, UNIStaleUnit,
  UNIDataModuleUnit;

type
  TZLEKontrolaRealizacjiRecznaWartosciowaDBGridForm = class(TZLEKontrolaRealizacjiRecznaDBGridForm)
    procedure KontrolaRecznaDBNavigatorClick(Sender: TObject;
      Button: TNavigateBtn);
    procedure OkresComboBoxChange(Sender: TObject);
    procedure DBGridDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);    
  private
  protected
    procedure InitializeObjectFields(); override;
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure BeforePost(DataSet: TDataSet); override;
  public
    //procedure InternalOpen; override;
  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  FormManagerUnit,
  UNIDBGridFormUnit,
  UNISysDefUnit,
  ZLEDefUnit,
  ZLEKontrolaRealizacjiRecznaWartosciowaUnit;

{ TZLEKontrolaRealizacjiRecznaWartosciowaDBGridForm }
procedure TZLEKontrolaRealizacjiRecznaWartosciowaDBGridForm.DBGridDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
{var
  s: string;}
begin
  inherited;
  (*if Column.Field <> Nil then begin
    s:= Column.Field.AsString;
    if (Column.FieldName = sZLEWART_WARTOSC) then begin
        s := FormatFloat('### ##0.000', Zaokraglij(DMAQFbN(sZLEWART_WARTOSC).AsFloat, 5 {UNIGetFracFromValueFormat(ASODM.vAsoFormatIlosci)} ));
      DBGrid.WriteText(DBGrid.Canvas, Rect, s, Column.Alignment);
    end;
  end;*)
end;


procedure TZLEKontrolaRealizacjiRecznaWartosciowaDBGridForm.BeforePost(
  DataSet: TDataSet);
begin
  if DataSet.FieldByName(sZLEWART_WARTOSC).IsNull then begin
    Komunikat( cWarning, 'Naley poda warto' );
    Abort;
  end;
end;

function TZLEKontrolaRealizacjiRecznaWartosciowaDBGridForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLEKontrolaRealizacjiRecznaWartosciowaDataModule.CreateOpen( Self,
                                                                     InheritedMasterKeyValues,
                                                                     AOpenMode );
end;

procedure TZLEKontrolaRealizacjiRecznaWartosciowaDBGridForm.InitializeObjectFields;
begin
  inherited;
  
  sEditField := sZLEWART_WARTOSC;
end;

procedure TZLEKontrolaRealizacjiRecznaWartosciowaDBGridForm.KontrolaRecznaDBNavigatorClick(
  Sender: TObject; Button: TNavigateBtn);
begin
  inherited;
  ZatwierdzZmiany();
  with Parameters do begin
    Values[sUNIOKRES_ID] := (Owner as TUNIDBGridForm).DMAQFbN(sUNIOKRES_ID).AsString;
    OkresComboBox.ItemIndex := oListaOkresow.IndexOfSkrot(Values[sUNIOKRES_ID]);
  end;
  DataModule.ReOpenDataSets();
end;

procedure TZLEKontrolaRealizacjiRecznaWartosciowaDBGridForm.OkresComboBoxChange(
  Sender: TObject);
begin
  inherited;
  if (Owner is TUNIDBGridForm) then
    (Owner as TUNIDBGridForm).DataModule.ActiveQuery.Locate( sUNIOKRES_ID,
                                                             oListaOkresow.ZwrocSkrot(OkresComboBox.ItemIndex),
                                                             [] );
end;

initialization
  FormManager.RegisterForm( TZLEKontrolaRealizacjiRecznaWartosciowaDBGridForm,
                            'Lista skadnikw rcznych kontroli realizacji wartociowej',
                            sZLEModulID );

end.
