unit ZLEKontrolaRealizacjiRecznaWartosciowaUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-04-23 gdeyk    Utworzone
}
{$I ..\!\defines.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ZLEKontrolaRealizacjiRecznaUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLEKontrolaRealizacjiRecznaWartosciowaDataModule = class(TZLEKontrolaRealizacjiRecznaDataModule)
  private
  protected
    function GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;
  public
    constructor Create( AOwner: TComponent); override;
    destructor Destroy(); override;
    procedure Open(); override;
  end;

implementation

{$R *.DFM}

uses
  FormManagerUnit,
  QueryBuilderUnit,
  UNIStaleUnit,
  UNISysDefUnit,
  Dodatki,
  ZLEDefUnit;

{ TZLEKontrolaRealizacjiRecznaWartosciowaDataModule }

constructor TZLEKontrolaRealizacjiRecznaWartosciowaDataModule.Create(
  AOwner: TComponent);
begin
  inherited;
end;

destructor TZLEKontrolaRealizacjiRecznaWartosciowaDataModule.Destroy;
begin
  inherited;
end;

function TZLEKontrolaRealizacjiRecznaWartosciowaDataModule.GetTableName: string;
begin
  result := sZLEWART;
end;

procedure TZLEKontrolaRealizacjiRecznaWartosciowaDataModule.InitializeGridQueryDefs;
begin
  if GridColDefs.Count = 0 then with GridColDefs do begin
    AddRequiredAndUnvisible( TableName+cSuffixPola_ID, 'M', '');
    AddRequiredAndUnvisible( sUNIOKRES_ID, 'M', '');
    AddRequired( sUNIROK_ROK, 'R', 'Rok', KontrolaOkresowa, taLeftJustify, 100 );
    Add( sUNIOKRES_OKRES_NR, 'O', 'Nr okresu', True, KontrolaOkresowa, taLeftJustify, 50 );
    AddRequired( sUNIOKRES_NAZWA, 'O', 'Okres', KontrolaOkresowa, taLeftJustify, 150 );
    AddRequiredAndUnvisible( sZLEZLECENIE_ID, 'M', '');
    AddRequiredAndUnvisible( sZLESKLADWART_ID, 'M', '');
    AddRequired( sZLESKLADWART_NAZWA, 'S', 'Nazwa skadnika', True, taLeftJustify, 150 );
    AddRequired( sZLEWART_WARTOSC, 'M', 'Warto', True, taRightJustify, 150, uftNumber );
    AddRequiredAndUnvisible( sZLESKLADWART_FORMAT, 'S', '');// 'Format', True, taLeftJustify, 50 );
  end;
  if GridTabDefs.Count = 0 then with GridTabDefs do begin
    Add( 'M', TableName );
    Add( 'O', sUNIOKRES );
    Add( 'R', sUNIROK );
    Add( 'S', sZLESKLADWART );
    Add( 'TS',sZLETYPSKLADW );
    Add( 'TZ',sZLETYPZLEC );
    Add( 'Z', sZLEZLECENIE );
  end;
  if GridJoinDefs.Count = 0 then with GridJoinDefs do begin
    AddSimple( 'M', 'O', 'M.'+sUNIOKRES_ID+'=O.'+sUNIOKRES_ID, qjkLeftOuter, True );
    AddSimple( 'M', 'S', 'M.'+sZLESKLADWART_ID+'=S.'+sZLESKLADWART_ID, qjkInner, True );
    AddCondition( 'S.'+sZLESKLADWART_RODZAJ+'='+QuotedStr(cZLERodzajSklad_RecznyID), True );
    AddSimple( 'O', 'R', 'O.'+sUNIROK_ID+'=R.'+sUNIROK_ID, qjkLeftOuter, True );
    AddSimple( 'M', 'Z', 'M.'+sZLEZLECENIE_ID+'=Z.'+sZLEZLECENIE_ID, qjkInner, True );
    AddSimple( 'Z', 'TZ', 'Z.'+sZLETYPZLEC_ID+'=TZ.'+sZLETYPZLEC_ID, qjkInner, True );
    AddSimple( 'TZ', 'TS', 'TZ.'+sZLETYPZLEC_ID+'=TS.'+sZLETYPZLEC_ID, qjkInner, True );
    AddSimple( 'TS', 'S', 'TS.'+sZLESKLADWART_ID+'=S.'+sZLESKLADWART_ID, qjkInner, True );
  end;
  inherited;
end;

procedure TZLEKontrolaRealizacjiRecznaWartosciowaDataModule.Open;
var sMaska, sMaskaEdycja: String;
    //oMark: TBookmark;
begin
  inherited;
  sMaska := ',0.00####';
  sMaskaEdycja := '0.00####';
  (ActiveQuery.FieldByName(sZLEWART_WARTOSC) as TNumericField).DisplayFormat := sMaska; //cMaskaKwotyExt;
  (ActiveQuery.FieldByName(sZLEWART_WARTOSC) as TNumericField).EditFormat := sMaskaEdycja; //cMaskaKwotyEdycjaExt;

  (*************
  if ActiveQuery.IsEmpty then Exit;
  oMark := ActiveQuery.GetBookmark;
  ActiveQuery.DisableControls;
  try
    ActiveQuery.First;
    while not ActiveQuery.Eof do begin
      if ActiveQuery.FieldByName(sZLESKLADWART_FORMAT).AsString <> '' then begin
        try
          sMaska := UNIGetMaskFromFormat(ActiveQuery.FieldByName(sZLESKLADWART_FORMAT).AsFloat, False);
          sMaskaEdycja := UNIGetMaskFromFormat(ActiveQuery.FieldByName(sZLESKLADWART_FORMAT).AsFloat, True);
        except
          sMaska := ',0.00####';
          sMaskaEdycja := '0.00####';
        end;
      end else begin
        sMaska := ',0.00####';
        sMaskaEdycja := '0.00####';
      end;
      (ActiveQuery.FieldByName(sZLEWART_WARTOSC) as TNumericField).DisplayFormat := sMaska; //cMaskaKwotyExt;
      (ActiveQuery.FieldByName(sZLEWART_WARTOSC) as TNumericField).EditFormat := sMaskaEdycja; //cMaskaKwotyEdycjaExt;
      ActiveQuery.Next;
    end;
  finally
    ActiveQuery.EnableControls;
    ActiveQuery.GotoBookmark(oMark);
    ActiveQuery.FreeBookmark(oMark);
  end;
  ********)
end;

initialization
  FormManager.RegisterForm( TZLEKontrolaRealizacjiRecznaWartosciowaDataModule,
                            'Modu danych dla kontroli rcznej', sZLEModulID );

end.
