unit ZLEKontrolaRealizacjiWartosciowejDBGridFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ZLEKontrolaRealizacjiDBGridFormUnit, Db, DBTables, UNIComponentsUnit,
  URDataSet, UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls,
  DBCtrls, ToolWin, ExtCtrls, UNIStaleUnit, UNIDataModuleUnit, UNIDBConstComboBoxUnit;

type
  TZLEKontrolaRealizacjiWartosciowejDBGridForm = class(TZLEKontrolaRealizacjiDBGridForm)
    procedure DBGridDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
  protected
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure AktualizujRealizacje(); override;
    procedure OpenDetail( AOpenMode: TOpenMode ); override;
  public
    procedure InternalOpen; override;
  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  FormManagerUnit,
  KeyManagerUnit,
  SecurityManagerUnit,
  SQLManagerUnit,
  UNIFormUnit,
  UNISysDefUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit,
  ZLEKontrolaRealizacjiWartosciowejUnit,
  ZLEKontrolaRealizacjiDBDetailFormUnit;

{ TZLEKontrolaRealizacjiWartosciowejDBGridForm }
procedure TZLEKontrolaRealizacjiWartosciowejDBGridForm.DBGridDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
{var
  s: string;}
begin
  inherited;
  (*if Column.Field <> Nil then begin
    s:= Column.Field.AsString;
    if (Column.FieldName = sZLEWART_WARTOSC) then begin
        s := FormatFloat('### ##0.000', Zaokraglij(DMAQFbN(sZLEWART_WARTOSC).AsFloat, 5 {UNIGetFracFromValueFormat(ASODM.vAsoFormatIlosci)} ));
       DBGrid.WriteText(DBGrid.Canvas, Rect, s, Column.Alignment);
    end;
  end;*)
end;

procedure TZLEKontrolaRealizacjiWartosciowejDBGridForm.AktualizujRealizacje;
begin
  ZLEDM.AktualizujRealizacjeZleceniaExt( StrToInt(Parameters.Values[sZLEZLECENIE_ID]),
                                         StrToInt(Parameters.Values[sZLETYPZLEC_ID]),
                                         StrToInt(Parameters.Values[sUNIOKRES_ID]),
                                         0, //asortymentu nie podajemy dla kontroli wartoiowej
                                         StrToInt(Parameters.Values[sUNIODDZIAL_ID]),
                                         True, //kontrola kosztw
                                         Parameters.Values[sZLETYPZLEC_KOSZTY_OKRES]=sUNICONST_ALTERNATYWA_TAK );
end;

function TZLEKontrolaRealizacjiWartosciowejDBGridForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLEKontrolaRealizacjiWartosciowejDataModule.CreateOpen( Self,
                                                                     InheritedMasterKeyValues,
                                                                     AOpenMode );
end;

procedure TZLEKontrolaRealizacjiWartosciowejDBGridForm.InternalOpen;
begin
  KontrolaWartosciowa := True;
  inherited;
end;

procedure TZLEKontrolaRealizacjiWartosciowejDBGridForm.OpenDetail(
  AOpenMode: TOpenMode);
var oParams: TKeyValues;
    sKlasa: String;
    sLocateId: String;
begin
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add( cFORM_CAPTION+'='+'Rczna edycja skadnikw kontroli wartociowej');
    Add(sZLEZLECENIE_ID+'='+Parameters.Values[sZLEZLECENIE_ID]);
    Add(sUNIOKRES_ID+'='+DMAQFbN(sUNIOKRES_ID).AsString);
  end;
  sKlasa := cKlasaSkladnikRealRWart+cSuffixKlasyDBGrid;


  AOpenMode := omVirtual or omList or omInPlaceEdit or omShowModal;
  FormManager.OpenForm( Self, sKlasa, AOpenMode, oParams );
  with DBGrid.DataSource.DataSet do
    try
      DisableControls;
      sLocateId := FieldByName(sUNIOKRES_ID).AsString;
      DataModule.ReOpenDataSets();
      if sLocateId <> '' then Locate( sUNIOKRES_ID, sLocateId, [] );
    finally
      EnableControls;
    end;
  DBGrid.SetFocus;
end;

initialization
  FormManager.RegisterForm( TZLEKontrolaRealizacjiWartosciowejDBGridForm,
                            'Lista kontroli realizacji wartociowej', sZLEModulID );

end.
