unit ZLEKontrolaRealizacjiWartosciowejUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-26 gdeyk    Utworzone
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables, DBClient,
  ZLEKontrolaRealizacjiUnit;

type
  TZLEKontrolaRealizacjiWartosciowejDataModule = class(TZLEKontrolaRealizacjiDataModule)
  protected
    procedure DefineColumns( oQuery: TUNIQuery); override;
    procedure AddRecordsToDataSet( oQueryFrom: TUNIQuery; oDataSetTo: TClientDataSet ); override;
    procedure CreateVirtualQuery(); override;
    function GetTableName: string; override;
  public
    constructor Create( Owner: TComponent ); override;
    procedure ReOpenDataSets(); override;
  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  FormManagerUnit,
  QueryBuilderUnit,
  SQLManagerUnit,
  UNIFormUnit,
  UNIDBGridFormUnit,
  UNIStaleUnit,
  UNISysDefUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit;

{ TZLEKontrolaRealizacjiWartosciowejDataModule }

procedure TZLEKontrolaRealizacjiWartosciowejDataModule.AddRecordsToDataSet(
  oQueryFrom: TUNIQuery; oDataSetTo: TClientDataSet );
begin
  with oQueryFrom do begin
    First;
    while not Eof do begin
      try
        if (FieldByName(sUNIOKRES_ID).IsNull)or
           (oDataSetTo.Locate( sUNIOKRES_ID, FieldByName(sUNIOKRES_ID).AsInteger, [] )) then
          oDataSetTo.Edit
        else
          oDataSetTo.Append;
        oDataSetTo.FieldByName(sUNIOKRES_ID).AsString := FieldByName(sUNIOKRES_ID).AsString;
        oDataSetTo.FieldByName(sZLEZLECENIE_ID).AsString := FieldByName(sZLEZLECENIE_ID).AsString;
        oDataSetTo.FieldByName(sUNIOKRES_OKRES_NR).AsString := FieldByName(sUNIOKRES_OKRES_NR).AsString;
        oDataSetTo.FieldByName(sUNIOKRES_NAZWA).AsString := FieldByName(sUNIOKRES_NAZWA).AsString;
        oDataSetTo.FieldByName(sUNIOKRES_DATA_POCZ).AsDateTime := FieldByName(sUNIOKRES_DATA_POCZ).AsDateTime;

        if FieldByName(sZLEWART_BLAD).AsString <> cZLEParserBlad_BrakID then begin
//           oDataSetTo.FieldByName( sZLEWART_WARTOSC+'_'+FieldByName(sZLESKLADWART_ID).AsString ).AsString := cslZLEParserBlad.Strings[FieldByName(sZLEWART_BLAD).AsInteger];
           oDataSetTo.FieldByName( sZLEWART_WARTOSC+'_'+FieldByName(sZLESKLADWART_ID).AsString ).AsFloat := -1; //cslZLEParserBlad.Strings[FieldByName(sZLEWART_BLAD).AsInteger];
           oDataSetTo.FieldByName( sZLEWART_BLAD+'_'+FieldByName(sZLESKLADWART_ID).AsString ).AsString :=
                                   FieldByName(sZLEWART_BLAD).AsString;
        end else begin
           oDataSetTo.FieldByName( sZLEWART_WARTOSC+'_'+FieldByName(sZLESKLADWART_ID).AsString ).AsFloat :=
                                   FieldByName(sZLEWART_WARTOSC).AsFloat;
           oDataSetTo.FieldByName( sZLEWART_BLAD+'_'+FieldByName(sZLESKLADWART_ID).AsString ).AsString :=
                                   FieldByName(sZLEWART_BLAD).AsString;

        end;

        if FieldByName(sZLESKLADWART_RODZAJ).AsString = cZLERodzajSklad_RecznyID then
          oDataSetTo.FieldByName( sZLEWART_WARTOSC+'_'+FieldByName(sZLESKLADWART_ID).AsString ).Tag := clBlue
        else
          oDataSetTo.FieldByName( sZLEWART_WARTOSC+'_'+FieldByName(sZLESKLADWART_ID).AsString ).Tag := clWindowText;
        oDataSetTo.Post;
      except
        oDataSetTo.Cancel;
        raise;
      end;
      Next;
    end;
  end;
end;

constructor TZLEKontrolaRealizacjiWartosciowejDataModule.Create(
  Owner: TComponent);
begin
  inherited;
  KontrolaWartosciowa := True;
end;

procedure TZLEKontrolaRealizacjiWartosciowejDataModule.CreateVirtualQuery;
var
    sSQL: String;
begin
  try
    {sWhere := '(@'+sZLEALIAS_WART_ZLECENIE_ID+'='+(Owner as TUNIForm).Parameters.Values[sZLEZLECENIE_ID]+')';
    if (Owner as TUNIForm).Parameters.Values[sUNIOKRES_ID] <> '-1' then
      sWhere := sWhere+
                'and(@'+sZLEALIAS_WART_OKRES_ID+'='+(Owner as TUNIForm).Parameters.Values[sUNIOKRES_ID]+')'
    else if (Owner as TUNIForm).Parameters.Values[sZLETYPZLEC_KOSZTY_OKRES]=sUNICONST_ALTERNATYWA_TAK then begin
      sSubSQL := 'select ok.%s from %s ok where ok.%s=%d';
      sSubSQL := Format( sSubSQL, [ sUNIOKRES_ID, SQLManager.GetTableName(sUNIOKRES),
                                    sUNIROK_ID, vAktywnyRokObrachunkowyID] );
      sWhere := sWhere+
                'and(@'+sZLEALIAS_WART_OKRES_ID+' in ('+sSubSQL+'))'
    end; }
    {                                 sZLEALIAS_WART_ID+';'+
                                      sZLEALIAS_WART_OKRES_ID+';'+
                                      sZLEALIAS_WART_ZLECENIE_ID+';'+
                                      sZLEALIAS_OKRES_NR+';'+
                                      sZLEALIAS_OKRES_NAZWA+';'+
                                      sZLEALIAS_WART_SKLADWART_ID+';'+
                                      sZLEALIAS_SKLADWART_NAZWA+';'+
                                      sZLEALIAS_SKLADWART_SYMBOL+';'+
                                      sZLEALIAS_SKLADWART_RODZAJ+';'+
                                      sZLEALIAS_WART_BLAD+';'+
                                      sZLEALIAS_WART_WARTOSC,

    sSQL := ZLEDM.ZLEOdpytajODaneSQL( sZLEWART,
                                      sZLEALIAS_WART_ID+';'+
                                      sZLEALIAS_WART_OKRES_ID+';'+
                                      sZLEALIAS_ZLECENIE_ID+';'+
                                      sZLEALIAS_TYPSKLADW_TYP_ID+';'+
                                      sZLEALIAS_TYPSKLADW_KOLEJNOSC+';'+
                                      sZLEALIAS_OKRES_NR+';'+
                                      sZLEALIAS_OKRES_NAZWA+';'+
                                      sZLEALIAS_WART_SKLADWART_ID+';'+
                                      sZLEALIAS_SKLADWART_NAZWA+';'+
                                      sZLEALIAS_SKLADWART_SYMBOL+';'+
                                      sZLEALIAS_SKLADWART_RODZAJ+';'+
                                      sZLEALIAS_WART_BLAD+';'+
                                      sZLEALIAS_WART_WARTOSC,
                                      sWhere,
                                      true );
    sSQL := sSQL + ' order by '+sZLEALIAS_OKRES+'.'+sUNIOKRES_OKRES_NR;}

    sSQL := 'SELECT   DISTINCT WART.' + sZLEWART_ID + ', ' +
                              'WART.' + sUNIOKRES_ID + ', ' +
                              'WART.' + sZLEZLECENIE_ID + ', ' +
                              'OKRES.' + sUNIOKRES_DATA_POCZ + ', ' +
                              'RK.' + sUNIROK_ROK_TEXT + '|| LPAD(' + 'OKRES.' + sUNIOKRES_OKRES_NR + ', 2, 0) AS ' + sUNIOKRES_OKRES_NR + ', ' +
                              'OKRES.' + sUNIOKRES_NAZWA + '||' + QuotedStr(' ') + '||' + ' RK.' + sUNIROK_ROK_TEXT + ' AS ' + sUNIOKRES_NAZWA + ', ' +
                              'WART.' + sZLESKLADWART_ID + ', ' +
                              'SKLADWART.' + sZLESKLADWART_NAZWA + ', ' +
                              'SKLADWART.' + sZLESKLADWART_SYMBOL + ', ' +
                              'SKLADWART.' + sZLESKLADWART_RODZAJ + ', ' +
                              'WART.' + sZLEWART_BLAD + ', ' +
                              'WART.' + sZLEWART_WARTOSC + ', ' +
                              'SKLADW.' + sZLETYPSKLADW_KOLEJNOSC + ' ' +
          'FROM     %s WART, %s OKRES, %s SKLADW, %s ZLEC, %s SKLADWART, %s RK ' +
          'WHERE ' +
             'SKLADW.' + sZLETYPZLEC_ID   + ' = ZLEC.' + sZLETYPZLEC_ID + ' AND ' +
             'SKLADW.' + sZLESKLADWART_ID + ' = SKLADWART.' + sZLESKLADWART_ID + ' AND ' +
             'SKLADW.' + sZLESKLADWART_ID + ' = WART.' + sZLESKLADWART_ID + '(+) AND ' +
             'WART.' + sUNIOKRES_ID       + ' = OKRES.' + sUNIOKRES_ID + '(+) AND ' +
             'OKRES.' + sUNIROK_ID        + ' = RK.' + sUNIROK_ID + '(+) AND ' +
             'ZLEC.' + sZLEZLECENIE_ID    + ' = WART.' + sZLEZLECENIE_ID + ' AND ' +
             '(ZLEC.' + sZLEZLECENIE_ID + ' = ' + (Owner as TUNIForm).Parameters.Values[sZLEZLECENIE_ID] + ') ';

    if (Owner as TUNIForm).Parameters.Values[sUNIOKRES_ID] <> '-1' then
      sSQL := sSQL + ' AND ' +
                '(WART.' + sUNIOKRES_ID + ' = ' + (Owner as TUNIForm).Parameters.Values[sUNIOKRES_ID]+') '
    else if (Owner as TUNIForm).Parameters.Values[sZLETYPZLEC_KOSZTY_OKRES]=sUNICONST_ALTERNATYWA_TAK then begin
      {sSubSQL := 'SELECT OK.%s FROM %s OK WHERE OK.%s=%d';
      sSubSQL := Format(sSubSQL, [sUNIOKRES_ID, SQLManager.GetTableName(sUNIOKRES),
                                    sUNIROK_ID, vAktywnyRokObrachunkowyID]);
      sSQL := sSQL + ' AND ' +
                '(WART.' + sUNIOKRES_ID + ' IN ('+sSubSQL+')) '}
    end;

    sSQL := sSQL +                                //To byo sUNIOKRES_OKRES_NR
          'ORDER BY OKRES.' + sUNIOKRES_DATA_POCZ + ', ' +
                   'SKLADW.' + sZLETYPSKLADW_KOLEJNOSC;

    FQuery := SQLManager.CreateQuery( sSQL, [sZLEWART, sUNIOKRES, sZLETYPSKLADW,
                                             sZLEZLECENIE, sZLESKLADWART, sUNIROK]);
    FQuery.Open;
    inherited;
  finally
    if FQuery <> nil then FreeAndNil(FQuery);
  end;
end;

procedure TZLEKontrolaRealizacjiWartosciowejDataModule.DefineColumns;
var iIndex: Integer;
begin
  //ustawienie kolumn dla Grida
  with GridColDefs do begin
    //dorzucenie nie istniejcych kolumn
    if IndexOfFieldName(sUNIOKRES_ID) = -1 then
      AddRequired( sUNIOKRES_ID, 'M', 'OkresId', False, taLeftJustify, 0, uftInteger );
    if IndexOfFieldName(sZLEZLECENIE_ID) = -1 then
      AddRequired( sZLEZLECENIE_ID, 'M', 'ZlecenieID', False, taLeftJustify, 0, uftInteger );

    if IndexOfFieldName(sUNIOKRES_OKRES_NR) = -1 then                            //Tu byo uftInteger
      Add( sUNIOKRES_OKRES_NR, 'O', 'Nr Okresu', False, True, taLeftJustify, 50, uftString);
    if IndexOfFieldName(sUNIOKRES_DATA_POCZ) = -1 then
      Add( sUNIOKRES_DATA_POCZ, 'O', 'Pocztek okresu', False, True, taLeftJustify, 60, uftDate);
    if IndexOfFieldName(sUNIOKRES_NAZWA) = -1 then
      Add( sUNIOKRES_NAZWA, 'O', 'Okres', False, True, taLeftJustify, 80, uftString);
    oQuery.First;
    while not oQuery.Eof do begin
      if IndexOfFieldName( sZLEWART_WARTOSC+'_'+oQuery.FieldByName(sZLESKLADWART_ID).AsString ) = -1 then
        AddRequired( sZLEWART_WARTOSC+'_'+
                     oQuery.FieldByName(sZLESKLADWART_ID).AsString, 'M',
                     oQuery.FieldByName(sZLESKLADWART_NAZWA).AsString,
                     True, taRightJustify, 100, {uftString} uftFloat );
      if IndexOfFieldName( sZLEWART_BLAD+'_'+oQuery.FieldByName(sZLESKLADWART_ID).AsString ) = -1 then
        AddRequired( sZLEWART_BLAD+'_'+
                     oQuery.FieldByName(sZLESKLADWART_ID).AsString, 'M',
                     'Bd_' + oQuery.FieldByName(sZLESKLADWART_NAZWA).AsString,
                     False, taRightJustify, 100, uftString );
      oQuery.Next;
    end;
    //wyrzucenie kolumn ju niepotrzebnych
    for iIndex := Count-1 downto 0 do begin
      if (Pos( sZLEWART_WARTOSC, Items[iIndex].FieldName) > 0)and
         (not oQuery.Locate( sZLESKLADWART_ID,
                             Copy( Items[iIndex].FieldName,
                                   Length(sZLEWART_WARTOSC+'_')+1,
                                   Length(Items[iIndex].FieldName)), [] )) then begin
        Delete(iIndex);
      end else
      if (Pos( sZLEWART_BLAD, Items[iIndex].FieldName) > 0)and
         (not oQuery.Locate( sZLESKLADWART_ID,
                             Copy( Items[iIndex].FieldName,
                                   Length(sZLEWART_BLAD+'_')+1,
                                   Length(Items[iIndex].FieldName)), [] )) then begin
        Delete(iIndex);
      end;
    end;
  end;
end;

function TZLEKontrolaRealizacjiWartosciowejDataModule.GetTableName: string;
begin
  result := sZLEWART;
end;

procedure TZLEKontrolaRealizacjiWartosciowejDataModule.ReOpenDataSets;
var iOkresID: Integer;
begin
  iOkresID := 0;
  if (ActiveQuery <> nil)and(ActiveQuery.FindField(sUNIOKRES_ID) <> nil) then
    iOkresID := ActiveQuery.FieldByName(sUNIOKRES_ID).AsInteger;
  inherited;
  if ActiveQuery <> nil then
    ActiveQuery.Locate( sUNIOKRES_ID, iOkresID, []);
end;

initialization
  FormManager.RegisterForm( TZLEKontrolaRealizacjiWartosciowejDataModule,
                            'Modu danych dla kontroli wartociowej', sZLEModulID );

end.
