unit ZLEKrytPozRangeFormUnit;
{
Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who          What
---------------------------------------------------------------------------------------------
2008-11-19 Tomjen       Utworzone na nowo
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIRangeFormUnit, Menus, UNIComponentsUnit, ToolWin, ComCtrls, StdCtrls,
  Buttons, ExtCtrls, Mask, DB;
  {UNIDBConstComboBoxUnit}

type
  TZLEKrytPozRangeForm = class(TUNIRangeForm)
    OkresLookupAliasEdit: TUNILookupAliasEdit;
    OkresLabel: TUNILabel;
    UkryjZeroweCheckBox: TUNICheckBox;
    procedure OkresLookupAliasEditButtonClick(Sender: TObject);
    procedure OkresLookupAliasEditDelKey(Sender: TObject);
    function OkresLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
  private
    bProcessData: Boolean;
    procedure InitializeControls();
    procedure InitializeObjectFields();
    procedure UstawAliasy();
  protected

    procedure PackData; override;
    procedure PrepareParamsStep1; override;
    procedure PrepareParamsStep2; override;
    procedure ProcessRangeParamsToParameters; override;
    procedure ProcessData; override;
    procedure RestoreDefaults; override;

    procedure BeforeShow; override;
    procedure SelectButtonPressed; override;
    //function  Validate : boolean; override;
    procedure InternalOpen; override;
  end;

var
  ZLEKrytPozRangeForm: TZLEKrytPozRangeForm;

implementation
uses
  Dodatki,
  FormManagerUnit,
  KeyManagerUnit,
  SecurityManagerUnit,
  SQLManagerUnit,
  UNIDataManagerUnit,
  UNIStaleUnit,
  UNISysDataManagerUnit,
  UNISysDefUnit,
  SystemDefUnit,
  ZLEDefUnit,
  ZLEDataManagerExtUnit,
  UNIDBGridFormUnit;

{$R *.DFM}

procedure TZLEKrytPozRangeForm.InitializeObjectFields;
begin
  bProcessData := False;
end;

procedure TZLEKrytPozRangeForm.InternalOpen;
begin
  InitializeObjectFields();
  InitializeControls();
  inherited;
end;

procedure TZLEKrytPozRangeForm.InitializeControls;
begin
//  ZadekretowanyCheckBox.Visible := DataManagers.Available(sLFKModulId);
  UstawAliasy();
end;

procedure TZLEKrytPozRangeForm.UstawAliasy;
begin
  with OkresLookupAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_Name := sUNISYSALIAS_Okres_Obrachunkowy_Nazwa;
    Alias_ID := sUNISYSALIAS_Okres_Obrachunkowy_ID;
    AdditionalAliases := sUNISYSALIAS_Okres_Obrachunkowy_Rok_Opis;
  end;
end;


procedure TZLEKrytPozRangeForm.BeforeShow;
begin
  HideStatusPanel;
  if Parameters=nil then Parameters := TKeyValues.CreateEmpty;
  inherited;
end;


procedure TZLEKrytPozRangeForm.SelectButtonPressed;
begin
  if not Validate then begin
    ModalResult:= mrnone;
    exit;
  end;

  inherited;
end;

procedure TZLEKrytPozRangeForm.ProcessData;
begin
  inherited;
  bProcessData := True;
  try
      if RangeParam(sUNIOKRES_ID).IsSet then
        OkresLookupAliasEdit.InitiateData( StrToIntDef(RangeParam(sUNIOKRES_ID).Value,0) )
      else
        OkresLookupAliasEdit.OnDelKey(self);


      if RangeParam('UKRYJ_ZEROWE').IsSet then
      begin
         UkryjZeroweCheckBox.Checked := (RangeParam('UKRYJ_ZEROWE').Value = sTAK);
      end else begin
         UkryjZeroweCheckBox.Checked := False;
      end;
  finally
    bProcessData := False;
  end;
end;


procedure TZLEKrytPozRangeForm.RestoreDefaults;
begin
  ClearRangeParams();
  PrepareParamsStep1();
  ProcessData();
end;

procedure TZLEKrytPozRangeForm.PrepareParamsStep1;
begin
  with RangeParams do begin
   // TypDokRangeCheckListBox.RangeParam := RangeParam(sMAGTYPDOK_ID);
  end;
end;


procedure TZLEKrytPozRangeForm.PrepareParamsStep2;
begin
  {if Parameters.Values[sUNIMAGAZYN_ID] <> '' then
    RangeParam(sUNIMAGAZYN_ID).Value := Parameters.Values[sUNIMAGAZYN_ID];}

  if Parameters.Values['UKRYJ_ZEROWE'] <> '' then
     RangeParam('UKRYJ_ZEROWE').Value := Parameters.Values['UKRYJ_ZEROWE'];

end;


procedure TZLEKrytPozRangeForm.ProcessRangeParamsToParameters;
begin
  with Parameters do begin
    Values[sUNIOKRES_ID]         := RangeParam(sUNIOKRES_ID).Value;

    if UkryjZeroweCheckBox.Visible and UkryjZeroweCheckBox.Checked then
         Values['UKRYJ_ZEROWE'] := sTAK
    else Values['UKRYJ_ZEROWE'] := sNie;
  end;//with Parameters
end;



procedure TZLEKrytPozRangeForm.OkresLookupAliasEditButtonClick(
  Sender: TObject);
var
  Q:  TDataset;
begin
  Q:= UNISysDM.UNIPokazIWybierzOkresObrachunkowy(
    vAktywnyRokObrachunkowyID,'',
    sUNISYSALIAS_Okres_Obrachunkowy_ID+';'+sUNISYSALIAS_Okres_Obrachunkowy_Nazwa+';'+sUNISYSALIAS_Okres_Obrachunkowy_Rok_Opis,false,
    RangeParam(sUNIOKRES_ID).Value);
  if Q<> nil then
  try
    OkresLookupAliasEditSetData(Q);
  finally
    Q.free;
  end;
end;

procedure TZLEKrytPozRangeForm.OkresLookupAliasEditDelKey(Sender: TObject);
begin
  RangeParam(sUNIOKRES_ID).Clear();
  OkresLookupAliasEdit.Text := '';
end;

function TZLEKrytPozRangeForm.OkresLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  result:= true;
  with AliasSrc do begin
    OkresLookupAliasEdit.Text := AliasSrc.FieldByName(sUNIOKRES_NAZWA).AsString + ' ' + AliasSrc.FieldByName(sUNIROK_ROK_TEXT).AsString;
    //RangeParam(sUNIOKRES_NAZWA).Value := AliasSrc.FieldByName(sUNIOKRES_NAZWA).AsString;
    RangeParam(sUNIOKRES_ID).Value := AliasSrc.FieldByName(sUNIOKRES_ID).AsString;
    //RangeParam(sUNIROK_ROK_TEXT).Value:= AliasSrc.FieldByName(sUNIROK_ROK_TEXT).AsString;
  end;
end;

procedure TZLEKrytPozRangeForm.PackData;
begin
  if UkryjZeroweCheckBox.Checked then
       RangeParam('UKRYJ_ZEROWE').Value := sTak
  else RangeParam('UKRYJ_ZEROWE').Value := sNie;
  inherited;
end;

initialization
  FormManager.RegisterForm(TZLEKrytPozRangeForm, 'Zakres pozycji kryterium', sZLEModulID );
end.
