unit ZLEKryteriaDBDetailFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who     What
---------------------------------------------------------------------------------------------
2008-01-25 Tomjen  Utworzenie
}

interface

uses
  UNIStaleUnit, UNIDataModuleUnit, UNIFormUnit, KeyManagerUnit,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBDetailFormUnit, Menus, UNIComponentsUnit, Db, ToolWin, ComCtrls,
  StdCtrls, ExtCtrls, Mask, DBCtrls, Buttons, UNIDBConstComboBoxUnit,
  ImgList, UNISimpleEditorUnit, ZLEParserUnit, ZleDefUnit;

type
  TZLEKryteriaDBDetailForm = class(TUNIDBDetailForm)
    CheckButton: TUNIButton;
    MainPanel: TUNIPanel;
    OpisGroupBox: TUNIGroupBox;
    SymbolLabel: TUNILabel;
    LNazwaLabel: TUNILabel;
    SymbolDBEdit: TUNIDBEdit;
    NazwaDBEdit: TUNIDBEdit;
    TypZleceniaLabel: TUNILabel;
    TypZleceniaDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    KryteriaOkresoweDBCheckBox: TUNIDBCheckBox;
    UNILabel3: TUNILabel;
    FormatMaskEdit: TUNIMaskEdit;
    SkladoweGroupBox: TUNIGroupBox;
    MnemonikLabel: TUNILabel;
    TabelaLabel: TUNILabel;
    SkladoweLabel: TUNILabel;
    SkladowePanel: TUNIPanel;
    MnemonikEdit: TUNIEdit;
    TabelaEdit: TUNIEdit;
    RegulaGroupBox: TUNIGroupBox;
    RegulaPanel: TUNIPanel;
    OgraniczeniaPanel: TUNIPanel;
    Slownik0LookupAliasEdit: TUNILookupAliasEdit2;
    Slownik0Label: TUNILabel;
    PoziomINFLabel: TUNILabel;
    PoziomINFDBConstComboBox: TUNIDBConstComboBox;
    SlownikLookupAliasEdit: TUNILookupAliasEdit;
    SlownikLabel: TUNILabel;
    WykorzystajMnemonikDBCheckBox: TUNIDBCheckBox;
    DodatkoweOgraniczeniaGroupBox: TUNIGroupBox;
    DodatkoweOgraniczeniaPanel: TUNIPanel;
    function TypZleceniaDBLookupAliasEditGetDataField: String;
    function TypZleceniaDBLookupAliasEditGetQuery: TUNIQuery;
    procedure TypZleceniaDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function TypZleceniaDBLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    procedure SelectButtonClick(Sender: TObject);
    procedure RegulaPanelResize(Sender: TObject);
    procedure SkladowePanelResize(Sender: TObject);
    procedure CheckButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure Slownik0LookupAliasEditButtonClick(Sender: TObject);
    function  Slownik0LookupAliasEditSetData(Sender: TObject;
      AliasSrc: TDataSet): Boolean;
    procedure Slownik0LookupAliasEditDelKey(Sender: TObject);
    procedure SlownikLookupAliasEditButtonClick(Sender: TObject);
    procedure SlownikLookupAliasEditDelKey(Sender: TObject);
    function  SlownikLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure WykorzystajMnemonikDBCheckBoxClick(Sender: TObject);

  private
    FParser:           TZLEParser;
    qMnem:             TUNIQuery;
    vLookupList:       array of TUNILookupAliasEdit2;
    vLabelList:        array of TUNILabel;
    sSkladniki:        String;
    sOgraniczenia:     String;
    iDlugText:         Integer;

    FWarunki :         TZLEWarunekLista;
    cslINFRodzajObiektu_Tmp : TConstStringList;

    {Skladniki}
    FRichEdit1:        TUNISimpleEditorRichEdit;
    FOperationList1:    TUNIStringList;
    Pozycja1 : Integer;
    {Regula}
    FRichEdit2:        TUNISimpleEditorRichEdit;
    FParamKindList2:   TUniStringList;
    FParamValuesList2: TUNIStringList;
    FOperationList2, FFunctionList2: TUNIStringList;
    {DodatkoweOgraniczenia}
    FRichEdit3:        TUNISimpleEditorRichEdit;
    FOperationList3:    TUNIStringList;
    Pozycja3 : Integer;

    procedure LookupButtonClick( Sender: TObject );
    function LookupSetData( Sender: TObject; AliasSrc: TDataSet ): Boolean;
    function LookupCheck( Sender: TObject ): Boolean;
    procedure MyOnExit( Sender: TObject );
    procedure MyDelKey( Sender: TObject );
//    procedure FieldChange( Sender: TObject );
//    procedure Clear();

    { Funkcje dla skladnika }
    function  GetFunctionsList1(const oCurrFunction: TUNIFunction;
                               var   sWholeCurrParam: string;
                               var   sCurrWord: string;
                               const sPrevWord: string;
                               const cSeparator: char;
                               var   sWordToInsert: string;
                               bShowList: boolean): TUNIStringList;
    procedure GetAdditionalHint1(const oCurrFunction: TUNIFunction;
                                const sWholeCurrParam: string;
                                var sAdditionalHint: string);
    function  GetCurrWordHint1 (const asCurrWord: string;
                               const aiCurrWordPos: integer;
                               const aiCurrWordLen: integer): string;

    procedure RichEventOnEnter1(oSender: TObject);
    procedure RichEventOnExit1(oSender: TObject);
    procedure RichEditChange1(Sender: TObject);
    function  CheckRegula1( bBezKomentarzy: Boolean = false): Boolean;
    procedure StworzListy1;
    procedure UsunListy1;

    { Funkcje dla reguly }
    function  GetFunctionsList2(const oCurrFunction: TUNIFunction;
                               var   sWholeCurrParam: string;
                               var   sCurrWord: string;
                               const sPrevWord: string;
                               const cSeparator: char;
                               var   sWordToInsert: string;
                               bShowList: boolean): TUNIStringList;
    procedure GetAdditionalHint2(const oCurrFunction: TUNIFunction;
                                const sWholeCurrParam: string;
                                var sAdditionalHint: string);
    function  GetCurrWordHint2 (const asCurrWord: string;
                               const aiCurrWordPos: integer;
                               const aiCurrWordLen: integer): string;

    procedure RichEventOnEnter2(oSender: TObject);
    procedure RichEventOnExit2(oSender: TObject);
    procedure RichEditChange2(Sender: TObject);
    function CheckRegula2( bBezKomentarzy: Boolean = false): Boolean;
//    procedure GetLastWord2(var sText, sFirstWord: String);
//    function GetMnemonikValuesList2( sText: String ): TUNIQuery;
    function GetList2( sFunctionName, sKind, sText: String;
                      const cSeparator: Char): TUNIStringList;
    procedure CreateFunctionList2;
    procedure CreateParamKindList2;
    procedure StworzListy2;
    procedure UsunListy2;

    { Funkcje dla DodatkoweOgraniczenia }
    function  GetFunctionsList3(const oCurrFunction: TUNIFunction;
                               var   sWholeCurrParam: string;
                               var   sCurrWord: string;
                               const sPrevWord: string;
                               const cSeparator: char;
                               var   sWordToInsert: string;
                               bShowList: boolean): TUNIStringList;
    procedure GetAdditionalHint3(const oCurrFunction: TUNIFunction;
                                const sWholeCurrParam: string;
                                var sAdditionalHint: string);
    function  GetCurrWordHint3 (const asCurrWord: string;
                               const aiCurrWordPos: integer;
                               const aiCurrWordLen: integer): string;

    procedure RichEventOnEnter3(oSender: TObject);
    procedure RichEventOnExit3(oSender: TObject);
    procedure RichEditChange3(Sender: TObject);
    function  CheckRegula3( bBezKomentarzy: Boolean = false): Boolean;
    procedure StworzListy3;
    procedure UsunListy3;

  protected
    function  CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure InternalOpen; override;
    class function ClassIsSingle: boolean; override;
    procedure UstawWlasciwosci1;
    procedure UstawWlasciwosci2;
    procedure UstawWlasciwosci3;
    procedure GetPositionAndParentForContainedForm( const nr:integer ; var APosition: TRect ; var AParent: TWinControl ; var AAlign:TAlign); override;

    //procedure InitializeControls(); virtual;
    procedure InitializeObjectFields(); virtual;
    procedure SetDefaults(); virtual;

  public
    FRegula1: string;
    FRegula2: string;
    FRegula3: string;
    FDlugosc: Integer;

    function Validate: boolean; override;
    procedure SelectButtonPressed; override;
    procedure UstawRegule1(sRegula1: string);
    procedure UstawRegule2(sRegula2: string);
    procedure UstawRegule3(sRegula3: string);
    procedure BeforeShow; override;
    destructor Destroy; override;
    procedure UstawSlowniki();
    procedure WyczyscPanel();
    procedure AktualizujWarunki(iKrytID: Integer);
    function  SprawdzDlugoscMnemonika(Dlugosc: Integer): Boolean;

    property  Regula1 : string read FRegula1 write UstawRegule1;
    property  Regula2 : string read FRegula2 write UstawRegule2;
    property  Regula3 : string read FRegula3 write UstawRegule3;
  end;

var
  ZLEKryteriaDBDetailForm: TZLEKryteriaDBDetailForm;

implementation
uses
  DBTables,
  variants,
  Dodatki,
  UNIDataManagerUnit, {cConditionForGrid, cConditionPosForGrid}
  UNIImageManagerUnit,
  UNISysDefUnit,
  UNISysDataManagerUnit,
  FormManagerUnit,
  UNIDBGridFormUnit,
  SQLManagerUnit,
  UniqueKeyUnit,
  SecurityManagerUnit,
  ZLEDataManagerUnit,
  ZLEKryteriaUnit,
  BKDefUnit,
  BKDataManagerUnit,
  FKDataManagerUnit,
  MFSDefUnit,
  MFSDataManagerUnit,
  MFZDefUnit,
  MFZDataManagerUnit,
  ASODefUnit,
  ASODataManagerExtUnit,
  MAGDefUnit,
  MAGDataManagerExtUnit,
  VATDefUnit,
  PLLIDefUnit,
  FKDefUnit,
  InfDefUnit;

{$R *.DFM}

function TZLEKryteriaDBDetailForm.SprawdzDlugoscMnemonika(Dlugosc: Integer): Boolean;
var iDlug: integer;
    sSQL : String;
    qMnemTmp: TUniQuery;
    iIndex: Integer;
    fSkladniki: TSplit;

begin
   result := True;
   if WykorzystajMnemonikDBCheckBox.Checked then begin
      {zakadamy ze qMnem zawiera odpowiednie zapytanie,
      a wczesniej zostala uruchomiona funkcja CheckRegula1()}

      if FRegula1 <> '' then begin
          iDlug := iDlugText;
          try
            fSkladniki := TSplit.Create(FRegula1, ',', '');
            for iIndex := 0 to fSkladniki.Count - 1 do
            begin
               if copy(Trim(fSkladniki[iIndex]), 1, 1) = '''' then begin
                  Continue; //To ju posumowane
               end else begin
                  sSQL := 'SELECT ' + sFKMNEMONIKI_DLUGOSC + ' ' +
                          'FROM %s ' +
                          'WHERE ' + sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr(Copy(Trim(fSkladniki[iIndex]), 1, 3));

                  if Length(Trim(fSkladniki[iIndex])) > 3 then
                      sSQL :=  sSQL + ' AND ' +
                                 sFKMNEMONIKI_INDEKS  + ' = ' +  Copy(Trim(fSkladniki[iIndex]), 4, 1)
                  else sSQL :=  sSQL + ' AND ' +
                                 sFKMNEMONIKI_INDEKS  + ' = 0';

                  qMnemTmp := SQLManager.CreateQuery(sSQL, [sFKMNEMONIKI]);

                  try
                     qMnemTmp.Open();
                     if not qMnemTmp.IsEmpty then begin
                        iDlug := iDlug + qMnemTmp.FieldByName(sFKMNEMONIKI_DLUGOSC).AsInteger;
                     end;


                  finally
                     if qMnemTmp <> nil then FreeAndNil(qMnemTmp);
                  end;
               end;
            end;
          finally
            FreeAndNil(fSkladniki);
          end;

          (******************* TAK BYO ****************************
          if qMnem <> nil then begin
             sTmp := FRegula1;
             FreeAndNil(qMnem);
             qMnem := ZLEDM.ListaMnemonikow(sTmp);
             qMnem.First;
             while not qMnem.Eof do begin
                iDlug := iDlug + qMnem.FieldByName(sFKMNEMONIKI_DLUGOSC).AsInteger;
                qMnem.Next;
             end;
          end;
          ******************* TAK BYO ****************************)

          if iDlug <> Dlugosc then begin
             Komunikat(cError, 'Bdna dugo mnemonika');
             result := False;
          end;
      end;
   end;

end;

function TZLEKryteriaDBDetailForm.CheckRegula1(bBezKomentarzy: Boolean = false): Boolean;
var
  sZnaki :string;
  iIndex, iIloscSkladnikow : Integer;
  fSkladniki: TSplit;

  function SprawdzApostrofy(sText: String): Boolean;
  var
    k, iIloscApostrofow: Integer;
  begin
    result := False;
    iIloscApostrofow := 0;
    for k := 1 to length(sText) do begin
       if sText[k] = '''' then  Inc(iIloscApostrofow);
    end;

    if ((iIloscApostrofow mod 2) = 0) {and (iIloscApostrofow > 0)} then
        result := True;
  end;

begin
  result := False;
  {Kontrola skadnikw}
  sZnaki := FRichEdit1.Text;
  // sZnaki:= StringReplace( sZnaki,' ','',[rfReplaceAll]);
  sZnaki:= StringReplace( sZnaki,#13,'',[rfReplaceAll]);
  sZnaki:= StringReplace( sZnaki,#10,'',[rfReplaceAll]);
//     sZnaki:= AnsiUpperCase( Args);

  if sZnaki = '' then begin
     Komunikat(cWarning, 'Brak definicji budowy sownika skadnikw');
     Exit;
  end else begin
    try
      iIloscSkladnikow := 0;
      iDlugText := 0;
      fSkladniki := TSplit.Create(sZnaki, ',', '');
      for iIndex := 0 to fSkladniki.Count - 1 do
      begin
         if copy(Trim(fSkladniki[iIndex]), 1, 1) = '''' then begin
           if SprawdzApostrofy(Trim(fSkladniki[iIndex])) then begin
              Inc(iIloscSkladnikow);
              iDlugText := iDlugText + length(Trim(fSkladniki[iIndex])) - 2; {ODEJMUJEMY DWA APOSTROFY}
              Continue;
           end else begin
              Komunikat(cWarning, 'Bdna definicja. Niepoprawna ilo apostrofw');
              iDlugText := 0;
              Exit;
           end;
         end else begin
           Inc(iIloscSkladnikow);
           Continue;
         end;
      end;
      if iIloscSkladnikow <> fSkladniki.Count then begin
         Komunikat(cWarning, 'Bdna definicja. Niepoprawna ilo skadnikw');
         iDlugText := 0;
         Exit;
      end;

    finally
      FreeAndNil(fSkladniki);
    end;

    FRegula1 := sZnaki;
  end;

  result := True;
  if not bBezKomentarzy then Komunikat(cInformation, 'Regua jest poprawna');
end;

procedure TZLEKryteriaDBDetailForm.UstawWlasciwosci1;
var
  rProp: TUNISimpleEditorRichEditProperties;
begin
(*******************************************
  // InitializeFields
  RegulaSimpleEditorRichEdit := TUNISimpleEditorRichEdit.Create( Self );
  with RegulaSimpleEditorRichEdit do begin
    SetFunctions(GetFunctionsList, GetAdditionalHint);
    SetProperties(Self.RichEditPanel, 0, 0, 0, 0, False);
    Align := alClient;
    {??}
    WantReturns := False;
  end;
  if OpenMode in [omView,omDelete] then RegulaSimpleEditorRichEdit.ReadOnly := true;
  CreateFunctionList;
  CreateParamKindList;
  FParamValuesList := TUNIStringList.Create();


  {Regua}
  RegulaSimpleEditorRichEdit.Lines.Clear;
  oSplit := nil;
  try
    oSplit := TSplit.Create( StringReplace( Trim(MAGDM.vMAGTrescRegula),
                                            #10,'',[rfReplaceAll] ), #13, '' );
    for iIndex := 0 to oSplit.Count-1 do begin
      RegulaSimpleEditorRichEdit.Lines.Add(oSplit[iIndex]);
    end;
  finally
    if oSplit <> nil then FreeAndNil(oSplit);
  end;
****************************************)

  ZeroMemory(Addr(rProp), sizeof(rProp));
  rProp.pFun1   := GetFunctionsList1;
  rProp.pFun2   := GetAdditionalHint1;
  rProp.pFun3   := GetCurrWordHint1;
  rProp.oParent := SkladowePanel; //Label.Parent;
  rProp.iTop    := 8; //+20;
  rProp.iLeft   := SkladoweLabel.Left;
  rProp.iWidth  := SkladowePanel.Width - (2 * SkladoweLabel.Left);
  rProp.iHeight := SkladowePanel.Height - 8;// - 20; // TUNIPanel(DekretacjaCenaZeroCheckBox.Parent).Height - 20;// DekretacjaCenaZeroCheckBox.Height*3;
  rProp.bWordWrap := true;
  FRichEdit1 := TUNISimpleEditorRichEdit.Create(self);

  {Skadniki mona edytowa gdy nie ma jeszcze tabeli ani mnemonika utworzonego}
  if (OpenMode <> omNew) then
    FRichEdit1.Enabled := false;
  StworzListy1;
  FRichEdit1.SetProperties(rProp);

  FRichEdit1.TabOrder := 0;
  FRichEdit1.Visible := true;
  FRichEdit1.RealOnEnter := RichEventOnEnter1;
  FRichEdit1.RealOnExit := RichEventOnExit1;
  FRichEdit1.OnChange := RichEditChange1;

  FRichEdit1.Text := DMAQFbN(sZLEKRYTERIA_SKLADNIKI).AsString;
  SkladoweLabel.FocusControl := FRichEdit1;

end;

procedure TZLEKryteriaDBDetailForm.UstawWlasciwosci2;
var
  rProp: TUNISimpleEditorRichEditProperties;
begin
(*******************************************
  // InitializeFields
  RegulaSimpleEditorRichEdit := TUNISimpleEditorRichEdit.Create( Self );
  with RegulaSimpleEditorRichEdit do begin
    SetFunctions(GetFunctionsList, GetAdditionalHint);
    SetProperties(Self.RichEditPanel, 0, 0, 0, 0, False);
    Align := alClient;
    {??}
    WantReturns := False;
  end;
  if OpenMode in [omView,omDelete] then RegulaSimpleEditorRichEdit.ReadOnly := true;
  CreateFunctionList;
  CreateParamKindList;
  FParamValuesList := TUNIStringList.Create();


  {Regua}
  RegulaSimpleEditorRichEdit.Lines.Clear;
  oSplit := nil;
  try
    oSplit := TSplit.Create( StringReplace( Trim(MAGDM.vMAGTrescRegula),
                                            #10,'',[rfReplaceAll] ), #13, '' );
    for iIndex := 0 to oSplit.Count-1 do begin
      RegulaSimpleEditorRichEdit.Lines.Add(oSplit[iIndex]);
    end;
  finally
    if oSplit <> nil then FreeAndNil(oSplit);
  end;
****************************************)

  ZeroMemory(Addr(rProp), sizeof(rProp));
  rProp.pFun1   := GetFunctionsList2;
  rProp.pFun2   := GetAdditionalHint2;
  rProp.pFun3   := GetCurrWordHint2;
  rProp.oParent := RegulaPanel;
  rProp.iTop    := 8; //RegulaLabel.Top+10;
  rProp.iLeft   := 8;
  rProp.iWidth  := RegulaPanel.Width - 16;
  rProp.iHeight := RegulaPanel.Height - 16;
  rProp.bWordWrap := true;
  FRichEdit2 := TUNISimpleEditorRichEdit.Create(self);

  {Skadniki mona edytowa gdy nie ma jeszcze tabeli ani mnemonika utworzonego}
  if not (OpenMode in [omNew, omEdit]) then
    FRichEdit2.Enabled := false;
  StworzListy2;
  FRichEdit2.SetProperties(rProp);

  FRichEdit2.TabOrder := 0;
  FRichEdit2.Visible := true;
  FRichEdit2.RealOnEnter := RichEventOnEnter2;
  FRichEdit2.RealOnExit := RichEventOnExit2;
  FRichEdit2.OnChange := RichEditChange2;

  //FRichEdit2.Text := DMAQFbN(sZLEKRYTERIA_REGULA).AsString;
  //RegulaLabel.FocusControl := FRichEdit2;
end;


function TZLEKryteriaDBDetailForm.CheckRegula3(bBezKomentarzy: Boolean = false): Boolean;
var
  sZnaki :string;
  iIndex, iIloscSkladnikow : Integer;
  fSkladniki: TSplit;

begin
  result := False;
  {Kontrola ogranicze}
  sZnaki := FRichEdit3.Text;
  sZnaki:= StringReplace( sZnaki,#13,'',[rfReplaceAll]);
  sZnaki:= StringReplace( sZnaki,#10,'',[rfReplaceAll]);

  if sZnaki = '' then begin
     result := True;
     Exit;
  end else begin
    try
      iIloscSkladnikow := 0;
      //iDlugText := 0;
      fSkladniki := TSplit.Create(sZnaki, ',', '');
      for iIndex := 0 to fSkladniki.Count - 1 do
      begin
         if copy(Trim(fSkladniki[iIndex]), 1, 1) = '''' then begin
            Komunikat(cWarning, 'Bdna definicja. Mona uywa tylko mnemoniki z listy');
            Exit;
         end else begin
            Inc(iIloscSkladnikow);
            Continue;
         end;
      end;
      if iIloscSkladnikow <> fSkladniki.Count then begin
         Komunikat(cWarning, 'Bdna definicja. Niepoprawna ilo skadnikw');
         Exit;
      end;

    finally
      FreeAndNil(fSkladniki);
    end;

    FRegula3 := sZnaki;
  end;

  result := True;
  if not bBezKomentarzy then Komunikat(cInformation, 'Definicja ogranicze jest poprawna');
end;

procedure TZLEKryteriaDBDetailForm.UstawWlasciwosci3;
var
  rProp: TUNISimpleEditorRichEditProperties;
begin
  ZeroMemory(Addr(rProp), sizeof(rProp));
  rProp.pFun1   := GetFunctionsList3;
  rProp.pFun2   := GetAdditionalHint3;
  rProp.pFun3   := GetCurrWordHint3;
  rProp.oParent := DodatkoweOgraniczeniaPanel; //Label.Parent;
  rProp.iTop    := 8; //+20;
  rProp.iLeft   := SkladoweLabel.Left;
  rProp.iWidth  := SkladowePanel.Width - (2 * SkladoweLabel.Left);
  rProp.iHeight := SkladowePanel.Height - 8;// - 20; // TUNIPanel(DekretacjaCenaZeroCheckBox.Parent).Height - 20;// DekretacjaCenaZeroCheckBox.Height*3;
  rProp.bWordWrap := true;
  FRichEdit3 := TUNISimpleEditorRichEdit.Create(self);

  {if (OpenMode <> omNew) then
    FRichEdit1.Enabled := false;}
  StworzListy3;
  FRichEdit3.SetProperties(rProp);

  FRichEdit3.TabOrder := 0;
  FRichEdit3.Visible := true;
  FRichEdit3.RealOnEnter := RichEventOnEnter3;
  FRichEdit3.RealOnExit := RichEventOnExit3;
  FRichEdit3.OnChange := RichEditChange3;

  FRichEdit3.Text := DMAQFbN(sZLEKRYTERIA_OGRANICZ).AsString;
  //SkladoweLabel.FocusControl := FRichEdit1;

end;


destructor TZLEKryteriaDBDetailForm.Destroy;
begin
  if FParser<>nil then FreeAndNil(FParser);
  if qMnem <> nil then FreeAndNil(qMnem);
  UsunListy1;
  FreeAndNil(FRichEdit1);
  UsunListy2;
  FreeAndNil(FRichEdit2);
  UsunListy3;
  FreeAndNil(FRichEdit3);
  inherited;
end;

function TZLEKryteriaDBDetailForm.Validate: boolean;
begin
  result := inherited validate;

  if (not result) or (OpenMode in [omView, omDelete]) then exit;

  if result then begin
    if (FormatMaskEdit.Text[1] < '1') or (FormatMaskEdit.Text[1] > '9') or
       (FormatMaskEdit.Text[3] < '0') or (FormatMaskEdit.Text[3] > '9') then begin
      result := false;
      FormatMaskEdit.SetFocus;
      Komunikat(cError, 'Bdny format');
    end else begin
      DMAQFbN(sZLEKRYTERIA_FORMAT).AsString := FormatMaskEdit.Text;
      //DMAQFbN(sINFPARAMETR_MASKA).AsString  := DajMaske(FormatMaskEdit.Text);
    end;
  end;

  if not result then exit;

  if (OpenMode = omNew) and WykorzystajMnemonikDBCheckBox.Checked then begin
     if DMAQFbN(sFKMNEMONIKI_ID).IsNull then begin
        Komunikat(cWarning, 'Musisz wybrac sownik');
        if SlownikLookupAliasEdit.Enabled then
           SlownikLookupAliasEdit.SetFocus();
        result := false;
        Exit;
     end;
  end;

  if (OpenMode = omNew) and (not CheckRegula1(True)) then begin
     result := False;
     Exit;
  end;

  if (not CheckRegula2(True)) then begin
     result := False;
     Exit;
  end;

  if {(OpenMode = omNew) and} (not CheckRegula3(True)) then begin
     result := False;
     Exit;
  end;
end;

procedure TZLEKryteriaDBDetailForm.UstawRegule1(sRegula1: string);
begin
  FRegula1 := sRegula1;
  DMAQFbN(sZLEKRYTERIA_SKLADNIKI).AsString := FRegula1;
//  FRichEdit1.Text := Regula1;
end;

procedure TZLEKryteriaDBDetailForm.UstawRegule2(sRegula2: string);
begin
  FRegula2 := sRegula2;
  DMAQFbN(sZLEKRYTERIA_REGULA).AsString := FRegula2;
//  FRichEdit2.Text := Regula2;
end;

procedure TZLEKryteriaDBDetailForm.UstawRegule3(sRegula3: string);
begin
  FRegula3 := sRegula3;
  DMAQFbN(sZLEKRYTERIA_OGRANICZ).AsString := FRegula3;
//  FRichEdit2.Text := Regula2;
end;

procedure TZLEKryteriaDBDetailForm.GetAdditionalHint1(
  const oCurrFunction: TUNIFunction; const sWholeCurrParam: string;
  var sAdditionalHint: string);
begin

end;

function TZLEKryteriaDBDetailForm.GetCurrWordHint1(
  const asCurrWord: string; const aiCurrWordPos,
  aiCurrWordLen: integer): string;
begin

end;

procedure TZLEKryteriaDBDetailForm.RichEditChange1(Sender: TObject);
begin
  FRegula1 := FRichEdit1.Text;
end;

procedure TZLEKryteriaDBDetailForm.RichEventOnEnter1(oSender: TObject);
begin
  SelectButton.Default := false;
  CancelButton.Cancel := false;
  sSkladniki := DMAQFbN(sZLEKRYTERIA_SKLADNIKI).AsString;
end;

procedure TZLEKryteriaDBDetailForm.RichEventOnExit1(oSender: TObject);
begin
  SelectButton.Default := true;
  CancelButton.Cancel := true;
  FRichEdit1.PlainText := true;

  try
    if sSkladniki <> FRichEdit1.Text then begin
      if CheckRegula1(True) then begin
         if WykorzystajMnemonikDBCheckBox.Checked and (not DMAQFbN(sFKMnemoniki_ID).IsNull) then begin
            if SprawdzDlugoscMnemonika(FDlugosc) then UstawRegule1(FRichEdit1.Text);
         end else begin
            UstawRegule1(FRichEdit1.Text);
         end;
      end;
    end;
  finally
    FRichEdit1.PlainText := false;
  end;

  DMAQFbN(sZLEKRYTERIA_SKLADNIKI).AsString := FRegula1;

  if sSkladniki <> DMAQFbN(sZLEKRYTERIA_SKLADNIKI).AsString then
     UstawSlowniki();
end;

procedure TZLEKryteriaDBDetailForm.StworzListy1;
var
  q, q2: TUNIQuery;
  sTmp, sSQL: String;
  bLokal, bZasob, bKlatka, bBrama,
  bBudynek, bNieruchomosc, bWspolnota,
  bRejon, bUlica, bSiecElem:  Boolean;

  iIdx2: Integer;
  sMnem: String;
begin
  FOperationList1 := TUNIStringList.Create;
  {Dostpne mnemoniki do budowy sownika kryterium}
  FOperationList1.AddObject('ZLE', TUNIFunction.Create('ZLE', [''], ''));
  FOperationList1.AddObject('JED', TUNIFunction.Create('JED', [''], ''));
  if vWielofirmowosc then
     FOperationList1.AddObject('FIR', TUNIFunction.Create('FIR', [''], ''));
  if vWieloodzialowosc then
     FOperationList1.AddObject('ODZ', TUNIFunction.Create('ODZ', [''], ''));

   {IF RODZAJ_OBIEKTU = '0'   THEN TABLE_NAME := 'INFLOKAL';
   ELSIF RODZAJ_OBIEKTU = '1' THEN TABLE_NAME := 'INFZASOB';
   ELSIF RODZAJ_OBIEKTU = '2' THEN TABLE_NAME := 'INFKLATKA';
   ELSIF RODZAJ_OBIEKTU = '3' THEN TABLE_NAME := 'INFBRAMA';
   ELSIF RODZAJ_OBIEKTU = '4' THEN TABLE_NAME := 'INFBUDYNEK';
   ELSIF RODZAJ_OBIEKTU = '5' THEN TABLE_NAME := 'INFNIERUCHOMOSC';
   ELSIF RODZAJ_OBIEKTU = '6' THEN TABLE_NAME := 'INFWSPOLNOTA';
   ELSIF RODZAJ_OBIEKTU = '7' THEN TABLE_NAME := 'INFREJON';
   ELSIF RODZAJ_OBIEKTU = '8' THEN TABLE_NAME := 'INFULICA';
   ELSIF RODZAJ_OBIEKTU = '9' THEN TABLE_NAME := 'INFSIECELEMENT';
   ELSIF RODZAJ_OBIEKTU = 'P' THEN TABLE_NAME := 'POZIOM';}

  {Dokadamy mnemoniki infrastruktury}
  bLokal        := False;
  bZasob        := False;
  bKlatka       := False;
  bBrama        := False;
  bBudynek      := False;
  bNieruchomosc := False;
  bWspolnota    := False;
  bRejon        := False;
  bUlica        := False;
  bSiecElem     := False;

  sSQL := 'SELECT DISTINCT ' +
               sZLETYPZLEC_LOKAL_A + ', ' +
               sZLETYPZLEC_ZASOB_A + ', ' +
               sZLETYPZLEC_KLATKA_A + ', ' +
               sZLETYPZLEC_BUDYNEK_A + ', ' +
               sZLETYPZLEC_NIERUCHOMOSC_A + ', ' +
               sZLETYPZLEC_SIECELEMENT_A + ', ' +
               sZLETYPZLEC_ELEMENTINF + ', ' +
               sZLETYPZLEC_POZIOMINF + ' ' +
          'FROM %s ';

  if DMAQFbN(sZLETYPZLEC_ID).AsString <> '' then
     sSQL := sSQL +  'WHERE ' + sZLETYPZLEC_ID + ' = ' + IntToStr(DMAQFBN(sZLETYPZLEC_ID).AsInteger);

  q2 := SQLManager.CreateQuery(sSQL, [sZLETYPZLEC]);

  try
    q2.Open;
    if not q2.IsEmpty then begin
       q2.First;
       while not q2.Eof do begin
         if q2.FieldByName(sZLETYPZLEC_ELEMENTINF).AsString = sTak then begin
            {Jesli jest wlaczone to dokladamy wszystkie dostepne mnemoniki z INF}
            if not bLokal then begin
               sMnem := cslZLE_INFMnemoniki[0];
               bLokal := True;
               iIdx2 := FOperationList1.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end;
            if not bZasob then begin
               sMnem := cslZLE_INFMnemoniki[1];
               bZasob := True;
               iIdx2 := FOperationList1.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end;
            if not bKlatka then begin
               sMnem := cslZLE_INFMnemoniki[2];
               bKlatka := True;
               iIdx2 := FOperationList1.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end;
            if (not bBrama) and (not vInfBramy) then begin
               sMnem := cslZLE_INFMnemoniki[3];
               bBrama := True;
               iIdx2 := FOperationList1.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end;
            if not bBudynek then begin
               sMnem := cslZLE_INFMnemoniki[4];
               bBudynek := True;
               iIdx2 := FOperationList1.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end;
            if not bNieruchomosc then begin
               sMnem := cslZLE_INFMnemoniki[5];
               bNieruchomosc := True;
               iIdx2 := FOperationList1.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end;
            if (not bWspolnota) and (not vWspolnoty) then begin
               sMnem := cslZLE_INFMnemoniki[6];
               bWspolnota := True;
               iIdx2 := FOperationList1.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end;
            if not bRejon then begin
               sMnem := cslZLE_INFMnemoniki[7];
               bRejon := True;
               iIdx2 := FOperationList1.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end;
            if not bUlica then begin
               sMnem := cslZLE_INFMnemoniki[8];
               bUlica := True;
               iIdx2 := FOperationList1.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end;
            if not bSiecElem then begin
               sMnem := cslZLE_INFMnemoniki[9];
               bSiecElem := True;
               iIdx2 := FOperationList1.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end;

            {if q2.FieldByName(sZLETYPZLEC_POZIOMINF).AsString <> '' then begin
               iIdx  := cslZLE_INFMnemoniki.IndexOfSkrot(q2.FieldByName(sZLETYPZLEC_POZIOMINF).AsString);
               if iIdx >= 0 then begin
                  if ((iIdx = 0) and (not bLokal)) then begin
                     sMnem := cslZLE_INFMnemoniki[iIdx];
                     bLokal := True;
                     iIdx2 := FOperationList1.IndexOf(sMnem);
                     if iIdx2 = -1 then
                        FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
                  end else
                  if ((iIdx = 1) and (not bZasob)) then begin
                     sMnem := cslZLE_INFMnemoniki[iIdx];
                     bZasob := True;
                     iIdx2 := FOperationList1.IndexOf(sMnem);
                     if iIdx2 = -1 then
                        FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
                  end else
                  if ((iIdx = 2) and (not bKlatka)) then begin
                     sMnem := cslZLE_INFMnemoniki[iIdx];
                     bKlatka := True;
                     iIdx2 := FOperationList1.IndexOf(sMnem);
                     if iIdx2 = -1 then
                        FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
                  end else
                  if ((iIdx = 3) and (not bBrama)) then begin
                     sMnem := cslZLE_INFMnemoniki[iIdx];
                     bBrama := True;
                     iIdx2 := FOperationList1.IndexOf(sMnem);
                     if iIdx2 = -1 then
                        FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
                  end else
                  if ((iIdx = 4) and (not bBudynek)) then begin
                     sMnem := cslZLE_INFMnemoniki[iIdx];
                     bBudynek := True;
                     iIdx2 := FOperationList1.IndexOf(sMnem);
                     if iIdx2 = -1 then
                        FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
                  end else
                  if ((iIdx = 5) and (not bNieruchomosc)) then begin
                     sMnem := cslZLE_INFMnemoniki[iIdx];
                     bNieruchomosc := True;
                     iIdx2 := FOperationList1.IndexOf(sMnem);
                     if iIdx2 = -1 then
                        FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
                  end else
                  if ((iIdx = 6) and (not bWspolnota)) then begin
                     sMnem := cslZLE_INFMnemoniki[iIdx];
                     bWspolnota := True;
                     iIdx2 := FOperationList1.IndexOf(sMnem);
                     if iIdx2 = -1 then
                        FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
                  end else
                  if ((iIdx = 7) and (not bRejon)) then begin
                     sMnem := cslZLE_INFMnemoniki[iIdx];
                     bRejon := True;
                     iIdx2 := FOperationList1.IndexOf(sMnem);
                     if iIdx2 = -1 then
                        FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
                  end else
                  if ((iIdx = 8) and (not bUlica)) then begin
                     sMnem := cslZLE_INFMnemoniki[iIdx];
                     bUlica := True;
                     iIdx2 := FOperationList1.IndexOf(sMnem);
                     if iIdx2 = -1 then
                        FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
                  end else
                  if ((iIdx = 9) and (not bSiecElem)) then begin
                     sMnem := cslZLE_INFMnemoniki[iIdx];
                     bSiecElem := True;
                     iIdx2 := FOperationList1.IndexOf(sMnem);
                     if iIdx2 = -1 then
                        FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
                  end else
                  if ((iIdx = 10) and (not bPoziom)) then begin
                     sMnem := cslZLE_INFMnemoniki[iIdx];
                     bPoziom := True;
                     iIdx2 := FOperationList1.IndexOf(sMnem);
                     if iIdx2 = -1 then
                        FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
                  end;
               end;
            end; }
         end;

         {Parametry remontow}
         if q2.FieldByName(sZLETYPZLEC_LOKAL_A).AsString <> 'A' then begin
            if not bLokal then begin
               sMnem := cslZLE_INFMnemoniki[0];
               bLokal := True;
               iIdx2 := FOperationList1.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end
         end;

         if q2.FieldByName(sZLETYPZLEC_ZASOB_A).AsString <> 'A' then begin
            if not bZasob then begin
               sMnem := cslZLE_INFMnemoniki[1];
               bZasob := True;
               iIdx2 := FOperationList1.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end
         end;

         if q2.FieldByName(sZLETYPZLEC_KLATKA_A).AsString <> 'A' then begin
            if not bKlatka then begin
               sMnem := cslZLE_INFMnemoniki[2];
               bKlatka := True;
               iIdx2 := FOperationList1.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end
         end;

         if q2.FieldByName(sZLETYPZLEC_BUDYNEK_A).AsString <> 'A' then begin
            if not bBudynek then begin
               sMnem := cslZLE_INFMnemoniki[4];
               bBudynek := True;
               iIdx2 := FOperationList1.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end
         end;

         if q2.FieldByName(sZLETYPZLEC_NIERUCHOMOSC_A).AsString <> 'A' then begin
            if not bNieruchomosc then begin
               sMnem := cslZLE_INFMnemoniki[5];
               bNieruchomosc := True;
               iIdx2 := FOperationList1.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end
         end;

         if q2.FieldByName(sZLETYPZLEC_SIECELEMENT_A).AsString <> 'A' then begin
            if not bSiecElem then begin
               sMnem := cslZLE_INFMnemoniki[9];
               bSiecElem := True;
               iIdx2 := FOperationList1.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end
         end;

         q2.Next;
       end;
    end;
  finally
    if q2 <> nil then FreeAndNil(q2);
  end;

  sTmp := '';
  sSQL :=  'SELECT DISTINCT ' +
              'DEF.' + sFKMNEMONIKI_ID + ', ' +
              'FM.'  + sFKMNEMONIKI_TABELA + ', ' +
              'FM.'  + sFKMNEMONIKI_DLUGOSC + ', ' +
              'FM.'  + sFKMNEMONIKI_MNEMONIK + ' ' +
           'FROM %s DEF, %s FM, %s WSK ' +
           'WHERE ' +
              'WSK.' + sUNIPOLAUZDEF_ID + ' = DEF.' + sUNIPOLAUZDEF_ID + ' AND ' +
              'DEF.' + sFKMNEMONIKI_ID  + ' = FM.'  + sFKMNEMONIKI_ID + ' AND ' +
              'WSK.' + sUNIPOLAUZWSK_FUNK + ' IN (' + QuotedStr(cPolaUZ_ZLEZlecenie) + ', ' + QuotedStr(cPolaUZ_ZLEPozycja) + ') AND ';

  if DMAQFbN(sZLETYPZLEC_ID).AsString <> '' then
     sSQL := sSQL +  'WSK.' + sUNIPOLAUZWSK_FUNKID + ' = ' + IntToStr(DMAQFBN(sZLETYPZLEC_ID).AsInteger) + ' AND ';

  sSQL := sSQL +  'FM.' + sFKMNEMONIKI_INDEKS + ' = 0 ' +
                  'ORDER BY ' + sFKMNEMONIKI_MNEMONIK;

  q := SQLManager.CreateQuery(sSQL, [sUNIPOLAUZDEF, sFKMNEMONIKI, sUNIPOLAUZWSK]);
  try
      q.Open;
      if q <> nil then
         While not q.Eof do begin
            sMnem := q.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString;
            iIdx2 := FOperationList1.IndexOf(sMnem);
            if iIdx2 = -1 then
               FOperationList1.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));

            {FOperationList1.AddObject(q.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString,
                TUNIFunction.Create(q.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString, [''], ''));}
            q.Next;
         end;
  finally
    if q <> nil then FreeAndNil(q);
  end;
end;

procedure TZLEKryteriaDBDetailForm.UsunListy1;
var
  i: integer;
begin
  if FOperationList1 <> nil then begin
    for i:=0 to FOperationList1.Count-1 do begin
      FOperationList1.Objects[i].Free;
    end;
    FreeAndNil(FOperationList1);
  end;
end;

function TZLEKryteriaDBDetailForm.GetFunctionsList1(
  const oCurrFunction: TUNIFunction; var sWholeCurrParam,
  sCurrWord: string; const sPrevWord: string; const cSeparator: char;
  var sWordToInsert: string; bShowList: boolean): TUNIStringList;
begin
  result := nil;
  if oCurrFunction = nil then begin
    result := FOperationList1
  end else if bShowList then begin
    if oCurrFunction <> nil then begin
      result := FOperationList1
    end;  // if oCurrFunction <> nil
  end;
end;

procedure TZLEKryteriaDBDetailForm.GetAdditionalHint2(
  const oCurrFunction: TUNIFunction; const sWholeCurrParam: string;
  var sAdditionalHint: string);
begin

end;

function TZLEKryteriaDBDetailForm.GetCurrWordHint2(
  const asCurrWord: string; const aiCurrWordPos,
  aiCurrWordLen: integer): string;
begin

end;

procedure TZLEKryteriaDBDetailForm.RichEditChange2(Sender: TObject);
var
  sZnaki :string;
begin
  sZnaki := FRichEdit2.Text;
  if (Length(sZnaki) > 1)then begin
    if FRegula2 <> sZnaki then begin
     {if (Length(sZnaki)-Length(FRegula))=1 then begin
       if sZnaki[Length(sZnaki)]=' ' then begin
         sZnaki := Copy(sZnaki, 1, Length(sZnaki)-1);
         FRichEdit.Text := sZnaki;
       end else
         if not (sZnaki[Length(sZnaki)] in ['+']) then begin
           sZnaki := Copy(sZnaki, 1, Length(sZnaki)-1);
           FRichEdit.Text := sZnaki;
           Komunikat(cWarning, 'Zy operator, moliwe operatory to +');
         end;
     end;}
     FRegula2 := sZnaki;
    end;
  end;
end;

procedure TZLEKryteriaDBDetailForm.RichEventOnEnter2(oSender: TObject);
begin
  SelectButton.Default := false;
  CancelButton.Cancel := false;
end;

procedure TZLEKryteriaDBDetailForm.RichEventOnExit2(oSender: TObject);
begin
  SelectButton.Default := true;
  CancelButton.Cancel := true;
  FRichEdit2.PlainText := true;

  try
    if FRegula2 <> FRichEdit2.Text then
      UstawRegule2(FRichEdit2.Text);
  finally
    FRichEdit2.PlainText := false;
  end;

  DMAQFbN(sZLEKRYTERIA_REGULA).AsString := FRegula2;
end;

procedure TZLEKryteriaDBDetailForm.StworzListy2;
begin
  FOperationList2 := TUNIStringList.Create;
  if FParamValuesList2<>nil then FreeAndNil(FParamValuesList2);
  if FParamKindList2<>nil   then FreeAndNil(FParamKindList2);
  CreateFunctionList2;
  CreateParamKindList2;
  FParamValuesList2 := TUNIStringList.Create();;
end;

procedure TZLEKryteriaDBDetailForm.UsunListy2;
var
  i: integer;
begin
  if FOperationList2 <> nil then begin
    for i:=0 to FOperationList2.Count-1 do begin
      FOperationList2.Objects[i].Free;
    end;
    FreeAndNil(FOperationList2);
  end;
  if FParamValuesList2<>nil then FreeAndNil(FParamValuesList2);
  if FParamKindList2<>nil then FreeAndNil(FParamKindList2);
end;

procedure TZLEKryteriaDBDetailForm.GetAdditionalHint3(
  const oCurrFunction: TUNIFunction; const sWholeCurrParam: string;
  var sAdditionalHint: string);
begin

end;

function TZLEKryteriaDBDetailForm.GetCurrWordHint3(
  const asCurrWord: string; const aiCurrWordPos,
  aiCurrWordLen: integer): string;
begin

end;

procedure TZLEKryteriaDBDetailForm.RichEditChange3(Sender: TObject);
begin
  FRegula3 := FRichEdit3.Text;
end;

procedure TZLEKryteriaDBDetailForm.RichEventOnEnter3(oSender: TObject);
begin
  SelectButton.Default := false;
  CancelButton.Cancel := false;
  sOgraniczenia := DMAQFbN(sZLEKRYTERIA_OGRANICZ).AsString;
end;

procedure TZLEKryteriaDBDetailForm.RichEventOnExit3(oSender: TObject);
begin
  SelectButton.Default := true;
  CancelButton.Cancel := true;
  FRichEdit3.PlainText := true;

  try
    if sOgraniczenia <> FRichEdit3.Text then begin
      if CheckRegula3(True) then begin
         UstawRegule3(FRichEdit3.Text);
      end;
    end;
  finally
    FRichEdit3.PlainText := false;
  end;

  DMAQFbN(sZLEKRYTERIA_OGRANICZ).AsString := FRegula3;

  if sOgraniczenia <> DMAQFbN(sZLEKRYTERIA_OGRANICZ).AsString then
     UstawSlowniki();
end;

procedure TZLEKryteriaDBDetailForm.StworzListy3;
var
  q2: TUNIQuery;
  sSQL: String;
  bLokal, bZasob, bKlatka, bBrama,
  bBudynek, bNieruchomosc, bWspolnota,
  bRejon, bUlica, bSiecElem: Boolean;

  iIdx2: Integer;
  sMnem: String;
begin
  FOperationList3 := TUNIStringList.Create;
  {Dostpne mnemoniki do budowy sownika kryterium}
  (***********************************************************
  FOperationList3.AddObject('ZLE', TUNIFunction.Create('ZLE', [''], ''));
  if vWielofirmowosc then
     FOperationList3.AddObject('FIR', TUNIFunction.Create('FIR', [''], ''));
  if vWieloodzialowosc then
     FOperationList3.AddObject('ODZ', TUNIFunction.Create('ODZ', [''], ''));
  *************************************************************)

   {IF RODZAJ_OBIEKTU = '0'   THEN TABLE_NAME := 'INFLOKAL';
   ELSIF RODZAJ_OBIEKTU = '1' THEN TABLE_NAME := 'INFZASOB';
   ELSIF RODZAJ_OBIEKTU = '2' THEN TABLE_NAME := 'INFKLATKA';
   ELSIF RODZAJ_OBIEKTU = '3' THEN TABLE_NAME := 'INFBRAMA';
   ELSIF RODZAJ_OBIEKTU = '4' THEN TABLE_NAME := 'INFBUDYNEK';
   ELSIF RODZAJ_OBIEKTU = '5' THEN TABLE_NAME := 'INFNIERUCHOMOSC';
   ELSIF RODZAJ_OBIEKTU = '6' THEN TABLE_NAME := 'INFWSPOLNOTA';
   ELSIF RODZAJ_OBIEKTU = '7' THEN TABLE_NAME := 'INFREJON';
   ELSIF RODZAJ_OBIEKTU = '8' THEN TABLE_NAME := 'INFULICA';
   ELSIF RODZAJ_OBIEKTU = '9' THEN TABLE_NAME := 'INFSIECELEMENT';
   ELSIF RODZAJ_OBIEKTU = 'P' THEN TABLE_NAME := 'POZIOM';}

  {Dokadamy mnemoniki infrastruktury}
  bLokal        := False;
  bZasob        := False;
  bKlatka       := False;
  bBrama        := False;
  bBudynek      := False;
  bNieruchomosc := False;
  bWspolnota    := False;
  bRejon        := False;
  bUlica        := False;
  bSiecElem     := False;

  sSQL := 'SELECT DISTINCT ' +
               sZLETYPZLEC_LOKAL_A + ', ' +
               sZLETYPZLEC_ZASOB_A + ', ' +
               sZLETYPZLEC_KLATKA_A + ', ' +
               sZLETYPZLEC_BUDYNEK_A + ', ' +
               sZLETYPZLEC_NIERUCHOMOSC_A + ', ' +
               sZLETYPZLEC_SIECELEMENT_A + ', ' +
               sZLETYPZLEC_ELEMENTINF + ', ' +
               sZLETYPZLEC_POZIOMINF + ' ' +
          'FROM %s ';

  if DMAQFbN(sZLETYPZLEC_ID).AsString <> '' then
     sSQL := sSQL +  'WHERE ' + sZLETYPZLEC_ID + ' = ' + IntToStr(DMAQFBN(sZLETYPZLEC_ID).AsInteger);

  q2 := SQLManager.CreateQuery(sSQL, [sZLETYPZLEC]);

  try
    q2.Open;
    if not q2.IsEmpty then begin
       q2.First;
       while not q2.Eof do begin
         if q2.FieldByName(sZLETYPZLEC_ELEMENTINF).AsString = sTak then begin
            {Jesli jest wlaczone to dokladamy wszystkie dostepne mnemoniki z INF}
            if not bLokal then begin
               sMnem := cslZLE_INFMnemoniki[0];
               bLokal := True;
               iIdx2 := FOperationList3.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList3.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end;
            if not bZasob then begin
               sMnem := cslZLE_INFMnemoniki[1];
               bZasob := True;
               iIdx2 := FOperationList3.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList3.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end;
            if not bKlatka then begin
               sMnem := cslZLE_INFMnemoniki[2];
               bKlatka := True;
               iIdx2 := FOperationList3.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList3.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end;
            if (not bBrama) and (not vInfBramy) then begin
               sMnem := cslZLE_INFMnemoniki[3];
               bBrama := True;
               iIdx2 := FOperationList3.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList3.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end;
            if not bBudynek then begin
               sMnem := cslZLE_INFMnemoniki[4];
               bBudynek := True;
               iIdx2 := FOperationList3.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList3.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end;
            if not bNieruchomosc then begin
               sMnem := cslZLE_INFMnemoniki[5];
               bNieruchomosc := True;
               iIdx2 := FOperationList3.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList3.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end;
            if (not bWspolnota) and (not vWspolnoty) then begin
               sMnem := cslZLE_INFMnemoniki[6];
               bWspolnota := True;
               iIdx2 := FOperationList3.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList3.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end;
            if not bRejon then begin
               sMnem := cslZLE_INFMnemoniki[7];
               bRejon := True;
               iIdx2 := FOperationList3.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList3.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end;
            if not bUlica then begin
               sMnem := cslZLE_INFMnemoniki[8];
               bUlica := True;
               iIdx2 := FOperationList3.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList3.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end;
            if not bSiecElem then begin
               sMnem := cslZLE_INFMnemoniki[9];
               bSiecElem := True;
               iIdx2 := FOperationList3.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList3.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end;
         end;

         {Parametry remontow}
         if q2.FieldByName(sZLETYPZLEC_LOKAL_A).AsString <> 'A' then begin
            if not bLokal then begin
               sMnem := cslZLE_INFMnemoniki[0];
               bLokal := True;
               iIdx2 := FOperationList3.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList3.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end
         end;

         if q2.FieldByName(sZLETYPZLEC_ZASOB_A).AsString <> 'A' then begin
            if not bZasob then begin
               sMnem := cslZLE_INFMnemoniki[1];
               bZasob := True;
               iIdx2 := FOperationList3.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList3.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end
         end;

         if q2.FieldByName(sZLETYPZLEC_KLATKA_A).AsString <> 'A' then begin
            if not bKlatka then begin
               sMnem := cslZLE_INFMnemoniki[2];
               bKlatka := True;
               iIdx2 := FOperationList3.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList3.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end
         end;

         if q2.FieldByName(sZLETYPZLEC_BUDYNEK_A).AsString <> 'A' then begin
            if not bBudynek then begin
               sMnem := cslZLE_INFMnemoniki[4];
               bBudynek := True;
               iIdx2 := FOperationList3.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList3.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end
         end;

         if q2.FieldByName(sZLETYPZLEC_NIERUCHOMOSC_A).AsString <> 'A' then begin
            if not bNieruchomosc then begin
               sMnem := cslZLE_INFMnemoniki[5];
               bNieruchomosc := True;
               iIdx2 := FOperationList3.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList3.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end
         end;

         if q2.FieldByName(sZLETYPZLEC_SIECELEMENT_A).AsString <> 'A' then begin
            if not bSiecElem then begin
               sMnem := cslZLE_INFMnemoniki[9];
               bSiecElem := True;
               iIdx2 := FOperationList3.IndexOf(sMnem);
               if iIdx2 = -1 then
                  FOperationList3.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));
            end
         end;

         q2.Next;
       end;
    end;
  finally
    if q2 <> nil then FreeAndNil(q2);
  end;

  (***********************************************************
  {------------  Na razie bez pl uytkownika  --------------}
  
  sTmp := '';
  sSQL :=  'SELECT DISTINCT ' +
              'ZMD.' + sFKMNEMONIKI_ID + ', ' +
              'FM.'  + sFKMNEMONIKI_TABELA + ', ' +
              'FM.'  + sFKMNEMONIKI_DLUGOSC + ', ' +
              'FM.'  + sFKMNEMONIKI_MNEMONIK + ' ' +
           'FROM %s ZMD, %s FM, %s ZT, %s ZW ' +
           'WHERE ZMD.' + sFKMNEMONIKI_ID + ' = FM.' + sFKMNEMONIKI_ID + ' AND ' +
                 'ZW.' + sZLETYPZLEC_ID + ' = ZT.' + sZLETYPZLEC_ID + ' AND ' +
                 'ZMD.' + sZLEPOLAZMDEF_ID + ' = ZW.' + sZLEPOLAZMDEF_ID + ' AND ';

  if DMAQFbN(sZLETYPZLEC_ID).AsString <> '' then
     sSQL := sSQL +  'ZT.' + sZLETYPZLEC_ID + ' = ' + IntToStr(DMAQFBN(sZLETYPZLEC_ID).AsInteger) + ' AND ';

  sSQL := sSQL +  'FM.' + sFKMNEMONIKI_INDEKS + ' = 0 ' +
                  'ORDER BY ' + sFKMNEMONIKI_MNEMONIK;

  q := SQLManager.CreateQuery(sSQL, [sZLEPOLAZMDEF, sFKMNEMONIKI, sZLETYPZLEC, sZLEPOLAZMWSK]);
  try
      q.Open;
      if q <> nil then
         While not q.Eof do begin
            sMnem := q.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString;
            iIdx2 := FOperationList3.IndexOf(sMnem);
            if iIdx2 = -1 then
               FOperationList3.AddObject(sMnem, TUNIFunction.Create(sMnem, [''], ''));

            {FOperationList1.AddObject(q.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString,
                TUNIFunction.Create(q.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString, [''], ''));}
            q.Next;
         end;
  finally
    if q <> nil then FreeAndNil(q);
  end;
  ***************************************)
end;


procedure TZLEKryteriaDBDetailForm.UsunListy3;
var
  i: integer;
begin
  if FOperationList3 <> nil then begin
    for i:=0 to FOperationList3.Count-1 do begin
      FOperationList3.Objects[i].Free;
    end;
    FreeAndNil(FOperationList3);
  end;
end;

function TZLEKryteriaDBDetailForm.GetFunctionsList3(
  const oCurrFunction: TUNIFunction; var sWholeCurrParam,
  sCurrWord: string; const sPrevWord: string; const cSeparator: char;
  var sWordToInsert: string; bShowList: boolean): TUNIStringList;
begin
  result := nil;
  if oCurrFunction = nil then begin
    result := FOperationList3
  end else if bShowList then begin
    if oCurrFunction <> nil then begin
      result := FOperationList3
    end;  // if oCurrFunction <> nil
  end;
end;

procedure TZLEKryteriaDBDetailForm.GetPositionAndParentForContainedForm(
  const nr: integer; var APosition: TRect; var AParent: TWinControl;
  var AAlign: TAlign);
begin
  inherited;
  case nr of
    0: begin
         AParent   := SkladowePanel;
         APosition := SkladowePanel.ClientRect;
         AAlign    := alClient;
       end;
    1: begin
         AParent   := RegulaPanel;
         APosition := RegulaPanel.ClientRect;
         AAlign    := alClient;
       end;
    2: begin
         AParent   := DodatkoweOgraniczeniaPanel;
         APosition := DodatkoweOgraniczeniaPanel.ClientRect;
         AAlign    := alClient;
       end;
  end;
end;

function  TZLEKryteriaDBDetailForm.CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLEKryteriaDataModule.CreateOpen(self, DefaultMasterKeyValues, AOpenMode);
end;

procedure TZLEKryteriaDBDetailForm.InternalOpen;
var oSplit: TSplit;
    iIndex: Integer;
begin
  //InitializeControls();
  FWarunki := TZLEWarunekLista.Create();
  InitializeObjectFields();

  if Parameters <> nil then
     if Parameters.Values[cFORM_CAPTION] <> '' then
        Caption := Parameters.Values[cFORM_CAPTION];

  qMnem := nil;
  SetLength(vLookupList, 0);
  SetLength(vLabelList, 0);

  if DataManagers.Available(sINFModulID) then begin
    with PoziomINFDBConstComboBox do begin
      DataField := sINFCONST_OBIEKT_ID;

      {Items.Add('<Nie wybrany>');
      for i := 0 to cslINFRodzajObiektu.Count -1 do begin
        Items.Add(cslINFRodzajObiektu[i]);
      end;}
      cslINFRodzajObiektu_Tmp := TConstStringList.Create();
      with cslINFRodzajObiektu_Tmp do begin
        Add( ' ', '');
        Add( sINFCONST_OBIEKT_LOKAL_TEXT, sINFCONST_OBIEKT_LOKAL );
        Add( sINFCONST_OBIEKT_ZASOB_TEXT, sINFCONST_OBIEKT_ZASOB );
        Add( sINFCONST_OBIEKT_KLATKA_TEXT, sINFCONST_OBIEKT_KLATKA );
        if vInfBramy then
           Add( sINFCONST_OBIEKT_BRAMA_TEXT, sINFCONST_OBIEKT_BRAMA );
        Add( sINFCONST_OBIEKT_BUDYNEK_TEXT, sINFCONST_OBIEKT_BUDYNEK );
        Add( sINFCONST_OBIEKT_NIERUCHOMOSC_TEXT, sINFCONST_OBIEKT_NIERUCHOMOSC );
        if vWspolnoty then
           Add( sINFCONST_OBIEKT_WSPOLNOTA_TEXT, sINFCONST_OBIEKT_WSPOLNOTA );
        Add( sINFCONST_OBIEKT_REJON_TEXT, sINFCONST_OBIEKT_REJON );
        Add( sINFCONST_OBIEKT_ULICA_TEXT, sINFCONST_OBIEKT_ULICA );
        Add( sINFCONST_OBIEKT_ELEMENTSIECI_TEXT, sINFCONST_OBIEKT_ELEMENTSIECI );
        Add( sINFCONST_OBIEKT_POZIOM_TEXT, sINFCONST_OBIEKT_POZIOM );
      end;

      Items.Assign( cslINFRodzajObiektu_Tmp);
      {//Items.Add(sINFCONST_STATUS_MIASTO);
      //Items.Add(sINFCONST_STATUS_WOJEWODZTWO);
      if not vInfBramy then
        Items.Delete( Items.IndexOf( sINFCONST_OBIEKT_BRAMA_TEXT ));
      if not vWspolnoty then
        Items.Delete( Items.IndexOf( sINFCONST_OBIEKT_WSPOLNOTA_TEXT ));}
    end;
  end else begin
    //ElementINFDBCheckBox.Enabled := False;
    PoziomINFLabel.Enabled := False;
    PoziomINFDBConstComboBox.Enabled := False;
  end;

  inherited;

  //ustawienie wartoi domylnych
  if OpenMode = omNew then SetDefaults();

  if OpenMode <> omNew then begin
      if DMAQFbN(sZLEKRYTERIA_REGULA).AsString = '' then
         DMAQFbN(sZLEKRYTERIA_REGULA).AsString := 'result := ';
  end;

  //wczytanie reguy z pola
  FRichEdit2.Lines.Clear;
  //nie korzystamy z RegulaSimpleEditorRichEdit.Lines.Text, poniewa
  //przy zastosowaniu tej metody wystpuj wycieki pamici (Delphi bug)
  oSplit := nil;
  try
    oSplit := TSplit.Create( StringReplace( Trim(DMAQFbN(sZLEKRYTERIA_REGULA).AsString),
                                            #10,'',[rfReplaceAll] ), #13, '' );
    for iIndex := 0 to oSplit.Count-1 do begin
      FRichEdit2.Lines.Add(oSplit[iIndex]);
    end;
  finally
    if oSplit <> nil then oSplit.Free;
  end;
end;

class function TZLEKryteriaDBDetailForm.ClassIsSingle: boolean;
begin
  result := true;
end;

procedure TZLEKryteriaDBDetailForm.BeforeShow;
var
  sMnemonik: String;
  q: TUNIQuery;
begin
  inherited;
  FormatMaskEdit.EditMask := '9' + DecimalSeparator + '9;1;_';
  if OpenMode <> omNew then
       FormatMaskEdit.Text := DMAQFbN(sZLEKRYTERIA_FORMAT).AsString
  else FormatMaskEdit.Clear;

  Pozycja1   := 0;
  UstawWlasciwosci1;
  FRichEdit1.TabOrder := 0;
//  Pozycja2  := 0;
//  UstawWlasciwosci2;
//  FRichEdit2.TabOrder := 0;
  Pozycja3   := 0;
  UstawWlasciwosci3;
  FRichEdit3.TabOrder := 0;

  {Widocznosc pol}
  if OpenMode <> omNew then begin
     q := SQLManager.CreateQuery('SELECT * FROM %s ' +
                                 'WHERE ' + sFKMNEMONIKI_ID + '=' + DMAQFbN(sFKMNEMONIKI_ID).AsString + ' AND ' +
                                            sFKMNEMONIKI_INDEKS + '= 0',
                                 [sFKMNEMONIKI]);
     try
        q.Open;
        if not q.IsEmpty then begin
           if DMAQFbN(sZLEKRYTERIA_ISTN_MNEMONIK).AsString = sTak then
              SlownikLookupAliasEdit.InitiateData(DMAQFbN(sFKMNEMONIKI_ID).AsInteger);
           sMnemonik := q.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString;
           MnemonikEdit.Text := sMnemonik;
           TabelaEdit.Text := sZLEModulID + sMnemonik;
        end;
     finally
        if q <> nil then FreeAndNil(q);
     end;

     SymbolDBEdit.Enabled := False;
     TypZleceniaDBLookupAliasEdit.Enabled := False;
     KryteriaOkresoweDBCheckBox.Enabled := False;
  end else begin
     TypZleceniaDBLookupAliasEdit.aAllowEmpty := not (ZLEDM.vZLEPoziomNarzutowTypZlec and ZLEDM.vZLENarzuty);

     KryteriaOkresoweDBCheckBox.Checked := True;
     DMAQFbN(sZLEKRYTERIA_ISTN_MNEMONIK).AsString := sNie;
     WykorzystajMnemonikDBCheckBox.Enabled := True;
     WykorzystajMnemonikDBCheckBox.Checked := False;
     SlownikLookupAliasEdit.Text := '';

     sMnemonik := ZLEDM.ZlePodajNastepnyMnemonik();
     MnemonikEdit.Text := sMnemonik;
     TabelaEdit.Text := sZLEModulID + sMnemonik;
  end;

  sSkladniki := '';
  sOgraniczenia := '';
  if OpenMode <> omNew then UstawSlowniki();
end;

procedure TZLEKryteriaDBDetailForm.LookupButtonClick;
var oQuery: TUNIQuery;
    oSelectedID: TStringList;
    vWarunekItem: TZLEWarunek;
begin
  oQuery := nil;
  oSelectedId := nil;
  vWarunekItem := FWarunki.GetItemByValue((Sender as TUNILookupAliasEdit2).Tag {FKMnemoniki_ID});
  if vWarunekItem <> nil then begin
     oSelectedId := TStringList.Create;
     oSelectedId.CommaText := vWarunekItem.ListaID;
  end;

  try
    if qMnem.Locate(sFKMNEMONIKI_ID, (Sender as TUNILookupAliasEdit2).Tag {sFKMNEMONIKI_ID}, []) then begin
      if qMnem.FieldByName(sFKMNEMONIKI_TABELA).AsString = sFKUZ then
        oQuery := UNISysDM.FKPokazIObsluzPozycjeSlownikaUzytkownika(
                                 qMnem.FieldByName(sFKMNEMONIKI_ID).AsString, {sTabela}
                                 '',   {sWarunek}
                                 False, {bBlok}
                                 True {bWyborWielu},
                                 sFKALIAS_SlUzytkownikaID+';'+
                                 sFKALIAS_SlUzytkownikaSymbol+';'+
                                 sFKALIAS_SlUzytkownikaNazwa, {sAtrybuty}
                                 UNISYSDM.vAktywnaFirma,
                                 ''{sPole},
                                 oSelectedID,
                                 0 {iPozycjonowanie} )
      else
        oQuery := UNISysDM.UNIPokazIObsluzSlownik(
                                 '',
                                 '',
                                 qMnem.FieldByName(sFKMNEMONIKI_ID).AsInteger,
                                 0,
                                 0,
                                 True {bWyborWielu},
                                 oSelectedID);
        {function TUniSysDataManager.UNIPokazIObsluzSlownik(sAtrybuty, sMnemonik: String;
          iMnemonikID: integer = 0; Indeks: integer=0; iPozycjonowanie: Integer = 0;
          bWyborWielu: boolean = false; a_oSelectedId: TStringList = nil): TUNIQuery;}
      LookupSetData( Sender, oQuery );
    end;
  finally
    if oQuery <> nil then FreeAndNil(oQuery);
  end;
end;

function TZLEKryteriaDBDetailForm.LookupSetData( Sender: TObject; AliasSrc: TDataSet ): Boolean;
var
    sTabela, sTmp: String;
    vWarunekItem: TZLEWarunek;
begin
  if (AliasSrc <> nil) and (Sender is TUNILookupAliasEdit2) then begin
    if qMnem.Locate(sFKMNEMONIKI_ID, (Sender as TUNILookupAliasEdit2).Tag {sFKMNEMONIKI_ID}, []) then begin
        sTabela := qMnem.FieldByName(sFKMNEMONIKI_TABELA).AsString;
        {if sTabela = sFKUZ then
           DataSource.DataSet.FieldByName( sFKUZ_ID ).AsInteger := AliasSrc.FieldByName( sFKUZ_ID ).AsInteger
        else
           DataSource.DataSet.FieldByName( sZLEPolaZM_Wart ).AsString := AliasSrc.FieldByName( sTabela+'_SYMBOL' ).AsString;}


        if AliasSrc.RecordCount > 1 then begin
           (Sender as TUNILookupAliasEdit2).Text := 'Wybrano ' + IntToStr(AliasSrc.RecordCount) + ' pozycji';
           sTmp := '';
           AliasSrc.First;
           while not AliasSrc.Eof do begin
              if sTmp <> '' then sTmp := sTmp + ',';
              sTmp := sTmp + AliasSrc.FieldByName(sTabela + '_ID').AsString;
              AliasSrc.Next;
           end;
        end else begin
           (Sender as TUNILookupAliasEdit2).Text := AliasSrc.FieldByName( sTabela+'_SYMBOL' ).AsString;
           sTmp := AliasSrc.FieldByName(sTabela + '_ID').AsString;
        end;

        vWarunekItem := FWarunki.GetItemByValue(qMnem.FieldByName(sFKMNEMONIKI_ID).AsInteger);
        if vWarunekItem = nil then begin
           vWarunekItem := FWarunki.Add;
           vWarunekItem.FKMnemonikiID := qMnem.FieldByName(sFKMNEMONIKI_ID).AsInteger;
        end;

        vWarunekItem.ListaID := sTmp;

        {par := TWinControl(Sender).Parent;
        for i:=0 to par.ControlCount -1 do begin
            if (par.Controls[i] is TLabel) and (TLabel(par.Controls[i]).Tag = 1 ) then
                TLabel(par.Controls[i]).Caption := AliasSrc.FieldByName(sTabela+'_Nazwa').AsString;
        end; }
    end;
  end;
  result  := true;
end;

procedure TZLEKryteriaDBDetailForm.MyOnExit(Sender: TObject);
begin
(***
  if not bPozycja then
    (DataSource.DataSet as TVirtualDataSet).FieldByName(sZLEPolaZM_Wart).AsString := (Sender as TUNILookupAliasEdit2).Text
  else DataSource.DataSet.FieldByName(sZLEPolaZM_Wart).AsString := (Sender as TUNILookupAliasEdit2).Text;
***)
end;

procedure TZLEKryteriaDBDetailForm.MyDelKey(Sender: TObject);
var
  vWarunekItem: TZLEWarunek;

begin
  if (Sender is TUNILookupAliasEdit2) then begin
     vWarunekItem := FWarunki.GetItemByValue((Sender as TUNILookupAliasEdit2).Tag {FKMnemoniki_ID});
     if vWarunekItem <> nil then vWarunekItem.ListaID := '';
     (Sender as TUNILookupAliasEdit2).Text := '';
  end;
end;

function TZLEKryteriaDBDetailForm.LookupCheck( Sender: TObject ): Boolean;
begin
//  result := False;
(***
  if Length((Sender as TUNILookupAliasEdit2).Text) > 0 then begin
    sTabela := DataSource.DataSet.FieldByName(sFKMNEMONIKI_TABELA).AsString;
    if sTabela = '' then Exit;
    sSQL := 'select * from %s tab '+
            'where tab.'+sTabela+'_SYMBOL'+' = '+QuotedStr((Sender as TUNILookupAliasEdit2).Text);
    try
      oQuery := TUNIQuery.Create(nil);
      SQLManager.OpenQuery( oQuery, sSQL, [sTabela] );
      LookupSetData( Sender, oQuery );
      if not oQuery.IsEmpty then result := True;
    finally
      if oQuery <> nil then oQuery.Free;
    end;
  end else
    result := True;
**************)
  result := True;
end;

procedure TZLEKryteriaDBDetailForm.WyczyscPanel();
var
  k: Integer;
begin
  for k := 0 to Length(vLookupList) - 1 do
      vLookupList[k].Free;

  for k := 0 to Length(vLabelList) - 1 do
      vLabelList[k].Free;

  SetLength(vLookupList, 0);
  SetLength(vLabelList, 0);

  //Wyczyszczenie listy warunkw
  FWarunki.Clear();
end;

procedure TZLEKryteriaDBDetailForm.UstawSlowniki();
var
  sListaMnem: String;
  vLookup: TUNILookupAliasEdit2;
  vLabel: TUNIlabel;
  ii, k, iPrzec: Integer;
  qWar, qSymbol: TUNIQuery;
  vWarunekItem: TZLEWarunek;
begin
  if qMnem <> nil then FreeAndNil(qMnem);
  sListaMnem := DMAQFbN(sZLEKRYTERIA_SKLADNIKI).AsString;

  if sListaMnem <> '' then sListaMnem := sListaMnem + ',' +  DMAQFbN(sZLEKRYTERIA_OGRANICZ).AsString
  else sListaMnem :=  DMAQFbN(sZLEKRYTERIA_OGRANICZ).AsString;


  if (sListaMnem = '') or (sSkladniki <> sListaMnem) or (sOgraniczenia <> sListaMnem) then begin
     WyczyscPanel;
     //Exit;
  end;

  qMnem := ZLEDM.ListaMnemonikow(sListaMnem);
  if qMnem = nil then Exit;

  {Odczyt warunkw z tabeli ZLEKRYTERIAWAR}
  if DMAQFbN(sZLEKRYTERIA_ID).AsInteger > 0 then begin
      qWar := SQLManager.CreateQuery('SELECT * FROM %s ' +
                                     'WHERE ' + sZLEKRYTERIA_ID + '=' + DMAQFbN(sZLEKRYTERIA_ID).AsString,
                                     [sZLEKRYTERIAWAR]);

      try
        qWar.Open;
        if not qWar.IsEmpty then begin
           while not qWar.Eof do begin
              //vWarunkiID.Add(sFKMNEMONIKI_ID + '=' + qWar.FieldByName(sFKMNEMONIKI_ID).AsString);
              //vWarunkiSymbol.Add(sZLEKRYTERIAWAR_LISTA_ID + qWar.FieldByName(sFKMNEMONIKI_ID).AsString + '=' + qWar.FieldByName(sZLEKRYTERIAWAR_LISTA_ID).AsString);
              vWarunekItem := FWarunki.Add;
              vWarunekItem.FKMnemonikiID := qWar.FieldByName(sFKMNEMONIKI_ID).AsInteger;
              vWarunekItem.ListaID := qWar.FieldByName(sZLEKRYTERIAWAR_LISTA_ID).AsString;

              qWar.Next;
           end;
        end;

      finally
        if qWar <> nil then FreeAndNil(qWar);
      end;
  end;

  qMnem.First;
  k := 0;
  while not qMnem.Eof do begin
     SetLength(vLookupList, k + 1);
     SetLength(vLabelList, k + 1);
     vLookup := TUNILookupAliasEdit2.Create(Self);
     vLabel := TUNILabel.Create(Self);

     vLabelList[k]  := vLabel;
     vLabel.Parent  := Slownik0Label.Parent;
     vLabel.Left    := Slownik0Label.Left;
     vLabel.Top     := Slownik0Label.Top + (30 * k);
     vLabel.Width   := Slownik0Label.Width;
     vLabel.Height  := Slownik0Label.Height;
     vLabel.Caption := qMnem.FieldByName(sFKMnemoniki_Nazwa).AsString;
     vLabel.Visible := True;


     vLookupList[k] := vLookup;
     vLookup.Parent := Slownik0LookupAliasEdit.Parent;
     vLookup.Left   := Slownik0LookupAliasEdit.Left;
     vLookup.Top    := Slownik0LookupAliasEdit.Top + (30 * k);
     vLookup.Width  := Slownik0LookupAliasEdit.Width;
     vLookup.Height := Slownik0LookupAliasEdit.Height;
     vLookup.Tag := qMnem.FieldByName(sFKMNEMONIKI_ID).AsInteger;
     vLookup.aAllowText := qMnem.FieldByName(sFKMnemoniki_Nazwa).AsString;
     //vLookup.aReadOnly := Self.ReadOnly;
      if qMnem.FieldByName(sFKMNEMONIKI_TABELA).AsString = sFKUZ then begin
        vLookup.AliasManager         := UniSysDM.AliasManager;
        vLookup.Alias_ID             := sFKALIAS_SlUzytkownikaID;
        vLookup.Alias_Name           := sFKALIAS_SlUzytkownikaSymbol;
        vLookup.AdditionalAliases    := sFKALIAS_SlUzytkownikaNazwa;
        vLookup.AdditionalCondition  := '@'+sFKALIAS_SlUzytkownikaIDMnemonika+'='+qMnem.FieldByName(sFKMNEMONIKI_ID).AsString;

        //InitiateData(DataSet.FieldByName(sFKUZ_ID).AsInteger);
        vWarunekItem := FWarunki.GetItemByValue(qMnem.FieldByName(sFKMNEMONIKI_ID).AsInteger);
        if vWarunekItem <> nil then
           if vWarunekItem.ListaID <> '' then
               if Pos(',', vWarunekItem.ListaID) > 0 then begin
                  iPrzec := 0;
                  for ii := 1 to Length(vWarunekItem.ListaID) do
                     if vWarunekItem.ListaID[ii] = ',' then
                        Inc(iPrzec);

                  vLookup.Text := 'Wybrano ' + IntToStr(iPrzec + 1) + ' pozycji';
               end else begin
                  vLookup.InitiateData(StrToInt(vWarunekItem.ListaID));
               end;


      end else begin
        vLookup.OnExit := MyOnExit;
        vLookup.OnCheck := LookupCheck;

        vWarunekItem := FWarunki.GetItemByValue(qMnem.FieldByName(sFKMNEMONIKI_ID).AsInteger);
        if vWarunekItem <> nil then
           if vWarunekItem.ListaID <> '' then
               if Pos(',', vWarunekItem.ListaID) > 0 then begin
                  iPrzec := 0;
                  for ii := 1 to Length(vWarunekItem.ListaID) do
                     if vWarunekItem.ListaID[ii] = ',' then
                        Inc(iPrzec);

                  vLookup.Text := 'Wybrano ' + IntToStr(iPrzec + 1) + ' pozycji';
               end else begin
                 qSymbol := SQLManager.CreateQuery('SELECT ' + qMnem.FieldByName(sFKMNEMONIKI_TABELA).AsString + '_SYMBOL ' +
                                                   'FROM %s ' +
                                                   'WHERE ' + qMnem.FieldByName(sFKMNEMONIKI_TABELA).AsString + '_ID' + '=' + vWarunekItem.ListaID,
                                                   [qMnem.FieldByName(sFKMNEMONIKI_TABELA).AsString]);

                 try
                    qSymbol.Open;
                    if not qSymbol.IsEmpty then
                       vLookup.Text := qSymbol.FieldByName(qMnem.FieldByName(sFKMNEMONIKI_TABELA).AsString + '_SYMBOL').AsString;
                 finally
                    if qSymbol <> nil then FreeAndNil(qSymbol);
                 end;
               end;
      end;

     vLookup.OnButtonClick := LookupButtonClick;
     vLookup.OnSetData := LookupSetData;
     vLookup.OnDelKey := MyDelKey;
     vLookup.aClickKey:= ShortCut(VK_RETURN,[ssCtrl]);
     vLookup.aDelKey:= ShortCut(VK_DELETE,[ssCtrl]);
     LookupCheck(vLookup);

     vLookup.Visible := True;

     Inc(k);
     qMnem.Next;
  end;

  sSkladniki := DMAQFbN(sZLEKRYTERIA_SKLADNIKI).AsString;
end;




(******************************************************************************)
function TZLEKryteriaDBDetailForm.GetList2( sFunctionName, sKind, sText: String;
                                                   const cSeparator: Char): TUNIStringList;
{var oQuery: TUNIQuery;
    bReplaceMinus: Boolean;}
begin
  result := nil;
  //oQuery := nil;

  //try

    (********************************************************
    if sKind = 'KONTOFK' then begin
      bReplaceMinus := True;
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := FKDataManager.FKOdpytajODane( vFKKSO, sFKALIAS_KSO_KONTO,
                                              '@'+sFKALIAS_KSO_KONTO+' like '+QuotedStr(sText+'%'),
                                              false, vAktywnaFirma );
    end
    else if sKind = 'OKRESOBR' then begin
      oQuery := UniSysDataManager.UNIOdpytajODane( sUNIOKRES, sUNISYSALIAS_Okres_Obrachunkowy_Numer,//'',
                                                   '@'+sUNISYSALIAS_Okres_Obrachunkowy_Rok_ID+' = '+IntToStr(vAktywnyRokObrachunkowyID),
                                                   false, vAktywnaFirma );
    end
    else if sKind = 'MNEMONIK_ZAKRESSUM' then begin
      if Pos(',',sText) <> 0 then oQuery := GetMnemonikValuesList2(sText)
      else begin
        sText := StringReplace(sText,'[','',[]);
        if (sText<>'')and(sText[1]=cSeparator) then sText := '';
        oQuery := UNISysDataManager.UNIOdpytajODane( sFKMNEMONIKI, sFKAlias_Mnemoniki_Mnemonik,
                                                     '@'+sFKAlias_Mnemoniki_Mnemonik+' like '+QuotedStr(sText+'%'),
                                                     true, vAktywnaFirma);
      end
    end
    else if sKind = 'MNEMONIK_DOKUMSP' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      FParamValuesList2.Clear;
      FParamValuesList2.Add('BRUTTO');
      FParamValuesList2.Add('NETTO');
      FParamValuesList2.Add('VAT');
      FParamValuesList2.Add('RABAT');
      FParamValuesList2.Add('OPAK');
      FParamValuesList2.Add('IL1');
      FParamValuesList2.Add('IL2');
      FParamValuesList2.Add('IL3');
      result := FParamValuesList2;
      Exit;
    end
    else if sKind = 'BILANS' then begin
      FParamValuesList2.Clear;
      FParamValuesList2.Add('TAK');
      FParamValuesList2.Add('NIE');
      result := FParamValuesList2;
      Exit;
    end
    else if sKind = 'STAWKAVAT' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISysDataManager.UNIOdpytajODane( sUNISTAWKIVAT, sUNISYSALIAS_StawkiVAT_Symbol,
                                                   '@'+sUNISYSALIAS_StawkiVAT_Symbol+' like '+QuotedStr(sText+'%'),
                                                   false, vAktywnaFirma );
    end
    else if sKind = 'GRUPAVAT' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISysDataManager.UNIOdpytajODane( sUNIGRUPAVAT, sUNISYSALIAS_GrupaVAT_Symbol,
                                                   '@'+sUNISYSALIAS_GrupaVAT_Symbol+' like '+QuotedStr(sText+'%'),
                                                   false, vAktywnaFirma );
    end
    else if sKind = 'REJESTR' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISysDataManager.UNIOdpytajODane( sUNIREJVAT, sUNISYSALIAS_RejestrVAT_Symbol,
                                                  '@'+sUNISYSALIAS_RejestrVAT_Symbol+' like '+QuotedStr(sText+'%'),
                                                  false, vAktywnaFirma );
    end
    else if sKind = 'MIESIAC' then begin
      FParamValuesList2.Clear;
      for i := 1 to 12 do FParamValuesList2.Add(IntToStr(i));
      result := FParamValuesList2;
      Exit;
    end
    else if sKind = 'PODKLASA' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISysDataManager.UNIOdpytajODane( sUNIPODKLASA, sUNISYSALIAS_Podklasa_Klasa_Kod,
                                                   '@'+sUNISYSALIAS_Podklasa_Klasa_Kod+' like '+QuotedStr(sText+'%'),
                                                   false, vAktywnaFirma );
    end
    else if sKind = 'TYPDOKMAG' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := MAGDataManager.OdpytajODane( sMAGTYPDOK, sMAGALIAS_MAGTYPDOK_SYMBOL,
                                                   '@'+sMAGALIAS_MAGTYPDOK_SYMBOL+' like '+QuotedStr(sText+'%'),
                                                   false, vAktywnaFirma );
    end
    else if sKind = 'KONTOMAT' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := ASODataManager.OdpytajODane( sASOKMAT, sASOAlias_KMat_Symbol,
                                                   '@'+sASOAlias_KMat_Symbol+' like '+QuotedStr(sText+'%'),
                                                   false{, vAktywnaFirma });
    end
    else if sKind = 'INDEKSASO' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := ASODataManager.OdpytajODane( sASOASORT, sASOAlias_Asort_Indeks,
                                                   '@'+sASOAlias_Asort_Indeks+' like '+QuotedStr(sText+'%'),
                                                   false{, vAktywnaFirma });
    end
    else if sKind = 'SYMBOLASO' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := ASODataManager.OdpytajODane( sASOASORT, sASOAlias_Asort_Symbol,
                                                   '@'+sASOAlias_Asort_Symbol+' like '+QuotedStr(sText+'%'),
                                                   false{, vAktywnaFirma });
    end
    else if sKind = 'GRUPAASO' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := ASODataManager.OdpytajODane( sASOGRAS, sASOAlias_Gras_Symbol,
                                                   '@'+sASOAlias_Gras_Symbol+' like '+QuotedStr(sText+'%'),
                                                   false{, vAktywnaFirma });
    end
    else if sKind = 'MAGAZYN' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISysDataManager.UNIOdpytajODane( sUNIMAGAZYN, sUNISYSALIAS_Magazyn_Symbol,
                                                   '@'+sUNISYSALIAS_Magazyn_Symbol+' like '+QuotedStr(sText+'%'),
                                                   false, vAktywnaFirma );
    end
    else if sKind = 'WYDZIAL' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISysDataManager.UNIOdpytajODane( sUNIJEDNOSTKAORG, sUNISysAlias_JednostkaOrg_Symbol,
                                                   '@'+sUNISysAlias_JednostkaOrg_Symbol+' like '+QuotedStr(sText+'%'),
                                                   false, vAktywnaFirma );
    end
    else if sKind = 'ZLECENIE' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := ZLEDataManager.ZLEOdpytajODane( sZLEZLECENIE, sZLEALIAS_ZLECENIE_SYMBOL,
                                             '@'+sZLEALIAS_ZLECENIE_SYMBOL+' like '+QuotedStr(sText+'%'),
                                             false);
    end
    else if sKind = 'KLIENT' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := BKDataManager.OdpytajODaneKlienta( sBKAlias_KlientSymbol,
                                                   '@'+sBKAlias_KlientSymbol+' like '+QuotedStr(sText+'%'),
                                                   now, false{, vAktywnaFirma });
    end
    else if sKind = 'TYPDOK' then begin
      if Pos( sFunctionName, cFunkcjeSprzedazy ) > 0 then begin
        if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
        if (sText<>'')and(sText[1]=cSeparator) then sText := '';
        oQuery := MFSDataManager.OdpytajODane( sMFSTypDok, sMFSAlias_TypSymbol,
                                                     '@'+sMFSAlias_TypSymbol+' like '''+sText+'%''',
                                                     false);
      end else if Pos( sFunctionName, cFunkcjeZakupu ) > 0 then begin
        if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
        if (sText<>'')and(sText[1]=cSeparator) then sText := '';
        oQuery := MFZDataManager.OdpytajODane( sMFZTypDok, sMFZAlias_TypDok_SYMBOL,
                                                     '@'+sMFZAlias_TypDok_Symbol+' like '''+sText+'%''',
                                                     false);
      end;
    end
    else if sKind = 'SPOSZAPL' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISYSDM.UNIOdpytajODane( sUNIFORMAPLATNOSCI,
                                          sUNISYSALIAS_FormaPlatnosci_Symbol,
                                          '@'+sUNISYSALIAS_FormaPlatnosci_Symbol+' like '+QuotedStr(sText+'%'),
                                          False );
    end
    else if sKind = 'FIRMA' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISysDataManager.UNIOdpytajODane( sUNIODDZIAL, sUNISYSALIAS_Oddzial_Symbol,
                                                   '@'+sUNISYSALIAS_Oddzial_Symbol+' like '+QuotedStr(sText+'%'),
                                                   false, vAktywnaFirma );
    end
    else if sKind = 'ROK' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISysDataManager.UNIOdpytajODane( sUNIROK, sUNISYSALIAS_Rok_Rok,
                                                   '@'+sUNISYSALIAS_Rok_Rok+' like '+QuotedStr(sText+'%'),
                                                   false, vAktywnaFirma );
    end
    else if (sKind = 'SKLAD_WART') then begin
      sText := StringReplace(sText,#39,'',[rfReplaceAll]);
      oQuery := ZLEDM.ZLEOdpytajODane( sZLESKLADWART, sZLEALIAS_SKLADWART_SYMBOL,
                                       '(@'+sZLEALIAS_SKLADWART_SYMBOL+' like '+QuotedStr(sText+'%')+')',
                                       false);
    end
    else if (sKind = 'SKLAD_IL') then begin
      sText := StringReplace(sText,#39,'',[rfReplaceAll]);
      oQuery := ZLEDM.ZLEOdpytajODane( sZLESKLADIL, sZLEALIAS_SKLADIL_SYMBOL,
                                       '(@'+sZLEALIAS_SKLADIL_SYMBOL+' like '+QuotedStr(sText+'%')+')',
                                       false);
    end
    else if sKind = 'KIERUNEK' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      FParamValuesList2.Clear;
      FParamValuesList2.Add('PRZYCHODOWY');
      FParamValuesList2.Add('ROZCHODOWY');
      result := FParamValuesList2;
      Exit;
    end
    else if sKind = 'ZNAK' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      FParamValuesList2.Clear;
      FParamValuesList2.Add('ZWYKY');
      FParamValuesList2.Add('STORNO');
      result := FParamValuesList2;
      Exit;
    end
    else if (sKind = 'POZROZDZ') then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
{      oQuery := ZLEDM.ZLEOdpytajODane( sZLEPLROZDEF, sZLEALIAS_PLROZDEF_SYMBOL,
                                       '(@'+sZLEALIAS_PLROZDEF_SYMBOL+' like '+QuotedStr(sText+'%')+')',
                                       false);}

      oQuery := SQLManager.CreateQuery('SELECT PLROZ.PLROZDEF_SYMBOL FROM ' +
                                        SQLManager.GetTableName(sPLROZDEF) + ' PLROZ, ' +
                                        SQLManager.GetTableName(sZLEPLROZDEF) + ' ZLEROZDEF '+
                                       'WHERE ZLEROZDEF.' + sPLROZDEF_ID + '= PLROZ.' + sPLROZDEF_ID + ' AND ' +
                                       '(PLROZ.' + sPLROZDEF_SYMBOL + ' LIKE '+QuotedStr(sText+'%')+')');
    end
    else if sKind = sWartosc then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      FParamValuesList2.Clear;
      FParamValuesList2.Add(sNETTO);
      FParamValuesList2.Add(sBRUTTO);
      result := FParamValuesList2;
      Exit;
    end
    else if sKind = cZLEMnem {sNazwaPolaUz} then begin
      if TrimLeft(sText)[1] = '[' then
        GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then
        sText := '';

      if sFunctionName = cSumPozDSPUz then begin
        oQuery := MFSDM.OdpytajODane( sMFSPoleZMDef, sMFSAlias_PoleZMDefNazwa,
                                     '@'+sMFSAlias_MnemonikiMnemonik+'=''ZLE''',
                                      false);
      end else if sFunctionName = cDokumZa then begin
        oQuery := SQLManager.CreateQuery(
          'SELECT def.'+sUNIPolaUzDef_Nazwa+
          ' FROM %s def, %s wsk, %s mn '+
          'WHERE def.' + sUNIPolaUzDef_ID + '= wsk.' + sUNIPolaUzDef_ID +
          ' AND def.' + sFKMnemoniki_ID + '=mn.'+sFKMnemoniki_ID+
          ' AND wsk.' + sUNIPolaUzWsk_Funk + '=' + cPolaUz_MFZDok+
          ' AND mn.'+sFKMnemoniki_Tabela+'='+QuotedStr(sZLEZlecenie),
          [sUNIPolaUzDef, sUNIPolaUzWsk, sFKMnemoniki]);
      end;
    end
    else if sKind = cTypDokSp then begin
      if TrimLeft(sText)[1] = '[' then
        GetLastWord2(sText,sFirstWord);
      if (sText<>'') and (sText[1]=cSeparator) then
        sText := '';
      oQuery := MFSDM.OdpytajODane( sMFSTYPDOK, sMFSAlias_TypSymbol,'',false );
    end
    else if (sKind = 'MODUL') then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord2(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISysDataManager.UNIOdpytajODane( sUNIMODULZSI, sUNISYSALIAS_ModulZSI_Kod,
                                                   '@'+sUNISYSALIAS_ModulZSI_Kod+' like '''+sText+'%''',
                                                   false, vAktywnaFirma );
    end
    else if (sKind = sMAGPROTOTYP) then begin
      FParamValuesList2.Clear;
      FParamValuesList2.Add(cMagPrototyp_ZuzycieID);
      FParamValuesList2.Add(cMagPrototyp_ZmniejszenieZuzyciaID);
      FParamValuesList2.Add(cMagPrototyp_PrzyjecieZZewnatrzID);
      FParamValuesList2.Add(cMagPrototyp_PrzyjecieZProdukcjiID);
      FParamValuesList2.Add(cMagPrototyp_WydanieNaZewnatrzID);
      FParamValuesList2.Add(cMagPrototyp_InnePrzychodyID);
      FParamValuesList2.Add(cMagPrototyp_InneRozchodyID);
      result := FParamValuesList2;
      Exit;
    end
    *************************************************************)
    if sKind = 'NARZUT' then begin
      FParamValuesList2.Clear;
      FParamValuesList2.Add('NIE');
      if ZLEDM.vZLENarzuty then
         FParamValuesList2.Add('TAK');

      result := FParamValuesList2;
      Exit;
    end
    else if sKind = 'BRAK_PODPOWIEDZI' then Exit
    else begin
      Komunikat(cWarning,'Bdny parametr funkcji',MB_OK+MB_APPLMODAL);
      Exit;
    end;

    {if oQuery = nil then Exit;
    FParamValuesList2.Clear;
    oQuery.Open;
    while not oQuery.Eof do begin
      case bReplaceMinus of
        True: FParamValuesList2.Add(StringReplace(oQuery.Fields[0].AsString,'-','',[rfReplaceAll]));
        False: FParamValuesList2.Add(oQuery.Fields[0].AsString);
      end;
      oQuery.Next;
    end;
    if FParamValuesList2.Count > 0 then result := FParamValuesList2;
    }
  //finally
    //if oQuery <> nil then oQuery.Free;
  //end;
end;

procedure TZLEKryteriaDBDetailForm.SetDefaults;
begin
  FDlugosc := 0;
  iDlugText := 0;
  DMAQFbN(sZLEKRYTERIA_REGULA).AsString := 'result := ';
end;

function TZLEKryteriaDBDetailForm.GetFunctionsList2(
  const oCurrFunction: TUNIFunction; var sWholeCurrParam,
  sCurrWord: string; const sPrevWord: string; const cSeparator: char;
  var sWordToInsert: string; bShowList: boolean): TUNIStringList;
begin
  result := nil;
  if oCurrFunction = nil then begin
    result := FFunctionList2;
  end else
  if bShowList then begin
{$ifdef ver210}
    if(CharInSet(cSeparator, ['='])) then begin //jeeli separatorem jest "=" to podpowiadamy moliwe warto parametru
                                      //o nazwie sPrevWord
{$else}
    if cSeparator in ['='] then begin //jeeli separatorem jest "=" to podpowiadamy moliwe warto parametru
                                      //o nazwie sPrevWord
{$endif}
       result := GetList2( AnsiUpperCase(oCurrFunction.FunName),
                          FParamKindList2.Values[AnsiUpperCase(sPrevWord)], sCurrWord, cSeparator );
    end
    (**********************************************************************************
    else if (AnsiUpperCase(oCurrFunction.FunName) = cSKLAD_WART)or
            (AnsiUpperCase(oCurrFunction.FunName) = cSKLAD_WART_GRUPY) then
      result := GetList2( AnsiUpperCase(oCurrFunction.FunName), cSKLAD_WART, sCurrWord, cSeparator ) //dla tej funkcji jest brak nazwy parametru
    else if (AnsiUpperCase(oCurrFunction.FunName) = cSKLAD_IL)or
            (AnsiUpperCase(oCurrFunction.FunName) = cSKLAD_IL_GRUPY) then
      result := GetList2( AnsiUpperCase(oCurrFunction.FunName), cSKLAD_IL, sCurrWord, cSeparator ) //dla tej funkcji jest brak nazwy parametru

    else if (AnsiUpperCase(oCurrFunction.FunName) = cKRYT_WARTPRACY) or
            (AnsiUpperCase(oCurrFunction.FunName) = cKRYT_WARTMAT) {  or
            (AnsiUpperCase(oCurrFunction.FunName) = cKRYT_WSPPRACY) or
            (AnsiUpperCase(oCurrFunction.FunName) = cKRYT_WSPMAT)} then
      result := nil//GetList2( AnsiUpperCase(oCurrFunction.FunName), c, sCurrWord, cSeparator ) //dla tej funkcji jest brak nazwy parametru
    ***********************************************************************************)  
    else result := oCurrFunction.ParamsNames; //w przeciwnym przypadku podpowiadamy list moliwych parametrw
  end;
end;

procedure TZLEKryteriaDBDetailForm.SelectButtonPressed;
begin
  if OpenMode in [omNew,omEdit] then
    DMAQFbN(sZLEKRYTERIA_REGULA).AsString := Trim(FRichEdit2.Lines.Text );
  inherited;
end;


{
function TZLEKryteriaDBDetailForm.GetMnemonikValuesList2(
  sText: String): TUNIQuery;
var oQuery: TUNIQuery;
    sMnemonik, sMnemonikId: String;
    sSQL, sWhere: String;
    sTableName: String;
    sPole, sIndeksPola: String;
    iIndeksPola: Integer;
begin
  result := nil;
  oQuery := nil;

  GetLastWord2(sText,sMnemonik); // pobiera pierwsze i ostatnie sowo z listy postaci
                                 //[<string>,..,<string>]

  try
    oQuery := UNISysDataManager.UNIOdpytajODane( sFKMNEMONIKI, sFKAlias_Mnemoniki_Id,
                            '@'+sFKAlias_Mnemoniki_Mnemonik+' = '+QuotedStr(sMnemonik),
                            true, vAktywnaFirma);
    if (oQuery = nil)or(oQuery.RecordCount = 0)or(oQuery.Fields[0].AsString = '') then Exit;
    sMnemonikId := oQuery.Fields[0].AsString;
  finally
    if oQuery <> nil then oQuery.Free();
  end;
  if sMnemonik = sMnemonikKontaSyntetyczne then begin
    //sownik-niesownik syntetyk
    sWhere:='';
    if vWielofirmowosc and (vAktywnaFirma <> 0) and vPlanKontRozlaczny then begin
      sWhere := sUNIODDZIAL_ID+'='+IntToStr(vAktywnaFirma);
    end;
    //przygotowanie treci zapytania
    if sWhere <> '' then sWhere := sWhere+' and ';
    sWhere := sWhere+sFKPLANKONT_SYMBOL+' like '+QuotedStr(sText+'%');
    sSQL:= SQLManager.GetSelectWithInnerJoins(sFKPLANKONT_SYMBOL,
                            [vFKPLANKONT], [''], [''], sWhere);
  end else begin
    //pozostae przypadki, czyli normalne sowniki
    sTableName:=SQLMAnager.OpenQueryWithResult(
             'select '+ sFKMNEMONIKI_TABELA+' from %s where '+
             sFKMNEMONIKI_ID+'='+sMnemonikId, [sFKMNEMONIKI]);

    if sTableName='' then Exit
    else begin
      // z ktorego pola w slowniku odczytac konto
      sIndeksPola:=SQLManager.OpenQueryWithResult(
               'select '+ sFKMNEMONIKI_INDEKS+' from %s where '+
               sFKMNEMONIKI_ID+'='+sMnemonikId, [sFKMNEMONIKI]);
      if sIndeksPola ='' then Exit
      else iIndeksPola:=StrToInt(sIndeksPola);
    end;

    if iIndeksPola=0 then sPole:='SYMBOL'
    else sPole:='POLE'+IntToStr(iIndeksPola);

    if (sTableName = sFKUZ) then begin
      sWhere:=sFKMNEMONIKI_ID+' = '+sMnemonikId
      //tu nie wystpuje UNIODDZIAL
    end else begin
      sWhere:='';
      if vWielofirmowosc and (vAktywnaFirma <> 0) then begin
        //tu wystpuje UNIODDZIAL, ale NIE W KADYM sowniku
        if SQLManager.OpenQueryWithResult(
             'select '+ sFKMNEMONIKI_CZY_FIRM+' from %s where '+
             sFKMNEMONIKI_ID+'='+sMnemonikId, [sFKMNEMONIKI]) <> 'N' then begin
          if sWhere <> '' then sWhere := sWhere+' and ';
          sWhere := sWhere+sUNIODDZIAL_ID+'='+IntToStr(vAktywnaFirma);
        end;
      end
    end;
    //przygotowanie treci zapytania
    if sWhere <> '' then sWhere := sWhere+' and ';
    sWhere := sWhere+sTableName+'_'+sPole+' like '+QuotedStr(sText+'%');
    sSQL:= SQLManager.GetSelectWithInnerJoins( sTableName+'_'+sPole,
                                               [sTableName], [''], [''], sWhere);
  end;

  result := SQLManager.CreateQuery(sSQL);
end;
}

{
procedure TZLEKryteriaDBDetailForm.GetLastWord2(var sText, sFirstWord: String);
var iPos: Integer;
begin
  sText := StringReplace(sText,'[','',[]);
  sText := StringReplace(sText,']','',[]);
  iPos := Pos(',',sText);
  if iPos = 0 then sFirstWord := sText
  else sFirstWord := Copy(sText,1,iPos-1);
  while iPos <> 0 do begin
    System.Delete(sText,1,iPos);
    iPos := Pos(',',sText);
  end;
end;
}

procedure TZLEKryteriaDBDetailForm.CreateFunctionList2;
begin
  FFunctionList2 := TUNIStringList.Create;
  with FFunctionList2 do begin
      {Funkcje dla kryteriw}
      AddObject(cKRYT_WARTPRACY,       TUNIFunction.Create(cKRYT_WARTPRACY, ['NARZUT='], ''''));
      AddObject(cKRYT_WARTMAT,         TUNIFunction.Create(cKRYT_WARTMAT,  ['NARZUT='], ''''));
      AddObject(cKRYT_ILOSCPRACY,      TUNIFunction.Create(cKRYT_ILOSCPRACY, ['NARZUT='], ''''));
      {AddObject(cKRYT_WSPPRACY,        TUNIFunction.Create(cKRYT_WSPPRACY, [''], ''));
      AddObject(cKRYT_WSPMAT,          TUNIFunction.Create(cKRYT_WSPMAT,  [''], ''));}

      (****************
      if DataManagers.Available(sFKModulId) then begin
        AddObject(cBOWN,        TUNIFunction.Create(cBOWN,        ['KontoOd=','KontoDo=','Konto=','ZakresSUM=['], ''''));
        AddObject(cBOMA,        TUNIFunction.Create(cBOMA,        ['KontoOd=','KontoDo=','Konto=','ZakresSUM=['], ''''));
        AddObject(cObrWN,       TUNIFunction.Create(cObrWN,       ['KontoOd=','KontoDo=','Konto=','ZakresSUM=[','OkresOd=','OkresDo=','OkresMin='], ''''));
        AddObject(cObrMA,       TUNIFunction.Create(cObrMA,       ['KontoOd=','KontoDo=','Konto=','ZakresSUM=[','OkresOd=','OkresDo=','OkresMin='], ''''));
        AddObject(cObrNarWN,    TUNIFunction.Create(cObrNarWN,    ['KontoOd=','KontoDo=','Konto=','ZakresSUM=[','OkresDo=','BO='], ''''));
        AddObject(cObrNarMA,    TUNIFunction.Create(cObrNarMA,    ['KontoOd=','KontoDo=','Konto=','ZakresSUM=[','OkresDo=','BO='], ''''));
        AddObject(cSumSaldWN,   TUNIFunction.Create(cSumSaldWN,   ['KontoOd=','KontoDo=','Konto=','ZakresSUM=[','OkresOd=','OkresDo=','OkresMin=','BO='], ''''));
        AddObject(cSumSaldMA,   TUNIFunction.Create(cSumSaldMA,   ['KontoOd=','KontoDo=','Konto=','ZakresSUM=[','OkresOd=','OkresDo=','OkresMin=','BO='], ''''));
        AddObject(cSaldo,       TUNIFunction.Create(cSaldo,       ['KontoOd=','KontoDo=','Konto=','ZakresSUM=[','OkresOd=','OkresDo=','OkresMin=','BO='], ''''));
      end;
      if DataManagers.Available(sVATModulId) then begin
        AddObject(cVatSprNetto, TUNIFunction.Create(cVatSprNetto, ['MiesiacPod=','MiesiacPodOd=','MiesiacPodDo=','Rejestr=[','Podklasa=[','StawkaVAT=[','GrupaVAT=[','ZAP'], ''''));
        AddObject(cVatSprVat,   TUNIFunction.Create(cVatSprVat,   ['MiesiacPod=','MiesiacPodOd=','MiesiacPodDo=','Rejestr=[','Podklasa=[','StawkaVAT=[','GrupaVAT=[','ZAP'], ''''));
        AddObject(cVatZakNetto, TUNIFunction.Create(cVatZakNetto, ['MiesiacPod=','MiesiacPodOd=','MiesiacPodDo=','Rejestr=[','Podklasa=[','StawkaVAT=[','GrupaVAT=[','ZAP'], ''''));
        AddObject(cVatZakVat,   TUNIFunction.Create(cVatZakVat,   ['MiesiacPod=','MiesiacPodOd=','MiesiacPodDo=','Rejestr=[','Podklasa=[','StawkaVAT=[','GrupaVAT=[','ZAP'], ''''));
        AddObject(cVatSadNetto, TUNIFunction.Create(cVatSadNetto, ['MiesiacPod=','MiesiacPodOd=','MiesiacPodDo=','Rejestr=[','Podklasa=[','StawkaVAT=[','GrupaVAT=[','ZAP'], ''''));
        AddObject(cVatSadVat,   TUNIFunction.Create(cVatSadVat,   ['MiesiacPod=','MiesiacPodOd=','MiesiacPodDo=','Rejestr=[','Podklasa=[','StawkaVAT=[','GrupaVAT=[','ZAP'], ''''));
      end;
      if DataManagers.Available(sMFSModulId) then begin
        AddObject(cDokumSp,     TUNIFunction.Create(cDokumSp,     ['Zlecenie='+cZLEParamSymbolZlec,'OkrObr=[','OkrObrOd=','OkrObrDo=','TypDok=[','KlPla=[','KlPlaOd=','KlPlaDo=','KlOdb=[','KlOdbOd=','KlOdbDo=',
                                                                   'SposZapl=[','Mnemonik=[','Modul='], ''''));
      end;
      if DataManagers.Available(sMFZModulId) then begin
        AddObject(cDokumZa,     TUNIFunction.Create(cDokumZa,     ['OkrObr=[','OkrObrOd=','OkrObrDo=','TypDok=[','Dostawca=[','DostawcaOd=','DostawcaDo=',
                                                                   'SposZapl=[','Mnemonik=[',sNazwaPolaUz+'=['], ''''));
      end;
      AddObject(cSklad_Wart,       TUNIFunction.Create(cSKLAD_WART,       ['Symbol skadnika wartociowego'], ''''));
      AddObject(cSklad_Wart_Grupy, TUNIFunction.Create(cSKLAD_WART_GRUPY, ['Symbol skadnika wartociowego'], ''''));
      AddObject(cWART_PRACY,       TUNIFunction.Create(cWART_PRACY, [''], ''));
      AddObject(cWART_ROZL,        TUNIFunction.Create(cWART_ROZL,  [''], ''));
      {Ilosciowa}
      AddObject(cSklad_Il,       TUNIFunction.Create(cSKLAD_IL,       ['Symbol skadnika ilociowego'], ''''));
      AddObject(cSklad_Il_Grupy, TUNIFunction.Create(cSKLAD_IL_GRUPY, ['Symbol skadnika ilociowego'], ''''));
      ***************************************)

      (*************************************
      {Ilociowa i wartociowa}
      AddObject(cILOSC_PRACY,    TUNIFunction.Create(cILOSC_PRACY,   [''], ''));
      AddObject(cILOSC_GODZ,     TUNIFunction.Create(cILOSC_GODZ,    [''], ''));
      AddObject(cILOSC_PALIWA,   TUNIFunction.Create(cILOSC_PALIWA,  [''], ''));

    if DataManagers.Available(sMAGModulId) then begin
      AddObject(cObrGM,         TUNIFunction.Create(cObrGM,       [
      'TypDokumentuOd=','TypDokumentuDo=','TypDokumentu=[','OkresObrachunkowyOd=','OkresObrachunkowyDo=',
                                                                   'OkresObrachunkowy=[','MagazynOd=','MagazynDo=','Magazyn=[','KontoMaterialoweOd=','KontoMaterialoweDo=','KontoMaterialowe=[','IndeksOd=',
                                                                   'IndeksDo=','Indeks='+cZLEParamIndeksAsort,'WydzialOd=','WydzialDo=','Wydzial=[','ZlecenieOd=','ZlecenieDo=','Zlecenie='+cZLEParamSymbolZlec,'OdbiorcaOd=','OdbiorcaDo=','Odbiorca=[',
                                                                   'DostawcaOd=','DostawcaDo=','Dostawca=[','MagazynDocelowyOd=','MagazynDocelowyDo=','MagazynDocelowy=[','Znak=[','Kierunek=[', sMAGPROTOTYP+'=['], ''''));
    end;
    if DataManagers.Available(sMFSModulId) then begin
      AddObject(cPozDokSp,      TUNIFunction.Create(cPozDokSp,    ['Zlecenie='+cZLEParamSymbolZlec,'OkrObr=[','OkrObrOd=','OkrObrDo=','TypDok=[','KlPla=[','KlPlaOd=','KlPlaDo=','KlOdb=[','KlOdbOd=','KlOdbDo=',
                                                                   'IndAso='+cZLEParamIndeksAsort,'IndAsoOd=','IndAsoDo=','SymbAs=[','SymbAsOd=','SymbAsDo=','GrAso=[','GrAsoOd=','GrAsoDo=','Mnemonik=[','Modul='], ''''));
      AddObject(cSumPozDSPUz,   TUNIFunction.Create(cSumPozDSPUz, [sNazwaWartosc+'=',sNazwaPolaUz+'=',sTypDokumentuSp+'='], ''''));
    end;
    if DataManagers.Available(sMFZModulId) then begin
      AddObject(cPozDokZa,      TUNIFunction.Create(cPozDokZa,    ['OkrObr=[','OkrObrOd=','OkrObrDo=','TypDok=[','Dostawca=[','DostawcaOd=','DostawcaDo=',
                                                                   'IndAso='+cZLEParamIndeksAsort,'IndAsoOd=','IndAsoDo=','SymbAs=[','SymbAsOd=','SymbAsDo=','GrAso=[','GrAsoOd=','GrAsoDo=','Mnemonik=['], ''''));
    end;

    if DataManagers.Available(sPLLIModulID) then begin
      AddObject(cWARTPL, TUNIFunction.Create(cWARTPL,             ['Zlecenie='+cZLEParamSymbolZlec,'POZROZDZ=['], ''''));
    end;
    *******************************)
  end;
end;

procedure TZLEKryteriaDBDetailForm.CreateParamKindList2;
begin
  //ustalenie rodzaju parametru
  FParamKindList2 := TUniStringList.Create;
  with FParamKindList2 do begin
    {Tylko jeden parametr}
    Add('NARZUT=NARZUT');

    {Add('KONTOOD=KONTOFK');
    Add('KONTODO=KONTOFK');
    Add('KONTO=KONTOFK');
    Add('OKRESOD=OKRESOBR');
    Add('OKRESDO=OKRESOBR');
    Add('OKRESMIN=OKRESOBR');
    Add('ZAKRESSUM=MNEMONIK_ZAKRESSUM');
    Add('BO=BILANS');
    Add('STAWKAVAT=STAWKAVAT');
    Add('GRUPAVAT=GRUPAVAT');
    Add('ZAP=BRAK_PODPOWIEDZI');
    Add('REJESTR=REJESTR');
    Add('MIESIACPOD=MIESIAC');
    Add('MIESIACPODOD=MIESIAC');
    Add('MIESIACPODDO=MIESIAC');
    Add('PODKLASA=PODKLASA');
    Add('SYMBOL=SYMBOLAN');
    Add('ROK=ROK');
    Add('OKRESNR=OKRESOBR');
    Add('FIRMASYM=FIRMA');
    Add('TYPDOKUMENTUOD=TYPDOKMAG');
    Add('TYPDOKUMENTUDO=TYPDOKMAG');
    Add('TYPDOKUMENTU=TYPDOKMAG');
    Add('OKRESOBRACHUNKOWYOD=OKRESOBR');
    Add('OKRESOBRACHUNKOWYDO=OKRESOBR');
    Add('OKRESOBRACHUNKOWY=OKRESOBR');
    Add('MAGAZYNOD=MAGAZYN');
    Add('MAGAZYNDO=MAGAZYN');
    Add('MAGAZYN=MAGAZYN');
    Add('KONTOMATERIALOWEOD=KONTOMAT');
    Add('KONTOMATERIALOWEDO=KONTOMAT');
    Add('KONTOMATERIALOWE=KONTOMAT');
    Add('INDEKSOD=INDEKSASO');
    Add('INDEKSDO=INDEKSASO');
    Add('INDEKS=INDEKSASO');
    Add('WYDZIALOD=WYDZIAL');
    Add('WYDZIALDO=WYDZIAL');
    Add('WYDZIAL=WYDZIAL');
    Add('ZLECENIEOD=ZLECENIE');
    Add('ZLECENIEDO=ZLECENIE');
    Add('ZLECENIE=ZLECENIE');
    Add('ODBIORCAOD=KLIENT');
    Add('ODBIORCADO=KLIENT');
    Add('ODBIORCA=KLIENT');
    Add('DOSTAWCAOD=KLIENT');
    Add('DOSTAWCADO=KLIENT');
    Add('DOSTAWCA=KLIENT');
    Add('MAGAZYNDOCELOWYOD=MAGAZYN');
    Add('MAGAZYNDOCELOWYDO=MAGAZYN');
    Add('MAGAZYNDOCELOWY=MAGAZYN');
    Add('OKROBR=OKRESOBR');
    Add('OKROBROD=OKRESOBR');
    Add('OKROBRDO=OKRESOBR');
    Add('TYPDOK=TYPDOK');
    Add('KLPLA=KLIENT');
    Add('KLPLAOD=KLIENT');
    Add('KLPLADO=KLIENT');
    Add('KLODB=KLIENT');
    Add('KLODBOD=KLIENT');
    Add('KLODBDO=KLIENT');
    Add('SPOSZAPL=SPOSZAPL');
    Add('MNEMONIK=MNEMONIK_DOKUMSP');
    Add('INDASO=INDEKSASO');
    Add('INDASOOD=INDEKSASO');
    Add('INDASODO=INDEKSASO');
    Add('SYMBAS=SYMBOLASO');
    Add('SYMBASOD=SYMBOLASO');
    Add('SYMBASDO=SYMBOLASO');
    Add('GRASO=GRUPAASO');
    Add('GRASOOD=GRUPAASO');
    Add('GRASODO=GRUPAASO');
    Add('POZROZDZ=POZROZDZ');
    Add('ZNAK=ZNAK');
    Add('KIERUNEK=KIERUNEK');
    Add(sNazwaWartosc+'='+sWartosc);
    Add(sNazwaPolaUz+'='+cZLEMnem);
    Add(sTypDokumentuSp+'='+cTypDokSp);
    Add('MODUL=MODUL');
    Add(sMAGPROTOTYP+'='+sMAGPROTOTYP);}
  end;
end;

procedure TZLEKryteriaDBDetailForm.InitializeObjectFields;
var
  rProp: TUNISimpleEditorRichEditProperties;
begin
  FParser := TZLEParser.Create(Self, True, True);
  with FParser do begin
    bSymulacja := False;
    if vWielofirmowosc then iFirmaID:= vAktywnaFirma;
    iOkresNr:= 1;
    sRok:= UNISysDM.vAktywnyRokObrachunkowy;
    sRokId:= inttostr(UNISysDM.vAktywnyRokObrachunkowyID);
  end;

  CreateFunctionList2;
  CreateParamKindList2;
  FParamValuesList2 := TUNIStringList.Create();

  ZeroMemory(Addr(rProp), sizeof(rProp));
  rProp.pFun1   := GetFunctionsList2;
  rProp.pFun2   := GetAdditionalHint2;
  rProp.pFun3   := GetCurrWordHint2;
  rProp.oParent := RegulaPanel;
  rProp.iTop    := 8; //RegulaLabel.Top+10;
  rProp.iLeft   := 8;
  rProp.iWidth  := RegulaPanel.Width - 16;
  rProp.iHeight := RegulaPanel.Height - 16;
  rProp.bWordWrap := true;
  FRichEdit2 := TUNISimpleEditorRichEdit.Create(self);

  {Skadniki mona edytowa gdy nie ma jeszcze tabeli ani mnemonika utworzonego}
  if not (OpenMode in [omNew, omEdit]) then
    FRichEdit2.Enabled := false;
  //StworzListy2;
  FRichEdit2.SetProperties(rProp);

  FRichEdit2.TabOrder := 0;
  FRichEdit2.Visible := true;
//  FRichEdit2.Align := alClient;
  FRichEdit2.RealOnEnter := RichEventOnEnter2;
  FRichEdit2.RealOnExit := RichEventOnExit2;
  FRichEdit2.OnChange := RichEditChange2;

  //FRichEdit2.Text := DMAQFbN(sZLEKRYTERIA_REGULA).AsString; //MAGDM.vMAGTrescRegula;
  //RegulaLabel.FocusControl := FRichEdit2;

(********
  FRichEdit2 := TUNISimpleEditorRichEdit.Create( Self );
  with FRichEdit2 do begin
    SetFunctions(GetFunctionsList2, GetAdditionalHint2);
    SetProperties( Self.RegulaPanel, 0, 0, 0, 0, True );
    Align := alClient;
    WordWrap := False;
  end;
  if OpenMode in [omView,omDelete] then FRichEdit2.ReadOnly := true;
********)

  //FRichEdit2.Text := DMAQFbN(sZLEKRYTERIA_REGULA).AsString; //MAGDM.vMAGTrescRegula;
  //RegulaLabel.FocusControl := FRichEdit2;

  with SlownikLookupAliasEdit do begin
    AliasManager := UniSysDM.AliasManager;
    Alias_ID := sFKAlias_Mnemoniki_ID;
    Alias_Name := sFKAlias_Mnemoniki_Nazwa;
    AdditionalAliases := sFKAlias_Mnemoniki_Tabela + ';' +
                         sFKALIAS_MNEMONIKI_MNEMONIK + ';' +
                         sFKALIAS_MNEMONIKI_DLUGOSC + ';' +
                         sFKALIAS_MNEMONIKI_LOKALIZACJA;
  end;

  WykorzystajMnemonikDBCheckBox.Enabled := (OpenMode = omNew);
 // SlownikLookupAliasEdit.Enabled := (OpenMode = omNew);
  KryteriaOkresoweDBCheckBox.Enabled := False; {Na razie tylko obsuga okresowych}
  SymbolDBEdit.Dictionary:= sUNICONST_SLOWNIK_SYMBOL;
end;

procedure TZLEKryteriaDBDetailForm.CancelButtonClick(Sender: TObject);
begin
  if (FRichEdit2.Enabled)and(FRichEdit2.CloseListBoxIfVisible()) then ;

    //nie rb nic
  //else inherited;
  inherited;
end;

function TZLEKryteriaDBDetailForm.CheckRegula2;
var s: String;
begin
  result := false;
  if FParser.ScriptCheck('Test', FRichEdit2.Lines, False) = 0 then begin
    s := '';
    case VarType(FParser.ResultOfScript) of
      varSmallint, varInteger: s := IntToStr(FParser.ResultOfScript);
      varSingle, varDouble, varCurrency: s := FloatToStr(FParser.ResultOfScript);
      varDate: s := DateToStr(FParser.ResultOfScript);
      varBoolean: if FParser.ResultOfScript = True then s := 'TRUE' else s := 'FALSE';
      varString: s := FParser.ResultOfScript;
    end;
    result := true;
    if not bBezKomentarzy then Komunikat(cInformation, 'Regua jest poprawna: ' + s);
  end else begin
    FRichEdit2.SetFocus;
    FRichEdit2.SelStart := FParser.Errors[FParser.Errors.Count - 1].Position;
    FRichEdit2.SelLength := FParser.Errors[FParser.Errors.Count - 1].Size;
    Komunikat(
      cWarning,
      'Linia: ' + IntToStr(FParser.Errors[FParser.Errors.Count - 1].Line) + '. ' +
      'Kolumna: ' + IntToStr(FParser.Errors[FParser.Errors.Count - 1].Column) + '. ' +
      FParser.Errors[FParser.Errors.Count - 1].ErrorMessage
    );
  end;
end;

procedure TZLEKryteriaDBDetailForm.AktualizujWarunki(iKrytID: Integer);
var
  k: Integer;
  iID: Integer;
  q, qUpdate, qInsert: TUNIQuery;
begin
   {   OmNew - zapis nowych warunkw,
       omEdit aktualizacja
       omDelete - usunicie warunkw dla kryterium}

   if OpenMode = omDelete then begin
      SQLManager.ExecuteQuery('DELETE FROM %s ' +
                              'WHERE ' + sZLEKRYTERIA_ID + '=' + IntToStr(iKrytID),
                              [sZLEKRYTERIAWAR]);
   end else begin
     for k := 0 to FWarunki.Count - 1 do begin
        q := SQLManager.CreateQuery('SELECT ' + sZLEKRYTERIAWAR_ID + ' ' +
                                    'FROM %s ' +
                                    'WHERE ' + sZLEKRYTERIA_ID + '=' + IntToStr(iKrytID) + ' AND ' +
                                               sFKMNEMONIKI_ID + '=' + IntToStr(FWarunki.Items[k].FKMnemonikiID),
                                    [sZLEKRYTERIAWAR]);

        iID := -1;
        try
          q.Open;
          if not q.IsEmpty then
             iID := q.FieldByName(sZLEKRYTERIAWAR_ID).AsInteger;
        finally
           if q <> nil then FreeAndNil(q);
        end;

        if iID > 0 then begin
           {Update}
           qUpdate := SQLManager.UpdateQueryStep1(sZLEKRYTERIAWAR,
                                                  sZLEKRYTERIAWAR_LISTA_ID + ',' +
                                                  sZLEKRYTERIAWAR_UZ_ZM_ID + ',' +
                                                  sZLEKRYTERIAWAR_DATA_ZM,
                                                  sZLEKRYTERIAWAR_ID + '=' + IntToSTr(iID));

           qUpdate.ParamByName(sZLEKRYTERIAWAR_LISTA_ID).DataType := ftString;
           qUpdate.ParamByName(sZLEKRYTERIAWAR_UZ_ZM_ID).DataType := ftInteger;
           qUpdate.ParamByName(sZLEKRYTERIAWAR_DATA_ZM).DataType  := ftDateTime;

           qUpdate.ParamByName(sZLEKRYTERIAWAR_LISTA_ID).AsString  := FWarunki.Items[k].ListaID;
           qUpdate.ParamByName(sZLEKRYTERIAWAR_UZ_ZM_ID).AsInteger := SecurityManager.UserID;
           qUpdate.ParamByName(sZLEKRYTERIAWAR_DATA_ZM).AsDateTime := UniNow;
           SQLManager.UpdateQueryStep2(qUpdate);
           if qUpdate <> nil then FreeAndNil(qUpdate);
        end else begin
           {Insert}
           qInsert := SQLManager.InsertQueryStep1(sZLEKRYTERIAWAR,
                                                  sZLEKRYTERIAWAR_ID + ',' +
                                                  sZLEKRYTERIA_ID + ',' +
                                                  sFKMNEMONIKI_ID + ',' +
                                                  sZLEKRYTERIAWAR_LISTA_ID + ',' +
                                                  sZLEKRYTERIAWAR_UZ_AU_ID + ',' +
                                                  sZLEKRYTERIAWAR_DATA_AU);

           qInsert.ParamByName(sZLEKRYTERIAWAR_ID).DataType       := ftInteger;
           qInsert.ParamByName(sZLEKRYTERIA_ID).DataType          := ftInteger;
           qInsert.ParamByName(sFKMNEMONIKI_ID).DataType          := ftInteger;
           qInsert.ParamByName(sZLEKRYTERIAWAR_LISTA_ID).DataType := ftString;
           qInsert.ParamByName(sZLEKRYTERIAWAR_UZ_AU_ID).DataType := ftInteger;
           qInsert.ParamByName(sZLEKRYTERIAWAR_DATA_AU).DataType  := ftDateTime;

           qInsert.ParamByName(sZLEKRYTERIA_ID).AsInteger          := iKrytID;
           qInsert.ParamByName(sFKMNEMONIKI_ID).AsInteger          := FWarunki.Items[k].FKMnemonikiID;
           qInsert.ParamByName(sZLEKRYTERIAWAR_LISTA_ID).AsString  := FWarunki.Items[k].ListaID;
           qInsert.ParamByName(sZLEKRYTERIAWAR_UZ_AU_ID).AsInteger := SecurityManager.UserID;
           qInsert.ParamByName(sZLEKRYTERIAWAR_DATA_AU).AsDateTime := UniNow;
           SQLManager.InsertQueryStep2(qInsert, sZLEKRYTERIAWAR_ID);
           if qInsert <> nil then FreeAndNil(qInsert);
        end;
     end;
   end;
end;

procedure TZLEKryteriaDBDetailForm.SelectButtonClick(Sender: TObject);
var
  iAktKryteriaID: Integer;
begin
  if DMAQFbN(sZLEKRYTERIA_ID).IsNull then
     DMAQFbN(sZLEKRYTERIA_ID).AsInteger := UniqueKey[sZLEKRYTERIA];

  iAktKryteriaID := DMAQFbN(sZLEKRYTERIA_ID).AsInteger;

  if (openMode in [OmNew, omEdit]) then begin
     if (not Validate) then begin
        if (OpenMode = omNew) then FRichEdit1.SetFocus; //FDoEvents := True;
        Exit;
     end;

     if DMAQFbN(sZLEKRYTERIA_SKLADNIKI).AsString <> FRegula1 then
        DMAQFbN(sZLEKRYTERIA_SKLADNIKI).AsString := FRegula1;

     if DMAQFbN(sZLEKRYTERIA_REGULA).AsString <> FRegula2 then
        DMAQFbN(sZLEKRYTERIA_REGULA).AsString := FRegula2;

     if DMAQFbN(sZLEKRYTERIA_OGRANICZ).AsString <> FRegula3 then
        DMAQFbN(sZLEKRYTERIA_OGRANICZ).AsString := FRegula3;

  end;

  inherited;
  if OpenMode in [omNew, omEdit, omDelete] then
     AktualizujWarunki(iAktKryteriaID);
end;

function TZLEKryteriaDBDetailForm.TypZleceniaDBLookupAliasEditGetDataField: String;
begin
  result := sZLETYPZLEC_ID;
end;

function TZLEKryteriaDBDetailForm.TypZleceniaDBLookupAliasEditGetQuery: TUNIQuery;
begin
  result := ZLEDM.ZLEPokazIObsluzTypZlecenia( sZLEALIAS_TYPZLECENIA_ID + ';' +
                                              sZLEALIAS_TYPZLECENIA_SYMBOL{ + ';' +
                                              sZLEALIAS_TYPZLECENIA_OPIS},
                                              '',
                                              false, false,
                                              0,
                                              DMAQFbN(sZLETYPZLEC_ID).AsInteger,
                                              vAktywnaFirma );
end;

procedure TZLEKryteriaDBDetailForm.TypZleceniaDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with TypZleceniaDBLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_ID := sZLEALIAS_TYPZLECENIA_ID;
    Alias_Name := sZLEALIAS_TYPZLECENIA_SYMBOL;
//    AdditionalAliases := sZLEALIAS_TYPZLECENIA_OPIS;
  end;
end;

function TZLEKryteriaDBDetailForm.TypZleceniaDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  inherited;
  if OpenMode = omNew then begin
     UsunListy1;
     StworzListy1;
     UsunListy2;
     StworzListy2;
  end;

  result := True;
end;

procedure TZLEKryteriaDBDetailForm.RegulaPanelResize(Sender: TObject);
begin
  inherited;
  if (FRichEdit2 <> nil) and (RegulaPanel <> nil) then
     FRichEdit2.Width := RegulaPanel.Width - 16;
end;

procedure TZLEKryteriaDBDetailForm.SkladowePanelResize(Sender: TObject);
begin
  inherited;
  if (FRichEdit1 <> nil) and (SkladowePanel <> nil) then
     FRichEdit1.Width := SkladowePanel.Width - (2 * SkladoweLabel.Left);
  //Komunikat(cInformation, 'Zmiana wielkosci panelu Skladowe');
end;

procedure TZLEKryteriaDBDetailForm.CheckButtonClick(Sender: TObject);
begin
  inherited;
  CheckRegula2();
end;

procedure TZLEKryteriaDBDetailForm.Slownik0LookupAliasEditButtonClick(
  Sender: TObject);
begin
  inherited;
  { --- }
end;

function TZLEKryteriaDBDetailForm.Slownik0LookupAliasEditSetData(
  Sender: TObject; AliasSrc: TDataSet): Boolean;
begin
  inherited;
  { --- }
  result  := true;
end;

procedure TZLEKryteriaDBDetailForm.Slownik0LookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  { --- }
end;

procedure TZLEKryteriaDBDetailForm.SlownikLookupAliasEditButtonClick(
  Sender: TObject);
var
  Q: TUNIQuery;
  sWarunek: string;
begin
  sWarunek := '';
  Q := UNISYSDataManager.UNIPokazIObsluzDane(
    sFKMNEMONIKI {sTabela},
    sWarunek     {sWarunek: string},
    False        {bBlok},
    False        {bWyborWielu: boolean},
    sFKALIAS_MNEMONIKI_ID + ';' +
    sFKALIAS_MNEMONIKI_NAZWA +';' +
    sFKAlias_Mnemoniki_Tabela + ';' +
    sFKALIAS_MNEMONIKI_MNEMONIK + ';' +
    sFKALIAS_MNEMONIKI_DLUGOSC + ';' +
    sFKALIAS_MNEMONIKI_LOKALIZACJA {sAtrybuty: string},
    vAktywnaFirma {iFirmaID: integer},
    IntToStr(DodatkiGetIntegerValue(Datamodule.ActiveQuery, sFKMNEMONIKI_ID))
  );
  if Q <> NIL then try
     SlownikLookupAliasEditSetData(Q);
  finally
    Q.Free;
  end;
end;

procedure TZLEKryteriaDBDetailForm.SlownikLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  DMAQFbN(sFKMNEMONIKI_ID).Clear;
  MnemonikEdit.Text := '';
  TabelaEdit.Text   := '';
  SlownikLookupAliasEdit.Text := '';
end;

function TZLEKryteriaDBDetailForm.SlownikLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  inherited;
  Result:= True;
  if AliasSrc <> nil then begin
    if DMAQFbN(sFKMNEMONIKI_ID).AsInteger <> AliasSrc.FieldByName(sFKMNEMONIKI_ID).AsInteger then begin
       if (AliasSrc.FieldByName(sFKMNEMONIKI_LOKALIZACJA).AsString <> 'ZLE') or
          ((Copy(AliasSrc.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString, 1, 2) <> 'XX') and
           (Copy(AliasSrc.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString, 1, 2) <> 'XY')) then begin
          Komunikat(cWarning, 'Mona wybra tylko mnemoniki z zakresu XXA-XYZ');
       end else begin
          if (OpenMode = omNew) then begin
             if SprawdzDlugoscMnemonika(AliasSrc.FieldByName(sFKMNEMONIKI_DLUGOSC).AsInteger) then begin
               DMAQFbN(sFKMNEMONIKI_ID).AsInteger := AliasSrc.FieldByName(sFKMNEMONIKI_ID).AsInteger;
               SlownikLookupAliasEdit.Text := AliasSrc.FieldByName(sFKMNEMONIKI_NAZWA).AsString;
               MnemonikEdit.Text := AliasSrc.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString;
               TabelaEdit.Text   := AliasSrc.FieldByName(sFKMNEMONIKI_TABELA).AsString;
               FDlugosc := AliasSrc.FieldByName(sFKMNEMONIKI_DLUGOSC).AsInteger;
             end;
          end;
       end;
    end;
  end;
end;

procedure TZLEKryteriaDBDetailForm.WykorzystajMnemonikDBCheckBoxClick(
  Sender: TObject);
begin
  inherited;
  { --- Uaktywnienie moliwoci wyboru mnemonika ----}
  if OpenMode = omNew then begin
     SlownikLookupAliasEdit.Enabled := WykorzystajMnemonikDBCheckBox.Checked;// not SlownikLookupAliasEdit.Enabled;
  end;
end;

initialization
  FormManager.RegisterForm(TZLEKryteriaDBDetailForm, sZLEModulID);
end.
