unit ZLEKryteriaDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2008-01-24 Tomjen   Utworzenie
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls, UNIStaleUnit,  UNIDataModuleUnit, UNIFormUnit, KeyManagerUnit;

type
  TZLEKryteriaDBGridForm = class(TUNIDBGridForm)
    PozycjeButton: TUNIButton;
    PrzeliczButton: TUNIButton;
    procedure PozycjeButtonClick(Sender: TObject);
    procedure PrzeliczButtonClick(Sender: TObject);
  protected
    function  CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure InternalOpen; override;
    procedure BeforeShow; override;
    procedure View;   override;
    procedure New;    override;
    procedure Open;   override;
    procedure Delete; override;
    procedure SetUserRights; override;
  public
    function GetHelpContextSuffix: String; override;
  end;

var
  ZLEKryteriaDBGridForm: TZLEKryteriaDBGridForm;

implementation
uses
  FormManagerUnit,
  SQLManagerUnit,
  Dodatki,
  ZLEKryteriaOkresoweSelectFormUnit,
  ZLEKryteriaUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit,
  UNISysDataManagerUnit,
  SecurityManagerUnit;

{$R *.DFM}

function TZLEKryteriaDBGridForm.GetHelpContextSuffix: String;
{ przyrostki do obs-ugi:
 KZ                                       zlecenia             2.3                  Definicja Typw Zlece
 KRYTERIA                                 zlecenia             2.6                  Kryteria
}
begin
  result := ''; {Na razie tak uzgodniono z Ania Ciucias}
end;

function  TZLEKryteriaDBGridForm.CreateDataModule(
                                 const AOpenMode:  TOpenMode): TUNIDataModule;
begin
  result := TZLEKryteriaDataModule.CreateOpen(self, nil, AOpenMode);
end;

procedure TZLEKryteriaDBGridForm.InternalOpen;
begin
  if (OpenModeFlags and omContained) = omContained then
    Switch_View_HotKey(false);
  inherited;
end;

procedure TZLEKryteriaDBGridForm.BeforeShow;
begin
  inherited;
end;

procedure TZLEKryteriaDBGridForm.View;
begin
  FormManager.OpenDBDetail(self, 'TZLEKryteriaDBDetailForm', omView + omShowModal);
end;

procedure TZLEKryteriaDBGridForm.New;
begin
  FormManager.OpenDBDetail(self, 'TZLEKryteriaDBDetailForm', omNew + omShowModal);
end;

procedure TZLEKryteriaDBGridForm.Open;
begin
  FormManager.OpenDBDetail(self, 'TZLEKryteriaDBDetailForm', omEdit + omShowModal);
end;

procedure TZLEKryteriaDBGridForm.Delete;
begin
  FormManager.OpenDBDetail(self, 'TZLEKryteriaDBDetailForm', omDelete + omShowModal);
end;

procedure TZLEKryteriaDBGridForm.SetUserRights;
begin
  inherited;
  with SecurityManager do begin
    Switch_View_HotKey(SM_UserCanDo(sZLE_USTAW_KRYTERIA_POKAZ));
    Switch_New_HotKey(SM_UserCanDo(sZLE_USTAW_KRYTERIA_DOPISZ));
    Switch_Open_HotKey(SM_UserCanDo(sZLE_USTAW_KRYTERIA_ZMIEN));
    Switch_Delete_HotKey(SM_UserCanDo(sZLE_USTAW_KRYTERIA_USUN));

    PrzeliczButton.Enabled := SM_UserCanDo(sZLE_USTAW_KRYTERIA_PRZELICZ);
    PozycjeButton.Enabled := SM_UserCanDo(sZLE_USTAW_KRYTERIA_POZYCJE);
  end;
end;

procedure TZLEKryteriaDBGridForm.PozycjeButtonClick(Sender: TObject);
var
  oParams: TKeyValues;
begin
  inherited;
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add(cFORM_CAPTION+'='+'Pozycje kryteriw');
    Add(cRangeClassName+'='+cKlasaKrytPoz+cSuffixKlasyRange);
    if DMAQFbN(sZLEKRYTERIA_ID).AsString <> '' then
       Add(sZLEKRYTERIA_ID+'='+IntToStr(DMAQFbN(sZLEKRYTERIA_ID).AsInteger));
  end;
  FormManager.OpenDBGrid(Self, 'TZLEKRYTPOZDBGridForm', omList, oParams);
end;

procedure TZLEKryteriaDBGridForm.PrzeliczButtonClick(Sender: TObject);
var
  Bookmark: TBookmark;
  i,j : integer;
  aKryteria, aOkresy: array of integer;
  oForm: TUNIForm;
  //sInformacja, sOkresy, sKryteria: string;
begin
  inherited;
  //sInformacja := '';
  //sOkresy := '';
  //sKryteria := '';
  if Komunikat(cConfirmation, PChar('Przeliczy wybrane kryteria ?'),MB_YESNO+MB_DEFBUTTON1+MB_ICONQUESTION) = IDYES then
  begin
    oForm := FormManager.OpenForm(self,'TZLEKryteriaOkresoweSelectForm', omHidden+omShowModal);
    with oForm do
    try
      try
        if ShowModal = mrOk then
        with (oForm as TZLEKryteriaOkresoweSelectForm) do
        begin
          SetLength(aOkresy,0);
          j:=0;
          //sOkresy := '';
          for i:= 0 to OkresyCheckListBox.Items.Count-1 do
          begin
            if OkresyCheckListBox.Checked[i] then
            begin
              SetLength(aOkresy, Length(aOkresy)+1);
              aOkresy[j]:= StrToInt(ListaIDOkresow[i]);
              {if sOkresy <> '' then sOkresy := sOkresy + ', ';
              sOkresy := sOkresy + ListaIDOkresow[i];}
              inc(j);
            end;
          end;
        end
        else exit;
      except
        raise;
      end;
    finally
      oForm.Free;
    end;

    if Length(DBGrid.MarkedRows) > 0 then
    begin
      Bookmark := DataModule.ActiveQuery.GetBookmark;
      DataModule.ActiveQuery.DisableControls;
      SetLength(aKryteria,Length(DBGrid.MarkedRows));
      for i:=0 to Length(DBGrid.MarkedRows) - 1 do begin
         aKryteria[i] := DBGrid.MarkedRows[i];
         {if sKryteria <> '' then sKryteria := sKryteria + ', ';
         sKryteria := sKryteria + IntToStr(DBGrid.MarkedRows[i]);}
     end;
      DataModule.ActiveQuery.GotoBookmark(Bookmark);
      DataModule.ActiveQuery.FreeBookmark(Bookmark);
      DataModule.ActiveQuery.EnableControls;
    end
    else
    begin
      SetLength(aKryteria,1);
      aKryteria[0] := DMAQFbN(sZLEKRYTERIA_ID).AsInteger;
      {sKryteria := IntToStr(DMAQFbN(sZLEKRYTERIA_ID).AsInteger);}
    end;

    {sInformacja := 'Zakoczono przeliczanie '#13;
    if Pos(',', sKryteria) > 0 then
       sInformacja := sInformacja + 'kryteriow ' + sKryteria + #13
    else sInformacja := sInformacja + 'kryterium ' + sKryteria + #13;

    if Pos(',', sOkresy) > 0 then
       sInformacja := sInformacja + 'w okresach ' + sOkresy
    else sInformacja := sInformacja + 'w okresie ' + sOkresy;}

    if ZLEDM.ZLEPrzeliczKryteria(aKryteria, aOkresy) > 0 then
      Komunikat(cError, 'Bd podczas obliczania wartoci kryterium !')
    else
      Komunikat(cInformation, 'Zakonczono przeliczanie wybranych kryteriow' {sInformacja});
  end;
end;

initialization
  FormManager.RegisterForm(TZLEKryteriaDBGridForm, sZLEModulID);
end.
