unit ZLEKryteriaOkresoweSelectFormUnit;
{
Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2008-02-05 Tomjen   Utworzenie
2009-06-17 ZzB      Rozszerzone wywoanie ZaladujListeOkresowObrachunkowych
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNISelectFormUnit, Menus, UNIComponentsUnit, ToolWin, ComCtrls, StdCtrls,
  ExtCtrls, CheckLst;

type
  TZLEKryteriaOkresoweSelectForm = class(TUNISelectForm)
    SlownikLabel: TUNILabel;
    OkresyCheckListBox: TUNICheckListBox;
    ZaznaczAllButton: TUNIButton;
    OdznaczAllButton: TUNIButton;
    OkresComboBox: TUNIComboBox;
    procedure FormCreate(Sender: TObject);
    procedure ZaznaczAllButtonClick(Sender: TObject);
    procedure OdznaczAllButtonClick(Sender: TObject);
  protected
    procedure BeforeShow; override;
  public
    ListaIDOkresow: TStringList;
  end;

var
  ZLEKryteriaOkresoweSelectForm: TZLEKryteriaOkresoweSelectForm;

implementation
uses
  Dodatki,
  UniSysDefUnit,
  UniStaleUnit,
  ZLEDefUnit,
  UNISysDataManagerUnit,
  FormManagerUnit;

{$R *.DFM}

procedure TZLEKryteriaOkresoweSelectForm.BeforeShow;
begin
  inherited;
  if OpenMode = omNew then OkresComboBox.ItemIndex := 0;
end;

procedure TZLEKryteriaOkresoweSelectForm.FormCreate(Sender: TObject);
var
  sOkres1 : string;
  i:integer;
begin
  inherited;
  ListaIDOkresow := TStringList.Create;
  if not UNISysDataManager.ZaladujListeOkresowObrachunkowych(OkresComboBox, ListaIDOkresow, IntToStr(vAktywnyRokObrachunkowyID), sOkres1, '',vAktywnaFirma) then
    Komunikat(cError, 'Bd !');
  OkresComboBox.ItemIndex := 0;
  for i:=0 to OkresComboBox.Items.Count - 1 do
    OkresyCheckListBox.Items.Add(OkresComboBox.Items[i]);
end;

procedure TZLEKryteriaOkresoweSelectForm.ZaznaczAllButtonClick(
  Sender: TObject);
var
  i: integer;
begin
  inherited;
  for i:=0 to OkresyCheckListBox.Items.Count -1 do
     OkresyCheckListBox.State[i] := cbChecked;
end;

procedure TZLEKryteriaOkresoweSelectForm.OdznaczAllButtonClick(
  Sender: TObject);
var
 i:integer;
begin
  inherited;
  for i:=0 to OkresyCheckListBox.Items.Count -1 do
     OkresyCheckListBox.State[i] := cbUnChecked;
end;

initialization
  FormManager.RegisterForm(TZLEKryteriaOkresoweSelectForm, sZLEModulID);
end.

