unit ZLEKryteriaUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2008-01-24 Tomjen   Utworzenie
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables{, UNIExtDataModuleUnit};

type
  TZLEKryteriaDataModule = class(TUNIDataModule)
  protected
    procedure GetKeys;                  override;
    function  GetTableName: string;     override;
    procedure InitializeGridQueryDefs;  override;
  public
    procedure Post;   override;
    procedure Delete; override;
  end;

var
  ZLEKryteriaDataModule: TZLEKryteriaDataModule;

implementation
uses
  Dodatki,
  SQLManagerUnit,
  UNIDataManagerUnit,
  QueryBuilderUnit,
  SystemDefUnit,
  SecurityManagerUnit,
  UNIStaleUnit,
  UNIFormUnit,
  KeyManagerUnit,
  UNISysDefUnit,
  ZLEDataManagerUnit,
  FKDefUnit,
  INFDefUnit,
  ZLEDefUnit;

{$R *.DFM}

procedure TZLEKryteriaDataModule.GetKeys;
begin
  FKeys.Add(sZLEKRYTERIA_ID);
end;

function  TZLEKryteriaDataModule.GetTableName: string;
begin
  result  := sZLEKRYTERIA;
end;

procedure TZLEKryteriaDataModule.InitializeGridQueryDefs;
begin
  with GridColDefs do
  begin
    Clear;
    AddRequiredAndUnvisible(sZLEKRYTERIA_ID, 'KR', '');
    AddRequiredAndUnvisible(sFKMNEMONIKI_ID, 'KR', '');
    if vWielofirmowosc then
       AddRequiredAndUnvisible(sUNIODDZIAL_ID, 'KR', '');

    AddRequiredAndUnvisible(sINFCONST_OBIEKT_ID, 'KR', '');
    Add(sZLEKRYTERIA_SYMBOL , 'KR', 'Symbol' , true , true , taLeftJustify, 80);
    Add(sZLEKRYTERIA_NAZWA  , 'KR', 'Nazwa'  , true , true , taLeftJustify, 100);
    Add(sZLEKRYTERIA_SKLADNIKI  , 'KR', 'Skadniki'  , true , true , taLeftJustify, 100);
    Add(sZLEKRYTERIA_REGULA  , 'KR', 'Regua'  , true , true , taLeftJustify, 100);
    Add(sZLEKRYTERIA_OGRANICZ , 'KR', 'Ograniczenia'  , true , true , taLeftJustify, 100);
    Add(sZLEKRYTERIA_OKRESOWE  , 'KR', 'Okresowe'  , true , true , taLeftJustify, 100);
    Add(sFKMNEMONIKI_MNEMONIK , 'F', 'Mnemonik' , true , true , taLeftJustify, 80);
    Add(sFKMNEMONIKI_TABELA  , 'F', 'Tabela'  , true , true , taLeftJustify, 80);
    Add(sZLEKRYTERIA_ISTN_MNEMONIK, 'KR', 'Czy istniejcy mnemonik', true , true , taLeftJustify, 30);

    if DataManagers.Available(sINFModulID) then
       Add(sINFCONST_OBIEKT_V  , 'I', 'Obiekt infrastruktury', true , true , taLeftJustify, 80);
  end;
  with GridTabDefs do
  begin
    Clear;
    Add('KR', TableName);
    Add('F', sFKMNEMONIKI);
    if DataManagers.Available(sINFModulID) then
       Add('I', sINFCONST_OBIEKT);
  end;
  with GridJoinDefs do
  begin
    Clear;
    AddExpres('KR.'+sFKMNEMONIKI_ID +'='+'F.' +sFKMNEMONIKI_ID, qjkLeftOuter, True);

    if DataManagers.Available(sINFModulID) then
       AddExpres('KR.'+sINFCONST_OBIEKT_ID +'='+'I.' +sINFCONST_OBIEKT_ID, qjkLeftOuter, True);

    if vWielofirmowosc then
      AddCondition('KR.'+sUNIODDZIAL_ID +'='+IntToStr(vAktywnaFirma), true);;
  end;
  inherited;
end;


procedure TZLEKryteriaDataModule.Post;
var
  bTrans: boolean;
  sMnem: String;
  iFkMnem: Integer;
begin
  bTrans  := not SQLManager.InTransaction;
  if bTrans then SQLManager.StartTransaction;
  try
    if OpenMode in [omNew, omEdit] then
      if vWielofirmowosc then
        ActiveQuery.FieldByName(sUNIODDZIAL_ID).AsInteger := vAktywnaFirma;

    if (OpenMode = OmNew) and (ActiveQuery.FieldByName(sZLEKRYTERIA_ISTN_MNEMONIK).AsString = 'N') then begin
       sMnem := ZLEDM.ZlePodajNastepnyMnemonik();
       {2. Mnemonik}
       iFkMnem := ZLEDM.ZLEDopiszMnemonik(sMnem, ActiveQuery.FieldByName(sZLEKRYTERIA_SKLADNIKI).AsString, False {bPola: Boolean});
       ActiveQuery.FieldByName(sFKMNEMONIKI_ID).AsInteger := iFkMnem;
    end;

    inherited;
    if bTrans then SQLManager.Commit;
  except
    if bTrans then SQLManager.Rollback;
    if (OpenMode = omNew) and (ActiveQuery.FieldByName(sZLEKRYTERIA_ISTN_MNEMONIK).AsString = 'N') then begin
       if SQLManager.SprawdzIstnienieTabeli(sZLEModulID + sMnem) then
          SQLManager.ExecuteQuery('DROP TABLE %s', [sZLEModulID + sMnem]);
       SQLManager.ExecuteQuery('DELETE FROM %s ' +
                               'WHERE ' +sFKMNEMONIKI_MNEMONIK + '=' + QuotedStr(sMnem),
                               [sFKMNEMONIKI]);
    end;
    raise;
  end;
end;

procedure TZLEKryteriaDataModule.Delete;
var
  bTrans: boolean;
  sMnemTab, sCzyIstniejacyMnem: String;
  iFkMnem: Integer;
begin
  bTrans  := not SQLManager.InTransaction;
  if bTrans then SQLManager.StartTransaction;
  try
    {
      DELETE FROM zlekryteriawar WHERE zlekryteria_id=61;
      DELETE FROM zlekryteria WHERE zlekryteria_id=61;
      DELETE FROM fkmnemoniki WHERE fkmnemoniki_tabela='ZLEXXB';
      DROP TABLE ZLEXXB;
    }
    sCzyIstniejacyMnem := ActiveQuery.FieldByName(sZLEKRYTERIA_ISTN_MNEMONIK).AsString;
    if (sCzyIstniejacyMnem = 'N') then begin
        iFkMnem := ActiveQuery.FieldByName(sFKMNEMONIKI_ID).AsInteger;
        sMnemTab := SQLManager.OpenQueryWithResult('SELECT ' + sFKMNEMONIKI_TABELA + ' ' +
                          'FROM %s ' +
                          'WHERE ' + sFKMNEMONIKI_ID + '=' + IntToStr(iFkMnem) + ' AND ' +
                                     sFKMNEMONIKI_INDEKS + '= 0',
                          [sFKMNEMONIKI]);
    end;

    SQLManager.ExecuteQuery('DELETE FROM %s ' +
                            'WHERE ' + sZLEKRYTERIA_ID + '=' + IntToStr(ActiveQuery.FieldByName(sZLEKRYTERIA_ID).AsInteger),
                            [sZLEKRYTERIAWAR]);

    inherited; //Usuniecie kryterium
    if (sCzyIstniejacyMnem = 'N') then begin
        SQLManager.ExecuteQuery('DELETE FROM %s ' +
                                'WHERE ' +sFKMNEMONIKI_TABELA + '=' + QuotedStr(sMnemTab),
                                [sFKMNEMONIKI]);

        if SQLManager.SprawdzIstnienieTabeli(sMnemTab) then
           SQLManager.ExecuteQuery('DROP TABLE %s', [sMnemTab]);
    end;

    if bTrans then SQLManager.Commit;
  except
    if bTrans then SQLManager.Rollback;
    raise;
  end;
end;

end.
