unit ZLEOsobyDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Modu dostarczajcy aktualizacje bazy.
Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2007-11-19 Tomjen   Utworzone
---------------------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls, UNIStaleUnit, UNIDataModuleUnit;

type
  TZLEOsobyDBGridForm = class(TUNIDBGridForm)
    procedure NewMenuItemClick(Sender: TObject);
    procedure DeleteMenuItemClick(Sender: TObject);
  private
   // procedure OpenDetail(AOpenMode: TOpenMode);
//    procedure Detail(OpenMode: TOpenMode);
  protected
    procedure BeforeShow; override;
    procedure New(); override;
    procedure Delete(); override;
    function  CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure SetUserRights; override;
  public
    procedure UstawPrzyciski;
    procedure InternalOpen(); override;
  end;

var
  ZLEOsobyDBGridForm: TZLEOsobyDBGridForm;

implementation

uses
  Dodatki,
  FormManagerUnit,
  SecurityManagerUnit,
  UNIDBDetailFormUnit,
  KeyManagerUnit,
  ZLEDefUnit,
  ZleOsobyUnit,
  ZLEDataManagerUnit,
  ZLEZasobyPracaDBDetailFormUnit,
  UNISysDefUnit;


{$R *.DFM}

function TZleOsobyDBGridForm.CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZleOsobyDataModule.CreateOpen(Self, DefaultMasterKeyValues, AOpenMode);
  SwitchOffColumnsEditorToolButton;
end;

procedure TZleOsobyDBGridForm.Delete;
begin
  inherited;
  UstawPrzyciski;
end;

procedure TZleOsobyDBGridForm.UstawPrzyciski;
begin
  if FormIsContained then begin
    (Owner as TZleZasobyPracaDBDetailForm).UsunButton.Enabled   := (DeleteMenuItem.Visible and DeleteMenuItem.Enabled);
    (Owner as TZleZasobyPracaDBDetailForm).DopiszButton.Enabled := (NewMenuItem.Visible    and NewMenuItem.Enabled);
  end;
end;

procedure TZleOsobyDBGridForm.InternalOpen;
begin
  if Parameters <> nil then
     if Parameters.Values[cFORM_CAPTION] <> '' then
        Caption := Parameters.Values[cFORM_CAPTION];
  inherited;
end;

procedure TZleOsobyDBGridForm.New;
begin
  (owner as TZLEZasobyPracaDBDetailForm).DopiszOsobe();
  UstawPrzyciski;
end;

{procedure TZleOsobyDBGridForm.OpenDetail(AOpenMode: TOpenMode);
var
  oParams: TKeyValues;
begin
  oParams := Nil;
  inherited;
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add(cFORM_CAPTION+'='+'Szczegy osb dla zasobu');
  end;

  if FormIsContained then
       AOpenMode := AOpenMode or omOverVirtual or omShowModal;

  FormManager.OpenDBDetail(Self, 'TZleOsobyDBDetailForm', AOpenMode, oParams);
end;}

procedure TZleOsobyDBGridForm.SetUserRights;
begin
  with SecurityManager do begin
    Switch_View_HotKey(False);
    Switch_New_HotKey(SM_UserCanDo(sZLE_REJ_CZASU_PRACY_DOPISZ));
    Switch_Open_HotKey(False);
    Switch_Delete_HotKey(SM_UserCanDo(sZLE_REJ_CZASU_PRACY_USUN));
  end;
end;

procedure TZLEOsobyDBGridForm.NewMenuItemClick(Sender: TObject);
begin
  New();
end;

procedure TZLEOsobyDBGridForm.DeleteMenuItemClick(Sender: TObject);
begin
  Delete();
end;

procedure TZLEOsobyDBGridForm.BeforeShow;
begin
  inherited;
  if Owner is TZLEZasobyPracaDBDetailForm then begin
    ViewMenuItem.Visible := False;
    ViewMenuItem.Enabled := False;

    EditMenuItem.Visible := False;
    EditMenuItem.Enabled := False;
    UstawPrzyciski;
  end;
end;

initialization
  FormManager.RegisterForm( TZleOsobyDBGridForm, 'Rejestracja osb dla zasobu', sZLEModulID );
end.
