unit ZLEOsobyGodzPrzeliczSelectFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2008-04-09 Tomjen   Utworzone
---------------------------------------------------------------------------------------------
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNISelectFormUnit, Menus, UNIComponentsUnit, ToolWin, ComCtrls, StdCtrls,
  ExtCtrls, Mask, DBGrids, DBCtrls, DBClient, Db, DBTables;

type
  TZLEOsobyGodzPrzeliczSelectForm = class(TUNISelectForm)
    OkresLookupAliasEdit: TUNILookupAliasEdit;
    OkresLabel: TUNILabel;
    JednOrgLabel: TUNILabel;
    JednostkaOrgLookupAliasEdit: TUNILookupAliasEdit;
    procedure OkresLookupAliasEditButtonClick(Sender: TObject);
    function  OkresLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure OkresLookupAliasEditDelKey(Sender: TObject);

    procedure JednostkaOrgLookupAliasEditButtonClick(Sender: TObject);
    procedure JednostkaOrgLookupAliasEditDelKey(Sender: TObject);
    function JednostkaOrgLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
  private
    iJednostkaID: Integer;
    iOkresID  : Integer;
  protected
    procedure BeforeShow; override;
    procedure InternalOpen; override;
    procedure SelectButtonPressed; override;
  public
    function  Validate(): Boolean; override;
  end;

var
  ZLEOsobyGodzPrzeliczSelectForm: TZLEOsobyGodzPrzeliczSelectForm;

implementation
uses
  SQLManagerUnit,
  SecurityManagerUnit,
  UNISysDefUnit,
  Dodatki,
  UniSysDataManagerUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit,
  FormManagerUnit;

{$R *.DFM}

procedure TZLEOsobyGodzPrzeliczSelectForm.SelectButtonPressed;
begin
  if Parameters <> nil then begin
     Parameters.Values[sUNIJEDNOSTKAORG_ID] := IntToStr(iJednostkaID);
     Parameters.Values[sUNIOKRES_ID]        := IntToStr(iOkresID);
  end;
  inherited;
end;

function TZLEOsobyGodzPrzeliczSelectForm.Validate: Boolean;
begin
  result := inherited Validate();
  if not result then Exit;

  if iJednostkaID <= 0 then begin
     Komunikat(cInformation, 'Nie wypeniona jednostka organizacyjna');
     JednostkaOrgLookupAliasEdit.SetFocus;
     ModalResult := mrNone;
     Exit;
  end;

  if iOkresID <= 0 then begin
     Komunikat(cInformation, 'Nie wypeniony okres');
     OkresLookupAliasEdit.SetFocus;
     ModalResult := mrNone;
     Exit;
  end;

end;

procedure TZLEOsobyGodzPrzeliczSelectForm.InternalOpen;
begin
  iJednostkaID := -1;
  iOkresID := -1;
  inherited;
end;

procedure TZLEOsobyGodzPrzeliczSelectForm.BeforeShow;
begin
  inherited;

  with JednostkaOrgLookupAliasEdit do begin
    AliasManager := UnisysDM.AliasManager;
    Alias_Id     := sUNISysAlias_JednostkaOrg_ID;
    Alias_Name   := sUNISysAlias_JednostkaOrg_Symbol;
    AdditionalAliases := sUNISysAlias_JednostkaOrg_Nazwa;
    aAllowEmpty  := False;
  end;

  with OkresLookupAliasEdit do begin
    AliasManager      := UniSysDataManager.AliasManager;
    Alias_ID          := sUNISYSALIAS_Okres_Obrachunkowy_ID;
    Alias_Name        := sUNISYSALIAS_Okres_Obrachunkowy_Nazwa;
    AdditionalAliases := sUNISYSALIAS_Okres_Obrachunkowy_Rok;
    AdditionalCondition :=
      '@' + sUNISYSALIAS_Okres_Obrachunkowy_Rok_ID + ' = ' + IntToStr(vAktywnyRokObrachunkowyID);
  end;  // with OkresLookupAliasEdit

  iJednostkaID := -1;
  iOkresID := -1;
  ActiveControl := JednostkaOrgLookupAliasEdit;
end;

procedure TZLEOsobyGodzPrzeliczSelectForm.OkresLookupAliasEditButtonClick(
  Sender: TObject);
var
  Q:  TDataset;
begin
  Q:= UNISysDM.UNIPokazIWybierzOkresObrachunkowy(
    vAktywnyRokObrachunkowyID,'',
    sUNISYSALIAS_Okres_Obrachunkowy_ID+';'+sUNISYSALIAS_Okres_Obrachunkowy_Nazwa + ';' +sUNISYSALIAS_Okres_Obrachunkowy_Rok,
    false{, IntToStr_ZeroToEmpty(iOkresID)});
  if Q<> nil then
  try
    OkresLookupAliasEditSetData(Q);
  finally
    Q.free;
  end;
end;

function TZLEOsobyGodzPrzeliczSelectForm.OkresLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  result:= true;
  with AliasSrc do begin
    iOkresID := Fields[0].AsInteger;
    OkresLookupAliasEdit.Text:= Fields[1].AsString;
  end;
end;

procedure TZLEOsobyGodzPrzeliczSelectForm.OkresLookupAliasEditDelKey(
  Sender: TObject);
begin
  iOkresID := -1;
  OkresLookupAliasEdit.Text:= '';
end;

procedure TZLEOsobyGodzPrzeliczSelectForm.JednostkaOrgLookupAliasEditButtonClick(
  Sender: TObject);
var
  Q: TUNIQuery;
begin
  Q := UniSysDM.UNIPokazIObsluzDane(
    sUNIJEDNOSTKAORG,
    '',
    False,
    False,
    sUNISysAlias_JednostkaOrg_ID + ';' + sUNISysAlias_JednostkaOrg_Symbol + ';' +sUNISysAlias_JednostkaOrg_Nazwa,
    0,
    sUNIJEDNOSTKAORG_ID + '=' + IntToStr(iJednostkaID)
  );
  if Q <> nil then
    try
      JednostkaOrgLookupAliasEditSetData(Q);
    finally
      Q.free;
    end;
end;

procedure TZLEOsobyGodzPrzeliczSelectForm.JednostkaOrgLookupAliasEditDelKey(
  Sender: TObject);
begin
  iJednostkaID := -1;
  JednostkaOrgLookupAliasEdit.Text := '';
end;

function TZLEOsobyGodzPrzeliczSelectForm.JednostkaOrgLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  result:= true;
  if AliasSrc <> nil then begin
     iJednostkaID := AliasSrc.FieldByName(sUNIJEDNOSTKAORG_ID).AsInteger;
     JednostkaOrgLookupAliasEdit.Text := AliasSrc.FieldByName(sUNIJEDNOSTKAORG_SYMBOL).AsString;
  end;
end;

initialization
  FormManager.RegisterForm(TZLEOsobyGodzPrzeliczSelectForm, sZLEModulID);
end.
