unit ZLEParserUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When     Who    What
---------------------------------------------------------------------------------------------
04-04-01 gdeyk  Utworzenie
}
{$I ..\!\defines.inc}

interface
uses
  DB,
  Classes,
  UniParserMainUnit,
  PLLIDefUnit,
  PLLIDataManagerExtUnit,
  UNIComponentsUnit;

type
  TZLEParser = class(TUNIParser)
  private
    FChecking: Boolean;
    FKontrolaWartosciowa: Boolean;
    {Na potrzeby kryteriow, domyslnie False}
    FKryteria:Boolean;
    function RealGetValueFromFunction(FuncName: String; var Arguments: array of Variant): Variant;
    function GetValueFromFunction(FuncName: String; var Arguments: array of Variant): Variant;
    function FunctionSKLAD_WART( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;
    function FunctionSKLAD_IL( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;
    function FunctionSKLAD_IL_WART( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;
    function FunctionSKLAD_WART_GRUPY( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;
    function FunctionSKLAD_IL_GRUPY( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;
    function FunctionWART_PRACY( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;
    function FunctionILOSC_PRACY( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;
    function FunctionILOSC_GODZ( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;
    function FunctionZLEPOZILOSC( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;
    function FunctionZLEPOZCENA( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;
    function FunctionZLEWARTPOZ( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;
    function FunctionWART_ROZL( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;
    function FunctionILOSC_PALIWA( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;
    function FunctionWARTPL( sArguments: String; iOkresNr: Integer; sOkresRok: String ): Extended;
    function FunctionKRYT_WARTPRACY( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;
    function FunctionKRYT_WARTMAT( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;
    function FunctionKRYT_ILOSCPRACY( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;
    {function FunctionKRYT_WSPPRACY( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;
    function FunctionKRYT_WSPMAT( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;}
    property Checking: Boolean read FChecking write FChecking;
  public
    iZlecenieId: Integer;
    {Na potrzeby kryteriw}
    iKryteriaId: Integer;
    iZleceniePozId: Integer;

    {Zmienne na potrzeby liczenia stawki}
    iOsobaID: Integer;
    iJednostkaOrgID: Integer;

    bSymulacja: boolean;
    iFirmaID:   integer;
    iOkresNr:   integer;
    sRok,sRokId: string;
    iAsortId: Integer;
    constructor Create( AOwner: TComponent; bKontrolaWartosciowa: Boolean; bKryteria: Boolean = False); reintroduce;
    function ScriptCheck(ScriptName: String; Script: TStrings; UseStoredScripts: Boolean): Integer;
    property KontrolaWartosciowa: Boolean read FKontrolaWartosciowa write FKontrolaWartosciowa;
    property Kryteria: Boolean read FKryteria write FKryteria;
  end;

const
  //stae nazwy funkcji
  cBOWN  = 'BOWN';
  cBOMA  = 'BOMA';
  cOBRWN = 'OBRWN';
  cOBRMA = 'OBRMA';
  cOBRNARWN = 'OBRNARWN';
  cOBRNARMA = 'OBRNARMA';
  cSUMSALDWN = 'SUMSALDWN';
  cSUMSALDMA = 'SUMSALDMA';
  cSALDO     = 'SALDO';
  cVatSprNetto = 'VATSPRNETTO';
  cVatSprVat   = 'VATSPRVAT';
  cVatZakNetto = 'VATZAKNETTO';
  cVatZakVat   = 'VATZAKVAT';
  cVatSadNetto = 'VATSADNETTO';
  cVatSadVat   = 'VATSADVAT';
  cOBRGM       = 'OBRGM';
  cDokumSP     = 'DOKUMSP';
  cDokumZA     = 'DOKUMZA';
  cPozDokSP    = 'POZDOKSP';
  cSumPozDSPUz = 'SUMPOZDSPUZ';//suma pozycji dokumentu sprzedazy podanego zlecenia
  cPozDokZA    = 'POZDOKZA';
  cSKLAD_WART  = 'SKLAD_WART';
  cSKLAD_IL    = 'SKLAD_IL';
  cSKLAD_IL_WART    = 'SKLAD_IL_WART';
  cSKLAD_WART_GRUPY = 'SKLAD_WART_GRUPY';
  cSKLAD_IL_GRUPY   = 'SKLAD_IL_GRUPY';
  cWART_PRACY       = 'WART_PRACY';
  cWARTPL           = 'WARTPL';
  cILOSC_PRACY      = 'ILOSC_PRACY';
  cILOSC_GODZ       = 'ILOSC_GODZ';
  cWART_ROZL        = 'WART_ROZL';
  cILOSC_PALIWA     = 'ILOSC_PALIWA';
  cKOSZTDOKZA       = 'KOSZTDOKZA';
  cOBRST            = 'OBRST';
  cTSROZL           = 'TSROZL';
  cZLEPOZILOSC      = 'ZLEPOZILOSC';
  cZLEPOZCENA       = 'ZLEPOZCENA';
  cZLEWARTPOZ       = 'ZLEWARTPOZ';

  cKRYT_WARTPRACY  = 'KRYT_WARTPRACY';
  cKRYT_WARTMAT    = 'KRYT_WARTMAT';
  cKRYT_ILOSCPRACY = 'KRYT_ILOSCPRACY';
  cKRYT_WSPPRACY   = 'KRYT_WSPPRACY';
  cKRYT_WSPMAT     = 'KRYT_WSPMAT';

  cFunkcjeSprzedazy = cDokumSP+';'+cPozDokSP+';'+cSumPozDSPUz;
  cFunkcjeZakupu    = cDokumZA+';'+cPozDokZA+';'+cKOSZTDOKZA;
  cFunkcjeKryteriow = cKRYT_WARTPRACY+';'+cKRYT_WARTMAT+';'+cKRYT_ILOSCPRACY {+';'+cKRYT_WSPPRACY+';'+cKRYT_WSPMAT};

implementation
uses
  variants,
  Sysutils,
  Dodatki,
  KeyManagerUnit,
  SQLManagerUnit,
  UNIDataManagerUnit,
  UNIDataModuleUnit,
  UNISysDefUnit,
  UNISysDataManagerUnit,
  FKDefUnit,
  FKDataManagerUnit,
  VATDefUnit,
  VATDataManagerUnit,
  MAGDefUnit,
  {$ifdef build_zle}
  MAGDataManagerExtUnit,
  {$else}  //build_zle
  MAGDataManagerUnit,
  {$endif}  //build_zle
  MFZDefUnit,
  MFZDataManagerUnit,
  MFSDefUnit,
  KDDefUnit,
  KDPRADefUnit,
  KDECPDefUnit,
  KDECPDataManagerExtUnit,
  MFSDataManagerUnit,
  ZLEDefUnit,
  STDefUnit,
  ASODefUnit,
  STDataManagerUnit,
  TSDefUnit,
  TSDataManagerExtUnit,
  ZLEDataManagerUnit;

const
  cZLEParser_Symbol    ='SYMBOL';
  cZLEParser_Rok       ='ROK';
  cZLEParser_OkresNr   ='OKRESNR';
  cZLEParser_AsortId   ='ASORTID';

const
  cFunkcjeWartosciowe = cBOMA+';'+
                        cBOWN+';'+
                        cOBRWN+';'+
                        cOBRMA+';'+
                        cOBRNARWN+';'+
                        cOBRNARMA+';'+
                        cSUMSALDWN+';'+
                        cSUMSALDMA+';'+
                        cSALDO+';'+
                        cVatSprNetto+';'+
                        cVatSprVat+';'+
                        cVatZakNetto+';'+
                        cVatZakVat+';'+
                        cVatSadNetto+';'+
                        cVatSadVat+';'+
                        cSKLAD_WART+';'+
                        cSKLAD_IL_WART+';'+
                        cSKLAD_WART_GRUPY+';'+
                        cWART_PRACY+';'+
                        cWARTPL+';'+
                        cWART_ROZL+';'+
                        cDokumSP+';'+
                        cDokumZA+';'+
                        cKOSZTDOKZA+';'+
                        cSumPozDSPUz+';'+
                        cObrST+';'+
                        cTSROZL+';'+
                        cZLEWARTPOZ;

  cFunkcjeIlosciowe = cPozDokSP+';'+
                      cPozDokZA+';'+
                      cSKLAD_IL+';'+
                      cILOSC_PRACY+';'+
                      cILOSC_GODZ+';'+
                      cILOSC_PALIWA+';'+
                      cSKLAD_IL_GRUPY+';'+
                      cZLEPOZILOSC+';'+
                      cZLEPOZCENA+';'+
                      cZLEWARTPOZ;

  cFunkcjeKryteria = cKRYT_WARTPRACY +';'+
                     cKRYT_WARTMAT+';'+
                     cKRYT_ILOSCPRACY;

constructor TZLEParser.Create( AOwner: TComponent; bKontrolaWartosciowa: Boolean; bKryteria: Boolean = False);
begin
  inherited Create( AOwner );
  Checking := false;
  KontrolaWartosciowa := bKontrolaWartosciowa;
  Kryteria := bKryteria;
  iKryteriaId := -1;
  iZleceniePozId := -1;
  iOsobaID := -1;
  Prepare;
  if KontrolaWartosciowa and (not Kryteria) then begin
    // funkcje finansowe
    AddFunction('', cBOWN, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cBOMA, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cOBRWN, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cOBRMA, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cOBRNARWN, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cOBRNARMA, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cSUMSALDWN, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cSUMSALDMA, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cSALDO, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    // vatowskie
    AddFunction('', cVatSprNetto, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cVatSprVat  , ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cVatZakNetto, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cVatZakVat  , ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cVatSadNetto, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cVatSadVat  , ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    // mfs
    AddFunction('', cDokumSP, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cDokumZA, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);

    // st
    AddFunction('', cOBRST, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);

    //mfz
    AddFunction('', cKOSZTDOKZA, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);

     // ts
    AddFunction('', cTSROZL, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);

    //zle
    AddFunction('', cSKLAD_WART, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cSKLAD_IL_WART, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cSKLAD_WART_GRUPY, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cWART_PRACY, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cWART_ROZL, ktFloat, [], fuOrdinary, GetValueFromFunction);
    //plli
    AddFunction('', cWARTPL, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
  end else if (not Kryteria) then begin
    // zle
    AddFunction('', cSKLAD_IL  , ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cSKLAD_IL_GRUPY  , ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cZLEPOZCENA, ktFloat, [], fuOrdinary, GetValueFromFunction);
    AddFunction('', cZLEPOZILOSC, ktFloat, [], fuOrdinary, GetValueFromFunction);
    //plli
    AddFunction('', cWARTPL, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
  end;

  if (not Kryteria) then begin
    {Funkcje dostpne zarwno jako ilociowe jak i wartociowe}
    AddFunction('', cILOSC_PRACY, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cILOSC_GODZ, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cILOSC_PALIWA, ktFloat, [], fuOrdinary, GetValueFromFunction);

    //Warto jednej pozycji lub wszystkich cznie
    AddFunction('', cZLEWARTPOZ, ktFloat, [], fuOrdinary, GetValueFromFunction);

    // gm
    AddFunction('', cOBRGM, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    // mfs
    AddFunction('', cPozDokSP, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cPozDokZA, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cSumPozDSPUz, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
  end;

  if Kryteria then begin
    AddFunction('', cKRYT_WARTPRACY,  ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cKRYT_WARTMAT,    ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    AddFunction('', cKRYT_ILOSCPRACY, ktFloat, [ftString], fuOrdinary, GetValueFromFunction);
    //AddFunction('', cKRYT_WSPPRACY,  ktFloat, [], fuOrdinary, GetValueFromFunction);
    //AddFunction('', cKRYT_WSPMAT,    ktFloat, [], fuOrdinary, GetValueFromFunction);
  end;

  if vWielofirmowosc then iFirmaID:= vAktywnaFirma;
end;

function TZLEParser.RealGetValueFromFunction;
var
  sRokKalendarzowy:string;

  function GetResult( Q: TDataset) : variant;
  begin
    try
      if Q=nil then result:= 0
      else Result:= Q.Fields[0].Value;
    finally
      Q.free;
    end;
  end;

var
    sArguments: String;
    iOkres, ile_rez: Integer;
    sOkresID: String;
begin
  Result := Null;
  ile_rez := 0;
  FuncName:=UpperCase(FuncName);
  sRokKalendarzowy:=copy(sRok,1,4);
  if Length(Arguments) > 0 then
    Arguments[0] := StringReplace( Arguments[0], #13#10, '', [rfReplaceAll])
  else
    sArguments := '';

  if (not Kryteria) then begin
    //funkcje moduu FK
    if DataManagers.Available(sFKModulId) then begin
      if FuncName = cBOWN then begin
        result:= GetResult( FKDataManager.FKFunFinansowe_BOWN(iFirmaID, sRok, Arguments[0], bSymulacja, iOkresNr));
      end else if FuncName = cBOMA then begin
        result:= GetResult( FKDataManager.FKFunFinansowe_BOMA(iFirmaID, sRok, Arguments[0], bSymulacja, iOkresNr));
      end else if FuncName = cOBRWN then begin
        result:= GetResult( FKDataManager.FKFunFinansowe_ObrWN(iFirmaID, sRok, Arguments[0], bSymulacja, iOkresNr));
      end else if FuncName = cOBRMA then begin
        result:= GetResult( FKDataManager.FKFunFinansowe_ObrMA(iFirmaID, sRok, Arguments[0], bSymulacja, iOkresNr));
      end else if FuncName = cOBRNARWN then begin
        result:= GetResult( FKDataManager.FKFunFinansowe_ObrNarWN(iFirmaID, sRok, Arguments[0], bSymulacja, iOkresNr));
      end else if FuncName = cOBRNARMA then begin
        result:= GetResult( FKDataManager.FKFunFinansowe_ObrNarMA(iFirmaID, sRok, Arguments[0], bSymulacja, iOkresNr));
      end else if FuncName = cSUMSALDWN then begin
        result:= GetResult( FKDataManager.FKFunFinansowe_SumaSaldWN(iFirmaID, sRok, Arguments[0], bSymulacja, iOkresNr));
      end else if FuncName = cSUMSALDMA then begin
        result:= GetResult( FKDataManager.FKFunFinansowe_SumaSaldMA(iFirmaID, sRok, Arguments[0], bSymulacja, iOkresNr));
      end else if FuncName = cSALDO then begin
        result:= GetResult( FKDataManager.FKFunFinansowe_Saldo(iFirmaID, sRok, Arguments[0], bSymulacja, iOkresNr));
      end;
    end;

    //funkcje moduu VAT
    if DataManagers.Available(sVATModulId) then begin
      if FuncName = cVATSPRNETTO then begin
        result:= VATDataManager.VATFunFinansoweVat_VatSprNetto(iFirmaID, sRokKalendarzowy, iOkresNr, Arguments[0]);
      end else if FuncName = cVATSPRVAT then begin
        result:= VATDataManager.VATFunFinansoweVat_VatSprVat(iFirmaID, sRokKalendarzowy, iOkresNr, Arguments[0]);
      end else if FuncName = cVATZAKNETTO then begin
        result:= VATDataManager.VATFunFinansoweVat_VatZakNetto(iFirmaID, sRokKalendarzowy, iOkresNr, Arguments[0]);
      end else if FuncName = cVATZAKVAT then begin
        result:= VATDataManager.VATFunFinansoweVat_VatZakVat(  iFirmaID, sRokKalendarzowy, iOkresNr, Arguments[0]);
      end else if FuncName = cVATSADNETTO then begin
        result:= VATDataManager.VATFunFinansoweVat_VatSadNetto(iFirmaID, sRokKalendarzowy, iOkresNr, Arguments[0]);
      end else if FuncName = cVATSADVAT then begin
        result:= VATDataManager.VATFunFinansoweVat_VatSadVat(  iFirmaID, sRokKalendarzowy, iOkresNr, Arguments[0]);
      end;
    end;

    //funkcje moduu MFS
    if DataManagers.Available(sMFSModulId) then begin
      if FuncName = cDOKUMSP then begin
        result:= MFSDM.DokumSP  ( Arguments[0], iOkresNr, sRok);
      end else if FuncName = cPOZDOKSP then begin
        result:= MFSDM.PozDokSP( Arguments[0], iOkresNr, sRok);
      end else if FuncName = cSumPozDSPUz then begin
        result := MFSDM.SumPozDSPUz( Arguments[0], iZlecenieId, iOkresNr, sRok );
      end;
    end;

    //funkcje moduu MFZ
    if DataManagers.Available(sMFZModulId) then begin
      if FuncName = cDOKUMZA then begin
        result:= MFZDM.DokumZA( Arguments[0], iOkresNr, sRok, iZlecenieId);
      end else if FuncName = cPOZDOKZA then begin
        result:= MFZDM.PozDokZA( Arguments[0], iOkresNr, sRok, iZlecenieId);
      end;
    end;

    //funkcje moduu MAG
    if DataManagers.Available(sMAGModulId) then begin
      if FuncName = cOBRGM then begin
        result:= MAGDM.ObrGM( Arguments[0], iOkresNr, sRok, KontrolaWartosciowa);
      end;
    end;
  end;

  //funkcje moduu ZLE
  if Kryteria then begin
     if (FuncName = cKRYT_WARTPRACY) then
        result:= FunctionKRYT_WARTPRACY( Arguments[0], iOkresNr, sRok)
     else if (FuncName = cKRYT_ILOSCPRACY) then
        result:= FunctionKRYT_ILOSCPRACY( Arguments[0], iOkresNr, sRok)
     else if (FuncName = cKRYT_WARTMAT) then
        result:= FunctionKRYT_WARTMAT( Arguments[0], iOkresNr, sRok);
     {else if (FuncName = cKRYT_WSPPRACY) then
        result:= FunctionKRYT_WSPPRACY( sArguments, iOkresNr, sRok)
     else if (FuncName = cKRYT_WSPMAT) then
        result:= FunctionKRYT_WSPMAT( sArguments, iOkresNr, sRok);}
  end else begin
    if KontrolaWartosciowa then begin
      if (FuncName = cSKLAD_WART) then
        result:= FunctionSKLAD_WART( Arguments[0], iOkresNr, sRok)
      else if (FuncName = cSKLAD_WART_GRUPY) then
        result:= FunctionSKLAD_WART_GRUPY( Arguments[0], iOkresNr, sRok)
      else if (FuncName = cSKLAD_IL_WART) then
        result:= FunctionSKLAD_IL_WART( Arguments[0], iOkresNr, sRok)
      else if (FuncName = cWART_PRACY) then
        result:= FunctionWART_PRACY( Arguments[0], iOkresNr, sRok)
      else if (FuncName = cWART_ROZL) then
        result:= FunctionWART_ROZL( sArguments, iOkresNr, sRok)
        //PLLI
      else if (FuncName = cWARTPL) then
        result:= FunctionWARTPL( Arguments[0], iOkresNr, sRok)
        {ZLE}
      else if (FuncName = cILOSC_PRACY) then
        result:= FunctionILOSC_PRACY( Arguments[0], iOkresNr, sRok)
      else if (FuncName = cILOSC_PALIWA) then
        result:= FunctionILOSC_PALIWA( sArguments, iOkresNr, sRok)
      else if (FuncName = cZLEWARTPOZ) then
        result:= FunctionZLEWARTPOZ( sArguments, iOkresNr, sRok)
      else if (FuncName = cILOSC_GODZ) then
        result:= FunctionILOSC_GODZ( Arguments[0], iOkresNr, sRok);

      //funkcje moduu ST
      if DataManagers.Available(sSTModulID) then begin
        if FuncName = cOBRST then begin
          result:= STDM.ObrST( Arguments[0], iOkresNr, sRok, KontrolaWartosciowa);
        end;
      end;

      //funkcje moduu TS
      if DataManagers.Available(sTSModulID) then begin
        if FuncName = cTSROZL then begin
           result:= GetResult( TSDM.TSFunkcjeANW_TSRozl(iFirmaID, sRok, Arguments[0], ile_rez{Ilosc slownikow}, bSymulacja, iOkresNr));
        end;
      end;

      if DataManagers.Available(sMFZModulId) then begin
        if FuncName = cKOSZTDOKZA then begin
           sOkresID := SQLManager.OpenQueryWithResult(UNISysDM.UNIOdpytajODaneSQL( sUNIOKRES,
                                                  sUNISYSALIAS_Okres_Obrachunkowy_ID,
                                                  '@'+sUNISYSALIAS_Okres_Obrachunkowy_Numer+'='+IntToStr(iOkresNr) + ' AND ' +
                                                  '@'+sUNISYSALIAS_Okres_Obrachunkowy_Rok_ID+'='+sRokID,
                                                  true,
                                                  iFirmaID ));

           try
             iOkres := StrToInt(sOkresID);
           except
             iOkres := 0;
           end;

           result := MFZDM.KosztDokZA( Arguments[0], 0, sRok, iOkres);

          (*result:= GetResult( MFZDM.KosztDokZaK(iFirmaID, sRokKalendarzowy, Arguments[0],
                                                 rez_ile, bSymulacja, iOkresNr, False {bTylkoNiezerowe}, False {bZestawienieZDokumentami}));*)
        end;
      end;
    end else if (not KontrolaWartosciowa) then begin
      if (FuncName = cSKLAD_IL) then
        result:= FunctionSKLAD_IL( Arguments[0], iOkresNr, sRok)
      else if (FuncName = cSKLAD_IL_GRUPY) then
        result:= FunctionSKLAD_IL_GRUPY( Arguments[0], iOkresNr, sRok)
      else if (FuncName = cILOSC_PRACY) then
        result:= FunctionILOSC_PRACY( Arguments[0], iOkresNr, sRok)
      else if (FuncName = cILOSC_PALIWA) then
        result:= FunctionILOSC_PALIWA( sArguments, iOkresNr, sRok)
      else if (FuncName = cILOSC_GODZ) then
        result:= FunctionILOSC_GODZ( Arguments[0], iOkresNr, sRok)
      else if (FuncName = cZLEPOZILOSC) then
        result:= FunctionZLEPOZILOSC( sArguments, iOkresNr, sRok)
      else if (FuncName = cZLEPOZCENA) then
        result:= FunctionZLEPOZCENA( sArguments, iOkresNr, sRok)
      else if (FuncName = cZLEWARTPOZ) then
        result:= FunctionZLEWARTPOZ( sArguments, iOkresNr, sRok)
        //PLLI
      else if (FuncName = cWARTPL) then
        result:= FunctionWARTPL( Arguments[0], iOkresNr, sRok)
    end;
  end;
end;

function TZLEParser.GetValueFromFunction;
var iIndex, jIndex: Integer;
    sErrorMsg: String;
    sFindText: String;
    sArgumenty: String;
    oFindList: TStringList;
begin
  result := 1;
  oFindList := nil;

  sErrorMsg := 'Brak parametru %s dla funkcji %s';
  if Length(Arguments)>0 then
    sArgumenty := Arguments[0]
  else
    sArgumenty := '';
  if Checking then begin
    FuncName:=UpperCase(FuncName);
    sArgumenty := StringReplace( sArgumenty, #13#10, '', [rfReplaceAll] );
    try
      oFindList := TStringList.Create();
      if (FuncName = cOBRGM) then begin
//        oFindList.Add('Zlecenie='+cZLEParamSymbolZlec);
        if not KontrolaWartosciowa then
          oFindList.Add('Indeks='+cZLEParamIndeksAsort);
      end else if (FuncName = cPOZDOKSP)or(FuncName = cPOZDOKZA) then begin
        if not KontrolaWartosciowa then
          oFindList.Add('IndAso='+cZLEParamIndeksAsort);
//      end else if FuncName = cSumPozDSPUz then begin
      end else if (FuncName = cWARTPL) then begin
          // nic nie rob
      end else Exit;
      for jIndex := 0 to oFindList.Count-1 do begin
        sFindText := oFindList[jIndex];
        iIndex := Pos( UpperCase(sFindText), UpperCase(sArgumenty) );
        if iIndex = 0 then begin
          sErrorMsg := Format( sErrorMsg, [sFindText, FuncName] );
          if Pos(UpperCase(cZLEParamIndeksAsort), UpperCase(sFindText)) > 0 then
            //Pomijam bd braku indeksu w kontroli ilosciowej
            continue
          else
            raise EOF_ZLEException.Create( sErrorMsg );
        end;
      end;
    finally
      if oFindList <> nil then oFindList.Free;
    end;
  end else result := RealGetValueFromFunction( FuncName, Arguments );
end;

function TZLEParser.FunctionSKLAD_WART( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;
var oQuery: TUNIQuery;
    sWhere: String;
begin
  result  := 0.0;
  oQuery := nil;
  try
    oQuery := ZLEDM.ZLEOdpytajODane( sZLESKLADWART,
                                     sZLEALIAS_TYPZLECENIA_ID+';'+
                                     sZLEALIAS_TYPSKLADW_ID,
                                     '(@'+sZLEALIAS_ZLECENIE_ID+'='+IntToStr(iZlecenieID)+')and'+
                                     '(@'+sZLEALIAS_SKLADWART_SYMBOL+'='+QuotedStr(sArguments)+')',
                                     false );
    if oQuery = nil then
      raise EOF_ZLEException.Create( cError_BrakSkladnika,
                                     Format(ZLEPodajSlowneRozwiniecieKoduBledu(cError_BrakSkladnika),[sArguments] ));
  finally
    if oQuery <> nil then FreeAndNil(oQuery);
  end;

  sWhere := '(@'+sZLEALIAS_WART_ZLECENIE_ID+'='+IntToStr(iZlecenieID)+')and'+
            '(@'+sZLEALIAS_SKLADWART_SYMBOL+'='+QuotedStr(sArguments)+')';
  if iOkresNr <> 0 then
    sWhere := sWhere+'and'+
              '(@'+sZLEALIAS_OKRES_NR+'='+IntToStr(iOkresNr)+')and'+
              '(@'+sZLEALIAS_ROK_ROK+'='+QuotedStr(sRok)+')';
  try
    oQuery := ZLEDM.ZLEOdpytajODane( sZLEWART,
                                     sZLEALIAS_WART_WARTOSC,
                                     sWhere,
                                     false);
    if oQuery <> nil then result := oQuery.FieldByName(sZLEWART_WARTOSC).AsFloat
    else raise EOF_ZLEException.Create( cError_SkladnikNiePrzeliczony,
                                        Format(ZLEPodajSlowneRozwiniecieKoduBledu(cError_SkladnikNiePrzeliczony),[sArguments] ));
  finally
    if oQuery <> nil then oQuery.Free;
  end;
end;

function TZLEParser.FunctionSKLAD_IL( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;
var oQuery: TUNIQuery;
    sWhere: String;
begin
  result  := 0.0;
  oQuery := nil;
  try
    oQuery := ZLEDM.ZLEOdpytajODane( sZLESKLADIL,
                                     sZLEALIAS_TYPZLECENIA_ID+';'+
                                     sZLEALIAS_TYPSKLADIL_ID,
                                     '(@'+sZLEALIAS_ZLECENIE_ID+'='+IntToStr(iZlecenieID)+')and'+
                                     '(@'+sZLEALIAS_ZLECENIEPOZ_ASORT_ID+'='+IntToStr(iAsortId)+')and'+
                                     '(@'+sZLEALIAS_SKLADIL_SYMBOL+'='+QuotedStr(sArguments)+')',
                                     false );
    if oQuery = nil then
      raise EOF_ZLEException.Create( cError_BrakSkladnika,
                                     Format(ZLEPodajSlowneRozwiniecieKoduBledu(cError_BrakSkladnika),[sArguments] ));
  finally
    if oQuery <> nil then FreeAndNil(oQuery);
  end;

  sWhere := '(@'+sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID+'='+IntToStr(iZlecenieID)+')and'+
            '(@'+sZLEALIAS_ZLECENIEPOZ_ASORT_ID+'='+IntToStr(iAsortID)+')and'+
            '(@'+sZLEALIAS_SKLADIL_SYMBOL+'='+QuotedStr(sArguments)+')';
  if iOkresNr <> 0 then
    sWhere := sWhere+'and'+
              '(@'+sZLEALIAS_OKRES_NR+'='+IntToStr(iOkresNr)+')and'+
              '(@'+sZLEALIAS_ROK_ROK+'='+QuotedStr(sRok)+')';
  try
    oQuery := ZLEDM.ZLEOdpytajODane( sZLEIL, sZLEALIAS_IL_ILOSC, sWhere, false);
    if oQuery <> nil then result := oQuery.FieldByName(sZLEIL_ILOSC).AsFloat
    else raise EOF_ZLEException.Create( cError_SkladnikNiePrzeliczony,
                                        Format(ZLEPodajSlowneRozwiniecieKoduBledu(cError_SkladnikNiePrzeliczony),[sArguments] ));
  finally
    if oQuery <> nil then oQuery.Free;
  end;
end;

function TZLEParser.FunctionSKLAD_IL_WART( sArguments: String; iOkresNr: Integer; sRok: String ): Extended;
var oQuery: TUNIQuery;
    sSQL: String;
begin
  result  := 0.0;
  oQuery := nil;
  sSQL := '';
  try
    oQuery := ZLEDM.ZLEOdpytajODane( sZLESKLADIL,
                                     sZLEALIAS_TYPZLECENIA_ID+';'+
                                     sZLEALIAS_TYPSKLADIL_ID,
                                     '(@'+sZLEALIAS_ZLECENIE_ID+'='+IntToStr(iZlecenieID)+')and'+
                                     '(@'+sZLEALIAS_SKLADIL_SYMBOL+'='+QuotedStr(sArguments)+')',
                                     false );
    if oQuery = nil then
      raise EOF_ZLEException.Create( cError_BrakSkladnika,
                                     Format(ZLEPodajSlowneRozwiniecieKoduBledu(cError_BrakSkladnika),[sArguments] ));
  finally
    if oQuery <> nil then FreeAndNil(oQuery);
  end;

  sSQL := 'SELECT COALESCE(SUM(NVL(IL.' + sZLEIL_ILOSC + ', 0)*NVL(POZ.' + sZLEZLECENIEPOZ_CENA + ', 0)), 0) as ' + sZLEIL_ILOSC + ' ' +
          'FROM %s POZ, %s IL, %s SKLAD ';

  if iOkresNr <> 0 then
     sSQL := sSQL + ', %s ok, %s rok ';

  sSQL := sSQL +
          'WHERE POZ.' + sZLEZLECENIEPOZ_ID + '=IL.' + sZLEZLECENIEPOZ_ID +
           ' AND IL.' + sZLESKLADIL_ID + '= SKLAD.' + sZLESKLADIL_ID +
           ' AND POZ.' + sZLEZLECENIE_ID + '=' + IntToStr(iZlecenieID) +
           ' AND SKLAD.' + sZLESKLADIL_SYMBOL + '=' + QuotedStr(sArguments);

  if iOkresNr <> 0 then
     sSQL := sSQL + ' AND OK.' + sUNIOKRES_ID + '= IL.' + sUNIOKRES_ID +
                    ' AND OK.' + sUNIROK_ID + '= ROK.' + sUNIROK_ID +
                    ' AND OK.' + sUNIOKRES_OKRES_NR + '=' + IntToStr(iOkresNr) +
                    ' AND ROK.' + sUNIROK_ROK + '=' + QuotedStr(sRok);


  try
    if iOkresNr <> 0 then begin
      oQuery := SQLManager.CreateQuery(sSQL, [sZLEZLECENIEPOZ, sZLEIL, sZLESKLADIL, sUNIOKRES, sUNIROK]);
    end else begin;
      oQuery := SQLManager.CreateQuery(sSQL, [sZLEZLECENIEPOZ, sZLEIL, sZLESKLADIL]);
    end;

    if oQuery <> nil then begin
      oQuery.Open();
      if not oQuery.IsEmpty then begin
         result := oQuery.FieldByName(sZLEIL_ILOSC).AsFloat;
      end;
    end
    else raise EOF_ZLEException.Create( cError_SkladnikNiePrzeliczony,
                                        Format(ZLEPodajSlowneRozwiniecieKoduBledu(cError_SkladnikNiePrzeliczony),[sArguments] ));
  finally
    if oQuery <> nil then FreeAndNil(oQuery);
  end;
end;

function TZLEParser.ScriptCheck(ScriptName: String; Script: TStrings; UseStoredScripts: Boolean): Integer;
begin
  try
    Checking := true;
    result := inherited ScriptExecute( ScriptName, Script, UseStoredScripts);
  finally
    Checking := false;
  end;
end;

function TZLEParser.FunctionSKLAD_IL_GRUPY(sArguments: String;
  iOkresNr: Integer; sRok: String): Extended;
var oQuery: TUNIQuery;
    sWhere: String;
begin
  result  := 0.0;
  oQuery := nil;
  sWhere := '(@'+sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID+'=@'+sZLEALIAS_ZLECENIE_ID+')and'+
            '(@'+sZLEALIAS_ZLECENIE_GRUPA_ID+'='+IntToStr(iZlecenieID)+')and'+
            '(@'+sZLEALIAS_ZLECENIEPOZ_ASORT_ID+'='+IntToStr(iAsortID)+')and'+
            '(@'+sZLEALIAS_SKLADIL_SYMBOL+'='+QuotedStr(sArguments)+')';
  if iOkresNr <> 0 then
    sWhere := sWhere+'and'+
              '(@'+sZLEALIAS_OKRES_NR+'='+IntToStr(iOkresNr)+')and'+
              '(@'+sZLEALIAS_ROK_ROK+'='+QuotedStr(sRok)+')';
  try
    oQuery := ZLEDM.ZLEOdpytajODane( sZLEIL,
                                     '#sum(@'+sZLEALIAS_IL_ILOSC+') as '+sZLEIL_ILOSC,
                                     sWhere, false);
    if oQuery <> nil then result := oQuery.FieldByName(sZLEIL_ILOSC).AsFloat
    else raise EOF_ZLEException.Create( cError_SkladnikNiePrzeliczony,
                                        'Funkcja "SKLAD_IL" nie odnalaza pozycji o symbolu: '+sArguments);
  finally
    if oQuery <> nil then oQuery.Free;
  end;
end;

function TZLEParser.FunctionSKLAD_WART_GRUPY(sArguments: String;
  iOkresNr: Integer; sRok: String): Extended;
var oQuery: TUNIQuery;
    sWhere: String;
begin
  result  := 0.0;
  sWhere := '(@'+sZLEALIAS_WART_ZLECENIE_ID+'=@'+sZLEALIAS_ZLECENIE_ID+')and'+
            '(@'+sZLEALIAS_ZLECENIE_GRUPA_ID+'='+IntToStr(iZlecenieID)+')and'+
            '(@'+sZLEALIAS_SKLADWART_SYMBOL+'='+QuotedStr(sArguments)+')';
  if iOkresNr <> 0 then
    sWhere := sWhere+'and'+
              '(@'+sZLEALIAS_OKRES_NR+'='+IntToStr(iOkresNr)+')and'+
              '(@'+sZLEALIAS_ROK_ROK+'='+QuotedStr(sRok)+')';
  oQuery := ZLEDM.ZLEOdpytajODane( sZLEWART,
                                   '#Sum(@'+sZLEALIAS_WART_WARTOSC+') as '+sZLEWART_WARTOSC,
                                   sWhere,
                                   false);
  try
    if oQuery <> nil then result := oQuery.FieldByName(sZLEWART_WARTOSC).AsFloat
    else raise EOF_ZLEException.Create( cError_SkladnikNiePrzeliczony,
                                        'Funkcja "SKLAD_WART" nie odnalaza pozycji o symbolu: '+sArguments);
  finally
    if oQuery <> nil then oQuery.Free;
  end;
end;

function TZLEParser.FunctionILOSC_PRACY(sArguments: String; iOkresNr: Integer; sRok: String): Extended;
var
  oQuery: TUNIQuery;
  sRodzajECP, sRodzajZasobu: string;
  sArgs: String;

  function Wytnij( sCo: string; bNum: boolean=false) : string;
  var
    p,q,i  :integer;
    wiele:  boolean;
  begin
    result:= '';
    p:= Pos( sCo+'=',sArgs);
    if p > 0 then begin
      q:= p + length(sCo) + 1;
      wiele:= false;
      for i:= q to length(sArgs) do begin
        case sArgs[i] of
          '[':  wiele:= true;
          ',':  if not wiele then break;
          ']':  wiele:= false;
        end;
      end;
      result:= copy( sArgs,q,i-q);

      delete( sArgs, p, i-p);
      result:= StringReplace( result,'[',#39,[rfReplaceAll]);
      result:= StringReplace( result,']',#39,[rfReplaceAll]);
      if not bNum then begin
        result:= StringReplace( result,',',#39','#39,[rfReplaceAll]);
        if Pos('(',result)>0 then begin
          insert(#39,result,2);
          insert(#39,result,length(result));
        {end else begin
          result:= #39+result+#39;}
        end;
      end;
    end;
  end;

  procedure Przerwij;
  var
    i:  integer;
    sTmp: String;
  begin
    i:= Pos('=',sArgs);
    if i>0 then sTmp:= copy(sArgs,1,i-1)
    else sTmp := sArgs;
    raise EOF_ZLEException.Create( 'WART_PRACY - nierozpoznany argument:'#13+sTmp);
  end;

begin
  result := 0.0;

  sArgs := AnsiUpperCase(StringReplace(sArguments, ' ', '', [rfReplaceAll]));
  sRodzajECP    := Wytnij('RODZAJECP');
  sRodzajZasobu := Wytnij('RODZAJZASOBU');
  // kocowa kontrola parametrw
  sArgs:= StringReplace( sArgs,',','',[rfReplaceAll]);
  if sArgs<>'' then Przerwij;

  if iOkresNr = 0 then
    result := ZLEDM.ZleDajIloscPracy( iZlecenieId, iOkresNr, sRodzajECP, sRodzajZasobu )
  else begin
    oQuery := UNISysDM.UNIOdpytajODane( sUNIOKRES,
                                        sUNISYSALIAS_Okres_Obrachunkowy_ID,
                                        '(@'+sUNISYSALIAS_Okres_Obrachunkowy_Numer+'='+IntToStr(iOkresNr)+')and'+
                                        '(@'+sUNISYSALIAS_Rok_Rok+'='+QuotedStr(sRok)+')',
                                        False, 0 );
    try
      if oQuery <> nil then
        result := ZLEDM.ZleDajIloscPracy( iZlecenieId, oQuery.FieldByName(sUNIOKRES_ID).AsInteger, sRodzajECP, sRodzajZasobu )
      else raise EOF_ZLEException.Create( cError_BlednyOkres,
                                          'Funkcja "ILOSC_PRACY" - bdny okres obrachunkowy');
    finally
      if oQuery <> nil then oQuery.Free;
    end;
  end;
end;

function TZLEParser.FunctionILOSC_GODZ(sArguments: String; iOkresNr: Integer; sRok: String): Extended;
var
  oQuery: TUNIQuery;
  sRodzajECP, sRodzajZasobu: string;
  sArgs: String;

  function Wytnij( sCo: string; bNum: boolean=false) : string;
  var
    p,q,i  :integer;
    wiele:  boolean;
  begin
    result:= '';
    p:= Pos( sCo+'=',sArgs);
    if p > 0 then begin
      q:= p + length(sCo) + 1;
      wiele:= false;
      for i:= q to length(sArgs) do begin
        case sArgs[i] of
          '[':  wiele:= true;
          ',':  if not wiele then break;
          ']':  wiele:= false;
        end;
      end;
      result:= copy( sArgs,q,i-q);

      delete( sArgs, p, i-p);
      result:= StringReplace( result,'[',#39,[rfReplaceAll]);
      result:= StringReplace( result,']',#39,[rfReplaceAll]);
      if not bNum then begin
        result:= StringReplace( result,',',#39','#39,[rfReplaceAll]);
        if Pos('(',result)>0 then begin
          insert(#39,result,2);
          insert(#39,result,length(result));
        {end else begin
          result:= #39+result+#39;}
        end;
      end;
    end;
  end;

  procedure Przerwij;
  var
    i:  integer;
    sTmp: String;
  begin
    i:= Pos('=',sArgs);
    if i>0 then sTmp:= copy(sArgs,1,i-1)
    else sTmp := sArgs;
    raise EOF_ZLEException.Create( 'WART_PRACY - nierozpoznany argument:'#13+sTmp);
  end;

begin
  result := 0.0;

  sArgs := AnsiUpperCase(StringReplace(sArguments, ' ', '', [rfReplaceAll]));
  sRodzajECP    := Wytnij('RODZAJECP');
  sRodzajZasobu := Wytnij('RODZAJZASOBU');
  // kocowa kontrola parametrw
  sArgs:= StringReplace( sArgs,',','',[rfReplaceAll]);
  if sArgs<>'' then Przerwij;

  if iOkresNr = 0 then
    result := ZLEDM.ZleDajIloscGodzin( iZlecenieId, iOkresNr, sRodzajECP, sRodzajZasobu )
  else begin
    oQuery := UNISysDM.UNIOdpytajODane( sUNIOKRES,
                                        sUNISYSALIAS_Okres_Obrachunkowy_ID,
                                        '(@'+sUNISYSALIAS_Okres_Obrachunkowy_Numer+'='+IntToStr(iOkresNr)+')and'+
                                        '(@'+sUNISYSALIAS_Rok_Rok+'='+QuotedStr(sRok)+')',
                                        False, 0 );
    try
      if oQuery <> nil then
        result := ZLEDM.ZleDajIloscGodzin( iZlecenieId, oQuery.FieldByName(sUNIOKRES_ID).AsInteger, sRodzajECP, sRodzajZasobu )
      else raise EOF_ZLEException.Create( cError_BlednyOkres,
                                          'Funkcja "ILOSC_GODZ" - bdny okres obrachunkowy');
    finally
      if oQuery <> nil then oQuery.Free;
    end;
  end;
end;

function TZLEParser.FunctionWART_PRACY(sArguments: String;
  iOkresNr: Integer; sRok: String): Extended;
var
  oQuery: TUNIQuery;
  sRodzajECP, sRodzajZasobu: string;
  sArgs: String;

  function Wytnij( sCo: string; bNum: boolean=false) : string;
  var
    p,q,i  :integer;
    wiele:  boolean;
  begin
    result:= '';
    p:= Pos( sCo+'=',sArgs);
    if p > 0 then begin
      q:= p + length(sCo) + 1;
      wiele:= false;
      for i:= q to length(sArgs) do begin
        case sArgs[i] of
          '[':  wiele:= true;
          ',':  if not wiele then break;
          ']':  wiele:= false;
        end;
      end;
      result:= copy( sArgs,q,i-q);

      delete( sArgs, p, i-p);
      result:= StringReplace( result,'[',#39,[rfReplaceAll]);
      result:= StringReplace( result,']',#39,[rfReplaceAll]);
      if not bNum then begin
        result:= StringReplace( result,',',#39','#39,[rfReplaceAll]);
        if Pos('(',result)>0 then begin
          insert(#39,result,2);
          insert(#39,result,length(result));
        {end else begin
          result:= #39+result+#39;}
        end;
      end;
    end;
  end;

  procedure Przerwij;
  var
    i:  integer;
    sTmp: String;
  begin
    i:= Pos('=',sArgs);
    if i>0 then sTmp:= copy(sArgs,1,i-1)
    else sTmp := sArgs;
    raise EOF_ZLEException.Create( 'WART_PRACY - nierozpoznany argument:'#13+sTmp);
  end;

begin
  result := 0.0;

  sArgs := AnsiUpperCase(StringReplace(sArguments, ' ', '', [rfReplaceAll]));
  sRodzajECP    := Wytnij('RODZAJECP');
  //if Copy(sRodzajECP, 0, 1) = '(' then sRodzajECP := Copy(sRodzajECP, 1, Length(sRodzajECP) - 2);

  sRodzajZasobu := Wytnij('RODZAJZASOBU');
  //if Copy(sRodzajZasobu, 0, 1) = '(' then sRodzajZasobu := Copy(sRodzajZasobu, 1, Length(sRodzajZasobu) - 2);
  // kocowa kontrola parametrw
  sArgs:= StringReplace( sArgs,',','',[rfReplaceAll]);
  if sArgs<>'' then Przerwij;

  if iOkresNr = 0 then
    result := ZLEDM.ZleDajWartoscPracy( iZlecenieId, iOkresNr, sRodzajECP, sRodzajZasobu )
  else begin
    oQuery := UNISysDM.UNIOdpytajODane( sUNIOKRES,
                                        sUNISYSALIAS_Okres_Obrachunkowy_ID,
                                        '(@'+sUNISYSALIAS_Okres_Obrachunkowy_Numer+'='+IntToStr(iOkresNr)+')and'+
                                        '(@'+sUNISYSALIAS_Rok_Rok+'='+QuotedStr(sRok)+')',
                                        False, 0 );
    try
      if oQuery <> nil then
        result := ZLEDM.ZleDajWartoscPracy( iZlecenieId, oQuery.FieldByName(sUNIOKRES_ID).AsInteger,sRodzajECP, sRodzajZasobu )
      else raise EOF_ZLEException.Create( cError_BlednyOkres,
                                          'Funkcja "WART_PRACY" - bdny okres obrachunkowy');
    finally
      if oQuery <> nil then oQuery.Free;
    end;
  end;
end;

function TZLEParser.FunctionKRYT_WARTPRACY(sArguments: String;
  iOkresNr: Integer; sRok: String): Extended;
var
  oQuery: TUNIQuery;
  bNarzuty: Boolean;
  sArgs, sNarzuty: String;

  function Wytnij( sCo: string; bNum: boolean=false) : string;
  var
    p,q,i  :integer;
    wiele:  boolean;
  begin
    result:= '';
    p:= Pos( sCo+'=',sArgs);
    if p > 0 then begin
      q:= p + length(sCo) + 1;
      wiele:= false;
      for i:= q to length(sArgs) do begin
        case sArgs[i] of
          '[':  wiele:= true;
          ',':  if not wiele then break;
          ']':  wiele:= false;
        end;
      end;
      result:= copy( sArgs,q,i-q);

      delete( sArgs, p, i-p);
      result:= StringReplace( result,'[','(',[rfReplaceAll]);
      result:= StringReplace( result,']',')',[rfReplaceAll]);
      if not bNum then begin
        result:= StringReplace( result,',',#39','#39,[rfReplaceAll]);
        if Pos('(',result)>0 then begin
          insert(#39,result,2);
          insert(#39,result,length(result));
        {end else begin
          result:= #39+result+#39;}
        end;
      end;
    end;
  end;

  procedure Przerwij;
  var
    i:  integer;
    sTmp: String;
  begin
    i:= Pos('=',sArgs);
    if i>0 then sTmp:= copy(sArgs,1,i-1)
    else sTmp := sArgs;
    raise EOF_ZLEException.Create( 'KRYT_WARTPRACY - nierozpoznany argument:'#13+sTmp);
  end;

begin
  result := 0.0;
  bNarzuty := False;

  sArgs := AnsiUpperCase(StringReplace(sArguments, ' ', '', [rfReplaceAll]));

  if ZLEDM.vZLENarzuty then begin
     sNarzuty := Wytnij('NARZUT');
     if sNarzuty = 'TAK' then
        bNarzuty := True;
  end;

  if iOkresNr = 0 then
    result := ZLEDM.ZleDajKrytWartoscPracy( iKryteriaId, iOkresNr, bNarzuty )
  else begin
    oQuery := UNISysDM.UNIOdpytajODane( sUNIOKRES,
                                        sUNISYSALIAS_Okres_Obrachunkowy_ID,
                                        '(@'+sUNISYSALIAS_Okres_Obrachunkowy_Numer+'='+IntToStr(iOkresNr)+')and'+
                                        '(@'+sUNISYSALIAS_Rok_Rok+'='+QuotedStr(sRok)+')',
                                        False, 0 );
    try
      if oQuery <> nil then
         result := ZLEDM.ZleDajKrytWartoscPracy( iKryteriaId, oQuery.FieldByName(sUNIOKRES_ID).AsInteger, bNarzuty )
      else raise EOF_ZLEException.Create( cError_BlednyOkres,
                                          'Funkcja "KRYT_WARTPRACY" - bdny okres obrachunkowy');
    finally
      if oQuery <> nil then oQuery.Free;
    end;
  end;
end;

function TZLEParser.FunctionKRYT_WARTMAT(sArguments: String;
  iOkresNr: Integer; sRok: String): Extended;
var
  oQuery: TUNIQuery;
  bNarzuty: Boolean;
  sArgs, sNarzuty: String;

  function Wytnij( sCo: string; bNum: boolean=false) : string;
  var
    p,q,i  :integer;
    wiele:  boolean;
  begin
    result:= '';
    p:= Pos( sCo+'=',sArgs);
    if p > 0 then begin
      q:= p + length(sCo) + 1;
      wiele:= false;
      for i:= q to length(sArgs) do begin
        case sArgs[i] of
          '[':  wiele:= true;
          ',':  if not wiele then break;
          ']':  wiele:= false;
        end;
      end;
      result:= copy( sArgs,q,i-q);

      delete( sArgs, p, i-p);
      result:= StringReplace( result,'[','(',[rfReplaceAll]);
      result:= StringReplace( result,']',')',[rfReplaceAll]);
      if not bNum then begin
        result:= StringReplace( result,',',#39','#39,[rfReplaceAll]);
        if Pos('(',result)>0 then begin
          insert(#39,result,2);
          insert(#39,result,length(result));
        {end else begin
          result:= #39+result+#39;}
        end;
      end;
    end;
  end;

  procedure Przerwij;
  var
    i:  integer;
    sTmp: String;
  begin
    i:= Pos('=',sArgs);
    if i>0 then sTmp:= copy(sArgs,1,i-1)
    else sTmp := sArgs;
    raise EOF_ZLEException.Create( 'KRYT_WARTMAT - nierozpoznany argument:'#13+sTmp);
  end;

begin
  result := 0.0;
  bNarzuty := False;

  sArgs := AnsiUpperCase(StringReplace(sArguments, ' ', '', [rfReplaceAll]));

  if ZLEDM.vZLENarzuty then begin
     sNarzuty := Wytnij('NARZUT');
     if sNarzuty = 'TAK' then
        bNarzuty := True;
  end;

  if iOkresNr = 0 then
    result := ZLEDM.ZleDajKrytWartoscMat( iKryteriaId, iOkresNr, bNarzuty )
  else begin
    oQuery := UNISysDM.UNIOdpytajODane( sUNIOKRES,
                                        sUNISYSALIAS_Okres_Obrachunkowy_ID,
                                        '(@'+sUNISYSALIAS_Okres_Obrachunkowy_Numer+'='+IntToStr(iOkresNr)+')and'+
                                        '(@'+sUNISYSALIAS_Rok_Rok+'='+QuotedStr(sRok)+')',
                                        False, 0 );
    try
      if oQuery <> nil then
        result := ZLEDM.ZleDajKrytWartoscMat( iKryteriaId, oQuery.FieldByName(sUNIOKRES_ID).AsInteger, bNarzuty )
      else raise EOF_ZLEException.Create( cError_BlednyOkres,
                                          'Funkcja "KRYT_WARTMAT" - bdny okres obrachunkowy');
    finally
      if oQuery <> nil then oQuery.Free;
    end;
  end;
end;

function TZLEParser.FunctionKRYT_ILOSCPRACY(sArguments: String;
  iOkresNr: Integer; sRok: String): Extended;
var
  oQuery: TUNIQuery;
  bNarzuty: Boolean;
  sArgs, sNarzuty: String;

  function Wytnij( sCo: string; bNum: boolean=false) : string;
  var
    p,q,i  :integer;
    wiele:  boolean;
  begin
    result:= '';
    p:= Pos( sCo+'=',sArgs);
    if p > 0 then begin
      q:= p + length(sCo) + 1;
      wiele:= false;
      for i:= q to length(sArgs) do begin
        case sArgs[i] of
          '[':  wiele:= true;
          ',':  if not wiele then break;
          ']':  wiele:= false;
        end;
      end;
      result:= copy( sArgs,q,i-q);

      delete( sArgs, p, i-p);
      result:= StringReplace( result,'[','(',[rfReplaceAll]);
      result:= StringReplace( result,']',')',[rfReplaceAll]);
      if not bNum then begin
        result:= StringReplace( result,',',#39','#39,[rfReplaceAll]);
        if Pos('(',result)>0 then begin
          insert(#39,result,2);
          insert(#39,result,length(result));
        {end else begin
          result:= #39+result+#39;}
        end;
      end;
    end;
  end;

  procedure Przerwij;
  var
    i:  integer;
    sTmp: String;
  begin
    i:= Pos('=',sArgs);
    if i>0 then sTmp:= copy(sArgs,1,i-1)
    else sTmp := sArgs;
    raise EOF_ZLEException.Create( 'KRYT_ILOSCPRACY - nierozpoznany argument:'#13+sTmp);
  end;

begin
  result := 0.0;
  bNarzuty := False;

  sArgs := AnsiUpperCase(StringReplace(sArguments, ' ', '', [rfReplaceAll]));

  if ZLEDM.vZLENarzuty then begin
     sNarzuty := Wytnij('NARZUT');
     if sNarzuty = 'TAK' then
        bNarzuty := True;
  end;

  if iOkresNr = 0 then
    result := ZLEDM.ZleDajKrytIloscPracy( iKryteriaId, iOkresNr, bNarzuty )
  else begin
    oQuery := UNISysDM.UNIOdpytajODane( sUNIOKRES,
                                        sUNISYSALIAS_Okres_Obrachunkowy_ID,
                                        '(@'+sUNISYSALIAS_Okres_Obrachunkowy_Numer+'='+IntToStr(iOkresNr)+')and'+
                                        '(@'+sUNISYSALIAS_Rok_Rok+'='+QuotedStr(sRok)+')',
                                        False, 0 );
    try
      if oQuery <> nil then
         result := ZLEDM.ZleDajKrytIloscPracy( iKryteriaId, oQuery.FieldByName(sUNIOKRES_ID).AsInteger, bNarzuty )
      else raise EOF_ZLEException.Create( cError_BlednyOkres,
                                          'Funkcja "KRYT_ILOSCPRACY" - bdny okres obrachunkowy');
    finally
      if oQuery <> nil then oQuery.Free;
    end;
  end;
end;

(************************************************************************
function TZLEParser.FunctionKRYT_WSPPRACY(sArguments: String;
  iOkresNr: Integer; sRok: String): Extended;
var
  oQuery: TUNIQuery;
begin
  result := 0.0;
  if iOkresNr = 0 then
    result := ZLEDM.ZleDajKrytWspPracy( iKryteriaId, iOkresNr )
  else
    try
      oQuery := UNISysDM.UNIOdpytajODane( sUNIOKRES,
                                          sUNISYSALIAS_Okres_Obrachunkowy_ID,
                                          '(@'+sUNISYSALIAS_Okres_Obrachunkowy_Numer+'='+IntToStr(iOkresNr)+')and'+
                                          '(@'+sUNISYSALIAS_Rok_Rok+'='+QuotedStr(sRok)+')',
                                          False, 0 );
      if oQuery <> nil then
        result := ZLEDM.ZleDajKrytWspPracy( iKryteriaId, oQuery.FieldByName(sUNIOKRES_ID).AsInteger )
      else raise EOF_ZLEException.Create( cError_BlednyOkres,
                                          'Funkcja "KRYT_WSPPRACY" - bdny okres obrachunkowy');
    finally
      if oQuery <> nil then oQuery.Free;
    end;
end;

function TZLEParser.FunctionKRYT_WSPMAT(sArguments: String;
  iOkresNr: Integer; sRok: String): Extended;
var
  oQuery: TUNIQuery;
begin
  result := 0.0;
  if iOkresNr = 0 then
    result := ZLEDM.ZleDajKrytWspMat( iKryteriaId, iOkresNr )
  else
    try
      oQuery := UNISysDM.UNIOdpytajODane( sUNIOKRES,
                                          sUNISYSALIAS_Okres_Obrachunkowy_ID,
                                          '(@'+sUNISYSALIAS_Okres_Obrachunkowy_Numer+'='+IntToStr(iOkresNr)+')and'+
                                          '(@'+sUNISYSALIAS_Rok_Rok+'='+QuotedStr(sRok)+')',
                                          False, 0 );
      if oQuery <> nil then
        result := ZLEDM.ZleDajKrytWspMat( iKryteriaId, oQuery.FieldByName(sUNIOKRES_ID).AsInteger )
      else raise EOF_ZLEException.Create( cError_BlednyOkres,
                                          'Funkcja "KRYT_WSPMAT" - bdny okres obrachunkowy');
    finally
      if oQuery <> nil then oQuery.Free;
    end;
end;
************************************************************************)

function TZLEParser.FunctionWART_ROZL(sArguments: String;
  iOkresNr: Integer; sRok: String): Extended;
var
  oQuery: TUNIQuery;
begin
  result := 0.0;
  if iOkresNr = 0 then
    result := ZLEDM.ZleDajWartoscRozliczenia( iZlecenieId, iOkresNr )
  else begin
    oQuery := UNISysDM.UNIOdpytajODane( sUNIOKRES,
                                        sUNISYSALIAS_Okres_Obrachunkowy_ID,
                                        '(@'+sUNISYSALIAS_Okres_Obrachunkowy_Numer+'='+IntToStr(iOkresNr)+')and'+
                                        '(@'+sUNISYSALIAS_Rok_Rok+'='+QuotedStr(sRok)+')',
                                        False, 0 );
    try
      if oQuery <> nil then
        result := ZLEDM.ZleDajWartoscRozliczenia( iZlecenieId, oQuery.FieldByName(sUNIOKRES_ID).AsInteger )
      else raise EOF_ZLEException.Create( cError_BlednyOkres,
                                          'Funkcja "WART_ROZL" - bdny okres obrachunkowy');
    finally
      if oQuery <> nil then oQuery.Free;
    end;
  end;
end;

function TZLEParser.FunctionILOSC_PALIWA(sArguments: String;
  iOkresNr: Integer; sRok: String): Extended;
var
  oQuery: TUNIQuery;
begin
  result := 0.0;
  if iOkresNr = 0 then
    result := ZLEDM.ZleDajIloscPaliwa( iZlecenieId, iOkresNr )
  else begin
    oQuery := UNISysDM.UNIOdpytajODane( sUNIOKRES,
                                        sUNISYSALIAS_Okres_Obrachunkowy_ID,
                                        '(@'+sUNISYSALIAS_Okres_Obrachunkowy_Numer+'='+IntToStr(iOkresNr)+')and'+
                                        '(@'+sUNISYSALIAS_Rok_Rok+'='+QuotedStr(sRok)+')',
                                        False, 0 );
    try
      if oQuery <> nil then
        result := ZLEDM.ZleDajIloscPaliwa( iZlecenieId, oQuery.FieldByName(sUNIOKRES_ID).AsInteger )
      else raise EOF_ZLEException.Create( cError_BlednyOkres,
                                          'Funkcja "ILOSC_PALIWA" - bdny okres obrachunkowy');
    finally
      if oQuery <> nil then oQuery.Free;
    end;
  end;
end;

function TZLEParser.FunctionWARTPL(sArguments: String; iOkresNr: Integer; sOkresRok: String): Extended;
var
  oQuery, qKoszt: TUNIQuery;
  bPozRozdz,  bWgJedn: Boolean;
  sArgs, sPozRozdz, sZlecenie, sWgJedn, sCofnijOkres: String;
  slListaKosztow: TStringList;
  iOkresMiesiac, iOkresRok, iCofnijOkres: Integer;
  oParams: TKeyValues;
  sListaPKTmp, sListaMnem: string;

  function Wytnij( sCo: string; bNum: boolean=false) : string;
  var
    p,q,i  :integer;
    wiele:  boolean;
  begin
    result:= '';
    p:= Pos( sCo+'=',sArgs);
    if p > 0 then begin
      q:= p + length(sCo) + 1;
      wiele:= false;
      for i:= q to length(sArgs) do begin
        case sArgs[i] of
          '[':  wiele:= true;
          ',':  if not wiele then break;
          ']':  wiele:= false;
        end;
      end;
      result:= copy( sArgs,q,i-q);

      delete( sArgs, p, i-p);
      result:= StringReplace( result,'[','(',[rfReplaceAll]);
      result:= StringReplace( result,']',')',[rfReplaceAll]);
      if not bNum then begin
        result:= StringReplace( result,',',#39','#39,[rfReplaceAll]);
        if Pos('(',result)>0 then begin
          insert(#39,result,2);
          insert(#39,result,length(result));
        end else begin
          result:= #39+result+#39;
        end;
      end;
    end;
  end;

  procedure Przerwij;
  var
    i:  integer;
    sTmp: String;
  begin
    i:= Pos('=',sArgs);
    if i>0 then sTmp:= copy(sArgs,1,i-1)
    else sTmp := sArgs;
    raise EOF_ZLEException.Create( 'WARTPL - nierozpoznany argument:'#13+sTmp);
  end;

begin
  result := 0.0;
  slListaKosztow  := nil;
  oParams := TKeyValues.CreateEmpty;
  sListaPKTmp := '';

  try
    sArgs := AnsiUpperCase(StringReplace(sArguments, ' ', '', [rfReplaceAll]));

    if sOkresRok = '' then raise EOF_ZLEException.Create( 'WARTPL - brak roku obrachunkowego');

    sZlecenie := Wytnij('ZLECENIE');
    sWgJedn := Wytnij('WGJEDN', true);

    bWgJedn := False;
    if sWgJedn  = 'TAK' then
       bWgJedn := True;

    sCofnijOkres := Wytnij('COFNIJOKRES', True);
    iCofnijOkres := 0;
    if sCofnijOkres <> '' then
       try
         iCofnijOkres := StrToInt(sCofnijOkres);
       except
         iCofnijOkres := 0;
       end;

    sPozRozdz := Wytnij('POZROZDZ');
    if sPozRozdz <> '' then begin
      bPozRozdz := True;

      if bPozROzdz then begin
         slListaKosztow := TStringList.Create;
         {Zapytanie do bazy o PozRozdzID }
         qKoszt := SQLManager.CreateQuery('SELECT DISTINCT PLROZ.' + sPLROZDEF_ID + ' FROM %s PLROZ, %s ZLEPL ' +
                                          'WHERE PLROZ.' + sPLROZDEF_ID + ' = ZLEPL.' + sPLROZDEF_ID + ' AND ' +
                                                'PLROZ.' + sPLROZDEF_SYMBOL + ' IN ' + sPozRozdz,
                                          [sPLROZDEF, sZLEPLROZDEF]);
         try
            qKoszt.Open;
            while not qKoszt.Eof do begin
              slListaKosztow.Add(qKoszt.FieldByName(sPLROZDEF_ID).AsString);
              qKoszt.Next;
            end;
         finally
            if qKoszt <> nil then FreeAndNil(qKoszt);
         end;
      end;
    end;

    // kocowa kontrola parametrw
    sArgs:= StringReplace( sArgs,',','',[rfReplaceAll]);
    if sArgs<>'' then Przerwij;

    if iOkresNr > 0 then begin
      oQuery := UNISysDM.UNIOdpytajODane( sUNIOKRES,
                                          sUNISYSALIAS_Okres_Obrachunkowy_ID + ';' + sUNISYSALIAS_Poczatek_Okresu_Obrachunkowego,
                                          '(@'+sUNISYSALIAS_Okres_Obrachunkowy_Numer+'='+IntToStr(iOkresNr)+')and'+
                                          '(@'+sUNISYSALIAS_Rok_Rok+'='+QuotedStr(sOkresRok)+')',
                                          False, 0 );
      try
        if oQuery <> nil then  begin

          try
            iOkresMiesiac := StrToInt(FormatDateTime('m', oQuery.FieldByName(sUNIOKRES_DATA_POCZ).AsDateTime));
          except
            raise EOF_ZLEException.Create( cError_BlednyOkres, 'Funkcja WARTPL - bdny miesic');
          end;

          try
            iOkresRok := StrToInt(Copy(sOkresRok, 1, 4));
          except
            raise EOF_ZLEException.Create( cError_BlednyOkres, 'Funkcja WARTPL - bdny rok');
          end;

          {Wypenienie parametrow}
          sListaPKTmp := '';
          sListaMnem := '';
          if DataManagers.Available(sKDECPModulId) then
             sListaMnem := KDECPDM.KDECPDajListeMnemonikow(sZRODLO_ZLECENIA);

          if sListaMnem <> '' then begin
            {if Pos(sMnemonikJednostkaOrg, sListaMnem) > 0 then
               sListaPKTmp := sMnemonikJednostkaOrg + '=' + IntToStr(iJednostkaOrgID);
            if Pos(sMnemonikZlecenie, sListaMnem) > 0 then begin
               if sListaPKTmp <> '' then sListaPKTmp := sListaPKTmp + ',';
                 sListaPKTmp := sListaPKTmp + sMnemonikZlecenie + '=' + IntToStr(iZlecenieID);
            end;}
            if (Pos(sMnemonikPracownicy, sListaMnem) > 0) and (iOsobaID > 0) then begin
               //if sListaPKTmp <> '' then sListaPKTmp := sListaPKTmp + ',';
               sListaPKTmp := sListaPKTmp + sMnemonikPracownicy + '=' + IntToStr(iOsobaID);
            end;
          end;

          if sListaPKTmp <> '' then
             oParams.Values[sLISTAPK] := sListaPKTmp;

          try
            result := PLLIDM.PLPodajWartoscKosztow(UNISYSDM.vAktywnaFirma,
                                                 iZlecenieID,
                                                 iOkresRok,
                                                 iOkresMiesiac,
                                                 slListaKosztow,
                                                 bWgJedn,
                                                 iCofnijOkres,
                                                 oParams);
          except
            raise EOF_ZLEException.Create( cError_BlednyOkres, 'Funkcja WARTPL'#13+Exception(ExceptObject).Message);
          end;
        end else raise EOF_ZLEException.Create( cError_BlednyOkres, 'Funkcja WARTPL - bdny okres obrachunkowy');
      finally
        if oQuery <> nil then oQuery.Free;
      end;
    end;
  finally
     FreeAndNil(oParams);
  end;

end;

function TZLEParser.FunctionZLEPOZILOSC(sArguments: String;
  iOkresNr: Integer; sRok: String): Extended;
var
  oQuery: TUNIQuery;
  sSQL: String;
begin
  result := 0.0;
  sSQL := 'SELECT COALESCE(SUM(NVL(POZ.' + sZLEZLECENIEPOZ_ILOSC + ', 0)),0) AS ' + sZLEZLECENIEPOZ_ILOSC + ' ' +
          'FROM %s POZ ' +
          'WHERE POZ.' + sZLEZLECENIE_ID + '=' + IntToStr(iZlecenieId) +
           ' AND POZ.' + sASOASORT_ID + '=' + IntToStr(iAsortId);

  oQuery := SQLManager.CreateQuery( sSQL, [sZLEZLECENIEPOZ]);
  try
    oQuery.Open();
    if not oQuery.IsEmpty then
      result := oQuery.FieldByName(sZLEZLECENIEPOZ_ILOSC).AsFloat;
  finally
    if oQuery <> nil then FreeAndNil(oQuery);
  end;
end;

function TZLEParser.FunctionZLEPOZCENA(sArguments: String;
  iOkresNr: Integer; sRok: String): Extended;
var
  oQuery: TUNIQuery;
  sSQL: String;
begin
  result := 0.0;
  sSQL := 'SELECT COALESCE(SUM(NVL(POZ.' + sZLEZLECENIEPOZ_CENA + ', 0)),0) AS ' + sZLEZLECENIEPOZ_CENA + ' ' +
          'FROM %s POZ ' +
          'WHERE POZ.' + sZLEZLECENIE_ID + '=' + IntToStr(iZlecenieId) +
           ' AND POZ.' + sASOASORT_ID + '=' + IntToStr(iAsortId);

  oQuery := SQLManager.CreateQuery( sSQL, [sZLEZLECENIEPOZ]);
  try
    oQuery.Open();
    if not oQuery.IsEmpty then
      result := oQuery.FieldByName(sZLEZLECENIEPOZ_CENA).AsFloat;
  finally
    if oQuery <> nil then FreeAndNil(oQuery);
  end;
end;

function TZLEParser.FunctionZLEWARTPOZ(sArguments: String;
  iOkresNr: Integer; sRok: String): Extended;
var
  oQuery: TUNIQuery;
  sSQL: String;
begin
  result := 0.0;
  sSQL := 'SELECT COALESCE(SUM(NVL(POZ.' + sZLEZLECENIEPOZ_WARTOSC + ', 0)),0) AS ' + sZLEZLECENIEPOZ_WARTOSC + ' ' +
          'FROM %s POZ ' +
          'WHERE POZ.' + sZLEZLECENIE_ID + '=' + IntToStr(iZlecenieId);
  if not KontrolaWartosciowa then
     sSQL := sSQL +
           ' AND POZ.' + sASOASORT_ID + '=' + IntToStr(iAsortId);

  oQuery := SQLManager.CreateQuery( sSQL, [sZLEZLECENIEPOZ]);
  try
    oQuery.Open();
    if not oQuery.IsEmpty then
      result := oQuery.FieldByName(sZLEZLECENIEPOZ_WARTOSC).AsFloat;
  finally
    if oQuery <> nil then FreeAndNil(oQuery);
  end;
end;

end.
