unit ZLEPlRozDefGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When         Who      What
---------------------------------------------------------------------------------------------
2006-10-05 Tomjen     Utworzone
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls,UNIStaleUnit, UNIDataModuleUnit;

type
  TZLEPlRozDefGridForm = class(TUNIDBGridForm)
    DaneToolBar: TUNIToolBar;
    PrzyciskiOsadzoneToolBar: TUNIToolBar;
    DopiszToolButton: TToolButton;
    UsunToolButton: TToolButton;
    procedure NewMenuItemClick(Sender: TObject);
    procedure DeleteMenuItemClick(Sender: TObject);
  protected
    m_bContained: Boolean;
    procedure BeforeShow; override;
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure New; override;
    procedure Delete; override;
  public
    procedure UstawPrzyciskiOsadzone;
  end;


implementation

uses ZLEDefUnit, ZLEDataManagerUnit, ZLEPlRozDefUnit, FormManagerUnit,
  SQLManagerUnit, MAGDefUnit, Dodatki, UniDataManagerUnit, PLLIDefUnit,
  PLLIDataManagerExtUnit, UniSysDataManagerUnit, UniqueKeyUnit,
  ZleParametrySelectFormUnit;

{$R *.DFM}
{ TZLEPlRozDefGridForm }


function TZLEPlRozDefGridForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  Result := TZLEPlRozDefDataModule.CreateOpen( self, nil {DefaultMasterKeyValues}, AOpenMode);
end;

procedure TZLEPlRozDefGridForm.BeforeShow;
begin
  inherited;
  if (OpenModeFlags and omContained) = omContained then begin
    m_bContained    := true;
//    m_iTrybOtwarcia := omOverVirtual + omShowModal;
//    m_iTrybOtwarcia := omShowModal;
  end;
  UstawPrzyciskiOsadzone;
end;

procedure TZLEPlRozDefGridForm.UstawPrzyciskiOsadzone;
begin
  DaneToolBar.Visible := m_bContained;

  if m_bContained then begin
    UsunToolButton.Enabled   := (DeleteMenuItem.Visible and DeleteMenuItem.Enabled);
    DopiszToolButton.Enabled := (NewMenuItem.Visible    and NewMenuItem.Enabled);
  end;
end;


procedure TZLEPlRozDefGridForm.Delete;
begin
  DataModule.Delete;
end;

procedure TZLEPlRozDefGridForm.New;
begin
//  inherited;
//  DataModule.New;
//  (owner as TASOAsortDBDetailForm).DodajKontoM;
end;

procedure TZLEPlRozDefGridForm.NewMenuItemClick(Sender: TObject);
var
  qKoszt: TUNIQuery;
  v: TUNIDBGridForm;
begin
  inherited;
  if DataManagers.Available(sPLLIModulID) then begin
     qKoszt := PLLIDM.PokazIWybierzRodzajeKosztowRozdzielnika;
     if qKoszt <> nil then begin
         v:= TZleParametrySelectForm(Owner).ContainedForms[TZleParametrySelectForm(Owner).PanelPLIndex] as TUNIDBGridForm;
         with v.DataModule.ActiveQuery as TVirtualDataSet do begin
           while not qKoszt.Eof do begin
             try
               VState := vsInternalInsert;
               Insert;
               FieldByName(sZLEPLROZDEF_ID).Value:= UniqueKey[sZLEPLROZDEF];
               v.DataModule.SetTechnicalFieldsOnInsert;

               FieldByName(sPLROZDEF_ID).Value:= qKoszt.FieldByName(sPLROZDEF_ID).Value;
               UpdateModifiedRecordFlagsForAddedRecord;
               
               {A to tylko dla grida - bez statusu modyfikacji}
               FieldByName(sPLROZDEF_SYMBOL).Value := qKoszt.FieldByName(sPLROZDEF_SYMBOL).Value;
               FieldByName(sPLROZDEF_NAZWA).Value := qKoszt.FieldByName(sPLROZDEF_NAZWA).Value;
               Post;
             finally
               VState := vsNormal;
             end;
             qKoszt.Next;
           end;
         end;
     end;
  end;


end;

procedure TZLEPlRozDefGridForm.DeleteMenuItemClick(Sender: TObject);
begin
  inherited;
  { --- }
end;

initialization
  FormManager.RegisterForm(TZLEPlRozDefGridForm, sZLEModulID);
end.
