unit ZLEPoleZmDefDBDetailFormUnit;
{
Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who        What
---------------------------------------------------------------------------------------------
2005-12-20 Tomjen     Utworzenie
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBDetailFormUnit, Menus, UNIComponentsUnit, Db, ToolWin, ComCtrls,
  StdCtrls, ExtCtrls, UNIStaleUnit, UNIDataModuleUnit, Mask, DBCtrls,
  UNIDBConstComboBoxUnit;

type
  TZLEPoleZmDefDBDetailForm = class(TUNIDBDetailForm)
    OgolnePanel: TUNIPanel;
    ZLEPoleZmDefNazwaLabel: TUNILabel;
    ZLEPoleZmDefTypLabel: TUNILabel;
    ZLEPoleZmDefMnemonikLabel: TUNILabel;
    UNILabel2: TUNILabel;
    ZLEPoleZmDefNazwaDBEdit: TUNIDBEdit;
    ZLEPoleZmDefMnemonikLookupAliasEdit: TUNILookupAliasEdit;
    ZLEPoleZmDefTypConstComboBox: TUNIDBConstComboBox;
    ZLEPoleZmDefDomenaLookupAliasEdit: TUNILookupAliasEdit;
    TypDanychPanel: TUNIPanel;
    TypDanychLabel: TUNILabel;
    TypDanychDBConstComboBox: TUNIDBConstComboBox;
    InnePanel: TUNIPanel;
    ZLEPoleZmDefDlugLabel: TUNILabel;
    ZnakiLabel: TUNILabel;
    ZLEPoleZmDefDlugDBEdit: TUNIDBEdit;
    ZnakiDBEdit: TUNIDBEdit;
    FormatLabel: TUNILabel;
    FormatDBEdit: TUNIDBEdit;
    procedure ZLEPoleZmDefMnemonikLookupAliasEditButtonClick(
      Sender: TObject);
    function ZLEPoleZmDefMnemonikLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    procedure ZLEPoleZmDefTypConstComboBoxChange(Sender: TObject);
    procedure SelectButtonClick(Sender: TObject);
    procedure ZLEPoleZmDefDomenaLookupAliasEditButtonClick(Sender: TObject);
    function ZLEPoleZmDefDomenaLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure ZLEPoleZmDefMnemonikLookupAliasEditDelKey(Sender: TObject);
    procedure ZLEPoleZmDefDomenaLookupAliasEditDelKey(Sender: TObject);
    procedure TypDanychDBConstComboBoxExit(Sender: TObject);
  private
    sNazwa:  string;
    procedure InitializeControls();
    procedure SetDefaults();
  protected
    procedure InternalOpen(); override;
    procedure BeforeShow; override;
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
  public
    class function  ClassIsSingle: boolean; override;
    function Validate : boolean; override;

  end;

implementation

uses
  FormManagerUnit,
  KeyManagerUnit,
  ZLEPoleZmDefUnit,
  SQLManagerUnit,
  ZLEDefUnit,
  FKDefUnit,
  Dodatki,
  UNISysDataManagerUnit,
  UNISysDefUnit,
  UNIDBGridFormUnit,
  FKDataManagerUnit,
  ZLEDataManagerUnit;

{$R *.DFM}

procedure TZLEPoleZmDefDBDetailForm.BeforeShow;
begin
  inherited;
  sNazwa := ZLEPoleZmDefNazwaDBEdit.Text;

  if not (OpenMode in [omNew, omEdit]) then begin
    ZLEPoleZmDefTypConstComboBox.Enabled := False;
    TypDanychDBConstComboBox.Enabled := False;
  end;

  if (not DMAQFbN(sFKMNEMONIKI_ID).IsNull)or
     (not DMAQFbN(sUNICONSTDEF_ID).IsNull) then begin
    TypDanychPanel.Visible := False;
    InnePanel.Visible := False;
  end;

  HideStatusPanel;
end;

class function TZLEPoleZmDefDBDetailForm.ClassIsSingle: boolean;
begin
  Result := true;
end;

function TZLEPoleZmDefDBDetailForm.CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule;
begin
  Result := TZLEPoleZmDef.CreateOpen( self, InheritedMasterKeyValues, AOpenMode);
  //Result := TZLEPoleZmDef.CreateOpen( self, Nil, AOpenMode);
end;

function TZLEPoleZmDefDBDetailForm.Validate;
begin
  Result := False;
  if not inherited Validate then Exit;
  if
    (OpenMode = omNew) or ((OpenMode = omEdit) and (ZLEPoleZmDefNazwaDBEdit.Text <> sNAZWA))
  then
    if SQLManager.OpenQueryWithResult(
      'SELECT ' +
      sZLEPOLAZMDEF_ID +
      ' FROM %s WHERE ' +
      sZLEPOLAZMDEF_NAZWA +
      '=''' +
      ZLEPoleZmDefNazwaDBEdit.Text +
      '''',
      [sZLEPOLAZMDEF]
    ) <> ''
    then begin
      Komunikat(cWarning, 'Istnieje ju zmienna o nazwie ' + '''' + ZLEPoleZmDefNazwaDBEdit.Text + '''!');
      ZLEPoleZmDefNazwaDBEdit.SetFocus;
      Exit;
    end;
  Result:= True;
end;

procedure TZLEPoleZmDefDBDetailForm.ZLEPoleZmDefMnemonikLookupAliasEditButtonClick(
  Sender: TObject);
var
  Q: TUNIQuery;
  sWarunek: string;
begin
  sWarunek := '';
  Q := UNISYSDataManager.UNIPokazIObsluzDane(
    sFKMNEMONIKI {sTabela},
    sWarunek     {sWarunek: string},
    False        {bBlok},
    False        {bWyborWielu: boolean},
    sFKALIAS_MNEMONIKI_ID + ';' +
    sFKALIAS_MNEMONIKI_NAZWA {sAtrybuty: string},
    vAktywnaFirma {iFirmaID: integer},
    IntToStr(DodatkiGetIntegerValue(Datamodule.ActiveQuery, sFKMNEMONIKI_ID))
  );
  if Q <> NIL then try
    ZLEPoleZmDefMnemonikLookupAliasEditSetData(Q);
  finally
    Q.Free;
  end;
end;

function TZLEPoleZmDefDBDetailForm.ZLEPoleZmDefMnemonikLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  inherited;
  Result:= True;
  with AliasSrc do
    if DMAQFbN(sFKMNEMONIKI_ID).AsInteger <> Fields[0].Value then begin
      DataModule.ActiveQuery[sFKMNEMONIKI_ID] := Fields[0].Value;
      ZLEPoleZmDefMnemonikLookupAliasEdit.Text := Fields[1].AsString;
      TypDanychPanel.Visible := False;
      InnePanel.Visible := False;
    end;
  if OpenMode in [omNew,omEdit] then
    ZLEPoleZmDefDomenaLookupAliasEditDelKey(Nil);
end;

procedure TZLEPoleZmDefDBDetailForm.ZLEPoleZmDefTypConstComboBoxChange(
  Sender: TObject);
begin
  inherited;
  {
  if ZLEPoleZmDefTypConstComboBox.ItemIndex = 0 then begin
    if (OpenMode = omNew) or (OpenMode = omEdit) then DMAQFbN(sFKMNEMONIKI_ID).Clear;
    ZLEPoleZmDefMnemonikLabel.Visible := False;
    ZLEPoleZmDefMnemonikLookupAliasEdit.Visible := False;
    ZLEPoleZmDefMnemonikLookupAliasEdit.Text := '';
  end else begin
    ZLEPoleZmDefMnemonikLabel.Visible := True;
    ZLEPoleZmDefMnemonikLookupAliasEdit.Visible := True;
  end;
  }
end;

procedure TZLEPoleZmDefDBDetailForm.SelectButtonClick(Sender: TObject);
begin
  {
  if (OpenMode = omNew) or (OpenMode = omEdit) then
    if ZLEPoleZmDefTypConstComboBox.ItemIndex > 1 then
      if DMAQFbN(sFKMNEMONIKI_ID).IsNull then begin
        Komunikat(cWarning, 'Poniewa zmienna zdefiniowana jest jako ''Wymagana'' - musisz wskaza sownik wartoci');
        ZLEPoleZmDefMnemonikLookupAliasEdit.SetFocus;
        Exit;
      end;
  }
  inherited;
end;

procedure TZLEPoleZmDefDBDetailForm.InternalOpen;
begin
  InitializeControls();
  inherited;
  if OpenMode = omNew then
    SetDefaults()
  else begin
    ZLEPoleZmDefMnemonikLookupAliasEdit.InitiateData(DMAQFbN(sFKMNEMONIKI_ID).AsInteger);
    ZLEPoleZmDefDomenaLookupAliasEdit.InitiateData(DMAQFbN(sUNICONSTDEF_ID).AsInteger);
    TypDanychDBConstComboBoxExit(TypDanychDBConstComboBox);
  end;

  //ustawienie kontrolek wg parametrw wejciowych
  //typ parametru
  if Parameters.Values[cParam_ZLEPOLAZMDEF_TYP] <> '' then begin
    ZLEPoleZmDefTypConstComboBox.Enabled := False;
    ZLEPoleZmDefTypLabel.Enabled := False;
  end;
  //typ danych
  if Parameters.Values[cParam_ZLEPOLAZMDEF_TYPDANYCH] <> '' then begin
    TypDanychDBConstComboBox.Enabled := False;
    TypDanychLabel.Enabled := False;
    ZLEPoleZmDefMnemonikLookupAliasEdit.aReadOnly := True;
    ZLEPoleZmDefDomenaLookupAliasEdit.aReadOnly := True;
  end;
  //dlugo parametru
  if Parameters.Values[cParam_ZLEPOLAZMDEF_DLUG] <> '' then begin
    ZLEPoleZmDefDlugDBEdit.Enabled := False;
    ZLEPoleZmDefDlugLabel.Enabled := False;
  end;
  if Parameters.Values[cParam_ZLEPOLAZMDEF_ZNAKI] <> '' then begin
    ZnakiDBEdit.Enabled := False;
    ZnakiLabel.Enabled := False;
  end;
end;

procedure TZLEPoleZmDefDBDetailForm.ZLEPoleZmDefDomenaLookupAliasEditButtonClick(
  Sender: TObject);
var
  Q: TUNIQuery;
  sWarunek: string;
begin
  sWarunek := '';
  Q := UNISysDataManager.UNIPokazIObsluzDane(
    sUNICONSTDEF {sTabela},
    sWarunek     {sWarunek: string},
    False        {bBlok},
    False        {bWyborWielu: boolean},
    sUNISYSALIAS_CONSTDEF_ID + ';' +
    sUNISYSALIAS_CONSTDEF_DOMENA {sAtrybuty: string},
    vAktywnaFirma {iFirmaID: integer},
    DMAQFbN(sUNICONSTDEF_ID).AsString
  );
  if Q <> NIL then try
    ZLEPoleZmDefDomenaLookupAliasEditSetData(Q);
  finally
    Q.Free;
  end;
end;

function TZLEPoleZmDefDBDetailForm.ZLEPoleZmDefDomenaLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  inherited;
  Result:= True;
  with AliasSrc do
    if DMAQFbN(sUNICONSTDEF_ID).AsInteger <> Fields[0].Value then begin
      DataModule.ActiveQuery[sUNICONSTDEF_ID] := Fields[0].Value;
      ZLEPoleZmDefDomenaLookupAliasEdit.Text := Fields[1].AsString;
      TypDanychPanel.Visible := False;
      InnePanel.Visible := False;
    end;
  if OpenMode in [omNew, omEdit] then
    ZLEPoleZmDefMnemonikLookupAliasEditDelKey(Nil);
end;

procedure TZLEPoleZmDefDBDetailForm.ZLEPoleZmDefMnemonikLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  DMAQFbN(sFKMNEMONIKI_ID).Clear;
  ZLEPoleZmDefMnemonikLookupAliasEdit.Text := '';
  if (DMAQFbN(sFKMNEMONIKI_ID).IsNull and DMAQFbN(sUNICONSTDEF_ID).IsNull) then begin
    TypDanychPanel.Visible := True;
    InnePanel.Visible := True;
  end;
end;

procedure TZLEPoleZmDefDBDetailForm.ZLEPoleZmDefDomenaLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  DMAQFbN(sUNICONSTDEF_ID).Clear;
  ZLEPoleZmDefDomenaLookupAliasEdit.Text := '';
  if (DMAQFbN(sFKMNEMONIKI_ID).IsNull and DMAQFbN(sUNICONSTDEF_ID).IsNull) then begin
    TypDanychPanel.Visible := True;
    InnePanel.Visible := True;
  end;
end;

procedure TZLEPoleZmDefDBDetailForm.InitializeControls;
begin
  //zainicjalizowanie kontrolek
  if Parameters = nil then
    Parameters := TKeyValues.CreateEmpty();
  ZLEPoleZmDefNazwaDBEdit.DataField := sZLEPOLAZMDEF_NAZWA;
  ZLEPoleZmDefTypConstComboBox.DataField := sZLEPOLAZMDEF_TYP;
  ZLEPoleZmDefDlugDBEdit.DataField := sZLEPOLAZMDEF_DLUG;
  TypDanychDBConstComboBox.DataField := sZLEPOLAZMDEF_TYPDANYCH;
  ZnakiDBEdit.DataField := sZLEPOLAZMDEF_ZNAKI;
  FormatDBEdit.DataField := sZLEPOLAZMDEF_FORMAT;

  ZLEPoleZmDefTypConstComboBox.Items.AddStrings(cslZLEPolaUzState);
  TypDanychDBConstComboBox.Items.AddStrings(cslZLETypDanych);

  with ZLEPoleZmDefMnemonikLookupAliasEdit do begin
    AliasManager := UniSysDM.AliasManager;
    Alias_ID := sFKAlias_Mnemoniki_ID;
    Alias_Name := sFKAlias_Mnemoniki_Nazwa;
  end;

  with ZLEPoleZmDefDomenaLookupAliasEdit do begin
    AliasManager := UNISYSDM.AliasManager;
    Alias_ID := sUNISysAlias_ConstDef_ID;
    Alias_Name := sUNISysAlias_ConstDef_Domena;
  end;

end;

procedure TZLEPoleZmDefDBDetailForm.SetDefaults;
begin
  try
    (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := True;
    //typ parametru
    if Parameters.Values[cParam_ZLEPOLAZMDEF_TYP] <> '' then begin
      DMAQFBN(sZLEPOLAZMDEF_TYP).AsString := Parameters.Values[cParam_ZLEPOLAZMDEF_TYP];
      //ZLEPoleZmDefTypConstComboBox.Enabled := False;
      //ZLEPoleZmDefTypLabel.Enabled := False;
    end else
      DMAQFBN(sZLEPOLAZMDEF_TYP).AsInteger := 0;
    //sownik
    if Parameters.Values[cParam_FKMNEMONIKI_ID] <> '' then begin
      DMAQFbN(sFKMNEMONIKI_ID).AsString := Parameters.Values[cParam_FKMNEMONIKI_ID];
      //ZLEPoleZmDefMnemonikLookupAliasEdit.InitiateData(DMAQFbN(sFKMNEMONIKI_ID));
      //ZLEPoleZmDefMnemonikLookupAliasEdit.aReadOnly := True;
    end else if Parameters.KeyExists(cParam_FKMNEMONIKI_ID) then begin
      //ZLEPoleZmDefDomenaLookupAliasEdit.aReadOnly := True;
    end;
    //domena
    if Parameters.Values[cParam_UNICONSTDEF_DOMENA] <> '' then begin
      ZLEPoleZmDefDomenaLookupAliasEdit.ReadOnly := False;
      ZLEPoleZmDefDomenaLookupAliasEdit.Text := Parameters.Values[cParam_UNICONSTDEF_DOMENA];
      ZLEPoleZmDefDomenaLookupAliasEdit.Modified := True;
      ZLEPoleZmDefDomenaLookupAliasEdit.DoExit();
      //DMAQFbN(sUNICONSTDEF_ID).AsString := Parameters.Values[cParam_UNICONSTDEF_ID];
      //ZLEPoleZmDefDomenaLookupAliasEdit.InitiateData(DMAQFbN(sUNICONSTDEF_ID));
      //ZLEPoleZmDefDomenaLookupAliasEdit.aReadOnly := True;
    end else if Parameters.KeyExists(cParam_UNICONSTDEF_DOMENA) then begin
      //ZLEPoleZmDefDomenaLookupAliasEdit.aReadOnly := True;
    end;

    //typ danych
    if Parameters.Values[cParam_ZLEPOLAZMDEF_TYPDANYCH] <> '' then begin
      DMAQFbN(sZLEPOLAZMDEF_TYPDANYCH).AsString := Parameters.Values[cParam_ZLEPOLAZMDEF_TYPDANYCH];
      //TypDanychDBConstComboBox.Enabled := False;
      //TypDanychLabel.Enabled := False;
    end else
      DMAQFbN(sZLEPOLAZMDEF_TYPDANYCH).AsString := ZLEDM.DajDefaultPola( sZLEPOLAZMDEF,
                                                                         sZLEPOLAZMDEF_TYPDANYCH );
    TypDanychDBConstComboBoxExit(TypDanychDBConstComboBox);
    //dlugo parametru
    if Parameters.Values[cParam_ZLEPOLAZMDEF_DLUG] <> '' then begin
      DMAQFBN(sZLEPOLAZMDEF_DLUG).AsString := Parameters.Values[cParam_ZLEPOLAZMDEF_DLUG];
      //ZLEPoleZmDefDlugDBEdit.Enabled := False;
      //ZLEPoleZmDefDlugLabel.Enabled := False;
    end else
      DMAQFBN(sZLEPOLAZMDEF_DLUG).AsInteger := 255;
    if Parameters.Values[cParam_ZLEPOLAZMDEF_ZNAKI] <> '' then begin
      DMAQFbN(sZLEPOLAZMDEF_ZNAKI).AsString := Parameters.Values[cParam_ZLEPOLAZMDEF_ZNAKI];
      //ZnakiDBEdit.Enabled := False;
      //ZnakiLabel.Enabled := False;
    end;
  finally
    (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := False;
  end;

end;

procedure TZLEPoleZmDefDBDetailForm.TypDanychDBConstComboBoxExit(
  Sender: TObject);
begin
  inherited;
  FormatLabel.Enabled := False;
  FormatDBEdit.Enabled := False;
  FormatDBEdit.aAllowEmpty := True;
  ZLEPoleZmDefDlugLabel.Enabled := False;
  ZLEPoleZmDefDlugDBEdit.Enabled := False;
  ZnakiLabel.Enabled := False;
  ZnakiDBEdit.Enabled := False;

  if DMAQFbN(sZLEPOLAZMDEF_TYPDANYCH).AsString = cZLETypDanych_FloatID then begin
    FormatLabel.Enabled := True;
    FormatDBEdit.Enabled := True;
    FormatDBEdit.aAllowEmpty := False;
  end else if DMAQFbN(sZLEPOLAZMDEF_TYPDANYCH).AsString = cZLETypDanych_StringID then begin
    ZLEPoleZmDefDlugLabel.Enabled := True;
    ZLEPoleZmDefDlugDBEdit.Enabled := True;
    ZnakiLabel.Enabled := True;
    ZnakiDBEdit.Enabled := True;
  end;
end;

initialization
  FormManager.RegisterForm(TZLEPoleZmDefDBDetailForm, sZLEModulID);
end.