unit ZLEPoleZmDefDBGridFormUnit;
{
Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who        What
---------------------------------------------------------------------------------------------
2005-12-20 Tomjen     Utworzenie
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls, UNIStaleUnit, UNIDataModuleUnit, QuickRpt;

type
  TZLEPoleZmDefDBGridForm = class(TUNIDBGridForm)
    procedure DBGridDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
  private
    function CheckIfICanModify(aID: Integer; var DocList: String): Boolean;
    procedure OpenDetail(const AOpenMode: TOpenMode);
  protected
    procedure InternalOpen; override;
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure Open; override;
    procedure New; override;
    procedure View; override;
    procedure Delete; override;
    procedure SetUserRights; override;
  public
    function GetHelpContext : string; override;
  end;

var
  ZLEPoleZmDefDBGridForm: TZLEPoleZmDefDBGridForm;

implementation

uses
  KeyManagerUnit,
  FKDefUnit,
  UNISysDefUnit,
  ZLEDefUnit,
  ZLEPoleZmDefUnit,
  ZLEPoleZmDefDBDetailFormUnit,
  FormManagerUnit,
  Dodatki,
  SQLManagerUnit,
  SecurityManagerUnit;

{$R *.DFM}

procedure TZLEPoleZmDefDBGridForm.InternalOpen;
begin
  inherited;
end;

function TZLEPoleZmDefDBGridForm.CheckIfICanModify(aID: Integer; var DocList: String): Boolean;
{var
  Q: TUNIQuery;}
begin
  Result := True;
  {
  Q := SQLManager.CreateQuery(
    'SELECT ' +
    'T.' + sZLEGRAS_SYMBOL +
    ' FROM ' +
    SQLManager.GetTableName(sZLEPOLAZMWSK) + ' W, ' +
    SQLManager.GetTableName(sZLEGRAS) + ' T ' +
    ' WHERE ' +
    'W.' + sZLEGRAS_ID + ' = ' + 'T.' + sZLEGRAS_ID + ' AND ' +
    'W.' +sZLEPOLAZMDEF_ID + ' = ' + IntToStr(aID) +
    ' ORDER BY ' +
    'T.' + sZLEGRAS_NAZWA
  );
  try
    Q.Open;
    DocList := '';
    if not Q.IsEmpty then begin
      Result := False;
      while not Q.EOF do begin
        DocList := DocList + Q.Fields[0].AsString + ', ';
        Q.Next;
      end;
      DocList := Copy(DocList, 1, Length(DocList) - 2)
    end;
    Q.Close;
  finally
    FreeAndNil(Q);
  end;
  }
end;

function TZLEPoleZmDefDBGridForm.CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule;
begin
  Result := TZLEPoleZmDef.CreateOpen( self, Nil, AOpenMode);
end;

procedure TZLEPoleZmDefDBGridForm.Open;
var
  s: string;
begin
  if CheckIfICanModify(DMAQFbN(sZLEPOLAZMDEF_ID).AsInteger, s) then
    OpenDetail(omEdit)
  else
    Komunikat(cInformation, 'Pole ''' +
        DMAQFbN(sZLEPOLAZMDEF_NAZWA).AsString +
        ''' jest ju uywane w definicjach rodzajw dokumentw (' +
        s +'). Modyfikacja lub usunicie nie jest moliwe.');
end;

procedure TZLEPoleZmDefDBGridForm.New;
begin
  OpenDetail(omNew);
end;

procedure TZLEPoleZmDefDBGridForm.View;
begin
  OpenDetail(omView);
end;

procedure TZLEPoleZmDefDBGridForm.Delete;
begin
  OpenDetail(omDelete);
end;

function TZLEPoleZmDefDBGridForm.GetHelpContext: string;
begin
  //result := cHelpKGRodzajeDowodow;
end;

procedure TZLEPoleZmDefDBGridForm.SetUserRights;
begin
  with SecurityManager do begin
    Switch_New_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_POLAUZ_DOPISZ));
    Switch_Delete_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_POLAUZ_USUN));
    Switch_Open_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_POLAUZ_ZMIEN));
    Switch_View_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_POLAUZ_POKAZ));
  end;
end;

procedure TZLEPoleZmDefDBGridForm.DBGridDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
begin
  inherited;
  if Column.Field <> Nil then
    if (Column.FieldName = sZLEPOLAZMDEF_TYP) then
      if not Column.Field.IsNull then
        DBGrid.WriteText(
          DBGrid.Canvas,
          Rect,
          cslZLEPolaUzState[Column.Field.Value],
          Column.Alignment
        );
end;

procedure TZLEPoleZmDefDBGridForm.OpenDetail(const AOpenMode: TOpenMode);
var
  oParams: TKeyValues;
begin
  oParams := nil;
  if Parameters <> nil then begin
    oParams := TKeyValues.CreateEmpty();
    with oParams do begin
      if Parameters.Values[cParam_ZLEPOLAZMDEF_TYP] <> '' then
        Add(cParam_ZLEPOLAZMDEF_TYP+'='+Parameters.Values[cParam_ZLEPOLAZMDEF_TYP]);
      if Parameters.Values[cParam_FKMNEMONIKI_ID] <> '' then
        Add(cParam_FKMNEMONIKI_ID+'='+Parameters.Values[cParam_FKMNEMONIKI_ID]);
      if Parameters.Values[cParam_UNICONSTDEF_DOMENA] <> '' then
        Add(cParam_UNICONSTDEF_DOMENA+'='+Parameters.Values[cParam_UNICONSTDEF_DOMENA]);
      if Parameters.Values[cParam_ZLEPOLAZMDEF_DLUG] <> '' then
        Add(cParam_ZLEPOLAZMDEF_DLUG+'='+Parameters.Values[cParam_ZLEPOLAZMDEF_DLUG]);
      if Parameters.Values[cParam_ZLEPOLAZMDEF_TYPDANYCH] <> '' then
        Add(cParam_ZLEPOLAZMDEF_TYPDANYCH+'='+Parameters.Values[cParam_ZLEPOLAZMDEF_TYPDANYCH]);
      if Parameters.Values[cParam_ZLEPOLAZMDEF_ZNAKI] <> '' then
        Add(cParam_ZLEPOLAZMDEF_ZNAKI+'='+Parameters.Values[cParam_ZLEPOLAZMDEF_ZNAKI]);
    end;
  end;
  FormManager.OpenDBDetail( self, 'TZLEPoleZmDefDBDetailForm', AOpenMode, oParams);
end;

initialization
  FormManager.RegisterForm(TZLEPoleZmDefDBGridForm, sZLEModulID);
end.
