unit ZLEPoleZmDefUnit;
{
Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who           What
---------------------------------------------------------------------------------------------
2005-12-21 Tomjen        Utworzenie
---------------------------------------------------------------------------------------------
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables, Dodatki;

type
  TZLEPoleZmDef = class(TUNIDataModule)
  private
    idcZLEPOLAZMDEF_TYP: Integer;
    idcZLEPOLAZMDEF_TYPDANYCH: Integer;
    idcZLEPOLAZMDEF_DLUG: Integer;
    idcZLEPOLAZMDEF_DOMENA: Integer;
    idcZLEPOLAZMDEF_ZNAKI: Integer;
    procedure SetRangeParams;
  protected
    procedure GetKeys; override;
    function GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;
  public
    constructor Create(AOwner: TComponent); override;
    procedure Post; override;
  end;

var
  ZLEPoleZmDef: TZLEPoleZmDef;

implementation

uses
  ZLEDefUnit,
  UNISysDefUnit,
  UNIStaleUnit,
  SQLManagerUnit,
  UNIFormUnit,
  FKDefUnit,
  QueryBuilderUnit,
  UNIDBGridFormUnit;

{$R *.DFM}

constructor TZLEPoleZmDef.Create;
begin
  inherited;
end;

procedure TZLEPoleZmDef.SetRangeParams;
begin
  if idcZLEPOLAZMDEF_TYP < 0 then idcZLEPOLAZMDEF_TYP := GridJoinDefs.AddEmptyCondition;
  GridJoinDefs.ExchangeCondition(idcZLEPOLAZMDEF_TYP, '1 = 1', True);
  if idcZLEPOLAZMDEF_TYPDANYCH < 0 then idcZLEPOLAZMDEF_TYPDANYCH := GridJoinDefs.AddEmptyCondition;
  GridJoinDefs.ExchangeCondition(idcZLEPOLAZMDEF_TYPDANYCH, '1 = 1', True);
  if idcZLEPOLAZMDEF_DLUG < 0 then idcZLEPOLAZMDEF_DLUG := GridJoinDefs.AddEmptyCondition;
  GridJoinDefs.ExchangeCondition(idcZLEPOLAZMDEF_DLUG, '1 = 1', True);
  if idcZLEPOLAZMDEF_DOMENA < 0 then idcZLEPOLAZMDEF_DOMENA := GridJoinDefs.AddEmptyCondition;
  GridJoinDefs.ExchangeCondition(idcZLEPOLAZMDEF_DOMENA, '1 = 1', True);
  if idcZLEPOLAZMDEF_ZNAKI < 0 then idcZLEPOLAZMDEF_ZNAKI := GridJoinDefs.AddEmptyCondition;
  GridJoinDefs.ExchangeCondition(idcZLEPOLAZMDEF_ZNAKI, '1 = 1', True);

  if (Owner is TUNIDBGridForm) then
    if TUNIDBGridForm(Owner).Parameters <> Nil then begin
      with TUNIDBGridForm(Owner).Parameters do begin
        if Values[cParam_ZLEPOLAZMDEF_TYP] <> '' then
          GridJoinDefs.ExchangeCondition(idcZLEPOLAZMDEF_TYP, 'D.' + sZLEPOLAZMDEF_TYP + ' IN (' + Values[cParam_ZLEPOLAZMDEF_TYP]+')', True)
        else if Values[sZLEPOLAZMDEF_TYP] <> '' then
          GridJoinDefs.ExchangeCondition(idcZLEPOLAZMDEF_TYP, 'D.' + sZLEPOLAZMDEF_TYP + ' IN ' + Values[sZLEPOLAZMDEF_TYP], True);
        if Values[cParam_ZLEPOLAZMDEF_TYPDANYCH] <> '' then
          GridJoinDefs.ExchangeCondition(idcZLEPOLAZMDEF_TYPDANYCH, 'D.'+sZLEPOLAZMDEF_TYPDANYCH+'='+QuotedStr(Values[cParam_ZLEPOLAZMDEF_TYPDANYCH]), True);
        if Values[cParam_ZLEPOLAZMDEF_DLUG] <> '' then
          GridJoinDefs.ExchangeCondition(idcZLEPOLAZMDEF_DLUG, 'D.' + sZLEPOLAZMDEF_DLUG+'<='+Values[cParam_ZLEPOLAZMDEF_DLUG], True);
        if Values[cParam_UNICONSTDEF_DOMENA] <> '' then
          GridJoinDefs.ExchangeCondition(idcZLEPOLAZMDEF_DOMENA, 'C.' + sUNICONSTDEF_DOMENA+'='+QuotedStr(Values[cParam_UNICONSTDEF_DOMENA]), True);
        if Values[cParam_ZLEPOLAZMDEF_ZNAKI] <> '' then
          GridJoinDefs.ExchangeCondition(idcZLEPOLAZMDEF_ZNAKI, 'D.' + sZLEPOLAZMDEF_ZNAKI+'='+QuotedStr(Values[cParam_ZLEPOLAZMDEF_ZNAKI]), True);
      end;
    end;
end;

procedure TZLEPoleZmDef.GetKeys;
begin
  with FKeys do begin
    Clear;
    AddPrimary(sZLEPOLAZMDEF_ID);
  end;
end;

function TZLEPoleZmDef.GetTableName: string;
begin
  Result := sZLEPOLAZMDEF;
end;

procedure TZLEPoleZmDef.InitializeGridQueryDefs;
begin
  idcZLEPOLAZMDEF_TYP := -1;
  idcZLEPOLAZMDEF_TYPDANYCH := -1;
  idcZLEPOLAZMDEF_DLUG := -1;
  idcZLEPOLAZMDEF_DOMENA := -1;
  idcZLEPOLAZMDEF_ZNAKI := -1;
  if GridColDefs.Count = 0 then with GridColDefs do begin
    Clear;
    AddRequired(sZLEPOLAZMDEF_ID, 'D', '', omNiewidoczne, taLeftJustify, 0);
    Add(sZLEPOLAZMDEF_NAZWA,       'D',    'Nazwa',        True,  True,  taLeftJustify,  200);
    Add(sZLEPOLAZMDEF_TYP,         'D',    'Typ',          True,  True,  taLeftJustify,  100);
    Add(sZLEPOLAZMDEF_DLUG,        'D',    'Dugo',      False, False, taLeftJustify,  100);
    AddRequiredAndUnvisible( sFKMNEMONIKI_ID, 'M', '' );
//    Add( sFKMNEMONIKI_MNEMONIK, 'FKMNEM', 'Mnemonik', False, True, taLeftJustify, 100 );
    AddRequiredAndUnvisible( sUNICONSTDEF_ID, 'D', '' );
//    Add( sUNICONSTDEF_DOMENA, 'CONSTDEF', 'Domena', False, True, taLeftJustify, 100 );
    AddRequiredAndUnvisible( sZLEPOLAZMDEF_TYPDANYCH, 'D', '' );
    AddRequired( sZLEPOLAZMDEF_ZNAKI, 'D', 'Dozwolone znaki', True, taLeftJustify, 200 );
    AddRequired( sZLEPOLAZMDEF_FORMAT, 'D', 'Format', True, taLeftJustify, 50 );

    Add(sFKMNEMONIKI_NAZWA,        'M',    'Mnemonik',     True,  True,  taLeftJustify,  200);
    Add(sUNICONSTDEF_NAZWA,        'C',    'Domena',     True,  True,  taLeftJustify,  200);
  end;
  if GridTabDefs.Count=0 then with GridTabDefs do begin
    Clear;
    Add('D',GetTableName);
    Add('M', sFKMNEMONIKI);
    Add('C', sUNICONSTDEF);
  end;
  with GridJoinDefs do begin
    Clear;
    AddExpres('D.' + sFKMNEMONIKI_ID + ' = ' + 'M.' + sFKMNEMONIKI_ID, qjkLeftOuter, True);
    AddExpres('D.' + sUNICONSTDEF_ID + ' = ' + 'C.' + sUNICONSTDEF_ID, qjkLeftOuter, True);
  end;
  SetRangeParams;
  inherited;
end;

procedure TZLEPoleZmDef.Post;
var
  bTrans: boolean;
begin
  bTrans  := not SQLManager.InTransaction;
  if bTrans then SQLManager.StartTransaction;
  try
    inherited;
    if (Owner as TUNIForm).ContainedFormCount > 0 then
      ContainedDataModules[0].Post;
    if bTrans then SQLManager.Commit;
  except
    if bTrans then SQLManager.Rollback;
    raise;
  end;
end;

end.
