unit ZLEPoleZmGridFormUnit;
{
Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who          What
---------------------------------------------------------------------------------------------
2005-12-20 Tomjen       Utworzenie
2006-04-04 Tomjen       Poprawa zapisu do bazy danych
---------------------------------------------------------------------------------------------
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls, UNIDataModuleUnit, UNIStaleUnit, DBCGrids, Mask,
  UNIDBConstComboBoxUnit, UNIDateEditUnit, DBClient;

const
  cPanelName = 'DBOwnSubPanel_';

type
  TDBOwnGrid = class;

  TZLEPoleZmGridForm = class(TUNIDBGridForm)
  private
    FPoleZMDefQuery: TUNIQuery;
    FOwnGrid: TDBOwnGrid;
    bPozycjaOwner: Boolean;
    procedure InitializeControls();
  protected
    procedure InternalOpen(); override;
    function  CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
  public
    constructor Create( Owner: TComponent ); override;
    destructor Destroy(); override;
    procedure DodajPolaZM( iZLETypZlec_ID: Integer );
    procedure WyczyscPolaZM();
    function Apply(): Boolean;
    property OwnGrid: TDBOwnGrid read FOwnGrid;
  end;

  TRowPanel = class(TUNIPanel)
  private
    FPanelID: String;
  public
    property PanelID: String read FPanelID;
  end;

  TDBOwnGridMakeRowPanel = procedure of object;
  TDBOwnGrid = class(TScrollBox)
  private
    FReadOnly: Boolean;
    FPanelCount: Integer;
    FDataSource: TDataSource;
    FPrimaryField: String;
    FRowHeight: Integer;
    bPozycja: Boolean;
    function DajWartosciDomeny( sDomena: String ): TConstStringList;
    procedure LookupButtonClick( Sender: TObject );
    function LookupSetData( Sender: TObject; AliasSrc: TDataSet ): Boolean;
    function LookupCheck( Sender: TObject ): Boolean;
    procedure MyOnExit( Sender: TObject );
    procedure MyDelKey( Sender: TObject );
    procedure FieldChange( Sender: TObject );
    procedure Clear();
  protected
    procedure MakeRowPanel( RowPanel: TRowPanel; DataSet: TDataSet ); virtual;
    procedure ChangeRow( Sender: TObject );
    procedure RowExit( Sender: TObject );
    function Validate(): Boolean;
  public
    constructor Create( Owner: TComponent ); override;
    destructor Destroy(); override;
    procedure Init();
  published
    property DataSource: TDataSource read FDataSource write FDataSource;
    property PrimaryField: String read FPrimaryField write FPrimaryField;
    property RowHeight: Integer read FRowHeight write FRowHeight;
    property ReadOnly: Boolean read FReadOnly write FReadOnly;
  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  FormManagerUnit,
  SQLManagerUnit,
  UniqueKeyUnit,
  UNISysDefUnit,
  UNISysDataManagerUnit,
  FKDefUnit,
  FKDataManagerUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit,
  ZLEPozycjeDBDetailFormUnit,
  ZLEPozycjeDBGridFormUnit,
  ZLEZLECENIEDBDetailFormUnit,
  ZLEPoleZmUnit;

{ TZLEPoleZmGridForm }

function TZLEPoleZmGridForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLEPoleZMDataModule.CreateOpen( Self, InheritedMasterKeyValues, AOpenMode );
  if (Owner is TZLEZlecenieDBDetailForm) then bPozycjaOwner := False
  else bPozycjaOwner := True;
end;

procedure TZLEPoleZmGridForm.DodajPolaZM( iZLETypZlec_ID: Integer );
var
  OldVState: TVirtualDataSetState;
  sFrom, sWhere: String;
  oTempVirtual: TClientDataSet;
begin
  if iZLETypZlec_ID <=0 then Exit;

  try
//    if FPoleZMDefQuery = nil then begin
   if FPoleZMDefQuery <> nil then FreeAndNil(FPoleZMDefQuery);

   { SELECT ZMNEW.ZLEPOLAZM_ID, ZMNEW.ZLEZLECENIE_ID, ZMNEW.ZLEZLECENIEPOZ_ID,
                 DEF.ZLEPOLAZMDEF_ID, ZMNEW.FKUZ_ID, ZMNEW.ZLEPOLAZM_DOMENAWART_ID,
                 ZMNEW.ZLEPOLAZM_WART, DEF.ZLEPOLAZMDEF_NAZWA, DEF.ZLEPOLAZMDEF_TYP,
                 DEF.FKMNEMONIKI_ID, MNEM.FKMNEMONIKI_MNEMONIK, MNEM.FKMNEMONIKI_TABELA,
                 DEF.UNICONSTDEF_ID, DOMENY.UNICONSTDEF_DOMENA, DEF.ZLEPOLAZMDEF_DLUG,
                 DEF.ZLEPOLAZMDEF_TYPDANYCH, DEF.ZLEPOLAZMDEF_ZNAKI, DEF.ZLEPOLAZMDEF_FORMAT
          FROM  ZLEPOLAZMDEF DEF, ZLEPOLAZMWSK WSK, ZLETYPZLEC TYP, FKMNEMONIKI MNEM, UNICONSTDEF DOMENY,
                (SELECT * FROM ZLEPOLAZM WHERE ZLEZLECENIE_ID = 1651 AND ZLEZLECENIEPOZ_ID IS NULL) ZMNEW
          WHERE DEF.ZLEPOLAZMDEF_ID = WSK.ZLEPOLAZMDEF_ID AND
                WSK.ZLEPOLAZMDEF_ID = ZMNEW.ZLEPOLAZMDEF_ID (+) AND
                WSK.ZLETYPZLEC_ID IN (SELECT ZLETYPZLEC_ID FROM ZLEZLECENIE WHERE ZLEZLECENIE_ID = 1651) AND
                DEF.UNICONSTDEF_ID = DOMENY.UNICONSTDEF_ID (+) AND
                DEF.FKMNEMONIKI_ID = MNEM.FKMNEMONIKI_ID (+) AND
                TYP.ZLETYPZLEC_ID= WSK.ZLETYPZLEC_ID AND
                (DEF.ZLEPOLAZMDEF_TYP <>'0') AND
                (WSK.ZLEPOLAZMWSK_POZYCJA='N')}

{  sSQL := 'SELECT ZMNEW.' + sZLEPOLAZM_ID + ', ZMNEW.' + sZLEZLECENIE_ID + ', ZMNEW.' + sZLEZLECENIEPOZ_ID + ', ' +
                 'DEF.' + sZLEPOLAZMDEF_ID + ', ZMNEW.' + sFKUZ_ID + ', ZMNEW.' + sZLEPOLAZM_DOMENAWART_ID + ', ' +
                 'ZMNEW.' + sZLEPOLAZM_WART + ', DEF.' + sZLEPOLAZMDEF_NAZWA + ', DEF.' + sZLEPOLAZMDEF_TYP + ', ' +
                 'DEF.' + sFKMNEMONIKI_ID + ', MNEM.' + sFKMNEMONIKI_MNEMONIK + ', MNEM.' + sFKMNEMONIKI_TABELA + ', ' +
                 'DEF.' + sUNICONSTDEF_ID + ', DOMENY.' + sUNICONSTDEF_DOMENA + ', DEF.' + sZLEPOLAZMDEF_DLUG + ', ' +
                 'DEF.' + sZLEPOLAZMDEF_TYPDANYCH + ', DEF.' + sZLEPOLAZMDEF_ZNAKI + ', DEF.' + sZLEPOLAZMDEF_FORMAT + ' ' +
          'FROM  %s DEF, %s WSK, %s TYP, %s MNEM, %s DOMENY, ' +
                '(SELECT * FROM  %s WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZLEZlecenie_ID) + ' AND ' +
                                             sZLEZLECENIEPOZ_ID + ' IS NOT NULL' + ') ZMNEW ' +
          'WHERE DEF.' + sZLEPOLAZMDEF_ID + ' = WSK.' + sZLEPOLAZMDEF_ID + ' AND ' +
                'DEF.' + sZLEPOLAZMDEF_ID + ' = ZMNEW.' + sZLEPOLAZMDEF_ID + ' (+) AND ' +
                'WSK.' + sZLETYPZLEC_ID + ' IN (SELECT ' + sZLETYPZLEC_ID +
                            ' FROM %s WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZLEZlecenie_ID) + ') AND ' +
                'DEF.' + sUNICONSTDEF_ID + ' = DOMENY.' + sUNICONSTDEF_ID + ' (+) AND ' +
                'DEF.' + sFKMNEMONIKI_ID + ' = MNEM.' + sFKMNEMONIKI_ID + ' (+) AND ' +
                'TYP.' + sZLETYPZLEC_ID + ' = WSK.' + sZLETYPZLEC_ID + ' AND ' +
                '(DEF.' + sZLEPOLAZMDEF_TYP + '<>' + QuotedStr(cZLEPolaUzState_IDOfUnUsed) + ') AND ' +
                '(WSK.' + sZLEPOLAZMWSK_POZYCJA + ' = ' + QuotedStr(sUNICONST_ALTERNATYWA_TAK) + ')';


  oQuery := SQLManager.CreateQuery(sSQL, [sZLEPOLAZMDEF, sZLEPOLAZMWSK, sZLETYPZLEC, sFKMNEMONIKI,
                                          sUNICONSTDEF, sZLEPOLAZM, sZLEZLECENIE]);
}
       sFrom :=  sZLEAlias_PolaZMDefID+';'+
            sZLEAlias_PolaZMDefNazwa+';'+
            sZLEAlias_PolaZMDefTyp+';'+
            sZLEAlias_PolaZMDefMnemonikiID+';'+
            sZLEAlias_MnemonikiMnemonik+';'+
            sZLEAlias_MnemonikiTabela+';'+
            sZLEAlias_PolaZMDefDomenyID+';'+
            sZLEAlias_DomenyDomena+';'+
            sZLEAlias_PolaZMDefDlugosc+';'+
            sZLEAlias_PolaZMDefTypDanych+';'+
            sZLEAlias_PolaZMDefZnaki+';'+
            sZLEAlias_PolaZMDefFormat;


       sWhere := '(@'+sZLEAlias_PolaZMWskZLETypZlecID+'='+IntToStr(iZLETypZlec_ID)+')AND'+
            '(@'+sZLEAlias_PolaZMDefTyp+'<>'+QuotedStr(cZLEPolaUzState_IDOfUnUsed)+')';

      if (Owner is TZLEZlecenieDBDetailForm) then begin
         sWhere := sWhere + ' AND (@' + sZLEAlias_PolaZMWsk_Pozycja+'='+QuotedStr(sUNICONST_ALTERNATYWA_NIE) + ')';
//         sWhere := sWhere + ' AND (@' + sZLEAlias_PolaZMPozycjaID + ' IS NULL)';
      end else if (Owner is TZLEPozycjeDBDetailForm) then begin
         sWhere := sWhere + 'AND (@'+sZLEAlias_PolaZMWsk_Pozycja+'='+QuotedStr(sUNICONST_ALTERNATYWA_TAK) + ')';
      end;

      //dodanie order by
      sWhere := sWhere + ' order by @'+sZLEAlias_PolaZMWskID;

      FPoleZMDefQuery := ZLEDM.ZLEOdpytajODane( sZLEPolaZMDef, sFrom, sWhere, False );
//    end;


    if FPoleZMDefQuery <> nil then begin
      OldVState := (DataModule.ActiveQuery as TVirtualDataSet).VState;
      oTempVirtual := TClientDataSet.Create(nil);
      try
        oTempVirtual.CloneCursor( DataModule.ActiveQuery as TVirtualDataSet, True );
        FPoleZMDefQuery.First;
        while not FPoleZMDefQuery.Eof do begin
          with DataModule.ActiveQuery as TVirtualDataSet do
            try
              //przepisanie danych z istniejcych ju pl
              if oTempVirtual.Locate( sZLEPolaZMDef_ID, FPoleZMDefQuery.FieldByName(sZLEPolaZMDef_ID).AsInteger, [] ) then begin
                VState := vsVirtualPost;
                Edit;
{                if not oTempVirtual.FieldByName(sFKUZ_ID).IsNull then
                  FieldByName(sFKUZ_ID).AsInteger := oTempVirtual.FieldByName(sFKUZ_ID).AsInteger;
                if not oTempVirtual.FieldByName(sZLEPolaZM_DomenaWart_ID).IsNull then
                  FieldByName(sZLEPolaZM_DomenaWart_ID).AsString := oTempVirtual.FieldByName(sZLEPolaZM_DomenaWart_ID).AsString;
                if not oTempVirtual.FieldByName(sZLEPolaZM_Wart).IsNull then
                  FieldByName(sZLEPolaZM_Wart).AsString := oTempVirtual.FieldByName(sZLEPolaZM_Wart).AsString;
}
                SetTechnicalFieldsOnUpdate();
              end else begin
                VState := vsInternalInsert;
                Insert;
                FieldByName( sZLEPolaZM_ID ).AsInteger := UniqueKey[sZLEPolaZM];

                if (Owner.Owner.Owner is TZLEZlecenieDBDetailForm) then begin
                   FieldByName( sZLEZLECENIE_ID ).AsString := DataModule.MasterKeyValues.KeyByName(sZLEZLECENIE_ID);
                end else if (Owner.Owner.Owner is TZLEPozycjeDBDetailForm) then begin
                   FieldByName( sZLEZLECENIE_ID ).AsString    := TZLEPozycjeDBDetailForm(Owner.Owner.Owner).DMAQFbN(sZLEZLECENIE_ID).AsString;
                   FieldByName( sZLEZLECENIEPOZ_ID ).AsString := DataModule.MasterKeyValues.KeyByName(sZLEZLECENIEPOZ_ID);
                end;

                FieldByName( sZLEPolaZMDef_ID ).AsInteger := FPoleZMDefQuery.FieldByName(sZLEPolaZMDef_ID).AsInteger;
                SetTechnicalFieldsOnInsert();
                UpdateModifiedRecordFlagsForAddedRecord();
                FieldByName( sZLEPolaZMDef_Nazwa ).AsString := FPoleZMDefQuery.FieldByName(sZLEPolaZMDef_Nazwa).AsString;
                FieldByName( sZLEPolaZMDef_Typ ).AsString := FPoleZMDefQuery.FieldByName(sZLEPolaZMDef_Typ).AsString;
                FieldByName( sFKMNEMONIKI_ID ).AsInteger := FPoleZMDefQuery.FieldByName(sFKMNEMONIKI_ID).AsInteger;
                FieldByName( sFKMNEMONIKI_MNEMONIK ).AsString := FPoleZMDefQuery.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString;
                FieldByName( sFKMNEMONIKI_TABELA ).AsString := FPoleZMDefQuery.FieldByName(sFKMNEMONIKI_TABELA).AsString;
                FieldByName( sUNICONSTDEF_ID ).AsInteger := FPoleZMDefQuery.FieldByName(sUNICONSTDEF_ID).AsInteger;
                FieldByName( sUNICONSTDEF_DOMENA ).AsString := FPoleZMDefQuery.FieldByName(sUNICONSTDEF_DOMENA).AsString;
                FieldByName( sZLEPolaZMDef_Dlug ).AsInteger := FPoleZMDefQuery.FieldByName(sZLEPolaZMDef_Dlug).AsInteger;
                FieldByName( sZLEPolaZMDef_TypDanych ).AsString := FPoleZMDefQuery.FieldByName(sZLEPolaZMDef_TypDanych).AsString;
                FieldByName( sZLEPolaZMDef_Znaki ).AsString := FPoleZMDefQuery.FieldByName(sZLEPolaZMDef_Znaki).AsString;
                FieldByName( sZLEPolaZMDef_Format ).AsFloat := FPoleZMDefQuery.FieldByName(sZLEPolaZMDef_Format).AsFloat;
              end;
              VirtualPost;
            finally
              VState := OldVState;
            end;
          FPoleZMDefQuery.Next;
        end;
      finally
        if oTempVirtual <> nil then oTempVirtual.Free;
      end;
    end;
  except
    if FPoleZMDefQuery <> nil then FreeAndNil(FPoleZMDefQuery);
    raise;
  end;
end;

procedure TZLEPoleZmGridForm.InitializeControls;
begin
end;

procedure TZLEPoleZmGridForm.InternalOpen;
var
    iZLETypZlec_ID: Integer;
begin
  InitializeControls();
  inherited;
//  WyczyscPolaZM();

  if (Owner is TZLEZlecenieDBDetailForm) then begin
    bPozycjaOwner := False;
    iZLETypZlec_ID := TZLEZLECENIEDBDetailForm(Owner).DMAQFbN(sZLETYPZLEC_ID).AsInteger;
    if (TZLEZLECENIEDBDetailForm(Owner).OpenMode in [omNew, omEdit]) and (iZLEtypZlec_ID > 0) then
      DodajPolaZM( iZLETypZlec_ID );
  end;

  {Pola powinny by ju dodane wczeniej dla pozycji}
{  if (Owner is TZLEPozycjeDBDetailForm) then begin
    iZLETypZlec_ID := -1;
    if (Owner.Owner.Owner is TZLEZLECENIEDBDetailForm) then
       iZLETypZlec_ID := TZLEZLECENIEDBDetailForm(Owner.Owner.Owner).DMAQFbN(sZLETYPZLEC_ID).AsInteger
    else if (Owner.Owner is TZLEPozycjeDBGridForm) then
       iZLETypZlec_ID := TZLEPozycjeDBGridForm(Owner.Owner).DMAQFbN(sZLETYPZLEC_ID).AsInteger;

    if (TZLEPozycjeDBDetailForm(Owner).OpenMode in [omNew, omEdit]) and (iZLEtypZlec_ID > 0) then
      DodajPolaZM( iZLETypZlec_ID );
  end;}

  DBGrid.TabStop := False;
  FOwnGrid := TDBOwnGrid.Create( GridPanel );
  with FOwnGrid do begin
    ReadOnly := (((OpenModeFlags and omReadOnly) = omReadOnly) OR (OpenMode = omDelete));
    Parent := Self.BodyPanel;
    Align := alClient;
    DataSource := Self.DataSource;
    PrimaryField := sZLEpolaZMDef_ID;
    RowHeight := 28;
    bPozycja := bPozycjaOwner;
//    Init();  -- zakomentowane - uruchamia osobno
  end;
end;

constructor TZLEPoleZmGridForm.Create(Owner: TComponent);
begin
  inherited;

  if (Owner is TZLEZlecenieDBDetailForm) then bPozycjaOwner := False
  else bPozycjaOwner := True;

  FPoleZMDefQuery := nil;
end;

destructor TZLEPoleZmGridForm.Destroy;
begin
  if FPoleZMDefQuery <> nil then
    FreeAndNil(FPoleZMDefQuery);
  inherited;
end;

procedure TZLEPoleZmGridForm.WyczyscPolaZM;
begin
  with DataModule do begin
    ActiveQuery.First;
    while not ActiveQuery.Eof do begin
      ActiveQuery.Delete;
      ActiveQuery.First;
    end;
  end;
  if FPoleZMDefQuery <> nil then
    FreeAndnil(FPoleZMDefQuery);
    
end;

function TZLEPoleZmGridForm.Apply: Boolean;
begin
  result := Validate();
  if not result then exit;
  result := FOwnGrid.Validate();
end;

{ TDBOwnGrid }

function TDBOwnGrid.DajWartosciDomeny( sDomena: String ): TConstStringList;
var
   sSQL: String;
   oQuery: TUNIQuery;
begin
  result := nil;
  oQuery := nil;
  try
    oQuery := TUNIQuery.Create(nil);
    sSQL := 'select domena.'+sDomena+'_ID, domena.'+sDomena+'_V'+' '+
            'from %s domena';
    SQLManager.OpenQuery( oQuery, sSQL, [sDomena] );
    try
      if not oQuery.IsEmpty then
        result := TConstStringList.Create();
      while not oQuery.Eof do begin
        result.Add( oQuery.FieldByName(sDomena+'_V').AsString,
                    oQuery.FieldByName(sDomena+'_ID').AsString );
        oQuery.Next;
      end;
    except
      if result <> nil then FreeAndNil(result);
    end;
  finally
    if oQuery <> nil then oQuery.Free;
  end;
end;

procedure TDBOwnGrid.ChangeRow(Sender: TObject);
var
  OldVState: TVirtualDataSetState;
begin
  if (Sender is TRowPanel) then begin
    if not bPozycja then
      OldVState := (DataSource.DataSet as TVirtualDataSet).VState
    else
      OldVState := vsNormal;
    try
     if not bPozycja then begin
       (DataSource.DataSet as TVirtualDataSet).VState := vsVirtualPost;
       (DataSource.DataSet as TVirtualDataSet).Locate( PrimaryField, (Sender as TRowPanel).PanelID, [] );
       (DataSource.DataSet as TVirtualDataSet).Edit;
     end else begin
       DataSource.DataSet.Locate( PrimaryField, (Sender as TRowPanel).PanelID, [] );
       DataSource.DataSet.Edit;
     end;

    finally
     if not bPozycja then
      (DataSource.DataSet as TVirtualDataSet).VState := OldVState;
    end;
  end;
end;

constructor TDBOwnGrid.Create(Owner: TComponent);
begin
  inherited;
  FReadOnly := False;
  FPanelCount := 0;
  FDataSource := nil;
  FPrimaryField := '';
  FRowHeight := 50;
  BorderStyle := bsNone;
end;

destructor TDBOwnGrid.Destroy;
begin
  inherited;
end;

procedure TDBOwnGrid.Init;
var
  oDataSet: TDataSet;
  oPanel: TRowPanel;
begin
  Assert( DataSource <> nil, 'Niepodpity datasource' );
  Assert( DataSource.DataSet <> nil, 'Brak zestawu danych' );
  Assert( DataSource.DataSet.FindField(PrimaryField) <> nil,
          'Pole PrimaryField nieodnalezione w zestawie danych' );
  oDataSet := DataSource.DataSet;
  oDataSet.First;
  Clear;
  while not oDataSet.Eof do begin
    oPanel := TRowPanel.Create(Self);
    with oPanel do begin
      ReadOnly := Self.ReadOnly;
      Parent := Self;
      Align := alBottom;
      Align := alTop;
      BevelOuter := bvLowered;
      Height := RowHeight;
      //FOwnGrid.Width := Self.BodyPanel.width;
      Name := cPanelName+IntToStr(FPanelCount);
      Caption := '';
      FPanelID := oDataSet.FieldByName(PrimaryField).AsString;
      OnEnter := ChangeRow;
      OnExit := RowExit;
    end;
    MakeRowPanel( oPanel, oDataSet );
    oDataSet.Next;
    Inc(FPanelCount);
  end;
end;

procedure TDBOwnGrid.MakeRowPanel( RowPanel: TRowPanel; DataSet: TDataSet );
var oDomena: TConstStringList;
    oLookup: TUNILookupAliasEdit2;
begin
  if Owner.Owner.Owner is TZLEZlecenieDBDetailForm then
     if DataSet.FieldByName(sZLEPolaZMWsk_Pozycja).AsString = sUNICONST_ALTERNATYWA_TAK then
        Exit;

  if Owner.Owner.Owner is TZLEPozycjeDBDetailForm then
     if DataSet.FieldByName(sZLEPolaZMWsk_Pozycja).AsString = sUNICONST_ALTERNATYWA_NIE then
        Exit;

  oDomena := nil;
  //tu naley utworzy poszczeglne kontrolki
  with TLabel.Create( RowPanel ) do begin
    Parent := RowPanel;
    Caption := DataSet.FieldByName(sZLEPolaZMDef_Nazwa).AsString;
    Top := 4;
    Left := 5;
  end;
  if DataSet.FieldByName(sFKMNEMONIKI_ID).AsInteger <> 0 then begin
    with TLabel.Create( RowPanel ) do begin
      Parent := RowPanel;
      Caption := '';//Nazwa mnemonika bedzie pobrana pozniej
      Tag := 1;//Zeby mozna bylo sprawdzic czy to ten
      Top := 4;
      Left := 405;
    end;
    oLookup := TUNILookupAliasEdit2.Create( RowPanel );
    with oLookup do begin
      Parent := RowPanel;
      Top := 2;
      Left := 200;
      Width := 200;
      aReadOnly := Self.ReadOnly;
      CharCase := ecUpperCase;
      aAllowEmpty := DataSet.FieldByName(sZLEPolaZMDef_Typ).AsString = cZLEPolaUzState_IDOfCanUse;
      aAllowText := DataSet.FieldByName(sZLEPolaZMDef_Nazwa).AsString;
      if DataSet.FieldByName(sFKMNEMONIKI_TABELA).AsString = sFKUZ then begin
        AliasManager := UniSysDM.AliasManager;
        Alias_ID := sFKALIAS_SlUzytkownikaID;
        Alias_Name := sFKALIAS_SlUzytkownikaSymbol;
        AdditionalAliases := sFKALIAS_SlUzytkownikaNazwa;
        AdditionalCondition := '@'+sFKALIAS_SlUzytkownikaIDMnemonika+'='+DataSet.FieldByName(sFKMNEMONIKI_ID).AsString;
        InitiateData(DataSet.FieldByName(sFKUZ_ID).AsInteger);
      end else begin
        OnExit := MyOnExit;
        OnCheck := LookupCheck;
        Text := DataSet.FieldByName(sZLEPolaZM_Wart).AsString;
      end;
      OnButtonClick := LookupButtonClick;
      OnSetData := LookupSetData;
      OnDelKey := MyDelKey;
      aClickKey:= ShortCut(VK_RETURN,[ssCtrl]);
      aDelKey:= ShortCut(VK_DELETE,[ssCtrl]);
      LookupCheck(oLookup);//Initialize TLabel
    end;
  end else if DataSet.FieldByName(sUNICONSTDEF_ID).AsInteger <> 0 then begin
    with TUNIComboBox.Create( RowPanel ) do begin
      Parent := RowPanel;
      Top := 2;
      Left := 200;
      Width := 200;
      Style := csDropDownList;
      Enabled := not Self.ReadOnly;
      try
        oDomena := DajWartosciDomeny(DataSet.FieldByName(sUNICONSTDEF_DOMENA).AsString);
        Items.AddStrings(oDomena);
        ItemIndex := oDomena.IndexOfSkrot(DataSet.FieldByName(sZLEPolaZM_DomenaWart_ID).AsString);
        if ItemIndex = -1 then
          ItemIndex := 0;
      finally
        if oDomena <> nil then oDomena.Free;
      end;
      OnChange := FieldChange;
    end;
  end else if DataSet.FieldByName(sZLEPolaZMDef_TypDanych).AsString = cZLETypDanych_DateID then begin
    with TUNIDateEdit.Create( RowPanel ) do begin
      Parent := RowPanel;
      Top := 2;
      Left := 200;
      //Width := 200;
      ReadOnly := Self.ReadOnly;
      EditMask := '!0000/00/00;1;_';
      aAllowEmpty := DataSet.FieldByName(sZLEPolaZMDef_Typ).AsString = cZLEPolaUzState_IDOfCanUse;
      aAllowText := DataSet.FieldByName(sZLEPolaZMDef_Nazwa).AsString;
      if not DataSet.FieldByName(sZLEPolaZM_Wart).IsNull then
        try
          Date := StrToDate(DataSet.FieldByName(sZLEPolaZM_Wart).AsString);
          if ReadOnly then
            Text := DataSet.FieldByName(sZLEPolaZM_Wart).AsString;
        except

        end;
      OnDateChange := FieldChange;
    end;
  end else begin
    with TUNIEdit.Create( RowPanel ) do begin
      Parent := RowPanel;
      Top := 2;
      Left := 200;
      Width := 450;
      ReadOnly := Self.ReadOnly;
      aAllowEmpty := DataSet.FieldByName(sZLEPolaZMDef_Typ).AsString = cZLEPolaUzState_IDOfCanUse;
      aAllowText := DataSet.FieldByName(sZLEPolaZMDef_Nazwa).AsString;
      if DataSet.FieldByName(sZLEPolaZMDef_TypDanych).AsString = cZLETypDanych_StringID then begin
        MaxLength := DataSet.FieldByName(sZLEPolaZMDef_Dlug).AsInteger;
        Dictionary := DataSet.FieldByName(sZLEPolaZMDef_Znaki).AsString;
      end else begin  //typ_danych FloatID and IntegerID
        aNumbersOnly := True;
        aDecimalCount := UNIGetFracFromValueFormat( DataSet.FieldByName(sZLEPolaZMDef_Format).AsFloat );
        aIntegerCount := DataSet.FieldByName(sZLEPolaZMDef_Format).AsInteger;
      end;
      Text := DataSet.FieldByName(sZLEPolaZM_Wart).AsString;
      OnChange := FieldChange;
    end;
  end;
end;

procedure TDBOwnGrid.LookupButtonClick;
var oQuery: TUNIQuery;
    iPoz: integer;
begin
  oQuery := nil;
  iPoz := 0;
  if DataSource.DataSet.FieldByName(sFKUZ_ID).AsInteger > 0 then
     iPoz := DataSource.DataSet.FieldByName(sFKUZ_ID).AsInteger;

  try
    if DataSource.DataSet.FieldByName(sFKMNEMONIKI_TABELA).AsString = sFKUZ then
      oQuery := UNISysDM.FKPokazIObsluzPozycjeSlownikaUzytkownika( DataSource.DataSet.FieldByName(sFKMNEMONIKI_ID).AsString,
                                                               '',
                                                               False, False,
                                                               sFKALIAS_SlUzytkownikaID+';'+
                                                               sFKALIAS_SlUzytkownikaSymbol+';'+
                                                               sFKALIAS_SlUzytkownikaNazwa,
                                                               UNISYSDM.vAktywnaFirma,
                                                               ''{sPole},
                                                               nil,
                                                               iPoz {iPozycjonowanie} )
    else
      oQuery := UNISysDM.UNIPokazIObsluzSlownik( '',
                                                 '',
                                                 DataSource.DataSet.FieldByName(sFKMNEMONIKI_ID).AsInteger,
                                                 0,
                                                 iPoz
                                               );
    LookupSetData( Sender, oQuery );
  finally
    if oQuery <> nil then oQuery.Free;
  end;
end;

function TDBOwnGrid.LookupSetData( Sender: TObject; AliasSrc: TDataSet ): Boolean;
var
    sTabela: String;
    i: Integer;
    par: TWinControl;
    OldVState: TVirtualDataSetState;
begin

  if AliasSrc <> nil then begin
    sTabela := DataSource.DataSet.FieldByName(sFKMNEMONIKI_TABELA).AsString;
    if DataSource.DataSet.State in dsEditModes then begin
      if not bPozycja then
         OldVState := (DataSource.DataSet as TVirtualDataSet).VState
      else
        OldVState := vsNormal;
      try
        if not bPozycja then begin
          (DataSource.DataSet as TVirtualDataSet).VState := vsVirtualPost;

          if sTabela = sFKUZ then
            (DataSource.DataSet as TVirtualDataSet).FieldByName( sFKUZ_ID ).AsInteger := AliasSrc.FieldByName( sFKUZ_ID ).AsInteger
          else
            (DataSource.DataSet as TVirtualDataSet).FieldByName( sZLEPolaZM_Wart ).AsString := AliasSrc.FieldByName( sTabela+'_SYMBOL' ).AsString;
        end else begin
          if sTabela = sFKUZ then
            DataSource.DataSet.FieldByName( sFKUZ_ID ).AsInteger := AliasSrc.FieldByName( sFKUZ_ID ).AsInteger
          else
            DataSource.DataSet.FieldByName( sZLEPolaZM_Wart ).AsString := AliasSrc.FieldByName( sTabela+'_SYMBOL' ).AsString;
        end;
      finally
        if not bPozycja then
          (DataSource.DataSet as TVirtualDataSet).VState := OldVState;
      end;

    end;
    (Sender as TUNILookupAliasEdit2).Text := AliasSrc.FieldByName( sTabela+'_SYMBOL' ).AsString;

    par := TWinControl(Sender).Parent;
    for i:=0 to par.ControlCount -1 do begin
        if (par.Controls[i] is TLabel) and (TLabel(par.Controls[i]).Tag = 1 ) then
            TLabel(par.Controls[i]).Caption :=
                AliasSrc.FieldByName(sTabela+'_Nazwa').AsString;
    end;
  end else begin
        {Nic nie wybrano - skasowac aktualna wartosc?}
  end;
  result := True;
end;

procedure TDBOwnGrid.FieldChange(Sender: TObject);
var oDomena: TConstStringList;
  OldVState: TVirtualDataSetState;
//  iFKUZ_ID, iZMDefID: Integer;
//  sWart, sDomenaWartID: String;
begin
  if (Sender is TRowPanel) then begin
    if not bPozycja then
      OldVState := (DataSource.DataSet as TVirtualDataSet).VState
    else
      OldVState := vsNormal;
    try
      if not bPozycja then begin
        (DataSource.DataSet as TVirtualDataSet).VState := vsVirtualPost;
        (DataSource.DataSet as TVirtualDataSet).Edit;

        if (Sender is TUNIDateEdit) then begin
           if (Sender as TUNIDateEdit).Date = 0 then
                (DataSource.DataSet as TVirtualDataSet).FieldByName(sZLEPolaZM_Wart).Clear()
           else (DataSource.DataSet as TVirtualDataSet).FieldByName(sZLEPolaZM_Wart).AsInteger := Trunc((Sender as TUNIDateEdit).Date);
        end else if (Sender is TUNIEdit) then begin
          (DataSource.DataSet as TVirtualDataSet).FieldByName(sZLEPolaZM_Wart).AsString := (Sender as TUNIEdit).Text;
        end else if (Sender is TUNIComboBox) then begin
          oDomena := nil;
          try
            oDomena := DajWartosciDomeny( (DataSource.DataSet as TVirtualDataSet).FieldByName(sUNICONSTDEF_DOMENA).AsString );
            (DataSource.DataSet as TVirtualDataSet).FieldByName(sZLEPolaZM_DomenaWart_ID).AsString := oDomena.ZwrocSkrot((Sender as TUNIComboBox).ItemIndex);
          finally
            if oDomena <> nil then oDomena.Free;
          end;
        end;

//      DataSource.DataSet.VirtualPost;
        (DataSource.DataSet as TVirtualDataSet).VirtualPost;
//      DataSource.DataSet.Post;

      end else begin
        DataSource.DataSet.Edit;
        if (Sender is TUNIDateEdit) then begin
           if (Sender as TUNIDateEdit).Date = 0 then
                DataSource.DataSet.FieldByName(sZLEPolaZM_Wart).Clear()
           else DataSource.DataSet.FieldByName(sZLEPolaZM_Wart).AsInteger := Trunc((Sender as TUNIDateEdit).Date);
        end else if (Sender is TUNIEdit) then begin
          DataSource.DataSet.FieldByName(sZLEPolaZM_Wart).AsString := (Sender as TUNIEdit).Text;
        end else if (Sender is TUNIComboBox) then begin
          oDomena := nil;
          try
            oDomena := DajWartosciDomeny( DataSource.DataSet.FieldByName(sUNICONSTDEF_DOMENA).AsString );
            DataSource.DataSet.FieldByName(sZLEPolaZM_DomenaWart_ID).AsString := oDomena.ZwrocSkrot((Sender as TUNIComboBox).ItemIndex);
          finally
            if oDomena <> nil then oDomena.Free;
          end;
        end;
      end;

    finally
      if not bPozycja then
        (DataSource.DataSet as TVirtualDataSet).VState := OldVState;
    end;
  end;
end;

function TDBOwnGrid.LookupCheck( Sender: TObject ): Boolean;
var
  sSQL, sTabela: String;
  oQuery: TUNIQuery;
begin
  result := False;
  if Length((Sender as TUNILookupAliasEdit2).Text) > 0 then begin
    sTabela := DataSource.DataSet.FieldByName(sFKMNEMONIKI_TABELA).AsString;
    if sTabela = '' then Exit;
    sSQL := 'select * from %s tab '+
            'where tab.'+sTabela+'_SYMBOL'+' = '+QuotedStr((Sender as TUNILookupAliasEdit2).Text);

    if (sTabela = sFKUZ) and (DataSource.DataSet.FieldByName(sFKMNEMONIKI_ID).AsString <> '') then
       sSQL := sSQL + ' AND tab.' + sFKMNEMONIKI_ID + '=' + DataSource.DataSet.FieldByName(sFKMNEMONIKI_ID).AsString;

    oQuery := TUNIQuery.Create(nil);
    try
      SQLManager.OpenQuery( oQuery, sSQL, [sTabela] );
      LookupSetData( Sender, oQuery );
      if not oQuery.IsEmpty then result := True;
    finally
      if oQuery <> nil then oQuery.Free;
    end;
  end else
    result := True;
end;

procedure TDBOwnGrid.MyOnExit(Sender: TObject);
begin
  if not bPozycja then
    (DataSource.DataSet as TVirtualDataSet).FieldByName(sZLEPolaZM_Wart).AsString := (Sender as TUNILookupAliasEdit2).Text
  else DataSource.DataSet.FieldByName(sZLEPolaZM_Wart).AsString := (Sender as TUNILookupAliasEdit2).Text;
end;

procedure TDBOwnGrid.MyDelKey(Sender: TObject);
var
  OldVState: TVirtualDataSetState;

begin
  if (Sender is TUNILookupAliasEdit2) then begin
    OldVState := vsNormal;
     try
       if not bPozycja then begin
         OldVState := (DataSource.DataSet as TVirtualDataSet).VState;
         (DataSource.DataSet as TVirtualDataSet).VState := vsVirtualPost;
         (DataSource.DataSet as TVirtualDataSet).Edit;
         if TUNILookupAliasEdit2(Sender).Text = '' then begin
           (DataSource.DataSet as TVirtualDataSet).FieldByName(sFKUZ_ID).Clear;
           (DataSource.DataSet as TVirtualDataSet).FieldByName(sZLEPolaZM_Wart).AsString := '';
         end;
         (DataSource.DataSet as TVirtualDataSet).VirtualPost;
      end else begin
         DataSource.DataSet.Edit;

         if TUNILookupAliasEdit2(Sender).Text = '' then begin
            DataSource.DataSet.FieldByName(sFKUZ_ID).Clear;
            DataSource.DataSet.FieldByName(sZLEPolaZM_Wart).AsString := '';
         end;
      end;
    finally
      if not bPozycja then
        (DataSource.DataSet as TVirtualDataSet).VState := OldVState;
    end;
  end;
end;


procedure TDBOwnGrid.RowExit(Sender: TObject);
var
  OldVState: TVirtualDataSetState;
  oDomena: TConstStringList;
  i:        integer;
begin
  if (Sender is TRowPanel) then begin
    if not bPozycja then
       OldVState := (DataSource.DataSet as TVirtualDataSet).VState
    else
      OldVState := vsNormal;
    try
      for i:=0 to TRowPanel(Sender).ControlCount -1 do begin
         if (TRowPanel(Sender).Controls[i] is TUNILookupAliasEdit2) and
            (TUNILookupAliasEdit2(TRowPanel(Sender).Controls[i]).Text = '') then begin

            if not bPozycja then begin
               (DataSource.DataSet as TVirtualDataSet).VState := vsVirtualPost;
               (DataSource.DataSet as TVirtualDataSet).Edit;

               (DataSource.DataSet as TVirtualDataSet).FieldByName(sFKUZ_ID).Clear;
               (DataSource.DataSet as TVirtualDataSet).FieldByName(sZLEPolaZM_Wart).AsString := '';

               (DataSource.DataSet as TVirtualDataSet).VirtualPost;
            end else begin
               DataSource.DataSet.Edit;
               DataSource.DataSet.FieldByName(sFKUZ_ID).Clear;
               DataSource.DataSet.FieldByName(sZLEPolaZM_Wart).AsString := '';
            end;
         end else
         if (TRowPanel(Sender).Controls[i] is TUNIComboBox) then begin

            if not bPozycja then begin
               (DataSource.DataSet as TVirtualDataSet).VState := vsVirtualPost;
               (DataSource.DataSet as TVirtualDataSet).Edit;
                oDomena := nil;
                try
                   oDomena := DajWartosciDomeny( (DataSource.DataSet as TVirtualDataSet).FieldByName(sUNICONSTDEF_DOMENA).AsString );
                   (DataSource.DataSet as TVirtualDataSet).FieldByName(sZLEPolaZM_DomenaWart_ID).AsString := oDomena.ZwrocSkrot(TUNIComboBox(TRowPanel(Sender).Controls[i]).ItemIndex);
                finally
                   if oDomena <> nil then oDomena.Free;
                end;
               (DataSource.DataSet as TVirtualDataSet).VirtualPost;
            end else begin
               DataSource.DataSet.Edit;
               oDomena := nil;
               try
                  oDomena := DajWartosciDomeny( DataSource.DataSet.FieldByName(sUNICONSTDEF_DOMENA).AsString );
                  DataSource.DataSet.FieldByName(sZLEPolaZM_DomenaWart_ID).AsString := oDomena.ZwrocSkrot(TUNIComboBox(TRowPanel(Sender).Controls[i]).ItemIndex);
               finally
                  if oDomena <> nil then oDomena.Free;
               end;
            end;

         end else
         if (TRowPanel(Sender).Controls[i] is TUNIEdit) then begin
       //     if (TUNIEdit(TRowPanel(Sender).Controls[i]).Text = '') then begin
            if not bPozycja then begin
               (DataSource.DataSet as TVirtualDataSet).VState := vsVirtualPost;
               (DataSource.DataSet as TVirtualDataSet).Edit;

               (DataSource.DataSet as TVirtualDataSet).FieldByName(sZLEPolaZM_Wart).AsString := TUNIEdit(TRowPanel(Sender).Controls[i]).Text;
               (DataSource.DataSet as TVirtualDataSet).VirtualPost;
            end else begin
               DataSource.DataSet.Edit;
               DataSource.DataSet.FieldByName(sZLEPolaZM_Wart).AsString := TUNIEdit(TRowPanel(Sender).Controls[i]).Text;
            end;
         end else
         if (TRowPanel(Sender).Controls[i] is TUNIDateEdit) then begin
       //     if (TUNIEdit(TRowPanel(Sender).Controls[i]).Text = '') then begin
            if not bPozycja then begin
               (DataSource.DataSet as TVirtualDataSet).VState := vsVirtualPost;
               (DataSource.DataSet as TVirtualDataSet).Edit;
               if TUNIDateEdit(TRowPanel(Sender).Controls[i]).Date = 0 then
                  (DataSource.DataSet as TVirtualDataSet).FieldByName(sZLEPolaZM_Wart).Clear()
               else
                  (DataSource.DataSet as TVirtualDataSet).FieldByName(sZLEPolaZM_Wart).AsString := DateToStr(TUNIDateEdit(TRowPanel(Sender).Controls[i]).Date);
               (DataSource.DataSet as TVirtualDataSet).VirtualPost;
            end else begin
               DataSource.DataSet.Edit;
               if TUNIDateEdit(TRowPanel(Sender).Controls[i]).Date = 0 then
                    DataSource.DataSet.FieldByName(sZLEPolaZM_Wart).Clear()
               else DataSource.DataSet.FieldByName(sZLEPolaZM_Wart).AsString := DateToStr(TUNIDateEdit(TRowPanel(Sender).Controls[i]).Date);
            end;
         end;
      end;

    finally
      if not bPozycja then
        (DataSource.DataSet as TVirtualDataSet).VState := OldVState;
    end;
  end;
end;

procedure TDBOwnGrid.Clear;
var iIndex: Integer;
begin
  for iIndex := ControlCount-1 downto 0 do
    Controls[iIndex].Free;
  FPanelCount := 0;
end;


function TDBOwnGrid.Validate: Boolean;
var iIndex, iIndex2: Integer;
begin
  result := False;
  for iIndex := 0 to ControlCount-1 do begin
    if Controls[iIndex] is TRowPanel then
      with Controls[iIndex] as TRowPanel do
        for iIndex2 := 0 to ControlCount-1 do
          if Controls[iIndex2].Visible then begin
            if (Controls[iIndex2] is TUNIEdit)and
               not(Controls[iIndex2] as TUNIEdit).Validate then Exit
            else
            if (Controls[iIndex2] is TUNIDateEdit)and
               not(Controls[iIndex2] as TUNIDateEdit).Validate then Exit
            else
            if (Controls[iIndex2] is TUNILookupAliasEdit2)and
               not(Controls[iIndex2] as TUNILookupAliasEdit2).Validate then Exit;
          end;
  end;
  result := True;
end;

initialization
  FormManager.RegisterForm( TZLEPoleZmGridForm, sZLEModulID );

end.
