unit ZLEPoleZmUnit;
{
Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who          What
---------------------------------------------------------------------------------------------
2005-12-20 Tomjen       Utworzenie
---------------------------------------------------------------------------------------------
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLEPoleZmDataModule = class(TUNIDataModule)
  private
    iZLEZLECENIECond: Integer;
    iZLEZLECENIEPOZCond: Integer;
    procedure SetQueryParams();
  protected
    procedure GetKeys; override;
    function  GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;
    procedure OpenDataSets(); override;
  public
    constructor Create( Owner: TComponent ); override;
    destructor Destroy(); override;
    procedure Post; override;
    procedure ReOpenDataSets(); override;
    procedure Open(); override;
  end;

implementation

{$R *.DFM}

uses
  QueryBuilderUnit,
  UNIFormUnit,
  UNISysDefUnit,
  FKDefUnit,
  ZLEDefUnit,
  ZLEPOZYCJEDBDetailFormUnit,
  ZLEZLECENIEDBDetailFormUnit;

{ TZLEPoleZmDataModule }

constructor TZLEPoleZmDataModule.Create(Owner: TComponent);
begin
  inherited;
end;

destructor TZLEPoleZmDataModule.Destroy;
begin
  if (Owner.Owner is TZLEZLECENIEDBDetailForm) then begin
    if (FActiveQuery as TVirtualDataSet).InTrans then
      (FActiveQuery as TVirtualDataSet).RollBackTrans;
    (FActiveQuery as TVirtualDataSet).VState := vsNormal;
  end;

  if (Owner.Owner is TZLEPOZYCJEDBDetailForm) then begin
    if (FActiveQuery as TVirtualDataSet).InTrans then
      (FActiveQuery as TVirtualDataSet).RollBackTrans;
    (FActiveQuery as TVirtualDataSet).VState := vsNormal;
  end;

  inherited;
end;

procedure TZLEPoleZmDataModule.GetKeys;
begin
  with FKeys do begin
    AddPrimary( sZLEPOLAZM_ID );

    if (Owner.Owner is TZLEZLECENIEDBDetailForm) then begin
       Add( sZLEZLECENIE_ID );
    end else if (Owner.Owner is TZLEPOZYCJEDBDetailForm) then begin
       Add( sZLEZLECENIEPOZ_ID );
    end;

    Add( sZLEPolaZMDef_ID );
  end;
end;

function TZLEPoleZmDataModule.GetTableName: string;
begin
  result := sZLEPOLAZM;
end;

procedure TZLEPoleZmDataModule.InitializeGridQueryDefs;
begin
  if GridColDefs.Count = 0 then with GridColDefs do begin
    AddRequiredAndUnvisible( sZLEPOLAZM_ID, 'M', '' );
    AddRequiredAndUnvisible( sZLEZLECENIE_ID, 'M', '' );
    AddRequiredAndUnvisible( sZLEZLECENIEPOZ_ID, 'M', '' );
    AddRequiredAndUnvisible( sZLEPOLAZMDef_ID, 'M', '' );
    AddRequiredAndUnvisible( sFKUZ_ID, 'M', '' );
    AddRequiredAndUnvisible( sZLEPOLAZMWSK_POZYCJA, 'W', '' );
    AddRequired( sFKUZ_SYMBOL, 'FKUZ', 'Sownik uytkownika', True, taLeftJustify, 100 );
    AddRequiredAndUnvisible( sFKMNEMONIKI_ID, 'DEF', '' );
    AddRequired( sFKMNEMONIKI_MNEMONIK, 'MNEM', 'Mnemonik', True, taLeftJustify, 100 );
    AddRequiredAndUnvisible( sFKMNEMONIKI_TABELA, 'MNEM', '' );
    AddRequiredAndUnvisible( sUNICONSTDEF_ID, 'DEF', '' );
    AddRequired( sUNICONSTDEF_DOMENA, 'CONSTDEF', 'Domena', True, taLeftJustify, 100 );
    AddRequired( sZLEPOLAZM_Wart, 'M', 'Warto', True, taLeftJustify, 100 );
    AddRequiredAndUnvisible( sZLEPOLAZM_DOMENAWART_ID, 'M', '' );
    AddRequired( sZLEPOLAZMDEF_Nazwa, 'DEF', 'Nazwa', True, taLeftJustify, 100 );
    AddRequired( sZLEPOLAZMDEF_Typ,  'DEF', 'Typ', True, taLeftJustify, 100 );
    AddRequired( sZLEPOLAZMDEF_Dlug, 'DEF', 'Dugo', True, taLeftJustify, 100 );
    AddRequired( sZLEPOLAZMDEF_TypDanych, 'DEF', 'Typ danych', True, taLeftJustify, 100 );
    AddRequired( sZLEPOLAZMDEF_Znaki,  'DEF', 'Dozwolone znaki', True, taLeftJustify, 100 );
    AddRequired( sZLEPOLAZMDEF_Format, 'DEF', 'Format', True, taLeftJustify, 50 );
    AddRequiredAndUnvisible( sZLEPOLAZMWSK_ID, 'W', '' );
  end;
  if GridTabDefs.Count = 0 then with GridTabDefs do begin
    Add( 'M', TableName );
    Add( 'DEF', sZLEPOLAZMDEF );
    Add( 'W', sZLEPOLAZMWSK );
    Add( 'MNEM', sFKMNEMONIKI );
    Add( 'CONSTDEF', sUNICONSTDEF );
    Add( 'FKUZ', sFKUZ );
    Add( 'ZLE', sZLEZLECENIE );
  end;
  if GridJoinDefs.Count = 0 then with GridJoinDefs do begin
    AddExpres( 'M.'+sZLEPOLAZMDEF_ID+'=DEF.'+sZLEPOLAZMDEF_ID, qjkInner, True );
    AddExpres( 'M.'+sFKUZ_ID+'=FKUZ.'+sFKUZ_ID, qjkLeftOuter, True );
    AddExpres( 'DEF.'+sFKMNEMONIKI_ID+'=MNEM.'+sFKMNEMONIKI_ID, qjkLeftOuter, True );
    AddExpres( 'DEF.'+sUNICONSTDEF_ID+'=CONSTDEF.'+sUNICONSTDEF_ID, qjkLeftOuter, True );
    AddExpres( 'DEF.'+sZLEPOLAZMDEF_ID+'=W.'+sZLEPOLAZMDEF_ID, qjkLeftOuter, True );
    AddExpres( 'M.'+sZLEZLECENIE_ID+'=ZLE.'+sZLEZLECENIE_ID, qjkInner, True );
    AddExpres( 'W.'+sZLETYPZLEC_ID+'=ZLE.'+sZLETYPZLEC_ID, qjkInner, True );

    if Owner.Owner is TZLEZlecenieDBDetailForm then begin
       AddCondition('W.' + sZLEPOLAZMWSK_POZYCJA + '=' + QuotedStr(sUNICONST_ALTERNATYWA_NIE), True);
       AddCondition('M.' + sZLEZLECENIEPOZ_ID + ' IS NULL ', True);
    end else if Owner.Owner is TZLEPozycjeDBDetailForm then begin
       AddCondition('W.' + sZLEPOLAZMWSK_POZYCJA + '=' + QuotedStr(sUNICONST_ALTERNATYWA_TAK), True);
       AddCondition('M.' + sZLEZLECENIEPOZ_ID + ' IS NOT NULL ', True);
    end;
  end;
  SetQueryParams();
  inherited;
end;

procedure TZLEPoleZmDataModule.Open;
begin
{TODO}
{  if (Owner.Owner is TZLEZLECENIEDBDetailForm) then begin
    if ListQuery <> nil then FreeAndNil(ListQuery);
    FActiveQuery := TZLEZLECENIEDBDetailForm(Owner.Owner).DataModule.ContainedDataModules[TZLEZLECENIEDBDetailForm(Owner.Owner).PolaUzFormIndex].ActiveQuery;
    //transakcja tylko na wirtualu
    (FActiveQuery as TVirtualDataSet).StartTrans;
    (FActiveQuery as TVirtualDataSet).VState := vsVirtualPost;
  end else}
    inherited;
end;

procedure TZLEPoleZmDataModule.OpenDataSets;
begin
  inherited;
end;

procedure TZLEPoleZmDataModule.Post;
var
  bTrans: Boolean;
  OldVState: TVirtualDataSetState;
begin
  bTrans := (FActiveQuery as TVirtualDataSet).InTrans;
  try
    if (Owner.Owner is TZLEZLECENIEDBDetailForm) then begin
      with ActiveQuery as TVirtualDataSet do begin
        OldVState := VState;
        try
          VState := vsVirtualPost;
          First;

          while not Eof do begin
            if (FieldByName(sZLEZLECENIE_ID).AsInteger = 0) then begin
              Edit;
              VirtualPost;
            end;
            Next;
          end;

        finally
           VState := OldVState;
        end;
      end;
    end;
    if (Owner.Owner is TZLEPOZYCJEDBDetailForm) then begin
      with ActiveQuery as TVirtualDataSet do begin
        OldVState := VState;
        try
          VState := vsVirtualPost;

          First;
          while not Eof do begin
            if (FieldByName(sZLEZLECENIE_ID).AsInteger = 0) then begin
                Edit;
                VirtualPost;
            end else if (FieldByName(sZLEZLECENIE_ID).AsInteger <> 0) then begin
                Edit;
                VirtualPost;
            end;

            if (FieldByName(sZLEZLECENIEPOZ_ID).AsInteger = 0) then begin
                Edit;
                VirtualPost;
            end;

            Next;
          end;

        finally
          VState := OldVState;
        end;

      end;
    end;
    inherited;
    if bTrans then
        (FActiveQuery as TVirtualDataSet).CommitTrans;
  except
    if bTrans then
        (FActiveQuery as TVirtualDataSet).RollBackTrans;
    raise;
  end;
end;

procedure TZLEPoleZmDataModule.ReOpenDataSets;
begin
  SetQueryParams();
  inherited;
end;

procedure TZLEPoleZmDataModule.SetQueryParams;
begin
  if iZLEZLECENIECond = 0 then
    iZLEZLECENIECond := GridJoinDefs.AddEmptyCondition();
  if iZLEZLECENIEPOZCond = 0 then
    iZLEZLECENIEPOZCond := GridJoinDefs.AddEmptyCondition();

  if (Owner.Owner is TZLEZlecenieDBDetailForm) and
     (TZLEZlecenieDBDetailForm(Owner.Owner).DMAQFbN(sZLEZLECENIE_ID).AsInteger <> 0) then
        GridJoinDefs.ExchangeCondition( iZLEZLECENIECond,
                                    'M.'+sZLEZLECENIE_ID+'='+TZLEZlecenieDBDetailForm(Owner.Owner).DMAQFbN(sZLEZLECENIE_ID).AsString,
                                    True )
  else
    GridJoinDefs.ExchangeCondition( iZLEZLECENIECond, '1=1', False );

  if (Owner.Owner is TZLEPozycjeDBDetailForm) and
     (TZLEPozycjeDBDetailForm(Owner.Owner).DMAQFbN(sZLEZLECENIEPOZ_ID).AsInteger <> 0) then
        GridJoinDefs.ExchangeCondition( iZLEZLECENIEPOZCond,
                                    'M.'+sZLEZLECENIEPOZ_ID+'='+TZLEPozycjeDBDetailForm(Owner.Owner).DMAQFbN(sZLEZLECENIEPOZ_ID).AsString,
                                    True )
  else
    GridJoinDefs.ExchangeCondition( iZLEZLECENIEPOZCond, '1=1', False );

end;

initialization
  RegisterClass( TZLEPoleZmDataModule );

end.
