unit ZLEPoleZmWskDBGridFormUnit;
{
Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who        What
---------------------------------------------------------------------------------------------
2005-12-20 Tomjen     Utworzenie
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls, UNIStaleUnit, UNIDataModuleUnit;

type
  TZLEPoleZmWskDBGridForm = class(TUNIDBGridForm)
  private
    procedure Detail(AOpenMode: TOpenMode);
  protected
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure Open; override;
    procedure View; override;
    procedure SetUserRights; override;
    procedure BeforeShow; override;
  public
    bCzyPozycja : Boolean;
    procedure New; override;
    procedure Delete; override;
    function GetHelpContext : string; override;
  end;

var
  ZLEPoleZmWskDBGridForm: TZLEPoleZmWskDBGridForm;

implementation

uses
  ZLEDefUnit,
  ZLEZlecenieDBDetailFormUnit,
  ZLEPoleZmWskUnit,
  ZLEPoleZmWskDBDetailFormUnit,
  ZLEPoleZmDefDBGridFormUnit,
  FormManagerUnit,
  UniqueKeyUnit,
  UniSysDefUnit,
  UNIDBDetailFormUnit,
  Dodatki,
  KeyManagerUnit,
  ZLETypZleceniaDBDetailFormUnit,
  SecurityManagerUnit;

{$R *.DFM}

procedure TZLEPoleZmWskDBGridForm.Detail(AOpenMode: TOpenMode);
var
  i: integer;
  GridForm: TUNIDBGridForm;
  oParams: TKeyValues;
begin
  i := TUNIDBDetailForm(Owner).DMAQFbN(sZLETYPZLEC_ID).AsInteger;
  if (AOpenMode = omNew) then begin
    oParams := TKeyValues.CreateEmpty;
    oParams.Add(sZLEPOLAZMDEF_TYP + '=' + '(1,2)');
    GridForm := FormManager.OpenDBGrid(Self, TZLEPoleZmDefDBGridForm.ClassName, omHidden + omLookup, oParams);
    if GridForm.ShowModal = mrOK then begin
      if DataModule.ActiveQuery.Locate(sZLEPOLAZMDEF_ID, GridForm.DMAQFbN(sZLEPOLAZMDEF_ID).Value, []) then
        Komunikat(cWarning, 'Ta zmiena wystpuje ju w definicji dokumentu')
      else
        with DataModule.ActiveQuery as TVirtualDataSet do begin
          try
            VState := vsInternalInsert;
            Append;
            FieldByName(sZLEPOLAZMWSK_ID).Value:= UniqueKey[sZLEPOLAZMWSK];
            FieldByName(sZLEPOLAZMDEF_ID).Value:= GridForm.DMAQFbN(sZLEPOLAZMDEF_ID).Value;
            if bCzyPozycja then
                FieldByName(sZLEPOLAZMWSK_POZYCJA).AsString:= sUNICONST_ALTERNATYWA_TAK
            else
               FieldByName(sZLEPOLAZMWSK_POZYCJA).AsString:= sUNICONST_ALTERNATYWA_NIE;

            FieldByName(sZLETYPZLEC_ID).Value := i;
            FieldByName(sZLEPOLAZMWSK_UZ_AU_ID).AsInteger := SecurityManager.UserID;
            FieldByName(sZLEPOLAZMWSK_DATA_AU).AsDateTime := UNINow;
            UpdateModifiedRecordFlagsForAddedRecord;
            FieldByName(sZLEPOLAZMDEF_NAZWA).Value := GridForm.DMAQFbN(sZLEPOLAZMDEF_NAZWA).Value;
            Post;
          finally
            VState := vsNormal;
          end;
        end;
    end;
  end else if (AOpenMode = omDelete) then begin
    FormManager.OpenDBDetail( self, TZLEPoleZmWskDBDetailForm.ClassName, AOpenMode or omOverVirtual );
  end;

  {if Owner is TZLETypZleceniaDBDetailForm then begin
    TZLETypZleceniaDBDetailForm(Owner).UsunPoleUzButton.Enabled := DeleteMenuItem.Enabled;
    TZLETypZleceniaDBDetailForm(Owner).UsunPolaUzPozButton.Enabled := DeleteMenuItem.Enabled;
  end;}
end;

procedure TZLEPoleZmWskDBGridForm.BeforeShow;
begin
  inherited;
  if Owner is TZLETypZleceniaDBDetailForm then begin
    ViewMenuItem.Visible := False;
    ViewMenuItem.Enabled := False;

    EditMenuItem.Visible := False;
    EditMenuItem.Enabled := False;

    {TZLETypZleceniaDBDetailForm(Owner).UsunPoleUzButton.Enabled := DeleteMenuItem.Enabled;
    TZLETypZleceniaDBDetailForm(Owner).UsunPolaUzPozButton.Enabled := DeleteMenuItem.Enabled;}
  end;
end;

function TZLEPoleZmWskDBGridForm.CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule;
begin
  if Parameters.Values[sZLEPOLAZMWSK_POZYCJA] <> '' then
    bCzyPozycja := (sUNICONST_ALTERNATYWA_TAK = Parameters.Values[sZLEPOLAZMWSK_POZYCJA]);
  Result := TZLEPoleZmWsk.CreateOpen(Self, DefaultMasterKeyValues, AOpenMode);
  SwitchOffColumnsEditorToolButton;
end;

procedure TZLEPoleZmWskDBGridForm.Open;
begin
  Detail(omEdit);
end;

procedure TZLEPoleZmWskDBGridForm.New;
begin
  Detail(omNew);
end;

procedure TZLEPoleZmWskDBGridForm.View;
begin
  Detail(omView);
end;

procedure TZLEPoleZmWskDBGridForm.Delete;
begin
  Detail(omDelete);
end;

function TZLEPoleZmWskDBGridForm.GetHelpContext: string;
begin
//  result := cHelpZlePolaUz;
end;

procedure TZLEPoleZmWskDBGridForm.SetUserRights;
begin
  with SecurityManager do begin
    Switch_New_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_POLAUZ_DOPISZ));
    Switch_Delete_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_POLAUZ_USUN));
    Switch_Open_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_POLAUZ_ZMIEN));
    Switch_View_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_POLAUZ_POKAZ));
  end;
end;

initialization
  FormManager.RegisterForm(TZLEPoleZmWskDBGridForm, sZLEModulID);
end.
