unit ZLEPoleZmWskUnit;
{
Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who        What
---------------------------------------------------------------------------------------------
2005-12-20 Tomjen     Utworzenie
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLEPoleZmWsk = class(TUNIDataModule)
  private
    idx: integer;
    procedure ChangeMasterKey;
  protected
    procedure GetKeys; override;
    function GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;
  public
    procedure Post; override;
  end;

var
  ZLEPoleZmWsk: TZLEPoleZmWsk;

implementation

uses
  ZLEDefUnit,
  UNISysDefUnit,
  UNIStaleUnit,
  SQLManagerUnit,
  UNIFormUnit,
  FKDefUnit,
  ZLEPoleZmWskDBGridFormUnit,
  QueryBuilderUnit;

{$R *.DFM}

procedure TZLEPoleZmWsk.ChangeMasterKey;
begin
  GridJoinDefs.ExchangeCondition(idx,'W.' + MasterKeyValues[0], True);
end;

procedure TZLEPoleZmWsk.GetKeys;
begin
  with FKeys do begin
    Clear;
    AddPrimary(sZLEPOLAZMWSK_ID);
  end;
end;

function TZLEPoleZmWsk.GetTableName: string;
begin
  Result := sZLEPOLAZMWSK;
end;

procedure TZLEPoleZmWsk.InitializeGridQueryDefs;
begin
  if GridColDefs.Count = 0 then with GridColDefs do begin
    Clear;
    AddRequired(sZLEPOLAZMWSK_ID, 'W', '', omNiewidoczne, taLeftJustify, 0);
    Add(sZLEPOLAZMWSK_POZYCJA,    'W', 'Pozycja', True, False, taLeftJustify, 0);
    Add(sZLEPOLAZMDEF_ID,         'W',    '',             True,  False, taLeftJustify,  0);
    Add(sZLETYPZLEC_ID,           'W',    '',             True,  False, taLeftJustify,  0);
    Add(sZLEPOLAZMDEF_NAZWA,      'D',    'Nazwa',        True,  True,  taLeftJustify,  200);
  end;
  if GridTabDefs.Count = 0 then with GridTabDefs do begin
    Clear;
    Add('W', GetTableName);
    Add('D', sZLEPOLAZMDEF);
  end;
  with GridJoinDefs do begin
    Clear;

    idx := AddEmptyCondition;
    ChangeMasterKey;

    AddExpres('W.' + sZLEPOLAZMDEF_ID + ' = ' + 'D.' + sZLEPOLAZMDEF_ID, qjkLeftOuter, True);
    if Owner is TZLEPoleZmWskDBGridForm then begin
       if TZLEPoleZmWskDBGridForm(Owner).bCzyPozycja then
             AddCondition('W.' + sZLEPOLAZMWSK_POZYCJA + ' = ' + QuotedStr(sUNICONST_ALTERNATYWA_TAK), True)
       else  AddCondition('W.' + sZLEPOLAZMWSK_POZYCJA + ' = ' + QuotedStr(sUNICONST_ALTERNATYWA_NIE), True);
    end;
//    AddExpres('W.' + sZLEPOLAZMDEF_ID + ' = ' + 'D.' + sZLEPOLAZMDEF_ID, qjkLeftOuter, True);
  end;
end;

procedure TZLEPoleZmWsk.Post;
var
  bTrans: boolean;
begin
  bTrans  := not SQLManager.InTransaction;
  if bTrans then SQLManager.StartTransaction;
  try
    inherited;
{    if (Owner as TUNIForm).ContainedFormCount > 0 then
      ContainedDataModules[0].Post;}
    if bTrans then SQLManager.Commit;
  except
    if bTrans then SQLManager.Rollback;
    raise;
  end;
end;

end.
