unit ZLEPozycjeDBDetailFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-25 gdeyk    Utworzone
2005-12-28 Tomjen   Pola uzytkownika
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBDetailFormUnit, UNIDBGridFormUnit, UNIFormUnit, Menus,
  UNIComponentsUnit, Db, DbClient, ToolWin, ComCtrls,
  StdCtrls, ExtCtrls, Mask, DBCtrls, UNIStaleUnit, UNIDataModuleUnit,
  UNIDBConstComboBoxUnit, UNIDateEditUnit, UNIDBDateEditUnit;

type
  TZLEPozycjeDBDetailForm = class(TUNIDBDetailForm)
    DanePageControl: TUNIPageControl;
    OgolneTabSheet: TTabSheet;
    OgolnePanel: TUNIPanel;
    SymbolAsortymentuLabel: TUNILabel;
    NazwaLabelAsortymentu: TUNILabel;
    OpisLabel: TUNILabel;
    SymbolLabel: TUNILabel;
    WzorDekrLabel: TUNILabel;
    WzorDekrNazwaLabel: TUNILabel;
    UNILabel2: TUNILabel;
    WartoscLabel: TUNILabel;
    DataLabel: TUNILabel;
    SymbolAsortymentuDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    OpisDBEdit: TUNIDBEdit;
    LpDBEdit: TUNIDBEdit;
    WzorDekrDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    IloscDBEdit: TUNIDBEdit;
    WartoscDBEdit: TUNIDBEdit;
    DataPozDBDateEdit: TUNIDBDateEdit;
    BOKSprawaPanel: TUNIPanel;
    UNILabel1: TUNILabel;
    BOKSprawaDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    PoziomINFPanel: TUNIPanel;
    PoziomINFLabel: TUNILabel;
    ElementINFLabel: TUNILabel;
    ElementINFNazwaLabel: TUNILabel;
    PoziomNazwaLabel: TUNILabel;
    ElementINFDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    CenaLabel: TUNILabel;
    CenaDBEdit: TUNIDBEdit;
    ObliczWartButton: TUNIButton;
    function SymbolAsortymentuDBLookupAliasEditGetDataField: String;
    function SymbolAsortymentuDBLookupAliasEditGetQuery: TUNIQuery;
    procedure SymbolAsortymentuDBLookupAliasEditInitAliasInfo(
      Sender: TObject);
    function SymbolAsortymentuDBLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    function BOKSprawaDBLookupAliasEditGetDataField: String;
    function BOKSprawaDBLookupAliasEditGetQuery: TUNIQuery;
    procedure BOKSprawaDBLookupAliasEditInitAliasInfo(Sender: TObject);
    procedure ElementINFDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function ElementINFDBLookupAliasEditGetDataField: String;
    function ElementINFDBLookupAliasEditGetQuery: TUNIQuery;
    function ElementINFDBLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    function BOKSprawaDBLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    function WzorDekrDBLookupAliasEditGetDataField: String;
    function WzorDekrDBLookupAliasEditGetQuery: TUNIQuery;
    procedure WzorDekrDBLookupAliasEditInitAliasInfo(Sender: TObject);
    procedure WzorDekrDBLookupAliasEditDelKey(Sender: TObject);
    procedure SymbolAsortymentuDBLookupAliasEditDelKey(Sender: TObject);
    procedure ObliczWartButtonClick(Sender: TObject);
  private
    oDefaultFieldList: TStringList;

    m_oOldZasobParent:    TWinControl;
    m_oOldZasobPosition:  TRect;
    m_oZakladkiPozGridy:  TStringList;
    m_oZakladkiParents:   TStringList;
    m_bUsunPolaUZ:        boolean;
    m_iPolaUzNr:          integer;

    FTabelaINF: String;
    FIndeks: String;
    FSprawaUmowione: String;
    FSprawaDataUmow: TDateTime;

    procedure MakeDefaultFieldList();
    procedure UnModifyDefaultFields( bUnModify: Boolean = true);
    procedure InitializeControls();
    procedure InitializeObjectFields();
    procedure SetDefaults();
    procedure UpdateLookupFields();
    procedure WylaczPanalePowiazan();
    procedure FieldChange( Sender: TField );
    procedure UtworzPolaUZNew();
    procedure WyswietlPolaUzytkownikaNew();
//    procedure PokazGridyOsadzoneNew();
//    procedure UtworzGridyOsadzoneNew();

  protected
    procedure BeforeShow; override;
    function  CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure InternalOpen; override;
    procedure GetPositionAndParentForContainedForm(
                       const nr:integer;
                       var APosition: TRect;
                       var AParent: TWinControl;
                       var AAlign:TAlign); override;
  public
    destructor Destroy(); override;
    procedure  CancelButtonPressed(); override;
    procedure  SelectButtonPressed(); override;
    function   Validate(): Boolean; override;
  end;

implementation

{$R *.DFM}

uses
  variants,
  FormManagerUnit,
  UNIDataManagerUnit,
  UNISysDefUnit,
  ASODefUnit,
  KeyManagerUnit,
  UniqueKeyUnit,
  ASODataManagerExtUnit,
  BOKDefUnit,
  BOKDataManagerExtUnit,
  INFDefUnit,
  MAGDEFUnit,
  INFDataManagerExtUnit,
  LFKDefUnit,
  FKDefUnit,
  LFKDataManagerUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit,
  ZLEZlecenieUnit,
  ZLEZlecenieDBDetailFormUnit,
  ZLEPozycjeUnit,
  ZLEPozycjeDBGridFormUnit,
  ZLEPoleZmGridFormUnit,
  UNISysDataManagerUnit,
  SQLManagerUnit,
  Dodatki;

{ TZLEPozycjeDBDetailForm }
procedure TZLEPozycjeDBDetailForm.UtworzPolaUZNew();
var
  iOpenMode:          TOpenMode;
  i:                  integer;
  oZakladkiPozNazwy,
  oZakladkiPozId:     TStringList;
  oZakladka:          TTabSheet;
  oParams:            TKeyValues;
  sTypId:             string;
  oGrid:          TUNIDBGridForm;
begin
  iOpenMode := omList or omContained or omVirtual;
  if(((OpenModeFlags and omReadOnly) = omReadOnly) or (OpenMode in [omView, omDelete])) then
    iOpenMode := iOpenMode or omReadOnly;

  if(m_oZakladkiPozGridy <> nil) then  FreeAndNil(m_oZakladkiPozGridy);

  oParams := TKeyValues.CreateEmpty();
  try
    (Owner as TUNIForm).GetParametersForForm(self, oParams);
    if(not ParamIsNotEmpty(oParams, sZLETYPZLEC_ID, sTypId)) then
      sTypId  := '0';
  finally
    oParams.Free();
  end;

  if(StrToInt(sTypId) = 0) then  exit;

  m_bUsunPolaUZ       := true;
  oZakladkiPozId      := TStringList.Create();
  oZakladkiPozNazwy   := TStringList.Create();
  m_oZakladkiPozGridy := TStringList.Create();
  m_oZakladkiParents  := TStringList.Create;

  try
    UNISysDM.UNIPolaUzytkownikaDajZakladki(
      oZakladkiPozId,
      oZakladkiPozNazwy,
      cPolaUZ_ZLEPozycja,
      StrToInt(sTypId)
    );

    for i := 0 to oZakladkiPozId.Count-1 do begin
      oZakladka := TTabSheet.Create(Self);
      oZakladka.PageControl := DanePageControl;
      oZakladka.Name        := cPolaUzPrefiksZakladki + IntToStr(i);
      oZakladka.Caption     := oZakladkiPozNazwy[i];
      oZakladka.PageIndex   := DanePageControl.PageCount - 1;
      oZakladka.TabVisible  := true;

      m_oZakladkiParents.AddObject(
        oZakladkiPozId[i],
        oZakladka
      );
      m_iPolaUzNr := m_oZakladkiParents.Count;
      m_oZakladkiPozGridy.AddObject(
        oZakladkiPozNazwy[i],
        UNISYSDM.UNIPokazIObsluzPolaUzytkownika(
           Self,
           DMAQFBN(sZLEZLECENIE_ID).AsInteger,
           cPolaUZ_ZLEPozycja,
           StrToInt(sTypId),
           StrToInt(oZakladkiPozId[i]),
           iOpenMode
        )
      );

      FContainedForms.AddObject(
        cPolaUzPrefiksZakladki + IntToStr(i),
        m_oZakladkiPozGridy.Objects[i]
      );

      oGrid := (m_oZakladkiPozGridy.Objects[i] as TUNIDBGridForm);
      UNISysDM.UNIFiltrujSubElemPolUzytkonwnika(
        oGrid,
        DMAQFbN(sZLEZLECENIE_ID).AsInteger,
        DMAQFbN(sZLEZLECENIEPOZ_ID).AsInteger
      );

      UNISysDM.UNIPrzeladujPolaUzytkownika(
        oGrid,
        cPolaUZ_ZLEPozycja,
        StrToInt(sTypId),
        DMAQFBN(sZLEZLECENIE_ID).AsInteger,
        DMAQFBN(sZLEZLECENIEPOZ_ID).AsInteger,
        true
      );
      oGrid.Show();
    end;  // for i := 0 to oZakladkiPozId.Count-1
  finally
    oZakladkiPozId.Free();
    oZakladkiPozNazwy.Free();
    m_oZakladkiParents.Free();
    m_iPolaUzNr := -1;
  end;
end;

procedure TZLEPozycjeDBDetailForm.WyswietlPolaUzytkownikaNew();
var
  i:              integer;
  oZakladka:      TTabSheet;
  oGrid:          TUNIDBGridForm;
begin
  for i := 0 to m_oZakladkiPozGridy.Count-1 do begin
    oZakladka := TTabSheet.Create(Self);
    oZakladka.PageControl := DanePageControl;
    oZakladka.Name        := cPolaUzPrefiksZakladki + IntToStr(i);
    oZakladka.Caption     := m_oZakladkiPozGridy[i];
    oZakladka.PageIndex   := DanePageControl.PageCount - 1;
    oZakladka.TabVisible  := true;



    oGrid := (m_oZakladkiPozGridy.Objects[i] as TUNIDBGridForm);
    if (i=0) then begin
      m_oOldZasobParent   := oGrid.ContainerParentForm;
      m_oOldZasobPosition := oGrid.PositionInContainer;
    end;
    oGrid.PositionInContainer := oZakladka.ClientRect;
    oGrid.ContainerParentForm := oZakladka;
    oGrid.Align    := alClient;

    UNISysDM.UNIFiltrujSubElemPolUzytkonwnika(
      oGrid,
      DMAQFbN(sZLEZLECENIE_ID).AsInteger,
      DMAQFbN(sZLEZLECENIEPOZ_ID).AsInteger
    );
    (oGrid.DataModule.ActiveQuery as TVirtualDataSet).StartTrans();
    UNISysDM.UNIPrzeladujPolaUzytkownika(
      oGrid,
      cPolaUZ_ZLEPozycja,
      (Owner.Owner as TZLEZlecenieDBDetailForm).DMAQFBN(sZLETYPZLEC_ID).AsInteger,
      DMAQFbN(sZLEZLECENIE_ID).AsInteger,
      DMAQFbN(sZLEZLECENIEPOZ_ID).AsInteger,
      (OpenMode = omNew)
    );
    oGrid.Show();
  end;  // for i := 0 to m_oZakladkiPozGridy.Count-1
end;

function TZLEPozycjeDBDetailForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
var
  i:Integer;
begin
  if(Parameters <> nil) then begin
    i := Parameters.IndexOf(sZLEParam_PolaUZGrid);
    if(i > -1) then begin
      m_oZakladkiPozGridy := (Parameters.Objects[i] as TStringList);
      Parameters.Objects[i]   := nil;
      Parameters.Delete(i);
    end;  // if(i > -1)
  end;  // if(Parameters <> nil)

  result := TZLEPozycjeDataModule.CreateOpen( Self, DefaultMasterKeyValues, AOpenMode );
end;

destructor TZLEPozycjeDBDetailForm.Destroy;
var i: Integer;
begin
  if oDefaultFieldList <> nil then oDefaultFieldList.Free;

  if(m_bUsunPolaUZ) then begin
    if(m_oZakladkiPozGridy <> nil) then
      FreeAndNil(m_oZakladkiPozGridy);
  end else if(m_oZakladkiPozGridy <> nil) then begin  // if(m_bUsunPolaUZ)
    for i := 0 to m_oZakladkiPozGridy.Count-1 do begin
      (m_oZakladkiPozGridy.Objects[i] as TUNIForm).ContainerParentForm    := m_oOldZasobParent;
      (m_oZakladkiPozGridy.Objects[i] as TUNIForm).PositionInContainer    := m_oOldZasobPosition;
      (m_oZakladkiPozGridy.Objects[i] as TUNIForm).Hide();
    end;  // for i := 0 to m_oZakladkiPozGridy.Count-1
  end;  // else - if(m_bUsunPolaUZ)

  inherited;
end;

procedure TZLEPozycjeDBDetailForm.GetPositionAndParentForContainedForm(
  const nr: integer; var APosition: TRect; var AParent: TWinControl;
  var AAlign: TAlign);
begin
  // wywietlamy pola uz (jeeli s tworzone na tej formatce a nie na parencie)
  if(m_iPolaUzNr > -1) then begin
     AParent   := (m_oZakladkiParents.Objects[m_iPolaUzNr - 1] as TWinControl);
     APosition := AParent.ClientRect;;
     AAlign    := alClient;
  end;
end;

procedure TZLEPozycjeDBDetailForm.InitializeControls;
var
  oForm: TZLEZlecenieDBDetailForm;
begin
  //ustawienie kontrolek
  LpDBEdit.DataField := sZLEZLECENIEPOZ_LP;
  WzorDekrNazwaLabel.Caption := '';
{  if Length(ASODM.vAsoMaskaIndeksu) > 0 then
    IndeksAsortymentuDBLookupAliasEdit.EditMask := ASODM.vAsoMaskaIndeksu+';0;_';}
  NazwaLabelAsortymentu.Caption := '';
  ElementINFNazwaLabel.Caption := '';
  OpisDBEdit.DataField     := sZLEZLECENIEPOZ_OPIS;
  IloscDBEdit.DataField    := sZLEZLECENIEPOZ_ILOSC;
  CenaDBEdit.DataField     := sZLEZLECENIEPOZ_CENA;
  WartoscDBEdit.DataField  := sZLEZLECENIEPOZ_WARTOSC;
  PoziomNazwaLabel.Caption := '';

  if not DataManagers.Available(sLFKModulID) then begin
     WzorDekrDBLookupAliasEdit.Visible := False;
     WzorDekrLabel.Visible := False;
     WzorDekrNazwaLabel.Visible := False;
  end;

  if not DataManagers.Available(sASOModulID) then begin
     SymbolAsortymentuDBLookupAliasEdit.Visible := False;
     SymbolAsortymentuLabel.Visible := False;
     NazwaLabelAsortymentu.Visible := False;
  end;

  WylaczPanalePowiazan();
  if (Owner.Owner is TZLEZlecenieDBDetailForm) then begin
    oForm := (Owner.Owner as TZLEZlecenieDBDetailForm);
    if DataManagers.Available(sINFModulID) then begin
      FTabelaINF := oForm.ElementINF;
      PoziomINFPanel.Visible := (oForm.ElementINF <> '');
      ElementINFDBLookupAliasEdit.Visible := PoziomINFPanel.Visible;
    end else begin
      FTabelaINF := '';
      PoziomINFPanel.Visible := False;
      ElementINFDBLookupAliasEdit.Visible := False;
    end;

    if DataManagers.Available(sBOKModulID) then
      BOKSprawaPanel.Visible := (oForm.TabelaPowiazana = sBOKSPRAWA)
    else
      BOKSprawaPanel.Visible := False;
    end;
end;

procedure TZLEPozycjeDBDetailForm.BeforeShow;
begin
  inherited;
  // jeeli pola uz nie byy utworzone na parencie to tworzymy je tutaj
  if(m_oZakladkiPozGridy = nil) then
    UtworzPolaUZNew()
  else
    WyswietlPolaUzytkownikaNew();
  //PokazGridyOsadzoneNew();
end;

procedure TZLEPozycjeDBDetailForm.InternalOpen;
begin
  InitializeControls();
  InitializeObjectFields();
  FIndeks := '';
  FSprawaUmowione := '';
  FSprawaDataUmow := 0;
  if Parameters.Values[cFORM_CAPTION] <> '' then begin
    Caption := Parameters.Values[cFORM_CAPTION];
  end;

  inherited;
  m_iPolaUzNr := -1;

  DMAQFbN(sZLEZLECENIEPOZ_POZIOMINF).OnChange := FieldChange;
  //ustawienie wartoci domylnych
  if OpenMode = omNew then
    SetDefaults()
  else if not DMAQFbN(sZLEZLECENIEPOZ_POZIOMINF).IsNull then
    FieldChange(DMAQFbN(sZLEZLECENIEPOZ_POZIOMINF));
//  ActiveControl := SymbolAsortymentuDBLookupAliasEdit;

  DanePageControl.ActivePage := OgolneTabSheet;
end;

procedure TZLEPozycjeDBDetailForm.SetDefaults;
begin
  Assert( Parameters.Values[sZLEZLECENIE_ID] <> '', 'Brak ID zlecenia dla pozycji');
  try
    (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := True;
    DMAQFbN(sZLEZLECENIE_ID).AsString := Parameters.Values[sZLEZLECENIE_ID];

    if (Owner.Owner is TZLEZlecenieDBDetailForm)and
       (Owner.Owner as TZLEZlecenieDBDetailForm).PodpowiedzDaneSprawy then begin
      if (Owner.Owner is TZLEZlecenieDBDetailForm) and (PoziomINFPanel.Visible) then
        DMAQFbN(sZLEZLECENIEPOZ_POZIOMINF).AsString := (Owner.Owner as TZLEZlecenieDBDetailForm).ElementINF;

      if (Parameters.Values[sBOKSPRAWA_ID] <> '')and
         (Pos( ',', Parameters.Values[sBOKSPRAWA_ID]) = 0) then
        DMAQFbN(sBOKSPRAWA_ID).AsString := Parameters.Values[sBOKSPRAWA_ID];
    end;

    DMAQFbN(sZLEZLECENIEPOZ_LP).AsString := Parameters.Values[sZLEZLECENIEPOZ_LP];

    //zaznaczenie pl ustawianych defaultowo jako nie zmodyfikowanych
    UnModifyDefaultFields();
  finally
    (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := False;
  end;

end;

function TZLEPozycjeDBDetailForm.Validate: Boolean;
var
  i, j: Integer;
begin
  result := inherited Validate();
  if Result then begin
     if (OpenMode in [omNew, omEdit]) and
        (DMAQFbN(sASOASORT_ID).IsNull) and
        (DMAQFbN(sBOKSPRAWA_ID).IsNull) then begin
        {Wymagalnosc tylko gdy wczona kontrola ilosciowa w typie zlecenia}
        if (Owner.Owner is TZLEZlecenieDBDetailForm) then begin
            if (Owner.Owner as TZLEZlecenieDBDetailForm).KontrolaIlosciowa and
               (not (Owner.Owner as TZLEZlecenieDBDetailForm).KontrolaIlosciowaAsoMag) then begin
              Komunikat(cWarning, 'Nie wypeniono asortymentu');
              SymbolAsortymentuDBLookupAliasEdit.SetFocus;
              result := False;
              Exit;
            end;
        end;
     end;
  end;

  if result then begin
      // walidacja pol uzytkownika
      for i := 0 to ContainedFormCount-1 do begin
        if(Pos(cPolaUzPrefiksZakladki, FContainedForms[i]) > 0) then begin
          result  := UNISysDM.UNIPolaUzytkownikaValidate((FContainedForms.Objects[i] as TUNIForm));
          if (result = false) then begin
              // przelcznie na waciw zakadk
            for j := 0 to DanePageControl.PageCount-1 do begin
              if(DanePageControl.Pages[j].name = FContainedForms[i]) then begin
                DanePageControl.ActivePage := DanePageControl.Pages[j];
                break;
              end;  // if(DanePageControl.Pages[j].name = FContainedForms[i])
            end;  // for j:=0 to DanePageControl.PageCount-1
            break;
          end;  // if(result = false)
        end;  // if(Pos(cPolaUzPrefiksZakladki, FContainedForms[i]) > 0)
      end;  // for i := 0 to ContainedFormCount-1
  end;
end;

function TZLEPozycjeDBDetailForm.SymbolAsortymentuDBLookupAliasEditGetDataField: String;
begin
  result := sASOASORT_ID;
end;

function TZLEPozycjeDBDetailForm.SymbolAsortymentuDBLookupAliasEditGetQuery: TUNIQuery;
var
  sWhere: String;
  iModulID: Integer;
begin
  sWhere := '';
  iModulID := cZLEModulZSI_ID;
  if (Owner.Owner is TZLEZlecenieDBDetailForm) then begin
    sWhere := '@'+sASOAlias_AsortReg_RegID+'='+IntToStr((Owner.Owner as TZLEZlecenieDBDetailForm).ASORegID);
    if (Owner.Owner as TZLEZlecenieDBDetailForm).ASORegID > -1 then
      iModulID := (Owner.Owner as TZLEZlecenieDBDetailForm).ASORegID;
  end;
  result := ASODM.PokazIObsluzAsortyment( sASOAlias_Asort_ID+';'+
                                          sASOAlias_Asort_Symbol+';'+
                                          sASOAlias_Asort_Indeks+';'+
                                          sASOAlias_Asort_Nazwa+ ';' +
                                          sLFKAlias_WzordekrID,
                                          sWhere,
                                          False, False, DMAQFbN(sASOASORT_ID).AsString,
                                          iModulID );

//  if result <> nil then WzorDekrDBLookupAliasEditSetData(result);

end;

procedure TZLEPozycjeDBDetailForm.SymbolAsortymentuDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  if not DataManagers.Available(sLFKModulID) then Exit;

  with SymbolAsortymentuDBLookupAliasEdit do begin
    AliasManager := ASODM.AliasManager;
    Alias_ID := sASOAlias_Asort_ID;
    Alias_Name := sASOAlias_Asort_Symbol;
    if not DataManagers.Available(sLFKModulID) then
      AdditionalAliases := sASOAlias_Asort_Indeks + ';' + sASOAlias_Asort_Nazwa
    else
      AdditionalAliases := sASOAlias_Asort_Indeks + ';' + sASOAlias_Asort_Nazwa + ';' + sLFKAlias_WzordekrID;
    if (Owner.Owner is TZLEZlecenieDBDetailForm) then
      AdditionalCondition :='@'+sASOAlias_AsortReg_RegID+'='+IntToStr((Owner.Owner as TZLEZlecenieDBDetailForm).ASORegID);
  end;
end;

function TZLEPozycjeDBDetailForm.SymbolAsortymentuDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
var
    q: TUNIQuery;
begin
  result := True;
  if not DataManagers.Available(sASOModulID) then Exit;

  if (OpenMode = omNew) or (OpenMode = omEdit) then begin
    if AliasSrc <> nil then with AliasSrc do begin
       NazwaLabelAsortymentu.Caption := FieldByName(sASOASORT_NAZWA).AsString;
       FIndeks := FieldByName(sASOASORT_Indeks).AsString;;

       if DataManagers.Available(sLFKModulID) then begin
         if (not FieldByName(sLFKWZORDEKR_ID).isNull) then begin
           {Aktualizacja pola Wzor Dekretacji}
           try
              q := LFKDM.LFKOdpytajODane(
                sLFKWZORDEKR, //Tabela
                sLFKAlias_WzordekrID + ';' + sLFKAlias_WzordekrNrDekr+ ';' + sLFKAlias_WZORDEKR_NAZWA, //Atrybuty
                '('+ sLFKWZORDEKR_ID + '=' + FieldByName(sLFKWZORDEKR_ID).AsString + ')', //Warunek
                False //Unikalne
                );
              if q <> nil then
                 if (not q.isEmpty) then begin
                    DMAQFbN(sLFKWZORDEKR_ID).AsString := FieldByName(sLFKWZORDEKR_ID).AsString;
                    WzorDekrDBLookupAliasEdit.Text := q.Fields[1].AsString;
                 end;

           finally
              if q <> Nil then FreeAndNil(q);
           end;
         end else begin
            DMAQFbN(sLFKWZORDEKR_ID).Clear();
            WzorDekrDBLookupAliasEdit.Text := '';
         end;
       end;
    end;
  end;
end;

procedure TZLEPozycjeDBDetailForm.UpdateLookupFields;
begin
  if (OpenMode in [omNew,omEdit])and
     ((Owner as TZLEPozycjeDBGridForm).FormIsContained) then
    with ((Owner as TZLEPozycjeDBGridForm).DataModule.ActiveQuery as TVirtualDataSet) do begin
      try
        VState := vsInternalInsert;
        Edit;
        if DataManagers.Available(sASOModulID) then begin
          FieldByName(sASOASORT_INDEKS).AsString := FIndeks; //IndeksAsortymentuDBLookupAliasEdit.Text;
          FieldByName(sASOASORT_SYMBOL).AsString := SymbolAsortymentuDBLookupAliasEdit.Text;
          FieldByName(sASOASORT_NAZWA).AsString := NazwaLabelAsortymentu.Caption;
        end;

        if FindField(sBOKSPRAWA_NUMER) <> nil then
           FieldByName(sBOKSPRAWA_NUMER).AsString := BOKSprawaDBLookupAliasEdit.Text;

        if FindField(sBOKSPRAWA_OBIEKTOPIS) <> nil then
           FieldByName(sBOKSPRAWA_OBIEKTOPIS).AsString := OpisDBEdit.Text;

        if DataManagers.Available(sINFModulID) then begin
          if FindField('OBIEKT_SYMBOL') <> nil then
             FieldByName('OBIEKT_SYMBOL').AsString := ElementINFDBLookupAliasEdit.Text;
          {if FindField('OBIEKT_SYMBOL') <> nil then
             FieldByName('OBIEKT_NAZWA').AsString := ElementINFNazwaLabel.Caption;}
          if FindField('INF_SYMBOL') <> nil then
             FieldByName('INF_SYMBOL').AsString := ElementINFDBLookupAliasEdit.Text;
          if FindField('INF_NAZWA') <> nil then
             FieldByName('INF_NAZWA').AsString := ElementINFNazwaLabel.Caption;
        end;

        if FindField(sBOKSPRAWA_UMOWIONE) <> nil then
           FieldByName(sBOKSPRAWA_UMOWIONE).AsString := FSprawaUmowione;

        if FindField(sBOKSPRAWA_DATA_UMOW) <> nil then
           FieldByName(sBOKSPRAWA_DATA_UMOW).AsDateTime := FSprawaDataUmow;
        Post;
      finally
        VState := vsNormal;
      end;
    end;
end;

procedure TZLEPozycjeDBDetailForm.SelectButtonPressed;
var
  q: TUNIQuery;
  oGridUZ,
  oGrid:    TUNIDBGridForm;
  i:        integer;
begin

  if OpenMode = omDelete then begin
    q := SQLManager.CreateQuery('SELECT COUNT(*) FROM ' + SQLManager.GetTableName(sZLEZASOBYPRACA) + ' WHERE ' + sZLEZLECENIEPOZ_ID + ' = ' + DMAQFbN(sZLEZLECENIEPOZ_ID).AsString);
    try
      q.Open;
      if q.Fields[0].AsInteger > 0 then
        if Komunikat(cConfirmation, 'Usunicie pozycji spowoduje rwnie usunicie elementw automatycznego rozliczenia uywajcych tej pozycji. Czy napewno usun pozycj?', MB_YESNO+MB_APPLMODAL+MB_DEFBUTTON2) <> IDYES then
          Exit;
    finally
      FreeAndNil(q);
    end;

    {Sprawdzenie czy pozycja zlecenia nie jest juz wykorzystana w Dyspozycji}
    q := SQLManager.CreateQuery('SELECT Count(*) FROM %s o, %s p, %s t, %s zp WHERE' +
             ' o.' + sMAGOBR_ID + ' = p.' + sMAGOBR_ID + ' AND' +
             ' o.' + sMAGTYPDOK_ID + ' = t.' + sMAGTYPDOK_ID + ' AND' +
             ' t.' + sMAGTYPDOK_SPEC + ' IN (''DM'')' + ' AND' +
             ' p.' + sZLEZLECENIEPOZ_ID + ' = zp.' + sZLEZLECENIEPOZ_ID + ' AND' +
             ' p.' + sZLEZLECENIEPOZ_ID + ' = ' + DMAQFbN(sZLEZLECENIEPOZ_ID).AsString,
             [  sMAGModulID + cMAGOBR_SUFFIX, sMAGModulID + cMAGOBRPOZ_SUFFIX, sMAGTYPDOK, sZLEZLECENIEPOZ ]);
    try
      q.Open;
      if q.Fields[0].AsInteger > 0 then begin
        Komunikat(cError, 'Nie mozna usun pozycji, poniewa istniej dyspozycje powiazane z nimi');
        Exit;
      end;
    finally
      FreeAndNil(q);
    end;

  end;
  UnModifyDefaultFields(false);
  inherited;

  UpdateLookupFields();

  if ((ModalResult = mrOk) and
     ((OpenModeFlags and omOverVirtual) = omOverVirtual) and
     (Owner is TUNIDBGridForm)) then begin
    if(OpenMode in [omNew, omEdit]) then begin
      oGrid := (Owner as TUNIDBGridForm);
      for i := 0 to m_oZakladkiPozGridy.Count-1 do begin
        oGridUZ := (m_oZakladkiPozGridy.Objects[i] as TUNIDBGridForm);
        with oGrid.DataModule.ActiveQuery as TVirtualDataSet do begin
          try
            VState := vsInternalInsert;
            Edit;
            UNISysDM.UNISysAktualizujDataSetPolamiUz(oGridUZ, oGrid.DataModule.ActiveQuery as TVirtualDataSet);
            Post;
          finally
            VState := vsNormal;
          end;
        end;
      end;    // for i := 0 to m_oZakladkiPozGridy.Count-1

      for i := 0 to m_oZakladkiPozGridy.Count-1 do begin
        oGridUZ := (m_oZakladkiPozGridy.Objects[i] as TUNIDBGridForm);
        if((oGridUZ.DataModule.ActiveQuery as TVirtualDataSet).InTrans()) then
          (oGridUZ.DataModule.ActiveQuery as TVirtualDataSet).CommitTrans();
      end;  // for i := 0 to m_oZakladkiPozGridy.Count-1
    end else if(OpenMode in [omDelete]) then begin
      for i := 0 to m_oZakladkiPozGridy.Count-1 do begin
        oGridUZ := (m_oZakladkiPozGridy.Objects[i] as TUNIDBGridForm);
        if((oGridUZ.DataModule.ActiveQuery as TVirtualDataSet).InTrans()) then
          (oGridUZ.DataModule.ActiveQuery as TVirtualDataSet).CommitTrans();
      end;  // for i := 0 to m_oZakladkiPozGridy.Count-1
    end;
  end;  // if((OpenModeFlags and omOverVirtual) = omOverVirtual)
end;

procedure TZLEPozycjeDBDetailForm.CancelButtonPressed();
var
  oGrid:  TUNIDBGridForm;
  i:      integer;
begin
  inherited;
  if(ModalResult = mrCancel) then begin
    for i := 0 to m_oZakladkiPozGridy.Count-1 do begin
      oGrid := (m_oZakladkiPozGridy.Objects[i] as TUNIDBGridForm);
      if((oGrid.DataModule.ActiveQuery as TVirtualDataSet).InTrans()) then
        (oGrid.DataModule.ActiveQuery as TVirtualDataSet).RollBackTrans();
    end;  // for i := 0 to m_oZakladkiPozGridy.Count-1
  end;
end;

procedure TZLEPozycjeDBDetailForm.InitializeObjectFields;
begin
  oDefaultFieldList := nil;
  oDefaultFieldList := TStringList.Create();
  MakeDefaultFieldList();
end;

procedure TZLEPozycjeDBDetailForm.MakeDefaultFieldList;
begin
  with oDefaultFieldList do begin
    Add(sZLEZLECENIE_ID);
  end;
end;

procedure TZLEPozycjeDBDetailForm.ObliczWartButtonClick(Sender: TObject);
begin
  inherited;
  if (OpenMode in [omNew, omEdit]) then begin
     if not (DMAQFbN(sZLEZLECENIEPOZ_ILOSC).IsNull or DMAQFbN(sZLEZLECENIEPOZ_CENA).IsNull) then
        DMAQFbN(sZLEZLECENIEPOZ_WARTOSC).AsFloat := Zaokraglij(DMAQFbN(sZLEZLECENIEPOZ_ILOSC).AsFloat * DMAQFbN(sZLEZLECENIEPOZ_CENA).AsFloat, 2);
  end;
end;

procedure TZLEPozycjeDBDetailForm.UnModifyDefaultFields(
  bUnModify: Boolean);
var iIndex: Integer;
begin
  for iIndex := 0 to oDefaultFieldList.Count-1 do begin
    with (DataModule.ActiveQuery as TVirtualDataSet).ModifiedRecordsFlagsList do
      if bUnModify then SetFieldIsNotModified(DMAQFbN(oDefaultFieldList[iIndex]))
      else SetFieldIsModified(DMAQFbN(oDefaultFieldList[iIndex]));
  end;
end;

function TZLEPozycjeDBDetailForm.BOKSprawaDBLookupAliasEditGetDataField: String;
begin
  result := sBOKSPRAWA_ID;
end;

function TZLEPozycjeDBDetailForm.BOKSprawaDBLookupAliasEditGetQuery: TUNIQuery;
var
  sLocate: String;
  sWhere: String;
begin
  sLocate := '';
  result := nil;
  if not DataManagers.Available(sBOKModulID) then Exit;

  if not DMAQFbN(sBOKSPRAWA_ID).IsNull then
    sLocate := sBOKSPRAWA_ID+'='+DMAQFbN(sBOKSPRAWA_ID).AsString;
  if (Owner.Owner is TZLEZlecenieDBDetailForm)and
     (Owner.Owner as TZLEZlecenieDBDetailForm).PodpowiedzDaneSprawy and
     (Parameters.Values[sBOKSPRAWA_ID] <> '') then
    sWhere := '@'+sBOKAlias_Sprawa_ID+' in ('+Parameters.Values[sBOKSPRAWA_ID]+')'
  else
    sWhere := '';
  result := BOKDM.PokazIObsluzDane( sBOKSPRAWA,
                                    sBOKAlias_Sprawa_ID+';'+
                                    sBOKAlias_Sprawa_Numer+';'+
                                    sBOKAlias_Sprawa_ObiektINF+';'+
                                    sBOKAlias_Sprawa_ObiektINF_ID+';'+
                                    sBOKAlias_Sprawa_Asort_ID+';'+
                                    sBOKAlias_Sprawa_Problem+';'+
                                    sBOKAlias_Sprawa_Umowione+';'+
                                    sBOKAlias_Sprawa_Data_Umow,
                                    sWhere, False, False, sLocate );
end;

procedure TZLEPozycjeDBDetailForm.BOKSprawaDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  if not DataManagers.Available(sBOKModulID) then Exit;

  with BOKSprawaDBLookupAliasEdit do begin
    if DataManagers.Available(sBOKModulID) then
      AliasManager := BOKDM.AliasManager
    else
      AliasManager := nil;
    Alias_ID := sBOKAlias_Sprawa_ID;
    Alias_Name := sBOKAlias_Sprawa_Numer;
    AdditionalAliases := sBOKAlias_Sprawa_ObiektINF+';'+
                         sBOKAlias_Sprawa_ObiektINF_ID+';'+
                         sBOKAlias_Sprawa_Asort_ID+';'+
                         sBOKAlias_Sprawa_Problem+';'+
                         sBOKAlias_Sprawa_Umowione+';'+
                         sBOKAlias_Sprawa_Data_Umow;
    if (Owner.Owner is TZLEZlecenieDBDetailForm)and
       (Owner.Owner as TZLEZlecenieDBDetailForm).PodpowiedzDaneSprawy and
       (Parameters.Values[sBOKSPRAWA_ID] <> '') then
      AdditionalCondition := '@'+sBOKAlias_Sprawa_ID+' in ('+Parameters.Values[sBOKSPRAWA_ID]+')'
    else
      AdditionalCondition := '';
  end;
end;

procedure TZLEPozycjeDBDetailForm.WylaczPanalePowiazan;
begin
  BOKSprawaPanel.Visible := False;
  PoziomINFPanel.Visible := False;
end;

procedure TZLEPozycjeDBDetailForm.ElementINFDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
var
  sPoziom: String;
begin
  with ElementINFDBLookupAliasEdit do begin
    if DataManagers.Available(sINFModulID)and
       (DataModule <> nil) then begin
      AliasManager := INFDM.AliasManager;
      sPoziom := DMAQFbN(sZLEZLECENIEPOZ_POZIOMINF).AsString;
      if sPoziom = sINFCONST_OBIEKT_LOKAL then begin
        Alias_ID := sINFAlias_Lokal_ID;
        Alias_Name := sINFAlias_Lokal_Symbol;
        AdditionalAliases := sINFAlias_LokalOpis_Opis;
      end else if sPoziom = sINFCONST_OBIEKT_ZASOB then begin
        Alias_ID := sINFAlias_Zasob_ID;
        Alias_Name := sINFAlias_Zasob_Symbol;
        AdditionalAliases := sINFAlias_Zasob_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_KLATKA then begin
        Alias_ID := sINFAlias_Klatka_ID;
        Alias_Name := sINFAlias_Klatka_Symbol;
        AdditionalAliases := sINFAlias_Klatka_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_BRAMA then begin
        Alias_ID := sINFAlias_Brama_ID;
        Alias_Name := sINFAlias_Brama_Symbol;
        AdditionalAliases := sINFAlias_Brama_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_BUDYNEK then begin
        Alias_ID := sINFAlias_Budynek_ID;
        Alias_Name := sINFAlias_Budynek_Symbol;
        AdditionalAliases := sINFAlias_Budynek_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_NIERUCHOMOSC then begin
        Alias_ID := sINFAlias_Nieruchomosc_ID;
        Alias_Name := sINFAlias_Nieruchomosc_Symbol;
        AdditionalAliases := sINFAlias_Nieruchomosc_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_WSPOLNOTA then begin
        Alias_ID := sINFAlias_Wspolnota_ID;
        Alias_Name := sINFAlias_Wspolnota_Symbol;
        AdditionalAliases := sINFAlias_Wspolnota_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_REJON then begin
        Alias_ID := sINFAlias_Rejon_ID;
        Alias_Name := sINFAlias_Rejon_Symbol;
        AdditionalAliases := sINFAlias_Rejon_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_ULICA then begin
        Alias_ID := sINFAlias_Ulica_ID;
        Alias_Name := sINFAlias_Ulica_Symbol;
        AdditionalAliases := sINFAlias_Ulica_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_ELEMENTSIECI then begin
        Alias_ID := sINFAlias_SiecElement_ID;
        Alias_Name := sINFAlias_SiecElement_Symbol;
        AdditionalAliases := sINFAlias_SiecElement_Opis;
      end else if sPoziom = sINFCONST_OBIEKT_SKLADNIKELSIECI then begin
        Alias_ID := sINFAlias_Skladnik_ID;
        Alias_Name := sINFAlias_Skladnik_Symbol;
        //AdditionalAliases := sINFAlias_SiecSkladnik_Opis;
      end else if sPoziom = sINFCONST_OBIEKT_POZIOM then begin
        Alias_ID := sINFAlias_Poziom_ID;
        Alias_Name := sINFAlias_Poziom_Nazwa;
      end else begin
        AliasManager := nil;
      end;
    end else
      AliasManager := nil;
  end;
end;

function TZLEPozycjeDBDetailForm.ElementINFDBLookupAliasEditGetDataField: String;
begin
  result := sZLEZLECENIEPOZ_INF_ID;
end;

function TZLEPozycjeDBDetailForm.ElementINFDBLookupAliasEditGetQuery: TUNIQuery;
var
  iPoziomID: Integer;
  sPoziom: String;
  sObiekt, sObiektTmp: String;
  iZleTypZlec_ID: Integer;
begin
  sObiektTmp := '';
  if (OpenMode = omNew) and (DMAQFbN(sZLEZLECENIEPOZ_POZIOMINF).AsString = '') and (Owner.Owner is TZLEZlecenieDBDetailForm) then begin
     iZleTypZlec_ID := TZLEZlecenieDBDetailForm(Owner.Owner).DMAQFBN(sZLETYPZLEC_ID).AsInteger;
     {Pobrac Dla zletypzlec_id domyslny poziom inf dla OmNew}
     if iZleTypZlec_ID > 0 then
        sObiektTmp := SQLManager.GetField(sZLETYPZLEC, sZLETYPZLEC_POZIOMINF, IntToStr(iZleTypZlec_ID));
  end;

  sObiekt := DMAQFbN(sZLEZLECENIEPOZ_POZIOMINF).AsString;
  if (sObiekt = '') and (sObiektTmp <> '') then sObiekt := sObiektTmp;

  iPoziomID := 0;
  sPoziom := '';
  result := INFDM.INFPokazIObsluzObiekt( sObiekt, iPoziomID, sPoziom, False, nil );
  if (OpenMode in [omNew,omEdit])and
     (result <> nil)and
     (sObiekt <> DMAQFbN(sZLEZLECENIEPOZ_POZIOMINF).AsString) then
    DMAQFbN(sZLEZLECENIEPOZ_POZIOMINF).AsString := sObiekt;
end;

function TZLEPozycjeDBDetailForm.ElementINFDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
    if AliasSrc.Fields.Count > 2 then
      ElementINFNazwaLabel.Caption := AliasSrc.Fields[2].AsString;
  end;
  result := True;
end;

procedure TZLEPozycjeDBDetailForm.FieldChange(Sender: TField);
var
  iIndex: Integer;
begin
  iIndex := cslINFRodzajObiektu.IndexOfSkrot( Sender.AsString );
  if iIndex <> -1 then
    PoziomNazwaLabel.Caption := cslINFRodzajObiektu[iIndex];
end;

function TZLEPozycjeDBDetailForm.BOKSprawaDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
    if (OpenMode in [omNew,omEdit]) then begin
      if (PoziomINFPanel.Visible)and
         ((BOKSprawaDBLookupAliasEdit.Initialized)or(DMAQFbN(sZLEZLECENIEPOZ_INF_ID).IsNull)) then begin
        DMAQFbN(sZLEZLECENIEPOZ_POZIOMINF).AsString := AliasSrc.FieldByName(sBOKSPRAWA_OBIEKTJAKI).AsString;
        DMAQFbN(sZLEZLECENIEPOZ_INF_ID).AsInteger := AliasSrc.FieldByName(sBOKSPRAWA_OBIEKTID).AsInteger;
        FSprawaUmowione := AliasSrc.FieldByName(sBOKSPRAWA_UMOWIONE).AsString;
        FSprawaDataUmow := AliasSrc.FieldByName(sBOKSPRAWA_DATA_UMOW).AsDateTime;
        ElementINFDBLookupAliasEdit.Refresh();
      end;
      if DMAQFbN(sASOASORT_ID).IsNull then begin
        SymbolAsortymentuDBLookupAliasEdit.InitiateData(AliasSrc.FieldByName(sASOASORT_ID));
      end;
      if DMAQFbN(sZLEZLECENIEPOZ_OPIS).IsNull then
        DMAQFbN(sZLEZLECENIEPOZ_OPIS).AsString := AliasSrc.FieldByName(sBOKSPRAWA_PROBLEM).AsString;
    end;
  end;
  result := True;
end;

function TZLEPozycjeDBDetailForm.WzorDekrDBLookupAliasEditGetDataField: String;
begin
  inherited;
  result := sLFKWZORDEKR_ID;
end;

function TZLEPozycjeDBDetailForm.WzorDekrDBLookupAliasEditGetQuery: TUNIQuery;
var
  sWarPos: String;
begin
  result := nil;
  if not DataManagers.Available(sLFKModulID) then Exit;

  inherited;
  sWarPos := '';
  if not DMAQFbN(sLFKWZORDEKR_ID).IsNull then
    sWarPos := sLFKAlias_WZORDEKR_ID+'='+DMAQFbN(sLFKWZORDEKR_ID).AsString;

  result := LFKDM.LFKPokazIObsluzDane( sLFKWZORDEKR, cZLEModulZSI_ID, '',
                                         False, False, True,
                                         sLFKAlias_WZORDEKR_ID+';'+
                                         sLFKAlias_WZORDEKR_NR_DEKR+';'+
                                         sLFKAlias_WZORDEKR_NAZWA,
                                         sWarPos );
end;

procedure TZLEPozycjeDBDetailForm.WzorDekrDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  inherited;
  if DataManagers.Available(sLFKModulID) then
    with WzorDekrDBLookupAliasEdit do begin
      AliasManager := LFKDM.AliasManager;
      Alias_ID := sLFKAlias_WZORDEKR_ID;
      Alias_Name := sLFKAlias_WZORDEKR_NR_DEKR;
      AdditionalAliases := sLFKAlias_WZORDEKR_NAZWA;
    end;
end;

procedure TZLEPozycjeDBDetailForm.WzorDekrDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  WzorDekrDBLookupAliasEdit.Clear();
//  WzorDekrNazwaLabel.Caption := '';
end;

procedure TZLEPozycjeDBDetailForm.SymbolAsortymentuDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  if not DataManagers.Available(sASOModulID) then Exit;

  if (OpenMode = omNew) or (OpenMode = omEdit) then begin
      NazwaLabelAsortymentu.Caption := '';
      FIndeks := '';
      DMAQFbN(sASOASORT_ID).Clear();
      SymbolAsortymentuDBLookupAliasEdit.Text := '';
  end;
end;

initialization
  FormManager.RegisterForm( TZLEPozycjeDBDetailForm, 'Pozycje zlecenia', sZLEModulID );
end.
