unit ZLEPozycjeDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-24 gdeyk    Utworzone
2006-01-03 Krz      W OpenDetail dla AOpenMode = omNew zamiast woa
                    TZLEPozycjeDataModule.NextLp (czyli RecordCount + 1) zaimplementowaem
                    ptelk po rekordach i zwrcenie najwyszego LP + 1. 
2007-07-25 Adam     Dodana kontrola aby zlecenie zawierao tylko jedn pozycj
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls, UNIStaleUnit, UNIDataModuleUnit, math, UNIFormUnit, KeyManagerUnit;
  {UNIStaleUnit,  UNIDataManagerUnit,  UNIDataModuleUnit, ,  Buttons;}

type
  TZLEPozycjeDBGridForm = class(TUNIDBGridForm)
    RightButtonPanel: TUNIPanel;
    DopiszButton: TUNIButton;
    UsunButton: TUNIButton;
    ZmienButton: TUNIButton;
    PokazButton: TUNIButton;
    SprawyButton: TUNIButton;
    procedure DopiszButtonClick(Sender: TObject);
    procedure UsunButtonClick(Sender: TObject);
    procedure ZmienButtonClick(Sender: TObject);
    procedure PokazButtonClick(Sender: TObject);
    procedure SprawyButtonClick(Sender: TObject);

  private
    m_oZakladkiPozGridy:  TStringList;
    procedure OdczytajZakladki();
    procedure InitializeControls();
    procedure OpenDetail( AOpenMode: TOpenMode );
    procedure RefreshGridButtons( DataSet: TDataSet);

  protected
    procedure New(); override;
    procedure Open(); override;
    procedure View(); override;
    procedure Delete(); override;
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;

  public
    procedure GetParametersForForm(
                  a_oForm:           TUNIForm;
                  a_oParameters:     TKeyValues
              ); override;  
    procedure InternalOpen(); override;
  end;

implementation

{$R *.DFM}

uses
  FormManagerUnit,
  UNIDBDetailFormUnit,
  UNIDataManagerUnit,
  UNISYSDataManagerUnit,
  ASODefUnit,
  BOKDefUnit,
  FKDefUnit,
  {$ifdef build_all}
  BOKDataManagerUnit,
  {$else}
  BOKDataManagerExtUnit,
  {$endif} //build_all
  UNISysDefUnit,
  ZLEDefUnit,
  SQLManagerUnit,
  ZLEDataManagerUnit,
  ZleZlecenieUnit,
  ZLEPozycjeUnit,
  ZLEZlecenieDBDetailFormUnit,
  Dodatki;

{ TZLEPozycjeDBGridForm }
procedure TZLEPozycjeDBGridForm.GetParametersForForm(
  a_oForm:          TUNIForm;
  a_oParameters:    TKeyValues
);
begin
  if(Owner is TUNIForm) then begin
    (Owner as TUNIForm).GetParametersForForm(self, a_oParameters);
  end;

  if((Parameters <> nil) and (a_oForm = self)) then begin
      // odpytanie o parametry zakresu
    a_oParameters.Assign(Parameters);
  end else if(DataModule <> nil) then begin
    a_oParameters.Values[sZLEZLECENIE_ID]   := IntToStr(DMAQFbN(sZLEZLECENIE_ID).AsInteger);
    a_oParameters.Values[sZLEZLECENIEPOZ_ID]:= IntToStr(DMAQFbN(sZLEZLECENIEPOZ_ID).AsInteger);
    a_oParameters.Values[sZLETYPZLEC_ID]:= DMAQFbN(sZLETYPZLEC_ID).AsString;
  end;
end;


function TZLEPozycjeDBGridForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLEPozycjeDataModule.CreateOpen( Self, InheritedMasterKeyValues, AOpenMode ); 
end;

procedure TZLEPozycjeDBGridForm.Delete;
begin
  OpenDetail( omDelete );
end;

procedure TZLEPozycjeDBGridForm.InitializeControls;
begin
  //ustawienia kontrolek
  RightButtonPanel.Visible := FormIsContained and Owner.InheritsFrom(TUNIDBDetailForm);
  SprawyButton.Visible := (Parameters.Values[sUNIMODULZSI_ID] = IntToStr(cZLEModulZSI_ID))and
                          (DataManagers.Available(sBOKModulID));
end;

procedure TZLEPozycjeDBGridForm.InternalOpen;
begin
  InitializeControls();

  if Parameters.Values[cFORM_CAPTION] <> '' then begin
    Caption := Parameters.Values[cFORM_CAPTION];
  end;

  inherited;

  //ustawienie dostpnoci guzikw "dopisz,usu,zmie,poka"
  DataModule.ActiveQuery.AfterScroll := RefreshGridButtons;
  RefreshGridButtons(DataModule.ActiveQuery);
end;

procedure TZLEPozycjeDBGridForm.New;
begin
//  if(DataModule.ActiveQuery.IsEmpty()) then
    OpenDetail( omNew )
{
  else begin
    Komunikat(
      cWarning,
      'Zlecenie moe zawiera tylko jedn pozycj',
      MB_OK + MB_ICONEXCLAMATION
    );
  end;
}
end;

procedure TZLEPozycjeDBGridForm.Open;
begin
  OpenDetail( omEdit );
end;

procedure TZLEPozycjeDBGridForm.OdczytajZakladki();
var
  oParams:  TKeyValues;
  i:        integer;
begin
  oParams := TKeyValues.CreateEmpty();
  (Owner as TUNIForm).GetParametersForForm(self, oParams);
  i := oParams.IndexOf(sZLEParam_PolaUZGrid);
  if(i > -1) then begin
    m_oZakladkiPozGridy := (oParams.Objects[i] as TStringList);
    oParams.Objects[i]   := nil;
  end else  // if(i > -1)
    m_oZakladkiPozGridy := nil;
  oParams.Free();
end;

procedure TZLEPozycjeDBGridForm.OpenDetail(AOpenMode: TOpenMode);
var
  oParams: TKeyValues;
  b: TBookMark;
  iMaxLp: Integer;
  //q: TUNIQuery;
  //sAtrybuty, sWarunek, sDomena: String;
  oMode: TOpenMode;
begin
  OdczytajZakladki();
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add( cFORM_CAPTION+'='+'Pozycje zlecenia');
    Add( sZLEZLECENIE_ID+'='+Parameters.Values[sZLEZLECENIE_ID]);
    Add( sBOKSPRAWA_ID+'='+Parameters.Values[sBOKSPRAWA_ID]);

    if(m_oZakladkiPozGridy <> nil) then begin
      oParams.AddObject(
        sZLEParam_PolaUZGrid,
        m_oZakladkiPozGridy
      );
    end;  // if(m_oZakladkiPozGridy <> nil)

    if AOpenMode = omNew then begin
      iMaxLp := 0;
      TZLEPozycjeDataModule(DataModule).ActiveQuery.DisableControls;
      try
        b := TZLEPozycjeDataModule(DataModule).ActiveQuery.GetBookMark;
        TZLEPozycjeDataModule(DataModule).ActiveQuery.First;
        while not TZLEPozycjeDataModule(DataModule).ActiveQuery.EOF do begin
          iMaxLp := max(iMaxLp, TZLEPozycjeDataModule(DataModule).ActiveQuery.FieldByName(sZLEZLECENIEPOZ_LP).AsInteger);
          TZLEPozycjeDataModule(DataModule).ActiveQuery.Next;
        end;
        Add( sZLEZLECENIEPOZ_LP+'='+IntToStr(iMaxLp + 1));
        if b <> Nil then
          TZLEPozycjeDataModule(DataModule).ActiveQuery.GotoBookMark(b);
      finally
        TZLEPozycjeDataModule(DataModule).ActiveQuery.EnableControls;
      end;
    end;
  end;

  //na razie formatki detail modalne
  oMode := AOpenMode + omShowModal;
  if FormIsContained and (OpenModeFlags and omVirtual = omVirtual) then
    oMode := oMode + omOverVirtual;
  FormManager.OpenDBDetail( Self, cKlasaPozycje+cSuffixKlasyDBDetail, oMode,
                            oParams );
  if (AOpenMode = omDelete) then begin
    if ZLEDM.vZLEZleceniePoz_RenumeracjaLP then
      (DataModule as TZLEPozycjeDataModule).RefreshLp();
  end;


  (*****************************************************
  if ((AOpenMode = omNew) or (AOpenMode = omEdit)) and (not TVirtualDataSet(DataModule.ActiveQuery).IsEmpty) then begin
    TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.First;
    try
       (DataModule.ActiveQuery as TVirtualDataSet).DisableControls;
//       DataModule.ActiveQuery.VState := vsInternalInsert;
       (DataModule.ActiveQuery as TVirtualDataSet).VState := vsVirtualPost;
       (DataModule.ActiveQuery as TVirtualDataSet).Edit;
       while not TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.Eof do begin

       //    (DataModule.ActiveQuery as TVirtualDataSet).Locate(sZLEZLECENIEPOZ_ID, TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sZLEZLECENIEPOZ_ID).Value, []);
         if TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger = TZLEPozycjeDataModule(DataModule).ActiveQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger then begin
           {1. Mnemonik i TABELA = sFKUZ - pole sFKUZ_ID - z bazy - MNEM}
           if (TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sFKMNEMONIKI_ID).AsInteger <> 0) and
              (TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sFKMNEMONIKI_TABELA).AsString = sFKUZ) then begin
              if (DataModule.ActiveQuery as TVirtualDataSet).FindField('MNEM'+TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sZLEPOLAZMDEF_ID).AsString) <> nil then begin
                 if (TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sFKUZ_ID).AsString <> '') then begin;
                    sAtrybuty := sFKALIAS_SlUzytkownikaID + ';' + sFKALIAS_SlUzytkownikaSymbol;
                    sWarunek := '@' + sFKALIAS_SlUzytkownikaID + '=' + TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sFKUZ_ID).AsString;
                    q := UniSysDM.FKOdpytajODanePozycjiSlownikaUzytkownika(
                            IntToStr(TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sFKMNEMONIKI_ID).AsInteger) {sTabela},
                            sAtrybuty,
                            sWarunek,
                            False {bUnikalny},
                            UNISYSDM.vAktywnaFirma {iFirmaID}
                            );

                    try
                      if q <> Nil then begin
                        (DataModule.ActiveQuery as TVirtualDataSet).FieldByName('MNEM'+TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sZLEPOLAZMDEF_ID).AsString).Value := q.FieldByName(sFKUZ_SYMBOL).AsString;
                        (DataModule.ActiveQuery as TVirtualDataSet).ModifiedRecordsFlagsList.SetFieldIsNotModified((DataModule.ActiveQuery as TVirtualDataSet).FieldByName('MNEM'+TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sZLEPOLAZMDEF_ID).AsString));
                      end;
                    finally
                      FreeAndNil(q);
                    end;
                 end else begin
                      (DataModule.ActiveQuery as TVirtualDataSet).FieldByName('MNEM'+TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sZLEPOLAZMDEF_ID).AsString).Clear();
                      (DataModule.ActiveQuery as TVirtualDataSet).ModifiedRecordsFlagsList.SetFieldIsNotModified((DataModule.ActiveQuery as TVirtualDataSet).FieldByName('MNEM'+TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sZLEPOLAZMDEF_ID).AsString));
                 end;
              end;
           end else
           if TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sUNICONSTDEF_ID).AsInteger <> 0 then begin
              {2. Domena - DOM }
              if (DataModule.ActiveQuery as TVirtualDataSet).FindField('DOME'+TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sZLEPOLAZMDEF_ID).AsString) <> nil then begin
                 if TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sZLEPolaZM_DomenaWart_ID).AsString <> '' then begin
                    sDomena := TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sUNICONSTDEF_DOMENA).AsString;
                    q := SQLManager.CreateQuery('SELECT ' + sDomena + '_V' + ' ' +
                                             'FROM %s WHERE ' + sDomena + '_ID' + '=' + QuotedStr(TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sZLEPolaZM_DomenaWart_ID).AsString),
                                             [sDomena] );
                    try
                      q.Open;
                      if not q.IsEmpty then begin
                         (DataModule.ActiveQuery as TVirtualDataSet).FieldByName('DOME'+TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sZLEPOLAZMDEF_ID).AsString).Value := q.FieldByName(sDomena+'_V').AsString;
                         (DataModule.ActiveQuery as TVirtualDataSet).ModifiedRecordsFlagsList.SetFieldIsNotModified((DataModule.ActiveQuery as TVirtualDataSet).FieldByName('DOME'+TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sZLEPOLAZMDEF_ID).AsString));
                      end;
                      q.Close;
                    finally
                       FreeAndNil(q);
                    end;
                 end else begin
                         (DataModule.ActiveQuery as TVirtualDataSet).FieldByName('DOME'+TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sZLEPOLAZMDEF_ID).AsString).Clear();
                         (DataModule.ActiveQuery as TVirtualDataSet).ModifiedRecordsFlagsList.SetFieldIsNotModified((DataModule.ActiveQuery as TVirtualDataSet).FieldByName('DOME'+TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sZLEPOLAZMDEF_ID).AsString));
                 end;
              end;
           end else begin
              {Reszta - WART}
              if (DataModule.ActiveQuery as TVirtualDataSet).FindField('WART'+TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sZLEPOLAZMDEF_ID).AsString) <> nil then begin
                 (DataModule.ActiveQuery as TVirtualDataSet).FieldByName('WART'+TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sZLEPOLAZMDEF_ID).AsString).Value := TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sZLEPolaZM_Wart).Value;
                 (DataModule.ActiveQuery as TVirtualDataSet).ModifiedRecordsFlagsList.SetFieldIsNotModified((DataModule.ActiveQuery as TVirtualDataSet).FieldByName('WART'+TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.FieldByName(sZLEPOLAZMDEF_ID).AsString));
              end;
           end;
         end;

         TZleZlecenieDataModule(TZleZlecenieDBDetailForm(Owner).DataModule).aZleZleceniePoleZmDataSet.Next;
       end;

//       (DataModule.ActiveQuery as TVirtualDataSet).Post; {Edycja jednej pozycji}
       (DataModule.ActiveQuery as TVirtualDataSet).VirtualPost;
    finally
      (DataModule.ActiveQuery as TVirtualDataSet).VState := vsNormal;
      (DataModule.ActiveQuery as TVirtualDataSet).EnableControls;
    end;
  end;
  *****************************************************)


  {Odswieenie przyciskw}
  RefreshGridButtons(DataModule.ActiveQuery);

//  iPozycjaRozlID := DataModule.ActiveQuery.FieldByName(DataModule.Keys.GetPrimaryKey()).AsString;
//  ReOpenDataSets();
//  if (not DataModule.ActiveQuery.IsEmpty) and (iPozycjaRozlID <> '') then
//     DataModule.ActiveQuery.Locate( DataModule.Keys.GetPrimaryKey(), iPozycjaRozlID, [] );

end;

procedure TZLEPozycjeDBGridForm.View;
begin
  OpenDetail( omView );
end;

procedure TZLEPozycjeDBGridForm.DopiszButtonClick(Sender: TObject);
begin
  inherited;
  New();
end;

procedure TZLEPozycjeDBGridForm.UsunButtonClick(Sender: TObject);
begin
  inherited;
  Delete();
end;

procedure TZLEPozycjeDBGridForm.ZmienButtonClick(Sender: TObject);
begin
  inherited;
  Open();
end;

procedure TZLEPozycjeDBGridForm.PokazButtonClick(Sender: TObject);
begin
  inherited;
  View();
end;

procedure TZLEPozycjeDBGridForm.RefreshGridButtons;
begin
  DopiszButton.Enabled := NewMenuItem.Enabled;
  UsunButton.Enabled := DeleteMenuItem.Enabled;
  ZmienButton.Enabled := EditMenuItem.Enabled;
  PokazButton.Enabled := ViewMenuItem.Enabled;

  {Wyczenie Wszystkich menu przy obsudze sownika z pozycjami zlece}
  if Parameters.Values['ONLYREADONLY'] = 'T' then begin
     Switch_New_HotKey(False);
     Switch_Open_HotKey(False);
     Switch_View_HotKey(False);
     Switch_Delete_HotKey(False);
  end;
end;

procedure TZLEPozycjeDBGridForm.SprawyButtonClick(Sender: TObject);
var
  oQuery: TUNIQuery;
  sSprawy: String;
begin
  oQuery := BOKDM.PokazIObsluzDane( sBOKSPRAWA,
                                    sBOKAlias_Sprawa_ID,
                                    '', True, True, '' );
  try
    if oQuery <> nil then begin
      sSprawy := '';
      while not oQuery.Eof do begin
        if Length(sSprawy) > 0 then
          sSprawy := sSprawy + ',';
        sSprawy := sSprawy + oQuery.FieldByName(sBOKSPRAWA_ID).AsString;
        oQuery.Next;
      end;
      if (Owner is TZLEZlecenieDBDetailForm) then
        (Owner as TZLEZlecenieDBDetailForm).DopiszPozycjeDlaSprawy( sSprawy );
    end;
  finally
    oQuery.Free;
  end;
end;

initialization
  FormManager.RegisterForm( TZLEPozycjeDBGridForm, 'Lista pozycji zlece', sZLEModulID );

end.
