unit ZLEPozycjeUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-24 gdeyk    Utworzone
2005-12-29 Tomjen   Pola uzytkownika
2010-07-19 Tomjen   Przejscie na uniwersalne pola UZ
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, DbClient, UNIComponentsUnit, DBTables, UNIDBConstComboBoxUnit;

type
  TZLEPozycjeDataModule = class(TUNIDataModule)
    procedure DataModuleCreate(Sender: TObject);
  private
    iConditionZlecenieID: Integer;
    procedure SetMasterJoins();
    procedure SetFieldProp();
  protected
    (*********** Pola UZ ************
    //Jak wyzej ale dla pozycji zlecenia
    kvPolaUzPozWart:TConstStringList;
    kvPolaUzPozMnem:TConstStringList;
    kvPolaUzPozDom:TConstStringList;
    procedure WezPolaUzytkPoz();
    *********** Pola UZ ************)
    procedure GetKeys; override;
    function GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;

  public
    constructor Create( AOwner: TComponent); override;
    procedure ReOpenDataSets(); override;
    procedure RefreshLp();
    function NextLp(): Integer;
    procedure Open; override;
    procedure Post; override;
    procedure Delete; override;
  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  UNIFormUnit,
  FormManagerUnit,
  QueryBuilderUnit,
  SQLManagerUnit,
  UNIDataManagerUnit,
  UNISYSDataManagerUnit,
  UNIStaleUnit,
  ASODefUnit,
  ASODataManagerExtUnit,
  ZLEDataManagerUnit,
  BOKDefUnit,
  UNISysDefUnit,
  INFDefUnit,
  FKDefUnit,
  LFKDefUnit,
  MAGDefUnit,
  ZLEDefUnit,
  ZLEPozycjeDBDetailFormUnit;

{ TZLEPozycjeDataModule }

constructor TZLEPozycjeDataModule.Create(AOwner: TComponent);
begin
  inherited;
  iConditionZlecenieID := -1;
end;

procedure TZLEPozycjeDataModule.Delete;
var
  bTrans: Boolean;
  iZLEZLECENIEPOZ_ID: Integer;
  sIlosc: String;
begin
  bTrans := SQLManager.InTransaction;
  if not bTrans then SQLManager.StartTransaction;
  try
    iZLEZLECENIEPOZ_ID := DataSource.DataSet.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger;

    if iZLEZLECENIEPOZ_ID > 0 then begin
      if DataManagers.Available(sMAGModulID) then begin
         try
           sIlosc := SQLManager.OpenQueryWithResult('SELECT COUNT(*) FROM %s WHERE ' + sZLEZLECENIEPOZ_ID + '=' +
                                    IntToStr(iZLEZLECENIEPOZ_ID), [sMAGModulID + cMAGOBRPOZ_SUFFIX]);
         finally
            if StrToInt(sIlosc) > 0 then begin
               Komunikat(cError, 'Pozycja zlecenia zostaa wykorzystana w dokumencie magazynowym.'#13'Usunicie niemoliwe!');
               Abort;
            end;
         end;
      end;

       try
         sIlosc := SQLManager.OpenQueryWithResult('SELECT COUNT(*) FROM %s WHERE ' + sZLEZLECENIEPOZ_ID + '=' +
                                  IntToStr(iZLEZLECENIEPOZ_ID), [sZLEZASOBYPRACA]);
       finally
          if StrToInt(sIlosc) > 0 then begin
             Komunikat(cError, 'Pozycja zlecenia zostaa wykorzystana w RCP.'#13'Usunicie niemoliwe!');
             Abort;
          end;
       end;
    end;

    inherited;
    if not bTrans then SQLManager.Commit;
  except
    if not bTrans then SQLManager.Rollback;
  end;
end;

function TZLEPozycjeDataModule.NextLp: Integer;
begin
  result := ActiveQuery.RecordCount+1;
end;

procedure TZLEPozycjeDataModule.GetKeys;
begin
  with FKeys do begin
    AddPrimary(sZLEZLECENIEPOZ_ID);
  end;
end;

function TZLEPozycjeDataModule.GetTableName: string;
begin
  result := sZLEZLECENIEPOZ;
end;

procedure TZLEPozycjeDataModule.InitializeGridQueryDefs;
(*********** Pola UZ ************
var
    iLicznik1: Integer;//petle Pol Uzytkownika
    sInWhere: String;
*********** Pola UZ ************)
begin
  (*********** Pola UZ ************
  if kvPolaUzPozWart = nil then
     kvPolaUzPozWart:=TConstStringList.Create();

  if kvPolaUzPozMnem = nil then
     kvPolaUzPozMnem:=TConstStringList.Create();

  if kvPolaUzPozDom = nil then
     kvPolaUzPozDom:=TConstStringList.Create();

  WezPolaUzytkPoz();
  *********** Pola UZ ************)

{ TODO -ogdeyk -czlecenia : Konicznie uzupeni o wywietlanie poziomu INF i wybranego elementu }
  if GridColDefs.Count = 0 then with GridColDefs do begin
    AddRequiredAndUnvisible( sZLEZLECENIEPOZ_ID, 'M', '' );
    AddRequiredAndUnvisible( sZLEZLECENIE_ID, 'M', '' );
    AddRequiredAndUnvisible( sZLETYPZLEC_ID, 'Z', '' );

    AddRequired( sZLEZLECENIEPOZ_LP, 'M', 'Lp', True, taRightJustify, 50 );
    AddRequiredAndUnvisible( sLFKWZORDEKR_ID, 'M', '' );
    if DataManagers.Available(sLFKModulID) then
       Add( sLFKWZORDEKR_NR_DEKR, 'L', 'Wzr dekretacji', False, True, taLeftJustify, 120 );
    AddRequiredAndUnvisible( sASOASORT_ID, 'M', '' );
    if DataManagers.Available(sASOModulID) then begin
      Add( sASOASORT_INDEKS, 'A', 'Indeks asortymentu', True, True, taLeftJustify, 200 );
      AddRequired( sASOASORT_SYMBOL, 'A', 'Symbol asortymentu', True, taLeftJustify, 100 );
      AddRequired( sASOASORT_NAZWA, 'A', 'Nazwa asortymentu', True, taLeftJustify, 200 );
    end;
    Add( sZLEZLECENIEPOZ_ILOSC, 'M', 'Ilosc', True, true, taRightJustify, 100, uftNumber);
    Add( sZLEZLECENIEPOZ_WARTOSC, 'M', 'Wartosc', True, true, taRightJustify, 100, uftNumber);
    Add( sZLEZLECENIEPOZ_CENA, 'M', 'Cena', False, true, taRightJustify, 100, uftNumber);
    Add( sZLEZLECENIEPOZ_DATA, 'M', 'Data pozycji', True, true, taRightJustify, 80, uftDate);
    AddRequired( sZLEZLECENIEPOZ_OPIS, 'M', 'Opis', True, taLeftJustify, 250 );
    if DataManagers.Available(sBOKModulID) then begin
      AddRequiredAndUnvisible( sBOKSPRAWA_ID, 'M', '' );
      Add( sBOKSPRAWA_NUMER, 'B', 'Numer zgoszenia', True, True, taLeftJustify, 100 );
      Add( sBOKSPRAWA_OBIEKTOPIS, 'B', 'Opis obiektu', False, True, taLeftJustify, 100 );
      Add( sBOKSPRAWA_NAZWA, 'B', 'Nazwa sprawy', False, True, taLeftJustify, 100 );
      Add( sBOKSPRAWA_PROBLEM, 'B', 'Problem sprawy', False, True, taLeftJustify, 100 );
      Add( sBOKSPRAWA_DATA_UMOW, 'B', 'Data umwienia', False, True, taLeftJustify, 100 );
      Add( sBOKSPRAWA_UMOWIONE, 'B', 'Umwione', False, True, taLeftJustify, 100 );

      if DataManagers.Available(sINFModulID) then begin
         Add( 'CAST('+SQLManager.GetSPName(sINF_DAJSYMBOLOBIEKTU)+'(B.'+sBOKSPRAWA_OBIEKTJAKI+',B.'+sBOKSPRAWA_OBIEKTID+',' +QuotedStr('SYMBOL')+') AS VARCHAR2(100));OBIEKT_SYMBOL',
              '', 'Obiekt - symbol', False, True, taLeftJustify, 80, uftClob );
         Add( 'CAST('+SQLManager.GetSPName(sINF_DAJSYMBOLOBIEKTU)+'(B.'+sBOKSPRAWA_OBIEKTJAKI+',B.'+sBOKSPRAWA_OBIEKTID+',' + QuotedStr('NAZWA')+') AS VARCHAR2(250));OBIEKT_NAZWA',
              '', 'Obiekt - nazwa', False, True, taLeftJustify, 100, uftClob );
      end;
    end;
    AddRequiredAndUnvisible( sZLEZLECENIEPOZ_POZIOMINF, 'M', '' );
    AddRequiredAndUnvisible( sZLEZLECENIEPOZ_INF_ID, 'M', '' );
    if DataManagers.Available(sINFModulID) then begin
       Add( 'CAST('+SQLManager.GetSPName(sINF_DAJSYMBOLOBIEKTU)+'(M.'+sZLEZLECENIEPOZ_POZIOMINF+',M.'+sZLEZLECENIEPOZ_INF_ID+',' +QuotedStr('SYMBOL')+') AS VARCHAR2(100));INF_SYMBOL',
            '', 'INF - symbol', False, True, taLeftJustify, 80, uftClob );
       Add( 'CAST('+SQLManager.GetSPName(sINF_DAJSYMBOLOBIEKTU)+'(M.'+sZLEZLECENIEPOZ_POZIOMINF+',M.'+sZLEZLECENIEPOZ_INF_ID+',' + QuotedStr('NAZWA')+') AS VARCHAR2(250));INF_NAZWA',
            '', 'INF - nazwa', False, True, taLeftJustify, 100, uftClob );
    end;

   (*********** Pola UZ ************
    // pola uzytkownika - z zapytania
    for iLicznik1 := 0 to kvPolaUzPozWart.Count-1 do //Wartosci
      Add(sZLEPOLAZM_WART+';WART'+kvPolaUzPozWart.ZwrocSkrot(iLicznik1), 'TWART'+kvPolaUzPozWart.ZwrocSkrot(iLicznik1),
              kvPolaUzPozWart[iLicznik1],false,true,taRightJustify,80,uftString);

    for iLicznik1 := 0 to kvPolaUzPozMnem.Count-1 do begin//Mnemoniki
      Add('CAST ('+SQLManager.GetSpName(sFK_SP_FKDAJ_SYMBOL_MNEMONIKA)+ '(' +
        'NVL(' + 'TMNEM' + kvPolaUzPozMnem.ZwrocSkrot(iLicznik1)+ '.' + sFKMNEMONIKI_ID + ',0),' +
        'NVL(' + 'TMNEM' + kvPolaUzPozMnem.ZwrocSkrot(iLicznik1)+ '.' + sFKUZ_ID + ', 0)' +
        ') AS VARCHAR2(30));MNEM'+kvPolaUzPozMnem.ZwrocSkrot(iLicznik1), '',
              kvPolaUzPozMnem[iLicznik1],false,true,taRightJustify,80,uftClob);
      //ponizsza linia jest potrzebna zeby nie usunac tabeli
      AddRequiredAndUnvisible( sFKMNEMONIKI_ID, 'TMNEM' + kvPolaUzPozMnem.ZwrocSkrot(iLicznik1), '' );
    end;

    for iLicznik1 := 0 to kvPolaUzPozDom.Count-1 do begin//Domeny
      Add('CAST ('+SQLManager.GetSpName(sFK_SP_FKDAJ_SYMBOL_DOMENY)+'('+
                  'TDOME'+kvPolaUzPozDom.ZwrocSkrot(iLicznik1)+'.'+sUNICONSTDEF_ID+
                  ', TDOME'+kvPolaUzPozDom.ZwrocSkrot(iLicznik1)+'.'+sZLEPOLAZM_DOMENAWART_ID+
                  ') AS VARCHAR2(30));DOME'+kvPolaUzPozDom.ZwrocSkrot(iLicznik1), '',
              kvPolaUzPozDom[iLicznik1],false,true,taRightJustify,80,uftClob);
      //ponizsza linia jest potrzebna zeby nie usunac tabeli
      AddRequiredAndUnvisible( sZLEPOLAZM_DOMENAWART_ID, 'TDOME' + kvPolaUzPozDom.ZwrocSkrot(iLicznik1), '' );
    end;
    *********** Pola UZ ************)
  end;

  if GridTabDefs.Count = 0 then with GridTabDefs do begin
    Add( 'M', TableName );
    if DataManagers.Available(sASOModulID) then
      Add( 'A', sASOASORT );
    Add( 'L', sLFKWZORDEKR );
    Add( 'Z', sZLEZLECENIE );
    if DataManagers.Available(sBOKModulID) then
      Add( 'B', sBOKSPRAWA );

   (*********** Pola UZ ************
    // Pola uzytkownika
    for iLicznik1 := 0 to kvPolaUzPozWart.Count-1 do begin //Wartosci
        sInWhere := '( SELECT '+sZLEPOLAZM_WART+','+sZLEPOLAZMDEF_ID+','+sZLEZLECENIEPOZ_ID
        +' FROM '+SqlManager.GetTableName(sZLEPOLAZM)
        +' WHERE '+sZLEPOLAZMDEF_ID+'='+QuotedStr(kvPolaUzPozWart.ZwrocSkrot(iLicznik1))+')';
        Add('TWART'+kvPolaUzPozWart.ZwrocSkrot(iLicznik1), sInWhere, '', False);
    end;
    for iLicznik1 := 0 to kvPolaUzPozMnem.Count-1 do begin //Mnemoniki
        sInWhere := '( SELECT '+sFKMNEMONIKI_ID+','+sFKUZ_ID+',DEF.'+sZLEPOLAZMDEF_ID+','+sZLEZLECENIEPOZ_ID
        +' FROM '+SqlManager.GetTableName(sZLEPOLAZM)+' ZM, '
        +SqlManager.GetTableName(sZLEPOLAZMDEF)+' DEF'
        +' WHERE DEF.'+sZLEPOLAZMDEF_ID+'='+QuotedStr(kvPolaUzPozMnem.ZwrocSkrot(iLicznik1))
        +' AND DEF.'+sZLEPOLAZMDEF_ID+'=ZM.'+sZLEPOLAZMDEF_ID+')';
        Add('TMNEM'+kvPolaUzPozMnem.ZwrocSkrot(iLicznik1), sInWhere, '', False);
    end;
    for iLicznik1 := 0 to kvPolaUzPozDom.Count-1 do begin //Domeny
        sInWhere := '(SELECT DEF.'+sUNICONSTDEF_ID+','+sZLEPOLAZM_DOMENAWART_ID+',DEF.'+sZLEPOLAZMDEF_ID+','+sZLEZLECENIEPOZ_ID
        +' FROM '+SqlManager.GetTableName(sZLEPOLAZM)+' ZM, '
        +SqlManager.GetTableName(sZLEPOLAZMDEF)+' DEF'
        +' WHERE DEF.'+sZLEPOLAZMDEF_ID+'='+QuotedStr(kvPolaUzPozDom.ZwrocSkrot(iLicznik1))
        +' AND DEF.'+sZLEPOLAZMDEF_ID+'=ZM.'+sZLEPOLAZMDEF_ID+')';
        Add('TDOME'+kvPolaUzPozDom.ZwrocSkrot(iLicznik1), sInWhere, '', False);
    end;
    *********** Pola UZ ************)

  end;
  if GridJoinDefs.Count = 0 then with GridJoinDefs do begin
    if DataManagers.Available(sASOModulID) then
       AddSimple( 'M', 'A', 'M.'+sASOASORT_ID+'=A.'+sASOASORT_ID, qjkLeftOuter {Tu byo qjkInner}, True );
    if DataManagers.Available(sLFKModulID) then
       AddSimple( 'M', 'L', 'M.'+sLFKWZORDEKR_ID+'=L.'+sLFKWZORDEKR_ID, qjkLeftOuter, True );
    AddExpres('M.'+sZLEZLECENIE_ID+'='+'Z.'+sZLEZLECENIE_ID, qjkInner, True);

    if DataManagers.Available(sBOKModulID) then
      AddSimple( 'M', 'B', 'M.'+sBOKSPRAWA_ID+'=B.'+sBOKSPRAWA_ID, qjkLeftOuter, True );

    (*********** Pola UZ ************
    // Pola uzytkownika
    for iLicznik1 := 0 to kvPolaUzPozWart.Count-1 do //Wartosci
      AddExpres('M.'+sZLEZLECENIEPOZ_ID+'='+'TWART'+kvPolaUzPozWart.ZwrocSkrot(iLicznik1)+'.'+sZLEZLECENIEPOZ_ID, qjkLeftOuter, false);
    for iLicznik1 := 0 to kvPolaUzPozMnem.Count-1 do //Mnemoniki
      AddExpres('M.'+sZLEZLECENIEPOZ_ID+'='+'TMNEM'+kvPolaUzPozMnem.ZwrocSkrot(iLicznik1)+'.'+sZLEZLECENIEPOZ_ID, qjkLeftOuter, false);
    for iLicznik1 := 0 to kvPolaUzPozDom.Count-1 do //Domeny
      AddExpres('M.'+sZLEZLECENIEPOZ_ID+'='+'TDOME'+kvPolaUzPozDom.ZwrocSkrot(iLicznik1)+'.'+sZLEZLECENIEPOZ_ID, qjkLeftOuter, false);
    *********** Pola UZ ************)
  end;

  UNISysDM.UNISysDodajPolaUzDoGrida(GridColDefs,
                                    GridTabDefs,
                                    GridJoinDefs,
                                    cPolaUZ_ZLEPozycja,
                                    'M.' + sZLEZLECENIE_ID,
                                    '',
                                    'M.' + sZLEZLECENIEPOZ_ID
                                    );
  SetMasterJoins();
  inherited;
end;

procedure TZLEPozycjeDataModule.Open;
begin
  inherited;
  SetFieldProp();
end;

procedure TZLEPozycjeDataModule.Post;
var bTrans: Boolean;
    i: Integer;
begin
  bTrans := SQLManager.InTransaction;
  if not bTrans then SQLManager.StartTransaction;
  try
(*******************POLA UZ***************************
    if Owner is TZLEPozycjeDBDetailForm then begin
       idx := TZLEPozycjeDBDetailForm(Owner).PolaUzPozFormIndex;
       if ContainedDataModules[idx] <> nil then
         try
           ContainedDataModules[idx].Post;
         except
         end;
    end;
*******************POLA UZ***************************)

    inherited;
    for i := 0 to (Owner as TUNIForm).ContainedFormCount - 1 do
      ContainedDataModules[i].Post();

    if not bTrans then SQLManager.Commit;
  except
    on EDMException do begin
      if not bTrans then SQLManager.Rollback;
      if FLastDBError.SQLObjectName=sZLEZLECENIEPOZ+c_UNK then begin
        Komunikat( cError,'Pozycje nie mog si powtarza!');
        abort;
      end else if Pos( sASOASORT_ID, FLastDBError.OrgMess ) > 0 then begin
        Komunikat( cError,'Prosz uzupeni asortyment w pozycjach!');
        abort;
      end else raise;
    end else begin
      if not bTrans then SQLManager.Rollback;
      raise;
    end;
  end;
end;

procedure TZLEPozycjeDataModule.RefreshLp;
var
  iLp: Integer;
  oDataSet: TClientDataSet;
begin
  {Sprawdzenie parametru ..czy re-numerowac pozycje zlecenia}
//  if (not ZLEDM.vZLEZleceniePoz_RenumeracjaLP) then Exit;

  oDataSet := nil;
  iLp := 1;
  try
    oDataSet := TClientDataSet.Create(nil);
    oDataSet.CloneCursor( ActiveQuery as TVirtualDataSet, False );
    oDataSet.IndexFieldNames := sZLEZLECENIEPOZ_ID;
    oDataSet.First;
    while not oDataSet.Eof do begin
      (ActiveQuery as TVirtualDataSet).GotoCurrent(oDataSet);
      //ActiveQuery.Locate(sZLEZLECENIEPOZ_ID,oDataSet.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger, [] );
      (ActiveQuery as TVirtualDataSet).VState := vsVirtualPost;
      try
        (ActiveQuery as TVirtualDataSet).Edit;
        (ActiveQuery as TVirtualDataSet).FieldByName(sZLEZLECENIEPOZ_LP).AsInteger := iLp;
        (ActiveQuery as TVirtualDataSet).Post;
      finally
        (ActiveQuery as TVirtualDataSet).VState := vsNormal;
      end;
      Inc(iLp);
      oDataSet.Next;
    end;
  finally
    oDataSet.Free;
  end;
end;

procedure TZLEPozycjeDataModule.ReOpenDataSets;
var iPozycjaID: String;
begin
  iPozycjaID := ActiveQuery.FieldByName(Keys.GetPrimaryKey()).AsString;
  SetMasterJoins();
  inherited;
  SetFieldProp();
  if (not ActiveQuery.IsEmpty)and(iPozycjaID <> '') then
    ActiveQuery.Locate( Keys.GetPrimaryKey(), iPozycjaID, [] );
end;

procedure TZLEPozycjeDataModule.SetFieldProp;
begin
  if ActiveQuery.FindField(sASOASORT_INDEKS) <> nil then
    //ustalenie formatu indeksu w gridzie
    ActiveQuery.FieldByName(sASOASORT_INDEKS).EditMask := ASODM.vAsoMaskaIndeksu+';0;_';
end;

procedure TZLEPozycjeDataModule.SetMasterJoins;
begin
  //ustawienie warunku typu master-detail
  if (iConditionZlecenieID = -1)or(iConditionZlecenieID > GridJoinDefs.Count-1) then
    iConditionZlecenieID := GridJoinDefs.AddEmptyCondition();

  with Owner as TUNIForm, GridJoinDefs do begin
    if Parameters.Values[sZLEZLECENIE_ID] <> '' then
      ExchangeCondition( iConditionZlecenieID,
                                      'M.'+sZLEZLECENIE_ID+'='+Parameters.Values[sZLEZLECENIE_ID],
                                      True )
    else
      ExchangeCondition( iConditionZlecenieID, '1=1', True );
  end;
end;

procedure TZLEPozycjeDataModule.DataModuleCreate(Sender: TObject);
begin
  inherited;
//  Parameters := TKeyValues.CreateEmpty;
end;

initialization
  FormManager.RegisterForm( TZLEPozycjeDataModule,
                            'Modu danych dla pozycji zlece', sZLEModulID );
end.
