unit ZLEPrefixDBGridFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls,UNIStaleUnit,UNIDataModuleUnit;

const
  ClassDetailName = 'TZLEPrefixDBDetailForm';

type
  TZLEPrefixDBGridForm = class(TUNIDBGridForm)
  protected
    function  CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure View; override;
    procedure Open; override;
    procedure New; override;
    procedure Delete; override;
    procedure InternalOpen; override;
    //procedure GetPositionAndParentForContainedForm( const nr:integer ; var APosition: TRect ; var AParent: TWinControl ; var AAlign:TAlign); override;
    procedure SetUserRights; override;
  end;

var
  ZLEPrefixDBGridForm: TZLEPrefixDBGridForm;

implementation
uses
  FormManagerUnit,
  KeyManagerUnit,
  SecurityManagerUnit,
  UNIDataManagerUnit,
  UNISYSDefUnit,
  ZLEDefUnit,
  ZLEPrefixUnit;

{$R *.DFM}

{ TZLEPrefixDBGridForm }

function TZLEPrefixDBGridForm.CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule;
begin
  Result := TZLEPrefixDataModule.CreateOpen( self, DefaultMasterKeyValues, AOpenMode);
end;

procedure TZLEPrefixDBGridForm.Delete;
begin
  FormManager.OpenDBDetail( self, ClassDetailName, omDelete);
end;

procedure TZLEPrefixDBGridForm.InternalOpen;
begin
  inherited; {---}
end;

procedure TZLEPrefixDBGridForm.New;
var
  oParams: TKeyValues;
begin
  oParams := TKeyValues.CreateEmpty();
  //oParams.Add(sUNIMODULZSI_ID+'='+Parameters.Values[sUNIMODULZSI_ID]);
  FormManager.OpenDBDetail( self, ClassDetailName, omNew, oParams );
end;

procedure TZLEPrefixDBGridForm.Open;
begin
  FormManager.OpenDBDetail( self, ClassDetailName, omEdit);
end;

procedure TZLEPrefixDBGridForm.SetUserRights;
begin
  with SecurityManager do begin
    Switch_View_HotKey(SM_UserCanDo(sZLE_USTAW_SLOW_PREFIX_POKAZ));
    Switch_New_HotKey(SM_UserCanDo(sZLE_USTAW_SLOW_PREFIX_DOPISZ));
    Switch_Open_HotKey(SM_UserCanDo(sZLE_USTAW_SLOW_PREFIX_ZMIEN));
    Switch_Delete_HotKey(SM_UserCanDo(sZLE_USTAW_SLOW_PREFIX_USUN));
  end;
end;

procedure TZLEPrefixDBGridForm.View;
begin
  FormManager.OpenDBDetail( self, ClassDetailName, omView);
end;

initialization
  FormManager.RegisterForm(TZLEPrefixDBGridForm, sZLEModulID);
end.
