unit ZLEPrefixUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who       What
---------------------------------------------------------------------------------------------
2008-06-12 Tomjen    Utworzone
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLEPrefixDataModule = class(TUNIDataModule)
  private
    //idxModul: Integer;
//    procedure SetParams();
  protected
    procedure GetKeys; override;
    function  GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;
  public
    procedure Post; override;
  end;


implementation

uses
  Dodatki,
  SQLManagerUnit,
  UNIStaleUnit,
  UNIDBGridFormUnit,
  UNISysDefUnit,
  FKDefUnit,
  UNISysDataManagerUnit,
  ZLEDefUnit,
  ZLEPrefixDBDetailFormUnit;

{$R *.DFM}

{ TZLEPrefixDataModule }

procedure TZLEPrefixDataModule.GetKeys;
begin
  FKeys.AddPrimary(sZLEPrefix_ID);
end;

function TZLEPrefixDataModule.GetTableName: string;
begin
  Result:=sZLEPrefix;
end;

procedure TZLEPrefixDataModule.InitializeGridQueryDefs;
begin
  //idxModul := -1;
  if GridColDefs.Count = 0 then with GridColDefs do begin
    AddRequired(sZLEPrefix_ID,   'P','', False, taLeftJustify,0);
    Add(sZLEPrefix_Symbol,       'P','Symbol',True,True, taLeftJustify,50);
    Add(sZLEPrefix_Nazwa,        'P','Nazwa',True,True,  taLeftJustify,100);
    if UNISysDM.DajDlugoscMnemonikaDlaSymbolu( sMnemonikZLEPrefix, 1 ) > 0 then
      Add(sZLEPrefix_Pole1,        'P','Pole 1',False,True,  taLeftJustify,60);
    if UNISysDM.DajDlugoscMnemonikaDlaSymbolu( sMnemonikZLEPrefix, 2 ) > 0 then
      Add(sZLEPrefix_Pole2,        'P','Pole 2',False,True,  taLeftJustify,60);
    if UNISysDM.DajDlugoscMnemonikaDlaSymbolu( sMnemonikZLEPrefix, 3 ) > 0 then
      Add(sZLEPrefix_Pole3,        'P','Pole 3',False,True,  taLeftJustify,60);
  end;
  if GridTabDefs.Count=0 then with GridTabDefs do begin
    Clear;
    Add('P',GetTableName);
  end;
  with GridJoinDefs do begin
    Clear;
  end;
  //SetParams();
  inherited;
end;

procedure TZLEPrefixDataModule.Post;
var
  bTrans: Boolean;
begin
  bTrans := not SQLManager.InTransaction;
  try
    if bTrans then SQLManager.StartTransaction;
    inherited;
    if bTrans then SQLManager.Commit;
  except
    on EDMException do begin
      if bTrans then SQLManager.Rollback;
      if FLastDBError.SQLObjectName=sZLEPrefix+c_UNK then begin
        Komunikat( cError,'Istnieje ju wpis o takim symbolu');
        with owner as TZLEPrefixDBDetailForm do ActiveControl:= SymbolDBEdit;
        Abort;
      end else raise;
    end else begin
      if bTrans then SQLManager.Rollback;
      raise;
    end;
  end;
end;

(*
procedure TZLEPrefixDataModule.SetParams;
begin
  {if (Owner is TUNIDBGridForm)and
     ((Owner as TUNIDBGridForm).Parameters <> nil) then begin
    if idxModul = -1 then
      idxModul := GridJoinDefs.AddCondition( 'P.'+sUNIMODULZSI_ID+'='+(Owner as TUNIDBGridForm).Parameters.Values[sUNIMODULZSI_ID], True)
    else
      GridJoinDefs.ExchangeCondition( idxModul, 'P.'+sUNIMODULZSI_ID+'='+(Owner as TUNIDBGridForm).Parameters.Values[sUNIMODULZSI_ID], True );
  end;}
end;
*)

end.
