unit ZLERaportEditUnit;
{
 Copyright Unisoft Sp. z o.o.

Modu dostarczajcy aktualizacje bazy.
Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2010-09-08 Tomjen   Utworzone
---------------------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLERaportEditDataModule = class(TUNIDataModule)
  protected
    procedure GetKeys; override;
    function  GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;
  public
    procedure Post; override;
  end;

var
  ZLERaportEditDataModule: TZLERaportEditDataModule;

implementation

{$R *.DFM}

uses
  ZLEDefUnit,
  SQLManagerUnit,
  UNIStaleUnit,
  Dodatki,
  UNISysDefUnit,
  SystemDefUnit,
  QueryBuilderUnit,
  KeyManagerUnit,
  UNIFormUnit;

procedure TZLERaportEditDataModule.GetKeys;
begin
  with FKeys do begin
    Clear;
    AddPrimary(sZLERaportEdit_ID);
  end;
end;

function TZLERaportEditDataModule.GetTableName: string;
begin
  Result:=sZLERaportEdit;
end;

procedure TZLERaportEditDataModule.Post;
  var
    trans:boolean;
begin
  trans:= not SQLManager.InTransaction;
  if trans then SQLManager.StartTransaction;
  try
    inherited;
    if trans then SQLManager.Commit;
  except
    if trans then SQLManager.Rollback;
    raise;
  end;
end;

procedure TZLERaportEditDataModule.InitializeGridQueryDefs;
begin
  with GridColDefs do begin
    Clear;
    AddRequiredAndUnvisible(sZLERaportEdit_ID, 'K', '');
    AddRequiredAndUnvisible(sUNIRep_ID, 'K', '');
    Add(sZLERaportedit_Komunikat, 'K','Komunikat',True,True, taRightJustify,200);
    Add(sUNIREP_NAME,    'R','Nazwa raportu',True,True,  taLeftJustify,150);
  end;

  with GridTabDefs do begin
    Clear;
    Add('K',GetTableName);
    Add('R',sUNIREP);
  end;

  with GridJoinDefs do begin
    Clear;
    AddSimple( 'K', 'R', 'K.' + sUNIREP_ID +'= R.' + sUNIREP_ID, qjkInner, True);
  end;

  inherited;
end;

end.
