unit ZLESkladnikKontroliDBDetailFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-18 gdeyk    Utworzone
}
{$I ..\!\defines.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBDetailFormUnit, Menus, UNIComponentsUnit, Db, ToolWin, ComCtrls,
  StdCtrls, ExtCtrls, Mask, DBCtrls, UNISimpleEditorUnit, ZLEParserUnit;

type
  TZLESkladnikKontroliDBDetailForm = class(TUNIDBDetailForm)
    DaneSkladnikaPanel: TUNIPanel;
    SymbolSkladnikaLabel: TUNILabel;
    NazwaSkladnikaLabel: TUNILabel;
    RodzajSkladnikaDBRadioGroup: TUNIDBRadioGroup;
    SymbolSkladnikaDBEdit: TUNIDBEdit;
    NazwaSkladnikaDBEdit: TUNIDBEdit;
    RegulaPanel: TUNIPanel;
    RegulaGroupBox: TUNIGroupBox;
    CheckButton: TUNIButton;
    RichEditPanel: TUNIPanel;
    procedure RodzajSkladnikaDBRadioGroupChange(Sender: TObject);
    procedure CheckButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
  private
    RegulaSimpleEditorRichEdit: TUNISimpleEditorRichEdit;
    FParser:         TZLEParser;
    FFunctionList:  TUNIStringList;
    FParamValuesList: TUNIStringList;
    FParamKindList: TUniStringList; //lista rodzajw parametrw funkcji,
                                    //schemat <nazwa_parametru>=<rodzaj_parametru>
                                    //e.g. KONTOOD=KONTOFK
    procedure EnableRegula();
    function CheckRegula( bBezKomentarzy: Boolean = false): Boolean;
    procedure GetLastWord(var sText, sFirstWord: String);
    function GetMnemonikValuesList( sText: String ): TUNIQuery;
    function GetList( sFunctionName, sKind, sText: String;
                      const cSeparator: Char): TUNIStringList;
    procedure CreateFunctionList;
    procedure CreateParamKindList;
    function  GetFunctionsList(const oCurrFunction: TUNIFunction;
                               var   sWholeCurrParam: string;
                               var   sCurrWord: string;
                               const sPrevWord: string;
                               const cSeparator: char;
                               var   sWordToInsert: string;
                               bShowList: boolean): TUNIStringList;
    procedure GetAdditionalHint(const oCurrFunction: TUNIFunction;
                                const sWholeCurrParam: string;
                                var sAdditionalHint: string);
    procedure SetKontrolaWartosciowa(const Value: Boolean);
  protected
    FTableName: String;
    FKontrolaWartosciowa: Boolean;
    procedure InitializeControls(); virtual;
    procedure InitializeObjectFields(); virtual;
    procedure SetDefaults(); virtual;
    procedure InternalOpen; override;
    property KontrolaWartosciowa: Boolean read FKontrolaWartosciowa write SetKontrolaWartosciowa;
  public
    destructor Destroy; override;
    function Validate(): Boolean; override;
    procedure SelectButtonPressed; override;
    property TableName: String read FTableName;
  end;

implementation

{$R *.DFM}

uses
  variants,
  Dodatki,
  SQLManagerUnit,
  UNIStaleUnit,
  UNIDataManagerUnit,
  BKDefUnit,
  BKDataManagerUnit,
  FKDefUnit,
  FKDataManagerUnit,
  MFSDefUnit,
  MFSDataManagerUnit,
  MFZDefUnit,
  MFZDataManagerUnit,
  ASODefUnit,
  ASODataManagerExtUnit,
  MAGDefUnit,
  MAGDataManagerExtUnit,
  UNISysDefUnit,
  UNISysDataManagerUnit,
  VATDefUnit,
  PLLIDefUnit,
  ZLEDefUnit,
  STDefUnit,
  TSDefUnit,
  ZLEDataManagerUnit;

{ TZLESkladnikKontroliDBDetailForm }

procedure TZLESkladnikKontroliDBDetailForm.InitializeControls;
var iIndex: Integer;
begin
  //podpicie pl do kontrolek
  SymbolSkladnikaDBEdit.DataField := TableName+cSuffixPola_Symbol;
  NazwaSkladnikaDBEdit.DataField := TableName+cSuffixPola_Nazwa;
  RodzajSkladnikaDBRadioGroup.DataField := TableName+cSuffixPola_Rodzaj;
  //RegulaDBMemo.DataField := TableName+cSuffixPola_Regula;
  
  //wczytanie rodzaji skadnikw
  for iIndex := 0 to cslZLERodzajSklad.Count-1 do begin
    RodzajSkladnikaDBRadioGroup.Items.Add( cslZLERodzajSklad.Strings[iIndex] );
    RodzajSkladnikaDBRadioGroup.Values.Add( cslZLERodzajSklad.ZwrocSkrot(iIndex) );
  end;

end;

procedure TZLESkladnikKontroliDBDetailForm.InternalOpen;
var oSplit: TSplit;
    iIndex: Integer;
begin
  KontrolaWartosciowa := TableName  = sZLESKLADWART;
  
  InitializeControls();
  InitializeObjectFields();

  if Parameters.Values[cFORM_CAPTION] <> '' then begin
    Caption := Parameters.Values[cFORM_CAPTION];
  end;

  inherited;

  //ustawienie wartoi domylnych
  if OpenMode = omNew then SetDefaults();

  //wczytanie reguy z pola
  RegulaSimpleEditorRichEdit.Lines.Clear;
  //nie korzystamy z RegulaSimpleEditorRichEdit.Lines.Text, poniewa
  //przy zastosowaniu tej metody wystpuj wycieki pamici (Delphi bug) 
  oSplit := nil;
  try
    oSplit := TSplit.Create( StringReplace( Trim(DMAQFbN(TableName+cSuffixPola_Regula).AsString),
                                            #10,'',[rfReplaceAll] ), #13, '' );
    for iIndex := 0 to oSplit.Count-1 do begin
      RegulaSimpleEditorRichEdit.Lines.Add(oSplit[iIndex]);
    end;
  finally
    if oSplit <> nil then oSplit.Free;
  end;
end;

procedure TZLESkladnikKontroliDBDetailForm.SetDefaults;
begin
  DMAQFbN( TableName+cSuffixPola_Rodzaj ).AsString :=
           ZLEDM.DajDefaultPola( TableName, TableName+cSuffixPola_Rodzaj );
  DMAQFbN( TableName+cSuffixPola_Regula ).AsString := 'result := ';
end;

function TZLESkladnikKontroliDBDetailForm.Validate: Boolean;
begin
  result := inherited Validate();
  if (DMAQFbN(TableName+cSuffixPola_Rodzaj).AsString = cZLERodzajSklad_RegulaID) then begin
     if (DMAQFbN(TableName+cSuffixPola_Regula).IsNull)or(not CheckRegula(true)) then begin
      result := false;
      exit;
     end;
  end;
end;

procedure TZLESkladnikKontroliDBDetailForm.RodzajSkladnikaDBRadioGroupChange(
  Sender: TObject);
begin
  inherited;
  EnableRegula();
end;

procedure TZLESkladnikKontroliDBDetailForm.EnableRegula;
var bCzyRegula: Boolean;
begin
  if RodzajSkladnikaDBRadioGroup.ItemIndex = -1 then Exit; 
  with RodzajSkladnikaDBRadioGroup do
    bCzyRegula := Values[ItemIndex]  = cZLERodzajSklad_RegulaID;

  RegulaSimpleEditorRichEdit.Enabled := bCzyRegula;
  CheckButton.Enabled := bCzyRegula;
end;

procedure TZLESkladnikKontroliDBDetailForm.GetAdditionalHint(
  const oCurrFunction: TUNIFunction; const sWholeCurrParam: string;
  var sAdditionalHint: string);
begin

end;

function TZLESkladnikKontroliDBDetailForm.GetFunctionsList(
  const oCurrFunction: TUNIFunction; var sWholeCurrParam,
  sCurrWord: string; const sPrevWord: string; const cSeparator: char;
  var sWordToInsert: string; bShowList: boolean): TUNIStringList;


begin
  result := nil;
  if oCurrFunction = nil then begin
    result := FFunctionList;
  end else
  if bShowList then begin
{$ifdef ver210}
    if(CharInSet(cSeparator, ['='])) then begin //jeeli separatorem jest "=" to podpowiadamy moliwe warto parametru
{$else}
    if cSeparator in ['='] then begin //jeeli separatorem jest "=" to podpowiadamy moliwe warto parametru
{$endif}
                                      //o nazwie sPrevWord
       result := GetList( AnsiUpperCase(oCurrFunction.FunName),
                          FParamKindList.Values[AnsiUpperCase(sPrevWord)], sCurrWord, cSeparator );
    end else if (AnsiUpperCase(oCurrFunction.FunName) = cSKLAD_WART)or
                (AnsiUpperCase(oCurrFunction.FunName) = cSKLAD_WART_GRUPY) then
      result := GetList( AnsiUpperCase(oCurrFunction.FunName), cSKLAD_WART, sCurrWord, cSeparator ) //dla tej funkcji jest brak nazwy parametru
    else if (AnsiUpperCase(oCurrFunction.FunName) = cSKLAD_IL)or
            (AnsiUpperCase(oCurrFunction.FunName) = cSKLAD_IL_GRUPY) then
      result := GetList( AnsiUpperCase(oCurrFunction.FunName), cSKLAD_IL, sCurrWord, cSeparator ) //dla tej funkcji jest brak nazwy parametru
    //else if (AnsiUpperCase(oCurrFunction.FunName) = cWART_PRACY) or (AnsiUpperCase(oCurrFunction.FunName) = cILOSC_PRACY) then
    //  result := nil//GetList( AnsiUpperCase(oCurrFunction.FunName), c, sCurrWord, cSeparator ) //dla tej funkcji jest brak nazwy parametru
    else result := oCurrFunction.ParamsNames; //w przeciwnym przypadku podpowiadamy list moliwych parametrw
  end;
end;

procedure TZLESkladnikKontroliDBDetailForm.SelectButtonPressed;
begin
  if OpenMode in [omNew,omEdit] then
    DMAQFbN( TableName+cSuffixPola_Regula ).AsString :=
             Trim(RegulaSimpleEditorRichEdit.Lines.Text );
  inherited;
end;

function TZLESkladnikKontroliDBDetailForm.GetList( sFunctionName, sKind, sText: String;
                                                   const cSeparator: Char): TUNIStringList;
var oQuery: TUNIQuery;
    i: Integer;
    bReplaceMinus: Boolean;
    sFirstWord: String;
begin
  result := nil;
  oQuery := nil;
  bReplaceMinus := False;

  try
    if sKind = 'KONTOFK' then begin
      bReplaceMinus := True;
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := FKDataManager.FKOdpytajODane( vFKKSO, sFKALIAS_KSO_KONTO,
                                              '@'+sFKALIAS_KSO_KONTO+' like '+QuotedStr(sText+'%'),
                                              false, vAktywnaFirma );
    end
    else if sKind = 'OKRESOBR' then begin
      oQuery := UniSysDataManager.UNIOdpytajODane( sUNIOKRES, sUNISYSALIAS_Okres_Obrachunkowy_Numer,//'',
                                                   '@'+sUNISYSALIAS_Okres_Obrachunkowy_Rok_ID+' = '+IntToStr(vAktywnyRokObrachunkowyID),
                                                   false, vAktywnaFirma );
    end
    else if sKind = 'MNEMONIK_ZAKRESSUM' then begin
      if Pos(',',sText) <> 0 then oQuery := GetMnemonikValuesList(sText)
      else begin
        sText := StringReplace(sText,'[','',[]);
        if (sText<>'')and(sText[1]=cSeparator) then sText := '';
        oQuery := UNISysDataManager.UNIOdpytajODane( sFKMNEMONIKI, sFKAlias_Mnemoniki_Mnemonik,
                                                     '@'+sFKAlias_Mnemoniki_Mnemonik+' like '+QuotedStr(sText+'%'),
                                                     true, vAktywnaFirma);
      end
    end
    else if sKind = 'MNEMONIK_DOKUMSP' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      FParamValuesList.Clear;
      FParamValuesList.Add('BRUTTO');
      FParamValuesList.Add('NETTO');
      FParamValuesList.Add('VAT');
      FParamValuesList.Add('RABAT');
      FParamValuesList.Add('OPAK');
      FParamValuesList.Add('IL1');
      FParamValuesList.Add('IL2');
      FParamValuesList.Add('IL3');
      result := FParamValuesList;
      Exit;
    end
    else if sKind = 'BILANS' then begin
      FParamValuesList.Clear;
      FParamValuesList.Add('TAK');
      FParamValuesList.Add('NIE');
      result := FParamValuesList;
      Exit;
    end
    else if sKind = 'RODZAJECP' then begin
      FParamValuesList.Clear;
      FParamValuesList.Add('O');
      FParamValuesList.Add('P');
      FParamValuesList.Add('R');
      FParamValuesList.Add('Z');
      result := FParamValuesList;
      Exit;
    end
    else if sKind = 'RODZAJZASOBU' then begin
      FParamValuesList.Clear;
      FParamValuesList.Add('P');
      FParamValuesList.Add('M');
      result := FParamValuesList;
      Exit;
    end
    else if sKind = 'STAWKAVAT' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISysDataManager.UNIOdpytajODane( sUNISTAWKIVAT, sUNISYSALIAS_StawkiVAT_Symbol,
                                                   '@'+sUNISYSALIAS_StawkiVAT_Symbol+' like '+QuotedStr(sText+'%'),
                                                   false, vAktywnaFirma );
    end
    else if sKind = 'GRUPAVAT' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISysDataManager.UNIOdpytajODane( sUNIGRUPAVAT, sUNISYSALIAS_GrupaVAT_Symbol,
                                                   '@'+sUNISYSALIAS_GrupaVAT_Symbol+' like '+QuotedStr(sText+'%'),
                                                   false, vAktywnaFirma );
    end
    else if sKind = 'REJESTR' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISysDataManager.UNIOdpytajODane( sUNIREJVAT, sUNISYSALIAS_RejestrVAT_Symbol,
                                                  '@'+sUNISYSALIAS_RejestrVAT_Symbol+' like '+QuotedStr(sText+'%'),
                                                  false, vAktywnaFirma );
    end
    else if sKind = 'MIESIAC' then begin
      FParamValuesList.Clear;
      for i := 1 to 12 do FParamValuesList.Add(IntToStr(i));
      result := FParamValuesList;
      Exit;
    end
    else if sKind = 'WGJEDN' then begin
      FParamValuesList.Clear;
      FParamValuesList.Add('TAK');
      FParamValuesList.Add('NIE');
      result := FParamValuesList;
      Exit;
    end
    else if sKind = 'STATUS' then begin
      FParamValuesList.Clear;
      {Uwaga: Pomijam status -1}
      FParamValuesList.Add('0');
      FParamValuesList.Add('1');
      FParamValuesList.Add('2');
      result := FParamValuesList;
      Exit;
    end
    else if sKind = 'COFNIJOKRES' then begin
      FParamValuesList.Clear;
      FParamValuesList.Add('0');
      FParamValuesList.Add('1');
      FParamValuesList.Add('2');
      FParamValuesList.Add('3');
      FParamValuesList.Add('4');
      FParamValuesList.Add('5');
      FParamValuesList.Add('6');
      FParamValuesList.Add('7');
      FParamValuesList.Add('8');
      FParamValuesList.Add('9');
      FParamValuesList.Add('10');
      FParamValuesList.Add('11');
      FParamValuesList.Add('11');
      result := FParamValuesList;
      Exit;
    end
    else if sKind = 'PODKLASA' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISysDataManager.UNIOdpytajODane( sUNIPODKLASA, sUNISYSALIAS_Podklasa_Klasa_Kod,
                                                   '@'+sUNISYSALIAS_Podklasa_Klasa_Kod+' like '+QuotedStr(sText+'%'),
                                                   false, vAktywnaFirma );
    end
    else if sKind = 'TYPDOKMAG' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := MAGDataManager.OdpytajODane( sMAGTYPDOK, sMAGALIAS_MAGTYPDOK_SYMBOL,
                                                   '@'+sMAGALIAS_MAGTYPDOK_SYMBOL+' like '+QuotedStr(sText+'%'),
                                                   false, vAktywnaFirma );
    end
    else if sKind = 'KONTOMAT' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := ASODataManager.OdpytajODane( sASOKMAT, sASOAlias_KMat_Symbol,
                                                   '@'+sASOAlias_KMat_Symbol+' like '+QuotedStr(sText+'%'),
                                                   false{, vAktywnaFirma });
    end
    else if sKind = 'INDEKSASO' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := ASODataManager.OdpytajODane( sASOASORT, sASOAlias_Asort_Indeks,
                                                   '@'+sASOAlias_Asort_Indeks+' like '+QuotedStr(sText+'%'),
                                                   false{, vAktywnaFirma });
    end
    else if sKind = 'SYMBOLASO' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := ASODataManager.OdpytajODane( sASOASORT, sASOAlias_Asort_Symbol,
                                                   '@'+sASOAlias_Asort_Symbol+' like '+QuotedStr(sText+'%'),
                                                   false{, vAktywnaFirma });
    end
    else if sKind = 'GRUPAASO' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := ASODataManager.OdpytajODane( sASOGRAS, sASOAlias_Gras_Symbol,
                                                   '@'+sASOAlias_Gras_Symbol+' like '+QuotedStr(sText+'%'),
                                                   false{, vAktywnaFirma });
    end
    else if sKind = 'MAGAZYN' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISysDataManager.UNIOdpytajODane( sUNIMAGAZYN, sUNISYSALIAS_Magazyn_Symbol,
                                                   '@'+sUNISYSALIAS_Magazyn_Symbol+' like '+QuotedStr(sText+'%'),
                                                   false, vAktywnaFirma );
    end
    else if sKind = 'WYDZIAL' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISysDataManager.UNIOdpytajODane( sUNIJEDNOSTKAORG, sUNISysAlias_JednostkaOrg_Symbol,
                                                   '@'+sUNISysAlias_JednostkaOrg_Symbol+' like '+QuotedStr(sText+'%'),
                                                   false, vAktywnaFirma );
    end
    else if sKind = 'ZLECENIE' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := ZLEDataManager.ZLEOdpytajODane( sZLEZLECENIE, sZLEALIAS_ZLECENIE_SYMBOL,
                                             '@'+sZLEALIAS_ZLECENIE_SYMBOL+' like '+QuotedStr(sText+'%'),
                                             false);
    end
    else if sKind = 'KLIENT' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := BKDataManager.OdpytajODaneKlienta( sBKAlias_KlientSymbol,
                                                   '@'+sBKAlias_KlientSymbol+' like '+QuotedStr(sText+'%'),
                                                   now, false{, vAktywnaFirma });
    end
    else if sKind = 'TYPDOK' then begin
      if Pos( sFunctionName, cFunkcjeSprzedazy ) > 0 then begin
        if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
        if (sText<>'')and(sText[1]=cSeparator) then sText := '';
        oQuery := MFSDataManager.OdpytajODane( sMFSTypDok, sMFSAlias_TypSymbol,
                                                     '@'+sMFSAlias_TypSymbol+' like '''+sText+'%''',
                                                     false);
      end else if Pos( sFunctionName, cFunkcjeZakupu ) > 0 then begin
        if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
        if (sText<>'')and(sText[1]=cSeparator) then sText := '';
        oQuery := MFZDataManager.OdpytajODane( sMFZTypDok, sMFZAlias_TypDok_SYMBOL,
                                                     '@'+sMFZAlias_TypDok_Symbol+' like '''+sText+'%''',
                                                     false);
      end;
    end
    else if sKind = 'TYPKOSZTU' then begin
      if Pos( sFunctionName, cFunkcjeZakupu ) > 0 then begin
        if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
        if (sText<>'')and(sText[1]=cSeparator) then sText := '';
        oQuery := MFZDataManager.OdpytajODane( sMFZTypKoszt, sMFZAlias_TypKosztuSymbol,
                                                     '@'+sMFZAlias_TypKosztuSymbol+' like '''+sText+'%''',
                                                     false);
      end;
    end
    else if sKind = 'SPOSZAPL' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISYSDM.UNIOdpytajODane( sUNIFORMAPLATNOSCI,
                                          sUNISYSALIAS_FormaPlatnosci_Symbol,
                                          '@'+sUNISYSALIAS_FormaPlatnosci_Symbol+' like '+QuotedStr(sText+'%'),
                                          False );
    end
    else if sKind = 'FIRMA' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISysDataManager.UNIOdpytajODane( sUNIODDZIAL, sUNISYSALIAS_Oddzial_Symbol,
                                                   '@'+sUNISYSALIAS_Oddzial_Symbol+' like '+QuotedStr(sText+'%'),
                                                   false, vAktywnaFirma );
    end
    else if sKind = 'ROK' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISysDataManager.UNIOdpytajODane( sUNIROK, sUNISYSALIAS_Rok_Rok,
                                                   '@'+sUNISYSALIAS_Rok_Rok+' like '+QuotedStr(sText+'%'),
                                                   false, vAktywnaFirma );
    end
    else if (sKind = 'SKLAD_WART') then begin
      sText := StringReplace(sText,#39,'',[rfReplaceAll]);
      oQuery := ZLEDM.ZLEOdpytajODane( sZLESKLADWART, sZLEALIAS_SKLADWART_SYMBOL,
                                       '(@'+sZLEALIAS_SKLADWART_SYMBOL+' like '+QuotedStr(sText+'%')+')',
                                       false);
    end
    else if (sKind = 'SKLAD_IL') then begin
      sText := StringReplace(sText,#39,'',[rfReplaceAll]);
      oQuery := ZLEDM.ZLEOdpytajODane( sZLESKLADIL, sZLEALIAS_SKLADIL_SYMBOL,
                                       '(@'+sZLEALIAS_SKLADIL_SYMBOL+' like '+QuotedStr(sText+'%')+')',
                                       false);
    end
    else if sKind = 'KIERUNEK' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      FParamValuesList.Clear;
      FParamValuesList.Add('PRZYCHODOWY');
      FParamValuesList.Add('ROZCHODOWY');
      result := FParamValuesList;
      Exit;
    end
    else if sKind = 'ZNAK' then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      FParamValuesList.Clear;
      FParamValuesList.Add('ZWYKY');
      FParamValuesList.Add('STORNO');
      result := FParamValuesList;
      Exit;
    end
    else if (sKind = 'POZROZDZ') then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
{      oQuery := ZLEDM.ZLEOdpytajODane( sZLEPLROZDEF, sZLEALIAS_PLROZDEF_SYMBOL,
                                       '(@'+sZLEALIAS_PLROZDEF_SYMBOL+' like '+QuotedStr(sText+'%')+')',
                                       false);}

      oQuery := SQLManager.CreateQuery('SELECT PLROZ.PLROZDEF_SYMBOL FROM ' +
                                        SQLManager.GetTableName(sPLROZDEF) + ' PLROZ, ' +
                                        SQLManager.GetTableName(sZLEPLROZDEF) + ' ZLEROZDEF '+
                                       'WHERE ZLEROZDEF.' + sPLROZDEF_ID + '= PLROZ.' + sPLROZDEF_ID + ' AND ' +
                                       '(PLROZ.' + sPLROZDEF_SYMBOL + ' LIKE '+QuotedStr(sText+'%')+')');
    end
    else if sKind = sWartosc then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      FParamValuesList.Clear;
      FParamValuesList.Add(sNETTO);
      FParamValuesList.Add(sBRUTTO);
      result := FParamValuesList;
      Exit;
    end
    else if sKind = cZLEMnem {sNazwaPolaUz} then begin
      if TrimLeft(sText)[1] = '[' then
        GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then
        sText := '';

      if sFunctionName = cSumPozDSPUz then begin
        oQuery := MFSDM.OdpytajODane( sMFSPoleZMDef, sMFSAlias_PoleZMDefNazwa,
                                     '@'+sMFSAlias_MnemonikiMnemonik+'=''ZLE''',
                                      false);
      end else if sFunctionName = cDokumZa then begin
        oQuery := SQLManager.CreateQuery(
          'SELECT def.'+sUNIPolaUzDef_Nazwa+
          ' FROM %s def, %s wsk, %s mn '+
          'WHERE def.' + sUNIPolaUzDef_ID + '= wsk.' + sUNIPolaUzDef_ID +
          ' AND def.' + sFKMnemoniki_ID + '=mn.'+sFKMnemoniki_ID+
          ' AND wsk.' + sUNIPolaUzWsk_Funk + '=' + cPolaUz_MFZDok+
          ' AND mn.'+sFKMnemoniki_Tabela+'='+QuotedStr(sZLEZlecenie),
          [sUNIPolaUzDef, sUNIPolaUzWsk, sFKMnemoniki]);
      end;
    end
    else if sKind = cTypDokSp then begin
      if TrimLeft(sText)[1] = '[' then
        GetLastWord(sText,sFirstWord);
      if (sText<>'') and (sText[1]=cSeparator) then
        sText := '';
      oQuery := MFSDM.OdpytajODane( sMFSTYPDOK, sMFSAlias_TypSymbol,'',false );
    end
    else if (sKind = 'MODUL') then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISysDataManager.UNIOdpytajODane( sUNIMODULZSI, sUNISYSALIAS_ModulZSI_Kod,
                                                   '@'+sUNISYSALIAS_ModulZSI_Kod+' like '''+sText+'%''',
                                                   false, vAktywnaFirma );
    end
    else if (sKind = 'REGULA') then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      oQuery := UNISysDataManager.UNIOdpytajODane( sUNIMODULZSI, sUNISYSALIAS_ModulZSI_Kod,
                                                   '@'+sUNISYSALIAS_ModulZSI_Kod+' like '''+sText+'%''',
                                                   false, vAktywnaFirma );
    end
    else if (sKind = sMAGPROTOTYP) then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      FParamValuesList.Clear;
      FParamValuesList.Add(cMagPrototyp_ZuzycieID);
      FParamValuesList.Add(cMagPrototyp_ZmniejszenieZuzyciaID);
      FParamValuesList.Add(cMagPrototyp_PrzyjecieZZewnatrzID);
      FParamValuesList.Add(cMagPrototyp_PrzyjecieZProdukcjiID);
      FParamValuesList.Add(cMagPrototyp_WydanieNaZewnatrzID);
      FParamValuesList.Add(cMagPrototyp_InnePrzychodyID);
      FParamValuesList.Add(cMagPrototyp_InneRozchodyID);
      result := FParamValuesList;
      Exit;
    end
    else if (sKind = 'RODZAJ') then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      FParamValuesList.Clear;
      FParamValuesList.Add(cAgregateFunctionParam_Rodzaj_KM);
      FParamValuesList.Add(cAgregateFunctionParam_Rodzaj_GODZ);
      FParamValuesList.Add(cAgregateFunctionParam_Rodzaj_GODZPOST);
      FParamValuesList.Add(cAgregateFunctionParam_Rodzaj_MTG);
      result := FParamValuesList;
      Exit;
    end
    else if (sKind = 'CZYILOWART') then begin
      if TrimLeft(sText)[1] = '[' then GetLastWord(sText,sFirstWord);
      if (sText<>'')and(sText[1]=cSeparator) then sText := '';
      FParamValuesList.Clear;
      FParamValuesList.Add(cAgregateFunctionParam_CzyIloWart_Ilosc);
      FParamValuesList.Add(cAgregateFunctionParam_CzyIloWart_Wartosc);
      result := FParamValuesList;
      Exit;
    end
    else if sKind = 'BRAK_PODPOWIEDZI' then Exit
    else begin
      Komunikat(cWarning,'Bdny parametr funkcji',MB_OK+MB_APPLMODAL);
      Exit;
    end;

    if oQuery = nil then Exit;
    FParamValuesList.Clear;
    oQuery.Open;
    while not oQuery.Eof do begin
      case bReplaceMinus of
        True: FParamValuesList.Add(StringReplace(oQuery.Fields[0].AsString,'-','',[rfReplaceAll]));
        False: FParamValuesList.Add(oQuery.Fields[0].AsString);
      end;
      oQuery.Next;
    end;
    if FParamValuesList.Count > 0 then result := FParamValuesList;
  finally
    if oQuery <> nil then oQuery.Free;
  end;
end;

function TZLESkladnikKontroliDBDetailForm.GetMnemonikValuesList(
  sText: String): TUNIQuery;
var oQuery: TUNIQuery;
    sMnemonik, sMnemonikId: String;
    sSQL, sWhere: String;
    sTableName: String;
    sPole, sIndeksPola: String;
    iIndeksPola: Integer;
begin
  result := nil;
  oQuery := nil;

  GetLastWord(sText,sMnemonik); // pobiera pierwsze i ostatnie sowo z listy postaci
                                 //[<string>,..,<string>]
  
  try
    oQuery := UNISysDataManager.UNIOdpytajODane( sFKMNEMONIKI, sFKAlias_Mnemoniki_Id,
                            '@'+sFKAlias_Mnemoniki_Mnemonik+' = '+QuotedStr(sMnemonik),
                            true, vAktywnaFirma);
    if (oQuery = nil)or(oQuery.RecordCount = 0)or(oQuery.Fields[0].AsString = '') then Exit;
    sMnemonikId := oQuery.Fields[0].AsString;
  finally
    if oQuery <> nil then oQuery.Free();
  end;
  if sMnemonik = sMnemonikKontaSyntetyczne then begin
    //sownik-niesownik syntetyk
    sWhere:='';
    if vWielofirmowosc and (vAktywnaFirma <> 0) and vPlanKontRozlaczny then begin
      sWhere := sUNIODDZIAL_ID+'='+IntToStr(vAktywnaFirma);
    end;
    //przygotowanie treci zapytania
    if sWhere <> '' then sWhere := sWhere+' and ';
    sWhere := sWhere+sFKPLANKONT_SYMBOL+' like '+QuotedStr(sText+'%');
    sSQL:= SQLManager.GetSelectWithInnerJoins(sFKPLANKONT_SYMBOL,
                            [vFKPLANKONT], [''], [''], sWhere);
  end else begin
    //pozostae przypadki, czyli normalne sowniki
    sTableName:=SQLMAnager.OpenQueryWithResult(
             'select '+ sFKMNEMONIKI_TABELA+' from %s where '+
             sFKMNEMONIKI_ID+'='+sMnemonikId, [sFKMNEMONIKI]);

    if sTableName='' then Exit
    else begin
      // z ktorego pola w slowniku odczytac konto
      sIndeksPola:=SQLManager.OpenQueryWithResult(
               'select '+ sFKMNEMONIKI_INDEKS+' from %s where '+
               sFKMNEMONIKI_ID+'='+sMnemonikId, [sFKMNEMONIKI]);
      if sIndeksPola ='' then Exit
      else iIndeksPola:=StrToInt(sIndeksPola);
    end;

    if iIndeksPola=0 then sPole:='SYMBOL'
    else sPole:='POLE'+IntToStr(iIndeksPola);

    if (sTableName = sFKUZ) then begin
      sWhere:=sFKMNEMONIKI_ID+' = '+sMnemonikId
      //tu nie wystpuje UNIODDZIAL
    end else begin
      sWhere:='';
      if vWielofirmowosc and (vAktywnaFirma <> 0) then begin
        //tu wystpuje UNIODDZIAL, ale NIE W KADYM sowniku
        if SQLManager.OpenQueryWithResult(
             'select '+ sFKMNEMONIKI_CZY_FIRM+' from %s where '+
             sFKMNEMONIKI_ID+'='+sMnemonikId, [sFKMNEMONIKI]) <> 'N' then begin
          if sWhere <> '' then sWhere := sWhere+' and ';
          sWhere := sWhere+sUNIODDZIAL_ID+'='+IntToStr(vAktywnaFirma);
        end;
      end
    end;
    //przygotowanie treci zapytania
    if sWhere <> '' then sWhere := sWhere+' and ';
    sWhere := sWhere+sTableName+'_'+sPole+' like '+QuotedStr(sText+'%');
    sSQL:= SQLManager.GetSelectWithInnerJoins( sTableName+'_'+sPole,
                                               [sTableName], [''], [''], sWhere);
  end;

  result := SQLManager.CreateQuery(sSQL);
end;

procedure TZLESkladnikKontroliDBDetailForm.GetLastWord(var sText,
  sFirstWord: String);
var iPos: Integer;
begin
  sText := StringReplace(sText,'[','',[]);
  sText := StringReplace(sText,']','',[]);
  iPos := Pos(',',sText);
  if iPos = 0 then sFirstWord := sText
  else sFirstWord := Copy(sText,1,iPos-1);
  while iPos <> 0 do begin
    System.Delete(sText,1,iPos);
    iPos := Pos(',',sText);
  end;
end;

procedure TZLESkladnikKontroliDBDetailForm.CreateFunctionList;
begin
  FFunctionList := TUNIStringList.Create;
  with FFunctionList do begin
    if KontrolaWartosciowa then begin
      if DataManagers.Available(sFKModulId) then begin
        AddObject(cBOWN,        TUNIFunction.Create(cBOWN,        ['KontoOd=','KontoDo=','Konto=','ZakresSUM=['], ''''));
        AddObject(cBOMA,        TUNIFunction.Create(cBOMA,        ['KontoOd=','KontoDo=','Konto=','ZakresSUM=['], ''''));
        AddObject(cObrWN,       TUNIFunction.Create(cObrWN,       ['KontoOd=','KontoDo=','Konto=','ZakresSUM=[','OkresOd=','OkresDo=','OkresMin='], ''''));
        AddObject(cObrMA,       TUNIFunction.Create(cObrMA,       ['KontoOd=','KontoDo=','Konto=','ZakresSUM=[','OkresOd=','OkresDo=','OkresMin='], ''''));
        AddObject(cObrNarWN,    TUNIFunction.Create(cObrNarWN,    ['KontoOd=','KontoDo=','Konto=','ZakresSUM=[','OkresDo=','BO='], ''''));
        AddObject(cObrNarMA,    TUNIFunction.Create(cObrNarMA,    ['KontoOd=','KontoDo=','Konto=','ZakresSUM=[','OkresDo=','BO='], ''''));
        AddObject(cSumSaldWN,   TUNIFunction.Create(cSumSaldWN,   ['KontoOd=','KontoDo=','Konto=','ZakresSUM=[','OkresOd=','OkresDo=','OkresMin=','BO='], ''''));
        AddObject(cSumSaldMA,   TUNIFunction.Create(cSumSaldMA,   ['KontoOd=','KontoDo=','Konto=','ZakresSUM=[','OkresOd=','OkresDo=','OkresMin=','BO='], ''''));
        AddObject(cSaldo,       TUNIFunction.Create(cSaldo,       ['KontoOd=','KontoDo=','Konto=','ZakresSUM=[','OkresOd=','OkresDo=','OkresMin=','BO='], ''''));
      end;
      if DataManagers.Available(sVATModulId) then begin
        AddObject(cVatSprNetto, TUNIFunction.Create(cVatSprNetto, ['MiesiacPod=','MiesiacPodOd=','MiesiacPodDo=','Rejestr=[','Podklasa=[','StawkaVAT=[','GrupaVAT=[','ZAP'], ''''));
        AddObject(cVatSprVat,   TUNIFunction.Create(cVatSprVat,   ['MiesiacPod=','MiesiacPodOd=','MiesiacPodDo=','Rejestr=[','Podklasa=[','StawkaVAT=[','GrupaVAT=[','ZAP'], ''''));
        AddObject(cVatZakNetto, TUNIFunction.Create(cVatZakNetto, ['MiesiacPod=','MiesiacPodOd=','MiesiacPodDo=','Rejestr=[','Podklasa=[','StawkaVAT=[','GrupaVAT=[','ZAP'], ''''));
        AddObject(cVatZakVat,   TUNIFunction.Create(cVatZakVat,   ['MiesiacPod=','MiesiacPodOd=','MiesiacPodDo=','Rejestr=[','Podklasa=[','StawkaVAT=[','GrupaVAT=[','ZAP'], ''''));
        AddObject(cVatSadNetto, TUNIFunction.Create(cVatSadNetto, ['MiesiacPod=','MiesiacPodOd=','MiesiacPodDo=','Rejestr=[','Podklasa=[','StawkaVAT=[','GrupaVAT=[','ZAP'], ''''));
        AddObject(cVatSadVat,   TUNIFunction.Create(cVatSadVat,   ['MiesiacPod=','MiesiacPodOd=','MiesiacPodDo=','Rejestr=[','Podklasa=[','StawkaVAT=[','GrupaVAT=[','ZAP'], ''''));
      end;
      if DataManagers.Available(sMFSModulId) then begin
        AddObject(cDokumSp,     TUNIFunction.Create(cDokumSp,     ['Zlecenie='+cZLEParamSymbolZlec,'OkrObr=[','OkrObrOd=','OkrObrDo=','TypDok=[','KlPla=[','KlPlaOd=','KlPlaDo=','KlOdb=[','KlOdbOd=','KlOdbDo=',
                                                                   'SposZapl=[','Mnemonik=[','Modul='], ''''));
      end;
      if DataManagers.Available(sMFZModulId) then begin
        AddObject(cDokumZa,     TUNIFunction.Create(cDokumZa,     ['OkrObr=[','OkrObrOd=','OkrObrDo=','TypDok=[','Dostawca=[','DostawcaOd=','DostawcaDo=',
                                                                   'SposZapl=[','Mnemonik=[','Modul=','Regula=',sNazwaPolaUz+'=['], ''''));
        AddObject(cKOSZTDOKZA,  TUNIFunction.Create(cKOSZTDOKZA,  ['OkrObr=[','OkrObrOd=','OkrObrDo=','DataZakupuOd=rrrrmmdd',
                                                                   'DataZakupuDo=rrrrmmdd','RokObr=[','RokObrOd=','RokObrDo=',
                                                                   'TypKosztu=[','TypKosztuOd=','TypKosztuDo=',
                                                                   'TypDok=[','ZakresSUM=['], ''''));
      end;
      AddObject(cSklad_Wart,       TUNIFunction.Create(cSKLAD_WART,       ['Symbol skadnika wartociowego'], ''''));
      AddObject(cSklad_Wart_Grupy, TUNIFunction.Create(cSKLAD_WART_GRUPY, ['Symbol skadnika wartociowego'], ''''));
      AddObject(cSKLAD_IL_WART,    TUNIFunction.Create(cSKLAD_IL_WART,    ['Symbol skadnika ilociowego'], ''''));
      AddObject(cWART_PRACY,       TUNIFunction.Create(cWART_PRACY, ['RODZAJECP=[','RODZAJZASOBU=['], ''''));
      AddObject(cWART_ROZL,        TUNIFunction.Create(cWART_ROZL,  [''], ''));
    end else begin
      AddObject(cSklad_Il,       TUNIFunction.Create(cSKLAD_IL,       ['Symbol skadnika ilociowego'], ''''));
      AddObject(cSklad_Il_Grupy, TUNIFunction.Create(cSKLAD_IL_GRUPY, ['Symbol skadnika ilociowego'], ''''));
      AddObject(cZLEPOZILOSC,    TUNIFunction.Create(cZLEPOZILOSC,   [''], ''));
      AddObject(cZLEPOZCENA,     TUNIFunction.Create(cZLEPOZCENA,    [''], ''));
    end;

    {Ilociowa i wartociowa}
    AddObject(cILOSC_PRACY,    TUNIFunction.Create(cILOSC_PRACY,   ['RODZAJECP=[','RODZAJZASOBU=['], ''''));
    AddObject(cILOSC_GODZ,     TUNIFunction.Create(cILOSC_GODZ,    ['RODZAJECP=[','RODZAJZASOBU=['], ''''));
    AddObject(cILOSC_PALIWA,   TUNIFunction.Create(cILOSC_PALIWA,  [''], ''));
    AddObject(cZLEWARTPOZ,     TUNIFunction.Create(cZLEWARTPOZ,    [''], ''));

    if DataManagers.Available(sMAGModulId) then begin
      AddObject(cObrGM,         TUNIFunction.Create(cObrGM,       ['TypDokumentuOd=','TypDokumentuDo=','TypDokumentu=[','OkresObrachunkowyOd=','OkresObrachunkowyDo=',
                                                                   'OkresObrachunkowy=[','MagazynOd=','MagazynDo=','Magazyn=[','KontoMaterialoweOd=','KontoMaterialoweDo=','KontoMaterialowe=[','IndeksOd=',
                                                                   'IndeksDo=','Indeks='+cZLEParamIndeksAsort,'WydzialOd=','WydzialDo=','Wydzial=[','ZlecenieOd=','ZlecenieDo=','Zlecenie='+cZLEParamSymbolZlec,'OdbiorcaOd=','OdbiorcaDo=','Odbiorca=[',
                                                                   'DostawcaOd=','DostawcaDo=','Dostawca=[','MagazynDocelowyOd=','MagazynDocelowyDo=','MagazynDocelowy=[','Znak=[','Kierunek=[', sMAGPROTOTYP+'=[','Status=['], ''''));
    end;
    if DataManagers.Available(sSTModulId) then begin
      AddObject(cObrST,         TUNIFunction.Create(cObrST,       ['OkresObrachunkowyOd=','OkresObrachunkowyDo=','OkresObrachunkowy=[',
                                                                   'ZlecenieOd=','ZlecenieDo=','Zlecenie='+cZLEParamSymbolZlec], ''''));
    end;
    if DataManagers.Available(sTSModulId) then  begin
      AddObject(cTSROZL,         TUNIFunction.Create(cTSROZL,       ['Rok=','RokOd=','RokDo=','OkresOd=[','OkresDo=[',
                                                                     'CzyIloWart=','Rodzaj=','ZakresSUM=['], ''''));
    end;
    if DataManagers.Available(sMFSModulId) then begin
      AddObject(cPozDokSp,      TUNIFunction.Create(cPozDokSp,    ['Zlecenie='+cZLEParamSymbolZlec,'OkrObr=[','OkrObrOd=','OkrObrDo=','TypDok=[','KlPla=[','KlPlaOd=','KlPlaDo=','KlOdb=[','KlOdbOd=','KlOdbDo=',
                                                                   'IndAso='+cZLEParamIndeksAsort,'IndAsoOd=','IndAsoDo=','SymbAs=[','SymbAsOd=','SymbAsDo=','GrAso=[','GrAsoOd=','GrAsoDo=','Mnemonik=[','Modul='], ''''));
      AddObject(cSumPozDSPUz,   TUNIFunction.Create(cSumPozDSPUz, [sNazwaWartosc+'=',sNazwaPolaUz+'=',sTypDokumentuSp+'='], ''''));
    end;
    if DataManagers.Available(sMFZModulId) then begin
      AddObject(cPozDokZa,      TUNIFunction.Create(cPozDokZa,    ['OkrObr=[','OkrObrOd=','OkrObrDo=','TypDok=[','Dostawca=[','DostawcaOd=','DostawcaDo=',
                                                                   'IndAso='+cZLEParamIndeksAsort,'IndAsoOd=','IndAsoDo=','SymbAs=[','SymbAsOd=','SymbAsDo=',
                                                                   'GrAso=[','GrAsoOd=','GrAsoDo=','Mnemonik=[',
                                                                   'Modul=','Regula='], ''''));
    end;

    if DataManagers.Available(sPLLIModulID) then begin
      AddObject(cWARTPL, TUNIFunction.Create(cWARTPL,             ['Zlecenie='+cZLEParamSymbolZlec,'POZROZDZ=[','WGJEDN=','COFNIJOKRES='], ''''));
    end;
  end;
end;

procedure TZLESkladnikKontroliDBDetailForm.CreateParamKindList;
begin
  //ustalenie rodzaju parametru
  FParamKindList := TUniStringList.Create;
  with FParamKindList do begin
    Add('KONTOOD=KONTOFK');
    Add('KONTODO=KONTOFK');
    Add('KONTO=KONTOFK');
    Add('OKRESOD=OKRESOBR');
    Add('OKRESDO=OKRESOBR');
    Add('OKRESMIN=OKRESOBR');
    Add('ZAKRESSUM=MNEMONIK_ZAKRESSUM');
    Add('BO=BILANS');
    Add('STAWKAVAT=STAWKAVAT');
    Add('GRUPAVAT=GRUPAVAT');
    Add('ZAP=BRAK_PODPOWIEDZI');
    Add('REJESTR=REJESTR');
    Add('MIESIACPOD=MIESIAC');
    Add('MIESIACPODOD=MIESIAC');
    Add('MIESIACPODDO=MIESIAC');
    Add('PODKLASA=PODKLASA');
    Add('SYMBOL=SYMBOLAN');
    Add('ROK=ROK');
    Add('OKRESNR=OKRESOBR');
    Add('FIRMASYM=FIRMA');
    Add('TYPDOKUMENTUOD=TYPDOKMAG');
    Add('TYPDOKUMENTUDO=TYPDOKMAG');
    Add('TYPDOKUMENTU=TYPDOKMAG');
    Add('OKRESOBRACHUNKOWYOD=OKRESOBR');
    Add('OKRESOBRACHUNKOWYDO=OKRESOBR');
    Add('OKRESOBRACHUNKOWY=OKRESOBR');
    Add('MAGAZYNOD=MAGAZYN');
    Add('MAGAZYNDO=MAGAZYN');
    Add('MAGAZYN=MAGAZYN');
    Add('KONTOMATERIALOWEOD=KONTOMAT');
    Add('KONTOMATERIALOWEDO=KONTOMAT');
    Add('KONTOMATERIALOWE=KONTOMAT');
    Add('INDEKSOD=INDEKSASO');
    Add('INDEKSDO=INDEKSASO');
    Add('INDEKS=INDEKSASO');
    Add('WYDZIALOD=WYDZIAL');
    Add('WYDZIALDO=WYDZIAL');
    Add('WYDZIAL=WYDZIAL');
    Add('ZLECENIEOD=ZLECENIE');
    Add('ZLECENIEDO=ZLECENIE');
    Add('ZLECENIE=ZLECENIE');
    Add('ODBIORCAOD=KLIENT');
    Add('ODBIORCADO=KLIENT');
    Add('ODBIORCA=KLIENT');
    Add('DOSTAWCAOD=KLIENT');
    Add('DOSTAWCADO=KLIENT');
    Add('DOSTAWCA=KLIENT');
    Add('MAGAZYNDOCELOWYOD=MAGAZYN');
    Add('MAGAZYNDOCELOWYDO=MAGAZYN');
    Add('MAGAZYNDOCELOWY=MAGAZYN');
    Add('OKROBR=OKRESOBR');
    Add('OKROBROD=OKRESOBR');
    Add('OKROBRDO=OKRESOBR');
    Add('TYPDOK=TYPDOK');
    Add('KLPLA=KLIENT');
    Add('KLPLAOD=KLIENT');
    Add('KLPLADO=KLIENT');
    Add('KLODB=KLIENT');
    Add('KLODBOD=KLIENT');
    Add('KLODBDO=KLIENT');
    Add('SPOSZAPL=SPOSZAPL');
    Add('MNEMONIK=MNEMONIK_DOKUMSP');
    Add('INDASO=INDEKSASO');
    Add('INDASOOD=INDEKSASO');
    Add('INDASODO=INDEKSASO');
    Add('SYMBAS=SYMBOLASO');
    Add('SYMBASOD=SYMBOLASO');
    Add('SYMBASDO=SYMBOLASO');
    Add('GRASO=GRUPAASO');
    Add('GRASOOD=GRUPAASO');
    Add('GRASODO=GRUPAASO');
    Add('POZROZDZ=POZROZDZ');
    Add('ZNAK=ZNAK');
    Add('KIERUNEK=KIERUNEK');
    Add(sNazwaWartosc+'='+sWartosc);
    Add(sNazwaPolaUz+'='+cZLEMnem);
    Add(sTypDokumentuSp+'='+cTypDokSp);
    Add('MODUL=MODUL');
    Add('REGULA=REGULA');
    Add(sMAGPROTOTYP+'='+sMAGPROTOTYP);
    Add('TYPKOSZTU=TYPKOSZTU');
    Add('WGJEDN=WGJEDN');
    Add('COFNIJOKRES=COFNIJOKRES');
    Add('RODZAJECP=RODZAJECP');
    Add('RODZAJZASOBU=RODZAJZASOBU');
    Add('STATUS=STATUS');
    Add('RODZAJ=RODZAJ');
    Add('CZYILOWART=CZYILOWART');
  end;
end;

procedure TZLESkladnikKontroliDBDetailForm.InitializeObjectFields;
begin
  RegulaSimpleEditorRichEdit := TUNISimpleEditorRichEdit.Create( Self );
  with RegulaSimpleEditorRichEdit do begin
    SetFunctions(GetFunctionsList, GetAdditionalHint);
    SetProperties( Self.RichEditPanel, 0, 0, 0, 0, True );
    Align := alClient;
    WordWrap := False;
  end;
  if OpenMode in [omView,omDelete] then RegulaSimpleEditorRichEdit.ReadOnly := true;

  FParser := TZLEParser.Create(Self, KontrolaWartosciowa);
  with FParser do begin
    bSymulacja := False;
    if vWielofirmowosc then iFirmaID:= vAktywnaFirma;
    iOkresNr:= 1;
    sRok:= UNISysDM.vAktywnyRokObrachunkowy;
    sRokId:= inttostr(UNISysDM.vAktywnyRokObrachunkowyID);
  end;
  CreateFunctionList;
  CreateParamKindList;
  FParamValuesList := TUNIStringList.Create();
end;

destructor TZLESkladnikKontroliDBDetailForm.Destroy;
begin
  if FParser<>nil then FreeAndNil(FParser);
  if FFunctionList<> nil then FreeAndNil(FFunctionList);
  if FParamValuesList<>nil then FreeAndNil(FParamValuesList);
  if FParamKindList<>nil then FreeAndNil(FParamKindList);
  if RegulaSimpleEditorRichEdit <> nil then RegulaSimpleEditorRichEdit.Free;
  inherited;
end;

procedure TZLESkladnikKontroliDBDetailForm.CheckButtonClick(
  Sender: TObject);
begin
  inherited;
  CheckRegula();
end;

procedure TZLESkladnikKontroliDBDetailForm.CancelButtonClick(
  Sender: TObject);
begin
  if (RegulaSimpleEditorRichEdit.Enabled)and(RegulaSimpleEditorRichEdit.CloseListBoxIfVisible()) then
    //nie rb nic
  else inherited;
end;

function TZLESkladnikKontroliDBDetailForm.CheckRegula;
var s: String;
begin
  result := false;
  if FParser.ScriptCheck('Test', RegulaSimpleEditorRichEdit.Lines, False) = 0 then begin
    s := '';
    case VarType(FParser.ResultOfScript) of
      varSmallint, varInteger: s := IntToStr(FParser.ResultOfScript);
      varSingle, varDouble, varCurrency: s := FloatToStr(FParser.ResultOfScript);
      varDate: s := DateToStr(FParser.ResultOfScript);
      varBoolean: if FParser.ResultOfScript = True then s := 'TRUE' else s := 'FALSE';
      varString: s := FParser.ResultOfScript;
    end;
    result := true;
    if not bBezKomentarzy then Komunikat(cInformation, 'Regua jest poprawna: ' + s);
  end else begin
    RegulaSimpleEditorRichEdit.SetFocus;
    RegulaSimpleEditorRichEdit.SelStart := FParser.Errors[FParser.Errors.Count - 1].Position;
    RegulaSimpleEditorRichEdit.SelLength := FParser.Errors[FParser.Errors.Count - 1].Size;
    Komunikat(
      cWarning,
      'Linia: ' + IntToStr(FParser.Errors[FParser.Errors.Count - 1].Line) + '. ' +
      'Kolumna: ' + IntToStr(FParser.Errors[FParser.Errors.Count - 1].Column) + '. ' +
      FParser.Errors[FParser.Errors.Count - 1].ErrorMessage
    );
  end;
end;

procedure TZLESkladnikKontroliDBDetailForm.SetKontrolaWartosciowa(
  const Value: Boolean);
begin
  FKontrolaWartosciowa := Value;
end;

end.
