unit ZLESkladnikKontroliIlosciowejDBDetailFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-18 gdeyk    Utworzone
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ZLESkladnikKontroliDBDetailFormUnit, Menus, UNIComponentsUnit, Db,
  StdCtrls, DBCtrls, Mask, ExtCtrls, ToolWin, ComCtrls, UNIStaleUnit, UNIDataModuleUnit;

type
  TZLESkladnikKontroliIlosciowejDBDetailForm = class(TZLESkladnikKontroliDBDetailForm)
    KolejnoscLabel: TUNILabel;
    KolejnoscEdit: TUNIEdit;
    SkladNieokresowyDBCheckBox: TUNIDBCheckBox;
  protected
    procedure InitializeControls(); override;
    procedure InitializeObjectFields(); override;
    procedure SetDefaults(); override;
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure InternalOpen(); override;
  public
    //procedure BeforeShow; override;
    function Validate(): Boolean; override;
    procedure SelectButtonPressed; override;
  end;

implementation

{$R *.DFM}

uses
  FormManagerUnit,
  Dodatki,
  UNISysDefUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit,
  ZLESkladnikKontroliIlosciowejUnit,
  ZLESkladnikKontroliIlosciowejDBGridFormUnit,
  ZLETypZleceniaDBDetailFormUnit;

{ TZLESkladnikKontroliIlosciowejDBDetailForm }

(***********************
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ZLESkladnikKontroliDBDetailFormUnit, Menus, UNIComponentsUnit, Db, DbClient,
  StdCtrls, DBCtrls, Mask, ExtCtrls, ToolWin, ComCtrls, UNIStaleUnit, UNIDataModuleUnit,
  UNISimpleEditorUnit;

{ TZLESkladnikKontroliWartosciowejDBDetailForm }

procedure TZLESkladnikKontroliWartosciowejDBDetailForm.InitializeControls;
begin
  inherited;
  with SymulacjaDBCheckBox do begin
    DataField := sZLESKLADWART_SYMULACJA;
    ValueChecked := sUNICONST_ALTERNATYWA_TAK;
    ValueUnchecked := sUNICONST_ALTERNATYWA_NIE;
  end;

  if (Owner.Owner.ClassName = TZLETypZleceniaDBDetailForm.ClassName) and
     ((Owner as TZLESkladnikKontroliWartosciowejDBGridForm).FormIsContained) then begin
     KolejnoscEdit.Visible := True;
     KolejnoscLabel.Visible := True;

     if Parameters.Values[sZLETYPSKLADW_KOLEJNOSC] <> '' then
        KolejnoscEdit.Text := Parameters.Values[sZLETYPSKLADW_KOLEJNOSC];
  end else begin
     KolejnoscEdit.Visible := False;
     KolejnoscLabel.Visible := False;
  end;
end;

procedure TZLESkladnikKontroliWartosciowejDBDetailForm.InitializeObjectFields;
begin
  inherited;
end;

procedure TZLESkladnikKontroliWartosciowejDBDetailForm.SetDefaults;
begin
  inherited;
  try
    (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := True;
    DMAQFbN(sZLESKLADWART_SYMULACJA).AsString := ZLEDM.DajDefaultPola( sZLESKLADWART,
                                                                       sZLESKLADWART_SYMULACJA );

    DMAQFbN(sZLESKLADWART_FORMAT).AsString    := ZLEDM.DajDefaultPola( sZLESKLADWART,
                                                                       sZLESKLADWART_FORMAT );
    {DMAQFbN(sZLESKLADWART_KOLEJNOSC).AsString := RecordCount??};
  finally
    (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := False;
  end;
end;

end.
*************)
procedure TZLESkladnikKontroliIlosciowejDBDetailForm.SelectButtonPressed;
begin
  if (OpenMode in [{omNew,} omEdit]) and (Owner.Owner.ClassName = TZLETypZleceniaDBDetailForm.ClassName) then
     Parameters.Values[sZLETYPSKLADIL_KOLEJNOSC] := KolejnoscEdit.Text;
  inherited;

  if (OpenMode in [{omNew,}omEdit]) and
     ((Owner as TZLESkladnikKontroliIlosciowejDBGridForm).FormIsContained) then
    with ((Owner as TZLESkladnikKontroliIlosciowejDBGridForm).DataModule.ActiveQuery as TVirtualDataSet) do begin
      try
        VState := vsInternalInsert;
        Edit;
        if FindField(sZLETYPSKLADIL_KOLEJNOSC) <> nil then
           FieldByName(sZLETYPSKLADIL_KOLEJNOSC).AsString := KolejnoscEdit.Text;
        Post;
      finally
        VState := vsNormal;
      end;
    end;
end;

procedure TZLESkladnikKontroliIlosciowejDBDetailForm.InitializeControls;
begin
  inherited;
  with SkladnieokresowyDBCheckBox do begin
    DataField := sZLESKLADIL_NIEOKRESOWY;
    ValueChecked := sUNICONST_ALTERNATYWA_TAK;
    ValueUnchecked := sUNICONST_ALTERNATYWA_NIE;
  end;
  if (Owner.Owner.ClassName = TZLETypZleceniaDBDetailForm.ClassName) and
     ((Owner as TZLESkladnikKontroliIlosciowejDBGridForm).FormIsContained) then begin
     KolejnoscEdit.Visible := True;
     KolejnoscLabel.Visible := True;

     if Parameters.Values[sZLETYPSKLADIL_KOLEJNOSC] <> '' then
        KolejnoscEdit.Text := Parameters.Values[sZLETYPSKLADIL_KOLEJNOSC];
  end else begin
     KolejnoscEdit.Visible := False;
     KolejnoscLabel.Visible := False;
  end;
end;

procedure TZLESkladnikKontroliIlosciowejDBDetailForm.InitializeObjectFields;
begin
  inherited;
end;

function TZLESkladnikKontroliIlosciowejDBDetailForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLESkladnikKontroliIlosciowejDataModule.CreateOpen( Self, InheritedMasterKeyValues, AOpenMode );
end;

procedure TZLESkladnikKontroliIlosciowejDBDetailForm.InternalOpen;
begin
  FTableName := sZLESKLADIL;
  inherited;
end;

function TZLESkladnikKontroliIlosciowejDBDetailForm.Validate: Boolean;
begin
  KontrolaWartosciowa := false;
  result := inherited Validate();
end;

procedure TZLESkladnikKontroliIlosciowejDBDetailForm.SetDefaults;
begin
  inherited;
  try
    (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := True;
    DMAQFbN(sZLESKLADIL_NIEOKRESOWY).AsString := ZLEDM.DajDefaultPola( sZLESKLADIL,
                                                                       sZLESKLADIL_NIEOKRESOWY );

    {DMAQFbN(sZLESKLADWART_KOLEJNOSC).AsString := RecordCount??};
  finally
    (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := False;
  end;
end;

initialization
  FormManager.RegisterForm( TZLESkladnikKontroliIlosciowejDBDetailForm,
                            'Skadnik kontroli ilociowej', sZLEModulID );

end.
