unit ZLESkladnikKontroliUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-18 gdeyk    Utworzone
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLESkladnikKontroliDataModule = class(TUNIDataModule)
  private
    iOddzialCondID, iTypZlecCondID: Integer;
    procedure SetMasterJoins();
  protected
    procedure GetKeys; override;
    procedure InitializeGridQueryDefs; override;
    procedure OpenDataSets(); override;
    procedure GetBlobText( Sender: TField; var Text: String; DisplayText: Boolean ); override;
  public
    constructor Create( AOwner: TComponent); override;
    procedure Post; override;
    procedure ReOpenDataSets(); override;
  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  QueryBuilderUnit,
  SQLManagerUnit,
  UNIStaleUnit,
  UNIFormUnit,
  UNISysDefUnit,
  ZLEDefUnit,
  ZLESkladnikKontroliDBDetailFormUnit;

{ TZLESkladnikKontroliDataModule }

procedure TZLESkladnikKontroliDataModule.GetBlobText(Sender: TField;
  var Text: String; DisplayText: Boolean);
begin
  inherited;
  if ActiveQuery.FieldByName(TableName+cSuffixPola_Rodzaj).AsString =
     cZLERodzajSklad_RecznyID then Text := '';
end;

constructor TZLESkladnikKontroliDataModule.Create(AOwner: TComponent);
begin
  inherited;
  iOddzialCondID := -1;
  iTypZlecCondID := -1;
end;

procedure TZLESkladnikKontroliDataModule.GetKeys;
begin
  with FKeys do begin
    AddPrimary(TableName+'_ID');
  end;
end;

procedure TZLESkladnikKontroliDataModule.InitializeGridQueryDefs;
begin
  if GridColDefs.Count = 0 then with GridColDefs do begin
    AddRequiredAndUnvisible( TableName+'_ID', 'M', '');
    AddRequiredAndUnvisible( sUNIODDZIAL_ID, 'M', '');
    if vWieloodzialowosc then
      Add( sUNIODDZIAL_NAZWA, 'O', 'Oddzia', True, True, taLeftJustify, 60 );
    AddRequired( TableName+cSuffixPola_Symbol, 'M', 'Symbol',  True, taLeftJustify, 80 );
    Add( TableName+cSuffixPola_Nazwa,  'M', 'Nazwa',   True, True, taLeftJustify, 80 );

    if (Owner is TUNIForm) then
       if (Owner as TUNIForm).Parameters.Values[sZLETYPZLEC_ID] <> '' then begin
          if TableName = sZLESKLADWART then
             Add( sZLETYPSKLADW_Kolejnosc,  'T', 'Kolejno',   True, True, taLeftJustify, 80 )
          else if TableName = sZLESKLADIL then
             Add( sZLETYPSKLADIL_Kolejnosc,  'T', 'Kolejno',   True, True, taLeftJustify, 80 );
       end;

    AddRequiredAndUnvisible( TableName+cSuffixPola_Rodzaj, 'M', '');
    Add( sZLECONST_SKLADNIK_V, 'S', 'Rodzaj', True, True, taLeftJustify, 70);
    //AddRequiredAndUnvisible( 'TO_CHAR('+TableName+cSuffixPola_Regula+');'+TableName+cSuffixPola_Regula, 'M', 'Regula');
    AddRequired( TableName+cSuffixPola_Regula, 'M', 'Regua', True, taLeftJustify, 200, uftClob);
    if TableName = sZLESKLADWART then
      Add( sZLESKLADWART_SYMULACJA, 'M', 'Symulacja', False, True, taLeftJustify, 60 );
  end;
  if GridTabDefs.Count = 0 then with GridTabDefs do begin
    Add( 'M', TableName );
    if vWieloodzialowosc then Add( 'O', sUNIODDZIAL );
    Add( 'S', sZLECONST_SKLADNIK );
  end;
  if GridJoinDefs.Count = 0 then with GridJoinDefs do begin
    if vWieloodzialowosc then
      AddSimple( 'M', 'O', 'M.'+sUNIODDZIAL_ID+'=O.'+sUNIODDZIAL_ID, qjkLeftOuter, True)
    else if vWielofirmowosc then
      AddCondition( 'M.'+sUNIODDZIAL_ID+'='+IntToStr(vAktywnaFirma), true);
    AddSimple( 'M', 'S', 'M.'+TableName+cSuffixPola_Rodzaj+'=S.'+sZLECONST_SKLADNIK_ID, qjkInner, True);
  end;
  SetMasterJoins();
  inherited;
end;

procedure TZLESkladnikKontroliDataModule.OpenDataSets;
begin
  inherited;
  {if (ListQuery <> nil)and
     (ListQuery.FindField(TableName+cSuffixPola_Regula) <> nil) then
    ListQuery.FieldByName(TableName+cSuffixPola_Regula).OnGetText := GetText;}
end;

procedure TZLESkladnikKontroliDataModule.Post;
var bTrans: Boolean;
begin
  bTrans := SQLManager.InTransaction;
  if not bTrans then SQLManager.StartTransaction;
  try
    if vWielofirmowosc then
      ActiveQuery.FieldByName(sUNIODDZIAL_ID).AsInteger := vAktywnaFirma;
    inherited;
    if not bTrans then SQLManager.Commit;
  except
    on EDMException do begin
      if not bTrans then SQLManager.Rollback;
      if ((Pos(sZLESKLADWART+c_UNK + '1', FLastDBError.OrgMess {SQLObjectName}) > 0) or
          (Pos(sZLESKLADIL+c_UNK + '1',   FLastDBError.OrgMess {SQLObjectName}) > 0)) then begin
        Komunikat( cError,'Istnieje ju skadnik o takim symbolu!');
        with owner as TZLESkladnikKontroliDBDetailForm do
          ActiveControl:= SymbolSkladnikaDBEdit;
        abort;
      end else
      if ((Pos(sZLESKLADWART+c_UNK + '2', FLastDBError.OrgMess {SQLObjectName}) > 0) or
          (Pos(sZLESKLADIL+c_UNK + '2',   FLastDBError.OrgMess {SQLObjectName}) > 0)) then begin
        Komunikat( cError,'Istnieje ju skadnik o takiej nazwie!');
        with owner as TZLESkladnikKontroliDBDetailForm do
          ActiveControl:= NazwaSkladnikaDBEdit;
        abort;
      end else raise;
    end else begin
      if not bTrans then SQLManager.Rollback;
      raise;
    end;
  end;
end;

procedure TZLESkladnikKontroliDataModule.ReOpenDataSets;
var sPrimaryID: String;
begin
  sPrimaryID := ActiveQuery.FieldByName( Keys.GetPrimaryKey() ).AsString;
  inherited;
  if not ActiveQuery.IsEmpty {ActiveQuery.RecordCount > 0} then
    ActiveQuery.Locate( Keys.GetPrimaryKey(), sPrimaryID, [] );
end;

procedure TZLESkladnikKontroliDataModule.SetMasterJoins;
begin
  //wyzerowanie poprzednich joinw
  with (Owner as TUNIForm).Parameters do begin
    if (Values[sUNIODDZIAL_ID] <> '')and(vWieloodzialowosc) then begin
      if (iOddzialCondID = -1)or(iOddzialCondID > GridJoinDefs.Count-1) then
        iOddzialCondID := GridJoinDefs.AddCondition('M.'+sUNIODDZIAL_ID+'='+Values[sUNIODDZIAL_ID], true)
      else
        GridJoinDefs.ExchangeCondition( iOddzialCondID,
                                        'M.'+sUNIODDZIAL_ID+'='+Values[sUNIODDZIAL_ID],
                                        true );
    end;
    if Values[sZLETYPZLEC_ID] <> '' then begin
      if (GridTabDefs.IndexOf('T') = -1) then begin
        if TableName = sZLESKLADWART then begin
          GridTabDefs.Add( 'T', sZLETYPSKLADW );
          GridJoinDefs.AddSimple( 'M', 'T', 'M.'+sZLESKLADWART_ID+'=T.'+sZLESKLADWART_ID,
                                  qjkInner, true );
        end else if TableName = sZLESKLADIL then begin
          GridTabDefs.Add( 'T', sZLETYPSKLADIL );
          GridJoinDefs.AddSimple( 'M', 'T', 'M.'+sZLESKLADIL_ID+'=T.'+sZLESKLADIL_ID,
                                  qjkInner, true );
        end;
      end;

      if (iTypZlecCondID = -1)or(iTypZlecCondID > GridJoinDefs.Count-1) then
        iTypZlecCondID := GridJoinDefs.AddCondition('T.'+sZLETYPZLEC_ID+'='+Values[sZLETYPZLEC_ID],true)
      else
        GridJoinDefs.ExchangeCondition( iTypZlecCondID,
                                        'T.'+sZLETYPZLEC_ID+'='+Values[sZLETYPZLEC_ID],
                                        true );
    end;
  end;
end;

end.
