unit ZLESkladnikKontroliWartosciowejDBDetailFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-18 gdeyk    Utworzone
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ZLESkladnikKontroliDBDetailFormUnit, Menus, UNIComponentsUnit, Db, DbClient,
  StdCtrls, DBCtrls, Mask, ExtCtrls, ToolWin, ComCtrls, UNIStaleUnit, UNIDataModuleUnit,
  UNISimpleEditorUnit;

type
  TZLESkladnikKontroliWartosciowejDBDetailForm = class(TZLESkladnikKontroliDBDetailForm)
    SymulacjaDBCheckBox: TUNIDBCheckBox;
    FormatLabel: TUNILabel;
    FormatMaskEdit: TUNIMaskEdit;
    KolejnoscLabel: TUNILabel;
    KolejnoscEdit: TUNIEdit;
  private
    { Private declarations }
  protected
    procedure InitializeControls(); override;
    procedure InitializeObjectFields(); override;
    procedure SetDefaults(); override;
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure InternalOpen(); override;
  public
    procedure BeforeShow; override;
    function Validate(): Boolean; override;
    procedure SelectButtonPressed; override;
  end;

implementation

{$R *.DFM}

uses
  FormManagerUnit,
  Dodatki,
  UNISysDefUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit,
  ZLESkladnikKontroliWartosciowejUnit,
  ZLESkladnikKontroliWartosciowejDBGridFormUnit,
  ZLETypZleceniaDBDetailFormUnit;

{ TZLESkladnikKontroliWartosciowejDBDetailForm }

procedure TZLESkladnikKontroliWartosciowejDBDetailForm.SelectButtonPressed;
begin
  if (OpenMode in [{omNew,} omEdit]) and (Owner.Owner.ClassName = TZLETypZleceniaDBDetailForm.ClassName) then
     Parameters.Values[sZLETYPSKLADW_KOLEJNOSC] := KolejnoscEdit.Text;
  inherited;

  if (OpenMode in [{omNew,}omEdit]) and
     ((Owner as TZLESkladnikKontroliWartosciowejDBGridForm).FormIsContained) then
    with ((Owner as TZLESkladnikKontroliWartosciowejDBGridForm).DataModule.ActiveQuery as TVirtualDataSet) do begin
      try
        VState := vsInternalInsert;
        Edit;
        if FindField(sZLETYPSKLADW_KOLEJNOSC) <> nil then
           FieldByName(sZLETYPSKLADW_KOLEJNOSC).AsString := KolejnoscEdit.Text;
        Post;
      finally
        VState := vsNormal;
      end;
    end;
end;

procedure TZLESkladnikKontroliWartosciowejDBDetailForm.BeforeShow;
begin
  inherited;
  FormatMaskEdit.EditMask := '9' + DecimalSeparator + '9;1;_';
  //if OpenMode <> omNew then
  FormatMaskEdit.Text := DMAQFbN(sZLESKLADWART_FORMAT).AsString
  //else ZLEDM.DajDefaultPola( sZLESKLADWART, sZLESKLADWART_FORMAT );
end;

function TZLESkladnikKontroliWartosciowejDBDetailForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLESkladnikKontroliWartosciowejDataModule.CreateOpen( Self, InheritedMasterKeyValues, AOpenMode );
end;

procedure TZLESkladnikKontroliWartosciowejDBDetailForm.InitializeControls;
begin
  inherited;
  with SymulacjaDBCheckBox do begin
    DataField := sZLESKLADWART_SYMULACJA;
    ValueChecked := sUNICONST_ALTERNATYWA_TAK;
    ValueUnchecked := sUNICONST_ALTERNATYWA_NIE;
  end;

  if (Owner.Owner.ClassName = TZLETypZleceniaDBDetailForm.ClassName) and
     ((Owner as TZLESkladnikKontroliWartosciowejDBGridForm).FormIsContained) then begin
     KolejnoscEdit.Visible := True;
     KolejnoscLabel.Visible := True;

     if Parameters.Values[sZLETYPSKLADW_KOLEJNOSC] <> '' then
        KolejnoscEdit.Text := Parameters.Values[sZLETYPSKLADW_KOLEJNOSC];
  end else begin
     KolejnoscEdit.Visible := False;
     KolejnoscLabel.Visible := False;
  end;
end;

procedure TZLESkladnikKontroliWartosciowejDBDetailForm.InitializeObjectFields;
begin
  inherited;
end;

procedure TZLESkladnikKontroliWartosciowejDBDetailForm.InternalOpen;
begin
  FTableName := sZLESKLADWART;
  inherited;
end;

procedure TZLESkladnikKontroliWartosciowejDBDetailForm.SetDefaults;
begin
  inherited;
  try
    (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := True;
    DMAQFbN(sZLESKLADWART_SYMULACJA).AsString := ZLEDM.DajDefaultPola( sZLESKLADWART,
                                                                       sZLESKLADWART_SYMULACJA );

    DMAQFbN(sZLESKLADWART_FORMAT).AsString    := ZLEDM.DajDefaultPola( sZLESKLADWART,
                                                                       sZLESKLADWART_FORMAT );
    {DMAQFbN(sZLESKLADWART_KOLEJNOSC).AsString := RecordCount??};
  finally
    (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := False;
  end;
end;

function TZLESkladnikKontroliWartosciowejDBDetailForm.Validate: Boolean;
begin
  KontrolaWartosciowa := true;
  result := inherited Validate();
  if result then begin
    {Maksymalna precyzja 6 - ograniczenie pola w bazie danych}
    if (FormatMaskEdit.Text[1] < '1') or (FormatMaskEdit.Text[1] > '9') or
       (FormatMaskEdit.Text[3] < '0') or (FormatMaskEdit.Text[3] > '6') then begin
      result := false;
      FormatMaskEdit.SetFocus;
      Komunikat(cError, 'Bdny format');
    end else begin
      DMAQFbN(sZLESKLADWART_FORMAT).AsString := FormatMaskEdit.Text;
    end;
  end;

  if not result then exit;

end;

initialization
  FormManager.RegisterForm( TZLESkladnikKontroliWartosciowejDBDetailForm,
                            'Skadnik kontroli wartociowej', sZLEModulID );

end.
