unit ZLESkladnikiECPDefDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When         Who      What
---------------------------------------------------------------------------------------------
2009-02-19   Tomjen   Utworzone
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, ExtCtrls, UNIComponentsUnit, Db, DBTables, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  UNIStaleUnit, UNIDataModuleUnit;

type
  TZLESkladnikiECPDefDBGridForm = class(TUNIDBGridForm)
    DaneToolBar: TUNIToolBar;
    PrzyciskiOsadzoneToolBar: TUNIToolBar;
    DopiszToolButton: TToolButton;
    UsunToolButton: TToolButton;
    procedure NewMenuItemClick(Sender: TObject);
    procedure DeleteMenuItemClick(Sender: TObject);
  protected
    m_bContained: Boolean;
    procedure BeforeShow; override;
    function  CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure New; override;
    procedure Delete; override;
  public
    procedure UstawPrzyciskiOsadzone;
  end;

var
  ZLESkladnikiECPDefDBGridForm: TZLESkladnikiECPDefDBGridForm;

implementation

uses
  ZLEDefUnit,
  ZLEDataManagerUnit,
  ZLESkladnikiECPDefUnit,
  FormManagerUnit,
  SQLManagerUnit,
  MAGDefUnit,
  Dodatki,
  UniDataManagerUnit,
  KDPRADefUnit,
  KDPRADataManagerExtUnit,
  KDDefUnit,
  KDDataManagerExtUnit,
  UniSysDataManagerUnit,
  UniqueKeyUnit,
  ZleParametrySelectFormUnit;

{$R *.DFM}

function TZLESkladnikiECPDefDBGridForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  Result := TZLESkladnikiECPDefDataModule.CreateOpen( self, nil {DefaultMasterKeyValues}, AOpenMode);
end;

procedure TZLESkladnikiECPDefDBGridForm.BeforeShow;
begin
  inherited;
  if (OpenModeFlags and omContained) = omContained then begin
    m_bContained    := true;
//    m_iTrybOtwarcia := omOverVirtual + omShowModal;
//    m_iTrybOtwarcia := omShowModal;
  end;
  UstawPrzyciskiOsadzone;
end;

procedure TZLESkladnikiECPDefDBGridForm.UstawPrzyciskiOsadzone;
begin
  DaneToolBar.Visible := m_bContained;

  if m_bContained then begin
    UsunToolButton.Enabled   := (DeleteMenuItem.Visible and DeleteMenuItem.Enabled);
    DopiszToolButton.Enabled := (NewMenuItem.Visible    and NewMenuItem.Enabled);
    {Wyczenie Pokaz oraz Zmien}
    EditMenuItem.Enabled := False;
    EditMenuItem.Visible := False;
    ViewMenuItem.Enabled := False;
    ViewMenuItem.Visible := False;
  end;
end;


procedure TZLESkladnikiECPDefDBGridForm.Delete;
begin
  DataModule.Delete;
end;

procedure TZLESkladnikiECPDefDBGridForm.New;
begin
//  inherited;
//  DataModule.New;
//  (owner as TASOAsortDBDetailForm).DodajKontoM;
end;

procedure TZLESkladnikiECPDefDBGridForm.NewMenuItemClick(Sender: TObject);
var
  qLista: TUNIQuery;
  v: TUNIDBGridForm;
begin
  inherited;
  if DataManagers.Available(sKDPRAModulID) then begin
     qLista := KDDM.KDPokazIObsluzDane(sKDSKLADNIKCZASU,
                                       sKDAlias_SKLADNIKCZASU_ID + ';' +
                                       sKDAlias_SKLADNIKCZASU_SYMBOL + ';' +
                                       sKDAlias_SKLADNIKCZASU_NAZWA,
                                       sKDSKLADNIKCZASU_TYPPOLA1 + ' = ' + QuotedStr(sTYPPOLA_GODZINY),
                                       true,
                                       false,
                                       UNISYSDM.vAktywnaFirma{,
                                       laeSklNadg50.Tag,
                                       TKeyValues.CreateAs([cModulID + '=' + sKDRCPModulID])});

     //qLista := KDDM.PokazIObsluzDane(KDSKLADNIKCZASU, );
     if qLista <> nil then begin
       if Owner is TZleParametrySelectForm then begin
         v := TZleParametrySelectForm(Owner).ContainedForms[TZleParametrySelectForm(Owner).PanelECPIndex] as TUNIDBGridForm;
         with v.DataModule.ActiveQuery as TVirtualDataSet do begin
           while not qLista.Eof do begin
             try
               VState := vsInternalInsert;
               Insert;
               FieldByName(sZLESKLADNIKIECPDEF_ID).Value:= UniqueKey[sZLESKLADNIKIECPDEF];
               v.DataModule.SetTechnicalFieldsOnInsert;

               FieldByName(sKDSKLADNIKCZASU_ID).Value:= qLista.FieldByName(sKDSKLADNIKCZASU_ID).Value;
               UpdateModifiedRecordFlagsForAddedRecord;

               {A to tylko dla grida - bez statusu modyfikacji}
               FieldByName(sKDSKLADNIKCZASU_SYMBOL).Value := qLista.FieldByName(sKDSKLADNIKCZASU_SYMBOL).Value;
               FieldByName(sKDSKLADNIKCZASU_NAZWA).Value := qLista.FieldByName(sKDSKLADNIKCZASU_NAZWA).Value;
               Post;
             finally
               VState := vsNormal;
             end;
             qLista.Next;
           end;
         end;
       end;
     end;
  end;
end;

procedure TZLESkladnikiECPDefDBGridForm.DeleteMenuItemClick(
  Sender: TObject);
begin
  inherited;
  {--}
end;

initialization
  FormManager.RegisterForm(TZLESkladnikiECPDefDBGridForm, sZLEModulID);
end.
