unit ZLEStatusZleceniaImportSelectFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who     What
---------------------------------------------------------------------------------------------
2011-11-30 Tomjen  Utworzone
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNISelectFormUnit, Menus, UNIComponentsUnit, ToolWin, ComCtrls, StdCtrls,
  ExtCtrls,
  UNIRangeFormUnit, Mask, UNIDateEditUnit,
  KeyManagerUnit,DB;

type
  TZLEStatusZleceniaImportSelectForm = class(TUNISelectForm)
    StatZlecProgressBar: TUNIProgressBar;
    OgolnePanel: TUNIPanel;
    DefinicjaImportuGroupBox: TUNIGroupBox;
    DefinicjaImportuLabel: TUNILabel;
    DefinicjaImportuLookupAliasEdit: TUNILookupAliasEdit;
    OddzialPanel: TUNIPanel;
    OddzialLabel: TUNILabel;
    OddzialLookupAliasEdit: TUNILookupAliasEdit;
    procedure FormCreate(Sender: TObject);
    procedure DefinicjaImportuLookupAliasEditButtonClick(Sender: TObject);
    procedure DefinicjaImportuLookupAliasEditDelKey(Sender: TObject);
    function  DefinicjaImportuLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure OddzialLookupAliasEditButtonClick(Sender: TObject);
    procedure OddzialLookupAliasEditDelKey(Sender: TObject);
    function  OddzialLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
  private
    bExistINFModul     : boolean;
    ivAktywnaFirma:Integer;
    ivOddzial: integer;
    TabelaZlec, TabelaZlecPoz: string;
    iDefinicjaImportuID: integer;

    procedure Importuj;
  protected
    procedure InternalOpen; override;
    procedure BeforeShow; override;
    procedure SelectButtonPressed; override;
  public
    function GetHelpContext : string; override;
    function Validate: boolean; override;
  end;

implementation

uses
  BKDataManagerUnit,
  BKDefUnit,
  BOKDefUnit,
  Dodatki,
  FormManagerUnit,
  INFDataManagerExtUnit,
  INFDefUnit,
  LFKDatamanagerUnit,
  LFKDefUnit,
  RRDefUnit,
  SecurityManagerUnit,
  SQLManagerUnit,
  UNIDataManagerUnit,
  UNISysDataManagerUnit,
  UNISysDefUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit,
  FKDefUnit,
  RRDataManagerUnit;

{$R *.DFM}


function TZLEStatusZleceniaImportSelectForm.GetHelpContext;
begin
  result := cHelpRRKorespondencjaNotyImport;
end;

procedure TZLEStatusZleceniaImportSelectForm.InternalOpen;
begin
  FMinWidth := 580;
  FMinHeight := 200;

  inherited;
end;

procedure TZLEStatusZleceniaImportSelectForm.BeforeShow;
{var
  oQuery      : TUNIQuery;
  iLicznik    : integer;
  sSQL        : string;
  sResult     : string;
  sSymbolFirmy: string;
  sNazwaFirmy : string;}
begin
  ivAktywnaFirma:=vAktywnaFirma;
  bExistINFModul:=DataManagers.Available(sINFModulID);

  OddzialPanel.Visible := false;
  ActiveControl := DefinicjaImportuLookupAliasEdit;

  with DefinicjaImportuLookupAliasEdit do begin
    AliasManager     := UNISysDataManager.AliasManager;
    Alias_Name       := sUNISYSAlias_ImpSymbol;
    Alias_ID         := sUNISYSAlias_ImpID;
  end;

  {if vWielofirmowosc     and
     (Parameters <> NIL) then
  begin
    sResult:=Parameters.Values[sUNIODDZIAL_ID];
    if (sResult <>'') and (sResult <>'0') then
      ivAktywnaFirma:=StrToInt(sResult);
    if ivAktywnaFirma <> vAktywnaFirma then
    begin
      RRDajNazweFirmy( ivAktywnaFirma,
                       sSymbolFirmy,
                       sNazwaFirmy
                      );
      Caption:=Caption+' [Firma: '+sSymbolFirmy+']';
    end;
  end;

  HideStatusPanel;
  DataDateEdit.Date   := UNIDate;

  //Obsluzenie panelu oddzialu
  if not vWieloodzialowosc then begin
    OddzialPanel.Visible := false;
    ActiveControl := DefinicjaImportuLookupAliasEdit;
  end
  else begin
    OddzialPanel.Visible := true;
    ActiveControl := OddzialLookupAliasEdit;

    with OddzialLookupAliasEdit do begin
      AliasManager     := UNISysDataManager.AliasManager;
      Alias_ID         := sUniSysAlias_Oddzial_Id;
      Alias_Name       := sUniSysAlias_Oddzial_Symbol;
      AdditionalCondition := '@'+sUniSysAlias_OddzialRights_User_Id + '=' + IntToStr(SecurityManager.UserID);
    end;

    if UniSysDM.vOddzialyRozdzielneDane then
      OddzialLookupAliasEdit.aAllowEmpty := false;
  end;
 }
  if Parameters = nil then
    Parameters := TKeyValues.CreateEmpty;

  inherited;
end;

function TZLEStatusZleceniaImportSelectForm.Validate: boolean;
begin
  result := inherited Validate;
end;

procedure TZLEStatusZleceniaImportSelectForm.Importuj;
var
  //bPozycjaOK        : boolean;
  bTrans            : boolean;
  //iFirmaID          : integer;
  //iOddzialId        : integer;
  iLicznikPoz       : integer;
  iLicznikZm        : integer;
  iLicznikAll       : integer;
  iLicznikOK        : integer;
  iLicznikBlad      : integer;
  iLicznikOstrz     : integer;
  iRaportID         : integer;
  iStatus           : integer;
  iPos              : integer;
  oQueryUpdate      : TUNIQuery;
  sBlad             : string;
  sBladWiersz       : string;
  sItem             : string;
  sName             : string;
  sOpis             : string;
  sValue            : string;
  sListaIDZlec      : string;

  sZlecenieSymb     : String;
  sZlecOpis         : String;
  iZlecenieID       : Integer;
  iDataZakonczZlec  : Integer;

  aPozycje          : TArrayOfArrayOfString;
  oQueryZlec        : TUNIQuery;
  kvNaglowek        : TKeyValues;

  sZLEListaSprawPrzed, sZleStatusPrzed : String;

  procedure DodajDoRaportu(var iRaportID:integer;sErrorMessage:string;iErrorCode:integer);
  var
    iErrorFlag:integer;
  begin
    if iRaportID = -1 then
    begin
      //raport bdow trzeba zaoy
      iRaportID := UNISysDM.UNIRaportBledowDodajNowy( ivAktywnaFirma,
                                                      SecurityManager.UserID,
                                                      cZLEMODULZSI_ID,
                                                      false,
                                                      sUNISysRaportBledow_ZLE_ImportStatZlec,
                                                      iErrorFlag);
    end;
    //a teraz mona dodawa....
    iErrorFlag := UNISysDM.UniRaportBledowDodajPozycje( iRaportID,
                                                        iErrorCode,
                                                        sErrorMessage);
  end;

begin
  iRaportID:=-1;
  sListaIDZlec := '';
  oQueryZlec := nil;
  oQueryUpdate := nil;

  if iDefinicjaImportuID = 0 then
    Komunikat(cWarning, 'Nie wybrano definicji importu !')
  else begin
    try
      // importujemy dane z pliku
      kvNaglowek := TKeyValues.CreateEmpty;
      UNISysDM.UNIUniversalImport(iDefinicjaImportuID,iStatus,kvNaglowek,aPozycje);

      iLicznikOK        := 0;
      iLicznikBlad      := 0;
      iLicznikOstrz     := 0;
      iLicznikAll       := Length(aPozycje);
      if iStatus = 0 then begin
        // zerujemy zmienne
        sBlad             := '';
        sBladWiersz       := '';
        sOpis             := '';
        //bPozycjaOK        := true;

        bTrans := not SQLManager.InTransaction;
        if bTrans then SQLManager.StartTransaction;

        // przetwarzamy zaimportowane dane
        try
          for iLicznikPoz := 0 to Length(aPozycje)-1 do begin
            iZlecenieID := 0;
            iDataZakonczZlec := 0;
            sZlecenieSymb := '';
            sZlecOpis := '';

            // przetwarzamy zaimportowane dane pozycji
            for iLicznikZm := 0 to Length(aPozycje[iLicznikPoz])-1 do begin
              sItem  := aPozycje[iLicznikPoz, iLicznikZm];
              iPos   := Pos('=', sItem);
              sName  := Copy(sItem, 1, iPos-1);
              sValue := Copy(sItem, iPos+1, Length(sItem)-iPos);

              if sName = sImpMnemZlecSymbol_ID then
                sZlecenieSymb := sValue
              else
              if sName = sImpMnemZlec_ID_ID then begin
                if sValue <> '' then begin
                  iZlecenieID := StrToInt(sValue);
                  if sListaIDZlec <> '' then
                     sListaIDZlec := sListaIDZlec + ',';
                  sListaIDZlec := sListaIDZlec + IntToStr(iZlecenieID);
                end else begin
                  DodajDoRaportu(iRaportID,
                                 'Nie znaleziono zlecenie dla symbolu ' + sZlecenieSymb,
                                 999);
                  Inc(iLicznikBlad);
                  Break; //Przerwanie petli for iLicznikZm := 0 to Length(aPozycje[iLicznikPoz])-1
                end;
              end
              else
              if sName = sImpMnemDataZak_ID then begin
                if sValue <> '' then
                     iDataZakonczZlec := StrToInt(sValue)
                else iDataZakonczZlec := 0;
              end else
              if sName = sImpMnemZleOpis_ID then
                sZlecOpis := sValue;
            end; // for iLicznikZm := 0 to Length(aPozycje[iLicznikPoz])-1

            if iDataZakonczZlec = 0 then  begin
               //Zlecenie nie ma daty zakoczenia Pomijam je, zapisujac to w raporcie bedw
               DodajDoRaportu(iRaportID,
                              'Nie znaleziono zlecenia dla symbolu ' + sZlecenieSymb,
                              999);
               Inc(iLicznikBlad);
               Break; //Przerwanie petli for iLicznikZm := 0 to Length(aPozycje[iLicznikPoz])-1
            end;

            if iZlecenieID > 0 then begin
              {Pobieramy dane zlecenia modyfikowanego przez import}
              oQueryZlec := SQLManager.CreateQuery('SELECT ' +
                                                     sZLEZLECENIE_ID + ', ' +
                                                     sZLEZLECENIE_SYMBOL + ', ' +
                                                     sZLEZLECENIE_NAZWA + ', ' +
                                                     sZLEZLECENIE_STATUS + ', ' +
                                                     sZLEZLECENIE_DATA_OTW + ', ' +
                                                     sZLEZLECENIE_DATA_ZAMK + ', ' +
                                                     sZLEZLECENIE_OPIS + ' ' +
                                                   'FROM %s ' +
                                                   'WHERE ' + sZLEZLECENIE_ID + '=' + IntToStr(iZlecenieID),
                                                   [sZLEZLECENIE]);

              try
                 oQueryZlec.Open();
                 if not oQueryZlec.IsEmpty then begin
                    // iZlecenieID
                    sZLEStatusPrzed := oQueryZlec.FieldByName(sZLEZLECENIE_STATUS).AsString;
                    if ZLEDM.vZLEBlokadaEdycjiZakoncz and (oQueryZlec.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_ZakonczoneID) then begin
                       //Zapisujemy do raport bdw informacje, ze pominelimy to zlecenie
                       DodajDoRaportu(iRaportID,
                                      'Zlecenie o symbolu ' + sZlecenieSymb + ' ma status zakoczony a jest waczona blokada edycji zlece o takim statusie. Modyfikacja niemoliwa.',
                                       999);
                       Inc(iLicznikOstrz);
                       Continue; //Przerwanie petli for iLicznikZm := 0 to Length(aPozycje[iLicznikPoz])-1
                    end else begin
                      if DataManagers.Available(sBOKModulID) then  begin
                         sZleListaSprawPrzed  := SQLManager.OpenQueryWithResult('SELECT %s.JoinStrings(CURSOR(' +
                                                                                'SELECT DISTINCT ' + sBOKSPRAWA_ID + ' ' +
                                                                                'FROM %s WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID) + ')) FROM DUAL',
                                                                                ['DODATKI_PACKAGE', sZLEZLECENIEPOZ]);
                      end;

                      //Aktualizacja zlecenie
                      try
                         try
                           oQueryUpdate := SQLManager.UpdateQueryStep1(sZLEZLECENIE,
                                                                       sZLEZLECENIE_STATUS + ', ' +
                                                                       sZLEZLECENIE_DATA_ZAMK + ', ' +
                                                                       sZLEZLECENIE_OPIS,
                                                                       sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID));
                           oQueryUpdate.ParamByName(sZLEZLECENIE_STATUS).DataType := ftString;
                           oQueryUpdate.ParamByName(sZLEZLECENIE_DATA_ZAMK).DataType := ftDate;
                           oQueryUpdate.ParamByName(sZLEZLECENIE_OPIS).DataType := ftString;

                           oQueryUpdate.ParamByName(sZLEZLECENIE_STATUS).AsString := cZLEStatusZlecenia_ZakonczoneID;
                           oQueryUpdate.ParamByName(sZLEZLECENIE_DATA_ZAMK).AsDate := iDataZakonczZlec;
                           oQueryUpdate.ParamByName(sZLEZLECENIE_OPIS).AsString := sZlecOpis;

                           SQLManager.UpdateQueryStep2(oQueryUpdate);
                         except
                            Inc(iLicznikBlad);
                            DodajDoRaportu(iRaportID,
                              'Bd aktualizacji zlecenia o symbolu ' + sZlecenieSymb,
                              999);
                         end;
                      finally
                         if oQueryUpdate <> nil then FreeAndNil(oQueryUpdate);
                      end;
                      //Aktualizacja statusw spraw
                      if DataManagers.Available(sBOKModulID) then
                        ZLEDM.ZLEUstawStatusySpraw(iZlecenieID,
                                                   sZLEStatusPrzed,
                                                   sZleListaSprawPrzed);
                      Inc(iLicznikOK);
                    end;
                 end;
              finally
                FreeAndNil(oQueryZlec);
              end;
            end else begin
              DodajDoRaportu(iRaportID,
                             'Nie znaleziono zlecenie dla symbolu ' + sZlecenieSymb,
                             999);
              Inc(iLicznikBlad);
            end;
          end;
          if bTrans then SQLManager.Commit;
        except
          if bTrans then SQLManager.Rollback;
          DodajDoRaportu(iRaportID,
                         'Bd importu - zmiany nie zostay zapamietane',
                          999);
        end;
      end
      else Komunikat(cWarning, 'Bd odczytu/dekodowania pliku. Bd: '+
                     UNISysDM.UNIPodajSlowneRozwiniecieKoduBledu('',iStatus)+' !');

      //no i zamiatamy po sobie
      if kvNaglowek <> NIL then
        FreeAndNil(kvNaglowek);
      for iLicznikPoz := 0 to Length(aPozycje)-1 do
        SetLength(aPozycje[iLicznikPoz], 0);
      SetLength(aPozycje, 0);
      //if bTrans then
      //  SQLManager.Commit;

      //raport
      if (iLicznikAll = 0) then
      begin
        if (iStatus = 0) then
          Komunikat(cWarning, 'W pliku importu nie odnaleziono pozycji!');
        //else
          //bad odczytu - obsuony wczeniej
      end
      else if iLicznikBlad = 0 then
      begin
        if iLicznikOstrz  = 0 then
          Komunikat(cInformation, 'Wczytano '+IntToStr(iLicznikAll)+' poz.'+#13+
                                  'Wszystkie poprawne')
        else
        begin
          Komunikat(cInformation, 'Wczytano '+IntToStr(iLicznikAll)+' poz.'+#13+
                                  'Z ostrzezeniami');

          {iErrorFlag:=} UNISysDM.UNIRaportBledowZmien(iRaportID,
                                                    iLicznikAll,
                                                    iLicznikOstrz,
                                                    UNIDate,
                                                    Time);
          //UniSysDM.UNIPokazPojedynczyRaportBledow(iRaportID);
        end;
      end
      else
      begin
        if iLicznikBlad = iLicznikAll then
          Komunikat(cWarning, 'Nie wczytano adnej pozycji.'+#13+
                              'Wszystkie byy bdne lub niekompletne!')
        else
          Komunikat(cWarning, 'Odnaleziono '+IntToStr(iLicznikAll)+' poz.'+#13+
                              'Wczytano poprawnie '+IntToStr(iLicznikOK)+' poz.'+#13+
                              'Pominito bdnych '+IntToStr(iLicznikBLAD)+' poz.');
        {iErrorFlag:=} UNISysDM.UNIRaportBledowZmien(iRaportID,
                                                  iLicznikAll,
                                                  iLicznikBLAD,
                                                  UNIDate,
                                                  Time);
        //UniSysDM.UNIPokazPojedynczyRaportBledow(iRaportID);
      end;

      //i zamknicie okna
      //self.NiePytajPrzyRezygnacji:=true;
      Close;                  //wymusza wyjcie jak po Esc,
                              //ale ustawia Modalresult na mrCancel
      ModalResult:= mrOk;     //dlatego musze go tu przestawi
    except
      //if oQuery <> NIL then
      //  FreeAndNil(oQuery);
      if kvNaglowek <> NIL then
        FreeAndNil(kvNaglowek);

      raise;
    end;
  end;
end;

procedure TZLEStatusZleceniaImportSelectForm.SelectButtonPressed;
begin
  ModalResult:= mrNone;

  if not Validate then
    exit;

  StatZlecProgressBar.Min := 0;
  StatZlecProgressBar.Step := 1;
  StatZlecProgressBar.Position := 0;
  StatZlecProgressBar.Visible := true;

  Importuj;

  StatZlecProgressBar.Visible := false;

  ModalResult:= mrOk;

  inherited;
end;

procedure TZLEStatusZleceniaImportSelectForm.FormCreate(Sender: TObject);
begin
  TabelaZlec    := sZLEZLECENIE;
  TabelaZlecPoz := sZLEZLECENIEPOZ;
  inherited;
end;

procedure TZLEStatusZleceniaImportSelectForm.DefinicjaImportuLookupAliasEditButtonClick(Sender: TObject);
var
  oQuery : TUNIQuery;
begin
  try
    oQuery := UNISysDM.UNIPokazIObsluzDane(sUNIIMP,
      '@' + sUNISYSAlias_ImpModulZSIID + ' = ' + IntToStr(cZLEMODULZSI_ID),
      true, false,
      sUNISYSAlias_ImpID + ';' + sUNISYSAlias_ImpSymbol,
      ivAktywnaFirma,
      IntToStr(iDefinicjaImportuID)
    );
    if Assigned(oQuery) then
      DefinicjaImportuLookupAliasEditSetData(oQuery);
  finally
    FreeAndNil(oQuery);
  end;
end;

procedure TZLEStatusZleceniaImportSelectForm.DefinicjaImportuLookupAliasEditDelKey( Sender: TObject);
begin
  iDefinicjaImportuID := 0;
  DefinicjaImportuLookupAliasEdit.Clear;
end;

function TZLEStatusZleceniaImportSelectForm.DefinicjaImportuLookupAliasEditSetData( AliasSrc: TDataSet): Boolean;
begin
  result := true;
  if AliasSrc <> nil then begin
    iDefinicjaImportuID                  := AliasSrc.Fields[0].AsInteger;
    DefinicjaImportuLookupAliasEdit.Text := AliasSrc.Fields[1].AsString;
  end;
end;

procedure TZLEStatusZleceniaImportSelectForm.OddzialLookupAliasEditButtonClick(Sender: TObject);
var
  oQuery: TUNIQuery;
  sWarunekPoz: string;
begin
  sWarunekPoz := '';
  if vWielofirmowosc then
    sWarunekPoz := '@' + sUniSysAlias_Oddzial_Id + ' = ' + IntToStr(ivAktywnaFirma);

  oQuery := UniSysDM.UNIPokazIObsluzDane(
      sUNIODDZIAL,
      '@'+sUniSysAlias_OddzialRights_User_Id + '=' + IntToStr(SecurityManager.UserID),
      false,
      true,
      sUniSysAlias_Oddzial_Id      + ';' +
        sUniSysAlias_Oddzial_Symbol+ ';' +
        sUniSysAlias_Oddzial_Nazwa,
      0,
      sWarunekPoz
    );

  if oQuery <> nil then
    with oQuery do
    try
      OddzialLookupAliasEditSetData(oQuery);
    finally
      Free;
    end;
end;

procedure TZLEStatusZleceniaImportSelectForm.OddzialLookupAliasEditDelKey(Sender: TObject);
begin
  ivOddzial := 0;
  OddzialLookupAliasEdit.Text := '';
end;

function TZLEStatusZleceniaImportSelectForm.OddzialLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
begin
  result := true;

  if AliasSrc <> nil then begin
    ivOddzial := AliasSrc.FieldByName(sUNIODDZIAL_ID).AsInteger;
    OddzialLookupAliasEdit.Text := AliasSrc.FieldByName(sUNIODDZIAL_SYMBOL).AsString;
  end;
end;

initialization
  FormManager.RegisterForm(TZLEStatusZleceniaImportSelectForm, sZLEModulID);
end.
