unit ZLESzczegoloweKosztyDBGridUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls, UNIDataModuleUnit, UNIStaleUnit;

type
  TZLESzczegoloweKosztyDBGridForm = class(TUNIDBGridForm)
    FuncButtonsPanel: TUNIPanel;
    ZmienButton: TUNIButton;
    DopiszButton: TUNIButton;
    UsunButton: TUNIButton;
    PokazButton: TUNIButton;
    procedure DopiszButtonClick(Sender: TObject);
    procedure ZmienButtonClick(Sender: TObject);
    procedure PokazButtonClick(Sender: TObject);
    procedure UsunButtonClick(Sender: TObject);
    procedure DBGridDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
  private
//    procedure OpenDetail(AMode: TOpenMode);
//    procedure DopiszPozycje();
  protected
    procedure New(); override;
    procedure Open(); override;
    procedure View(); override;
    procedure Delete(); override;
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure BeforeShow; override;
    procedure RefreshButtons;
  public
    procedure InternalOpen; override;
    procedure SetUserRights; override;
    procedure ReOpenDataSets(); override;
  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  SQLManagerUnit,
  SecurityManagerUnit,
  FormManagerUnit,
  UNIDBDetailFormUnit,
  MAGDataManagerExtUnit,
  KeyManagerUnit,
  UniSysDefUnit,
  ASODefUnit,
  MAGDefUnit,
  ZLEDefUnit,
  ZLEZlecenieDBGridFormUnit,
  ZLESzczegoloweKosztyUnit,
  ZLEDataManagerUnit;

{ TZLESzczegoloweKosztyDBGridForm }

procedure TZLESzczegoloweKosztyDBGridForm.BeforeShow;
begin
  inherited;
 // DataSource.DataSet.AfterScroll := ZmienPozycje;
  FuncButtonsPanel.Visible := (Parameters.Values[sZLESZCZEGOLY_RODZAJ] = sZLESZCZEGOLY_RODZAJ_R) and
                              ((OpenModeFlags and omContained) = omContained);
end;


procedure TZLESzczegoloweKosztyDBGridForm.SetUserRights;
begin
  with SecurityManager do begin
    Switch_View_HotKey(False);
    Switch_New_HotKey(False);
    Switch_Open_HotKey(False);
    Switch_Delete_HotKey(False);
    if Parameters <> nil then begin
      if Parameters.Values[sZLESZCZEGOLY_RODZAJ] = sZLESZCZEGOLY_RODZAJ_R then begin
        Switch_View_HotKey(SM_UserCanDo(sZLE_REJ_CZASU_PRACY_POKAZ));
        Switch_New_HotKey(SM_UserCanDo(sZLE_REJ_CZASU_PRACY_DOPISZ));
        Switch_Open_HotKey(SM_UserCanDo(sZLE_REJ_CZASU_PRACY_ZMIEN));
        Switch_Delete_HotKey(SM_UserCanDo(sZLE_REJ_CZASU_PRACY_USUN));
      end;
    end;
  end;
end;

function TZLESzczegoloweKosztyDBGridForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLESzczegoloweKosztyDataModule.CreateOpen( Self,
                                                        DefaultMasterKeyValues, {InheritedMasterKeyValues}
                                                        AOpenMode );
end;

procedure TZLESzczegoloweKosztyDBGridForm.InternalOpen;
begin
  inherited;
  SwitchEditorKeys(False);
  SetUserRights();
  RefreshButtons();
end;

procedure TZLESzczegoloweKosztyDBGridForm.ReOpenDataSets;
var s, sTmp: String;
    q: TUniQuery;
begin
  s := '';
  sTmp := '';
  inherited;
  if Owner is TZLEZlecenieDBGridForm then begin
    if ZLEDM.vZLEFormatGodzinLiczba then
         sTmp := ')) AS RAZEM '
    else sTmp := '/60)) AS RAZEM ';
    if Parameters.Values[sZLESZCZEGOLY_RODZAJ] = sZLESZCZEGOLY_RODZAJ_M then
       s := MAGDM.DajWartoscDlaZlecenia((Owner as TZLEZlecenieDBGridForm).DataModule.ActiveQuery.FieldByName(sZLEZLECENIE_ID).AsInteger)
    else begin
       q := SQLManager.CreateQuery('SELECT SUM(' + sZLEZASOBYPRACA_STAWKA + ' * (' + sZLEZASOBYPRACA_CZAS_PRACY + sTmp +
                                   'FROM %s ' +
                                   'WHERE ' + sZLECONST_RODZAJECP_ID + ' IN (' + QuotedStr(cZLERodzajECP_OsobaID) + ', ' + QuotedStr(cZLERodzajECP_ZasobID) + ') AND ' +
                                              sZLEZLECENIE_ID + ' = ' + IntToStr((Owner as TZLEZlecenieDBGridForm).DataModule.ActiveQuery.FieldByName(sZLEZLECENIE_ID).AsInteger),
                                   [sZLEZASOBYPRACA]);
       try
         q.Open;
         s := q.FieldByName('RAZEM').AsString;
         q.Close;
       finally
         FreeAndNil(q);
       end;
    end;

    if s <> '' then s := Format('%.2f', [StrToFloat(s)]);
    (Owner as TZLEZlecenieDBGridForm).PodsumowanieEdit.Text := s;
  end;

  RefreshButtons();
end;

procedure TZLESzczegoloweKosztyDBGridForm.New();
var
  oParams: TKeyValues;
  omMode: integer;
begin
  omMode := omNew or omShowModal;
  if (OpenModeFlags and omVirtual) = omVirtual then
    omMode := omMode or omOverVirtual;
  if Parameters = nil then
    oParams := TKeyValues.CreateEmpty
  else begin
    oParams := TKeyValues.CreateEmpty;
    oParams.Assign(Parameters);
  end;

  oParams.Add(sZLECONST_RODZAJECP_ID + '=' + cZLERodzajECP_ZasobID);  //Zasob/Osoba


  FormManager.OpenDBDetail(self, 'TZLEZasobyPracaDBDetailForm', omMode, oParams);
  //FormManager.OpenDBDetail(self, 'TZLEOsobyGodzDBDetailForm', omMode, oParams);

  if FormIsContained and (Owner is TZLEZlecenieDBGridForm) and
     (Parameters.Values[sZLESZCZEGOLY_RODZAJ] = sZLESZCZEGOLY_RODZAJ_R) then begin
       if ((Owner as TZLEZlecenieDBGridForm).FContainedForms.Count > (Owner as TZLEZlecenieDBGridForm).SzczegoloweKosztyRobociznyFormIndex) and
          ((Owner as TZLEZlecenieDBGridForm).SzczegoloweKosztyRobociznyFormIndex >= 0) then
          (Owner as TZLEZlecenieDBGridForm).RefreshDetail( True, (Owner as TZLEZlecenieDBGridForm).SzczegoloweKosztyRobociznyFormIndex);
  end;
  RefreshButtons();
end;

procedure TZLESzczegoloweKosztyDBGridForm.Open();
var
  oParams:  TKeyValues;
  omMode:   integer;
begin
  omMode := omEdit or omShowModal;
  if (OpenModeFlags and omVirtual) = omVirtual then
    omMode := omMode or omOverVirtual;
  if Parameters = nil then
    oParams := TKeyValues.CreateEmpty
  else begin
    oParams := TKeyValues.CreateEmpty;
    oParams.Assign(Parameters);
  end;
  oParams.Add(sZLECONST_RODZAJECP_ID + '=' + cZLERodzajECP_ZasobID);  //Zasob/Osoba
  //FormManager.OpenDBDetail(self, 'TZLEOsobyGodzDBDetailForm', omMode, oParams);
  FormManager.OpenDBDetail(self, 'TZLEZasobyPracaDBDetailForm', omMode, oParams);

  if FormIsContained and (Owner is TZLEZlecenieDBGridForm) and
     (Parameters.Values[sZLESZCZEGOLY_RODZAJ] = sZLESZCZEGOLY_RODZAJ_R) then begin
       if ((Owner as TZLEZlecenieDBGridForm).FContainedForms.Count > (Owner as TZLEZlecenieDBGridForm).SzczegoloweKosztyRobociznyFormIndex) and
          ((Owner as TZLEZlecenieDBGridForm).SzczegoloweKosztyRobociznyFormIndex >= 0) then
          (Owner as TZLEZlecenieDBGridForm).RefreshDetail( True, (Owner as TZLEZlecenieDBGridForm).SzczegoloweKosztyRobociznyFormIndex);
  end;
  RefreshButtons();
end;

procedure TZLESzczegoloweKosztyDBGridForm.View();
var
  oParams:  TKeyValues;
  omMode: integer;
begin
  omMode := omView or omShowModal;
  if (OpenModeFlags and omVirtual) = omVirtual then
    omMode := omMode or omOverVirtual;

  if Parameters = nil then
    oParams := TKeyValues.CreateEmpty
  else begin
    oParams := TKeyValues.CreateEmpty;
    oParams.Assign(Parameters);
  end;

  oParams.Add(sZLECONST_RODZAJECP_ID + '=' + cZLERodzajECP_ZasobID);  //Zasob/Osoba
  FormManager.OpenDBDetail(self, 'TZLEZasobyPracaDBDetailForm', omMode, oParams);
  //FormManager.OpenDBDetail(self, 'TZLEOsobyGodzDBDetailForm', omMode, oParams);
end;

procedure TZLESzczegoloweKosztyDBGridForm.Delete();
var
  oParams:  TKeyValues;
  omMode: integer;
begin
  omMode := omDelete or omShowModal;
  if (OpenModeFlags and omVirtual) = omVirtual then
    omMode := omMode or omOverVirtual;

  if Parameters = nil then
    oParams := TKeyValues.CreateEmpty
  else begin
    oParams := TKeyValues.CreateEmpty;
    oParams.Assign(Parameters);
  end;

  oParams.Add(sZLECONST_RODZAJECP_ID + '=' + cZLERodzajECP_ZasobID);  //Zasob/Osoba
  FormManager.OpenDBDetail(self, 'TZLEZasobyPracaDBDetailForm', omMode, oParams);
  //FormManager.OpenDBDetail(self, 'TZLEOsobyGodzDBDetailForm', omMode, oParams);

  if FormIsContained and (Owner is TZLEZlecenieDBGridForm) and
     (Parameters.Values[sZLESZCZEGOLY_RODZAJ] = sZLESZCZEGOLY_RODZAJ_R) then begin
       if ((Owner as TZLEZlecenieDBGridForm).FContainedForms.Count > (Owner as TZLEZlecenieDBGridForm).SzczegoloweKosztyRobociznyFormIndex) and
          ((Owner as TZLEZlecenieDBGridForm).SzczegoloweKosztyRobociznyFormIndex >= 0) then
          (Owner as TZLEZlecenieDBGridForm).RefreshDetail( True, (Owner as TZLEZlecenieDBGridForm).SzczegoloweKosztyRobociznyFormIndex);
  end;

  RefreshButtons();
end;


procedure TZLESzczegoloweKosztyDBGridForm.DopiszButtonClick(Sender: TObject);
begin
  inherited;
  New();
end;

procedure TZLESzczegoloweKosztyDBGridForm.ZmienButtonClick(Sender: TObject);
begin
  inherited;
  Open();
end;

procedure TZLESzczegoloweKosztyDBGridForm.PokazButtonClick(Sender: TObject);
begin
  inherited;
  View();
end;

procedure TZLESzczegoloweKosztyDBGridForm.UsunButtonClick(Sender: TObject);
begin
  inherited;
  Delete();
end;

procedure TZLESzczegoloweKosztyDBGridForm.RefreshButtons;
var
  bEmpty, bReadOnly: Boolean;
begin
  bEmpty := DataModule.ActiveQuery.IsEmpty;
  //bSelected := (DBGrid.SelectedRows.Count > 0);
  bReadOnly := OpenMode in [omDelete, omView]; //((OpenModeFlags and aReadOnly) = aReadOnly);

  with SecurityManager do begin
    UsunButton.Enabled   := not (bEmpty or bReadOnly); //(DeleteMenuItem.Visible and DeleteMenuItem.Enabled);
    DopiszButton.Enabled := not bReadOnly; //(NewMenuItem.Visible    and NewMenuItem.Enabled);
    ZmienButton.Enabled  := not (bEmpty or bReadOnly); //(EditMenuItem.Visible   and EditMenuItem.Enabled);
    PokazButton.Enabled  := not bEmpty; //(ViewMenuItem.Visible   and ViewMenuItem.Enabled);
  end;
end;

(*
procedure TZLESzczegoloweKosztyDBGridForm.DopiszPozycje;
begin
  OpenDetail(OmNew);
{  oQuery := nil;
  try
    sFieldList := sZLEALIAS_ZLECENIEPOZ_ID+';'+
                  sZLEALIAS_ZLECENIEPOZ_LP+';'+
                  sZLEALIAS_ZLECENIEZASOB_ZASOB_ID+';'+
                  sZLEALIAS_ZLEZASOB_STAWKA+';'+
                  sZLEALIAS_ZLEZASOB_NAZWA+';'+
                  sZLEALIAS_ZLEZASOB_RODZAJ+';'+
                  sZLEALIAS_RODZAJZASOBU_V+';';


                  sZLEOSOBYGODZ_ID + ';' +
                  sZLEOSOBYGODZ_ID + ';' +
                  sZLEOSOBYGODZ_ID + ';' +
                  sZLEOSOBYGODZ_ID + ';' +
                  sZLEOSOBYGODZ_ID + ';' +
                  sZLEOSOBYGODZ_ID + ';' +
                  sZLEOSOBYGODZ_ID + ';' +
                  sZLEOSOBYGODZ_ID + ';' +
                  sZLEOSOBYGODZ_ID + ';' +

    if DataManagers.Available(sBOKModulID) then
       sFieldList := sFieldList + sZLEALIAS_BOKSPRAWA_NUMER+';';

    sFieldList := sFieldList + sZLEALIAS_ZLECENIEPOZ_ASORT_ID+';'+
                               sZLEALIAS_ASORT_INDEKS+';'+
                               sZLEALIAS_ASORT_NAZWA+';'+
                               sZLEALIAS_ZLECENIEPOZ_OPIS;

    oQuery := ZLEDM.ZLEOdpytajODane( sZLEZLECENIEPOZ,
                                     sFieldList,
                                     '(@'+sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID+'='+Parameters.Values[sZLEZLECENIE_ID]+')and'+
                                     '(@'+sZLEALIAS_ZLECENIEZASOB_ZLECENIE_ID+'='+Parameters.Values[sZLEZLECENIE_ID]+')',
                                     False, sZLEALIAS_ZLECENIEPOZ_ID );
    if oQuery <> nil then begin
      while not oQuery.Eof do begin
        with (DataModule.ActiveQuery as TVirtualDataSet) do begin
          if not Locate( sZLEZLECENIEPOZ_ID+';'+sZLEZASOB_ID,
                         VarArrayOf([ oQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger,
                                      oQuery.FieldByName(sZLEZASOB_ID).AsInteger]), [] ) then
            try
              VState := vsInternalInsert;
              Append;

              FieldByName(sZLEZLECENIEROZL_ID).AsInteger := UniqueKey[sZLEOSOBYGODZ];
              FieldByName(sZLEZLECENIEPOZ_ID).AsInteger := oQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger;
              FieldByName(sZLEZASOB_ID).AsInteger := oQuery.FieldByName(sZLEZASOB_ID).AsInteger;
              FieldByName(sZLEZLECENIEROZL_STAWKA).AsFloat := oQuery.FieldByName(sZLEZASOB_STAWKA).AsFloat;
              SetTechnicalFieldsOnInsert();
              UpdateModifiedRecordFlagsForAddedRecord();
              if DataManagers.Available(sBOKModulID) then
                 FieldByName(sBOKSPRAWA_NUMER).AsString := oQuery.FieldByName(sBOKSPRAWA_NUMER).AsString;

              FieldByName(sZLEZASOB_NAZWA).AsString := oQuery.FieldByName(sZLEZASOB_NAZWA).AsString;
              FieldByName(sZLEZASOB_RODZAJ).AsString := oQuery.FieldByName(sZLEZASOB_RODZAJ).AsString;
              FieldByName(sZLECONST_RODZAJZASOBU_V).AsString := oQuery.FieldByName(sZLECONST_RODZAJZASOBU_V).AsString;
              FieldByName(sASOASORT_ID).AsString := oQuery.FieldByName(sASOASORT_ID).AsString;
              FieldByName(sASOASORT_INDEKS).AsString := oQuery.FieldByName(sASOASORT_INDEKS).AsString;
              FieldByName(sASOASORT_NAZWA).AsString := oQuery.FieldByName(sASOASORT_NAZWA).AsString;
              FieldByName(sZLEZLECENIEPOZ_OPIS).AsString := oQuery.FieldByName(sZLEZLECENIEPOZ_OPIS).AsString;

              if FindField(sZLEZLECENIEPOZ_LP) <> nil then
                 FieldByName(sZLEZLECENIEPOZ_LP).AsString := oQuery.FieldByName(sZLEZLECENIEPOZ_LP).AsString;

              Post;
            finally
              VState := vsNormal;
            end;
        end;
        oQuery.Next;
      end;
    end;
  finally
    if oQuery <> nil then oQuery.Free;
  end;
  DataModule.Post();}
end;
*)

(*
procedure TZLESzczegoloweKosztyDBGridForm.OpenDetail(AMode: TOpenMode);
var
 oForm: TUNIDBDetailForm;
 oParams: TKeyValues;
 AOpenMode: TOpenMode;
begin
  oForm := nil;
  oParams := nil;
  AOpenMode := AMode or omHidden or omVirtual;
  try
    oParams := TKeyValues.CreateEmpty();
    if AMode = omEdit then begin
       with oParams do begin
         Add( cFORM_CAPTION+'='+'Rozliczenie pozycji zlecenia' );
       //  Add( sASOASORT_ID+'='+DMAQFbN(sASOASORT_ID).AsString );
       //  Add( sZLEZLECENIEPOZ_OPIS+'='+DMAQFbN(sZLEZLECENIEPOZ_OPIS).AsString );
       end;
    end else begin
       with oParams do begin
         Add( cFORM_CAPTION+'='+'Nowa pozycja rozliczenia' );
         //Add( sASOASORT_ID+'='+DMAQFbN(sASOASORT_ID).AsString );
         if Owner is TZLEZlecenieDBGridForm then
            Add( sZLEZLECENIE_ID + '=' + TZLEZLECENIEDBGridForm(Owner).DataModule.ActiveQuery.FieldByName(sZLEZLECENIE_ID).AsString);
       end;
    end;

    oParams.Add(sZLECONST_RODZAJECP_ID + '=' + cZLERodzajECP_ZasobID);  //Zasob/Osoba

    oForm := FormManager.OpenDBDetail(self, 'TZLEZasobyPracaDBDetailForm', AOpenMode, oParams);
    {oForm := FormManager.OpenDBDetail( Self, 'TZLEOsobyGodzDBDetailForm',
                                       AOpenMode, oParams );}
    if oForm.ShowModal = mrOK then begin
      ReOpenDataSets();
      if FormIsContained and (Owner is TZLEZlecenieDBGridForm) then
        (Owner as TZLEZlecenieDBGridForm).RefreshDetail( True, (Owner as TZLEZlecenieDBGridForm).SzczegoloweKosztyRobociznyFormIndex );
    end;
  finally
    if oForm <> nil then oForm.Free;
    if oParams <> nil then FreeAndNil(oParams);
  end;
end;
*)

procedure TZLESzczegoloweKosztyDBGridForm.DBGridDrawColumnCell(
  Sender: TObject; const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
  s: string;
begin
  inherited;
  if Column.Field <> Nil then begin
    s:= Column.Field.AsString;
    if (Uppercase(Column.FieldName) = Uppercase(sZLESZCZEGOLY_ILOSC)) then begin
      if ZLEDM.vZLEFormatGodzinLiczba then
           s := FormatFloat('### ##0.00', DMAQFbN(sZLESZCZEGOLY_ILOSC).AsFloat)
      else s := FormatFloat('### ### ##0', Round(DMAQFbN(sZLESZCZEGOLY_ILOSC).AsFloat * 60.0) div 60) + ':' + FormatFloat('00', Round(DMAQFbN(sZLESZCZEGOLY_ILOSC).AsFloat * 60.0) mod 60);
      DBGrid.WriteText(DBGrid.Canvas, Rect, s, Column.Alignment);
    end else begin
     // if Column.Field.Value <> Nil then
           DBGrid.WriteText(DBGrid.Canvas, Rect, Column.Field.DisplayText, Column.Alignment);
      //else DBGrid.WriteText(DBGrid.Canvas, Rect, '', Column.Alignment);
    end;
  end;
end;

initialization
  FormManager.RegisterForm( TZLESzczegoloweKosztyDBGridForm, sZLEModulID );
end.
