unit ZLESzczegoloweKosztyUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables, ZLEDefUnit;

type
  TZLESzczegoloweKosztyDataModule = class(TUNIDataModule)
  private
    ZlecenieID: Integer;
    OkresID: Integer;
    RodzajKosztow: TZleRodzajKosztow;
    bSprawy: Boolean;
    bElementINF: Boolean;
    procedure SetParams();
    procedure InitializeObjectFields();
  protected
    procedure GetKeys; override;
    function GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;
    procedure OpenDataSets(); override;
    procedure SetFieldsFormat;
  public
     destructor Destroy(); override;
    procedure ReOpenDataSets(); override;
    procedure RefreshDataSets(); override;
  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  SQLManagerUnit,
  UNIFormUnit,
  UNIDBGridFormUnit,
  UNISysDataManagerUnit,
  UNIDataManagerUnit,
  UNIStaleUnit,
  SystemDefUnit,
  ASODefUnit,
  ASODataManagerExtUnit,
  BOKDefUnit,
  INFDefUnit,
  MAGDefUnit,
  UNISysDefUnit,
  ZLEDataManagerUnit;

{ TZLESzczegoloweKosztyDataModule }

destructor TZLESzczegoloweKosztyDataModule.Destroy();
begin
  if ListQuery <> nil then FreeAndNil(ListQuery);
  inherited destroy;
end;

procedure TZLESzczegoloweKosztyDataModule.GetKeys;
begin
  if RodzajKosztow = rkRobocizna then begin
     FKeys.AddPrimary(sZLEZASOBYPRACA_ID);
     FKeys.Add(sZLEZLECENIE_ID);
  end else begin
     FKeys.AddPrimary('ROWNUM');
     FKeys.Add(sZLEZLECENIE_ID);
  end;
end;

function TZLESzczegoloweKosztyDataModule.GetTableName: string;
begin
  result := sZLEZLECENIE;
end;

procedure TZLESzczegoloweKosztyDataModule.InitializeGridQueryDefs;
begin
  InitializeObjectFields();
  SetParams();
  if GridColDefs.Count = 0 then with GridColDefs do begin
    AddRequiredAndUnvisible( sZLEZLECENIE_ID, 'M', '' );
    Add( sZLESZCZEGOLY_DATA, 'M', 'Data', True, True, taLeftJustify, 100 );

    if DataManagers.Available(sASOModulID) then begin
      Add( sASOASORT_SYMBOL, 'M', 'Symbol asort.', True, True, taLeftJustify, 100 );
      Add( sASOASORT_NAZWA, 'M', 'Nazwa asort.', False, True, taLeftJustify, 150 );
      Add( sUNIJM_SYMBOL, 'M', 'J.m.', False, True, taLeftJustify, 50 );
    end;

    if RodzajKosztow = rkMaterialy then begin
      AddRequiredAndUnvisible( 'ROWNUM', '', '' );
      Add( sZLESZCZEGOLY_CENA, 'M', 'Cena', True, True, taRightJustify, 100 );
      Add( 'PRZYCHOD_IL', 'M', 'Zuycie il.',false,true,taRightJustify,80,uftFloat);
      Add( 'ROZCHOD_IL',  'M', 'Zm. zuycia il.',false,true,taRightJustify,80,uftFloat);
      Add( 'SALDO_IL', 'M', 'Saldo zu. il.',false,true,taRightJustify,80,uftFloat);
      Add( 'Przychod', 'M','Zuycie',false,true,taRightJustify,80,uftCurrency, False, '#,##0.00');
      Add( 'Rozchod',  'M', 'Z,. zuycia',false,true,taRightJustify,80,uftCurrency, False, '#,##0.00');
      Add( 'Saldo', 'M', 'Saldo zuycia',false,true,taRightJustify,80,uftCurrency, False, '#,##0.00');

      Add( sUNIMAGAZYN_SYMBOL, 'M', 'Magazyn', True, True, taLeftJustify, 100 );
      Add( sMAGTYPDOK_SYMBOL, 'M', 'Typ dok.', True, True, taLeftJustify, 100 );
      Add( sMAGOBR_NR_DOK, 'M', 'Numer dok.', True, True, taLeftJustify, 100 );
      Add( sMAGOBRPOZ_LP, 'M', 'Pozycja dokumentu', True, True, taRightJustify, 60 );
      Add( sZLEZLECENIEPOZ_LP, 'M', 'Pozycja zlecenia', False, True, taRightJustify, 60 );

      Add( 'ZLECENIEPOZ_ASORT_NAZWA', 'M', 'Asortyment zlecenia', False, True, taLeftJustify, 80 );
      Add( 'ZLECENIEPOZ_ASORT_SYMBOL', 'M', 'Symbol asort. zlec.', False, True, taLeftJustify, 50 );
      Add( sMAGOBRPOZ_ZNAK, 'M', 'Znak', True, True, taLeftJustify, 50 );

      if ZLEDM.vZLENarzuty then begin
         Add( 'ZLEWSPNARZUTMAT', 'M', 'Wsp. narzutu mat.', True, True, taRightJustify,80,uftCurrency, False, '#,##0.000 ###');
         Add( 'SALDO_NARZUTMAT', 'M', 'Saldo z narzutem', True, True, taRightJustify,80,uftCurrency, False, '#,##0.00');
      end;

      if bSprawy then
        if DataManagers.Available(sBOKModulID) then begin
          Add( sBOKSPRAWA_NUMER, 'M', 'Nr zgoszenia', False, True, taLeftJustify, 60 );
          Add( sBOKSPRAWA_OBIEKTOPIS, 'M', 'Opis zgoszenia', False, True, taLeftJustify, 70, uftClob );
        end;

      if bElementINF then begin
         if DataManagers.Available(sINFModulID) then begin
            Add( sINFCONST_OBIEKT_V, 'M', 'Obiekt', False, True, taLeftJustify, 50 );
            Add( 'OBIEKT_SYMBOL', 'M', 'Obiekt - symbol', False, True, taLeftJustify, 50, uftClob );
         end;
      end;
    end else if RodzajKosztow = rkRobocizna then begin
      AddRequiredAndUnvisible( sZLEZASOBYPRACA_ID, 'M', '' );
      AddRequiredAndUnvisible( sZLEZLECENIEPOZ_ID, 'M', '' );
      AddRequiredAndUnvisible( sZLEZASOB_ID, 'M', '' );
      AddRequiredAndUnvisible( sBOKSPRAWA_ID, 'M', '' );
      Add( sZLESZCZEGOLY_CENA, 'M', 'Cena', True, True, taRightJustify, 100 );
      Add( sZLESZCZEGOLY_ILOSC, 'M', 'Ilo', True, True, taRightJustify, 100 );
      Add( sZLESZCZEGOLY_WARTOSC, 'M', 'Warto', True, True, taRightJustify, 100, uftFloat, False, '#,##0.00' );
      Add( sKDOSOBA_IMIE, 'M', 'Imi', True, True, taLeftJustify, 100 );
      Add( sKDOSOBA_NAZWISKO, 'M', 'Nazwisko', True, True, taLeftJustify, 100 );
      Add( sZLEZASOB_NAZWA, sZLEAlias_ZLEZASOB, 'Nazwa zasobu', True, True, taLeftJustify, 100 );
      Add( sZLEZLECENIEPOZ_LP, 'M', 'Pozycja zlecenia', False, True, taRightJustify, 60 );
      if ZLEDM.vZLENarzuty then begin
         Add( 'ZLEWSPNARZUTROB', 'M', 'Wsp. narzutu rob.', True, True, taRightJustify,80,uftCurrency, False, '#,##0.000 ###');
         Add( 'SALDO_NARZUTROB', 'M', 'Warto z narzutem', True, True, taRightJustify,80,uftCurrency, False, '#,##0.00');
      end;
    end;
  end;
  inherited;
end;

procedure TZLESzczegoloweKosztyDataModule.InitializeObjectFields;
var
  oQuery: TUNIQuery;
  sSQL: String;
begin
  bSprawy := False;
  bElementINF := False;
  sSQL := ZLEDM.ZLEOdpytajODaneSQL( sZLETYPZLEC, '#COUNT(@'+sZLEALIAS_TYPZLECENIA_TABPOWIAZANA+')'+';#'+QuotedStr(sZLETYPZLEC_TABPOWIAZANA)+' as NAZWA',
                                    '@'+sZLEALIAS_TYPZLECENIA_TABPOWIAZANA+'='+QuotedStr(sBOKSPRAWA),
                                    False );
  sSQL := sSQL+' UNION ALL '+
          ZLEDM.ZLEOdpytajODaneSQL( sZLETYPZLEC, '#COUNT(@'+sZLEALIAS_TYPZLECENIA_ELEMENTINF+')'+';#'+QuotedStr(sZLETYPZLEC_ELEMENTINF)+' as NAZWA',
                                    '@'+sZLEALIAS_TYPZLECENIA_ELEMENTINF+'='+QuotedStr(sUNICONST_ALTERNATYWA_TAK),
                                    False );
  oQuery := TUNIQuery.Create(nil);
  try
    SQLManager.OpenQuery( oQuery, sSQL, [] );
    if oQuery.Locate( 'NAZWA', sZLETYPZLEC_TABPOWIAZANA, [] ) then
      bSprawy := oQuery.Fields[0].AsInteger > 0;
    if oQuery.Locate( 'NAZWA', sZLETYPZLEC_ELEMENTINF, [] ) then
      bElementINF := oQuery.Fields[0].AsInteger > 0;
  finally
    oQuery.Free;
  end;
end;

procedure TZLESzczegoloweKosztyDataModule.OpenDataSets;
var
  oSplit: TSplit;
  iIndex: Integer;
  oField: TField;
  sOrderBy: String;
begin
  SetParams();
  if ListQuery <> nil then FreeAndNil(ListQuery);
  ListQuery := ZLEDM.ZleDajKosztyZleceniaSzczegolowo( ZlecenieID, OkresID, RodzajKosztow, nil {a_oParams: TKeyValues  = nil} );
  ListQuery.Open;
  if OrderByCols <> '' then begin
    oSplit := TSplit.Create( OrderByCols, ',', '' );
    try
      sOrderBy := '';
      for iIndex := 0 to oSplit.Count-1 do begin
        oField := ListQuery.Fields.FindField(UtnijNazweKorelacji(oSplit[iIndex]));
        if (oField <> nil) then begin
          if sOrderBy <> '' then sOrderBy := sOrderBy+',';
          sOrderBy := sOrderBy + IntToStr(oField.Index+1);
        end;
      end;
    finally
      if oSplit <> nil then oSplit.Free;
    end;
    if sOrderBy <> '' then begin
      ListQuery.Close;
      iIndex := Pos(' ORDER',UpperCase(ListQuery.SQL.Text));
      if iIndex > 0 then ListQuery.SQL.Text := Copy(ListQuery.SQL.Text,1,iIndex);
      ListQuery.SQL.Text := ListQuery.SQL.Text + ' ORDER BY ' + sOrderBy;
      ListQuery.Open;
    end;
  end;
  SetFieldsFormat();
end;

procedure TZLESzczegoloweKosztyDataModule.ReOpenDataSets;
begin
  inherited;
  FActiveQuery := ListQuery;
  (Owner as TUNIDBGridForm).DataSource.DataSet := FActiveQuery;
end;

procedure TZLESzczegoloweKosztyDataModule.RefreshDataSets;
begin
   ReOpendataSets;
end;

procedure TZLESzczegoloweKosztyDataModule.SetFieldsFormat;
begin
  if RodzajKosztow = rkRobocizna then begin
    if DataManagers.Available(sASOModulID) then begin
      (ListQuery.FieldByName(sZLESZCZEGOLY_CENA) as TNumericField).DisplayFormat := UNIGetMaskFromFormat(ASODM.vAsoFormatCeny);
      (ListQuery.FieldByName(sZLESZCZEGOLY_ILOSC) as TNumericField).DisplayFormat := UNIGetMaskFromFormat(ASODM.vAsoFormatIlosci);
    end else begin
      (ListQuery.FieldByName(sZLESZCZEGOLY_CENA) as TNumericField).DisplayFormat := UNIGetMaskFromFormat(12.2{ASODM.vAsoFormatCeny});
      (ListQuery.FieldByName(sZLESZCZEGOLY_ILOSC) as TNumericField).DisplayFormat := UNIGetMaskFromFormat(12.3{ASODM.vAsoFormatIlosci});
    end;
    (ListQuery.FieldByName(sZLESZCZEGOLY_WARTOSC) as TNumericField).DisplayFormat := UNIGetMaskFromFormat(12.2);
    if ZLEDM.vZLENarzuty then begin
      (ListQuery.FieldByName('SALDO_NARZUTROB') as TNumericField).DisplayFormat := UNIGetMaskFromFormat(12.2);
      (ListQuery.FieldByName('ZLEWSPNARZUTROB') as TNumericField).DisplayFormat := UNIGetMaskFromFormat(12.3);
    end;
  end else if RodzajKosztow = rkMaterialy then begin
    (ListQuery.FieldByName(sZLESZCZEGOLY_CENA) as TNumericField).DisplayFormat := UNIGetMaskFromFormat(ASODM.vAsoFormatCeny);
    (ListQuery.FieldByName('PRZYCHOD_IL') as TNumericField).DisplayFormat := UNIGetMaskFromFormat(ASODM.vAsoFormatIlosci);
    (ListQuery.FieldByName('ROZCHOD_IL') as TNumericField).DisplayFormat := UNIGetMaskFromFormat(ASODM.vAsoFormatIlosci);
    (ListQuery.FieldByName('SALDO_IL') as TNumericField).DisplayFormat := UNIGetMaskFromFormat(ASODM.vAsoFormatIlosci);
    (ListQuery.FieldByName('PRZYCHOD') as TNumericField).DisplayFormat := UNIGetMaskFromFormat(12.2);
    (ListQuery.FieldByName('ROZCHOD') as TNumericField).DisplayFormat := UNIGetMaskFromFormat(12.2);
    (ListQuery.FieldByName('SALDO') as TNumericField).DisplayFormat := UNIGetMaskFromFormat(12.2);
    if ZLEDM.vZLENarzuty then begin
      (ListQuery.FieldByName('SALDO_NARZUTMAT') as TNumericField).DisplayFormat := UNIGetMaskFromFormat(12.2);
      (ListQuery.FieldByName('ZLEWSPNARZUTMAT') as TNumericField).DisplayFormat := UNIGetMaskFromFormat(12.3);
    end;
  end;
end;

procedure TZLESzczegoloweKosztyDataModule.SetParams;
begin
  ZlecenieID := StrToIntDef((Owner as TUNIForm).Parameters.Values[sZLEZLECENIE_ID],0);
  OkresID := StrToIntDef((Owner as TUNIForm).Parameters.Values[sUNIOKRES_ID],0);
  if (Owner as TUNIForm).Parameters.Values[sZLESZCZEGOLY_RODZAJ] = sZLESZCZEGOLY_RODZAJ_M then
    RodzajKosztow := rkMaterialy
  else if (Owner as TUNIForm).Parameters.Values[sZLESZCZEGOLY_RODZAJ] = sZLESZCZEGOLY_RODZAJ_R then
    RodzajKosztow := rkRobocizna;
end;

initialization
  RegisterClass( TZLESzczegoloweKosztyDataModule );

end.
