unit ZLETypZleceniaDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-18 gdeyk    Utworzone
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls, UNIStaleUnit, UNIDataModuleUnit;

type
  TZLETypZleceniaDBGridForm = class(TUNIDBGridForm)
  private
    procedure InitializeControls();
    procedure OpenDetail( AOpenMode: TOpenMode );
  protected
    procedure New(); override;
    procedure Open(); override;
    procedure View(); override;
    procedure Delete(); override;
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure SetUserRights; override;
  public
    procedure InternalOpen(); override;
    function GetHelpContextSuffix: String; override;
  end;

implementation

{$R *.DFM}

uses
  FormManagerUnit,
  KeyManagerUnit,
  SecurityManagerUnit,
  UNISysDefUnit,
  ZLEDefUnit,
  ZLETypZleceniaUnit;

{ TZLETypZleceniaDBGridForm }

function TZLETypZleceniaDBGridForm.GetHelpContextSuffix: String;
{ przyrostki do obs-ugi:
 [brak przyrostka]                        Remonty              1.3.2                Definicje Typw zlece
 TZ                                       zlecenia             2.3                  Definicja Typw Zlece
}
begin
  result := '';
end;

function TZLETypZleceniaDBGridForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLETypZleceniaDataModule.CreateOpen( Self, DefaultMasterKeyValues, AOpenMode );
end;

procedure TZLETypZleceniaDBGridForm.Delete;
begin
  OpenDetail( omDelete );
end;

procedure TZLETypZleceniaDBGridForm.InitializeControls;
begin

end;

procedure TZLETypZleceniaDBGridForm.InternalOpen;
begin
  InitializeControls();

  if Parameters <> nil then begin
    if Parameters.Values[cFORM_CAPTION] <> '' then begin
      Caption := Parameters.Values[cFORM_CAPTION];
    end;
  end;
  
  inherited;

end;

procedure TZLETypZleceniaDBGridForm.New;
begin
  OpenDetail( omNew );
end;

procedure TZLETypZleceniaDBGridForm.Open;
begin
  OpenDetail( omEdit );
end;

procedure TZLETypZleceniaDBGridForm.OpenDetail(AOpenMode: TOpenMode);
var oParams: TKeyValues;
begin
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add( cFORM_CAPTION+'='+'Typ zlecenia');
    Add( sUNIODDZIAL_ID+'='+Parameters.Values[sUNIODDZIAL_ID]);
    Add( sUNIMODULZSI_ID+'='+Parameters.Values[sUNIMODULZSI_ID]);
  end;

  //na razie formatki detail modalne
  AOpenMode := AOpenMode + omShowModal;
  FormManager.OpenDBDetail( Self, cKlasaTypZlecenia+cSuffixKlasyDBDetail, AOpenMode,
                            oParams );
end;

procedure TZLETypZleceniaDBGridForm.SetUserRights;
begin
  with SecurityManager do begin
    Switch_View_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_TYP_ZLEC_POKAZ));
    Switch_New_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_TYP_ZLEC_DOPISZ));
    Switch_Open_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_TYP_ZLEC_ZMIEN));
    Switch_Delete_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_TYP_ZLEC_USUN));
  end;
end;

procedure TZLETypZleceniaDBGridForm.View;
begin
  OpenDetail( omView );
end;

initialization
  FormManager.RegisterForm( TZLETypZleceniaDBGridForm,
                            'Lista typw zlece', sZLEModulID );

end.
