unit ZLETypZleceniaUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-18 gdeyk    Utworzone
2005-12-27 Tomjen   Pola Uzytkownika
2007-07-31 Adam     Pole sZLETYPZLEC_PRODUKCYJNE
2008-03-12 Adam     Pole sZLETYPZLEC_WYMAG_RECEP
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLETypZleceniaDataModule = class(TUNIDataModule)
  private
    procedure DodajSkladnikiKosztow();
    procedure DodajSkladnikiIlosciowe();
  protected
    procedure GetKeys; override;
    function GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;
  public
    procedure Post; override;
    procedure Delete; override;
    constructor Create( AOwner: TComponent); override;
    procedure ReOpenDataSets(); override;
    procedure Open(); override;
  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  FormManagerUnit,
  QueryBuilderUnit,
  SecurityManagerUnit,
  UNIDataManagerUnit,
  SQLManagerUnit,
  UNIStaleUnit,
  UNISysDefUnit,
  UNISysDataManagerUnit,
  ASODefUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit,
  ZLETypZleceniaDBDetailFormUnit,
  UNIFormUnit,
  BOKDefUnit,
  LWPDefUnit;

{ TZLETypZleceniaDataModule }

constructor TZLETypZleceniaDataModule.Create(AOwner: TComponent);
begin
  inherited;
end;

procedure TZLETypZleceniaDataModule.Delete;
var bTrans: Boolean;
    sIlosc: String;
    i, iZleTypZlecID: Integer;
begin
  bTrans := False;
  try
    bTrans := SQLManager.InTransaction;
    if not bTrans then SQLManager.StartTransaction;

    iZleTypZlecID := ActiveQuery.FieldByName(sZLETYPZLEC_ID).AsInteger;
    if iZleTypZlecID > 0 then begin
       try
         sIlosc := SQLManager.OpenQueryWithResult('SELECT COUNT(*) FROM %s WHERE ' + sZLETYPZLEC_ID + '=' +
                                  IntToStr(iZleTypZlecID), [sZLEZLECENIE]);
       finally
          if StrToInt(sIlosc) > 0 then begin
             Komunikat(cError, 'Istnieje przynajmniej jedno zlecenie tego typu.'#13'Usunicie niemoliwe!');
             if not bTrans then SQLManager.Rollback;
             Abort;
          end;
       end;
    end;

    if (DataManagers.Available(sBOKModulID)) then begin
      if iZleTypZlecID > 0 then begin
         try
           sIlosc := SQLManager.OpenQueryWithResult('SELECT COUNT(*) FROM %s WHERE ' + sZLETYPZLEC_ID + '=' +
                                    IntToStr(iZleTypZlecID), [sBOKSPRAWAGRUPA]);
         finally
            if StrToInt(sIlosc) > 0 then begin
               Komunikat(cError, 'Istnieje grupa spraw wykorzystujca ten typ zlecenia.'#13'Usunicie niemoliwe!');
               if not bTrans then SQLManager.Rollback;
               Abort;
            end;
         end;
      end;
    end;

    (** POLA UZ **
    {Usunicie wszystkich wpisw z ZLEPOLAZMWSK dla typu zlecenia}
    if iZleTypZlecID > 0 then begin
      try
        SQLManager.ExecuteQuery('DELETE FROM %s ' +
                                'WHERE ' + sZLETYPZLEC_ID + '=' + IntToStr(iZleTypZlecID),
                                [sZLEPOLAZMWSK]);
      except
         Komunikat(cError, 'Bd przy usuwaniu pl uytkownika dla tego typu zlecenia');
         if not bTrans then SQLManager.Rollback;
         Abort;
      end;
    end;
    ** POLA UZ **)
    
    {Usunicie pl uytkownika przypisanych do typu zlecenia}
    for i := 0 to (Owner as TUNIForm).ContainedFormCount - 1 do begin
      ContainedDataModules[i].ActiveQuery.First();
      while(not ContainedDataModules[i].ActiveQuery.Eof) do
        ContainedDataModules[i].Delete();
      ContainedDataModules[i].Post();
    end;  // for i := 0 to (Owner as TUNIForm).ContainedFormCount - 1

    inherited;
    if not bTrans then SQLManager.Commit;
  except
    on EDMException do begin
      if bTrans then SQLManager.Rollback;
      if FLastDBError.SQLObjectName=sZLETYPZLEC+c_FRK+'3' then begin
        Komunikat( cError,'Typ zlecenia jest wykorzystywany jako grupujcy dla innych typw!');
        with owner as TZLETypZleceniaDBDetailForm do
          ActiveControl:= SymbolDBEdit;
      end else raise;
    end else begin
      if bTrans then SQLManager.Rollback;
      raise;
    end;
  end;
end;

procedure TZLETypZleceniaDataModule.DodajSkladnikiIlosciowe;
var iIndex: Integer;
    sSQL: String;
    aIDs: TIntegerArray;
    oInsertQuery, oUpdateQuery: TUNIQuery;
begin
  oInsertQuery := nil;
  try
    oInsertQuery := SQLManager.InsertQueryStep1( sZLETYPSKLADIL,
                                                 sZLETYPSKLADIL_ID+','+
                                                 sZLETYPZLEC_ID+','+
                                                 sZLESKLADIL_ID+','+
                                                 sZLETYPSKLADIL_UZ_AU_ID+','+
                                                 sZLETYPSKLADIL_DATA_AU );
    with oInsertQuery do begin
      ParamByName( sZLETYPZLEC_ID ).DataType := ftInteger;
      ParamByName( sZLESKLADIL_ID ).DataType := ftInteger;
      ParamByName( sZLETYPSKLADIL_UZ_AU_ID ).DataType := ftInteger;
      ParamByName( sZLETYPSKLADIL_DATA_AU ).DataType := ftDate;
    end;
    aIDs := (Owner as TZLETypZleceniaDBDetailForm).NoweSkladnikiKontroliIlosci.SkladnikiNowe;

    for iIndex := 0 to Length(aIDs)-1 do begin
      oInsertQuery.ParamByName( sZLETYPZLEC_ID ).AsInteger := ActiveQuery.FieldByName( sZLETYPZLEC_ID ).AsInteger;
      oInsertQuery.ParamByName( sZLESKLADIL_ID ).AsInteger := aIDs[iIndex];
      oInsertQuery.ParamByName( sZLETYPSKLADIL_UZ_AU_ID ).AsInteger := SecurityManager.UserId;
      oInsertQuery.ParamByName( sZLETYPSKLADIL_DATA_AU ).AsDateTime := UNINow;
      SQLManager.InsertQueryStep2( oInsertQuery, sZLETYPSKLADIL_ID );
    end;
  finally
    if oInsertQuery <> nil then oInsertQuery.Free;
  end;

  {Aktualizacja pola kolejno}
  aIDs := (Owner as TZLETypZleceniaDBDetailForm).NoweSkladnikiKontroliIlosci.SkladnikiAktywne;
  for iIndex := 0 to Length(aIDs)-1 do
  begin
    oUpdateQuery := nil;
    try
      oUpdateQuery := SQLManager.UpdateQueryStep1( sZLETYPSKLADIL,
                                                   sZLETYPSKLADIL_KOLEJNOSC,
                                                   sZLETYPZLEC_ID + '=' + IntToStr(ActiveQuery.FieldByName( sZLETYPZLEC_ID ).AsInteger) + ' AND ' +
                                                   sZLESKLADIL_ID + '=' + IntToStr(aIDs[iIndex]));
      with oUpdateQuery do begin
        ParamByName(sZLETYPSKLADIL_KOLEJNOSC).DataType := ftInteger;
//        ParamByName(sZLESKLADWART_ID).DataType := ftInteger;
      end;

      oUpdateQuery.ParamByName(sZLETYPSKLADIL_KOLEJNOSC).AsInteger := (Owner as TZLETypZleceniaDBDetailForm).NoweSkladnikiKontroliIlosci.GetKolejnosc(aIDs[iIndex]);
//      oUpdateQuery.ParamByName(sZLESKLADWART_ID).AsInteger := (Owner as TZLETypZleceniaDBDetailForm).NoweSkladnikiKontroliKosztow.GetKolejnosc(aIDs[iIndex]);
      SQLManager.UpdateQueryStep2(oUpdateQuery);
    finally
      if oUpdateQuery <> nil then FreeAndNil(oUpdateQuery);
    end;
  end;

  sSQL := 'delete from %%s sklad '+
          'where sklad.'+sZLETYPZLEC_ID+'=%d and sklad.'+sZLESKLADIL_ID+'=%d';
  aIDs := (Owner as TZLETypZleceniaDBDetailForm).NoweSkladnikiKontroliIlosci.SkladnikiUsuniete;

  for iIndex := 0 to Length(aIDs)-1 do begin
    SQLManager.ExecuteQuery( Format( sSQL, [ ActiveQuery.FieldByName( sZLETYPZLEC_ID ).AsInteger,
                                             aIDs[iIndex]] ), [sZLETYPSKLADIL] );
  end;
end;

procedure TZLETypZleceniaDataModule.DodajSkladnikiKosztow;
var iIndex: Integer;
    oInsertQuery, oUpdateQuery: TUNIQuery;
    sSQL: String;
    aIDs: TIntegerArray;
begin
  oInsertQuery := nil;
  try
    oInsertQuery := SQLManager.InsertQueryStep1( sZLETYPSKLADW,
                                                 sZLETYPSKLADW_ID+','+
                                                 sZLETYPZLEC_ID+','+
                                                 sZLESKLADWART_ID+','+
                                                 sZLETYPSKLADW_UZ_AU_ID+','+
                                                 sZLETYPSKLADW_DATA_AU );
    with oInsertQuery do begin
      ParamByName( sZLETYPZLEC_ID ).DataType := ftInteger;
      ParamByName( sZLESKLADWART_ID ).DataType := ftInteger;
      ParamByName( sZLETYPSKLADW_UZ_AU_ID ).DataType := ftInteger;
      ParamByName( sZLETYPSKLADW_DATA_AU ).DataType := ftDate;
    end;
    aIDs := (Owner as TZLETypZleceniaDBDetailForm).NoweSkladnikiKontroliKosztow.SkladnikiNowe;

    for iIndex := 0 to Length(aIDs)-1 do begin
      oInsertQuery.ParamByName( sZLETYPZLEC_ID ).AsInteger := ActiveQuery.FieldByName( sZLETYPZLEC_ID ).AsInteger;
      oInsertQuery.ParamByName( sZLESKLADWART_ID ).AsInteger := aIDs[iIndex];
      oInsertQuery.ParamByName( sZLETYPSKLADW_UZ_AU_ID ).AsInteger := SecurityManager.UserId;
      oInsertQuery.ParamByName( sZLETYPSKLADW_DATA_AU ).AsDateTime := UNINow;
      SQLManager.InsertQueryStep2( oInsertQuery, sZLETYPSKLADW_ID );
    end;
  finally
    if oInsertQuery <> nil then oInsertQuery.Free;
  end;

  {Aktualizacja pola kolejno}
  aIDs := (Owner as TZLETypZleceniaDBDetailForm).NoweSkladnikiKontroliKosztow.SkladnikiAktywne;
  for iIndex := 0 to Length(aIDs)-1 do
  begin
    oUpdateQuery := nil;
    try
      oUpdateQuery := SQLManager.UpdateQueryStep1( sZLETYPSKLADW,
                                                   sZLETYPSKLADW_KOLEJNOSC,
                                                   sZLETYPZLEC_ID + '=' + IntToStr(ActiveQuery.FieldByName( sZLETYPZLEC_ID ).AsInteger) + ' AND ' +
                                                   sZLESKLADWART_ID + '=' + IntToStr(aIDs[iIndex]));
      with oUpdateQuery do begin
        ParamByName(sZLETYPSKLADW_KOLEJNOSC).DataType := ftInteger;
//        ParamByName(sZLESKLADWART_ID).DataType := ftInteger;
      end;

      oUpdateQuery.ParamByName(sZLETYPSKLADW_KOLEJNOSC).AsInteger := (Owner as TZLETypZleceniaDBDetailForm).NoweSkladnikiKontroliKosztow.GetKolejnosc(aIDs[iIndex]);
//      oUpdateQuery.ParamByName(sZLESKLADWART_ID).AsInteger := (Owner as TZLETypZleceniaDBDetailForm).NoweSkladnikiKontroliKosztow.GetKolejnosc(aIDs[iIndex]);
      SQLManager.UpdateQueryStep2(oUpdateQuery);
    finally
      if oUpdateQuery <> nil then FreeAndNil(oUpdateQuery);
    end;
  end;

  sSQL := 'delete from %%s sklad '+
          'where sklad.'+sZLETYPZLEC_ID+'=%d and sklad.'+sZLESKLADWART_ID+'=%d';
  aIDs := (Owner as TZLETypZleceniaDBDetailForm).NoweSkladnikiKontroliKosztow.SkladnikiUsuniete;

  for iIndex := 0 to Length(aIDs)-1 do begin
    SQLManager.ExecuteQuery( Format( sSQL, [ ActiveQuery.FieldByName( sZLETYPZLEC_ID ).AsInteger,
                                             aIDs[iIndex]] ), [sZLETYPSKLADW] );
  end;
end;

procedure TZLETypZleceniaDataModule.GetKeys;
begin
  with FKeys do begin
    AddPrimary(sZLETYPZLEC_ID);
  end;
end;

function TZLETypZleceniaDataModule.GetTableName: string;
begin
  result := sZLETYPZLEC;
end;

procedure TZLETypZleceniaDataModule.InitializeGridQueryDefs;
begin
  if GridColDefs.Count = 0 then with GridColDefs do begin
    AddRequiredAndUnvisible( sZLETYPZLEC_ID, 'M', '');
    AddRequired( sZLETYPZLEC_SYMBOL, 'M', 'Symbol', True, taLeftJustify, 100);
    Add( sZLETYPZLEC_NAZWA, 'M', 'Nazwa', True, True, taLeftJustify, 200);
    AddRequiredAndUnvisible( sUNIODDZIAL_ID, 'M', '');

    if vWieloodzialowosc then begin
      Add( sUNIODDZIAL_Symbol, 'O', 'Oddzia', True, True, taLeftJustify, 100 );
      Add( sUNIODDZIAL_NAZWA, 'O', 'Nazwa oddziau', True, True, taLeftJustify, 200 );
    end else if vWielofirmowosc then begin
      Add( sUNIODDZIAL_SYMBOL, 'O', 'Firma', True, True, taLeftJustify, 100 );
      Add( sUNIODDZIAL_NAZWA, 'O', 'Nazwa firmy', True, True, taLeftJustify, 200 );
    end;

    AddRequiredAndUnvisible( sUNIAUTNUM_ID, 'M', '');
    Add( sUNIAUTNUM_NAZWA, 'AUTNUM', 'Numerator', True, True, taLeftJustify, 300);
    AddRequiredAndUnvisible( sZLETYPZLEC_GRUPUJACE, 'M', '' );
    Add( sUNICONST_ALTERNATYWA_V+';'+sZLETYPZLEC_GRUPUJACE+'_T', 'N1', 'Grupujce', True, True, taCenter, 100);
    AddRequiredAndUnvisible( sZLETYPZLEC_TYP_GRUPY_ID, 'M', '' );
    Add( sZLETYPZLEC_SYMBOL+';'+sZLETYPZLEC_TYP_GRUPY_ID+'_T1', 'TYP', 'Symbol typu grupy', True, True, taLeftJustify, 100 );
    Add( sZLETYPZLEC_NAZWA+';'+sZLETYPZLEC_TYP_GRUPY_ID+'_T2', 'TYP', 'Nazwa typu grupy', True, True, taLeftJustify, 100 );
    AddRequiredAndUnvisible( sZLETYPZLEC_KOSZTY, 'M', '');
    AddRequiredAndUnvisible( sZLETYPZLEC_KOSZTY_OKRES, 'M', '');
    AddRequiredAndUnvisible( sZLETYPZLEC_ILOSCI, 'M', '');
    AddRequiredAndUnvisible( sZLETYPZLEC_ILOSCI_OKRES, 'M', '');
    Add( sUNICONST_ALTERNATYWA_V+';'+sZLETYPZLEC_KOSZTY+'_T', 'N2', 'Koszty', True, True, taCenter, 50);
    Add( sUNICONST_ALTERNATYWA_V+';'+sZLETYPZLEC_KOSZTY_OKRES+'_T', 'N3', 'Koszty okresowe', True, True, taCenter, 50);
    Add( sUNICONST_ALTERNATYWA_V+';'+sZLETYPZLEC_ILOSCI+'_T', 'N4', 'Iloci', True, True, taCenter, 50);
    Add( sUNICONST_ALTERNATYWA_V+';'+sZLETYPZLEC_ILOSCI_OKRES+'_T', 'N5', 'Iloci okresowe', True, True, taCenter, 50);
    AddRequiredAndUnvisible( sZLETYPZLEC_ZASOBY, 'M', '' );
    Add( sUNICONST_ALTERNATYWA_V+';'+sZLETYPZLEC_ZASOBY+'_T', 'N6', 'Zasoby', True, True, taCenter, 50);
    AddRequiredAndUnvisible( sZLETYPZLEC_ILOSCI_ASOMAG, 'M', '');
    Add( sUNICONST_ALTERNATYWA_V+';'+sZLETYPZLEC_ILOSCI_ASOMAG+'_T', 'N7', 'Na Podst.Dok.Magaz.', True, True, taCenter, 50);
    AddRequiredAndUnvisible( sZLETYPZLEC_UWAGI, 'M', '');
    Add( sUNICONST_ALTERNATYWA_V+';'+sZLETYPZLEC_UWAGI+'_T', 'N8', 'Uwagi', True, True, taCenter, 50);
    AddRequiredAndUnvisible( sASOREG_ID, 'M', '' );
    if DataManagers.Available(sASOModulID) then
       Add( sUNIMODULZSI_NAZWA, 'MOD', 'Regua', True, True, taLeftJustify, 100 );
    AddRequiredAndUnvisible( sZLETYPZLEC_TABPOWIAZANA, 'M', '' );
    Add( sZLECONST_TABPOWIAZANE_V, 'TABPOW', 'Powizanie', True, True, taLeftJustify, 100 );
    Add( sZLETYPZLEC_DOM_NAZWA, 'M', 'Domylna nazwa', False, True, taLeftJustify, 100 );
    Add( sZLETYPZLEC_DOM_DATA_OTW, 'M', 'Podpowied daty otw.', False, True, taLeftJustify, 50 );
    AddRequiredAndUnvisible( sZLETYPZLEC_PROCENT_UE_A, 'M', '');
    AddRequiredAndUnvisible( sZLETYPZLEC_POJAZD_A, 'M', '');
    if(DataManagers.Available(sLWPModulID)) then begin
      Add( sZLETYPZLEC_PRODUKCYJNE, 'M', 'Zlecenia produkcyjne', False, True, taLeftJustify, 50 );
      Add( sZLETYPZLEC_WYMAG_RECEP, 'M', 'Wymagana receptura', False, True, taLeftJustify, 50 );
    end;
  end;
  if GridTabDefs.Count = 0 then with GridTabDefs do begin
    Add( 'M', GetTableName() );
    Add( 'N1', sUNICONST_ALTERNATYWA );
    Add( 'N2', sUNICONST_ALTERNATYWA );
    Add( 'N3', sUNICONST_ALTERNATYWA );
    Add( 'N4', sUNICONST_ALTERNATYWA );
    Add( 'N5', sUNICONST_ALTERNATYWA );
    Add( 'N6', sUNICONST_ALTERNATYWA );
    Add( 'N7', sUNICONST_ALTERNATYWA );
    Add( 'N8', sUNICONST_ALTERNATYWA );
    Add( 'TYP', sZLETYPZLEC );
    Add( 'AUTNUM', sUNIAUTNUM );
    if DataManagers.Available(sASOModulID) then begin
      Add( 'REG', sASOREG );
      Add( 'MOD', sUNIMODULZSI );
    end;
    Add( 'TABPOW', sZLECONST_TABPOWIAZANE );
    if vWieloodzialowosc or vWielofirmowosc then
       Add( 'O', sUNIODDZIAL );
  end;
  if GridJoinDefs.Count = 0 then with GridJoinDefs do begin
    AddSimple( 'M', 'N1', 'M.'+sZLETYPZLEC_GRUPUJACE+'=N1.'+sUNICONST_ALTERNATYWA_ID, qjkInner, true );
    AddSimple( 'M', 'TYP', 'M.'+sZLETYPZLEC_TYP_GRUPY_ID+'=TYP.'+sZLETYPZLEC_ID, qjkLeftOuter, true );
    AddSimple( 'M', 'N2', 'M.'+sZLETYPZLEC_KOSZTY+'=N2.'+sUNICONST_ALTERNATYWA_ID, qjkInner, true );
    AddSimple( 'M', 'N3', 'M.'+sZLETYPZLEC_KOSZTY_OKRES+'=N3.'+sUNICONST_ALTERNATYWA_ID, qjkInner, true);
    AddSimple( 'M', 'N4', 'M.'+sZLETYPZLEC_ILOSCI+'=N4.'+sUNICONST_ALTERNATYWA_ID, qjkInner, true);
    AddSimple( 'M', 'N5', 'M.'+sZLETYPZLEC_ILOSCI_OKRES+'=N5.'+sUNICONST_ALTERNATYWA_ID, qjkInner, true);
    AddSimple( 'M', 'N6', 'M.'+sZLETYPZLEC_ZASOBY+'=N6.'+sUNICONST_ALTERNATYWA_ID, qjkInner, true);
    AddSimple( 'M', 'N7', 'M.'+sZLETYPZLEC_ILOSCI_ASOMAG+'=N7.'+sUNICONST_ALTERNATYWA_ID, qjkInner, true);
    AddSimple( 'M', 'N8', 'M.'+sZLETYPZLEC_UWAGI+'=N8.'+sUNICONST_ALTERNATYWA_ID, qjkInner, true);

    if DataManagers.Available(sASOModulID) then begin
      AddSimple( 'M', 'REG', 'M.'+sASOREG_ID+'=REG.'+sASOREG_ID, qjkLeftOuter, true);
      AddSimple( 'REG', 'MOD', 'REG.'+sUNIMODULZSI_ID+'=MOD.'+sUNIMODULZSI_ID, qjkLeftOuter, True);
    end;

    AddSimple( 'M', 'TABPOW', 'M.'+sZLETYPZLEC_TABPOWIAZANA+'=TABPOW.'+sZLECONST_TABPOWIAZANE_ID, qjkLeftOuter, True);
    if vWieloodzialowosc or vWielofirmowosc then begin
       AddSimple( 'M', 'O', 'M.'+sUNIODDZIAL_ID+'=O.'+sUNIODDZIAL_ID, qjkLeftOuter, true);
       if vWielofirmowosc and (not (UNISysDM.vWielofirmowoscWieleFirm or ZLEDM.vZLEWspolneZlecenia)) then
          AddCondition( 'M.'+sUNIODDZIAL_ID+'='+IntToStr(vAktywnaFirma), true);
    end;
    AddSimple( 'M', 'AUTNUM', 'M.'+sUNIAUTNUM_ID+'=AUTNUM.'+sUNIAUTNUM_ID, qjkLeftOuter, true);
  end;
  inherited;
end;

procedure TZLETypZleceniaDataModule.Post;
var bTrans: Boolean;
begin
  bTrans := not SQLManager.InTransaction;
  if bTrans then SQLManager.StartTransaction;
  try
    if vWielofirmowosc and ActiveQuery.FieldByName(sUNIODDZIAL_ID).IsNull then
      ActiveQuery.FieldByName(sUNIODDZIAL_ID).AsInteger := vAktywnaFirma;
    inherited;
    //uaktualnienie listy skadnikw kosztowych
    DodajSkladnikiKosztow();
    //uaktualnienie listy skadnikw ilociowych
    DodajSkladnikiIlosciowe();

    {Przepisz pola do starych DataSet-w}
    {Zapis nowych pl}
    if TZLETypZleceniaDBDetailForm(owner).PolaUzNewFormIndex > -1 then
       ContainedDataModules[TZLETypZleceniaDBDetailForm(owner).PolaUzNewFormIndex].Post;

    if TZLETypZleceniaDBDetailForm(owner).PolaUzPozNewFormIndex > -1 then
       ContainedDataModules[TZLETypZleceniaDBDetailForm(owner).PolaUzPozNewFormIndex].Post;


    if TZLETypZleceniaDBDetailForm(owner).AuthorisedUsersFormIdx > -1 then
       ContainedDataModules[TZLETypZleceniaDBDetailForm(owner).AuthorisedUsersFormIdx].Post;

    (** POLA UZ **
    if TZLETypZleceniaDBDetailForm(owner).PolaUzFormIndex > -1 then
       ContainedDataModules[TZLETypZleceniaDBDetailForm(owner).PolaUzFormIndex].Post;

    if TZLETypZleceniaDBDetailForm(owner).PolaUzPozFormIndex > -1 then
       ContainedDataModules[TZLETypZleceniaDBDetailForm(owner).PolaUzPozFormIndex].Post;
    ** POLA UZ **)
    if bTrans then SQLManager.Commit;
  except
    on EDMException do begin
      if bTrans then SQLManager.Rollback;
      if Pos(sZLETYPZLEC+c_UNK, FLastDBError.SQLObjectName) > 0 then begin
        Komunikat( cError,'Istnieje ju typ zlecenia o takim symbolu!');
        with owner as TZLETypZleceniaDBDetailForm do
          ActiveControl:= SymbolDBEdit;
        abort;
      end else raise;
    end else begin
      if bTrans then SQLManager.Rollback;
      raise;
    end;
  end;
end;

procedure TZLETypZleceniaDataModule.Open;
var
  bSetFilter:boolean;

begin
  //----------------------------------------------------------------------------
  //dla tego dataset'a konieczne jest wyczenie filtrw globalnych
  //patrz opis w InitializeGridQueryDefs
  //----------------------------------------------------------------------------
  bSetFilter:=SQLManager.SQLFilterEnabled;
  try
    if ZLEDM.vZLEWylaczonyFiltrDlaTypu and (vWieloodzialowosc or vWielofirmowosc) then
       SQLManager.SQLFilterEnabled:=false;
    inherited;
  finally
    SQLManager.SQLFilterEnabled:=bSetFilter;
  end;
end;

procedure TZLETypZleceniaDataModule.ReOpenDataSets;
var
  bSetFilter:boolean;

begin
  //----------------------------------------------------------------------------
  //dla tego dataset'a konieczne jest wyczenie filtrw globalnych
  //patrz opis w InitializeGridQueryDefs
  //----------------------------------------------------------------------------
  bSetFilter:=SQLManager.SQLFilterEnabled;
  try
    if ZLEDM.vZLEWylaczonyFiltrDlaTypu and (vWieloodzialowosc or vWielofirmowosc) then
       SQLManager.SQLFilterEnabled:=false;
    inherited;
  finally
    SQLManager.SQLFilterEnabled:=bSetFilter;
  end;
end;

initialization
  FormManager.RegisterForm( TZLETypZleceniaDataModule,
                            'Modu danych dla typw zlece', sZLEModulID );
end.
