unit ZLETypZleceniaUsersDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who     What
---------------------------------------------------------------------------------------------
2011-06-24 Tomjen  Utworzenie
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls, UNIStaleUnit, UNIDataModuleUnit;

type
  TZLETypZleceniaUsersDBGridForm = class(TUNIDBGridForm)
  private
    procedure Detail(AOpenMode: TOpenMode);
  protected
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure View; override;
    procedure SetUserRights; override;
    procedure BeforeShow; override;
  public
    procedure New; override;
    procedure Delete; override;
    procedure Open; override;
    function GetHelpContext : string; override;
  end;

var
  ZLETypZleceniaUsersDBGridForm: TZLETypZleceniaUsersDBGridForm;

implementation

uses
  ZLETypZleceniaUsersUnit,
  FormManagerUnit,
  ZLEDefUnit,
  UniqueKeyUnit,
  UNIDBDetailFormUnit,
  Dodatki,
  ZLETypZleceniaDBDetailFormUnit,
  KeyManagerUnit,
  SecurityManagerUnit,
  SystemDefUnit,
  UNISysDataManagerUnit,
  UNISysDefUnit;

{$R *.DFM}

procedure TZLETypZleceniaUsersDBGridForm.Detail(AOpenMode: TOpenMode);
var
  i: integer;
  q: TUNIQuery;
  sWarunek: String;
begin
  if TUNIDBDetailForm(Owner).Parameters <> Nil then
    if TUNIDBDetailForm(Owner).Parameters.Values[sZLETypZlecUsers + 'EXCLUDED'] = '' then
      sWarunek := ''
    else
      sWarunek := sSMUSER_ID + ' NOT IN (' + TUNIDBDetailForm(Owner).Parameters.Values[sZLETypZlecUsers + 'EXCLUDED'] + ')'
  else
    sWarunek := '';
  i := TUNIDBDetailForm(Owner).DMAQFbN(sZLETypZlec_ID).AsInteger;
  if (AOpenMode = omNew) then begin
    q := UNISysDM.UNIPokazIObsluzDane(
       sSMUSER,
       sWarunek,
       False,
       False,
       sUNISYSALIAS_USER_ID + ';' + sADMAlias_UserNazwa,
       vAktywnaFirma
    );
    if q <> Nil then
      if not q.Fields[0].IsNull then
        if DataModule.ActiveQuery.Locate(sSMUSER_ID, q.Fields[0].Value, []) then
          Komunikat(cWarning, 'Ten uytkownik jest ju uprawniona do tego typu dokumentu')
        else
          with DataModule.ActiveQuery as TVirtualDataSet do begin
            VState := vsInternalInsert;
            try
              Append;
              FieldByName(sZLETypZlecUsers_ID).Value:= UniqueKey[sZLETypZlecUsers];
              FieldByName(sSMUSER_ID).Value:= q.Fields[0].Value;
              FieldByName(sZLETypZlec_ID).Value := i;
              SetTechnicalFieldsOnInsert;
              UpdateModifiedRecordFlagsForAddedRecord;
              FieldByName(sSMUSER_NAZWA).Value := q.Fields[1].Value;
              Post;
            finally
              VState := vsNormal;
            end;
          end;
  end else if (AOpenMode = omDelete) then begin
    DataModule.Delete;
  end;
  TZLETypZleceniaDBDetailForm(Owner).DeleteUserButton.Enabled := DeleteMenuItem.Enabled;
end;

procedure TZLETypZleceniaUsersDBGridForm.BeforeShow;
begin
  inherited;
  if Owner is TZLETypZleceniaDBDetailForm then begin
    ViewMenuItem.Visible := False;
    ViewMenuItem.Enabled := False;

    EditMenuItem.Visible := False;
    EditMenuItem.Enabled := False;

    TZLETypZleceniaDBDetailForm(Owner).DeleteUserButton.Enabled := DeleteMenuItem.Enabled
  end;
end;

function TZLETypZleceniaUsersDBGridForm.CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule;
begin
  Result := TZLETypZleceniaUsers.CreateOpen(Self, DefaultMasterKeyValues, AOpenMode);
  SwitchOffColumnsEditorToolButton;
end;

procedure TZLETypZleceniaUsersDBGridForm.Open;
begin
  Detail(omEdit);
end;

procedure TZLETypZleceniaUsersDBGridForm.New;
begin
  Detail(omNew);
end;

procedure TZLETypZleceniaUsersDBGridForm.View;
begin
  Detail(omView);
end;

procedure TZLETypZleceniaUsersDBGridForm.Delete;
begin
  Detail(omDelete);
end;

function TZLETypZleceniaUsersDBGridForm.GetHelpContext: string;
begin
  result := '';
end;

procedure TZLETypZleceniaUsersDBGridForm.SetUserRights;
begin
  with SecurityManager do begin
    Switch_New_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_TYP_ZLEC_ZMIEN_UPR));
    Switch_Delete_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_TYP_ZLEC_ZMIEN_UPR));
    Switch_Open_HotKey(False);
    Switch_View_HotKey(False);
  end;
end;

initialization
  FormManager.RegisterForm(TZLETypZleceniaUsersDBGridForm, sZLEModulID);
end.
