unit ZLETypZleceniaUsersUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who     What
---------------------------------------------------------------------------------------------
2011-06-24 Tomjen  Utworzenie
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLETypZleceniaUsers = class(TUNIDataModule)
  private
    idx: integer;
    procedure ChangeMasterKey;
  protected
    procedure GetKeys; override;
    function GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;
  end;

var
  ZLETypZleceniaUsers: TZLETypZleceniaUsers;

implementation

uses
  ZLEDefUnit,
  UNISysDefUnit,
  UNIStaleUnit,
  SQLManagerUnit,
  UNIFormUnit,
  QueryBuilderUnit,
  UNIDBGridFormUnit,
  SystemDefUnit;

{$R *.DFM}

procedure TZLETypZleceniaUsers.ChangeMasterKey;
begin
  GridJoinDefs.ExchangeCondition(idx,'W.' + MasterKeyValues[0], True);
end;

procedure TZLETypZleceniaUsers.GetKeys;
begin
  with FKeys do begin
    Clear;
    AddPrimary(sZLETypZlecUsers_ID);
  end;
end;

function TZLETypZleceniaUsers.GetTableName: string;
begin
  Result := sZLETypZlecUsers;
end;

procedure TZLETypZleceniaUsers.InitializeGridQueryDefs;
begin
  with GridColDefs do begin
    Clear;
    Add({sSMUSER_NAZWISKO + ' || '' '' || ' + sSMUSER_IMIE + ';' +} sSMUSER_NAZWA , 'S', 'Uytkownik', True, True, taLeftJustify, 200);
    AddRequiredAndUnvisible(sZLETypZlecUsers_ID, 'W', '');
    AddRequiredAndUnvisible(sZLETypZlec_ID, 'W', '');
    AddRequiredAndUnvisible(sSMUSER_ID, 'W', '');
  end;
  with GridTabDefs do begin
    Clear;
    Add('W', GetTableName);
    Add('S', sSMUSER);
  end;
  with GridJoinDefs do begin
    Clear;
    idx := AddEmptyCondition;
    ChangeMasterKey;
    AddExpres('W.' + sSMUSER_ID + ' = ' + 'S.' + sSMUSER_ID, qjkInner, True);
  end;
  inherited;
end;

end.
