unit ZLEWSPNarzutyDBDetailFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Modu dostarczajcy aktualizacje bazy.
Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2008-10-22 Tomjen   Utworzone
---------------------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBDetailFormUnit, Menus, UNIComponentsUnit, Db, ToolWin, ComCtrls,
  StdCtrls, ExtCtrls, Mask, DBCtrls,UNIStaleUnit, UNIDataModuleUnit,
  UNIDBConstComboBoxUnit;
  {UNISelectFormUnit, CheckLst, UNIRangeFormUnit, Buttons, Mask}

type
  TZLEWSPNarzutyDBDetailForm = class(TUNIDBDetailForm)
    OddzialPanel: TUNIPanel;
    JednostkaOrgPanel: TUNIPanel;
    TypZlecPanel: TUNIPanel;
    MainPanel: TUNIPanel;
    TypZleceniaLabel: TUNILabel;
    TypZleceniaDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    JednOrgLabel: TUNILabel;
    JednOrgDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    OddzialLabel: TUNILabel;
    OddzialDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    OddzialNazwaLabel: TUNILabel;
    OkresLabel: TUNILabel;
    WspNarzutRobLabel: TUNILabel;
    WSPNarzutRobDBEdit: TUNIDBEdit;
    WSPNarzutMatLabel: TUNILabel;
    WSPNarzutMATDBEdit: TUNIDBEdit;
    OkresDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    function OddzialDBLookupAliasEditGetDataField: String;
    function OddzialDBLookupAliasEditGetQuery: TUNIQuery;
    procedure OddzialDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function OddzialDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    function JednOrgDBLookupAliasEditGetDataField: String;
    function JednOrgDBLookupAliasEditGetQuery: TUNIQuery;
    procedure JednOrgDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function JednOrgDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    function TypZleceniaDBLookupAliasEditGetDataField: String;
    function TypZleceniaDBLookupAliasEditGetQuery: TUNIQuery;
    procedure TypZleceniaDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function TypZleceniaDBLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    function OkresDBLookupAliasEditGetDataField: String;
    function OkresDBLookupAliasEditGetQuery: TUNIQuery;
    procedure OkresDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function OkresDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
  private
    procedure InitializeControls();
    procedure SetDefaults;
    procedure SetFieldFormat();
  protected
//    function Validate(): Boolean; override;
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure InternalOpen; override;
    procedure BeforeShow; override;
  end;

var
  ZLEWSPNarzutyDBDetailForm: TZLEWSPNarzutyDBDetailForm;

implementation

{$R *.DFM}

uses FormManagerUnit,
     ZLEWSPNarzutyUnit,
     UniDataManagerUnit,
     UNISysDataManagerUnit,
     ZLEDataManagerUnit,
     ASODataManagerExtUnit,
     ASODefUnit,
     FKDefUnit,
     ZLEDefUnit,
     UNISysDefUnit,
     Dodatki;


procedure TZLEWSPNarzutyDBDetailForm.SetFieldFormat();
var
  fFormat: Double;
begin
  fFormat := 20.6;
  if WSPNarzutRobDBEdit.Field <> nil then
    with TNumericField(WSPNarzutRobDBEdit.Field) do begin
      EditFormat    := UNIGetMaskFromFormat(fFormat, True);
      DisplayFormat := UNIGetMaskFromFormat(fFormat);
    end;
  WSPNarzutRobDBEdit.aIntegerCount := Trunc(fFormat);
  WSPNarzutRobDBEdit.aDecimalCount := UNIGetFracFromValueFormat(fFormat);
  WSPNarzutRobDBEdit.aNumbersOnly  := True;

  if WSPNarzutMATDBEdit.Field <> nil then
    with TNumericField(WSPNarzutMATDBEdit.Field) do begin
      EditFormat    := UNIGetMaskFromFormat(fFormat, True);
      DisplayFormat := UNIGetMaskFromFormat(fFormat);
    end;
  WSPNarzutMATDBEdit.aIntegerCount := Trunc(fFormat);
  WSPNarzutMATDBEdit.aDecimalCount := UNIGetFracFromValueFormat(fFormat);
  WSPNarzutMATDBEdit.aNumbersOnly  := True;

  {if DataManagers.Available(sASOModulID) then begin
     ASODM.SetFormatForCena(WSPNarzutRobDBEdit, 20.6);
     ASODM.SetFormatForCena(WSPNarzutMATDBEdit, 20.6);
  end;}
end;

procedure TZLEWSPNarzutyDBDetailForm.InternalOpen;
begin
   InitializeControls();
   inherited;
   SetFieldFormat();
   if OpenMode = OmNew then SetDefaults();
end;

procedure TZLEWSPNarzutyDBDetailForm.InitializeControls();
begin
  TypZlecPanel.Visible := ZLEDM.vZLEPoziomNarzutowTypZlec;
  JednostkaOrgPanel.Visible := ZLEDM.vZLEPoziomNarzutowJednOrg;

  OddzialPanel.Visible := ZLEDM.vZLEPoziomNarzutowOddzial and (vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial);
  OddzialDBLookupAliasEdit.aAllowEmpty := not (vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial and ZLEDM.vZLEPoziomNarzutowOddzial);
end;

procedure TZLEWSPNarzutyDBDetailForm.SetDefaults;
begin
  (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := True;
  try
    DMAQFbN(sZLEWSPNarzuty_ROB).AsFloat := 1.000000;
    DMAQFbN(sZLEWSPNarzuty_MAT).AsFloat := 1.000000;
    if vWielofirmowosc and ZLEDM.vZLEPoziomNarzutowOddzial then
       DMAQFbN(sUNIODDZIAL_ID).AsInteger := vAktywnaFirma;

  finally
    (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := False;
  end;
end;



procedure TZLEWSPNarzutyDBDetailForm.BeforeShow;
begin
  inherited;  { --}
end;

function TZLEWSPNarzutyDBDetailForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  Result := TZLEWSPNarzutyDataModule.CreateOpen( self, DefaultMasterKeyValues, AOpenMode);
end;

function TZLEWSPNarzutyDBDetailForm.OddzialDBLookupAliasEditGetDataField: String;
begin
  result := sUNIODDZIAL_ID;
end;

function TZLEWSPNarzutyDBDetailForm.OddzialDBLookupAliasEditGetQuery: TUNIQuery;
var
  sWar: String;
begin
  result  := nil;
  if not OpenMode in [omNew,omEdit] then exit;

  if not DMAQFbN(sUNIODDZIAL_ID).IsNull then
    sWar:=sUNIODDZIAL_ID+'='+DMAQFbN(sUNIODDZIAL_ID).AsString
  else
    sWar:='';
  Result:=UNISysDM.UNIPokazIObsluzDane( sUNIODDZIAL, '', True, False,
                                        sUNISYSALIAS_Oddzial_ID+';'+
                                        sUNISYSALIAS_Oddzial_Symbol+';'+
                                        sUNISYSALIAS_Oddzial_Nazwa,
                                        vAktywnaFirma, sWar);
end;

procedure TZLEWSPNarzutyDBDetailForm.OddzialDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  inherited;
  if vWieloodzialowosc or vWielofirmowosc then begin
    with OddzialDBLookupAliasEdit do begin
      AliasManager := UNISysDM.AliasManager;
      Alias_ID := sUNISYSALIAS_Oddzial_ID;
      Alias_Name := sUNISYSALIAS_Oddzial_Symbol;
      AdditionalAliases := sUNISYSALIAS_Oddzial_Nazwa;
    end;
  end;
end;

function TZLEWSPNarzutyDBDetailForm.OddzialDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  result := True;
  if AliasSrc <> nil then begin
    OddzialDBLookupAliasEdit.Hint := AliasSrc.FieldByName(sUNIODDZIAL_NAZWA).AsString;
    OddzialNazwaLabel.Caption := AliasSrc.FieldByName(sUNIODDZIAL_NAZWA).AsString;
  end;
end;

function TZLEWSPNarzutyDBDetailForm.JednOrgDBLookupAliasEditGetDataField: String;
begin
  result := sUNIJEDNOSTKAORG_ID;
end;

function TZLEWSPNarzutyDBDetailForm.JednOrgDBLookupAliasEditGetQuery: TUNIQuery;
var
  sWarPoz: String;
begin

   sWarPoz := '';
   if not DMAQFbN(sUNIJEDNOSTKAORG_ID).IsNull then
      sWarPoz := sUNIJEDNOSTKAORG_ID + '=' + IntToStr(DMAQFbN(sUNIJEDNOSTKAORG_ID).AsInteger);


   Result := UNISysDataManager.UNIPokazIObsluzDane(sUNIJEDNOSTKAORG, '', false, false,
                     sUNISysAlias_JednostkaOrg_ID + ';' +
                     sUNISysAlias_JednostkaOrg_Symbol + ';' +
                     sUNISysAlias_JednostkaOrg_Nazwa,
                     vAktywnaFirma);
end;

procedure TZLEWSPNarzutyDBDetailForm.JednOrgDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with JednOrgDBLookupAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_ID := sUNISysAlias_JednostkaOrg_ID;
    Alias_Name := sUNISysAlias_JednostkaOrg_Symbol;
    AdditionalAliases := sUNISysAlias_JednostkaOrg_Nazwa;
  end;
end;

function TZLEWSPNarzutyDBDetailForm.JednOrgDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
    if (OpenMode in [omNew,omEdit])
       {and(JednOrgDBLookupAliasEdit.Initialized)} then begin
       DMAQFbN(sUNIJEDNOSTKAORG_ID).AsInteger := AliasSrc.FieldByName(sUNIJEDNOSTKAORG_ID).AsInteger;
    end;
  end else begin
    if (OpenMode in [omNew,omEdit]) then
       DMAQFbN(sUNIJEDNOSTKAORG_ID).Clear;
  end;
  result := True;
end;

function TZLEWSPNarzutyDBDetailForm.TypZleceniaDBLookupAliasEditGetDataField: String;
begin
  result := sZLETYPZLEC_ID;
end;

function TZLEWSPNarzutyDBDetailForm.TypZleceniaDBLookupAliasEditGetQuery: TUNIQuery;
begin
  result := ZLEDM.ZLEPokazIObsluzTypZlecenia( sZLEALIAS_TYPZLECENIA_ID+';'+
                                              sZLEALIAS_TYPZLECENIA_SYMBOL,
                                              '',
                                              false,
                                              false,
                                              cZLEMODULZSI_ID,
                                              DMAQFbN(sZLETYPZLEC_ID).AsInteger,
                                              vAktywnaFirma );
end;

procedure TZLEWSPNarzutyDBDetailForm.TypZleceniaDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with TypZleceniaDBLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_ID := sZLEALIAS_TYPZLECENIA_ID;
    Alias_Name := sZLEALIAS_TYPZLECENIA_SYMBOL;
  end;
end;

function TZLEWSPNarzutyDBDetailForm.TypZleceniaDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  result := true;
  if AliasSrc <> nil then begin
     if (OpenMode in [omNew,omEdit]) then
        DMAQFbN(sZLETYPZLEC_ID).AsInteger := AliasSrc.FieldByName(sZLETYPZLEC_ID).AsInteger;
     TypZleceniaDBLookupAliasEdit.Text := AliasSrc.FieldByName(sZLETYPZLEC_SYMBOL).AsString;
  end;
end;

function TZLEWSPNarzutyDBDetailForm.OkresDBLookupAliasEditGetDataField: String;
begin
  result := sUNIOKRES_ID;
end;

function TZLEWSPNarzutyDBDetailForm.OkresDBLookupAliasEditGetQuery: TUNIQuery;
begin
  {result := UNISysDM.UNIPokazIWybierzOkresObrachunkowy(
    vAktywnyRokObrachunkowyID,
    '',
    sUNISYSALIAS_Okres_Obrachunkowy_ID+';'+
    sUNISYSALIAS_Okres_Obrachunkowy_Nazwa+';'+
    sUNISYSALIAS_Okres_Obrachunkowy_Rok_ID,
    false,
    DMAQFbN(sUNIOKRES_ID).Value);}
  result := UniSysDataManager.UNIPokazIWybierzDefinicjeOkresowILat(
                   '',
                   False,
                   sUNISYSALIAS_Okres_Obrachunkowy_ID + ';' +
                   sUNISYSALIAS_Okres_Obrachunkowy_Nazwa + ';' +
                   sUNISYSALIAS_Okres_Obrachunkowy_Rok_ID + ';' +
                   sUNISYSALIAS_Rok_Rok_Text + ';' +
                   sUNISYSALIAS_Rok_Rok,
                   -1,
                   -1
        );

end;

procedure TZLEWSPNarzutyDBDetailForm.OkresDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with OkresDBLookupAliasEdit do begin
    AliasManager := UNISYSDM.AliasManager;
    Alias_ID := sUNISYSALIAS_Okres_Obrachunkowy_ID;
    Alias_Name := sUNISYSALIAS_Okres_Obrachunkowy_Nazwa;
    AdditionalAliases := sUNISYSALIAS_Okres_Obrachunkowy_Rok_ID + ';' +
                         sUNISYSALIAS_Rok_Rok_Text + ';' +
                         sUNISYSALIAS_Rok_Rok;
  end;
end;

function TZLEWSPNarzutyDBDetailForm.OkresDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  result := true;
  if AliasSrc <> nil then begin
     if (OpenMode in [omNew,omEdit]) then begin
        DMAQFbN(sUNIOKRES_ID).AsInteger := AliasSrc.FieldByName(sUNIOKRES_ID).AsInteger;
        DMAQFbN(sUNIROK_ID).AsInteger   := AliasSrc.FieldByName(sUNIROK_ID).AsInteger;
     end;
     OkresDBLookupAliasEdit.Text := AliasSrc.FieldByName(sUNIOKRES_NAZWA).AsString + ' ' + AliasSrc.FieldByName(sUNIROK_ROK_TEXT).AsString;
  end;
end;

initialization
  FormManager.RegisterForm(TZLEWSPNarzutyDBDetailForm, sZLEModulID);
end.
