unit ZLEWSPNarzutyDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Modu dostarczajcy aktualizacje bazy.
Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2008-10-22 Tomjen   Utworzone
---------------------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls, UNIStaleUnit, UNIDataModuleUnit;

type
  TZLEWSPNarzutyDBGridForm = class(TUNIDBGridForm)
    FunkcjeToolButton: TToolButton;
    FunkcjePopupMenu: TUNIPopupMenu;
    KopiujWspNarzutowMenuItem: TMenuItem;
    procedure DBGridDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure KopiujWspNarzutowMenuItemClick(Sender: TObject);
  private
    procedure OpenDetail(AOpenMode: TOpenMode);
  protected
    procedure New(); override;
    procedure Open(); override;
    procedure View(); override;
    procedure Delete(); override;
    function  CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure SetUserRights; override;
  public
    procedure InternalOpen(); override;
  end;

var
  ZLEWSPNarzutyDBGridForm: TZLEWSPNarzutyDBGridForm;

implementation
uses
  Dodatki,
  FormManagerUnit,
  UNIImageManagerUnit,
  SecurityManagerUnit,
  UNIDBDetailFormUnit,
  KeyManagerUnit,
  SQLManagerUnit,
  ZLEdefUnit,
  ZleWSPNarzutyUnit,
  ZLEDataManagerUnit,
  UNISysDefUnit;

{$R *.DFM}

procedure TZLEWSPNarzutyDBGridForm.KopiujWspNarzutowMenuItemClick(Sender: TObject);
var
  oQuery: TUNIQuery;
  sSQL, sAktOkres: String;
begin
  sAktOkres := '';
  sSQL := 'SELECT OK1.' + sUNIOKRES_ID + ', ' +
                 'OK1.' + sUNIOKRES_OKRES_NR + ', ' +
                 'RK1.' + sUNIROK_ROK + ', ' +
                 'OK1.' + sUNIROK_ID + ' ' +
          'FROM %s OK1, %s RK1 ' +
          'WHERE OK1.' + sUNIROK_ID + ' = RK1.' + sUNIROK_ID + ' AND ' +
                'OK1.' + sUNIOKRES_DATA_POCZ + ' = (SELECT MIN(' + sUNIOKRES_DATA_POCZ + ') ' +
                                               'FROM %s ' +
                                               'WHERE ' + sUNIOKRES_DATA_POCZ + ' > (SELECT MAX(' + sUNIOKRES_DATA_POCZ + ') ' +
                                                                                    'FROM %s OK, %s ZWN ' +
                                                                                    'WHERE OK.' + sUNIOKRES_ID +' = ZWN.' + sUNIOKRES_ID + '))';
  oQuery := SQLManager.CreateQuery(sSQL, [sUNIOKRES, sUNIROK, sUNIOKRES,
                                          sUNIOKRES, sZLEWSPNARZUTY]);
  try
    oQuery.Open();
    if not oQuery.IsEmpty then begin
      sAktOkres := oQuery.FieldByName(sUNIOKRES_OKRES_NR).AsString + '/' + oQuery.FieldByName(sUNIROK_ROK).AsString;
      if Komunikat(cConfirmation, 'Czy chcesz wygenerowa wspczynniki narzutw na okres '+ sAktOkres, MB_YesNo + MB_DEFBUTTON2) = idYes then begin
         try
            if not SQLManager.InTransaction then SQLManager.StartTransaction;
            //inserty do tabeli ZLEWSPNARZUTY
            SQLManager.ExecuteQuery('INSERT INTO %s (' + sZLEWSPNARZUTY_ID + ', ' +
                                                         sUNIODDZIAL_ID + ', ' +
                                                         sUNIJEDNOSTKAORG_ID + ', ' +
                                                         sZLETYPZLEC_ID + ', ' +
                                                         sUNIOKRES_ID + ', ' +
                                                         sUNIROK_ID + ', ' +
                                                         sZLEWSPNARZUTY_ROB + ', ' +
                                                         sZLEWSPNARZUTY_MAT + ', ' +
                                                         sZLEWSPNARZUTY_UZ_AU_ID + ', ' +
                                                         sZLEWSPNARZUTY_DATA_AU + ') ' +
                                    'SELECT %s.NEXTVAL, ' +
                                           sUNIODDZIAL_ID + ', ' +
                                           sUNIJEDNOSTKAORG_ID + ', ' +
                                           sZLETYPZLEC_ID + ', ' +
                                           IntToStr(oQuery.FieldByName(sUNIOKRES_ID).AsInteger) + ', ' +
                                           IntToStr(oQuery.FieldByName(sUNIROK_ID).AsInteger) + ', ' +
                                           sZLEWSPNARZUTY_ROB + ', ' +
                                           sZLEWSPNARZUTY_MAT + ', ' +
                                           IntToStr(SecurityManager.UserId) + ', ' +
                                           'SYSDATE ' +
                                    'FROM  %s ZWN1 ' +
                                    'WHERE ZWN1.' + sUNIOKRES_ID + ' = (SELECT ' + sUNIOKRES_ID + ' ' +
                                                                       'FROM %s ' +
                                                                       'WHERE ' + sUNIOKRES_DATA_POCZ + ' = (SELECT MAX(' + sUNIOKRES_DATA_POCZ + ') ' +
                                                                                                            'FROM %s OK, %s ZWN ' +
                                                                                                            'WHERE OK.' + sUNIOKRES_ID + ' = ZWN.' + sUNIOKRES_ID + '))',
                                  [sZLEWSPNARZUTY, 'SEQ_' + sZLEWSPNARZUTY,
                                   sZLEWSPNARZUTY, sUNIOKRES,
                                   sUNIOKRES, sZLEWSPNARZUTY]);
            if SQLManager.InTransaction then SQLManager.Commit;
            DataModule.ReOpenDataSets();
            Komunikat(cInformation, 'Wspczynniki narzutw zostay dopisane na okres ' + sAktOkres);
         except
           if SQLManager.InTransaction then SQLManager.Rollback();
           Komunikat(cError, 'Wystpi bd podczas dopisywania wspczynnikw.'#13 +
                             'Wspczynniki narzutw nie zostay dopisane');
           Raise;
         end;

      end;
    end else begin
      //Brak danych do skopiowania
      Komunikat(cInformation, 'Brak danych do skopiowania. Wspczynniki nie zostan wygenerowane');
    end;

  finally
    if oQuery <> nil then FreeAndNil(oQuery);
  end;
end;

function TZleWSPNarzutyDBGridForm.CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZleWSPNarzutyDataModule.CreateOpen(Self, DefaultMasterKeyValues, AOpenMode);
end;

procedure TZleWSPNarzutyDBGridForm.Delete;
begin
  OpenDetail(omDelete);
end;

procedure TZleWSPNarzutyDBGridForm.InternalOpen;
begin
  if Parameters <> nil then
     if Parameters.Values[cFORM_CAPTION] <> '' then
        Caption := Parameters.Values[cFORM_CAPTION];
  inherited;
   FunkcjeToolButton.ImageIndex:= cimPreselekcja;
end;

procedure TZleWSPNarzutyDBGridForm.DBGridDrawColumnCell(
  Sender: TObject; const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
  sTmp: string;
begin
  inherited;
  if Column.Field <> Nil then begin
    //s:= Column.Field.AsString;
    if (Uppercase(Column.FieldName) = Uppercase(sZLEWSPNARZUTY_ROB)) or
       (Uppercase(Column.FieldName) = Uppercase(sZLEWSPNARZUTY_MAT)) then begin
       sTmp := FormatFloat('##0.000 000', DMAQFbN(Column.FieldName).AsFloat);
       DBGrid.WriteText(DBGrid.Canvas, Rect, sTmp, Column.Alignment);
    end else begin
     // if Column.Field.Value <> Nil then
           DBGrid.WriteText(DBGrid.Canvas, Rect, Column.Field.DisplayText, Column.Alignment);
      //else DBGrid.WriteText(DBGrid.Canvas, Rect, '', Column.Alignment);
    end;
  end;
end;


procedure TZleWSPNarzutyDBGridForm.New;
begin
  OpenDetail(omNew);
end;

procedure TZleWSPNarzutyDBGridForm.Open;
begin
  OpenDetail(omEdit);
end;

procedure TZleWSPNarzutyDBGridForm.OpenDetail(AOpenMode: TOpenMode);
var
  oParams: TKeyValues;
begin
  inherited;
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add(cFORM_CAPTION+'='+'Szczegy rejestracji narzutw');
  end;

  AOpenMode := AOpenMode;
  FormManager.OpenDBDetail(Self, 'TZleWSPNarzutyDBDetailForm', AOpenMode, oParams);
end;

procedure TZleWSPNarzutyDBGridForm.View;
begin
  OpenDetail(omView);
end;

procedure TZleWSPNarzutyDBGridForm.SetUserRights;
begin
  with SecurityManager do begin
    Switch_View_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_NARZUTY_POKAZ));
    Switch_New_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_NARZUTY_DOPISZ));
    Switch_Open_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_NARZUTY_ZMIEN));
    Switch_Delete_HotKey(SM_UserCanDo(sZLE_USTAW_DEF_NARZUTY_USUN));

    //Kopiowanie aktywne gdy uytkownik ma prawo dopisywania narzutw
    KopiujWspNarzutowMenuItem.Enabled := SM_UserCanDo(sZLE_USTAW_DEF_NARZUTY_DOPISZ);
  end;
end;

initialization
  FormManager.RegisterForm( TZleWSPNarzutyDBGridForm, 'Rejestracja narzutw', sZLEModulID );
end.
