unit ZLEWSPNarzutyUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2008-10-22 Tomjen   Utworzenie
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLEWSPNarzutyDataModule = class(TUNIDataModule)
  protected
    procedure GetKeys;                  override;
    function  GetTableName: string;     override;
    procedure InitializeGridQueryDefs;  override;
  public
    procedure Post;   override;
    procedure Delete; override;
  end;

var
  ZLEWSPNarzutyDataModule: TZLEWSPNarzutyDataModule;

implementation

{$R *.DFM}
uses
  Dodatki,
  SQLManagerUnit,
  QueryBuilderUnit,
  SystemDefUnit,
  SecurityManagerUnit,
  UNIStaleUnit,
  UNIFormUnit,
  KeyManagerUnit,
  UNISysDefUnit,
  ZLEDataManagerUnit,
  FKDefUnit,
  INFDefUnit,
  ZLEDefUnit;

procedure TZLEWSPNarzutyDataModule.GetKeys;
begin
  FKeys.Add(sZLEWSPNarzuty_ID);
end;

function  TZLEWSPNarzutyDataModule.GetTableName: string;
begin
  result  := sZLEWSPNarzuty;
end;

procedure TZLEWSPNarzutyDataModule.InitializeGridQueryDefs;
begin
  with GridColDefs do
  begin
    Clear;
    AddRequiredAndUnvisible(sZLEWSPNarzuty_ID, 'M', '');
    AddRequiredAndUnvisible(sUNIJEDNOSTKAORG_ID, 'M', '');
    AddRequiredAndUnvisible(sZLETYPZLEC_ID, 'M', '');
    AddRequiredAndUnvisible(sUNIOKRES_ID, 'M', '');
    AddRequiredAndUnvisible(sUNIROK_ID, 'M', '');

    if vWielofirmowosc or (vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial) then
       AddRequiredAndUnvisible(sUNIODDZIAL_ID, 'M', '');

    if ZLEDM.vZLEPoziomNarzutowOddzial and (vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial) then
       Add(sUNIODDZIAL_NAZWA, 'ODZ', 'Oddzia', true , true , taLeftJustify, 100);

    if ZLEDM.vZLEPoziomNarzutowJednOrg then
       Add(sUNIJEDNOSTKAORG_SYMBOL, 'J', 'Jednostka org.', true , true , taLeftJustify, 100);
    Add(sUNIOKRES_NAZWA, 'O', 'Okres', true , true , taLeftJustify, 100);
    Add(sUNIROK_ROK, 'R', 'Rok', true , true , taLeftJustify, 100);
    if ZLEDM.vZLEPoziomNarzutowtypZlec then begin
       Add(sZLETYPZLEC_SYMBOL, 'T', 'Symbol zlec.', true , true , taLeftJustify, 100);
       Add(sZLETYPZLEC_NAZWA, 'T', 'Typ zlecenia', true , true , taLeftJustify, 100);
    end;

    Add(sZLEWSPNarzuty_ROB, 'M', 'Narzuty robocizny', true , true , taRightJustify, 100);
    Add(sZLEWSPNarzuty_MAT, 'M', 'Narzuty materiaw', true , true , taRightJustify, 100);
  end;
  with GridTabDefs do
  begin
    Clear;
    Add('M', TableName);
    Add('O', sUNIOKRES);
    Add('R', sUNIROK);
    if ZLEDM.vZLEPoziomNarzutowtypZlec then
       Add('T', sZLETYPZLEC);

    if ZLEDM.vZLEPoziomNarzutowJednOrg then
       Add('J', sUNIJEDNOSTKAORG);

    if ZLEDM.vZLEPoziomNarzutowOddzial and (vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial) then
       Add('ODZ', sUNIODDZIAL);
  end;
  with GridJoinDefs do
  begin
    Clear;
    AddExpres('M.'+sUNIOKRES_ID +'='+'O.' +sUNIOKRES_ID, qjkLeftOuter, True);
    AddExpres('M.'+sUNIROK_ID +'='+'R.' +sUNIROK_ID, qjkLeftOuter, True);

    if ZLEDM.vZLEPoziomNarzutowtypZlec then
       AddExpres('M.'+sZLETYPZLEC_ID +'='+'T.' +sZLETYPZLEC_ID, qjkLeftOuter, True);

    if ZLEDM.vZLEPoziomNarzutowJednOrg then
       AddExpres('M.'+sUNIJEDNOSTKAORG_ID +'='+'J.' +sUNIJEDNOSTKAORG_ID, qjkLeftOuter, True);

    if vWielofirmowosc and ZLEDM.vZLEPoziomNarzutowOddzial then
       AddCondition('M.'+sUNIODDZIAL_ID +'='+IntToStr(vAktywnaFirma), true);

    if ZLEDM.vZLEPoziomNarzutowOddzial and (vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial) then begin
       AddExpres('M.'+sUNIODDZIAL_ID +'='+'ODZ.' +sUNIODDZIAL_ID, qjkLeftOuter, True);
    end;
  end;
  inherited;
end;


procedure TZLEWSPNarzutyDataModule.Post;
var
  bTrans: boolean;
  q: TUNIQuery;
  sSQL: String;
begin
  bTrans  := not SQLManager.InTransaction;
  if bTrans then SQLManager.StartTransaction;
  try
    if OpenMode = omNew then
      if vWielofirmowosc and ZLEDM.vZLEPoziomNarzutowOddzial then
        ActiveQuery.FieldByName(sUNIODDZIAL_ID).AsInteger := vAktywnaFirma;

    {Kontrola - czy ju nie wprowadzono danych o tym samym kluczu}
    sSQL := 'SELECT COUNT(*) FROM %s WHERE ' +
                sUNIOKRES_ID + '=' + ActiveQuery.FieldByName(sUNIOKRES_ID).AsString;

    if ZLEDM.vZLEPoziomNarzutowTypZlec then
       sSQL := sSQL + ' AND ' +
                sZLETYPZLEC_ID + '=' + ActiveQuery.FieldByName(sZLETYPZLEC_ID).AsString;

    if ZLEDM.vZLEPoziomNarzutowJednOrg then
       sSQL := sSQL + ' AND ' +
                sUNIJEDNOSTKAORG_ID + '=' + ActiveQuery.FieldByName(sUNIJEDNOSTKAORG_ID).AsString;

    if ZLEDM.vZLEPoziomNarzutowOddzial and (vWielofirmowosc or (vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial)) then
       sSQL := sSQL + ' AND ' +
                sUNIODDZIAL_ID + '=' + ActiveQuery.FieldByName(sUNIODDZIAL_ID).AsString;

    if OpenMode <> omNew then
       sSQL := sSQL + ' AND ' +
                '(' + sZLEWSPNARZUTY_ID + ' <> ' + ActiveQuery.FieldByName(sZLEWSPNARZUTY_ID).AsString + ')';

    q := SQLManager.CreateQuery(sSQL, [sZLEWSPNARZUTY]);
    try
      q.Open();
      if not q.IsEmpty then begin
         if q.Fields[0].AsInteger > 0 then begin
            {Istnieje ju taki wpis}
            raise EOF_ZLEException.Create( cError_WpisIstnieje,
                                          'Wystpuje ju wpis dla tego klucza');
         end;
      end;
    finally
      if q <> nil then FreeAndNil(q);
    end;
    inherited;
    if bTrans then SQLManager.Commit;
  except
    if bTrans then SQLManager.Rollback;
    raise;
  end;
end;

procedure TZLEWSPNarzutyDataModule.Delete;
var
  bTrans: boolean;
begin
  bTrans  := not SQLManager.InTransaction;
  if bTrans then SQLManager.StartTransaction;
  try
    inherited; //Usuniecie kryterium
    if bTrans then SQLManager.Commit;
  except
    if bTrans then SQLManager.Rollback;
    raise;
  end;
end;

end.
