unit ZLEZasobDBDetailFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2005-02-22 gdeyk    Utworzone
2007-09-27 Adam     Dodane pola 'Max obcienie' i 'Jednostka czasu'
2007-11-13 Adam     Dodane pole grupa kalendarzowa
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBDetailFormUnit, Menus, UNIComponentsUnit, Db, ToolWin, ComCtrls,
  StdCtrls, ExtCtrls, UNIStaleUnit, UNIDataModuleUnit, Mask, DBCtrls,
  UNIDBConstComboBoxUnit;

const
  cZLEZasobDBDetailFormClass = 'TZLEZasobDBDetailForm';

type
  TZLEZasobDBDetailForm = class(TUNIDBDetailForm)
    RodzajPanel: TUNIPanel;
    RodzajLabel: TUNILabel;
    RodzajDBConstComboBox: TUNIDBConstComboBox;
    StawkaLabel: TUNILabel;
    StawkaDBEdit: TUNIDBEdit;
    PracownikPanel: TUNIPanel;
    PracownikLabel: TUNILabel;
    PracownikDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    NazwaPanel: TUNIPanel;
    NazwaLabel: TUNILabel;
    NazwaDBEdit: TUNIDBEdit;
    JednOrgDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    JednOrgLabel: TUNILabel;
    LWPPanel: TUNIPanel;
    UNILabel1: TUNILabel;
    ObciazenieDBEdit: TUNIDBEdit;
    UNILabel2: TUNILabel;
    UNILabel3: TUNILabel;
    JednostkaLookupAliasEdit: TUNILookupAliasEdit;
    UNILabel4: TUNILabel;
    GrupaKalendarzowaLookupAliasEdit: TUNILookupAliasEdit;
    UNILabel5: TUNILabel;
    SymbolDBEdit: TUNIDBEdit;
    SymbolLabel: TUNILabel;
    function PracownikDBLookupAliasEditGetDataField: String;
    function PracownikDBLookupAliasEditGetQuery: TUNIQuery;
    procedure PracownikDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function PracownikDBLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    function JednOrgDBLookupAliasEditGetDataField: String;
    function JednOrgDBLookupAliasEditGetQuery: TUNIQuery;
    procedure JednOrgDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function JednOrgDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure JednostkaLookupAliasEditButtonClick(Sender: TObject);
    procedure JednostkaLookupAliasEditDelKey(Sender: TObject);
    function JednostkaLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure GrupaKalendarzowaLookupAliasEditButtonClick(Sender: TObject);
    procedure GrupaKalendarzowaLookupAliasEditDelKey(Sender: TObject);
    function GrupaKalendarzowaLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    procedure CancelButtonClick(Sender: TObject);
  private
    iNumeratorID: Integer;
    procedure InitializeControls();
    procedure SetDefaults();
    procedure FieldChange( Sender: TField );
    procedure ShowAliases();
  protected
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure InternalOpen; override;
    procedure BeforeShow(); override;
  public
    function Validate(): Boolean; override;
    procedure SelectButtonPressed; override;
    procedure CancelButtonPressed; override;    
  end;

implementation

{$R *.DFM}

uses
  UNIDataManagerUnit,
  FormManagerUnit,
  KeyManagerUnit,
  UNIDBGridFormUnit,
  Dodatki,
  UNISysDefUnit,
  UNISysDataManagerUnit,
  SystemDefUnit,
  ZLEDataManagerUnit,
{$ifdef build_all}
  LWPDataManagerUnit,
{$else}
  LWPDataManagerExtUnit,
{$endif}
  ZLEDefUnit,
  ZLEZasobUnit,
  LWPDefUnit;

{ TZLEZasobDBDetailForm }

function TZLEZasobDBDetailForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  if((Owner is TUNIDBGridForm) or (Parameters = nil) or (Parameters.IndexOfName(sZLEZASOB_ID) = -1)) then
    result := TZLEZasobDataModule.CreateOpen( Self, InheritedMasterKeyValues, AOpenMode )
  else if(Parameters.IndexOfName(sZLEZASOB_ID) > -1) then begin
    result := TZLEZasobDataModule.CreateOpen(
      Self,
      TKeyValues.CreateAs([sZLEZASOB_ID + '=' + Parameters.Values[sZLEZASOB_ID]]),
      AOpenMode
    );
  end else
    result  := nil;
end;

procedure TZLEZasobDBDetailForm.InitializeControls;
begin
  if Parameters.Values[cFORM_CAPTION] <> '' then
    Caption := Parameters.Values[cFORM_CAPTION]
  else
    Caption := 'Zasb';

  //ustawienia pl w kontrolkach
  RodzajDBConstComboBox.DataField := sZLEZASOB_RODZAJ;
  StawkaDBEdit.DataField := sZLEZASOB_STAWKA;
  NazwaDBEdit.DataField := sZLEZASOB_NAZWA;

  RodzajDBConstComboBox.Items.AddStrings(cslZLERodzajZasobu);

  StawkaDBEdit.aAllowEmpty  := (not ZLEDM.vZLEWymaganaStawkaZasobu);
  if (Owner is TUNIDBGridForm)and
     (Length((Owner as TUNIDBGridForm).DBGrid.MarkedRows)>0) then begin
    PracownikPanel.Visible := False;
    NazwaPanel.Visible := False;
  end;
  ObciazenieDBEdit.DataField  := sZLEZASOB_OBCIAZENIE_MAX;
  if(DataManagers.Available(sLWPModulID)) then begin
    with JednostkaLookupAliasEdit do begin
      AliasManager  := LWPDM.AliasManager;
      Alias_ID      := sLWPAlias_Jednostka_Id;
      Alias_Name    := sLWPAlias_Jednostka_Symbol;
    end;  // with JednostkaDBLookupAliasEdit
    with GrupaKalendarzowaLookupAliasEdit do begin
      AliasManager  := UNISysDM.AliasManager;
      Alias_ID      := sUNISysKDAlias_GrupaKalID;
      Alias_Name    := sUNISysKDAlias_GrupaKalSymbol;
    end;  // with GrupaKalendarzowaLookupAliasEdit
    LWPPanel.Visible  := true;
  end else  // if(DataManagers.Available(sLWPModulID))
    LWPPanel.Visible  := false;
end;

procedure TZLEZasobDBDetailForm.InternalOpen;
begin
  if Parameters = nil then
    Parameters := TKeyValues.CreateEmpty();

  iNumeratorID := ZLEDM.vZLENumeratorZasobow; {jeli -1 nie jest ustawiony}
  InitializeControls();
  inherited;
  DMAQFbN(sZLEZASOB_RODZAJ).OnChange := FieldChange;
  with DMAQFbN(sZLEZASOB_STAWKA) as TNumericField do begin
    DisplayFormat := cMaskaKwoty;
    EditFormat := cMaskaKwotyEdycja;
  end;
  if OpenMode = omNew then
    SetDefaults();
  //ustawienie aktywnej kontrolki
  if OpenMode = omNew then
    ActiveControl := RodzajDBConstComboBox
  else if OpenMode = omEdit then 
    ActiveControl := StawkaDBEdit;
end;

procedure TZLEZasobDBDetailForm.BeforeShow();
begin
  inherited;
  ShowAliases();

  SymbolDBEdit.Enabled := False;
  if (OpenMode in [omNew, omEdit]) and (DMAQFbN(sUNIAUTNUM_ID).IsNull) then
     SymbolDBEdit.Enabled := True;
end;
                                   
procedure TZLEZasobDBDetailForm.SetDefaults;
var
  iLicznik: Integer;
begin
  try
    (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := True;
    //tu ustawieni defaultowe;
    if iNumeratorID > 0 then begin
       DMAQFbN(sZLEZASOB_SYMBOL).AsString  := UNISysDM.UNIPodajNumerExt( iNumeratorID,
                                                                         0,
                                                                         vAktywnyRokObrachunkowyID { tu byo - 0},
                                                                         0 {iOkresId},
                                                                         0,
                                                                         '',
                                                                         iLicznik);

      DMAQFbN(sZLEZASOB_LICZNIK).AsInteger := iLicznik;
      DMAQFbN(sUNIAUTNUM_ID).AsInteger     := iNumeratorID;
      SymbolDBEdit.Enabled := False;
    end else begin
      SymbolDBEdit.Enabled := True;
    end;

    DMAQFbN(sZLEZASOB_RODZAJ).AsString := cZLERodzajZasobu_PracownikID;
  finally
    (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := False;
  end;
end;

function TZLEZasobDBDetailForm.Validate: Boolean;
begin
  result := inherited Validate();
end;

function TZLEZasobDBDetailForm.PracownikDBLookupAliasEditGetDataField: String;
begin
  result := sKDOSOBA_ID;
end;

function TZLEZasobDBDetailForm.PracownikDBLookupAliasEditGetQuery: TUNIQuery;
begin
  result := UNISYSDM.KDPokazIObsluzPracownika(self, '',
                                               sKDAlias_OsobaID+';'+
                                               sKDAlias_OsobaSymbol+';'+
                                               sKDAlias_OsobaNazwa,
                                               False, False, DMAQFbN(sKDOSOBA_ID).AsInteger,
                                               vAktywnaFirma, sZLEModulID,
                                               '', nil, False, True );
end;

procedure TZLEZasobDBDetailForm.PracownikDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with PracownikDBLookupAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_ID := sKDAlias_OsobaID;
    Alias_Name := sKDAlias_OsobaSymbol;
    AdditionalAliases := sKDAlias_OsobaNazwa;
  end;
end;

function TZLEZasobDBDetailForm.PracownikDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
    if (OpenMode in [omNew,omEdit])and(PracownikDBLookupAliasEdit.Initialized) then begin
      DMAQFbN(sZLEZASOB_NAZWA).AsString := AliasSrc.FieldByName(sKDOSOBA_NAZWA).AsString;
    end;
  end;
  result := True;
end;

procedure TZLEZasobDBDetailForm.FieldChange;
begin
  if Sender.FieldName = sZLEZASOB_RODZAJ then begin
    if DMAQFbN(sZLEZASOB_RODZAJ).AsString = cZLERodzajZasobu_PracownikID then begin
      PracownikPanel.Visible := True;
      PracownikPanel.Top := NazwaPanel.Top;
    end else if DMAQFbN(sZLEZASOB_RODZAJ).AsString = cZLERodzajZasobu_MaszynaID then begin
      PracownikPanel.Visible := False;
    end;
  end;
end;

procedure TZLEZasobDBDetailForm.ShowAliases();
var
  oQuery:   TUNIQuery;
  sAliasy,
  sWarunek: string;
begin
  if(not DMAQFbN(sLWPJEDNCZAS_ID).IsNull) then begin
    UNIDajAliasyZLookupa(JednostkaLookupAliasEdit, sAliasy, sWarunek);
    oQuery  := LWPDM.LWPOdpytajODane(sLWPJEDNCZAS,
      sAliasy,
      '@' + sLWPAlias_Jednostka_Id + ' = ' + DMAQFbN(sLWPJEDNCZAS_ID).AsString,
      false
    );
    if(oQuery <> nil) then begin
      JednostkaLookupAliasEdit.Text := oQuery.Fields[1].AsString;
      oQuery.Free();
    end;  // if(oQuery <> nil)
  end;  // if(not DMAQFbN(sLWPJEDNCZAS_ID).IsNull)
  if(not DMAQFbN(sKDGRUPAKAL_ID).IsNull) then begin
    UNIDajAliasyZLookupa(GrupaKalendarzowaLookupAliasEdit, sAliasy, sWarunek);
    oQuery  := UNISysDM.KDOdpytajODaneKalendarza(sKDGRUPAKAL,
      sAliasy,
      '@' + sUNISysKDAlias_GrupaKalID + ' = ' + DMAQFbN(sKDGRUPAKAL_ID).AsString,
      false, false
    );
    if(oQuery <> nil) then begin
      GrupaKalendarzowaLookupAliasEdit.Text := oQuery.Fields[1].AsString;
      oQuery.Free();
    end;  // if(oQuery <> nil)
  end;  // if(not DMAQFbN(sKDGRUPAKAL_ID).IsNull)
end;

function TZLEZasobDBDetailForm.JednOrgDBLookupAliasEditGetDataField: String;
begin
  result := sUNIJEDNOSTKAORG_ID;
end;

function TZLEZasobDBDetailForm.JednOrgDBLookupAliasEditGetQuery: TUNIQuery;
var
  sWarPoz: String;
begin

   sWarPoz := '';
   if not DMAQFbN(sUNIJEDNOSTKAORG_ID).IsNull then
      sWarPoz := sUNIJEDNOSTKAORG_ID + '=' + IntToStr(DMAQFbN(sUNIJEDNOSTKAORG_ID).AsInteger);


   Result := UNISysDataManager.UNIPokazIObsluzDane(sUNIJEDNOSTKAORG, '', false, false,
                     sUNISysAlias_JednostkaOrg_ID + ';' +
                     sUNISysAlias_JednostkaOrg_Symbol + ';' +
                     sUNISysAlias_JednostkaOrg_Nazwa,
                     vAktywnaFirma);
end;

procedure TZLEZasobDBDetailForm.JednOrgDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with JednOrgDBLookupAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_ID := sUNISysAlias_JednostkaOrg_ID;
    Alias_Name := sUNISysAlias_JednostkaOrg_Symbol;
    AdditionalAliases := sUNISysAlias_JednostkaOrg_Nazwa;
  end;
end;

function TZLEZasobDBDetailForm.JednOrgDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
    if (OpenMode in [omNew,omEdit])
       {and(JednOrgDBLookupAliasEdit.Initialized)} then begin
      DMAQFbN(sUNIJEDNOSTKAORG_ID).AsInteger := AliasSrc.FieldByName(sUNIJEDNOSTKAORG_ID).AsInteger;
    end;
  end else begin
     DMAQFbN(sUNIJEDNOSTKAORG_ID).Clear;
  end;
  result := True;
end;

procedure TZLEZasobDBDetailForm.JednostkaLookupAliasEditButtonClick(
  Sender: TObject);
var
  oQuery:   TUNIQuery;
  sAliasy,
  sWarunek: string;
begin
  UNIDajAliasyZLookupa(JednostkaLookupAliasEdit, sAliasy, sWarunek);
  oQuery  := LWPDM.LWPPokazIObsluzDane(sLWPJEDNCZAS,
    sAliasy, sWarunek, false, true, false,
    DMAQFbN(sLWPJEDNCZAS_ID).AsString
  );
  if(oQuery <> nil) then begin
    JednostkaLookupAliasEditSetData(oQuery);
    oQuery.Free();
  end;  // if(oQuery <> nil)
end;

procedure TZLEZasobDBDetailForm.JednostkaLookupAliasEditDelKey(
  Sender: TObject);
begin
  DMAQFbN(sLWPJEDNCZAS_ID).Clear();
  JednostkaLookupAliasEdit.Clear();
end;

function TZLEZasobDBDetailForm.JednostkaLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  DMAQFbN(sLWPJEDNCZAS_ID).AsInteger:= AliasSrc.Fields[0].AsInteger;
  JednostkaLookupAliasEdit.Text     := AliasSrc.Fields[1].AsString;
  result  := true;
end;

procedure TZLEZasobDBDetailForm.GrupaKalendarzowaLookupAliasEditButtonClick(
  Sender: TObject);
var
  oQuery:   TUNIQuery;
  sWarunek,
  sAliasy:  string;
begin
  UNIDajAliasyZLookupa(GrupaKalendarzowaLookupAliasEdit, sAliasy, sWarunek);
  oQuery  := UNISysDM.KDPokazIObsluzKalendarz(sKDGRUPAKAL,
    sAliasy, sWarunek, false, false, false,
    DMAQFbN(sKDGRUPAKAL_ID).AsInteger
  );
  if(oQuery <> nil) then begin
    GrupaKalendarzowaLookupAliasEditSetData(oQuery);
    oQuery.Free();
  end;  // if(oQuery <> nil)
end;

procedure TZLEZasobDBDetailForm.GrupaKalendarzowaLookupAliasEditDelKey(
  Sender: TObject);
begin
  DMAQFbN(sKDGRUPAKAL_ID).Clear();
  GrupaKalendarzowaLookupAliasEdit.Clear();
end;

function TZLEZasobDBDetailForm.GrupaKalendarzowaLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  DMAQFbN(sKDGRUPAKAL_ID).AsInteger     := AliasSrc.Fields[0].AsInteger;
  GrupaKalendarzowaLookupAliasEdit.Text := AliasSrc.Fields[1].AsString;
  result  := true;
end;

procedure TZLEZasobDBDetailForm.CancelButtonClick(Sender: TObject);
begin
  inherited;
  {Zwrocic numer z numeratora}
end;

procedure TZLEZasobDBDetailForm.CancelButtonPressed;
var sSymbol: String;
    iLicznik, iNumID: Integer;
begin
  sSymbol := DMAQFbN(sZLEZASOB_SYMBOL).AsString;
  iLicznik := DMAQFbN(sZLEZASOB_LICZNIK).AsInteger;
  iNumID := DMAQFbN(sUNIAUTNUM_ID).AsInteger;

  inherited;

    if (ModalResult = mrCancel) and (OpenMode = omNew) and
       (iNumID <> 0)            and (sSymbol <> '') then begin
       UNISysDM.UNIZwrocNumer( sSymbol, iNumID, 0, vAktywnyRokObrachunkowyID{0}, 0, 0, iLicznik);
  end;
end;


procedure TZLEZasobDBDetailForm.SelectButtonPressed;
var sSymbol: String;
    iLicznik, iNumID: Integer;
begin
  sSymbol := DMAQFbN(sZLEZASOB_SYMBOL).AsString;
  iLicznik := DMAQFbN(sZLEZASOB_LICZNIK).AsInteger;
  iNumID := DMAQFbN(sUNIAUTNUM_ID).AsInteger;

  inherited;

  if (ModalResult = mrOK) and (OpenMode = omDelete) and
     (iNumID <> 0) and (sSymbol <> '') then begin
     UNISysDM.UNIZwrocNumer( sSymbol, iNumID, 0, vAktywnyRokObrachunkowyID{0}, 0, 0, iLicznik);
  end;
end;

initialization
  FormManager.RegisterForm( TZLEZasobDBDetailForm, sZLEModulID );

end.
