unit ZLEZasobDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2005-02-22 gdeyk    Utworzone
2011-10-10 Adam    Zastpienie FormManager.RefreshDBGrid funkcj KOMDM.KOMOdswiezGrid
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls, UNIStaleUnit, UNIDataModuleUnit, UNIFormUnit, KeyManagerUnit;

const
  cZLEZasobDBGridFormClass = 'TZLEZasobDBGridForm';

type
  TZLEZasobDBGridForm = class(TUNIDBGridForm)
    ZakresButton: TUNIButton;
    FunkcjePopupMenu: TUNIPopupMenu;
    PrzeliczMenuItem: TMenuItem;
    FunkcjeToolButton: TToolButton;
    PrzeliczRozlMenuItem: TMenuItem;
    procedure ZakresButtonClick(Sender: TObject);
    procedure PrzeliczMenuItemClick(Sender: TObject);
    procedure PrzeliczRozlMenuItemClick(Sender: TObject);
  private
    sZleZlecenieID: String;
    procedure InitializeControls();
    procedure OpenDetail( AOpenMode: TOpenMode );
  protected
    procedure New(); override;
    procedure Open(); override;
    procedure View(); override;
    procedure Delete(); override;
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure SetUserRights; override;
    procedure AssignProperties; override;
    function  GetPropertyValue(APropertyName: String): String;  override;
  public
    procedure InternalOpen(); override;
    procedure GridHasBeenChanged( ByWho: TComponent ); override;
    procedure GetParametersForForm(AForm: TUNIForm; Parameters: TKeyValues); override;

  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  FormManagerUnit,
  UNIImageManagerUnit,
  SecurityManagerUnit,
  SQLManagerUnit,
  SystemDefUnit,
  UNISysDefUnit,
  ZLEDefUnit,
  ZLEZasobUnit,
  ZLEZasobDBDetailFormUnit,
  KOMDataManagerExtUnit;

{ TZLEZasobDBGridForm }

function TZLEZasobDBGridForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLEZasobDataModule.CreateOpen( Self, InheritedMasterKeyValues, AOpenMode );
end;

procedure TZLEZasobDBGridForm.Delete;
begin
  OpenDetail(omDelete);
end;

procedure TZLEZasobDBGridForm.GridHasBeenChanged(ByWho: TComponent);
begin
  inherited;
{$ifndef build_all}
  if Length(DBGrid.MarkedRows) > 0 then
    KOMDM.KOMOdswiezGrid(Self.ClassName, DMAQFbN(sZLEZASOB_ID).AsInteger);
{$endif}
end;

procedure TZLEZasobDBGridForm.InitializeControls;
begin
  if Parameters.Values[cFORM_CAPTION] <> '' then
    Caption := Parameters.Values[cFORM_CAPTION]
  else
    Caption := 'Zasoby';

  if Parameters.IndexOf(cRangeClassName) < 0 then
    Parameters.Add(cRangeClassName+'='+'TZLEZasobyZakresForm' {cKlasaZakresZlecen+cSuffixKlasySelect});
end;

procedure TZLEZasobDBGridForm.InternalOpen;
begin
  if Parameters = nil then
    Parameters := TKeyValues.CreateEmpty();
  {sZleZlecenieID := '';
  if Parameters.Values[sZLEZLECENIE_ID] <> '' then
     sZleZlecenieID := Parameters.Values[sZLEZLECENIE_ID];}
  InitializeControls();
  inherited;
  FunkcjeToolButton.ImageIndex:= cimPreselekcja;
end;

procedure TZLEZasobDBGridForm.New;
begin
  OpenDetail(omNew);
end;

procedure TZLEZasobDBGridForm.Open;
begin
  OpenDetail(omEdit);
end;

procedure TZLEZasobDBGridForm.OpenDetail(AOpenMode: TOpenMode);
var
  oParams: TKeyValues;
begin
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add(cFORM_CAPTION+'='+'Zasb');
  end;
  FormManager.OpenDBDetail( Self, cZLEZasobDBDetailFormClass, AOpenMode, oParams );
end;

procedure TZLEZasobDBGridForm.SetUserRights;
begin
  sZleZlecenieID := '';
  if Parameters <> nil then
     if Parameters.Values[sZLEZLECENIE_ID] <> '' then
        sZleZlecenieID := Parameters.Values[sZLEZLECENIE_ID];

  with SecurityManager do begin
    Switch_View_HotKey(SM_UserCanDo(sZLE_USTAW_SLOW_ZASOBY_POKAZ));
    Switch_New_HotKey(SM_UserCanDo(sZLE_USTAW_SLOW_ZASOBY_DOPISZ));
    Switch_Open_HotKey(SM_UserCanDo(sZLE_USTAW_SLOW_ZASOBY_ZMIEN));
    Switch_Delete_HotKey(SM_UserCanDo(sZLE_USTAW_SLOW_ZASOBY_USUN));
  end;
end;

procedure TZLEZasobDBGridForm.View;
begin
  OpenDetail(omView);
end;

procedure TZLEZasobDBGridForm.ZakresButtonClick(Sender: TObject);
begin
//  inherited;
 // Dopisac ;)
  if OpenRangeForm() then
    DataModule.ReOpenDataSets();
  DBGrid.SetFocus;
end;

procedure TZLEZasobDBGridForm.GetParametersForForm(AForm: TUNIForm;
  Parameters: TKeyValues);
begin
  Parameters.Assign(Self.Parameters);

  if (sZleZlecenieID <> '') and (Parameters.Values[sZLEZLECENIE_ID] = '') then 
     Parameters.Values[sZLEZLECENIE_ID] := sZLEZlecenieID;
end;

procedure TZLEZasobDBGridForm.AssignProperties;
begin
  if Parameters = nil then
    Parameters := TKeyValues.CreateEmpty;
  if Parameters.IndexOf(cRangeClassName) < 0 then
    Parameters.Add(cRangeClassName+'='+'TZLEZasobyZakresForm' {cKlasaZakresZlecen+cSuffixKlasySelect});
  inherited;
  Properties.AddProperty( 'PH', GetPropertyValue );
  Properties.AddProperty( 'PV', GetPropertyValue );
end;

function TZLEZasobDBGridForm.GetPropertyValue(
  APropertyName: String): String;
begin
//  if APropertyName = 'PH' then result := IntToStr(PozycjeZleceniaPanel.Height)
//  else if APropertyName = 'PV' then result := IntToStr(Integer(PozycjeZleceniaPanel.Visible))
  {else} result := inherited GetPropertyValue( APropertyName );
end;


procedure TZLEZasobDBGridForm.PrzeliczMenuItemClick(Sender: TObject);
var
  oParams : TKeyValues;
  oForm:    TUNIForm;
  bTrans: Boolean;
  sSQL, sListaZlecID, sListaZasobowID, sWhere: String;
  iOkresID, i, iJednostkaOrgID: Integer;
  dDataOd, dDataDo: TDate;
begin
  oParams := TKeyValues.CreateEmpty;
  if not DataModule.ActiveQuery.IsEmpty then begin
     {Pobranie domyslnych wartoci}
     bTrans := false;
     oForm := FormManager.OpenForm(self, 'TZLEZasobyPrzeliczSelectForm',
                                   omEdit + omHidden, oParams);
     try
        if (oForm.ShowModal = mrOk) then begin
           iOkresID := 0;
           dDataOd  := 0;
           dDataDo  := 0;
           sListaZlecID := '';
           sListaZasobowID := '';
           sWhere := '';
           iJednostkaOrgID := 0;

           if (Length(DBGrid.MarkedRows) > 0) then
              for i := 0 to Length(DBGrid.MarkedRows) - 1 do begin
                 if sListaZasobowID <> '' then sListaZasobowID := sListaZasobowID + ',';
                 sListaZasobowID := sListaZasobowID + IntToStr(DBGrid.MarkedRows[i]);
              end;

(*************
                sSQL := 'UPDATE %s ZG ' +
                        'SET ZG.' + sZLEOSOBYGODZ_CENA + ' = (SELECT ZO1.' + sZLEZASOB_STAWKA + ' ' +
                                                             'FROM %s ZO1 ' +
                                                             'WHERE ZO1.' + sUNIJEDNOSTKAORG_ID + ' = ' + IntToStr(iJednostkaID) + ' AND ' +
                                                                   '(((ZG.' + sKDOSOBA_ID + ' = ZO1.' + sKDOSOBA_ID + ') AND ' +
                                                                     '(ZO1.' + sZLEZASOB_RODZAJ + ' = ' + QuotedStr('P') + ')) OR ' +
                                                                    '((ZG.' + sZLEZASOB_ID + ' = ZO1.' + sZLEZASOB_ID + ') AND ' +
                                                                     '(ZO1.' + sZLEZASOB_RODZAJ + ' = ' + QuotedStr('M') + ')) )) ' +
                        'WHERE ZG.' + sZLEOSOBYGODZ_ID + ' IN (SELECT ZOG.' + sZLEOSOBYGODZ_ID + ' ' +
                                                              'FROM %s ZOG, %s ZO ' +
                                                              'WHERE ZOG.' + sUNIOKRES_ID + ' = ' + IntToStr(iOkresID) + ' AND ' +
                                                                     'ZO.' + sUNIJEDNOSTKAORG_ID + ' = ' + IntToStr(iJednostkaID) + ' AND ' +
                                                                     '(((ZOG.' + sKDOSOBA_ID + ' = ZO.' + sKDOSOBA_ID + ') AND ' +
                                                                       '(ZO.' + sZLEZASOB_RODZAJ + ' = ' + QuotedStr('P') + ')) OR ' +
                                                                      '((ZOG.' + sZLEZASOB_ID + ' = ZO.' + sZLEZASOB_ID + ') AND ' +
                                                                       '(ZO.' + sZLEZASOB_RODZAJ + ' = ' + QuotedSTr('M') + ')) ))';
****************************)

           if oParams <> nil then begin
              if (oParams.Values[sZLEZLECENIE_ID] <> '') then
                sListaZlecID := oParams.Values[sZLEZLECENIE_ID];

              if (oParams.Values[sUNIOKRES_ID] <> '') and (oParams.Values[sUNIOKRES_ID] <> '-1') then
                 iOkresID := StrToInt(oParams.Values[sUNIOKRES_ID]);
              if (oParams.Values['DATA_OD'] <> '') and (oParams.Values['DATA_OD'] <> '0') then
                 dDataOd := StrToInt(oParams.Values['DATA_OD']);

              if (oParams.Values['DATA_DO'] <> '') and (oParams.Values['DATA_DO'] <> '0') then
                 dDataDo := StrToInt(oParams.Values['DATA_DO']);
              if (oParams.Values[sUNIJEDNOSTKAORG_ID] <> '') and (oParams.Values[sUNIJEDNOSTKAORG_ID] <> '-1') then
                 iJednostkaOrgID := StrToInt(oParams.Values[sUNIJEDNOSTKAORG_ID]);
           end;

           if (iOkresID > 0) or (dDataOd > 0) or (dDataDo > 0) or (sListaZlecID <> '') then begin
              try
                DataModule.ActiveQuery.DisableControls;
                bTrans := not SQLManager.InTransaction;
                if bTrans then SQLManager.StartTransaction;

                sSQL := 'UPDATE %s ZG ' +
                        'SET ZG.' + sZLEZASOBYPRACA_STAWKA + ' = (SELECT MAX(ZO1.' + sZLEZASOB_STAWKA + ') ' +
                                                                 'FROM %s ZO1 ' +
                                                                 'WHERE ';
                if sListaZasobowID <> '' then
                   sSQL := sSQL + ' ZO1.' + sZLEZASOB_ID + ' IN (' + sListaZasobowID + ') AND ';

                if iJednostkaOrgID > 0 then
                   sSQL := sSQL + ' ZO1.' + sUNIJEDNOSTKAORG_ID + '=' + IntToStr(iJednostkaOrgID) + ' AND ';

                sSQL := sSQL +                                    ' (((ZG.' + sKDOSOBA_ID + ' = ZO1.' + sKDOSOBA_ID + ') AND ' +
                                                                     '(ZO1.' + sZLEZASOB_RODZAJ + ' = ' + QuotedStr('P') + ')) OR ' +
                                                                    '((ZG.' + sZLEZASOB_ID + ' = ZO1.' + sZLEZASOB_ID + ') AND ' +
                                                                     '(ZO1.' + sZLEZASOB_RODZAJ + ' = ' + QuotedStr('M') + ')) )) ' +
                        'WHERE ZG.' + sZLEZASOBYPRACA_ID + ' IN (SELECT ZOG.' + sZLEZASOBYPRACA_ID + ' ' +
                                                                'FROM %s ZOG, %s ZO ' +
                                                                'WHERE ';

                if iOkresID > 0 then begin
                   if sWhere <> '' then sWhere := sWhere + ' AND ';
                   sWhere := sWhere + ' (ZOG.' + sUNIOKRES_ID + ' = ' + IntToStr(iOkresID) + ')';
                end;

                if dDataOd > 0 then begin
                   if sWhere <> '' then sWhere := sWhere + ' AND ';
                   sWhere := sWhere + ' (ZOG.' + sZLEZASOBYPRACA_DATA + ' >= ' + KonwertujDate2SQL(dDataOd{, 'dd-mm-yyyy'}) + ')';
                end;

                if dDataDo > 0 then begin
                   if sWhere <> '' then sWhere := sWhere + ' AND ';
                   sWhere := sWhere + ' (ZOG.' + sZLEZASOBYPRACA_DATA + ' <= ' + KonwertujDate2SQL(dDataDo{, 'dd-mm-yyyy'}) + ')';
                end;

                if sListaZlecID <> '' then begin
                   if sWhere <> '' then sWhere := sWhere + ' AND ';
                   sWhere := sWhere + ' (ZOG.' + sZLEZLECENIE_ID + ' IN (' + sListaZlecID + '))';
                end;

                if sListaZasobowID <> '' then begin
                   if sWhere <> '' then sWhere := sWhere + ' AND ';
                   sWhere := sWhere + ' (ZG.' + sZLEZASOB_ID + ' IN (' + sListaZasobowID + '))';
                end;

                if iJednostkaOrgID > 0 then begin
                   if sWhere <> '' then sWhere := sWhere + ' AND ';
                   sWhere := sWhere + ' (ZO.' + sUNIJEDNOSTKAORG_ID + '=' + IntToStr(iJednostkaOrgID) + ')';
                end;

                if sWhere <> '' then sWhere := sWhere + ' AND ';
                sWhere := sWhere + '(((ZOG.' + sKDOSOBA_ID + ' = ZO.' + sKDOSOBA_ID + ') AND ' +
                                     '(ZO.' + sZLEZASOB_RODZAJ + ' = ' + QuotedStr('P') + ')) OR ' +
                                    '((ZOG.' + sZLEZASOB_ID + ' = ZO.' + sZLEZASOB_ID + ') AND ' +
                                     '(ZO.' + sZLEZASOB_RODZAJ + ' = ' + QuotedSTr('M') + ')) ))';

                if sWhere <> '' then
                   sSQL := sSQL + sWhere;

                sSQL := sSQL + ' AND ZG.' + sZLECONST_RODZAJECP_ID + ' IN (' + QuotedStr(cZLERodzajECP_OsobaID) + ', ' +
                                                                               QuotedStr(cZLERodzajECP_ZasobID) + ')';

                SQLManager.ExecuteQuery(sSQL, [sZLEZASOBYPRACA, sZLEZASOB, sZLEZASOBYPRACA, sZLEZASOB]);
                if bTrans then SQLManager.Commit;
                Komunikat(cInformation, 'Przeliczanie ewidencji zakonczono pomylnie');
              finally
                DataModule.ActiveQuery.EnableControls;
                DataModule.ReOpenDataSets();
              end;
           end;
        end;
     finally
        if bTrans and SQLManager.InTransaction then SQLManager.RollBack;
        oForm.Free;
     end;
  end;
end;

procedure TZLEZasobDBGridForm.PrzeliczRozlMenuItemClick(Sender: TObject);
var
  oParams : TKeyValues;
  oForm:    TUNIForm;
  bTrans: Boolean;
  sSQL, sListaZlecID, sListaZasobowID, sWhere: String;
  iOkresID, i, iJednostkaOrgID: Integer;
  dDataOd, dDataDo: TDate;
begin
  oParams := TKeyValues.CreateEmpty;
  if not DataModule.ActiveQuery.IsEmpty then begin
     {Pobranie domyslnych wartoci}
     bTrans := false;
     oForm := FormManager.OpenForm(self, 'TZLEZasobyPrzeliczSelectForm',
                                   omEdit + omHidden, oParams);
     try
        if (oForm.ShowModal = mrOk) then begin
           iOkresID := 0;
           dDataOd  := 0;
           dDataDo  := 0;
           sListaZlecID := '';
           sListaZasobowID := '';
           sWhere := '';
           iJednostkaOrgID := 0;

           if (Length(DBGrid.MarkedRows) > 0) then
              for i := 0 to Length(DBGrid.MarkedRows) - 1 do begin
                 if sListaZasobowID <> '' then sListaZasobowID := sListaZasobowID + ',';
                 sListaZasobowID := sListaZasobowID + IntToStr(DBGrid.MarkedRows[i]);
              end;


           if oParams <> nil then begin
              if (oParams.Values[sZLEZLECENIE_ID] <> '') then
                sListaZlecID := oParams.Values[sZLEZLECENIE_ID];

              if (oParams.Values[sUNIOKRES_ID] <> '') and (oParams.Values[sUNIOKRES_ID] <> '-1') then
                 iOkresID := StrToInt(oParams.Values[sUNIOKRES_ID]);
              if (oParams.Values['DATA_OD'] <> '') and (oParams.Values['DATA_OD'] <> '0') then
                 dDataOd := StrToInt(oParams.Values['DATA_OD']);

              if (oParams.Values['DATA_DO'] <> '') and (oParams.Values['DATA_DO'] <> '0') then
                 dDataDo := StrToInt(oParams.Values['DATA_DO']);

              if (oParams.Values[sUNIJEDNOSTKAORG_ID] <> '') and (oParams.Values[sUNIJEDNOSTKAORG_ID] <> '-1') then
                 iJednostkaOrgID := StrToInt(oParams.Values[sUNIJEDNOSTKAORG_ID]);
           end;

           if (iOkresID > 0) or (dDataOd > 0) or (dDataDo > 0) or (sListaZlecID <> '') then begin
              try
                DataModule.ActiveQuery.DisableControls;
                bTrans := not SQLManager.InTransaction;
                if bTrans then SQLManager.StartTransaction;

                sSQL := 'UPDATE %s ZR ' +
                        'SET ZR.' + sZLEZASOBYPRACA_STAWKA + ' = (SELECT MAX(ZO1.' + sZLEZASOB_STAWKA + ') ' +
                                                                  'FROM   %s ZO1 ' +
                                                                  'WHERE  ZR.' + sZLEZASOB_ID + ' = ZO1.' + sZLEZASOB_ID;
                if iJednostkaOrgID > 0 then
                   sSQL := sSQL + ' AND ZO1.' + sUNIJEDNOSTKAORG_ID + ' = ' + IntToStr(iJednostkaOrgID);

                sSQL := sSQL                                   + ') ' +
                        'WHERE ZR.' + sZLEZASOBYPRACA_ID + ' IN (SELECT ZOR.' + sZLEZASOBYPRACA_ID + ' ' +
                                                                'FROM   %s ZOR, %s ZS ' +
                                                                'WHERE  ZOR.' + sZLEZASOB_ID + ' = ZS.' + sZLEZASOB_ID;

                if iOkresID > 0 then begin
                   { dwa warunki zamiast okresu }
                   {Obecnie jest ju okres}
                   sWhere := sWhere + ' AND (ZOR.' + sUNIOKRES_ID + ' = ' + IntToStr(iOkresID) + ')';

                   (**********************
                   sWhere := sWhere + ' AND (ZOR.' + sZLEZLECENIEROZL_DATA + ' >= (SELECT ' + sUNIOKRES_DATA_POCZ + ' ' +
                                                                                       'FROM %s ' +
                                                                                       'WHERE ' + sUNIOKRES_ID + ' = ' + IntToStr(iOkresID) + ')) ' +
                                      ' AND (ZOR.' + sZLEZLECENIEROZL_DATA + ' <= (SELECT ' + sUNIOKRES_DATA_KONCA + ' ' +
                                                                                       'FROM %s ' +
                                                                                       'WHERE ' + sUNIOKRES_ID + ' = ' + IntToStr(iOkresID) + ')) ';
                   *********************)
                end;

                if dDataOd > 0 then begin
                   sWhere := sWhere + ' AND (ZOR.' + sZLEZASOBYPRACA_DATA + ' >= ' + KonwertujDate2SQL(dDataOd{, 'dd-mm-yyyy'}) + ')';
                end;

                if dDataDo > 0 then begin
                   sWhere := sWhere + ' AND (ZOR.' + sZLEZASOBYPRACA_DATA + ' <= ' + KonwertujDate2SQL(dDataDo{, 'dd-mm-yyyy'}) + ')';
                end;

                if sListaZlecID <> '' then begin
                   sWhere := sWhere + ' AND (ZOR.' + sZLEZLECENIE_ID + ' IN (' + sListaZlecID + '))';
                end;

                if sListaZasobowID <> '' then begin
                   sWhere := sWhere + ' AND (ZOR.' + sZLEZASOB_ID + ' IN (' + sListaZasobowID + '))';
                end;

                if iJednostkaOrgID > 0 then begin
                   sWhere := sWhere + ' AND (ZS.' + sUNIJEDNOSTKAORG_ID + ' = ' + IntToStr(iJednostkaOrgID) + ')';
                end;

                if sWhere <> '' then
                   sSQL := sSQL + sWhere;

                sSQL := sSQL + ')';

                sSQL := sSQL + ' AND ZR.' + sZLECONST_RODZAJECP_ID + ' = ' + QuotedStr(cZLERodzajECP_RozliczID);

                (*if iOkresID > 0 then begin
                   SQLManager.ExecuteQuery(sSQL, [sZLEZLECENIEROZL, sZLEZASOB,
                                                  sZLEZLECENIEROZL, sZLEZLECENIEPOZ,
                                                  sUNIOKRES, sUNIOKRES]);
                end else begin*)
                   SQLManager.ExecuteQuery(sSQL, [sZLEZASOBYPRACA, sZLEZASOB,
                                                  sZLEZASOBYPRACA, sZLEZASOB]);
                //end;

                if bTrans then SQLManager.Commit;
                Komunikat(cInformation, 'Przeliczanie rozliczen zakonczono pomylnie');
              finally
                DataModule.ActiveQuery.EnableControls;
                DataModule.ReOpenDataSets();
              end;
           end;
        end;
     finally
        if bTrans and SQLManager.InTransaction then SQLManager.RollBack;
        oForm.Free;
     end;
  end;
end;

initialization
  FormManager.RegisterForm( TZLEZasobDBGridForm, sZLEModulID );

end.
