unit ZLEZasobUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2005-02-22 gdeyk    Utworzone
2007-09-27 Adam     Dodane pola 'Max obcienie' i 'Jednostka czasu'
2007-11-13 Adam     Dodane pola Symbol i Nazwa grupy kalendarzowej
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLEZasobDataModule = class(TUNIDataModule)
  private
    iZakresConditionIdx: Integer;
    //iZakresJednOrgConditionIdx: Integer;
    procedure UstawZakres();
//    procedure JoinOnField(const iFun: Integer; sFieldName: String; var sConditions: String);
  protected
    procedure GetKeys; override;
    function  GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;
  public
    constructor Create( AOwner: TComponent); override;
    procedure OpenDataSets(); override;
    procedure ReOpenDataSets(); override;
    procedure Post; override;
    procedure Delete; override;
  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  UNIDataManagerUnit,
  KeyManagerUnit,
  QueryBuilderUnit,
  UNIDBFormUnit,
  SecurityManagerUnit,
  SQLManagerUnit,
  UNIDBDetailFormUnit,
  UNIDBGridFormUnit,
  LWPDefUnit,
  SystemDefUnit,
  UNIStaleUnit,
  UNISysDefUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit;

{ TZLEZasobDataModule }

constructor TZLEZasobDataModule.Create(AOwner: TComponent);
begin
  inherited;
  iZakresConditionIdx := -1;
//  iZakresJednOrgConditionIdx := -1;
end;

procedure TZLEZasobDataModule.Delete;
var
  bTrans: Boolean;
begin
  bTrans := not SQLManager.InTransaction;
  try
    if bTrans then SQLManager.StartTransaction;
    inherited;
    if bTrans then SQLManager.Commit;
  except
    if bTrans then SQLManager.Rollback;
    Komunikat( cError, (ExceptObject as Exception).Message );
    Abort;
  end;
end;

procedure TZLEZasobDataModule.GetKeys;
begin
  with FKeys do begin
    AddPrimary(sZLEZASOB_ID);
  end;
end;

function TZLEZasobDataModule.GetTableName: string;
begin
  result := sZLEZASOB;
end;

(*
procedure TZLEZasobDataModule.JoinOnField(const iFun: Integer;
                                          sFieldName: String;
                                          var sConditions: String);
const cADMID = sADMID+'%d';
var
  sCondition: String;
  oIDs_List: TStringList;
  sCorrel1: String;
  sCorrel2: String;
  iPFun: Integer;
  sRangeClassName: String;
begin
  iPFun := (Owner as TUNIDBGridForm).RangePodFunc;
  sRangeClassName := (Owner as TUNIDBGridForm).RangeClassName;
  oIDs_List := ADMID_CreateAndLoad( iFun, iPFun, SecurityManager.UserId,
                                    sRangeClassName );
  try
    sCorrel1 := Copy( sFieldName, 1, Pos( '.', sFieldName )-1 );
    sCorrel2 := Format(cADMID, [iFun]);

    if oIDs_List.Count > 0 then
    begin
      //dodanie warunku
      sCondition := '('+sCorrel2+'.'+sADMID_FUNK+'='+IntToStr(iFun)+')and'+
                  '('+sCorrel2+'.'+sADMID_PFUNK+'='+IntToStr(iPFun)+')and'+
                  '('+sCorrel2+'.'+sSMUSER_ID+'='+IntToStr(SecurityManager.UserId)+')and'+
                  '('+sCorrel2+'.'+sADMID_KONTEKST+'='+QuotedStr(sRangeClassName)+')';
      GridTabDefs.Add(sCorrel2, sADMID);

      DopiszDoWhere(sCondition, sConditions);
    end;

    if GridJoinDefs.IndexOfCorrel2( sCorrel2 ) = -1 then
      GridJoinDefs.AddSimple( sCorrel1, sCorrel2, sFieldName+'='+sCorrel2+'.'+sADMID_V, qjkInner, oIDs_List.Count > 0 )
    else
      GridJoinDefs.Items[ GridJoinDefs.IndexOfCorrel2( sCorrel2 ) ].Required := (oIDs_List.Count > 0);
  finally
    oIDs_List.Free;
  end;
end;
*)

procedure TZLEZasobDataModule.OpenDataSets;
begin
  UstawZakres();
  inherited;
end;

procedure TZLEZasobDataModule.ReOpenDataSets;
begin
  inherited;
end;

procedure TZLEZasobDataModule.UstawZakres;
var oParams: TKeyValues;
    sWhere: String;
begin
  oParams := nil;
  sWhere := '';

  if (Owner is TUNIDBGridForm) then begin
    try
      oParams := TKeyValues.CreateEmpty();
      (Owner as TUNIDBForm).GetParametersForForm( (Owner as TUNIDBForm), oParams );
      if oParams = nil then exit;

      with oParams do begin
        // Rodzaj zasobu
        if Values[sParam_ZLEZasobRodzID] <> '' then
            DopiszDoWhere('M.'+sZLEZASOB_RODZAJ + ' in (' + QuotedStr(Values[sParam_ZLEZasobRodzID])+')', sWhere );
        if Values[sUNIJEDNOSTKAORG_ID] <> '' then
            DopiszDoWhere('M.'+sUNIJEDNOSTKAORG_ID + ' in (' + Values[sUNIJEDNOSTKAORG_ID] +')', sWhere );

        {Zlecenie}    
        if ZLEDM.vZLEOgraniczonaListaZasobow and
           (Values[sZLEZLECENIE_ID] <> '') then
           DopiszDoWhere(' EXISTS (SELECT ZZB.' + sZLEZLECENIE_ID + ' ' +
                                  'FROM ' + SQLManager.GetTableName(sZLEZLECENIEZASOB) + ' ZZB ' +
                                  'WHERE ZZB.' + sZLEZLECENIE_ID + ' IN (' + QuotedStr(Values[sZLEZLECENIE_ID]) + ') AND ' +
                                        'ZZB.' + sZLEZASOB_ID + ' = M.' + sZLEZASOB_ID + ')', sWhere);
           {DopiszDoWhere('ZS.'+sZLEZLECENIE_ID + ' in (' + QuotedStr(Values[sZLEZLECENIE_ID])+')', sWhere );}
      end;

      if sWhere <> '' then begin
        GridJoinDefs.ExchangeCondition( iZakresConditionIdx, sWhere, true );
        //GridJoinDefs.ExchangeCondition( iZakresJednOrgConditionIdx, sWhere, true )
      end else begin
        GridJoinDefs.Items[iZakresConditionIdx].Required := false;
        //GridJoinDefs.Items[iZakresJednOrgConditionIdx].Required := false;
      end;

    finally
      if oParams <> nil then oParams.Free;
    end;
  end;

end;


procedure TZLEZasobDataModule.InitializeGridQueryDefs;
begin
  with GridColDefs do begin
    AddRequiredAndUnvisible( sZLEZASOB_ID, 'M', '' );
    Add( sZLEZASOB_SYMBOL, 'M', 'Symbol', True, True, taLeftJustify, 150 );
    Add( sZLEZASOB_NAZWA, 'M', 'Nazwa', True, True, taLeftJustify, 150 );
    AddRequiredAndUnvisible( sZLEZASOB_RODZAJ, 'M', '' );
    Add( sZLECONST_RODZAJZASOBU_V, 'R', 'Rodzaj', True, True, taLeftJustify, 100 );
    Add( sZLEZASOB_STAWKA, 'M', 'Stawka', True, True, taRightJustify, 100, uftCurrency );
    AddRequiredAndUnvisible( sKDOSOBA_ID, 'M', '' );
    Add( sKDOSOBA_SYMBOL, 'OS', 'Symbol pracownika', False, True, taLeftJustify, 80 );
    AddRequiredAndUnvisible( sUNIJEDNOSTKAORG_ID, 'M', '' );

    {if ZLEDM.vZLEOgraniczonaListaZasobow then
       AddRequiredAndUnvisible( sZLEZLECENIE_ID, 'ZS', '' );}

    Add( sUNIJEDNOSTKAORG_SYMBOL, 'JO', 'Jedn. org.', False, True, taLeftJustify, 100 );
    if(DataManagers.Available(sLWPModulID)) then begin
      Add(sZLEZASOB_OBCIAZENIE_MAX, 'M', 'Maksymalne obcienie', True, True, taRightJustify, 100, uftNumber);
      Add(sLWPJEDNCZAS_SYMBOL , sLWPAlias_Jednostka, 'Symbol jednostki czasu', True, True, taLeftJustify, 100);
      Add(sLWPJEDNCZAS_NAZWA  , sLWPAlias_Jednostka, 'Nazwa jednostki czasu', False, True, taLeftJustify, 100);
      Add(sKDGRUPAKAL_SYMBOL  , 'GR', 'Symbol grupy kalendarzowej', True, True, taLeftJustify, 100);
      Add(sKDGRUPAKAL_NAZWA   , 'GR', 'Nazwa grupy kalendarzowej', False, True, taLeftJustify, 200);
    end;  // if(DataManagers.Available(sLWPModulID))
  end;
  with GridTabDefs do begin
    Add( 'M', TableName );
    Add( 'R', sZLECONST_RODZAJZASOBU );
    Add( 'OS', sKDOSOBA );
    Add( 'JO', sUNIJEDNOSTKAORG );
    if(DataManagers.Available(sLWPModulID)) then begin
      Add(sLWPAlias_Jednostka, sLWPJEDNCZAS);
      Add( 'GR', sKDGRUPAKAL );
    end;

    {if ZLEDM.vZLEOgraniczonaListaZasobow then
       Add('ZS', sZLEZLECENIEZASOB);}
  end;
  with GridJoinDefs do begin
    AddSimple( 'M', 'R', 'M.'+sZLEZASOB_RODZAJ+'=R.'+sZLECONST_RODZAJZASOBU_ID, qjkInner, True );
    AddSimple( 'M', 'OS', 'M.'+sKDOSOBA_ID+'=OS.'+sKDOSOBA_ID, qjkLeftOuter, True );
    AddSimple( 'M', 'JO', 'M.'+sUNIJEDNOSTKAORG_ID+'=JO.'+sUNIJEDNOSTKAORG_ID, qjkLeftOuter, True );
    if(DataManagers.Available(sLWPModulID)) then begin
      AddExpres('M.' + sLWPJEDNCZAS_ID+ ' = ' + sLWPAlias_Jednostka + '.' + sLWPJEDNCZAS_ID, qjkLeftOuter, false);
      AddExpres('M.' + sKDGRUPAKAL_ID + ' = GR.' + sKDGRUPAKAL_ID, qjkLeftOuter, false);
    end;

    {if ZLEDM.vZLEOgraniczonaListaZasobow then
       AddSimple( 'M', 'ZS', 'M.'+sZLEZASOB_ID+'=ZS.'+sZLEZASOB_ID, qjkInner, True );}
    iZakresConditionIdx := AddCondition( '1=1', false );
//    iZakresJednOrgConditionIdx := AddCondition( '1=1', false );
  end;
  inherited;
end;

procedure TZLEZasobDataModule.Post;
var
  bTrans: Boolean;
  oUpdateQuery: TUNIQuery;
  sWhere: String;
begin
  bTrans := not SQLManager.InTransaction;
  try
    if bTrans then SQLManager.StartTransaction;
    if (OpenMode = omEdit)and
       (Owner.Owner is TUNIDBGridForm)and
       (Length((Owner.Owner as TUNIDBGridForm).DBGrid.MarkedRows)>0) then begin
      sWhere := sZLEZASOB_ID+' in ('+Andy((Owner.Owner as TUNIDBGridForm).DBGrid.MarkedRows,',')+')';
      oUpdateQuery := SQLManager.UpdateQueryStep1( sZLEZASOB,
                                                   sZLEZASOB_STAWKA+','+
                                                   sZLEZASOB_UZ_ZM_ID+','+
                                                   sZLEZASOB_DATA_ZM,
                                                   sWhere );
      with oUpdateQuery do begin
        ParamByName(sZLEZASOB_STAWKA).AsFloat := ActiveQuery.FieldByName(sZLEZASOB_STAWKA).AsFloat;
        ParamByName(sZLEZASOB_UZ_ZM_ID).AsInteger := SecurityManager.UserId;
        ParamByName(sZLEZASOB_DATA_ZM).AsDateTime := UNINow; 
      end;
      SQLManager.UpdateQueryStep2( oUpdateQuery );
    end else
      inherited;
    if bTrans then SQLManager.Commit;
  except
    if bTrans then SQLManager.Rollback;
    Komunikat( cError, (ExceptObject as Exception).Message );
    Abort;
  end;
end;

initialization
  RegisterClass( TZLEZasobDataModule );

end.
