unit ZLEZasobyBrakiDBDetailFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Modu dostarczajcy aktualizacje bazy.
Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2007-11-19 Tomjen   Utworzone
---------------------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBDetailFormUnit, Menus, UNIComponentsUnit, Db, ToolWin, ComCtrls,
  DbClient, StdCtrls, ExtCtrls, Mask, DBCtrls,UNIStaleUnit, UNIDataModuleUnit;

type
  TZLEZasobyBrakiDBDetailForm = class(TUNIDBDetailForm)
    UNILabel1: TUNILabel;
    UNILabel2: TUNILabel;
    BrakDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    IloscDBEdit: TUNIDBEdit;
    OsobaPanel: TUNIPanel;
    OsobaLabel: TUNILabel;
    OsobaNazwaLabel: TUNILabel;
    OsobaSymbolDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    procedure BrakDBLookupAliasEditDelKey(Sender: TObject);
    function BrakDBLookupAliasEditGetDataField: String;
    function BrakDBLookupAliasEditGetQuery: TUNIQuery;
    procedure BrakDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function BrakDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure SelectButtonClick(Sender: TObject);
    procedure OsobaSymbolDBLookupAliasEditDelKey(Sender: TObject);
    function OsobaSymbolDBLookupAliasEditGetDataField: string;
    function OsobaSymbolDBLookupAliasEditGetQuery: TUNIQuery;
    procedure OsobaSymbolDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function OsobaSymbolDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
  private
    sNazwaBraku: String;
    oDefaultFieldList: TStringList;
    procedure MakeDefaultFieldList();
    procedure UnModifyDefaultFields( bUnModify: Boolean = true);
    procedure UpdateLookupFields();
    procedure InitializeObjectFields();
//    procedure FieldChange( Sender: TField );
  protected
    function  CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure InternalOpen; override;
    procedure BeforeShow; override;
  public
    procedure SelectButtonPressed(); override;
  end;

var
  ZLEZasobyBrakiDBDetailForm: TZLEZasobyBrakiDBDetailForm;

implementation

{$R *.DFM}

uses
  FormManagerUnit,
  ZLEZasobyBrakiUnit,
  UNISysDataManagerUnit,
  FKDefUnit,
  ZLEDefUnit,
  SystemDefUnit,
  Dodatki,
  ZLEDataManagerUnit,
  ZLEZasobyBrakiDBGridFormUnit;

procedure TZLEZasobyBrakiDBDetailForm.BeforeShow;
begin
  inherited;{--}
end;

procedure TZLEZasobyBrakiDBDetailForm.InternalOpen;
begin
  sNazwaBraku := '';
  OsobaNazwaLabel.Caption := '';
  InitializeObjectFields();
  inherited;
end;

function TZLEZasobyBrakiDBDetailForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  Result := TZLEZasobyBrakiDataModule.CreateOpen( self, DefaultMasterKeyValues, AOpenMode);
end;

procedure TZLEZasobyBrakiDBDetailForm.BrakDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  if OpenMode in [omNew, omEdit] then begin
    BrakDBLookupAliasEdit.Text := '';
    DMAQFbN(sZLEBRAKI_ID).Clear;
    sNazwaBraku := '';
  end;
end;

function TZLEZasobyBrakiDBDetailForm.BrakDBLookupAliasEditGetDataField: String;
begin
  result := sZLEBRAKI_ID;
end;

function TZLEZasobyBrakiDBDetailForm.BrakDBLookupAliasEditGetQuery: TUNIQuery;
begin
  result := ZLEDM.ZLEPokazIObsluzDane( sZLEBRAKI,
                                       sZLEAlias_BrakiID + ';' +
                                       sZLEAlias_BrakiSymbol + ';' +
                                       sZLEAlias_BrakiNazwa,
                                       '',
                                       False,
                                       False,
                                       cZLEmodulZSI_ID,
                                       DMAQFbN(sZLEBRAKI_ID).AsInteger);
end;

procedure TZLEZasobyBrakiDBDetailForm.BrakDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with BrakDBLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_ID := sZLEAlias_BrakiId;
    Alias_Name := sZLEAlias_BrakiSymbol;
    AdditionalAliases := sZLEAlias_BrakiNazwa;
  end;
end;

function TZLEZasobyBrakiDBDetailForm.BrakDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  inherited;
  if AliasSrc <> nil then begin
     sNazwaBraku := AliasSrc.FieldByName(sZLEBraki_NAZWA).AsString;
  end;
  result := True;
end;



procedure TZLEZasobyBrakiDBDetailForm.SelectButtonPressed;
begin
  UnModifyDefaultFields(false);
  inherited;
  UpdateLookupFields();
end;

procedure TZLEZasobyBrakiDBDetailForm.InitializeObjectFields;
begin
  oDefaultFieldList := nil;
  oDefaultFieldList := TStringList.Create();
  MakeDefaultFieldList();
end;

procedure TZLEZasobyBrakiDBDetailForm.MakeDefaultFieldList;
begin
  with oDefaultFieldList do begin
    Add(sZLEZasobyPraca_ID);
  end;
end;

procedure TZLEZasobyBrakiDBDetailForm.OsobaSymbolDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  OsobaSymbolDBLookupAliasEdit.Text := '';
  OsobaNazwaLabel.Caption := '';
  if OpenMode in [omNew, omEdit] then
    DMAQFbN(sKDOSOBA_ID).Clear;
end;

function TZLEZasobyBrakiDBDetailForm.OsobaSymbolDBLookupAliasEditGetDataField: string;
begin
  result := sKDOSOBA_ID;
end;

function TZLEZasobyBrakiDBDetailForm.OsobaSymbolDBLookupAliasEditGetQuery: TUNIQuery;
var
  iFirmaId: integer;
begin
  iFirmaId := 0;
  if (UNISysDM.vWieloodzialowosc) and (Parameters.Values[sUNIODDZIAL_ID] <> '') then
    iFirmaID := StrToInt(Parameters.Values[sUNIODDZIAL_ID])
  else if UNISysDM.vWielofirmowosc then
    iFirmaID := UNISysDM.vAktywnaFirma;

  Result := UNISysDM.KDPokazIObsluzPracownika(
    self, '',
    sKDAlias_OsobaID + ';' + sKDAlias_OsobaSymbol + ';' + sKDAlias_OsobaNazwa,
    False,
    False,
    DMAQFbN(sKDOSOBA_ID).AsInteger,
    iFirmaID, sZLEModulID,'',
    nil,
    ZLEDM.vZLEECPPracownicyWieleFirm,
    True{bPokazJednostke}
    );
end;

procedure TZLEZasobyBrakiDBDetailForm.OsobaSymbolDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with OsobaSymbolDBLookupAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_ID := sKDAlias_OsobaID;
    Alias_Name := sKDAlias_OsobaSymbol;
    AdditionalAliases := sKDAlias_OsobaNazwa;
  end;
end;

function TZLEZasobyBrakiDBDetailForm.OsobaSymbolDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then
    OsobaNazwaLabel.Caption := AliasSrc.FieldByName(sKDOSOBA_NAZWA).AsString;
  Result := True;
end;

procedure TZLEZasobyBrakiDBDetailForm.UnModifyDefaultFields(
  bUnModify: Boolean);
var iIndex: Integer;
begin
  for iIndex := 0 to oDefaultFieldList.Count-1 do begin
    with (DataModule.ActiveQuery as TVirtualDataSet).ModifiedRecordsFlagsList do
      if bUnModify then SetFieldIsNotModified(DMAQFbN(oDefaultFieldList[iIndex]))
      else SetFieldIsModified(DMAQFbN(oDefaultFieldList[iIndex]));
  end;
end;

procedure TZLEZasobyBrakiDBDetailForm.UpdateLookupFields;
begin
  { wypelnienie na osadzonym gridzie wartoci pl zw. z LookupAliasEdit i DBConstComboBox }
  if (ModalResult = mrOk) and (OpenMode in [omEdit, omNew]) and
     ((OpenModeFlags and omOverVirtual) = omOverVirtual) then begin
    with (Owner as TZLEZasobyBrakiDBGridForm).DataModule.ActiveQuery as TVirtualDataSet do begin
      try
        VState := vsInternalInsert;
        Edit;
        if FindField(sZLEBRAKI_NAZWA) <> nil then
           FieldByName(sZLEBRAKI_NAZWA).AsString := sNazwaBraku;
        if FindField(sZLEBRAKI_SYMBOL) <> nil then
           FieldByName(sZLEBRAKI_SYMBOL).AsString := BrakDBLookupAliasEdit.Text;
        if FindField(sKDOSOBA_NAZWA) <> nil then
           FieldByName(sKDOSOBA_NAZWA).AsString := OsobaNazwaLabel.Caption;
        if FindField(sKDOSOBA_SYMBOL) <> nil then
           FieldByName(sKDOSOBA_SYMBOL).AsString := OsobaSymbolDBLookupAliasEdit.Text;
        Post;
      finally
        VState := vsNormal;
      end;
    end;
  end; // if (ModalResult = mrOk) and (OpenMode in [omEdit, omNew]) and ...
end;

procedure TZLEZasobyBrakiDBDetailForm.SelectButtonClick(Sender: TObject);
{
var
  sQuery : string;
  oQuery : TUNIQuery;
}
begin
  inherited;

  { wypelnienie na osadzonym gridzie wartoci pl zw. z LookupAliasEdit i DBConstComboBox }
  {if (ModalResult = mrOk) and (OpenMode in [omEdit, omNew]) and
     ((OpenModeFlags and omOverVirtual) = omOverVirtual) then begin
    with (Owner as TZLEZasobyBrakiDBGridForm).DataModule.ActiveQuery as TVirtualDataSet do begin
      try
        VState := vsInternalInsert;
        Edit;
        if FindField(sZLEBRAKI_NAZWA) <> nil then
           FieldByName(sZLEBRAKI_NAZWA).AsString := BrakDBLookupAliasEdit.Text;
        Post;
      finally
        VState := vsNormal;
      end;
    end;
  end;} // if (ModalResult = mrOk) and (OpenMode in [omEdit, omNew]) and ...
end;

initialization
  FormManager.RegisterForm(TZLEZasobyBrakiDBDetailForm, sZLEModulID);
end.
