unit ZLEZasobyBrakiDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Modu dostarczajcy aktualizacje bazy.
Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2007-11-19 Tomjen   Utworzone
---------------------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls, UNIStaleUnit, UNIDataModuleUnit;

type
  TZLEZasobyBrakiDBGridForm = class(TUNIDBGridForm)
  private
    procedure OpenDetail(AOpenMode: TOpenMode);
  protected
    procedure New(); override;
    procedure Open(); override;
    procedure View(); override;
    procedure Delete(); override;
    function  CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure SetUserRights; override;
    procedure BeforeShow; override;
  public
    procedure UstawPrzyciski;
    procedure InternalOpen(); override;
    procedure Dopisz();
    procedure Usun();
  end;

var
  ZLEZasobyBrakiDBGridForm: TZLEZasobyBrakiDBGridForm;

implementation

uses
  Dodatki,
  FormManagerUnit,
  SecurityManagerUnit,
  UNIDBDetailFormUnit,
  KeyManagerUnit,
  ZLEDefUnit,
  ZleZasobyBrakiUnit,
  ZLEDataManagerUnit,
  ZleZasobyPracaDBDetailFormUnit,
  UNISysDefUnit;


{$R *.DFM}

function TZleZasobyBrakiDBGridForm.CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZleZasobyBrakiDataModule.CreateOpen(Self, DefaultMasterKeyValues, AOpenMode);
end;

procedure TZleZasobyBrakiDBGridForm.Delete;
begin
//  DataModule.Delete();
  OpenDetail(omDelete);
end;

procedure TZleZasobyBrakiDBGridForm.Dopisz();
begin
   New();
end;

procedure TZleZasobyBrakiDBGridForm.Usun();
begin
   Delete();
end;

procedure TZleZasobyBrakiDBGridForm.InternalOpen;
begin
  if Parameters <> nil then
     if Parameters.Values[cFORM_CAPTION] <> '' then
        Caption := Parameters.Values[cFORM_CAPTION];
  inherited;
end;

procedure TZleZasobyBrakiDBGridForm.New;
begin
  OpenDetail(omNew);
end;

procedure TZleZasobyBrakiDBGridForm.Open;
begin
  OpenDetail(omEdit);
end;

procedure TZleZasobyBrakiDBGridForm.OpenDetail(AOpenMode: TOpenMode);
var
  oParams: TKeyValues;
begin
  inherited;
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add(cFORM_CAPTION+'='+'Szczegy brakw dla zasobu');
  end;

  if FormIsContained then
       AOpenMode := AOpenMode or omOverVirtual or omShowModal;

  FormManager.OpenDBDetail(Self, 'TZleZasobyBrakiDBDetailForm', AOpenMode, oParams);
  UstawPrzyciski;
end;

procedure TZleZasobyBrakiDBGridForm.View;
begin
  OpenDetail(omView);
end;

procedure TZleZasobyBrakiDBGridForm.SetUserRights;
begin
  with SecurityManager do begin
//    Switch_View_HotKey(SM_UserCanDo(sZLE_REJ_CZASU_PRACY_POKAZ));
//    Switch_Open_HotKey(SM_UserCanDo(sZLE_REJ_CZASU_PRACY_ZMIEN));
    Switch_View_HotKey(False);
    Switch_Open_HotKey(False);
    Switch_New_HotKey(SM_UserCanDo(sZLE_REJ_CZASU_PRACY_DOPISZ));
    Switch_Delete_HotKey(SM_UserCanDo(sZLE_REJ_CZASU_PRACY_USUN));
  end;
end;

procedure TZleZasobyBrakiDBGridForm.UstawPrzyciski;
begin
  if FormIsContained then begin
    (Owner as TZleZasobyPracaDBDetailForm).Usun2Button.Enabled   := (DeleteMenuItem.Visible and DeleteMenuItem.Enabled);
    (Owner as TZleZasobyPracaDBDetailForm).Dopisz2Button.Enabled := (NewMenuItem.Visible    and NewMenuItem.Enabled);
  end;
end;

procedure TZleZasobyBrakiDBGridForm.BeforeShow;
begin
  inherited;
  UstawPrzyciski;
end;

initialization
  FormManager.RegisterForm( TZleZasobyBrakiDBGridForm, 'Rejestracja brakw dla zasobw', sZLEModulID );
end.
