unit ZLEZasobyBrakiUnit;
{
 Copyright Unisoft Sp. z o.o.

Modu dostarczajcy aktualizacje bazy.
Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2007-11-19 Tomjen   Utworzone
---------------------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLEZasobyBrakiDataModule = class(TUNIDataModule)
    procedure DetailQueryNewRecord(DataSet: TDataSet);
  protected
    procedure GetKeys; override;
    function  GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;
  public
    procedure Post; override;
  private
    m_sZleZasobyBrakiId   : string;
    m_iZleZasobyBrakiIdx  : integer;
    m_sZleZasobyPracaId   : string;
    m_iZleZasobyPracaIdx  : integer;

    procedure ComposeConditions();
  end;

var
  ZLEZasobyBrakiDataModule: TZLEZasobyBrakiDataModule;

implementation

{$R *.DFM}

uses ZLEDefUnit, SQLManagerUnit, UNIStaleUnit, Dodatki,
     ZLEZasobyBrakiDBDetailFormUnit, UNISysDefUnit,
     QueryBuilderUnit, KeyManagerUnit, UNIFormUnit;

procedure TZLEZasobyBrakiDataModule.GetKeys;
begin
  with FKeys do begin
    Clear;
    AddPrimary(sZLEZasobyBraki_ID);

   // if (Owner as TUNIForm).FormIsContained then
    Add(sZLEZasobyPraca_ID);
  end;
end;

function TZLEZasobyBrakiDataModule.GetTableName: string;
begin
  Result:=sZLEZasobyBraki;
end;

procedure TZLEZasobyBrakiDataModule.DetailQueryNewRecord(DataSet: TDataSet);
begin
  inherited;
 (***
  with DataSet do begin
    //o ponisze parametry naley odpyta ownera
    ownerKeyValues := TKeyValues.CreateAs([sZLEZasobyPraca_ID]{,
                       sParamEdytowanaPozycjaID]});
    try
      (self.owner as TUNIForm).GetParametersForForm( NIL, ownerKeyValues );
      FieldByName(sZLEZasobyPraca_ID).AsInteger := StrToInt(ownerKeyValues.KeyByName(sZLEZasobyPraca_ID));
    finally
      ownerKeyValues.Free;
    end;
  end;
 *******************)
end;

procedure TZLEZasobyBrakiDataModule.InitializeGridQueryDefs;
begin
  with GridColDefs do begin
    Clear;
    AddRequiredAndUnvisible(sZLEZasobyBRAKI_ID, 'K', '');
    AddRequiredAndUnvisible(sZLEBRAKI_ID, 'K', '');
    AddRequiredAndUnvisible(sZLEZasobyPraca_ID, 'K', '');
    AddRequiredAndUnvisible(sKDOSOBA_ID, 'K', '');
    Add(sZLEZasobyBraki_Il, 'K','Ilo',True,True, taRightJustify,90);
    Add(sZLEBraki_NAZWA,    'B','Nazwa braku',True,True,  taLeftJustify,150);
    Add(sZLEBraki_SYMBOL,   'B','Symbol braku',True,True,  taLeftJustify,100);
    Add(sKDOSOBA_NAZWA,    'O','Nazwa osoby',False,True,  taLeftJustify,150);
    Add(sKDOSOBA_SYMBOL,   'O','Symbol osoby',False,True,  taLeftJustify,100);
  end;

  with GridTabDefs do begin
    Clear;
    Add('K',GetTableName);
    Add('B',sZLEBRAKI);
    Add('O', sKDOSOBA);
  end;

  with GridJoinDefs do begin
    Clear;
    AddSimple( 'K', 'B', 'K.' + sZLEBraki_ID +'=B.' + sZLEBraki_ID, qjkInner, True);
    AddSimple( 'K', 'O', 'K.' + sKDOSOBA_ID +'=O.' + sKDOSOBA_ID, qjkLeftOuter, True);
    m_iZleZasobyBrakiIdx := AddEmptyCondition();
    m_iZleZasobyPracaIdx := AddEmptyCondition();
  end;

  ComposeConditions();
  inherited;
end;

procedure TZLEZasobyBrakiDataModule.Post;
  var
    trans:boolean;
begin
  trans:= not SQLManager.InTransaction;
  if trans then SQLManager.StartTransaction;
  try
    inherited;
    if trans then SQLManager.Commit;
  except
    on EDMException do begin
      if trans then SQLManager.Rollback;
      if FLastDBError.SQLObjectName=sZLEZasobyBraki+'1'+c_UNK then begin
        Komunikat( cError,'Istnieje ju taki element');
        {with owner as TZLEBrakiDBDetailForm do
           ActiveControl:= SymbolDBEdit;}
        abort;
      end else raise;
    end else begin
      if trans then SQLManager.Rollback;
      raise;
    end;
  end;

end;

procedure TZLEZasobyBrakiDataModule.ComposeConditions();
var
  oParams:        TKeyValues;
begin
  if (Owner as TUNIForm).FormIsContained then
     m_sZleZasobyPracaId := (Owner as TUNIForm).Parameters.Values[sZLEZasobyPraca_ID];

  if(not ParamIsNotEmpty(MasterKeyValues, sZLEZASOBYBRAKI_ID, m_sZleZasobyBrakiId)) then begin
    oParams := TKeyValues.CreateEmpty();
    try
      (Owner as TUNIForm).GetParametersForForm((Owner as TUNIForm), oParams);
      ParamIsNotEmpty(oParams, sZLEZasobyBraki_ID, m_sZleZasobyBrakiId);
    finally
      oParams.Free();
    end;
  end;  // if nie ma id zlecenia w MasterKeyValues
  if(Length(m_sZleZasobyBrakiId) > 0) then begin
    GridJoinDefs.ExchangeCondition(m_iZleZasobyBrakiIdx, 'K.' + sZLEZasobyBraki_ID  + ' = ' + m_sZleZasobyBrakiId, true);
  end else begin
    GridJoinDefs.ExchangeCondition(m_iZleZasobyBrakiIdx, '', false);
  end;

  if(Length(m_sZleZasobyPracaId) > 0) then begin
    GridJoinDefs.ExchangeCondition(m_iZleZasobyPracaIdx, 'K.' + sZLEZasobyPraca_ID  + ' = ' + m_sZleZasobyPracaId, true);
  end else begin
    GridJoinDefs.ExchangeCondition(m_iZleZasobyPracaIdx, '', false);
  end;
end;

end.
