unit ZLEZasobyPracaRapUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2010-03-31 Tomjen   Utworzone
---------------------------------------------------------------------------------------------}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLEZasobyPracaRapDataModule = class(TUNIDataModule)
  protected
    procedure GetKeys();  override;
    function  GetTableName(): string; override;
    procedure InitializeGridQueryDefs();  override;
    //procedure ReopenDataSets(); override;

  {private
    m_iZakresConditionId: Integer;}
    //procedure ComposeConditions();
  public
    {procedure Post; override;
    procedure ReFreshDataSets(); override;}
  end;

var
  ZLEZasobyPracaRapDataModule: TZLEZasobyPracaRapDataModule;

implementation
uses
  QueryBuilderUnit,
  UNIStaleUnit,
  SQLManagerUnit,
  SecurityManagerUnit,
  Dodatki,
  KeyManagerUnit,
  UNIDataManagerUnit,
  ZLEDataManagerUnit,
  ZLEZasobyPracaRapDBGridFormUnit,
  SystemDefUnit,
  UNIFormUnit,
  UNISysDefUnit,
  ZLEDefUnit
  ;

{$R *.DFM}
procedure TZLEZasobyPracaRapDataModule.GetKeys;
begin
  with FKeys do begin
    Clear;
    Add(sZLEZASOBYPRACARAP_ID);
  end;
end;

function  TZLEZasobyPracaRapDataModule.GetTableName: string;
begin
  Result  := sZLEZASOBYPRACARAP;
end;

procedure TZLEZasobyPracaRapDataModule.InitializeGridQueryDefs;
begin
  with GridColDefs do begin
    Clear();
    Add(sZLEZASOBYPRACARAP_KOMUNIKAT, 'M', 'Komunikat bdu', True, True, taLeftJustify, 100);
    Add(sSMUSER_NAZWA               , 'U', 'Zatwierdzi'    , True, True, taLeftJustify, 100);
    Add(sZLECONST_ZASOBYPRACARAPST_V, 'S', 'Status'         , true, true, taLeftJustify, 80);

    AddRequiredAndUnvisible(sZLEZASOBYPRACARAP_ID,  'M', '');
    AddRequiredAndUnvisible(sZLEZASOBYPRACA_ID,     'M', '');
    AddRequiredAndUnvisible(sSMUSER_ID,             'M', '');
    AddRequiredAndUnvisible(sZLECONST_ZASOBYPRACARAPST_ID, 'M', '');
  end;

  with GridTabDefs do begin
    Clear();
    Add('M', GetTableName());
    Add('U', sSMUSER);
    Add('S', sZLECONST_ZASOBYPRACARAPST);
  end;

  with GridJoinDefs do begin
    Clear();
    AddExpres('M.' + sZLECONST_ZASOBYPRACARAPST_ID + ' = S.' + sZLECONST_ZASOBYPRACARAPST_ID, qjkLeftOuter, false);
    AddExpres('M.' + sSMUSER_ID + ' = U.' + sSMUSER_ID, qjkLeftOuter, false);

    if Owner is TZLEZasobyPracaRapDBGridForm then begin
       if (Owner as TZLEZasobyPracaRapDBGridForm).Parameters <> nil then
          if (Owner as TZLEZasobyPracaRapDBGridForm).Parameters.Values[sZLEZASOBYPRACA_ID] <> '' then
             AddCondition('M.' +sZLEZASOBYPRACA_ID + '=' + (Owner as TZLEZasobyPracaRapDBGridForm).Parameters.Values[sZLEZASOBYPRACA_ID], True);
    end;
  end;
  inherited;
end;

end.
