unit ZLEZasobyPracaUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2007-11-13 Tomjen   Utworzone
2008-02-18 Adam     Zmieniony typ pola LWPRECEPTURA_OPIS na CLOB
2008-02-19 Adam     Zmieniony typ pola LWPRECEPPOZ_OPIS i LWPFAZAPROD_OPIS na CLOB
2008-07-09 Adam     Dodany status rekordu pracy zasobw
2008-09-16 Adam     Rzutowanie CLOBA na VARCHAR2(250) aby nie byo problemw z Blobs to cache
2008-09-29 Adam     Dodany tryb wywietlania rekordw utworzonych w aktualnej sesji
2008-09-30 Adam     Rzutowanie CLOBA na VARCHAR2 przy uyciu funkcji RzutujCLOBNaVarchar2
2010-03-22 Adam     Dodane pole "Typ raportu"
2011-05-23 Tomjen   Obsuga Daty do
---------------------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLEZasobyPracaDataModule = class(TUNIDataModule)
  protected
    procedure GetKeys();  override;
    function  GetTableName(): string; override;
    procedure InitializeGridQueryDefs();  override;
    procedure SetDisplayFormat; override;

  private
    m_sZlecenieId:      string;
    m_iZlecenieIndeks:  integer;
    m_iTrybPracyIndeks: integer;
    m_iZleConst_RodzajEcpId: Integer;
    m_iZakresConditionId: Integer;
    m_iMasterConditionId: Integer;
    procedure ChangeMasterKey;
    procedure ComposeConditions();
  public
    procedure Post; override;
    procedure RefreshDataSets(); override;
    procedure MojGetText(Sender: TField; var Text: String; DisplayText: Boolean);
    procedure Delete; override;
    procedure ReOpenDataSets(); override;
  end;

implementation
uses
  QueryBuilderUnit,
  UNIStaleUnit,
  SQLManagerUnit,
  SecurityManagerUnit,
  ZLEZasobyPracaDBDetailFormUnit,
  ZleZasobyPracaDBGridFormUnit,
  Dodatki,
  KeyManagerUnit,
  UNIDataManagerUnit,
  ZLEDataManagerUnit,
  ASODefUnit,
  SystemDefUnit,
  LWPDEFUnit,
  KDPRADefUnit,
  KDECPDataManagerExtUnit,
  KDDefUnit,
  KDDataManagerExtUnit,
  ASODataManagerExtUnit,
  UNIFormUnit,
  UNIDBGridFormUnit,
  UNISysDefUnit,
  ZLEDefUnit,
  FKDefUnit,
  LFKDefUnit
  ;

{$R *.DFM}

procedure TZLEZasobyPracaDataModule.ChangeMasterKey;
begin
  GridJoinDefs.ExchangeCondition(m_iMasterConditionId,sZLEALIAS_ZasobyPraca+'.'+sZLEZASOBYPRACA_EL_NAD_ID + '=' + GetKeyValue(MasterKeyValues[0]),true);
end;

procedure TZLEZasobyPracaDataModule.GetKeys;
begin
  with FKeys do begin
    Clear;
    AddPrimary(sZLEZASOBYPRACA_ID);
    //if (Owner is TUNIDBGridForm) and TUNIDBGridForm(Owner).FormIsContained then  begin
       Add(sZLEZASOBYPRACA_EL_NAD_ID);
    //end;
  end;
end;

function  TZLEZasobyPracaDataModule.GetTableName: string;
begin
  Result  := sZLEZASOBYPRACA;
end;

procedure TZLEZasobyPracaDataModule.InitializeGridQueryDefs;
var
  sTmp: string;
begin
  with GridColDefs do begin
    Clear();
    Add(sZLEZASOB_NAZWA,             sZLEALIAS_Zasob, 'Nazwa zasobu', False, True, taLeftJustify, 100);
    if(DataManagers.Available(sLWPModulID)) then
      Add(sLWPRAPORTPRODTYP_SYMBOL,    'RT', 'Typ raportu', true, true, taLeftJustify, 100);
    Add(sZLEZASOBYPRACA_IL_PRACY,    sZLEALIAS_ZasobyPraca, 'Ilo pracy', True, True, taRightJustify, 100, uftFloat);

    if ZLEDM.vZLEFormatGodzinLiczba then
      Add(sZLEZASOBYPRACA_CZAS_PRACY,  sZLEALIAS_ZasobyPraca, 'Czas pracy', True, True, taRightJustify, 100, uftFloat)
    else
      Add(sZLEZASOBYPRACA_CZAS_PRACY,  sZLEALIAS_ZasobyPraca, 'Czas pracy', True, True, taRightJustify, 100, uftMinutes);

    Add(sZLEZASOBYPRACA_DATA,        sZLEALIAS_ZasobyPraca, 'Data', True, True, taLeftJustify, 100);
    Add(sZLEZASOBYPRACA_DATA_DO,     sZLEALIAS_ZasobyPraca, 'Data do', False, True, taLeftJustify, 100);

    {Wartosc}
    if ZLEDM.vZLEFormatGodzinLiczba then
         sTmp := ')*'
    else sTmp := '/60)*';

    Add('(' + sZLEALIAS_ZasobyPraca + '.' + sZLEZASOBYPRACA_CZAS_PRACY + sTmp + sZLEALIAS_ZasobyPraca + '.' + sZLEZASOBYPRACA_STAWKA + ',2' + ';' + sZLEOSOBYGODZ_WARTOSC, '', 'Warto', True, True, taRightJustify, 200, uftFloat);
    Items[Count - 1].ColumnFunction:= SQLManager.GetSPName('ZAOKRAGLIJ');

    if ZLEDM.vZLEZlecenieRozl_ZuzPaliwa then
       Add(sZLEZASOBYPRACA_ZUZ_PALIWA,  sZLEALIAS_ZasobyPraca, 'Zuycie paliwa', False, True, taRightJustify, 100, uftFloat);
    Add(sZLEZASOBYPRACA_STAWKA,      sZLEALIAS_ZasobyPraca, 'Stawka', False, True, taRightJustify, 100, uftFloat);
    Add(sZLEZLECENIE_SYMBOL,         sZLEALIAS_Zlecenie, 'Symbol zlec.', True, True, taLeftJustify, 100);
    Add(sZLEZLECENIE_NAZWA,          sZLEALIAS_Zlecenie, 'Nazwa zlec.', True, True, taLeftJustify, 120);
    Add(sZLEZASOBYPRACA_UWAGI,       sZLEALIAS_ZasobyPraca, 'Uwagi', False, True, taLeftJustify, 120);
    Add(sZLEZLECENIE_ILOSC,          sZLEALIAS_Zlecenie, 'Ilo zlecona', False, True, taRightJustify, 80);
    Add(sASOASORT_SYMBOL,       'ASO', 'Symbol asortymentu zlecenia', False, True, taLeftJustify, 80);
    Add(sASOASORT_NAZWA,        'ASO', 'Nazwa asortymentu zlecenia', False, True, taLeftJustify, 120);
    Add(sASOASORT_SYMBOL+';'+sASOASORT_SYMBOL+'2', 'ASO2', 'Symbol asortymentu ewidencji', False, True, taLeftJustify, 80);
    Add(sASOASORT_NAZWA +';'+sASOASORT_NAZWA +'2', 'ASO2', 'Nazwa asortymentu ewidencji', False, True, taLeftJustify, 120);
    Add(sKDOSOBA_SYMBOL,       'KDO', 'Osoba', False, True, taLeftJustify, 80);
    Add(sKDOSOBA_NAZWA,        'KDO', 'Nazwa osoby', False, True, taLeftJustify, 120);
    Add(sZLEZASOBYPRACA_STATUS      , sZLEALIAS_ZasobyPraca, 'Status', true, true, taLeftJustify, 100);

    Add(sKDZMIANYDEF_SYMBOL,   'ZM', 'Symbol zmiany', False, True, taLeftJustify, 120);
    Add(sKDZMIANYDEF_GODZ_POCZATEK,   'ZM', 'Pocztek zmiany', False, True, taRightJustify, 100, uftMinutes2);
    Add(sKDZMIANYDEF_GODZ_KONIEC,   'ZM', 'Koniec zmiany', False, True, taRightJustify, 100, uftMinutes2);

    if (DataManagers.Available(sKDPRAModulID)) then begin
      Add(sKDSKLADNIKCZASU_SYMBOL,   'SC', 'Skadnik czasu pracy', false, true, taLeftJustify, 100);
      Add(sKDSKLADNIKCZASU_NAZWA,    'SC', 'Nazwa skadnika czasu pracy', false, true, taLeftJustify, 100);
    end;

    if DataManagers.Available(sLWPModulID) then begin
      Add(sLWPRECEPTURA_SYMBOL,       'REC', 'Symbol receptury', False, True, taLeftJustify, 80);
      Add(sLWPRECEPTURA_NAZWA,        'REC', 'Nazwa receptury', False, True, taLeftJustify, 120);
      Add(
        RzutujCLOBNaVarchar2('REC.' + sLWPRECEPTURA_OPIS, sLWPRECEPTURA_OPIS),
        '', 'Opis receptury' , false, omWidoczne, taLeftJustify, 120, uftString
      );

      Add(
        RzutujCLOBNaVarchar2('RECP.' + sLWPRECEPPOZ_OPIS, sLWPRECEPPOZ_OPIS),
        '', 'Opis poz. recept.' , false, omWidoczne, taLeftJustify, 120, uftString
      );
      Add(sLWPRECEPPOZ_KOLEJNOSC,    'RECP', 'Kolejno poz. recept.', False, True, taRightJustify, 120);

      Add(sLWPFAZAPROD_SYMBOL,       'FAZA', 'Symbol fazy prod.', False, True, taLeftJustify, 80);
      Add(sLWPFAZAPROD_NAZWA,        'FAZA', 'Nazwa fazy prod.', False, True, taLeftJustify, 120);
      Add(
        RzutujCLOBNaVarchar2('FAZA.' + sLWPFAZAPROD_OPIS, sLWPFAZAPROD_OPIS),
        '', 'Opis fazy prod.' , false, omWidoczne, taLeftJustify, 120, uftString
      );

      Add(sLWPPLANPRODEL_ILOSC_PLAN, 'PLANEL', 'Planowana ilo', False, True, taRightJustify, 80);
      Add(sLWPPLANPRODEL_DATA_POCZ,  'PLANEL', 'Data pocztkowa el.prod.', False, True, taRightJustify, 120);
      Add(sLWPPLANPRODEL_DATA_KONC,  'PLANEL', 'Data kocowa el.prod.', False, True, taRightJustify, 120);
    end;
    AddRequiredAndUnvisible(sZLEZASOBYPRACA_STATUS, sZLEALIAS_ZasobyPraca, '');
    AddRequiredAndUnvisible(sZLEZASOBYPRACA_ID,     sZLEALIAS_ZasobyPraca, '');
    AddRequiredAndUnvisible(sKDSKLADNIKCZASU_ID,    sZLEALIAS_ZasobyPraca, '');
    AddRequiredAndUnvisible(sZLEZLECENIE_ID,        sZLEALIAS_ZasobyPraca, '');
    AddRequiredAndUnvisible(sZLEZASOB_ID,           sZLEALIAS_ZasobyPraca, '');
    AddRequiredAndUnvisible(sKDOSOBA_ID,            sZLEALIAS_ZasobyPraca, '');
    AddRequiredAndUnvisible(sKDZMIANYDEF_ID,        sZLEALIAS_ZasobyPraca, '');
    AddRequiredAndUnvisible(sLWPPLANPRODEL_ID,      sZLEALIAS_ZasobyPraca, '');
    AddRequiredAndUnvisible(sLWPRECEPPOZ_ID,        sZLEALIAS_ZasobyPraca, '');
    AddRequiredAndUnvisible(sZLECONST_RODZAJECP_ID, sZLEALIAS_ZasobyPraca, '');
    AddRequiredAndUnvisible(sZLEZASOBYPRACA_FORMECP_ID, sZLEALIAS_ZasobyPraca, '');
    AddRequiredAndUnvisible(sZLEZASOBYPRACA_EL_NAD_ID, sZLEALIAS_ZasobyPraca, '');
    AddRequiredAndUnvisible(sZLEZASOBYPRACA_STANOWISKO_ID, sZLEALIAS_ZasobyPraca, '');
    AddRequiredAndUnvisible(sZLEZLECENIEPOZ_ID,     sZLEALIAS_ZasobyPraca, '');
  end;

  with GridTabDefs do begin
    Clear();
    Add(sZLEALIAS_ZasobyPraca    , GetTableName());
    Add(sZLEALIAS_Zasob          , sZLEZASOB);
    Add(sZLEALIAS_Zlecenie       , sZLEZLECENIE);
    Add('ASO'       , sASOASORT);
    Add('ASO2'      , sASOASORT);
    Add('ZM'        , sKDZMIANYDEF);
    Add('KDO'       , sKDOSOBA);
    if DataManagers.Available(sKDPRAModulID) then
       Add('SC'       , sKDSKLADNIKCZASU);

    if DataManagers.Available(sLWPModulID) then begin
        Add('REC'       , sLWPRECEPTURA);
        Add('RECP'      , sLWPRECEPPOZ);
        Add('PLANEL'    , sLWPPLANPRODEL);
        Add('FAZA'      , sLWPFAZAPROD);
        Add('RT'        , sLWPRAPORTPRODTYP);
    end;
  end;

  with GridJoinDefs do begin
    Clear();
    AddExpres(sZLEALIAS_ZasobyPraca + '.' + sZLEZLECENIE_ID + ' = ' + sZLEALIAS_ZLECENIE + '.' + sZLEZLECENIE_ID, qjkLeftOuter, false);
    AddExpres(sZLEALIAS_ZasobyPraca + '.' + sZLEZASOB_ID    + ' = ' + sZLEALIAS_ZASOB    + '.' + sZLEZASOB_ID, qjkLeftOuter, false);
    AddExpres(sZLEALIAS_Zlecenie + '.' + sASOASORT_ID    + ' = ' + 'ASO'  + '.' + sASOASORT_ID, qjkLeftOuter, false);
    AddExpres(sZLEALIAS_ZasobyPraca + '.' + sASOASORT_ID    + ' = ' + 'ASO2'  + '.' + sASOASORT_ID, qjkLeftOuter, false);
    AddExpres(sZLEALIAS_ZasobyPraca + '.' + sKDZMIANYDEF_ID    + ' = ' + 'ZM'  + '.' + sKDZMIANYDEF_ID, qjkLeftOuter, false);
    AddExpres(sZLEALIAS_ZasobyPraca + '.' + sKDOSOBA_ID    + ' = ' + 'KDO'  + '.' + sKDOSOBA_ID, qjkLeftOuter, false);
    if DataManagers.Available(sKDPRAModulID) then
       AddExpres(sZLEALIAS_ZasobyPraca + '.' + sKDSKLADNIKCZASU_ID    + ' = ' + 'SC'  + '.' + sKDSKLADNIKCZASU_ID, qjkLeftOuter, false);

    if DataManagers.Available(sLWPModulID) then begin
      AddExpres(sZLEALIAS_ZasobyPraca + '.' + sLWPRECEPPOZ_ID    + ' = ' + 'RECP'  + '.' + sLWPRECEPPOZ_ID, qjkLeftOuter, false);
      AddExpres('RECP' + '.' + sLWPFAZAPROD_ID    + ' = ' + 'FAZA'  + '.' + sLWPFAZAPROD_ID, qjkLeftOuter, true);
      AddExpres('RECP' + '.' + sLWPRECEPTURA_ID    + ' = ' + 'REC'  + '.' + sLWPRECEPTURA_ID, qjkLeftOuter, true);
      AddExpres(sZLEALIAS_ZasobyPraca + '.' + sLWPPLANPRODEL_ID    + ' = ' + 'PLANEL'  + '.' + sLWPPLANPRODEL_ID, qjkLeftOuter, false);
      AddExpres(sZLEALIAS_ZasobyPraca + '.' + sLWPRAPORTPRODTYP_ID + ' = RT.' + sLWPRAPORTPRODTYP_ID, qjkLeftOuter, false);
    end;
    m_iZlecenieIndeks := AddEmptyCondition();
    m_iTrybPracyIndeks:= AddEmptyCondition();
    m_iZleConst_RodzajEcpId := AddEmptyCondition();
    m_iZakresConditionId := AddEmptyCondition();
    m_iMasterConditionId := AddEmptyCondition();
  end;
  ComposeConditions();

  inherited;
end;

procedure TZLEZasobyPracaDataModule.ComposeConditions();
var
  oParams:        TKeyValues;
  sDopisz, sWhere: String;
begin
  if (Owner <> nil) and
     (Owner is TZleZasobyPracaDBGridForm) and
     TZleZasobyPracaDBGridForm(Owner).FormIsContained then  begin
     ChangeMasterKey;
      {if sWhere <> '' then
        GridJoinDefs.ExchangeCondition( m_iZakresConditionId, sWhere, true )
      else
        GridJoinDefs.Items[m_iZakresConditionId].Required := false;}
     end;

  if (not ParamIsNotEmpty(MasterKeyValues, sZLEZLECENIE_ID, m_sZlecenieId)) then begin
    oParams := TKeyValues.CreateEmpty();
    try
      (Owner as TUNIForm).GetParametersForForm((Owner as TUNIForm), oParams);
      ParamIsNotEmpty(oParams, sZLEZLECENIE_ID, m_sZlecenieId);
    finally
      oParams.Free();
    end;
  end;  // if nie ma id zlecenia w MasterKeyValues
  if(Length(m_sZlecenieId) > 0) then begin
    GridJoinDefs.ExchangeCondition(m_iZlecenieIndeks, sZLEALIAS_ZasobyPraca + '.' + sZLEZLECENIE_ID  + ' = ' + m_sZlecenieId, true);
  end else begin
    GridJoinDefs.ExchangeCondition(m_iZlecenieIndeks, '', false);
  end;
  if((Owner <> nil) and (Owner as TZleZasobyPracaDBGridForm).TrybCheckBox.Checked) then begin
    GridJoinDefs.ExchangeCondition(
      m_iTrybPracyIndeks,
      sZLEALIAS_ZasobyPraca + '.' + sZLEZASOBYPRACA_ID + ' in (' +
        ADMID_SelectSQL(
          cADMIDFunZLEZlecPracaZMag_Utworzone,
          0,
          SecurityManager.UserId,
          '',
          vAktywnaFirma
        ) +
      ')',
      true
    );
  end else
    GridJoinDefs.ExchangeCondition(m_iTrybPracyIndeks, '', false);

  if ((Owner <> nil) and
      ((Owner as TZleZasobyPracaDBGridForm).Parameters.Values[sZLECONST_RODZAJECP_ID] <> '')) then begin
    if (((Owner as TZleZasobyPracaDBGridForm).Parameters.Values[sZLECONST_RODZAJECP_ID] = cZLERodzajECP_ProdukcjaID) or
        ((Owner as TZleZasobyPracaDBGridForm).Parameters.Values[sZLECONST_RODZAJECP_ID] = cZLERodzajECP_RozliczID)) then
    GridJoinDefs.ExchangeCondition(
      m_iZleConst_RodzajEcpId,
      sZLEALIAS_ZasobyPraca + '.' + sZLECONST_RODZAJECP_ID + ' in (' + QuotedStr((Owner as TZleZasobyPracaDBGridForm).Parameters.Values[sZLECONST_RODZAJECP_ID]) + ')',
      true
    )
    else
    GridJoinDefs.ExchangeCondition(
      m_iZleConst_RodzajEcpId,
      sZLEALIAS_ZasobyPraca + '.' + sZLECONST_RODZAJECP_ID + ' in (' + QuotedStr(cZLERodzajECP_ZasobID) + ', ' +
                                                                       QuotedStr(cZLERodzajECP_OsobaID) + ')',
      true
    );
  end else
    GridJoinDefs.ExchangeCondition(m_iZleConst_RodzajEcpId, '', false);

  {m_iZakresConditionId - elementy zakresu}
  oParams := nil;
  sWhere := '';

  if (Owner <> nil) and (Owner is TZleZasobyPracaDBGridForm) then begin
    try
      //oParams := TKeyValues.CreateEmpty();
      //(Owner as TZleZasobyPracaDBGridForm).GetParametersForForm( (Owner as TZleZasobyPracaDBGridForm), oParams );
      if (Owner as TZleZasobyPracaDBGridForm).Parameters = nil then exit;
      with (Owner as TZleZasobyPracaDBGridForm).Parameters do begin
        //zlezlecenie_id
        if (Values[sParam_ZLEZlecenieID] <> '') then
           DopiszDoWhere(sZLEALIAS_ZasobyPraca + '.' + sZLEZLECENIE_ID + ' IN ('+ Values[sParam_ZLEZlecenieID] + ')', sWhere);

        //kdosoba_id
        if (Values[sParam_ZLEOsobaID] <> '') then
           DopiszDoWhere(sZLEALIAS_ZasobyPraca + '.' + sKDOSOBA_ID + ' IN ('+ Values[sParam_ZLEOsobaID] + ')', sWhere);

        //ZLEZASOB_ID
        if (Values[sParam_ZLEZasobID] <> '') then
           DopiszDoWhere(sZLEALIAS_ZasobyPraca + '.' + sZLEZASOB_ID + ' IN ('+ Values[sParam_ZLEZasobID] + ')', sWhere);

        if DataManagers.Available(sKDPRAModulID) and (ZLEDM.vZLEWysylanieECPWlaczone or ZLEDM.vZLEWysylanieRozliczECPWlaczone) then begin
           if (Values[sParam_ZLESkladCzasuID] <> '') then
             DopiszDoWhere(sZLEALIAS_ZasobyPraca + '.' + sKDSKLADNIKCZASU_ID + ' IN ('+ Values[sParam_ZLESkladCzasuID] + ')', sWhere);
        end;

        if Values[sParam_ZLEOkresID] <> '' then begin
           if (Values[sParam_ZLEOkresID] <> '0') and (Values[sParam_ZLEOkresID] <> '-1') then
              DopiszDoWhere(sZLEALIAS_ZasobyPraca + '.' + sUNIOKRES_ID + ' IN ('+ Values[sParam_ZLEOkresID] + ')', sWhere);
        end;
        //data
        sDopisz := '';
        if (Values[sParam_ZLEDataOd] <> '')and(Values[sParam_ZLEDataOd] <> '0')and
           (Values[sParam_ZLEDataDo] <> '')and(Values[sParam_ZLEDataDo] <> '0') then begin
          sDopisz := sZLEALIAS_ZasobyPraca + '.'+sZLEZASOBYPRACA_DATA+' between '+
                     KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataOd]))+' and '+
                     KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataDo]));
        end else if (Values[sParam_ZLEDataOd] <> '')and(Values[sParam_ZLEDataOd] <> '0') then begin
          sDopisz := sZLEALIAS_ZasobyPraca + '.'+sZLEZASOBYPRACA_DATA+'>='+KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataOd]));
        end else if (Values[sParam_ZLEDataOtwDo] <> '')and(Values[sParam_ZLEDataOtwDo] <> '0') then begin
          sDopisz := sZLEALIAS_ZasobyPraca + '.'+sZLEZASOBYPRACA_DATA+'<='+KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataDo]));
        end;
        if sDopisz <> '' then DopiszDoWhere(sDopisz, sWhere );

        {if (vWielofirmowosc and ZLEDM.vZLEWspolneZlecenia) or (vWieloodzialowosc) then
           if Values[sUNIODDZIAL_ID] <> '' then
              DopiszDoWhere( 'G.'+sUNIODDZIAL_ID+' in (' + Values[sUNIODDZIAL_ID] + ')', sWhere );}
      end;

      if sWhere <> '' then
        GridJoinDefs.ExchangeCondition( m_iZakresConditionId, sWhere, true )
      else
        GridJoinDefs.Items[m_iZakresConditionId].Required := false;
    finally
      if oParams <> nil then oParams.Free;
    end;
  end;
end;

procedure TZLEZasobyPracaDataModule.Post;
  var
    trans: Boolean;
    sListaMnem: String;
    iZLEZasobyPracaID, iOsobaID, iOsobaOldID, iSkladnikCzasuID: Integer;
    slRaportBledow: TStringList;
    bBladUsuwaniaOjca, bPrzerwijZapis: Boolean;
    dOd, dDo: TDateTime;
    iGodziny, iRazemGodzin, i: Integer;
    oQuery, oInsertQuery: TUNIQuery;
    sListaPK, sKomunikat: String;
    aMnem: TaMnemValue;
    iZlecID, iPozID, idx, iSumaGodzin: Integer;
begin
  trans:= not SQLManager.InTransaction;
  if trans then SQLManager.StartTransaction;
  try
    iZLEZasobyPracaID := ActiveQuery.FieldByName(sZLEZASOBYPRACA_ID).AsInteger;
    iOsobaID          := ActiveQuery.FieldByName(sKDOSOBA_ID).AsInteger;
    iSkladnikCzasuID  := ActiveQuery.FieldByName(sKDSKLADNIKCZASU_ID).AsInteger;
    dOd               := ActiveQuery.FieldByName(sZLEZASOBYPRACA_DATA).AsDateTime;
    dDo               := ActiveQuery.FieldByName(sZLEZASOBYPRACA_DATA_DO).AsDateTime;
    sKomunikat := '';

    iOsobaOldID := 0;
    if OpenMode = omEdit then begin
       oQuery := SQLManager.CreateQuery('SELECT ZP.' + sKDOSOBA_ID + ' ' +
                                        'FROM %s ZP ' +
                                        'WHERE ZP.' + sZLEZASOBYPRACA_ID + ' = ' + IntToStr(iZLEZasobyPracaID),
                                        [sZLEZASOBYPRACA]);

       try
          oQuery.Open();
          if not oQuery.IsEmpty then
             iOsobaOldID := oQuery.FieldByName(sKDOSOBA_ID).AsInteger;
       finally
          if oQuery <> nil then FreeAndNil(oQuery);
       end;
    end;

    if ZLEDM.vZLEFormatGodzinLiczba then begin
      iGodziny := Trunc(60.0 * ActiveQuery.FieldByName(sZLEZASOBYPRACA_CZAS_PRACY_NOM).AsFloat);
      iRazemGodzin := Trunc(60.0 * ActiveQuery.FieldByName(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat);
    end else begin
      iGodziny := Trunc(ActiveQuery.FieldByName(sZLEZASOBYPRACA_CZAS_PRACY_NOM).AsFloat);
      iRazemGodzin := Trunc(ActiveQuery.FieldByName(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat);
    end;

    sListaPK := '';

    slRaportBledow := TStringList.Create();
    bBladUsuwaniaOjca := False;
    bPrzerwijZapis := False;

    inherited;
    {Zapis danych z osadzonych gridw}

    if (Owner.Owner is TZLEZasobyPracaDBGridForm) and
       (Owner.Owner as TZLEZasobyPracaDBGridForm).FormIsContained then
      Exit;

    if Owner is TZLEZasobyPracaDBDetailForm then begin
       with (Owner as TZLEZasobyPracaDBDetailForm) do begin

         if ZLEDM.vZLEWysylanieECPWlaczone and
            (OpenMode in [omNew, omEdit]) and
            ((iOsobaID > 0) or (iOsobaOldID > 0)) and
            ((RodzajECP = cZLERodzajECP_OsobaID) or (RodzajECP = cZLERodzajECP_ZasobID)) {and
            ((Owner as TZLEZasobyPracaDBDetailForm).bOsobyKDECP)} then begin

            if (ZLEDM.vZLESkladnikECPDomyslnyID <= 0) and (iSkladnikCzasuID <= 0) then begin
               Komunikat(cError, 'W parametrach wczona zostaa komunikacja z moduem kadrowym ECP'#13+
                                 'a nie ustawiono domyslnego skadnika czasu pracy');
               bPrzerwijZapis := True;
            end;

            if not bPrzerwijZapis then begin
              sListaMnem := KDECPDM.KDECPDajListeMnemonikow(sZRODLO_ZLECENIA);
              {Obecnie obsugiwane mnemoniki:
               sMnemonikJednostkaOrg,
               sMnemonikZlecenie,
               sMnemonikPracownicy}
              if sListaMnem <> '' then begin
                 oQuery := SQLManager.CreateQuery('SELECT ZP.' + sZLEZLECENIE_ID + ', ' +
                                                         'ZP.' + sZLEZLECENIEPOZ_ID + ', ' +
                                                         'ZP.' + sKDOSOBA_ID + ', ' +
                                                         'ZL.' + sUNIJEDNOSTKAORG_ID + ' ' +
                                                  'FROM %s ZP, %s ZL ' +
                                                  'WHERE ZP.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' AND ' +
                                                        'ZP.' + sZLEZASOBYPRACA_ID + ' = ' + IntToStr(iZLEZasobyPracaID),
                                                  [sZLEZASOBYPRACA, sZLEZLECENIE]);

                 try
                    oQuery.Open();
                    if not oQuery.IsEmpty then begin
                      iPozID := oQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger;
                      iZlecID := oQuery.FieldByName(sZLEZLECENIE_ID).AsInteger;
                      if Pos(sMnemonikJednostkaOrg, sListaMnem) > 0 then
                         sListaPK := sMnemonikJednostkaOrg + '=' + IntToStr(oQuery.FieldByName(sUNIJEDNOSTKAORG_ID).AsInteger);
                      if Pos(sMnemonikZlecenie, sListaMnem) > 0 then begin
                          if sListaPK <> '' then sListaPK := sListaPK + ',';
                          sListaPK := sListaPK + sMnemonikZlecenie + '=' + IntToStr(oQuery.FieldByName(sZLEZLECENIE_ID).AsInteger);
                      end;
                      if Pos(sMnemonikPracownicy, sListaMnem) > 0 then begin
                         if sListaPK <> '' then sListaPK := sListaPK + ',';
                         sListaPK := sListaPK + sMnemonikPracownicy + '=' + IntToStr(oQuery.FieldByName(sKDOSOBA_ID).AsInteger);
                      end;

                      if (iPozID > 0) and (iZlecID > 0) and ZLEDM.vZLEWymaganaPozycjaEwid then begin
                        SetLength(aMnem, 0);
                        if ZLEDM.ZLEMnemonikiDlaPozycjiZlecenia(iZlecID, iPozID, aMnem) <> 0 then begin
                          //Bd podczas wywoania funkcji
                          Komunikat(cError, 'Bd wywoania funkcji ZLEMnemonikiDlaPozycjiZlecenia');
                          Abort;
                        end else begin
                          if length(aMnem) > 0 then begin
                             for idx := 0 to length(aMnem) - 1 do begin
                                if Pos(aMnem[idx].sName, sListaMnem) > 0 then begin
                                  if sListaPK <> '' then sListaPK := sListaPK + ',';
                                  sListaPK := sListaPK + aMnem[idx].sName + '=' + aMnem[idx].sValue;
                                end;
                             end;
                          end;
                        end
                      end;
                    end;
                 finally
                    if oQuery<> nil then FreeAndNil(oQuery);
                 end;
              end;

              try
                if (OpenMode = omEdit) and (iOsobaOldID > 0) then
                   KDECPDM.KDECPUsunWgOjca(sZRODLO_ZLECENIA,iZLEZasobyPracaID, slRaportBledow);

                if slRaportBledow.Count > 0 then begin
                  sKomunikat := 'Bd usuwania danych w ECP: ';
                  for i := 0 to slRaportBledow.Count -1 do begin
                    if sKomunikat <> '' then sKomunikat := sKomunikat + chr(13) + ' ';
                    sKomunikat := sKomunikat + slRaportBledow[i];
                  end;

                  if ZLEDM.vZLEUwzglednijBlokadeKDECP then begin
                     Komunikat(cError, sKomunikat + chr(13) + 'Zmiany nie zostan zapisane');
                     bPrzerwijZapis := True;
                     //Abort;
                  end else begin
                    if Komunikat(cConfirmation, sKomunikat + chr(13) + 'Kontynuowac zapis?', MB_YesNo + MB_DEFBUTTON2) = idYes then begin
                      //Zapisujemy zgod na desynchronizacj danych i pomijamy zapis nowych danych do ECP
                      bPrzerwijZapis := False;

                      //Dopisac obsluge zapisu bledow
                      oInsertQuery := SQLManager.InsertQueryStep1( sZLEZASOBYPRACARAP,
                                                       sZLEZASOBYPRACARAP_ID+','+
                                                       sZLEZASOBYPRACA_ID+','+
                                                       sSMUSER_ID + ',' +
                                                       sZLECONST_ZASOBYPRACARAPST_ID+','+
                                                       {sZLEZASOBYPRACARAP_BLAD_ID+','+}
                                                       sZLEZASOBYPRACARAP_KOMUNIKAT + ',' +
                                                       sZLEZASOBYPRACARAP_UZ_AU_ID+','+
                                                       sZLEZASOBYPRACARAP_DATA_AU );

                       try
                         with oInsertQuery do begin
                           ParamByName(sZLEZASOBYPRACARAP_ID).DataType := ftInteger;

                           ParamByName(sZLEZASOBYPRACA_ID).DataType := ftInteger;
                           ParamByName(sSMUSER_ID).DataType := ftInteger;
                           ParamByName(sZLECONST_ZASOBYPRACARAPST_ID).DataType := ftString;
                           ParamByName(sZLEZASOBYPRACARAP_KOMUNIKAT).DataType := ftString;
                           ParamByName(sZLEZASOBYPRACARAP_UZ_AU_ID).DataType := ftInteger;
                           ParamByName(sZLEZASOBYPRACARAP_DATA_AU).DataType := ftDate;

                           ParamByName(sZLEZASOBYPRACA_ID).AsInteger := iZLEZasobyPracaID;
                           ParamByName(sSMUSER_ID).AsInteger := SecurityManager.UserId;
                           ParamByName(sZLECONST_ZASOBYPRACARAPST_ID).AsString := cZLEConstZasobyPracaRapStatus_NiezgodnyID;
                           ParamByName(sZLEZASOBYPRACARAP_KOMUNIKAT).AsString := sKomunikat;
                           ParamByName(sZLEZASOBYPRACARAP_UZ_AU_ID).AsInteger := SecurityManager.UserId;
                           ParamByName(sZLEZASOBYPRACARAP_DATA_AU).AsDateTime := UNIDate;
                         end;

                         SQLManager.InsertQueryStep2( oInsertQuery, sZLEZASOBYPRACARAP_ID );
                       finally
                         if oInsertQuery <> nil then FreeAndNil(oInsertQuery);
                       end;
                    end else begin
                      bPrzerwijZapis := True;
                      bBladUsuwaniaOjca := True;
                      Abort;
                    end;
                  end;
                end;

              except
                Komunikat(cError, 'Nie mona usunc danych z ECP'#13+Exception(ExceptObject).Message);
                //Komunikat(cError, 'Nie mona usunc danych z ECP');
                bPrzerwijZapis := True;
                Abort;
              end;

              if (not bBladUsuwaniaOjca) and (iOsobaID > 0) and (not bPrzerwijZapis) then begin
                 try
                   {Czyszczymy list bdow}
                   slRaportBledow.Clear();
                   if dDo < dOd then dDo := dOd; //Jesli nie ma daty do to bierzemy date dOd

                   KDECPDM.KDECPWprowadzSkladnikExt(''{sCP_ListaID}, //Lista umow
                                                    IntToStr(iOsobaID) {sOS_ListaID},
                                                    iSkladnikCzasuID, {ZLEDM.vZLESkladnikECPDomyslnyID,}
                                                    dOd,
                                                    dDo,
                                                    sZRODLO_ZLECENIA,
                                                    iGodziny,
                                                    0, 0, 0,
                                                    sListaPK,
                                                    iZLEZasobyPracaID,
                                                    slRaportBledow,
                                                    '',
                                                    '',
                                                    '',
                                                    iSumaGodzin);

                   if slRaportBledow.Count > 0 then begin
                      // Tu obsuga bdow zapisu nowych danych
                      sKomunikat := 'Bd zapisu danych: ' + chr(13);
                      for i := 0 to slRaportBledow.Count -1 do begin
                         if sKomunikat <> '' then sKomunikat := sKomunikat + chr(13) + ' ';
                         sKomunikat := sKomunikat + slRaportBledow[i];
                      end;

                      if ZLEDM.vZLEUwzglednijBlokadeKDECP then begin
                         Komunikat(cError, sKomunikat + chr(13) + 'Zmiany nie zostan zapisane');
                         bPrzerwijZapis := True;
                         //Abort;
                      end else begin
                        if Komunikat(cConfirmation, sKomunikat + chr(13) + 'Kontynuowac zapis?', MB_YesNo + MB_DEFBUTTON2) = idYes then begin
                           //Zapisujemy zgod na desynchronizacj danych i pomijamy zapis nowych danych do ECP
                           //bBladUsuwaniaOjca := True;
                           //Zapisz bd do Raportow i kontynuuj
                           oInsertQuery := SQLManager.InsertQueryStep1( sZLEZASOBYPRACARAP,
                                                           sZLEZASOBYPRACARAP_ID+','+
                                                           sZLEZASOBYPRACA_ID+','+
                                                           sSMUSER_ID + ',' +
                                                           sZLECONST_ZASOBYPRACARAPST_ID+','+
                                                           {sZLEZASOBYPRACARAP_BLAD_ID+','+}
                                                           sZLEZASOBYPRACARAP_KOMUNIKAT + ',' +
                                                           sZLEZASOBYPRACARAP_UZ_AU_ID+','+
                                                           sZLEZASOBYPRACARAP_DATA_AU );

                           try
                             with oInsertQuery do begin
                               ParamByName(sZLEZASOBYPRACARAP_ID).DataType := ftInteger;

                               ParamByName(sZLEZASOBYPRACA_ID).DataType := ftInteger;
                               ParamByName(sSMUSER_ID).DataType := ftInteger;
                               ParamByName(sZLECONST_ZASOBYPRACARAPST_ID).DataType := ftString;
                               ParamByName(sZLEZASOBYPRACARAP_KOMUNIKAT).DataType := ftString;
                               ParamByName(sZLEZASOBYPRACARAP_UZ_AU_ID).DataType := ftInteger;
                               ParamByName(sZLEZASOBYPRACARAP_DATA_AU).DataType := ftDate;

                               ParamByName(sZLEZASOBYPRACA_ID).AsInteger := iZLEZasobyPracaID;
                               ParamByName(sSMUSER_ID).AsInteger := SecurityManager.UserId;
                               ParamByName(sZLECONST_ZASOBYPRACARAPST_ID).AsString := cZLEConstZasobyPracaRapStatus_NiezgodnyID;
                               ParamByName(sZLEZASOBYPRACARAP_KOMUNIKAT).AsString := sKomunikat;
                               ParamByName(sZLEZASOBYPRACARAP_UZ_AU_ID).AsInteger := SecurityManager.UserId;
                               ParamByName(sZLEZASOBYPRACARAP_DATA_AU).AsDateTime := UNIDate;
                             end;

                             SQLManager.InsertQueryStep2( oInsertQuery, sZLEZASOBYPRACARAP_ID );
                           finally
                             if oInsertQuery <> nil then FreeAndNil(oInsertQuery);
                           end;
                        end else begin
                          //Komunikat(cWarning, 'Zmiany nie zostay zapamitane');
                          bPrzerwijZapis := True;
                        end;
                      end;
                   end;

                   if (not bPrzerwijZapis) and (iRazemGodzin <> iSumaGodzin) then  begin
                      //Aktualizacja pola ZLEZASOBYPRACA_CZAS_PRACY
                      SQLManager.ExecuteQuery('UPDATE %s ' +
                                              'SET ' + sZLEZASOBYPRACA_CZAS_PRACY + ' = ' + IntToStr(iSumaGodzin) + ' ' +
                                              'WHERE ' + sZLEZASOBYPRACA_ID + ' = ' + IntToStr(iZLEZasobyPracaID),
                                             [sZLEZASOBYPRACA]);
                   end;
                 except
                   Komunikat(cError, 'Bd komunikacji z moduem kadrowym ECP'#13+Exception(ExceptObject).Message);
                   //Komunikat(cError, 'Bd komunikacji z moduem kadrowym ECP');
                   bPrzerwijZapis := True;
                 end;
              end;
            end;
         end;

         if (not bPrzerwijZapis) and (RodzajECP = cZLERodzajECP_ProdukcjaID) then begin
             if ZakladkaOsobyFormIndex > -1 then begin
               try
                 ContainedDataModules[ZakladkaOsobyFormIndex].Post;
               except
                 ZakladkiPageControl.ActivePage := OsobyTabSheet;
                 raise;
               end;
             end;

             if ZakladkaBrakiFormIndex > -1 then begin
               try
                 ContainedDataModules[ZakladkaBrakiFormIndex].Post;
               except
                 ZakladkiPageControl.ActivePage := BrakiTabSheet;
                 raise;
               end;
             end;
         end;
       end;
    end;

    if trans and (not bPrzerwijZapis) then SQLManager.Commit
    else if trans and bPrzerwijZapis then SQLManager.Rollback;
  except
    on EDMException do begin
      if trans then SQLManager.Rollback;
      if FLastDBError.SQLObjectName=sZLEZasobyBraki+'1'+c_UNK then begin
        Komunikat( cError,'Istnieje ju taki element');
        {with owner as TZLEBrakiDBDetailForm do
           ActiveControl:= SymbolDBEdit;}
        abort;
      end else raise;
    end else begin
      if trans then SQLManager.Rollback;
      raise;
    end;
  end;

end;

procedure TZLEZasobyPracaDataModule.Delete;
var
  bTrans: Boolean;
  iZLEZasobyPracaID, i, iOsobaID: Integer;
  slRaportBledow: TStringList;
  sKomunikat: String;
  bPrzerwijZapis: Boolean;
begin
  bTrans:= not SQLManager.InTransaction;
  if bTrans then SQLManager.StartTransaction;
  try
    iZLEZasobyPracaID := ActiveQuery.FieldByName(sZLEZASOBYPRACA_ID).AsInteger;
    iOsobaID          := ActiveQuery.FieldByName(sKDOSOBA_ID).AsInteger;

    slRaportBledow    := TStringList.Create();
    bPrzerwijZapis    := False;
    sKomunikat        := '';

    if Owner is TZLEZasobyPracaDBDetailForm then begin
       with (Owner as TZLEZasobyPracaDBDetailForm) do begin
         if ZLEDM.vZLEWysylanieECPWlaczone and
            (iOsobaID > 0) and
            ((RodzajECP = cZLERodzajECP_OsobaID) or (RodzajECP = cZLERodzajECP_ZasobID)) then begin
           try
             KDECPDM.KDECPUsunWgOjca(sZRODLO_ZLECENIA,iZLEZasobyPracaID, slRaportBledow);
             if slRaportBledow.Count > 0 then begin
               sKomunikat := '';
               for i := 0 to slRaportBledow.Count -1 do begin
                   if sKomunikat <> '' then sKomunikat := sKomunikat + chr(13) + ' ';
                   sKomunikat := sKomunikat + slRaportBledow[i];
               end;

               if ZLEDM.vZLEUwzglednijBlokadeKDECP then begin
                 Komunikat(cError, sKomunikat + chr(13) + 'Nie mona usunc danych');
                 bPrzerwijZapis := True;
               end else begin
                 if Komunikat(cConfirmation, sKomunikat, MB_YesNo + MB_DEFBUTTON2) = idYes then begin
                    // Nie zapisujemy rekordu do raportow, bo kasujemy wpis w tabeli ZLEZASOBYPRACARAP,
                    // zatem pozostanie tylko wpis po stronie ECP
                 end else begin
                    //Komunikat(cWarning, 'Rezygnacja z usunicia danych');
                    bPrzerwijZapis := True;
                 end;
               end;
             end;

           except
             Komunikat(cError, 'Nie mona usunc danych z ECP');
             bPrzerwijZapis := True;
           end;
         end;

         if (not bPrzerwijZapis) and
            ZLEDM.vZLEWysylanieECPWlaczone and
            (iOsobaID > 0) and
            ((RodzajECP = cZLERodzajECP_OsobaID) or (RodzajECP = cZLERodzajECP_ZasobID)) then begin
            //Usuwamy dane z tabeli z raportami dla tej krotki
            SQLManager.ExecuteQuery('DELETE FROM %s ' +
                                    'WHERE ' + sZLEZASOBYPRACA_ID + '=' + IntToStr(iZLEZasobyPracaID),
                                    [sZLEZASOBYPRACARAP]);
         end;
         if (not bPrzerwijZapis) and (RodzajECP = cZLERodzajECP_ProdukcjaID) then begin
           if ZakladkaOsobyFormIndex > -1 then begin
              with ContainedDataModules[ZakladkaOsobyFormIndex] do begin
                ActiveQuery.First();
                while(not ActiveQuery.Eof) do begin
                  Delete();
                end;  // while(not ActiveQuery.Eof)
                Post();
              end;  // with ContainedDataModules[ZakladkaOsobyFormIndex]
           end;

           if ZakladkaBrakiFormIndex > -1 then begin
              with ContainedDataModules[ZakladkaBrakiFormIndex] do begin
                ActiveQuery.First();
                while(not ActiveQuery.Eof) do begin
                  Delete();
                end;  // while(not ActiveQuery.Eof)
                Post();
              end;  // with ContainedDataModules[ZakladkaBrakiFormIndex]
           end;
         end;
       end;
    end;

    if (not bPrzerwijZapis) then inherited;

    if bTrans and (not bPrzerwijZapis) then SQLManager.Commit
    else if bPrzerwijZapis and bTrans then  SQLManager.Rollback;
  except
    if bTrans then SQLManager.Rollback;
  end;
end;

procedure TZLEZasobyPracaDataModule.ReOpenDataSets();
begin
  ComposeConditions();
  inherited;
end;


procedure TZLEZasobyPracaDataModule.RefreshDataSets;
begin
  {nie wywoujemy inherited dla klasy TZLEszczegoloweKosztyDBGridForm}
  if (Owner.Owner is TZleZasobyPracaDBGridForm) or
     (Owner is TZleZasobyPracaDBGridForm) then
     inherited;
end;

procedure TZLEZasobyPracaDataModule.SetDisplayFormat;
var
  i: Integer;
begin
  inherited;
  for i := 0 to GridColDefs.Count - 1 do begin
    if GridColDefs[i].Active or (OpenModeFlags and omVirtual > 0) then begin
      if (GridColDefs[i].FieldName = sZLEZASOBYPRACA_IL_PRACY) then begin
        (ListQuery.FieldByName(sZLEZASOBYPRACA_IL_PRACY) as TNumericField).DisplayFormat := UNIGetMaskFromFormat(12.2{ASODM.vAsoFormatIlosci});
        (ListQuery.FieldByName(sZLEZASOBYPRACA_IL_PRACY) as TNumericField).EditFormat := UNIGetMaskFromFormat(12.2 {ASODM.vAsoFormatIlosci}, True);
      end;

      {if (GridColDefs[i].FieldName = sZLEZASOBYPRACA_CZAS_PRACY) then
        ListQuery.FieldByName(GridColDefs[i].FieldName).OnGetText := MojGetText;

      if (GridColDefs[i].FieldName = sKDZMIANYDEF_GODZ_POCZATEK) then
        ListQuery.FieldByName(GridColDefs[i].FieldName).OnGetText := MojGetText;

      if (GridColDefs[i].FieldName = sKDZMIANYDEF_GODZ_KONIEC) then
        ListQuery.FieldByName(GridColDefs[i].FieldName).OnGetText := MojGetText;}

    end;
  end;
end;

procedure TZLEZasobyPracaDataModule.MojGetText(Sender: TField; var Text: String;
  DisplayText: Boolean);
begin //do pl godzinowych
 if Sender.AsString = '' then exit;

 if ZLEDM.vZLEFormatGodzinLiczba and (Sender.FieldName = sZLEZASOBYPRACA_CZAS_PRACY) then
      Text := Sender.AsString
 else Text := WyznaczGodzine(Sender.AsInteger); //?? mod 1440);
end;

end.
