unit ZLEZasobyPracaZMagazynuSelectFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2008-09-01 Adam     Utworzone
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNISelectFormUnit, Menus, UNIComponentsUnit, ToolWin, ComCtrls, StdCtrls,
  ExtCtrls, Mask, UNIRangeFormUnit,
  DB;

type
  TZLEZasobyPracaZMagazynuSelectForm = class(TUNISelectForm)
    UNILabel1: TUNILabel;
    UNILabel2: TUNILabel;
    MAGTypDokRangeLookupAliasEdit: TUNIRangeLookupAliasEdit;
    MAGDokumentyRangeLookupAliasEdit: TUNIRangeLookupAliasEdit;
    procedure MAGTypDokRangeLookupAliasEditInitAliasInfo(Sender: TObject);
    function MAGTypDokRangeLookupAliasEditGetQuery: TUNIQuery;
    function MAGTypDokRangeLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    procedure MAGDokumentyRangeLookupAliasEditInitAliasInfo(
      Sender: TObject);
    function MAGDokumentyRangeLookupAliasEditGetQuery: TUNIQuery;
    function MAGDokumentyRangeLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
  public
    destructor  Destroy();  override;

  protected
    procedure InternalOpen(); override;
    procedure BeforeShow(); override;
    procedure SelectButtonPressed();  override;
    procedure CancelButtonPressed();  override;

  private
    m_oWybraneTypDok: TStringList;
    m_oWybraneDok:    TStringList;
    m_oRange:         TRangeParamsList;

    procedure SetControlProperties();

  end;

implementation
uses
  SecurityManagerUnit,
  FormManagerUnit,
  Dodatki,
  KeyManagerUnit,
  UNIDBGridFormUnit,
  UNIDataManagerUnit,
  MAGDataManagerExtUnit,
  UNISysDefUnit,
  MAGDefUnit,
  ZLEDefUnit;

{$R *.DFM}

destructor  TZLEZasobyPracaZMagazynuSelectForm.Destroy();
begin
  m_oWybraneTypDok.Free();
  m_oWybraneDok.Free();
  m_oRange.Free();
  inherited;
end;

procedure TZLEZasobyPracaZMagazynuSelectForm.InternalOpen();
begin
  m_oWybraneTypDok:= ADMID_CreateAndLoad(cADMIDFunZLEZlecPracaZMag_TypDok, 0, SecurityManager.UserId, '');
  m_oWybraneDok   := ADMID_CreateAndLoad(cADMIDFunZLEZlecPracaZMag_Dok, 0, SecurityManager.UserId, '');
  inherited;
end;

procedure TZLEZasobyPracaZMagazynuSelectForm.BeforeShow();
begin
  inherited;
  SetControlProperties();
end;

procedure TZLEZasobyPracaZMagazynuSelectForm.SelectButtonPressed();
begin
  inherited;
  if(ModalResult = mrOk) then begin
    ADMID_Save(cADMIDFunZLEZlecPracaZMag_TypDok, 0, SecurityManager.UserId, '', nil, m_oWybraneTypDok);
    ADMID_Save(cADMIDFunZLEZlecPracaZMag_Dok, 0, SecurityManager.UserId, '', nil, m_oWybraneDok);
  end;  // if(ModalResult = mrOk)
end;

procedure TZLEZasobyPracaZMagazynuSelectForm.CancelButtonPressed();
begin
  inherited;
end;

procedure TZLEZasobyPracaZMagazynuSelectForm.SetControlProperties();
begin
  m_oRange  := TRangeParamsList.Create();
  MAGTypDokRangeLookupAliasEdit.RangeParam    := m_oRange.Add(sMAGTYPDOK_ID, m_oWybraneTypDok.CommaText);
  MAGTypDokRangeLookupAliasEdit.InitiateData();
  MAGDokumentyRangeLookupAliasEdit.RangeParam := m_oRange.Add(sMAGOBR_ID, m_oWybraneDok.CommaText);
  MAGDokumentyRangeLookupAliasEdit.InitiateData();
end;

procedure TZLEZasobyPracaZMagazynuSelectForm.MAGTypDokRangeLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  if DataManagers.Available(sMAGModulID) then  begin
    with MAGTypDokRangeLookupAliasEdit do begin
      AliasManager  := MAGDM.AliasManager;
      Alias_ID      := sMAGALIAS_MAGTYPDOK_ID;
      Alias_Name    := sMAGALIAS_MAGTYPDOK_SYMBOL;
    end;
  end;
end;

function TZLEZasobyPracaZMagazynuSelectForm.MAGTypDokRangeLookupAliasEditGetQuery: TUNIQuery;
var
  sAliasy:  string;
  sWarunek: string;
begin
  result := nil;
  if not DataManagers.Available(sMAGModulID) then Exit;

  UNIDajAliasyZLookupa(MAGTypDokRangeLookupAliasEdit, sAliasy, sWarunek);
  result  := MAGDM.PokazIObsluzDane(sMAGTYPDOK,
    sWarunek, true, true, sAliasy, vAktywnaFirma, 0,
    nil, nil,
    m_oWybraneTypDok
  );
end;

function TZLEZasobyPracaZMagazynuSelectForm.MAGTypDokRangeLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  m_oWybraneTypDok.Clear();
  result  := true;
  while(not AliasSrc.Eof) do begin
    m_oWybraneTypDok.Add(AliasSrc.Fields[0].AsString);
    AliasSrc.Next();
  end;  // while(not AliasSrc.Eof)
end;

procedure TZLEZasobyPracaZMagazynuSelectForm.MAGDokumentyRangeLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  if DataManagers.Available(sMAGModulID) then begin
    with MAGDokumentyRangeLookupAliasEdit do begin
      AliasManager  := MAGDM.AliasManager;
      Alias_ID      := sMAGALIAS_MAGOBR_ID;
      Alias_Name    := sMAGALIAS_MAGOBR_NUMER;
    end;
  end;
end;

function TZLEZasobyPracaZMagazynuSelectForm.MAGDokumentyRangeLookupAliasEditGetQuery: TUNIQuery;
var
  sAliasy:  string;
  sWarunek: string;
  oParams:  TKeyValues;
begin
  result := nil;
  if not DataManagers.Available(sMAGModulID) then Exit;

  UNIDajAliasyZLookupa(MAGDokumentyRangeLookupAliasEdit, sAliasy, sWarunek);
  oParams := TKeyValues.CreateAs(
    [
      cMAGOBROPENMODE + '=' + cMOOB_ORDINARY,
      cRangeClassName + '=TMAGObrZakresSelectForm',
      cFORM_CAPTION   + '=Dokumenty magazynowe'
    ]
  );
  if(m_oWybraneTypDok.Count > 0) then
    oParams.Values[sMAGTYPDOK_ID] := '(' + m_oWybraneTypDok.CommaText + ')';
  if(MAGDM.vMAGPaczkaUniInt() <> 0) then
    oParams.Values[sMAGPACZKA_ID] := IntToStr(MAGDM.vMAGPaczkaUniInt());

  result  := MAGDM.MAGPokazIObsluzDane(sMAGOBR,
    sWarunek, true, true, sAliasy, vAktywnaFirma, 0,
    nil, oParams,
    m_oWybraneDok
  );
end;

function TZLEZasobyPracaZMagazynuSelectForm.MAGDokumentyRangeLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  m_oWybraneDok.Clear();
  result  := true;
  while(not AliasSrc.Eof) do begin
    m_oWybraneDok.Add(AliasSrc.Fields[0].AsString);
    AliasSrc.Next();
  end;  // while(not AliasSrc.Eof)
end;

initialization
  FormManager.RegisterForm(TZLEZasobyPracaZMagazynuSelectForm, sZLEModulID );
end.
