unit ZLEZasobyPrzeliczSelectFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2009-05-20 Tomjen   Utworzone
---------------------------------------------------------------------------------------------
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNISelectFormUnit, Menus, UNIComponentsUnit, ToolWin, ComCtrls, StdCtrls,
  ExtCtrls, Mask, DBGrids, DBCtrls, DBClient, Db, DBTables, UNIDateEditUnit,
  UNIRangeFormUnit;

type
  TZLEZasobyPrzeliczSelectForm = class(TUNISelectForm)
    OkresLookupAliasEdit: TUNILookupAliasEdit;
    OkresLabel: TUNILabel;
    DataLabel: TUNILabel;
    DataOdDateEdit: TUNIDateEdit;
    DataDoLabel: TUNILabel;
    DataDoDateEdit: TUNIDateEdit;
    ZlecenieLabel: TUNILabel;
    ZlecenieLookupAliasEdit: TUNILookupAliasEdit;
    JednOrgLabel: TUNILabel;
    JednostkaOrgLookupAliasEdit: TUNILookupAliasEdit;
    procedure OkresLookupAliasEditButtonClick(Sender: TObject);
    function  OkresLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure OkresLookupAliasEditDelKey(Sender: TObject);
    procedure ZlecenieLookupAliasEditButtonClick(Sender: TObject);
    procedure ZlecenieLookupAliasEditDelKey(Sender: TObject);
    function  ZlecenieLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure DataOdDateEditDateChange(Sender: TObject);
    procedure DataDoDateEditDateChange(Sender: TObject);
    procedure JednostkaOrgLookupAliasEditButtonClick(Sender: TObject);
    procedure JednostkaOrgLookupAliasEditDelKey(Sender: TObject);
    function JednostkaOrgLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
  private
    sZLEZlecenieID: String;
    iDataOd, iDataDo: Integer; //Data zapamietana jako liczba
    iAktOkresID  : Integer;
    bUstawOkres : Boolean;
    iJednostkaID: Integer;
  protected
    procedure BeforeShow; override;
    procedure InternalOpen; override;
    procedure SelectButtonPressed; override;
    procedure WczytajZakresyDatDlaOkresu(iOkresID:Integer;
                                         var dOkresOd:TDateTime;
                                         var dOkresDo:TDateTime);
  public
    function  Validate(): Boolean; override;

  end;

var
  ZLEZasobyPrzeliczSelectForm: TZLEZasobyPrzeliczSelectForm;

implementation
uses
  SQLManagerUnit,
  SecurityManagerUnit,
  UNISysDefUnit,
  Dodatki,
  UniSysDataManagerUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit,
  FormManagerUnit;

{$R *.DFM}

procedure TZLEZasobyPrzeliczSelectForm.WczytajZakresyDatDlaOkresu(
                                        iOkresID:Integer;
                                        var dOkresOd:TDateTime;
                                        var dOkresDo:TDateTime);
var
  Q    :TUNIQuery;
  sSQL :string;

begin
  //musz wczyta min i max zakres dat
  sSQL:=UNISysDM.UNIOdpytajODaneSQL( sUNIOKRES,
                            sUNISYSALIAS_Poczatek_Okresu_Obrachunkowego+';'+
                            sUNISYSALIAS_Koniec_Okresu_Obrachunkowego,
                            '@'+sUNISYSALIAS_Okres_Obrachunkowy_ID+'='+IntToStr(iOkresID),false);

  Q := TUNIQuery.Create(nil);
  if Q <> nil then
  try
    SQLManager.OpenQuery(Q, sSQL, ['']);
    dOkresOd:=Q.Fields[0].AsDateTime;
    dOkresDo:=Q.Fields[1].AsDateTime;
  finally
    if Q <> nil then FreeAndNil(Q);
  end;
end;

procedure TZLEZasobyPrzeliczSelectForm.SelectButtonPressed;
begin
  if not Validate() then begin
    ModalResult := mrNone;
    Abort;
    Exit;
  end;

  if (sZLEZlecenieID = '') and
     (iAktOkresID <= 0) and
      (iDataOd = 0) and
      (iDataDo = 0) then begin
     Komunikat(cWarning, 'Musisz ograniczyc przeliczanie danych przynajmniej jednym parametrem');
     ModalResult := mrNone;
     Abort;
     Exit;
  end;

  if Parameters <> nil then begin
     Parameters.Values[sZLEZLECENIE_ID] := sZLEZlecenieID;
     Parameters.Values[sUNIOKRES_ID]    := IntToStr(iAktOkresID);
     Parameters.Values['DATA_OD']       := IntToStr(iDataOd);
     Parameters.Values['DATA_DO']       := intToStr(iDataDo);
     Parameters.Values[sUNIJEDNOSTKAORG_ID] := IntToStr(iJednostkaID);
  end;
  inherited;
end;

function TZLEZasobyPrzeliczSelectForm.Validate: Boolean;
var i: Integer;
    dOkresOd: TDateTime;
    dOkresDo: TDateTime;
begin
  result := inherited Validate;
  if not result then Exit;

  {Obecnie nie jest wymagana jednostka
  if iJednostkaID <= 0 then begin
     Komunikat(cInformation, 'Nie wypeniona jednostka organizacyjna');
     JednostkaOrgLookupAliasEdit.SetFocus;
     ModalResult := mrNone;
     Exit;
  end;}

  {Kontrola dat i okresu}
  if (DataOdDateEdit.Date > DataDoDateEdit.Date) and
     (DataDoDateEdit.Date <> 0) then
  begin
      //kontrola dat midzy sob
      Komunikat(cWarning, 'Bdny zakres dat dokumentw');
      ModalResult := mrNone;
      DataOdDateEdit.SetFocus;
      Exit;
  end else begin
    if iAktOkresID > 0 then begin
        i := iAktOkresID;

        WczytajZakresyDatDlaOkresu(i,dOkresOd,dOkresDo);
        if (DataOdDateEdit.Date <> 0) and
           ((DataOdDateEdit.Date > dOkresDo) or (DataOdDateEdit.Date < dOkresOd)) then
        begin
          Komunikat(cWarning, 'Zakres dat dokumentw nie pasuje do wybranego okresu');
          DataOdDateEdit.SetFocus;
          ModalResult := mrNone;
          Exit;
        end else if (DataDoDateEdit.Date <> 0) and
            ((DataDoDateEdit.Date > dOkresDo) or (DataDoDateEdit.Date < dOkresOd)) then
        begin
          Komunikat(cWarning, 'Zakres dat dokumentw nie pasuje do wybranego okresu');
          DataDoDateEdit.SetFocus;
          ModalResult := mrNone;
          Exit;
        end;
    end;
  end;

  result := true;
end;

procedure TZLEZasobyPrzeliczSelectForm.InternalOpen;
begin
  sZLEZlecenieID := '';
  iAktOkresID := -1;
  iDataOd := 0;
  iDataDo := 0;
  iJednostkaID := -1;
  inherited;
end;

procedure TZLEZasobyPrzeliczSelectForm.BeforeShow;
begin
  inherited;

  with ZlecenieLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_Id     := sZLEAlias_Zlecenie_ID;
    Alias_Name   := sZLEAlias_Zlecenie_Symbol;
    AdditionalAliases := sZLEAlias_Zlecenie_Nazwa;
    //aAllowEmpty  := False;
  end;

  with OkresLookupAliasEdit do begin
    AliasManager      := UniSysDataManager.AliasManager;
    Alias_ID          := sUNISYSALIAS_Okres_Obrachunkowy_ID;
    Alias_Name        := sUNISYSALIAS_Okres_Obrachunkowy_Nazwa;
    AdditionalAliases := sUNISYSALIAS_Okres_Obrachunkowy_Rok;
    AdditionalCondition :=
      '@' + sUNISYSALIAS_Okres_Obrachunkowy_Rok_ID + ' = ' + IntToStr(vAktywnyRokObrachunkowyID);
  end;  // with OkresLookupAliasEdit

  sZLEZlecenieID := '';
  iAktOkresID := -1;
  iDataOd := 0;
  iDataDo := 0;
  ActiveControl := ZlecenieLookupAliasEdit;
end;

procedure TZLEZasobyPrzeliczSelectForm.OkresLookupAliasEditButtonClick(
  Sender: TObject);
var
  Q:  TDataset;
begin
  Q:= UNISysDM.UNIPokazIWybierzOkresObrachunkowy(
    vAktywnyRokObrachunkowyID,'',
    sUNISYSALIAS_Okres_Obrachunkowy_ID + ';' +
    sUNISYSALIAS_Okres_Obrachunkowy_Nazwa + ';' +
    sUNISYSALIAS_Okres_Obrachunkowy_Rok,
    false{, IntToStr_ZeroToEmpty(iAktOkresID)});

  if Q<> nil then
    try
      OkresLookupAliasEditSetData(Q);
    finally
      Q.free;
    end;
end;

function TZLEZasobyPrzeliczSelectForm.OkresLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
var
  dOkresOd:TDateTime;
  dOkresDo:TDateTime;
begin
  result:= true;

  with AliasSrc do begin
    iAktOkresID := AliasSrc.FieldByName(sUNIOKRES_ID).AsInteger;
    OkresLookupAliasEdit.Text:= AliasSrc.FieldByName(sUNIOKRES_NAZWA).AsString;
    //RangeParam(sUNIROK_ROK_TEXT).Value:= AliasSrc.FieldByName(sUNIROK_ROK_TEXT).AsString;

    //Teraz ewentualna korekta zakresu dat
    if iAktOkresID > 0 then
    begin
      try
        bUstawOkres := True;

        //jest okres - trzeba wczyta min i max zakres dat
        WczytajZakresyDatDlaOkresu(iAktOkresID,dOkresOd,dOkresDo);

        if (DataOdDateEdit.Date < dOkresOd) or
           (DataOdDateEdit.Date > dOkresDo) then
           DataOdDateEdit.Date := dOkresOd;

        if (DataDoDateEdit.Date < dOkresOd) or
           (DataDoDateEdit.Date > dOkresDo) then
           DataDoDateEdit.Date := dOkresDo;

        if DataDoDateEdit.Date < DataOdDateEdit.Date then
        begin
           DataOdDateEdit.Date := dOkresOd;
           DataDoDateEdit.Date := dOkresDo;
        end;
      finally
        bUstawOkres := False;
      end;
    end;
  end;
end;

procedure TZLEZasobyPrzeliczSelectForm.OkresLookupAliasEditDelKey(
  Sender: TObject);
begin
  iAktOkresID := -1;
  OkresLookupAliasEdit.Text:= '';
end;

procedure TZLEZasobyPrzeliczSelectForm.ZlecenieLookupAliasEditButtonClick(
  Sender: TObject);
var
  Q: TUNIQuery;
begin
  Q := ZLEDM.ZlePokazIObsluzZlecenia(sZLEALIAS_Zlecenie_ID +';'+
                                     sZLEALIAS_Zlecenie_Symbol + ';' +
                                     sZLEALIAS_Zlecenie_Nazwa,
                                     '',
                                     true,
                                     true,
                                     0,
                                     0{StrToIntDef( RangeParam(sParam_ZLEZlecenieID).Value, 0)},
                                     0,
                                     nil{oSelectedId} );

  if Q <> nil then
    try
      ZlecenieLookupAliasEditSetData(Q);
    finally
      Q.free;
    end;
end;

procedure TZLEZasobyPrzeliczSelectForm.ZlecenieLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  sZLEZlecenieID := '';
  ZlecenieLookupAliasEdit.Text := '';
end;

function TZLEZasobyPrzeliczSelectForm.ZlecenieLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  result:= true;
  if AliasSrc <> nil then begin
    sZLEZlecenieID := '';
    if AliasSrc.RecordCount > 1 then begin
       ZlecenieLookupAliasEdit.Text := 'Wybranych pozycji: ' + IntToStr(AliasSrc.RecordCount);
       while not AliasSrc.Eof do begin
          if sZLEZlecenieID <> '' then sZLEZlecenieID := sZLEZlecenieID + ',';
          sZLEZlecenieID := sZLEZlecenieID + AliasSrc.FieldByName(sZLEZlecenie_ID).AsString;
          AliasSrc.Next;
       end;
    end else begin
       ZlecenieLookupAliasEdit.Text := AliasSrc.FieldByName(sZLEZLECENIE_SYMBOL).AsString;
       sZLEZlecenieID := AliasSrc.FieldByName(sZLEZlecenie_ID).AsString;
    end;
  end;
end;

procedure TZLEZasobyPrzeliczSelectForm.DataOdDateEditDateChange(
  Sender: TObject);
begin
  inherited;
  if Trunc(DataOdDateEdit.Date) <> 0 then begin
    iDataOd := Trunc(DataOdDateEdit.Date);

    if not bUstawOkres then begin
      if ((Trunc(DataDoDateEdit.Date) <> 0) and
          (DataDoDateEdit.Date < DataOdDateEdit.Date))
          or (Trunc(DataDoDateEdit.Date) = 0) then
         DataDoDateEdit.Date := DataOdDateEdit.Date;
    end;
  end else
    iDataOd := 0;
end;

procedure TZLEZasobyPrzeliczSelectForm.DataDoDateEditDateChange(
  Sender: TObject);
begin
  inherited;
  if Trunc(DataDoDateEdit.Date) <> 0 then
    iDataDo := Trunc(DataDoDateEdit.Date)
  else
    iDataDo := 0;
end;

procedure TZLEZasobyPrzeliczSelectForm.JednostkaOrgLookupAliasEditButtonClick(
  Sender: TObject);
var
  Q: TUNIQuery;
begin
  Q := UniSysDM.UNIPokazIObsluzDane(
    sUNIJEDNOSTKAORG,
    '',
    False,
    False,
    sUNISysAlias_JednostkaOrg_ID + ';' + sUNISysAlias_JednostkaOrg_Symbol + ';' +sUNISysAlias_JednostkaOrg_Nazwa,
    0,
    sUNIJEDNOSTKAORG_ID + '=' + IntToStr(iJednostkaID)
  );
  if Q <> nil then
    try
      JednostkaOrgLookupAliasEditSetData(Q);
    finally
      Q.free;
    end;
end;

procedure TZLEZasobyPrzeliczSelectForm.JednostkaOrgLookupAliasEditDelKey(
  Sender: TObject);
begin
  iJednostkaID := -1;
  JednostkaOrgLookupAliasEdit.Text := '';
end;

function TZLEZasobyPrzeliczSelectForm.JednostkaOrgLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  result:= true;
  if AliasSrc <> nil then begin
     iJednostkaID := AliasSrc.FieldByName(sUNIJEDNOSTKAORG_ID).AsInteger;
     JednostkaOrgLookupAliasEdit.Text := AliasSrc.FieldByName(sUNIJEDNOSTKAORG_SYMBOL).AsString;
  end;
end;

initialization
  FormManager.RegisterForm(TZLEZasobyPrzeliczSelectForm, sZLEModulID);
end.
