unit ZLEZlecenieMaterialDBDetailFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2007-09-12 Adam     Utworzone
2012-03-23 Adam     Moliwo dopisywania materiaw do zlece nieprodukcyjnych
---------------------------------------------------------------------------------------------}
interface

uses
  UNIStaleUnit, UNIDataModuleUnit, UNIDBGridFormUnit, UNIFormUnit, KeyManagerUnit,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBDetailFormUnit, Menus, UNIComponentsUnit, Db, ToolWin, ComCtrls,
  StdCtrls, ExtCtrls, DBCtrls, Mask;

type
  TZLEZlecenieMaterialDBDetailForm = class(TUNIDBDetailForm)
    UNILabel1: TUNILabel;
    LMaterialLabel: TUNILabel;
    UNILabel3: TUNILabel;
    LJednostkaLabel: TUNILabel;
    MaterialLookupAliasEdit: TUNILookupAliasEdit;
    IloscDBEdit: TUNIDBEdit;
    UNILabel4: TUNILabel;
    LKontoMaterialoweLabel: TUNILabel;
    UNILabel6: TUNILabel;
    KontoMaterialoweLookupAliasEdit: TUNILookupAliasEdit;
    LOperacjaLabel: TUNILabel;
    OperacjaEdit: TUNIEdit;
    procedure MaterialLookupAliasEditButtonClick(Sender: TObject);
    procedure MaterialLookupAliasEditDelKey(Sender: TObject);
    function MaterialLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure KontoMaterialoweLookupAliasEditButtonClick(Sender: TObject);
    procedure KontoMaterialoweLookupAliasEditDelKey(Sender: TObject);
    function KontoMaterialoweLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
  public
    procedure SelectButtonPressed();  override;
      {
        Wywietla dane asortymentu i tabel powizanych pobierajc dane z przekazanego datasetu
      }
    procedure ShowAsort(
                    const ac_oDataSet:  TDataSet
              );
    procedure ShowKontoMaterialowe(
                    const ac_oQuery:    TDataSet
              );

  protected
    function  CreateDataModule(
                    const AOpenMode:  TOpenMode
              ): TUNIDataModule; override;
    procedure BeforeShow(); override;

  private
    m_sAsortIndeks,
    m_sAsortPKWIU,
    m_sGrasSymbol,
    m_sGrasNazwa,
    m_sJMSymbol
                  : string;
    m_iKontoMatId:    integer;  // id konta materiaowego ASOKMAT_ID (nie ASOASORTKMAT_ID)

    procedure SetControlProperties();
    procedure LoadLookups();

  end;

implementation
uses
  Dodatki,
  FormManagerUnit,
  SQLManagerUnit,
  UNIDataManagerUnit,
  ZLEZlecenieMaterialUnit,
  ASODataManagerExtUnit,
  LWPDefUnit,
  UNISysDefUnit,
  ASODefUnit,
  ZLEDefUnit
  ;

{$R *.DFM}

procedure TZLEZlecenieMaterialDBDetailForm.SelectButtonPressed();
begin
  inherited;
  if((OpenMode in [omNew, omEdit]) and (ModalResult = mrOk)) then begin
    with((Owner as TUNIDBGridForm).DataModule.ActiveQuery as TVirtualDataSet) do begin
      VState  := vsInternalInsert;
      try
        Edit();
        if(FindField(sASOASORT_SYMBOL) <> nil) then
          FieldByName(sASOASORT_SYMBOL).AsString:= MaterialLookupAliasEdit.Text;
        if(FindField(sASOASORT_NAZWA) <> nil) then
          FieldByName(sASOASORT_NAZWA).AsString := LMaterialLabel.Caption;
        if(FindField(sASOASORT_INDEKS) <> nil) then
          FieldByName(sASOASORT_INDEKS).AsString:= m_sAsortIndeks;
        if(FindField(sASOASORT_PKWIU) <> nil) then
          FieldByName(sASOASORT_PKWIU).AsString := m_sAsortPKWIU;
        if(FindField(sASOGRAS_SYMBOL) <> nil) then
          FieldByName(sASOGRAS_SYMBOL).AsString := m_sGrasSymbol;
        if(FindField(sASOGRAS_NAZWA) <> nil) then
          FieldByName(sASOGRAS_NAZWA).AsString  := m_sGrasNazwa;
        if(FindField(sUNIJM_SYMBOL) <> nil) then
          FieldByName(sUNIJM_SYMBOL).AsString   := m_sJMSymbol;
        if(FindField(sASOKMAT_SYMBOL) <> nil) then
          FieldByName(sASOKMAT_SYMBOL).AsString:= KontoMaterialoweLookupAliasEdit.Text;
        if(FindField(sASOKMAT_NAZWA) <> nil) then
          FieldByName(sASOKMAT_NAZWA).AsString:= LKontoMaterialoweLabel.Caption;
        Post();
      finally
        VState := vsNormal;
      end;
    end;  // with(DataModule.ActiveQuery as TVirtualDataSet)
  end;  // if((OpenMode in [omNew, omEdit]) and (ModalResult = mrOk))
end;

procedure TZLEZlecenieMaterialDBDetailForm.ShowAsort(
  const ac_oDataSet:  TDataSet
);
begin
  MaterialLookupAliasEdit.Text:= ac_oDataSet.FieldByName(sASOASORT_SYMBOL).AsString;
  LMaterialLabel.Caption      := ac_oDataSet.FieldByName(sASOASORT_NAZWA).AsString;
  m_sAsortIndeks              := ac_oDataSet.FieldByName(sASOASORT_INDEKS).AsString;
  m_sAsortPKWIU               := ac_oDataSet.FieldByName(sASOASORT_PKWIU).AsString;
  m_sGrasSymbol               := ac_oDataSet.FieldByName(sASOGRAS_SYMBOL).AsString;
  m_sGrasNazwa                := ac_oDataSet.FieldByName(sASOGRAS_NAZWA).AsString;
  m_sJMSymbol                 := ac_oDataSet.FieldByName(sUNIJM_SYMBOL).AsString;
  LJednostkaLabel.Caption     := m_sJMSymbol;
  KontoMaterialoweLookupAliasEdit.Enabled := true;
  KontoMaterialoweLookupAliasEdit.AdditionalCondition :=
    '@' + sASOAlias_Asort_ID  + ' = ' + ac_oDataSet.FieldByName(sASOASORT_ID).AsString + ' and ' +
    '@' + sASOAlias_AsortKMat_ID + ' is not null';
end;

procedure TZLEZlecenieMaterialDBDetailForm.ShowKontoMaterialowe(
  const ac_oQuery:    TDataSet
);
begin
  KontoMaterialoweLookupAliasEdit.Text:= ac_oQuery.FieldByName(sASOKMAT_SYMBOL).AsString;
  LKontoMaterialoweLabel.Caption      := ac_oQuery.FieldByName(sASOKMAT_NAZWA).AsString;
  m_iKontoMatId                       := ac_oQuery.FieldByName(sASOKMAT_ID).AsInteger;
end;

function  TZLEZlecenieMaterialDBDetailForm.CreateDataModule(
  const AOpenMode:  TOpenMode
): TUNIDataModule;
begin
  result  := TZLEZlecenieMaterialDataModule.CreateOpen(
      self,
      DefaultMasterKeyValues,
      AOpenMode
  );
end;

procedure TZLEZlecenieMaterialDBDetailForm.BeforeShow();
begin
  inherited;
  SetControlProperties();
  LoadLookups();
end;

procedure TZLEZlecenieMaterialDBDetailForm.SetControlProperties();
begin
  LMaterialLabel.Caption  := '';
  LJednostkaLabel.Caption := '';
  LKontoMaterialoweLabel.Caption  := '';
  IloscDBEdit.DataField   := sZLEZLECENIEMAT_ILOSC;
  if(OpenMode = omNew) then
    DMAQFbN(sZLEZLECENIEMAT_ILOSC).AsInteger  := 1;
  with MaterialLookupAliasEdit do begin
    aFieldName    := sASOASORT_ID;
    aAllowEmpty   := false;
    AliasManager  := ASODM.AliasManager;
    Alias_ID      := sASOAlias_Asort_ID;
    Alias_Name    := sASOAlias_Asort_Symbol;
    AdditionalAliases :=
      sASOAlias_Asort_Nazwa + ';' + sASOAlias_Asort_Indeks  + ';' +
      sASOAlias_Asort_PKWIU + ';' + sASOAlias_Gras_Symbol   + ';' +
      sASOAlias_Gras_Nazwa  + ';' + sASOAlias_Asort_JmSymbol1;
  end;  // with MaterialLookupAliasEdit
  with KontoMaterialoweLookupAliasEdit do begin
    aAllowEmpty   := true;
    Enabled       := false;
    AliasManager  := ASODM.AliasManager;
    Alias_ID      := sASOAlias_KMat_ID;
    Alias_Name    := sASOAlias_KMat_Symbol;
    AdditionalAliases :=
      sASOAlias_KMat_Nazwa + ';' + sASOAlias_AsortKMat_ID + ';' +
      sASOAlias_Asort_ID;
  end;
  if(DataManagers.Available(sLWPModulID)) then begin
    LOperacjaLabel.Visible:= ((not DMAQFbN(sLWPRECEPPOZOPER_NAZWA).IsNull) or (not DMAQFbN(sLWPRECEPPOZOPERZAM_NAZWA).IsNull));
    if(LOperacjaLabel.Visible) then begin
      if(DMAQFbN(sLWPRECEPPOZOPERZAM_ID).IsNull) then
        OperacjaEdit.Text := DMAQFbN(sLWPRECEPPOZOPER_NAZWA).AsString
      else
        OperacjaEdit.Text := DMAQFbN(sLWPRECEPPOZOPERZAM_NAZWA).AsString;
    end;
  end else begin
    LOperacjaLabel.Visible  := false;
  end;
  OperacjaEdit.Visible  := LOperacjaLabel.Visible;
end;

procedure TZLEZlecenieMaterialDBDetailForm.LoadLookups();
begin
  if(not DMAQFbN(sASOASORT_ID).IsNull) then begin
    ShowAsort((Owner as TUNIDBGridForm).DataModule.ActiveQuery);
  end;  // if(not DMAQFbN(sASOASORT_ID).IsNull)
  if(not DMAQFbN(sASOASORTKMAT_ID).IsNull) then begin
    ShowKontoMaterialowe((Owner as TUNIDBGridForm).DataModule.ActiveQuery);
  end;  // if(not DMAQFbN(sASOASORTKMAT_ID).IsNull)
end;

procedure TZLEZlecenieMaterialDBDetailForm.MaterialLookupAliasEditButtonClick(
  Sender: TObject);
var
  oQuery:   TUNIQuery;
  sAliasy,
  sWarunek: string;
  iModulId: integer;
begin
  if(DataManagers.Available(sLWPModulID)) then
    iModulId  := cLWPMODULZSI_ID
  else
    iModulId  := cZLEModulZSI_ID;
  UNIDajAliasyZLookupa(MaterialLookupAliasEdit, sAliasy, sWarunek);
  oQuery  := ASODM.PokazIObsluzAsortyment(
    sAliasy, sWarunek,
    false, false, DMAQFbN(sASOASORT_ID).AsString, iModulId
  );
  if(oQuery <> nil) then begin
    MaterialLookupAliasEditSetData(oQuery);
    oQuery.Free();
  end;
end;

procedure TZLEZlecenieMaterialDBDetailForm.MaterialLookupAliasEditDelKey(
  Sender: TObject);
begin
  DMAQFbN(sASOASORT_ID).Clear();
  MaterialLookupAliasEdit.Clear();
  LMaterialLabel.Caption  := '';
  m_sAsortIndeks          := '';
  m_sAsortPKWIU           := '';
  m_sGrasSymbol           := '';
  m_sGrasNazwa            := '';
  m_sJMSymbol             := '';
  LJednostkaLabel.Caption := '';
  KontoMaterialoweLookupAliasEditDelKey(nil);
  KontoMaterialoweLookupAliasEdit.Enabled := false;
end;

function TZLEZlecenieMaterialDBDetailForm.MaterialLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  DMAQFbN(sASOASORT_ID).AsInteger := AliasSrc.Fields[0].AsInteger;
  ShowAsort(AliasSrc);
  result  := true;
end;

procedure TZLEZlecenieMaterialDBDetailForm.KontoMaterialoweLookupAliasEditButtonClick(
  Sender: TObject);
var
  oQuery:   TUNIQuery;
  sAliasy:  string;
  sWarunek: string;
begin
  UNIDajAliasyZLookupa(KontoMaterialoweLookupAliasEdit, sAliasy, sWarunek);
  oQuery  := ASODM.PokazIObsluzDaneSlownikowe(sASOKMAT,
    sASOAlias_KMat_ID, sWarunek, false, false,
    IntToStr_ZeroToEmpty(m_iKontoMatId)
  );
  if(oQuery <> nil) then begin
    sWarunek  :=
      '@' + sASOAlias_KMat_ID + ' = ' + oQuery.Fields[0].AsString + ' and ' +
      '@' + sASOAlias_Asort_ID+ ' = ' + DMAQFbN(sASOASORT_ID).AsString;
    oQuery.Free();
    oQuery  := ASODM.OdpytajODane(sASOKMAT, sAliasy, sWarunek, false);
    if(oQuery <> nil) then
      KontoMaterialoweLookupAliasEditSetData(oQuery);
    oQuery.Free();
  end;
end;

procedure TZLEZlecenieMaterialDBDetailForm.KontoMaterialoweLookupAliasEditDelKey(
  Sender: TObject);
begin
  DMAQFbN(sASOASORTKMAT_ID).Clear();
  m_iKontoMatId := 0;
  KontoMaterialoweLookupAliasEdit.Clear();
  LKontoMaterialoweLabel.Caption  := '';
end;

function TZLEZlecenieMaterialDBDetailForm.KontoMaterialoweLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if(DMAQFbN(sASOASORTKMAT_ID).AsInteger <> AliasSrc.Fields[3].AsInteger) then begin
    DMAQFbN(sASOASORTKMAT_ID).AsInteger := AliasSrc.Fields[3].AsInteger;
    ShowKontoMaterialowe(AliasSrc);
  end;  // if zmienione konto materiaowe
  result  := true;
end;

initialization
  FormManager.RegisterForm(TZLEZlecenieMaterialDBDetailForm, sZLEModulID);
end.
