unit ZLEZlecenieRozlDBDetailFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2005-02-27 gdeyk    Utworzone
2010-11-04 Tomjen   Dooenie obsugi skadnika czasu pracy na formatce
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBDetailFormUnit, Menus, UNIComponentsUnit, Db, ToolWin, ComCtrls,
  StdCtrls, ExtCtrls, UNIStaleUnit, UNIDataModuleUnit, Mask, DBCtrls,
  UNIDBConstComboBoxUnit, UNIDBDateEditUnit, UNIDateEditUnit, UNIGodzEdit;

type
  TZLEZlecenieRozlDBDetailForm = class(TUNIDBDetailForm)
    RozliczeniePanel: TUNIPanel;
    DataRozliczeniaDBDateEdit: TUNIDBDateEdit;
    DataRozliczeniaLabel: TUNILabel;
    GodzinyLabel: TUNILabel;
    EwidencjaZuzPaliwaDBEdit: TUNIDBEdit;
    EwidencjaZuzPaliwaLabel: TUNILabel;
    StawkaDBEdit: TUNIDBEdit;
    StawkaLabel: TUNILabel;
    ZasobPanel: TUNIPanel;
    ZasobLabel: TUNILabel;
    ZasobNazwaLabel: TUNILabel;
    ZasobLookupAliasEdit: TUNILookupAliasEdit;
    AsortymentPanel: TUNIPanel;
    AsortymentLabel: TUNILabel;
    AsortymentNazwaLabel: TUNILabel;
    AsortymentLookupAliasEdit: TUNILookupAliasEdit;
    PozycjaZleceniaPanel: TUNIPanel;
    OpisLabel: TUNILabel;
    OpisMemo: TUNIMemo;
    PozycjaPanel: TUNIPanel;
    PozycjaZleceniaLabel: TUNILabel;
    PozycjaLookupAliasEdit: TUNILookupAliasEdit;
    IloscGodzEdit: TUNIGodzEdit;
    IloscDBEdit: TUNIDBEdit;
    SkladnikCzasuPanel: TUNIPanel;
    SkladnikCzasuLabel: TUNILabel;
    SkladnikOpisLabel: TUNILabel;
    SkladnikCzasuPracyDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    function ZasobLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    procedure ZasobLookupAliasEditButtonClick(Sender: TObject);
    procedure AsortymentLookupAliasEditButtonClick(Sender: TObject);
    function AsortymentLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure PozycjaLookupAliasEditButtonClick(Sender: TObject);
    function PozycjaLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure DataRozliczeniaDBDateEditDateChange(Sender: TObject);
    function SkladnikCzasuPracyDBLookupAliasEditGetDataField: String;
    function SkladnikCzasuPracyDBLookupAliasEditGetQuery: TUNIQuery;
    procedure SkladnikCzasuPracyDBLookupAliasEditInitAliasInfo(
      Sender: TObject);
    procedure SkladnikCzasuPracyDBLookupAliasEditDelKey(Sender: TObject);
    function SkladnikCzasuPracyDBLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    procedure IloscDBEditExit(Sender: TObject);
    procedure IloscGodzEditExit(Sender: TObject);

  private
    procedure InitializeControls();
    procedure SetDefaults();
  protected
    procedure BeforeShow; override;
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure InternalOpen; override;
  public
    procedure UstawOkres(dData: TDate);  
    function Validate(): Boolean; override;
  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  FormManagerUnit,
  KeyManagerUnit,
  UNIDataManagerUnit,
  UNISysDataManagerUnit,
  UNISysDefUnit,
  ASODefUnit,
  ASODataManagerExtUnit,
  ZLEDefUnit,
  KDDefUnit,
  KDPRADefUnit,
  SystemDefUnit,
  KDDataManagerExtUnit,
  ZLEDataManagerUnit,
  ZLEZlecenieRozlDBGridFormUnit,
  ZLEZlecenieRozlUnit;

  {UNISysDefUnit,
  SystemDefUnit,
  KDECPDataManagerExtUnit,
  LWPDataManagerExtUnit,
  SPDefUnit,
  FKDefUnit,
  LWPDefUnit,
  UniqueKeyUnit,
  SPDataManagerExtUnit;}

{ TZLEZlecenieRozlDBDetailForm }

function TZLEZlecenieRozlDBDetailForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLEZlecenieRozlDataModule.CreateOpen( Self, InheritedMasterKeyValues, AOpenMode );
end;

procedure TZLEZlecenieRozlDBDetailForm.IloscDBEditExit(Sender: TObject);
begin
  inherited;
  if (OpenMode in [omNew, omEdit]) {and (not ZLEDM.vZLEWysylanieRozliczECPWlaczone)} then begin
     if DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY_NOM).AsFloat  <> DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat then begin
        DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY_NOM).AsFloat := DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat;
     end;
  end;
end;

procedure TZLEZlecenieRozlDBDetailForm.IloscGodzEditExit(Sender: TObject);
begin
  inherited;
  if (OpenMode in [omNew, omEdit]) {and (not ZLEDM.vZLEWysylanieRozliczECPWlaczone)} then begin
     if DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY_NOM).AsFloat  <> DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat then
        DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY_NOM).AsFloat := DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat;
  end;
end;

procedure TZLEZlecenieRozlDBDetailForm.InitializeControls;
begin
  if Parameters.Values[cFORM_CAPTION] <> '' then
    Caption := Parameters.Values[cFORM_CAPTION];

  DataRozliczeniaDBDateEdit.DataField := sZLEZASOBYPRACA_DATA;
  StawkaDBEdit.DataField := sZLEZASOBYPRACA_STAWKA;
  IloscGodzEdit.DataField := sZLEZASOBYPRACA_CZAS_PRACY;
  IloscDBEdit.DataField := sZLEZASOBYPRACA_CZAS_PRACY;

  if ZLEDM.vZLEFormatGodzinLiczba then begin
     IloscGodzEdit.Visible := False;
     IloscDBEdit.Visible := True;
  end else begin
     IloscGodzEdit.Visible := True;
     IloscDBEdit.Visible := False;
  end;

  if ZLEDM.vZLEZLECENIEROZL_ZUZPALIWA then begin
     EwidencjaZuzPaliwaDBEdit.DataField := sZLEZASOBYPRACA_ZUZ_PALIWA;
     EwidencjaZuzPaliwaDBEdit.Visible := True;
     EwidencjaZuzPaliwaLabel.Visible  := True;
  end else begin
     EwidencjaZuzPaliwaDBEdit.Visible := False;
     EwidencjaZuzPaliwaLabel.Visible  := False;
  end;

  AsortymentNazwaLabel.Caption := '';
  with AsortymentLookupAliasEdit do begin
    AliasManager := ASODM.AliasManager;
    Alias_ID := sASOAlias_Asort_ID;
    Alias_Name := sASOAlias_Asort_Indeks;
    AdditionalAliases := sASOAlias_Asort_Nazwa;
    EditMask := ASODM.vAsoMaskaIndeksu+';0;_';
    InitiateData(StrToIntDef(Parameters.Values[sASOASORT_ID],0));

   { if OpenMode <> omNew then}
    aReadOnly := True;
  end;

  ZasobNazwaLabel.Caption := '';
  with ZasobLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_ID := sZLEALIAS_ZLEZASOB_ID;
    Alias_Name := sZLEALIAS_ZLEZASOB_SYMBOL;


    AdditionalAliases := sZLEALIAS_ZLEZASOB_NAZWA+';'+
                         sZLEALIAS_ZLEZASOB_KDOSOBA_ID+';'+
                         sZLEALIAS_ZLEZASOB_STAWKA+';'+
                         sZLEALIAS_ZLEZASOB_RODZAJ+';'+
                         sZLEALIAS_RODZAJZASOBU_V;

    if OpenMode <> omNew then
       aReadOnly := True;
  end;

  with PozycjaLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_ID := sZLEALIAS_ZLECENIEPOZ_ID;
    Alias_Name := sZLEALIAS_ZLECENIEPOZ_LP;

    AdditionalAliases := sZLEALIAS_ZLECENIEPOZ_ASORT_ID+';'+
                         sZLEALIAS_ZLECENIEPOZ_OPIS+';'+
                         sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID;

    if OpenMode <> omNew then
       aReadOnly := True;
  end;

  with OpisMemo do begin
    Text := Parameters.Values[sZLEZLECENIEPOZ_OPIS];
    ReadOnly := True;
  end;

 { if OpenMode = omNew then begin
     PozycjaPanel.Visible := True;
     ZasobPanel.Visible := True;
  end else begin
     PozycjaPanel.Visible := False;
     ZasobPanel.Visible := False;
  end; }

  if ZLEDM.vZLEWysylanieRozliczECPWlaczone then begin
     SkladnikCzasuPanel.Visible := True;
     SkladnikCzasuPracyDBLookupAliasEdit.aAllowEmpty := False;
  end else begin
     SkladnikCzasuPanel.Visible := False;
     SkladnikCzasuPracyDBLookupAliasEdit.aAllowEmpty := True;
  end;

end;

procedure TZLEZlecenieRozlDBDetailForm.BeforeShow;
begin
  inherited;
  if ((OpenMode = omEdit) or (OpenMode = omNew)) and ZLEDM.vZLEZLECENIEROZL_ZUZPALIWA then begin
    if OpenMode = omEdit then begin
      if (not (Owner as TZLEZlecenieRozlDBGridForm).DataModule.DataSource.DataSet.FieldByName(sZLEZasob_Rodzaj).isNull) then begin
         if (Owner as TZLEZlecenieRozlDBGridForm).DataModule.DataSource.DataSet.FieldByName(sZLEZasob_Rodzaj).AsString = cZLERodzajZasobu_MaszynaID then begin
              EwidencjaZuzPaliwaDBEdit.Visible := True;
              EwidencjaZuzPaliwaLabel.Visible := True;
         end else begin
              EwidencjaZuzPaliwaDBEdit.Visible := False;
              EwidencjaZuzPaliwaLabel.Visible := False;
         end;
      end;
    end else begin
       EwidencjaZuzPaliwaDBEdit.Visible := True;
       EwidencjaZuzPaliwaLabel.Visible := True;
    end;
  end else begin
    if not ZLEDM.vZLEZLECENIEROZL_ZUZPALIWA then begin
       EwidencjaZuzPaliwaDBEdit.Visible := False;
       EwidencjaZuzPaliwaLabel.Visible  := False;
    end;
  end;
end;

procedure TZLEZlecenieRozlDBDetailForm.InternalOpen;
begin
  if Parameters = nil then
    Parameters := TKeyValues.CreateEmpty();
  InitializeControls();
  inherited;
  if OpenMode = omNew then
    SetDefaults()
  else if OpenMode = omEdit then begin
      if ZLEDM.vZLEWysylanieRozliczECPWlaczone and
         (ZLEDM.vZLESkladnikECPDomyslnyID > 0) and
         (DMAQFbN(sKDSKLADNIKCZASU_ID).AsInteger <= 0)
      then begin
        try
          (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := True;
          DMAQFbN(sKDSKLADNIKCZASU_ID).AsInteger := ZLEDM.vZLESkladnikECPDomyslnyID;
          SkladnikCzasuPracyDBLookupAliasEdit.InitiateData(DMAQFbN(sKDSKLADNIKCZASU_ID).AsInteger);
        finally
          (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := False;
        end;
      end;
  end;

  if (OpenMode in [omEdit, omNew] )and (DMAQFbN(sZLEZASOBYPRACA_DATA).IsNull) then begin
    DMAQFbN(sZLEZASOBYPRACA_DATA).AsDateTime := UNIDate();
    UstawOkres(DMAQFbN(sZLEZASOBYPRACA_DATA).AsDateTime);
  end;
  with (DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY) as TNumericField) do begin
    DisplayFormat := cMaskaKwoty;
    EditFormat := cMaskaKwotyEdycja;
  end;

  if ZLEDM.vZLEZLECENIEROZL_ZUZPALIWA then begin
     with (DMAQFbN(sZLEZASOBYPRACA_ZUZ_PALIWA) as TNumericField) do begin
        DisplayFormat := cMaskaKwoty;
        EditFormat := cMaskaKwotyEdycja;
     end;
  end;

  with (DMAQFbN(sZLEZASOBYPRACA_STAWKA) as TNumericField) do begin
    DisplayFormat := cMaskaKwoty;
    EditFormat    := cMaskaKwotyEdycja;
  end;

//  if OpenMode in [omNew, omDelete] then begin
     if not DMAQFbN(sZLEZLECENIEPOZ_ID).IsNull then
        PozycjaLookupAliasEdit.InitiateData(DMAQFbN(sZLEZLECENIEPOZ_ID).AsInteger);

     if not DMAQFbN(sZLEZASOB_ID).IsNull then
        ZasobLookupAliasEdit.InitiateData(DMAQFbN(sZLEZASOB_ID).AsInteger);

//  end;

  if not ZLEDM.vZLEFormatGodzinLiczba then begin
     IloscGodzEdit.Inicjuj; //W innym przypadku aktywny jest zwyky IloscDBEdit
  end;

  if OpenMode = omEdit then begin
     if ZLEDM.vZLEFormatGodzinLiczba then
           ActiveControl := IloscDBEdit
     else  ActiveControl := IloscGodzEdit;
  end else if OpenMode = omNew then
              ActiveControl := ZasobLookupAliasEdit;

end;

procedure TZLEZlecenieRozlDBDetailForm.SetDefaults;
begin
  try
    (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := True;
    //tu ustawienia defaultowe;
    DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat := 0;
    DMAQFbN(sZLEZASOBYPRACA_STAWKA).AsFloat := 0.00;
    if ZLEDM.vZLEZLECENIEROZL_ZUZPALIWA then
       DMAQFbN(sZLEZASOBYPRACA_ZUZ_PALIWA).AsFloat := 0.00;

    DMAQFbN(sZLECONST_RODZAJECP_ID).AsString := cZLERodzajECP_RozliczID;
    if Parameters.Values[sZLEZLECENIE_ID] <> '' then
       DMAQFbN(sZLEZLECENIE_ID).AsInteger := StrToInt(Parameters.Values[sZLEZLECENIE_ID]);

    if ZLEDM.vZLEWysylanieRozliczECPWlaczone and (ZLEDM.vZLESkladnikECPDomyslnyID > 0) then begin
       DMAQFbN(sKDSKLADNIKCZASU_ID).AsInteger := ZLEDM.vZLESkladnikECPDomyslnyID;
       SkladnikCzasuPracyDBLookupAliasEdit.InitiateData(DMAQFbN(sKDSKLADNIKCZASU_ID).AsInteger);
    end;
  finally
    (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := False;
  end;
end;

function TZLEZlecenieRozlDBDetailForm.Validate: Boolean;
begin
  result := inherited Validate();

  if DMAQFbN(sZLEZASOB_ID).IsNull then begin
     Komunikat(cWarning, 'Naley wybra zasb!');
     ZasobLookupAliasEdit.SetFocus;
     Abort;
     result := False;
     Exit;
  end;

  if DMAQFbN(sZLEZLECENIEPOZ_ID).IsNull then begin
     Komunikat(cWarning, 'Naley wybra pozycj zlecenia!');
     PozycjaLookupAliasEdit.SetFocus;
     Abort;
     result := False;
     Exit;
  end;

end;

procedure TZLEZlecenieRozlDBDetailForm.ZasobLookupAliasEditButtonClick(
  Sender: TObject);
var
  oQuery: TUniQuery;
begin
  oQuery := ZLEDM.ZLEPokazIObsluzDane( sZLEZASOB,
                                       sZLEALIAS_ZLEZASOB_ID+';'+
                                       sZLEALIAS_ZLEZASOB_SYMBOL+';'+
                                       sZLEALIAS_ZLEZASOB_NAZWA+';'+
                                       sZLEALIAS_ZLEZASOB_KDOSOBA_ID+';'+
                                       sZLEALIAS_ZLEZASOB_STAWKA+';'+
                                       sZLEALIAS_ZLEZASOB_RODZAJ+';'+
                                       sZLEALIAS_RODZAJZASOBU_V,
                                       '', False, True );
  if oQuery <> nil then
     ZasobLookupAliasEditSetData(oQuery);
end;

function TZLEZlecenieRozlDBDetailForm.ZasobLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
    if OpenMode in [omNew, omEdit] then begin
      DMAQFbN(sZLEZASOB_ID).AsInteger := AliasSrc.FieldByName(sZLEZASOB_ID).AsInteger;
      if (DMAQFbN(sKDOSOBA_ID).AsInteger <> AliasSrc.FieldByName(sKDOSOBA_ID).AsInteger) and
         (AliasSrc.FieldByName(sKDOSOBA_ID).AsInteger > 0) then begin
         DMAQFbN(sKDOSOBA_ID).AsInteger := AliasSrc.FieldByName(sKDOSOBA_ID).AsInteger;
         DMAQFbN(sZLEZASOBYPRACA_STAWKA).AsFloat := AliasSrc.FieldByName(sZLEZASOB_STAWKA).AsFloat;
      end;
    end;

    ZasobLookupAliasEdit.Text := AliasSrc.FieldByName(sZLEZASOB_SYMBOL).AsString;
    ZasobNazwaLabel.Caption := AliasSrc.FieldByName(sZLEZASOB_NAZWA).AsString;

    {Sprawdzenie Rodzaju Zasobu}
    if ZLEDM.vZLEZLECENIEROZL_ZUZPALIWA then begin
      if AliasSrc.FieldByName(sZLEZASOB_RODZAJ).AsString = cZLERodzajZasobu_MaszynaID then begin
         EwidencjaZuzPaliwaDBEdit.Visible := True;
         EwidencjaZuzPaliwaLabel.Visible := True;
         if OpenMode in [omNew, omEdit] then begin
            if (OpenMode = omNew) or (DMAQFbN(sZLEZASOBYPRACA_ZUZ_PALIWA).IsNull) then
               DMAQFbN(sZLEZASOBYPRACA_ZUZ_PALIWA).AsFloat := 0.00;
         end;
      end else begin
         if OpenMode in [omNew, omEdit] then
              DMAQFbN(sZLEZASOBYPRACA_ZUZ_PALIWA).Clear;
         EwidencjaZuzPaliwaDBEdit.Visible := False;
         EwidencjaZuzPaliwaLabel.Visible := False;
      end;
    end;
  end;
  result := True;
end;

procedure TZLEZlecenieRozlDBDetailForm.AsortymentLookupAliasEditButtonClick(
  Sender: TObject);
var
 sListaPol: String;
 oQuery: TUNIQuery;
begin
  sListaPol := sASOAlias_Asort_ID + ';' +
               sASOAlias_Asort_Indeks + ';' +
               sASOAlias_Asort_Nazwa;
  if Parameters.Values[sASOASORT_ID] <> '' then
     oQuery := ASODM.PokazIObsluzAsortyment( sListaPol, '', True, False, sASOASORT_ID+'='+Parameters.Values[sASOASORT_ID] )
  else oQuery := ASODM.PokazIObsluzAsortyment( sListaPol, '', True, False, '' );
  FreeAndNil(oQuery);
 { if OpenMode = omNew then
     if oQuery <> nil then
        AsortymentLookupAliasEditSetData(oQuery);}
end;

function TZLEZlecenieRozlDBDetailForm.AsortymentLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
    AsortymentNazwaLabel.Caption := AliasSrc.FieldByName(sASOASORT_NAZWA).AsString;
  end;
  result := True;
end;

procedure TZLEZlecenieRozlDBDetailForm.PozycjaLookupAliasEditButtonClick(
  Sender: TObject);
var
  oQuery: TUniQuery;
  sWarunek: String;
begin
  sWarunek := '';
  //if Parameters.Values[sZLEZLECENIE_ID] <> '' then
  if DMAQFbN(sZLEZLECENIE_ID).AsInteger > 0 then
     sWarunek := '@' + sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID + '=' + IntToStr(DMAQFbN(sZLEZLECENIE_ID).AsInteger);

  oQuery := ZLEDM.ZLEPokazIObsluzDane( sZLEZLECENIEPOZ,
                                       sZLEALIAS_ZLECENIEPOZ_ID+';'+
                                       sZLEALIAS_ZLECENIEPOZ_LP+';'+
                                       sZLEALIAS_ZLECENIEPOZ_ASORT_ID+';'+
                                       sZLEALIAS_ZLECENIEPOZ_OPIS+';'+
                                       sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID,
                                       sWarunek,
                                       True, True );
  if oQuery <> nil then
     PozycjaLookupAliasEditSetData(oQuery);
end;

function TZLEZlecenieRozlDBDetailForm.PozycjaLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
     if OpenMode in [omNew, omEdit] then
        DMAQFbN(sZLEZLECENIEPOZ_ID).AsInteger :=  AliasSrc.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger;

     Parameters.Values[sZLEZLECENIEPOZ_OPIS] :=  AliasSrc.FieldByName(sZLEZLECENIEPOZ_OPIS).AsString;
     OpisMemo.Text := AliasSrc.FieldByName(sZLEZLECENIEPOZ_OPIS).AsString;
     PozycjaLookupAliasEdit.Text := AliasSrc.FieldByName(sZLEZLECENIEPOZ_LP).AsString;
     Parameters.Values[sASOASORT_ID] := AliasSrc.FieldByName(sASOASORT_ID).AsString;
     AsortymentLookupAliasEdit.InitiateData(StrToIntDef(Parameters.Values[sASOASORT_ID],0));
  end;
  result  := true;
end;

procedure TZLEZlecenieRozlDBDetailForm.DataRozliczeniaDBDateEditDateChange(
  Sender: TObject);
begin
  UstawOkres(DataRozliczeniaDBDateEdit.Date);
end;

procedure TZLEZlecenieRozlDBDetailForm.UstawOkres(dData: TDate);
var
  iRokID: Integer;
  q: TUNIQuery;
begin
  if not (OpenMode in [omNew, omEdit]) then Exit;
  iRokID := -1;
  q := UniSysDataManager.UNIPodajRokObrachunkowy(dData, sUNISYSALIAS_Rok_ID);
  try
    if q = Nil then begin
      Komunikat(cInformation, Format('Data "%d" jest niezgodna ze zdefiniowanymi latami obrachunkowymi' ,[dData]));
    end else
      iRokID := q.Fields[0].AsInteger;
  finally
    FreeAndNil(q);
  end;
  q := UNISysDataManager.UNIPodajOkresObrachunkowy(
    iRokID,
    dData,
    sUNISYSALIAS_Okres_Obrachunkowy_ID + ';' + sUNISYSALIAS_Poczatek_Okresu_Obrachunkowego + ';' + sUNISYSALIAS_Koniec_Okresu_Obrachunkowego
  );
  try
    if q = Nil then begin
      Komunikat(cInformation, Format('Data "%d" jest niezgodna ze zdefiniowanymi okresami obrachunkowymi' ,[dData]));
    end else
      if OpenMode in [omNew, omEdit] then
        begin
          DMAQFbN(sUNIOKRES_ID).AsInteger := q.Fields[0].AsInteger;
        end;
  finally
    FreeAndNil(q);
  end;
end;

procedure TZLEZlecenieRozlDBDetailForm.SkladnikCzasuPracyDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  SkladnikOpisLabel.Caption := '';
end;

function TZLEZlecenieRozlDBDetailForm.SkladnikCzasuPracyDBLookupAliasEditGetDataField: String;
begin
  result := sKDSKLADNIKCZASU_ID;
end;

function TZLEZlecenieRozlDBDetailForm.SkladnikCzasuPracyDBLookupAliasEditGetQuery: TUNIQuery;
begin
  Result  := KDDM.KDPokazIObsluzDane(sKDSKLADNIKCZASU,
                                     sKDAlias_SKLADNIKCZASU_ID + ';' +
                                     sKDAlias_SKLADNIKCZASU_SYMBOL + ';' +
                                     sKDAlias_SKLADNIKCZASU_NAZWA,
                                     '',
                                     true,
                                     false,
                                     UNISYSDM.vAktywnaFirma);
end;

procedure TZLEZlecenieRozlDBDetailForm.SkladnikCzasuPracyDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  if DataManagers.Available(sKDPRAModulID) then begin
    with SkladnikCzasuPracyDBLookupAliasEdit do begin
      AliasManager := KDDM.AliasManager;
      Alias_ID := sKDAlias_SKLADNIKCZASU_ID;
      Alias_Name := sKDAlias_SKLADNIKCZASU_SYMBOL;
      AdditionalAliases := sKDAlias_SKLADNIKCZASU_NAZWA;
    end;
  end;
end;

function TZLEZlecenieRozlDBDetailForm.SkladnikCzasuPracyDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  inherited;
  if AliasSrc <> nil then begin
     SkladnikOpisLabel.Caption := AliasSrc.FieldByName(sKDSKLADNIKCZASU_NAZWA).AsString;
  end;
  result := True;
end;


initialization
  FormManager.RegisterForm( TZLEZlecenieRozlDBDetailForm, sZLEModulID );

end.
