unit ZLEZlecenieRozlDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2005-02-26 gdeyk    Utworzone
2011-10-10 Adam    Zastpienie FormManager.RefreshDBGrid funkcj KOMDM.KOMOdswiezGrid
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls, UNIStaleUnit, UNIDataModuleUnit;

type
  TZLEZlecenieRozlDBGridForm = class(TUNIDBGridForm)
    FuncButtonsPanel: TUNIPanel;
    DopiszButton: TUNIButton;
    RozliczButton: TUNIButton;
    ZmienButton: TUNIButton;
    ZakresButton: TUNIButton;
    DopiszMenuItem: TMenuItem;
    RozliczMenuItem: TMenuItem;
    ZmienMenuItem: TMenuItem;
    DopiszZasobButton: TUNIButton;
    UsunButton: TUNIButton;
    procedure DopiszButtonClick(Sender: TObject);
    procedure RozliczButtonClick(Sender: TObject);
    procedure ZmienButtonClick(Sender: TObject);
    procedure DBGridMark;
    procedure DBGridUnMark;
    procedure ZakresButtonClick(Sender: TObject);
    procedure DopiszZasobButtonClick(Sender: TObject);
    procedure UsunButtonClick(Sender: TObject);
    procedure DBGridDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
  private
    FAnaliza: Boolean;
    procedure InitializeControls();
    procedure InitializeObjectFields();
    procedure _AfterScroll(DataSet: TDataSet);
    procedure DopiszPozycje();
    procedure OpenDetail( bRozliczenie: Boolean; AMode: TOpenMode );
    procedure PrzelaczButtony();
//    function Zakres( bWymusPokazanie: Boolean = True ): Boolean;
  protected
    procedure New(); override;
//    procedure Open(); override;
//    procedure View(); override;
//    procedure Delete(); override;
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure SetUserRights; override;
  public
    procedure InternalOpen(); override;
    property Analiza: Boolean read FAnaliza;
    procedure ReOpenDataSets(); override;
  end;

implementation

{$R *.DFM}

uses
  variants,
  Dodatki,
  FormManagerUnit,
  KeyManagerUnit,
  UniqueKeyUnit,
  SecurityManagerUnit,
  UNIDBDetailFormUnit,
  UNIRangeFormUnit,
  UNISysDefUnit,
  SQLManagerUnit,
  UNIDataManagerUnit,
  ASODefUnit,
  ASODataManagerExtUnit,
  BOKDefUnit,
  ZLEDefUnit,
  SystemDefUnit,
  ZLEDataManagerUnit,
  ZLEZlecenieRozlUnit,
  ZLEZlecenieDBGridFormUnit,
  KOMDataManagerExtUnit;

{ TZLEZlecenieRozlDBGridForm }

function TZLEZlecenieRozlDBGridForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLEZlecenieRozlDataModule.CreateOpen( Self, InheritedMasterKeyValues, AOpenMode );
end;

procedure TZLEZlecenieRozlDBGridForm.InitializeControls;
begin
  SwitchEditorKeys(False);
  if Analiza then
    FuncButtonsPanel.Visible := False;
end;

procedure TZLEZlecenieRozlDBGridForm.InternalOpen;
var
  q : TUNIQuery;
  s : String;

begin
  if Parameters = nil then
    Parameters := TKeyValues.CreateEmpty();
  if Parameters.Values[cFORM_CAPTION] <> '' then
    Self.Caption := Parameters.Values[cFORM_CAPTION];

  InitializeObjectFields();
  InitializeControls();
  inherited;
  if not Analiza then begin
    DataModule.ActiveQuery.AfterScroll := _AfterScroll;
    _AfterScroll(DataModule.ActiveQuery);

    q := SQLManager.CreateQuery('SELECT Sum(zr.' +sZLEZASOBYPRACA_CZAS_PRACY +') as RAZEM ' +
                              'FROM %s zr, %s zp ' +
                              'WHERE zr.' + sZLEZLECENIEPOZ_ID + '=zp.' + sZLEZLECENIEPOZ_ID + ' AND ' +
                                    'zr.' + sZLECONST_RODZAJECP_ID + ' = ' + QuotedStr(cZLERodzajECP_RozliczID) + ' AND ' +
                                    'zp.' + sZLEZLECENIE_ID + '=' + IntToStr((Owner as TZLEZlecenieDBGridForm).DataModule.ActiveQuery.FieldByName(sZLEZLECENIE_ID).AsInteger),
                               [sZLEZASOBYPRACA, sZLEZLECENIEPOZ]);
    try
      q.Open;
      if not q.isEmpty then begin
         if ZLEDM.vZLEFormatGodzinLiczba then begin
            s := q.FieldByName('Razem').AsString;
            if s <> '' then s := Format('%.2f', [StrToFloat(s)]);
         end else s := FormatFloat('### ### ##0', q.FieldByName('Razem').AsInteger div 60) + ':' + FormatFloat('00', q.FieldByName('Razem').AsInteger mod 60);
         (Owner as TZLEZlecenieDBGridForm).PodsumowanieEdit.Text := s;
      end;
    finally
      FreeAndNil(q);
    end;
  end;
end;

procedure TZLEZlecenieRozlDBGridForm._AfterScroll(DataSet: TDataSet);
begin
  PrzelaczButtony();
end;

procedure TZLEZlecenieRozlDBGridForm.DopiszButtonClick(Sender: TObject);
begin
  DopiszPozycje();
  DBGrid.SetFocus;
end;

procedure TZLEZlecenieRozlDBGridForm.DopiszPozycje;
var
  oQuery: TUNIQuery;
  sFieldList: String;
begin
  oQuery := nil;
  try

    sFieldList := sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID+';'+
                  sZLEALIAS_ZLECENIEPOZ_ID+';'+
                  sZLEALIAS_ZLECENIEPOZ_LP+';'+
                  sZLEALIAS_ZLECENIEZASOB_ZASOB_ID+';'+
                  sZLEALIAS_ZLEZASOB_KDOSOBA_ID+';'+  //tu brak jeszcze symbolu i nazwy
                  sZLEALIAS_ZLEZASOB_STAWKA+';'+
                  sZLEALIAS_ZLEZASOB_NAZWA+';'+
                  sZLEALIAS_ZLEZASOB_UNIJEDNOSTKAORG_ID+';'+
                  sZLEALIAS_ZLEZASOB_SYMBOL+';'+
                  sZLEALIAS_ZLEZASOB_RODZAJ+';'+
                  sZLEALIAS_RODZAJZASOBU_V+';';


    if DataManagers.Available(sBOKModulID) then
       sFieldList := sFieldList + sZLEALIAS_BOKSPRAWA_NUMER+';';

    sFieldList := sFieldList + sZLEALIAS_ZLECENIEPOZ_ASORT_ID+';'+
                               sZLEALIAS_ASORT_INDEKS+';'+
                               sZLEALIAS_ASORT_NAZWA+';'+
                               sZLEALIAS_ZLECENIEPOZ_OPIS;

    oQuery := ZLEDM.ZLEOdpytajODane( sZLEZLECENIEPOZ,
                                     sFieldList,
                                     '(@'+sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID+'='+Parameters.Values[sZLEZLECENIE_ID]+')and'+
                                     '(@'+sZLEALIAS_ZLECENIEZASOB_ZLECENIE_ID+'='+Parameters.Values[sZLEZLECENIE_ID]+')',
                                     False, sZLEALIAS_ZLECENIEPOZ_ID );
    if oQuery <> nil then begin
      while not oQuery.Eof do begin
        with (DataModule.ActiveQuery as TVirtualDataSet) do begin
          if not Locate( sZLEZLECENIEPOZ_ID+';'+sZLEZASOB_ID,
                         VarArrayOf([ oQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger,
                                      oQuery.FieldByName(sZLEZASOB_ID).AsInteger]), [] ) then
            try
              VState := vsInternalInsert;
              Append;

              FieldByName(sZLEZASOBYPRACA_ID).AsInteger := UniqueKey[sZLEZASOBYPRACA];
              FieldByName(sZLEZLECENIE_ID).AsInteger := oQuery.FieldByName(sZLEZLECENIE_ID).AsInteger;
              FieldByName(sZLEZLECENIEPOZ_ID).AsInteger := oQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger;
              FieldByName(sUNIJEDNOSTKAORG_ID).Value := oQuery.FieldByName(sUNIJEDNOSTKAORG_ID).Value; //Tu moe byc NULL
              FieldByName(sZLEZASOB_ID).AsInteger := oQuery.FieldByName(sZLEZASOB_ID).AsInteger;
              FieldByName(sZLEZASOBYPRACA_STAWKA).AsFloat := oQuery.FieldByName(sZLEZASOB_STAWKA).AsFloat;
              FieldByName(sZLECONST_RODZAJECP_ID).AsString := cZLERodzajECP_RozliczID;
              if oQuery.FieldByName(sKDOSOBA_ID).AsInteger > 0 then
                 FieldByName(sKDOSOBA_ID).AsInteger := oQuery.FieldByName(sKDOSOBA_ID).AsInteger;
              SetTechnicalFieldsOnInsert();
              UpdateModifiedRecordFlagsForAddedRecord();
              if DataManagers.Available(sBOKModulID) then
                 FieldByName(sBOKSPRAWA_NUMER).AsString := oQuery.FieldByName(sBOKSPRAWA_NUMER).AsString;

              FieldByName(sZLEZASOB_NAZWA).AsString := oQuery.FieldByName(sZLEZASOB_NAZWA).AsString;
              FieldByName(sZLEZASOB_SYMBOL).AsString := oQuery.FieldByName(sZLEZASOB_SYMBOL).AsString;
              FieldByName(sZLEZASOB_RODZAJ).AsString := oQuery.FieldByName(sZLEZASOB_RODZAJ).AsString;
              FieldByName(sZLECONST_RODZAJZASOBU_V).AsString := oQuery.FieldByName(sZLECONST_RODZAJZASOBU_V).AsString;
              FieldByName(sASOASORT_ID).AsString := oQuery.FieldByName(sASOASORT_ID).AsString;
              FieldByName(sASOASORT_INDEKS).AsString := oQuery.FieldByName(sASOASORT_INDEKS).AsString;
              FieldByName(sASOASORT_NAZWA).AsString := oQuery.FieldByName(sASOASORT_NAZWA).AsString;
              FieldByName(sZLEZLECENIEPOZ_OPIS).AsString := oQuery.FieldByName(sZLEZLECENIEPOZ_OPIS).AsString;

              if FindField(sZLEZLECENIEPOZ_LP) <> nil then
                 FieldByName(sZLEZLECENIEPOZ_LP).AsString := oQuery.FieldByName(sZLEZLECENIEPOZ_LP).AsString;

              Post;
            finally
              VState := vsNormal;
            end;
        end;
        oQuery.Next;
      end;
    end;
  finally
    if oQuery <> nil then oQuery.Free;
  end;
  DataModule.Post();
end;

procedure TZLEZlecenieRozlDBGridForm.RozliczButtonClick(Sender: TObject);
begin
  OpenDetail( True, OmEdit );
  DBGrid.SetFocus;
end;

procedure TZLEZlecenieRozlDBGridForm.ZmienButtonClick(Sender: TObject);
begin
  OpenDetail( False, OmEdit );
  DBGrid.SetFocus;
end;

procedure TZLEZlecenieRozlDBGridForm.OpenDetail(bRozliczenie: Boolean; AMode: TOpenMode);
var
 oForm: TUNIDBDetailForm;
 oParams: TKeyValues;
 AOpenMode: TOpenMode;
begin
  oForm := nil;
  AOpenMode := AMode or omHidden;  //Byo OmEdit
  try
    oParams := TKeyValues.CreateEmpty();
    if AMode = omEdit then begin
       with oParams do begin
         Add( cFORM_CAPTION + '=' + 'Rozliczenie pozycji zlecenia' );
         Add( sASOASORT_ID + '=' + DMAQFbN(sASOASORT_ID).AsString );
         Add( sZLEZLECENIEPOZ_OPIS + '=' + DMAQFbN(sZLEZLECENIEPOZ_OPIS).AsString );
         Add( sZLECONST_RODZAJECP_ID + '=' + cZLERodzajECP_RozliczID);
       end;
    end else begin
       with oParams do begin
         Add( cFORM_CAPTION+'='+'Nowa pozycja rozliczenia' );
         Add( sZLECONST_RODZAJECP_ID+'='+cZLERodzajECP_RozliczID);
         //Add( sASOASORT_ID+'='+DMAQFbN(sASOASORT_ID).AsString );
         if Owner is TZLEZlecenieDBGridForm then
            Add( sZLEZLECENIE_ID + '=' + TZLEZLECENIEDBGridForm(Owner).DataModule.ActiveQuery.FieldByName(sZLEZLECENIE_ID).AsString);
       end;
    end;
    if bRozliczenie then
      oParams.Add(cZLERozliczenieZasobow+'='+sUNICONST_ALTERNATYWA_TAK)
    else
      oParams.Add(cZLERozliczenieZasobow+'='+sUNICONST_ALTERNATYWA_NIE);
    oForm := FormManager.OpenDBDetail( Self, 'TZLEZlecenieRozlDBDetailForm',
                                       AOpenMode, oParams );
    if oForm.ShowModal = mrOK then begin
      ReOpenDataSets();
      if FormIsContained and (Owner is TZLEZlecenieDBGridForm) then
        (Owner as TZLEZlecenieDBGridForm).RefreshDetail( True, (Owner as TZLEZlecenieDBGridForm).RozliczenieFormIndex );
    end;
  finally
    if oForm <> nil then oForm.Free;
  end;
end;

procedure TZLEZlecenieRozlDBGridForm.DBGridMark;
begin
  if not DMAQFbN(sZLEZASOBYPRACA_DATA).IsNull then begin
    inherited;
    PrzelaczButtony();
  end else DBGrid.UnMark();
end;

procedure TZLEZlecenieRozlDBGridForm.DBGridUnMark;
begin
  inherited;
  if (DataModule <> nil)and
     (DataModule.ActiveQuery <> nil) then PrzelaczButtony();
end;

procedure TZLEZlecenieRozlDBGridForm.PrzelaczButtony();
begin
  if DataModule.ActiveQuery.IsEmpty then begin
    DopiszButton.Enabled := NewMenuItem.Enabled;
    DopiszZasobButton.Enabled := NewMenuItem.Enabled;
    RozliczButton.Enabled := False;
    UsunButton.Enabled := DeleteMenuItem.Enabled;
    ZmienButton.Enabled := EditMenuItem.Enabled;
  end else if Length(DBGrid.MarkedRows) > 0 then begin
    DopiszButton.Enabled := False;
    DopiszZasobButton.Enabled := False;
    RozliczButton.Enabled := False;
    UsunButton.Enabled := False;
    ZmienButton.Enabled := EditMenuItem.Enabled;
  end else begin
    DopiszButton.Enabled := NewMenuItem.Enabled;
    DopiszZasobButton.Enabled := NewMenuItem.Enabled;
    UsunButton.Enabled   := DeleteMenuItem.Enabled;
    RozliczButton.Enabled := False;
    ZmienButton.Enabled := EditMenuItem.Enabled;

    if DataModule.ActiveQuery.FindField(sZLEZASOBYPRACA_DATA) <> nil then
       if DMAQFbN(sZLEZASOBYPRACA_DATA).IsNull then begin
          RozliczButton.Enabled := True;
          ZmienButton.Enabled := False;
       end;
  end;

  //SetUserRights();
end;

procedure TZLEZlecenieRozlDBGridForm.ReOpenDataSets;
var iPozycjaRozlID: String;
    s: String;
    q: TUNIQuery;
begin
  iPozycjaRozlID := DataModule.ActiveQuery.FieldByName(DataModule.Keys.GetPrimaryKey()).AsString;
  inherited;
  DataModule.ActiveQuery.AfterScroll := _AfterScroll;
  _AfterScroll(DataModule.ActiveQuery);

  if Owner is TZLEZlecenieDBGridForm then begin


     q := SQLManager.CreateQuery('SELECT Sum(zr.' +sZLEZLECENIEROZL_GODZINY +') as RAZEM ' +
                              'FROM %s zr, %s zp ' +
                              'WHERE zr.' + sZLEZLECENIEPOZ_ID + '=zp.' + sZLEZLECENIEPOZ_ID + ' AND zp.' +
                              sZLEZLECENIE_ID + '=' + (Owner as TZLEZlecenieDBGridForm).DataModule.ActiveQuery.FieldByName(sZLEZLECENIE_ID).AsString, [ sZLEZLECENIEROZL, sZLEZLECENIEPOZ ]);
     try
       q.Open;
       if not q.isEmpty then begin
          if ZLEDM.vZLEFormatGodzinLiczba then
               s := FormatFloat('### ##0.00', q.FieldByName('Razem').AsFloat)
          //else s := FormatFloat('### ### ##0', Round(DMAQFbN(sZLESZCZEGOLY_ILOSC).AsFloat * 60.0) div 60) + ':' + FormatFloat('00', Round(DMAQFbN(sZLESZCZEGOLY_ILOSC).AsFloat * 60.0) mod 60);
          else s := FormatFloat('### ### ##0', q.FieldByName('Razem').AsInteger div 60) + ':' + FormatFloat('00', q.FieldByName('Razem').AsInteger mod 60);
          (Owner as TZLEZlecenieDBGridForm).PodsumowanieEdit.Text := s;
       end;
     finally
       FreeAndNil(q);
     end;
  end;

  if (not DataModule.ActiveQuery.IsEmpty) and (iPozycjaRozlID <> '') then
     DataModule.ActiveQuery.Locate( DataModule.Keys.GetPrimaryKey(), iPozycjaRozlID, [] );
end;

procedure TZLEZlecenieRozlDBGridForm.InitializeObjectFields;
begin
  if Parameters <> nil then
    FAnaliza := Parameters.Values[cFORM_ANALIZA] = sUNICONST_ALTERNATYWA_TAK;
end;

{
function TZLEZlecenieRozlDBGridForm.Zakres;
var
  vForm: TUNIRangeForm;
  oParams: TKeyValues;
begin
  result := False;
  oParams := TKeyValues.CreateEmpty();
  vForm := TUNIRangeForm(FormManager.OpenForm( Self, cKlasaZlecenieRozl+cSuffixKlasyRange,
                                               omDefault+omHidden, oParams));
  try
    if (bWymusPokazanie or not vForm.DontAskCheckBox.Checked)and
       (vForm.ShowModal = mrOK) then begin
      Parameters.Values[sParam_ZLEZasobRodzID] := oParams.Values[sParam_ZLEZasobRodzID];
      Parameters.Values[sParam_ZLEDataRozlOd] := oParams.Values[sParam_ZLEDataRozlOd];
      Parameters.Values[sParam_ZLEDataRozlDo] := oParams.Values[sParam_ZLEDataRozlDo];
      result := True;
    end;
  finally
    vForm.Free
  end;
end;
}

procedure TZLEZlecenieRozlDBGridForm.ZakresButtonClick(Sender: TObject);
begin
  inherited;
  if OpenRangeForm() then
    KOMDM.KOMOdswiezGrid(Self.ClassName, DMAQFbN(sZLEZASOBYPRACA_ID).AsInteger);
end;

procedure TZLEZlecenieRozlDBGridForm.SetUserRights;
begin
  with SecurityManager do begin
    DopiszButton.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_ROZL_ZASOBOW_DOPISZ);
    RozliczButton.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_ROZL_ZASOBOW_ROZL);
    ZmienButton.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN_ROZL_ZASOBOW_ZMIEN);
  end;
end;

procedure TZLEZlecenieRozlDBGridForm.New;
begin
  OpenDetail(False, omNew);
end;

procedure TZLEZlecenieRozlDBGridForm.DopiszZasobButtonClick(
  Sender: TObject);
begin
  OpenDetail(False, omNew);
end;

procedure TZLEZlecenieRozlDBGridForm.UsunButtonClick(Sender: TObject);
begin
  OpenDetail(False, omDelete);
  {Usu}
end;

procedure TZLEZlecenieRozlDBGridForm.DBGridDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
  s: string;
begin
  inherited;
  if Column.Field <> Nil then begin
    s:= Column.Field.AsString;
    if (Column.FieldName = sZLEZASOBYPRACA_CZAS_PRACY) then begin
      if ZLEDM.vZLEFormatGodzinLIczba then
        s := FormatFloat('### ##0.00', Zaokraglij(DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat, UNIGetFracFromValueFormat(ASODM.vAsoFormatIlosci)))
      else
        s := FormatFloat('### ### ##0', DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY).AsInteger div 60) + ':' + FormatFloat('00', DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY).AsInteger mod 60);


//      s := FormatFloat('### ### ##0', DMAQFbN(sZLEZLECENIEROZL_GODZINY).AsInteger div 60) + ':' + FormatFloat('00', DMAQFbN(sZLEZLECENIEROZL_GODZINY).AsInteger mod 60);
      DBGrid.WriteText(DBGrid.Canvas, Rect, s, Column.Alignment);
    end else
    if (Uppercase(Column.FieldName) = Uppercase(sZLEOSOBYGODZ_WARTOSC)) then begin
      s := FormatFloat('### ##0.00', DMAQFbN(sZLEOSOBYGODZ_WARTOSC).AsFloat);
      DBGrid.WriteText(DBGrid.Canvas, Rect, s, Column.Alignment);
    end else begin
      DBGrid.WriteText(DBGrid.Canvas, Rect, Column.Field.DisplayText, Column.Alignment);
    end;
  end;
end;

initialization
  FormManager.RegisterForm( TZLEZlecenieRozlDBGridForm, sZLEModulID );

end.
