unit ZLEZlecenieRozlRangeFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIRangeFormUnit, Menus, UNIComponentsUnit, ToolWin, ComCtrls, StdCtrls,
  Buttons, ExtCtrls, Mask, UNIDateEditUnit, DB;

type
  TZLEZlecenieRozlRangeForm = class(TUNIRangeForm)
    ZleceniePanel: TUNIPanel;
    ZlecenieLabel: TUNILabel;
    AsortymentPanel: TUNIPanel;
    AsortymentLabel: TUNILabel;
    ZgloszeniePanel: TUNIPanel;
    ZgloszenieLabel: TUNILabel;
    ZlecenieLookupAliasEdit2: TUNIRangeLookupAliasEdit;
    AsortymentLookupAliasEdit2: TUNIRangeLookupAliasEdit;
    ZgloszenieLookupAliasEdit2: TUNIRangeLookupAliasEdit;
    ZasobPanel: TUNIPanel;
    ZasobLabel: TUNILabel;
    ZasobLookupAliasEdit2: TUNIRangeLookupAliasEdit;
    ZasobRodzajComboBox: TUNIComboBox;
    ZasobRodzajLabel: TUNILabel;
    DataRozliczeniaPanel: TUNIPanel;
    DataRozliczeniaOdLabel: TUNILabel;
    DataRozliczeniaDoLabel: TUNILabel;
    DataRozliczeniaOdDateEdit: TUNIDateEdit;
    DataRozliczeniaDoDateEdit: TUNIDateEdit;
    DataOtwarciaLabel: TUNILabel;
    DataOtwarciaOdDateEdit: TUNIDateEdit;
    DataOtwarciaDoDateEdit: TUNIDateEdit;
    DataOtwarciaDoLabel: TUNILabel;
    procedure ZasobRodzajComboBoxChange(Sender: TObject);
    procedure DataRozliczeniaOdDateEditDateChange(Sender: TObject);
    procedure DataRozliczeniaDoDateEditDateChange(Sender: TObject);
    function ZlecenieLookupAliasEdit2GetQuery: TUNIQuery;
    function AsortymentLookupAliasEdit2GetQuery: TUNIQuery;
    function ZgloszenieLookupAliasEdit2GetQuery: TUNIQuery;
    function ZasobLookupAliasEdit2GetQuery: TUNIQuery;
    procedure ZlecenieLookupAliasEdit2InitAliasInfo(Sender: TObject);
    procedure AsortymentLookupAliasEdit2InitAliasInfo(Sender: TObject);
    procedure ZgloszenieLookupAliasEdit2InitAliasInfo(Sender: TObject);
    procedure ZasobLookupAliasEdit2InitAliasInfo(Sender: TObject);
    function UNIRangeCheckListBox1GetQuery: TUNIQuery;
    procedure DataOtwarciaOdDateEditDateChange(Sender: TObject);
    procedure DataOtwarciaDoDateEditDateChange(Sender: TObject);
  private
    bProcessData: Boolean;
    procedure InitializeControls();
    procedure InitializeObjectFields();
  protected
    procedure ProcessRangeParamsToParameters; override;
    procedure PrepareParamsStep1; override;
    procedure ProcessData; override;
    procedure RestoreDefaults; override;
    procedure InternalOpen(); override;
  public
    destructor Destroy(); override;
    function Validate(): Boolean; override;
  end;

resourcestring
  SCancelButton = 'Anuluj';


implementation

{$R *.DFM}

uses
  Dodatki,
  AliasManagerUnit,
  FormManagerUnit,
  SecurityManagerUnit,
  SQLManagerUnit,
  SystemDefUnit,
  UNISysDefUnit,
  ASODefUnit,
  ASODataManagerExtUnit,
  BOKDefUnit,
  BOKDataManagerExtUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit;

const
  cZaznaczoneText = 'wybrano %d pozycji';

destructor TZLEZlecenieRozlRangeForm.Destroy;
begin
  inherited;
end;

procedure TZLEZlecenieRozlRangeForm.InitializeObjectFields;
begin
  bProcessData := False;
end;

procedure TZLEZlecenieRozlRangeForm.InitializeControls;
begin
  with ZasobRodzajComboBox do begin
    Items.Assign(cslZLERodzajZasobu);
    Items.Add('Wszystkie');
    DropDownCount := Items.Count;
  end;
end;

procedure TZLEZlecenieRozlRangeForm.ZasobRodzajComboBoxChange(
  Sender: TObject);
var
  iIndex: Integer;
begin
  iIndex := cslZLERodzajZasobu.IndexOf(ZasobRodzajComboBox.Text);
  if iIndex > -1 then
    RangeParam(sParam_ZLEZasobRodzID).Value := cslZLERodzajZasobu.ZwrocSkrot(iIndex)
  else
    RangeParam(sParam_ZLEZasobRodzID).Clear();
end;

procedure TZLEZlecenieRozlRangeForm.ProcessData;
var
  iIndex: Integer;
begin
  inherited;
  bProcessData := True;
  try
    iIndex := -1;
    if RangeParam(sParam_ZLEZasobRodzID).IsSet then
      iIndex := cslZLERodzajZasobu.IndexOfSkrot( RangeParam(sParam_ZLEZasobRodzID).Value );
    if iIndex = -1 then
      ZasobRodzajComboBox.ItemIndex := cslZLERodzajZasobu.Count
    else
      ZasobRodzajComboBox.ItemIndex := iIndex;

    if RangeParam(sParam_ZLEDataRozlOd).IsSet then
      DataRozliczeniaOdDateEdit.Date := StrToIntDef(RangeParam(sParam_ZLEDataRozlOd).Value,0)
    else
      DataRozliczeniaOdDateEdit.Date := 0;
    if RangeParam(sParam_ZLEDataRozlDo).IsSet then
      DataRozliczeniaDoDateEdit.Date := StrToIntDef(RangeParam(sParam_ZLEDataRozlDo).Value,0)
    else
      DataRozliczeniaDoDateEdit.Date := 0;

    if RangeParam(sParam_ZLEDataOtwOd).IsSet then
      DataOtwarciaOdDateEdit.Date:= StrToIntDef(RangeParam(sParam_ZLEDataOtwOd).Value, 0)
    else
      DataOtwarciaOdDateEdit.Date := 0;
    if RangeParam(sParam_ZLEDataOtwDo).IsSet then
      DataOtwarciaDoDateEdit.Date:= StrToIntDef(RangeParam(sParam_ZLEDataOtwDo).Value, 0)
    else
      DataOtwarciaDoDateEdit.Date := 0;
  finally
    bProcessData := False;
  end;
end;

procedure TZLEZlecenieRozlRangeForm.RestoreDefaults;
begin
  ClearRangeParams();
  PrepareParamsStep1();
  ProcessData();
end;

procedure TZLEZlecenieRozlRangeForm.InternalOpen;
begin
  InitializeObjectFields();
  InitializeControls();
  inherited;
end;

procedure TZLEZlecenieRozlRangeForm.DataRozliczeniaOdDateEditDateChange(
  Sender: TObject);
begin
  inherited;
  if Trunc(DataRozliczeniaOdDateEdit.Date) <> 0 then
    RangeParam(sParam_ZLEDataRozlOd).Value := IntToStr(Trunc(DataRozliczeniaOdDateEdit.Date))
  else
    RangeParam(sParam_ZLEDataRozlOd).Clear();
end;

procedure TZLEZlecenieRozlRangeForm.DataRozliczeniaDoDateEditDateChange(
  Sender: TObject);
begin
  inherited;
  if Trunc(DataRozliczeniaDoDateEdit.Date) <> 0 then
    RangeParam(sParam_ZLEDataRozlDo).Value := IntToStr(Trunc(DataRozliczeniaDoDateEdit.Date))
  else
    RangeParam(sParam_ZLEDataRozlDo).Clear();
end;

function TZLEZlecenieRozlRangeForm.Validate;
begin
  result := False;
  if not SprawdzZakresDat( DataRozliczeniaOdDateEdit.Date,
                           DataRozliczeniaDoDateEdit.Date ) then begin
    Komunikat( cInformation, 'Bdny zakres dat' );
    Exit;
  end;
  result := inherited Validate();
end;

procedure TZLEZlecenieRozlRangeForm.ProcessRangeParamsToParameters;
begin
  inherited;
  Parameters.Values[sParam_ZLEZasobRodzID] := RangeParam(sParam_ZLEZasobRodzID).Value;
  Parameters.Values[sParam_ZLEDataRozlOd] := RangeParam(sParam_ZLEDataRozlOd).Value;
  Parameters.Values[sParam_ZLEDataRozlDo] := RangeParam(sParam_ZLEDataRozlDo).Value;
  Parameters.Values[sParam_ZLEDataOtwOd]:= RangeParam(sParam_ZLEDataOtwOd).Value;
  Parameters.Values[sParam_ZLEDataOtwDo]:= RangeParam(sParam_ZLEDataOtwDo).Value;
end;

procedure TZLEZlecenieRozlRangeForm.PrepareParamsStep1;
begin
  inherited;
  with RangeParams do begin
    ZlecenieLookupAliasEdit2.RangeParam := AddLarge( sParam_ZLEZlecenieID, '', cADMIDFuncZLEZlecenie );
    AsortymentLookupAliasEdit2.RangeParam := AddLarge( sParam_ZLEAsortID, '', cADMIDFuncZLEAsortyment );
    ZgloszenieLookupAliasEdit2.RangeParam := AddLarge( sParam_ZLESprawaID, '', cADMIDFuncZLESprawa );
    ZasobLookupAliasEdit2.RangeParam := AddLarge( sParam_ZLEZasobZLEID, '', cADMIDFuncZLEZasobZLE );
  end;
end;

function TZLEZlecenieRozlRangeForm.ZlecenieLookupAliasEdit2GetQuery: TUNIQuery;
var
  oSelectedIds: TStringList;
begin
  inherited;
  oSelectedIds := nil;
  if RangeParam(sParam_ZLEZlecenieID).Count > 1 then
    oSelectedIds := RangeParam(sParam_ZLEZlecenieID);
  result := ZLEDM.ZLEPokazIObsluzZlecenia( sZLEALIAS_ZLECENIE_ID+';'+
                                           sZLEALIAS_ZLECENIE_SYMBOL+';'+
                                           sZLEALIAS_ZLECENIE_NAZWA,
                                           '', True, True, cZLEModulZSI_ID,
                                           StrToIntDef(RangeParam(sParam_ZLEZlecenieID).Value,0), 0,
                                           oSelectedIds );
end;

function TZLEZlecenieRozlRangeForm.AsortymentLookupAliasEdit2GetQuery: TUNIQuery;
var
  oSelectedIds: TStringList;
begin
  inherited;
  oSelectedIds := nil;
  if RangeParam(sParam_ZLEAsortID).Count > 1 then
    oSelectedIds := RangeParam(sParam_ZLEAsortID);
  result := ASODM.PokazIObsluzAsortyment( sASOAlias_Asort_ID+';'+
                                          sASOAlias_Asort_Symbol,
                                          '', True, True,
                                          RangeParam(sParam_ZLEAsortID).Value,
                                          0{cZLEModulZSI_ID}, True, 0, False, '',
                                          True, oSelectedIds );
end;

function TZLEZlecenieRozlRangeForm.ZgloszenieLookupAliasEdit2GetQuery: TUNIQuery;
begin
  inherited;
  result := BOKDM.PokazIObsluzDane( sBOKSPRAWA,
                                    sBOKAlias_Sprawa_ID+';'+
                                    sBOKAlias_Sprawa_Numer,
                                    '', True, True, '' );
end;

function TZLEZlecenieRozlRangeForm.ZasobLookupAliasEdit2GetQuery: TUNIQuery;
var
  oSelectedIds: TStringList;
begin
  inherited;
  oSelectedIds := nil;
  if RangeParam(sParam_ZLEZasobZLEID).Count > 1 then
    oSelectedIds := RangeParam(sParam_ZLEZasobZLEID);
  result := ZLEDM.ZLEPokazIObsluzDane( sZLEZASOB,
                                       sZLEALIAS_ZLEZASOB_ID+';'+
                                       sZLEALIAS_ZLEZASOB_NAZWA,
                                       '', True, True, cZLEModulZSI_ID,
                                       StrToIntDef(RangeParam(sParam_ZLEZasobZLEID).Value,0), 0, '',
                                       oSelectedIds );
end;

procedure TZLEZlecenieRozlRangeForm.ZlecenieLookupAliasEdit2InitAliasInfo(
  Sender: TObject);
begin
  with ZlecenieLookupAliasEdit2 do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_ID := sZLEALIAS_ZLECENIE_ID;
    Alias_Name := sZLEALIAS_ZLECENIE_SYMBOL;
  end;
end;

procedure TZLEZlecenieRozlRangeForm.AsortymentLookupAliasEdit2InitAliasInfo(
  Sender: TObject);
begin
  with AsortymentLookupAliasEdit2 do begin
    AliasManager := ASODM.AliasManager;
    Alias_ID := sASOAlias_Asort_ID;
    Alias_Name := sASOAlias_Asort_Symbol;
  end;
end;

procedure TZLEZlecenieRozlRangeForm.ZgloszenieLookupAliasEdit2InitAliasInfo(
  Sender: TObject);
begin
  with ZgloszenieLookupAliasEdit2 do begin
    AliasManager := BOKDM.AliasManager;
    Alias_ID := sBOKAlias_Sprawa_ID;
    Alias_Name := sBOKAlias_Sprawa_Numer;
  end;
end;

procedure TZLEZlecenieRozlRangeForm.ZasobLookupAliasEdit2InitAliasInfo(
  Sender: TObject);
begin
  with ZasobLookupAliasEdit2 do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_ID := sZLEALIAS_ZLEZASOB_ID;
    Alias_Name := sZLEALIAS_ZLEZASOB_NAZWA;
  end;
end;

function TZLEZlecenieRozlRangeForm.UNIRangeCheckListBox1GetQuery: TUNIQuery;
begin
  inherited;
  result := ZLEDM.ZLEOdpytajODane( sZLEZLECENIE,
                                   sZLEALIAS_ZLECENIE_ID+';'+
                                   sZLEALIAS_ZLECENIE_SYMBOL+';'+
                                   sZLEALIAS_ZLECENIE_NAZWA,
                                   '', False, sZLEALIAS_ZLECENIE_SYMBOL );
end;

procedure TZLEZlecenieRozlRangeForm.DataOtwarciaOdDateEditDateChange(
  Sender: TObject);
begin
  inherited;
  if Trunc(DataOtwarciaOdDateEdit.Date) <> 0 then
    RangeParam(sParam_ZLEDataOtwOd).Value := IntToStr(Trunc(DataOtwarciaOdDateEdit.Date))
  else
    RangeParam(sParam_ZLEDataOtwOd).Clear();
end;

procedure TZLEZlecenieRozlRangeForm.DataOtwarciaDoDateEditDateChange(
  Sender: TObject);
begin
  inherited;
  if Trunc(DataOtwarciaDoDateEdit.Date) <> 0 then
    RangeParam(sParam_ZLEDataOtwDo).Value := IntToStr(Trunc(DataOtwarciaDoDateEdit.Date))
  else
    RangeParam(sParam_ZLEDataOtwDo).Clear();
end;

initialization
  FormManager.RegisterForm( TZLEZlecenieRozlRangeForm, 'Zakres rozliczenia zasobw', sZLEModulID );

end.
