unit ZLEZlecenieRozlUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2005-02-26 gdeyk    Utworzone
2006-01-03 Krz      Dodaem sZLEZLECENIEPOZ_LP    
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLEZlecenieRozlDataModule = class(TUNIDataModule)
  private
    idcZlecenie, idjZlecenie: Integer;
    idcAsortyment, idjAsortyment: Integer;
    idcSprawa, idjSprawa: Integer;
    idcZasobZLE, idjZasobZLE: Integer;
    idcZasobZLERodzaj: Integer;
    idcDataRozliczeniaOd: Integer;
    idcDataRozliczeniaDo: Integer;
    idcDataOtwarciaOd: Integer;
    idcDataOtwarciaDo: Integer;
    FAnaliza: Boolean;
    procedure SetADMIDJoinOnField( const iFun: Integer;
                                   var iCondIndex: Integer; sFieldName: String );
    procedure SetParameters();
    procedure ResetConditions();
  protected
    procedure GetKeys; override;
    function GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;
    procedure SetDisplayFormat(); override;
  public
    procedure ReOpenDataSets(); override;
    constructor Create(AOwner: TComponent); override;
    procedure Post; override;
    procedure Delete; override;
  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  QueryBuilderUnit,
  FormManagerUnit,
  KeyManagerUnit,
  UniqueKeyUnit,
  SecurityManagerUnit,
  SQLManagerUnit,
  UNIFormUnit,
  UNIDataManagerUnit,
  UNIDBDetailFormUnit,
  UNIDBGridFormUnit,
  UNIStaleUnit,
  SystemDefUnit,
  UNISysDefUnit,
  ASODefUnit,
  FKDefUnit,
  LFKDefUnit,
  KDPRADefUnit,
  KDECPDataManagerExtUnit,
  KDDefUnit,
  KDDataManagerExtUnit,
  ASODataManagerExtUnit,
  BOKDefUnit,
  INFDefUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit,
  ZLEZlecenieRozlDBGridFormUnit,
  ZLEZlecenieRozlDBDetailFormUnit;

{ TZLEZlecenieRozlDataModule }

constructor TZLEZlecenieRozlDataModule.Create(AOwner: TComponent);
begin
  inherited;
  FAnaliza := false;
  if (Owner is TUNIDBGridForm) then
    FAnaliza := (Owner as TZleZlecenieRozlDBGridForm).Analiza;
end;

procedure TZLEZlecenieRozlDataModule.Delete;
var
  bTrans: Boolean;
  iZLEZasobyPracaID, i, iOsobaID: Integer;
  slRaportBledow: TStringList;
  sKomunikat: String;
  bPrzerwijZapis: Boolean;
begin
  bTrans := not SQLManager.InTransaction;
  try
    if bTrans then SQLManager.StartTransaction;
    iZLEZasobyPracaID := ActiveQuery.FieldByName(sZLEZASOBYPRACA_ID).AsInteger;
    iOsobaID          := ActiveQuery.FieldByName(sKDOSOBA_ID).AsInteger;

    slRaportBledow    := TStringList.Create();
    bPrzerwijZapis    := False;
    sKomunikat        := '';

    if Owner is TZLEZlecenieRozlDBDetailForm then begin
       with (Owner as TZLEZlecenieRozlDBDetailForm) do begin
         if ZLEDM.vZLEWysylanieRozliczECPWlaczone and (iOsobaID > 0) then begin
           try
             KDECPDM.KDECPUsunWgOjca(sZRODLO_ZLECENIA,iZLEZasobyPracaID, slRaportBledow);
             if slRaportBledow.Count > 0 then begin
               sKomunikat := '';
               for i := 0 to slRaportBledow.Count -1 do begin
                   if sKomunikat <> '' then sKomunikat := sKomunikat + chr(13) + ' ';
                   sKomunikat := sKomunikat + slRaportBledow[i];
               end;
               if ZLEDM.vZLEUwzglednijBlokadeKDECP then begin
                 Komunikat(cError, sKomunikat + chr(13) + 'Nie mona usunc danych');
                 bPrzerwijZapis := True;
               end else begin
                 if Komunikat(cConfirmation, sKomunikat, MB_YesNo + MB_DEFBUTTON2) = idYes then begin
                    // Nie zapisujemy rekordu do raportow, bo kasujemy wpis w tabeli ZLEZASOBYPRACARAP,
                    // zatem pozostanie tylko wpis po stronie ECP
                 end else begin
                    //Komunikat(cWarning, 'Rezygnacja z usunicia danych');
                    bPrzerwijZapis := True;
                 end;
               end;
             end;

           except
             Komunikat(cError, 'Nie mona usunc danych z ECP');
             bPrzerwijZapis := True;
           end;
         end;
       end;
    end;

    if (not bPrzerwijZapis) and
        ZLEDM.vZLEWysylanieRozliczECPWlaczone and
        (iOsobaID > 0) then begin
        //Usuwamy dane z tabeli z raportami dla tej krotki
        SQLManager.ExecuteQuery('DELETE FROM %s ' +
                                'WHERE ' + sZLEZASOBYPRACA_ID + '=' + IntToStr(iZLEZasobyPracaID),
                                [sZLEZASOBYPRACARAP]);
    end;
    if (not bPrzerwijZapis) then inherited;
    if bTrans and (not bPrzerwijZapis) then SQLManager.Commit
    else if bPrzerwijZapis and bTrans then  SQLManager.Rollback;
  except
    if bTrans then SQLManager.Rollback;
  end;
end;

procedure TZLEZlecenieRozlDataModule.GetKeys;
begin
  with FKeys do begin
    AddPrimary(sZLEZASOBYPRACA_ID);
  end;
end;

function TZLEZlecenieRozlDataModule.GetTableName: string;
begin
  result := sZLEZASOBYPRACA;
end;

procedure TZLEZlecenieRozlDataModule.InitializeGridQueryDefs;
var
  {sElementINFSQL,} sTmp: String;
begin
  ResetConditions();
  {sElementINFSQL := Format( '%s(PZ.%s,PZ.%s)',[ SQLManager.GetSPName(sINF_DAJSYMBOLOBIEKTU),
                                          sZLEZLECENIEPOZ_POZIOMINF,
                                          sZLEZLECENIEPOZ_INF_ID] );}
  with GridColDefs do begin
    Clear();
    AddRequiredAndUnvisible( sZLEZASOBYPRACA_ID, 'M', '' );
    AddRequiredAndUnvisible( sZLEZLECENIE_ID, 'M', '' );
    AddRequiredAndUnvisible( sZLEZLECENIEPOZ_ID, 'M', '' );
    AddRequiredAndUnvisible( sZLEZASOB_ID, 'M', '' );
    AddRequiredAndUnvisible( sUNIOKRES_ID, 'M', '' );
    AddRequiredAndUnvisible( sKDOSOBA_ID, 'M', '' );
    AddRequiredAndUnvisible( sUNIJEDNOSTKAORG_ID, 'M', '' );
    AddRequiredAndUnvisible( sZLECONST_RODZAJECP_ID, 'M', '' );
    if DataManagers.Available(sBOKModulID) then
      Add( sBOKSPRAWA_NUMER, 'BOK', 'Zgoszenie numer', True, True, taLeftJustify, 50 );
    AddRequired( sZLEZASOB_NAZWA, 'Z', 'Nazwa', True, taLeftJustify, 100 );
    AddRequired( sZLEZASOB_SYMBOL, 'Z', 'Symbol Zasobu', True, taLeftJustify, 70 );
    Add( sZLEZLECENIEPOZ_LP , 'PZ', 'L.p.', False, True, taLeftJustify, 80 );
    Add( sKDOSOBA_SYMBOL, 'OS', 'Symbol osoby', False, True, taLeftJustify, 80 );
    Add( sKDOSOBA_NAZWA, 'OS', 'Nazwa osoby', False, True, taLeftJustify, 80 );

    {Wartosc}
    if ZLEDM.vZLEFormatGodzinLiczba then
         sTmp := ')*'
    else sTmp := '/60)*';

    Add('(M.' + sZLEZASOBYPRACA_CZAS_PRACY + sTmp + ' M.' + sZLEZASOBYPRACA_STAWKA + ',2' + ';' + sZLEOSOBYGODZ_WARTOSC, '', 'Warto', True, True, taRightJustify, 200, uftFloat);
    Items[Count - 1].ColumnFunction:= SQLManager.GetSPName('ZAOKRAGLIJ');

    Add( sZLEZASOBYPRACA_CZAS_PRACY{ZLECENIEROZL_GODZINY}, 'M', 'Ilo godzin pracy zasobu', True, True, taRightJustify, 50, uftCurrency );
    Add( sZLEZASOBYPRACA_STAWKA {sZLEZLECENIEROZL_STAWKA}, 'M', 'Stawka', True, True, taRightJustify, 50, uftCurrency );
    Add( sZLEZASOBYPRACA_DATA{sZLEZLECENIEROZL_DATA}, 'M', 'Data rozliczenia', True, True, taLeftJustify, 70 );
    if FAnaliza then begin
      Add( sZLEZLECENIE_DATA_OTW, 'ZLE', 'Data otwarcia', True, True, taLeftJustify, 70 );
      Add( sZLEZLECENIE_DATA_ZAMK, 'ZLE', 'Data zamknicia', True, True, taLeftJustify, 70 );
    end;
    AddRequiredAndUnvisible( sZLEZASOB_RODZAJ, 'Z', '' );
    Add( sZLECONST_RODZAJZASOBU_V, 'RZ', 'Rodzaj', True, True, taLeftJustify, 100 );
    AddRequiredAndUnvisible( sASOASORT_ID, 'PZ', '' );
    Add( sASOASORT_INDEKS, 'ASORT', 'Indeks asortymentu', False, True, taLeftJustify, 50 );
    Add( sASOASORT_NAZWA, 'ASORT', 'Nazwa asortymentu', False, True, taLeftJustify, 100 );
    Add( sZLEZLECENIEPOZ_OPIS, 'PZ', 'Opis', False, True, taLeftJustify, 100, uftClob, True );
    if ZLEDM.vZLEZLECENIEROZL_ZUZPALIWA then
       Add( sZLEZASOBYPRACA_ZUZ_PALIWA {sZLEZLECENIEROZL_ZUZ_PALIWA}, 'M', 'Zuycie Paliwa', False, True, taRightJustify, 70, uftCurrency );

    if (DataManagers.Available(sKDPRAModulID)) then begin
      Add(sKDSKLADNIKCZASU_SYMBOL,   'SC', 'Skadnik czasu pracy', false, true, taLeftJustify, 100);
      Add(sKDSKLADNIKCZASU_NAZWA,    'SC', 'Nazwa skadnika czasu pracy', false, true, taLeftJustify, 100);
    end;

    if FAnaliza then begin
      Add( sZLEZLECENIE_NAZWA, 'ZLE', 'Nazwa zlecenia', True, True, taLeftJustify, 150 );
      AddRequiredAndUnvisible( sZLEZLECENIE_STATUS, 'ZLE', '' );
      Add( sZLECONST_STATUS_V, 'STZLE', 'Status zlecenia', True, True, taLeftJustify, 50 );
      Add( sZLEZLECENIE_SYMBOL, 'ZLE', 'Symbol zlecenia', True, True, taLeftJustify, 50 );
      Add( sZLEZLECENIE_OPIS, 'ZLE', 'Opis zlecenia', True, True, taLeftJustify, 100, uftClob );
      Add( sASOASORT_SYMBOL, 'ASORT', 'Symbol asortymentu', False, True, taLeftJustify, 50 );
      Add( sUNIJM_SYMBOL, 'JM', 'J.m.', True, True, taLeftJustify, 50 );
    end;

    if DataManagers.Available(sBOKModulID) then begin
      AddRequiredAndUnvisible( sBOKSPRAWA_ID, 'PZ', '' );
      Add( sBOKSPRAWA_NUMER, 'BOK', 'Numer zgoszenia', True, True, taLeftJustify, 100 );
      Add( sBOKSPRAWA_OBIEKTOPIS, 'BOK', 'Opis obiektu', False, True, taLeftJustify, 100 );
      Add( sBOKSPRAWA_NAZWA, 'BOK', 'Nazwa sprawy', False, True, taLeftJustify, 100 );
      Add( sBOKSPRAWA_PROBLEM, 'BOK', 'Opis zgoszenia', True, True, taLeftJustify, 100, uftClob );
      Add( sBOKSPRAWA_DATA_UMOW, 'BOK', 'Data umwienia', False, True, taLeftJustify, 100 );
      Add( sBOKSPRAWA_UMOWIONE, 'BOK', 'Umwione', False, True, taLeftJustify, 100 );

      if DataManagers.Available(sINFModulID) then begin
         Add( 'CAST('+SQLManager.GetSPName(sINF_DAJSYMBOLOBIEKTU)+'(BOK.'+sBOKSPRAWA_OBIEKTJAKI+',BOK.'+sBOKSPRAWA_OBIEKTID+',' +QuotedStr('SYMBOL')+') AS VARCHAR2(100));OBIEKT_SYMBOL',
              '', 'Obiekt - symbol', False, True, taLeftJustify, 80, uftClob );
         Add( 'CAST('+SQLManager.GetSPName(sINF_DAJSYMBOLOBIEKTU)+'(BOK.'+sBOKSPRAWA_OBIEKTJAKI+',BOK.'+sBOKSPRAWA_OBIEKTID+',' + QuotedStr('NAZWA')+') AS VARCHAR2(250));OBIEKT_NAZWA',
              '', 'Obiekt - nazwa', False, True, taLeftJustify, 100, uftClob );
      end;
    end;

    AddRequiredAndUnvisible( sZLEZLECENIEPOZ_POZIOMINF, 'PZ', '' );
    {if DataManagers.Available(sINFModulID) then begin
      Add( sINFCONST_OBIEKT_V, 'POZIOM_INF', 'Poziom inf.', True, True, taLeftJustify, 70 );
      Add( 'CAST(' + sElementINFSQL+' AS VARCHAR2(50))'+';'+'INFOBIEKT_SYMBOL', '', 'Symbol elementu inf.', True, True, taLeftJustify, 70 );
    end;}

    AddRequiredAndUnvisible( sZLEZLECENIEPOZ_POZIOMINF, 'PZ', '' );
    AddRequiredAndUnvisible( sZLEZLECENIEPOZ_INF_ID, 'PZ', '' );
    AddRequiredAndUnvisible( sKDSKLADNIKCZASU_ID,    'M', '');

    if DataManagers.Available(sINFModulID) then begin
       Add( 'CAST('+SQLManager.GetSPName(sINF_DAJSYMBOLOBIEKTU)+'(PZ.'+sZLEZLECENIEPOZ_POZIOMINF+',PZ.'+sZLEZLECENIEPOZ_INF_ID+',' +QuotedStr('SYMBOL')+') AS VARCHAR2(100));INF_SYMBOL',
            '', 'INF - symbol', False, True, taLeftJustify, 80, uftClob );
       Add( 'CAST('+SQLManager.GetSPName(sINF_DAJSYMBOLOBIEKTU)+'(PZ.'+sZLEZLECENIEPOZ_POZIOMINF+',PZ.'+sZLEZLECENIEPOZ_INF_ID+',' + QuotedStr('NAZWA')+') AS VARCHAR2(250));INF_NAZWA',
            '', 'INF - nazwa', False, True, taLeftJustify, 100, uftClob );
    end;
  end;

  with GridTabDefs do begin
    Clear();
    Add( 'M', TableName );
    Add( 'Z', sZLEZASOB );
    Add( 'OS', sKDOSOBA );
    Add( 'RZ', sZLECONST_RODZAJZASOBU );
    Add( 'PZ', sZLEZLECENIEPOZ );
    if DataManagers.Available(sBOKModulID) then
      Add( 'BOK', sBOKSPRAWA );
    Add( 'ASORT', sASOASORT );
    if DataManagers.Available(sKDPRAModulID) then
       Add('SC'       , sKDSKLADNIKCZASU);

    if FAnaliza then begin
      Add( 'ZLE', sZLEZLECENIE );
      Add( 'STZLE', sZLECONST_STATUS );
      Add( 'JM', sUNIJM );
    end;

    {if DataManagers.Available(sINFModulID) then begin
        Add( 'POZIOM_INF', sINFCONST_OBIEKT );
    end; }
  end;
  with GridJoinDefs do begin
    Clear();
    AddSimple( 'M', 'Z', 'M.'+sZLEZASOB_ID+'=Z.'+sZLEZASOB_ID, qjkInner, True );
    AddSimple( 'Z', 'RZ', 'Z.'+sZLEZASOB_RODZAJ+'=RZ.'+sZLECONST_RODZAJZASOBU_ID, qjkInner, True );
    AddSimple( 'M', 'OS', 'M.'+sKDOSOBA_ID+'=OS.'+sKDOSOBA_ID, qjkLeftOuter, True ); //Teraz osoba z tabeli ZLEZASOBYPRACA
    AddSimple( 'M', 'PZ', 'M.'+sZLEZLECENIEPOZ_ID+'=PZ.'+sZLEZLECENIEPOZ_ID, qjkInner, True );
    AddCondition('M.'+sZLECONST_RODZAJECP_ID + '=' + QuotedStr(cZLERodzajECP_RozliczID),True);
    if DataManagers.Available(sBOKModulID) then
      AddSimple( 'PZ', 'BOK', 'PZ.'+sBOKSPRAWA_ID+'=BOK.'+sBOKSPRAWA_ID, qjkLeftOuter, True );
    AddSimple( 'PZ', 'ASORT', 'PZ.'+sASOASORT_ID+'=ASORT.'+sASOASORT_ID, qjkLeftOuter, True );
    if DataManagers.Available(sKDPRAModulID) then
       AddExpres('M.' + sKDSKLADNIKCZASU_ID + ' = ' + 'SC'  + '.' + sKDSKLADNIKCZASU_ID, qjkLeftOuter, false);

    if FAnaliza then begin
      AddSimple( 'PZ', 'ZLE', 'PZ.'+sZLEZLECENIE_ID+'=ZLE.'+sZLEZLECENIE_ID, qjkInner, True );
      AddSimple( 'ZLE', 'STZLE', 'ZLE.'+sZLEZLECENIE_STATUS+'=STZLE.'+sZLECONST_STATUS_ID, qjkInner, True );
      AddSimple( 'ASORT', 'JM', 'ASORT.'+sUNIJM_ID1+'=JM.'+sUNIJM_ID, qjkLeftOuter, True );
    end;

    {if DataManagers.Available(sINFModulID) then begin
        AddSimple( 'PZ', 'POZIOM_INF', 'PZ.'+sZLEZLECENIEPOZ_POZIOMINF+'=POZIOM_INF.'+sINFCONST_OBIEKT_ID, qjkLeftOuter, True );
    end;}
  end;
  SetParameters();
  inherited;
end;


procedure TZLEZlecenieRozlDataModule.Post;
var
  bTrans: Boolean;
  oUpdateQuery, oInsertQuery: TUNIQuery;
  sWhere, sZlecID, sListaPol, sListaRozliczID: String;
  qLista, qDane: TUNIQuery;
  sListaMnem: String;
  iZLEZasobyPracaID, iOsobaID, iOsobaOldID, iSkladnikCzasuID: Integer;
  slRaportBledow: TStringList;
  {bBladUsuwaniaOjca,}
  bPrzerwijZapis: Boolean;
  dOd: TDateTime;
  iGodziny, iSumaGodzin: Integer;
  oQuery: TUNIQuery;
  sListaPK, sKomunikat: String;


  procedure ZapiszRaport(sKom: String; iID: Integer);
  begin
     if (sKom <> '') and (iID > 0) then begin
       oInsertQuery := SQLManager.InsertQueryStep1( sZLEZASOBYPRACARAP,
                                                 sZLEZASOBYPRACARAP_ID+','+
                                                 sZLEZASOBYPRACA_ID+','+
                                                 sSMUSER_ID + ',' +
                                                 sZLECONST_ZASOBYPRACARAPST_ID+','+
                                                 {sZLEZASOBYPRACARAP_BLAD_ID+','+}
                                                 sZLEZASOBYPRACARAP_KOMUNIKAT + ',' +
                                                 sZLEZASOBYPRACARAP_UZ_AU_ID+','+
                                                 sZLEZASOBYPRACARAP_DATA_AU );

       try
         with oInsertQuery do begin
           ParamByName(sZLEZASOBYPRACARAP_ID).DataType := ftInteger;

           ParamByName(sZLEZASOBYPRACA_ID).DataType := ftInteger;
           ParamByName(sSMUSER_ID).DataType := ftInteger;
           ParamByName(sZLECONST_ZASOBYPRACARAPST_ID).DataType := ftString;
           ParamByName(sZLEZASOBYPRACARAP_KOMUNIKAT).DataType := ftString;
           ParamByName(sZLEZASOBYPRACARAP_UZ_AU_ID).DataType := ftInteger;
           ParamByName(sZLEZASOBYPRACARAP_DATA_AU).DataType := ftDate;

           ParamByName(sZLEZASOBYPRACA_ID).AsInteger := iID;
           ParamByName(sSMUSER_ID).AsInteger := SecurityManager.UserId;
           ParamByName(sZLECONST_ZASOBYPRACARAPST_ID).AsString := cZLEConstZasobyPracaRapStatus_NiezgodnyID;
           ParamByName(sZLEZASOBYPRACARAP_KOMUNIKAT).AsString := sKom;
           ParamByName(sZLEZASOBYPRACARAP_UZ_AU_ID).AsInteger := SecurityManager.UserId;
           ParamByName(sZLEZASOBYPRACARAP_DATA_AU).AsDateTime := UNIDate;
         end;

         SQLManager.InsertQueryStep2( oInsertQuery, sZLEZASOBYPRACARAP_ID );
       finally
         if oInsertQuery <> nil then FreeAndNil(oInsertQuery);
       end;
     end;

  end;

  function Usun_Z_ECP(iID: Integer; iOldID: Integer): Boolean;
  var idx: Integer;
  begin
    result := False;
    if (iID > 0) and (iOldID > 0) then begin
      try
        slRaportBledow.Clear();
        KDECPDM.KDECPUsunWgOjca(sZRODLO_ZLECENIA,iID, slRaportBledow);
        if slRaportBledow.Count > 0 then begin
          sKomunikat := 'Bd usuwania danych w ECP: ';
          for idx := 0 to slRaportBledow.Count -1 do begin
            if sKomunikat <> '' then sKomunikat := sKomunikat + chr(13) + ' ';
            sKomunikat := sKomunikat + slRaportBledow[idx];
          end;

          if ZLEDM.vZLEUwzglednijBlokadeKDECP then begin
            Result := True;
            Komunikat(cError, 'Bd usuwania danych do moduu Kadry ECP - blokada w module Kadry ECP' + chr(13) + sKomunikat);
          end else begin
            if Komunikat(cConfirmation, sKomunikat + chr(13) + 'Kontynuowac zapis?', MB_YesNo + MB_DEFBUTTON2) = idYes then begin
              //Zapisujemy zgod na desynchronizacj danych i pomijamy zapis nowych danych do ECP
              Result := False;
              ZapiszRaport(sKomunikat, iID);
            end else begin
              //Result := True;
              //bBladUsuwaniaOjca := True;
              Raise Exception.Create('USU DANE Z ECP: Bd usuwania ojca');
            end;
          end;
        end;
      except
        //Result := True;
        Raise Exception.Create('Nie mona usunc danych z ECP'#13+Exception(ExceptObject).Message);
      end;
    end;
  end;

  function Dopisz_Do_ECP(iID, iOsID, iGodz: Integer; dData: TDateTime; iSkladnikID: Integer): Boolean;
  var idx: Integer;
  begin
    result := False; //Czyli brak bdu
    if (iID > 0) and (iOsID > 0) and (iGodz > 0) and (iSkladnikID > 0) then begin
      try
        {Czyszczymy list bdow}
        slRaportBledow.Clear();
        KDECPDM.KDECPWprowadzSkladnikExt(''{sCP_ListaID}, //Lista umow
                                         IntToStr(iOsID) {sOS_ListaID},
                                         iSkladnikID {ZLEDM.vZLESkladnikECPDomyslnyID},
                                         dData,
                                         dData, //Taka sama data od i do
                                         sZRODLO_ZLECENIA,
                                         iGodz, 0, 0, 0,
                                         sListaPK,
                                         iID,
                                         slRaportBledow,
                                         '',
                                         '',
                                         '',
                                         iSumaGodzin);

        if slRaportBledow.Count > 0 then begin
          // Tu obsuga bdow zapisu nowych danych
          sKomunikat := 'Bd zapisu danych: ' + chr(13);
          for idx := 0 to slRaportBledow.Count -1 do begin
             if sKomunikat <> '' then sKomunikat := sKomunikat + chr(13) + ' ';
             sKomunikat := sKomunikat + slRaportBledow[idx];
          end;

          if ZLEDM.vZLEUwzglednijBlokadeKDECP then begin
            Result := True;
            Komunikat(cError, 'Bd wysyania danych do moduu Kadry ECP - blokada w module Kadry ECP' + chr(13) + sKomunikat);
          end else begin
            if Komunikat(cConfirmation, sKomunikat + chr(13) + 'Kontynuowac zapis?', MB_YesNo + MB_DEFBUTTON2) = idYes then begin
              //Zapisujemy zgod na desynchronizacj danych i pomijamy zapis nowych danych do ECP
              //Zapisz bd do Raportow i kontynuuj
              ZapiszRaport(sKomunikat, iID);
            end else begin
              //Komunikat(cWarning, 'Zmiany nie zostay zapamitane');
              Result := True;
            end;
          end;
        end;
      except
        //Result := True;
        raise EOF_ZLEException.Create('Bd komunikacji z moduem kadrowym ECP'#13+Exception(ExceptObject).Message);
      end;
    end;
  end;

  procedure UzupelnijListaPK(iID: Integer);
  var aMnem: TaMnemValue;
      iZlecID, iPozID, idx: Integer;
  begin
    //Pobieramy sobie liste mnemonikow
    sListaPK := '';
    //aMnem := TaMnemValue.Create();
    sListaMnem := KDECPDM.KDECPDajListeMnemonikow(sZRODLO_ZLECENIA);
    if sListaMnem <> '' then begin
      oQuery := SQLManager.CreateQuery('SELECT ZP.' + sZLEZLECENIE_ID + ', ' +
                                              'ZP.' + sZLEZLECENIEPOZ_ID + ', ' +
                                              'ZP.' + sKDOSOBA_ID + ', ' +
                                              'ZL.' + sUNIJEDNOSTKAORG_ID + ' ' +
                                       'FROM %s ZP, %s ZL ' +
                                       'WHERE ZP.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' AND ' +
                                             'ZP.' + sZLEZASOBYPRACA_ID + ' = ' + IntToStr(iID),
                                       [sZLEZASOBYPRACA, sZLEZLECENIE]);

      try
        oQuery.Open();
        iPozID := 0;
        iZlecID := 0;
        if not oQuery.IsEmpty then begin
          iPozID  := oQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger;
          iZlecID := oQuery.FieldByName(sZLEZLECENIE_ID).AsInteger;
          if Pos(sMnemonikJednostkaOrg, sListaMnem) > 0 then
             sListaPK := sMnemonikJednostkaOrg + '=' + IntToStr(oQuery.FieldByName(sUNIJEDNOSTKAORG_ID).AsInteger);
          if Pos(sMnemonikZlecenie, sListaMnem) > 0 then begin
             if sListaPK <> '' then sListaPK := sListaPK + ',';
               sListaPK := sListaPK + sMnemonikZlecenie + '=' + IntToStr(oQuery.FieldByName(sZLEZLECENIE_ID).AsInteger);
          end;
          if Pos(sMnemonikPracownicy, sListaMnem) > 0 then begin
             if sListaPK <> '' then sListaPK := sListaPK + ',';
             sListaPK := sListaPK + sMnemonikPracownicy + '=' + IntToStr(oQuery.FieldByName(sKDOSOBA_ID).AsInteger);
          end;
        end;
      finally
        if oQuery<> nil then FreeAndNil(oQuery);
      end;

      if  (iPozID > 0) and (iZlecID > 0) and ZLEDM.vZLEWymaganaPozycjaEwid then begin
        SetLength(aMnem, 0);
        if ZLEDM.ZLEMnemonikiDlaPozycjiZlecenia(iZlecID, iPozID, aMnem) <> 0 then begin
          //Bd podczas wywoania funkcji
          Komunikat(cError, 'Bd wywoania funkcji ZLEMnemonikiDlaPozycjiZlecenia');
          Abort;
        end else begin
          if length(aMnem) > 0 then begin
             for idx := 0 to length(aMnem) - 1 do begin
                if Pos(aMnem[idx].sName, sListaMnem) > 0 then begin
                  if sListaPK <> '' then sListaPK := sListaPK + ',';
                  sListaPK := sListaPK + aMnem[idx].sName + '=' + aMnem[idx].sValue;
                end;
             end;
          end;
        end;
      end;
    end;
  end;
  //sWhere, sZlecID, sListaPol: String;
begin
  sWhere          := '';
  sKomunikat      := '';
  sListaRozliczID := '';
  slRaportBledow  := TStringList.Create();
  bPrzerwijZapis  := False;
  sListaPK        := '';
  dOd      := 0;
  iOsobaID := 0;
  iGodziny := 0;
  iZLEZasobyPracaID := 0;
  iSkladnikCzasuID  := 0;

  if ZLEDM.vZLEWysylanieRozliczECPWlaczone
     and (OpenMode in [omNew, omEdit])
     and (Owner is TUNIDBDetailForm)
     and (ZLEDM.vZLESkladnikECPDomyslnyID <= 0) then begin
     //bPrzerwijZapis := True;
     raise EOF_ZLEException.Create('W parametrach wczona zostaa komunikacja z moduem kadrowym ECP'#13+
                                   'a nie ustawiono domyslnego skadnika czasu pracy');
  end;

  bTrans := not SQLManager.InTransaction;
  try
    if bTrans then SQLManager.StartTransaction;
    if (Owner is TUNIDBDetailForm) then begin
      if TUNIDBDetailForm(Owner).OpenMode = omNew then begin //Dopisz
        {Zapisac do ZLEZLECENIEZASOB}
        {1. Sprawdzamy czy zasb jest ju dopisany dla danego zlecenia w ZLEZLECENIEZASOB}
        sZlecID := SQLManager.OpenQueryWithResult('SELECT ' + sZLEZLECENIE_ID + ' FROM %s WHERE ' +
                                            sZLEZLECENIEPOZ_ID + '=' + ActiveQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsString,
                                            [sZLEZLECENIEPOZ]);

        if SQLManager.OpenQueryWithResult('SELECT COUNT(*) FROM %s WHERE ' + sZLEZLECENIE_ID + '=' + sZlecID + ' AND ' +
                                                                              sZLEZASOB_ID + '=' + ActiveQuery.FieldByName(sZLEZASOB_ID).AsString,
                                           [sZLEZLECENIEZASOB]) = '0' then begin
            {Dopisa}
            oInsertQuery := SQLManager.InsertQueryStep1( sZLEZLECENIEZASOB,
                                                         sZLEZLECENIEZASOB_ID+','+
                                                         sZLEZLECENIE_ID+','+
                                                         sZLEZASOB_ID+','+
                                                         sZLEZLECENIEZASOB + '_UZ_AU_ID'+','+
                                                         sZLEZLECENIEZASOB + '_DATA_AU');
            with oInsertQuery do begin
              ParamByName(sZLEZLECENIEZASOB_ID).DataType := ftInteger;
              ParamByName(sZLEZLECENIE_ID).DataType := ftInteger;
              ParamByName(sZLEZASOB_ID).DataType := ftInteger;
              ParamByName(sZLEZLECENIEZASOB + '_UZ_AU_ID').DataType := ftInteger;
              ParamByName(sZLEZLECENIEZASOB + '_DATA_AU').DataType := ftDate;
              ParamByName(sZLEZLECENIEZASOB_ID).AsInteger := UniqueKey[sZLEZLECENIEZASOB];
              ParamByName(sZLEZLECENIE_ID).AsInteger := StrToInt(sZlecID);
              ParamByName(sZLEZASOB_ID).AsInteger := ActiveQuery.FieldByName(sZLEZASOB_ID).AsInteger;
              ParamByName(sZLEZLECENIEZASOB + '_UZ_AU_ID').AsInteger := SecurityManager.UserId;
              ParamByName(sZLEZLECENIEZASOB + '_DATA_AU').AsDateTime := UNINow;
            end;
            SQLManager.InsertQueryStep2( oInsertQuery, '' );

        end;

        if ZLEDM.vZLEWysylanieRozliczECPWlaczone and (ActiveQuery.FieldByName(sKDOSOBA_ID).AsInteger > 0) then begin
          iZLEZasobyPracaID := ActiveQuery.FieldByName(sZLEZASOBYPRACA_ID).AsInteger;
          iOsobaID          := ActiveQuery.FieldByName(sKDOSOBA_ID).AsInteger;
          dOd               := ActiveQuery.FieldByName(sZLEZASOBYPRACA_DATA).AsDateTime;
          iSkladnikCzasuID  := ActiveQuery.FieldByName(sKDSKLADNIKCZASU_ID).AsInteger;

          if ZLEDM.vZLEFormatGodzinLiczba then
               iGodziny := Trunc(60.0 * ActiveQuery.FieldByName(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat)
          else iGodziny := Trunc(ActiveQuery.FieldByName(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat);
        end;

        inherited;

        if ZLEDM.vZLEWysylanieRozliczECPWlaczone and (ActiveQuery.FieldByName(sKDOSOBA_ID).AsInteger > 0) then begin
           UzupelnijListaPK(iZLEZasobyPracaID);
           bPrzerwijZapis := Dopisz_Do_ECP(iZLEZasobyPracaID, iOsobaID, iGodziny, dOd, iSkladnikCzasuID);
        end;
      end else begin //Zmien
        sListaRozliczID := '';
        if (Owner as TUNIDBDetailForm).Parameters.Values[cZLERozliczenieZasobow] = sUNICONST_ALTERNATYWA_TAK then begin
          sWhere := '('+sZLEZLECENIEPOZ_ID+'='+ActiveQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsString+')and'+
                    '('+sZLEZASOBYPRACA_CZAS_PRACY+'=0.0)';
          qLista := SQLManager.CreateQuery('SELECT ' + sZLEZASOBYPRACA_ID + ' ' +
                                           'FROM %s ' +
                                           'WHERE ' + sWhere,
                                           [sZLEZASOBYPRACA]);
          try
            qLista.Open();
            if not qLista.IsEmpty() then begin
               while not qLista.Eof do begin
                 if sListaRozliczID <> '' then sListaRozliczID := sListaRozliczID + ',';
                 sListaRozliczID := sListaRozliczID + IntToStr(qLista.FieldByName(sZLEZASOBYPRACA_ID).AsInteger);
                 qLista.Next;
               end;
            end;
          finally
            if qLista <> nil then FreeAndNil(qLista);
          end;
        end else begin//zmiana rozliczonych pozycji
          if (Owner.Owner is TUNIDBGridForm)and
             (Length((Owner.Owner as TUNIDBGridForm).DBGrid.MarkedRows) > 0) then begin
             sWhere := sZLEZASOBYPRACA_ID+' in ('+ Andy( (Owner.Owner as TUNIDBGridForm).DBGrid.MarkedRows, ',')+')';
             sListaRozliczID := Andy( (Owner.Owner as TUNIDBGridForm).DBGrid.MarkedRows, ',');
          end else begin
             sWhere := sZLEZASOBYPRACA_ID+'='+(Owner.Owner as TUNIDBGridForm).DMAQFbN(sZLEZASOBYPRACA_ID).AsString;
             sListaRozliczID := (Owner.Owner as TUNIDBGridForm).DMAQFbN(sZLEZASOBYPRACA_ID).AsString;
          end;
        end;

        if ZLEDM.vZLEWysylanieRozliczECPWlaczone and (sListaRozliczID <> '') then begin
          qDane := SQLManager.CreateQuery('SELECT ' +
                                              sZLEZASOBYPRACA_ID + ', ' +
                                              sKDOSOBA_ID + ', ' +
                                              sZLEZASOBYPRACA_DATA + ', ' +
                                              sZLEZASOBYPRACA_CZAS_PRACY + ' ' +
                                           'FROM %s ' +
                                           'WHERE ' + sZLEZASOBYPRACA_ID + ' IN (' + sListaRozliczID + ')',
                                           [sZLEZASOBYPRACA]);
          try
            qDane.Open();
            if not qDane.IsEmpty() then begin
               while not qDane.Eof do begin
                 UzupelnijListaPK(qDane.FieldByName(sZLEZASOBYPRACA_ID).AsInteger);
                 iOsobaOldID       := qDane.FieldByName(sKDOSOBA_ID).AsInteger;
                 iZLEZasobyPracaID := qDane.FieldByName(sZLEZASOBYPRACA_ID).AsInteger;
                 iOsobaID          := iOsobaOldID; //ActiveQuery.FieldByName(sKDOSOBA_ID).AsInteger;
                 dOd               := ActiveQuery.FieldByName(sZLEZASOBYPRACA_DATA).AsDateTime;
                 iSkladnikCzasuID  := ActiveQuery.FieldByName(sKDSKLADNIKCZASU_ID).AsInteger;

                 if ZLEDM.vZLEFormatGodzinLiczba then
                      iGodziny := Trunc(60.0 * ActiveQuery.FieldByName(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat)
                 else iGodziny := Trunc(ActiveQuery.FieldByName(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat);

                 bPrzerwijZapis := Usun_Z_ECP(iZLEZasobyPracaID, iOsobaOldID);
                 if not bPrzerwijZapis then begin
                   bPrzerwijZapis := Dopisz_Do_ECP(iZLEZasobyPracaID, iOsobaID, iGodziny, dOd, iSkladnikCzasuID);
                   if bPrzerwijZapis then Break;
                 end else Break;

                 qDane.Next;
               end;
            end;
          finally
            if qDane <> nil then FreeAndNil(qDane);
          end;
        end;

        if not bPrzerwijZapis then begin
          sListaPol := sZLEZASOBYPRACA_DATA+','+
                       sUNIOKRES_ID+','+
                       sZLEZASOBYPRACA_CZAS_PRACY+','+
                       sZLEZASOBYPRACA_CZAS_PRACY_NOM+','+
                       sZLEZASOBYPRACA_UZ_ZM_ID+','+
                       sZLEZASOBYPRACA_DATA_ZM;

          if ZLEDM.vZLERozliczAktStawka then
             sListaPol := sListaPol + ',' + sZLEZASOBYPRACA_STAWKA;

          if ZLEDM.vZLEZlecenieRozl_ZuzPaliwa then
             sListaPol := sListaPol + ',' + sZLEZASOBYPRACA_ZUZ_PALIWA;

          if ZLEDM.vZLEWysylanieRozliczECPWlaczone then
             sListaPol := sListaPol + ',' + sKDSKLADNIKCZASU_ID;

          oUpdateQuery := SQLManager.UpdateQueryStep1(sZLEZASOBYPRACA,
                                                      sListaPol,
                                                      sWhere );
          with oUpdateQuery do begin
            ParamByName(sZLEZASOBYPRACA_DATA).AsDate := ActiveQuery.FieldByName(sZLEZASOBYPRACA_DATA).AsDateTime;
            ParamByName(sUNIOKRES_ID).AsInteger := ActiveQuery.FieldByName(sUNIOKRES_ID).AsInteger;
            ParamByName(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat := ActiveQuery.FieldByName(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat;
            ParamByName(sZLEZASOBYPRACA_CZAS_PRACY_NOM).AsFloat := ActiveQuery.FieldByName(sZLEZASOBYPRACA_CZAS_PRACY).AsFloat;

            {W zalenosci od parametrw}
            if ZLEDM.vZLERozliczAktStawka then
               ParamByName(sZLEZASOBYPRACA_STAWKA).AsFloat := ActiveQuery.FieldByName(sZLEZASOBYPRACA_STAWKA).AsFloat;

            if ZLEDM.vZLEZlecenieRozl_ZuzPaliwa then
               ParamByName(sZLEZASOBYPRACA_ZUZ_PALIWA).AsFloat := ActiveQuery.FieldByName(sZLEZASOBYPRACA_ZUZ_PALIWA).AsFloat;

            if ZLEDM.vZLEWysylanieRozliczECPWlaczone then
               ParamByName(sKDSKLADNIKCZASU_ID).AsInteger := ActiveQuery.FieldByName(sKDSKLADNIKCZASU_ID).AsInteger;

            ParamByName(sZLEZASOBYPRACA_UZ_ZM_ID).AsInteger := SecurityManager.UserId;
            ParamByName(sZLEZASOBYPRACA_DATA_ZM).AsDateTime := UNINow;
          end;
          SQLManager.UpdateQueryStep2( oUpdateQuery );
        end;
      end;
    end else begin
      inherited;
    end;

    if slRaportBledow <> nil then FreeAndNil(slRaportBledow);

    {if bPrzerwijZapis then begin
       Komunikat(cError, 'Wystpi bd podczas zapisu danych'#13+
                         'Dane nie zostan zapamitane');
    end;}
    if bTrans and (not bPrzerwijZapis) then SQLManager.Commit
    else if bTrans and bPrzerwijZapis then SQLManager.Rollback;
  except
    Komunikat(cError, 'Wystpi bd podczas zapisu danych'#13+
                      'Dane nie zostan zapamitane');
    if bTrans then SQLManager.Rollback;
    if slRaportBledow <> nil then FreeAndNil(slRaportBledow);
  end;
end;

procedure TZLEZlecenieRozlDataModule.ReOpenDataSets;
begin
  SetParameters();
  inherited;
end;

procedure TZLEZlecenieRozlDataModule.ResetConditions;
begin
  idcZlecenie := -1;
  idjZlecenie := -1;
  idcAsortyment := -1;
  idjAsortyment := -1;
  idcSprawa := -1;
  idjSprawa := -1;
  idcZasobZLE := -1;
  idjZasobZLE := -1;
  idcZasobZLERodzaj := -1;
  idcDataRozliczeniaOd := -1;
  idcDataRozliczeniaDo := -1;
  idcDataOtwarciaOd := -1;
  idcDataOtwarciaDo := -1;
end;

procedure TZLEZlecenieRozlDataModule.SetADMIDJoinOnField(const iFun: Integer;
  var iCondIndex: Integer; sFieldName: String);
const cADMID = 'ADMID%d';
var
  oIDs_List: TStringList;
  sCorrel1, sCorrel2, sCondition: String;
  iPFun: Integer;
  sRangeClassName: String;
begin
  iPFun := (Owner as TUNIDBGridForm).RangePodFunc;
  sRangeClassName := (Owner as TUNIDBGridForm).RangeClassName;
  oIDs_List := ADMID_CreateAndLoad( iFun, iPFun, SecurityManager.UserId,
                                    sRangeClassName );
  try
    sCorrel1 := Copy( sFieldName, 1, Pos( '.', sFieldName )-1 );
    sCorrel2 := Format(cADMID, [iFun]);
    //dodanie tabeli
    if GridTabDefs.IndexOf( sCorrel2 ) = -1 then
      GridTabDefs.Add( sCorrel2, sADMID );
    //dodanie/wyczenie zczenia
    if GridJoinDefs.IndexOfCorrel2( sCorrel2 ) = -1 then
      GridJoinDefs.AddSimple( sCorrel1, sCorrel2, sFieldName+'='+sCorrel2+'.'+sADMID_V, qjkInner, oIDs_List.Count > 0 )
    else
      GridJoinDefs.Items[ GridJoinDefs.IndexOfCorrel2( sCorrel2 ) ].Required := oIDs_List.Count > 0;
    //dodanie/podmienienie warunku
    sCondition := '('+sCorrel2+'.'+sADMID_FUNK+'='+IntToStr(iFun)+')and'+
                  '('+sCorrel2+'.'+sADMID_PFUNK+'='+IntToStr(iPFun)+')and'+
                  '('+sCorrel2+'.'+sSMUSER_ID+'='+IntToStr(SecurityManager.UserId)+')and'+
                  '('+sCorrel2+'.'+sADMID_KONTEKST+'='+QuotedStr(sRangeClassName)+')';
    if iCondIndex = -1 then
      iCondIndex := GridJoinDefs.AddCondition( sCondition, oIDs_List.Count > 0 )
    else
      GridJoinDefs.ExchangeCondition( iCondIndex, sCondition, oIDs_List.Count > 0 );
  finally
    oIDs_List.Free;
  end;
end;

procedure TZLEZlecenieRozlDataModule.SetDisplayFormat;
begin
  inherited;
  if ListQuery.FindField(sASOASORT_INDEKS) <> nil then
    ListQuery.FieldByName(sASOASORT_INDEKS).EditMask := ASODM.vAsoMaskaIndeksu+';0;_';
end;

procedure TZLEZlecenieRozlDataModule.SetParameters;
var
  dData: TDate;
begin
  if (Owner as TUNIForm).FormIsContained then begin
    if idcZlecenie = -1 then
      idcZlecenie := GridJoinDefs.AddEmptyCondition();
    if (Owner as TUNIForm).Parameters.Values[sZLEZLECENIE_ID] <> '' then
      GridJoinDefs.ExchangeCondition( idcZlecenie, 'PZ.'+sZLEZLECENIE_ID+'='+(Owner as TUNIForm).Parameters.Values[sZLEZLECENIE_ID], True );
  end else begin
    if idcZasobZLERodzaj = -1 then
      idcZasobZLERodzaj := GridJoinDefs.AddEmptyCondition();
    if idcDataRozliczeniaOd = -1 then
      idcDataRozliczeniaOd := GridJoinDefs.AddEmptyCondition();
    if idcDataRozliczeniaDo = -1 then
      idcDataRozliczeniaDo := GridJoinDefs.AddEmptyCondition();
    if idcDataOtwarciaOd = -1 then
      idcDataOtwarciaOd := GridJoinDefs.AddEmptyCondition();
    if idcDataOtwarciaDo = -1 then
      idcDataOtwarciaDo := GridJoinDefs.AddEmptyCondition();

    //ograniczenie na zlecenie
    SetADMIDJoinOnField( cADMIDFuncZLEZlecenie, idcZlecenie, 'PZ.'+sZLEZLECENIE_ID );
    //ograniczenie na asortyment
    SetADMIDJoinOnField( cADMIDFuncZLEAsortyment, idcAsortyment, 'PZ.'+sASOASORT_ID );
    if DataManagers.Available(sBOKModulID) then begin
      //ograniczenie na sprawa
      SetADMIDJoinOnField( cADMIDFuncZLESprawa, idcSprawa, 'PZ.'+sBOKSPRAWA_ID );
    end;
    //ograniczenie na zasb zlece
    SetADMIDJoinOnField( cADMIDFuncZLEZasobZLE, idcZasobZLE, 'Z.'+sZLEZASOB_ID );
    with (Owner as TUNIForm) do begin
      GridJoinDefs.ExchangeCondition( idcZasobZLERodzaj, 'Z.'+sZLEZASOB_RODZAJ+'='+QuotedStr(Parameters.Values[sParam_ZLEZasobRodzID]), Parameters.Values[sParam_ZLEZasobRodzID] <> '');
      dData := StrToIntDef(Parameters.Values[sParam_ZLEDataRozlOd],0);
      GridJoinDefs.ExchangeCondition( idcDataRozliczeniaOd, 'M.'+sZLEZASOBYPRACA_DATA+'>='+KonwertujDate2SQL(dData), dData <> 0);
      dData := StrToIntDef(Parameters.Values[sParam_ZLEDataRozlDo],0);
      GridJoinDefs.ExchangeCondition( idcDataRozliczeniaDo, 'M.'+sZLEZASOBYPRACA_DATA+'<='+KonwertujDate2SQL(dData), dData <> 0);
      dData := StrToIntDef(Parameters.Values[sParam_ZLEDataOtwOd],0);
      GridJoinDefs.ExchangeCondition( idcDataOtwarciaOd, 'ZLE.'+sZLEZLECENIE_DATA_OTW+'>='+KonwertujDate2SQL(dData), dData <> 0);
      dData := StrToIntDef(Parameters.Values[sParam_ZLEDataOtwDo],0);
      GridJoinDefs.ExchangeCondition( idcDataOtwarciaDo, 'ZLE.'+sZLEZLECENIE_DATA_OTW+'<='+KonwertujDate2SQL(dData), dData <> 0);
    end;
  end;
end;

initialization
  RegisterClass( TZLEZlecenieRozlDataModule );

end.
