unit ZLEZlecenieSANDBGridFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ZLEZlecenieDBGridFormUnit, ExtCtrls, UNIComponentsUnit, Db, DBTables,
  URDataSet, UniDesigner, Menus, StdCtrls, Grids, DBGrids, ComCtrls,
  DBCtrls, ToolWin, ActnList,
  UNIStaleUnit, UNIDataModuleUnit, UNIFormUnit, KeyManagerUnit,
  SANDefUnit;

type
  TZLEZlecenieDBGridForm_SAN = class(TZLEZlecenieDBGridForm)
    FunkcjeZbioroweActionList: TUNIActionList;
    WystawFaktureAction: TAction;
    FunkcjeZbioroweAction: TAction;
    WystawFakturePopupMenuItem: TMenuItem;
    FunkcjeZbioroweMenuItem: TMenuItem;
    WystawFaktureMenuItem: TMenuItem;
    ZleceniePWPanel: TUNIPanel;
    ButtonZleceniePWPanel: TUNIPanel;
    ZleceniePWButton: TUNIButton;
    ZleceniePWAction: TAction;
    PotwierdzeniaWywozuMenuItem: TMenuItem;
    ZmienStatusZleceniaMenuItem: TMenuItem;
    procedure WystawFaktureActionExecute(Sender: TObject);
    procedure PozycjeButtonClick(Sender: TObject);
    procedure ZleceniePWActionExecute(Sender: TObject);
    procedure ZmienStatusZleceniaMenuItemClick(Sender: TObject);
  private
    FZleceniePWFormIndex:   integer;

    procedure FunkcjaZbiorowa( const oFunkcja: TFunkcjaZbiorowa );
  protected
    procedure AddContainedForms(); override;
    procedure WylaczPaneleInformacji(); override;

    procedure InitializeObjectFields(); override;
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    function OpenRangeForm( bWymusWyswietlenie: boolean = True): boolean; override;
    procedure SetUserRights(); override;

    procedure GetPositionAndParentForContainedForm( const nr: Integer;
                                                    var APosition: TRect;
                                                    var AParent: TWinControl;
                                                    var AAlign: TAlign); override;
  public
    procedure RefreshDetail( bWymus: Boolean = False; iFormIndex: Integer = -2); override;

    procedure GetParametersForForm( AForm: TUNIForm; Parameters: TKeyValues ); override;
  end;

  TZLEZlecenieDBGridForm_SANOdbiorcy = class(TZLEZlecenieDBGridForm_SAN)
  private
  protected
    procedure InitializeObjectFields(); override;
  public
  end;

  TZLEZlecenieDBGridForm_SANFakturowanie = class(TZLEZlecenieDBGridForm_SAN)
  private
  protected
    procedure InitializeControls(); override;
    procedure InitializeObjectFields(); override;
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure SetUserRights(); override;
  public
  end;

implementation

uses
  Dodatki,
  FormManagerUnit,
  SecurityManagerUnit,
  UNIDBGridFormUnit,
  BKDefUnit,
  SANDataManagerExtUnit,
  UNISYSDefUnit,
  ZLEDefUnit,
  ZLEZlecenieUnit;

{$R *.DFM}

{ TZLEZlecenieDBGridForm_SAN }

procedure TZLEZlecenieDBGridForm_SAN.AddContainedForms;
var
  oForm: TUNIDBGridForm;
begin
  inherited;

  //zlecenia - potwierdzenia wywozu
  FZleceniePWFormIndex := FContainedForms.Count;
  oForm := SANDM.SANPokazIObsluzDaneGrid( Self, sSANPW, '', '', True, True,
                                          omList or omMultiSelect or omContained,
                                          cZLEMODULZSI_ID, 0, vAktywnaFirma,
                                          TKeyValues.CreateFromLine( sSANTrybPWDBGridForm+'='+sSANTrybPWDBGridForm_Zlecenia ) );
{  oForm := FormManager.OpenDBGrid( Self, cKlasaPW+cSuffixKlasyDBGrid,
                                   omList or omMultiSelect or omContained,
                                   TKeyValues.CreateFromLine( sSANTrybPWDBGridForm+'='+sSANTrybPWDBGridForm_Zlecenia ));}
  FContainedForms.AddObject( 'Potwierdzenia wywozu', oForm );
end;

function TZLEZlecenieDBGridForm_SAN.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLEZlecenieDataModule_SAN.CreateOpen( Self, DefaultMasterKeyValues, AOpenMode );
end;

procedure TZLEZlecenieDBGridForm_SAN.FunkcjaZbiorowa(
  const oFunkcja: TFunkcjaZbiorowa);
var
  sMsg: String;
begin
  if Length(Self.DBGrid.MarkedRows) = 0 then begin
      Self.DBGrid.Mark();
  end;
  sMsg := oFunkcja( Self, Self.DBGrid.MarkedRows, nil, fzZlecenie );
  Self.DBGrid.UnMarkAll();
  if Length(sMsg) > 0 then begin
    Komunikat( cInformation, sMsg );
  end;
end;

procedure TZLEZlecenieDBGridForm_SAN.GetParametersForForm(AForm: TUNIForm;
  Parameters: TKeyValues);
begin
  inherited;
  if FormIsContained then begin
    if (Parameters <> nil) then begin
      Parameters.Values[sParam_ZLEKlientID] := (Owner as TUNIForm).Parameters.Values[sBKKLIENT_ID];
      Parameters.Values[sZLEZLECENIE_WYKONAWCA_ID] := (Owner as TUNIForm).Parameters.Values[sBKKLIENT_ID];
    end;
  end;
end;

procedure TZLEZlecenieDBGridForm_SAN.GetPositionAndParentForContainedForm(
  const nr: Integer; var APosition: TRect; var AParent: TWinControl;
  var AAlign: TAlign);
begin
  if(nr = FZleceniePWFormIndex) then begin
    ZleceniePWPanel.Align := alClient;
    AParent   := ZleceniePWPanel;
    APosition := ZleceniePWPanel.ClientRect;
    AAlign    := alClient;
  end else
    inherited;
end;

procedure TZLEZlecenieDBGridForm_SAN.InitializeObjectFields;
begin
  inherited;
  bPrzyciskiWlaczone := True;
  bPrzyciskPozycjiWlaczony := True;
  bPolaUzWlaczone := True;
end;

function TZLEZlecenieDBGridForm_SAN.OpenRangeForm(
  bWymusWyswietlenie: boolean): boolean;
begin
  if FormIsContained then
    result := True
  else
    result := inherited OpenRangeForm(bWymusWyswietlenie);
end;

procedure TZLEZlecenieDBGridForm_SAN.WylaczPaneleInformacji;
begin
  inherited;
  ZleceniePWPanel.Visible := False;
  ZleceniePWAction.Checked := False;

  ZleceniePWButton.Font.Style := [];
end;

procedure TZLEZlecenieDBGridForm_SAN.RefreshDetail(bWymus: Boolean;
  iFormIndex: Integer);
begin
  inherited;
  //PW
  if  (PrzyciskiWlaczone or ZleceniePWButton.Enabled) and (ZleceniePWPanel.Visible or (iFormIndex = FZleceniePWFormIndex)) then begin
    if ZleceniePWPanel.Visible then begin
       (ContainedForms[FZleceniePWFormIndex] as TUNIDBGridForm).Visible := True;
       RazemPanel.Visible := False;
    end;

    if bWymus or (Parameters.Values[sZLEZLECENIE_ID] <> Self.DMAQFbN(sZLEZLECENIE_ID).AsString) then begin
      Parameters.Values[sZLEZLECENIE_ID] := Self.DMAQFbN(sZLEZLECENIE_ID).AsString;
      Self.DataModule.ContainedDataModules[FZleceniePWFormIndex].ReOpenDataSets();
    end;
  end;
end;

{ TZLEZlecenieDBGridForm_SANFakturowanie }

function TZLEZlecenieDBGridForm_SANFakturowanie.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLEZlecenieDataModule_SANFakturowanie.CreateOpen( Self, DefaultMasterKeyValues, AOpenMode );
end;

procedure TZLEZlecenieDBGridForm_SANFakturowanie.InitializeControls;
begin
  inherited;
  FunkcjePanel.Visible := False;
end;

procedure TZLEZlecenieDBGridForm_SAN.SetUserRights;
begin
  inherited;
  with SecurityManager do begin
    FunkcjeZbioroweAction.Enabled := SM_UserCanDo(sSAN_FAKTUR);
    WystawFaktureAction.Enabled := SM_UserCanDo(sSAN_FAKTUR);
    ZleceniePWAction.Enabled := SANDM.SANSecurity_AllowAnyPWAll();
  end;
end;

procedure TZLEZlecenieDBGridForm_SAN.WystawFaktureActionExecute(
  Sender: TObject);
begin
  inherited;
  FunkcjaZbiorowa(SANDM.SANFakturowanie);
end;

procedure TZLEZlecenieDBGridForm_SANFakturowanie.InitializeObjectFields;
begin
  inherited;
  bPrzyciskiWlaczone := False;
  bPrzyciskPozycjiWlaczony := False;
end;

procedure TZLEZlecenieDBGridForm_SANFakturowanie.SetUserRights;
begin
  inherited;
  with SecurityManager do begin
    FunkcjeZbioroweAction.Visible := False;
    WystawFaktureAction.Enabled := False;
  end;
end;

procedure TZLEZlecenieDBGridForm_SAN.PozycjeButtonClick(Sender: TObject);
begin
  PozycjeMenuItem.Click;
end;

procedure TZLEZlecenieDBGridForm_SAN.ZleceniePWActionExecute(
  Sender: TObject);
begin
  AktywujFunkcje( ZleceniePWButton, ZleceniePWPanel, nil, ZleceniePWAction );
end;

procedure TZLEZlecenieDBGridForm_SAN.ZmienStatusZleceniaMenuItemClick(
  Sender: TObject);
begin
  ZmienStatus();
end;

{ TZLEZlecenieDBGridForm_SANOdbiorcy }

procedure TZLEZlecenieDBGridForm_SANOdbiorcy.InitializeObjectFields;
begin
  inherited;
  bPrzyciskiWlaczone := False;
  bPrzyciskPozycjiWlaczony := False;
end;

initialization
  FormManager.RegisterForm( TZLEZlecenieDBGridForm_SAN, 'Lista zlece Sanipor', sZLEModulID );
  FormManager.RegisterForm( TZLEZlecenieDBGridForm_SANOdbiorcy, 'Lista zlece Sanipor odbiorcy', sZLEModulID );
  FormManager.RegisterForm( TZLEZlecenieDBGridForm_SANFakturowanie, 'Lista zlece Sanipor fakturowanie', sZLEModulID );
end.
