unit ZLEZlecenieUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-24 gdeyk    Utworzone
2005-12-21 Tomjen   Pola Uzytkownika
2007-07-25 Adam     Przystosowanie do wsppracy z zapotrzebowaniami
2008-02-18 Adam     Zmieniony typ pola LWPRECEPTURA_OPIS na CLOB
2008-05-15 Adam     Przygotowywanie i wysyanie danych zlecenia do partnera
2008-06-17 Adam     Zapisywanie id systemu obcego po wysaniu zlecenia do partnera
2008-07-25 Adam     Dodane wysyanie zasobw na ktrych ma by realizowana dana pozycja receptury
2008-09-05 Adam     Dodane pole czy dane zlecenie zostao ju wysane do systemu partnera
2008-09-16 Adam     Rzutowanie CLOBA na VARCHAR2(250) aby nie byo problemw z Blobs to cache
2008-09-30 Adam     Rzutowanie CLOBA na VARCHAR2 przy uyciu funkcji RzutujCLOBNaVarchar2
2009-10-06 Adam     Dodana kolumna wskazujca czy zlecenie zostao bdnie wysane
2010-05-21 Adam     Moliwo wysyania do partnera wybranych elementw planu produkcji
2012-03-23 Adam     Moliwo dopisywania materiaw do zlece nieprodukcyjnych
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables, DbClient, Math, KeyManagerUnit,
  QueryBuilderUnit,UNIDBConstComboBoxUnit, UNIStaleUnit;

type
  TZLEZlecenieDataModule = class(TUNIDataModule)
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
  private
    iZakresConditionIdx: Integer;
    procedure UstawZakres(); virtual;
    procedure DopiszWartosciKryterium;
    procedure PoprawSymbolZKryterium(sKrytPozSymbolOld: string);
    function  PodajKrytPozSymbolOld: string;
    procedure JoinOnField(const iFun: Integer; sFieldName: String; var sConditions: String);
{
    function  PrzygotujDaneZleceniaProdDoWyslania(
                          const ac_sZlecenieId: string
              ):  string;
    procedure WyslijDane(
                          const ac_sDane:       string;
                          const ac_iOperacjaId: integer
              );
}

  protected
    iMnemonikZLEID: Integer;

    procedure GetKeys; override;
    function GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;
    procedure SetDisplayFormat; override;

  public
    procedure Post; override;
    procedure Delete; override;
    constructor Create( AOwner: TComponent); override;
    procedure OpenDataSets(); override;
    procedure ReOpenDataSets(); override;
  end;

  TZLEZlecenieDataModule_SAN = class(TZLEZlecenieDataModule)
  private
    procedure UstawZakres(); override;
  end;

  TZLEZlecenieDataModule_SANFakturowanie = class(TZLEZlecenieDataModule_SAN)
  private
    idcZlecFakt: Integer;
    procedure UstawZakres(); override;
  public
    constructor Create( AOwner: TComponent); override;
  end;

implementation

{$R *.DFM}

uses
  Dodatki,
  FormManagerUnit,
  SQLManagerUnit,
  SystemDefUnit,
  SecurityManagerUnit,
  UNIDBFormUnit,
  UNIFormUnit,
  UNIDBDetailFormUnit,
  UNIDBGridFormUnit,
  UNISysDefUnit,
  UNIDataManagerUnit,
  UNISysDataManagerUnit,
  ZLEDataManagerUnit,
  BOKDefUnit,
  KDDefUnit,
  FKDefUnit,
  BKDefUnit,
  SPDefUnit,
  LFKDefUnit,
  SPDataManagerExtUnit,
  ZLEDefUnit,
  MAGDefUnit,
  UniqueKeyUnit,
  KDECPDefUnit,
  KDECPDataManagerExtUnit,
  BOKDataManagerExtUnit,
  ZLETypZleceniaDBDetailFormUnit,
  ZLEZlecenieDBDetailFormUnit,
  ZLEZlecenieDBGridFormUnit,
  ZLEZaangazowaniDBDetailFormUnit,
  UNIINTDataManagerExtUnit,
  LWPDataManagerExtUnit,
  FKDataManagerUnit,
  MSXML2_TLB,
  UNIXMLParserUnit,
  UNIINTKomunikatyUnit,
  //ZLEKontrolaRealizacjiDBDetailFormUnit,
  ZAODefUnit,
  ZAMDefUnit,
  ASODefUnit,
  LWPDefUnit,
  INFDefUnit,
  UNIINTDefUnit;

{ TZLEZlecenieDataModule }
constructor TZLEZlecenieDataModule.Create(AOwner: TComponent);
var
  oQuery : TUNIQuery;
begin
  inherited;
  DataModuleCreate(Self);
  iZakresConditionIdx := -1;

  iMnemonikZLEID := -1;
  oQuery := SQLManager.CreateQuery('SELECT ' + sFKMNEMONIKI_ID +
                                  ' FROM %s ' +
                                  ' WHERE ' + sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr(sMnemonikZlecenie) + ' AND ' +
                                  sFKMNEMONIKI_INDEKS + ' = 0',
                                  [sFKMNEMONIKI]);

  try
    if oQuery <> nil then begin
      oQuery.Open;
      if not oQuery.IsEmpty then
        iMnemonikZLEID := oQuery.FieldByName(sFKMNEMONIKI_ID).AsInteger;
    end;
  finally
     if oQuery <> nil then FreeAndNil(oQuery);
  end;
end;

procedure TZLEZlecenieDataModule.SetDisplayFormat;
begin
  inherited;
  if ZLEDM.vZLEMaskaSymboluWlaczona and
     (ZLEDM.vZLEMaskaSymbolu <> '') and
     (ListQuery.FindField(sZLEZLECENIE_SYMBOL) <> nil) then begin
    ListQuery.FindField(sZLEZLECENIE_SYMBOL).EditMask := ZLEDM.vZLEMaskaSymbolu+';0;_';
  end;
end;

procedure TZLEZlecenieDataModule.Delete;
var
  bTrans: Boolean;
  iZLEZLECENIE_ID: Integer;
  sIlosc : String;
  sSymbolZlec : String;
  iFirmaID, i, j: integer;

  {Zmienne na potrzeby zmian statusu Spraw}
  iZlecenieID                             : Integer;
  vZLEListaSprawZlecenPo                  : TUNIQuery;
  sZLEListaSprawPrzed, sZLEListaSprawPo,
  sZleStatusPrzed, sZleStatusPo, sSQL     : String;

  bWszystkieAnulowane,
  bWszystkieOczekujace,
  bWszystkieWstrzymane,
  bWszystkieZakonczone                    : Boolean;
  iAktSprawa                              : Integer;
  sAktStatusSprawy                        : String;
{$ifndef build_all}
//  sDane:      string;
{$endif}
begin
  iZlecenieID := 0;
  bTrans := SQLManager.InTransaction;
  if not bTrans then SQLManager.StartTransaction;
  try

{$ifndef build_all}
{ !!! Wyczamy na razie wysyanie zlece on-line (podczas edycji i dopisywania)
    if(DataManagers.Available(sUNIINTModulID) and
    (Owner as TZLEZlecenieDBDetailForm).ZlecenieProdukcyjne and
    UNIINTDM.CzyOperacjaAktywna(cUNIINTOperacja_ZlecenieProdUsun_Id)) then
      sDane := PrzygotujDaneZleceniaProdDoWyslania(ActiveQuery.FieldByName(sZLEZLECENIE_ID).AsString);
}
{$endif}

    sSymbolZlec     := DataSource.DataSet.FieldByName(sZLEZLECENIE_Symbol).AsString;
    iZLEZLECENIE_ID := DataSource.DataSet.FieldByName(sZLEZLECENIE_ID).AsInteger;

    if DataManagers.Available(sMAGModulID) then begin
      if iZLEZLECENIE_ID > 0 then begin
         try
           sIlosc := SQLManager.OpenQueryWithResult('SELECT COUNT(*) FROM %s WHERE ' + sZLEZLECENIE_ID + '=' +
                                    IntToStr(iZLEZLECENIE_ID), [sMAGModulID + cMAGOBRPOZ_SUFFIX]);
         finally
            if StrToInt(sIlosc) > 0 then begin
               Komunikat(cError, 'Zlecenie zostao wykorzystane w dokumencie magazynowym.'#13'Usunicie niemoliwe!');
               Abort;
            end;
         end;
      end;
    end;

    if DataManagers.Available(sBOKModulID) then  begin
       iZlecenieID          := ActiveQuery.FieldByName(sZLEZLECENIE_ID).AsInteger;
       sZLEStatusPrzed      := SQLManager.OpenQueryWithResult('SELECT ' + sZLEZLECENIE_STATUS + ' ' +
                                                              'FROM %s ' +
                                                              'WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID),
                                                              [sZLEZLECENIE]);

       sZleListaSprawPrzed  := SQLManager.OpenQueryWithResult('SELECT %s.JoinStrings(CURSOR(' +
                                                              'SELECT DISTINCT ' + sBOKSPRAWA_ID + ' ' +
                                                              'FROM %s WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID) + ')) FROM DUAL',
                                                              ['DODATKI_PACKAGE', sZLEZLECENIEPOZ]);
    end;

    if(DataManagers.Available(sZAOModulID)) then begin
        // usunicie powizanych rekordw z ZAO
      if((TZLEZlecenieDBDetailForm(Owner).ZapotrzPierwFormIndex > -1)) then begin
        with ContainedDataModules[TZLEZlecenieDBDetailForm(Owner).ZapotrzPierwFormIndex] do begin
          ActiveQuery.First();
          while(not ActiveQuery.Eof) do begin
            Delete();
          end;  // while(not ActiveQuery.Eof)
          Post();
        end;  // with ContainedDataModules[TZLEZlecenieDBDetailForm(Owner).ZapotrzPierwFormIndex]
      end;  // if((TZLEZlecenieDBDetailForm(Owner).ZapotrzPierwFormIndex > -1))
      if((TZLEZlecenieDBDetailForm(Owner).ZapotrzWtorneFormIndex > -1)) then begin
        with ContainedDataModules[TZLEZlecenieDBDetailForm(Owner).ZapotrzWtorneFormIndex] do begin
          ActiveQuery.First();
          while(not ActiveQuery.Eof) do begin
            Delete();
          end;  // while(not ActiveQuery.Eof)
          Post();
        end;  // with ContainedDataModules[TZLEZlecenieDBDetailForm(Owner).ZapotrzWtorneFormIndex]
      end;  // if((TZLEZlecenieDBDetailForm(Owner).ZapotrzWtorneFormIndex > -1))
    end;  // if(DataManagers.Available(sZAOModulID))
    if(DataManagers.Available(sZAMModulID)) then begin
        // usunicie powizanych rekordw z ZAM
      if((TZLEZlecenieDBDetailForm(Owner).ZamowienieFormIndex > -1)) then begin
        with ContainedDataModules[TZLEZlecenieDBDetailForm(Owner).ZamowienieFormIndex] do begin
          ActiveQuery.First();
          while(not ActiveQuery.Eof) do begin
            Delete();
          end;  // while(not ActiveQuery.Eof)
          Post();
        end;  // with ContainedDataModules[TZLEZlecenieDBDetailForm(Owner).ZamowienieFormIndex]
      end;  // if((TZLEZlecenieDBDetailForm(Owner).ZamowienieFormIndex > -1))
        // usunicie powizanych rekordw z ZAM
      if((TZLEZlecenieDBDetailForm(Owner).ZapytanieFormIndex > -1)) then begin
        with ContainedDataModules[TZLEZlecenieDBDetailForm(Owner).ZapytanieFormIndex] do begin
          ActiveQuery.First();
          while(not ActiveQuery.Eof) do begin
            Delete();
          end;  // while(not ActiveQuery.Eof)
          Post();
        end;  // with ContainedDataModules[TZLEZlecenieDBDetailForm(Owner).ZapytanieFormIndex]
      end;  // if((TZLEZlecenieDBDetailForm(Owner).ZapytanieFormIndex > -1))
    end;  // if(DataManagers.Available(sZAMModulID))

    if(DataManagers.Available(sLWPModulID)) then begin
      if((TZLEZlecenieDBDetailForm(Owner).MaterialFormIndex > -1)) then begin
        with ContainedDataModules[TZLEZlecenieDBDetailForm(Owner).MaterialFormIndex] do begin
          ActiveQuery.First();
          while(not ActiveQuery.Eof) do begin
            Delete();
          end;  // while(not ActiveQuery.Eof)
          Post();
        end;  // with ContainedDataModules[TZLEZlecenieDBDetailForm(Owner).MaterialFormIndex]
      end;  // if((TZLEZlecenieDBDetailForm(Owner).MaterialFormIndex > -1))
      if((TZLEZlecenieDBDetailForm(Owner).ZasobyFormIndex > -1)) then begin
        with ContainedDataModules[TZLEZlecenieDBDetailForm(Owner).ZasobyFormIndex] do begin
          ActiveQuery.First();
          while(not ActiveQuery.Eof) do begin
            Delete();
          end;  // while(not ActiveQuery.Eof)
          Post();
        end;  // with ContainedDataModules[TZLEZlecenieDBDetailForm(Owner).ZasobyFormIndex]
      end;  // if((TZLEZlecenieDBDetailForm(Owner).ZasobyFormIndex > -1))
    end;  // if(DataManagers.Available(sLWPModulID))


    if (TZLEZlecenieDBDetailForm(Owner).m_oPolaUZGridy <> nil) then
       for i := 0 to TZLEZlecenieDBDetailForm(Owner).m_oPolaUZGridy.Count-1 do
       begin
         j := TZLEZlecenieDBDetailForm(Owner).FContainedForms.IndexOf(cPolaUzPrefiksZakladki + IntToStr(i));
         if(j > -1) then begin
            with ContainedDataModules[j] do begin
               ActiveQuery.First();
               while (not ActiveQuery.Eof) do begin
                 Delete();
               end;  // while(not ActiveQuery.Eof)
               Post();
            end;
         end;
       end;  // for i := 0 to m_oPolaUZGridy.Count-1

    if (TZLEZlecenieDBDetailForm(Owner).m_oZakladkiPozGridy <> nil) then
       for i := 0 to TZLEZlecenieDBDetailForm(Owner).m_oZakladkiPozGridy.Count-1 do
       begin
         j := TZLEZlecenieDBDetailForm(Owner).FContainedForms.IndexOf(cPolaUzPrefiksZakladki + IntToStr(gciZLEPolaUZPozIndeks + i));
         if(j > -1) then begin
            with ContainedDataModules[j] do begin
               ActiveQuery.First();
               while (not ActiveQuery.Eof) do begin
                 Delete();
               end;  // while(not ActiveQuery.Eof)
               Post();
            end;
         end;
       end;  // for i := 0 to oZakladkiPozId.Count-1

    inherited;

    iFirmaID := 0;
    if vWielofirmowosc then
      iFirmaID := vAktywnaFirma;

    if ((iMnemonikZLEID > 0) AND (sSymbolZlec <> '')) then
       UNISysDM.UNIUsunSymbolZKryt(iFirmaID, iMnemonikZLEID, sSymbolZlec);

    (Owner as TZLEZlecenieDBDetailForm).PostPictureChanges();

    {Aktualizacja statusw spraw powizanych ze zleceniem}
    if DataManagers.Available(sBOKModulID) then begin
       sZLEStatusPo := SQLManager.OpenQueryWithResult('SELECT ' + sZLEZLECENIE_STATUS + ' ' +
                                                      'FROM %s ' +
                                                      'WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID),
                                                      [sZLEZLECENIE]);

       sZleListaSprawPo := SQLManager.OpenQueryWithResult('SELECT %s.JoinStrings(CURSOR(' +
                                                              'SELECT DISTINCT ' + sBOKSPRAWA_ID + ' ' +
                                                              'FROM %s WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID) + ')) FROM DUAL',
                                                         ['DODATKI_PACKAGE', sZLEZLECENIEPOZ]);

       if (sZleListaSprawPo = '') and (sZleListaSprawPrzed = '') then begin
          {Nie zmieniamy statusw spraw - bo zlecenie nie ma powiazania ze sprawa}
       end else begin
          sSQL := 'SELECT ZP.' + sZLEZLECENIE_ID + ', ' +
                         'ZL.' + sZLEZLECENIE_STATUS + ', ' +
                         'ZP.' + sBOKSPRAWA_ID + ', ' +
                         'BS.' + sBOKSPRAWA_STATUS + ' ' +
                  'FROM %s ZP, %s ZL, %s BS ' +
                  'WHERE BS.' + sBOKSPRAWA_ID + ' = ZP.' + sBOKSPRAWA_ID + ' AND ' +
                        'ZP.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' AND ';

          if sZleListaSprawPrzed = '' then begin
             sSQL := sSQL +
                        '(ZP.' + sBOKSPRAWA_ID + ' IN (SELECT DISTINCT ' + sBOKSPRAWA_ID + ' ' +
                                                       'FROM %s WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID) + '))';

             sSQL := sSQL + ' ORDER BY ZP.' + sBOKSPRAWA_ID + ', BS.' + sBOKSPRAWA_STATUS;
             vZLEListaSprawZlecenPo := SQLManager.CreateQuery(sSQL, [sZLEZLECENIEPOZ, sZLEZLECENIE,
                                                                     sBOKSPRAWA, sZLEZLECENIEPOZ]);

          end else begin
             sSQL := sSQL +
                        '((ZP.' + sBOKSPRAWA_ID + ' IN (SELECT DISTINCT ' + sBOKSPRAWA_ID + ' ' +
                                                       'FROM %s WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID) + ')) OR ' +
                       '  (ZP.' + sBOKSPRAWA_ID + ' IN (' + sZleListaSprawPrzed + ')))';

             sSQL := sSQL + ' UNION ' +
                       'SELECT NULL, NULL, BS.' + sBOKSPRAWA_ID + ', BS.' + sBOKSPRAWA_STATUS + ' ' +
                       'FROM %s BS ' +
                       'WHERE (BS.' + sBOKSPRAWA_ID + ' IN (' + sZleListaSprawPrzed + ')) AND ' +
                             '(BS.' + sBOKSPRAWA_ID + ' NOT IN (SELECT DISTINCT ' + sBOKSPRAWA_ID +
                                                               ' FROM %s WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID) + ')) AND ' +
                             ' NOT EXISTS (SELECT ' + sBOKSPRAWA_ID +
                                         ' FROM %s WHERE ' + sBOKSPRAWA_ID + ' = BS.' + sBOKSPRAWA_ID + ') ';

             sSQL := sSQL + ' ORDER BY ' + sBOKSPRAWA_ID + ', ' + sBOKSPRAWA_STATUS;

             vZLEListaSprawZlecenPo := SQLManager.CreateQuery(sSQL, [sZLEZLECENIEPOZ, sZLEZLECENIE,
                                                                     sBOKSPRAWA, sZLEZLECENIEPOZ,
                                                                     sBOKSPRAWA, sZLEZLECENIEPOZ,
                                                                     sZLEZLECENIEPOZ]);

          end;

          try
            vZLEListaSprawZlecenPo.Open;

            bWszystkieAnulowane  := True;
            bWszystkieOczekujace := True;
            bWszystkieWstrzymane := True;
            bWszystkieZakonczone := True;
            iAktSprawa := -1;
            sAktStatusSprawy := '';
            while not vZLEListaSprawZlecenPo.Eof do begin
               if (iAktSprawa <> vZLEListaSprawZlecenPo.FieldByName(sBOKSPRAWA_ID).AsInteger) and
                  (iAktSprawa <> -1) then begin

                  {zapisanie statusu sprawy}
                  if bWszystkieOczekujace then begin
                     if sAktStatusSprawy <> sBOKCONST_SSTATUS_PRZYJETA_ID then
                        BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_PRZYJETA_ID, UNINow());
                  end else
                  if bWszystkieWstrzymane then begin
                     if sAktStatusSprawy <> sBOKCONST_SSTATUS_ZAWIESZONA_ID then
                        BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_ZAWIESZONA_ID, UNINow());
                  end else
                  if bWszystkieZakonczone then begin
                     if sAktStatusSprawy <> sBOKCONST_SSTATUS_ZAKONCZONA_ID then
                        BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_ZAKONCZONA_ID, UNINow());
                  end else
                  if bWszystkieAnulowane then begin
                     if sAktStatusSprawy <> sBOKCONST_SSTATUS_ANULOWANA_ID then
                        BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_ANULOWANA_ID, UNINow());
                  end else begin
                     if sAktStatusSprawy <> sBOKCONST_SSTATUS_REALIZOWANA_ID then
                        BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_REALIZOWANA_ID, UNINow());
                  end;

                  iAktSprawa       := vZLEListaSprawZlecenPo.FieldByName(sBOKSPRAWA_ID).AsInteger;
                  sAktStatusSprawy := vZLEListaSprawZlecenPo.FieldByName(sBOKSPRAWA_STATUS).AsString;

                  bWszystkieAnulowane  := (vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_AnulowaneID);
                  bWszystkieOczekujace := ((vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_OczekujaceID) or vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).IsNull);
                  bWszystkieWstrzymane := (vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_WstrzymaneID);
                  bWszystkieZakonczone := (vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_ZakonczoneID);
               end else begin

                  if (iAktSprawa = -1) then begin
                      iAktSprawa       := vZLEListaSprawZlecenPo.FieldByName(sBOKSPRAWA_ID).AsInteger;
                      sAktStatusSprawy := vZLEListaSprawZlecenPo.FieldByName(sBOKSPRAWA_STATUS).AsString;
                  end;

                  bWszystkieAnulowane  := bWszystkieAnulowane  and (vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_AnulowaneID);
                  bWszystkieOczekujace := bWszystkieOczekujace and ((vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_OczekujaceID) or vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).IsNull);
                  bWszystkieWstrzymane := bWszystkieWstrzymane and (vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_WstrzymaneID);
                  bWszystkieZakonczone := bWszystkieZakonczone and (vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_ZakonczoneID);
               end;

               vZLEListaSprawZlecenPo.Next;
            end;

            if iAktSprawa <> -1 then begin
               {Zapisanie statusu dla ostatniej sprawy}
               if bWszystkieOczekujace then begin
                  if sAktStatusSprawy <> sBOKCONST_SSTATUS_PRZYJETA_ID then
                     BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_PRZYJETA_ID, UNINow());
               end else
               if bWszystkieWstrzymane then begin
                  if sAktStatusSprawy <> sBOKCONST_SSTATUS_ZAWIESZONA_ID then
                     BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_ZAWIESZONA_ID, UNINow());
               end else
               if bWszystkieZakonczone then begin
                  if sAktStatusSprawy <> sBOKCONST_SSTATUS_ZAKONCZONA_ID then
                     BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_ZAKONCZONA_ID, UNINow());
               end else
               if bWszystkieAnulowane then begin
                  if sAktStatusSprawy <> sBOKCONST_SSTATUS_ANULOWANA_ID then
                     BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_ANULOWANA_ID, UNINow());
               end else begin
                  if sAktStatusSprawy <> sBOKCONST_SSTATUS_REALIZOWANA_ID then
                     BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_REALIZOWANA_ID, UNINow());
               end;
            end;
            vZLEListaSprawZlecenPo.Close;
          finally
            if vZLEListaSprawZlecenPo <> nil then FreeAndNil(vZLEListaSprawZlecenPo);
          end;
       end;
    end;

{$ifndef build_all}
{ !!! Wyczamy na razie wysyanie zlece on-line (podczas edycji i dopisywania)
    if(DataManagers.Available(sUNIINTModulID) and
    (Owner as TZLEZlecenieDBDetailForm).ZlecenieProdukcyjne and
    UNIINTDM.CzyOperacjaAktywna(cUNIINTOperacja_ZlecenieProdUsun_Id)) then
      WyslijDane(sDane, cUNIINTOperacja_ZlecenieProdUsun_Id);
}
{$endif}
    if not bTrans then SQLManager.Commit;
  except
    if not bTrans then SQLManager.Rollback;
    SysUtils.Abort;
  end;
end;

procedure TZLEZlecenieDataModule.GetKeys;
begin
  with FKeys do begin
    AddPrimary(sZLEZLECENIE_ID);
  end;
end;

function TZLEZlecenieDataModule.GetTableName: string;
begin
  result := sZLEZLECENIE;
end;

procedure TZLEZlecenieDataModule.InitializeGridQueryDefs;
var oQuery: TUNIQuery;
    sSQL: String;
begin
  {if GridColDefs.Count = 0 then}
   with GridColDefs do begin
    Clear();
    AddRequiredAndUnvisible( sZLEZLECENIE_ID, 'M', '', True );
    AddRequiredAndUnvisible( sZLEZLECENIE_PRZELICZ, 'M', '', True );
    AddRequired( sZLEZLECENIE_SYMBOL, 'M', 'Symbol', True, taLeftJustify, 150 );
    Add( sZLEZLECENIE_NAZWA, 'M', 'Nazwa', True, True, taLeftJustify, 200 );
    Add( sZLEZLECENIE_DATA_OTW, 'M', 'Data otwarcia', True, True, taLeftJustify, 150 );
    Add( sZLEZLECENIE_DATA_ZAMK, 'M', 'Data zamknicia', True, True, taLeftJustify, 150 );
    AddRequiredAndUnvisible( sZLETYPZLEC_ID, 'M', '', True );
    AddRequiredAndUnvisible( sUNIROK_ID, 'M', '', True );
    Add( sUNIRok_ROK_TEXT, 'R', 'Rok', True, True, taLeftJustify, 80 );
    Add( sZLETYPZLEC_SYMBOL, 'T', 'Symbol typu zlecenia', True, True, taLeftJustify, 150 );
    Add( sZLETYPZLEC_NAZWA, 'T', 'Nazwa typu zlecenia', True, True, taLeftJustify, 200 );
    AddRequiredAndUnvisible( sUNIODDZIAL_ID, 'M', '', True );
    AddRequiredAndUnvisible( sZLEZLECENIE_LICZNIK, 'M', '', True );
    if vWieloodzialowosc then begin
      Add( sUNIODDZIAL_Symbol, 'O', 'Oddzia', True, True, taLeftJustify, 100 );
      Add( sUNIODDZIAL_NAZWA, 'O', 'Nazwa oddziau', True, True, taLeftJustify, 200 );
    end else if vWielofirmowosc then begin
      Add( sUNIODDZIAL_SYMBOL, 'O', 'Firma', True, True, taLeftJustify, 100 );
      Add( sUNIODDZIAL_NAZWA, 'O', 'Nazwa firmy', True, True, taLeftJustify, 200 );
    end;

    AddRequiredAndUnvisible( sUNIJEDNOSTKAORG_ID, 'M', '', True );
    Add( sUNIJEDNOSTKAORG_SYMBOL, 'W', 'Jednostka organizacyjna', True, True, taLeftJustify, 100 );
    Add( sUNIJEDNOSTKAORG_NAZWA, 'W', 'Nazwa jednostki org.', True, True, taLeftJustify, 150 );

    {Kontrahent}
    AddRequiredAndUnvisible( sZLEZLECENIE_WYKONAWCA_ID, 'M', '', True );
    Add( sBKKLIENT_SYMBOL, 'BKKL', 'Kontrahent', True, omWidoczne, taLeftJustify, 100 );
    Add( sBKKLIENT_SKROT, 'BKKL', 'Skrt kontrahenta', True, omWidoczne, taLeftJustify, 100 );
    Add( sBKKLIENT_NAZWA, 'BKKL', 'Nazwa kontrahenta', True, omWidoczne, taLeftJustify, 150 );

    {Pojazdy i sprzt}
    AddRequiredAndUnvisible( sUNIPOJSP_ID, 'M', '', True );
    Add( sUNIPOJSP_SYMBOL, 'POJ', 'Pojazd/Sprzt', True, omWidoczne, taLeftJustify, 100 );
    Add( sUNIPOJSP_NAZWA,  'POJ', 'Nazwa pojazdu/sprztu', True, omWidoczne, taLeftJustify, 150 );

    {Obiekt infrastruktury na podstawie elementu remontow}
    {if DataManagers.Available(sINFModulID) then begin
      Add( SQLManager.GetSPName(sZLE_PACKAGE + '.' + sZLE_DajDaneObiektu) + '(M.' + sZLEZLECENIE_ID + ', ''S'')' + ';' + 'SYMBOL_OBIEKTU', '', 'Symbol obiektu inf.', False, True, taLeftJustify, 80, uftString);
      Add( SQLManager.GetSPName(sZLE_PACKAGE + '.' + sZLE_DajDaneObiektu) + '(M.' + sZLEZLECENIE_ID + ', ''N'')' + ';' + 'NAZWA_OBIEKTU', '', 'Nazwa obiektu inf.', False, True, taLeftJustify, 150, uftString);
    end;}
    AddRequiredAndUnvisible(sZLEZLECENIE_POZIOMINF, 'M', '' );
    AddRequiredAndUnvisible(sZLEZLECENIE_INF_ID, 'M', '' );
    if DataManagers.Available(sINFModulID) then begin
       Add( 'CAST('+SQLManager.GetSPName(sINF_DAJSYMBOLOBIEKTU)+'(M.'+sZLEZLECENIE_POZIOMINF+',M.'+sZLEZLECENIE_INF_ID+',' +QuotedStr('SYMBOL')+') AS VARCHAR2(100));SYMBOL_OBIEKTU',
            '', 'Symbol obiektu inf.', False, True, taLeftJustify, 80, uftClob);
       Add( 'CAST('+SQLManager.GetSPName(sINF_DAJSYMBOLOBIEKTU)+'(M.'+sZLEZLECENIE_POZIOMINF+',M.'+sZLEZLECENIE_INF_ID+',' + QuotedStr('NAZWA')+') AS VARCHAR2(250));NAZWA_OBIEKTU',
            '', 'Nazwa obiektu inf.', False, True, taLeftJustify, 120, uftClob);
    end;

    Add( sUNICONST_ALTERNATYWA_V+';'+sZLEZLECENIE_PRZELICZ+'_T', 'N1', 'Przelicz', True, True, taCenter, 50);

    oQuery := nil;
    sSQL := UNISysDM.UNIOdpytajODaneSQL( sFKMNEMONIKI, sFKAlias_Mnemoniki_Indeks + ';' + sFKAlias_Mnemoniki_Dlugosc,
                                         '(@'+sFKAlias_Mnemoniki_Mnemonik+'='+QuotedStr(sMnemonikZlecenie)+')and'+
                                         '(@'+sFKAlias_Mnemoniki_Dlugosc+'>0)',
                                         False, UNISysDM.vAktywnaFirma );
    try
      oQuery := SQLManager.CreateQuery( sSQL );
      oQuery.Open;
      if oQuery.Locate( sFKMNEMONIKI_INDEKS, 1, [] ) then
        Add( sZLEZLECENIE_POLE1, 'M', 'Pole 1', True, True, taLeftJustify, 150 );
      if oQuery.Locate( sFKMNEMONIKI_INDEKS, 2, [] ) then
        Add( sZLEZLECENIE_POLE2, 'M', 'Pole 2', True, True, taLeftJustify, 150 );
      if oQuery.Locate( sFKMNEMONIKI_INDEKS, 3, [] ) then
        Add( sZLEZLECENIE_POLE3, 'M', 'Pole 3', True, True, taLeftJustify, 150 );
    finally
      if oQuery <> nil then oQuery.Free;
    end;
    AddRequiredAndUnvisible( sZLEZLECENIE_GRUPA_ID, 'M', '', True  );
    Add( sZLEZLECENIE_SYMBOL+';'+sZLEZLECENIE_GRUPA_ID+'_T1', 'ZLEC', 'Zlecenie grupujce', True, True, taLeftJustify, 100 );
    Add( sZLEZLECENIE_NAZWA+';'+sZLEZLECENIE_GRUPA_ID+'_T2', 'ZLEC', 'Zlecenie grupujce', True, False, taLeftJustify, 150 );
    AddRequiredAndUnvisible( sUNIMODULZSI_ID, 'M', '', True  );
    Add( sUNIMODULZSI_KOD, 'MD', 'rdo', True, True, taLeftJustify, 200 );
    AddRequiredAndUnvisible( sZLEZLECENIE_OSOBA_ODP, 'M', '' );
    Add( sKDOSOBA_NAZWA+';'+sZLEZLECENIE_OSOBA_ODP+'_Nazwa', 'KD1', 'Osoba odpowiedzialna', True, True, taLeftJustify, 200 );

    AddRequiredAndUnvisible( sZLEZLECENIE_OSOBA_ZGLASZ, 'M', '' );
    Add( sKDOSOBA_NAZWA+';'+sZLEZLECENIE_OSOBA_ZGLASZ+'_Nazwa', 'KD5', 'Osoba zgaszajca', True, True, taLeftJustify, 200 );

    AddRequiredAndUnvisible( sZLEZLECENIE_UZ_AU_ID, 'M', '' );
    Add( {'SM.' +} sSMUSER_IMIE+ '||'+QuotedStr(' ')+'|| SM.'+sSMUSER_NAZWISKO+';'+sSMUSER_NAZWISKO, 'SM', 'Operator wprowadzajcy', True, True, taLeftJustify, 100 );

    AddRequiredAndUnvisible( sZLEZLECENIE_STATUS, 'M', '' );
    AddRequired( sZLECONST_STATUS_V, 'ST', 'Status', True, taLeftJustify, 100 );
    AddRequiredAndUnvisible( sZLEZLECENIE_STATUS_OSOBA, 'M', '' );
    Add( sKDOSOBA_NAZWA+';'+sZLEZLECENIE_STATUS_OSOBA+'_Nazwa', 'KD2', 'Osoba potwierdzajca realizacj', True, True, taLeftJustify, 200 );
    Add( sZLEZLECENIE_STATUS_PODST, 'M', 'Podstawa potwierdzenia realizacji', True, True, taLeftJustify, 200 );
    Add( {sZLEZLECENIE_OPIS}RzutujCLOBNaVarchar2('M.' + sZLEZLECENIE_OPIS, sZLEZLECENIE_OPIS, 2048), {'M'}'', 'Opis', True, True, taLeftJustify, 200, {uftLongRaw} uftString );

    AddRequiredAndUnvisible( sZLEZLECENIE_OSOBA_AKCEPT, 'M', '' );
    Add( sKDOSOBA_NAZWA+';'+sZLEZLECENIE_OSOBA_AKCEPT+'_Nazwa', 'KD3', 'Osoba akceptujca', True, True, taLeftJustify, 200 );
    AddRequiredAndUnvisible( sZLEZLECENIE_OSOBA_REAL, 'M', '' );
    Add( sKDOSOBA_NAZWA+';'+sZLEZLECENIE_OSOBA_REAL+'_Nazwa', 'KD4', 'Osoba realizujca', True, True, taLeftJustify, 200 );
    AddRequiredAndUnvisible( sZLEZLECENIE_OPER_AKCEPT, 'M', '' );
    Add( {'SM1.' + }sSMUSER_IMIE+ '||'+QuotedStr(' ')+'|| SM1.'+sSMUSER_NAZWISKO+';'+sSMUSER_NAZWISKO+'1', 'SM1', 'Akceptujcy', True, True, taLeftJustify, 100 );
    AddRequiredAndUnvisible( sZLEZLECENIE_OPER_ODP, 'M', '' );
    Add( {'SM2.' + }sSMUSER_IMIE+ '||'+QuotedSTr(' ')+'|| SM2.'+sSMUSER_NAZWISKO+';'+sSMUSER_NAZWISKO+'2', 'SM2', 'Odpowiedzialny', True, True, taLeftJustify, 100 );
    AddRequiredAndUnvisible( sZLEZLECENIE_OPER_REAL, 'M', '' );
    Add( {'SM3.' +}sSMUSER_IMIE+ '||'+QuotedStr(' ')+'|| SM3.'+sSMUSER_NAZWISKO+';'+sSMUSER_NAZWISKO+'3', 'SM3', 'Realizujcy', True, True, taLeftJustify, 100 );
    AddRequiredAndUnvisible( sZLEZLECENIE_OPER_POTW_REAL, 'M', '' );
    Add( {'SM4.' +}sSMUSER_IMIE+ '||'+QuotedStr(' ')+'|| SM4.'+sSMUSER_NAZWISKO+';'+sSMUSER_NAZWISKO+'4', 'SM4', 'Potwierdzajcy realizacj', True, True, taLeftJustify, 100 );

    AddRequiredAndUnvisible( sBOKUMOWA_ID, 'M', '', True );
    if(DataManagers.Available(sBOKModulID)) then begin
      Add(sBOKUMOWA_NUMER    ,'UM', 'Numer umowy', true, omWidoczne, taLeftJustify, 110);
    end;  // if(DataManagers.Available(sBOKModulID))

    AddRequiredAndUnvisible( sINFPUNKT_ID, 'M', '', True );
    if(DataManagers.Available(sINFModulID)) then begin
      Add(sINFPUNKT_SYMBOL    ,'PK', 'Symbol punktu', true, omWidoczne, taLeftJustify, 70);
      Add(sINFPUNKT_NAZWA     ,'PK', 'Nazwa punktu', true, omWidoczne, taLeftJustify, 120);
    end;  // if(DataManagers.Available(sBOKModulID))

    if(DataManagers.Available(sZAOModulID)) then begin
      Add(sASOASORT_SYMBOL    , 'ASO', 'Symbol wyrobu', true, omWidoczne, taLeftJustify, 110);
      Add(sASOASORT_NAZWA     , 'ASO', 'Nazwa wyrobu', true, omWidoczne, taLeftJustify, 200);
      Add(sUNIJM_SYMBOL       , 'JM', 'Jednostka', true, omWidoczne, taLeftJustify, 80);
      Add(sASOASORT_INDEKS    , 'ASO', 'Indeks', false, omWidoczne, taLeftJustify, 100);
      Add(sASOASORT_NAZWA_HANDL, 'ASO', 'Nazwa handlowa wyrobu', false, omWidoczne, taLeftJustify, 200);
      if(DataManagers.Available(sLWPModulID)) then begin
        Add(sLWPRECEPTURA_SYMBOL, sLWPAlias_Receptura, 'Symbol receptury', true, omWidoczne, taLeftJustify, 110);
        Add(sLWPRECEPTURA_NAZWA , sLWPAlias_Receptura, 'Nazwa receptury', true, omWidoczne, taLeftJustify, 200);
        Add(
          RzutujCLOBNaVarchar2(sLWPAlias_Receptura + '.' + sLWPRECEPTURA_OPIS, sLWPRECEPTURA_OPIS),
          '', 'Opis receptury' , false, omWidoczne, taLeftJustify, 300, uftString
        );
        Add(sLWPRecepturaTyp_SYMBOL, sLWPAlias_RecepturaTyp, 'Symbol typu receptury', true, omWidoczne, taLeftJustify, 120);
        Add(sLWPRecepturaTyp_NAZWA , sLWPAlias_RecepturaTyp, 'Nazwa typu receptury', false, omWidoczne, taLeftJustify, 300);
        Add(sLWPRECEPTURA_ILOSC , sLWPAlias_Receptura, 'Ilo wyrobu w recepturze', true, omWidoczne, taRightJustify, 80);
      end;  // if(DataManagers.Available(sLWPModulID))
    end;  // if(DataManagers.Available(sZAOModulID))
    if(DataManagers.Available(sUNIINTModulID) and UNIINTDM.CzyOperacjaAktywna(cUNIINTOperacja_ZlecenieProdWyslij_Id)) then begin
      Add(
        '(' +
          'SELECT ''' + sTak + ''' FROM Dual Where ' +
            'EXISTS(' +
              'SELECT * FROM ' + SQLManager.GetTableName(sZLEZLECENIEOBCY) + ' ZO' +
              ' WHERE ZO.' + sZLEZLECENIE_ID + ' = M.' + sZLEZLECENIE_ID  +
            ')' +
        ');ZLEZLECENIE_WYSLANE',
        '', 'Wysane do partnera' , true, omWidoczne, taLeftJustify, 80
      );
      Add(
        '(' +
          'SELECT ''' + sTak + ''' FROM Dual Where ' +
            'EXISTS(' +
              'SELECT * FROM ' + SQLManager.GetTableName(sZLEZLECENIEOBCY) + ' ZO' +
              ' WHERE ZO.' + sZLEZLECENIE_ID + ' = M.' + sZLEZLECENIE_ID + ' and ZO.' + sZLEZLECENIEOBCY_BLAD + ' is not null' +
            ')' +
        ');' + sZLEZLECENIEOBCY_BLAD,
        '', 'Bdnie wysane' , true, omWidoczne, taLeftJustify, 80
      );
    end;  // if dostpny UNIINT i aktywna operacja wysyania zlecenia
    AddRequiredAndUnvisible(sZLETYPZLEC_PRODUKCYJNE, 'T', '' );

    Add('(' + 'SELECT SUM(' + sZLEZLECENIEPOZ_WARTOSC + ') ' +
              'FROM ' + SQLManager.GetTableName(sZLEZLECENIEPOZ) + ' ZPP ' +
              'WHERE ZPP.' + sZLEZLECENIE_ID + ' = M.' + sZLEZLECENIE_ID + ');'+sZLEZLECENIEPOZ_WARTOSC,
        '', 'Wartosc pozycji', true, omWidoczne, taLeftJustify, 80);

    {Zmiana pola na widoczne - Tomjen}
    // AddRequiredAndUnvisible(sZLEZLECENIE_ILOSC , 'M', '');
    Add( sZLEZLECENIE_ILOSC , 'M', 'Ilo', true, omWidoczne, taRightJustify, 80);
  end;

  {if GridTabDefs.Count = 0 then}
   with GridTabDefs do begin
    Clear();
    Add( 'M', TableName );
    if vWieloodzialowosc or vWieloFirmowosc then
      Add( 'O', sUNIODDZIAL );
    Add( 'T',   sZLETYPZLEC );
    Add( 'MD',  sUNIMODULZSI );
    Add( 'KD1', sKDOSOBA );
    Add( 'KD2', sKDOSOBA );
    Add( 'SM',  sSMUSER);
    Add( 'ST',  sZLECONST_STATUS );
    Add( 'ZLEC',sZLEZLECENIE );
    Add( 'W',   sUNIJEDNOSTKAORG );
    Add( 'R',    sUNIROK );
    Add( 'BKKL', sBKKLIENT );
    Add( 'N1', sUNICONST_ALTERNATYWA );

    {Zaangaowani}
    Add( 'KD3',  sKDOSOBA );
    Add( 'KD4',  sKDOSOBA );
    Add( 'KD5',  sKDOSOBA );
    Add( 'SM1',  sSMUSER);
    Add( 'SM2',  sSMUSER);
    Add( 'SM3',  sSMUSER);
    Add( 'SM4',  sSMUSER);

    Add( 'POJ',  sUNIPOJSP );

    if DataManagers.Available(sBOKModulID) then begin
      Add('UM', sBOKUMOWA);
    end;

    if(DataManagers.Available(sZAOModulID)) then begin
      Add('ASO',  sASOASORT);
      Add('JM',   sUNIJM);
      if(DataManagers.Available(sLWPModulID)) then begin
        Add(sLWPAlias_Receptura, sLWPRECEPTURA);
        Add(sLWPAlias_RecepturaTyp, sLWPRECEPTURATYP);
      end;  // if(DataManagers.Available(sLWPModulID))
    end;  // if(DataManagers.Available(sZAOModulID))

    if DataManagers.Available(sINFModulID) then begin
      Add('PK', sINFPUNKT);
    end;
  end;

  {if GridJoinDefs.Count = 0 then}
  with GridJoinDefs do begin
    Clear();
    if vWieloodzialowosc or
       (vWielofirmowosc and ZLEDM.vZLEWspolneZlecenia) or
       (vWielofirmowosc and UNISYSDM.vWielofirmowoscWieleFirm) then
      AddSimple( 'M', 'O', 'M.'+sUNIODDZIAL_ID+'=O.'+sUNIODDZIAL_ID, qjkLeftOuter, True )
    else if vWielofirmowosc and
            (not (ZLEDM.vZLEWspolneZlecenia or UNISYSDM.vWielofirmowoscWieleFirm)) then begin
      AddCondition( 'M.'+sUNIODDZIAL_ID+'='+IntToStr(vAktywnaFirma), True );
      AddSimple( 'M', 'O', 'M.'+sUNIODDZIAL_ID+'=O.'+sUNIODDZIAL_ID, qjkLeftOuter, True )
    end;
    AddSimple( 'M', 'T',   'M.'+sZLETYPZLEC_ID+'=T.'+sZLETYPZLEC_ID, qjkInner, True );
    AddSimple( 'M', 'MD',  'M.'+sUNIMODULZSI_ID+'=MD.'+sUNIMODULZSI_ID, qjkInner, False );
    AddSimple( 'M', 'KD1', 'M.'+sZLEZLECENIE_OSOBA_ODP+'=KD1.'+sKDOSOBA_ID, qjkLeftOuter, False );
    AddSimple( 'M', 'KD2', 'M.'+sZLEZLECENIE_STATUS_OSOBA+'=KD2.'+sKDOSOBA_ID, qjkLeftOuter, False );
    AddSimple( 'M', 'SM',  'M.'+sZLEZLECENIE_UZ_AU_ID+'=SM.'+sSMUSER_ID, qjkLeftOuter, False );
    AddSimple( 'M', 'ST',  'M.'+sZLEZLECENIE_STATUS+'=ST.'+sZLECONST_STATUS_ID, qjkInner, False );
    AddSimple( 'M', 'ZLEC','M.'+sZLEZLECENIE_GRUPA_ID+'=ZLEC.'+sZLEZLECENIE_ID, qjkLeftOuter, False );
    AddSimple( 'M', 'W',   'M.'+sUNIJEDNOSTKAORG_ID+'=W.'+sUNIJEDNOSTKAORG_ID, qjkLeftOuter, False );
    AddSimple( 'M', 'R',   'M.'+sUNIROK_ID+'=R.'+sUNIROK_ID, qjkLeftOuter, False );
    AddSimple( 'M', 'BKKL','M.'+sZLEZLECENIE_WYKONAWCA_ID+'=BKKL.'+sBKKLIENT_ID, qjkLeftOuter, False );
    AddSimple( 'M', 'N1',  'M.'+sZLEZLECENIE_PRZELICZ+'=N1.'+sUNICONST_ALTERNATYWA_ID, qjkInner, False );

    {Zaangaowani}
    AddSimple( 'M', 'KD3', 'M.'+sZLEZLECENIE_OSOBA_AKCEPT+'=KD3.'+sKDOSOBA_ID, qjkLeftOuter, False );
    AddSimple( 'M', 'KD4', 'M.'+sZLEZLECENIE_OSOBA_REAL+'=KD4.'+sKDOSOBA_ID, qjkLeftOuter, False );
    AddSimple( 'M', 'KD5', 'M.'+sZLEZLECENIE_OSOBA_ZGLASZ+'=KD5.'+sKDOSOBA_ID, qjkLeftOuter, False );
    AddSimple( 'M', 'SM1',  'M.'+sZLEZLECENIE_OPER_AKCEPT+'=SM1.'+sSMUSER_ID, qjkLeftOuter, False );
    AddSimple( 'M', 'SM2',  'M.'+sZLEZLECENIE_OPER_ODP+'=SM2.'+sSMUSER_ID, qjkLeftOuter, False );
    AddSimple( 'M', 'SM3',  'M.'+sZLEZLECENIE_OPER_REAL+'=SM3.'+sSMUSER_ID, qjkLeftOuter, False );
    AddSimple( 'M', 'SM4',  'M.'+sZLEZLECENIE_OPER_POTW_REAL+'=SM4.'+sSMUSER_ID, qjkLeftOuter, False );
    AddExpres( 'M.' + sUNIPOJSP_ID + ' = POJ.'   + sUNIPOJSP_ID, qjkLeftOuter, false);

    if DataManagers.Available(sBOKModulID) then begin
      AddExpres( 'M.' + sBOKUMOWA_ID + ' = UM.'   + sBOKUMOWA_ID, qjkLeftOuter, false);
    end;

    if DataManagers.Available(sINFModulID) then begin
      AddExpres( 'M.' + sINFPUNKT_ID + ' = PK.'   + sINFPUNKT_ID, qjkLeftOuter, false);
    end;

    iZakresConditionIdx := GridJoinDefs.AddEmptyCondition();

    if(DataManagers.Available(sZAOModulID)) then begin
      AddExpres('M.' + sASOASORT_ID + ' = ASO.'   + sASOASORT_ID, qjkLeftOuter, true);
      AddExpres('ASO.' + sUNIJM_ID1 + ' = JM.' + sUNIJM_ID, qjkLeftOuter, false);
      if(DataManagers.Available(sLWPModulID)) then begin
        AddExpres('M.' + sLWPRECEPTURA_ID + ' = ' + sLWPAlias_Receptura + '.'   + sLWPRECEPTURA_ID, qjkLeftOuter, true);
        AddExpres(sLWPAlias_Receptura + '.' + sLWPRECEPTURATYP_ID + ' = ' + sLWPAlias_RecepturaTyp + '.'   + sLWPRECEPTURATYP_ID, qjkLeftOuter, false);
      end;  // if(DataManagers.Available(sLWPModulID))
    end;  // if(DataManagers.Available(sZAOModulID))

  end;


  if ((owner is TZLEZlecenieDBGridForm) and TZLEZlecenieDBGridForm(Owner).PolaUzWlaczone) or
       (not (owner is TZLEZlecenieDBGridForm)) then begin
    UNISysDM.UNISysDodajPolaUzDoGrida(
      GridColDefs,
      GridTabDefs,
      GridJoinDefs,
      cPolaUZ_ZLEZlecenie,
      'M.' + sZLEZLECENIE_ID,
      'M.' + sZLETYPZLEC_ID
    );
  end;
  inherited;
end;

procedure TZLEZlecenieDataModule.JoinOnField(const iFun: Integer;
  sFieldName: String; var sConditions: String);
const cADMID = sADMID+'%d';
var
  sCondition: String;
  oIDs_List: TStringList;
  sCorrel1: String;
  sCorrel2: String;
  iPFun: Integer;
  sRangeClassName: String;
begin
  iPFun := (Owner as TUNIDBGridForm).RangePodFunc;
  sRangeClassName := (Owner as TUNIDBGridForm).RangeClassName;

  if sRangeClassName = '' then Exit;

  oIDs_List := ADMID_CreateAndLoad( iFun, iPFun, SecurityManager.UserId,
                                    sRangeClassName );
  try
    sCorrel1 := Copy( sFieldName, 1, Pos( '.', sFieldName )-1 );
    sCorrel2 := Format(cADMID, [iFun]);

    if oIDs_List.Count > 0 then
    begin
      //dodanie warunku
      sCondition := '('+sCorrel2+'.'+sADMID_FUNK+'='+IntToStr(iFun)+')and'+
                  '('+sCorrel2+'.'+sADMID_PFUNK+'='+IntToStr(iPFun)+')and'+
                  '('+sCorrel2+'.'+sSMUSER_ID+'='+IntToStr(SecurityManager.UserId)+')and'+
                  '('+sCorrel2+'.'+sADMID_KONTEKST+'='+QuotedStr(sRangeClassName)+')';
        //dodajemy tabele
//      TD.Add( sCorrel2, sADMID );
//      sTables := sTables+','+SQLManager.GetTableName(sADMID)+' '+sCorrel2+' ';
      GridTabDefs.Add(sCorrel2, sADMID);

      DopiszDoWhere(sCondition, sConditions);
    end;

    //dodajemy warunki zlaczenia
//      GridJoinDefs.AddExpres(sFieldName+'='+sCorrel2+'.'+sADMID_V, qjkInner, oIDs_List.Count > 0)
//      sConditions := sConditions + ' and '+sFieldName+'='+sCorrel2+'.'+sADMID_V+' and '+sCondition+' ';
    if GridJoinDefs.IndexOfCorrel2( sCorrel2 ) = -1 then
      GridJoinDefs.AddSimple( sCorrel1, sCorrel2, sFieldName+'='+sCorrel2+'.'+sADMID_V, qjkInner, oIDs_List.Count > 0 )
    else
      GridJoinDefs.Items[ GridJoinDefs.IndexOfCorrel2( sCorrel2 ) ].Required := (oIDs_List.Count > 0);
  finally
    oIDs_List.Free;
  end;
end;

(*
function  TZLEZlecenieDataModule.PrzygotujDaneZleceniaProdDoWyslania(
  const ac_sZlecenieId: string
):  string;
var
  oXMLDoc:  TUNIXMLParser;
  oElem:    IXMLDOMElement;
  oQueryZlec: TUNIQuery;
  oQueryRecep:TUNIQuery;
  oQueryZasob:TUNIQuery;
  oZlecId:    TStringList;
begin
  oZlecId     := TStringList.Create();
  oXMLDoc     := TUNIXMLParser.Create();
  oQueryZlec  := nil;
  oQueryRecep := nil;
  oQueryZasob := nil;
  try
    oElem := oXMLDoc.DodajElementGlowny(sZLEZLECENIE);
    oZlecId.Add(ActiveQuery.FieldByName(Keys.GetPrimaryKey()).AsString);
    ZLEDM.ZapiszIdZlecDoWyslaniaWADMId(oZlecId, SecurityManager.UserId, (Owner as TUNIForm).ClassName + (Owner as TUNIForm).Suffix, true);
    oQueryZlec  := ZLEDM.DajQueryZlecDoWyslania(
      SecurityManager.UserId,
      (Owner as TUNIForm).ClassName + (Owner as TUNIForm).Suffix
    );
    oQueryRecep := ZLEDM.DajQueryReceppozZlecDoWyslania(
      SecurityManager.UserId,
      (Owner as TUNIForm).ClassName + (Owner as TUNIForm).Suffix
    );
    oQueryZasob := ZLEDM.DajQueryZasobowReceppozZlecDoWyslania(
      SecurityManager.UserId,
      (Owner as TUNIForm).ClassName + (Owner as TUNIForm).Suffix
    );

    ZLEDM.PrzepiszDaneZlecDoXML(
      oXMLDoc,
      oElem,
      oQueryZlec,
      oQueryRecep,
      oQueryZasob
    );
    result  := oXMLDoc.ZapiszDokumentDoStringa();
  finally
    oQueryZlec.Free();
    oQueryRecep.Free();
    oQueryZasob.Free();
    oXMLDoc.Free();
    oZlecId.Free();
    ZLEDM.UsunIdZlecDoWyslaniaWADMId(SecurityManager.UserId, (Owner as TUNIForm).ClassName + (Owner as TUNIForm).Suffix);
  end;
end;

procedure TZLEZlecenieDataModule.WyslijDane(
  const ac_sDane:       string;
  const ac_iOperacjaId: integer
);
begin
{$ifndef build_all}
  ZLEDM.WyslijDaneZlec(ac_sDane, ac_iOperacjaId, SecurityManager.UserId, (Owner as TUNIForm).ClassName + (Owner as TUNIForm).Suffix);
{$endif}
end;
*)

procedure TZLEZlecenieDataModule.OpenDataSets;
begin
  UstawZakres();
  inherited;
end;



procedure TZLEZlecenieDataModule.Post;
var
    bTrans                                  : Boolean;
    {Zmienne na potrzeby zmian statusu Spraw}
    iZlecenieID                             : Integer;
    vZLEListaSprawZlecenPo                  : TUNIQuery;
    sZLEListaSprawPrzed, sZLEListaSprawPo,
    sZleStatusPrzed, sZleStatusPo, sSQL     : String;

    bWszystkieAnulowane,
    bWszystkieOczekujace,
    bWszystkieWstrzymane,
    bWszystkieZakonczone                    : Boolean;
    iAktSprawa                              : Integer;
    sAktStatusSprawy                        : String;

    qObcyQuery, qUpdateObcy                 : TUNIQuery;
    sKrytPozSymbolOld                       : string;
    bZasobyZapisane                         : boolean;
    i, j, iFormIndex{, iOperacjaId}         : integer;
    iZleObcyID                              : Integer;
begin
  {--------------To na potrzeby uytkownikow zaangaowanych ------------}
  if ((OpenModeFlags and omOverVirtual) = omOverVirtual) or (Owner is TZLEZaangazowaniDBDetailForm) then begin
    inherited;
    exit;
  end;

  bZasobyZapisane := false;
  bTrans := SQLManager.InTransaction;
  if not bTrans then SQLManager.StartTransaction;
  try
    if vWielofirmowosc and ActiveQuery.FieldByName(sUNIODDZIAL_ID).IsNull and (OpenMode = omNew) then
      ActiveQuery.FieldByName(sUNIODDZIAL_ID).AsInteger := vAktywnaFirma;

    iZlecenieID          := ActiveQuery.FieldByName(sZLEZLECENIE_ID).AsInteger;
    sZLEStatusPrzed      := SQLManager.OpenQueryWithResult('SELECT ' + sZLEZLECENIE_STATUS + ' ' +
                                                           'FROM %s ' +
                                                           'WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID),
                                                           [sZLEZLECENIE]);

    if DataManagers.Available(sBOKModulID) then  begin
       {iZlecenieID          := ActiveQuery.FieldByName(sZLEZLECENIE_ID).AsInteger;
       sZLEStatusPrzed      := SQLManager.OpenQueryWithResult('SELECT ' + sZLEZLECENIE_STATUS + ' ' +
                                                              'FROM %s ' +
                                                              'WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID),
                                                              [sZLEZLECENIE]);}

       sZleListaSprawPrzed  := SQLManager.OpenQueryWithResult('SELECT %s.JoinStrings(CURSOR(' +
                                                              'SELECT DISTINCT ' + sBOKSPRAWA_ID + ' ' +
                                                              'FROM %s WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID) + ')) FROM DUAL',
                                                              ['DODATKI_PACKAGE', sZLEZLECENIEPOZ]);
    end;

    sKrytPozSymbolOld := PodajKrytPozSymbolOld;
    inherited;

    if OpenMode = omNew then begin
      DopiszWartosciKryterium;

      {Uzupenienie pola Zlezlecenie_obcy_id po wysaniu zlecenia do Megabit}
      if DataManagers.Available(sUNIINTModulID) then begin
        qObcyQuery := SQLManager.CreateQuery('SELECT %s(' + IntToStr(iZlecenieID) + ')  AS ' + sZLEZLECENIE_OBCY_ID + ' ' +
                                             'FROM dual',
                                             [sZLE_POBIERZ_ID_OBCY]);
        try
          qObcyQuery.Open();
          if not qObcyQuery.IsEmpty then begin
             iZleObcyID := qObcyQuery.FieldByName(sZLEZLECENIE_OBCY_ID).AsInteger;
             qUpdateObcy := SQLManager.UpdateQueryStep1(sZLEZLECENIE,
                                                        sZLEZLECENIE_OBCY_ID,
                                                        sZLEZLECENIE_ID + '=' + intToStr(iZlecenieID));
             qUpdateObcy.ParamByName(sZLEZLECENIE_OBCY_ID).DataType := ftInteger;
             if iZleObcyID > 0 then
                  qUpdateObcy.ParamByName(sZLEZLECENIE_OBCY_ID).AsInteger := iZleObcyID
             else qUpdateObcy.ParamByName(sZLEZLECENIE_OBCY_ID).Clear;
             SQLManager.UpdateQueryStep2(qUpdateObcy);
          end;
        finally
          if qObcyQuery <> nil then FreeAndNil(qObcyQuery);
        end;
      end;
    end;

    if OpenMode = omEdit then begin
      PoprawSymbolZKryterium(sKrytPozSymbolOld);
      DopiszWartosciKryterium;
    end;

    //zatwierdzenie zmian w pozycjach
    if (owner as TUNIDBDetailForm).Parameters.Values[cZLEFuncRodzaj] = cZLEFuncZlecenie then begin
      //dla edycji zamwienia zatwierdzamy pozycje oraz zasoby powizane
      with (Owner as TZLEZlecenieDBDetailForm) do begin
        if PozycjeZleceniaFormIndex > -1 then begin
          try
            iFormIndex := FContainedForms.IndexOf(cFormPozycjeZlecenia);
            if(iFormIndex > -1) then ContainedDataModules[iFormIndex].Post();
            //ContainedDataModules[PozycjeZleceniaFormIndex].Post;
          except
            ZleceniePageControl.ActivePage := PozycjeTabSheet;
            raise;
          end;
        end;

        if ZasobyFormIndex > -1 then begin
          iFormIndex := FContainedForms.IndexOf(cFormZasobyPowiazane);
          if(iFormIndex > -1) then ContainedDataModules[iFormIndex].Post();
          //ContainedDataModules[ZasobyFormIndex].Post;
          bZasobyZapisane := true;
        end;
      end;
    end else if (owner as TUNIDBDetailForm).Parameters.Values[cZLEFuncRodzaj] = cZLEFuncKontrolaRealizacji then begin
      ContainedDataModules[0].Post;
      ContainedDataModules[1].Post;
    end;

    {Aktualizacja statusw spraw powizanych ze zleceniem}
    if DataManagers.Available(sBOKModulID) then begin
       sZLEStatusPo := SQLManager.OpenQueryWithResult('SELECT ' + sZLEZLECENIE_STATUS + ' ' +
                                                      'FROM %s ' +
                                                      'WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID),
                                                      [sZLEZLECENIE]);

       sZleListaSprawPo := SQLManager.OpenQueryWithResult('SELECT %s.JoinStrings(CURSOR(' +
                                                              'SELECT DISTINCT ' + sBOKSPRAWA_ID + ' ' +
                                                              'FROM %s WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID) + ')) FROM DUAL',
                                                         ['DODATKI_PACKAGE', sZLEZLECENIEPOZ]);

       if (sZleListaSprawPo = '') and (sZleListaSprawPrzed = '') then begin
          {Nie zmieniamy statusw spraw - bo zlecenie nie ma powiazania ze sprawa}
       end else begin
          sSQL := 'SELECT ZP.' + sZLEZLECENIE_ID + ', ' +
                         'ZL.' + sZLEZLECENIE_STATUS + ', ' +
                         'ZP.' + sBOKSPRAWA_ID + ', ' +
                         'BS.' + sBOKSPRAWA_STATUS + ' ' +
                  'FROM %s ZP, %s ZL, %s BS ' +
                  'WHERE BS.' + sBOKSPRAWA_ID + ' = ZP.' + sBOKSPRAWA_ID + ' AND ' +
                        'ZP.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' AND ';

          if sZleListaSprawPrzed = '' then begin
             sSQL := sSQL +
                        '(ZP.' + sBOKSPRAWA_ID + ' IN (SELECT DISTINCT ' + sBOKSPRAWA_ID + ' ' +
                                                       'FROM %s WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID) + '))';

             sSQL := sSQL + ' ORDER BY ZP.' + sBOKSPRAWA_ID + ', BS.' + sBOKSPRAWA_STATUS;
             vZLEListaSprawZlecenPo := SQLManager.CreateQuery(sSQL, [sZLEZLECENIEPOZ, sZLEZLECENIE,
                                                                     sBOKSPRAWA, sZLEZLECENIEPOZ]);

          end else begin
             sSQL := sSQL +
                        '((ZP.' + sBOKSPRAWA_ID + ' IN (SELECT DISTINCT ' + sBOKSPRAWA_ID + ' ' +
                                                       'FROM %s WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID) + ')) OR ' +
                       '  (ZP.' + sBOKSPRAWA_ID + ' IN (' + sZleListaSprawPrzed + ')))';

             sSQL := sSQL + ' UNION ' +
                       'SELECT NULL, NULL, BS.' + sBOKSPRAWA_ID + ', BS.' + sBOKSPRAWA_STATUS + ' ' +
                       'FROM %s BS ' +
                       'WHERE (BS.' + sBOKSPRAWA_ID + ' IN (' + sZleListaSprawPrzed + ')) AND ' +
                             '(BS.' + sBOKSPRAWA_ID + ' NOT IN (SELECT DISTINCT ' + sBOKSPRAWA_ID +
                                                               ' FROM %s WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID) + ')) AND ' +
                             ' NOT EXISTS (SELECT ' + sBOKSPRAWA_ID +
                                         ' FROM %s WHERE ' + sBOKSPRAWA_ID + ' = BS.' + sBOKSPRAWA_ID + ') ';

             sSQL := sSQL + ' ORDER BY ' + sBOKSPRAWA_ID + ', ' + sBOKSPRAWA_STATUS;

             vZLEListaSprawZlecenPo := SQLManager.CreateQuery(sSQL, [sZLEZLECENIEPOZ, sZLEZLECENIE,
                                                                     sBOKSPRAWA, sZLEZLECENIEPOZ,
                                                                     sBOKSPRAWA, sZLEZLECENIEPOZ,
                                                                     sZLEZLECENIEPOZ]);

          end;

          try
            vZLEListaSprawZlecenPo.Open;

            bWszystkieAnulowane  := True;
            bWszystkieOczekujace := True;
            bWszystkieWstrzymane := True;
            bWszystkieZakonczone := True;
            iAktSprawa := -1;
            sAktStatusSprawy := '';
            while not vZLEListaSprawZlecenPo.Eof do begin
               if (iAktSprawa <> vZLEListaSprawZlecenPo.FieldByName(sBOKSPRAWA_ID).AsInteger) and
                  (iAktSprawa <> -1) then begin

                  {zapisanie statusu sprawy}
                  if bWszystkieOczekujace then begin
                     if sAktStatusSprawy <> sBOKCONST_SSTATUS_PRZYJETA_ID then
                        BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_PRZYJETA_ID, UNINow());
                  end else
                  if bWszystkieWstrzymane then begin
                     if sAktStatusSprawy <> sBOKCONST_SSTATUS_ZAWIESZONA_ID then
                        BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_ZAWIESZONA_ID, UNINow());
                  end else
                  if bWszystkieZakonczone then begin
                     if sAktStatusSprawy <> sBOKCONST_SSTATUS_ZAKONCZONA_ID then
                        BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_ZAKONCZONA_ID, UNINow());
                  end else
                  if bWszystkieAnulowane then begin
                     if sAktStatusSprawy <> sBOKCONST_SSTATUS_ANULOWANA_ID then
                        BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_ANULOWANA_ID, UNINow())
                  end else begin
                     if sAktStatusSprawy <> sBOKCONST_SSTATUS_REALIZOWANA_ID then
                        BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_REALIZOWANA_ID, UNINow());
                  end;

                  iAktSprawa       := vZLEListaSprawZlecenPo.FieldByName(sBOKSPRAWA_ID).AsInteger;
                  sAktStatusSprawy := vZLEListaSprawZlecenPo.FieldByName(sBOKSPRAWA_STATUS).AsString;

                  bWszystkieAnulowane  := (vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_AnulowaneID);
                  bWszystkieOczekujace := ((vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_OczekujaceID) or vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).IsNull);
                  bWszystkieWstrzymane := (vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_WstrzymaneID);
                  bWszystkieZakonczone := (vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_ZakonczoneID);
               end else begin

                  if (iAktSprawa = -1) then begin
                      iAktSprawa       := vZLEListaSprawZlecenPo.FieldByName(sBOKSPRAWA_ID).AsInteger;
                      sAktStatusSprawy := vZLEListaSprawZlecenPo.FieldByName(sBOKSPRAWA_STATUS).AsString;
                  end;

                  bWszystkieAnulowane  := bWszystkieAnulowane  and (vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_AnulowaneID);
                  bWszystkieOczekujace := bWszystkieOczekujace and ((vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_OczekujaceID) or vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).IsNull);
                  bWszystkieWstrzymane := bWszystkieWstrzymane and (vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_WstrzymaneID);
                  bWszystkieZakonczone := bWszystkieZakonczone and (vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_ZakonczoneID);
               end;

               vZLEListaSprawZlecenPo.Next;
            end;

            if iAktSprawa <> -1 then begin
               {Zapisanie statusu dla ostatniej sprawy}
               if bWszystkieOczekujace then begin
                  if sAktStatusSprawy <> sBOKCONST_SSTATUS_PRZYJETA_ID then
                     BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_PRZYJETA_ID, UNINow());
               end else
               if bWszystkieWstrzymane then begin
                  if sAktStatusSprawy <> sBOKCONST_SSTATUS_ZAWIESZONA_ID then
                     BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_ZAWIESZONA_ID, UNINow());
               end else
               if bWszystkieZakonczone then begin
                  if sAktStatusSprawy <> sBOKCONST_SSTATUS_ZAKONCZONA_ID then
                     BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_ZAKONCZONA_ID, UNINow());
               end else
               if bWszystkieAnulowane then begin
                  if sAktStatusSprawy <> sBOKCONST_SSTATUS_ANULOWANA_ID then
                     BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_ANULOWANA_ID, UNINow());
               end else begin
                  if sAktStatusSprawy <> sBOKCONST_SSTATUS_REALIZOWANA_ID then
                     BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_REALIZOWANA_ID, UNINow());
               end;
            end;
            vZLEListaSprawZlecenPo.Close;
          finally
            if vZLEListaSprawZlecenPo <> nil then FreeAndNil(vZLEListaSprawZlecenPo);
          end;
       end;
    end;

    if(DataManagers.Available(sZAOModulID)) then begin
      if ((TZLEZlecenieDBDetailForm(Owner).ZapotrzPierwFormIndex > -1)) then begin
        iFormIndex := TZLEZlecenieDBDetailForm(Owner).FContainedForms.IndexOf(cFormZapotrzebPierw);
        if(iFormIndex > -1) then ContainedDataModules[iFormIndex].Post();
        //ContainedDataModules[TZLEZlecenieDBDetailForm(Owner).ZapotrzPierwFormIndex].Post();
      end;

      if((TZLEZlecenieDBDetailForm(Owner).ZapotrzWtorneFormIndex > -1)) then begin
        iFormIndex := TZLEZlecenieDBDetailForm(Owner).FContainedForms.IndexOf(cFormZapotrzebWtorne);
        if(iFormIndex > -1) then ContainedDataModules[iFormIndex].Post();
        //ContainedDataModules[TZLEZlecenieDBDetailForm(Owner).ZapotrzWtorneFormIndex].Post();
      end;
    end;  // if(DataManagers.Available(sZAOModulID))

    if(DataManagers.Available(sZAMModulID)) then begin
      if((TZLEZlecenieDBDetailForm(Owner).ZamowienieFormIndex > -1)) then begin
        iFormIndex := TZLEZlecenieDBDetailForm(Owner).FContainedForms.IndexOf(cFormZamowienia);
        if(iFormIndex > -1) then ContainedDataModules[iFormIndex].Post();
        //ContainedDataModules[TZLEZlecenieDBDetailForm(Owner).ZamowienieFormIndex].Post();
      end;

      if((TZLEZlecenieDBDetailForm(Owner).ZapytanieFormIndex > -1)) then begin
        iFormIndex := TZLEZlecenieDBDetailForm(Owner).FContainedForms.IndexOf(cFormZapytania);
        if(iFormIndex > -1) then ContainedDataModules[iFormIndex].Post();
        //ContainedDataModules[TZLEZlecenieDBDetailForm(Owner).ZapytanieFormIndex].Post();
      end;
    end;  // if(DataManagers.Available(sZAMModulID))

    if((TZLEZlecenieDBDetailForm(Owner).MaterialFormIndex > -1)) then begin
      iFormIndex := TZLEZlecenieDBDetailForm(Owner).FContainedForms.IndexOf(cFormMaterialy);
      if(iFormIndex > -1) then ContainedDataModules[iFormIndex].Post();
      //ContainedDataModules[TZLEZlecenieDBDetailForm(Owner).MaterialFormIndex].Post();
    end;
    if(DataManagers.Available(sLWPModulID)) then begin
      if ((not bZasobyZapisane) and (TZLEZlecenieDBDetailForm(Owner).ZasobyFormIndex > -1)) then begin
         iFormIndex := TZLEZlecenieDBDetailForm(Owner).FContainedForms.IndexOf(cFormZasobyPowiazane);
         if(iFormIndex > -1) then ContainedDataModules[iFormIndex].Post();
         //ContainedDataModules[TZLEZlecenieDBDetailForm(Owner).ZasobyFormIndex].Post();
      end;
    end;  // if(DataManagers.Available(sLWPModulID))

    if (TZLEZlecenieDBDetailForm(Owner).m_oPolaUZGridy <> nil) then
       for i := 0 to TZLEZlecenieDBDetailForm(Owner).m_oPolaUZGridy.Count-1 do
       begin
         j := TZLEZlecenieDBDetailForm(Owner).FContainedForms.IndexOf(cPolaUzPrefiksZakladki + IntToStr(i));
         if(j > -1) then ContainedDataModules[j].Post();
       end;  // for i := 0 to m_oPolaUZGridy.Count-1

    if (TZLEZlecenieDBDetailForm(Owner).m_oZakladkiPozGridy <> nil) then
       for i := 0 to TZLEZlecenieDBDetailForm(Owner).m_oZakladkiPozGridy.Count-1 do
       begin
         j := TZLEZlecenieDBDetailForm(Owner).FContainedForms.IndexOf(cPolaUzPrefiksZakladki + IntToStr(gciZLEPolaUZPozIndeks + i));
         if(j > -1) then ContainedDataModules[j].Post();
       end;  // for i := 0 to oZakladkiPozId.Count-1

{$ifndef build_all}
{ !!! Wyczamy na razie wysyanie zlece on-line (podczas edycji i dopisywania)
    if(DataManagers.Available(sUNIINTModulID) and (Owner as TZLEZlecenieDBDetailForm).ZlecenieProdukcyjne) then begin
      case OpenMode of
        omNew:    iOperacjaId := cUNIINTOperacja_ZlecenieProdWyslij_Id;
        omEdit:   iOperacjaId := cUNIINTOperacja_ZlecenieProdWyslij_Id;
        omDelete: iOperacjaId := cUNIINTOperacja_ZlecenieProdUsun_Id;
      end;  // case ac_iOpenMode
      if((iOperacjaId > -1) and UNIINTDM.CzyOperacjaAktywna(iOperacjaId)) then
        WyslijDane(PrzygotujDaneZleceniaProdDoWyslania(ActiveQuery.FieldByName(sZLEZLECENIE_ID).AsString), iOperacjaId);
    end;  // if(DataManagers.Available(sUNIINTModulID) and zlecenie produkcyjne)
}
{$endif}

    {Zamknicie kont ksigowych powizanych ze zleceniem - przy zamykaniu zlecenia}
    if (OpenMode = omEdit) and ZLEDM.vZLEZamkniecieKont then begin
        if DataManagers.Available(sFKModulID) then begin
           {Sprawdzic czy zmieniony zosta status na Zamknity w zleceniu}
           sZLEStatusPo := SQLManager.OpenQueryWithResult('SELECT ' + sZLEZLECENIE_STATUS + ' ' +
                                                      'FROM %s ' +
                                                      'WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID),
                                                      [sZLEZLECENIE]);
           {Nastpia zmiana statusu na zakoczone}
           if (sZLEStatusPo    = cZLEStatusZlecenia_ZakonczoneID) and
              (sZLEStatusPrzed <> cZLEStatusZlecenia_ZakonczoneID) then begin
              FKDM.FKKontaNieaktywne(vAktywnaFirma,
                                     vAktywnyRokObrachunkowyID,
                                     ActiveQuery.FieldByName(sZLEZLECENIE_DATA_ZAMK).AsDateTime,
                                     iMnemonikZLEID, ActiveQuery.FieldByName(sZLEZLECENIE_SYMBOL).AsString, nil);
           end;

        end;
    end;

    (Owner as TZLEZlecenieDBDetailForm).PostPictureChanges();
    if not bTrans then SQLManager.Commit;
  except
    on EDMException do begin
      if not bTrans then SQLManager.Rollback;
      if Pos(sZLEZLECENIE+c_UNK, FLastDBError.SQLObjectName) > 0 then begin
        Komunikat( cError,'Istnieje ju zlecenie o takim symbolu!');
        with Owner as TZLEZlecenieDBDetailForm do begin
          ZleceniePageControl.ActivePage := OgolneTabSheet;
          if SymbolDBEdit.Enabled then ActiveControl := SymbolDBEdit
          else ActiveControl := TypZleceniaDBLookupAliasEdit;
        end;
        Abort;
      end else raise;
    end else begin
      if not bTrans then SQLManager.Rollback;
      raise;
    end;
  end;
end;

procedure TZLEZlecenieDataModule.DopiszWartosciKryterium;
begin
  {iFirmaID := 0;
  if vWielofirmowosc then
    iFirmaID := vAktywnaFirma;

  UNISysDataManager.UNIDopiszWartosciKryterium(iFirmaID, iMnemonikZLEID,
                                        ActiveQuery.FieldByName(sZLEZLECENIE_SYMBOL).AsString);}
end;

function TZLEZlecenieDataModule.PodajKrytPozSymbolOld: string;
begin
  try
     result := SQLManager.OpenQueryWithResult('SELECT ' + sZLEZLECENIE_SYMBOL +
                            ' FROM %s ' +
                            ' WHERE ' + sZLEZLECENIE_ID + ' = ' + QuotedStr(ActiveQuery.FieldByName(sZLEZLECENIE_ID).AsString),
                            [sZLEZLECENIE]);
  except
     result := '';
  end;
end;

procedure TZLEZlecenieDataModule.PoprawSymbolZKryterium(sKrytPozSymbolOld: string);
var
  sKrytPozSymbolNew: string;
  iFirmaID: integer;
begin
  iFirmaID := 0;
  if vWielofirmowosc then
    iFirmaID := vAktywnaFirma;

  sKrytPozSymbolNew :=  ActiveQuery.FieldByName(sZLEZLECENIE_SYMBOL).AsString;
  if ((sKrytPozSymbolOld <> sKrytPozSymbolNew) AND
      (sKrytPozSymbolOld <> '') AND (sKrytPozSymbolNew <> '')) then
      UNISysDataManager.UNIPoprawSymbolZKryt(iFirmaID,
                                             iMnemonikZLEID,
                                             sKrytPozSymbolOld,
                                             sKrytPozSymbolNew);
end;

procedure TZLEZlecenieDataModule.ReOpenDataSets;
var
  i, k: Integer;
begin
  inherited;
  k:= 0;
  for i := 0 to (Owner as TUNIForm).ContainedFormCount - 1 do begin
    if not ((TUNIForm(Owner).ContainedForms[i] is TUNIDBDetailForm) or
            (TUNIForm(Owner).ContainedForms[i] is TUNIDBGridForm))
      {KDECPCzasPracyNaZleFormUnit}  then  begin
      //Specjalna obsuga Odwieania
      inc(k);
      KDECPDM.KDECPOdswiezCzasPracyNaZleceniu(TUNIForm(Owner).ContainedForms[i]);
    end else begin
      ContainedDataModules[i-k].ReOpenDataSets; //Czy pojawi si w rodku na licie?
    end;
  end;

end;

procedure TZLEZlecenieDataModule.UstawZakres;
var oParams: TKeyValues;
    sDopisz, sWhere: String;
    iIndex: Integer;
    iStatusKod: Integer;
    (**** Pola UZ ***
    Grid : TUNIDBGridForm;
    iLicznik1: Integer;
    bWartOd, bWartDo : Boolean;
    **** Pola UZ ***)
    sTmp: String;
    iOsobaID: Integer;
begin
  oParams := nil;
  sWhere := '';

  if (Owner is TUNIDBGridForm) then begin
    try
      oParams := TKeyValues.CreateEmpty();
      (Owner as TUNIDBForm).GetParametersForForm( (Owner as TUNIDBForm), oParams );
      if oParams = nil then exit;
      with oParams do begin
        //symbol zlecenia
        sDopisz := '';
        if (Values[sParam_ZLESymbolOd] <> '')and(Values[sParam_ZLESymbolDo] <> '') then begin
          sTmp := Values[sParam_ZLESymbolDo];
          if length(Values[sParam_ZLESymbolDo]) < UNISysDM.vMaxDLSymboluZle then begin
             {Uzupeniamy SymbolDo liter 'Z' do dugoci maxymalnej dugoci symbolu zlecenia}
             //sTmp := Values[sParam_ZLESymbolDo];
             while (length(sTmp) < UNISysDM.vMaxDLSymboluZle) do
               sTmp := sTmp + 'Z';
          end;

          sDopisz :=  '(M.'+sZLEZLECENIE_SYMBOL+'>='+QuotedStr(Values[sParam_ZLESymbolOd])+ ') and ' +
                      '(M.'+sZLEZLECENIE_SYMBOL+'<='+QuotedStr(sTmp) + ') ';
          {'M.'+sZLEZLECENIE_SYMBOL+' between '+
                     QuotedStr(Values[sParam_ZLESymbolOd])+' and '+
                     QuotedStr(Values[sParam_ZLESymbolDo]);}
        end else if Values[sParam_ZLESymbolOd] <> '' then begin
          sDopisz := 'M.'+sZLEZLECENIE_SYMBOL+'>='+QuotedStr(Values[sParam_ZLESymbolOd]);
        end else if Values[sParam_ZLESymbolDo] <> '' then begin
          sDopisz := 'M.'+sZLEZLECENIE_SYMBOL+'<='+QuotedStr(Values[sParam_ZLESymbolDo]);
        end;
        if sDopisz <> '' then DopiszDoWhere( sDopisz, sWhere );

        //nazwa zlecenia
        sDopisz := '';
        if (Values[sParam_ZLENazwaOd] <> '')and(Values[sParam_ZLENazwaDo] <> '') then begin
          sDopisz := 'M.'+sZLEZLECENIE_NAZWA+' between '+
                     QuotedStr(Values[sParam_ZLENazwaOd])+' and '+
                     QuotedStr(Values[sParam_ZLENazwaDo]);
        end else if Values[sParam_ZLENazwaOd] <> '' then begin
          sDopisz := 'M.'+sZLEZLECENIE_NAZWA+'>='+QuotedStr(Values[sParam_ZLENazwaOd]);
        end else if Values[sParam_ZLENazwaDo] <> '' then begin
          sDopisz := 'M.'+sZLEZLECENIE_NAZWA+'<='+QuotedStr(Values[sParam_ZLENazwaDo]);
        end;
        if sDopisz <> '' then DopiszDoWhere( sDopisz, sWhere );

        //data otwarcia
        sDopisz := '';
        if (Values[sParam_ZLEDataOtwOd] <> '')and(Values[sParam_ZLEDataOtwOd] <> '0')and
           (Values[sParam_ZLEDataOtwDo] <> '')and(Values[sParam_ZLEDataOtwDo] <> '0') then begin
          sDopisz := 'M.'+sZLEZLECENIE_DATA_OTW+' between '+
                     KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataOtwOd]))+' and '+
                     KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataOtwDo]));
        end else if (Values[sParam_ZLEDataOtwOd] <> '')and(Values[sParam_ZLEDataOtwOd] <> '0') then begin
          sDopisz := 'M.'+sZLEZLECENIE_DATA_OTW+'>='+KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataOtwOd]));
        end else if (Values[sParam_ZLEDataOtwDo] <> '')and(Values[sParam_ZLEDataOtwDo] <> '0') then begin
          sDopisz := 'M.'+sZLEZLECENIE_DATA_OTW+'<='+KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataOtwDo]));
        end;
        if sDopisz <> '' then DopiszDoWhere( sDopisz, sWhere );

        //data Zakonczenia
        sDopisz := '';
        if (Values[sParam_ZLEDataZakOd] <> '')and(Values[sParam_ZLEDataZakOd] <> '0')and
           (Values[sParam_ZLEDataZakDo] <> '')and(Values[sParam_ZLEDataZakDo] <> '0') then begin
          sDopisz := 'M.'+sZLEZLECENIE_DATA_ZAMK+' between '+
                     KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataZakOd]))+' and '+
                     KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataZakDo]));
          if Values['NIEZAKONCZONE'] = 'T' then
             sDopisz := '(' + sDopisz + ') OR (M.'+sZLEZLECENIE_DATA_ZAMK + ' IS NULL)';
        end else if (Values[sParam_ZLEDataZakOd] <> '')and(Values[sParam_ZLEDataZakOd] <> '0') then begin
          sDopisz := 'M.'+sZLEZLECENIE_DATA_ZAMK+'>='+KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataZakOd]));
          if Values['NIEZAKONCZONE'] = 'T' then
             sDopisz := '(' + sDopisz + ') OR (M.'+sZLEZLECENIE_DATA_ZAMK + ' IS NULL)';
        end else if (Values[sParam_ZLEDataZakDo] <> '')and(Values[sParam_ZLEDataZakDo] <> '0') then begin
          sDopisz := 'M.'+sZLEZLECENIE_DATA_ZAMK+'<='+KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataZakDo]));
          if Values['NIEZAKONCZONE'] = 'T' then
             sDopisz := '(' + sDopisz + ') OR (M.'+sZLEZLECENIE_DATA_ZAMK + ' IS NULL)';
        end;

        if sDopisz <> '' then DopiszDoWhere( sDopisz, sWhere );

        //przelicz - na razie filtrujemy tylko z wczonym przeliczaniem albo wszystko
        if Values[sParam_ZLEPrzelicz] = sTak then
            DopiszDoWhere( 'M.'+sZLEZLECENIE_PRZELICZ+ ' = '+ QuotedStr(Values[sParam_ZLEPrzelicz]), sWhere );

        //Pojazd
        if Values[sParam_ZLEPOjazdID] <> '' then
            DopiszDoWhere( 'M.'+sUNIPOJSP_ID+' in ('+Values[sParam_ZLEPOjazdID]+')', sWhere );

        //status zlecenia
        sDopisz := '';
        if Values[sParam_ZLEStatusZlec] <> '' then begin
          iStatusKod := StrToInt(Values[sParam_ZLEStatusZlec]);
          for iIndex := 0 to cslZLEStatusZlecenia.Count-1 do begin
            if iStatusKod and Round(Power( 2, iIndex )) <> 0 then begin
              if sDopisz <> '' then sDopisz := sDopisz + ',';
              sDopisz := sDopisz + QuotedStr(cslZLEStatusZlecenia.ZwrocSkrot(iIndex));
            end;
          end;
          if sDopisz <> '' then sDopisz := 'M.'+sZLEZLECENIE_STATUS+' in ('+sDopisz+')';
        end;
        if sDopisz <> '' then DopiszDoWhere( sDopisz, sWhere );

        // Operator wprowadzajacy
        if Values[sParam_ZLEOperatorWprowadz] <> '' then
            DopiszDoWhere( 'M.'+sZLEZLECENIE_UZ_AU_ID+' in ('+Values[sParam_ZLEOperatorWprowadz]+')', sWhere );


        //typ zlecenia
        if Values[sParam_ZLETypZlec] <> '' then
            DopiszDoWhere( 'T.'+sZLETYPZLEC_ID+' in ('+Values[sParam_ZLETypZlec]+')', sWhere );

        //Kontrahent
        if Values[sParam_ZLEKlientID] <> '' then
           DopiszDoWhere( 'M.'+sZLEZLECENIE_WYKONAWCA_ID+' in ('+Values[sParam_ZLEKlientID]+')', sWhere );

        //Zlecenie nadrzdne
        if Values[sParam_ZlecNadrzedneID] <> '' then begin
           if Values[sParam_ZlecNadrzednePokaz] = 'T' then
             DopiszDoWhere( '((M.' + sZLEZLECENIE_GRUPA_ID + ' IN (' + Values[sParam_ZlecNadrzedneID] + ')) OR (M.' + sZLEZLECENIE_ID + ' IN (' + Values[sParam_ZlecNadrzedneID] + ')))', sWhere)
           else
             DopiszDoWhere( 'M.' + sZLEZLECENIE_GRUPA_ID + ' IN (' + Values[sParam_ZlecNadrzedneID] + ')', sWhere);
        end;

        //modu rdowy
        if Values[sParam_ZLEModulZSI] <> '' then
            DopiszDoWhere( 'M.'+sUNIMODULZSI_ID+' in ('+Values[sParam_ZLEModulZSI]+')', sWhere );

        if (vWielofirmowosc and ZLEDM.vZLEWspolneZlecenia) or (vWieloodzialowosc) then
           if Values[sUNIODDZIAL_ID] <> '' then
              DopiszDoWhere( 'M.'+sUNIODDZIAL_ID+' in ('+Values[sUNIODDZIAL_ID]+')', sWhere );

        //Jednostka organizacyjna
        if Values[sUNIJEDNOSTKAORG_ID] <> '' then
           DopiszDoWhere( 'M.'+sUNIJEDNOSTKAORG_ID + ' IN ('+Values[sUNIJEDNOSTKAORG_ID]+')', sWhere );

        //Values[sZLEZLECENIE_POZIOMINF] := '9';
        if Values[sZLEZLECENIE_POZIOMINF] <> '' then
           DopiszDoWhere( 'M.'+sZLEZLECENIE_POZIOMINF+' = '+QuotedStr(Values[sZLEZLECENIE_POZIOMINF]), sWhere );

        //Values[sZLEZLECENIE_INF_ID] := '28222,26665';
        if Values[sZLEZLECENIE_INF_ID] <> '' then
           DopiszDoWhere( 'M.'+sZLEZLECENIE_INF_ID+' in ('+Values[sZLEZLECENIE_INF_ID]+')', sWhere );

        if Values[sMODULE_FOR_CREATOR] = sTak then
           DopiszDoWhere( '1 = 0', sWhere);

        //osoba odpowiedzialna
        JoinOnField( cADMIDFuncZLEOsoba, 'M.'+sZLEZLECENIE_OSOBA_ODP, sWhere );

        //zasb
        JoinOnField( cADMIDFuncZLEZasob, 'M.'+sZLEZLECENIE_ID, sWhere );

        //boksprawa
        sDopisz := '';
        if (Values[sUNIMODULZSI_ID] = IntToStr(cBOKModulZSI_ID)) then begin
           if (Values[sBOKSPRAWA_ID] <> '') then begin
              if ZLEDM.vZLEZleceniaBezPozycjiZeSpraw then begin
                if (Owner as TZLEZlecenieDBGridForm).WszystkieSprawy then
                  sDopisz := 'M.'+sBOKSPRAWA_ID + ' IS NOT NULL '
                else
                  sDopisz := 'M.'+sBOKSPRAWA_ID + ' in ('+ Values[sBOKSPRAWA_ID] + ') ';
              end else begin
                if (Owner as TZLEZlecenieDBGridForm).WszystkieSprawy then
                  sDopisz := 'M.'+sZLEZLECENIE_ID+' in ('+
                             ZLEDM.ZLEOdpytajODaneSQL( sZLEZLECENIEPOZ,
                                                       sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID,
                                                       '@'+sZLEALIAS_ZLECENIEPOZ_SPRAWA_ID+' IS NOT NULL ', {in ('+Values[sBOKSPRAWA_ID]+}
                                                       False )+')'
                else
                  sDopisz := 'M.'+sZLEZLECENIE_ID+' in ('+
                             ZLEDM.ZLEOdpytajODaneSQL( sZLEZLECENIEPOZ,
                                                       sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID,
                                                       '@'+sZLEALIAS_ZLECENIEPOZ_SPRAWA_ID+' in ('+Values[sBOKSPRAWA_ID]+')',
                                                       False )+')';
              end;
          end else
          if (Values[sBOKUMOWA_ID] <> '') then begin
              if (Owner as TZLEZlecenieDBGridForm).WszystkieSprawy then
                sDopisz := 'M.'+sBOKUMOWA_ID + ' IS NOT NULL '
              else
                sDopisz := 'M.'+sBOKUMOWA_ID + ' in ('+Values[sBOKUMOWA_ID]+')';
          end;
        end;
        if sDopisz <> '' then DopiszDoWhere( sDopisz, sWhere );

        //uprawnienia uytkownikw do typw dokumentw
        DopiszDoWhere('((T.' + sZLETYPZLEC_WLACZUPRAWNIENIA + ' = ' + QuotedStr('N') + ') OR (T.' + sZLETYPZLEC_ID + ' IN (SELECT X.' + sZLETYPZLEC_ID + ' FROM ' + SQLManager.GetTableName(sZLETYPZLECUSERS) + ' X WHERE X.' + sSMUSER_ID + '=' + IntToStr(SecurityManager.UserID) + ')))', sWhere);

        //Klient z formatki "Informacja o kliencie"
        if Values[sParam_ZLEKontekst] = sParam_ZLEKontekst_KlientInfo then begin
           if Values[sParam_ZLEWykonawcaID] <> '' then begin
             if (Owner as TZLEZlecenieDBGridForm).WszystkieSprawy then
               DopiszDoWhere('M.' + sZLEZLECENIE_ID + ' in (' +
                                  ' select distinct ZP.' + sZLEZLECENIE_ID +
                                  ' from ' + SQLManager.GetTableName(sZLEZLECENIEPOZ) + ' ZP, ' +
                                             SQLManager.GetTableName(sBOKSPRAWA)      + ' S' +
                                  ' where ZP.' + sBOKSPRAWA_ID + ' = S.' + sBOKSPRAWA_ID +
                                   ' and S.'  + sBKKLIENT_ID+' IN (' +Values[sParam_ZLEWykonawcaID]+'))', sWhere)
             else
               DopiszDoWhere('M.'+sZLEZLECENIE_WYKONAWCA_ID+' IN (' +Values[sParam_ZLEWykonawcaID]+')', sWhere);
           end;
        end;

        if ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0) then begin
           if Values[sParam_ZLEPrefixID] <> '' then
              DopiszDoWhere( 'M.'+sZLEZLECENIE_PREFIX_ID+' in ('+Values[sParam_ZLEPrefixID]+')', sWhere );
        end;

        {Zaangaowani}
        if Values[sParam_ZLEOperAkcept] <> '' then
           DopiszDoWhere( 'M.'+sZLEZLECENIE_OPER_AKCEPT + ' IN ('+Values[sParam_ZLEOperAkcept]+')', sWhere );
        if Values[sParam_ZLEOperOdp] <> '' then
           DopiszDoWhere( 'M.'+sZLEZLECENIE_OPER_ODP + ' IN ('+Values[sParam_ZLEOperOdp]+')', sWhere );
        if Values[sParam_ZLEOperReal] <> '' then
           DopiszDoWhere( 'M.'+sZLEZLECENIE_OPER_REAL + ' IN ('+Values[sParam_ZLEOperReal]+')', sWhere );
        if Values[sParam_ZLEOperPotwReal] <> '' then
           DopiszDoWhere( 'M.'+sZLEZLECENIE_OPER_POTW_REAL + ' IN ('+Values[sParam_ZLEOperPotwReal]+')', sWhere );
        if Values[sParam_ZLEOsobaAkcept] <> '' then
           DopiszDoWhere( 'M.'+sZLEZLECENIE_OSOBA_AKCEPT + ' IN ('+Values[sParam_ZLEOsobaAkcept]+')', sWhere );
        if Values[sParam_ZLEOsobaReal] <> '' then
           DopiszDoWhere( 'M.'+sZLEZLECENIE_OSOBA_REAL + ' IN ('+Values[sParam_ZLEOsobaReal]+')', sWhere );
        if Values[sParam_ZLEOsobaPotwReal] <> '' then
           DopiszDoWhere( 'M.'+sZLEZLECENIE_STATUS_OSOBA + ' IN ('+Values[sParam_ZLEOsobaPotwReal]+')', sWhere );

        // punkt
        if Values[sINFPUNKT_ID] <> '' then
           DopiszDoWhere( 'M.'+sINFPUNKT_ID+' = '+Values[sINFPUNKT_ID], sWhere );

        DodajZakresPolUZ(oParams, GridColDefs, sWhere);
      end;

      if ZLEDM.vZLEKontrolaUprawnionych then begin
         {Pobieramy kdosoba_id z smuser}  //sTabela, sAtrybuty, sWarunek: string; bUnikalny: boolean; iFirmaID: integer
         try
           iOsobaID := StrToInt(SQLManager.OpenQueryWithResult('SELECT ' + sKDOSOBA_ID + ' ' +
                                                               'FROM %s ' +
                                                               'WHERE ' + sSMUSER_ID + '=' + IntToStr(SecurityManager.UserId),
                                                               [sSMUSER]));
         except
           iOsobaID := 0;
         end;

         if iOsobaID = 0 then begin
            Komunikat(cError, 'W ustawieniach moduu wczono '#13+
                              'kontrol uytkowniow zaangaowanych,'#13 +
                              'ale aktywny operator nie ma powizania z osob');
            Abort;
         end;

         DopiszDoWhere('1 = (CASE WHEN M.' + sZLEZLECENIE_OSOBA_ODP + ' = ' + IntToStr(iOsobaID) + ' OR ' +
                                      'M.' + sZLEZLECENIE_STATUS_OSOBA + ' = ' + IntToStr(iOsobaID) + ' OR ' +
                                      'M.' + sZLEZLECENIE_OSOBA_AKCEPT + ' = ' + IntToStr(iOsobaID) + ' OR ' +
                                      'M.' + sZLEZLECENIE_OSOBA_REAL + ' = ' + IntToStr(iOsobaID) + ' OR ' +
                                      'M.' + sZLEZLECENIE_OPER_AKCEPT + ' = ' + IntToStr(SecurityManager.UserId) + ' OR ' +
                                      'M.' + sZLEZLECENIE_OPER_ODP + ' = ' + IntToStr(SecurityManager.UserId) + ' OR ' +
                                      'M.' + sZLEZLECENIE_OPER_REAL + ' = ' + IntToStr(SecurityManager.UserId) + ' OR ' +
                                      'M.' + sZLEZLECENIE_OPER_POTW_REAL + ' = ' + IntToStr(SecurityManager.UserId) + ' OR ' +
                                      'M.' + sZLEZLECENIE_UZ_AU_ID + ' = ' + IntToStr(SecurityManager.UserId) + ' OR ' +
                                      'M.' + sZLEZLECENIE_UZ_ZM_ID + ' = ' + IntToStr(SecurityManager.UserId) + ' OR ' +
                                      'EXISTS ( SELECT RF.' + sSMROLA_ID + ' ' +
                                               'FROM ' + SQLManager.GetTableName(sSMROLAFUNK) + ' RF, ' +
                                                         SQLManager.GetTableName(sSMUSERROLA) + ' UR, ' +
                                                         SQLManager.GetTableName(sSMFUNKCJONALNOSC) + ' FUNK ' +
                                               'WHERE RF.' + sSMROLA_ID + ' = UR.' + sSMROLA_ID +
                                                 ' AND FUNK.' + sSMFUNKCJONALNOSC_ID + ' = RF.' + sSMFUNKCJONALNOSC_ID +
                                                 ' AND FUNK.' + sSMFUNKCJONALNOSC_NAZWA + ' = ' + QuotedStr(sZLE_KART_ZLECEN_POTW_EXT_ZLEC) +
                                                 ' AND UR.' + sSMUSER_ID + ' = ' + intToStr(SecurityManager.UserId) + ' ' +
                                               'UNION ' +
                                               'SELECT ' + sSMUSERFUNK_ID + ' ' +
                                               'FROM ' + SQLManager.GetTableName(sSMUSERFUNK) + ' UF, ' +
                                                         SQLManager.GetTableName(sSMFUNKCJONALNOSC) + ' FUNK ' +
                                               'WHERE UF.' + sSMFUNKCJONALNOSC_ID + ' = FUNK.' + sSMFUNKCJONALNOSC_ID +
                                                ' AND FUNK.' + sSMFUNKCJONALNOSC_NAZWA + ' = ' + QuotedStr(sZLE_KART_ZLECEN_POTW_EXT_ZLEC) +
                                                ' AND UF.' + sSMUSER_ID + ' = ' + IntToStr(SecurityManager.UserId) + ') ' +
                                      //' OR ' +
                                     // '(' + SQLManager.GetSPName('UNISYS_PACKAGE.GETLOGONUSERID') + '() = 1) ' + //Unisoft
                                 'THEN 1 ' +
                                 'ELSE 0 ' +
                            'END)', sWhere);
      end;

      if sWhere <> '' then
        GridJoinDefs.ExchangeCondition( iZakresConditionIdx, sWhere, true )
      else
        GridJoinDefs.Items[iZakresConditionIdx].Required := false;
    finally
      if oParams <> nil then oParams.Free;
    end;
  end;
end;

procedure TZLEZlecenieDataModule.DataModuleCreate(Sender: TObject);
begin
  inherited;
//  Parameters := TKeyValues.CreateEmpty;
end;

procedure TZLEZlecenieDataModule.DataModuleDestroy(Sender: TObject);
begin
  inherited;
end;

{ TZLEZlecenieDataModule_SAN }

procedure TZLEZlecenieDataModule_SAN.UstawZakres;
{var
  sKlientID: String;}
begin
  inherited;
  {if Self.ClassName = TSANZlecenieDataModule.ClassName then begin
    sKlientID := '';
    if (Owner is TUNIDBGridForm)and
       (Owner as TUNIDBGridForm).FormIsContained then begin
      sKlientID := (Owner.Owner as TUNIForm).Parameters.Values[sBKKLIENT_ID];
      if idxKlient = -1 then
        idxKlient := GridJoinDefs.AddEmptyCondition();
      if sKlientID <> '' then begin
        GridJoinDefs.ExchangeCondition( idxKlient,
                                        '(ZLEC.'+sZLEZLECENIE_WYKONAWCA_ID+'='+sKlientID+')',
                                        True )
      end else
        GridJoinDefs.ExchangeCondition( idxKlient, '1=0', True );
    end;
  end;}
end;

{ TZLEZlecenieDataModule_SANFakturowanie }

constructor TZLEZlecenieDataModule_SANFakturowanie.Create(
  AOwner: TComponent);
begin
  inherited;
  idcZlecFakt := -1;
end;

procedure TZLEZlecenieDataModule_SANFakturowanie.UstawZakres;
begin
  inherited;
  Dodatki.ADMID_SetJoinOnField( Self,
                                cADMIDFunSANFaktury_Zlecenia,
                                SQLManager.ZSISessionId,
                                Owner.Owner.ClassName+(Owner.Owner as TUNIForm).Suffix,
                                idcZlecFakt,
                                Format( 'M.%s', [sZLEZLECENIE_ID]), 0, True );
end;

initialization
  FormManager.RegisterForm( TZLEZlecenieDataModule,
                            'Modu danych dla zlece', sZLEModulID );
  FormManager.RegisterForm( TZLEZlecenieDataModule_SAN,
                            'Modu danych dla zlece Sanipor', sZLEModulID );
  FormManager.RegisterForm( TZLEZlecenieDataModule_SANFakturowanie,
                            'Modu danych dla zlece Sanipor fakturowanie', sZLEModulID );

end.
