unit ZLEZlecenieUprDBGridFormUnit;
{
Copyright Unisoft Sp. z o.o.

Modu dostarczajcy aktualizacje bazy.
Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2010-12-14 Tomjen   Utworzone
---------------------------------------------------------------------------------------------}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, ExtCtrls, UNIComponentsUnit, Db, DBTables, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  UNIStaleUnit, UNIDataModuleUnit, UNIFormUnit, KeyManagerUnit;

type
  TZLEZlecenieUprDBGridForm = class(TUNIDBGridForm)
    ZakresButton: TUNIButton;
    procedure ZakresButtonClick(Sender: TObject);
  private
    procedure OpenDetail(AOpenMode: TOpenMode);
  protected
    procedure New(); override;
    procedure Open(); override;
    procedure View(); override;
    procedure Delete(); override;
    function  CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure SetUserRights; override;
  public
    procedure InternalOpen(); override;
    procedure GetParametersForForm( AForm: TUNIForm; Parameters: TKeyValues ); override;
  end;

var
  ZLEZlecenieUprDBGridForm: TZLEZlecenieUprDBGridForm;

implementation
uses
  Dodatki,
  FormManagerUnit,
  SecurityManagerUnit,
  UNIDBDetailFormUnit,
  ZLEdefUnit,
  ZleZlecenieUprUnit,
  ZLEDataManagerUnit,
  UNISysDefUnit;

{$R *.DFM}
function TZleZlecenieUprDBGridForm.CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZleZlecenieUprDataModule.CreateOpen(Self, DefaultMasterKeyValues, AOpenMode);
end;

procedure TZleZlecenieUprDBGridForm.Delete;
begin
  OpenDetail(omDelete);
end;

procedure TZleZlecenieUprDBGridForm.GetParametersForForm(AForm: TUNIForm;
  Parameters: TKeyValues);
begin
  Parameters.Assign(Self.Parameters);
  if(DataModule <> nil) and (not DataModule.ActiveQuery.IsEmpty) then
    Parameters.Values[sZLEZLECENIE_ID]  := DMAQFbN(sZLEZLECENIE_ID).AsString
  else
    Parameters.Values[sZLEZLECENIE_ID]  := '-1';
end;

procedure TZleZlecenieUprDBGridForm.InternalOpen;
begin
  if Parameters <> nil then
     if Parameters.Values[cFORM_CAPTION] <> '' then
        Caption := Parameters.Values[cFORM_CAPTION];
  inherited;
end;

procedure TZleZlecenieUprDBGridForm.New;
begin
  OpenDetail(omNew);
end;

procedure TZleZlecenieUprDBGridForm.Open;
begin
  OpenDetail(omEdit);
end;

procedure TZleZlecenieUprDBGridForm.OpenDetail(AOpenMode: TOpenMode);
var
  oParams: TKeyValues;
begin
  inherited;
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add(cFORM_CAPTION+'='+'Szczegoy zlecenia');
  end;

  AOpenMode := AOpenMode;
  FormManager.OpenDBDetail(Self, 'TZleZLecenieDBDetailForm', AOpenMode, oParams);
end;

procedure TZleZlecenieUprDBGridForm.View;
begin
  OpenDetail(omView);
end;

procedure TZLEZlecenieUprDBGridForm.ZakresButtonClick(Sender: TObject);
begin
  if OpenRangeForm() then
    DataModule.ReOpenDataSets();
  DBGrid.SetFocus;
end;

procedure TZleZlecenieUprDBGridForm.SetUserRights;
begin
  with SecurityManager do begin
    Switch_View_HotKey(SM_UserCanDo(sZLE_KART_ZLECEN_UPR_POKAZ));
    Switch_New_HotKey(False{SM_UserCanDo(sZLE_KART_ZLECEN_DOPISZ)});
    Switch_Open_HotKey(False{SM_UserCanDo(sZLE_KART_ZLECEN_ZMIEN)});
    Switch_Delete_HotKey(false{SM_UserCanDo(sZLE_KART_ZLECEN_USUN)});
  end;
end;

initialization
  FormManager.RegisterForm(TZleZlecenieUprDBGridForm, 'Uproszczona lista zlecen', sZLEModulID);
end.
