unit ZLEZlecenieUprUnit;
{
 Copyright Unisoft Sp. z o.o.

Modu dostarczajcy aktualizacje bazy.
Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2010-12-14 Tomjen   Utworzone
---------------------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables, Math;
{  DbClient,  KeyManagerUnit,
   QueryBuilderUnit,UNIDBConstComboBoxUnit, UNIStaleUnit;}

type
  TZLEZlecenieUprDataModule = class(TUNIDataModule)
  protected
    procedure GetKeys; override;
    function  GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;
  public
    procedure Post; override;
    procedure OpenDataSets(); override;
    procedure ReOpenDataSets(); override;
  private
    //m_sZleZlecenieId   : string;
    m_iZleZlecenieIdx  : integer;
    procedure JoinOnField(const iFun: Integer; sFieldName: String; var sConditions: String);
    procedure ComposeConditions();
  end;

var
  ZLEZlecenieUprDataModule: TZLEZlecenieUprDataModule;

implementation
uses
  ZLEDefUnit,
  SQLManagerUnit,
  UNIStaleUnit,
  Dodatki,
  ZLEZlecenieDBDetailFormUnit,
  UNISysDefUnit,
  KeyManagerUnit,
  UNIFormUnit,
  FKDefUnit,
  ZLEDataManagerUnit,
  UNIDataManagerUnit,
  FormManagerUnit,
  SystemDefUnit,
  QueryBuilderUnit,
  SecurityManagerUnit,
  UNIDBFormUnit,
  UNIDBDetailFormUnit,
  UNIDBGridFormUnit,
  UniqueKeyUnit,
  UNISysDataManagerUnit;

{$R *.DFM}
procedure TZLEZLecenieUprDataModule.GetKeys;
begin
  with FKeys do begin
    Clear;
    Add(sZLEZlecenie_ID);
  end;
end;

function TZLEZLecenieUprDataModule.GetTableName: string;
begin
  Result:=sZLEZlecenie;
end;

procedure TZLEZLecenieUprDataModule.JoinOnField(const iFun: Integer;
  sFieldName: String; var sConditions: String);
const cADMID = sADMID+'%d';
var
  sCondition: String;
  oIDs_List: TStringList;
  sCorrel1: String;
  sCorrel2: String;
  iPFun: Integer;
  sRangeClassName: String;
begin
  iPFun := (Owner as TUNIDBGridForm).RangePodFunc;
  sRangeClassName := (Owner as TUNIDBGridForm).RangeClassName;
  oIDs_List := ADMID_CreateAndLoad(iFun, iPFun, SecurityManager.UserId, sRangeClassName );
  try
    sCorrel1 := Copy( sFieldName, 1, Pos( '.', sFieldName )-1 );
    sCorrel2 := Format(cADMID, [iFun]);

    if oIDs_List.Count > 0 then
    begin
      //dodanie warunku
      sCondition := '('+sCorrel2+'.'+sADMID_FUNK+'='+IntToStr(iFun)+')and'+
                  '('+sCorrel2+'.'+sADMID_PFUNK+'='+IntToStr(iPFun)+')and'+
                  '('+sCorrel2+'.'+sSMUSER_ID+'='+IntToStr(SecurityManager.UserId)+')and'+
                  '('+sCorrel2+'.'+sADMID_KONTEKST+'='+QuotedStr(sRangeClassName)+')';
      GridTabDefs.Add(sCorrel2, sADMID);

      DopiszDoWhere(sCondition, sConditions);
    end;

    //dodajemy warunki zlaczenia
    if GridJoinDefs.IndexOfCorrel2( sCorrel2 ) = -1 then
      GridJoinDefs.AddSimple( sCorrel1, sCorrel2, sFieldName+'='+sCorrel2+'.'+sADMID_V, qjkInner, oIDs_List.Count > 0 )
    else
      GridJoinDefs.Items[ GridJoinDefs.IndexOfCorrel2( sCorrel2 ) ].Required := (oIDs_List.Count > 0);
  finally
    oIDs_List.Free;
  end;
end;

procedure TZLEZLecenieUprDataModule.InitializeGridQueryDefs;
var oQuery: TUNIQuery;
    sSQL: String;
begin
  if GridColDefs.Count = 0 then with GridColDefs do begin
    AddRequired(sZLEZLECENIE_ID,   'M','', False, taLeftJustify,0);
    AddRequired( sZLEZLECENIE_SYMBOL, 'M', 'Symbol', True, taLeftJustify, 90 );
    Add(sZLEZlecenie_NAZWA,   'M','Nazwa',True,True,  taLeftJustify,200);

    Add( sZLEZLECENIE_DATA_OTW, 'M', 'Data otwarcia', True, True, taLeftJustify, 70 );
    Add( sZLEZLECENIE_DATA_ZAMK, 'M', 'Data zamknicia', True, True, taLeftJustify, 70 );
    AddRequiredAndUnvisible( sZLETYPZLEC_ID, 'M', '', True );
    AddRequiredAndUnvisible( sUNIROK_ID, 'M', '', True );
    Add( sUNIRok_ROK_TEXT, 'R', 'Rok', True, True, taLeftJustify, 50 );
    Add( sZLETYPZLEC_SYMBOL, 'T', 'Symbol typu zlecenia', True, True, taLeftJustify, 50 );
    Add( sZLETYPZLEC_NAZWA, 'T', 'Nazwa typu zlecenia', True, True, taLeftJustify, 150 );
    AddRequiredAndUnvisible( sUNIODDZIAL_ID, 'M', '', True );
    AddRequiredAndUnvisible( sZLEZLECENIE_LICZNIK, 'M', '', True );
    if vWieloodzialowosc then begin
      Add( sUNIODDZIAL_Symbol, 'O', 'Oddzia', True, True, taLeftJustify, 70 );
      Add( sUNIODDZIAL_NAZWA, 'O', 'Nazwa oddziau', True, True, taLeftJustify, 150 );
    end else if vWielofirmowosc then begin
      Add( sUNIODDZIAL_SYMBOL, 'O', 'Firma', True, True, taLeftJustify, 70 );
      Add( sUNIODDZIAL_NAZWA, 'O', 'Nazwa firmy', True, True, taLeftJustify, 150 );
    end;

    AddRequiredAndUnvisible( sUNIMODULZSI_ID, 'M', '', True  );
    Add( sUNIMODULZSI_KOD, 'MD', 'rdo', True, True, taLeftJustify, 80 );

    AddRequiredAndUnvisible( sUNIJEDNOSTKAORG_ID, 'M', '', True );
    Add( sUNIJEDNOSTKAORG_SYMBOL, 'W', 'Jednostka organizacyjna', True, True, taLeftJustify, 70 );
    Add( sUNIJEDNOSTKAORG_NAZWA, 'W', 'Nazwa jednostki org.', True, True, taLeftJustify, 150 );
    AddRequiredAndUnvisible( sZLEZLECENIE_STATUS, 'M', '' );
    AddRequired( sZLECONST_STATUS_V, 'ST', 'Status', True, taLeftJustify, 80 );

    oQuery := nil;
    sSQL := UNISysDM.UNIOdpytajODaneSQL( sFKMNEMONIKI, sFKAlias_Mnemoniki_Indeks + ';' + sFKAlias_Mnemoniki_Dlugosc,
                                         '(@'+sFKAlias_Mnemoniki_Mnemonik+'='+QuotedStr(sMnemonikZlecenie)+')and'+
                                         '(@'+sFKAlias_Mnemoniki_Dlugosc+'>0)',
                                         False, UNISysDM.vAktywnaFirma );
    try
      oQuery := SQLManager.CreateQuery( sSQL );
      oQuery.Open;
      if oQuery.Locate( sFKMNEMONIKI_INDEKS, 1, [] ) then
        Add( sZLEZLECENIE_POLE1, 'M', 'Pole 1', True, True, taLeftJustify, 80 );
      if oQuery.Locate( sFKMNEMONIKI_INDEKS, 2, [] ) then
        Add( sZLEZLECENIE_POLE2, 'M', 'Pole 2', True, True, taLeftJustify, 80 );
      if oQuery.Locate( sFKMNEMONIKI_INDEKS, 3, [] ) then
        Add( sZLEZLECENIE_POLE3, 'M', 'Pole 3', True, True, taLeftJustify, 80 );
    finally
      if oQuery <> nil then oQuery.Free;
    end;
  end;

  if GridTabDefs.Count=0 then with GridTabDefs do begin
    Clear;
    Add('M',GetTableName);
    if vWieloodzialowosc or vWieloFirmowosc then
       Add( 'O', sUNIODDZIAL );
    Add( 'T',   sZLETYPZLEC );
    Add( 'ST',  sZLECONST_STATUS );
    Add( 'W',   sUNIJEDNOSTKAORG );
    Add( 'R',   sUNIROK );
    Add( 'MD',  sUNIMODULZSI );
  end;

  with GridJoinDefs do begin
    Clear;
    if vWieloodzialowosc or
       (vWielofirmowosc and ZLEDM.vZLEWspolneZlecenia) or
       (vWielofirmowosc and UNISYSDM.vWielofirmowoscWieleFirm) then
      AddSimple( 'M', 'O', 'M.'+sUNIODDZIAL_ID+'=O.'+sUNIODDZIAL_ID, qjkLeftOuter, True )
    else if vWielofirmowosc and
            (not (ZLEDM.vZLEWspolneZlecenia or UNISYSDM.vWielofirmowoscWieleFirm)) then begin
      AddCondition( 'M.'+sUNIODDZIAL_ID+'='+IntToStr(vAktywnaFirma), True );
      AddSimple( 'M', 'O', 'M.'+sUNIODDZIAL_ID+'=O.'+sUNIODDZIAL_ID, qjkLeftOuter, True )
    end;

    AddSimple( 'M', 'MD',  'M.'+sUNIMODULZSI_ID+'=MD.'+sUNIMODULZSI_ID, qjkInner, True );
    AddSimple( 'M', 'T',   'M.'+sZLETYPZLEC_ID+'=T.'+sZLETYPZLEC_ID, qjkInner, True );
    AddSimple( 'M', 'ST',  'M.'+sZLEZLECENIE_STATUS+'=ST.'+sZLECONST_STATUS_ID, qjkInner, True );
    AddSimple( 'M', 'W',   'M.'+sUNIJEDNOSTKAORG_ID+'=W.'+sUNIJEDNOSTKAORG_ID, qjkLeftOuter, True );
    AddSimple( 'M', 'R',   'M.'+sUNIROK_ID+'=R.'+sUNIROK_ID, qjkLeftOuter, True );
    m_iZleZlecenieIdx := AddEmptyCondition();
  end;

  ComposeConditions();
  inherited;
end;

procedure TZLEZLecenieUprDataModule.Post;
  var
    trans:boolean;
begin
  trans:= not SQLManager.InTransaction;
  if trans then SQLManager.StartTransaction;
  try
    inherited;
    if trans then SQLManager.Commit;
  except
    on EDMException do begin
      if trans then SQLManager.Rollback;
      if FLastDBError.SQLObjectName=sZLEZlecenie+'1'+c_UNK then begin
        Komunikat( cError,'Istnieje ju zlecenie o takim symbolu/nazwie');
        {with owner as TZLEBrakiDBDetailForm do
           ActiveControl:= SymbolDBEdit;}
        abort;
      end else raise;
    end else begin
      if trans then SQLManager.Rollback;
      raise;
    end;
  end;

end;

procedure TZLEZLecenieUprDataModule.OpenDataSets;
begin
  ComposeConditions();
  inherited;
end;

procedure TZLEZLecenieUprDataModule.ReOpenDataSets;
begin
  //ComposeConditions();
  inherited;
end;


procedure TZLEZLecenieUprDataModule.ComposeConditions();
var
    oParams:        TKeyValues;
    sDopisz, sWhere: String;
    iIndex: Integer;
    iStatusKod: Integer;
    sTmp: String;
begin
  oParams := nil;
  sWhere := '';

  if (Owner is TUNIDBGridForm) then begin
    try
      oParams := TKeyValues.CreateEmpty();
      (Owner as TUNIDBForm).GetParametersForForm( (Owner as TUNIDBForm), oParams );
      if oParams = nil then exit;
      with oParams do begin
        //symbol zlecenia
        sDopisz := '';
        if (Values[sParam_ZLESymbolOd] <> '')and(Values[sParam_ZLESymbolDo] <> '') then begin
          sTmp := Values[sParam_ZLESymbolDo];
          if length(Values[sParam_ZLESymbolDo]) < UNISysDM.vMaxDLSymboluZle then begin
             {Uzupeniamy SymbolDo liter 'Z' do dugoci maxymalnej dugoci symbolu zlecenia}
             //sTmp := Values[sParam_ZLESymbolDo];
             while (length(sTmp) < UNISysDM.vMaxDLSymboluZle) do
               sTmp := sTmp + 'Z';
          end;

          sDopisz :=  '(M.'+sZLEZLECENIE_SYMBOL+'>='+QuotedStr(Values[sParam_ZLESymbolOd])+ ') and ' +
                      '(M.'+sZLEZLECENIE_SYMBOL+'<='+QuotedStr(sTmp) + ') ';
        end else if Values[sParam_ZLESymbolOd] <> '' then begin
          sDopisz := 'M.'+sZLEZLECENIE_SYMBOL+'>='+QuotedStr(Values[sParam_ZLESymbolOd]);
        end else if Values[sParam_ZLESymbolDo] <> '' then begin
          sDopisz := 'M.'+sZLEZLECENIE_SYMBOL+'<='+QuotedStr(Values[sParam_ZLESymbolDo]);
        end;
        if sDopisz <> '' then DopiszDoWhere( sDopisz, sWhere );

        //nazwa zlecenia
        sDopisz := '';
        if (Values[sParam_ZLENazwaOd] <> '')and(Values[sParam_ZLENazwaDo] <> '') then begin
          sDopisz := 'M.'+sZLEZLECENIE_NAZWA+' between '+
                     QuotedStr(Values[sParam_ZLENazwaOd])+' and '+
                     QuotedStr(Values[sParam_ZLENazwaDo]);
        end else if Values[sParam_ZLENazwaOd] <> '' then begin
          sDopisz := 'M.'+sZLEZLECENIE_NAZWA+'>='+QuotedStr(Values[sParam_ZLENazwaOd]);
        end else if Values[sParam_ZLENazwaDo] <> '' then begin
          sDopisz := 'M.'+sZLEZLECENIE_NAZWA+'<='+QuotedStr(Values[sParam_ZLENazwaDo]);
        end;
        if sDopisz <> '' then DopiszDoWhere( sDopisz, sWhere );

        //data otwarcia
        sDopisz := '';
        if (Values[sParam_ZLEDataOtwOd] <> '')and(Values[sParam_ZLEDataOtwOd] <> '0')and
           (Values[sParam_ZLEDataOtwDo] <> '')and(Values[sParam_ZLEDataOtwDo] <> '0') then begin
          sDopisz := 'M.'+sZLEZLECENIE_DATA_OTW+' between '+
                     KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataOtwOd]))+' and '+
                     KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataOtwDo]));
        end else if (Values[sParam_ZLEDataOtwOd] <> '')and(Values[sParam_ZLEDataOtwOd] <> '0') then begin
          sDopisz := 'M.'+sZLEZLECENIE_DATA_OTW+'>='+KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataOtwOd]));
        end else if (Values[sParam_ZLEDataOtwDo] <> '')and(Values[sParam_ZLEDataOtwDo] <> '0') then begin
          sDopisz := 'M.'+sZLEZLECENIE_DATA_OTW+'<='+KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataOtwDo]));
        end;
        if sDopisz <> '' then DopiszDoWhere( sDopisz, sWhere );

        //data Zakonczenia
        sDopisz := '';
        if (Values[sParam_ZLEDataZakOd] <> '')and(Values[sParam_ZLEDataZakOd] <> '0')and
           (Values[sParam_ZLEDataZakDo] <> '')and(Values[sParam_ZLEDataZakDo] <> '0') then begin
          sDopisz := 'M.'+sZLEZLECENIE_DATA_ZAMK+' between '+
                     KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataZakOd]))+' and '+
                     KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataZakDo]));
          if Values['NIEZAKONCZONE'] = 'T' then
             sDopisz := '(' + sDopisz + ') OR (M.'+sZLEZLECENIE_DATA_ZAMK + ' IS NULL)';
        end else if (Values[sParam_ZLEDataZakOd] <> '')and(Values[sParam_ZLEDataZakOd] <> '0') then begin
          sDopisz := 'M.'+sZLEZLECENIE_DATA_ZAMK+'>='+KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataZakOd]));
          if Values['NIEZAKONCZONE'] = 'T' then
             sDopisz := '(' + sDopisz + ') OR (M.'+sZLEZLECENIE_DATA_ZAMK + ' IS NULL)';
        end else if (Values[sParam_ZLEDataZakDo] <> '')and(Values[sParam_ZLEDataZakDo] <> '0') then begin
          sDopisz := 'M.'+sZLEZLECENIE_DATA_ZAMK+'<='+KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataZakDo]));
          if Values['NIEZAKONCZONE'] = 'T' then
             sDopisz := '(' + sDopisz + ') OR (M.'+sZLEZLECENIE_DATA_ZAMK + ' IS NULL)';
        end;

        if sDopisz <> '' then DopiszDoWhere( sDopisz, sWhere );

        //przelicz - na razie filtrujemy tylko z wczonym przeliczaniem albo wszystko
        if Values[sParam_ZLEPrzelicz] = sTak then
            DopiszDoWhere( 'M.'+sZLEZLECENIE_PRZELICZ+ ' = '+ QuotedStr(Values[sParam_ZLEPrzelicz]), sWhere );

        //Pojazd
        if Values[sParam_ZLEPOjazdID] <> '' then
            DopiszDoWhere( 'M.'+sUNIPOJSP_ID+' in ('+Values[sParam_ZLEPOjazdID]+')', sWhere );

        //status zlecenia
        sDopisz := '';
        if Values[sParam_ZLEStatusZlec] <> '' then begin
          iStatusKod := StrToInt(Values[sParam_ZLEStatusZlec]);
          for iIndex := 0 to cslZLEStatusZlecenia.Count-1 do begin
            if iStatusKod and Round(Power( 2, iIndex )) <> 0 then begin
              if sDopisz <> '' then sDopisz := sDopisz + ',';
              sDopisz := sDopisz + QuotedStr(cslZLEStatusZlecenia.ZwrocSkrot(iIndex));
            end;
          end;
          if sDopisz <> '' then sDopisz := 'M.'+sZLEZLECENIE_STATUS+' in ('+sDopisz+')';
        end;
        if sDopisz <> '' then DopiszDoWhere( sDopisz, sWhere );

        // Operator wprowadzajacy
        if Values[sParam_ZLEOperatorWprowadz] <> '' then
            DopiszDoWhere( 'M.'+sZLEZLECENIE_UZ_AU_ID+' in ('+Values[sParam_ZLEOperatorWprowadz]+')', sWhere );

        //typ zlecenia
        if Values[sParam_ZLETypZlec] <> '' then
            DopiszDoWhere( 'T.'+sZLETYPZLEC_ID+' in ('+Values[sParam_ZLETypZlec]+')', sWhere );

        //Kontrahent
        if Values[sParam_ZLEKlientID] <> '' then
           DopiszDoWhere( 'M.'+sZLEZLECENIE_WYKONAWCA_ID+' in ('+Values[sParam_ZLEKlientID]+')', sWhere );

        //modu rdowy
        if Values[sParam_ZLEModulZSI] <> '' then
            DopiszDoWhere( 'M.'+sUNIMODULZSI_ID+' in ('+Values[sParam_ZLEModulZSI]+')', sWhere );

        if (vWielofirmowosc and ZLEDM.vZLEWspolneZlecenia) or (vWieloodzialowosc) then
           if Values[sUNIODDZIAL_ID] <> '' then
              DopiszDoWhere( 'M.'+sUNIODDZIAL_ID+' in ('+Values[sUNIODDZIAL_ID]+')', sWhere );

        //Jednostka organizacyjna
        if Values[sUNIJEDNOSTKAORG_ID] <> '' then
           DopiszDoWhere( 'M.'+sUNIJEDNOSTKAORG_ID + ' IN ('+Values[sUNIJEDNOSTKAORG_ID]+')', sWhere );

        //osoba odpowiedzialna
        JoinOnField( cADMIDFuncZLEOsoba, 'M.'+sZLEZLECENIE_OSOBA_ODP, sWhere );

        //zasb
        JoinOnField( cADMIDFuncZLEZasob, 'M.'+sZLEZLECENIE_ID, sWhere );

        if ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0) then begin
           if Values[sParam_ZLEPrefixID] <> '' then
              DopiszDoWhere( 'M.'+sZLEZLECENIE_PREFIX_ID+' in ('+Values[sParam_ZLEPrefixID]+')', sWhere );
        end;

        //Zlecenie nadrzdne
        if Values[sParam_ZlecNadrzedneID] <> '' then begin
           if Values[sParam_ZlecNadrzednePokaz] = 'T' then
             DopiszDoWhere( '((M.' + sZLEZLECENIE_GRUPA_ID + ' IN (' + Values[sParam_ZlecNadrzedneID] + ')) OR (M.' + sZLEZLECENIE_ID + ' IN (' + Values[sParam_ZlecNadrzedneID] + ')))', sWhere)
           else
             DopiszDoWhere( 'M.' + sZLEZLECENIE_GRUPA_ID + ' IN (' + Values[sParam_ZlecNadrzedneID] + ')', sWhere);
        end;

      end;

      {if TZLEZlecenieUprDBGridForm(Owner).FormIsContained and (not ParamIsNotEmpty(MasterKeyValues, sZLEZlecenie_ID, m_sZleZlecenieId)) then begin
        ParamIsNotEmpty(oParams, sZLEZlecenie_ID, m_sZleZlecenieId);
        if (Length(m_sZleZlecenieId) > 0) and (m_sZleZlecenieId <> '-1') then
          DopiszDoWhere('M.' + sZLEZlecenie_ID  + ' = ' + m_sZleZlecenieId, sWhere);
      end;  // if nie ma id zlecenia w MasterKeyValues}
      if sWhere <> '' then
        GridJoinDefs.ExchangeCondition( m_iZleZlecenieIdx, sWhere, true )
      else
        GridJoinDefs.Items[m_iZleZlecenieIdx].Required := false;
    finally
      if oParams <> nil then oParams.Free;
    end;
  end;
end;

end.
