unit ZLEZlecenieWycenaDBDetailFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2008-01-14 Adam     Utworzone
2008-03-10 Adam     Zwikszona precyzja pola sZLEZLECENIEWYC_KOSZT
2008-08-28 Adam     Dodane pole status
---------------------------------------------------------------------------------------------}
interface

uses
  UNIStaleUnit, UNIDataModuleUnit, UNIDBGridFormUnit, UNIFormUnit, KeyManagerUnit,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBDetailFormUnit, Menus, UNIComponentsUnit, Db, ToolWin, ComCtrls,
  StdCtrls, ExtCtrls, Mask, DBCtrls, UNIDBConstComboBoxUnit;

type
  TZLEZlecenieWycenaDBDetailForm = class(TUNIDBDetailForm)
    UNIGroupBox1: TUNIGroupBox;
    ZlecSymbolEdit: TUNIEdit;
    UNILabel2: TUNILabel;
    UNILabel1: TUNILabel;
    ZlecNazwaEdit: TUNIEdit;
    UNIGroupBox2: TUNIGroupBox;
    UNILabel3: TUNILabel;
    UNILabel4: TUNILabel;
    ZasSymbolEdit: TUNIEdit;
    ZasNazwaEdit: TUNIEdit;
    UNIGroupBox3: TUNIGroupBox;
    UNILabel5: TUNILabel;
    UNILabel6: TUNILabel;
    UNILabel7: TUNILabel;
    PracaKosztDBEdit: TUNIDBEdit;
    PracaCzasEdit: TUNIEdit;
    PracaIloscEdit: TUNIEdit;
    UNILabel8: TUNILabel;
    StatusDBConstComboBox: TUNIDBConstComboBox;
  public
    function  Validate(): boolean;  override;

  protected
    function  CreateDataModule(
                    const AOpenMode:  TOpenMode
              ): TUNIDataModule; override;
   procedure BeforeShow();  override;

  private
    procedure SetControlProperties();

  end;

implementation
uses
  FormManagerUnit,
  SecurityManagerUnit,
  ZLEZlecenieWycenaUnit,
  ZLEDefUnit
  ;

{$R *.DFM}

function  TZLEZlecenieWycenaDBDetailForm.Validate(): boolean;
begin
  result  := inherited  Validate();
  if(DMAQFbN(sZLEZLECENIEWYC_KOSZT).IsNull) then
    DMAQFbN(sZLEZLECENIEWYC_KOSZT).AsCurrency := 0;
end;

function  TZLEZlecenieWycenaDBDetailForm.CreateDataModule(
  const AOpenMode:  TOpenMode
): TUNIDataModule;
begin
  result  := TZLEZlecenieWycenaDataModule.CreateOpen(
    self,
    DefaultMasterKeyValues,
    AOpenMode
  );
end;

procedure TZLEZlecenieWycenaDBDetailForm.BeforeShow();
begin
  inherited;
  SetControlProperties();
end;

procedure TZLEZlecenieWycenaDBDetailForm.SetControlProperties();
var
  oDataSet: TDataSet;
begin
  oDataSet  := (Owner as TUNIDBGridForm).DataModule.ActiveQuery;
  ZlecSymbolEdit.Text         := oDataSet.FieldByName(sZLEZLECENIE_SYMBOL).AsString;
  ZlecNazwaEdit.Text          := oDataSet.FieldByName(sZLEZLECENIE_NAZWA).AsString;
  ZasSymbolEdit.Text          := oDataSet.FieldByName(sZLEZASOB_SYMBOL).AsString;
  ZasNazwaEdit.Text           := oDataSet.FieldByName(sZLEZASOB_NAZWA).AsString;
  PracaCzasEdit.Text          := oDataSet.FieldByName(csWycena_CzasPracy + '_U').AsString;
  PracaIloscEdit.Text         := oDataSet.FieldByName(csWycena_IloscPracy + '_U').AsString;
  PracaKosztDBEdit.DataField  := sZLEZLECENIEWYC_KOSZT;
  PracaKosztDBEdit.aNumbersOnly   := true;
  PracaKosztDBEdit.aIntegerCount  := 8;
  PracaKosztDBEdit.aDecimalCount  := 6;
  PracaKosztDBEdit.ReadOnly       := (DMAQFbN(sZLEZLECENIEWYC_STATUS).AsString <> cZLEConstZleWycenaStatus_WprowadzonyID);
  if(OpenMode = omNew) then
    DMAQFbN(sZLEZLECENIEWYC_STATUS).AsString  := cZLEConstZleWycenaStatus_WprowadzonyID;
  StatusDBConstComboBox.Items.Assign(cslZLEConstZleWycenaStatus);
  StatusDBConstComboBox.DataField := sZLEZLECENIEWYC_STATUS;
  StatusDBConstComboBox.Enabled := (
    (OpenMode in [omNew, omEdit]) and
    (
      (
        (DMAQFbN(sZLEZLECENIEWYC_STATUS).AsString <> cZLEConstZleWycenaStatus_ZaakceptowanyID) and
        SecurityManager.SM_UserCanDo(sZLE_KART_ZLECEN_WYCENA_AKCEPTUJ)
      ) or (
        (DMAQFbN(sZLEZLECENIEWYC_STATUS).AsString = cZLEConstZleWycenaStatus_ZaakceptowanyID) and
        SecurityManager.SM_UserCanDo(sZLE_KART_ZLECEN_WYCENA_COFNIJ_AKCEPT)
      )
    )
  );
end;

initialization
  FormManager.RegisterForm(TZLEZlecenieWycenaDBDetailForm, sZLEModulID);
end.
