unit ZLEZlecenieWycenaUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2008-01-11 Adam     Utworzone
2008-02-19 Adam     Zmieniony typ pola LWPRECEPPOZ_OPIS na CLOB
2008-03-10 Adam     Zwikszona precyzja pola sZLEZLECENIEWYC_KOSZT
2008-08-28 Adam     Dodane pole status
2008-09-16 Adam     Rzutowanie CLOBA na VARCHAR2(250) aby nie byo problemw z Blobs to cache
2008-09-30 Adam     Rzutowanie CLOBA na VARCHAR2 przy uyciu funkcji RzutujCLOBNaVarchar2
---------------------------------------------------------------------------------------------}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLEZlecenieWycenaDataModule = class(TUNIDataModule)
  public
    procedure ReOpenDataSets(); override;

  protected
    procedure GetKeys(); override;
    function  GetTableName(): string; override;
    procedure InitializeGridQueryDefs(); override;

  private
    m_iZlecenieIndeks:  integer;

    procedure ComposeConditions();

  end;

const
  csWycena_IloscPracy = 'IL_PRACY';
  csWycena_CzasPracy  = 'IL_CZASU';

implementation
uses
  QueryBuilderUnit,
  KeyManagerUnit,
  SQLManagerUnit,
  UNIDBGridFormUnit,
  UNIDataManagerUnit,
  Dodatki,
  UNIStaleUnit,
  UNISysDefUnit,
  LWPDefUnit,
  ZLEDefUnit
  ;

{$R *.DFM}

procedure TZLEZlecenieWycenaDataModule.ReOpenDataSets();
begin
  ComposeConditions();
  inherited;
end;

procedure TZLEZlecenieWycenaDataModule.GetKeys();
begin
  FKeys.AddPrimary(sZLEZLECENIEWYC_ID);
end;

function  TZLEZlecenieWycenaDataModule.GetTableName(): string;
begin
  Result  := sZLEZLECENIEWYC;
end;

procedure TZLEZlecenieWycenaDataModule.InitializeGridQueryDefs();
begin
  with GridColDefs do begin
    Clear();
      // ten grid jest wywietlany tylko gdy dostpny jest modu LWP wic tutaj nie trzeba sprawdza jego dostpnoci
    Add(sLWPRECEPPOZ_KOLEJNOSC  , sLWPAlias_RecepturaPoz  , 'Kolejno pozycji receptury', true, true, taRightJustify, 80);
    Add(sLWPFAZAPROD_SYMBOL     , sLWPAlias_FazaProdukcji , 'Symbol fazy', true, true, taLeftJustify, 100);
    Add(sLWPFAZAPROD_NAZWA      , sLWPAlias_FazaProdukcji , 'Nazwa fazy', false, true, taLeftJustify, 200);
    Add(
      RzutujCLOBNaVarchar2(sLWPAlias_RecepturaPoz + '.' + sLWPRECEPPOZ_OPIS, sLWPRECEPPOZ_OPIS),
      '', 'Opis pozycji receptury' , false, omWidoczne, taLeftJustify, 200, uftString
    );
    Add(sZLEZASOB_SYMBOL        , 'ZA'                    , 'Symbol zasobu', true, true, taLeftJustify, 100);
    Add(sZLEZASOB_NAZWA         , 'ZA'                    , 'Nazwa zasobu', true, true, taLeftJustify, 150);
    Add(
      '(select ' +
        'sum(nvl(PR.'  + sZLEZASOBYPRACA_IL_PRACY + ', 0))' +
      ' from ' +
        SQLManager.GetTableName(sZLEZASOBYPRACA) + ' PR, ' +
        SQLManager.GetTableName(sLWPRAPORTPRODTYP) + ' LWPRT' +
      ' where ' +
        'PR.' + sZLEZLECENIE_ID + ' = W.' + sZLEZLECENIE_ID + ' and ' +
        'PR.' + sZLEZASOB_ID    + ' = W.' + sZLEZASOB_ID    + ' and ' +
        'PR.' + sZLEZASOBYPRACA_STATUS  + ' = ''' + cZLEConstZasobPracaStatus_ZaakceptowanyID + ''' and ' +
        'PR.' + sLWPRECEPPOZ_ID + ' = W.' + sLWPRECEPPOZ_ID + ' and ' +
        'PR.' + sLWPRAPORTPRODTYP_ID + ' = LWPRT.' + sLWPRAPORTPRODTYP_ID + ' and ' +
        'LWPRT.' + sLWPRAPORTPRODTYP_PROD + ' = ''' + sTak + '''' +
      ');' + csWycena_IloscPracy,
      '', 'Ilo pracy zasobu',
      true, true, taRightJustify, 150, uftNumber
    );
    Add(
      '(select ' +
        'sum(nvl(PR.'  + sZLEZASOBYPRACA_CZAS_PRACY + ', 0))' +
      ' from ' +
        SQLManager.GetTableName(sZLEZASOBYPRACA) + ' PR, ' +
        SQLManager.GetTableName(sLWPRAPORTPRODTYP) + ' LWPRT' +
      ' where ' +
        'PR.' + sZLEZLECENIE_ID + ' = W.' + sZLEZLECENIE_ID + ' and ' +
        'PR.' + sZLEZASOB_ID    + ' = W.' + sZLEZASOB_ID    + ' and ' +
        'PR.' + sZLEZASOBYPRACA_STATUS  + ' = ''' + cZLEConstZasobPracaStatus_ZaakceptowanyID + ''' and ' +
        'PR.' + sLWPRECEPPOZ_ID + ' = W.' + sLWPRECEPPOZ_ID + ' and ' +
        'PR.' + sLWPRAPORTPRODTYP_ID + ' = LWPRT.' + sLWPRAPORTPRODTYP_ID + ' and ' +
        'LWPRT.' + sLWPRAPORTPRODTYP_PROD + ' = ''' + sTak + '''' +
      ');' + csWycena_CzasPracy,
      '', 'Ilo czasu pracy zasobu',
      true, true, taRightJustify, 150, uftNumber
    );
    Add(sZLEZLECENIEWYC_KOSZT   , 'W'                     , 'Koszt', true, true, taRightJustify, 100, uftCounter);
    Add(sZLEZLECENIE_SYMBOL     , 'Z'                     , 'Symbol zlecenia', false, true, taLeftJustify, 100);
    Add(sZLEZLECENIE_NAZWA      , 'Z'                     , 'Nazwa zlecenia', false, true, taLeftJustify, 200);
    Add(sZLEZLECENIEWYC_STATUS  , 'W'                     , 'Status', true, true, taLeftJustify, 100);

    AddRequiredAndUnvisible(sZLEZLECENIEWYC_ID, 'W', '');
    AddRequiredAndUnvisible(sZLEZLECENIE_ID, 'W', '');
    AddRequiredAndUnvisible(sZLEZLECENIE_SYMBOL, 'Z', '');
    AddRequiredAndUnvisible(sZLEZLECENIE_NAZWA, 'Z', '');
    AddRequiredAndUnvisible(sZLEZASOB_SYMBOL, 'ZA', '');
    AddRequiredAndUnvisible(sZLEZASOB_NAZWA, 'ZA', '');
    AddRequiredAndUnvisible(
      '(select ' +
        'sum(nvl(PR.'  + sZLEZASOBYPRACA_IL_PRACY + ', 0))' +
      ' from ' +
        SQLManager.GetTableName(sZLEZASOBYPRACA) + ' PR, ' +
        SQLManager.GetTableName(sLWPRAPORTPRODTYP) + ' LWPRT' +
      ' where ' +
        'PR.' + sZLEZLECENIE_ID + ' = W.' + sZLEZLECENIE_ID + ' and ' +
        'PR.' + sZLEZASOB_ID    + ' = W.' + sZLEZASOB_ID    + ' and ' +
        'PR.' + sZLEZASOBYPRACA_STATUS  + ' = ''' + cZLEConstZasobPracaStatus_ZaakceptowanyID + ''' and ' +
        'PR.' + sLWPRECEPPOZ_ID + ' = W.' + sLWPRECEPPOZ_ID + ' and ' +
        'PR.' + sLWPRAPORTPRODTYP_ID + ' = LWPRT.' + sLWPRAPORTPRODTYP_ID + ' and ' +
        'LWPRT.' + sLWPRAPORTPRODTYP_PROD + ' = ''' + sTak + '''' +
      ');' + csWycena_IloscPracy + '_U',
      '', ''
    );
    AddRequiredAndUnvisible(
      '(select ' +
        'sum(nvl(PR.'  + sZLEZASOBYPRACA_CZAS_PRACY + ', 0))' +
      ' from ' +
        SQLManager.GetTableName(sZLEZASOBYPRACA) + ' PR, ' +
        SQLManager.GetTableName(sLWPRAPORTPRODTYP) + ' LWPRT' +
      ' where ' +
        'PR.' + sZLEZLECENIE_ID + ' = W.' + sZLEZLECENIE_ID + ' and ' +
        'PR.' + sZLEZASOB_ID    + ' = W.' + sZLEZASOB_ID    + ' and ' +
        'PR.' + sZLEZASOBYPRACA_STATUS  + ' = ''' + cZLEConstZasobPracaStatus_ZaakceptowanyID + ''' and ' +
        'PR.' + sLWPRECEPPOZ_ID + ' = W.' + sLWPRECEPPOZ_ID + ' and ' +
        'PR.' + sLWPRAPORTPRODTYP_ID + ' = LWPRT.' + sLWPRAPORTPRODTYP_ID + ' and ' +
        'LWPRT.' + sLWPRAPORTPRODTYP_PROD + ' = ''' + sTak + '''' +
      ');' + csWycena_CzasPracy + '_U',
      '', ''
    );
    AddRequiredAndUnvisible(sZLEZLECENIEWYC_STATUS, 'W', '');
  end;
  with GridTabDefs do begin
    Clear();
    Add('W'                     , GetTableName());
    Add(sLWPAlias_RecepturaPoz  , sLWPRECEPPOZ);
    Add(sLWPAlias_FazaProdukcji , sLWPFAZAPROD);
    Add('Z'                     , sZLEZLECENIE);
    Add('ZA'                    , sZLEZASOB);
  end;
  with GridJoinDefs do begin
    Clear();
    AddExpres(
      'W.'  + sZLEZLECENIE_ID + ' = Z.' + sZLEZLECENIE_ID,
      qjkInner,
      false
    );
    AddExpres(
      'W.'  + sZLEZASOB_ID + ' = ZA.' + sZLEZASOB_ID,
      qjkInner,
      false
    );
    AddExpres(
      'W.'  + sLWPRECEPPOZ_ID + ' = ' + sLWPAlias_RecepturaPoz + '.' + sLWPRECEPPOZ_ID,
      qjkLeftOuter,
      false
    );
    AddExpres(
      sLWPAlias_RecepturaPoz + '.' + sLWPFAZAPROD_ID + ' = ' + sLWPAlias_FazaProdukcji + '.' + sLWPFAZAPROD_ID,
      qjkLeftOuter,
      false
    );

    m_iZlecenieIndeks := AddEmptyCondition();
  end;
  ComposeConditions();

  inherited;
end;

procedure TZLEZlecenieWycenaDataModule.ComposeConditions();
var
  oParams:      TKeyValues;
  sZlecenieId:  string;
begin
  oParams := TKeyValues.CreateEmpty();
  try
    (Owner as TUNIDBGridForm).GetParametersForForm((Owner as TUNIDBGridForm), oParams);
    ParamIsNotEmptyOrZero(oParams, sZLEZLECENIE_ID, sZlecenieId);
  finally
    oParams.Free();
  end;
  if(Length(sZlecenieId) > 0) then begin
    GridJoinDefs.ExchangeCondition(
      m_iZlecenieIndeks,
      'W.'  + sZLEZLECENIE_ID + ' = ' + sZlecenieId,
      true
    );
  end else begin
    GridJoinDefs.ExchangeCondition(
      m_iZlecenieIndeks,
      '',
      false
    );
  end;
end;

end.
