unit ZLEZlecenieZasobUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2005-02-23 gdeyk    Utworzone
2007-11-26 Adam     Dodane pole 'Czas zajtoci' dla zlece produkcyjnych
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables;

type
  TZLEZlecenieZasobDataModule = class(TUNIDataModule)
  private
    idcZlecenie: Integer;
    procedure SetParameters();
  protected
    procedure GetKeys; override;
    function GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;
  public
    procedure ReOpenDataSets(); override;
    procedure Post; override;
    procedure Delete; override;
  end;

implementation

{$R *.DFM}

uses
  QueryBuilderUnit,
  SQLManagerUnit,
  UNIDataManagerUnit,
  UNIFormUnit,
  LWPDefUnit,
  UNIStaleUnit,
  SystemDefUnit,
  UNISysDefUnit,
  ZLEDefUnit;

{ TZLEZlecenieZasobDataModule }

procedure TZLEZlecenieZasobDataModule.Delete;
var
  bTrans: Boolean;
begin
  bTrans := not SQLManager.InTransaction;
  try
    if bTrans then SQLManager.StartTransaction;
    inherited;
    if bTrans then SQLManager.Commit;
  except
    if bTrans then SQLManager.Rollback;
  end;
end;

procedure TZLEZlecenieZasobDataModule.GetKeys;
begin
  with FKeys do begin
    AddPrimary(sZLEZlecenieZasob_ID);
  end;
end;

function TZLEZlecenieZasobDataModule.GetTableName: string;
begin
  result := sZLEZlecenieZasob;
end;

procedure TZLEZlecenieZasobDataModule.InitializeGridQueryDefs;
begin
  idcZlecenie := -1;
  with GridColDefs do begin
    AddRequiredAndUnvisible( sZLEZlecenieZasob_ID, 'M', '' );
    AddRequiredAndUnvisible( sZLEZLECENIE_ID, 'M', '' );
    AddRequiredAndUnvisible( sZLEZASOB_ID, 'M', '' );
    AddRequired( sZLEZASOB_NAZWA, 'Z', 'Nazwa', True, taLeftJustify, 100 );
    Add( sKDOSOBA_SYMBOL, 'OS', 'Symbol zasobu', False, True, taLeftJustify, 80 );
    Add( sZLEZASOB_STAWKA, 'Z', 'Stawka', True, True, taRightJustify, 50, uftCurrency );
    AddRequiredAndUnvisible( sZLEZASOB_RODZAJ, 'Z', '' );
    Add( sZLECONST_RODZAJZASOBU_V, 'RZ', 'Rodzaj', True, True, taLeftJustify, 100 );
    Add( '(select sum(ROZL.'+sZLEZLECENIEROZL_GODZINY+') '+
         'from '+SQLManager.GetTableName(sZLEZLECENIEROZL)+' ROZL, '+
         SQLManager.GetTableName(sZLEZLECENIEPOZ)+' POZ '+
         'where (ROZL.'+sZLEZASOB_ID+'=Z.'+sZLEZASOB_ID+')AND'+
         '(ROZL.'+sZLEZLECENIEPOZ_ID+'=POZ.'+sZLEZLECENIEPOZ_ID+')AND'+
         '(POZ.'+sZLEZLECENIE_ID+'=M.'+sZLEZLECENIE_ID+'));'+sZLEZLECENIEROZL_GODZINY,
         '', 'Ilo godzin pracy', False, True, taRightJustify, 70, uftCurrency );
    if(DataManagers.Available(sLWPModulID)) then begin
      Add(sLWPRECEPPOZ_KOLEJNOSC, sLWPAlias_RecepturaPoz, 'Kolejno faz', True, True, taRightJustify, 80, uftNumber);
      Add(sZLEZLECENIEZASOB_WYD, 'M', 'Norma wydajnoci', True, True, taRightJustify, 80, uftNumber);
      Add(sLWPJEDNCZAS_SYMBOL +';'+ sLWPAlias_ZasobWydJednCzas_Symbol, sLWPAlias_ZasobWydJednCzas, 'Jednostka czasu normy wydajnoci', True, True, taLeftJustify, 80);
      Add(sLWPJEDNCZAS_NAZWA  +';'+ sLWPAlias_ZasobWydJednCzas_Nazwa, sLWPAlias_ZasobWydJednCzas, 'Nazwa jednostki czasu normy wydajnoci', False, True, taLeftJustify, 100);
      Add(sZLEZLECENIEZASOB_PLAN, 'M', 'Planowanie', False, True, taLeftJustify, 80);
      Add(sZLEZLECENIEZASOB_OBCIAZ, 'M', 'Obcienie', False, True, taRightJustify, 80, uftNumber);
      Add(sLWPJEDNCZAS_SYMBOL, sLWPAlias_Jednostka, 'Jednostka czasu obcienia', False, True, taLeftJustify, 80);
      Add(sLWPJEDNCZAS_NAZWA, sLWPAlias_Jednostka, 'Nazwa jednostki czasu obcienia', False, True, taLeftJustify, 100);
      Add(
        '(CASE WHEN ' +
          'M.'  + sZLEZLECENIEZASOB_WYD + ' = 0 or ' +
          'M.'  + sZLEZLECENIEZASOB_PLAN + ' is null or ' +
          'M.'  + sZLEZLECENIEZASOB_PLAN + ' <> ''' + sTak + '''' +
          ' THEN NULL' +
          ' ELSE ' +
            sZLEALIAS_ZLECENIE  + '.' + sZLEZLECENIE_ILOSC + ' / ' +
              'M.'  + sZLEZLECENIEZASOB_WYD +
          ' END' +
        ');CzasZaj',
        '',
        'Czas zajtoci',
        True,
        True,
        taRightJustify,
        100,
        uftCounter
      );
      Add(sLWPJEDNCZAS_SYMBOL+';ZajJednSymb', sLWPAlias_Jednostka, 'Jednostka czasu zajtoci', True, True, taLeftJustify, 80);
      Add(sLWPJEDNCZAS_NAZWA+';ZajJednNazwa', sLWPAlias_Jednostka, 'Nazwa jednostki czasu zajtoci', False, True, taLeftJustify, 100);
    end;  // if(DataManagers.Available(sLWPModulID))
    AddRequiredAndUnvisible(sLWPRECEPPOZZASOB_ID, 'M', '' );
  end;
  with GridTabDefs do begin
    Add( 'M', TableName );
    Add( 'Z', sZLEZASOB );
    Add( 'RZ', sZLECONST_RODZAJZASOBU );
    Add( 'OS', sKDOSOBA );
    if(DataManagers.Available(sLWPModulID)) then begin
      Add(sLWPAlias_Jednostka, sLWPJEDNCZAS);
      Add(sLWPAlias_ZasobWydJednCzas, sLWPJEDNCZAS);
      Add(sZLEALIAS_ZLECENIE, sZLEZLECENIE);
      Add(sLWPAlias_RecepturaPozZasob , sLWPRECEPPOZZASOB);
      Add(sLWPAlias_RecepturaPoz      , sLWPRECEPPOZ);
    end;
  end;
  with GridJoinDefs do begin
    AddSimple( 'M', 'Z', 'M.'+sZLEZASOB_ID+'=Z.'+sZLEZASOB_ID, qjkInner, True );
    AddSimple( 'Z', 'RZ', 'Z.'+sZLEZASOB_RODZAJ+'=RZ.'+sZLECONST_RODZAJZASOBU_ID, qjkInner, True );
    AddSimple( 'Z', 'OS', 'Z.'+sKDOSOBA_ID+'=OS.'+sKDOSOBA_ID, qjkLeftOuter, True );
    if(DataManagers.Available(sLWPModulID)) then begin
      AddExpres('M.'  + sLWPJEDNCZAS_ID + ' = ' + sLWPAlias_Jednostka + '.' + sLWPJEDNCZAS_ID, qjkLeftOuter, false);
      AddExpres('M.'  + sZLEZLECENIEZASOB_WYDJED + ' = ' + sLWPAlias_ZasobWydJednCzas + '.' + sLWPJEDNCZAS_ID, qjkLeftOuter, false);
      AddExpres('M.'  + sZLEZLECENIE_ID + ' = ' + sZLEALIAS_ZLECENIE + '.' + sZLEZLECENIE_ID, qjkInner, True);
      AddExpres('M.'  + sLWPRECEPPOZZASOB_ID  + ' = ' + sLWPAlias_RecepturaPozZasob + '.' + sLWPRECEPPOZZASOB_ID, qjkLeftOuter, false);
      AddExpres(sLWPAlias_RecepturaPozZasob + '.' + sLWPRECEPPOZ_ID  + ' = ' + sLWPAlias_RecepturaPoz + '.' + sLWPRECEPPOZ_ID, qjkLeftOuter, false);
    end;
  end;
  SetParameters();
  inherited;
end;

procedure TZLEZlecenieZasobDataModule.Post;
var
  bTrans: Boolean;
begin
  bTrans := not SQLManager.InTransaction;
  try
    if bTrans then SQLManager.StartTransaction;
    inherited;
    if bTrans then SQLManager.Commit;
  except
    if bTrans then SQLManager.Rollback;
    raise;
  end;
end;

procedure TZLEZlecenieZasobDataModule.ReOpenDataSets;
begin
  SetParameters();
  inherited;
end;

procedure TZLEZlecenieZasobDataModule.SetParameters;
begin
  if idcZlecenie = -1 then
    idcZlecenie := GridJoinDefs.AddEmptyCondition();
  GridJoinDefs.ExchangeCondition( idcZlecenie, 'M.'+sZLEZLECENIE_ID+'='+(Owner as TUNIForm).Parameters.Values[sZLEZLECENIE_ID], True );
end;

initialization
  RegisterClass( TZLEZlecenieZasobDataModule );

end.
