unit ZLEZlecenieZmianaStatusuSelectFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2009-05-12 Adam     Utworzone
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNISelectFormUnit, Menus, UNIComponentsUnit, ToolWin, ComCtrls, StdCtrls,
  ExtCtrls;

type
  TZLEZlecenieZmianaStatusuSelectForm = class(TUNISelectForm)
    UNILabel1: TUNILabel;
    StatusAktualnyEdit: TUNIEdit;
    UNILabel2: TUNILabel;
    StatusNowyComboBox: TUNIComboBox;
    procedure SelectButtonClick(Sender: TObject);
  protected
    procedure BeforeShow(); override;
    procedure CancelButtonPressed();  override;

  private
    m_sStatusNowy:  string;
    m_sStatusStary: string;

    procedure SetProperties();

  public
    function  Validate(): boolean;  override;
    property  StatusNowy: string  read  m_sStatusNowy;

  end;

implementation
uses
  FormManagerUnit,
  Dodatki,
  ZLEDefUnit
  ;

{$R *.DFM}

procedure TZLEZlecenieZmianaStatusuSelectForm.BeforeShow();
begin
  SetProperties();
  inherited;
end;

function  TZLEZlecenieZmianaStatusuSelectForm.Validate(): boolean;
begin
  result  := inherited Validate();
  if(result) then begin
    if(m_sStatusNowy = m_sStatusStary) then begin
      result  := false;
      Komunikat(cWarning, 'Nowy status jest taki sam jak aktualny. Prosz wybra inny status.', MB_OK + MB_ICONEXCLAMATION);
      StatusNowyComboBox.SetFocus();
    end;  // if(m_sStatusNowy = m_sStatusStary)
  end;  // if(result)
end;

procedure TZLEZlecenieZmianaStatusuSelectForm.CancelButtonPressed();
begin
  m_sStatusNowy := '';
  inherited;
end;

procedure TZLEZlecenieZmianaStatusuSelectForm.SetProperties();
begin
  StatusNowyComboBox.Items    := cslZLEStatusZlecenia;
  StatusNowyComboBox.ItemIndex:= 0;
  m_sStatusStary              := Parameters.Values[sZLEZLECENIE_STATUS];
  StatusAktualnyEdit.Text     := cslZLEStatusZlecenia[cslZLEStatusZlecenia.IndexOfSkrot(m_sStatusStary)];
end;

procedure TZLEZlecenieZmianaStatusuSelectForm.SelectButtonClick(
  Sender: TObject);
begin
  m_sStatusNowy := cslZLEStatusZlecenia.ZwrocSkrot(StatusNowyComboBox.ItemIndex);
  if(Validate()) then
    inherited
  else
    ModalResult := mrNone;
end;

initialization
  FormManager.RegisterForm(TZLEZlecenieZmianaStatusuSelectForm, sZLEModulID);
end.
