CREATE OR REPLACE PACKAGE BODY zle_package
AS

--definicje parametrw systemowych i uytkownika
sINIZLEDomyslnyStatusZlecenia             constant varchar2(25)  := 'ZLEDomyslnyStatusZlecenia';
sINIZLEDomyslnyTypZlecenia                constant varchar2(22)  := 'ZLEDomyslnyTypZlecenia';
sINIZLEInstalacjeTypZlec                  constant varchar2(20)  := 'ZLEInstalacjeTypZlec';
sINIZLEWymaganaOsobaZamZlec               constant varchar2(34)  := 'ZLEWymaganaOsobaZamykajacaZlecenie';
sINIZLEAsoReg_ID                          constant varchar2(15)  := 'INIZLEAsoReg_ID';
sINIZLEPozycjeWlaczone                    constant varchar2(18)  := 'ZLEPozycjeWlaczone';
sINIZLEKontrolaKosztowWlaczona            constant varchar2(26)  := 'ZLEKontrolaKosztowWlaczona';
sINIZLEKontrolaIlosciWlaczona             constant varchar2(25)  := 'ZLEKontrolaIlosciWlaczona';
sINIZLEKosztyMaterialoweWlacz             constant varchar2(28)  := 'ZLEKosztyMaterialoweWlaczone';
sINIZLEKosztyRobociznyWlacz               constant varchar2(26)  := 'ZLEKosztyRobociznyWlaczone';
sINIZLEWystawioneFakturyWlacz             constant varchar2(28)  := 'ZLEWystawioneFakturyWlaczone';
sINIZLEWystawioneFaktZakWlacz             constant varchar2(34)  := 'ZLEWystawioneFakturyZakupuWlaczone';
sINIZLEZasobyWlaczone                     constant varchar2(17)  := 'ZLEZasobyWlaczone';
sINIZLERozliczenieWlaczone                constant varchar2(22)  := 'ZLERozliczenieWlaczone';
sINIZLEZlecenieRozl_ZuzPaliwa             constant varchar2(25)  := 'ZLEZlecenieRozl_ZuzPaliwa';
sINIZLEZleceniePoz_RenumLP                constant varchar2(28)  := 'ZLEZleceniePoz_RenumeracjaLP';
sINIZLEWymaganyOddzial                    constant varchar2(18)  := 'ZLEWymaganyOddzial';
sINIZLEDomyslnyOddzialID                  constant varchar2(20)  := 'ZLEDomyslnyOddzialID';
sINIZLEWymaganaStawkaZasobu               constant varchar2(23)  := 'ZLEWymaganaStawkaZasobu';
sINIZLEPrzeliczanieWlaczone               constant varchar2(23)  := 'ZLEPrzeliczanieWlaczone';
sINIZLEPrzeliczanieGodzina                constant varchar2(22)  := 'ZLEPrzeliczanieGodzina';
sINIZLEGrupowanieDanych                   constant varchar2(19)  := 'ZLEGrupowanieDanych';
sINIZLENumeratorZasobow                   constant varchar2(19)  := 'ZLENumeratorZasobow';
sINIZLEOgraniczonaListaZasobow            constant varchar2(26)  := 'ZLEOgraniczonaListaZasobow';
sINIZLEWspolneZlecenia                    constant varchar2(18)  := 'ZLEWspolneZlecenia';
sINIZLEFormatGodzinLiczba                 constant varchar2(21)  := 'ZLEFormatGodzinLiczba';
sINIZLEWylaczonyFiltrDlaTypu              constant varchar2(24)  := 'ZLEWylaczonyFiltrDlaTypu';
sINIZLEWycenaPracyZasobowWlacz            constant varchar2(29)  := 'ZLEWycenaPracyZasobowWlaczona';
sINIZLENumeratorExt                       constant varchar2(15)  := 'ZLENumeratorExt';
sINIZLEPrefixSlownikID                    constant varchar2(18)  := 'ZLEPrefixSlownikID';
sINIZLESuffixDefinicja                    constant varchar2(18)  := 'ZLESuffixDefinicja';
sINIZLEOsobnaNum                          constant varchar2(12)  := 'ZLEOsobnaNum';
sINIZLEWymaganaPozycjaEwid                constant varchar2(25)  := 'INIZLEWymaganaPozycjaEwid';
sINIZLEZamkniecieKont                     constant varchar2(17)  := 'ZLEZamkniecieKont';
sINIZLESprawyPodpowiadanie                constant varchar2(22)  := 'ZLESprawyPodpowiadanie';
sINIZLESprawyKontrahent                   constant varchar2(19)  := 'ZLESprawyKontrahent';
sINIZLESprawyWydzial                      constant varchar2(16)  := 'ZLESprawyWydzial';
sINIZLESprawyPrefix                       constant varchar2(15)  := 'ZLESprawyPrefix';
sINIZLENarzuty                            constant varchar2(10)  := 'ZLENarzuty';
sINIZLEPoziomNarzutowJednOrg              constant varchar2(24)  := 'ZLEPoziomNarzutowJednOrg';
sINIZLEPoziomNarzutowOddzial              constant varchar2(24)  := 'ZLEPoziomNarzutowOddzial';
sINIZLEPoziomNarzutowTypZlec              constant varchar2(24)  := 'ZLEPoziomNarzutowTypZlec';

procedure CASTEXCEPT( errcode integer, sError varchar2) is
begin
  raise_application_error(-20000-errcode, sError /*|| '. ' || DAJOPISBLEDU(errcode)*/ );
end;



  FUNCTION INIT RETURN NUMBER
  IS
    iWynik NUMBER;

  BEGIN
    iWynik := UNISYS_PACKAGE.cFalse;
    -- Inicjacja zmiennych dla moduu ZLE
    vZLEDomyslnyStatusZlecenia          := UNISYS_PACKAGE.GetSystemIniString( UNISYS_PACKAGE.vAktywnaFirma, sZLEModulID, '', sINIZLEDomyslnyStatusZlecenia, UNISYS_PACKAGE.cStatusZlecenia_OczekujaceID);
    vZLEDomyslnyTypZlecenia             := UNISYS_PACKAGE.GetUserIniInteger(  UNISYS_PACKAGE.vAktywnaFirma, UNISYS_PACKAGE.UserId, sZLEModulID, '', sINIZLEDomyslnyTypZlecenia, -1 );
    vZLEInstalacjeTypZlec               := UNISYS_PACKAGE.GetSystemIniInteger(UNISYS_PACKAGE.vAktywnaFirma, sZLEModulID, '', sINIZLEInstalacjeTypZlec, -1 );
    vZLEWymaganaOsobaZamZlec            := UNISYS_PACKAGE.GetSystemIniBoolean(UNISYS_PACKAGE.vAktywnaFirma, sZLEModulID, '', sINIZLEWymaganaOsobaZamZlec, False );
    vZLEAsoReg_ID                       := UNISYS_PACKAGE.GetSystemIniInteger(UNISYS_PACKAGE.vAktywnaFirma, sZLEModulID, '', sINIZLEAsoReg_ID, -1 );
    vZLEPozycjeWlaczone                 := UNISYS_PACKAGE.GetUserIniBoolean(  UNISYS_PACKAGE.vAktywnaFirma, UNISYS_PACKAGE.UserId, sZLEModulID, '', sINIZLEPozycjeWlaczone, True );
    vZLEKontrolaKosztowWlaczona         := UNISYS_PACKAGE.GetUserIniBoolean(  UNISYS_PACKAGE.vAktywnaFirma, UNISYS_PACKAGE.UserId, sZLEModulID, '', sINIZLEKontrolaKosztowWlaczona, True );
    vZLEKontrolaIlosciWlaczona          := UNISYS_PACKAGE.GetUserIniBoolean(  UNISYS_PACKAGE.vAktywnaFirma, UNISYS_PACKAGE.UserId, sZLEModulID, '', sINIZLEKontrolaIlosciWlaczona, True );
    vZLEKosztyMaterialoweWlaczone       := UNISYS_PACKAGE.GetUserIniBoolean(  UNISYS_PACKAGE.vAktywnaFirma, UNISYS_PACKAGE.UserId, sZLEModulID, '', sINIZLEKosztyMaterialoweWlacz, True );
    vZLEKosztyRobociznyWlaczone         := UNISYS_PACKAGE.GetUserIniBoolean(  UNISYS_PACKAGE.vAktywnaFirma, UNISYS_PACKAGE.UserId, sZLEModulID, '', sINIZLEKosztyRobociznyWlacz, True );
    vZLEWystawioneFakturyWlaczone       := UNISYS_PACKAGE.GetUserIniBoolean(  UNISYS_PACKAGE.vAktywnaFirma, UNISYS_PACKAGE.UserId, sZLEModulID, '', sINIZLEWystawioneFakturyWlacz, True );
    vZLEWystawioneFaktZakWlacz          := UNISYS_PACKAGE.GetUserIniBoolean(  UNISYS_PACKAGE.vAktywnaFirma, UNISYS_PACKAGE.UserId, sZLEModulID, '', sINIZLEWystawioneFaktZakWlacz, False );
    vZLEZasobyWlaczone                  := UNISYS_PACKAGE.GetUserIniBoolean ( UNISYS_PACKAGE.vAktywnaFirma, UNISYS_PACKAGE.UserId, sZLEModulID, '', sINIZLEZasobyWlaczone, True );
    vZLERozliczenieWlaczone             := UNISYS_PACKAGE.GetUserIniBoolean ( UNISYS_PACKAGE.vAktywnaFirma, UNISYS_PACKAGE.UserId, sZLEModulID, '', sINIZLERozliczenieWlaczone, True );
    vZLEZlecenieRozl_ZuzPaliwa          := UNISYS_PACKAGE.GetSystemIniBoolean(UNISYS_PACKAGE.vAktywnaFirma, sZLEModulID, '', sINIZLEZlecenieRozl_ZuzPaliwa, False );
    vZLEZleceniePoz_RenumeracjaLP       := UNISYS_PACKAGE.GetSystemIniBoolean(UNISYS_PACKAGE.vAktywnaFirma, sZLEModulID, '', sINIZLEZleceniePoz_RenumLP, False );
    vZLEWymaganyOddzial                 := UNISYS_PACKAGE.GetSystemIniBoolean(UNISYS_PACKAGE.vAktywnaFirma, sZLEModulID, '', sINIZLEWymaganyOddzial, False );
    vZLEDomyslnyOddzialID               := UNISYS_PACKAGE.GetUserIniInteger(  UNISYS_PACKAGE.vAktywnaFirma, UNISYS_PACKAGE.UserId, sZLEModulID, '', sINIZLEDomyslnyOddzialID, -1 );
    vZLEWymaganaStawkaZasobu            := UNISYS_PACKAGE.GetSystemIniBoolean(UNISYS_PACKAGE.vAktywnaFirma, sZLEModulID, '', sINIZLEWymaganaStawkaZasobu, True );
    vZLEPrzeliczanieWlaczone            := UNISYS_PACKAGE.GetUserIniBoolean(  UNISYS_PACKAGE.vAktywnaFirma, UNISYS_PACKAGE.UserId, sZLEModulID, '', sINIZLEPrzeliczanieWlaczone, False );
    vZLEPrzeliczanieGodzina             := UNISYS_PACKAGE.GetUserIniString(   UNISYS_PACKAGE.vAktywnaFirma, UNISYS_PACKAGE.UserId, sZLEModulID, '', sINIZLEPrzeliczanieGodzina, '00:00');
    vZLEGrupowanieDanych                := UNISYS_PACKAGE.GetUserIniBoolean(  UNISYS_PACKAGE.vAktywnaFirma, UNISYS_PACKAGE.UserId, sZLEModulID, '', sINIZLEGrupowanieDanych, False );
    vZLENumeratorZasobow                := UNISYS_PACKAGE.GetSystemIniInteger(0, sZLEModulID, '', sINIZLENumeratorZasobow, -1 );
    vZLEOgraniczonaListaZasobow         := UNISYS_PACKAGE.GetSystemIniBoolean(UNISYS_PACKAGE.vAktywnaFirma, sZLEModulID, '', sINIZLEOgraniczonaListaZasobow, False );
    vZLEWspolneZlecenia                 := UNISYS_PACKAGE.GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEWspolneZlecenia, False );
    vZLEFormatGodzinLiczba              := UNISYS_PACKAGE.GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEFormatGodzinLiczba, False );
    vZLEWylaczonyFiltrDlaTypu           := UNISYS_PACKAGE.GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEWylaczonyFiltrDlaTypu, False );
    vZLEWycenaPracyZasobowWlaczona      := UNISYS_PACKAGE.GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEWycenaPracyZasobowWlacz, UNISYS_PACKAGE.ModulAvailable(LWP_PACKAGE.cLWPModulZSI_ID));
    vZLENumeratorExt                    := UNISYS_PACKAGE.GetSystemIniBoolean(0, sZLEModulID, '', sINIZLENumeratorExt, False);
    vZLEPrefixSlownikID                 := UNISYS_PACKAGE.GetSystemIniInteger(UNISYS_PACKAGE.vAktywnaFirma, sZLEModulID, '', sINIZLEPrefixSlownikID, -1 );
    vZLEOsobnaNum                       := UNISYS_PACKAGE.GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEOsobnaNum, True);
    vZLEWymaganaPozycjaEwid             := UNISYS_PACKAGE.GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEWymaganaPozycjaEwid, False);
    vZLEZamkniecieKont                  := UNISYS_PACKAGE.GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEZamkniecieKont, False);
    vZLESprawyPodpowiadanie             := UNISYS_PACKAGE.GetSystemIniBoolean(0, sZLEModulID, '', sINIZLESprawyPodpowiadanie, False);
    vZLESprawyKontrahent                := UNISYS_PACKAGE.GetSystemIniString( 0, sZLEModulID, '', sINIZLESprawyKontrahent, 'Kontrahent');
    vZLESprawyWydzial                   := UNISYS_PACKAGE.GetSystemIniString( 0, sZLEModulID, '', sINIZLESprawyWydzial, 'Wydzia');
    vZLESprawyPrefix                    := UNISYS_PACKAGE.GetSystemIniString( 0, sZLEModulID, '', sINIZLESprawyPrefix, 'Prefix' );
    vZLENarzuty                         := UNISYS_PACKAGE.GetSystemIniBoolean(0, sZLEModulID, '', sINIZLENarzuty, False);
    vZLEPoziomNarzutowJednOrg           := UNISYS_PACKAGE.GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEPoziomNarzutowJednOrg, False);
    vZLEPoziomNarzutowOddzial           := UNISYS_PACKAGE.GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEPoziomNarzutowOddzial, False);
    vZLEPoziomNarzutowTypZlec           := UNISYS_PACKAGE.GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEPoziomNarzutowTypZlec, True);

    iWynik := UNISYS_PACKAGE.cTrue;
    RETURN (iWynik);
  END;

  FUNCTION ZLEWspNarzutuRob(
              iZLEZleceniePozID INTEGER,
              iUNIOkresID INTEGER)
  RETURN NUMBER AS
      fWyn NUMBER;
      sSQL VARCHAR2(1000);
  BEGIN
      fWyn := 0.00;
      IF vZLENarzuty THEN
         IF (iUNIOkresID IS NULL) OR (iZLEZleceniePozID IS NULL) THEN
            fWyn := 0.00;
         ELSE
           sSQL := 'SELECT ZLEWSPNARZUTY_ROB ' ||
                   'FROM ZLEWSPNARZUTY zw, zlezlecenie zl, zlezleceniepoz zp ' ||
                   'WHERE zl.zlezlecenie_id = zp.zlezlecenie_id AND ' ||
                         'zw.uniokres_id = ' || To_Char(iUNIOkresID) || ' and ' ||
                         'zp.zlezleceniepoz_id = ' || To_Char(iZLEZleceniePozID);

           IF vZLEPoziomNarzutowJednOrg THEN
              sSQL := sSQL || ' AND zl.unijednostkaorg_id = zw.unijednostkaorg_id';
           END IF;
           IF vZLEPoziomNarzutowOddzial THEN
              sSQL := sSQL || ' AND zl.unioddzial_id = zw.unioddzial_id';
           END IF;
           IF vZLEPoziomNarzutowTypZlec THEN
              sSQL := sSQL || ' AND zl.zletypzlec_id = zw.zletypzlec_id';
           END IF;
           EXECUTE IMMEDIATE sSQL INTO fWyn;
        END IF;
      END IF;

      RETURN(fWyn);
  EXCEPTION
      when no_data_found then RETURN(0.00);
  END;

  FUNCTION ZLEWspNarzutuMat(
              iZLEZleceniePozID INTEGER,
              iUNIOkresID INTEGER)
  RETURN NUMBER AS
      fWyn NUMBER;
      sSQL VARCHAR2(1000);
  BEGIN
      fWyn := 0.00;
      IF vZLENarzuty THEN
         IF (iUNIOkresID IS NULL) OR (iZLEZleceniePozID IS NULL) THEN
            fWyn := 0.00;
         ELSE
           sSQL := 'SELECT ZLEWSPNARZUTY_MAT ' ||
                   'FROM ZLEWSPNARZUTY zw, zlezlecenie zl, zlezleceniepoz zp ' ||
                   'WHERE zl.zlezlecenie_id = zp.zlezlecenie_id AND ' ||
                         'zw.uniokres_id = ' || To_Char(iUNIOkresID) || ' and ' ||
                         'zp.zlezleceniepoz_id = ' || To_Char(iZLEZleceniePozID);

           IF vZLEPoziomNarzutowJednOrg THEN
              sSQL := sSQL || ' AND zl.unijednostkaorg_id = zw.unijednostkaorg_id';
           END IF;
           IF vZLEPoziomNarzutowOddzial THEN
              sSQL := sSQL || ' AND zl.unioddzial_id = zw.unioddzial_id';
           END IF;
           IF vZLEPoziomNarzutowTypZlec THEN
              sSQL := sSQL || ' AND zl.zletypzlec_id = zw.zletypzlec_id';
           END IF;
           EXECUTE IMMEDIATE sSQL INTO fWyn;
         END IF;
      END IF;

      RETURN(fWyn);
  EXCEPTION
      when no_data_found then RETURN(0.00);
  END;

  FUNCTION Daj_Opis_Obiektu(iObiektTypID INTEGER, iObiektID INTEGER) RETURN VARCHAR2 AS
   sWynik VARCHAR2(1000);

  BEGIN
   IF iObiektTypID = 39 THEN
     -- opis dla zlecen
     BEGIN
       SELECT 'Symbol: ' || ZLEZlecenie_Symbol || ' Nazwa: ' || ZLEZlecenie_Nazwa
       INTO sWynik
       FROM ZLEZLECENIE
       WHERE ZLEZLECENIE_ID = iObiektID;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        sWynik := NULL;
    END;
   END IF;

   RETURN SUBSTR(sWynik, 1, 255);
  END;

  FUNCTION  DajIdZasobu(
    aZLEZASOB_SYMBOL in VARCHAR2
  ) RETURN  INTEGER
  as
    vZLEZASOB_ID INTEGER;
  begin
    select zlezasob_id
    into vZLEZASOB_ID
    from zlezasob
    where upper(zlezasob_symbol) = upper(aZLEZASOB_SYMBOL);

    return  vZLEZASOB_ID;
  end;

  FUNCTION  DajIdZmianyDlaZasobu(
    aZLEZASOB_ID 				IN INTEGER,
    aKDZMIANYDEF_SYMBOL IN VARCHAR2,
    aDATA               IN DATE
  ) RETURN  INTEGER
  as
    vKDZMIANYDEF_ID INTEGER;
	begin
    select
      zm.kdzmianydef_id into vKDZMIANYDEF_ID
    from
      zlezasob z
        inner join kdkalczas kal
          on z.kdgrupakal_id = kal.kdgrupakal_id
        inner join kdzmianydef zm
          on kal.kdsystemzmian_id = zm.kdsystemzmian_id
    where
      z.zlezasob_id = aZLEZASOB_ID and
      upper(zm.kdzmianydef_symbol) = upper(aKDZMIANYDEF_SYMBOL) and
      kal.kdkalczas_data = aDATA;

    RETURN vKDZMIANYDEF_ID;
	end;

  FUNCTION  DajIdRodzajuBraku(
    aZLEBRAKI_SYMBOL in VARCHAR2
  ) RETURN  INTEGER
  as
    vZLEBRAKI_ID INTEGER;
  begin
    select zlebraki_id
    into vZLEBRAKI_ID
    from zlebraki
    where upper(zlebraki_symbol) = upper(aZLEBRAKI_SYMBOL);

    return vZLEBRAKI_ID;
  end;

  FUNCTION MoznaEdytowacZlecenieProd(
	  a_iZlecenieId INTEGER
  )	RETURN VARCHAR2 AS
    iTemp INTEGER;
  BEGIN
    IF (UNISYS_PACKAGE.ModulAvailable(50)) THEN
        -- jeeli jest modu UNIINT
      BEGIN
        SELECT 1 INTO iTemp FROM dual WHERE EXISTS(SELECT * FROM zlezlecenieobcy WHERE zlezlecenie_id = a_iZlecenieId);
      EXCEPTION
        WHEN NO_DATA_FOUND THEN iTemp := 0;
      END;
      IF(iTemp = 1) THEN
        RETURN(sResultZlecenieWyslane);
      ELSE
        RETURN(NULL);
      END IF;
    ELSE
      RETURN(NULL);
    END IF;
  END;

  FUNCTION ZLE_DajDaneObiektu (zlezlecenie_id   INTEGER,
                               p_informacja     VARCHAR2)
  RETURN VARCHAR2
  AS
     RESULT   	VARCHAR2(250);
     TABLE_NAME VARCHAR2(30);
     sSQL       VARCHAR2(1000);
     sPole      VARCHAR2(50);

     vNieruch   VARCHAR2(1);
     vBudynek   VARCHAR2(1);
     vLokal     VARCHAR2(1);
     vKlatka    VARCHAR2(1);
     vUlica     VARCHAR2(1);
     vZasob     VARCHAR2(1);
     vSiecElem  VARCHAR2(1);
     vSkladSiecElem  VARCHAR2(1);
  BEGIN
    RESULT := NULL;
    TABLE_NAME := NULL;
    sSQL := '';

    IF zlezlecenie_id IS NULL THEN
       RETURN NULL;
    END IF;

    EXECUTE IMMEDIATE
    'SELECT
      zt.ZLETYPZLEC_NIERUCHOMOSC_A,
      zt.ZLETYPZLEC_BUDYNEK_A,
      zt.ZLETYPZLEC_LOKAL_A,
      zt.ZLETYPZLEC_KLATKA_A,
      zt.ZLETYPZLEC_ULICA_A,
      zt.ZLETYPZLEC_ZASOB_A,
      zt.ZLETYPZLEC_SIECELEMENT_A,
      zt.ZLETYPZLEC_SKLADELEMSIECI_A

    FROM
      zletypzlec zt,
      zlezlecenie zl
    WHERE
      zl.zletypzlec_id = zt.zletypzlec_id
      AND zl.zlezlecenie_id = '||To_Char(zlezlecenie_id)
    INTO
      vNieruch,
      vBudynek,
      vLokal,
      vKlatka,
      vUlica,
      vZasob,
      vSiecElem,
      vSkladSiecElem;

    IF vNieruch <> 'A' THEN
       Result := 'Nieruchomo';
       TABLE_NAME := 'INFNIERUCHOMOSC';
    ELSIF vBudynek <> 'A' THEN
       TABLE_NAME := 'INFBUDYNEK';
       Result := 'Budynek';
    ELSIF vLokal <> 'A' THEN
      TABLE_NAME := 'INFLOKAL';
      Result := 'Lokal';
    ELSIF vKlatka <> 'A' THEN
      TABLE_NAME := 'INFKLATKA';
      Result := 'Klatka';
    ELSIF vUlica <> 'A' THEN
      TABLE_NAME := 'INFULICA';
      Result := 'Ulica';
    ELSIF vZasob <> 'A' THEN
      TABLE_NAME := 'INFZASOB';
      Result := 'Zasb';
    ELSIF vSiecElem <> 'A' THEN
      TABLE_NAME := 'INFSIECELEMENT';
      Result := 'Element sieci';
    ELSIF vSkladSiecElem <> 'A' THEN
      TABLE_NAME := 'INFSIECSKLADNIK';
      Result := 'Sk.elem.sieci';
    ELSE
      Result := NULL;
    END IF;

    sPole := NULL;
    IF p_informacja = 'R' THEN
      RETURN Result;
    ELSIF p_informacja = 'S' THEN
      sPole := '_SYMBOL';
    ELSIF p_informacja = 'N' THEN
      sPole := '_NAZWA';
    ELSE
      RETURN NULL;
    END IF;

    IF (sPole IS NOT NULL) AND (TABLE_NAME IS NOT NULL) THEN
      sSQL := 'SELECT inf.'||TABLE_NAME||sPole||' FROM ZLEZLECENIE zl, '||TABLE_NAME||' inf WHERE zl.'||TABLE_NAME||'_ID=inf.'||TABLE_NAME||'_ID AND zl.zlezlecenie_id = '||To_Char(zlezlecenie_id);
      EXECUTE IMMEDIATE sSQL INTO RESULT;
    END IF;

    RETURN RESULT;
  EXCEPTION
    WHEN NO_DATA_FOUND
    THEN
        RETURN NULL;
    WHEN OTHERS
    THEN
        RAISE;
  END;

BEGIN
  IF (Init = UNISYS_PACKAGE.cFalse) THEN
    CastExcept( eZLE_BladInitPakietu, 'Inicjalizacja pakietu');
  END IF;
END;
/

