CREATE OR REPLACE PACKAGE zle_package
AS
   cZLEModulZSI_ID   CONSTANT NUMBER (10, 1) := 33;
   sZLEModulID       CONSTANT VARCHAR2 (3)   := 'ZLE';

  /* Parametry moduu ZLE */
  vZLEDomyslnyStatusZlecenia          VARCHAR2(1);
  vZLEDomyslnyTypZlecenia             Integer;
  vZLEInstalacjeTypZlec               Integer;
  vZLEWymaganaOsobaZamZlec            Boolean;
  vZLEAsoReg_ID                       Integer;
  vZLEPozycjeWlaczone                 Boolean;
  vZLEKontrolaKosztowWlaczona         Boolean;
  vZLEKontrolaIlosciWlaczona          Boolean;
  vZLEKosztyMaterialoweWlaczone       Boolean;
  vZLEKosztyRobociznyWlaczone         Boolean;
  vZLEWystawioneFakturyWlaczone       Boolean;
  vZLEWystawioneFaktZakWlacz          Boolean;
  vZLEZasobyWlaczone                  Boolean;
  vZLERozliczenieWlaczone             Boolean;
  vZLEZlecenieRozl_ZuzPaliwa          Boolean;
  vZLEZleceniePoz_RenumeracjaLP       Boolean;
  vZLEWymaganyOddzial                 Boolean;
  vZLEDomyslnyOddzialID               Integer;
  vZLEWymaganaStawkaZasobu            Boolean;
  vZLEPrzeliczanieWlaczone            Boolean;
  vZLEPrzeliczanieGodzina             VARCHAR2(10);
  vZLEGrupowanieDanych                Boolean;
  vZLENumeratorZasobow                integer;
  vZLEOgraniczonaListaZasobow         Boolean;
  vZLEWspolneZlecenia                 Boolean;
  vZLEFormatGodzinLiczba              Boolean;
  vZLEWylaczonyFiltrDlaTypu           Boolean;
  vZLEWycenaPracyZasobowWlaczona      Boolean;
  vZLENumeratorExt                    Boolean;
  vZLEPrefixSlownikID                 Integer;
  vZLEOsobnaNum                       Boolean;
  vZLEWymaganaPozycjaEwid             Boolean;
  vZLEZamkniecieKont                  Boolean;
  vZLESprawyPodpowiadanie             Boolean;
  vZLESprawyKontrahent                VARCHAR2(255);
  vZLESprawyWydzial                   VARCHAR2(255);
  vZLESprawyPrefix                    VARCHAR2(255);
  vZLENarzuty                         Boolean;
  vZLEPoziomNarzutowJednOrg           Boolean;
  vZLEPoziomNarzutowOddzial           Boolean;
  vZLEPoziomNarzutowTypZlec           Boolean;

  /* stae dla rezultatw funkcji - komunikacja z partnerem */
  sResultZlecenieWyslane    CONSTANT VARCHAR2(44) := 'Zlecenie zostao wysane do systemu partnera';

  /* Bdy pakietu */
  eZLE_BladInitPakietu         CONSTANT INTEGER := 10;

  procedure CASTEXCEPT( errcode integer, sError varchar2);
  FUNCTION INIT RETURN NUMBER;

  FUNCTION ZLEWspNarzutuRob(
              iZLEZleceniePozID INTEGER,
              iUNIOkresID INTEGER)
  RETURN NUMBER;

  FUNCTION ZLEWspNarzutuMat(
              iZLEZleceniePozID INTEGER,
              iUNIOkresID INTEGER)
  RETURN NUMBER;

  FUNCTION Daj_Opis_Obiektu(
              iObiektTypID INTEGER,
              iObiektID INTEGER)
  RETURN VARCHAR2;

  FUNCTION  DajIdZasobu(aZLEZASOB_SYMBOL in VARCHAR2) RETURN INTEGER;

  FUNCTION  DajIdZmianyDlaZasobu(
    aZLEZASOB_ID 				IN INTEGER,
    aKDZMIANYDEF_SYMBOL IN VARCHAR2,
    aDATA               IN DATE)
  RETURN  INTEGER;

  FUNCTION  DajIdRodzajuBraku(aZLEBRAKI_SYMBOL in VARCHAR2) RETURN INTEGER;

    /*
      Zlecenie produkcyjne mona edytowa jeeli nie zostao jeszcze wysane do aplikacji partnera.
      Funkcja zwraca NULL jeeli mona edytowa zlecenie lub komunikat dlaczego nie mona tego zrobi.
    */
  FUNCTION MoznaEdytowacZlecenieProd(a_iZlecenieId INTEGER)	RETURN VARCHAR2;

   /* Funkcja zwraca informacje dla obiektu Parametry remontow
      p_informacja S - zwraca symbol
                   N - zwraca nazwe
                   R - zwraca rodzaj_obiektu
   */
  FUNCTION ZLE_DajDaneObiektu (zlezlecenie_id   INTEGER,
                               p_informacja     VARCHAR2)       RETURN VARCHAR2;
END;
/