unit ZleOsobyGodzDBDetailFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Modu dostarczajcy aktualizacje bazy.

Changes
---------------------------------------------------------------------------------------------
When       Who    What
---------------------------------------------------------------------------------------------
2004-12-05 kk     Utworzone
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBDetailFormUnit, Menus, UNIComponentsUnit, Db, ToolWin, ComCtrls,
  StdCtrls, ExtCtrls, Mask, UNIDBDateEditUnit, UNIStaleUnit, UNIDataModuleUnit,
  DBCtrls, UNIDateEditUnit, UNIGodzEdit;

type
  TZleOsobyGodzDBDetailForm = class(TUNIDBDetailForm)
    ZlecenieSymbolDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    ZlecenieLabel: TUNILabel;
    ZlecenieNazwaLabel: TUNILabel;
    MAGObrDataLabel: TUNILabel;
    DataDBDateEdit: TUNIDBDateEdit;
    UNILabel1: TUNILabel;
    OsobaSymbolDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    OsobaNazwaLabel: TUNILabel;
    AsortymentLabel: TUNILabel;
    AsortymentSymbolDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    AsortymentNazwaLabel: TUNILabel;
    CenaDBEdit: TUNIDBEdit;
    UNILabel2: TUNILabel;
    UNILabel3: TUNILabel;
    UNILabel4: TUNILabel;
    IloscGodzEdit: TUNIGodzEdit;
    ZasobLabel: TUNILabel;
    ZasobDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    IloscPracyDBEdit: TUNIDBEdit;
    IloscDBEdit: TUNIDBEdit;
    PozycjaZleceniaLabel: TUNILabel;
    PozycjaLookupAliasEdit: TUNILookupAliasEdit;
    procedure ZlecenieSymbolDBLookupAliasEditDelKey(Sender: TObject);
    function ZlecenieSymbolDBLookupAliasEditGetDataField: String;
    function ZlecenieSymbolDBLookupAliasEditGetQuery: TUNIQuery;
    procedure ZlecenieSymbolDBLookupAliasEditInitAliasInfo(
      Sender: TObject);
    function ZlecenieSymbolDBLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    procedure OsobaSymbolDBLookupAliasEditDelKey(Sender: TObject);
    function OsobaSymbolDBLookupAliasEditGetDataField: String;
    function OsobaSymbolDBLookupAliasEditGetQuery: TUNIQuery;
    procedure OsobaSymbolDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function OsobaSymbolDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure DataDBDateEditDateChange(Sender: TObject);
    procedure AsortymentSymbolDBLookupAliasEditDelKey(Sender: TObject);
    function AsortymentSymbolDBLookupAliasEditGetDataField: String;
    function AsortymentSymbolDBLookupAliasEditGetQuery: TUNIQuery;
    procedure AsortymentSymbolDBLookupAliasEditInitAliasInfo(
      Sender: TObject);
    function AsortymentSymbolDBLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    procedure ZasobDBLookupAliasEditDelKey(Sender: TObject);
    function ZasobDBLookupAliasEditGetDataField: String;
    function ZasobDBLookupAliasEditGetQuery: TUNIQuery;
    procedure ZasobDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function ZasobDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure PozycjaLookupAliasEditButtonClick(Sender: TObject);
    function PozycjaLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
  private
    iOsobaOld : Integer;
    iZlecenieOldID: Integer;
    iZasobOldID: Integer;
    bZmianaZasobu: Boolean;
    procedure InitializeControls();
    procedure SetDefaults;
//    procedure GetCenaFromCennik;
    procedure SetFieldFormat();
  protected
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure InternalOpen; override;
  public
    function Validate(): Boolean; override;
    procedure SelectButtonPressed; override;
  end;

var
  ZleOsobyGodzDBDetailForm: TZleOsobyGodzDBDetailForm;

implementation

uses
  Dodatki,
  FormManagerUnit,
  SQLManagerUnit,
  UNIDataManagerUnit,
  SystemDefUnit,
  UNISysDefUnit,
  UNISysDataManagerUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit,
  ZleOsobyGodzUnit,
  ZLESzczegoloweKosztyDBGridUnit,
  KDDefUnit,
  KeyManagerUnit,
  KDDataManagerExtUnit,
  ASODefUnit,
  ASODataManagerExtUnit,
  SPDefUnit,
  SPDataManagerExtUnit,
  UNIDBGridFormUnit;

{$R *.DFM}

procedure TZleOsobyGodzDBDetailForm.SetDefaults;
begin
  (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := True;
  try
    if TUNIDBGridForm(Owner).Parameters.Values[sZLEOSOBYGODZ_DATA] = '' then
      DMAQFbN(sZLEOSOBYGODZ_DATA).AsDateTime := Date
    else
      DMAQFbN(sZLEOSOBYGODZ_DATA).AsDateTime := StrToDate(TUNIDBGridForm(Owner).Parameters.Values[sZLEOSOBYGODZ_DATA]);
    DataDBDateEditDateChange(Nil);
    if TUNIDBGridForm(Owner).Parameters.Values[sKDOSOBA_ID] <> '' then
      DMAQFbN(sKDOSOBA_ID).AsInteger := StrToInt(TUNIDBGridForm(Owner).Parameters.Values[sKDOSOBA_ID]);
    if TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOB_ID] <> '' then
      DMAQFbN(sZLEZASOB_ID).AsInteger := StrToInt(TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOB_ID]);
    if TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIE_ID] <> '' then
      DMAQFbN(sZLEZLECENIE_ID).AsInteger := StrToInt(TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIE_ID]);
    if TUNIDBGridForm(Owner).Parameters.Values[sASOASORT_ID] <> '' then
      DMAQFbN(sASOASORT_ID).AsInteger := StrToInt(TUNIDBGridForm(Owner).Parameters.Values[sASOASORT_ID]);
    if TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIEPOZ_ID] <> '' then begin
      DMAQFbN(sZLEZLECENIEPOZ_ID).AsInteger := StrToInt(TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIEPOZ_ID]);
      PozycjaLookupAliasEdit.InitiateData(DMAQFbN(sZLEZLECENIEPOZ_ID).AsInteger);
    end;

    if TUNIDBGridForm(Owner).Parameters.Values[sZLEOSOBYGODZ_ILOSC] <> '' then begin
      if not ZLEDM.vZLEFormatGodzinLiczba then
         DMAQFbN(sZLEOSOBYGODZ_ILOSC).AsInteger :=  StrToInt(TUNIDBGridForm(Owner).Parameters.Values[sZLEOSOBYGODZ_ILOSC])
      else
         DMAQFbN(sZLEOSOBYGODZ_ILOSC).AsFloat :=
            Zaokraglij(StrToFloat(TUNIDBGridForm(Owner).Parameters.Values[sZLEOSOBYGODZ_ILOSC]), UNIGetFracFromValueFormat(12.6 {ASODM.vAsoFormatCeny}));
    end else begin
       DMAQFbN(sZLEOSOBYGODZ_ILOSC).AsFloat := 0;
    end;

    if TUNIDBGridForm(Owner).Parameters.Values[sZLEOSOBYGODZ_IL_PRACY] <> '' then begin
      DMAQFbN(sZLEOSOBYGODZ_IL_PRACY).AsFloat :=
        Zaokraglij(StrToFloat(TUNIDBGridForm(Owner).Parameters.Values[sZLEOSOBYGODZ_IL_PRACY]), UNIGetFracFromValueFormat(12.2 {ASODM.vAsoFormatCeny}));
        //StrToFloat(TUNIDBGridForm(Owner).Parameters.Values[sZLEOSOBYGODZ_IL_PRACY]);
    end else begin
      DMAQFbN(sZLEOSOBYGODZ_IL_PRACY).AsFloat := 0;
    end;

    if TUNIDBGridForm(Owner).Parameters.Values[sZLEOSOBYGODZ_CENA] <> '' then begin
      DMAQFbN(sZLEOSOBYGODZ_CENA).AsFloat :=
        Zaokraglij(StrToFloat(TUNIDBGridForm(Owner).Parameters.Values[sZLEOSOBYGODZ_CENA]), UNIGetFracFromValueFormat(ASODM.vAsoFormatCeny));
    end else begin
      DMAQFbN(sZLEOSOBYGODZ_CENA).AsFloat := 0.00;
    end;


  finally
    (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := False;
  end;
end;

{
procedure TZleOsobyGodzDBDetailForm.GetCenaFromCennik;
var
  sSql: String;
  sStandID: String;
  q: TUNIQuery;
begin
  try
    q := SPDM.OdpytajODane(
      sSPCena,
      sSPAlias_CenaVatID + ';' + sSPAlias_CenaNetto + ';' + sSPAlias_CenaBrutto + ';' + sSPAlias_CenaRabatProc,
      sASOASORT_ID + '=' + DMAQFbN(sASOASORT_iD).AsString + ' and ' + sSPCennik_ID + '=' + DMAQFbN(sSPCENNIK_ID).AsString,
      True
    );
    if q = Nil then begin
      sSql := SPDM.OdpytajODaneSQL(
        sSPCennik,
        sSPAlias_CennikGL_ID,
        sSPCennik_ID + '=' + DMAQFbN(sSPCENNIK_ID).AsString + ' and ' + sSPCennik_Indyw + '=' + #39 + sTak + #39,
        True
      );
      sStandID := SQLManager.OpenQueryWithResult(sSql);
      if sStandID <> '' then begin
        q := SPDM.OdpytajODane(
          sSPCena,
          sSPAlias_CenaVatID + ';' + sSPAlias_CenaNetto + ';' + sSPAlias_CenaBrutto + ';' + sSPAlias_CenaRabatProc,
          sASOASORT_ID + '=' + DMAQFbN(sASOASORT_ID).AsString + ' and ' + sSPCennik_ID + '=' + DMAQFbN(sSPCENNIK_ID).AsString,
          True
        );
      end;
    end;
    if q <> Nil then begin
      DMAQFbN(sZLEOSOBYGODZ_CENA).AsFloat := q.FieldByName(sSPCena_Netto).AsFloat;
    end else
      Komunikat(cWarning, 'Dla wybranego asortyment nie znale cennika');
  finally
    if q <> Nil then FreeAndNil(q);
  end;
end;
}

procedure TZleOsobyGodzDBDetailForm.ZlecenieSymbolDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  if OpenMode in [omNew, omEdit] then begin
    ZlecenieSymbolDBLookupAliasEdit.Text := '';
    ZlecenieNazwaLabel.Caption := '';
    DMAQFbN(sZLEZLECENIE_ID).Clear;
    iZlecenieOldID := 0;
    {Czyszczymy rwnie pozycj zlecenia}
    DMAQFbN(sZLEZLECENIEPOZ_ID).Clear;
    PozycjaLookupAliasEdit.Text := '';
  end;
end;

function TZleOsobyGodzDBDetailForm.ZlecenieSymbolDBLookupAliasEditGetDataField: String;
begin
  Result := sZLEZLECENIE_ID;
end;

function TZleOsobyGodzDBDetailForm.ZlecenieSymbolDBLookupAliasEditGetQuery: TUNIQuery;
var
  iFirmaId: integer;
begin
  iFirmaId := 0;
  iZlecenieOldID := DMAQFbN(sZLEZLECENIE_ID).AsInteger;
  if (UNISysDM.vWieloodzialowosc) and (Parameters.Values[sUNIODDZIAL_ID] <> '') then
    iFirmaID := StrToInt(Parameters.Values[sUNIODDZIAL_ID])
  else if UNISysDM.vWielofirmowosc then
    iFirmaID := UNISysDM.vAktywnaFirma;

  Result := ZLEDM.ZLEPokazIObsluzZlecenia(
    sZLEALIAS_ZLECENIE_ID + ';' + sZLEALIAS_ZLECENIE_SYMBOL + ';' + sZLEALIAS_ZLECENIE_NAZWA,
    '',
    False,
    False,
    cZLEModulZSI_ID,
    DMAQFbN(sZLEZLECENIE_ID).AsInteger,
    iFirmaId
  );
end;

procedure TZleOsobyGodzDBDetailForm.ZlecenieSymbolDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with ZlecenieSymbolDBLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_ID := sZLEALIAS_Zlecenie_ID;
    Alias_Name := sZLEALIAS_Zlecenie_Symbol;
    AdditionalAliases := sZLEALIAS_Zlecenie_Nazwa;
  end;
end;

function TZleOsobyGodzDBDetailForm.ZlecenieSymbolDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
    ZlecenieNazwaLabel.Caption := AliasSrc.FieldByName(sZLEZLECENIE_NAZWA).AsString;

    if (OpenMode in [omEdit, omNew]) and
       (iZlecenieOldID <> AliasSrc.FieldByName(sZLEZLECENIE_ID).AsInteger) and
       ZlecenieSymbolDBLookupAliasEdit.Initialized then begin
       DMAQFbN(sZLEZLECENIEPOZ_ID).Clear;
       PozycjaLookupAliasEdit.Text := '';
    end;
  end;
  Result := True;
end;

function TZleOsobyGodzDBDetailForm.Validate: Boolean;
begin
  Result := inherited Validate();
  if result then begin
     {Sprawdzamy czy wypenione zostao jedno z pl: osoba albo zasb}
     if DMAQFbN(sKDOSOBA_ID).IsNull and DMAQFbN(sZLEZASOB_ID).IsNull then begin
        Komunikat(cWarning, 'Przynajmniej jedno z pl osoba lub zasb musi by uzupenione!');
        result := False;
        OsobaSymbolDBLookupAliasEdit.SetFocus();
     end;
  end;
end;

function TZleOsobyGodzDBDetailForm.CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule;
begin
  Result := TZleOsobyGodz.CreateOpen(Self, InheritedMasterKeyValues {Default}, AOpenMode);
end;

procedure TZleOsobyGodzDBDetailForm.InternalOpen;
begin
  bZmianaZasobu := False;
  InitializeControls();
  inherited;
  SetFieldFormat();
  if OpenMode = omNew then SetDefaults();
  if Owner is TZLESzczegoloweKosztyDBGridForm then
    ZlecenieSymbolDBLookupAliasEdit.aReadOnly := True;

  if not ZLEDM.vZLEFormatGodzinLiczba then
     IloscGodzEdit.Inicjuj;
  //IloscPracyGodzEdit.Inicjuj;

  //  if OpenMode in [omNew, omDelete] then begin
  if not DMAQFbN(sZLEZLECENIEPOZ_ID).IsNull then
     PozycjaLookupAliasEdit.InitiateData(DMAQFbN(sZLEZLECENIEPOZ_ID).AsInteger);
end;

procedure TZleOsobyGodzDBDetailForm.SelectButtonPressed;
begin
  if TUNIDBGridForm(Owner).Parameters.Values[sZLEOSOBYGODZ_DATA] = '' then
    TUNIDBGridForm(Owner).Parameters.Values[sZLEOSOBYGODZ_DATA] := DateToStr(DMAQFbN(sZLEOSOBYGODZ_DATA).AsDateTime)
  else
    TUNIDBGridForm(Owner).Parameters.Add(sZLEOSOBYGODZ_DATA + '=' + DateToStr(DMAQFbN(sZLEOSOBYGODZ_DATA).AsDateTime));
  if TUNIDBGridForm(Owner).Parameters.Values[sKDOSOBA_ID] = '' then
    TUNIDBGridForm(Owner).Parameters.Add(sKDOSOBA_ID + '=' + DMAQFbN(sKDOSOBA_ID).AsString)
  else
    TUNIDBGridForm(Owner).Parameters.Values[sKDOSOBA_ID] := DMAQFbN(sKDOSOBA_ID).AsString;
  if TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOB_ID] = '' then
    TUNIDBGridForm(Owner).Parameters.Add(sZLEZASOB_ID + '=' + DMAQFbN(sZLEZASOB_ID).AsString)
  else
    TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOB_ID] := DMAQFbN(sZLEZASOB_ID).AsString;
  if TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOB_SYMBOL] = '' then
    TUNIDBGridForm(Owner).Parameters.Add(sZLEZASOB_SYMBOL + '=' + ZasobDBLookupAliasEdit.Text)
  else
    TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOB_SYMBOL] := ZasobDBLookupAliasEdit.Text;
  {if TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOB_NAZWA] = '' then
    TUNIDBGridForm(Owner).Parameters.Add(sZLEZASOB_NAZWA + '=' + ZasobDBLookupAliasEdit.Text)
  else
    TUNIDBGridForm(Owner).Parameters.Values[sZLEZASOB_NAZWA] := ZasobDBLookupAliasEdit.Text;}
  if TUNIDBGridForm(Owner).Parameters.Values[sKDOSOBA_SYMBOL] = '' then
    TUNIDBGridForm(Owner).Parameters.Add(sKDOSOBA_SYMBOL + '=' + OsobaSymbolDBLookupAliasEdit.Text)
  else
    TUNIDBGridForm(Owner).Parameters.Values[sKDOSOBA_SYMBOL] := OsobaSymbolDBLookupAliasEdit.Text;
  if TUNIDBGridForm(Owner).Parameters.Values[sKDOSOBA_NAZWA] = '' then
    TUNIDBGridForm(Owner).Parameters.Add(sKDOSOBA_NAZWA + '=' + OsobaNazwaLabel.Caption)
  else
    TUNIDBGridForm(Owner).Parameters.Values[sKDOSOBA_NAZWA] := OsobaNazwaLabel.Caption;
  if TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIE_ID] = '' then
    TUNIDBGridForm(Owner).Parameters.Add(sZLEZLECENIE_ID + '=' + DMAQFbN(sZLEZLECENIE_ID).AsString)
  else
    TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIE_ID] := DMAQFbN(sZLEZLECENIE_ID).AsString;
  if TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIE_SYMBOL] = '' then
    TUNIDBGridForm(Owner).Parameters.Add(sZLEZLECENIE_SYMBOL + '=' + ZlecenieSymbolDBLookupAliasEdit.Text)
  else
    TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIE_SYMBOL] := ZlecenieSymbolDBLookupAliasEdit.Text;

  if TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIE_NAZWA] = '' then
    TUNIDBGridForm(Owner).Parameters.Add(sZLEZLECENIE_NAZWA + '=' + ZlecenieNazwaLabel.Caption)
  else
    TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIE_NAZWA] := ZlecenieNazwaLabel.Caption;

  if TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIEPOZ_ID] = '' then
    TUNIDBGridForm(Owner).Parameters.Add(sZLEZLECENIEPOZ_ID + '=' + DMAQFbN(sZLEZLECENIEPOZ_ID).AsString)
  else
    TUNIDBGridForm(Owner).Parameters.Values[sZLEZLECENIEPOZ_ID] := DMAQFbN(sZLEZLECENIEPOZ_ID).AsString;

  if TUNIDBGridForm(Owner).Parameters.Values[sASOASORT_ID] = '' then
    TUNIDBGridForm(Owner).Parameters.Add(sASOASORT_ID + '=' + DMAQFbN(sASOASORT_ID).AsString)
  else
    TUNIDBGridForm(Owner).Parameters.Values[sASOASORT_ID] := DMAQFbN(sASOASORT_ID).AsString;
{  if ASODM.vAsoCzyMaskaIndeksu then begin
    s := '';
    for i := 1 to Length(AsortymentIndeksDBLookupAliasEdit.Text) do
      if not (AsortymentIndeksDBLookupAliasEdit.Text[i] in [' ', '_', '-', '.']) then begin
        s := s + AsortymentIndeksDBLookupAliasEdit.Text[i];
      end;
  end else begin
    s := AsortymentIndeksDBLookupAliasEdit.Text;
  end;
  if TUNIDBGridForm(Owner).Parameters.Values[sASOASORT_INDEKS] ='' then
    TUNIDBGridForm(Owner).Parameters.Add(sASOASORT_INDEKS + '=' + s)
  else
    TUNIDBGridForm(Owner).Parameters.Values[sASOASORT_INDEKS] := s;}

{  if TUNIDBGridForm(Owner).Parameters.Values[sASOASORT_SYMBOL] ='' then
    TUNIDBGridForm(Owner).Parameters.Add(sASOASORT_SYMBOL + '=' + DMAQFbN(sASOASORT_SYMBOL).AsString)
  else
    TUNIDBGridForm(Owner).Parameters.Values[sASOASORT_SYMBOL] := DMAQFbN(sASOASORT_SYMBOL).AsString;}

  if TUNIDBGridForm(Owner).Parameters.Values[sASOASORT_NAZWA] = '' then
    TUNIDBGridForm(Owner).Parameters.Add(sASOASORT_NAZWA + '=' + AsortymentNazwaLabel.Caption)
  else
    TUNIDBGridForm(Owner).Parameters.Values[sASOASORT_NAZWA] := AsortymentNazwaLabel.Caption;

  if TUNIDBGridForm(Owner).Parameters.Values[sZLEOSOBYGODZ_ILOSC] = '' then  begin
     if not ZLEDM.vZLEFormatGodzinLiczba then
        TUNIDBGridForm(Owner).Parameters.Add(sZLEOSOBYGODZ_ILOSC + '=' + IntToStr(DMAQFbN(sZLEOSOBYGODZ_ILOSC).AsInteger))
     else
        TUNIDBGridForm(Owner).Parameters.Add(sZLEOSOBYGODZ_ILOSC + '=' + UNIFloatToFormatStr(12.6 {ASODM.vAsoFormatIlosci}, DMAQFbN(sZLEOSOBYGODZ_ILOSC).AsFloat))
  end else begin
     if not ZLEDM.vZLEFormatGodzinLiczba then
        TUNIDBGridForm(Owner).Parameters.Values[sZLEOSOBYGODZ_ILOSC] := IntToStr(DMAQFbN(sZLEOSOBYGODZ_ILOSC).AsInteger)
     else
        TUNIDBGridForm(Owner).Parameters.Values[sZLEOSOBYGODZ_ILOSC] := UNIFloatToFormatStr(12.6 {ASODM.vAsoFormatIlosci}, DMAQFbN(sZLEOSOBYGODZ_ILOSC).AsFloat);
  end;

  if TUNIDBGridForm(Owner).Parameters.Values[sZLEOSOBYGODZ_IL_PRACY] ='' then
    TUNIDBGridForm(Owner).Parameters.Add(sZLEOSOBYGODZ_IL_PRACY + '=' + UNIFloatToFormatStr(12.2 {ASODM.vAsoFormatIlosci}, DMAQFbN(sZLEOSOBYGODZ_IL_PRACY).AsFloat))
  else
    TUNIDBGridForm(Owner).Parameters.Values[sZLEOSOBYGODZ_IL_PRACY] := UNIFloatToFormatStr(12.2 {ASODM.vAsoFormatIlosci}, DMAQFbN(sZLEOSOBYGODZ_IL_PRACY).AsFloat);
  if TUNIDBGridForm(Owner).Parameters.Values[sZLEOSOBYGODZ_CENA] = '' then
    TUNIDBGridForm(Owner).Parameters.Add(sZLEOSOBYGODZ_CENA + '=' + UNIFloatToFormatStr(ASODM.vAsoFormatCeny, DMAQFbN(sZLEOSOBYGODZ_CENA).AsFloat))
  else
    TUNIDBGridForm(Owner).Parameters.Values[sZLEOSOBYGODZ_CENA] := UNIFloatToFormatStr(ASODM.vAsoFormatCeny, DMAQFbN(sZLEOSOBYGODZ_CENA).AsFloat);
  inherited;
end;

procedure TZleOsobyGodzDBDetailForm.OsobaSymbolDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  OsobaSymbolDBLookupAliasEdit.Text := '';
  OsobaNazwaLabel.Caption := '';
  if OpenMode in [omNew, omEdit] then begin
    if iOsobaOld <> DMAQFbN(sKDOSOBA_ID).AsInteger then
       iOsobaOld := 0;
    DMAQFbN(sKDOSOBA_ID).Clear;
  end;
end;

function TZleOsobyGodzDBDetailForm.OsobaSymbolDBLookupAliasEditGetDataField: String;
begin
  Result := sKDOSOBA_ID;
end;

function TZleOsobyGodzDBDetailForm.OsobaSymbolDBLookupAliasEditGetQuery: TUNIQuery;
var
  iFirmaId: integer;
begin
  iFirmaId := 0;
  if (UNISysDM.vWieloodzialowosc) and (Parameters.Values[sUNIODDZIAL_ID] <> '') then
    iFirmaID := StrToInt(Parameters.Values[sUNIODDZIAL_ID])
  else if UNISysDM.vWielofirmowosc then
    iFirmaID := UNISysDM.vAktywnaFirma;

  Result := UNISysDM.KDPokazIObsluzPracownika(
    self, '',
    sKDAlias_OsobaID + ';' + sKDAlias_OsobaSymbol + ';' + sKDAlias_OsobaNazwa,
    False,
    False,
    DMAQFbN(sKDOSOBA_ID).AsInteger,
    iFirmaID);
end;

procedure TZleOsobyGodzDBDetailForm.OsobaSymbolDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with OsobaSymbolDBLookupAliasEdit do begin
    if DataManagers.Available(sKDModulID) then begin
      AliasManager := KDDM.AliasManager;
    end else begin
      AliasManager := UNISysDM.AliasManager;
    end;
    Alias_ID := sKDAlias_OsobaID;
    Alias_Name := sKDAlias_OsobaSymbol;
    AdditionalAliases := sKDAlias_OsobaNazwa;
  end;
end;

function TZleOsobyGodzDBDetailForm.OsobaSymbolDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
var
  oQuery: TUNIQuery;
begin
  if AliasSrc <> nil then begin
    if (OpenMode = omNew) and
      (iOsobaOld <> DMAQFbN(sKDOSOBA_ID).AsInteger) then begin
      iOsobaOld := DMAQFbN(sKDOSOBA_ID).AsInteger;
      {Odszukanie w Zasobach Stawki dla pracownika (MAX)}
      oQuery := SQLManager.CreateQuery('SELECT ' + ' MAX(' + sZLEZASOB_STAWKA + ') AS ' + sZLEZASOB_STAWKA + ' ' +
                                        'FROM %s ' +
                                        'WHERE ' + sKDOSOBA_ID + ' = ' + IntToStr(DMAQFbN(sKDOSOBA_ID).AsInteger),
                                        [sZLEZASOB]);


      try
         oQuery.Open;
         if (not oQuery.IsEmpty) and (DMAQFbN(sZLEOSOBYGODZ_CENA).AsFloat <> oQuery.FieldByName(sZLEZASOB_STAWKA).AsFloat) then
            DMAQFbN(sZLEOSOBYGODZ_CENA).AsFloat := Zaokraglij(oQuery.FieldByName(sZLEZASOB_STAWKA).AsFloat, UNIGetFracFromValueFormat(ASODM.vAsoFormatCeny));
      finally
        if oQuery <> nil then FreeAndNil(oQuery);
      end;
    end;

    if (OpenMode in [omNew, omEdit]) and
        OsobaSymbolDBLookupAliasEdit.Initialized and
       (not bZmianaZasobu) and
       (not DMAQFbN(sZLEZASOB_ID).IsNull) and
       (not AliasSrc.FieldByName(sKDOSOBA_ID).IsNull) then begin
        DMAQFbN(sZLEZASOB_ID).Clear;
        iZasobOldID := 0;
        ZasobDBLookupAliasEdit.Text := '';
    end;

    OsobaNazwaLabel.Caption := AliasSrc.FieldByName(sKDOSOBA_NAZWA).AsString;
  end;
  Result := True;
end;

procedure TZleOsobyGodzDBDetailForm.DataDBDateEditDateChange(
  Sender: TObject);
var
  iRokID: Integer;
  q: TUNIQuery;
begin
  if not (OpenMode in [omNew, omEdit]) then Exit;
  iRokID := -1;
  q := UniSysDataManager.UNIPodajRokObrachunkowy(DataDBDateEdit.Date, sUNISYSALIAS_Rok_ID);
  try
    if q = Nil then begin
      Komunikat(cInformation, Format('Data "%d" jest niezgodna ze zdefiniowanymi latami obrachunkowymi' ,[DataDBDateEdit.Date]));
    end else
      iRokID := q.Fields[0].AsInteger;
  finally
    FreeAndNil(q);
  end;
  q := UNISysDataManager.UNIPodajOkresObrachunkowy(
    iRokID,
    DataDBDateEdit.Date,
    sUNISYSALIAS_Okres_Obrachunkowy_ID + ';' + sUNISYSALIAS_Poczatek_Okresu_Obrachunkowego + ';' + sUNISYSALIAS_Koniec_Okresu_Obrachunkowego
  );
  try
    if q = Nil then begin
      Komunikat(cInformation, Format('Data "%d" jest niezgodna ze zdefiniowanymi okresami obrachunkowymi' ,[DataDBDateEdit.Date]));
    end else
      if OpenMode in [omNew, omEdit] then
        begin
          DMAQFbN(sUNIOKRES_ID).AsInteger := q.Fields[0].AsInteger;
        end;
  finally
    FreeAndNil(q);
  end;
end;

procedure TZleOsobyGodzDBDetailForm.AsortymentSymbolDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  AsortymentSymbolDBLookupAliasEdit.Text := '';
  AsortymentNazwaLabel.Caption := '';
  if OpenMode in [omNew, omEdit] then begin
    DMAQFbN(sASOASORT_ID).Clear;
//    DMAQFbN(sASOASORT_INDEKS).Clear;
  end;
end;

function TZleOsobyGodzDBDetailForm.AsortymentSymbolDBLookupAliasEditGetDataField: String;
begin
  Result := sASOASORT_ID;
end;

function TZleOsobyGodzDBDetailForm.AsortymentSymbolDBLookupAliasEditGetQuery: TUNIQuery;
var
  sWhere: String;
begin
  result  := nil;
  if ZLEDM.vZLEAsoReg_ID <= 0 then begin
    Komunikat(cInformation, 'Nie zdefiniowano reguy asortymentowej dla moduu zlece.');
    Exit;
  end;
  if DMAQFbN(sASOASORT_ID).IsNull then begin
    if AsortymentSymbolDBLookupAliasEdit.Text = '' then begin
      sWhere := '';
    end else begin
      sWhere := sASOASORT_SYMBOL + ' LIKE ''' + AsortymentSymbolDBLookupAliasEdit.Text + '%''';
    end;
  end else
    sWhere := '@'+sASOAlias_Asort_ID+'='+IntToStr(DMAQFbN(sASOASORT_ID).AsInteger);
  Result := ASODM.PokazIObsluzAsortyment( sASOAlias_Asort_ID + ';' +
                                          sASOAlias_Asort_Symbol + ';' +
                                          sASOAlias_Asort_Indeks + ';' +
                                          sASOAlias_Asort_Nazwa,
                                          '',
                                          False,
                                          False,
                                          sWhere,
                                          ZLEDM.vZLEAsoReg_ID
                                        );
end;

procedure TZleOsobyGodzDBDetailForm.AsortymentSymbolDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with AsortymentSymbolDBLookupAliasEdit do begin
    AliasManager := ASODM.AliasManager;
    Alias_ID := sASOAlias_Asort_ID;
    Alias_Name := sASOAlias_Asort_Symbol;
    AdditionalAliases := sASOAlias_Asort_Indeks + ';' + sASOAlias_Asort_Nazwa;
  end;
end;

function TZleOsobyGodzDBDetailForm.AsortymentSymbolDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
    AsortymentNazwaLabel.Caption := AliasSrc.FieldByName(sASOASORT_NAZWA).AsString;
 //   DMAQFbN(sASOASORT_INDEKS).AsString := AliasSrc.FieldByName(sASOASORT_INDEKS).AsString;
  end;
  Result := True;
end;

procedure TZleOsobyGodzDBDetailForm.SetFieldFormat;
begin
  (DMAQFbN(sZLEOSOBYGODZ_ILOSC) as TNumericField).DisplayFormat := UNIGetMaskFromFormat(ASODM.vAsoFormatIlosci);
  (DMAQFbN(sZLEOSOBYGODZ_IL_PRACY) as TNumericField).DisplayFormat := UNIGetMaskFromFormat(12.2 {ASODM.vAsoFormatIlosci});
  (DMAQFbN(sZLEOSOBYGODZ_ILOSC) as TNumericField).EditFormat := UNIGetMaskFromFormat(ASODM.vAsoFormatIlosci, True);
  (DMAQFbN(sZLEOSOBYGODZ_IL_PRACY) as TNumericField).EditFormat := UNIGetMaskFromFormat(12.2 {ASODM.vAsoFormatIlosci}, True);
  (DMAQFbN(sZLEOSOBYGODZ_CENA) as TNumericField).DisplayFormat := UNIGetMaskFromFormat(ASODM.vAsoFormatCeny);
  (DMAQFbN(sZLEOSOBYGODZ_CENA) as TNumericField).EditFormat := UNIGetMaskFromFormat(ASODM.vAsoFormatCeny, True);
end;

procedure TZleOsobyGodzDBDetailForm.InitializeControls;
begin
  if Parameters.Values[cFORM_CAPTION] <> '' then begin
    Caption := Parameters.Values[cFORM_CAPTION];
  end;

  if ZLEDM.vZLEFormatGodzinLiczba then begin
     IloscGodzEdit.Visible := False;
     IloscDBEdit.Visible := True;
  end else begin
     IloscGodzEdit.Visible := True;
     IloscDBEdit.Visible := False;
  end;
  //AsortymentIndeksDBLookupAliasEdit.EditMask := ASODM.vAsoMaskaIndeksu+';0;_';
  OsobaNazwaLabel.Caption := '';
  ZlecenieNazwaLabel.Caption := '';
  AsortymentNazwaLabel.Caption := '';

  with PozycjaLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_ID := sZLEALIAS_ZLECENIEPOZ_ID;
    Alias_Name := sZLEALIAS_ZLECENIEPOZ_LP;

    AdditionalAliases := {sZLEALIAS_ZLECENIEPOZ_ASORT_ID+';'+
                         sZLEALIAS_ZLECENIEPOZ_OPIS+';'+}
                         sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID;

    if ZLEDM.vZLEWymaganaPozycjaEwid then
       PozycjaLookupAliasEdit.aAllowEmpty := False;
  end;

end;

procedure TZleOsobyGodzDBDetailForm.ZasobDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  ZasobDBLookupAliasEdit.Text := '';
  if OpenMode in [omNew, omEdit] then begin
    DMAQFbN(sZLEZASOB_ID).Clear;
    iZasobOldID := 0;
  end;
end;

function TZleOsobyGodzDBDetailForm.ZasobDBLookupAliasEditGetDataField: String;
begin
  result := sZLEZASOB_ID;
end;

function TZleOsobyGodzDBDetailForm.ZasobDBLookupAliasEditGetQuery: TUNIQuery;
var
//  iFirmaId: integer;
  oPar: TKeyValues;
begin
{
  iFirmaId := 0;
  if (UNISysDM.vWieloodzialowosc) and (Parameters.Values[sUNIODDZIAL_ID] <> '') then
    iFirmaID := StrToInt(Parameters.Values[sUNIODDZIAL_ID])
  else if UNISysDM.vWielofirmowosc then
    iFirmaID := UNISysDM.vAktywnaFirma;
}
  try
    oPar := TKeyValues.CreateEmpty;
    if ZLEDM.vZLEOgraniczonaListaZasobow and (DMAQFbN(sZLEZLECENIE_ID).AsString <> '') then
       oPar.Add(sZLEZLECENIE_ID + '=' + DMAQFbN(sZLEZLECENIE_ID).AsString);

    Result := ZLEDM.ZLEPokazIObsluzdane(sZLEZASOB,
                                      sZLEALIAS_ZLEZASOB_ID+ ';' +
                                      sZLEALIAS_ZLEZASOB_SYMBOL + ';' +
                                      sZLEALIAS_ZLEZASOB_NAZWA+ ';' +
                                      sZLEALIAS_ZLEZASOB_KDOSOBA_ID{ + ';' +
                                      sZLEALIAS_ZLECENIEZASOB_ZLECENIE_ID},
                                      '',
                                      False,
                                      False,
                                      cZLEModulZSI_ID,
                                      DMAQFbN(sZLEZASOB_ID).AsInteger,
                                      0,
                                      '',
                                      nil,
                                      nil,
                                      oPar
                                      );

  finally
   // if oPar <> nil then FreeAndNil(oPar);
  end;
end;

procedure TZleOsobyGodzDBDetailForm.ZasobDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with ZasobDBLookupAliasEdit do begin
    AliasManager      := ZLEDM.AliasManager;
    Alias_ID          := sZLEAlias_ZLEZasob_ID;
    Alias_Name        := sZLEAlias_ZLEZasob_Symbol;
    AdditionalAliases := sZLEAlias_ZLEZasob_Nazwa + ';' +sZLEALIAS_ZLEZASOB_KDOSOBA_ID;
  end;
end;

function TZleOsobyGodzDBDetailForm.ZasobDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
var
  oQuery: TUNIQuery;
begin
  inherited;
  bZmianaZasobu := True;
  if (AliasSrc <> nil) and (OpenMode in [omNew, omEdit]) and ZasobDBLookupAliasEdit.Initialized then begin
     {Podpowiadanie stawki dla zasobu}
     if (OpenMode = omNew) and (iZasobOldID <> DMAQFbN(sZLEZASOB_ID).AsInteger) then begin
       iZasobOldID := DMAQFbN(sZLEZASOB_ID).AsInteger;
       {Odszukanie w Zasobach Stawki dla zasobu (MAX)}
       oQuery := SQLManager.CreateQuery('SELECT ' + ' MAX(' + sZLEZASOB_STAWKA + ') AS ' + sZLEZASOB_STAWKA + ' ' +
                                        'FROM %s ' +
                                        'WHERE ' + sZLEZASOB_ID + ' = ' + IntToStr(DMAQFbN(sZLEZASOB_ID).AsInteger),
                                        [sZLEZASOB]);


       try
         oQuery.Open;
         if (not oQuery.IsEmpty) and (DMAQFbN(sZLEOSOBYGODZ_CENA).AsFloat <> oQuery.FieldByName(sZLEZASOB_STAWKA).AsFloat) then
            DMAQFbN(sZLEOSOBYGODZ_CENA).AsFloat := Zaokraglij(oQuery.FieldByName(sZLEZASOB_STAWKA).AsFloat, UNIGetFracFromValueFormat(ASODM.vAsoFormatCeny));
       finally
         if oQuery <> nil then FreeAndNil(oQuery);
       end;
     end;

     if AliasSrc.FieldByName(sKDOsoba_ID).AsInteger > 0 then begin
        if DMAQFbN(sKDOSOBA_ID).AsInteger <> AliasSrc.FieldByName(sKDOsoba_ID).AsInteger then
           OsobaSymbolDBLookupAliasEdit.InitiateData(AliasSrc.FieldByName(sKDOSOBA_ID).AsInteger);
     end else begin
        DMAQFbN(sKDOSOBA_ID).Clear;
        OsobaSymbolDBLookupAliasEdit.Text := '';
        OsobaNazwaLabel.Caption := '';
     end;
  end;   
  bZmianaZasobu := False;
  Result := True;
end;

procedure TZleOsobyGodzDBDetailForm.PozycjaLookupAliasEditButtonClick(
  Sender: TObject);
var
  oQuery: TUniQuery;
  sWarunek: String;
begin
  sWarunek := '';
  if DMAQFbN(sZLEZLECENIE_ID).AsString <> '' then
     sWarunek := '@' + sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID + '=' + DMAQFbN(sZLEZLECENIE_ID).AsString
  else begin
     Komunikat(cInformation, 'Wybierz najpierw zlecenie');
     Exit;
  end;

  oQuery := ZLEDM.ZLEPokazIObsluzDane( sZLEZLECENIEPOZ,
                                       sZLEALIAS_ZLECENIEPOZ_ID+';'+
                                       sZLEALIAS_ZLECENIEPOZ_LP+';'+
                                      // sZLEALIAS_ZLECENIEPOZ_ASORT_ID+';'+
                                      // sZLEALIAS_ZLECENIEPOZ_OPIS+';'+
                                       sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID,
                                       sWarunek,
                                       True, True );
  if oQuery <> nil then
     PozycjaLookupAliasEditSetData(oQuery);
end;

function TZleOsobyGodzDBDetailForm.PozycjaLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
     if OpenMode in [omNew, omEdit] then begin
        DMAQFbN(sZLEZLECENIEPOZ_ID).AsInteger :=  AliasSrc.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger;
        PozycjaLookupAliasEdit.Text := AliasSrc.FieldByName(sZLEZLECENIEPOZ_LP).AsString;
     //   AsortymentSymbolDBLookupAliasEdit.InitiateData(StrToIntDef(Parameters.Values[sASOASORT_ID],0));
     end;
  end;
  result  := true;
end;

initialization
  FormManager.RegisterForm(TZleOsobyGodzDBDetailForm, 'Rejestracja czasu pracy', sZLEModulID);
end.
