unit ZleOsobyGodzDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Modu dostarczajcy aktualizacje bazy.

Changes
---------------------------------------------------------------------------------------------
When       Who    What
---------------------------------------------------------------------------------------------
2004-12-05 kk     Utworzone
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls, UNIStaleUnit, UNIDataModuleUnit, UNIFormUnit, KeyManagerUnit;

type
  TZleOsobyGodzDBGridForm = class(TUNIDBGridForm)
    N1: TMenuItem;
    Dajwartopracy1: TMenuItem;
    ZakresButton: TUNIButton;
    FunkcjeToolButton: TToolButton;
    FunkcjePopupMenu: TUNIPopupMenu;
    PrzeliczMenuItem: TMenuItem;
    procedure Dajwartopracy1Click(Sender: TObject);
    procedure DBGridDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure ZakresButtonClick(Sender: TObject);
    procedure PrzeliczMenuItemClick(Sender: TObject);
  private
    bLastLesult: TModalResult;
    procedure OpenDetail(AOpenMode: TOpenMode);
  protected
    procedure New(); override;
    procedure Open(); override;
    procedure View(); override;
    procedure Delete(); override;
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure SetUserRights; override;
  public
    procedure InternalOpen(); override;
    procedure GetParametersForForm( AForm: TUNIForm; Parameters: TKeyValues ); override;
    function  GetHelpContextSuffix: String; override;
  end;

implementation

uses
  Dodatki,
  FormManagerUnit,
  SecurityManagerUnit,
  UNIImageManagerUnit,
  UNIDBDetailFormUnit,
  SystemDefUnit,
  ZLEdefUnit,
  ASOdefUnit,
  ASODataManagerExtUnit,
  ZleOsobyGodzUnit,
  ZLEDataManagerUnit,
  SQLManagerUnit,
  UNISysDefUnit,
  ProgressFormUnit;

{$R *.DFM}



function TZleOsobyGodzDBGridForm.GetHelpContextSuffix: String;
{ przyrostki do obs-ugi:
 [brak przyrostka]                        LWP                  4.2
 RCPOSO                                   zlecenia             4.2                  Rejestracja czasu pracy osb(RCP)
}
begin
   result := ''; {Okienko jest takie samo bez wzgldu z jakiego miejsca jest wywoane}
end;

procedure TZleOsobyGodzDBGridForm.GetParametersForForm(AForm: TUNIForm; Parameters: TKeyValues);
begin
  Parameters.Assign(Self.Parameters);
end;

function TZleOsobyGodzDBGridForm.CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZleOsobyGodz.CreateOpen(Self, DefaultMasterKeyValues, AOpenMode);
end;

procedure TZleOsobyGodzDBGridForm.Delete;
begin
  OpenDetail(omDelete);
end;

procedure TZleOsobyGodzDBGridForm.InternalOpen;
begin
  if Parameters.Values[cFORM_CAPTION] <> '' then begin
    Caption := Parameters.Values[cFORM_CAPTION];
  end;
  inherited;
  FunkcjeToolButton.ImageIndex:= cimPreselekcja;
end;

procedure TZleOsobyGodzDBGridForm.New;
begin
  OpenDetail(omNew);
  while bLastLesult = mrOK do begin
    OpenDetail(omNew);
  end;
end;

procedure TZleOsobyGodzDBGridForm.Open;
begin
  OpenDetail(omEdit);
end;

procedure TZleOsobyGodzDBGridForm.OpenDetail(AOpenMode: TOpenMode);
var
  oParams: TKeyValues;
  f: TUNIDBDetailForm;
begin
  bLastLesult := mrCancel;
  inherited;
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add(cFORM_CAPTION+'='+'Szczegy rejestracji czasu pracy');
  end;

  AOpenMode := AOpenMode + omShowModal + omHidden;
  f := FormManager.OpenDBDetail(Self, 'TZleOsobyGodzDBDetailForm', AOpenMode, oParams);
  bLastLesult := f.ShowModal;
  if f <> nil then FreeAndNil(f);
end;

procedure TZleOsobyGodzDBGridForm.View;
begin
  OpenDetail(omView);
end;

procedure TZleOsobyGodzDBGridForm.Dajwartopracy1Click(Sender: TObject);
var
  wartosc: Extended;
begin
  inherited;
  wartosc := ZLEDM.ZleDajWartoscPracy(DMAQFbN(sZLEZLECENIE_ID).AsInteger, DMAQFbN(sUNIOKRES_ID).AsInteger);
  ShowMessage(UNIFloatToFormatStr(12.2, wartosc));
end;

procedure TZleOsobyGodzDBGridForm.SetUserRights;
begin
  with SecurityManager do begin
    Switch_View_HotKey(SM_UserCanDo(sZLE_REJ_CZASU_PRACY_POKAZ));
    Switch_New_HotKey(SM_UserCanDo(sZLE_REJ_CZASU_PRACY_DOPISZ));
    Switch_Open_HotKey(SM_UserCanDo(sZLE_REJ_CZASU_PRACY_ZMIEN));
    Switch_Delete_HotKey(SM_UserCanDo(sZLE_REJ_CZASU_PRACY_USUN));
  end;
end;

procedure TZleOsobyGodzDBGridForm.DBGridDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
  s: string;
begin
  inherited;
  if Column.Field <> Nil then begin
    s:= Column.Field.AsString;
    if (Column.FieldName = sZLEOSOBYGODZ_ILOSC) then begin
      if ZLEDM.vZLEFormatGodzinLIczba then
        s := FormatFloat('### ##0.00', Zaokraglij(DMAQFbN(sZLEOSOBYGODZ_ILOSC).AsFloat, UNIGetFracFromValueFormat(ASODM.vAsoFormatIlosci)))
      else
        s := FormatFloat('### ### ##0', DMAQFbN(sZLEOSOBYGODZ_ILOSC).AsInteger div 60) + ':' + FormatFloat('00', DMAQFbN(sZLEOSOBYGODZ_ILOSC).AsInteger mod 60);
      DBGrid.WriteText(DBGrid.Canvas, Rect, s, Column.Alignment);
    {end else if (Column.FieldName = sZLEOSOBYGODZ_IL_PRACY) then begin
      s := FormatFloat('### ### ##0', DMAQFbN(sZLEOSOBYGODZ_IL_PRACY).AsInteger div 60) + ':' + FormatFloat('00', DMAQFbN(sZLEOSOBYGODZ_IL_PRACY).AsInteger mod 60);
      DBGrid.WriteText(DBGrid.Canvas, Rect, s, Column.Alignment);}
    end;
  end;
end;

procedure TZleOsobyGodzDBGridForm.ZakresButtonClick(Sender: TObject);
begin
  if OpenRangeForm() then
    DataModule.ReOpenDataSets();
  DBGrid.SetFocus;
end;

procedure TZleOsobyGodzDBGridForm.PrzeliczMenuItemClick(Sender: TObject);
var
  oParams : TKeyValues;
  oForm:    TUNIForm;
  bTrans: Boolean;
  sSQL: String;
  iJednostkaID, iOkresID: Integer;
begin
  oParams := TKeyValues.CreateEmpty;
  bTrans  := false;
  if not DataModule.ActiveQuery.IsEmpty then begin
     {Pobranie domyslnych wartoci}
     oForm := FormManager.OpenForm(self, 'TZLEOsobyGodzPrzeliczSelectForm',
                                   omEdit + omHidden, oParams);

     try
        if (oForm.ShowModal = mrOk) then begin
           iJednostkaID := 0;
           iOkresID := 0;

           if oParams <> nil then begin
              if (oParams.Values[sUNIJEDNOSTKAORG_ID] <> '') and (oParams.Values[sUNIJEDNOSTKAORG_ID] <> '-1') then
                iJednostkaID := StrToInt(oParams.Values[sUNIJEDNOSTKAORG_ID]);

              if (oParams.Values[sUNIOKRES_ID] <> '') and (oParams.Values[sUNIOKRES_ID] <> '-1') then
                 iOkresID := StrToInt(oParams.Values[sUNIOKRES_ID]);
           end;

           if (iOkresID > 0) and (iJednostkaID > 0) then begin
              try
                DataModule.ActiveQuery.DisableControls;
                bTrans := not SQLManager.InTransaction;
                if bTrans then SQLManager.StartTransaction;

                sSQL := 'UPDATE %s ZG ' +
                        'SET ZG.' + sZLEOSOBYGODZ_CENA + ' = (SELECT ZO1.' + sZLEZASOB_STAWKA + ' ' +
                                                             'FROM %s ZO1 ' +
                                                             'WHERE ZO1.' + sUNIJEDNOSTKAORG_ID + ' = ' + IntToStr(iJednostkaID) + ' AND ' +
                                                                   '(((ZG.' + sKDOSOBA_ID + ' = ZO1.' + sKDOSOBA_ID + ') AND ' +
                                                                     '(ZO1.' + sZLEZASOB_RODZAJ + ' = ' + QuotedStr('P') + ')) OR ' +
                                                                    '((ZG.' + sZLEZASOB_ID + ' = ZO1.' + sZLEZASOB_ID + ') AND ' +
                                                                     '(ZO1.' + sZLEZASOB_RODZAJ + ' = ' + QuotedStr('M') + ')) )) ' +
                        'WHERE ZG.' + sZLEOSOBYGODZ_ID + ' IN (SELECT ZOG.' + sZLEOSOBYGODZ_ID + ' ' +
                                                              'FROM %s ZOG, %s ZO ' +
                                                              'WHERE ZOG.' + sUNIOKRES_ID + ' = ' + IntToStr(iOkresID) + ' AND ' +
                                                                     'ZO.' + sUNIJEDNOSTKAORG_ID + ' = ' + IntToStr(iJednostkaID) + ' AND ' +
                                                                     '(((ZOG.' + sKDOSOBA_ID + ' = ZO.' + sKDOSOBA_ID + ') AND ' +
                                                                       '(ZO.' + sZLEZASOB_RODZAJ + ' = ' + QuotedStr('P') + ')) OR ' +
                                                                      '((ZOG.' + sZLEZASOB_ID + ' = ZO.' + sZLEZASOB_ID + ') AND ' +
                                                                       '(ZO.' + sZLEZASOB_RODZAJ + ' = ' + QuotedSTr('M') + ')) ))';
                SQLManager.ExecuteQuery(sSQL, [sZLEOSOBYGODZ, sZLEZASOB, sZLEOSOBYGODZ, sZLEZASOB]);
                if bTrans then SQLManager.Commit;
              finally
                DataModule.ActiveQuery.EnableControls;
                DataModule.ReOpenDataSets();
              end;
           end;
        end;
     finally
        if bTrans and SQLManager.InTransaction then SQLManager.RollBack;
        oForm.Free;
     end;
  end;
end;

initialization
  FormManager.RegisterForm( TZleOsobyGodzDBGridForm, 'Rejestracja czasu pracy', sZLEModulID );

end.
