unit ZleOsobyGodzSelectFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2008-04-03 tomjen   Utworzone
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIRangeFormUnit, Menus, UNIComponentsUnit, ToolWin, ComCtrls, StdCtrls,
  Buttons, ExtCtrls, DB, UNIDateEditUnit, Mask;

type
  TZleOsobyGodzSelectForm = class(TUNIRangeForm)
    DataOtwarciaPanel: TUNIPanel;
    DataLabel: TUNILabel;
    DataDoLabel: TUNILabel;
    DataOdDateEdit: TUNIDateEdit;
    DataDoDateEdit: TUNIDateEdit;
    OkresLookupAliasEdit: TUNILookupAliasEdit;
    OkresLabel: TUNILabel;
    OsobaLabel: TUNILabel;
    OsobaLookupAliasEdit: TUNIRangeLookupAliasEdit;
    ZasobLabel: TUNILabel;
    ZasobLookupAliasEdit: TUNIRangeLookupAliasEdit;
    ZlecenieLabel: TUNILabel;
    ZlecenieLookupAliasEdit: TUNIRangeLookupAliasEdit;
    function  ZlecenieLookupAliasEditGetQuery: TUNIQuery;
    procedure ZlecenieLookupAliasEditInitAliasInfo(Sender: TObject);
    procedure OkresLookupAliasEditButtonClick(Sender: TObject);
    procedure OkresLookupAliasEditDelKey(Sender: TObject);
    function  OkresLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    function  OsobaLookupAliasEditGetQuery: TUNIQuery;
    procedure OsobaLookupAliasEditInitAliasInfo(Sender: TObject);
    function  ZasobLookupAliasEditGetQuery: TUNIQuery;
    procedure ZasobLookupAliasEditInitAliasInfo(Sender: TObject);
    procedure DataOdDateEditDateChange(Sender: TObject);
    procedure DataDoDateEditDateChange(Sender: TObject);
    //function  OddzialRangeLookupAliasEditGetQuery: TUNIQuery;
    //procedure OddzialRangeLookupAliasEditInitAliasInfo(Sender: TObject);
  private
    bProcessData: Boolean;
    bUstawOkres : Boolean;

    procedure InitializeControls();
    procedure InitializeObjectFields();
    procedure UstawAliasy();
    //procedure GetParamZasForGrid();

  protected
    procedure ProcessData; override;
    procedure ProcessRangeParamsToParameters; override;
    procedure PrepareParamsStep1; override;
    procedure PrepareParamsStep2; override;
    procedure PackData; override;
    procedure BeforeShow; override;
    procedure InternalOpen; override;
    procedure RestoreDefaults; override;
    procedure AssignProperties; override;
    procedure SelectButtonPressed; override;
    procedure WczytajZakresyDatDlaOkresu(sOkresID:string;
                                         var dOkresOd:TDateTime;
                                         var dOkresDo:TDateTime);
  public
    destructor Destroy(); override;
    function  Validate: Boolean; override;
  end;

var
  ZleOsobyGodzSelectForm: TZleOsobyGodzSelectForm;

implementation

{$R *.DFM}

uses
  Dodatki,
  FormManagerUnit,
  UNISysDataManagerUnit,
  UNISysDefUnit,
  UNIStaleUnit,
  SecurityManagerUnit,
  SQLManagerUnit,
  SystemDefUnit,
  KeyManagerUnit,
  KDDefUnit,
  KDDataManagerExtUnit,
  UNIDataManagerUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit;

function TZleOsobyGodzSelectForm.ZlecenieLookupAliasEditGetQuery: TUNIQuery;
var
  oSelectedId: TStringList;
begin
  if RangeParam(sParam_ZLEZlecenieID).Count > 0 then
     oSelectedId := RangeParam(sParam_ZLEZlecenieID)
  else
     oSelectedId := nil;

  Result := ZLEDM.ZlePokazIObsluzZlecenia( sZLEALIAS_Zlecenie_ID +';'+ sZLEALIAS_Zlecenie_Symbol,
                                '', true, true, 0, StrToIntDef( RangeParam(sParam_ZLEZlecenieID).Value, 0),
                                0, oSelectedId );
end;

procedure TZleOsobyGodzSelectForm.ZlecenieLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with ZlecenieLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_Name := sZLEALIAS_Zlecenie_Symbol;
    Alias_ID := sZLEALIAS_Zlecenie_ID;
  end;
end;

procedure TZleOsobyGodzSelectForm.OkresLookupAliasEditButtonClick(
  Sender: TObject);
var
  Q:  TDataset;
begin
  Q:= UNISysDM.UNIPokazIWybierzOkresObrachunkowy(
    vAktywnyRokObrachunkowyID,'',
    sUNISYSALIAS_Okres_Obrachunkowy_ID+';'+sUNISYSALIAS_Okres_Obrachunkowy_Nazwa+';'+
    sUNISYSALIAS_Okres_Obrachunkowy_Rok_Opis,
    false, RangeParam(sUNIOKRES_ID).Value);

  if Q<> nil then
  try
    OkresLookupAliasEditSetData(Q);
  finally
    Q.free;
  end;
end;

procedure TZleOsobyGodzSelectForm.OkresLookupAliasEditDelKey(
  Sender: TObject);
begin
  RangeParam(sUNIOKRES_ID).Clear();
  OkresLookupAliasEdit.Text := '';
end;

procedure TZleOsobyGodzSelectForm.WczytajZakresyDatDlaOkresu(
                                        sOkresID:string;
                                        var dOkresOd:TDateTime;
                                        var dOkresDo:TDateTime);
var
  Q    :TUNIQuery;
  sSQL :string;

begin
  //musz wczyta min i max zakres dat
  sSQL:=UNISysDM.UNIOdpytajODaneSQL( sUNIOKRES,
                            sUNISYSALIAS_Poczatek_Okresu_Obrachunkowego+';'+
                            sUNISYSALIAS_Koniec_Okresu_Obrachunkowego,
                            '@'+sUNISYSALIAS_Okres_Obrachunkowy_ID+'='+sOkresID,false);

  Q := TUNIQuery.Create(nil);
  if Q <> nil then
  try
    SQLManager.OpenQuery(Q, sSQL, ['']);
    dOkresOd:=Q.Fields[0].AsDateTime;
    dOkresDo:=Q.Fields[1].AsDateTime;
  finally
    if Q <> nil then FreeAndNil(Q);
  end;
end;

function TZleOsobyGodzSelectForm.OkresLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
var
  dOkresOd:TDateTime;
  dOkresDo:TDateTime;
begin
  result:= true;

  with AliasSrc do begin
    OkresLookupAliasEdit.Text := AliasSrc.FieldByName(sUNIOKRES_NAZWA).AsString;
    //RangeParam(sUNIOKRES_NAZWA).Value := AliasSrc.FieldByName(sUNIOKRES_NAZWA).AsString;
    RangeParam(sUNIOKRES_ID).Value := AliasSrc.FieldByName(sUNIOKRES_ID).AsString;
    //RangeParam(sUNIROK_ROK_TEXT).Value:= AliasSrc.FieldByName(sUNIROK_ROK_TEXT).AsString;

    if bProcessData then Exit;

    //Teraz ewentualna korekta zakresu dat
    if RangeParam(sUNIOKRES_ID).IsSet then
    begin
      try
        if RangeParam(sUNIOKRES_ID).Value = '' then Exit;

        bUstawOkres := True;

        //jest okres - trzeba wczyta min i max zakres dat
        WczytajZakresyDatDlaOkresu(RangeParam(sUNIOKRES_ID).Value,dOkresOd,dOkresDo);

        if (DataOdDateEdit.Date < dOkresOd) or
           (DataOdDateEdit.Date > dOkresDo) then
           DataOdDateEdit.Date := dOkresOd;

        if (DataDoDateEdit.Date < dOkresOd) or
           (DataDoDateEdit.Date > dOkresDo) then
           DataDoDateEdit.Date := dOkresDo;

        if DataDoDateEdit.Date < DataOdDateEdit.Date then
        begin
           DataOdDateEdit.Date := dOkresOd;
           DataDoDateEdit.Date := dOkresDo;
        end;
      finally
        bUstawOkres := False;
      end;
    end;
  end;
end;

function TZleOsobyGodzSelectForm.OsobaLookupAliasEditGetQuery: TUNIQuery;
var
  oSelectedIds: TStringList;
begin
  inherited;
  oSelectedIds := nil;
  if RangeParam(sParam_ZLEOsobaID).Count > 0 then
    oSelectedIds := RangeParam(sParam_ZLEOsobaID);

  result := UNISysDM.KDPokazIObsluzPracownika(
             self, '', sKDAlias_OsobaID + ';' + sKDAlias_OsobaSymbol,
             True, False, 0, vAktywnaFirma, '', '', oSelectedIds);
end;

procedure TZleOsobyGodzSelectForm.OsobaLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with OsobaLookupAliasEdit do begin
    AliasManager  := UniSysDM.AliasManager;
    Alias_ID      := sKDALIAS_OsobaID;
    Alias_Name    := sKDALIAS_OsobaSymbol;
  end;
end;

function TZleOsobyGodzSelectForm.ZasobLookupAliasEditGetQuery: TUNIQuery;
var
  oSelectedId: TStringList;
begin
  if RangeParam(sParam_ZLEZasobID).Count > 1 then
     oSelectedId := RangeParam(sParam_ZLEZasobID)
  else
     oSelectedId := nil;

  Result := ZLEDM.ZLEPokazIObsluzDane( sZLEZASOB,
                                       sZLEALIAS_ZLEZASOB_ID+';'+
                                       sZLEALIAS_ZLEZASOB_NAZWA, '',
                                       True, True, cZLEModulZSI_ID, 0, 0,
                                       '', oSelectedId );
end;

procedure TZleOsobyGodzSelectForm.ZasobLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with ZasobLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_ID := sZLEALIAS_ZLEZASOB_ID;
    Alias_Name := sZLEALIAS_ZLEZASOB_NAZWA;
  end;
end;

procedure TZleOsobyGodzSelectForm.DataOdDateEditDateChange(
  Sender: TObject);
begin
  inherited;
  if Trunc(DataOdDateEdit.Date) <> 0 then begin
    RangeParam(sParam_ZLEDataOd).Value := IntToStr(Trunc(DataOdDateEdit.Date));

    if bProcessData then Exit;
    if not bUstawOkres then begin
      if ((Trunc(DataDoDateEdit.Date) <> 0) and
          (DataDoDateEdit.Date < DataOdDateEdit.Date))
          or (Trunc(DataDoDateEdit.Date) = 0) then
         DataDoDateEdit.Date := DataOdDateEdit.Date;
    end;
  end else
    RangeParam(sParam_ZLEDataOd).Clear();

end;

procedure TZleOsobyGodzSelectForm.DataDoDateEditDateChange(
  Sender: TObject);
begin
  inherited;
  if Trunc(DataDoDateEdit.Date) <> 0 then
    RangeParam(sParam_ZLEDataDo).Value := IntToStr(Trunc(DataDoDateEdit.Date))
  else
    RangeParam(sParam_ZLEDataDo).Clear();
end;

(**********
function TZleOsobyGodzSelectForm.OddzialRangeLookupAliasEditGetQuery: TUNIQuery;
var
  oSelectedId: TStringList;
begin
  result := nil;
  if OddzialPanel.Visible then begin
    oSelectedId := nil;
    if RangeParam(sUNIODDZIAL_ID).Count > 1 then
       oSelectedId := RangeParam(sUNIODDZIAL_ID);
    result := UNISysDataManager.UNIPokazIObsluzDane(
      sUNIODDZIAL,
      '',
      False,
      True,
      sUNISYSALIAS_Oddzial_ID + ';' + sUNISYSALIAS_Oddzial_Symbol,
      0,
      sUNIODDZIAL_ID + '=' + iifs(RangeParam(sUNIODDZIAL_ID).Value = '', '0', RangeParam(sUNIODDZIAL_ID).Value),
      oSelectedId
    );
  end;
end;

procedure TZleOsobyGodzSelectForm.OddzialRangeLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  if OddzialPanel.Visible then
    with OddzialRangeLookupAliasEdit do begin
      AliasManager := UNISysDM.AliasManager;
      Alias_ID := sUNISYSALIAS_Oddzial_ID;
      Alias_Name := sUNISYSALIAS_Oddzial_Symbol;
    end;
end;
***********************)

procedure TZleOsobyGodzSelectForm.InitializeControls;
begin
  //OddzialPanel.Visible := (vWieloodzialowosc or (vWielofirmowosc and ZLEDM.vZLEWspolneZlecenia));
  UstawAliasy();
end;

procedure TZleOsobyGodzSelectForm.InitializeObjectFields;
begin
  bProcessData := False;
end;

procedure TZleOsobyGodzSelectForm.ProcessData;
begin
  inherited;
(*****************************************************************
  try
    try
      bDefault := True;
      {Jeli daty mieszcz si w okresie to s ustawiane}
      if RangeParam(sUNIOKRES_ID).IsSet then begin
          OkresLookupAliasEdit.InitiateData( StrToIntDef(RangeParam(sUNIOKRES_ID).Value,0) );
          s:= RangeParam(sUNIOKRES_ID).Value;

          if s = '' then Exit;
          //kontrola dat z okresem

          WczytajZakresyDatDlaOkresu(s,dOkresOd,dOkresDo);

          if RangeParam(sParam_ZLEDataOd).IsSet then begin
             DataOdDateEdit.Date:= StrToIntDef(RangeParam(sParam_ZLEDataOd).Value, 0);

             if (DataOdDateEdit.Date <> 0) and
                ((DataOdDateEdit.Date > dOkresDo) or
                 (DataOdDateEdit.Date < dOkresOd))
             then begin
               DataOdDateEdit.Clear();
               RangeParam(sParam_ZLEDataOd).Clear();
             end;
          end else DataOdDateEdit.Date := 0;

          if RangeParam(sParam_ZLEDataDo).IsSet then begin
             DataDoDateEdit.Date := StrToIntDef(RangeParam(sParam_ZLEDataDo).Value, 0);

             if (DataDoDateEdit.Date <> 0) and
                ((DataDoDateEdit.Date > dOkresDo) or
                 (DataDoDateEdit.Date < dOkresOd))
             then begin
               DataDoDateEdit.Clear();
               RangeParam(sParam_ZLEDataDo).Clear();
             end;

          end else DataDoDateEdit.Date := 0;
      end else begin
          OkresLookupAliasEdit.OnDelKey(self);
          if RangeParam(sParam_ZLEDataOd).IsSet then
             DataOdDateEdit.Date:= StrToIntDef(RangeParam(sParam_ZLEDataOd).Value, 0)
          else
             DataOdDateEdit.Date := 0;

          if RangeParam(sParam_ZLEDataDo).IsSet then
             DataDoDateEdit.Date:= StrToIntDef(RangeParam(sParam_ZLEDataDo).Value, 0)
          else
             DataDoDateEdit.Date := 0;
      end;

    finally
      bDefault := True;
      //bUstawOkres := False;
    end;
*****************************************************************)

  bProcessData := True;
  try
      if RangeParam(sUNIOKRES_ID).IsSet then
         OkresLookupAliasEdit.InitiateData( StrToIntDef(RangeParam(sUNIOKRES_ID).Value,0) )
      else
         OkresLookupAliasEdit.OnDelKey(self);

      if RangeParam(sParam_ZLEDataOd).IsSet then
         DataOdDateEdit.Date:= StrToIntDef(RangeParam(sParam_ZLEDataOd).Value, 0)
      else
         DataOdDateEdit.Date := 0;

      if RangeParam(sParam_ZLEDataDo).IsSet then
         DataDoDateEdit.Date:= StrToIntDef(RangeParam(sParam_ZLEDataDo).Value, 0)
      else
         DataDoDateEdit.Date := 0;
  finally
      bProcessData := False;
  end;
end;

procedure TZleOsobyGodzSelectForm.ProcessRangeParamsToParameters;
begin
  inherited;

  with Parameters do begin
    {Zmiana nazwy parametru, bo ZLEZLECENIE_ID jest uywane do podpowiadania zlecenia w detalu}
    Values[sParam_ZLEZlecenieID] := RangeParam(sParam_ZLEZlecenieID).CommaText;
    Values[sUNIOKRES_ID]         := RangeParam(sUNIOKRES_ID).Value;
    Values[sParam_ZLEOsobaID]    := RangeParam(sParam_ZLEOsobaID).CommaText;
    Values[sParam_ZLEZasobID]    := RangeParam(sParam_ZLEZasobID).CommaText;
    Values[sParam_ZLEDataOd]     := RangeParam(sParam_ZLEDataOd).Value;
    Values[sParam_ZLEDataDo]     := RangeParam(sParam_ZLEDataDo).Value;

    //if (vWielofirmowosc and ZLEDM.vZLEWspolneZlecenia) or (vWieloodzialowosc) then
    //   Values[sUNIODDZIAL_ID] := RangeParam(sUNIODDZIAL_ID).CommaText; {Lista ID}
  end;

  //GetParamZasForGrid();
end;

procedure TZleOsobyGodzSelectForm.PrepareParamsStep1;
begin
  with RangeParams do begin
    ZlecenieLookupAliasEdit.RangeParam := AddLarge(sParam_ZLEZlecenieID, '', cADMIDFunZLEZlecenie);
    OsobaLookupAliasEdit.RangeParam    := AddLarge(sParam_ZLEOsobaID, '', cADMIDFuncZLEOsoba2);
    ZasobLookupAliasEdit.RangeParam    := AddLarge(sParam_ZLEZasobID, '', cADMIDFuncZLEZasZle2);
    //if OddzialPanel.Visible then
    //   OddzialRangeLookupAliasEdit.RangeParam := RangeParam(sUNIODDZIAL_ID);
  end;

end;

procedure TZleOsobyGodzSelectForm.PrepareParamsStep2;
begin
  inherited;
end;

procedure TZleOsobyGodzSelectForm.PackData;
begin
  inherited;
end;

procedure TZleOsobyGodzSelectForm.UstawAliasy;
begin
  with OkresLookupAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_Name := sUNISYSALIAS_Okres_Obrachunkowy_Nazwa;
    Alias_ID := sUNISYSALIAS_Okres_Obrachunkowy_ID;
    AdditionalAliases := sUNISYSALIAS_Okres_Obrachunkowy_Rok_Opis;
  end;
end;


(**
procedure TZleOsobyGodzSelectForm.GetParamZasForGrid();//Pobranie parametrow dla Zasb
const cADMID = sADMID+'%d';
var
  sTables: String;
  sCondition: String;
  oIDs_List: TStringList;
  sCorrel2: String;
  iPFun: Integer;
  sRangeClassName: String;
  sSql: String;
  oQuery: TUNIQuery;
  iFun: Integer;
  sFieldName: String;
begin
  iFun := cADMIDFuncZLEZasZle2;
  sFieldName  := {sZLEALIAS_ZLECENIEZASOB+'.'+}sZLEZASOB_ID;

  iPFun := RangeComboBox.ItemIndex;
  sRangeClassName := ClassName + FSuffix;
  oIDs_List := ADMID_CreateAndLoad( iFun, iPFun, SecurityManager.UserId,
                                    sRangeClassName );
  RangeParam(sParam_ZLEZasobZLEID2).Clear();
  try
    if oIDs_List.Count > 0 then
    begin
      sCorrel2 := Format(cADMID, [iFun]);

        //dodanie warunku
      sCondition := '('+sCorrel2+'.'+sADMID_FUNK+'='+IntToStr(iFun)+')and'+
                  '('+sCorrel2+'.'+sADMID_PFUNK+'='+IntToStr(iPFun)+')and'+
                  '('+sCorrel2+'.'+sSMUSER_ID+'='+IntToStr(SecurityManager.UserId)+')and'+
                  '('+sCorrel2+'.'+sADMID_KONTEKST+'='+QuotedStr(sRangeClassName)+')';
        //dodajemy tabele
//        sTables := sTables+','+SQLManager.GetTableName(sADMID)+' '+sCorrel2+' ';
//          GridTabDefs.Add(sCorrel2, sADMID)

        //dodajemy warunki zlaczenia
//        GridJoinDefs.AddExpres(sFieldName+'='+sCorrel2+'.'+sADMID_V, qjkInner, true)
//        sConditions := sConditions + ' and '+sFieldName+'='+sCorrel2+'.'+sADMID_V+' and '+sCondition+' ';

//        DopiszDoWhere(sCondition, sConditions);

        sSql := 'Select ' + sZLEZLECENIE_ID + ' From ' +
                SQLManager.GetTableName(sZLEZLECENIEZASOB) + ',' + SQLManager.GetTableName(sADMID) + ' ' + sCorrel2 +
                ' Where ' + sFieldName + '=' + sCorrel2 + '.' + sADMID_V +
                ' and ' + sCondition;

        oQuery := SQLManager.CreateQuery( sSql );
        oQuery.Open;
        if oQuery.IsEmpty then
            oQuery := nil
        else while not oQuery.Eof do
        begin
            RangeParam(sParam_ZLEZasobZLEID2).Add( oQuery.FieldByName(sZLEZLECENIE_ID).AsString);
            oQuery.Next;
        end

    end;
  finally
    if oQuery <> nil then
        FreeAndNil(oQuery);
    oIDs_List.Free;

    ADMID_Save( cADMIDFuncZLEZasob2, iPFun, SecurityManager.UserId, sRangeClassName,
                nil, RangeParam(sParam_ZLEZasobZLEID2) );

  end;
end;
**)

procedure TZleOsobyGodzSelectForm.InternalOpen;
begin
  bUstawOkres := False;

  //inicjalizacja pl obiektu
  InitializeObjectFields();
  //inicjalizacja kontrolek
  InitializeControls();

  if Parameters = nil then begin
    Parameters := TKeyValues.CreateEmpty;
  end;
  inherited;
end;

procedure TZleOsobyGodzSelectForm.SelectButtonPressed;
begin
  if not Validate then begin
    ModalResult:= mrNone;
    exit;
  end;

  inherited;
end;

destructor TZleOsobyGodzSelectForm.Destroy;
begin
  inherited;
end;

procedure TZleOsobyGodzSelectForm.AssignProperties;
begin
  inherited;
end;

function TZleOsobyGodzSelectForm.Validate : boolean;
var s: string;
    dOkresOd: TDateTime;
    dOkresDo: TDateTime;
begin
  result := inherited Validate;
  if not result then Exit;

  if (DataOdDateEdit.Date > DataDoDateEdit.Date) and
     (DataDoDateEdit.Date <> 0) then
  begin
      //kontrola dat midzy sob
      Komunikat(cWarning, 'Bdny zakres dat dokumentw');
      DataOdDateEdit.SetFocus;
      Exit;
  end else begin
    if RangeParam(sUNIOKRES_ID).IsSet then begin
        s:= RangeParam(sUNIOKRES_ID).Value;
        //kontrola dat z okresem
        if s = '' then begin
           result := true;
           Exit;
        end;

        WczytajZakresyDatDlaOkresu(s,dOkresOd,dOkresDo);
        if (DataOdDateEdit.Date <> 0) and
           ((DataOdDateEdit.Date > dOkresDo) or (DataOdDateEdit.Date < dOkresOd)) then
        begin
          Komunikat(cWarning, 'Zakres dat dokumentw nie pasuje do wybranego okresu');
          DataOdDateEdit.SetFocus;
          Exit;
        end else if (DataDoDateEdit.Date <> 0) and
            ((DataDoDateEdit.Date > dOkresDo) or (DataDoDateEdit.Date < dOkresOd)) then
        begin
          Komunikat(cWarning, 'Zakres dat dokumentw nie pasuje do wybranego okresu');
          DataDoDateEdit.SetFocus;
          Exit;
        end;
    end;
  end;

  result := true;
end;

procedure TZleOsobyGodzSelectForm.BeforeShow;
begin
  inherited;
end;

procedure TZleOsobyGodzSelectForm.RestoreDefaults;
begin
  ClearRangeParams();
  PrepareParamsStep1();
  ProcessData();
end;

initialization
  FormManager.RegisterForm( TZleOsobyGodzSelectForm, 'Zakres ewidencji czasu pracy', sZLEModulID );
end.
