unit ZleOsobyGodzUnit;
{
 Copyright Unisoft Sp. z o.o.

Modu dostarczajcy aktualizacje bazy.

Changes
---------------------------------------------------------------------------------------------
When       Who    What
---------------------------------------------------------------------------------------------
2004-12-05 kk     Utworzone
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataModuleUnit, Db, UNIComponentsUnit, DBTables, DbClient, Math, KeyManagerUnit;

type
  TZleOsobyGodz = class(TUNIDataModule)
  private
    iZakresConditionIdx: Integer;
    procedure SetOnSetText;
    procedure UstawZakres();
//    procedure JoinOnField(const iFun: Integer; sFieldName: String; var sConditions: String);
  protected
    procedure GetKeys; override;
    function  GetTableName: string; override;
    procedure InitializeGridQueryDefs; override;
    procedure SetDisplayFormat; override;
  public
    constructor Create( AOwner: TComponent); override;
    procedure ReOpenDataSets(); override;
    procedure OpenDataSets(); override;
    procedure RefreshDataSets(); override;
    procedure OnSetText(Sender: TField; const Text: String);
    procedure Open; override;
    procedure Post; override;
  end;

implementation

uses
  Dodatki,
  FormManagerUnit,
  SecurityManagerUnit,
  QueryBuilderUnit,
  SQLManagerUnit,
  SystemDefUnit,
  UNIStaleUnit,
  UNISysDefUnit,
  ASODefUnit,
  ASODataManagerExtUnit,
  ZleOsobyGodzDBGridFormUnit,
  UNIDBGridFormUnit,
  UNIDBFormUnit,
  KDDefUnit,
  SPDefUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit;

{$R *.DFM}

procedure TZleOsobyGodz.Open;
begin
  inherited;
  SetOnSetText;
end;

(**********************
procedure TZleOsobyGodz.JoinOnField(const iFun: Integer; sFieldName: String; var sConditions: String);
const cADMID = sADMID+'%d';
var
  sTables: String;
  sCondition: String;
  oIDs_List: TStringList;
  sCorrel1: String;
  sCorrel2: String;
  iPFun: Integer;
  sRangeClassName: String;
begin
  iPFun := (Owner as TUNIDBGridForm).RangePodFunc;
  sRangeClassName := (Owner as TUNIDBGridForm).RangeClassName;
  oIDs_List := ADMID_CreateAndLoad( iFun, iPFun, SecurityManager.UserId,
                                    sRangeClassName );
  try
    sCorrel1 := Copy( sFieldName, 1, Pos( '.', sFieldName )-1 );
    sCorrel2 := Format(cADMID, [iFun]);

    if oIDs_List.Count > 0 then
    begin
      //dodanie warunku
      sCondition := '('+sCorrel2+'.'+sADMID_FUNK+'='+IntToStr(iFun)+')and'+
                  '('+sCorrel2+'.'+sADMID_PFUNK+'='+IntToStr(iPFun)+')and'+
                  '('+sCorrel2+'.'+sSMUSER_ID+'='+IntToStr(SecurityManager.UserId)+')and'+
                  '('+sCorrel2+'.'+sADMID_KONTEKST+'='+QuotedStr(sRangeClassName)+')';
        //dodajemy tabele
//      TD.Add( sCorrel2, sADMID );
//      sTables := sTables+','+SQLManager.GetTableName(sADMID)+' '+sCorrel2+' ';
      GridTabDefs.Add(sCorrel2, sADMID);

      DopiszDoWhere(sCondition, sConditions);
    end;

    //dodajemy warunki zlaczenia
//      GridJoinDefs.AddExpres(sFieldName+'='+sCorrel2+'.'+sADMID_V, qjkInner, oIDs_List.Count > 0)
//      sConditions := sConditions + ' and '+sFieldName+'='+sCorrel2+'.'+sADMID_V+' and '+sCondition+' ';
    if GridJoinDefs.IndexOfCorrel2( sCorrel2 ) = -1 then
      GridJoinDefs.AddSimple( sCorrel1, sCorrel2, sFieldName+'='+sCorrel2+'.'+sADMID_V, qjkInner, oIDs_List.Count > 0 )
    else
      GridJoinDefs.Items[ GridJoinDefs.IndexOfCorrel2( sCorrel2 ) ].Required := (oIDs_List.Count > 0);
  finally
    oIDs_List.Free;
  end;
end;
***********************)

procedure TZleOsobyGodz.SetOnSetText;
var
  F: TField;
begin
  inherited;
  F := ActiveQuery.FindField(sZLEOSOBYGODZ_CENA);
  if F <> Nil then F.OnSetText := OnSetText;
  F := ActiveQuery.FindField(sZLEOSOBYGODZ_ILOSC);
  if F <> Nil then F.OnSetText := OnSetText;
end;

procedure TZleOsobyGodz.OnSetText(Sender: TField; const Text: String);
begin
  if Sender.FieldName = sZLEOSOBYGODZ_CENA then
    Sender.AsFloat := Zaokraglij(StrToFloat(Text), UNIGetFracFromValueFormat(ASODM.vAsoFormatCeny))
  else if Sender.FieldName = sZLEOSOBYGODZ_ILOSC then
    if ZLEDM.vZLEFormatGodzinLiczba then
         Sender.AsFloat := Zaokraglij(StrToFloat(Text), UNIGetFracFromValueFormat(ASODM.vAsoFormatIlosci));
    {else Sender.AsFloat := Zaokraglij(StrToFloat(Text), UNIGetFracFromValueFormat(ASODM.vAsoFormatIlosci));}
end;

constructor TZleOsobyGodz.Create(AOwner: TComponent);
begin
  iZakresConditionIdx := -1;
  inherited;
end;

procedure TZleOsobyGodz.GetKeys;
begin
  with FKeys do begin
    AddPrimary(sZLEOSOBYGODZ_ID);
  end;
end;

function TZleOsobyGodz.GetTableName: string;
begin
  result := sZLEOSOBYGODZ;
end;

procedure TZleOsobyGodz.InitializeGridQueryDefs;
var
  sTmp: String;
begin
  if GridColDefs.Count = 0 then with GridColDefs do begin
    AddRequiredAndUnvisible(sZLEOSOBYGODZ_ID, 'G', '');
    AddRequiredAndUnvisible(sZLEZLECENIE_ID, 'G', '');
    AddRequiredAndUnvisible(sASOASORT_ID, 'G', '');
    //AddRequiredAndUnvisible(sSPCENNIK_ID, 'G', '');
    AddRequiredAndUnvisible(sUNIOKRES_ID, 'G', '');
    AddRequiredAndUnvisible(sKDOSOBA_ID, 'G', '');
    AddRequiredAndUnvisible(sZLEZASOB_ID, 'G', '');
    AddRequiredAndUnvisible(sZLEZLECENIEPOZ_ID, 'G', '');
    Add(sZLEZASOB_NAZWA, 'ZAS', 'Nazwa zasobu', False, True, taLeftJustify, 100);

    Add(sZLEOSOBYGODZ_ILOSC, 'G', 'Ilo godz.', True, True, taRightJustify, 100, uftFloat);
    Add(sZLEOSOBYGODZ_IL_PRACY, 'G', 'Ilo pracy', True, True, taRightJustify, 100, uftFloat);
    Add(sZLEOSOBYGODZ_CENA, 'G', 'Cena', True, True, taRightJustify, 200, uftFloat);
//    Add('(G.' + sZLEOSOBYGODZ_ILOSC + '/60)*' + 'G.' + sZLEOSOBYGODZ_CENA + ',2' + ';' + sZLEOSOBYGODZ_WARTOSC, '', 'Warto', True, True, taRightJustify, 200, uftFloat);
    if ZLEDM.vZLEFormatGodzinLiczba then
         sTmp := ')*'
    else sTmp := '/60)*';

    Add('(G.' + sZLEOSOBYGODZ_ILOSC + sTmp + 'G.' + sZLEOSOBYGODZ_CENA + ',2' + ';' + sZLEOSOBYGODZ_WARTOSC, '', 'Warto', True, True, taRightJustify, 200, uftFloat);
    Items[Count - 1].ColumnFunction:= SQLManager.GetSPName('ZAOKRAGLIJ');
    Add(sZLEOSOBYGODZ_DATA, 'G', 'Data', True, True, taLeftJustify, 100);

    Add(sZLEZLECENIE_SYMBOL, 'Z', 'Symbol zlec.', True, True, taLeftJustify, 100);
    Add(sASOASORT_INDEKS, 'A', 'Indeks asort.', True, True, taLeftJustify, 100);
    Add(sASOASORT_SYMBOL, 'A', 'Symbol asort.', True, True, taLeftJustify, 100);
    Add(sASOASORT_NAZWA, 'A', 'Nazwa asort.', True, True, taLeftJustify, 100);
    //Add(sSPCENNIK_SYMBOL, 'C', 'Symbol cennika', True, True, taLeftJustify, 200);
    //Add(sSPCENNIK_NAZWA, 'C', 'Nazwa cennika', True, True, taLeftJustify, 200);
    Add(sKDOSOBA_SYMBOL, 'O', 'Symbol osoby', True, True, taLeftJustify, 100);
    Add(sKDOSOBA_NAZWA, 'O', 'Imi i nazwisko', True, True, taLeftJustify, 200);
    Add(sZLEZLECENIEPOZ_LP, 'P', 'Pozycja zlecenia', False, True, taLeftJustify, 100);
    Add(sZLEZLECENIEPOZ_OPIS, 'P', 'Opis pozycji zlecenia', False, True, taLeftJustify, 120);
  end;
  if GridTabDefs.Count = 0 then with GridTabDefs do begin
    Add('G', GetTableName() );
    Add('Z', sZLEZLECENIE);
    Add('A', sASOASORT);
    //Add('C', sSPCENNIK);
    Add('O', sKDOSOBA);
    Add('ZAS', sZLEZASOB);
    Add('P', sZLEZLECENIEPOZ);
  end;
  if GridJoinDefs.Count = 0 then with GridJoinDefs do begin
    AddSimple( 'G', 'Z', 'G.' + sZLEZLECENIE_ID +'=Z.' + sZLEZLECENIE_ID, qjkInner, True);
    AddSimple( 'G', 'A', 'G.' + sASOASORT_ID +'=A.' + sASOASORT_ID, qjkLeftOuter, True);
    //AddSimple( 'G', 'C', 'G.' + sSPCENNIK_ID +'=C.' + sSPCENNIK_ID, qjkLeftOuter, True);
    AddSimple( 'G', 'O', 'G.' + sKDOSOBA_ID +'=O.' + sKDOSOBA_ID, qjkLeftOuter, True);
    AddSimple( 'G', 'ZAS', 'G.' + sZLEZASOB_ID +'=ZAS.' + sZLEZASOB_ID, qjkLeftOuter, True);
    AddSimple( 'G', 'P', 'G.' + sZLEZLECENIEPOZ_ID +'=P.' + sZLEZLECENIEPOZ_ID, qjkLeftOuter, True);

    iZakresConditionIdx := AddCondition( '1=1', false );
  end;
  inherited;
end;

procedure TZleOsobyGodz.Post;
var
  bTrans: Boolean;
begin
  bTrans := SQLManager.InTransaction;
  if not bTrans then SQLManager.StartTransaction;
  try
    inherited;
    if not bTrans then SQLManager.Commit;
  except
    if not bTrans then SQLManager.Rollback;
    Raise;
  end;
end;

procedure TZleOsobyGodz.UstawZakres;
var oParams: TKeyValues;
    sDopisz, sWhere: String;

begin
  oParams := nil;
  sWhere := '';

  if (Owner is TUNIDBGridForm) then begin
    try
      oParams := TKeyValues.CreateEmpty();
      (Owner as TUNIDBForm).GetParametersForForm( (Owner as TUNIDBForm), oParams );
      if oParams = nil then exit;
      with oParams do begin
        //zlezlecenie_id
        if (Values[sParam_ZLEZlecenieID] <> '') then
           DopiszDoWhere('G.' + sZLEZLECENIE_ID + ' IN ('+ Values[sParam_ZLEZlecenieID] + ')', sWhere);

        //kdosoba_id
        if (Values[sParam_ZLEOsobaID] <> '') then
           DopiszDoWhere('G.' + sKDOSOBA_ID + ' IN ('+ Values[sParam_ZLEOsobaID] + ')', sWhere);

        //ZLEZASOB_ID
        if (Values[sParam_ZLEZasobID] <> '') then
           DopiszDoWhere('G.' + sZLEZASOB_ID + ' IN ('+ Values[sParam_ZLEZasobID] + ')', sWhere);


        if Values[sUNIOKRES_ID] <> '' then begin
           if (Values[sUNIOKRES_ID] <> '0') and (Values[sUNIOKRES_ID] <> '-1') then
              DopiszDoWhere('G.' + sUNIOKRES_ID + ' IN ('+ Values[sUNIOKRES_ID] + ')', sWhere);
        end;
        //data
        sDopisz := '';
        if (Values[sParam_ZLEDataOd] <> '')and(Values[sParam_ZLEDataOd] <> '0')and
           (Values[sParam_ZLEDataDo] <> '')and(Values[sParam_ZLEDataDo] <> '0') then begin
          sDopisz := 'G.'+sZLEOSOBYGODZ_DATA+' between '+
                     KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataOd]))+' and '+
                     KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataDo]));
        end else if (Values[sParam_ZLEDataOd] <> '')and(Values[sParam_ZLEDataOd] <> '0') then begin
          sDopisz := 'G.'+sZLEOSOBYGODZ_DATA+'>='+KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataOd]));
        end else if (Values[sParam_ZLEDataOtwDo] <> '')and(Values[sParam_ZLEDataOtwDo] <> '0') then begin
          sDopisz := 'G.'+sZLEOSOBYGODZ_DATA+'<='+KonwertujDate2SQL(StrToInt(Values[sParam_ZLEDataDo]));
        end;
        if sDopisz <> '' then DopiszDoWhere(sDopisz, sWhere );

        {if (vWielofirmowosc and ZLEDM.vZLEWspolneZlecenia) or (vWieloodzialowosc) then
           if Values[sUNIODDZIAL_ID] <> '' then
              DopiszDoWhere( 'G.'+sUNIODDZIAL_ID+' in (' + Values[sUNIODDZIAL_ID] + ')', sWhere );}

        //osoba
        //JoinOnField( cADMIDFuncZLEOsoba2, 'G.'+sKDOSOBA_ID, sWhere );

        //zasb
        //JoinOnField( cADMIDFuncZLEZasob2, 'G.'+sZLEZLECENIE_ID, sWhere );
      end;

      if sWhere <> '' then
        GridJoinDefs.ExchangeCondition( iZakresConditionIdx, sWhere, true )
      else
        GridJoinDefs.Items[iZakresConditionIdx].Required := false;
    finally
      if oParams <> nil then oParams.Free;
    end;
  end;
end;

procedure TZleOsobyGodz.OpenDataSets;
begin
  UstawZakres();
  inherited;
end;

procedure TZleOsobyGodz.ReOpenDataSets;
begin
  inherited;
  SetOnSetText;
end;

procedure TZleOsobyGodz.RefreshDataSets;
begin
  {nie wywoujemy inherited dla klasy TZLEszczegoloweKosztyDBGridForm}
  if (Owner.Owner is TZleOsobyGodzDBGridForm) or
     (Owner is TZleOsobyGodzDBGridForm) then
     inherited;
end;

procedure TZleOsobyGodz.SetDisplayFormat;
begin
  inherited;
  if ListQuery.FindField(sZLEOSOBYGODZ_ILOSC) <> nil then
    (ListQuery.FieldByName(sZLEOSOBYGODZ_ILOSC) as TNumericField).DisplayFormat := UNIGetMaskFromFormat(ASODM.vAsoFormatIlosci);
  if ListQuery.FindField(sZLEOSOBYGODZ_IL_PRACY) <> nil then
    (ListQuery.FieldByName(sZLEOSOBYGODZ_IL_PRACY) as TNumericField).DisplayFormat := UNIGetMaskFromFormat(12.2 {ASODM.vAsoFormatIlosci});
  if ListQuery.FindField(sZLEOSOBYGODZ_CENA) <> nil then
    (ListQuery.FieldByName(sZLEOSOBYGODZ_CENA) as TNumericField).DisplayFormat := UNIGetMaskFromFormat(ASODM.vAsoFormatCeny);
  if ListQuery.FindField(sZLEOSOBYGODZ_WARTOSC) <> nil then
    (ListQuery.FieldByName(sZLEOSOBYGODZ_WARTOSC) as TNumericField).DisplayFormat := cMaskaKwoty;
 { if ListQuery.FindField(sASOASORT_INDEKS) <> nil then
    ListQuery.FieldByName(sASOASORT_INDEKS).EditMask := ASODM.vAsoMaskaIndeksu+';0;_';}
end;

initialization
  FormManager.RegisterForm( TZLEOsobyGodz, 'Rejestracja czasu pracy', sZLEModulID );

end.
