unit ZleZasobyPracaDBGridFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Modu dostarczajcy aktualizacje bazy.
Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2007-11-13 Tomjen   Utworzone
2008-09-04 Adam     Dodane tworzenie wpisw na podstawie dokumentw magazynowych
2008-09-29 Adam     Dodany tryb wywietlania rekordw utworzonych w aktualnej sesji
2008-10-20 Adam     Dodana kontrola utworzenia rekordw wyceny zlecenia
---------------------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBGridFormUnit, Db, DBTables, UNIComponentsUnit, URDataSet,
  UniDesigner, Menus, Grids, DBGrids, StdCtrls, ComCtrls, DBCtrls, ToolWin,
  ExtCtrls, UNIStaleUnit, UNIDataModuleUnit, UNIFormUnit, Mask, UNIDateEditUnit; //KeyManagerUnit;


type
  TZleZasobyPracaDBGridForm = class(TUNIDBGridForm)
    FunkcjeToolButton: TToolButton;
    FunkcjePopupMenu: TUNIPopupMenu;
    AkceptacjaMenuItem: TMenuItem;
    UtworzZMagazynuMenuItem: TMenuItem;
    ToolButton1: TToolButton;
    TrybCheckBox: TUNICheckBox;
    btnZakresButton: TUNIButton;
    RaportkomunikacjizECPMenuItem: TMenuItem;
    AktualizujStawkiMenuItem: TMenuItem;
    DataBlokadyPanel: TUNIPanel;
    DataBlokadyLabel: TUNILabel;
    DataBlokadyRCPDateEdit: TUNIDateEdit;
    procedure AkceptacjaMenuItemClick(Sender: TObject);
    procedure UtworzZMagazynuMenuItemClick(Sender: TObject);
    procedure TrybCheckBoxClick(Sender: TObject);
    procedure btnZakresButtonClick(Sender: TObject);
    procedure RaportkomunikacjizECPMenuItemClick(Sender: TObject);
    procedure AktualizujStawkiMenuItemClick(Sender: TObject);
    procedure DBGridDrawColumnCell(Sender: TObject; const Rect: TRect;
            DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure DataBlokadyRCPDateEditDateChange(Sender: TObject);
  private
    bLastLesult: TModalResult;
    m_iLastId:  integer;
    bPowtorz: Boolean;
    procedure OpenDetail(AOpenMode: TOpenMode);
  protected
    procedure New(); override;
    procedure Open(); override;
    procedure View(); override;
    procedure Delete(); override;
    function  CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure SetUserRights; override;
    procedure InternalOpen(); override;

  public
    destructor  Destroy();  override;
    function GetHelpContextSuffix: String; override;
  end;

implementation
uses
  Dodatki,
  FormManagerUnit,
  SecurityManagerUnit,
  UNISYSDataManagerUnit,
  SQLManagerUnit,
  UNIDBDetailFormUnit,
  KeyManagerUnit,
  ZLEdefUnit,
  LWPDefUnit,
  ASODefUnit,
  SystemDefUnit,
  ZleZasobyPracaUnit,
  ZLEDataManagerUnit,
  ZleZasobyPracaDBDetailFormUnit,
  UNISysDefUnit;

{$R *.DFM}


procedure TZleZasobyPracaDBGridForm.DataBlokadyRCPDateEditDateChange(
  Sender: TObject);
begin
  inherited;
  if DataBlokadyRCPDateEdit.Enabled then begin
    if Trunc(DataBlokadyRCPDateEdit.Date) <> ZLEDM.vZLEDataBlokadyECP then begin
       ZLEDM.vZLEDataBlokadyECP := Trunc(DataBlokadyRCPDateEdit.Date);
       UNISYSDM.SetSystemIniInteger( vAktywnaFirma, sZLEModulID, '', sINIZLEDataBlokadyECP, ZLEDM.vZLEDataBlokadyECP );
    end;
  end;
end;

procedure TZleZasobyPracaDBGridForm.DBGridDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
  s: string;
begin
  inherited;
  if Column.Field <> Nil then begin
    //s:= Column.Field.AsString;
    if (Column.FieldName = sZLEZASOBYPRACA_STAWKA) then begin
      s := FormatFloat('### ##0.00', DMAQFbN(sZLEZASOBYPRACA_STAWKA).AsFloat);
      DBGrid.WriteText(DBGrid.Canvas, Rect, s, Column.Alignment);
    end else DBGrid.WriteText(DBGrid.Canvas, Rect, Column.Field.DisplayText, Column.Alignment);
  end;
end;

function TZleZasobyPracaDBGridForm.GetHelpContextSuffix: String;
{ przyrostki do obs-ugi:
 [brak przyrostka]                        LWP                  4.1
 RCP                                      zlecenia             4                    Rejestracja czasu pracy osb i zasobw
}
begin
  result := '';
end;

function TZleZasobyPracaDBGridForm.CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule;
begin
  bPowtorz := False;
    // usunicie ewentualnych zapisw w ADMID
  ZLEDM.UsunPraceZasobowZADMID();
  result := TZleZasobyPracaDataModule.CreateOpen(Self, DefaultMasterKeyValues, AOpenMode);
end;

procedure TZleZasobyPracaDBGridForm.Delete;
begin
  if(not DataModule.ActiveQuery.IsEmpty()) then begin
    if((DMAQFbN(sZLEZASOBYPRACA_STATUS).AsString = cZLEConstZasobPracaStatus_WprowadzonyID) or
    (not ZLEDM.UtworzonyRekordWyceny(DMAQFbN(sZLEZLECENIE_ID).AsInteger, DMAQFbN(sZLEZASOB_ID).AsInteger, DMAQFbN(sLWPRECEPPOZ_ID).AsInteger))) then
      OpenDetail(omDelete)
    else begin
        // s ju utworzone rekordy wyceny zlecenia wic nie mona usun tego rekordu
      Komunikat(cWarning, 'Dla tego zlecenia, zasobu i pozycji receptury utworzony jest ju rekord wyceny zlecenia.' + Chr(13) + 'Usunicie niemoliwe', MB_OK + MB_ICONEXCLAMATION);
    end;
  end;  // if(not DataModule.ActiveQuery.IsEmpty())
end;

procedure TZleZasobyPracaDBGridForm.InternalOpen;
begin
  if Parameters.Values[cFORM_CAPTION] <> '' then begin
    Caption := Parameters.Values[cFORM_CAPTION];
  end;
  inherited;
  {CopyMenuItem.Visible := True;
  CopyMenuItem.Enabled := True;}

  ZLEDM.vZLEDataBlokadyECP := UNISYSDM.GetSystemIniInteger(vAktywnaFirma, sZLEModulID, '', sINIZLEDataBlokadyECP, 0);
  DataBlokadyRCPDateEdit.Date := ZLEDM.vZLEDataBlokadyECP;
end;

destructor  TZleZasobyPracaDBGridForm.Destroy();
begin
  ZLEDM.UsunPraceZasobowZADMID();
  inherited;
end;

procedure TZleZasobyPracaDBGridForm.New;
begin
  bPowtorz := False;
  OpenDetail(omNew);
  while bLastLesult = mrOK do begin
    bPowtorz := True;
    ZLEDM.DopiszPraceZasobowDoADMID(IntToStr(m_iLastId));
    OpenDetail(omNew);
  end;
end;

procedure TZleZasobyPracaDBGridForm.Open;
begin
  OpenDetail(omEdit);
end;

procedure TZleZasobyPracaDBGridForm.OpenDetail(AOpenMode: TOpenMode);
var
  oParams: TKeyValues;
  f: TUNIDBDetailForm;
begin
  if(AOpenMode = omNew) then
    m_iLastId := 0
  else
    m_iLastId := DMAQFbN(sZLEZASOBYPRACA_ID).AsInteger;
  bLastLesult := mrCancel;
  if Parameters.Values[sZLECONST_RODZAJECP_ID] = '' then
     Parameters.Values[sZLECONST_RODZAJECP_ID] := cZLERodzajECP_ProdukcjaID;

  inherited;

  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add(cFORM_CAPTION+'='+'Szczegy rejestracji czasu pracy');
    Add(sZLECONST_RODZAJECP_ID+'='+Parameters.Values[sZLECONST_RODZAJECP_ID]);
  end;


  if (AOpenMode = omNew) then begin
     {Uzupenienie parametrw wartociami domylnymi}
     if (not DataModule.ActiveQuery.IsEmpty) {and (DataModule.ActiveQuery.FindField(sZLEZASOB_ID) <> nil)} then begin
        {Zakomentowaem warunek .. Czy jest gdzies potrzebny?
        if(DMAQFbN(sZLEZASOB_ID).AsString <> '') and (Parameters.Values[sZLEZASOB_ID] = '') then begin}
        //Nie podpowiadamy jeli jest to powtorzenie dopisywania i wypenione sa parametry
        if (not bPowtorz) or (not (Parameters.Values[sZLEZASOBYPRACA_DATA] <> '')) then begin
            if DataModule.ActiveQuery.FindField(sZLEZASOBYPRACA_DATA) <> nil then
               if DMAQFbN(sZLEZASOBYPRACA_DATA).AsDateTime > 0 then
                  Parameters.Values[sZLEZASOBYPRACA_DATA]       := DateToStr(DMAQFbN(sZLEZASOBYPRACA_DATA).AsDateTime);
               {else Parameters.Values[sZLEZASOBYPRACA_DATA]       := DateToStr(UNIDate());}
            if DataModule.ActiveQuery.FindField(sZLEZASOB_ID) <> nil then
               Parameters.Values[sZLEZASOB_ID]               := DMAQFbN(sZLEZASOB_ID).AsString;
            //Parameters.Values[sZLEZASOB_NAZWA]            := ZasobDBLookupAliasEdit.Text;
            if DataModule.ActiveQuery.FindField(sKDZMIANYDEF_ID) <> nil then
               Parameters.Values[sKDZMIANYDEF_ID]            := DMAQFbN(sKDZMIANYDEF_ID).AsString;

            if DataModule.ActiveQuery.FindField(sKDOSOBA_ID) <> nil then
               Parameters.Values[sKDOSOBA_ID] := DMAQFbN(sKDOSOBA_ID).AsString;
            if DataModule.ActiveQuery.FindField(sUNIJEDNOSTKAORG_ID) <> nil then
               Parameters.Values[sUNIJEDNOSTKAORG_ID] := DMAQFbN(sUNIJEDNOSTKAORG_ID).AsString;
            if DataModule.ActiveQuery.FindField(sZLEZASOBYPRACA_ZUZ_PALIWA) <> nil then
               Parameters.Values[sZLEZASOBYPRACA_ZUZ_PALIWA] := DMAQFbN(sZLEZASOBYPRACA_ZUZ_PALIWA).AsString;
            if DataModule.ActiveQuery.FindField(sZLEZASOBYPRACA_STAWKA) <> nil then
               Parameters.Values[sZLEZASOBYPRACA_STAWKA] := DMAQFbN(sZLEZASOBYPRACA_STAWKA).AsString;
            if DataModule.ActiveQuery.FindField(sZLEZLECENIEPOZ_ID) <> nil then
               Parameters.Values[sZLEZLECENIEPOZ_ID] := DMAQFbN(sZLEZLECENIEPOZ_ID).AsString;
            if DataModule.ActiveQuery.FindField(sASOASORT_ID) <> nil then
               Parameters.Values[sASOASORT_ID] := DMAQFbN(sASOASORT_ID).AsString;
            if DataModule.ActiveQuery.FindField(sUNIOKRES_ID) <> nil then
               Parameters.Values['PARAM_' + sUNIOKRES_ID] := DMAQFbN(sUNIOKRES_ID).AsString;
            if DataModule.ActiveQuery.FindField(sLWPRECEPPOZ_ID) <> nil then
               Parameters.Values[sLWPRECEPPOZ_ID]            := DMAQFbN(sLWPRECEPPOZ_ID).AsString;
            if DataModule.ActiveQuery.FindField(sLWPPLANPRODEL_ID) <> nil then
               Parameters.Values[sLWPPLANPRODEL_ID]          := DMAQFbN(sLWPPLANPRODEL_ID).AsString;
            if DataModule.ActiveQuery.FindField(sZLEZLECENIE_ID) <> nil then
               Parameters.Values[sZLEZLECENIE_ID]            := DMAQFbN(sZLEZLECENIE_ID).AsString;
            if DataModule.ActiveQuery.FindField(sZLEZLECENIE_SYMBOL) <> nil then
               Parameters.Values[sZLEZLECENIE_SYMBOL]        := DMAQFbN(sZLEZLECENIE_SYMBOL).AsString;
            //Parameters.Values[sZLEZLECENIE_NAZWA]         := ZlecenieNazwaLabel.Caption;
            if DataModule.ActiveQuery.FindField(sZLEZASOBYPRACA_CZAS_PRACY) <> nil then
               Parameters.Values[sZLEZASOBYPRACA_CZAS_PRACY] := IntToStr(DMAQFbN(sZLEZASOBYPRACA_CZAS_PRACY).AsInteger);
            if DataModule.ActiveQuery.FindField(sZLEZASOBYPRACA_IL_PRACY) <> nil then
               Parameters.Values[sZLEZASOBYPRACA_IL_PRACY]   := UNIFloatToFormatStr(12.2 {ASODM.vAsoFormatIlosci}, DMAQFbN(sZLEZASOBYPRACA_IL_PRACY).AsFloat);
            if DataModule.ActiveQuery.FindField(sZLECONST_RODZAJECP_ID) <> nil then
               Parameters.Values[sZLECONST_RODZAJECP_ID]     := DMAQFbN(sZLECONST_RODZAJECP_ID).AsString;
            if DataModule.ActiveQuery.FindField(sZLEZASOBYPRACA_EL_NAD_ID) <> nil then
               Parameters.Values[sZLEZASOBYPRACA_EL_NAD_ID]     := DMAQFbN(sZLEZASOBYPRACA_EL_NAD_ID).AsString;
        end;
        {end;}
     end // else Parameters.Values[sZLECONST_RODZAJECP_ID] := DMAQFbN(sZLECONST_RODZAJECP_ID).AsString;

  {end else if (AOpenMode = omCopy) and  (not DataModule.ActiveQuery.IsEmpty) then begin
            if DataModule.ActiveQuery.FindField(sZLECONST_RODZAJECP_ID) <> nil then
               Parameters.Values[sZLECONST_RODZAJECP_ID]     := DMAQFbN(sZLECONST_RODZAJECP_ID).AsString;}
     else
     if FormIsContained and (Owner is TZleZasobyPracaDBDetailForm) then begin
        //Przekazujemy dane z rekordu nadrzdnego
        if TZleZasobyPracaDBDetailForm(Owner).DataModule.ActiveQuery.FindField(sZLEZASOBYPRACA_DATA) <> nil then
           if DMAQFbN(sZLEZASOBYPRACA_DATA).AsDateTime > 0 then
              Parameters.Values[sZLEZASOBYPRACA_DATA]       := DateToStr(TZleZasobyPracaDBDetailForm(Owner).DataModule.ActiveQuery.FieldByName(sZLEZASOBYPRACA_DATA).AsDateTime);
        if TZleZasobyPracaDBDetailForm(Owner).DataModule.ActiveQuery.FindField(sZLEZLECENIE_ID) <> nil then
           Parameters.Values[sZLEZLECENIE_ID] := TZleZasobyPracaDBDetailForm(Owner).DataModule.ActiveQuery.FieldByName(sZLEZLECENIE_ID).AsString;
     end;
  end;

  AOpenMode := AOpenMode or omShowModal or omHidden;
  if FormIsContained then
    AOpenMode := AOpenMode or omOverVirtual;

  f := FormManager.OpenDBDetail(Self, 'TZleZasobyPracaDBDetailForm', AOpenMode, oParams);
  bLastLesult := f.ShowModal;
  if f <> nil then begin
    m_iLastId := f.DataModule.ActiveQuery.FieldByName(sZLEZASOBYPRACA_ID).AsInteger;
    FreeAndNil(f);
  end;
end;

procedure TZleZasobyPracaDBGridForm.View;
begin
  OpenDetail(omView);
end;

procedure TZleZasobyPracaDBGridForm.SetUserRights;
begin
  with SecurityManager do begin
    Switch_View_HotKey(SM_UserCanDo(sZLE_REJ_CZASU_PRACY_POKAZ));
    Switch_New_HotKey(SM_UserCanDo(sZLE_REJ_CZASU_PRACY_DOPISZ));
    Switch_Open_HotKey(SM_UserCanDo(sZLE_REJ_CZASU_PRACY_ZMIEN));
    Switch_Delete_HotKey(SM_UserCanDo(sZLE_REJ_CZASU_PRACY_USUN));
    AkceptacjaMenuItem.Enabled  := SM_UserCanDo(sZLE_REJ_CZASU_PRACY_AKCEPTACJA);
    UtworzZMagazynuMenuItem.Enabled := SM_UserCanDo(sZLE_REJ_CZASU_PRACY_UTWORZ_Z_MAG) and (Parameters.Values[sZLECONST_RODZAJECP_ID] = cZLERodzajECP_ProdukcjaID);
    DataBlokadyRCPDateEdit.Enabled := SM_UserCanDo(sZLE_REJ_CZASU_PRACY_DATA_BLOKADY);
    DataBlokadyPanel.Visible := SM_UserCanDo(sZLE_REJ_CZASU_PRACY_DATA_BLOKADY);
  end;
end;

procedure TZleZasobyPracaDBGridForm.AkceptacjaMenuItemClick(
  Sender: TObject);
begin
  if(not DataModule.ActiveQuery.IsEmpty()) then begin
    if(Length(DBGrid.MarkedRows) > 0) then
      ZLEDM.AkceptujPraceZasobow(DBGrid.MarkedRows)
    else
      ZLEDM.AkceptujPraceZasobow([DMAQFbN(sZLEZASOBYPRACA_ID).AsInteger]);
    DataModule.RefreshDataSets();
  end;  // if not empty
end;

procedure TZleZasobyPracaDBGridForm.UtworzZMagazynuMenuItemClick(
  Sender: TObject);
begin
  if(ZLEDM.UtworzPraceNaPodstawieMagazynu()) then begin
    TrybCheckBox.Checked  := true;
    DataModule.RefreshDataSets();
  end;  // if(ZLEDM.UtworzPraceNaPodstawieMagazynu())
end;

procedure TZleZasobyPracaDBGridForm.TrybCheckBoxClick(Sender: TObject);
begin
  DataModule.ReOpenDataSets();
end;

procedure TZleZasobyPracaDBGridForm.btnZakresButtonClick(Sender: TObject);
begin
  inherited;
  if OpenRangeForm() then
    DataModule.ReOpenDataSets();
  DBGrid.SetFocus;
end;

procedure TZleZasobyPracaDBGridForm.RaportkomunikacjizECPMenuItemClick(
  Sender: TObject);
var oParams: TKeyValues;
begin
  if DataModule.ActiveQuery.IsEmpty then Exit;
  inherited;
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add(sZLEZASOBYPRACA_ID+'='+IntToStr(DMAQFbN(sZLEZASOBYPRACA_ID).AsInteger));
  end;
  FormManager.OpenDBGrid( Self, 'TZLEZasobyPracaRapDBGridForm', omList{+omReadOnly}, oParams );
end;

procedure TZleZasobyPracaDBGridForm.AktualizujStawkiMenuItemClick(Sender: TObject);
var
  oParams : TKeyValues;
  oForm:    TUNIForm;
  sSQL, sListaZlecID, sWhere: String;
  iOkresID, iJednostkaOrgID, idx: Integer;
  dDataOd, dDataDo: TDate;
  aListaID: array of Integer;
  q: TUNIQuery;
begin
  oParams := TKeyValues.CreateEmpty;
  if not DataModule.ActiveQuery.IsEmpty then begin
     try
       DataModule.ActiveQuery.DisableControls;

       if (Length(DBGrid.MarkedRows) > 0) then begin
         //Wybrana lista do przeliczenia. Nie wyswietlamy okienka z dodatkowymi parametrami
         ZLEDM.ZLEPrzeliczStawki(DBGrid.MarkedRows);
       end else begin
         //Brak listy .. otwieramy okienko i przeliczamy dla wybranego zakresu ZLEZASOBYPRACA_ID
         oForm := FormManager.OpenForm(self,
                                       'TZLEZasobyPrzeliczSelectForm',
                                       omEdit + omHidden,
                                       oParams);
         try
            if (oForm.ShowModal = mrOk) then begin
               iOkresID := 0;
               dDataOd  := 0;
               dDataDo  := 0;
               sListaZlecID := '';
               sWhere := '';
               iJednostkaOrgID := 0;
               SetLength(aListaID, 0);

               if oParams <> nil then begin
                  if (oParams.Values[sZLEZLECENIE_ID] <> '') then
                    sListaZlecID := oParams.Values[sZLEZLECENIE_ID];
                  if (oParams.Values[sUNIOKRES_ID] <> '') and (oParams.Values[sUNIOKRES_ID] <> '-1') then
                     iOkresID := StrToInt(oParams.Values[sUNIOKRES_ID]);
                  if (oParams.Values['DATA_OD'] <> '') and (oParams.Values['DATA_OD'] <> '0') then
                     dDataOd := StrToInt(oParams.Values['DATA_OD']);
                  if (oParams.Values['DATA_DO'] <> '') and (oParams.Values['DATA_DO'] <> '0') then
                     dDataDo := StrToInt(oParams.Values['DATA_DO']);
                  if (oParams.Values[sUNIJEDNOSTKAORG_ID] <> '') and (oParams.Values[sUNIJEDNOSTKAORG_ID] <> '-1') then
                     iJednostkaOrgID := StrToInt(oParams.Values[sUNIJEDNOSTKAORG_ID]);
               end;

               if (iOkresID > 0) or
                  (dDataOd > 0) or
                  (dDataDo > 0) or
                  (sListaZlecID <> '') or
                  (iJednostkaOrgID > 0) then
               begin
                  sSQL := 'SELECT ' +  sZLEZASOBYPRACA_ID + ' ' +
                          'FROM %s ZOG, %s ZL ' +
                          'WHERE ZOG.' + sZLEZLECENIE_ID + '=ZL.' + sZLEZLECENIE_ID + ' AND ' +
                                'ZOG.' + sKDOSOBA_ID + ' IS NOT NULL '; //Dla innych nie mam sensu pobierac stawki

                  if iOkresID > 0 then
                     sWhere := sWhere + ' AND (ZOG.' + sUNIOKRES_ID + ' = ' + IntToStr(iOkresID) + ')';

                  if dDataOd > 0 then
                     sWhere := sWhere + ' AND (ZOG.' + sZLEZASOBYPRACA_DATA + ' >= ' + KonwertujDate2SQL(dDataOd{, 'dd-mm-yyyy'}) + ')';

                  if dDataDo > 0 then
                     sWhere := sWhere + ' AND (ZOG.' + sZLEZASOBYPRACA_DATA + ' <= ' + KonwertujDate2SQL(dDataDo{, 'dd-mm-yyyy'}) + ')';

                  if sListaZlecID <> '' then
                     sWhere := sWhere + ' AND (ZOG.' + sZLEZLECENIE_ID + ' IN (' + sListaZlecID + '))';

                  if iJednostkaOrgID > 0 then
                     sWhere := sWhere + ' AND (ZL.' + sUNIJEDNOSTKAORG_ID + '=' + IntToStr(iJednostkaOrgID) + ')';

                  if sWhere <> '' then
                     sSQL := sSQL + sWhere;

                  sSQL := sSQL + ' AND ZOG.' + sZLECONST_RODZAJECP_ID + ' IN (' + QuotedStr(cZLERodzajECP_OsobaID) + ', ' +
                                                                                 QuotedStr(cZLERodzajECP_ZasobID) + ')';

                  q := SQLManager.CreateQuery(sSQL, [sZLEZASOBYPRACA, sZLEZLECENIE]);
                  try
                    q.Open();
                    if not q.IsEmpty then begin
                      SetLength(aListaID, q.RecordCount);
                      idx := 0;
                       while not q.Eof do begin
                         aListaID[idx] := q.FieldByName(sZLEZASOBYPRACA_ID).AsInteger;
                         Inc(idx);
                         q.Next;
                       end;

                       ZLEDM.ZLEPrzeliczStawki(aListaID);
                    end else begin
                       Komunikat(cError, 'W wybranym zakresie nie ma adnych'#13+
                                         ' ewidencji do przeliczenia stawek!');
                       Exit;
                    end;
                  finally
                    if q <> nil then FreeAndNil(q);
                  end;
               end else begin
                  //Przeliczyc wszystkie ewidencje? Czy tylko dla zaznaczonego na gridzie?
                  Komunikat(cError, 'Nie wybrano nic na zakresie');
                  Exit;
               end;
            end;
         finally
            oForm.Free;
         end;

       end;
     finally
       DataModule.ActiveQuery.EnableControls;
       DataModule.ReOpenDataSets();
     end;
  end;
end;

initialization
  FormManager.RegisterForm( TZleZasobyPracaDBGridForm, 'Rejestracja czasu pracy osob/zasobow/produkcja', sZLEModulID );
end.
