CREATE OR REPLACE TRIGGER zlezlecenie_ins_after
AFTER INSERT
ON zlezlecenie
FOR EACH ROW
DECLARE
  iZlezlecenie_Id   ZLEZLECENIE.ZLEZLECENIE_ID%TYPE;
  vLicznik          BINARY_INTEGER;

  P_ORDER_ID_UNISOFT NUMBER;  -- id z ERP
  P_TYP_ZLECENIA NUMBER;  -- id typu zlecenia wg GIS
  P_START VARCHAR2(200); -- data otwarcia zlecenia - tekst w formacie 'yyyy-mm-dd hh24:mi:ss'
  P_KOM_ZGL VARCHAR2(200); -- komrka zgaszajca z ERP w formacie tekstowym
  P_SYMBOL VARCHAR2(200);   -- nr ERP w formacie tekstowym
  P_NAZWA VARCHAR2(200);  -- tekst opisujcy zlecenie
  P_OPIS VARCHAR2(500); -- opis zlecenia
  P_STATUS NUMBER; -- id statusu wg GIS
  P_KOM_WYKON VARCHAR2(200); -- skrt nazwy komrki wykonujcej wg GIS

  --Parametry wyjciowe
  V_NEWID_ORDER NUMBER := 0;  -- id zlecenia wg GIS, -1 zlecenie nie powstao
  V_ERROR VARCHAR2(500) := NULL;  -- opis bdw

  iZlecenieID INTEGER;
  iIDObcyID INTEGER;
  vZLEWysylanie VARCHAR2(1);
  vPartnerID INTEGER;
  iJednostkaOrgID INTEGER;
  sJednostkaOrg VARCHAR2(50);

  sSQL VARCHAR2(1024);
  PRAGMA AUTONOMOUS_TRANSACTION;

BEGIN
  vZLEWysylanie := 'N';
  vPartnerID := -1;
  sJednostkaOrg := null;
  IF UNIZSI_PACKAGE.ifUNIINT = TRUE THEN
    IF (:NEW.Zletypzlec_ID >= 0) THEN
      BEGIN
        SELECT ZLETYPZLEC_WYSYLANIE_UNIINT
        INTO  vZLEWysylanie
        FROM  zletypzlec
        WHERE zletypzlec_id = :NEW.Zletypzlec_ID;
        EXCEPTION
         WHEN No_Data_Found THEN
           vZLEWysylanie := 'N';
         WHEN OTHERS THEN
           RAISE;
      END;

      SELECT UNISYSTEMPARAM_VALUE
      INTO  vPartnerID
      FROM  unisystemparam
      WHERE unisystemparam_system='UNIINT'
        AND UNISYSTEMPARAM_ITEM='UNIINT_PARTNER';

      IF (vPartnerID = 2) AND (vZLEWysylanie = 'T') THEN
        P_ORDER_ID_UNISOFT := :NEW.Zlezlecenie_id;

        CASE WHEN :NEW.zletypzlec_id = 41 THEN P_TYP_ZLECENIA := 1010511;
             WHEN :NEW.zletypzlec_id = 42 THEN P_TYP_ZLECENIA := 1010512;
             WHEN :NEW.zletypzlec_id = 43 THEN P_TYP_ZLECENIA := 1010513;
             WHEN :NEW.zletypzlec_id = 44 THEN P_TYP_ZLECENIA := 1010514;
             WHEN :NEW.zletypzlec_id = 45 THEN P_TYP_ZLECENIA := 1010515;
             WHEN :NEW.zletypzlec_id = 46 THEN P_TYP_ZLECENIA := 1010516;
             WHEN :NEW.zletypzlec_id = 47 THEN P_TYP_ZLECENIA := 1010517;
             WHEN :NEW.zletypzlec_id = 48 THEN P_TYP_ZLECENIA := 1010518;
             WHEN :NEW.zletypzlec_id = 49 THEN P_TYP_ZLECENIA := 1010519;
             WHEN :NEW.zletypzlec_id = 50 THEN P_TYP_ZLECENIA := 1010521;
             WHEN :NEW.zletypzlec_id = 21 THEN P_TYP_ZLECENIA := 1010522;
             WHEN :NEW.zletypzlec_id = 51 THEN P_TYP_ZLECENIA := 1010524;
             WHEN :NEW.zletypzlec_id = 52 THEN P_TYP_ZLECENIA := 1010525;
             WHEN :NEW.zletypzlec_id = 53 THEN P_TYP_ZLECENIA := 1010526;
             WHEN :NEW.zletypzlec_id = 54 THEN P_TYP_ZLECENIA := 1010527;
             WHEN :NEW.zletypzlec_id = 55 THEN P_TYP_ZLECENIA := 1010528;
             WHEN :NEW.zletypzlec_id = 56 THEN P_TYP_ZLECENIA := 1010529;
             WHEN :NEW.zletypzlec_id = 57 THEN P_TYP_ZLECENIA := 1010530;
        ELSE raise_application_error(-20001, 'Nieobsugiwany typ zlecenia podczas wysyania do systemu partnera');
        END CASE;


        P_START := To_Char(:NEW.zlezlecenie_data_otw, 'yyyy-mm-dd hh24:mi:ss');
        P_KOM_ZGL := 'PEk';
        P_KOM_WYKON := 'PEk'; --'EKS' || '/' || 'PE' || '/' || 'PEk';  -- skrt nazwy komrki wykonujcej wg GIS

        sJednostkaOrg := NULL;
        IF :NEW.unijednostkaorg_id IS NOT NULL THEN
           SELECT UNIJEDNOSTKAORG_SYMBOL
           INTO sJednostkaOrg
           FROM unijednostkaorg
           WHERE unijednostkaorg_id = :NEW.unijednostkaorg_id;
           P_KOM_ZGL := sJednostkaOrg;
           P_KOM_WYKON := sJednostkaOrg;
        END IF;
        P_SYMBOL  := :NEW.zlezlecenie_symbol;  -- nr ERP w formacie tekstowym
        P_NAZWA   := :NEW.zlezlecenie_nazwa;
        P_OPIS    := :NEW.zlezlecenie_opis;

        CASE WHEN :NEW.zlezlecenie_status = 'O' THEN P_STATUS := 1;
             WHEN :NEW.zlezlecenie_status = 'Z' THEN P_STATUS := 5;
             WHEN :NEW.zlezlecenie_status = 'R' THEN P_STATUS := 3;
             WHEN :NEW.zlezlecenie_status = 'A' THEN P_STATUS := 6;
             WHEN :NEW.zlezlecenie_status = 'W' THEN P_STATUS := 6;
        ELSE P_STATUS := 1;
        END CASE;


        BEGIN
          /*6506 to id miasta (tu Supsk)*/
          sSQL := 'BEGIN mb_app.unisoft_insert_order@link_ejb(' ||
                              To_Char(P_ORDER_ID_UNISOFT) || ', ' ||
                              To_Char(P_TYP_ZLECENIA) || ', ''' ||
                              P_START || ''', ''' ||
                              P_KOM_ZGL || ''', ''' ||
                              P_SYMBOL || ''', ''' ||
                              P_NAZWA || ''', ''' ||
                              P_OPIS || ''', ' ||
                              To_Char(P_STATUS) || ', ''' ||
                              P_KOM_WYKON || ''',6506); END; ';

          --Dbms_Output.put_line(sSQL);
          EXECute IMMEDIATE sSQL;
          EXCEPTION
           WHEN OTHERS THEN
             raise_application_error(-20001, 'Bd wysania zlecenia do systemu partnera');
        END;
      END IF;
    END IF;
  END IF;

END;
/

