unit ZLEDataManagerUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-16 gdeyk    Utworzone
2004-08-12 Krz      Wyrzucenie GetAliases (zostaa odwirtualniona w TUNIDataMAnager)
2004-08-31 ZzB      Funkcja ZLEPokazIObsluzDane przebudowana, aby potrafia obsuzy
                    pola podane wprost a nie tylko atrybutami. Rozwizanie jest malo eleganckie
                    ale nie chciaem za mocno ingerowac w obcy kod
                    Nadpisana funkcja UNIPokazIObsluzSlownik
2004-09-17 ZzB      Poprawki do j.w.
2006-11-22 KNowak   Dodanie do funkcji UniPokazDok parametrw multiselekcji
2007-06-28 Adam     Dodana funkcja ZLEPokazIObsluzDetail
2007-07-25 Adam     Dodane pole ZLEZLECENIEPOZ_ILOSC
2007-08-23 Adam     Dodana tabela sZLEZLECREZERW
2007-08-28 Adam     Dodana funkcje ZLEDopiszZlecenieZPozycjiZapotrzebowan
2007-09-26 Adam     Dodane pola ZLEZASOB_OBCIAZENIE_MAX i LWPJEDNCZAS_ID do tabeli
                    ZLEZASOB oraz pole LWPRECEPPOZZASOB_ID do tabeli ZLEZLECENIEZASOB
2007-11-13 Adam     Dodane pole sKDGRUPAKAL_ID do tabeli ZLEZASOB
2008-02-12 Adam     Dodana pozycja menu 'Stopie realizacji zlece"
2008-02-27 Adam     Dodany parametr vZLEWycenaPracyZasobowWlaczona
2008-02-28 Adam     Dodana funkcja AktualizujWyceneZlecen
2008-03-10 Adam     Zwikszona precyzja pola sZLEZLECENIEWYC_KOSZT
2008-03-14 Adam     Dodana funkcja ZLEDopiszZlecenieZPozycjiZapytan
2008-06-17 Adam     Dodana tabela ZLEZLECENIEOBCY
2008-06-18 Adam     Dodane funkcje wysyajce zlecenia do partnerw oraz przygotowujce dane zlece
2008-07-25 Adam     Dodane wysyanie zasobw na ktrych ma by realizowana dana pozycja receptury
                    dodana funkcja DajQueryZasobowReceppozZlecDoWyslania oraz jej wykorzystanie
2008-08-26 Adam     Dodane pola LWPRECEPPOZOPER_ID i LWPRECEPPOZOPERZAM_ID do tabeli ZLEZLECENIEMAT
2008-08-28 Adam     Dodane pole status do wyceny
2008-09-04 Adam     Dodana funkcja UtworzPraceNaPodstawieMagazynu
2008-09-05 Adam     Dodana kontrola czy zlecenia zostay ju wczeniej wysane do systemu partnera
                    (ZapiszIdZlecDoWyslaniaWADMId)
2008-09-18 Adam     Dodany parametr ac_iTypZlecId do funkcji ZLEDopiszZlecenieZPozycjiZapotrzebowan,
                    ZLEDopiszZlecenieZPozycjiZamowien i ZLEDopiszZlecenieZPozycjiZapytan
2008-09-29 Adam     Dodane funkcje pomocnicze zapisujce id pracy zasobw w ADMID
                    Wykorzystywane przez UtworzPraceNaPodstawieMagazynu
2008-10-20 Adam     Dodana funkcja UtworzonyRekordWyceny
2008-12-17 Adam     Kopiowanie osoby odpowiedzialnej z Zapyta, Zamwie i Zapotrzebowa
2009-04-07 Adam     Dodana kontrola czy wysyane zlecenie ma jeden ze statusw ustawionych w parametrach UNIINT
2009-06-26 Adam     Dodane pole LWPPLANPRODEL_ID do tabeli ZLEZLECENIEOBCY
2009-07-27 Tomjen   Funkcje dla analiz
2009-10-06 Adam     Dodane pole ZLEZLECENIEOBCY_BLAD oraz funkcje sprawdzajce czy zlecenie, receptura
                    i element planu zostay wysane do partnera
2009-10-09 Adam     Dodane funkcjonalnoci do wycofywania zlece z systemu partnerskiego
2010-03-08 Adam     Zmiana typu pola ZLEZLECENIE_OBCY_ID na varchar2(21)
2010-05-18 Adam     Daty w przesyanych zleceniach do partnera w formacie rrrr-mm-dd
2010-05-21 Adam     Moliwo wysyania do partnera wybranych elementw planu produkcji
2010-09-06 Adam     Dodane funkcjonalnoci do brakw
2011-03-04 Adam     Dodana funkcja ZLEDopiszZlecenieNieProdZPozycjiZapotrzebowan
2011-01-07 Adam     Dodana funkcja tworzenia zlecenia nieprodukcyjnego z zapytania ofertowego
2011-08-25 Adam     Parametr ukrywania przycisku tworzenia zapotrzebowania
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDataManagerUnit, Menus, UNIComponentsUnit, SQLManagerUnit, db,
  UNIDBConstComboBoxUnit, KeyManagerUnit, ZLEDefUnit, DBTables, UNIDataModuleUnit,
  {$ifdef build_zle}
  ZLEParserUnit,
  MSXML2_TLB,
  UNIXMLParserUnit,
  {$endif}
  UNIDBGridFormUnit, UNIDBDetailFormUnit, UniStaleUnit, SecurityManagerUnit,
  ExtCtrls, LFKDefUnit
  ;

type
  TZLEDataManager = class(TUNIDataManager)
    UstawieniaMenuItem: TMenuItem;
    ParametryMenuItem: TMenuItem;
    DefinicjeMenuItem: TMenuItem;
    SlownikiMenuItem: TMenuItem;
    KartotekaZlecenMenuItem: TMenuItem;
    ParametryPracyMenuItem: TMenuItem;
    SkladnikiKontroliWartosciowejMenuItem: TMenuItem;
    SkladnikiKontroliIlosciowejMenuItem: TMenuItem;
    TypZlecenMenuItem: TMenuItem;
    NumeratorySymboliZlecenMenuItem: TMenuItem;
    Testy1: TMenuItem;
    Createtables1: TMenuItem;
    Createconstraints1: TMenuItem;
    ZleceniaExt1: TMenuItem;
    Kontrolazlecenia1: TMenuItem;
    KontrolaZLEDodajZlecenie1: TMenuItem;
    DajListeSkladTypu1: TMenuItem;
    DajListeWartSklad1: TMenuItem;
    ZapiszWartSklad1: TMenuItem;
    Wypenijdomeny1: TMenuItem;
    Createdomains1: TMenuItem;
    RejestracjaPracyMenuItem: TMenuItem;
    ZasobyMenuItem: TMenuItem;
    AnalizaZlecenMenuItem: TMenuItem;
    AnalizaRozliczenieZasobowMenuItem: TMenuItem;
    PolaUzMenuItem: TMenuItem;
    PLLIKoszty: TMenuItem;
    PrzeliczanieTimer: TTimer;
    PracaZasobowMenuItem: TMenuItem;
    RejestracjaCzasuPracyMenuItem: TMenuItem;
    ZLEBrakiMenuItem: TMenuItem;
    GrupyKalendarzoweMenuItem: TMenuItem;
    SystemyZmianoweMenuItem: TMenuItem;
    KalendarzMenuItem: TMenuItem;
    NumeratoryZasobowMenuItem: TMenuItem;
    KryteriaMenuItem: TMenuItem;
    ZLEGIS_ZLECViewDef: TUNIViewDef;
    LWPRealizacjaZlecenMenuItem: TMenuItem;
    ZLEPackageBodySPDef: TUNISPDef;
    ZLEPackageSPDef: TUNISPDef;
    PrefiksMenuItem: TMenuItem;
    ZLEXMLPackageSPDef: TUNISPDef;
    ZLEXMLPackageBodySPDef: TUNISPDef;
    NarzutyMenuItem: TMenuItem;
    TestListZlecen1: TMenuItem;
    ZLEOSOBYGODZViewDef: TUNIViewDef;
    ZLEZLECENIEROZLViewDef: TUNIViewDef;
    RaportyMenuItem: TMenuItem;
    ZLEPolazmViewDef: TUNIViewDef;
    ZLEPolazmdefViewDef: TUNIViewDef;
    ZLEPolazmwskViewDef: TUNIViewDef;
    PolaUZGrupaMenuItem: TMenuItem;
    PolazleceniaMenuItem: TMenuItem;
    PolapozycjiMenuItem: TMenuItem;
    ZleceniapolauytkownikaMenuItem: TMenuItem;
    RaportraportowdopoprawyMenuItem: TMenuItem;
    miWzorceImportuKalCzas: TMenuItem;
    WzorceImportuMenuItem: TMenuItem;
    //KryteriaMenuItem: TMenuItem;
    procedure SkladnikiKontroliWartosciowejMenuItemClick(Sender: TObject);
    procedure SkladnikiKontroliIlosciowejMenuItemClick(Sender: TObject);
    procedure TypZlecenMenuItemClick(Sender: TObject);
    procedure Createtables1Click(Sender: TObject);
    procedure Createconstraints1Click(Sender: TObject);
    procedure NumeratorySymboliZlecenMenuItemClick(Sender: TObject);
    procedure KartotekaZlecenMenuItemClick(Sender: TObject);
    procedure ParametryMenuItemClick(Sender: TObject);
    procedure ParametryPracyMenuItemClick(Sender: TObject);
    procedure ZleceniaExt1Click(Sender: TObject);
    procedure Kontrolazlecenia1Click(Sender: TObject);
    procedure KontrolaZLEDodajZlecenie1Click(Sender: TObject);
    procedure DajListeSkladTypu1Click(Sender: TObject);
    procedure DajListeWartSklad1Click(Sender: TObject);
    procedure ZapiszWartSklad1Click(Sender: TObject);
    procedure Wypenijdomeny1Click(Sender: TObject);
    procedure Createdomains1Click(Sender: TObject);
    procedure ZasobyMenuItemClick(Sender: TObject);
    procedure AnalizaRozliczenieZasobowMenuItemClick(Sender: TObject);
    procedure PolaUzMenuItemClick(Sender: TObject);
    procedure PLLIKosztyClick(Sender: TObject);
    procedure PrzeliczanieTimerTimer(Sender: TObject);
    procedure PracaZasobowMenuItemClick(Sender: TObject);
    procedure RejestracjaCzasuPracyMenuItemClick(Sender: TObject);
    procedure ZLEBrakiMenuItemClick(Sender: TObject);
    procedure GrupyKalendarzoweMenuItemClick(Sender: TObject);
    procedure SystemyZmianoweMenuItemClick(Sender: TObject);
    procedure KalendarzMenuItemClick(Sender: TObject);
    procedure NumeratoryZasobowMenuItemClick(Sender: TObject);
    procedure KryteriaMenuItemClick(Sender: TObject);
    procedure LWPRealizacjaZlecenMenuItemClick(Sender: TObject);
    procedure PrefiksMenuItemClick(Sender: TObject);
    procedure NarzutyMenuItemClick(Sender: TObject);
    procedure TestListZlecen1Click(Sender: TObject);
    procedure PolazleceniaMenuItemClick(Sender: TObject);
    procedure PolapozycjiMenuItemClick(Sender: TObject);
    procedure RaportraportowdopoprawyMenuItemClick(Sender: TObject);
    procedure miWzorceImportuKalCzasClick(Sender: TObject);
    procedure WzorceImportuMenuItemClick(Sender: TObject);
    //procedure ZLEPolaUzZleceniaMenuItemClick(Sender: TObject);
    //procedure ZLEPolaUzPozycjaMenuItemClick(Sender: TObject);
    //procedure KryteriaMenuItemClick(Sender: TObject);
  private
    {$ifdef build_zle}
    Parser: TZLEParser;
    vZLEAsoZMag: Boolean;
    sWarPoz: String;
    {$endif}
  {$ifndef build_all}
    m_oZasobyPracaNoweId: TStringList;  // przechowuje list idkw rekordw pracy zasobw utworzonych w bierzcej sesji (od wejcia na grida pracy zasobw)
  {$endif}

    procedure pola_techniczne( sTabela: string; FieldDefs: TUNIFieldDefs);

    //metody kontroli realizacji
   {$ifdef build_zle}
    function AktualizujRealizacjeZleceniaKoszty( iZlecenieID, iTypZleceniaID, iOkresID: Integer;
                                                 bKosztyOkresowe: Boolean;
                                                 bZwrocDataSet: Boolean = false ): TVirtualDataSet;
    function AktualizujRealizacjeZleceniaIlosci( iZlecenieID, iTypZleceniaID, iOkresID,
                                                 iAsortID: Integer;
                                                 bIlosciOkresowe: Boolean;
                                                 bZwrocDataSet: Boolean = false ): TVirtualDataSet;
    function PrzeliczZlecenieKoszty( iZlecenieID, iTypZleceniaID, iOkresID: Integer;
                                     bKosztyOkresowe: Boolean ): TVirtualDataSet;
    function PrzeliczZlecenieIlosci( iZlecenieID, iTypZleceniaID, iOkresID,
                                     iAsortID: Integer;
                                     bIlosciOkresowe: Boolean ): TVirtualDataSet;
    function WyliczWartoscZRegulyKoszty( sRegula: String; iOkresID, iZlecenieID: Integer;
                                         sSymbolZlecenia: String; bSymulacja: Boolean; var sBladID: String): Extended;
    function WyliczWartoscZRegulyIlosci( sRegula: String; iOkresID, iZlecenieID: Integer;
                                         sSymbolZlecenia, sIndeksAsortymentu: String;
                                         iAsortId: Integer; var sBladID: String ): Extended;
    function WyliczWartoscZReguly(sRegula: String; iOkresID: Integer; var sBladID: String ): Extended;


    function ZLEFunAnalizy_Internal(
                      sScript: string;
                      iFirmaID: integer;
                      sRok: string;
                      bSymulacja:boolean;
                      var iLiczbaSlownikow: integer;
                      iAktywnyOkresNr: integer = 0;
                      bTylkoNiezerowe: boolean = false;
                      bZestawienieZDokumentami: boolean = false): TUNIQuery;
    {$endif}
  protected
    procedure Init; override;
   {$ifdef build_zle}
    function GetValueFromFunction(FuncName: String; var Arguments: array of Variant): Variant; override;
    {$endif}
    procedure SetUserRights; override;
    //procedure GetAliases; override;
  public
    //metody dostpne tylko dla moduu ZLE
    {$ifdef build_zle}
    FPrzeliczoneKoszty: TZLEPrzeliczoneLista;
    FPrzeliczoneIlosci: TZLEPrzeliczoneLista;
    {$endif}

    destructor  Destroy();  override;

    function WczytajOkresy(): TConstStringList;
    {$ifdef build_zle}
    procedure ZLEPrzeliczStawki(aListaID: array of Integer);
    function AktualizujRealizacjeZleceniaExt( iZlecenieID, iTypZleceniaID,
                                              iOkresID, iAsortID, iFirmaID: Integer;
                                              bKoszty, bOkresowa: Boolean ): TVirtualDataSet;
    {$endif}

    procedure GetFunctionality( FC: TFunkCollection); override;
    function DajNazwyDomen : String; override;
    function DajDefinicjeDomeny( sDomain:string):TConstStringList; override;
    function DajNazwyTablic : string; override;
    procedure DajDefinicjeTablicy(TableName: string; FieldDefs: TUNIFieldDefs; IndexDefs: TIndexDefs); override;
    procedure DajDefinicjeConstraints(TableName: string; ConstraintDefs: TUNIConstraintDefs); override;

    {$ifdef build_zle}
    function DopiszPozycjeZlecenia( iZlecenieID, iTypZleceniaID,
                                    iOkresID: Integer; bIlosciOkresowe: Boolean): Integer;
    {$endif}
    //metody dostpne dla innych moduw
    //udostpnianie danych
    function ZLEOdpytajODaneSQL( sTabela, sAtrybuty, sWarunek: string;
                                 bUnikalne: boolean; sOrderBy: String = '') : string;

    function ZLEOdpytajODane( sTabela, sAtrybuty, sWarunek: string;
                              bUnikalne: boolean; sOrderBy: String = '') : TUNIQuery;
    function ZLEZlecenieOtwarte( sSymbol: String; dData: TDate ): Boolean;
    function ZLEPokazIObsluzDane( sTabela, sAtrybuty, sWarunek: string;
                                  bBlok, bWyborWielu: Boolean;
                                  iModulZSIID: Integer = 0;
                                  iLocateID: Integer = 0;
                                  iFirmaID: Integer = 0;
                                  sPola: String = '';
                                  oSelected: TStrings = nil;
                                  oLocateContained: TStrings = nil;
                                  oParams: TKeyValues = nil): TUNIQuery;
    function ZLEPokazIObsluzDaneGrid(const oOwner:TComponent; sTabela, sAtrybuty, sWarunek: string;
                                      bBlok, bWyborWielu: Boolean;
                                      iOpenMode: TOpenMode;
                                      iModulZSIID: Integer = 0;
                                      iLocateID: Integer = 0;
                                      iFirmaID: Integer = 0;
                                      oLocateContained: TStrings = nil;
                                      oParams: TKeyValues = nil;
                                      sSufiksKlasy: String = ''): TUNIDBGridForm;
    function ZLEPokazIObsluzTypZlecenia( sAtrybuty, sWarunek: string;
                                         bBlok, bWyborWielu: Boolean;
                                         iModulZSIID: Integer = 0;
                                         iLocateID: Integer = 0;
                                         iFirmaID: Integer = 0): TUNIQuery;
    function ZLEPokazIObsluzTypZleceniaGrid(const oOwner:TComponent; sAtrybuty, sWarunek: string;
                                             bBlok, bWyborWielu: Boolean;
                                             iOpenMode: TOpenMode;
                                             iModulZSIID: Integer = 0;
                                             iLocateID: Integer = 0;
                                             iFirmaID: Integer = 0): TUNIDBGridForm;
    function ZLEPokazIObsluzZlecenia( sAtrybuty, sWarunek: string;
                                      bBlok, bWyborWielu: Boolean;
                                      iModulZSIID: Integer;
                                      iLocateID: Integer = 0;
                                      iFirmaID: Integer = 0;
                                      oSelected: TStrings = nil;
                                      oLocateContained: TStrings = nil;
                                      oParams: TKeyValues = nil): TUNIQuery;
    function ZLEPokazIObsluzZleceniaGrid( const oOwner:TComponent; sAtrybuty, sWarunek: string;
                                          bBlok, bWyborWielu: Boolean;
                                          iOpenMode: TOpenMode;
                                          iModulZSIID: Integer;
                                          iLocateID: Integer = 0;
                                          iFirmaID: Integer = 0;
                                          oLocateContained: TStrings = nil;
                                          oParams: TKeyValues = nil;
                                          sSufiksKlasy: String = '' ): TUNIDBGridForm;
    function ZLEKontrolaZlecenia( iZlecenieID: Integer;
                                  sAtrybuty: string;
                                  bBlok: Boolean;
                                  iModulZSIID: Integer;
                                  iFirmaID: Integer = 0 ): TUNIQuery;
    function ZLEKontrolaZleceniaGrid(const oOwner:TComponent; iZlecenieID: Integer;
                                      sAtrybuty: string;
                                      bBlok: Boolean;
                                      iOpenMode: TOpenMode;
                                      iModulZSIID: Integer;
                                      iFirmaID: Integer = 0 ): TUNIDBDetailForm;
    function ZLEDopiszZlecenie( const cTypOperacji: TSposobNadaniaGrupy;
                                var iGrupaID: Integer;
                                iTypZleceniaID: Integer;
                                iModulZSIID: Integer;
                                iFirmaID: Integer = 0 ): Integer;
    function ZLEDopiszZlecenieGrupujace( iTypZleceniaID, iModulZSIID: Integer;
                                         sSymbol, sNazwa, sOpis: String;
                                         dDataOtwarcia: TDate;
                                         iFirmaID: Integer = 0 ): Integer;
    function UNIDopiszZlecenie( iTypZleceniaID, iModulZSIID: Integer;
                            sSymbol, sNazwa, sOpis: String;
                            dDataOtwarcia: TDate;
                            dDataZamkniecia: TDate;
                            sStatus: String = cZLEStatusZlecenia_OczekujaceID;
                            iOsobaOdp: Integer = 0;
                            iOsobaStatus: Integer = 0;
                            iUniRok_ID: Integer = 0;
                            iUniJednostkaOrg_ID: Integer = 0;
                            iWykonawca_ID: Integer = 0; //Kontrahent
                            sPotwierdzenie: String = '';
                            iFirmaID: Integer = 0;
                            iInfSiecElementID: Integer = 0;
                            iZleZlecenieGrupaID: Integer = 0 ): Integer;

    {Funkcja zwraca True, jeli istnieje aktywne zlecenie
     dla podanego slementu infrastruktury i typu zlecenia.
     Wtedy mona dopisywa zlecenia anulowane albo zakoczone}
    function ZLEKontrolaUnikalnosciElemInf( iTypZleceniaID: Integer;
                                            iInfElementID: Integer;
                                            sPoziomInf: String;
                                            iZlecenieID: Integer): Boolean;

    //funkcje dla analiz
    function ZLEFunAnalizy_ZLEDanePozycji(iFirmaID: integer;
                                          sRok, sOpisParametrow: string;
                                          var iLiczbaSlownikow:integer;
                                          bSymulacja:boolean=false;
                                          iAktywnyOkresNr:integer=0;
                                          bTylkoNiezerowe:boolean=false;
                                          bZestawienieZDokumentami:boolean=false): TUNIQuery;

    {Funkcja zwraca wszelkie symbole mnemonikw dla wskazanego zlecenia}
    function ZLEMnemonikiDlaZlecenia(iZlecenieID: Integer;
                                     var   av_aMnem:     TaMnemValue): Integer;

    function ZLEUstawStatusySpraw(iZlecenieID: Integer;
                                  sZLEStatusPrzed: String;
                                  sZleListaSprawPrzed: String): Integer;

    {Funkcja zwraca wszelkie symbole mnemonikw dla wskazanej pozycji zlecenia}
    function ZLEMnemonikiDlaPozycjiZlecenia(iZlecenieID, iZleceniePozID: Integer;
                                            var av_aMnem: TaMnemValue): Integer;

    procedure ZLEListaMnemonikow(slMnemZle: TStringList;
                                 iFirmaID: Integer = 0);

    function ZLEDajIdTypElemGrup( iTypZleceniaID: Integer;
                               iFirmaID: Integer = 0 ): Integer;
    function ZLEDajIdElemGrup( iZlecenieID: Integer;
                            iFirmaID: Integer = 0 ): Integer;
    function ZLEDajListeSkladTypu( iGrupaID, iTypZleceniaID: Integer;
                                iFirmaID: Integer = 0 ): TUNIQuery;
    function ZLEDajListeWartSklad( iGrupaID, iZlecenieID: Integer;
                                iFirmaID: Integer = 0 ): TUNIQuery;
    function ZLEZapiszWartSklad(  iGrupaID, iZlecenieID, iZleceniePozID: Integer;
                              Skladniki: TZLEListaSkladnikow;
                              iFirmaID: Integer = 0 ): Boolean;
    procedure ZLEPokazIObsluzDetail(
                      const ac_sTabela:     string;
                      const ac_iId:         integer;
                      const ac_iOpenMode:   TOpenMode;
                      const ac_iModulID:    integer = cZLEMODULZSI_ID;
                            a_oParams:      TKeyValues  = nil
              );
    function  ZLEDopiszZlecenieZPozycjiZapotrzebowan(
                      const ac_sZapotrzPozId: string;
                      const ac_iTypZlecId:    integer // domylny typ zlecenia
              ):  TIntegerArray;
    function  ZLEDopiszZlecenieZPozycjiZamowien(
                      const ac_sZamowieniePozId:string;
                      const ac_iTypZlecId:      integer // domylny typ zlecenia
              ):  TIntegerArray;
      {
        Funkcja dopisuje wizualnie JEDNO zlecenie nieprodukcyjne z pozycjami utworzonymi
        z przekazanych pozycji zamwie
      }
    function  ZLEDopiszZlecenieNieProdZPozycjiZamowien(
                      const ac_iAdmIdFunkId:    integer;// funkcja z ADMID gdzie s zapisane idki pozycji zamwie z ktrych ma by utworzone zlecenie
                      const ac_iTypZlecId:      integer // domylny typ zlecenia
              ):  integer;
      {
        Funkcja dopisuje wizualnie JEDNO zlecenie nieprodukcyjne z pozycjami utworzonymi
        z przekazanych pozycji zapotrzebowa
      }
    function  ZLEDopiszZlecenieNieProdZPozycjiZapotrzebowan(
                      const ac_iAdmIdFunkId:    integer;// funkcja z ADMID gdzie s zapisane idki pozycji zapotrzebowa z ktrych ma by utworzone zlecenie
                      const ac_iTypZlecId:      integer // domylny typ zlecenia
              ):  integer;
    function  ZLEDopiszZlecenieZPozycjiZapytan(
                      const ac_sZapytaniePozId: string;
                      const ac_iTypZlecId:      integer // domylny typ zlecenia
              ):  TIntegerArray;
      {
        Funkcja dopisuje wizualnie JEDNO zlecenie nieprodukcyjne z pozycjami utworzonymi
        z przekazanych pozycji zapyta wejciowych
      }
    function  ZLEDopiszZlecenieNieProdZPozycjiZapytan(
                      const ac_iAdmIdFunkId:    integer;// funkcja z ADMID gdzie s zapisane idki pozycji zapyta wejciowych z ktrych ma by utworzone zlecenie
                      const ac_iTypZlecId:      integer // domylny typ zlecenia
              ):  integer;

    function DajListeAktualizacji : TStringList; override;
    function UruchomAktualizacje( nr: string) : boolean; override;

    function ZLEDajWartoscKryterium(iFirmaID: integer;
                sKryteriaSymbol: string;
                iFKMnemonikiID: integer;
                sZakres, sKrytPozWartoscTyp,
                sKryteriaRodzaj: string; iOkresID:integer;
                bAnalizy:boolean = false): TUNIQuery;

    {$ifdef build_zle}
    {Kryteria}
    function ZLEZapiszPrzeliczoneKryterium(iID, iOkresID: integer; DataPocz, DataKonc: string):byte;
    function ZLEPrzeliczKryteria(Kryteria, Okresy : array of integer):byte;
    //function ZleDajListePozycjiDlaKryterium(iKryteriumID, iUNIOKRES_ID: Integer): String;
    function ZleDajListeSymboliDlaKryterium(iKryteriumID, iUNIOKRES_ID: Integer;
                                            var SELSQL: String; oPar: TKeyValues;
                                            var bJestWhere, bINI_IBU: Boolean): TUNIQuery;

    function ZleDajKrytWartoscPracy(iKryteria_ID, iUNIOKRES_ID: Integer; bNarzut: Boolean): Extended;
    function ZleDajKrytWartoscMat(iKryteria_ID, iUNIOKRES_ID: Integer; bNarzut: Boolean): Extended;
    function ZleDajKrytIloscPracy(iKryteria_ID, iUNIOKRES_ID: Integer; bNarzut: Boolean): Extended;
    {function ZleDajKrytWspPracy(iKryteria_ID, iUNIOKRES_ID: Integer): Extended;
    function ZleDajKrytWspMat(iKryteria_ID, iUNIOKRES_ID: Integer): Extended;}

    function ListaMnemonikow(var sListaSkl: String): TUNIQuery;
    procedure PrzeliczZlecenia();
    function UNIPokazIObsluzSlownik(sAtrybuty, sTabela, sPole, sWarunek: string;iMnemonikID:integer=0; iPozycjonowanie: Integer = 0;
                                    bWyborWielu:boolean = false;a_oSelectedId : TStringList = nil; oParams: TKeyValues = nil): TUNIQuery; override;

    (*obsuga obiektw*)
    function UNIDajOpisObiektu: String; override;
    procedure UNIObiektInicjujOkulary( iObiektTypID: Integer;
                                       oLookupAliasEdit: TUNILookupAliasEdit); override;
    procedure UNIDajGridaObiektu( iObiektTypID: Integer; OpenModeFlags: Integer;var sKlasa: String;
                                  var sPrimaryAlias: String;
                                  const oParams: TKeyValues); override;
    procedure UNIDajDetalaObiektu( iObiektTypID: Integer; iObiektID: Integer; iOpenMode: TOpenMode;
                                   var sKlasa: String;
                                   const oParams: TKeyValues); override;
    function UNIPrawoDoObiektu: String; override;
    {+----------------*}
      {obsuga wysyania danych zlecenia do systemw partnerw}
      {
        Funkcja zapisuje podane idki zlece do wysania, do tabeli ADMID dla podanego usera i kontekstu.
        Zwraca FALSE jeeli uytkownik anulowa wysyanie w komunikacie o ponownym wysyaniu.
      }
    function  ZapiszIdZlecDoWyslaniaWADMId(
                        const ac_oZlecId:     TStringList;  // id zlece do wysania (same id bez nazwy pola itp)
                        const ac_iUserId:     integer;
                        const ac_sKontekst:   string;
                        const ac_bUsuwanie:   boolean;      // czy zlecenia bd wycofywane (wtedy trzeba si upewni, e wszystkie byy wczeniej wysane)
                        const ac_oPlanProdElId: TStringList = nil // identyfikatory elementw planu produkcji podawane jeeli maj by wysane tylko te elementy a nie cae zlecenia
              ):  boolean;
      {
        Procedura usuwa idki zlece do wysania, z tabeli ADMID dla podanego usera i kontekstu
      }
    procedure UsunIdZlecDoWyslaniaWADMId(
                        const ac_iUserId:     integer;
                        const ac_sKontekst:   string
              );
      {
        Funkcja buduje query zwracajce dane nagwkw zlece, ktrych id zostay zapisane wczeniej do admid.
        Parametrami s wartoci pl tabeli admid.
      }
    function  DajQueryZlecDoWyslania(
                        const ac_iUserId:   integer;
                        const ac_sKontekst: string
              ):  TUNIQuery;
      {
        Funkcja buduje query zwracajce dane pozycji receptury zlece, ktrych id zostay zapisane wczeniej do admid.
        Parametrami s wartoci pl tabeli admid.
      }
    function  DajQueryReceppozZlecDoWyslania(
                        const ac_iUserId:         integer;
                        const ac_sKontekst:       string;
                        const ac_bWysylanieElems: boolean = false // czy wysyane s tylko wybrane elementy planu produkcji (id zapisane s ju w admid)
              ):  TUNIQuery;
      {
        Funkcja buduje query zwracajce dane zasobw pozycji receptury zlece, ktrych id zostay zapisane wczeniej do admid.
        Parametrami s wartoci pl tabeli admid.
      }
    function  DajQueryZasobowReceppozZlecDoWyslania(
                        const ac_iUserId:   integer;
                        const ac_sKontekst: string
              ):  TUNIQuery;
      {
        Procedura przepisuje dane z aktualnego rekordu ac_oZlecQuery oraz odpowiadajcym
        mu rekordw ac_oRecepPozQuery i ac_oZasobRecepPozQuery do dokumentu xml
        podpinajc elementy do elementu a_oParentNode
      }
    procedure PrzepiszDaneZlecDoXML(
                              a_oXMLDoc:              TUNIXMLParser;
                              a_oParentNode:          IXMLDOMElement;
                        const ac_oZlecQuery:          TUNIQuery;
                        const ac_oRecepPozQuery:      TUNIQuery;
                        const ac_oZasobRecepPozQuery: TUNIQuery
              );
      {
        Procedura wysya dane zlece do partnera i zapisuje id otrzymane z obcego systemu
        @param  ac_sDokumentXML     - dokument xml
        @param  ac_iOperacjaId      - operacja
        @param  ac_iUserId:         - user na ktrym zapisane s idki elementw planu do wysania
        @param  ac_sKontekst:       - kontekst na ktrym zapisane s idki elementw planu do wysania
        @param  ac_bWysylanieElems  - czy wysyane s tylko wybrane elementy planu produkcji (id zapisane s ju w admid)
                                      Przy wysyaniu caego zlecenia trzeba usun stare zapisy a przy wysyaniu poszczeglnych elementw planu nie mona
                                      tego robi
      }
    procedure WyslijDaneZlec(
                        const ac_sDokumentXML:      string;
                        const ac_iOperacjaId:       integer;
                        const ac_iUserId:           integer;
                        const ac_sKontekst:         string;
                        const ac_bWysylanieElems:   boolean = false // czy wysyane s tylko wybrane elementy planu produkcji (id zapisane s ju w admid)
              );
      {
        Funkcja sprzawdza czy zlecenia, ktrych id zostay zapisane wczeniej do admid s w peni zaplanowane.
        Parametrami s wartoci pl tabeli admid.
        Zwraca true jeeli mona kontynuowa wysyanie planu produkcji.
      }
    function  CzyWysylaneZleceniaSaWPelniZaplanowane(
                        const ac_iUserId:   integer;
                        const ac_sKontekst: string
              ):  boolean;
      {
        Funkcja buduje query zwracajce dane zasobw pozycji receptury zlece, ktrych id zostay zapisane wczeniej do admid.
        Parametrami s wartoci pl tabeli admid.
      }
    function  DajQueryZasobowReceppozPlanuProdukcjiDoWyslania(
                        const ac_iUserId:         integer;
                        const ac_sKontekst:       string;
                        const ac_bWysylanieElems: boolean = false // czy wysyane s tylko wybrane elementy planu produkcji (id zapisane s ju w admid)
              ):  TUNIQuery;
      {
        Funkcja buduje query zwracajce dane planu produkcji zlece, ktrych id zostay zapisane wczeniej do admid.
        Parametrami s wartoci pl tabeli admid.
      }
    function  DajQueryPlanuProdukcjiZlecDoWyslania(
                        const ac_iUserId:         integer;
                        const ac_sKontekst:       string;
                        const ac_bWysylanieElems: boolean = false // czy wysyane s tylko wybrane elementy planu produkcji (id zapisane s ju w admid)
              ):  TUNIQuery;
      {
        Procedura przepisuje dane z aktualnego rekordu ac_oZlecQuery oraz odpowiadajcym
        mu rekordw ac_oRecepPozQuery i ac_oZasobRecepPozQuery do dokumentu xml
        podpinajc elementy do elementu a_oParentNode
      }
    procedure PrzepiszDanePlanuProdukcjiDoXML(
                              a_oXMLDoc:              TUNIXMLParser;
                              a_oParentNode:          IXMLDOMElement;
                        const ac_oZlecQuery:          TUNIQuery;
                        const ac_oRecepPozQuery:      TUNIQuery;
                        const ac_oZasobRecepPozQuery: TUNIQuery;
                        const ac_oPlanProdQuery:      TUNIQuery
              );
      {
        Procedura zewntrzna moduu ZLE
      }
    procedure WyslijPlanProdukcjiZlec(
                        const ac_oZlecIds:            TStringList;
                        const ac_sKontekst:           string;
                        const ac_oPlanProdElId:       TStringList = nil // identyfikatory elementw planu produkcji podawane jeeli maj by wysane tylko te elementy a nie cae zlecenia
              );
      {
        Procedura zewntrzna moduu ZLE
      }
    procedure WycofajPlanProdukcjiZlec(
                        const ac_oZlecIds:            TStringList;
                        const ac_sKontekst:           string;
                        const ac_oPlanProdElId:       TStringList = nil // identyfikatory elementw planu produkcji podawane jeeli maj by wysane tylko te elementy a nie cae zlecenia
              );
      {koniec obsugi wysyania danych zlecenia do systemw partnerw}
    {+----------------*}
    {$endif}
    function ZleDajWartoscPracy(iZLECENIE_ID, iUNIOKRES_ID: Integer;
                                RODZAJECP: string='';
                                RODZAJZASOBU: string=''): Extended;
    function ZleDajWartoscRozliczenia(iZLECENIE_ID, iUNIOKRES_ID: Integer): Extended;
    function ZleDajIloscPaliwa(iZLECENIE_ID, iUNIOKRES_ID: Integer): Extended;
    function ZleDajIloscPracy(iZLECENIE_ID, iUNIOKRES_ID: Integer;
                              RODZAJECP: string='';
                              RODZAJZASOBU: string=''): Extended;
    function ZleDajIloscGodzin(iZLECENIE_ID, iUNIOKRES_ID: Integer;
                               RODZAJECP: string='';
                               RODZAJZASOBU: string=''): Extended;
    function ZLEDajKosztyZleceniaSzczegolowo(iZLECENIE_ID, iUNIOKRES_ID: Integer;
                                             aRodzajKosztow: TZleRodzajKosztow;
                                             a_oParams: TKeyValues  = nil): TUNIQuery;
    function ZLEDajKosztyZleceniaSzczegolowoSuma(iZLECENIE_ID, iUNIOKRES_ID: Integer;
                                                 a_oParams: TKeyValues  = nil): Extended;
    procedure ZLEPokazZasob(const ac_iZasobId:  integer);
    procedure AktualizujWyceneZlecen( const ac_sZleceniaId: string );
    procedure AkceptujWyceneZlecen(
                      const ac_aZleceniaWycIds: array of integer
              );
    procedure CofnijAkceptacjeWycenyZlecen(
                      const ac_aZleceniaWycIds: array of integer
              );
    procedure AkceptujPraceZasobow(
                      const ac_aZasobyPracaIds: array of integer
              );
      {
        Funkcja sprawdza czy mona modyfikowa podane zlecenie produkcyjne. Sprawdza czy
        nie jest umieszczone na planie produkcji.
        Zwraca '' jeeli mona edytowa lub komunikat dlaczego edycja nie jest dozwolona.
      }
    function  MoznaEdytowacZlecenieProdukcyjne(
                      const ac_iZlecenieId:       integer
              ):  string;
      {
        Funkcja sprawdza czy podane zlecenie zostao umieszczone na planie produkcji.
      }
    function  ZlecenieNaPlanieProdukcji(
                      const ac_iZlecenieId:       integer
              ):  boolean;
      {
        Funkcja sprawdza czy dla podanych parametrw jest ju utworzony rekord wyceny
        zlecenia. Jeeli tak to nie mona usun adnego rekordu czasu pracy zasobu
        powizanego z podanym zleceniem, zasobem i pozycj receptury.
        @param  ac_iZlecenieId
        @param  ac_iZasobId
        @param  ac_iRecepturaPozId
        @returns  True jeeli jest jaki rekord wyceny dla podanego kompletu danych
      }
    function  UtworzonyRekordWyceny(
                      const ac_iZlecenieId:     integer;
                      const ac_iZasobId:        integer;
                      const ac_iRecepturaPozId: integer
              ):  boolean;
      {
        Funkcja ustawia podanemu zleceniu status na ac_sNowyStatus
        @param  ac_iZlecenieId  - id zlecenia, ktremu ma by zmieniony status
        @param  ac_sNowyStatus  - nowy status ktry ma mie zlecenie
      }
    procedure ZmienStatusZlecenia(
                      const ac_iZlecenieId:     integer;
                      const ac_sNowyStatus:     string
              );
      {
        Funkcja sprawdza czy podane zlecenie zostao wysane do partnera (istnieje zapis w ZLEZLECENIEOBCY).
        @param  ac_iZlecenieId  - id zlecenia
      }
    function  ZlecenieWyslaneDoPartnera(
                      const ac_iZlecenieId:     integer
              ):  boolean;
      {
        Funkcja sprawdza czy podana receptura zostaa wysana do partnera (istnieje zapis w ZLEZLECENIEOBCY).
        @param  ac_iRecepturaId - id receptury
      }
    function  RecepturaWyslanaDoPartnera(
                      const ac_iRecepturaId:    integer
              ):  boolean;
      {
        Funkcja sprawdza czy podana pozycja receptury zostaa wysana do partnera (istnieje zapis w ZLEZLECENIEOBCY).
        @param  ac_iRecepturaPozId - id pozycji receptury
      }
    function  RecepturaPozWyslanaDoPartnera(
                      const ac_iRecepturaPozId: integer
              ):  boolean;
      {
        Funkcja sprawdza czy podany element planu zosta wysana do partnera (istnieje zapis w ZLEZLECENIEOBCY).
        @param  ac_iPlanProdElId  - id elementu planu produkcji
      }
    function  PlanProdElWyslanyDoPartnera(
                      const ac_iPlanProdElId:   integer
              ):  boolean;

  public
    //zarzdzanie parametrami
    vZLEDomyslnyStatusZlecenia: String;
    vZLEDomyslnyTypZlecenia: Integer;
    vZLEInstalacjeTypZlec:Integer;
    vZLEWymaganaOsobaZamykajacaZlecenie: Boolean;
    vZLEAsoReg_ID: Integer;
    vZLEPozycjeWlaczone: Boolean;
    vZLEKontrolaKosztowWlaczona: Boolean;
    vZLEKontrolaIlosciWlaczona: Boolean;
    vZLEKosztyMaterialoweWlaczone: Boolean;
    vZLEKosztyMatZakupWlaczone: Boolean;
    vZLEKosztyRobociznyWlaczone: Boolean;
    vZLEWystawioneFakturyWlaczone: Boolean;
    vZLEWystawioneFakturyZakupuWlaczone: Boolean;
    vZLEZasobyWlaczone: Boolean;
    vZLERozliczenieWlaczone: Boolean;
    vZLEZlecenieRozl_ZuzPaliwa: Boolean;
    vZLEZleceniePoz_RenumeracjaLP: Boolean;
    vZLEWymaganyOddzial: Boolean;
    vZLEDomyslnyOddzialID: Integer;
    vZLEWymaganaStawkaZasobu: boolean;
    vZLEPrzeliczanieWlaczone: Boolean;
    vZLEPrzeliczanieGodzina: String; {Format HH:MM}
    vZLEGrupowanieDanych: Boolean;
    vZLENumeratorZasobow: Integer;
    vZLEOgraniczonaListaZasobow: Boolean;
    vZLEWspolneZlecenia: Boolean;
    vZLEFormatGodzinLiczba: Boolean;
    vZLEWylaczonyFiltrDlaTypu: Boolean;
    vZLEWycenaPracyZasobowWlaczona: boolean;
    vZLENumeratorExt: Boolean;
    vZLEPrefixSlownikID: Integer;
    vZLEOsobnaNum: Boolean;
    vZLEWymaganaPozycjaEwid: Boolean;
    vZLEZamkniecieKont: Boolean;
    vZLESprawyPodpowiadanie: Boolean;
    vZLESprawyKontrahent: String;
    vZLESprawyWydzial: String;
    vZLESprawyPrefix: String;
    vZLENarzuty: Boolean;
    vZLEPoziomNarzutowJednOrg: Boolean;
    vZLEPoziomNarzutowOddzial: Boolean;
    vZLEPoziomNarzutowTypZlec: Boolean;
    vZLEZleceniaNadrzedne: Boolean;
    vZLEKosztyZakupuWlaczone: Boolean;
    vZLEKosztyKDECPWlaczone: Boolean;
    vZLEWydrukZlecenia: Boolean;
    vZLERozliczAktStawka: Boolean;
    vZLEKopiujZlecenieBezPozycji: Boolean;
    vZLEPrzeliczOkresID: Integer;
    vZLEWlaczAktywnePrzyciki: Boolean;
    vZLEPrzeliczanie: Boolean;
    vZLEKontrolaUprawnionych: Boolean;
    vZLESrodkiTrwaleWlaczone: Boolean;
    vZLEWysylanieECPWlaczone: Boolean;
    vZLEWysylanieRozliczECPWlaczone: Boolean;
    vZLESkladnikECPDomyslnyID: Integer;
    vZLEStawkaRegula: String;
    vZLEBlokadaZmianySymbolu: Boolean;
    vZLEReczneWprowadzanieSymbolu: Boolean;
    vZLEUwzglednijBlokadeKDECP: Boolean;
    vZLETransportWlaczony: Boolean;
    vZLEMaskaSymboluWlaczona: Boolean;
    vZLEMaskaSymbolu: String;
    vZLEDataBlokadyECP: Integer;
    vZLEBlokadaEdycjiZakoncz: Boolean;
    vZLEECPPracownicyWieleFirm: Boolean;
    vZLEUnikalnoscElemInf: Boolean;
    vZLEZleceniaPodrzedneWlaczone: Boolean;
    vZLEDopiszKosztyZakupuWlaczone: Boolean;
    vZLETworzZapotrzWlaczone: boolean;
    vZLEUproszczonySlownikZlecenWlaczony: Boolean;
    vZLERozliczanieAkorduECPWlaczone: Boolean;
    vZLESlownikStanowiskMnemID: Integer; //FKMnemoniki_ID
    vZLEZleceniaBezPozycjiZeSpraw: Boolean;

    {Funkcje do obsugi raportw}
    function  RaportOn(sNameRap: String): Integer;
    procedure RaportAdd(id_rap, iBlad: Integer; sBlad: String);
    procedure RaportOff(id_rap, iPoz, iPozErr: Integer);
    procedure RaportDelete(id_rap: Integer);
    procedure OdczytajParametry();
    procedure ZapiszParametry();

    {$ifdef build_zle}
    // Zwraca pierwszy wolny mnemonik postaci XX?
    function ZlePodajNastepnyMnemonik(): String;

    //Zwraca id mnemonika
    function ZLEDopiszMnemonik(sMnemonik: String; sRegula: String; bPola: Boolean): Integer;
    {$endif}

    function PobierzTekst(var sText: String): Integer;
    function ImportSkladnikowZPlikuTxt(sNazwaPliku: String; sSeparator: Char = ';'):Boolean;

    procedure CreateSPs();override;
    procedure UtworzSP(sSPName : string); override;
    procedure UtworzWyzwalacz(sTriggerName: string);

  {$ifndef build_all}
      {
        Funkcja tworzy rekordy o pracy zasobu na podstawie dokumentw magazynowych
      }
    function  UtworzPraceNaPodstawieMagazynu(): boolean;

      // funkcje pomocnicze przy zapisywaniu pracy zasobw
    procedure UtworzStringListePracyZasobow();
    procedure DopiszPraceZasobowDoADMID(
                  const ac_oZasobyPracaIds: TStringList
              );  overload;
    procedure DopiszPraceZasobowDoADMID(
                  const ac_sZasobyPracaId:  string
              );  overload;
    procedure UsunPraceZasobowZADMID();

  {$endif}

  end;

  EOF_ZLEException = class(EOFException)
    constructor Create( const Msg: string); overload;
  end;

  function ZLEPodajSlowneRozwiniecieKoduBledu( iErrorCode: Integer ): String;

var
  ZLEDataManager: TZLEDataManager;
  ZLEDM: TZLEDataManager;


implementation

{$R *.DFM}

uses
  variants,
  Dodatki,
  FormManagerUnit,
  QueryBuilderUnit,
  UNIFormUnit,
  UniqueKeyUnit,
  UNISysDefUnit,
  UNISysDataManagerUnit,
  SystemDefUnit,
  ASODefUnit,
  BKDefUnit,
  BOKDefUnit,
  FKDefUnit,
  INFDefUnit,
  KDDefUnit,
  KDPRADefUnit,
  //LFKDefUnit,
  MAGDefUnit,
  PLLIDefUnit,
  {$ifdef build_all}
  PLLIDataManagerUnit,
  KDPRADataManagerUnit,
  {$else}
  PLLIDataManagerExtUnit,
  LWPDataManagerExtUnit,
  KDPRADataManagerExtUnit,
  {$endif}
  {$ifdef build_all}
  MAGDataManagerUnit,
  ZAODataManagerUnit,
  ZAMDataManagerUnit,
  {$else}
  MAGDataManagerExtUnit,
  ZAODataManagerExtUnit,
  ZLEZlecenieDBDetailFormUnit,
  ZAMDataManagerExtUnit,
  BOKDataManagerExtUnit,
  UNIINTDataManagerExtUnit,
  UNIINTKomunikatyUnit,
  UNIINTDefUnit,
  {$endif}
  ZAMDefUnit,
  LWPDefUnit,
  SPDefUnit,
  MFSDefUnit,
  MFZDefUnit,
  PRZDefUnit,
  ZLEUpdateUnit,
  UNIParserMainUnit,
  {$ifdef build_zle}
  ZLEZlecenieDBGridFormUnit,
  ZLEFunkcjeAnalizyUnit,
  {$endif}
  {$ifndef installer}
  UNIReport,
  //UNIFormArchiveClassesUnit,
  //UNIFormsFormDefUnit,
  //UNIRepTypes,
  //UNIFormsTypesUnit,
  {$endif}
  EnvironmentManagerUnit,
  ZLEPobierzTekstFormUnit,
  ZLEPoleZmDefDBGridFormUnit,
  ZLEZasobDBGridFormUnit,
  ProgressFormUnit,
  ZAODefUnit;



function TZLEDataManager.RaportOn(sNameRap: string): integer;
  var
   iError:integer;
begin
  // dodanie nowego raportu
  Result:=UniSysDataManager.UNIRaportBledowDodajNowy(vAktywnaFirma,SecurityManager.UserID,
                                                     cASOMODULZSI_ID,false,sNameRap,iError);

  if iError <> 0 then begin
    Komunikat(cError,'Bd tworzenia raportu bdw');
    Result:=0;
  end;
end;

procedure TZLEDataManager.RaportAdd(id_rap, iBlad: integer; sBlad:string);
begin
  // dodanie pozycji do raportu
  if id_rap > 0 then  UniSysDataManager.UNIRaportBledowDodajPozycje(id_rap,iBlad,sBlad);
end;

procedure TZLEDataManager.RaportOff(id_rap, iPoz, iPozErr: integer);
var
  StopTime, StopDate :TDateTime;
begin
// zamknicie raportu
  StopTime:=time;
  StopDate:=date;

  if id_rap > 0 then UniSysDataManager.UNIRaportBledowZmien(id_rap,iPoz,iPozErr,StopDate,StopTime);
end;


procedure TZLEDataManager.RaportDelete(id_rap: Integer);
begin
  if id_rap > 0 then UniSysDataManager.UNIRaportBledowUsun(id_rap);
end;

{ Import danych do skadnikw wartociowych rcznych z pliku txt }
function TZLEDataManager.ImportSkladnikowZPlikuTxt(sNazwaPliku: String; sSeparator: Char = ';'):Boolean;
var
  plik1: TextFile;
  sSymbol, sRok, sOkres, sSkladnik, sWartosc, sWiersz: String;
  iZlecenieID, iRokID, iOkresID, iSkladnikID, iWartID: Integer;
  bTrans: Boolean;
  iDlugWiersz, iDodane, iZmienione, iBladDanych: Integer;
  iIlosc, iPoz, iPozErr: Integer;
  iRaportBl: Integer;
  MySplit: TSplit;

  {Zwraca ID Zlecenia dla podanego symbolu lub -1 jesli nie udao sie ustalenie wyniku}
  function GetZleZlecenieID(sSymbol: String) : Integer;
  var
    sID: String;
  begin
    result := -1;
    if length(sSymbol) <= 0 then Exit;

    try
       sID := SQLManager.OpenQueryWithResultWithoutFilter('SELECT ' + sZLEZLECENIE_ID + ' FROM %s WHERE ' +
                                                           sZLEZLECENIE_SYMBOL + '=' + QuotedStr(sSymbol), [sZLEZLECENIE]);

       if sID <> '' then
         try
            result := StrToInt(sID);
         except
            result := -1;
         end;
    except
       result := -1;
    end;

  end;

  {Zwraca ID Roku dla podanego tekstu lub -1 jesli nie udao sie ustalenie wyniku}
  function GetUniRokID(sText: String) : Integer;
  var
    sID: String;
  begin
    result := -1;
    if length(sText) <= 0 then Exit;

    try
       sID := SQLManager.OpenQueryWithResultWithoutFilter('SELECT ' + sUNIROK_ID + ' FROM %s WHERE ' +
                                                           sUNIROK_ROK + '=' + QuotedStr(sText), [sUNIROK]);

       if sID <> '' then
         try
            result := StrToInt(sID);
         except
            result := -1;
         end;
    except
       result := -1;
    end;

  end;

  {Zwraca ID Okresu dla podanego tekstu lub -1 jesli nie udao sie ustalenie wyniku}
  function GetUniokresID(sText: String; iRokID: Integer) : Integer;
  var
    sID: String;
  begin
    result := -1;
    if length(sText) <= 0 then Exit;

    try
       sID := SQLManager.OpenQueryWithResultWithoutFilter('SELECT ' + sUNIOKRES_ID + ' FROM %s WHERE ' +
                                                           sUNIOKRES_OKRES_NR + '=' + QuotedStr(sText) + ' AND ' +
                                                           sUNIROK_ID + '=' + IntToStr(iRokID), [sUNIOKRES]);

       if sID <> '' then
         try
            result := StrToInt(sID);
         except
            result := -1;
         end;
    except
       result := -1;
    end;

  end;

  {Zwraca ID Roku dla podanego tekstu lub -1 jesli nie udao sie ustalenie wyniku}
  function GetSkladnikID(sText: String; iZlecID: Integer) : Integer;
  var
    sID: String;
  begin
    result := -1;
    if length(sText) <= 0 then Exit;

    try
       sID := SQLManager.OpenQueryWithResultWithoutFilter('SELECT W.' + sZLESKLADWART_ID +
                               ' FROM %s W, %s ZW ' +
                               ' WHERE W.' + sZLESKLADWART_ID + ' = ZW.' + sZLESKLADWART_ID + ' AND ' +
                                    ' ZW.' + sZLESKLADWART_RODZAJ + ' = ' + QuotedStr(cZLERodzajSklad_RecznyID) + ' AND ' +
                                    '  W.' + sZLETYPZLEC_ID + ' IN (SELECT ' + sZLETYPZLEC_ID +
                                                                  ' FROM %s WHERE ' +
                                                                       sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecID) + ')' +
                                ' AND ZW.' + sZLESKLADWART_SYMBOL + ' = ' + QuotedStr(sText),
                                [sZLETYPSKLADW, sZLESKLADWART, sZLEZLECENIE]);

       if sID <> '' then
         try
            result := StrToInt(sID);
         except
            result := -1;
         end;
    except
       result := -1;
    end;

  end;

  //GetWartoscID(sWartosc, iZlecenieID, iRokID, iOkresID, iSkladnikID);
  {Zwraca ID Roku dla podanego tekstu lub -1 jesli nie udao sie ustalenie wyniku}
  function GetWartoscID(sText: String; iZlecID, iRok, iOkres, iSkladnik: Integer) : Integer;
  var
    sID: String;
  begin
    result := -1;
    if length(sText) <= 0 then Exit;

    try
       {Poprawi zapytanie!!}
       sID := SQLManager.OpenQueryWithResultWithoutFilter('SELECT ' + sZLEWART_ID +
                                                         ' FROM %s ' +
                                                         ' WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecID) + ' AND ' +
                                                                     sZLESKLADWART_ID + ' = ' + IntToStr(iSkladnik) + ' AND ' +
                                                                     sUNIOKRES_ID + ' = ' + IntToStr(iOkres),
                                                           [sZLEWART]);

       if sID <> '' then
         try
            result := StrToInt(sID);
         except
            result := -1;
         end;
    except
       result := -1;
    end;

  end;

  procedure AktualizujZleWart(sText: String; iWart: Integer);
  var
     oUpdateQuery: TUNIQuery;
  begin
      oUpdateQuery := SQLManager.UpdateQueryStep1(sZLEWART,
                                                  sZLEWART_WARTOSC + ', ' +
                                                  sZLEWART_BLAD,
                                                  sZLEWART_ID + ' = ' + IntToStr(iWart));
     oUpdateQuery.ParamByName(sZLEWART_WARTOSC).DataType := ftFloat;
     oUpdateQuery.ParamByName(sZLEWART_BLAD).DataType := ftString;

     oUpdateQuery.ParamByName(sZLEWART_WARTOSC).AsFloat := StrToFloat(sText);
     oUpdateQuery.ParamByName(sZLEWART_BLAD).AsString := cZLEParserBlad_BrakID;

     SQLManager.UpdateQueryStep2(oUpdateQuery);
  end;

  procedure DopiszZleWart(sText: String; iZlecID, iOkres, iSkladnik: Integer);
  var
    oInsertWART: TUNIQuery;
  begin

     oInsertWART := SQLManager.InsertQueryStep1( sZLEWART,
                                               sZLEWART_ID+','+sZLESKLADWART_ID+','+
                                               sUNIOKRES_ID + ',' + sZLEZLECENIE_ID+','+
                                               sZLEWART_WARTOSC+','+ sZLEWART_BLAD + ',' +
                                               sZLEWART_UZ_AU_ID+','+ sZLEWART_DATA_AU );

     try
       with oInsertWART do begin
         ParamByName(sZLEWART_ID).DataType := ftInteger;
         ParamByName(sZLESKLADWART_ID).DataType := ftInteger;
         ParamByName(sZLEZLECENIE_ID).DataType := ftInteger;
         ParamByName(sUNIOKRES_ID).DataType := ftInteger;
         ParamByName(sZLEWART_WARTOSC).DataType := ftFloat;
         ParamByName(sZLEWART_BLAD).DataType := ftString;

         ParamByName(sZLEWART_UZ_AU_ID).DataType := ftInteger;
         ParamByName(sZLEWART_DATA_AU).DataType := ftDate;

         ParamByName(sZLESKLADWART_ID).AsInteger := iSkladnik;
         ParamByName(sZLEZLECENIE_ID).AsInteger := iZlecID;
         ParamByName(sUNIOKRES_ID).AsInteger := iOkres;
         ParamByName(sZLEWART_WARTOSC).AsFloat := StrToFloat(sText);
         ParamByName(sZLEWART_BLAD).AsString := cZLEParserBlad_BrakID;

         ParamByName(sZLEWART_UZ_AU_ID).AsInteger := SecurityManager.UserId;
         ParamByName(sZLEWART_DATA_AU).AsDateTime := UNIDate;
       end;

       SQLManager.InsertQueryStep2( oInsertWART, sZLEWART_ID );
     finally
       if oInsertWART <> nil then FreeAndNil(oInsertWART);
     end;
  end;

begin
  iDodane           := 0;
  iZmienione        := 0;
  iBladDanych       := 0;
  iIlosc            := 0;
  iPoz              := 0;
  iPozErr           := 0;
  MySplit           := nil;
  result            := false;

  iRaportBl := RaportOn(sUNISysRaportBledow_ZLE_Import);
  if iRaportBl <= 0 then Exit;

  if sSeparator = '' then Exit;

  ProgressStart( nil, 100, 'Trwa importowanie danych ', false, 0 );
  ProgressForm.Progress(2);

  try {Otwrz plik}

      AssignFile(plik1, sNazwaPliku);
      Reset(plik1);

      { Rozpoczcie transakcji }
      bTrans := not SQLManager.InTransaction;
      try {TransSQL}
          if bTrans then SQLManager.StartTransaction;

          try
             { Przetwarzanie pliku tekstowego }
             while not Eof(plik1) do begin
                ProgressForm.Progress(5);
                Readln(plik1, sWiersz);

                Inc(iIlosc);

                {Pomijamy analiz pierwszego wiersza - nagwka pliku csv}
                if iIlosc = 1 then Continue;

                sWiersz := Trim(sWiersz);
                iDlugWiersz := Length(sWiersz);

                if iDlugWiersz <= 0 then begin
                   Inc(iBladDanych);
                   Inc(iPoz);
                   Inc(iPozErr);
                   RaportAdd(iRaportBl, 0, 'Ostrzeenie! Wiersz: ' + intToStr(iIlosc) + ' jest pusty.');
                   Continue;
                end;

                {constructor Create(const lancuch:string; const separator:char; const delimiter:String);}
                if MySplit <> nil then FreeAndNil(MySplit);

                MySplit := TSplit.Create(sWiersz, sSeparator, '''');

                if MySplit.Count <> 5 then begin
                   Inc(iBladDanych);
                   Inc(iPoz);
                   Inc(iPozErr);
                   RaportAdd(iRaportBl, 0, 'Ostrzeenie! Wiersz ' + intToStr(iIlosc) + ': ' + sWiersz + ' jest bdny. Zawiera ' + IntToStr(MySplit.Count) + ' elementw.');
                   Continue;
                end;

                {Zaczynamy analiz danych}
                {1. Sprawdzenie Symbolu Zlecenia}
                sSymbol := MySplit.Items[0];
                if sSymbol[1] = '"' then begin
                   System.Delete(sSymbol, 1, 1);
                   if sSymbol[length(sSymbol)] = '"' then
                      System.Delete(sSymbol, length(sSymbol), 1);
                end;

                iZlecenieId := GetZleZlecenieID(sSymbol);
                if iZlecenieID <= 0 then begin
                   Inc(iBladDanych);
                   Inc(iPoz);
                   Inc(iPozErr);
                   RaportAdd(iRaportBl, 0, 'Ostrzeenie! Wiersz ' + intToStr(iIlosc) + ': ' + sWiersz + ' zawiera bdny symbol zlecenia.');
                   Continue;
                end;

                {2. Sprawdzenie roku}
                sRok := MySplit.Items[1];
                if sRok[1] = '"' then begin
                   System.Delete(sRok, 1, 1);
                   if sRok[length(sRok)] = '"' then
                      System.Delete(sRok, length(sRok), 1);
                end;
                iRokID := GetUniRokID(sRok);
                if (iRokID <= 0) or (iRokID <> UNISYSDM.vAktywnyRokObrachunkowyID) then begin
                   Inc(iBladDanych);
                   Inc(iPoz);
                   Inc(iPozErr);
                   RaportAdd(iRaportBl, 0, 'Ostrzeenie! Wiersz ' + intToStr(iIlosc) + ': ' + sWiersz + ' zawiera bdny rok.');
                   if (iRokID <> UNISYSDM.vAktywnyRokObrachunkowyID) then begin
                      Inc(iPoz);
                      Inc(iPozErr);
                      RaportAdd(iRaportBl, 0, 'Ostrzeenie! Wiersz ' + intToStr(iIlosc) + ': Rok jest niezgodny z rokiem obrachunkowym.');
                   end;
                   Continue;
                end;

                {3. Sprawdzenie okresu}
                sOkres := MySplit.Items[2];
                if sOkres[1] = '"' then begin
                   System.Delete(sOkres, 1, 1);
                   if sRok[length(sOkres)] = '"' then
                      System.Delete(sOkres, length(sOkres), 1);
                end;
                iOkresID := GetUniOkresID(sOkres, iRokID);
                if (iOkresID <= 0) then begin
                   Inc(iBladDanych);
                   Inc(iPoz);
                   Inc(iPozErr);
                   RaportAdd(iRaportBl, 0, 'Ostrzeenie! Wiersz ' + intToStr(iIlosc) + ': ' + sWiersz + ' zawiera bdny okres.');
                   Continue;
                end;

                {4. Teraz Skadnik kontroli wartociowej - rczny?}
                sSkladnik := MySplit.Items[3];
                if sSkladnik[1] = '"' then begin
                   System.Delete(sSkladnik, 1, 1);
                   if sSkladnik[length(sSkladnik)] = '"' then
                      System.Delete(sSkladnik, length(sSkladnik), 1);
                end;

                iSkladnikID := GetSkladnikID(sSkladnik, iZlecenieID);
                if (iSkladnikID <= 0) then begin
                   Inc(iBladDanych);
                   Inc(iPoz);
                   Inc(iPozErr);
                   RaportAdd(iRaportBl, 0, 'Ostrzeenie! Wiersz ' + intToStr(iIlosc) + ': ' + sWiersz + ' zawiera bdny skadnik.');
                   Continue;
                end;

                {5. I ostatni parametr - Warto}
                sWartosc := MySplit.Items[4];
                if sWartosc[1] = '"' then begin
                   System.Delete(sWartosc, 1, 1);
                   if sRok[length(sWartosc)] = '"' then
                      System.Delete(sWartosc, length(sWartosc), 1);
                end;

                iWartID := GetWartoscID(sWartosc, iZlecenieID, iRokID, iOkresID, iSkladnikID);
                {Jesli iWartID > 0 tzn., ze skadnik juz istnia - mg by oczywicie zerowej wartoci}
                {W przeciwnym wypadku trzeba dopisa skadnik o podanej wartoci}
                if (iWartID > 0) then begin
                    {Update}
                    AktualizujZleWart(sWartosc, iWartID);
                    Inc(iZmienione);
                end else begin
                    {Insert}
                    DopiszZleWart(sWartosc, iZlecenieID, iOkresID, iSkladnikID);
                    Inc(iDodane);
                end;


             end; { while Eof() }

          {Zakoczenie transakcji }
         // if bTrans then SQLManager.Rollback;
          if bTrans then SQLManager.Commit;
          RaportAdd( iRaportBl, 0, 'Import zakoczony. Dodano: ' + IntToStr(iDodane) +
                                ', zmieniono: ' + IntToStr(iZmienione) +
                                ', bdnych: ' + IntToStr(iBladDanych) );

          except
             {W przypadku bedu wykonaja sie instrukcje poznizsze}
             //ProgressEnd();
            // RaportDelete(iRaportBl);
            // Exit;
          end;

          inc(iPoz);
          CloseFile(plik1);

          RaportOff( iRaportBl, iPoz, iPozErr);
          ProgressEnd();
          UniSysDataManager.UNIPokazPojedynczyRaportBledow(iRaportBl);
      except {TransSQL}
         { Przerwij transakcje }
         if bTrans then SQLManager.Rollback;
         Komunikat(cError, 'Bd importu danych z pliku');
      end;  {TransSQL}

  except
    Komunikat(cError, 'Bd otwarcia pliku ' + sNazwaPliku);
  end;

  RaportDelete(iRaportBl);

  result := true;
end;


{$ifdef build_zle}
function TZLEDataManager.GetValueFromFunction(FuncName: String; var Arguments: array of Variant): Variant;
begin
  result := '';
  { LISTADOK }
  if FuncName = 'LISTADOK' then begin
     if DataManagers.Available(sMAGModulID) then begin
                              // zlezlecenie_id, uniokres_id, Asoasort_id
        Result := MAGDM.MagListaDok(Arguments[0], Arguments[1], Arguments[2]);
     end;
  end;
end;
{$endif}

function ZLEPodajSlowneRozwiniecieKoduBledu(iErrorCode:Integer):string;
var
  sMessage:string;
begin

  sMessage:=IntToStr(iErrorCode)+'.';

  case iErrorCode of
    cError_BrakIDFirmy:              sMessage := sMessage + ' Nie podano ID firmy';
    cError_BrakIDModulu:             sMessage := sMessage + ' Nie podano ID moduu rdowego';
    cError_BrakModulu:               sMessage := sMessage + ' Brak moduu o podanym identyfikatorze';

    cError_TabelaNieobslugiwana:     sMessage := sMessage + ' Niedozwolona nazwa tabeli: ';
    cError_BrakZlecenia:             sMessage := sMessage + ' Brak zlecenia o podanym identyfikatorze';

    cError_BrakGrupy:                sMessage := sMessage + ' Brak grupy o podanym ID';
    cError_BrakTypuZlecenia:         sMessage := sMessage + ' Brak typu zlecenia o podanym ID';
    cError_BladDodaniaElemGrup:      sMessage := sMessage + ' Bd podczas tworzenia elementu grupujcego';
    cError_BladDodaniaElemGrupIstnieje: sMessage := sMessage + ' Zlecenie o podanym symbolu ju isnieje';

    cError_BrakSkladnika:               sMessage := sMessage + ' Brak skadnika o symbolu: %s w definicji typu';
    cError_SkladnikNiePrzeliczony:      sMessage := sMessage + ' Pozycja o symbolu: %s nie zostaa jeszcze przeliczona';
  else
      sMessage:=sMessage + ' Nieoczekiwany bd';
  end;
  result := sMessage;
end;

{ EOF_ZLEException }

constructor EOF_ZLEException.Create(const Msg: string);
begin
  inherited Create(msg);
  Module:= sZLEModulID;
end;

{ TZLEDataManager }

procedure TZLEDataManager.pola_techniczne(sTabela: string;
  FieldDefs: TUNIFieldDefs);
begin
  with FieldDefs do begin
    AddI(sTabela+'_UZ_AU_ID',omWymagane);
    AddD(sTabela+'_DATA_AU',omWymagane);
    AddI(sTabela+'_UZ_ZM_ID',omNieWymagane);
    AddD(sTabela+'_DATA_ZM',omNieWymagane);
  end;
end;

function TZLEDataManager.DajNazwyTablic: string;
begin
  if not DataManagers.Doinstalowanie then begin
    //przeniesione do UNISysDM
    {Result := sZLEZLECENIE;
    Result := Result + ';' + sZLETYPZLEC;}
  end;
  if DataManagers.Available(sZLEModulID) then begin
    Result := sZLEZLECENIEPOZ;
    Result := Result + ';' + sZLEWART;
    Result := Result + ';' + sZLEIL;
    Result := Result + ';' + sZLEILOPIS;
    Result := Result + ';' + sZLETYPSKLADW;
    Result := Result + ';' + sZLESKLADWART;
    Result := Result + ';' + sZLETYPSKLADIL;
    Result := Result + ';' + sZLESKLADIL;
    //Result := Result + ';' + sZLEOSOBYGODZ;
    Result := Result + ';' + sZLEZASOB;
    Result := Result + ';' + sZLEZLECENIEZASOB;
    //Result := Result + ';' + sZLEZLECENIEROZL;
    {Result := Result + ';' + sZLEPOLAZMDEF;
    Result := Result + ';' + sZLEPOLAZMWSK;
    Result := Result + ';' + sZLEPOLAZM;}
    Result := Result + ';' + sZLEPLROZDEF;
    Result := Result + ';' + sZLEZLECENIEMAT;
    Result := Result + ';' + sZLEZASOBYPRACA;
    Result := Result + ';' + sZLEBRAKI;
    Result := Result + ';' + sZLEZASOBYBRAKI;
    Result := Result + ';' + sZLEOSOBY;
    Result := Result + ';' + sZLEZLECENIEWYC;
    Result := Result + ';' + sZLEKRYTERIA;
    Result := Result + ';' + sZLEKRYTPOZ;
    Result := Result + ';' + sZLEKRYTERIAWAR;
    Result := Result + ';' + sZLEPREFIX;
    Result := Result + ';' + sZLEZLECENIEOBCY;
    Result := Result + ';' + sZLEZASOBYPRACAMAGP;
    Result := Result + ';' + sZLEWSPNARZUTY;
    Result := Result + ';' + sZLESKLADNIKIECPDEF;
    Result := Result + ';' + sZLEZASOBYPRACARAP;
    Result := Result + ';' + sZLERAPORTEDIT;
    Result := Result + ';' + sZLETYPZLECUSERS;
  end;
end;

procedure TZLEDataManager.DajDefinicjeTablicy(TableName: string;
  FieldDefs: TUNIFieldDefs; IndexDefs: TIndexDefs);
begin
  //przeniesione do UNISysDM
  //sZLEZLECENIE
  //sZLETYPZLEC
  //
  if TableName = sZLEZLECENIEPOZ then begin
    with FieldDefs do begin
      AddI(sZLEZLECENIEPOZ_ID, omWymagane,    '',     '* Specyfikacja pozycji zlecenia');
      AddI(sZLEZLECENIE_ID, omWymagane,       '',     'Zlecenie');
      AddI(sZLEZLECENIEPOZ_LP, omNieWymagane, '',     'Lp. pozycji zlecenia');
      AddI(sLFKWZORDEKR_ID, omNieWymagane,    '',     'Wzr dekretacji');
      Add( sZLEZLECENIEPOZ_ILOSC, uftNumber, 0, omNieWymagane, True, '', 'Ilo');
      AddI(sASOASORT_ID, omNieWymagane, '', 'Asortyment'); //Zmiana 2007-11-21 Tomjen
      AddS(sZLEZLECENIEPOZ_OPIS, cTypOpisDowKsieg, omNieWymagane, True, '', 'Opis pozycji');
      AddI(sBOKSPRAWA_ID, omNieWymagane, '', 'Sprawa BOK');
      AddS(sZLEZLECENIEPOZ_POZIOMINF, 2, omNieWymagane, True, '', 'Poziom infrastruktury');
      AddI(sZLEZLECENIEPOZ_INF_ID, omNieWymagane, '', 'Element infrastruktury');
      Add( sZLEZLECENIEPOZ_WARTOSC, uftNumber, 0, omNieWymagane, True, '', 'Warto');
      Add( sZLEZLECENIEPOZ_CENA, uftNumber, 0, omNieWymagane, True, '', 'Cena');
      AddD(sZLEZLECENIEPOZ_DATA, omNieWymagane, '', 'Data pozycji');
    end;
    with IndexDefs do begin
      Add( '', sZLEZLECENIEPOZ_ID, [ixPrimary]);
      {Usunicie unikalnoci asortymentu - Tomjen - 2008-04-08}
      //Add( c_UNK+'1', sZLEZLECENIE_ID+','+sASOASORT_ID+','+sBOKSPRAWA_ID,[ixUnique] );
      Add( c_UNK+'2', sZLEZLECENIE_ID+','+sZLEZLECENIEPOZ_LP, [ixUnique] );
    end;
  end else if TableName = sZLEWART then begin
    with FieldDefs do begin
      AddI(sZLEWART_ID, omWymagane, '', '* Specyfikacja kontroli wartociowej');
      AddI(sZLEZLECENIE_ID, omWymagane, '', 'Zlecenie');
      AddI(sUNIOKRES_ID, omNieWymagane, '', 'Okres');
      AddI(sZLESKLADWART_ID, omWymagane, '', 'Skadnik wartociowy');
      Add( sZLEWART_WARTOSC, uftNumber, 0, omWymagane, True, '0.0', 'Warto skadnika');
      AddS(sZLEWART_BLAD, 2, omWymagane, True, cZLEParserBlad_BrakID, 'Bd skadnika');
    end;
    with IndexDefs do begin
      Add('', sZLEWART_ID, [ixPrimary]);
      Add(c_UNK+'1', sZLEZLECENIE_ID+','+sZLESKLADWART_ID+','+sUNIOKRES_ID,
                     [ixUnique] );
    end;
  end else if TableName = sZLEIL then begin
    with FieldDefs do begin
      AddI(sZLEIL_ID, omWymagane, '', 'Specyfikacja kontroli ilociowej');
      AddI(sZLEZLECENIEPOZ_ID, omWymagane, '', 'Pozycja zlecenia');
      AddI(sUNIOKRES_ID, omNieWymagane, '', 'Okres');
      AddI(sZLESKLADIL_ID, omWymagane, '', 'Skadnik ilociowy');
      Add(sZLEIL_ILOSC, uftCounter, 0, omWymagane, True, '', 'Ilo skadnika');
      AddS(sZLEIL_BLAD, 2, omWymagane, True, cZLEParserBlad_BrakID, 'Bd dla skadnika');
    end;
    with IndexDefs do begin
      Add('', sZLEIL_ID, [ixPrimary]);
      Add(c_UNK+'1', sZLEZLECENIEPOZ_ID+','+sZLESKLADIL_ID+','+sUNIOKRES_ID,
                     [ixUnique] );
    end;
  end else if TableName = sZLEILOPIS then begin
    with FieldDefs do begin
      AddI(sZLEILOPIS_ID, omWymagane, '', '* Specyfikacja uwag w kontroli ilociowej');
      AddI(sZLEZLECENIEPOZ_ID, omWymagane, '', 'Pozycja zlecenie');
      AddI(sUNIOKRES_ID, omNieWymagane, '', 'Okres');
      AddS(sZLEILOPIS_UWAGI, 150, omNieWymagane, True, '', 'Uwagi');
    end;
    with IndexDefs do begin
      Add('', sZLEILOPIS_ID, [ixPrimary]);
      Add(c_UNK+'1', sZLEZLECENIEPOZ_ID+','+sUNIOKRES_ID, [ixUnique] );
    end;
  end else if TableName = sZLETYPSKLADW then begin
    with FieldDefs do begin
      AddI(sZLETYPSKLADW_ID, omWymagane, '', '* Specyfikacja def. skadnikw wartociowych dla typu zlec.');
      AddI(sZLETYPZLEC_ID, omWymagane, '', 'Typ Zlecenia');
      AddI(sZLESKLADWART_ID, omWymagane, '', 'Skladnik wartociowy');
      AddI(sZLETYPSKLADW_KOLEJNOSC, omNieWymagane, '', 'Kolejno skadnika w kontroli dla typu zlecenia');
    end;
    with IndexDefs do begin
      Add('', sZLETYPSKLADW_ID, [ixPrimary]);
      Add(c_UNK+'1', sZLETYPZLEC_ID+','+sZLESKLADWART_ID, [ixUnique] );
    end;
  end else if TableName = sZLESKLADWART then begin
    with FieldDefs do begin
      AddI(sZLESKLADWART_ID, omWymagane, '', '* Specyfikacja skladnika wartosciowego');
      AddI(sUNIODDZIAL_ID, omNieWymagane, '', 'Oddzia');
      AddS(sZLESKLADWART_SYMBOL, cZLEDlugoscPola_Symbol, omWymagane, True, '', 'Symbol');
      AddS(sZLESKLADWART_NAZWA, cZLEDlugoscPola_Nazwa, omNieWymagane, True, '', 'Nazwa');
      AddS(sZLESKLADWART_RODZAJ, 1, omWymagane, false, cZLERodzajSklad_RecznyID, 'Rodzaj');
      Add( sZLESKLADWART_REGULA, uftClob, 0, omNieWymagane, True, '', 'Regula');
      AddS(sZLESKLADWART_SYMULACJA, 1, omWymagane, False, sUNICONST_ALTERNATYWA_NIE, 'Czy symulacja');
      AddS(sZLESKLADWART_FORMAT    , 3, omWymagane, True, '9,2', 'Okrelenie iloci miejsc przed i po przecinku.');
    end;
    with IndexDefs do begin
      Add('', sZLESKLADWART_ID, [ixPrimary]);
      if vWieloodzialowosc or vWielofirmowosc then begin
        Add(c_UNK+'1', sZLESKLADWART_SYMBOL+','+sUNIODDZIAL_ID, [ixUnique] );
        Add(c_UNK+'2', sZLESKLADWART_NAZWA+','+sUNIODDZIAL_ID, [ixUnique] );
      end else begin
        Add(c_UNK+'1', sZLESKLADWART_SYMBOL, [ixUnique] );
        Add(c_UNK+'2', sZLESKLADWART_NAZWA, [ixUnique] );
      end;
    end;
  end else if TableName = sZLETYPSKLADIL then begin
    with FieldDefs do begin
      AddI(sZLETYPSKLADIL_ID, omWymagane, '', '* Specyfikacja skadnika ilociowego');
      AddI(sZLETYPZLEC_ID, omWymagane, '', 'Typ zlecenia');
      AddI(sZLESKLADIL_ID, omWymagane, '', 'Skadnik ilociowy');
      AddI(sZLETYPSKLADIL_KOLEJNOSC, omNieWymagane, '', 'Kolejno skadnika w kontroli dla typu zlecenia');
    end;
    with IndexDefs do begin
      Add('', sZLETYPSKLADIL_ID, [ixPrimary]);
      Add(c_UNK+'1', sZLETYPZLEC_ID+','+sZLESKLADIL_ID, [ixUnique] );
    end;
  end else if TableName = sZLESKLADIL then begin
    with FieldDefs do begin
      AddI(sZLESKLADIL_ID, omWymagane, '', '* Specyfikacja skadnika ilociowego');
      AddI(sUNIODDZIAL_ID, omNieWymagane, '', 'Oddzia');
      AddS(sZLESKLADIL_SYMBOL, cZLEDlugoscPola_Symbol, omWymagane, True, '', 'Symbol');
      AddS(sZLESKLADIL_NAZWA, cZLEDlugoscPola_Nazwa, omNieWymagane, True, '', 'Nazwa');
      AddS(sZLESKLADIL_RODZAJ, 1, omWymagane, false, cZLERodzajSklad_RecznyID, 'Rodzaj');
      Add( sZLESKLADIL_REGULA, uftClob, 0, omNieWymagane, True, '', 'Regua');
      AddS(sZLESKLADIL_NIEOKRESOWY, 1, omWymagane, False, sUNICONST_ALTERNATYWA_NIE, 'Czy skadnik okresowy');
    end;
    with IndexDefs do begin
      Add('', sZLESKLADIL_ID, [ixPrimary]);
      if vWieloodzialowosc or vWielofirmowosc then begin
        Add(c_UNK+'1', sZLESKLADIL_SYMBOL+','+sUNIODDZIAL_ID, [ixUnique] );
        Add(c_UNK+'2', sZLESKLADIL_NAZWA+','+sUNIODDZIAL_ID, [ixUnique] );
      end else begin
        Add(c_UNK+'1', sZLESKLADIL_SYMBOL, [ixUnique] );
        Add(c_UNK+'2', sZLESKLADIL_NAZWA, [ixUnique] );
      end;
    end;
  (********************** WIDOK *******************
  end else if TableName = sZLEOSOBYGODZ then begin
    with FieldDefs do begin
      AddI(sZLEOSOBYGODZ_ID, omWymagane, '', '* Specyfikacja RCP osb');
      AddI(sZLEZLECENIE_ID, omWymagane, '', 'Zlecenie');
      AddI(sZLEZLECENIEPOZ_ID, omNieWymagane, '', 'Pozycja zlecenia');
      AddI(sASOASORT_ID, omNieWymagane, '', 'Asortyment');
      AddI(sSPCENNIK_ID, omNieWymagane, '', 'Cennik');
      AddI(sUNIOKRES_ID, omWymagane, '', 'Okres');
      AddI(sKDOSOBA_ID, omNieWymagane, '', 'Osoba');
      //AddI(sZLEOSOBYGODZ_ILOSC, omWymagane, '', 'Ilo godzin');
      Add(sZLEOSOBYGODZ_ILOSC, uftNumber, 0, True, False, '', 'Ilo godzin');
      Add(sZLEOSOBYGODZ_CENA, uftCounter, 0, True, False, '', 'Cena');
      Add( sZLEOSOBYGODZ_IL_PRACY, uftNumber, 0, omNieWymagane, True, '0.0', 'Ilo pracy');
      AddD(sZLEOSOBYGODZ_DATA, omNieWymagane, '', 'Data');
      AddI(sZLEZASOB_ID, omNieWymagane, '', 'Zasb');
      AddI(sZLEOSOBY_ID, omNieWymagane, '', 'Osoba powiazana z zasobem');
    end;
    with IndexDefs do begin
      Add('', sZLEOSOBYGODZ_ID, [ixPrimary]);
    end;
  ********************** WIDOK **********************)
  end else if TableName = sZLEZASOB then begin
    with FieldDefs do begin
      AddI( sZLEZASOB_ID, omWymagane, '', '* Specyfikacja zasobw');
      AddS( sZLEZASOB_RODZAJ, 1, omWymagane, True, '', 'Rodzaj');
      Add( sZLEZASOB_STAWKA, uftCounter, 0, True, False, '', 'Stawka godzinowa');
      AddS( sZLEZASOB_SYMBOL, cZLEDlugoscPola_Symbol, omNieWymagane, True, '', 'Symbol');
      AddS( sZLEZASOB_POLE1, 20,omNiewymagane, True, '', 'Pole1');
      AddS( sZLEZASOB_POLE2, 20,omNiewymagane, True, '', 'Pole2');
      AddS( sZLEZASOB_POLE3, 20,omNiewymagane, True, '', 'Pole3');
      AddS( sZLEZASOB_NAZWA, 30, omNieWymagane, True, '', 'Nazwa');
      AddI( sKDOSOBA_ID, omNieWymagane, '', 'Osoba');
      AddI( sUNIJEDNOSTKAORG_ID, omNieWymagane, '', 'Jednostka organizacyjna');
      Add(  sZLEZASOB_OBCIAZENIE_MAX, uftNumber, 0, omNieWymagane, True, '', 'Maksymalne obcienie');
      AddI( sLWPJEDNCZAS_ID, omNieWymagane, '', 'Jednostka czasu');
      AddI( sKDGRUPAKAL_ID, omNieWymagane, '', 'Grupa kalendarzowa');
      AddI( sUNIAUTNUM_ID, omNieWymagane, '', 'Numerator symbolu');
      AddI( sZLEZASOB_LICZNIK, omNieWymagane, '', 'Licznik numeratora');
    end;
    with IndexDefs do begin
      Add( '', sZLEZASOB_ID, [ixPrimary] );
    end;
  end else if TableName = sZLEZLECENIEZASOB then begin
    with FieldDefs do begin
      AddI( sZLEZLECENIEZASOB_ID, omWymagane, '', '* Specyfikacja zasobu dla zlecenie');
      AddI( sZLEZLECENIE_ID, omWymagane, '', 'Zlecenie');
      AddI( sZLEZASOB_ID, omWymagane, '', 'Zasb');
      AddS( sZLEZLECENIEZASOB_PLAN, 1, omNieWymagane, true, sNie, 'Plan');
      Add(  sZLEZLECENIEZASOB_OBCIAZ, uftNumber, 0, omNieWymagane, True, '', 'Obcienie');
      AddI( sLWPRECEPPOZZASOB_ID, omNieWymagane, '', 'Zasb pozycji receptury');
      AddI( sLWPJEDNCZAS_ID, omNieWymagane);
      Add(  sZLEZLECENIEZASOB_WYD, uftNumber, 0, omNieWymagane);
      AddI( sZLEZLECENIEZASOB_WYDJED, omNieWymagane);
    end;
    with IndexDefs do begin
      Add( '', sZLEZLECENIEZASOB_ID, [ixPrimary] );
      Add( c_UNK+'1', sZLEZLECENIE_ID+','+sZLEZASOB_ID+','+sLWPRECEPPOZZASOB_ID, [ixUnique] );
    end;
  (********************** WIDOK *******************
  end else if TableName = sZLEZLECENIEROZL then begin
    with FieldDefs do begin
      AddI( sZLEZLECENIEROZL_ID, omWymagane, '', '* Specyfikacja rozlicze');
      AddI( sZLEZLECENIEPOZ_ID, omWymagane, '', 'Pozycja zlecenia');
      AddI( sZLEZASOB_ID, omWymagane, '', 'Zasb');
     // Add( sZLEZLECENIEROZL_GODZINY, uftInteger, 0, omWymagane, False, '0', 'Ilo godzin');
      Add( sZLEZLECENIEROZL_GODZINY, uftNumber, 0, omWymagane, False, '0.00', 'Ilo godzin');
      Add( sZLEZLECENIEROZL_STAWKA, uftCounter, 0, omWymagane, False, '0.00', 'Stawka');
      AddD( sZLEZLECENIEROZL_DATA, omNieWymagane, '', 'Data');
      Add( sZLEZLECENIEROZL_ZUZ_PALIWA, uftFloat, 0, omNieWymagane, False, '0.0', 'Zuycie paliwa');
    end;
    with IndexDefs do begin
      Add( '', sZLEZLECENIEROZL_ID, [ixPrimary] );
      Add( c_UNK+'1', sZLEZLECENIEPOZ_ID+','+sZLEZASOB_ID, [ixUnique] );
    end;
  ********************** WIDOK *******************)
  (*************************** POLA UZ ************************
  end else if TableName = sZLEPOLAZMDEF then begin
    with FieldDefs do begin
      AddI(sZLEPOLAZMDEF_ID, omWymagane, '', '* Specyfikacja definicji pola uytkownika');
      AddS(sZLEPOLAZMDEF_NAZWA, 35, omWymagane, True, '', 'Nazwa');
      AddI(sZLEPOLAZMDEF_TYP, omWymagane, '', 'Typ');
      AddI(sZLEPOLAZMDEF_DLUG, omNieWymagane, '', 'Dlugosc');
      AddS(sZLEPOLAZMDEF_TYPDANYCH, 1, omWymagane, False, cMAGTypDanych_StringID, 'Typ danych');
      AddS(sZLEPOLAZMDEF_ZNAKI, 50, omNiewymagane, True, '', 'Dopuszczalne znaki');
      AddI(sFKMNEMONIKI_ID, omNieWymagane, '', 'Mnemonik');
      AddI(sUNICONSTDEF_ID, omNieWymagane, '', 'Domena');
      Add(sZLEPOLAZMDEF_FORMAT, uftFloat, 0, omNiewymagane, True, '', 'Format');
    end;
    with IndexDefs do begin
      Add('', sZLEPOLAZMDEF_ID, [ixPrimary]);
    end;
  end else if TableName = sZLEPOLAZMWSK then begin
    with FieldDefs do begin
      AddI(sZLEPOLAZMWSK_ID, omWymagane, '', '* Specyfikacja pl dla typu zlecenia');
      AddI(sZLEPOLAZMDEF_ID, omWymagane, '', 'Definicja pola');
      AddI(sZLETYPZLEC_ID, omWymagane, '', 'Typ zlecenia');
      AddS(sZLEPOLAZMWSK_POZYCJA, 1, omWymagane, False, sUNICONST_ALTERNATYWA_NIE, 'Czy pozycja');
    end;
    with IndexDefs do begin
      Add('', sZLEPOLAZMWSK_ID, [ixPrimary]);
    end;
  end else if TableName = sZLEPOLAZM then begin
    with FieldDefs do begin
      AddI(sZLEPOLAZM_ID, omWymagane, '', '* Specyfikacja pl uytkownika');
      AddI(sZLEZLECENIE_ID, omWymagane, '', 'Zlecenie');
      AddI(sZLEZLECENIEPOZ_ID, omNieWymagane, '', 'Pozycja zlecenia');
      AddI(sZLEPOLAZMDEF_ID, omWymagane, '', 'Definicja pola');
      AddI(sFKUZ_ID, omNieWymagane, '', 'Pole slownika uytkownika');
      AddS(sZLEPOLAZM_DOMENAWART_ID, 5, omNieWymagane, True, '', 'Domena');
      AddS(sZLEPOLAZM_WART, 255, omNieWymagane, True, '', 'Warto');
    end;
    with IndexDefs do begin
      Add('', sZLEPOLAZM_ID, [ixPrimary]);
    end;
  *************************** POLA UZ ************************)
  end else if TableName = sZLEPLROZDEF then begin
    with FieldDefs do begin
      AddI(sZLEPLROZDEF_ID, omWymagane, '', '* Specyfikacja rozdzielnik kosztw');
      AddI(sPLROZDEF_ID, omWymagane, '', 'Rozdzielnik kosztow z plac');
    end;
    with IndexDefs do begin
      Add('', sZLEPLROZDEF_ID, [ixPrimary]);
      Add( c_UNK+'1', sPLROZDEF_ID, [ixUnique] );
    end;
  end else if(TableName = sZLEZLECENIEMAT) then begin
    with FieldDefs do begin
      AddI(sZLEZLECENIEMAT_ID     , omWymagane, '', '* Specyfikacja materiaw');
      AddI(sZLEZLECENIE_ID        , omWymagane, '', 'Zlecenie');
      AddI(sLWPRECEPPOZMATERIAL_ID, omNieWymagane, '', 'Materia pozycji receptury');
      AddI(sASOASORT_ID           , omWymagane, '', 'Asortyment');
      Add(sZLEZLECENIEMAT_ILOSC, uftNumber, 0, omWymagane, True, '', 'Ilo');
      AddI(sASOASORTKMAT_ID       , omNieWymagane, '', 'Konto materiaowe');
      AddI(sLWPRECEPPOZOPER_ID    , omNieWymagane, '', 'Operacja');
      AddI(sLWPRECEPPOZOPERZAM_ID , omNieWymagane, '', 'Aktualnie wybrany zamiennik operacji');
    end;
    with IndexDefs do begin
      Add('', sZLEZLECENIEMAT_ID, [ixPrimary]);
    end;
  end else if(TableName = sZLEZASOBYPRACA) then begin
    with FieldDefs do begin
      AddI(sZLEZASOBYPRACA_ID         , omWymagane, '', '* Specyfikacja RCP zasobw');
      AddI(sZLEZLECENIE_ID            , omNieWymagane, '', 'Zlecenie');
      AddI(sZLEZASOB_ID               , omNieWymagane, '', 'Zasb'); {Zmiana byo wymagane}
      AddI(sKDZMIANYDEF_ID            , omNieWymagane, '', 'Zmiana');{Zmiana byo wymagane}
      AddI(sLWPPLANPRODEL_ID          , omNieWymagane, '', 'Partia produkcji');
      AddS(sZLEZASOBYPRACA_STATUS     , 3, omWymagane, true, cZLEConstZasobPracaStatus_WprowadzonyID, 'Status rekordu');
      AddD(sZLEZASOBYPRACA_DATA       , omNieWymagane, '', 'Data');
      AddD(sZLEZASOBYPRACA_DATA_DO    , omNieWymagane, '', 'Data do');
      Add(sZLEZASOBYPRACA_IL_PRACY    , uftNumber, 0, omWymagane, True, '0.00', 'Ilo pracy');
      Add(sZLEZASOBYPRACA_CZAS_PRACY  , uftNumber, 0, omWymagane, True, '0.00', 'Czas pracy');
      Add(sZLEZASOBYPRACA_CZAS_PRACY_NOM, uftNumber, 0, omWymagane, True, '0.00', 'Czas pracy nominalny');
      AddI(sLWPRECEPPOZ_ID            , omNieWymagane, '', 'Pozycja receptury');
      AddI(sZLEZLECENIEPOZ_ID         , omNieWymagane, '', 'Pozycja zlecenia');
      AddI(sASOASORT_ID               , omNieWymagane, '', 'Asortyment');
      AddI(sUNIJEDNOSTKAORG_ID        , omNieWymagane, '', 'Jednostka organizacyjna');
      AddI(sKDOSOBA_ID                , omNieWymagane, '', 'Osoba');
      AddI(sUNIOKRES_ID               , omNieWymagane, '', 'okres');
      AddI(sSPCENNIK_ID               , omNieWymagane, '', 'Cennik');
      AddI(sKDSKLADNIKCZASU_ID        , omNieWymagane, '', 'Skadnik czasu pracy');
      AddI(sLWPRAPORTPRODTYP_ID       , omNieWymagane, '', 'Typ raportu produkcji');
      AddS(sZLECONST_RODZAJECP_ID     , 1, omWymagane, true, cZLERodzajECP_ProdukcjaID, 'Rodzaj ewidencji');
      Add( sZLEZASOBYPRACA_ZUZ_PALIWA , uftFloat, 0, omNieWymagane, False, '0.0', 'Zuycie paliwa');
      Add( sZLEZASOBYPRACA_STAWKA     , uftCounter, 0, omNieWymagane, False, '0.00', 'Stawka');
      AddS(sZLEZASOBYPRACA_UWAGI      , 255, omNieWymagane, True, '', 'Uwagi');
      AddI(sZLEZASOBYPRACA_EL_NAD_ID  , omNieWymagane, '', 'Element nadrzdny dla ECP zasobw');
      AddI(sZLEZASOBYPRACA_STANOWISKO_ID, omNieWymagane, '', 'Stanowisko ze sownika stanowisk');
      AddI(sZLEZASOBYPRACA_FORMECP_ID , omNieWymagane, '', 'Formatka osadzona na formatce ECP zasobw');
    end;
    with IndexDefs do begin
      Add('', sZLEZASOBYPRACA_ID, [ixPrimary]);
    end;
  end else if(TableName = sZLEBRAKI) then begin
    with FieldDefs do begin
      AddI(sZLEBRAKI_ID        , omWymagane, '', '* Specyfikacja sownika brakw');
      AddS(sZLEBRAKI_SYMBOL    , cZLEDlugoscPola_Symbol, omWymagane, True, '', 'Symbol braku');
      AddS(sZLEBRAKI_NAZWA     , cZLEDlugoscPola_Nazwa , omNieWymagane, True, '', 'Nazwa braku');
      AddI(sKDSKLADNIKCZASU_ID , omNieWymagane, '', 'Skadnik czasu pracy dla brakw');
    end;
    with IndexDefs do begin
      Add('', sZLEBRAKI_ID, [ixPrimary]);
    end;
  end else if(TableName = sZLEZASOBYBRAKI) then begin
    with FieldDefs do begin
      AddI(sZLEZASOBYBRAKI_ID        , omWymagane, '', '* Specyfikacja brakw dla RCP zasobu');
      Add(sZLEZASOBYBRAKI_IL         , uftNumber, 0, omWymagane, True, '', 'Ilo brakw');
      AddI(sZLEBRAKI_ID              , omWymagane, '', 'Braki');
      AddI(sZLEZASOBYPRACA_ID        , omWymagane, '', 'RCP zasobw');
      AddI(sKDOSOBA_ID               , omNieWymagane, '', 'Osoba');
    end;
    with IndexDefs do begin
      Add('', sZLEZASOBYBRAKI_ID, [ixPrimary]);
    end;
  end else if(TableName = sZLEOSOBY) then begin
    with FieldDefs do begin
      AddI(sZLEOSOBY_ID            , omWymagane, '', '* Specyfikacja osb pracujcych na zasobie');
      AddI(sKDOSOBA_ID             , omWymagane, '', 'Osoba');
      AddI(sZLEZASOBYPRACA_ID      , omWymagane, '', 'RCP zasobw');
    end;
    with IndexDefs do begin
      Add('', sZLEOSOBY_ID, [ixPrimary]);
    end;
  end else if(TableName = sZLEZLECENIEWYC) then begin
    with FieldDefs do begin
      AddI(sZLEZLECENIEWYC_ID     , omWymagane, '', '*Wycena kosztw pracy zasobw na zleceniu');
      AddI(sZLEZLECENIE_ID        , omWymagane, '', 'Zlecenie');
      AddI(sZLEZASOB_ID           , omWymagane, '', 'Zasb');
      AddI(sLWPRECEPPOZ_ID        , omWymagane, '', 'Pozycja receptury (faza produkcji)');
      Add( sZLEZLECENIEWYC_KOSZT  , uftCounter, 0, omNieWymagane, true, '', 'Koszt pracy zasobu');
      AddS(sZLEZLECENIEWYC_STATUS , 3, omWymagane, true, cZLEConstZleWycenaStatus_WprowadzonyID, 'Status rekordu');
    end;
    with IndexDefs do begin
      Add('', sZLEZLECENIEWYC_ID, [ixPrimary]);
    end;
  end else if(TableName = sZLEKRYTERIA) then begin
    with FieldDefs do begin
      AddI(sZLEKRYTERIA_ID        , omWymagane, '', '* Specyfikacja kryteriw');
      AddI(sUNIODDZIAL_ID         , omNieWymagane, '', 'Oddzia');
      AddS(sZLEKRYTERIA_SYMBOL    , cZLEDlugoscPola_Symbol, omWymagane, True, '', 'Symbol kryterium');
      AddS(sZLEKRYTERIA_NAZWA     , cZLEDlugoscPola_Nazwa , omNieWymagane, True, '', 'Nazwa kryterium');
      //Lista mnemonikw do budowy sownika
      AddS(sZLEKRYTERIA_SKLADNIKI , 80, omNieWymagane, True, '', 'Lista mnemonikw sownika');
      AddS(sZLEKRYTERIA_REGULA    , 250, omNieWymagane, True, '', 'Regua liczenia wartoci kryterium');
      AddS(sZLEKRYTERIA_OGRANICZ  , 250, omNieWymagane, True, '', 'Ograniczenia dodatkowe dla kryterium');
                                                         {Domyslny format 6,2}
      AddS(sZLEKRYTERIA_FORMAT    , 3, omWymagane, True, '6,2', 'Okrelenie iloci miejsc za i po przecinku.');
      //Mnemoniki XXA -- XYZ
      AddI(sZLETYPZLEC_ID         , omNieWymagane, '', 'Typ zlecenia');
      AddI(sFKMNEMONIKI_ID        , omNieWymagane, '', 'Mnemonik');
      AddS(sZLEKRYTERIA_OKRESOWE, 1, omWymagane, False, sTak, 'Czy okresowe');
      AddS(sINFCONST_OBIEKT_ID, 5, omNieWymagane, True, '', 'Poziom infrastruktury' );
      AddS(sZLEKRYTERIA_ISTN_MNEMONIK, 1, omWymagane, False, sNIE, 'Wykorzysta istniejcy mnemonik');
    end;
    with IndexDefs do begin
      Add('', sZLEKRYTERIA_ID, [ixPrimary]);
    end;
  end else if(TableName = sZLEKRYTPOZ) then begin
    with FieldDefs do begin
      AddI(sZLEKRYTPOZ_ID     , omWymagane, '', '* Specyfikacja pozycji kryterium');
      AddI(sZLEKRYTERIA_ID        , omWymagane, '', 'Kryterium');
      AddS(sZLEKRYTPOZ_SYMBOL , cZLEDlugoscPola_Symbol, omWymagane, True, '', 'Symbol poz. kryterium');
      Add( sZLEKRYTPOZ_WARTOSC, uftNumber, 0, omWymagane, False, '0.00', 'Warto');
      AddI(sUNIOKRES_ID           , omNieWymagane, '', 'Okres');
      AddI(sUNIROK_ID             , omNieWymagane, '', 'Rok');
    end;
    with IndexDefs do begin
      Add('', sZLEKRYTPOZ_ID, [ixPrimary]);
    end;
  end else if(TableName = sZLEKRYTERIAWAR) then begin
    with FieldDefs do begin
      AddI(sZLEKRYTERIAWAR_ID, omWymagane, '', '* Specyfikacja warunkw dla kryterium');
      AddI(sZLEKRYTERIA_ID       , omWymagane, '', 'Kryterium');
      AddI(sFKMNEMONIKI_ID       , omWymagane, '', 'Mnemonik');
      AddS(sZLEKRYTERIAWAR_LISTA_ID, 2000, omNieWymagane, True, '', 'Lista id do warunku');
    end;
    with IndexDefs do begin
      Add('', sZLEKRYTERIAWAR_ID, [ixPrimary]);
    end;
  end else if TableName = sZLEPREFIX then begin
    with FieldDefs do begin
      AddI( sZLEPREFIX_ID, omWymagane, '', '* Specyfikacja prefiksw');
      AddS( sZLEPREFIX_SYMBOL, 10, omWymagane, True, '', 'Symbol');
      AddS( sZLEPREFIX_NAZWA, 50, omNieWymagane, True, '', 'Nazwa');
      AddS( sZLEPREFIX_POLE1, 20,omNiewymagane, True, '', 'Pole1');
      AddS( sZLEPREFIX_POLE2, 20,omNiewymagane, True, '', 'Pole2');
      AddS( sZLEPREFIX_POLE3, 20,omNiewymagane, True, '', 'Pole3');
    end;
    with IndexDefs do begin
      Add( '', sZLEPREFIX_ID, [ixPrimary] );
    end;
  end else if(TableName = sZLEZLECENIEOBCY) then begin
    with FieldDefs do begin
      AddI(sZLEZLECENIEOBCY_ID  , omWymagane, '', '*Powizanie zlece z systemami obcymi');
      AddI(sZLEZLECENIE_ID      , omWymagane, '', 'Id zlecenia w systemie Unisoft');
      AddI(sLWPRECEPPOZ_ID      , omNieWymagane, '', 'Pozycja receptury w systemie Unisoft');
      AddS(sZLEZLECENIE_OBCY_ID , 21, omWymagane, false, '', 'Id zlecenia w systemie partnera');
      AddI(sLWPPLANPRODEL_ID    , omNieWymagane, '', 'Element planu produkcji w systemie Unisoft');
      AddI(sZLEZLECENIEOBCY_BLAD, omNieWymagane, '', 'Czy wystpiy bdy przy wysyaniu zlecenia. Puste oznacza brak bdw');
    end;
    with IndexDefs do begin
      Add('', sZLEZLECENIEOBCY_ID, [ixPrimary]);
    end;
  end else if(TableName = sZLEZASOBYPRACAMAGP) then begin
    with FieldDefs do begin
      AddI(sZLEZASOBYPRACAMAGP_ID , omWymagane, '', '*Powizanie pracy zasobw z dokumentami magazynowymi');
      AddI(sZLEZASOBYPRACA_ID     , omWymagane, '', 'Praca zasobu');
      AddI(sMAGOBRPOZ_ID          , omWymagane, '', 'Pozycja dokumentu magazynowego');
    end;
    with IndexDefs do begin
      Add('', sZLEZASOBYPRACAMAGP_ID, [ixPrimary]);
    end;
  end else if TableName = sZLEWSPNARZUTY then begin
    with FieldDefs do begin
      AddI( sZLEWSPNARZUTY_ID, omWymagane, '', '* Specyfikacja wspczynnikw narzutw');
      //Oddzia jest wypeniany w wersji wielofirmowej lub wieloodziaowej z wymaganym oddziaem
      AddI(sUNIODDZIAL_ID         , omNieWymagane, '', 'Oddzia');
      AddI(sUNIJEDNOSTKAORG_ID    , omNieWymagane, '', 'Jednostka organizacyjna');
      AddI(sZLETYPZLEC_ID         , omNieWymagane, '', 'Typ zlecenia');
      AddI(sUNIOKRES_ID           , omNieWymagane, '', 'Okres');
      //Rok moe si przyda przy ewidencjach rocznych
      AddI(sUNIROK_ID             , omNieWymagane, '', 'Rok');
      Add(sZLEWSPNARZUTY_ROB, uftNumber, 0, omWymagane, True, '0.0', 'Wspczynnik narzutu robocizny');
      Add(sZLEWSPNARZUTY_MAT, uftNumber, 0, omWymagane, True, '0.0', 'Wspczynnik narzutu materiaw');
    end;
    with IndexDefs do begin
      Add( '', sZLEWSPNARZUTY_ID, [ixPrimary] );
      {Add( c_UNK+'1', sUNIODDZIAL_ID+','+sUNIJEDNOSTKAORG_ID+','+sZLETYPZLEC_ID+','+sUNIOKRES_ID+','+sUNIROK_ID, [ixUnique] );}
    end;
  end else if TableName = sZLESKLADNIKIECPDEF then begin
    with FieldDefs do begin
      AddI(sZLESKLADNIKIECPDEF_ID, omWymagane, '', '* Specyfikacja listy skadnikw czasu');
      AddI(sKDSKLADNIKCZASU_ID, omWymagane, '', 'Skadnik czasu pracy');
    end;
    with IndexDefs do begin
      Add('', sZLESKLADNIKIECPDEF_ID, [ixPrimary]);
      Add( c_UNK+'1', sKDSKLADNIKCZASU_ID, [ixUnique] );
    end;
  end else if TableName = sZLEZASOBYPRACARAP then begin
    with FieldDefs do begin
      AddI(sZLEZASOBYPRACARAP_ID, omWymagane, '', '* Specyfikacja listy bdw komunikacji z ECP');
      AddI(sZLEZASOBYPRACA_ID, omWymagane, '', 'Ewidencja czasu pracy zlecen');
      AddI(sSMUSER_ID, omWymagane, '', 'Uytkownik');
      AddS(sZLECONST_ZASOBYPRACARAPST_ID , 1, omWymagane, true, cZLEConstZasobyPracaRapStatus_ZgodnyID, 'Status rekordu');
      AddI(sZLEZASOBYPRACARAP_BLAD_ID, omNieWymagane, '', 'Kod bdu');
      AddS(sZLEZASOBYPRACARAP_KOMUNIKAT , 4000, omNieWymagane, True, '', 'Komunikat bdu');
    end;
    with IndexDefs do begin
      Add('', sZLEZASOBYPRACARAP_ID, [ixPrimary]);
    end;
  end else if TableName = sZLERAPORTEDIT then begin
    with FieldDefs do begin
      AddI(sZLERAPORTEDIT_ID, omWymagane, '', '* Specyfikacja komunikatw dla raportw');
      AddI(sUNIREP_ID, omWymagane, '', 'Ewidencja czasu pracy zlecen');
      AddS(sZLERAPORTEDIT_KOMUNIKAT , 255, omNieWymagane, True, '', 'Komunikat bdu');
    end;
    with IndexDefs do begin
      Add('', sZLERAPORTEDIT_ID, [ixPrimary]);
    end;
  end else if(TableName = sZLETYPZLECUSERS) then begin
    with FieldDefs do begin
      AddI(sZLETYPZLECUSERS_ID  , omWymagane, '', '* Specyfikacja osb uprawnionych do typu zlecenia');
      AddI(sZLETYPZLEC_ID       , omWymagane, '', 'Typ zlecenia');
      AddI(sSMUSER_ID           , omWymagane, '', 'Uytkownika');
    end;
    with IndexDefs do begin
      Add('', sZLETYPZLECUSERS_ID, [ixPrimary]);
      Add(c_UNK+'1', sZLETYPZLEC_ID+','+sSMUSER_ID, [ixUnique]);
    end;
  end;

  //definicje pol technicznych
  pola_techniczne(TableName, FieldDefs);
end;

procedure TZLEDataManager.DajDefinicjeConstraints(TableName: string;
  ConstraintDefs: TUNIConstraintDefs);
begin
  //przeniesione do UNISysDM
  //sZLEZLECENIE
  //sZLETYPZLEC
  //
  if TableName = sZLEZLECENIEPOZ then begin
    with ConstraintDefs do begin
      if not DataManagers.Doinstalowanie then begin
        AddForeign( TableName+c_FRK+'1', sZLEZLECENIE_ID, sZLEZLECENIE, sZLEZLECENIE_ID, aodfkCascade);
      end;
      if DataManagers.Available(sASOModulID) then begin
        AddForeign( TableName+c_FRK+'2', sASOASORT_ID, sASOASORT, sASOASORT_ID, aodfkRestrict);
      end;
      if DataManagers.Available(sBOKModulID) then begin
        AddForeign( TableName+c_FRK+'3', sBOKSPRAWA_ID, sBOKSPRAWA, sBOKSPRAWA_ID, aodfkRestrict);
      end;
      AddForeign( TableName+c_FRK+'4', sLFKWZORDEKR_ID, sLFKWZORDEKR, sLFKWZORDEKR_ID, aodfkRestrict);
    end;
  end else if TableName = sZLEWART then begin
    with ConstraintDefs do begin
      AddForeign( TableName+c_FRK+'1', sZLEZLECENIE_ID, sZLEZLECENIE, sZLEZLECENIE_ID, aodfkCascade);
      AddForeign( TableName+c_FRK+'2', sUNIOKRES_ID, sUNIOKRES, sUNIOKRES_ID, aodfkRestrict);
      AddForeign( TableName+c_FRK+'3', sZLESKLADWART_ID, sZLESKLADWART, sZLESKLADWART_ID, aodfkRestrict);
      AddForeign( TableName+c_FRK+'4', sZLEWART_BLAD, sZLECONST_PARSERBLAD, sZLECONST_PARSERBLAD + '_ID', aodfkRestrict);
    end;
  end else if TableName = sZLEIL then begin
    with ConstraintDefs do begin
      AddForeign( TableName+c_FRK+'1', sZLEZLECENIEPOZ_ID, sZLEZLECENIEPOZ, sZLEZLECENIEPOZ_ID, aodfkCascade);
      AddForeign( TableName+c_FRK+'2', sUNIOKRES_ID, sUNIOKRES, sUNIOKRES_ID, aodfkRestrict);
      AddForeign( TableName+c_FRK+'3', sZLESKLADIL_ID, sZLESKLADIL, sZLESKLADIL_ID, aodfkRestrict);
      AddForeign( TableName+c_FRK+'4', sZLEIL_BLAD, sZLECONST_PARSERBLAD, sZLECONST_PARSERBLAD + '_ID', aodfkRestrict);
    end;
  end else if TableName = sZLETYPSKLADW then begin
    with ConstraintDefs do begin
      AddForeign( TableName+c_FRK+'1', sZLETYPZLEC_ID, sZLETYPZLEC, sZLETYPZLEC_ID, aodfkCascade);
      AddForeign( TableName+c_FRK+'2', sZLESKLADWART_ID, sZLESKLADWART, sZLESKLADWART_ID, aodfkRestrict);
    end;
  end else if TableName = sZLESKLADWART then begin
    with ConstraintDefs do begin
      if vWieloodzialowosc or vWielofirmowosc then
        AddForeign( TableName+c_FRK+'1', sUNIODDZIAL_ID, sUNIODDZIAL, sUNIODDZIAL_ID, aodfkRestrict);
      AddForeign( TableName+c_FRK+'2', sZLESKLADWART_RODZAJ, sZLECONST_SKLADNIK, sZLECONST_SKLADNIK_ID, aodfkRestrict);
      AddForeign( TableName+c_FRK+'3', sZLESKLADWART_SYMULACJA, sUNICONST_ALTERNATYWA, sUNICONST_ALTERNATYWA_ID, aodfkRestrict );
    end;
  end else if TableName = sZLETYPSKLADIL then begin
    with ConstraintDefs do begin
      AddForeign( TableName+c_FRK+'1', sZLETYPZLEC_ID, sZLETYPZLEC, sZLETYPZLEC_ID, aodfkCascade);
      AddForeign( TableName+c_FRK+'2', sZLESKLADIL_ID, sZLESKLADIL, sZLESKLADIL_ID, aodfkRestrict);
    end;
  end else if TableName = sZLESKLADIL then begin
    with ConstraintDefs do begin
      if vWieloodzialowosc or vWielofirmowosc then
        AddForeign( TableName+c_FRK+'1', sUNIODDZIAL_ID, sUNIODDZIAL, sUNIODDZIAL_ID, aodfkRestrict);
      AddForeign( TableName+c_FRK+'2', sZLESKLADIL_RODZAJ, sZLECONST_SKLADNIK, sZLECONST_SKLADNIK_ID, aodfkRestrict);
      AddForeign( TableName+c_FRK+'3', sZLESKLADIL_NIEOKRESOWY, sUNICONST_ALTERNATYWA, sUNICONST_ALTERNATYWA_ID, aodfkRestrict );
    end;
  (*********************** WIDOK ***********************
  end else if TableName = sZLEOSOBYGODZ then begin
    with ConstraintDefs do begin
      AddForeign(TableName+c_FRK+'1', sZLEZLECENIE_ID, sZLEZLECENIE, sZLEZLECENIE_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'2', sASOASORT_ID, sASOASORT, sASOASORT_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'3', sSPCENNIK_ID, sSPCENNIK, sSPCENNIK_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'4', sUNIOKRES_ID, sUNIOKRES, sUNIOKRES_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'5', sKDOSOBA_ID,  sKDOSOBA, sKDOSOBA_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'6', sZLEZASOB_ID, sZLEZASOB, sZLEZASOB_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'7', sZLEOSOBY_ID, sZLEOSOBY, sZLEOSOBY_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'8', sZLEZLECENIEPOZ_ID, sZLEZLECENIEPOZ, sZLEZLECENIEPOZ_ID, aodfkRestrict);
    end;
  ************************* WIDOK ***********************)
  end else if TableName = sZLEZASOB then begin
    with ConstraintDefs do begin
      AddForeign(TableName+c_FRK+'1', sZLEZASOB_RODZAJ, sZLECONST_RODZAJZASOBU, sZLECONST_RODZAJZASOBU_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'2', sKDOSOBA_ID, sKDOSOBA, sKDOSOBA_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'3', sUNIJEDNOSTKAORG_ID, sUNIJEDNOSTKAORG, sUNIJEDNOSTKAORG_ID, aodfkRestrict);
      if(DataManagers.Available(sLWPModulID)) then
        AddForeign(TableName+c_FRK+'4', sLWPJEDNCZAS_ID, sLWPJEDNCZAS, sLWPJEDNCZAS_ID, aodfkRestrict);
      AddForeign(TableName + c_FRK + '5', sKDGRUPAKAL_ID, sKDGRUPAKAL, sKDGRUPAKAL_ID, aodfkRestrict);
      AddForeign(TableName + c_FRK + '6', sUNIAUTNUM_ID, sUNIAUTNUM, sUNIAUTNUM_ID, aodfkRestrict);
    end;
  end else if TableName = sZLEZLECENIEZASOB then begin
    with ConstraintDefs do begin
      AddForeign(TableName+c_FRK+'1', sZLEZLECENIE_ID, sZLEZLECENIE, sZLEZLECENIE_ID, aodfkCascade);
      AddForeign(TableName+c_FRK+'2', sZLEZASOB_ID, sZLEZASOB, sZLEZASOB_ID, aodfkRestrict);
      if(DataManagers.Available(sLWPModulID)) then begin
        AddForeign(TableName+c_FRK+'3', sLWPRECEPPOZZASOB_ID, sLWPRECEPPOZZASOB , sLWPRECEPPOZZASOB_ID, aodfkRestrict);
        AddForeign(TableName+c_FRK+'4', sLWPJEDNCZAS_ID     , sLWPJEDNCZAS      , sLWPJEDNCZAS_ID, aodfkRestrict);
        AddForeign(TableName+c_FRK+'5', sZLEZLECENIEZASOB_WYDJED, sLWPJEDNCZAS      , sLWPJEDNCZAS_ID, aodfkRestrict);
      end;
    end;
  (******************** WIDOK ***********************
  end else if TableName = sZLEZLECENIEROZL then begin
    with ConstraintDefs do begin
      AddForeign( TableName+c_FRK+'1', sZLEZLECENIEPOZ_ID, sZLEZLECENIEPOZ, sZLEZLECENIEPOZ_ID, aodfkCascade);
      AddForeign( TableName+c_FRK+'2', sZLEZASOB_ID, sZLEZASOB, sZLEZASOB_ID, aodfkRestrict );
      AddCheck( TableName+c_CNT+'1', sZLEZLECENIEROZL_GODZINY+'>=0.0' );
      AddCheck( TableName+c_CNT+'2', sZLEZLECENIEROZL_STAWKA+'>=0.00' );
    end;
  ********************* WIDOK ***********************)
  (*************************** POLA UZ ************************
  end else if TableName = sZLEPOLAZMDEF then begin
      {sZLEPOLAZMDEF}
    with ConstraintDefs do begin
      AddForeign(TableName + c_FRK+'1', sFKMNEMONIKI_ID, sFKMNEMONIKI, sFKMNEMONIKI_ID, aodfkRestrict);
      AddForeign(TableName + c_FRK+'2', sUNICONSTDEF_ID, sUNICONSTDEF, sUNICONSTDEF_ID, aodfkRestrict);
      AddForeign(TableName + c_FRK+'3', sZLEPOLAZMDEF_TYPDANYCH, sMAGCONST_TYPDANYCH, sMAGCONST_TYPDANYCH_ID, aodfkRestrict);
    end;
  end else if TableName = sZLEPOLAZMWSK then begin
      {sZLEPOLAZMWSK}
    with ConstraintDefs do begin
      AddForeign( TableName + c_FRK+'1', sZLEPOLAZMDEF_ID, sZLEPOLAZMDEF, sZLEPOLAZMDEF_ID, aodfkRestrict);
      AddForeign( TableName + c_FRK+'2', sZLETYPZLEC_ID,  sZLETYPZLEC,  sZLETYPZLEC_ID, aodfkRestrict);
    end;
  end else if TableName = sZLEPOLAZM then begin
      {sZLEPOLAZM}
    with ConstraintDefs do begin
//      AddForeign( TableName + c_FRK+'1', sZLEZLECENIE_ID, sZLEZLECENIE, sZLEZLECENIE_ID, aodfkCascade);
      AddForeign( TableName + c_FRK+'2', sZLEPOLAZMDEF_ID, sZLEPOLAZMDEF, sZLEPOLAZMDEF_ID, aodfkRestrict);
      AddForeign( TableName + c_FRK+'3', sFKUZ_ID, sFKUZ, sFKUZ_ID, aodfkRestrict);
    end;
  *************************** POLA UZ ************************)
  end else if TableName = sZLEPLROZDEF then begin
      {sZLEPLROZDEF}
    with ConstraintDefs do begin
      if DataManagers.Available(sPLLIModulID) then
         AddForeign( TableName + c_FRK+'1', sPLROZDEF_ID, sPLROZDEF, sPLROZDEF_ID, aodfkRestrict);
    end;
  end else if(TableName = sZLEZLECENIEMAT) then begin
    with ConstraintDefs do begin
      AddForeign(TableName+c_FRK+'1', sZLEZLECENIE_ID, sZLEZLECENIE, sZLEZLECENIE_ID, aodfkCascade);
      if(DataManagers.Available(sLWPModulID)) then
        AddForeign(TableName+c_FRK+'2', sLWPRECEPPOZMATERIAL_ID , sLWPRECEPPOZMATERIAL, sLWPRECEPPOZMATERIAL_ID , aodfkRestrict);
      if DataManagers.Available(sASOModulID) then begin
        AddForeign(TableName+c_FRK+'3', sASOASORT_ID, sASOASORT, sASOASORT_ID, aodfkRestrict);
        AddForeign(TableName+c_FRK+'4', sASOASORTKMAT_ID, sASOASORTKMAT, sASOASORTKMAT_ID, aodfkRestrict);
      end;
      if(DataManagers.Available(sLWPModulID)) then begin
        AddForeign(TableName+c_FRK+'5', sLWPRECEPPOZOPER_ID     , sLWPRECEPPOZOPER    , sLWPRECEPPOZOPER_ID     , aodfkRestrict);
        AddForeign(TableName+c_FRK+'6', sLWPRECEPPOZOPERZAM_ID  , sLWPRECEPPOZOPERZAM , sLWPRECEPPOZOPERZAM_ID  , aodfkRestrict);
      end;
    end;
  end else if(TableName = sZLEZASOBYBRAKI) then begin
    with ConstraintDefs do begin
      AddForeign(TableName+c_FRK+'1', sZLEBRAKI_ID, sZLEBRAKI, sZLEBRAKI_ID, aodfkCascade);
      AddForeign(TableName+c_FRK+'2', sZLEZASOBYPRACA_ID, sZLEZASOBYPRACA, sZLEZASOBYPRACA_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'3', sKDOSOBA_ID, sKDOSOBA, sKDOSOBA_ID, aodfkRestrict);
    end;
  end else if(TableName = sZLEBRAKI) then begin
    with ConstraintDefs do begin
      if(DataManagers.Available(sKDPRAModulID)) then
        AddForeign(TableName+c_FRK+'1', sKDSKLADNIKCZASU_ID, sKDSKLADNIKCZASU, sKDSKLADNIKCZASU_ID, aodfkRestrict);
    end;
  end else if(TableName = sZLEZASOBYPRACA) then begin
    with ConstraintDefs do begin
      AddForeign(TableName+c_FRK+'1', sZLEZLECENIE_ID,   sZLEZLECENIE,   sZLEZLECENIE_ID,   aodfkCascade);
      AddForeign(TableName+c_FRK+'2', sZLEZASOB_ID,      sZLEZASOB,      sZLEZASOB_ID,      aodfkRestrict);
      if(DataManagers.Available(sLWPModulID)) then begin
        AddForeign(TableName+c_FRK+'3', sLWPPLANPRODEL_ID, sLWPPLANPRODEL, sLWPPLANPRODEL_ID, aodfkRestrict);
        AddForeign(TableName+c_FRK+'4', sLWPRECEPPOZ_ID,   sLWPRECEPPOZ, sLWPRECEPPOZ_ID, aodfkRestrict);
      end;

      AddForeign(TableName+c_FRK+'5', sZLEZLECENIEPOZ_ID, sZLEZLECENIEPOZ, sZLEZLECENIEPOZ_ID, aodfkRestrict);
      if(DataManagers.Available(sASOModulID)) then
         AddForeign(TableName+c_FRK+'6', sASOASORT_ID, sASOASORT, sASOASORT_ID, aodfkRestrict);

      if(DataManagers.Available(sSPModulID)) then
        AddForeign(TableName+c_FRK+'7', sSPCENNIK_ID, sSPCENNIK, sSPCENNIK_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'8', sUNIOKRES_ID, sUNIOKRES, sUNIOKRES_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'9', sKDOSOBA_ID,  sKDOSOBA, sKDOSOBA_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'10',sZLECONST_RODZAJECP_ID, sZLECONST_RODZAJECP, sZLECONST_RODZAJECP_ID, aodfkRestrict);
      if(DataManagers.Available(sLWPModulID)) then
        AddForeign(TableName+c_FRK+'11', sLWPRAPORTPRODTYP_ID, sLWPRAPORTPRODTYP, sLWPRAPORTPRODTYP_ID, aodfkRestrict);
      if(DataManagers.Available(sKDPRAModulID)) then
        AddForeign(TableName+c_FRK+'12', sKDSKLADNIKCZASU_ID, sKDSKLADNIKCZASU, sKDSKLADNIKCZASU_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'13', sZLEZASOBYPRACA_EL_NAD_ID, sZLEZASOBYPRACA, sZLEZASOBYPRACA_ID, aodfkRestrict);
    end;
  end else if(TableName = sZLEOSOBY) then begin
    with ConstraintDefs do begin
      AddForeign(TableName+c_FRK+'1', sKDOSOBA_ID,  sKDOSOBA, sKDOSOBA_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'2', sZLEZASOBYPRACA_ID, sZLEZASOBYPRACA, sZLEZASOBYPRACA_ID, aodfkRestrict);
    end;
  end else if(TableName = sZLEZLECENIEWYC) then begin
    with ConstraintDefs do begin
      AddForeign(TableName+c_FRK+'1', sZLEZLECENIE_ID ,  sZLEZLECENIE , sZLEZLECENIE_ID , aodfkRestrict);
      AddForeign(TableName+c_FRK+'2', sZLEZASOB_ID    ,  sZLEZASOB    , sZLEZASOB_ID    , aodfkRestrict);
      if(DataManagers.Available(sLWPModulID)) then
        AddForeign(TableName+c_FRK+'3', sLWPRECEPPOZ_ID ,  sLWPRECEPPOZ , sLWPRECEPPOZ_ID , aodfkRestrict);
    end;
  end else if(TableName = sZLEKRYTERIA) then begin
    with ConstraintDefs do begin
      if vWieloodzialowosc or vWielofirmowosc then
        AddForeign( TableName+c_FRK+'1', sUNIODDZIAL_ID, sUNIODDZIAL, sUNIODDZIAL_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'2', sZLETYPZLEC_ID   ,  sZLETYPZLEC,sZLETYPZLEC_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'3', sFKMNEMONIKI_ID ,  sFKMNEMONIKI , sFKMNEMONIKI_ID , aodfkRestrict);
      if(DataManagers.Available(sINFModulID)) then
         AddForeign(TableName+c_FRK+'4', sINFCONST_OBIEKT_ID,  sINFCONST_OBIEKT, sINFCONST_OBIEKT_ID, aodfkRestrict);
    end;
  end else if(TableName = sZLEKRYTPOZ) then begin
    with ConstraintDefs do begin
      AddForeign(TableName+c_FRK+'1', sZLEKRYTERIA_ID,  sZLEKRYTERIA, sZLEKRYTERIA_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'2', sUNIOKRES_ID, sUNIOKRES, sUNIOKRES_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'3', sUNIROK_ID  ,  sUNIROK,  sUNIROK_ID, aodfkRestrict);
    end;
  end else if(TableName = sZLEKRYTERIAWAR) then begin
    with ConstraintDefs do begin
      AddForeign(TableName+c_FRK+'1', sZLEKRYTERIA_ID,  sZLEKRYTERIA, sZLEKRYTERIA_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'2', sFKMNEMONIKI_ID ,  sFKMNEMONIKI , sFKMNEMONIKI_ID , aodfkRestrict);
    end;
  end else if(TableName = sZLEZLECENIEOBCY) then begin
    with ConstraintDefs do begin
      AddForeign(TableName+c_FRK+'1', sZLEZLECENIE_ID,  sZLEZLECENIE, sZLEZLECENIE_ID, aodfkRestrict);
      if(DataManagers.Available(sLWPModulID)) then begin
        AddForeign(TableName+c_FRK+'2', sLWPRECEPPOZ_ID,  sLWPRECEPPOZ, sLWPRECEPPOZ_ID, aodfkRestrict);
        AddForeign(TableName+c_FRK+'3', sLWPPLANPRODEL_ID, sLWPPLANPRODEL, sLWPPLANPRODEL_ID, aodfkRestrict);
      end;
    end;
  end else if(TableName = sZLEZASOBYPRACAMAGP) then begin
    with ConstraintDefs do begin
      AddForeign(TableName+c_FRK+'1', sZLEZASOBYPRACA_ID, sZLEZASOBYPRACA, sZLEZASOBYPRACA_ID, aodfkCascade);
      if(DataManagers.Available(sMAGModulID)) then
        AddForeign(TableName+c_FRK+'2', sMAGOBRPOZ_ID, sMAG_OBRPOZ, sMAGOBRPOZ_ID, aodfkRestrict);
    end;
  end else if(TableName = sZLEWSPNARZUTY) then begin
    with ConstraintDefs do begin
      if vWieloodzialowosc or vWielofirmowosc then
        AddForeign( TableName+c_FRK+'1', sUNIODDZIAL_ID, sUNIODDZIAL, sUNIODDZIAL_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'2', sZLETYPZLEC_ID,      sZLETYPZLEC,      sZLETYPZLEC_ID,      aodfkRestrict);
      AddForeign(TableName+c_FRK+'3', sUNIJEDNOSTKAORG_ID, sUNIJEDNOSTKAORG, sUNIJEDNOSTKAORG_ID, aodfkRestrict);
      AddForeign(TableName+c_FRK+'4', sUNIOKRES_ID,        sUNIOKRES,        sUNIOKRES_ID,        aodfkRestrict);
      AddForeign(TableName+c_FRK+'5', sUNIROK_ID,          sUNIROK,          sUNIROK_ID,          aodfkRestrict);
    end;
  end else if TableName = sZLESKLADNIKIECPDEF then begin
    with ConstraintDefs do begin
      if DataManagers.Available(sKDPRAModulID) then
         AddForeign( TableName + c_FRK+'1', sKDSKLADNIKCZASU_ID, sKDSKLADNIKCZASU, sKDSKLADNIKCZASU_ID, aodfkRestrict);
    end;
  end else if TableName = sZLEZASOBYPRACARAP then begin
    with ConstraintDefs do begin
       AddForeign( TableName + c_FRK + '1', sZLEZASOBYPRACA_ID, sZLEZASOBYPRACA, sZLEZASOBYPRACA_ID, aodfkRestrict);
       AddForeign( TableName + c_FRK + '2', sSMUSER_ID, sSMUSER, sSMUSER_ID, aodfkRestrict);
       AddForeign( TableName + c_FRK + '3', sZLECONST_ZASOBYPRACARAPST_ID, sZLECONST_ZASOBYPRACARAPST, sZLECONST_ZASOBYPRACARAPST_ID, aodfkRestrict);
    end;
  end else if TableName = sZLERAPORTEDIT then begin
    {with ConstraintDefs do begin
       AddForeign( TableName + c_FRK + '1', sUNIREP_ID, sUNIREP, sUNIREP_ID, aodfkRestrict);
    end;}
  end else if TableName = sZLETYPZLECUSERS then begin
    with ConstraintDefs do begin
       AddForeign( TableName + c_FRK + '1', sZLETYPZLEC_ID, sZLETYPZLEC, sZLETYPZLEC_ID, aodfkRestrict);
       AddForeign( TableName + c_FRK + '2', sSMUSER_ID, sSMUSER, sSMUSER_ID, aodfkRestrict);
    end;
  end;
end;

procedure TZLEDataManager.Init;
begin
  inherited;
  OdczytajParametry();
  //PrzeliczanieTimer := TTimer.Create(Self);
  //ga testy widoczna tylko dla administratora
  Testy1.Visible := SecurityManager.UserAdmin;
  RejestracjaczasupracyMenuItem.Enabled := vZLEKosztyRobociznyWlaczone;
  //NarzutyMenuItem.Enabled := vZLENarzuty;

  {Inicjacja ZLE_package}
  try
    SQLManager.OpenQueryWithresult('SELECT ' + SQLManager.GetSPName(sZLE_PACKAGE) +'.INIT FROM dual');
  except
    {Pewnie nie ma jeszcze INIT w package, wic bd ignorujemy}
  end;

  {$ifdef build_zle}
  FPrzeliczoneKoszty := TZLEPrzeliczoneLista.Create();
  FPrzeliczoneIlosci := TZLEPrzeliczoneLista.Create();
  {$endif}

  PasteReportMenu(RaportyMenuItem);
  //SetMainMenuByParameters;

  FHtmlHelpFile := cZLEHelpFile;
end;

procedure TZLEDataManager.SetUserRights;
begin
  with SecurityManager do begin
    UstawieniaMenuItem.Enabled := SM_UserCanDo(sZLE_USTAW);
      ParametryMenuItem.Enabled := SM_UserCanDo(sZLE_USTAW_PARAM);
      DefinicjeMenuItem.Enabled := SM_UserCanDo(sZLE_USTAW_DEF);
        SkladnikiKontroliWartosciowejMenuItem.Enabled := DefinicjeMenuItem.Enabled and SM_UserCanDo(sZLE_USTAW_DEF_SKL_KONTR_WART);
        SkladnikiKontroliIlosciowejMenuItem.Enabled := DefinicjeMenuItem.Enabled and SM_UserCanDo(sZLE_USTAW_DEF_SKL_KONTR_IL);
        TypZlecenMenuItem.Enabled := DefinicjeMenuItem.Enabled and SM_UserCanDo(sZLE_USTAW_DEF_TYP_ZLEC);
        NumeratorySymboliZlecenMenuItem.Enabled := DefinicjeMenuItem.Enabled and SM_UserCanDo(sZLE_USTAW_DEF_NUM_ZLEC);
        NumeratoryZasobowMenuItem.Enabled := DefinicjeMenuItem.Enabled and SM_UserCanDo(sZLE_USTAW_DEF_NUM_ZASOBOW);
        KryteriaMenuItem.Enabled := DefinicjeMenuItem.Enabled and SM_UserCanDo(sZLE_USTAW_KRYTERIA);
        NarzutyMenuItem.Enabled := DefinicjeMenuItem.Enabled and SM_UserCanDo(sZLE_USTAW_DEF_NARZUTY);
        PolaUZGrupaMenuItem.Enabled := DefinicjeMenuItem.Enabled and SM_UserCanDo(sZLE_USTAW_DEF_POLAUZ);
          PolazleceniaMenuItem.Enabled := PolaUZGrupaMenuItem.Enabled;
          PolapozycjiMenuItem.Enabled := PolaUZGrupaMenuItem.Enabled;
      SlownikiMenuItem.Enabled := SM_UserCanDo(sZLE_USTAW_SLOW);
        ZasobyMenuItem.Enabled := SlownikiMenuItem.Enabled and SM_UserCanDo(sZLE_USTAW_SLOW_ZASOBY);
        ZLEBrakiMenuItem.Enabled := SlownikiMenuItem.Enabled and SM_UserCanDo(sZLE_USTAW_SLOW_BRAKI);
        PrefiksMenuItem.Enabled := SlownikiMenuItem.Enabled and SM_UserCanDo(sZLE_USTAW_SLOW_PREFIX);
        GrupyKalendarzoweMenuItem.Enabled := SlownikiMenuItem.Enabled and SM_UserCanDo(sZLE_USTAW_SLOW_GRUPYKALEND);
        SystemyZmianoweMenuItem.Enabled := SlownikiMenuItem.Enabled and SM_UserCanDo(sZLE_USTAW_SLOW_SYSTEMYZMIANOWE);
        KalendarzMenuItem.Enabled := SlownikiMenuItem.Enabled and SM_UserCanDo(sZLE_USTAW_SLOW_KALENDARZ);

    KartotekaZlecenMenuItem.Enabled := SM_UserCanDo(sZLE_KART_ZLECEN) or SM_UserCanDo(sZLE_KART_ZLECEN_UPR);

    //Chwilowo jedno uprawnienei do wszystkich funkcjonalnosci sZLE_REJ_CZASU_PRACY
    RejestracjaPracyMenuItem.Enabled := SM_UserCanDo(sZLE_REJ_CZASU_PRACY);
      RejestracjaczasupracyMenuItem.Enabled := SM_UserCanDo(sZLE_REJ_CZASU_PRACY);
      PracaZasobowMenuItem.Enabled := SM_UserCanDo(sZLE_REJ_CZASU_PRACY);

    AnalizaZlecenMenuItem.Enabled := SM_UserCanDo(sZLE_ANALIZY) and DataManagers.Available(sASOModulID); //Na razie blokujemy dostep do funkcji gdy brak ASO
      AnalizaRozliczenieZasobowMenuItem.Enabled := AnalizaZlecenMenuItem.Enabled and SM_UserCanDo(sZLE_ANALIZY_ROZL_ZASOBOW);
      LWPRealizacjaZlecenMenuItem.Visible := DataManagers.Available(sLWPModulID);
      LWPRealizacjaZlecenMenuItem.Enabled := AnalizaZlecenMenuItem.Enabled and SM_UserCanDo(sZLE_STOPIEN_REALIZACJI_ZLECEN);

    ParametryPracyMenuItem.Enabled := SM_UserCanDo(sZLE_PARAM);
  end;
end;

procedure TZLEDataManager.SkladnikiKontroliWartosciowejMenuItemClick(
  Sender: TObject);
var oParams: TKeyValues;
begin
  inherited;
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add(cFORM_CAPTION+'='+'Skadniki kontroli wartociowej');
  end;
  FormManager.OpenDBGrid( Self, cKlasaSkladnikWartosciowy+cSuffixKlasyDBGrid,
                          omList, oParams );
end;

procedure TZLEDataManager.SkladnikiKontroliIlosciowejMenuItemClick(
  Sender: TObject);
var oParams: TKeyValues;
begin
  inherited;
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add(cFORM_CAPTION+'='+'Skadniki kontroli ilociowej');
  end;
  FormManager.OpenDBGrid( Self, cKlasaSkladnikIlosciowy+cSuffixKlasyDBGrid,
                          omList, oParams );
end;

procedure TZLEDataManager.TypZlecenMenuItemClick(Sender: TObject);
var oParams: TKeyValues;
begin
  inherited;
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add(cFORM_CAPTION+'='+'Typ zlecenia');
    Add(sUNIMODULZSI_ID+'='+IntToStr(cZLEModulZSI_ID));
  end;
  FormManager.OpenDBGrid( Self, cKlasaTypZlecenia+cSuffixKlasyDBGrid, omList, oParams );
end;

procedure TZLEDataManager.Createtables1Click(Sender: TObject);
var oSplit: TSplit;
    iIndex: Integer;
begin
  inherited;
  oSplit := nil;
  try
    oSplit := TSplit.Create(Self.DajNazwyTablic(), ';','');
    for iIndex := 0 to oSplit.Count-1 do begin
      try
        SQLManager.ZalozTabliceZDataManagera( Self.Name, oSplit[iIndex], oSplit[iIndex] );
      except
        on E:Exception do begin
          if Komunikat( cError, 'Bd podczas zakadania tabeli '+oSplit[iIndex]+#13#10+E.Message+
                        #13#10+'Kontynuowa?', MB_YESNO ) = IDNO then
            raise;
        end;
      end;
    end;
  finally
    if oSplit <> nil then oSplit.Free;
  end;
end;

procedure TZLEDataManager.Createconstraints1Click(Sender: TObject);
var oSplit: TSplit;
    iIndex: Integer;
begin
  inherited;
  oSplit := nil;
  try
    oSplit := TSplit.Create(Self.DajNazwyTablic(), ';','');
    for iIndex := 0 to oSplit.Count-1 do begin
      try
        SQLManager.ZalozNaTabliceConstaintsZDataManagera( Self.Name, oSplit[iIndex] );
      except
        on E:Exception do begin
          if Komunikat( cError, 'Bd podczas zakadania constriants dla '+oSplit[iIndex]+#13#10+E.Message+
                        #13#10+'Kontynuowa?', MB_YESNO ) = IDNO then
            raise;
        end;
      end;
    end;
  finally
    if oSplit <> nil then oSplit.Free;
  end;
end;

procedure TZLEDataManager.OdczytajParametry;
begin
  with UNISysDM do begin
    vZLEDomyslnyStatusZlecenia := GetSystemIniString( vAktywnaFirma, sZLEModulID, '',
                                                      sINIZLEDomyslnyStatusZlecenia,
                                                      cZLEStatusZlecenia_OczekujaceID );
    vZLEDomyslnyTypZlecenia := GetUserIniInteger( vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                                                    sINIZLEDomyslnyTypZlecenia, -1 );
    vZLEInstalacjeTypZlec := GetSystemIniInteger( vAktywnaFirma, sZLEModulID, '',
                                                    sINIZLEInstalacjeTypZlec, -1 );
    vZLEWymaganaOsobaZamykajacaZlecenie := GetSystemIniBoolean( vAktywnaFirma, sZLEModulID, '',
                                                                sINIZLEWymaganaOsobaZamykajacaZlecenie, False );
    vZLEAsoReg_ID := GetSystemIniInteger( vAktywnaFirma, sZLEModulID, '',
                                          sINIZLEAsoReg_ID, -1 );
    vZLEPozycjeWlaczone := GetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId,
                                              sZLEModulID, '', sINIZLEPozycjeWlaczone, True );
    vZLEKontrolaKosztowWlaczona := GetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId,
                                                      sZLEModulID, '', sINIZLEKontrolaKosztowWlaczona, True );
    vZLEKontrolaIlosciWlaczona := GetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId,
                                                     sZLEModulID, '', sINIZLEKontrolaIlosciWlaczona, True );
    vZLEKosztyMaterialoweWlaczone := GetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId,
                                                        sZLEModulID, '', sINIZLEKosztyMaterialoweWlaczone, True );
    vZLEKosztyMatZakupWlaczone := GetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId,
                                                        sZLEModulID, '', sINIZLEKosztyMatZakupWlaczone, False);
    vZLEKosztyRobociznyWlaczone := GetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId,
                                                      sZLEModulID, '', sINIZLEKosztyRobociznyWlaczone, True );
    vZLEWystawioneFakturyWlaczone := GetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId,
                                                        sZLEModulID, '', sINIZLEWystawioneFakturyWlaczone, True );
    vZLEWystawioneFakturyZakupuWlaczone := GetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId,
                                                        sZLEModulID, '', sINIZLEWystawioneFakturyZakupuWlaczone, False );
    vZLEZasobyWlaczone := GetUserIniBoolean ( vAktywnaFirma, SecurityManager.UserId,
                                              sZLEModulID, '', sINIZLEZasobyWlaczone, True );
    vZLERozliczenieWlaczone := GetUserIniBoolean ( vAktywnaFirma, SecurityManager.UserId,
                                                   sZLEModulID, '', sINIZLERozliczenieWlaczone, True );
    vZLEZlecenieRozl_ZuzPaliwa := GetSystemIniBoolean ( vAktywnaFirma, sZLEModulID, '',
                                                        sINIZLEZlecenieRozl_ZuzPaliwa, False );
    vZLEZleceniePoz_RenumeracjaLP := GetSystemIniBoolean ( vAktywnaFirma, sZLEModulID, '',
                                                        sINIZLEZleceniePoz_RenumeracjaLP, False );

    vZLEWymaganyOddzial   := GetSystemIniBoolean ( vAktywnaFirma, sZLEModulID, '',
                                                   sINIZLEWymaganyOddzial, False );
    vZLEDomyslnyOddzialID := GetUserIniInteger( vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                                                  sINIZLEDomyslnyOddzialID, -1 );
    vZLEWymaganaStawkaZasobu  := GetSystemIniBoolean(vAktywnaFirma, sZLEModulID, '',
                                                   sINIZLEWymaganaStawkaZasobu, True );

    vZLESrodkiTrwaleWlaczone := GetUserIniBoolean(vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                                                  sINIZLESrodkiTrwaleWlaczone, False);

    vZLEPrzeliczanieWlaczone  := GetUserIniBoolean(vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                                                     sINIZLEPrzeliczanieWlaczone, False );

    vZLEPrzeliczanieGodzina   := GetUserIniString( vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                                                     sINIZLEPrzeliczanieGodzina, '00:00');

    vZLEGrupowanieDanych  := GetUserIniBoolean(vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                                                     sINIZLEGrupowanieDanych, False );

    vZLENumeratorZasobow := GetSystemIniInteger( 0 {vAktywnaFirma}, sZLEModulID, '',
                                                    sINIZLENumeratorZasobow, -1 );

    vZLEOgraniczonaListaZasobow := GetSystemIniBoolean(vAktywnaFirma, sZLEModulID, '',
                                                     sINIZLEOgraniczonaListaZasobow, False );

    vZLEWspolneZlecenia := GetSystemIniBoolean( 0, sZLEModulID, '',
                                                     sINIZLEWspolneZlecenia, False );

    vZLEFormatGodzinLiczba := GetSystemIniBoolean( 0, sZLEModulID, '',
                                                     sINIZLEFormatGodzinLiczba, False );

    vZLEWylaczonyFiltrDlaTypu := GetSystemIniBoolean( 0, sZLEModulID, '',
                                                     sINIZLEWylaczonyFiltrDlaTypu, False );
    vZLEWycenaPracyZasobowWlaczona  := GetSystemIniBoolean(
      0, sZLEModulID, '',
      sINIZLEWycenaPracyZasobowWlaczona, DataManagers.Available(sLWPModulID)
    );

    vZLENumeratorExt  := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLENumeratorExt, False);

    vZLEPrefixSlownikID := GetSystemIniInteger( 0 {vAktywnaFirma}, sZLEModulID, '',
                                                sINIZLEPrefixSlownikID, -1 );
    vZLEOsobnaNum  := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEOsobnaNum, False);

    vZLEWymaganaPozycjaEwid := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEWymaganaPozycjaEwid, False);
    ZLEDM.vZLEZamkniecieKont := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEZamkniecieKont, False);

    {Podpowiadanie danych ze spraw}
    vZLESprawyPodpowiadanie := GetSystemIniBoolean( 0, sZLEModulID, '',
                                                    sINIZLESprawyPodpowiadanie, False );

    vZLESprawyKontrahent := GetSystemIniString( 0, sZLEModulID, '',
                                                sINIZLESprawyKontrahent,
                                               'Kontrahent' );
    vZLESprawyWydzial    := GetSystemIniString( 0, sZLEModulID, '',
                                                sINIZLESprawyWydzial,
                                                'Wydzia' );
    vZLESprawyPrefix     := GetSystemIniString( 0, sZLEModulID, '',
                                                sINIZLESprawyPrefix,
                                                'Prefix' );
    vZLEStawkaRegula     := GetSystemIniString(0, sZLEModulID, '', sINIZLEStawkaRegula, '');

    vZLENarzuty                := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLENarzuty, False);
    vZLEPoziomNarzutowJednOrg  := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEPoziomNarzutowJednOrg, False);
    vZLEPoziomNarzutowOddzial  := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEPoziomNarzutowOddzial, False);
    vZLEPoziomNarzutowTypZlec  := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEPoziomNarzutowTypZlec, True);
    vZLEZleceniaNadrzedne      := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEZleceniaNadrzedne, False);
    vZLEKosztyZakupuWlaczone   := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEKosztyZakupuWlaczone, False);
    vZLEDopiszKosztyZakupuWlaczone   := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEDopiszKosztyZakupuWlaczone, ZLEDM.vZLEKosztyZakupuWlaczone);
    vZLEKosztyKDECPWlaczone    := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEKosztyKDECPWlaczone, False);
    vZLEWydrukZlecenia         := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEWydrukZlecenia, False);
    vZLERozliczAktStawka       := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLERozliczAktStawka, True);
    vZLEWlaczAktywnePrzyciki   := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEWlaczAktywnePrzyciki, False);
    vZLEKontrolaUprawnionych   := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEKontrolaUprawnionych, False);
    vZLEWysylanieECPWlaczone   := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEWysylanieECPWlaczone, False);
    vZLEWysylanieRozliczECPWlaczone   := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEWysylanieRozliczECPWlaczone, False);
    vZLESkladnikECPDomyslnyID  := GetSystemIniInteger(vAktywnaFirma, sZLEModulID, '', sINIZLESkladnikECPDomyslnyID, -1);
    vZLEBlokadaZmianySymbolu   := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEBlokadaZmianySymbolu, False);
    vZLEReczneWprowadzanieSymbolu := GetUserIniBoolean(vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                                                       sINIZLEReczneWprowadzanieSymbolu, False );
    vZLEKopiujZlecenieBezPozycji := GetUserIniBoolean(vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                                                     sINIZLEKopiujZlecenieBezPozycji, False );

    vZLEPrzeliczOkresID        := GetUserIniInteger( vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                                                  sINIZLEPrzeliczOkresID, -1 );

    vZLEUwzglednijBlokadeKDECP := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEUwzglednijBlokadeKDECP, False);

    vZLETransportWlaczony      := GetUserIniBoolean(vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                                                    sINIZLETransportWlaczony, False);
    vZLETworzZapotrzWlaczone   := GetUserIniBoolean(vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '', sINIZLETworzZapotrzWlaczone, UNISysDM.UNICzyAktywnyModul(sZAOModulID));

    vZLEUproszczonySlownikZlecenWlaczony := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEUproszczonySlownikZlecenWlaczony, False);
    vZLERozliczanieAkorduECPWlaczone := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLERozliczanieAkorduECPWlaczone, False);
    vZLESlownikStanowiskMnemID  := GetSystemIniInteger(0, sZLEModulID, '', sINIZLESlownikStanowiskMnemID, -1);

    vZLEMaskaSymboluWlaczona   := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEMaskaSymboluWlaczona, False);
    vZLEMaskaSymbolu           := GetSystemIniString(0, sZLEModulID, '', sINIZLEMaskaSymbolu, '');
    vZLEDataBlokadyECP         := GetSystemIniInteger(vAktywnaFirma, sZLEModulID, '', sINIZLEDataBlokadyECP, 0);
    vZLEBlokadaEdycjiZakoncz   := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEBlokadaEdycjiZakoncz, False);
    vZLEECPPracownicyWieleFirm := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEECPPracownicyWieleFirm, False);
    vZLEUnikalnoscElemInf      := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEUnikalnoscElemInf, False);

    vZLEZleceniaBezPozycjiZeSpraw := GetSystemIniBoolean(0, sZLEModulID, '', sINIZLEZleceniaBezPozycjiZeSpraw, False);
    vZLEZleceniaPodrzedneWlaczone := GetUserIniBoolean(vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                                                       sINIZLEZleceniaPodrzedneWlaczone, False );
  end;

  vZLEPrzeliczanie := False;
  PrzeliczanieTimer.Enabled := vZLEPrzeliczanieWlaczone;
  PrzeliczanieTimer.Interval := 60000;
end;

procedure TZLEDataManager.ZapiszParametry;
begin
  with UNISysDM do begin
    SetSystemIniString( vAktywnaFirma, sZLEModulID, '',
                        sINIZLEDomyslnyStatusZlecenia, vZLEDomyslnyStatusZlecenia );
    SetUserIniInteger( vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                         sINIZLEDomyslnyTypZlecenia, vZLEDomyslnyTypZlecenia );
    SetSystemIniInteger( vAktywnaFirma, sZLEModulID, '',
                         sINIZLEInstalacjeTypZlec, vZLEInstalacjeTypZlec );
    SetSystemIniBoolean( vAktywnaFirma, sZLEModulID, '',
                         sINIZLEWymaganaOsobaZamykajacaZlecenie, vZLEWymaganaOsobaZamykajacaZlecenie );
    SetSystemIniInteger( vAktywnaFirma, sZLEModulID, '',
                         sINIZLEAsoReg_ID, vZLEAsoReg_ID );
    SetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                       sINIZLEPozycjeWlaczone, vZLEPozycjeWlaczone );
    SetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                       sINIZLEKontrolaKosztowWlaczona, vZLEKontrolaKosztowWlaczona );
    SetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                       sINIZLEKontrolaIlosciWlaczona, vZLEKontrolaIlosciWlaczona );
    SetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                       sINIZLEKosztyMaterialoweWlaczone, vZLEKosztyMaterialoweWlaczone );
    SetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                       sINIZLEKosztyMatZakupWlaczone, vZLEKosztyMatZakupWlaczone );
    SetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                       sINIZLEKosztyRobociznyWlaczone, vZLEKosztyRobociznyWlaczone );
    SetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                       sINIZLEWystawioneFakturyWlaczone, vZLEWystawioneFakturyWlaczone );
    SetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                       sINIZLEWystawioneFakturyZakupuWlaczone, vZLEWystawioneFakturyZakupuWlaczone );
    SetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId, sZLEMOdulID, '',
                       sINIZLEZasobyWlaczone, vZLEZasobyWlaczone );
    SetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId, sZLEMOdulID, '',
                       sINIZLERozliczenieWlaczone, vZLERozliczenieWlaczone );
    SetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                       sINIZLESrodkiTrwaleWlaczone, vZLESrodkiTrwaleWlaczone);
    SetSystemIniBoolean( vAktywnaFirma, sZLEMOdulID, '',
                       sINIZLEZlecenieRozl_ZuzPaliwa, vZLEZlecenieRozl_ZuzPaliwa );
    SetSystemIniBoolean( vAktywnaFirma, sZLEMOdulID, '',
                       sINIZLEZleceniePoz_RenumeracjaLP, vZLEZleceniePoz_RenumeracjaLP );
    SetSystemIniBoolean( vAktywnaFirma, sZLEMOdulID, '',
                       sINIZLEWymaganyOddzial, vZLEWymaganyOddzial );
    SetUserIniInteger( vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                         sINIZLEDomyslnyOddzialID, vZLEDomyslnyOddzialID );
    SetSystemIniBoolean( vAktywnaFirma, sZLEMOdulID, '',
                       sINIZLEWymaganaStawkaZasobu, vZLEWymaganaStawkaZasobu);
    SetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId, sZLEMOdulID, '',
                       sINIZLEPrzeliczanieWlaczone, vZLEPrzeliczanieWlaczone);
    SetUserIniString( vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                        sINIZLEPrzeliczanieGodzina, vZLEPrzeliczanieGodzina );
    SetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId, sZLEMOdulID, '',
                       sINIZLEgrupowanieDanych, vZLEGrupowanieDanych);
    SetSystemIniInteger( 0 {vAktywnaFirma}, sZLEModulID, '',
                         sINIZLENumeratorZasobow, vZLENumeratorZasobow );
    SetSystemIniBoolean( vAktywnaFirma, sZLEMOdulID, '',
                       sINIZLEOgraniczonaListaZasobow, vZLEOgraniczonaListaZasobow);
    SetSystemIniBoolean( 0, sZLEMOdulID, '',
                       sINIZLEWspolneZlecenia, vZLEWspolneZlecenia);
    SetSystemIniBoolean( 0, sZLEMOdulID, '',
                       sINIZLEFormatGodzinLiczba, vZLEFormatGodzinLiczba);
    SetSystemIniBoolean( 0, sZLEMOdulID, '',
                       sINIZLEWylaczonyFiltrDlaTypu, vZLEWylaczonyFiltrDlaTypu);
    SetSystemIniBoolean(
      0, sZLEModulID, '',
      sINIZLEWycenaPracyZasobowWlaczona, vZLEWycenaPracyZasobowWlaczona
    );
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLENumeratorExt, vZLENumeratorExt);

    {Tu by bd -  update??}
    SetSystemIniInteger( 0 {vAktywnaFirma}, sZLEModulID, '',
                         sINIZLEPrefixSlownikID, vZLEPrefixSlownikID );
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEOsobnaNum, vZLEOsobnaNum);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEWymaganaPozycjaEwid, vZLEWymaganaPozycjaEwid);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEZamkniecieKont, vZLEZamkniecieKont);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLESprawyPodpowiadanie, vZLESprawyPodpowiadanie);

    SetSystemIniString( 0, sZLEModulID, '',  sINIZLESprawyKontrahent, vZLESprawyKontrahent );
    SetSystemIniString( 0, sZLEModulID, '',  sINIZLESprawyWydzial, vZLESprawyWydzial );
    SetSystemIniString( 0, sZLEModulID, '',  sINIZLESprawyPrefix, vZLESprawyPrefix );
    SetSystemIniString( 0, sZLEModulID, '',  sINIZLEStawkaRegula, vZLEStawkaRegula );

    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLENarzuty, vZLENarzuty);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEPoziomNarzutowJednOrg, vZLEPoziomNarzutowJednOrg);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEPoziomNarzutowOddzial, vZLEPoziomNarzutowOddzial);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEPoziomNarzutowTypZlec, vZLEPoziomNarzutowTypZlec);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEZleceniaNadrzedne, vZLEZleceniaNadrzedne);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEKosztyZakupuWlaczone, vZLEKosztyZakupuWlaczone);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEDopiszKosztyZakupuWlaczone, vZLEDopiszKosztyZakupuWlaczone);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEKosztyKDECPWlaczone, vZLEKosztyKDECPWlaczone);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEWydrukZlecenia, vZLEWydrukZlecenia);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLERozliczAktStawka, vZLERozliczAktStawka);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEWlaczAktywnePrzyciki, vZLEWlaczAktywnePrzyciki);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEKontrolaUprawnionych, vZLEKontrolaUprawnionych);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEWysylanieECPWlaczone, vZLEWysylanieECPWlaczone);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEWysylanieRozliczECPWlaczone, vZLEWysylanieRozliczECPWlaczone);
    SetSystemIniInteger( vAktywnaFirma, sZLEModulID, '',
                         sINIZLESkladnikECPDomyslnyID, vZLESkladnikECPDomyslnyID );
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEBlokadaZmianySymbolu, vZLEBlokadaZmianySymbolu);
    SetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId, sZLEMOdulID, '',
                       sINIZLEReczneWprowadzanieSymbolu, vZLEReczneWprowadzanieSymbolu);

    SetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId, sZLEMOdulID, '',
                       sINIZLEKopiujZlecenieBezPozycji, vZLEKopiujZlecenieBezPozycji);
    SetUserIniInteger( vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                         sINIZLEPrzeliczOkresID, vZLEPrzeliczOkresID );

    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEUwzglednijBlokadeKDECP, vZLEUwzglednijBlokadeKDECP);

    SetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                       sINIZLETransportWlaczony, vZLETransportWlaczony);
    SetUserIniBoolean(vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '', sINIZLETworzZapotrzWlaczone, vZLETworzZapotrzWlaczone);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEUproszczonySlownikZlecenWlaczony, vZLEUproszczonySlownikZlecenWlaczony);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLERozliczanieAkorduECPWlaczone, vZLERozliczanieAkorduECPWlaczone);
    SetSystemIniInteger( 0, sZLEModulID, '', sINIZLESlownikStanowiskMnemID, vZLESlownikStanowiskMnemID );

    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEMaskaSymboluWlaczona, vZLEMaskaSymboluWlaczona);
    SetSystemIniString( 0, sZLEModulID, '',  sINIZLEMaskaSymbolu, vZLEMaskaSymbolu);
    SetSystemIniInteger( vAktywnaFirma, sZLEModulID, '', sINIZLEDataBlokadyECP, vZLEDataBlokadyECP );
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEBlokadaEdycjiZakoncz, vZLEBlokadaEdycjiZakoncz);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEECPPracownicyWieleFirm, vZLEECPPracownicyWieleFirm);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEUnikalnoscElemInf, vZLEUnikalnoscElemInf);
    SetSystemIniBoolean( 0, sZLEMOdulID, '', sINIZLEZleceniaBezPozycjiZeSpraw, vZLEZleceniaBezPozycjiZeSpraw);
    SetUserIniBoolean( vAktywnaFirma, SecurityManager.UserId, sZLEModulID, '',
                       sINIZLEZleceniaPodrzedneWlaczone, vZLEZleceniaPodrzedneWlaczone );
  end;
  PrzeliczanieTimer.Enabled := vZLEPrzeliczanieWlaczone;
  PrzeliczanieTimer.Interval := 60000;

  {Inicjacja ZLE_package}
  try
    SQLManager.OpenQueryWithresult('SELECT ' + SQLManager.GetSPName(sZLE_PACKAGE) +'.INIT FROM dual');
  except
    {Pewnie nie ma jeszcze INIT w package, wic bd ignorujemy}
  end;
end;

procedure TZLEDataManager.NumeratorySymboliZlecenMenuItemClick(
  Sender: TObject);
var
    oMnem: TUNIQuery;
    sMnemonik  : String;
begin
  if ((ZLEDM.vZLEWymaganyOddzial and vWieloodzialowosc) or
      (ZLEDM.vZLENumeratorExt and ZLEDM.vZLEOsobnaNum)) and
     (not (ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = -1))) then begin
      {if ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = -1) then begin
         Komunikat(cWarning, 'Ustawiono rozszerzon obsug numeratorw,'#13+
                             'ale nie zosta zdefiniowany sownik numeratorw'#13+
                             'Ustaw w parametrach sownik prefiksw dla numeratora');
         Exit;
      end;}

      if ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0) then
           sMnemonik := sMnemonikZLEPrefix
      else
      if ZLEDM.vZLENumeratorExt and vWielofirmowosc and (ZLEDM.vZLEPrefixSlownikID = 1) then
           sMnemonik := sMnemonikFirmy
      else sMnemonik := sMnemonikOddzialy;

      oMnem := SQLManager.CreateQuery(
        'SELECT ' +
           sFKMNEMONIKI_ID +
        ' FROM ' +
           SQLManager.GetTableName(sFKMNEMONIKI) +
        ' WHERE ' +
           sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr(sMnemonik) + ' AND ' +
           sFKMNEMONIKI_INDEKS + ' = 0');

      try
        oMnem.Open;

        {function  UNIPokazIObsluzAutomatyNum( sKodAutomatu: string; iMaxDlugosc: integer; sBlokada, sAtrybuty, sWarunek: string; bBlok: boolean;
                                              iPozycjonowanieID: integer = 0; bNieFirmowy:boolean = false ;
                                              bUnikalnoscWzorca:boolean=true;iMnemonikID:integer = 0;
                                              sMnemonikiTryb:string = ''): TUNIQuery;}
        UNISysDM.UNIPokazIObsluzAutomatyNum( sUNINUMERATORModuluZlecen,
                                           UNISysDM.vMaxDLSymboluZle,
                                           sUNICONST_ALTERNATYWA_TAK,
                                           '', '', False, 0,
                                           (ZLEDM.vZLENumeratorExt and vWielofirmowosc and (ZLEDM.vZLEPrefixSlownikID = 1)) { tu zmiana byo False - NieFirmowy - false},
                                           True,
                                           oMnem.FieldByName(sFKMNEMONIKI_ID).AsInteger{,
                                           sUNISysAutomatyNumerowaniaMnemonikTryb_BrakCheckboxa} );
      finally
        if oMnem <> nil then FreeAndNil(oMnem);
      end;
 end else begin
     UNISysDM.UNIPokazIObsluzAutomatyNum( sUNINUMERATORModuluZlecen,
                                       UNISysDM.vMaxDLSymboluZle,
                                       sUNICONST_ALTERNATYWA_TAK,
                                       '', '', False, 0, False {NieFirmowy - false}
                                       {,false - unikalnosc wzorca});
 end;

end;

function TZLEDataManager.ZLEPokazIObsluzDane( sTabela, sAtrybuty, sWarunek: string;
                                  bBlok, bWyborWielu: Boolean;
                                  iModulZSIID, iLocateID, iFirmaID: Integer;
                                  sPola: String; oSelected: TStrings;
                                  oLocateContained: TStrings;
                                  oParams: TKeyValues): TUNIQuery;
var vForm: TUNIDBGridForm;
    sSQL: String;
    iOpenMode: TOpenMode;
    iIndex, iPosID: Integer;
    sCorrel: string;
begin
  result := nil;

  iOpenMode := omList;
  if not (ZZBEmptyString(sAtrybuty) and ZZBEmptyString(sPola)) then
    iOpenMode := omLookup or omHidden;

  vForm := ZLEPokazIObsluzDaneGrid(self, sTabela, sAtrybuty, sWarunek, bBlok,
                                    bWyborWielu, iOpenMode, iModulZSIID, iLocateID,
                                    iFirmaID, oLocateContained, oParams );
  try
    if oSelected <> nil then begin
      vForm.DataModule.ActiveQuery.DisableControls;
      iPosID := vForm.DMAQFbN( sTabela+'_ID' ).AsInteger;
      try
        for iIndex := 0 to oSelected.Count-1 do
          if vForm.DataModule.ActiveQuery.Locate( sTabela+'_ID', oSelected[iIndex], [] ) then
            vForm.DBGrid.Mark();
      finally
        vForm.DataModule.ActiveQuery.Locate( sTabela+'_ID', iPosID, [] );
        vForm.DataModule.ActiveQuery.EnableControls;
      end;
    end;
    //jeeli brak atrybutw nie zwracamy wyniku
    if ((iOpenMode and omLookup) = omLookup)and
       (vForm.ShowModal = mrOK) then begin
      //zwracamy wynik w postaci Quera zawierajcego wybrane krotki
      if sWarunek <> '' then sWarunek := sWarunek +' and ';
      iIndex := AliasManager.Tabs.IndexOfTable(sTabela);
      if iIndex > -1 then
        sCorrel := AliasManager.Tabs.Items[iIndex].Correl+'.'
      else
        sCorrel := '';

      if Pos(sCorrel, sPola) > 0 then {Tu byo =0??}
        sCorrel := '';

      {if bWyborWielu then
        sWarunek := sWarunek +  sCorrel+sTabela+'_ID'+' in ('+Andy(vForm.DBGrid.MarkedRows,',')+')'
      else
        sWarunek := sWarunek + sCorrel+sTabela+'_ID'+' = '+vForm.DMAQFbN(sTabela+'_ID').AsString;}

      if ZZBEmptyString(sPola) then begin
        if bWyborWielu then
          sWarunek := sWarunek +  sCorrel+sTabela+'_ID'+' in ('+Andy(vForm.DBGrid.MarkedRows,',')+')'
        else
          sWarunek := sWarunek + sCorrel+sTabela+'_ID'+' = '+vForm.DMAQFbN(sTabela+'_ID').AsString;
        //atrybuty podane jako aliasy
        sSQL := AliasManager.ComposeQuery( sAtrybuty, sWarunek, true );
      end else begin
        if bWyborWielu then
          sWarunek := sWarunek + sTabela+'_ID'+' in ('+Andy(vForm.DBGrid.MarkedRows,',')+')'
        else
          sWarunek := sWarunek + sTabela+'_ID'+' = '+vForm.DMAQFbN(sTabela+'_ID').AsString;
        //atrybuty podane jako pola wprost
        sSQL := 'select ' + sPola {sAtrybuty} +
                ' from ' + SQLManager.GetTableName(sTabela) +
                ' where ' + sWarunek;
      end;

      try
        result := SQLManager.CreateQuery( sSQL );
        result.Open;
        if result.IsEmpty then result := nil;
      except
        if result <> nil then FreeAndNil(result);
      end;
    end;
  finally
    if (iOpenMode and omLookup) = omLookup then
      vForm.Free;
  end;
end;

function TZLEDataManager.ZLEPokazIObsluzTypZlecenia( sAtrybuty, sWarunek: string;
                                                     bBlok, bWyborWielu: Boolean;
                                                     iModulZSIID, iLocateID,
                                                     iFirmaID: Integer): TUNIQuery;
begin
  result := ZLEPokazIObsluzDane( sZLETYPZLEC, sAtrybuty, sWarunek, bBlok,
                                 bWyborWielu, iModulZSIID, iLocateID, iFirmaID );
end;

procedure TZLEDataManager.KartotekaZlecenMenuItemClick(Sender: TObject);
var
  oParams: TKeyValues;
  //bTest: Boolean;
begin
  inherited;

  //bTest := True;
  if SecurityManager.SM_UserCanDo(sZLE_KART_ZLECEN) {and not bTest} then begin
     oParams := TKeyValues.CreateEmpty();
      with oParams do begin
    //    if WyborZakresu then
            Add(cRangeClassName+'='+cKlasaZakresZlecen+cSuffixKlasySelect);
        Add(cFORM_CAPTION+'='+'Zlecenia');
        Add(sUNIMODULZSI_ID+'='+IntToStr(cZLEModulZSI_ID));
        Add(cZLEFuncRodzaj+'='+cZLEFuncZlecenie);

        Add(cUsedCreatorRangeForm+'='+ sTak);
      end;

      FormManager.OpenDBGrid( Self, cKlasaZlecenie+cSuffixKlasyDBGrid, omList or omMultiSelect, oParams );
  end else
  if SecurityManager.SM_UserCanDo(sZLE_KART_ZLECEN_UPR) {or bTest} then begin
      oParams := TKeyValues.CreateEmpty();
      with oParams do begin
        Add(cRangeClassName+'='+cKlasaZakresZlecenUpr+cSuffixKlasySelect);
        Add(cFORM_CAPTION+'='+'Uproszczona lista zlece');
        //Add(sUNIMODULZSI_ID+'='+IntToStr(cZLEModulZSI_ID));
        //Add(cZLEFuncRodzaj+'='+cZLEFuncZlecenie);
      end;

      FormManager.OpenDBGrid( Self, cKlasaZlecenieUpr+cSuffixKlasyDBGrid, omList or omMultiSelect, oParams );
  end else Komunikat(cWarning, 'Brak uprawnien');
end;

procedure TZLEDataManager.ParametryMenuItemClick(Sender: TObject);
var oParams: TKeyValues;
begin
  inherited;
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add(cFORM_CAPTION+'='+'Parametry moduu zlecenia');
  end;
  FormManager.OpenForm( Self, cKlasaParametry+cSuffizKlasyTreeForm,
                          omDefault, oParams );
end;

function TZLEDataManager.ZLEOdpytajODane( sTabela, sAtrybuty, sWarunek: string;
                                          bUnikalne: boolean;
                                          sOrderBy: String): TUNIQuery;
begin
  result := nil;
  try
    result := SQLManager.CreateQuery( ZLEOdpytajODaneSQL( sTabela, sAtrybuty,
                                                          sWarunek, bUnikalne,
                                                          sOrderBy ) );
    if result <> nil then result.Open;
    if result.IsEmpty then FreeAndNil(result);
  except
    if result <> nil then FreeAndNil(result);
    raise;
  end;
end;

function TZLEDataManager.ZLEOdpytajODaneSQL( sTabela, sAtrybuty, sWarunek: string;
                                             bUnikalne: boolean;
                                             sOrderBy: String): string;
begin
  result := ZLEDM.AliasManager.ComposeQuery( sAtrybuty, sWarunek, bUnikalne,
                                             False, sOrderBy );
end;

procedure TZLEDataManager.ParametryPracyMenuItemClick(Sender: TObject);
begin
  inherited;
  FormManager.OpenForm(self, 'TUNISysParametryPracySelectForm', omEdit)
end;

function TZLEDataManager.ZLEPokazIObsluzZlecenia(sAtrybuty,
  sWarunek: string; bBlok, bWyborWielu: Boolean; iModulZSIID, iLocateID,
  iFirmaID: Integer; oSelected: TStrings; oLocateContained: TStrings;
  oParams: TKeyValues): TUNIQuery;
begin
  result := ZLEPokazIObsluzDane( sZLEZLECENIE, sAtrybuty, sWarunek, bBlok,
                                 bWyborWielu, iModulZSIID, iLocateID, iFirmaID,
                                 '', oSelected, oLocateContained, oParams );
end;

procedure TZLEDataManager.ZleceniaExt1Click(Sender: TObject);
begin
  inherited;
  ZLEPokazIObsluzZlecenia( '', '', false, false, cZLEModulZSI_ID );
end;

function TZLEDataManager.ZLEKontrolaZlecenia(iZlecenieID: Integer;
  sAtrybuty: string; bBlok: Boolean; iModulZSIID, iFirmaID: Integer): TUNIQuery;
var vForm: TUNIDBDetailForm;
    sSQL: String;
begin
  result := nil;
  
  vForm := ZLEKontrolaZleceniaGrid(self,  iZlecenieID, sAtrybuty, bBlok,
                                    iModulZSIID, iFirmaID );
  if sAtrybuty = '' then Exit;
  if vForm.ModalResult = mrOK then begin
    //jeeli brak atrybutw nie zwracamy wyniku
    if sAtrybuty = '' then Exit;
    //zwracamy wynik w postaci Quera zawierajcego wybrane krotki
    sSQL := AliasManager.ComposeQuery( sAtrybuty, '', true );
    try
      result := SQLManager.CreateQuery( sSQL );
      result.Open;
      if result.IsEmpty then result := nil;
    except
      if result <> nil then FreeAndNil(result);
    end;
  end;

end;

procedure TZLEDataManager.Kontrolazlecenia1Click(Sender: TObject);
begin
  inherited;
  ZLEKontrolaZlecenia( 229, '', false, cZLEModulZSI_ID );
end;

destructor  TZLEDataManager.Destroy();
begin
{$ifndef build_all}
  m_oZasobyPracaNoweId.Free();
{$endif}
  inherited;
end;

function TZLEDataManager.WczytajOkresy: TConstStringList;
var oQuery: TUNIQuery;
    sSQL: String;
begin
  oQuery := nil;
  try
    result := TConstStringList.Create();
   { oQuery := UNISysDM.UNIOdpytajODane( sUNIOKRES,
                                        sUNISYSALIAS_Okres_Obrachunkowy_ID+';'+
                                        sUNISYSALIAS_Okres_Obrachunkowy_Nazwa,
                                        '@'+sUNISYSALIAS_Rok_ID+'='+IntToStr(vAktywnyRokObrachunkowyID),
                                        true, vAktywnaFirma );}

    sSQL := DataManagers[sUniSysModulID].AliasManager.ComposeQuery( sUNISYSALIAS_Okres_Obrachunkowy_ID+';'+
                                         sUNISYSALIAS_Okres_Obrachunkowy_Nazwa + ';' +
                                         sUNISYSAlias_Poczatek_Okresu_Obrachunkowego,
                                        '@'+sUNISYSALIAS_Rok_ID+'='+IntToStr(vAktywnyRokObrachunkowyID),
                                        true, false,
                                        sUNISYSAlias_Poczatek_Okresu_Obrachunkowego );

    result.Add( '<dowolny>', '-1' );
    oQuery := SQLManager.CreateQuery(sSQL);
    oQuery.Open;
    if oQuery <> nil then
      with oQuery do begin
         while not oQuery.Eof do begin
           result.Add( FieldByName(sUNIOKRES_NAZWA).AsString,
                       FieldByName(sUNIOKRES_ID).AsString );
           Next;
         end;
      end;
  finally
    if oQuery <> nil then oQuery.Free;
  end;
end;

function TZLEDataManager.DajNazwyDomen: String;
begin
  result := sZLECONST_SKLADNIK;
  result := result + ';' + sZLECONST_RODZAJZASOBU;
  result := result + ';' + sZLECONST_PARSERBLAD;
  result := result + ';' + sZLECONST_PREFIX;
  result := result + ';' + sZLECONST_ZASOBPRACAST;
  result := result + ';' + sZLECONST_ZLEWYCENAST;
  result := result + ';' + sZLECONST_RODZAJECP;
  result := result + ';' + sZLECONST_ZASOBYPRACARAPST;
  //przeniesione do UNISysDM
  //sZLECONST_STATUS+';'+
  //sZLECONST_AKTYWNOSC;
end;

function TZLEDataManager.DajDefinicjeDomeny( sDomain:string):TConstStringList;
begin
  Result:=nil;
  if sDomain = sZLECONST_SKLADNIK then
    Result := cslZLERodzajSklad
  else if sDomain = sZLECONST_RODZAJZASOBU then
    Result := cslZLERodzajZasobu
  else if sDomain = sZLECONST_PARSERBLAD then
    Result := cslZLEParserBlad
  else if sDomain = sZLECONST_PREFIX then begin
    Result := cslZLEConstPrefix;
    //  Oddzia jest w domenie,
    //  ale nie zawsze bdzie dostpny do wyboru na licie
  end else if(sDomain = sZLECONST_ZASOBPRACAST) then
    result  := cslZLEConstZasobPracaStatus
  else if(sDomain = sZLECONST_ZLEWYCENAST) then
    result  := cslZLEConstZleWycenaStatus
  else if sDomain = sZLECONST_RODZAJECP then
    Result := cslZLERodzajECP
  else if(sDomain = sZLECONST_ZASOBYPRACARAPST) then
    result  := cslZLEConstZasobyPracaRapStatus;
end;

function TZLEDataManager.ZLEDajIdElemGrup( iZlecenieID: Integer;
                                        iFirmaID: Integer = 0 ): Integer;
var oQuery: TUNIQuery;
    sWhere: String;
begin
  result := 0;

  oQuery := nil;
  sWhere := '';
  try
    sWhere := '(@'+sZLEALIAS_ZLECENIE_ID+'='+IntToStr(iZlecenieID)+')';
    if iFirmaID <> 0 then
      sWhere := sWhere + 'and(@'+sUNIODDZIAL_ID+'='+IntToStr(iFirmaID)+')';
    oQuery := ZLEOdpytajODane( sZLEZLECENIE, sZLEALIAS_ZLECENIE_GRUPA_ID,
                               sWhere, true );
    if oQuery <> nil then
      result := oQuery.FieldByName(sZLEZLECENIE_GRUPA_ID).AsInteger;
  finally
    if oQuery <> nil then oQuery.Free;
  end;

end;

function TZLEDataManager.ZLEDajIdTypElemGrup( iTypZleceniaID: Integer;
                                           iFirmaID: Integer = 0 ): Integer;
var oQuery: TUNIQuery;
    sWhere: String;
begin
  result := 0;

  oQuery := nil;
  sWhere := '';
  try
    sWhere := '(@'+sZLEALIAS_TYPZLECENIA_ID+'='+IntToStr(iTypZleceniaID)+')';
    if iFirmaID <> 0 then
      sWhere := sWhere + 'and(@'+sUNIODDZIAL_ID+'='+IntToStr(iFirmaID)+')';
    oQuery := ZLEOdpytajODane( sZLETYPZLEC, sZLEALIAS_TYPZLECENIA_TYP_GRUPY_ID,
                               sWhere, true );
    if oQuery <> nil then
      result := oQuery.FieldByName(sZLETYPZLEC_TYP_GRUPY_ID).AsInteger;
  finally
    if oQuery <> nil then oQuery.Free;
  end;
end;

function TZLEDataManager.ZLEDajListeSkladTypu( iGrupaID, iTypZleceniaID: Integer;
                                            iFirmaID: Integer = 0 ): TUNIQuery;
var sSQL1, sSQL2, sSQL, sWhere: String;
begin
  result := nil;
  Assert( (iGrupaID<>0)or(iTypZleceniaID<>0), 'Jeden z parametrw musi by rny od zera' );
  if iGrupaID <> 0 then
    sWhere := '(@'+sZLEALIAS_ZLECENIE_ID+'='+IntToStr(iGrupaID)+')and'+
              '(@'+sZLEALIAS_TYPZLECENIA_GRUPUJACE+'='+QuotedStr(sUNICONST_ALTERNATYWA_TAK)+')'
  else if iTypZleceniaID <> 0 then
    sWhere := '(@'+sZLEALIAS_TYPZLECENIA_ID+'='+IntToStr(iTypZleceniaID)+')'
  else
    sWhere := '';
  if iFirmaID <> 0 then
    sWhere := sWhere + 'and('+'@'+sZLEALIAS_TYPZLECENIA_ODDZIAL_ID+'='+IntToStr(iFirmaID)+')';

  sSQL1 := AliasManager.ComposeQuery( sZLEALIAS_SKLADWART_NAZWA+';'+
                                      sZLEALIAS_SKLADWART_SYMBOL+';'+
                                      sZLEALIAS_SKLADWART_RODZAJ+';'+
                                      '#@'+sZLEALIAS_TYPSKLADW_ID+' as TypSkladID;'+
                                      '#@'+sZLEALIAS_SKLADWART_ID+' as SkladID;'+
                                      '#'+QuotedStr(sZLESKLADWART)+' as Tabela',
                                      sWhere,
                                      false );
  sSQL2 := AliasManager.ComposeQuery( sZLEALIAS_SKLADIL_NAZWA+';'+
                                      sZLEALIAS_SKLADIL_SYMBOL+';'+
                                      sZLEALIAS_SKLADIL_RODZAJ+';'+
                                      '#@'+sZLEALIAS_TYPSKLADIL_ID+' as TypSkladID;'+
                                      '#@'+sZLEALIAS_SKLADIL_ID+' as SkladID;'+
                                      '#'+QuotedStr(sZLESKLADIL)+' as Tabela',
                                      sWhere,
                                      false );
  sSQL := sSQL1+#13#10+'union'+#13#10+sSQL2;
  try
    result := SQLManager.CreateQuery( sSQL );
    if result <> nil then begin
      result.Open;
      if result.IsEmpty then FreeAndNil(result);
    end;
  except
    if result <> nil then result.Free;
    raise;
  end;
end;

function TZLEDataManager.ZLEDajListeWartSklad( iGrupaID, iZlecenieID: Integer;
                                            iFirmaID: Integer = 0 ): TUNIQuery;
var sSQL1, sSQL2, sSQL, sWhere: String;
begin
  result := nil;
  Assert( (iGrupaID<>0)or(iZlecenieID<>0), 'Jeden z parametrw musi by rny od zera' );
  if iGrupaID <> 0 then
    sWhere := '(@'+sZLEALIAS_ZLECENIE_ID+'='+IntToStr(iGrupaID)+')and'+
              '(@'+sZLEALIAS_TYPZLECENIA_GRUPUJACE+'='+QuotedStr(sUNICONST_ALTERNATYWA_TAK)+')'
  else if iZlecenieID <> 0 then
    sWhere := '(@'+sZLEALIAS_ZLECENIE_ID+'='+IntToStr(iZlecenieID)+')'
  else
    sWhere := '';
  if iFirmaID <> 0 then
    sWhere := sWhere + 'and('+'@'+sZLEALIAS_ZLECENIE_ODDZIAL_ID+'='+IntToStr(iFirmaID)+')';

  sSQL1 := AliasManager.ComposeQuery( sZLEALIAS_SKLADWART_NAZWA+';'+
                                      sZLEALIAS_SKLADWART_RODZAJ+';'+
                                      '#@'+sZLEALIAS_WART_WARTOSC+' as WartIl;'+
                                      '#'+QuotedStr(sZLESKLADWART)+' as Tabela',
                                      sWhere,
                                      false );
  sSQL2 := AliasManager.ComposeQuery( sZLEALIAS_SKLADIL_NAZWA+';'+
                                      sZLEALIAS_SKLADIL_RODZAJ+';'+
                                      '#@'+sZLEALIAS_IL_ILOSC+' as WartIl;'+
                                      '#'+QuotedStr(sZLESKLADIL)+' as Tabela',
                                      sWhere,
                                      false );
  sSQL := sSQL1+#13#10+'union'+#13#10+sSQL2;
  try
    result := SQLManager.CreateQuery( sSQL );
    if result <> nil then begin
      result.Open;
      if result.IsEmpty then FreeAndNil(result);
    end;
  except
    if result <> nil then result.Free;
    raise;
  end;
end;

function TZLEDataManager.ZLEZapiszWartSklad( iGrupaID, iZlecenieID, iZleceniePozID: Integer;
                                          Skladniki: TZLEListaSkladnikow;
                                          iFirmaID: Integer = 0 ): Boolean;
var iIndex: Integer;
    oInsertWART, oInsertIL: TUNIQuery;
    oQueryWART, oQueryIL: TUNIQuery;
    bTrans: Boolean;
begin
  result := false;

  oInsertWART := nil;
  oInsertIL := nil;
  oQueryWART := nil;
  oQueryIL := nil;

  try
    oQueryWART := ZLEDM.ZLEOdpytajODane( sZLESKLADWART,
                                         sZLEALIAS_SKLADWART_ID+';'+
                                         sZLEALIAS_SKLADWART_RODZAJ+';'+
                                         sZLEALIAS_TYPSKLADW_ID+';'+
                                         sZLEALIAS_TYPZLECENIA_ID,
                                         '@'+sZLEALIAS_ZLECENIE_ID+'='+IntToStr(iZlecenieID),
                                         false );
    oQueryIL := ZLEDM.ZLEOdpytajODane( sZLESKLADIL,
                                       sZLEALIAS_SKLADIL_ID+';'+
                                       sZLEALIAS_SKLADIL_RODZAJ+';'+
                                       sZLEALIAS_TYPSKLADIL_ID+';'+
                                       sZLEALIAS_TYPZLECENIA_ID,
                                       '(@'+sZLEALIAS_ZLECENIEPOZ_ID+'='+IntToStr(iZleceniePozID)+')and'+
                                       '(@'+sZLEALIAS_ZLECENIE_ID+'='+IntToStr(iZlecenieID)+')',
                                       false );
    oInsertWART := SQLManager.InsertQueryStep1( sZLEWART,
                                               sZLEWART_ID+','+sZLESKLADWART_ID+','+
                                               sZLEZLECENIE_ID+','+sZLEWART_WARTOSC+','+
                                               sZLEWART_UZ_AU_ID+','+sZLEWART_DATA_AU );
    with oInsertWART do begin
      ParamByName(sZLEWART_ID).DataType := ftInteger;
      ParamByName(sZLESKLADWART_ID).DataType := ftInteger;
      ParamByName(sZLEZLECENIE_ID).DataType := ftInteger;
      ParamByName(sZLEWART_WARTOSC).DataType := ftFloat;
      ParamByName(sZLEWART_UZ_AU_ID).DataType := ftInteger;
      ParamByName(sZLEWART_DATA_AU).DataType := ftDate;
      ParamByName(sZLEWART_UZ_AU_ID).AsInteger := SecurityManager.UserId;
      ParamByName(sZLEWART_DATA_AU).AsDateTime := UNIDate;
    end;
    oInsertIL := SQLManager.InsertQueryStep1( sZLEIL,
                                             sZLEIL_ID+','+sZLESKLADIL_ID+','+
                                             sZLEZLECENIEPOZ_ID+','+sZLEIL_ILOSC+','+
                                             sZLEIL_UZ_AU_ID+','+sZLEIL_DATA_AU );
    with oInsertIL do begin
      ParamByName(sZLEIL_ID).DataType := ftInteger;
      ParamByName(sZLESKLADIL_ID).DataType := ftInteger;
      ParamByName(sZLEZLECENIEPOZ_ID).DataType := ftInteger;
      ParamByName(sZLEIL_ILOSC).DataType := ftFloat;
      ParamByName(sZLEIL_UZ_AU_ID).DataType := ftInteger;
      ParamByName(sZLEIL_DATA_AU).DataType := ftDate;
      ParamByName(sZLEIL_UZ_AU_ID).AsInteger := SecurityManager.UserId;
      ParamByName(sZLEIL_DATA_AU).AsDateTime := UNIDate;
    end;
    bTrans := not SQLManager.InTransaction;
    try
      if bTrans then SQLManager.StartTransaction;
      for iIndex := 0 to Skladniki.Count-1 do with Skladniki[iIndex] do begin
        if Table = sZLEWART then begin
          if oQueryWART.Locate( sZLESKLADWART_ID, ID, [] ) then begin
            if oQueryWART.FieldByName(sZLESKLADWART_RODZAJ).AsString = cZLERodzajSklad_Reczny then
              raise EOF_ZLEException.Create( cError_BladTypuSkladnika,
                                             'Dopiszywany skadnik musi by typu rcznego' );
          end else begin
            raise EOF_ZLEException.Create( cError_BrakSkladnika,
                                           'Skadnik nie naley do podanego zlecenia' );
          end;
          oInsertWART.ParamByName(sZLESKLADWART_ID).AsInteger := ID;
          oInsertWART.ParamByName(sZLEZLECENIE_ID).AsInteger := iZlecenieID;
          oInsertWART.ParamByName(sZLEWART_WARTOSC).AsFloat := Value;
          SQLManager.InsertQueryStep2( oInsertWART, sZLEWART_ID );
        end else if Table = sZLEIL then begin
          if oQueryIL.Locate( sZLESKLADIL_ID, ID, [] ) then begin
            if oQueryIL.FieldByName(sZLESKLADIL_RODZAJ).AsString = cZLERodzajSklad_Reczny then
              raise EOF_ZLEException.Create( cError_BladTypuSkladnika,
                                             'Dopiszywany skadnik musi by typu rcznego' );
          end else begin
            raise EOF_ZLEException.Create( cError_BrakSkladnika,
                                           'Skadnik nie naley do podanego zlecenia' );
          end;
          oInsertIL.ParamByName(sZLESKLADIL_ID).AsInteger := ID;
          oInsertIL.ParamByName(sZLEZLECENIEPOZ_ID).AsInteger := iZleceniePozID;
          oInsertIL.ParamByName(sZLEIL_ILOSC).AsFloat := Value;
          SQLManager.InsertQueryStep2( oInsertIL, sZLEIL_ID );
        end;
      end;
      if bTrans then SQLManager.Commit;
    except
      if bTrans then SQLManager.Rollback;
      raise;
    end;
  finally
    if oInsertWART <> nil then oInsertWART.Free;
    if oInsertIL <> nil then oInsertIL.Free;
    if oQueryWART <> nil then oQueryWART.Free;
    if oQueryIL <> nil then oQueryIL.Free;
  end;
end;

procedure TZLEDataManager.ZLEPokazIObsluzDetail(
  const ac_sTabela:     string;
  const ac_iId:         integer;
  const ac_iOpenMode:   TOpenMode;
  const ac_iModulID:    integer;
        a_oParams:      TKeyValues
);

  function  GetDetailName():  string;
  begin
    if(LowerCase(ac_sTabela) = LowerCase(sZLEZLECENIE)) then
      result  := 'TZLEZlecenieDBDetailForm'
    else begin
      raise EOF_ZLEException.Create(
        'Niedozwolona nazwa tabeli: ' + ac_sTabela + '(ZLEPokazIObsluzDetail)'
      );
    end;
  end;

var
  oParams:      TKeyValues;
  sDetailName:  string;
begin
  sDetailName := GetDetailName();

  if(a_oParams <> nil) then
    oParams := a_oParams
  else
    oParams := TKeyValues.CreateEmpty();
  oParams.Values[cIDforForm]      := IntToStr(ac_iId);
  oParams.Values[sUNIMODULZSI_ID] := IntToStr(ac_iModulID);
  FormManager.OpenDBDetail(
    self,
    sDetailName,
    ac_iOpenMode + omShowModal,
    oParams
  );
end;

function  TZLEDataManager.ZLEDopiszZlecenieZPozycjiZapotrzebowan(
  const ac_sZapotrzPozId: string;
  const ac_iTypZlecId:    integer // domylny typ zlecenia
):  TIntegerArray;
{$ifndef build_all}
type
  TrecAsort = record
    m_iAsortId:     integer;
    m_sAsortSymbol: string;
    m_sAsortNazwa:  string;
    m_iKDOdpowId:   integer;
    m_dIlosc:       double;
    m_aZapotrzPozId:array of integer;
  end;
var
  oDetal:   TZLEZlecenieDBDetailForm;
  oQuery:   TUNIQuery;
  oParams:  TKeyValues;
  aAsorts:  array of TrecAsort;
  i:        integer;
{$endif}
begin
  SetLength(result, 0);
{$ifndef build_all}
  oQuery  := ZAODM.ZAOOdpytajODane(sZAOZAPOTRZPOZ,
    sZAOAlias_ZapotrzebowaniePoz_Id + ';' + sZAOAlias_ZapotrzebowaniePoz_Ilosc  + ';' +
    sZAOAlias_ASOAsort_Id           + ';' + sZAOAlias_ASOAsort_Symbol           + ';' +
    sZAOAlias_ASOAsort_Nazwa        + ';' + sZAOAlias_KDOdpow_Id                + ';' +
    sZAOAlias_Zapotrzebowanie_Id,
    '@' + sZAOAlias_ZapotrzebowaniePoz_Id + ' in(' + ac_sZapotrzPozId + ')',
    false
  );
  if(oQuery <> nil) then begin
    while(not oQuery.Eof) do begin
        // szukamy tego asortymentu
      i := 0;
      while(i < Length(aAsorts)) do begin
        if(aAsorts[i].m_iAsortId = oQuery.Fields[2].AsInteger) then
          break
        else
          Inc(i);
      end;  // while(i < Length(aAsorts))
      if(i >= Length(aAsorts)) then begin
        i := Length(aAsorts);
        SetLength(aAsorts, i+1);
        aAsorts[i].m_iAsortId     := oQuery.Fields[2].AsInteger;
        aAsorts[i].m_sAsortSymbol := oQuery.Fields[3].AsString;
        aAsorts[i].m_sAsortNazwa  := oQuery.Fields[4].AsString;
        aAsorts[i].m_iKDOdpowId   := oQuery.Fields[5].AsInteger;
        aAsorts[i].m_dIlosc       := oQuery.Fields[1].AsFloat;
      end else
        aAsorts[i].m_dIlosc       := aAsorts[i].m_dIlosc + oQuery.Fields[1].AsFloat;
      SetLength(aAsorts[i].m_aZapotrzPozId, Length(aAsorts[i].m_aZapotrzPozId)+1);
      aAsorts[i].m_aZapotrzPozId[High(aAsorts[i].m_aZapotrzPozId)]  := oQuery.Fields[0].AsInteger;
      oQuery.Next();
    end;  // while(not oQuery.Eof)
    oQuery.Free();
    for i := Low(aAsorts) to High(aAsorts) do begin
      oParams := TKeyValues.CreateAs(
        [
          sZLEZLECENIE_ID + '=-1',
          cFORM_CAPTION   + '=Zlecenie',
          sUNIMODULZSI_ID + '=' + IntToStr(cZAOMODULZSI_ID)
        ]
      );
      if(ac_iTypZlecId <> 0) then
        oParams.Add(sZLETYPZLEC_ID + '=' + IntToStr(ac_iTypZlecId));
      oDetal  := (FormManager.OpenDBDetail(
        nil,  // aby detal nie prbowa odwiea tego grida
        'TZLEZlecenieDBDetailForm',
        omNew + omHidden,
        oParams
      ) as TZLEZlecenieDBDetailForm);
      oDetal.UstawDanePozycjiZapotrzebowania(
        aAsorts[i].m_iAsortId,
        aAsorts[i].m_aZapotrzPozId,
        aAsorts[i].m_dIlosc,
        aAsorts[i].m_iKDOdpowId,
        aAsorts[i].m_sAsortSymbol,
        aAsorts[i].m_sAsortNazwa
      );
      if(oDetal.ShowModal() = mrOk) then begin
        SetLength(result, Length(result) + 1);
        result[High(result)]  := oDetal.DMAQFbN(sZLEZLECENIE_ID).AsInteger;
        oDetal.Free();
      end else begin
        oDetal.Free();
        break;
      end;
    end;  // for i := Low(aAsorts) to High(aAsorts)
  end;  // if(oQuery <> nil)
{$endif}
end;

function  TZLEDataManager.ZLEDopiszZlecenieZPozycjiZamowien(
  const ac_sZamowieniePozId:string;
  const ac_iTypZlecId:      integer // domylny typ zlecenia
):  TIntegerArray;
{$ifndef build_all}
type
  TrecAsort = record
    m_iAsortId:     integer;
    m_sAsortSymbol: string;
    m_sAsortNazwa:  string;
    m_iKDOdpowId:   integer;
    m_iReceptId:    integer;
    m_sReceptSymbol:string;
    m_dIlosc:       double;
    m_aZamowPozId:  array of integer;
  end;
var
  oDetal:   TZLEZlecenieDBDetailForm;
  oQuery:   TUNIQuery;
  oParams:  TKeyValues;
  aAsorts:  array of TrecAsort;
  i:        integer;
{$endif}
begin
  SetLength(result, 0);
{$ifndef build_all}
  oQuery  := ZAMDM.ZAMOdpytajODane(sZAMZAMOWIENIEPOZ,
{0} sZAMAlias_ZamowieniePoz_Id  + ';' + sZAMAlias_ZamowieniePoz_Ilosc + ';' +
{2} sZAMAlias_ASOAsort_Id       + ';' + sZAMAlias_ASOAsort_Symbol     + ';' +
{4} sZAMAlias_ASOAsort_Nazwa    + ';' + sZAMAlias_LWPRecept_Id        + ';' +
{6} sZAMAlias_LWPRecept_Symbol  + ';' + sZAMAlias_KDOsoba_Id          + ';' +
{8} sZAMAlias_Zamowienie_Id,
    '@' + sZAMAlias_ZamowieniePoz_Id + ' in(' + ac_sZamowieniePozId + ')',
    false
  );
  if(oQuery <> nil) then begin
    while(not oQuery.Eof) do begin
        // szukamy tego asortymentu
      i := 0;
      while(i < Length(aAsorts)) do begin
        if((aAsorts[i].m_iAsortId = oQuery.Fields[2].AsInteger) and
        (aAsorts[i].m_iReceptId = oQuery.Fields[5].AsInteger)) then
          break
        else
          Inc(i);
      end;  // while(i < Length(aAsorts))
      if(i >= Length(aAsorts)) then begin
        i := Length(aAsorts);
        SetLength(aAsorts, i+1);
        aAsorts[i].m_iAsortId     := oQuery.Fields[2].AsInteger;
        aAsorts[i].m_sAsortSymbol := oQuery.Fields[3].AsString;
        aAsorts[i].m_sAsortNazwa  := oQuery.Fields[4].AsString;
        aAsorts[i].m_iKDOdpowId   := oQuery.Fields[7].AsInteger;
        aAsorts[i].m_iReceptId    := oQuery.Fields[5].AsInteger;
        aAsorts[i].m_sReceptSymbol:= oQuery.Fields[6].AsString;
        aAsorts[i].m_dIlosc       := oQuery.Fields[1].AsFloat;
      end else
        aAsorts[i].m_dIlosc       := aAsorts[i].m_dIlosc + oQuery.Fields[1].AsFloat;
      SetLength(aAsorts[i].m_aZamowPozId, Length(aAsorts[i].m_aZamowPozId)+1);
      aAsorts[i].m_aZamowPozId[High(aAsorts[i].m_aZamowPozId)]  := oQuery.Fields[0].AsInteger;
      oQuery.Next();
    end;  // while(not oQuery.Eof)
    oQuery.Free();
    for i := Low(aAsorts) to High(aAsorts) do begin
      oParams := TKeyValues.CreateAs(
        [
          sZLEZLECENIE_ID + '=-1',
          cFORM_CAPTION   + '=Zlecenie',
          sUNIMODULZSI_ID + '=' + IntToStr(cZAMMODULZSI_ID)
        ]
      );
      if(ac_iTypZlecId <> 0) then
        oParams.Add(sZLETYPZLEC_ID + '=' + IntToStr(ac_iTypZlecId));
      oDetal  := (FormManager.OpenDBDetail(
        nil,  // aby detal nie prbowa odwiea tego grida
        'TZLEZlecenieDBDetailForm',
        omNew + omHidden,
        oParams
      ) as TZLEZlecenieDBDetailForm);
      oDetal.UstawDanePozycjiZamowienia(
        aAsorts[i].m_iAsortId,
        aAsorts[i].m_aZamowPozId,
        aAsorts[i].m_dIlosc,
        aAsorts[i].m_iKDOdpowId,
        aAsorts[i].m_sAsortSymbol,
        aAsorts[i].m_sAsortNazwa,
        aAsorts[i].m_iReceptId,
        aAsorts[i].m_sReceptSymbol
      );
      if(oDetal.ShowModal() = mrOk) then begin
        SetLength(result, Length(result) + 1);
        result[High(result)]  := oDetal.DMAQFbN(sZLEZLECENIE_ID).AsInteger;
        oDetal.Free();
      end else begin
        oDetal.Free();
        break;
      end;
    end;  // for i := Low(aAsorts) to High(aAsorts)
  end;  // if(oQuery <> nil)
{$endif}
end;

  {
    Funkcja dopisuje wizualnie JEDNO zlecenie nieprodukcyjne z pozycjami utworzonymi
    z przekazanych pozycji zamwie
  }
function  TZLEDataManager.ZLEDopiszZlecenieNieProdZPozycjiZamowien(
  const ac_iAdmIdFunkId:    integer;// funkcja z ADMID gdzie s zapisane idki pozycji zamwie z ktrych ma by utworzone zlecenie
  const ac_iTypZlecId:      integer // domylny typ zlecenia
):  integer;
{$ifndef build_all}
type
  TrecAsort = record
    m_iAsortId:     integer;
    m_sAsortSymbol: string;
    m_sAsortNazwa:  string;
    m_sAsortIndeks: string;
    m_sOpis:        string;
    m_iKDOdpowId:   integer;
    m_dIlosc:       double;
    m_iWykonawcaId: integer;
  end;
var
  oDetal:   TZLEZlecenieDBDetailForm;
  oQuery:   TUNIQuery;
  oParams:  TKeyValues;
  aAsorts:  array of TrecAsort;
  i:        integer;
{$endif}
begin
  result  := 0;
{$ifndef build_all}
  oQuery  := SQLManager.CreateQuery(
    'select ' +
{0}   'ZP.' + sZAMZAMOWIENIEPOZ_ID  + ', ZP.' + sZAMZAMOWIENIEPOZ_ILOSC + ', ' +
{2}   'A.'  + sASOASORT_ID          + ', A.'  + sASOASORT_SYMBOL        + ', ' +
{4}   'A.'  + sASOASORT_NAZWA       + ', A.'  + sASOASORT_INDEKS        + ', ' +
{6}   'Z.'  + sKDOSOBA_ID           + ', ZP.' + sZAMZAMOWIENIEPOZ_OPIS  + ', ' +
{8}   'Z.'  + sBKKLIENT_ID          +
    ' from ' +
      '%s Z, ' +
      '%s ZP, ' +
      '%s A, '  +
      '(' + ADMID_SelectSQL(ac_iAdmIdFunkId, 0, SecurityManager.UserId, '') + ') ADM' +
    ' where ' +
      'ZP.' + sZAMZAMOWIENIEPOZ_ID + ' = ADM.' + sADMID_V +
      ' and ZP.' + sZAMZAMOWIENIE_ID + ' = Z.' + sZAMZAMOWIENIE_ID +
      ' and ZP.' + sASOASORT_ID + ' = A.' + sASOASORT_ID +
    ' order by A.' + sASOASORT_SYMBOL + ', Z.' + sZAMZAMOWIENIE_SYMBOL
    ,
    [sZAMZAMOWIENIE, sZAMZAMOWIENIEPOZ, sASOASORT]
  );
  try
    oQuery.Open();
    while(not oQuery.Eof) do begin
        // szukamy tego asortymentu
      if((Length(aAsorts) = 0) or (aAsorts[High(aAsorts)].m_sAsortSymbol <> oQuery.Fields[3].AsString)) then begin
        i := Length(aAsorts);
        SetLength(aAsorts, i+1);
        aAsorts[i].m_dIlosc       := oQuery.Fields[1].AsFloat;
        aAsorts[i].m_iAsortId     := oQuery.Fields[2].AsInteger;
        aAsorts[i].m_sAsortSymbol := oQuery.Fields[3].AsString;
        aAsorts[i].m_sAsortNazwa  := oQuery.Fields[4].AsString;
        aAsorts[i].m_sAsortIndeks := oQuery.Fields[5].AsString;
        aAsorts[i].m_iKDOdpowId   := oQuery.Fields[6].AsInteger;
        aAsorts[i].m_sOpis        := oQuery.Fields[7].AsString;
        aAsorts[i].m_iWykonawcaId := oQuery.Fields[8].AsInteger;
      end else begin
        i := High(aAsorts);
        aAsorts[i].m_dIlosc := aAsorts[i].m_dIlosc + oQuery.Fields[1].AsFloat;
      end;
      oQuery.Next();
    end;  // while(not oQuery.Eof)
  finally
    FreeAndNil(oQuery);
  end;
  if(Length(aAsorts) > 0) then begin
    oParams := TKeyValues.CreateAs(
      [
        sZLEZLECENIE_ID + '=-1',
        cFORM_CAPTION   + '=Zlecenie',
        sUNIMODULZSI_ID + '=' + IntToStr(cZAMMODULZSI_ID)
      ]
    );
    if(ac_iTypZlecId <> 0) then
      oParams.Add(sZLETYPZLEC_ID + '=' + IntToStr(ac_iTypZlecId));
    oDetal  := (FormManager.OpenDBDetail(
      nil,  // aby detal nie prbowa odwiea tego grida
      'TZLEZlecenieDBDetailForm',
      omNew + omHidden,
      oParams
    ) as TZLEZlecenieDBDetailForm);
    try
      for i := Low(aAsorts) to High(aAsorts) do begin
        oDetal.DodajPozycjeZleceniaNieProd(
          aAsorts[i].m_iAsortId,
          aAsorts[i].m_dIlosc,
          aAsorts[i].m_iKDOdpowId,
          aAsorts[i].m_sOpis,
          aAsorts[i].m_sAsortSymbol,
          aAsorts[i].m_sAsortNazwa,
          aAsorts[i].m_sAsortIndeks,
          aAsorts[i].m_iWykonawcaId
        );
      end;  // for i := Low(aAsorts) to High(aAsorts)
      oDetal.PowiazZlecenieNieProdZZamowieniem(ac_iAdmIdFunkId);
      if(oDetal.ShowModal() = mrOk) then
        result  := oDetal.DMAQFbN(sZLEZLECENIE_ID).AsInteger;
    finally
      FreeAndNil(oDetal);
    end;
  end;  // if(Length(aAsorts) > 0)
{$endif}
end;

  {
    Funkcja dopisuje wizualnie JEDNO zlecenie nieprodukcyjne z pozycjami utworzonymi
    z przekazanych pozycji zapotrzebowa
  }
function  TZLEDataManager.ZLEDopiszZlecenieNieProdZPozycjiZapotrzebowan(
  const ac_iAdmIdFunkId:    integer;// funkcja z ADMID gdzie s zapisane idki pozycji zapotrzebowa z ktrych ma by utworzone zlecenie
  const ac_iTypZlecId:      integer // domylny typ zlecenia
):  integer;
{$ifndef build_all}
type
  TrecAsort = record
    m_iAsortId:     integer;
    m_sAsortSymbol: string;
    m_sAsortNazwa:  string;
    m_sAsortIndeks: string;
    m_sOpis:        string;
    m_iKDOdpowId:   integer;
    m_dIlosc:       double;
  end;

var
  oDetal:   TZLEZlecenieDBDetailForm;
  oQuery:   TUNIQuery;
  oParams:  TKeyValues;
  aAsorts:  array of TrecAsort;
  i:        integer;
{$endif}
begin
  result  := 0;
{$ifndef build_all}
  oQuery  := SQLManager.CreateQuery(
    'select ' +
{0}   'ZP.' + sZAOZAPOTRZPOZ_ID     + ', ZP.' + sZAOZAPOTRZPOZ_ILOSC    + ', ' +
{2}   'A.'  + sASOASORT_ID          + ', A.'  + sASOASORT_SYMBOL        + ', ' +
{4}   'A.'  + sASOASORT_NAZWA       + ', A.'  + sASOASORT_INDEKS        + ', ' +
{6}   'Z.'  + sKDOSOBA_ID           + ', ZP.' + sZAOZAPOTRZPOZ_OPIS     +
    ' from ' +
      '%s ZP'  +
        ' inner join %s Z' +
          ' on ZP.' + sZAOZAPOTRZ_ID + ' = Z.' + sZAOZAPOTRZ_ID +
        ' inner join %s A'  +
          ' on ZP.' + sASOASORT_ID   + ' = A.' + sASOASORT_ID +
        ' inner join (' +
          ADMID_SelectSQL(ac_iAdmIdFunkId, 0, SecurityManager.UserId, '') +
        ') ADM' +
          ' on ZP.' + sZAOZAPOTRZPOZ_ID + ' = ADM.' + sADMID_V +
    ' order by A.' + sASOASORT_SYMBOL
    ,
    [sZAOZAPOTRZPOZ, sZAOZAPOTRZ, sASOASORT]
  );
  try
    oQuery.Open();
    while(not oQuery.Eof) do begin
        // szukamy tego asortymentu
      if((Length(aAsorts) = 0) or (aAsorts[High(aAsorts)].m_iAsortId <> oQuery.Fields[2].AsInteger)) then begin
        i := Length(aAsorts);
        SetLength(aAsorts, i+1);

        aAsorts[i].m_dIlosc       := oQuery.Fields[1].AsFloat;
        aAsorts[i].m_iAsortId     := oQuery.Fields[2].AsInteger;
        aAsorts[i].m_sAsortSymbol := oQuery.Fields[3].AsString;
        aAsorts[i].m_sAsortNazwa  := oQuery.Fields[4].AsString;
        aAsorts[i].m_sAsortIndeks := oQuery.Fields[5].AsString;
        aAsorts[i].m_iKDOdpowId   := oQuery.Fields[6].AsInteger;
        aAsorts[i].m_sOpis        := oQuery.Fields[7].AsString;
      end else begin
        i := High(aAsorts);
        aAsorts[i].m_dIlosc := aAsorts[i].m_dIlosc + oQuery.Fields[1].AsFloat;
      end;
      oQuery.Next();
    end;  // while(not oQuery.Eof)
  finally
    FreeAndNil(oQuery);
  end;
  if(Length(aAsorts) > 0) then begin
    oParams := TKeyValues.CreateAs(
      [
        sZLEZLECENIE_ID + '=-1',
        cFORM_CAPTION   + '=Zlecenie',
        sUNIMODULZSI_ID + '=' + IntToStr(cZAOMODULZSI_ID)
      ]
    );
    if(ac_iTypZlecId <> 0) then
      oParams.Add(sZLETYPZLEC_ID + '=' + IntToStr(ac_iTypZlecId));
    oDetal  := (FormManager.OpenDBDetail(
      nil,  // aby detal nie prbowa odwiea tego grida
      'TZLEZlecenieDBDetailForm',
      omNew + omHidden,
      oParams
    ) as TZLEZlecenieDBDetailForm);
    try
      for i := Low(aAsorts) to High(aAsorts) do begin
        oDetal.DodajPozycjeZleceniaNieProd(
          aAsorts[i].m_iAsortId,
          aAsorts[i].m_dIlosc,
          aAsorts[i].m_iKDOdpowId,
          aAsorts[i].m_sOpis,
          aAsorts[i].m_sAsortSymbol,
          aAsorts[i].m_sAsortNazwa,
          aAsorts[i].m_sAsortIndeks,
          0 // id wykonawcy
        );
      end;  // for i := Low(aAsorts) to High(aAsorts)
      oDetal.PowiazZlecenieNieProdZZapotrzebowaniem(ac_iAdmIdFunkId);
      if(oDetal.ShowModal() = mrOk) then
        result  := oDetal.DMAQFbN(sZLEZLECENIE_ID).AsInteger;
    finally
      FreeAndNil(oDetal);
    end;
  end;  // if(Length(aAsorts) > 0)
{$endif}
end;

function  TZLEDataManager.ZLEDopiszZlecenieZPozycjiZapytan(
  const ac_sZapytaniePozId: string;
  const ac_iTypZlecId:      integer // domylny typ zlecenia
):  TIntegerArray;
{$ifndef build_all}
type
  TrecAsort = record
    m_iAsortId:     integer;
    m_sAsortSymbol: string;
    m_sAsortNazwa:  string;
    m_iKDOdpowId:   integer;
    m_iReceptId:    integer;
    m_sReceptSymbol:string;
    m_dIlosc:       double;
    m_aZapytPozId:  array of integer;
  end;
var
  oDetal:   TZLEZlecenieDBDetailForm;
  oQuery:   TUNIQuery;
  oParams:  TKeyValues;
  aAsorts:  array of TrecAsort;
  i:        integer;
{$endif}
begin
  SetLength(result, 0);
{$ifndef build_all}
  oQuery  := ZAMDM.ZAMOdpytajODane(sZAMZAPYTANIEPOZ,
{0} sZAMAlias_ZapytaniePoz_Id   + ';' + sZAMAlias_ZapytaniePoz_Ilosc  + ';' +
{2} sZAMAlias_ASOAsort_Id       + ';' + sZAMAlias_ASOAsort_Symbol     + ';' +
{4} sZAMAlias_ASOAsort_Nazwa    + ';' + sZAMAlias_LWPRecept_Id        + ';' +
{6} sZAMAlias_LWPRecept_Symbol  + ';' + sZAMAlias_KDOsoba_Id          + ';' +
{8} sZAMAlias_Zapytanie_Id,
    '@' + sZAMAlias_ZapytaniePoz_Id + ' in(' + ac_sZapytaniePozId + ')',
    false
  );
  if(oQuery <> nil) then begin
    while(not oQuery.Eof) do begin
        // szukamy tego asortymentu
      i := 0;
      while(i < Length(aAsorts)) do begin
        if((aAsorts[i].m_iAsortId = oQuery.Fields[2].AsInteger) and
        (aAsorts[i].m_iReceptId = oQuery.Fields[5].AsInteger)) then
          break
        else
          Inc(i);
      end;  // while(i < Length(aAsorts))
      if(i >= Length(aAsorts)) then begin
        i := Length(aAsorts);
        SetLength(aAsorts, i+1);
        aAsorts[i].m_iAsortId     := oQuery.Fields[2].AsInteger;
        aAsorts[i].m_sAsortSymbol := oQuery.Fields[3].AsString;
        aAsorts[i].m_sAsortNazwa  := oQuery.Fields[4].AsString;
        aAsorts[i].m_iKDOdpowId   := oQuery.Fields[7].AsInteger;
        aAsorts[i].m_iReceptId    := oQuery.Fields[5].AsInteger;
        aAsorts[i].m_sReceptSymbol:= oQuery.Fields[6].AsString;
        aAsorts[i].m_dIlosc       := oQuery.Fields[1].AsFloat;
      end else
        aAsorts[i].m_dIlosc       := aAsorts[i].m_dIlosc + oQuery.Fields[1].AsFloat;
      SetLength(aAsorts[i].m_aZapytPozId, Length(aAsorts[i].m_aZapytPozId)+1);
      aAsorts[i].m_aZapytPozId[High(aAsorts[i].m_aZapytPozId)]  := oQuery.Fields[0].AsInteger;
      oQuery.Next();
    end;  // while(not oQuery.Eof)
    oQuery.Free();
    for i := Low(aAsorts) to High(aAsorts) do begin
      oParams := TKeyValues.CreateAs(
        [
          sZLEZLECENIE_ID + '=-1',
          cFORM_CAPTION   + '=Zlecenie',
          sUNIMODULZSI_ID + '=' + IntToStr(cZAMMODULZSI_ID)
        ]
      );
      if(ac_iTypZlecId <> 0) then
        oParams.Add(sZLETYPZLEC_ID + '=' + IntToStr(ac_iTypZlecId));
      oDetal  := (FormManager.OpenDBDetail(
        nil,  // aby detal nie prbowa odwiea tego grida
        'TZLEZlecenieDBDetailForm',
        omNew + omHidden,
        oParams
      ) as TZLEZlecenieDBDetailForm);
      oDetal.UstawDanePozycjiZapytania(
        aAsorts[i].m_iAsortId,
        aAsorts[i].m_aZapytPozId,
        aAsorts[i].m_iKDOdpowId,
        aAsorts[i].m_dIlosc,
        aAsorts[i].m_sAsortSymbol,
        aAsorts[i].m_sAsortNazwa,
        aAsorts[i].m_iReceptId,
        aAsorts[i].m_sReceptSymbol
      );
      if(oDetal.ShowModal() = mrOk) then begin
        SetLength(result, Length(result) + 1);
        result[High(result)]  := oDetal.DMAQFbN(sZLEZLECENIE_ID).AsInteger;
        oDetal.Free();
      end else begin
        oDetal.Free();
        break;
      end;
    end;  // for i := Low(aAsorts) to High(aAsorts)
  end;  // if(oQuery <> nil)
{$endif}
end;

  {
    Funkcja dopisuje wizualnie JEDNO zlecenie nieprodukcyjne z pozycjami utworzonymi
    z przekazanych pozycji zapyta wejciowych
  }
function  TZLEDataManager.ZLEDopiszZlecenieNieProdZPozycjiZapytan(
  const ac_iAdmIdFunkId:    integer;// funkcja z ADMID gdzie s zapisane idki pozycji zapyta wejciowych z ktrych ma by utworzone zlecenie
  const ac_iTypZlecId:      integer // domylny typ zlecenia
):  integer;
{$ifndef build_all}
type
  TrecAsort = record
    m_iAsortId:     integer;
    m_sAsortSymbol: string;
    m_sAsortNazwa:  string;
    m_sAsortIndeks: string;
    m_sOpis:        string;
    m_iKDOdpowId:   integer;
    m_dIlosc:       double;
  end;
var
  oDetal:   TZLEZlecenieDBDetailForm;
  oQuery:   TUNIQuery;
  oParams:  TKeyValues;
  aAsorts:  array of TrecAsort;
  i:        integer;
{$endif}
begin
  result  := 0;
{$ifndef build_all}
  oQuery  := SQLManager.CreateQuery(
    'select ' +
{0} 'ZP.' + sZAMZAPYTANIEPOZ_ID + ', ZP.' + sZAMZAPYTANIEPOZ_ILOSC  + ', ' +
{2} 'ZP.' + sASOASORT_ID        + ', A.'  + sASOASORT_SYMBOL        + ', ' +
{4} 'A.'  + sASOASORT_NAZWA     + ', A.'  + sASOASORT_INDEKS        + ', ' +
{6} 'Z.'  + sKDOSOBA_ID         + ', ZP.' + sZAMZAPYTANIEPOZ_OPIS   +
    ' from ' +
      '%s ZP' +
        ' inner join %s Z' +
          ' on ZP.' + sZAMZAPYTANIE_ID  + ' = Z.' + sZAMZAPYTANIE_ID +
        ' left outer join %s A' +
          ' on ZP.' + sASOASORT_ID  + ' = A.' + sASOASORT_ID +
        ' inner join (' +
          ADMID_SelectSQL(ac_iAdmIdFunkId, 0, SecurityManager.UserId, '') +
        ') ADM' +
          ' on ZP.' + sZAMZAPYTANIEPOZ_ID + ' = ADM.' + sADMID_V +
    ' order by A.' + sASOASORT_SYMBOL,
    [sZAMZAPYTANIEPOZ, sZAMZAPYTANIE, sASOASORT]
  );
  try
    oQuery.Open();
    while(not oQuery.Eof) do begin
        // szukamy tego asortymentu

      if((Length(aAsorts) = 0) or (aAsorts[High(aAsorts)].m_iAsortId <> oQuery.Fields[2].AsInteger)) then begin
        i := Length(aAsorts);
        SetLength(aAsorts, i+1);

        aAsorts[i].m_dIlosc       := oQuery.Fields[1].AsFloat;
        aAsorts[i].m_iAsortId     := oQuery.Fields[2].AsInteger;
        aAsorts[i].m_sAsortSymbol := oQuery.Fields[3].AsString;
        aAsorts[i].m_sAsortNazwa  := oQuery.Fields[4].AsString;
        aAsorts[i].m_sAsortIndeks := oQuery.Fields[5].AsString;
        aAsorts[i].m_iKDOdpowId   := oQuery.Fields[6].AsInteger;
        aAsorts[i].m_sOpis        := oQuery.Fields[7].AsString;
      end else begin
        i := High(aAsorts);
        aAsorts[i].m_dIlosc := aAsorts[i].m_dIlosc + oQuery.Fields[1].AsFloat;
      end;
      oQuery.Next();
    end;  // while(not oQuery.Eof)
  finally
    FreeAndNil(oQuery);
  end;
  if(Length(aAsorts) > 0) then begin
    oParams := TKeyValues.CreateAs(
      [
        sZLEZLECENIE_ID + '=-1',
        cFORM_CAPTION   + '=Zlecenie',
        sUNIMODULZSI_ID + '=' + IntToStr(cZAMMODULZSI_ID)
      ]
    );
    if(ac_iTypZlecId <> 0) then
      oParams.Add(sZLETYPZLEC_ID + '=' + IntToStr(ac_iTypZlecId));
    oDetal  := (FormManager.OpenDBDetail(
      nil,  // aby detal nie prbowa odwiea tego grida
      'TZLEZlecenieDBDetailForm',
      omNew + omHidden,
      oParams
    ) as TZLEZlecenieDBDetailForm);
    try
      for i := Low(aAsorts) to High(aAsorts) do begin
        oDetal.DodajPozycjeZleceniaNieProd(
          aAsorts[i].m_iAsortId,
          aAsorts[i].m_dIlosc,
          aAsorts[i].m_iKDOdpowId,
          aAsorts[i].m_sOpis,
          aAsorts[i].m_sAsortSymbol,
          aAsorts[i].m_sAsortNazwa,
          aAsorts[i].m_sAsortIndeks,
          0 // id wykonawcy
        );
      end;  // for i := Low(aAsorts) to High(aAsorts)
      oDetal.PowiazZlecenieNieProdZZapytaniem(ac_iAdmIdFunkId);
      if(oDetal.ShowModal() = mrOk) then
        result  := oDetal.DMAQFbN(sZLEZLECENIE_ID).AsInteger;
    finally
      FreeAndNil(oDetal);
    end;
  end;  // if(Length(aAsorts) > 0)
{$endif}
end;

function TZLEDataManager.ZLEDopiszZlecenie( const cTypOperacji: TSposobNadaniaGrupy;
                                            var iGrupaID: Integer;
                                            iTypZleceniaID: Integer;
                                            iModulZSIID: Integer;
                                            iFirmaID: Integer = 0 ): Integer;
var oForm: TUNIDBDetailForm;
    oParams: TKeyValues;
    OpenMode: TOpenMode;
    oQuery: TUNIQuery;
    sWhere: String;
begin
  result := 0;

  if cTypOperacji = sngParametr then begin
    sWhere := '(@'+sZLEALIAS_ZLECENIE_ID+'=%d)';
    if iFirmaId <> 0 then
      sWhere := sWhere + 'and(@'+sZLEALIAS_ZLECENIE_ODDZIAL_ID+')';
    oQuery := ZLEDM.ZLEOdpytajODane( sZLEZLECENIE,
                                     sZLEALIAS_ZLECENIE_ID,
                                     Format( sWhere, [iGrupaID] ),
                                     true );
    try
      if oQuery = nil then
        raise EOF_ZLEException.Create( cError_BrakGrupy,
                                       ZLEPodajSlowneRozwiniecieKoduBledu( cError_BrakGrupy ),
                                       'ZLEDopiszZlecenie' );
    finally
      if oQuery <> nil then oQuery.Free;
    end;
  end else if (cTypOperacji = sngAutomat)and(iGrupaID = 0) then begin
    sWhere := '(@'+sZLEALIAS_TYPZLECENIA_ID+'=%d)';
    if iFirmaId <> 0 then
      sWhere := sWhere + 'and(@'+sZLEALIAS_TYPZLECENIA_ODDZIAL_ID+')';
    oQuery := ZLEDM.ZLEOdpytajODane( sZLETYPZLEC,
                                     sZLEALIAS_TYPZLECENIA_TYP_GRUPY_ID,
                                     Format( sWhere, [iTypZleceniaID] ),
                                     True );
    try
      if oQuery = nil then
        raise EOF_ZLEException.Create( cError_BrakTypuZlecenia,
                                       ZLEPodajSlowneRozwiniecieKoduBledu( cError_BrakTypuZlecenia ),
                                       'ZLEDopiszZlecenie' );
                                       
      iGrupaID := ZLEDopiszZlecenieGrupujace( oQuery.FieldByName(sZLETYPZLEC_TYP_GRUPY_ID).AsInteger,
                                              iModulZSIID, 'TA', 'Test automatu',
                                              'Zlecenie automatyczne', UNIDate,
                                              iFirmaID );
    finally
      if oQuery <> nil then oQuery.Free;
    end;
  end;


  oForm := nil;
  OpenMode := omShowModal or omNew;
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add(sUNIMODULZSI_ID+'='+IntToStr(iModulZSIID));
    Add(cFORM_CAPTION+'='+'Nowe zlecenie zewntrzne');
    Add(cZLEFuncRodzaj+'='+cZLEFuncZlecenie);
    if cTypOperacji in [sngParametr,sngAutomat] then begin
      Add(sZLEZLECENIE_GRUPA_ID+'='+IntToStr(iGrupaID));
    end;
  end;
  try
    oForm := FormManager.OpenDBDetail( Self, cKlasaZlecenie+cSuffixKlasyDBDetail,
                                       OpenMode, oParams );
    if oForm.ModalResult = mrOK then begin
      iGrupaID := oForm.DMAQFbN(sZLEZLECENIE_GRUPA_ID).AsInteger;
      result := oForm.DMAQFbN(sZLEZLECENIE_ID).AsInteger;
    end;
  finally                                       
    if oForm <> nil then oForm.Free;
  end;
end;

procedure TZLEDataManager.KontrolaZLEDodajZlecenie1Click(Sender: TObject);
begin
  //iGrupaID := 0;
  //ZLEDopiszZlecenie( sngAutomat, iGrupaID, 44, cZLEModulZSI_ID );
  UNIDopiszZlecenie( 68, cZLEModulZSI_ID,
                     'TESTOWE', 'Zlecenie testowe', 'Opis',
                     39429{Data}, 0, cZLEStatusZlecenia_OczekujaceID,
                     0, 0, vAktywnyRokObrachunkowyID, 0, 0,
                     '', 0, 0,0);
end;

function TZLEDataManager.UNIDopiszZlecenie( iTypZleceniaID, iModulZSIID: Integer;
                            sSymbol, sNazwa, sOpis: String;
                            dDataOtwarcia: TDate;
                            dDataZamkniecia: TDate;
                            sStatus: String = cZLEStatusZlecenia_OczekujaceID;
                            iOsobaOdp: Integer = 0;
                            iOsobaStatus: Integer = 0;
                            iUniRok_ID: Integer = 0;
                            iUniJednostkaOrg_ID: Integer = 0;
                            iWykonawca_ID: Integer = 0; //Kontrahent
                            sPotwierdzenie: String = '';
                            iFirmaID: Integer = 0;
                            iInfSiecElementID: Integer = 0;
                            iZleZlecenieGrupaID: Integer = 0 ): Integer;

begin
  {Funkcja w UNISYS}
  result := UNISYSDM.UNIDopiszZlecenie( iTypZleceniaID, iModulZSIID,
                            sSymbol, sNazwa, sOpis,
                            dDataOtwarcia,
                            dDataZamkniecia,
                            sStatus,
                            iOsobaOdp,
                            iOsobaStatus,
                            iUniRok_ID,
                            iUniJednostkaOrg_ID,
                            iWykonawca_ID,
                            sPotwierdzenie,
                            iFirmaID,
                            iInfSiecElementID,
                            iZleZlecenieGrupaID);
end;

{Funkcja zwraca True, jeli istnieje aktywne zlecenie
 dla podanego slementu infrastruktury i typu zlecenia.
 Wtedy mona dopisywa zlecenia anulowane albo zakoczone}
function TZLEDataManager.ZLEKontrolaUnikalnosciElemInf( iTypZleceniaID: Integer;
                                                        iInfElementID: Integer;
                                                        sPoziomInf: String;
                                                        iZlecenieID: Integer): Boolean;
var
  sWynik, sSQL: String;
  iIlosc: Integer;
begin
  try
    sSQL := 'SELECT Count(*) ' +
            'FROM %s ' +
            'WHERE ' + sZLETYPZLEC_ID + '=' + IntToStr(iTypZleceniaID) + ' AND ' +
                       sZLEZLECENIE_STATUS + ' NOT IN (' + QuotedStr(cZLEStatusZlecenia_ZakonczoneID) + ', ' +
                                                           QuotedStr(cZLEStatusZlecenia_AnulowaneID) + ') AND ' +
                       sZLEZLECENIE_POZIOMINF + '=' + QuotedStr(sPoziomInf) + ' AND ' +
                       sZLEZLECENIE_INF_ID + '=' + IntToStr(iInfElementID);
    if iZlecenieID > 0 then
       sSQL := sSQL + ' AND (' + sZLEZLECENIE_ID + '<>' + IntToStr(iZlecenieID) + ')';

    sWynik := SQLManager.OpenQueryWithResult(sSQL, [sZLEZLECENIE]);
    iIlosc := StrToInt(sWynik);
  except
    iIlosc := 0;
  end;
  Result := (iIlosc > 0);
end;


{Funkcja zwraca wszelkie symbole mnemonikw dla wskazanej pozycji zlecenia}
function TZLEDataManager.ZLEMnemonikiDlaPozycjiZlecenia(iZlecenieID, iZleceniePozID: Integer;
                                                        var av_aMnem: TaMnemValue): Integer;
var
  sSQL: String;
  q: TUniQuery;
  iIdx: Integer;
begin
  iIdx := Length(av_aMnem);
  {1. Mnemoniki ze pozycji zlecenia}
  if DataManagers.Available(sINFModulID) then begin
      sSQL := 'SELECT ' +
                'CASE  WHEN ' + sZLEZLECENIEPOZ_POZIOMINF + ' = ' + QuotedStr('0') + ' THEN ' + QuotedStr('ILO') + ' ' +
                      'WHEN ' + sZLEZLECENIEPOZ_POZIOMINF + ' = ' + QuotedStr('1') + ' THEN ' + QuotedStr('IZA') + ' ' +
                      'WHEN ' + sZLEZLECENIEPOZ_POZIOMINF + ' = ' + QuotedStr('2') + ' THEN ' + QuotedStr('IKL') + ' ' +
                      'WHEN ' + sZLEZLECENIEPOZ_POZIOMINF + ' = ' + QuotedStr('3') + ' THEN ' + QuotedStr('IBR') + ' ' +
                      'WHEN ' + sZLEZLECENIEPOZ_POZIOMINF + ' = ' + QuotedStr('4') + ' THEN ' + QuotedStr('IBU') + ' ' +
                      'WHEN ' + sZLEZLECENIEPOZ_POZIOMINF + ' = ' + QuotedStr('5') + ' THEN ' + QuotedStr('INI') + ' ';

      if vWielofirmowosc then
         sSQL := sSQL +
                      'WHEN ' + sZLEZLECENIEPOZ_POZIOMINF + ' = ' + QuotedStr('6') + ' THEN ' + QuotedStr('FIR') + ' ';

      if vWieloodzialowosc then
         sSQL := sSQL +
                      'WHEN ' + sZLEZLECENIEPOZ_POZIOMINF + ' = ' + QuotedStr('6') + ' THEN ' + QuotedStr('ODD') + ' ';

      sSQL := sSQL +
                      'WHEN ' + sZLEZLECENIEPOZ_POZIOMINF + ' = ' + QuotedStr('7') + ' THEN ' + QuotedStr('IRE') + ' ' +
                      'WHEN ' + sZLEZLECENIEPOZ_POZIOMINF + ' = ' + QuotedStr('8') + ' THEN ' + QuotedStr('ILU') + ' ' +
                      'WHEN ' + sZLEZLECENIEPOZ_POZIOMINF + ' = ' + QuotedStr('9') + ' THEN ' + QuotedStr('ISE') + ' ' +
                      'ELSE NULL ' +
                'END AS ' + sFKMNEMONIKI_MNEMONIK + ', ' +
                'poz.' + sZLEZLECENIEPOZ_INF_ID + ', ' +
                SQLManager.GetSPName(sINF_DAJSYMBOLOBIEKTU) + '(poz.' + sZLEZLECENIEPOZ_POZIOMINF + ', poz.' + sZLEZLECENIEPOZ_INF_ID +', ' + QuotedStr('SYMBOL') + ')  AS INF_SYMBOL ' +
              'FROM %s poz ' +
              'WHERE poz.' + sZLEZLECENIEPOZ_ID + ' = ' + IntToStr(iZleceniePozID);

     q := SQLManager.CreateQuery(sSQL, [sZLEZLECENIEPOZ]);
     try
        q.Open();
        if q <> nil then begin
           if not q.IsEmpty then begin
              if     (q.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString <> '')
                 and (q.FieldByName(sZLEZLECENIEPOZ_INF_ID).AsInteger > 0) then begin
                 SetLength(av_aMnem, iIdx + 1);
                 av_aMnem[iIdx].sName    := q.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString;
                 av_aMnem[iIdx].sValue   := IntToStr(q.FieldByName(sZLEZLECENIEPOZ_INF_ID).AsInteger);
                 Inc(iIdx);
              end;
           end;
        end;

     finally
        if q <> nil then FreeAndNil(q);
     end;
  end;

  {2. Mnemoniki dla pl uytkownika}
  sSQL := 'SELECT ' +
            'PUZ.' + sFKUZ_ID + ', ' +
            'PUZ.' + sUNIPOLAUZ_WARTID + ', ' +
            'FM.'  + sFKMNEMONIKI_MNEMONIK + ', ' +
            'FM.'  + sFKMNEMONIKI_TABELA + ' ' +
          'FROM %s PUZ, %s DEF, %s WSK, %s FM ' +
          'WHERE PUZ.' + sUNIPOLAUZWSK_ID + ' = WSK.' + sUNIPOLAUZWSK_ID + ' ' +
            'AND WSK.' + sUNIPOLAUZDEF_ID + ' = DEF.' + sUNIPOLAUZDEF_ID + ' ' +
            'AND FM.'  + sFKMNEMONIKI_ID  + ' = DEF.' + sFKMNEMONIKI_ID + ' ' +
            'AND PUZ.' + sUNIPOLAUZ_FSUBELEMID + ' = ' + IntToStr(iZleceniePozID);

   q := SQLManager.CreateQuery(sSQL, [sUNIPOLAUZ, sUNIPOLAUZDEF, sUNIPOLAUZWSK, sFKMNEMONIKI]);
   try
      q.Open();
      if q <> nil then begin
         while not q.Eof do begin
           {1. Tabela <> FKUZ}
           if (q.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString <> '') then begin
             if (q.FieldByName(sFKMNEMONIKI_TABELA).AsString = sFKUZ) then begin
               if (q.FieldByName(sFKUZ_ID).AsInteger > 1) then begin
                  SetLength(av_aMnem, iIdx + 1);
                  av_aMnem[iIdx].sName  := q.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString;
                  av_aMnem[iIdx].sValue := IntToStr(q.FieldByName(sFKUZ_ID).AsInteger);
                  Inc(iIdx);
               end;
             end else begin
               if (q.FieldByName(sUNIPOLAUZ_WARTID).AsInteger > 0) then begin
                  SetLength(av_aMnem, iIdx + 1);
                  av_aMnem[iIdx].sName  := q.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString;
                  av_aMnem[iIdx].sValue := IntToStr(q.FieldByName(sUNIPOLAUZ_WARTID).AsInteger);
                  Inc(iIdx);
               end;
             end;
           end;
           q.Next;
         end;
      end;
   finally
      if q <> nil then FreeAndNil(q);
   end;
   result := 0;
end;



function TZLEDataManager.ZLEUstawStatusySpraw(iZlecenieID: Integer;
                                              sZLEStatusPrzed: String;
                                              sZleListaSprawPrzed: String): Integer;
var
  vZLEListaSprawZlecenPo                  : TUNIQuery;
  sZLEListaSprawPo, sZleStatusPo          : String;
  bWszystkieAnulowane,
  bWszystkieOczekujace,
  bWszystkieWstrzymane,
  bWszystkieZakonczone                    : Boolean;
  iAktSprawa                              : Integer;
  sAktStatusSprawy, sSQL                  : String;

begin
  Result := 0;
  {$ifndef build_all}
  if not DataManagers.Available(sBOKModulID) then Exit;

  {Aktualizacja statusw spraw powizanych ze zleceniem}
  sZLEStatusPo := SQLManager.OpenQueryWithResult('SELECT ' + sZLEZLECENIE_STATUS + ' ' +
                                                 'FROM %s ' +
                                                 'WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID),
                                                 [sZLEZLECENIE]);

  sZleListaSprawPo := SQLManager.OpenQueryWithResult('SELECT %s.JoinStrings(CURSOR(' +
                                                          'SELECT DISTINCT ' + sBOKSPRAWA_ID + ' ' +
                                                          'FROM %s WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID) + ')) FROM DUAL',
                                                     ['DODATKI_PACKAGE', sZLEZLECENIEPOZ]);

  if (sZleListaSprawPo = '') and (sZleListaSprawPrzed = '') then Exit;

  sSQL := 'SELECT ZP.' + sZLEZLECENIE_ID + ', ' +
                 'ZL.' + sZLEZLECENIE_STATUS + ', ' +
                 'ZP.' + sBOKSPRAWA_ID + ', ' +
                 'BS.' + sBOKSPRAWA_STATUS + ' ' +
          'FROM %s ZP, %s ZL, %s BS ' +
          'WHERE BS.' + sBOKSPRAWA_ID + ' = ZP.' + sBOKSPRAWA_ID + ' AND ' +
                'ZP.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' AND ';

  if sZleListaSprawPrzed = '' then begin
     sSQL := sSQL +
                '(ZP.' + sBOKSPRAWA_ID + ' IN (SELECT DISTINCT ' + sBOKSPRAWA_ID + ' ' +
                                               'FROM %s WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID) + '))';

     sSQL := sSQL + ' ORDER BY ZP.' + sBOKSPRAWA_ID + ', BS.' + sBOKSPRAWA_STATUS;
     vZLEListaSprawZlecenPo := SQLManager.CreateQuery(sSQL, [sZLEZLECENIEPOZ, sZLEZLECENIE,
                                                             sBOKSPRAWA, sZLEZLECENIEPOZ]);

  end else begin
     sSQL := sSQL +
                '((ZP.' + sBOKSPRAWA_ID + ' IN (SELECT DISTINCT ' + sBOKSPRAWA_ID + ' ' +
                                               'FROM %s WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID) + ')) OR ' +
               '  (ZP.' + sBOKSPRAWA_ID + ' IN (' + sZleListaSprawPrzed + ')))';

     sSQL := sSQL + ' UNION ' +
               'SELECT NULL, NULL, BS.' + sBOKSPRAWA_ID + ', BS.' + sBOKSPRAWA_STATUS + ' ' +
               'FROM %s BS ' +
               'WHERE (BS.' + sBOKSPRAWA_ID + ' IN (' + sZleListaSprawPrzed + ')) AND ' +
                     '(BS.' + sBOKSPRAWA_ID + ' NOT IN (SELECT DISTINCT ' + sBOKSPRAWA_ID +
                                                       ' FROM %s WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID) + ')) AND ' +
                     ' NOT EXISTS (SELECT ' + sBOKSPRAWA_ID +
                                 ' FROM %s WHERE ' + sBOKSPRAWA_ID + ' = BS.' + sBOKSPRAWA_ID + ') ';

     sSQL := sSQL + ' ORDER BY ' + sBOKSPRAWA_ID + ', ' + sBOKSPRAWA_STATUS;

     vZLEListaSprawZlecenPo := SQLManager.CreateQuery(sSQL, [sZLEZLECENIEPOZ, sZLEZLECENIE,
                                                             sBOKSPRAWA, sZLEZLECENIEPOZ,
                                                             sBOKSPRAWA, sZLEZLECENIEPOZ,
                                                             sZLEZLECENIEPOZ]);

  end;

  try
    vZLEListaSprawZlecenPo.Open;

    bWszystkieAnulowane  := True;
    bWszystkieOczekujace := True;
    bWszystkieWstrzymane := True;
    bWszystkieZakonczone := True;
    iAktSprawa := -1;
    sAktStatusSprawy := '';
    while not vZLEListaSprawZlecenPo.Eof do begin
       if (iAktSprawa <> vZLEListaSprawZlecenPo.FieldByName(sBOKSPRAWA_ID).AsInteger) and
          (iAktSprawa <> -1) then begin

          {zapisanie statusu sprawy}
          if bWszystkieOczekujace then begin
             if sAktStatusSprawy <> sBOKCONST_SSTATUS_PRZYJETA_ID then
                BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_PRZYJETA_ID, UNINow());
          end else
          if bWszystkieWstrzymane then begin
             if sAktStatusSprawy <> sBOKCONST_SSTATUS_ZAWIESZONA_ID then
                BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_ZAWIESZONA_ID, UNINow());
          end else
          if bWszystkieZakonczone then begin
             if sAktStatusSprawy <> sBOKCONST_SSTATUS_ZAKONCZONA_ID then
                BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_ZAKONCZONA_ID, UNINow());
          end else
          if bWszystkieAnulowane then begin
             if sAktStatusSprawy <> sBOKCONST_SSTATUS_ANULOWANA_ID then
                BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_ANULOWANA_ID, UNINow())
          end else begin
             if sAktStatusSprawy <> sBOKCONST_SSTATUS_REALIZOWANA_ID then
                BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_REALIZOWANA_ID, UNINow());
          end;

          iAktSprawa       := vZLEListaSprawZlecenPo.FieldByName(sBOKSPRAWA_ID).AsInteger;
          sAktStatusSprawy := vZLEListaSprawZlecenPo.FieldByName(sBOKSPRAWA_STATUS).AsString;

          bWszystkieAnulowane  := (vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_AnulowaneID);
          bWszystkieOczekujace := ((vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_OczekujaceID) or vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).IsNull);
          bWszystkieWstrzymane := (vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_WstrzymaneID);
          bWszystkieZakonczone := (vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_ZakonczoneID);
       end else begin

          if (iAktSprawa = -1) then begin
              iAktSprawa       := vZLEListaSprawZlecenPo.FieldByName(sBOKSPRAWA_ID).AsInteger;
              sAktStatusSprawy := vZLEListaSprawZlecenPo.FieldByName(sBOKSPRAWA_STATUS).AsString;
          end;

          bWszystkieAnulowane  := bWszystkieAnulowane  and (vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_AnulowaneID);
          bWszystkieOczekujace := bWszystkieOczekujace and ((vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_OczekujaceID) or vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).IsNull);
          bWszystkieWstrzymane := bWszystkieWstrzymane and (vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_WstrzymaneID);
          bWszystkieZakonczone := bWszystkieZakonczone and (vZLEListaSprawZlecenPo.FieldByName(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_ZakonczoneID);
       end;

       vZLEListaSprawZlecenPo.Next;
    end;

    if iAktSprawa <> -1 then begin
       {Zapisanie statusu dla ostatniej sprawy}
       if bWszystkieOczekujace then begin
          if sAktStatusSprawy <> sBOKCONST_SSTATUS_PRZYJETA_ID then
             BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_PRZYJETA_ID, UNINow());
       end else
       if bWszystkieWstrzymane then begin
          if sAktStatusSprawy <> sBOKCONST_SSTATUS_ZAWIESZONA_ID then
             BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_ZAWIESZONA_ID, UNINow());
       end else
       if bWszystkieZakonczone then begin
          if sAktStatusSprawy <> sBOKCONST_SSTATUS_ZAKONCZONA_ID then
             BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_ZAKONCZONA_ID, UNINow());
       end else
       if bWszystkieAnulowane then begin
          if sAktStatusSprawy <> sBOKCONST_SSTATUS_ANULOWANA_ID then
             BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_ANULOWANA_ID, UNINow());
       end else begin
          if sAktStatusSprawy <> sBOKCONST_SSTATUS_REALIZOWANA_ID then
             BOKDM.ZmienStatusSprawy(iAktSprawa, sBOKCONST_SSTATUS_REALIZOWANA_ID, UNINow());
       end;
    end;
    vZLEListaSprawZlecenPo.Close;
  finally
    if vZLEListaSprawZlecenPo <> nil then FreeAndNil(vZLEListaSprawZlecenPo);
  end;
  {$endif}
end;

{Funkcja zwraca wszelkie symbole mnemonikw dla wskazanego zlecenia}
function TZLEDataManager.ZLEMnemonikiDlaZlecenia(iZlecenieID : Integer;
                                                 var av_aMnem: TaMnemValue): Integer;
var
  sSQL: String;
  q: TUniQuery;
  iIdx: Integer;
begin
//  result := -1;//Bd 0 = poprawnie
  iIdx := Length(av_aMnem);
  {1. Mnemoniki ze zlecenia}
  sSQL := 'SELECT ZT.' + sZLETYPZLEC_SYMBOL;
  if vWielofirmowosc or (vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial) then
     sSQL := sSQL + ', ODDZ.' + sUNIODDZIAL_SYMBOL;

  sSQL := sSQL + ', ' +
                 'UJ.' + sUNIJEDNOSTKAORG_SYMBOL + ', ' +
                 'BK.' + sBKKLIENT_SYMBOL;

  if DataManagers.Available(sINFModulID) then begin
     sSQL := sSQL + ', ' +
                 'INFNIE.' + sINFNIERUCHOMOSC_SYMBOL + ', ' +
                 'INFBUD.' + sINFBUDYNEK_SYMBOL + ', ' +
                 'INFLOK.' + sINFLOKAL_SYMBOL + ', ' +
                 'INFKL.' + sINFKLATKA_SYMBOL + ', ' +
                 'INFUL.' + sINFULICA_SYMBOL + ', ' +
                 'INFZAS.' + sINFZASOB_SYMBOL + ', ' +
                 'INFSIEC.' + sINFSIECELEMENT_SYMBOL;
  end;

  if DataManagers.Available(sASOModulID) then begin
     sSQL := sSQL + ', ' +
                 'ASO.' + sASOASORT_SYMBOL;
  end;

  if DataManagers.Available(sLWPModulID) then begin
     sSQL := sSQL + ', ' +
                 'LWPREC.' + sLWPRECEPTURA_SYMBOL;
  end;

  sSQL := sSQL + ', ' +
                 'ZLEPRE.' + sZLEPREFIX_SYMBOL + ' ' +
          'FROM ' +
                 SQLManager.GetTableName(sZLEZLECENIE) + ' ZL, ';

  if vWielofirmowosc or (vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial) then
     sSQL := sSQL + SQLManager.GetTableName(sUNIODDZIAL) + ' ODDZ, ';

  sSQL := sSQL +
                 SQLManager.GetTableName(sUNIJEDNOSTKAORG) + ' UJ, ' +
                 SQLManager.GetTableName(sZLETYPZLEC) + ' ZT, ' +
                 SQLManager.GetTableName(sBKKLIENT) + ' BK';

  if DataManagers.Available(sINFModulID) then begin
     sSQL := sSQL + ', ' +
                 SQLManager.GetTableName(sINFNIERUCHOMOSC) + ' INFNIE, ' +
                 SQLManager.GetTableName(sINFBUDYNEK) + ' INFBUD, ' +
                 SQLManager.GetTableName(sINFLOKAL) + ' INFLOK, ' +
                 SQLManager.GetTableName(sINFKLATKA) + ' INFKL, ' +
                 SQLManager.GetTableName(sINFULICA) + ' INFUL, ' +
                 SQLManager.GetTableName(sINFZASOB) + ' INFZAS, ' +
                 SQLManager.GetTableName(sINFSIECELEMENT) + ' INFSIEC';
  end;

  if DataManagers.Available(sASOModulID) then begin
     sSQL := sSQL + ', ' +
                 SQLManager.GetTableName(sASOASORT) + ' ASO';
  end;

  if DataManagers.Available(sLWPModulID) then begin
     sSQL := sSQL + ', ' +
                  SQLManager.GetTableName(sLWPRECEPTURA) +  ' LWPREC';
  end;

  sSQL := sSQL + ', ' +
                  SQLManager.GetTableName(sZLEPREFIX) + ' ZLEPRE ' +
          'WHERE ' + 'ZL.' + sZLETYPZLEC_ID + ' = ' + 'ZT.' + sZLETYPZLEC_ID + ' (+) AND ';

  if vWielofirmowosc or (vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial) then
     sSQL := sSQL + 'ZL.' + sUNIODDZIAL_ID + ' = ' + 'ODDZ.' + sUNIODDZIAL_ID + ' (+) AND ';

  sSQL := sSQL +
                 'ZL.' + sUNIJEDNOSTKAORG_ID + ' = ' + 'UJ.' + sUNIJEDNOSTKAORG_ID + ' (+) AND ' +
                 'ZL.' + sZLEZLECENIE_WYKONAWCA_ID + ' = ' + 'BK.' + sBKKLIENT_ID + ' (+)';

  if DataManagers.Available(sINFModulID) then begin
     sSQL := sSQL + ' AND ' +
                 'ZL.' + sINFNIERUCHOMOSC_ID + ' = ' + 'INFNIE.' + sINFNIERUCHOMOSC_ID + ' (+) AND ' +
                 'ZL.' + sINFBUDYNEK_ID + ' = ' + 'INFBUD.' + sINFBUDYNEK_ID + ' (+) AND ' +
                 'ZL.' + sINFLOKAL_ID + ' = ' + 'INFLOK.' + sINFLOKAL_ID + ' (+) AND ' +
                 'ZL.' + sINFKLATKA_ID + ' = ' + 'INFKL.' + sINFKLATKA_ID + ' (+) AND ' +
                 'ZL.' + sINFULICA_ID + ' = ' + 'INFUL.' + sINFULICA_ID + ' (+) AND ' +
                 'ZL.' + sINFSIECELEMENT_ID + ' = ' + 'INFSIEC.' + sINFSIECELEMENT_ID + ' (+) AND ' +
                 'ZL.' + sINFZASOB_ID + ' = ' + 'INFZAS.' + sINFZASOB_ID + ' (+)';
   end;

   if DataManagers.Available(sASOModulID) then begin
      sSQL := sSQL + ' AND ' +
                 'ZL.' + sASOASORT_ID + ' = ' + 'ASO.' + sASOASORT_ID + ' (+)';
   end;

   if DataManagers.Available(sLWPModulID) then begin
      sSQL := sSQL + ' AND ' +
                 'ZL.' + sLWPRECEPTURA_ID + ' = LWPREC.' + sLWPRECEPTURA_ID + ' (+)';
   end;

   sSQL := sSQL + ' AND ' +
                 'ZL.' + sZLEZLECENIE_PREFIX_ID + ' = ' + 'ZLEPRE.' + sZLEPREFIX_ID + ' (+) AND ' +
                 'ZL.' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID);

   q := SQLManager.CreateQuery(sSQL, []);
   try
      q.Open();
      if q <> nil then begin
         if not q.IsEmpty then begin
            iIdx  := Length(av_aMnem);

            if vWielofirmowosc or (vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial) then begin
                SetLength(av_aMnem, iIdx + 1);
                if vWieloodzialowosc then
                   av_aMnem[iIdx].sName := sMnemonikOddzialy
                else if vWielofirmowosc then
                   av_aMnem[iIdx].sName := sMnemonikFirmy;
                av_aMnem[iIdx].sValue   := q.FieldByName(sUNIODDZIAL_SYMBOL).AsString;
                Inc(iIdx);

                if vWieloodzialowosc then begin
                   SetLength(av_aMnem, iIdx + 1);
                   av_aMnem[iIdx].sName  := sMnemonikOddzialZeZlecenia;
                   av_aMnem[iIdx].sValue := q.FieldByName(sUNIODDZIAL_SYMBOL).AsString;
                   Inc(iIdx);
                end;
            end;

            if q.FieldByName(sUNIJEDNOSTKAORG_SYMBOL).AsString <> '' then begin
               SetLength(av_aMnem, iIdx + 1);
               av_aMnem[iIdx].sName    := sMnemonikJednostkaOrg;
               av_aMnem[iIdx].sValue   := q.FieldByName(sUNIJEDNOSTKAORG_SYMBOL).AsString;
               Inc(iIdx);
               SetLength(av_aMnem, iIdx + 1);
               av_aMnem[iIdx].sName    := sMnemonikJednostkaZeZlecenia;
               av_aMnem[iIdx].sValue   := q.FieldByName(sUNIJEDNOSTKAORG_SYMBOL).AsString;
               Inc(iIdx);
            end;

            if q.FieldByName(sBKKLIENT_SYMBOL).AsString <> '' then begin
                SetLength(av_aMnem, iIdx + 1);
                av_aMnem[iIdx].sName    := sMnemonikKontrahenci;
                av_aMnem[iIdx].sValue   := q.FieldByName(sBKKLIENT_SYMBOL).AsString;
                Inc(iIdx);
                SetLength(av_aMnem, iIdx + 1);
                av_aMnem[iIdx].sName    := sMnemonikKlientZeZlecenia;
                av_aMnem[iIdx].sValue   := q.FieldByName(sBKKLIENT_SYMBOL).AsString;
                Inc(iIdx);
            end;

            if q.FieldByName(sZLETYPZLEC_SYMBOL).AsString <> '' then begin
                SetLength(av_aMnem, iIdx + 1);
                av_aMnem[iIdx].sName    := sMnemonikTypZlecenia;
                av_aMnem[iIdx].sValue   := q.FieldByName(sZLETYPZLEC_SYMBOL).AsString;
                Inc(iIdx);
            end;

            if q.FieldByName(sZLEPREFIX_SYMBOL).AsString <> '' then begin
                SetLength(av_aMnem, iIdx + 1);
                av_aMnem[iIdx].sName    := sMnemonikZLEPrefix;
                av_aMnem[iIdx].sValue   := q.FieldByName(sZLEPREFIX_SYMBOL).AsString;
                Inc(iIdx);
            end;

            if DataManagers.Available(sINFModulID) then begin
               if q.FieldByName(sINFNIERUCHOMOSC_SYMBOL).AsString <> '' then begin
                  SetLength(av_aMnem, iIdx + 1);
                  av_aMnem[iIdx].sName    := sMnemonikNieruchomosci;
                  av_aMnem[iIdx].sValue   := q.FieldByName(sINFNIERUCHOMOSC_SYMBOL).AsString;
                  Inc(iIdx);
                end;

                if q.FieldByName(sINFBUDYNEK_SYMBOL).AsString <> '' then begin
                  SetLength(av_aMnem, iIdx + 1);
                  av_aMnem[iIdx].sName    := sMnemonikBudynki;
                  av_aMnem[iIdx].sValue   := q.FieldByName(sINFBUDYNEK_SYMBOL).AsString;
                  Inc(iIdx);
                end;

                if q.FieldByName(sINFLOKAL_SYMBOL).AsString <> '' then begin
                  SetLength(av_aMnem, iIdx + 1);
                  av_aMnem[iIdx].sName    := sMnemonikLokale;
                  av_aMnem[iIdx].sValue   := q.FieldByName(sINFLOKAL_SYMBOL).AsString;
                  Inc(iIdx);
                end;

                if q.FieldByName(sINFKLATKA_SYMBOL).AsString <> '' then begin
                  SetLength(av_aMnem, iIdx + 1);
                  av_aMnem[iIdx].sName    := sMnemonikKlatki;
                  av_aMnem[iIdx].sValue   := q.FieldByName(sINFKLATKA_SYMBOL).AsString;
                  Inc(iIdx);
                end;

                if q.FieldByName(sINFULICA_SYMBOL).AsString <> '' then begin
                  SetLength(av_aMnem, iIdx + 1);
                  av_aMnem[iIdx].sName    := sMnemonikUlice;
                  av_aMnem[iIdx].sValue   := q.FieldByName(sINFULICA_SYMBOL).AsString;
                  Inc(iIdx);
                end;

                if q.FieldByName(sINFZASOB_SYMBOL).AsString <> '' then begin
                  SetLength(av_aMnem, iIdx + 1);
                  av_aMnem[iIdx].sName    := sMnemonikZasoby;
                  av_aMnem[iIdx].sValue   := q.FieldByName(sINFZASOB_SYMBOL).AsString;
                  Inc(iIdx);
                end;
                if q.FieldByName(sINFSIECELEMENT_SYMBOL).AsString <> '' then begin
                  SetLength(av_aMnem, iIdx + 1);
                  av_aMnem[iIdx].sName    := sMnemonikElemSieci;
                  av_aMnem[iIdx].sValue   := q.FieldByName(sINFSIECELEMENT_SYMBOL).AsString;
                  Inc(iIdx);
                end;
            end;

            if DataManagers.Available(sASOModulID) and (q.FieldByName(sASOASORT_SYMBOL).AsString <> '')then begin
                SetLength(av_aMnem, iIdx + 1);
                av_aMnem[iIdx].sName    := sMnemonikAsoAsort;
                av_aMnem[iIdx].sValue   := q.FieldByName(sASOASORT_SYMBOL).AsString;
                Inc(iIdx);
            end;

            if DataManagers.Available(sLWPModulID) and (q.FieldByName(sLWPRECEPTURA_SYMBOL).AsString <> '') then begin
                SetLength(av_aMnem, iIdx + 1);
                av_aMnem[iIdx].sName    := sMnemonikLWPReceptura;
                av_aMnem[iIdx].sValue   := q.FieldByName(sLWPRECEPTURA_SYMBOL).AsString;
                Inc(iIdx);
            end;
         end;
      end;

   finally
      if q <> nil then FreeAndNil(q);
   end;

  {2. Mnemoniki dla pl uytkownika}
  sSQL := 'SELECT ' +
                'FUZ.' + sFKUZ_SYMBOL + ', ' +
                'DEF.' + sFKMNEMONIKI_ID + ', ' +
                'MNEM.' + sFKMNEMONIKI_MNEMONIK + ', ' +
                'MNEM.' + sFKMNEMONIKI_TABELA + ', ' +
                'M.' + sFKUZ_ID + ', ' +
                'M.' + sUNIPOLAUZ_WART + ' ' +
         'FROM %s FUZ, %s MNEM, %s M, %s DEF, %s W, %s ZLE ' +
         'WHERE ' +
                'W.' + sUNIPOLAUZDEF_ID + ' = DEF.' + sUNIPOLAUZDEF_ID + ' AND ' +
                'W.' + sUNIPOLAUZWSK_ID + ' = M.' + sUNIPOLAUZWSK_ID + ' AND ' +
                'M.' + sFKUZ_ID + ' = FUZ.' + sFKUZ_ID + '(+) AND ' +
                'DEF.' + sFKMNEMONIKI_ID + ' = MNEM.' + sFKMNEMONIKI_ID + ' AND ' +
                'MNEM.' + sFKMNEMONIKI_INDEKS + ' = 0 AND ' +
                'M.' + sUNIPOLAUZ_FELEMENTID + ' = ZLE.' + sZLEZLECENIE_ID + ' AND ' +
                'W.' + sUNIPOLAUZWSK_FUNKID + ' = ZLE.' + sZLETYPZLEC_ID + ' AND ' +
                'W.' + sUNIPOLAUZWSK_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEZlecenie) + ' AND ' +
                'M.' + sUNIPOLAUZ_FELEMENTID + ' = ' + IntToStr(iZlecenieID);

   q := SQLManager.CreateQuery(sSQL, [sFKUZ,         sFKMNEMONIKI,
                                      sUNIPOLAUZ,    sUNIPOLAUZDEF,
                                      sUNIPOLAUZWSK, sZLEZLECENIE]);
   try
      q.Open();
      if q <> nil then begin
         while not q.Eof do begin
           {1. Tabela <> FKUZ}
           if q.FieldByName(sFKMNEMONIKI_TABELA).AsString = sFKUZ then begin
               if (q.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString <> '')
                  and (q.FieldByName(sFKUZ_SYMBOL).AsString <> '') then begin
                  SetLength(av_aMnem, iIdx + 1);
                  av_aMnem[iIdx].sName  := q.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString;
                  av_aMnem[iIdx].sValue := q.FieldByName(sFKUZ_SYMBOL).AsString;
                  Inc(iIdx);
               end;
           end else begin
               if (q.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString <> '')
                  and (q.FieldByName(sUNIPOLAUZ_WART).AsString <> '') then begin
                  SetLength(av_aMnem, iIdx + 1);
                  av_aMnem[iIdx].sName  := q.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString;
                  av_aMnem[iIdx].sValue := q.FieldByName(sUNIPOLAUZ_WART).AsString;
                  Inc(iIdx);
               end;
           end;

           q.Next;
         end;
      end;
   finally
      if q <> nil then FreeAndNil(q);
   end;

   q := SQLManager.CreateQuery('SELECT ' +
                                  '(SELECT ZL2.' + sUNIJEDNOSTKAORG_ID + ' ' +
                                   'FROM %s ZL2 ' +
                                   'WHERE ZL2.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_GRUPA_ID + ') AS ' + sUNIJEDNOSTKAORG_ID + ', ' +
                                  '(SELECT JD2.' + sUNIJEDNOSTKAORG_SYMBOL + ' ' +
                                   'FROM %s ZL3, %s JD2 ' +
                                   'WHERE ZL3.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_GRUPA_ID + ' AND ' +
                                         'ZL3.' + sUNIJEDNOSTKAORG_ID + ' = JD2.' + sUNIJEDNOSTKAORG_ID + ') AS ' + sUNIJEDNOSTKAORG_SYMBOL + ' ' +
                              'FROM %s ZL ' +
                              'WHERE ZL.' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZlecenieID),
                              [sZLEZLECENIE, sZLEZLECENIE, sUNIJEDNOSTKAORG, sZLEZLECENIE]);
   try
     q.Open();
     if not q.isEmpty then begin
        if q.FieldByName(sUNIJEDNOSTKAORG_SYMBOL).AsString <> '' then begin
          SetLength(av_aMnem, iIdx + 1);
          av_aMnem[iIdx].sName  := sMnemonikJednZlecNadrzed; //XJN
          av_aMnem[iIdx].sValue := q.FieldByName(sUNIJEDNOSTKAORG_SYMBOL).AsString;
//          Inc(iIdx);
        end;
     end;
   finally
     if q <> nil then FreeAndNil(q);
   end;
   result := 0;

end;

procedure TZLEDataManager.ZLEListaMnemonikow(slMnemZle: TStringList;
                                             iFirmaID: Integer = 0);
var
  sWar: String;
  q: TUNIQuery;
  bNieruchomosc, bBudynek,
  bLokal, bKlatka, bUlica,
  bZasob, bSiecElement,
  bJednostkaOrg,
  bWykonawca: Boolean;
begin
  {Mnemoniki stae dla zlece}
  if vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial then begin
    slMnemZle.Add(sMnemonikOddzialy);
    slMnemZle.Add(sMnemonikOddzialZeZlecenia);
  end else if vWielofirmowosc then slMnemZle.Add(sMnemonikFirmy);

  slMnemZle.Add(sMnemonikTypZlecenia);

  if ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0) then
     slMnemZle.Add(sMnemonikZLEPrefix);

  bNieruchomosc := False;
  bBudynek      := False;
  bLokal        := False;
  bKlatka       := False;
  bUlica        := False;
  bZasob        := False;
  bSiecElement  := False;
  bJednostkaOrg := False;
  bWykonawca    := False;

  sWar := '';
  if vWielofirmowosc {or (vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial)} then begin
     if (iFirmaID > 0) then
          sWar := ' WHERE ' + sUNIODDZIAL_ID + ' = ' + IntToStr(iFirmaID)
     else sWar := ' WHERE ' + sUNIODDZIAL_ID + ' = ' + IntToStr(vAktywnaFirma);
  end;

  q := SQLManager.CreateQuery('SELECT ' +
                                sZLETYPZLEC_NIERUCHOMOSC_A + ', ' +
                                sZLETYPZLEC_BUDYNEK_A + ', ' +
                                sZLETYPZLEC_LOKAL_A + ', ' +
                                sZLETYPZLEC_KLATKA_A + ', ' +
                                sZLETYPZLEC_ULICA_A + ', ' +
                                sZLETYPZLEC_ZASOB_A + ', ' +
                                sZLETYPZLEC_SIECELEMENT_A + ', ' +
                                sZLETYPZLEC_WYKONAWCA_A + ', ' +
                                sZLETYPZLEC_WYDZIAL_A + ' ' +
                              'FROM %s' + sWar,
                              [sZLETYPZLEC]);
  try
    q.Open;
    if not q.IsEmpty then begin
       while not q.Eof do begin
         if q.FieldByName(sZLETYPZLEC_NIERUCHOMOSC_A).AsString <> cZLEAktywnosc_NieAktywnyID then
            bNieruchomosc := True;
         if q.FieldByName(sZLETYPZLEC_BUDYNEK_A).AsString <> cZLEAktywnosc_NieAktywnyID then
            bBudynek      := True;
         if q.FieldByName(sZLETYPZLEC_LOKAL_A).AsString <> cZLEAktywnosc_NieAktywnyID then
            bLokal        := True;
         if q.FieldByName(sZLETYPZLEC_KLATKA_A).AsString <> cZLEAktywnosc_NieAktywnyID then
            bKlatka       := True;
         if q.FieldByName(sZLETYPZLEC_ULICA_A).AsString <> cZLEAktywnosc_NieAktywnyID then
            bUlica        := True;
         if q.FieldByName(sZLETYPZLEC_ZASOB_A).AsString <> cZLEAktywnosc_NieAktywnyID then
            bZasob        := True;
         if q.FieldByName(sZLETYPZLEC_SIECELEMENT_A).AsString <> cZLEAktywnosc_NieAktywnyID then
            bSiecElement  := True;
         if q.FieldByName(sZLETYPZLEC_WYDZIAL_A).AsString <> cZLEAktywnosc_NieAktywnyID then
            bJednostkaOrg := True;
         if q.FieldByName(sZLETYPZLEC_WYKONAWCA_A).AsString <> cZLEAktywnosc_NieAktywnyID then
            bWykonawca    := True;
         q.Next;
       end;
    end;
  finally
    if q <> nil then FreeAndNil(q);
  end;

  if bNieruchomosc then slMnemZle.Add(sMnemonikNieruchomosci);
  if bBudynek      then slMnemZle.Add(sMnemonikBudynki);
  if bLokal        then slMnemZle.Add(sMnemonikLokale);
  if bKlatka       then slMnemZle.Add(sMnemonikKlatki);
  if bUlica        then slMnemZle.Add(sMnemonikUlice);
  if bZasob        then slMnemZle.Add(sMnemonikZasoby);
  if bSiecElement  then slMnemZle.Add(sMnemonikElemSieci);
  if bJednostkaOrg then begin
     slMnemZle.Add(sMnemonikJednostkaOrg);
     slMnemZle.Add(sMnemonikJednostkaZeZlecenia);
  end;
  if bWykonawca    then begin
    slMnemZle.Add(sMnemonikKontrahenci);
    slMnemZle.Add(sMnemonikKlientZeZlecenia);
  end;

  if DataManagers.Available(sASOModulID) and DataManagers.Available(sLWPModulID) then
     slMnemZle.Add(sMnemonikAsoAsort);  //Asortyment tylko dla zlece produkcyjnych

  if DataManagers.Available(sLWPModulID) then
     slMnemZle.Add(sMnemonikLWPReceptura);

  sWar := '';
  if vWielofirmowosc {or (vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial)} then begin
     if (iFirmaID > 0) then
          sWar := ' AND ZT.' + sUNIODDZIAL_ID + ' = ' + IntToStr(iFirmaID)
     else sWar := ' AND ZT.' + sUNIODDZIAL_ID + ' = ' + IntToStr(vAktywnaFirma);
  end;

  q := SQLManager.CreateQuery('SELECT DISTINCT ' +
                                  'FM.' + sFKMNEMONIKI_MNEMONIK + ' ' +
                              'FROM %s DEF, %s WSK, %s FM, %s ZT ' +
                              'WHERE ' +
                                  'WSK.' + sUNIPOLAUZDEF_ID + ' = DEF.' + sUNIPOLAUZDEF_ID + ' AND ' +
                                  'DEF.' + sFKMNEMONIKI_ID  + ' = FM.'  + sFKMNEMONIKI_ID  + ' AND ' +
                                  'ZT.'  + sZLETYPZLEC_ID   + ' = WSK.' + sUNIPOLAUZWSK_FUNKID  + ' AND ' +
                                  'DEF.' + sUNIPOLAUZDEF_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEZlecenie) + sWar,
                              [sUNIPOLAUZDEF, sUNIPOLAUZWSK,
                               sFKMNEMONIKI, sZLETYPZLEC]);
  try
    q.Open;
    if not q.IsEmpty then begin
       while not q.Eof do begin
         slMnemZle.Add(q.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString);
         q.Next;
       end;
    end;
  finally
    if q <> nil then FreeAndNil(q);
  end;
end;

function TZLEDataManager.ZLEDopiszZlecenieGrupujace( iTypZleceniaID, iModulZSIID: Integer;
                                                     sSymbol, sNazwa, sOpis: String;
                                                     dDataOtwarcia: TDate;
                                                     iFirmaID: Integer): Integer;
var oInsert, oQuery: TUNIQuery;
    sWhere: String;
    iNumId: Integer;
    iOkresID: Integer;
begin
  oInsert := nil;
  oQuery := nil;
  iNumId := 0;
  iOkresID:= 0;
  result  := 0;

  //sprawdzenie czy do typu zlecenia nie jest podpity numerator
  sWhere := '(@'+sZLEALIAS_TYPZLECENIA_ID+'='+IntToStr(iTypZleceniaID)+')';
  if iFirmaID <> 0 then
    sWhere := sWhere + 'and(@'+sZLEALIAS_TYPZLECENIA_ID+'='+IntToStr(iFirmaID)+')';
  try
    oQuery := ZLEOdpytajODane( sZLETYPZLEC, sZLEALIAS_TYPZLECENIA_NUM_ID,
                               sWhere, true );
    if oQuery <> nil then iNumId := oQuery.FieldByName(sUNIAUTNUM_ID).AsInteger;
  finally
    if oQuery <> nil then oQuery.Free;
  end;

  //jeeli korzystamy z numeratora to szukamy okresu okrechunkowego dla daty rozpoczecia
  oQuery := nil;
  if iNumId <> 0 then begin
    try
      oQuery := UNISYSDM.UNIPodajOkresObrachunkowy( vAktywnyRokObrachunkowyID,
                                                    dDataOtwarcia,
                                                    sUNISYSALIAS_Okres_Obrachunkowy_ID );
      if oQuery <> nil then
        iOkresID := oQuery.FieldByName(sUNIOKRES_ID).AsInteger;
    finally
      if oQuery <> nil then oQuery.Free;
    end;
  end;

  try
    oInsert := SQLManager.InsertQueryStep1( sZLEZLECENIE,
                                            sZLEZLECENIE_ID+','+
                                            sZLETYPZLEC_ID+','+
                                            sUNIODDZIAL_ID+','+
                                            sZLEZLECENIE_SYMBOL+','+
                                            sZLEZLECENIE_NAZWA+','+
                                            sZLEZLECENIE_DATA_OTW+','+
                                            sUNIMODULZSI_ID+','+
                                            sZLEZLECENIE_STATUS+','+
                                            sZLEZLECENIE_OPIS+','+
                                            sZLEZLECENIE_UZ_AU_ID+','+
                                            sZLEZLECENIE_DATA_AU );
    if oInsert = nil then
      raise EOF_ZLEException.Create( cError_BladDodaniaElemGrup,
                                     ZLEPodajSlowneRozwiniecieKoduBledu( cError_BladDodaniaElemGrup ),
                                     'ZLEDopiszZlecenie' );
    try
      with oInsert do begin
        //ustawienie rodzaju parametrw
        ParamByName(sZLEZLECENIE_ID).DataType := ftInteger;
        ParamByName(sZLETYPZLEC_ID).DataType := ftInteger;
        ParamByName(sUNIODDZIAL_ID).DataType := ftInteger;
        ParamByName(sZLEZLECENIE_SYMBOL).DataType := ftString;
        ParamByName(sZLEZLECENIE_NAZWA).DataType := ftString;
        ParamByName(sZLEZLECENIE_DATA_OTW).DataType := ftDate;
        ParamByName(sUNIMODULZSI_ID).DataType := ftInteger;
        ParamByName(sZLEZLECENIE_STATUS).DataType := ftString;
        ParamByName(sZLEZLECENIE_OPIS).DataType := ftString;
        ParamByName(sZLEZLECENIE_UZ_AU_ID).DataType := ftInteger;
        ParamByName(sZLEZLECENIE_DATA_AU).DataType := ftDate;
        //ustawienie wartoci parametrw
        ParamByName(sZLETYPZLEC_ID).AsInteger := iTypZleceniaID;
        if iFirmaID = 0 then
          ParamByName(sUNIODDZIAL_ID).Clear
        else
          ParamByName(sUNIODDZIAL_ID).AsInteger := iFirmaID;

        if iNumId <> 0 then
          sSymbol := UNISysDM.UNIPodajNumer( iNumId, iFirmaID,
                                             vAktywnyRokObrachunkowyID,
                                             iOkresID );

        ParamByName(sZLEZLECENIE_SYMBOL).AsString := sSymbol;

        ParamByName(sZLEZLECENIE_NAZWA).AsString := sNazwa;
        ParamByName(sZLEZLECENIE_DATA_OTW).AsDateTime := dDataOtwarcia;
        ParamByName(sUNIMODULZSI_ID).AsInteger := iModulZSIID;
        ParamByName(sZLEZLECENIE_STATUS).AsString := cZLEStatusZlecenia_OczekujaceID;
        ParamByName(sZLEZLECENIE_OPIS).AsString := sOpis;
        ParamByName(sZLEZLECENIE_UZ_AU_ID).AsInteger := SecurityManager.UserId;
        ParamByName(sZLEZLECENIE_DATA_AU).AsDateTime := UNIDate;
      end;
      result := SQLManager.InsertQueryStep2( oInsert, sZLEZLECENIE_ID );
    except
      if iNumId <> 0 then UNISYSDM.UNIZwrocNumer( sSymbol, iNumID, iFirmaID,
                                                  vAktywnyRokObrachunkowyID,
                                                  iOkresID );
      if Pos( sZLEZLECENIE+c_UNK+'1',(ExceptObject as Exception).Message ) > 0 then begin
        raise EOF_ZLEException.Create( cError_BladDodaniaElemGrupIstnieje,
                                       ZLEPodajSlowneRozwiniecieKoduBledu( cError_BladDodaniaElemGrupIstnieje ),
                                       'ZLEDopiszZlecenie' );
      end else raise;
    end;
  finally
    if oInsert <> nil then oInsert.Free;
  end;
end;

{$ifdef build_zle}
{Kryteria}
function TZLEDataManager.ZLEZapiszPrzeliczoneKryterium(iID, iOkresID: integer; DataPocz, DataKonc: string): byte;
var
  Q, qKryt, IQuery, DQuery, qSymbole, qMnem, qSymb, qMnem2: TUniQuery;
  sSQL, sBlad, sSymbol, sFormat, sSQLMnem, sSymb2, sSQLTmp: string;
  trans: boolean;
  sSelSQLText: String;
  oParam: TKeyValues;
  fWartosc: Variant;
  sWarunek, sSQLPoz: String;
  i, iii: Integer;
  oSplit: TSplit;
  sRegula, sListaMnem, sTabela: String;
  bKrytOkresowe, bWhere, bINI__IBU: Boolean;
begin
  result        := 0;
  trans         := false;
  bKrytOkresowe := false;
  Q             := nil;
  try
    try
      {Odczytujemy definicje kryterium}
      qKryt := SQLManager.CreateQuery('SELECT FM.' + sFKMNEMONIKI_TABELA + ' , KR.* ' +
                                      'FROM %s KR, %s FM ' +
                                      'WHERE KR.' + sFKMNEMONIKI_ID +  ' = FM.' + sFKMNEMONIKI_ID + '(+)' + ' AND ' +
                                            'KR.' + sZLEKRYTERIA_ID + ' = ' + IntToStr(iID),
                                      [sZLEKRYTERIA, sFKMNEMONIKI]);
      try
         if qKryt <> nil then begin
            qKryt.Open;
            if not qKryt.IsEmpty then begin
               sRegula       := qKryt.FieldByName(sZLEKRYTERIA_REGULA).AsString;
               sListaMnem    := qKryt.FieldByName(sZLEKRYTERIA_SKLADNIKI).AsString;
               sTabela       := qKryt.FieldByName(sFKMNEMONIKI_TABELA).AsString;
//               bTypZlec      := (not qKryt.FieldByName(sZLETYPZLEC_ID).IsNull);
               bKrytOkresowe := (qKryt.FieldByName(sZLEKRYTERIA_OKRESOWE).AsString = sTak);
               sFormat       := qKryt.FieldByName(sZLEKRYTERIA_FORMAT).AsString;
            end;
         end;
      finally
         if qKryt <> nil then FreeAndNil(qKryt);
      end;

      qMnem := ZLEDM.ListaMnemonikow(sListaMnem);

      if sRegula <> '' then
      begin
        trans := not SQLManager.InTransaction;
        if trans then SQLManager.StartTransaction;

        {Usuwamy aktualne dane - w podanym okresie - jesli kryterium jest okresowe}
        sSQL := 'DELETE FROM ' + SQLManager.GetTableName(sZLEKRYTPOZ) +
                      ' WHERE ' + sZLEKRYTERIA_ID + ' = ' + IntToStr(iID);
        if bKrytOkresowe then
           sSQL := sSQL + ' AND ' + sUNIOKRES_ID + ' = ' + IntToStr(iOkresID);
        {if sTabela = sZLEKRYTPOZ then begin
           sSQL := sSQL + ' WHERE ' + sZLEKRYTERIA_ID + ' = ' + IntToStr(iID);
           if bKrytOkresowe then
              sSQL := sSQL + ' AND ' + sUNIOKRES_ID + ' = ' + IntToStr(iOkresID);
        end else begin
           if bKrytOkresowe then
              sSQL := sSQL + ' WHERE ' + sUNIOKRES_ID + ' = ' + IntToStr(iOkresID);
        end;}

        DQuery := SQLManager.CreateQuery(sSQL);
        DQuery.ExecSQL;

        try
          IQuery := SQLManager.InsertQueryStep1(sZLEKRYTPOZ,
                    sZLEKRYTPOZ_ID       + ', ' +
                    sUNIOKRES_ID         + ', ' +
                    sUNIROK_ID           + ', ' +
                    sZLEKRYTERIA_ID      + ', ' +
                    sZLEKRYTPOZ_SYMBOL   + ', ' +
                    sZLEKRYTPOZ_WARTOSC + ', ' +
                    sZLEKRYTPOZ_UZ_AU_ID + ', ' +
                    sZLEKRYTPOZ_DATA_AU
                    );

          qSymb := SQLManager.InsertQueryStep1(sTabela,
                    sTabela + '_ID'      + ', ' +
                    sTabela + '_SYMBOL'  + ', ' +
                    sTabela + '_UZ_AU_ID'+ ', ' +
                    sTabela + '_DATA_AU'
                    );

          oParam := TKeyValues.CreateEmpty();
          qSymbole := ZleDajListeSymboliDlaKryterium(iID, iOkresID, sSelSQLText, oParam, bWhere, bINI__IBU);
          while not qSymbole.Eof do begin
             {Dla kadego symbolu liczymy warto}
             {Budowanie symbolu}
             i := 0;
             sSymbol := '';
             sWarunek := '';
             sSQLPoz := 'SELECT SEL.ZLEZLECENIEPOZ_ID FROM ' + sSelSQLText;
             //if not bWhere then sSQLPoz := sSQLPoz + ' WHERE ';

             if Pos(',', sListaMnem) > 0 then begin
                oSplit:= TSplit.Create(sListaMnem, ',', '');
                try
                  for iii := 0 to oSplit.Count - 1 do begin
                    if (copy(Trim(oSplit.Items[iii]), 1, 1) = '''') then begin
                       if (copy(Trim(oSplit.Items[iii]), length(Trim(oSplit.Items[iii])), 1) = '''') then begin
                          sSymbol := sSymbol + copy(Trim(oSplit.Items[iii]), 2, length(Trim(oSplit.Items[iii])) - 2);

                          Continue; {Dopisujemy sta do symbolu}
                       end else begin
                          Komunikat(cError, 'Nieprawidowa ilo apostrofw');
                          Exit;
                       end;
                    end;

                    if qMnem.Locate(sFKMNEMONIKI_MNEMONIK, Copy(Trim(oSplit.Items[iii]), 1, 3), []) then begin
                       if (sWarunek <> '') or bWhere then
                          sWarunek := sWarunek + ' AND ';

                       if oParam.Values[qMnem.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString] <> '' then begin
                          if qSymbole.Fields[i].IsNull then
                             sWarunek := sWarunek + 'SEL.' + oParam.Values[qMnem.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString] + ' IS NULL '
                          else sWarunek := sWarunek + 'SEL.' + oParam.Values[qMnem.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString] + ' = ' + QuotedStr(qSymbole.Fields[i].AsString);
                       end;

                       if Length(Trim(oSplit.Items[iii])) > 3 then begin
                          sSQLMnem := 'SELECT * FROM %s WHERE ' +
                                         sFKMNEMONIKI_MNEMONIK + '=' + QuotedStr(qMnem.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString) + ' AND ' +
                                         sFKMNEMONIKI_INDEKS + '=' + Copy(Trim(oSplit.Items[iii]), 4, 1);
                          qMnem2 := SQLManager.CreateQuery(sSQLMnem , [sFKMNEMONIKI]);
                          try
                            qMnem2.Open();
                            if not qMnem2.IsEmpty then begin
                               {Popranie wartoci z odpowiedniego _POLEx z danego sownika}
                               sSQLTmp := 'SELECT ' + qMnem2.FieldByName(sFKMnemoniki_Tabela).AsString + '_POLE' + qMnem2.FieldByName(sFKMnemoniki_Indeks).AsString + ' ' +
                                                                        'FROM %s ' +
                                                                        'WHERE ' + qMnem2.FieldByName(sFKMnemoniki_Tabela).AsString + '_SYMBOL' + '=' + QuotedStr(qSymbole.Fields[i].AsString);
                               if qMnem2.FieldByName(sFKMnemoniki_Tabela).AsString = sFKUZ then
                                  sSQLTmp := sSQLTmp + ' AND ' + sFKMnemoniki_ID + ' = ' + qMnem2.FieldByName(sFKMnemoniki_ID).AsString;

                               sSymb2 := SQLManager.OpenQueryWithResult(sSQLTmp, [qMnem2.FieldByName(sFKMnemoniki_Tabela).AsString]);
                               sSymbol := sSymbol + ZZBPadR(sSymb2,
                                                            qMnem2.FieldByName(sFKMNEMONIKI_DLUGOSC).AsInteger,
                                                            ' ');
                            end;


                          finally
                            if qMnem2 <> nil then FreeAndNil(qMnem2);
                          end;
                       end else begin
                          sSymbol := sSymbol + ZZBPadR(qSymbole.Fields[i].AsString,
                                                       qMnem.FieldByName(sFKMNEMONIKI_DLUGOSC).AsInteger,
                                                       ' ');
                       end;
                       Inc(i);
                    end;
                  end;
                finally
                  oSplit.Free;
                end;
             end else begin
                if (copy(Trim(sListaMnem), 1, 1) = '''') then begin
                   if (copy(Trim(sListaMnem), length(Trim(sListaMnem)), 1) = '''') then begin
                      sSymbol := sSymbol + copy(Trim(sListaMnem), 2, length(Trim(sListaMnem)) - 2);
                   end else begin
                      Komunikat(cError, 'Nieprawidowa ilo apostrofw');
                      Exit;
                   end;
                end else
                if qMnem.Locate(sFKMNEMONIKI_MNEMONIK, Trim(sListaMnem), []) then begin
                   if (sWarunek <> '') or bWhere then
                      sWarunek := sWarunek + ' AND ';

                   if oParam.Values[qMnem.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString] <> '' then begin
                      if qSymbole.Fields[i].IsNull then
                         sWarunek := sWarunek + 'SEL.' + oParam.Values[qMnem.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString] + ' IS NULL '
                      else sWarunek := sWarunek + 'SEL.' + oParam.Values[qMnem.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString] + ' = ' + QuotedStr(qSymbole.Fields[i].AsString);
                   end;

                   if qMnem.Locate(sFKMNEMONIKI_MNEMONIK, Copy(Trim(sListaMnem), 1, 3), []) then begin
                       if (sWarunek <> '') or bWhere then
                          sWarunek := sWarunek + ' AND ';

                       if oParam.Values[qMnem.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString] <> '' then begin
                          if qSymbole.Fields[i].IsNull then
                             sWarunek := sWarunek + 'SEL.' + oParam.Values[qMnem.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString] + ' IS NULL '
                          else sWarunek := sWarunek + 'SEL.' + oParam.Values[qMnem.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString] + ' = ' + QuotedStr(qSymbole.Fields[i].AsString);
                       end;

                       if Length(Trim(sListaMnem)) > 3 then begin
                          sSQLMnem := 'SELECT * FROM %s WHERE ' +
                                         sFKMNEMONIKI_MNEMONIK + '=' + QuotedStr(qMnem.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString) + ' AND ' +
                                         sFKMNEMONIKI_INDEKS + '=' + Copy(Trim(sListaMnem), 4, 1);
                          qMnem2 := SQLManager.CreateQuery(sSQLMnem , [sFKMNEMONIKI]);
                          try
                            qMnem2.Open();
                            if not qMnem2.IsEmpty then begin
                               {Popranie wartoci z odpowiedniego Polax z danego sownika}
                               sSQLTmp := 'SELECT ' + qMnem2.FieldByName(sFKMnemoniki_Tabela).AsString + '_POLE' + qMnem2.FieldByName(sFKMnemoniki_Indeks).AsString + ' ' +
                                                                        'FROM %s ' +
                                                                        'WHERE ' + qMnem2.FieldByName(sFKMnemoniki_Tabela).AsString + '_SYMBOL' + '=' + QuotedStr(qSymbole.Fields[i].AsString);
                               if qMnem2.FieldByName(sFKMnemoniki_Tabela).AsString = sFKUZ then
                                  sSQLTmp := sSQLTmp + ' AND ' + sFKMnemoniki_ID + ' = ' + qMnem2.FieldByName(sFKMnemoniki_ID).AsString;

                               sSymb2 := SQLManager.OpenQueryWithResult(sSQLTmp, [qMnem2.FieldByName(sFKMnemoniki_Tabela).AsString]);

                               sSymbol := sSymbol + ZZBPadR(sSymb2,
                                                            qMnem2.FieldByName(sFKMNEMONIKI_DLUGOSC).AsInteger,
                                                            ' ');
                            end;


                          finally
                            if qMnem2 <> nil then FreeAndNil(qMnem2);
                          end;
                       end else begin
                          sSymbol := sSymbol + ZZBPadR(qSymbole.Fields[i].AsString,
                                                       qMnem.FieldByName(sFKMNEMONIKI_DLUGOSC).AsInteger,
                                                       ' ');
                       end;
                   end;
//                   Inc(i);
                end;
             end;

             (************** TAK BYLO ***********************
             qMnem.First;
             while not qMnem.Eof do begin
                if (sWarunek <> '') or bWhere then
                   sWarunek := sWarunek + ' AND ';

                if oParam.Values[qMnem.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString] <> '' then begin
                   if qSymbole.Fields[i].IsNull then
                      sWarunek := sWarunek + 'SEL.' + oParam.Values[qMnem.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString] + ' IS NULL '
                   else sWarunek := sWarunek + 'SEL.' + oParam.Values[qMnem.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString] + ' = ' + QuotedStr(qSymbole.Fields[i].AsString);
                end;

                sSymbol := sSymbol + ZZBPadR(qSymbole.Fields[i].AsString,
                                             qMnem.FieldByName(sFKMNEMONIKI_DLUGOSC).AsInteger,
                                             ' ');
                Inc(i);
                qMnem.Next;
             end;
             ************** TAK BYLO ***********************)




             if (sWarunek <> '') then begin
                if (not bWhere) then sSQLPoz := sSQLPoz + ' WHERE ';
                sSQLPoz := sSQLPoz + sWarunek;
             end;

             //Zmienna globalna wykorzystana w parserze zlecen
             sWarPoz := sSQLPoz;
             //fWartosc := 0;
             fWartosc := WyliczWartoscZReguly(sRegula, iOkresID, sBlad);

             if sFormat <> '' then
                fWartosc := ZaokraglijFormat(fWartosc, sFormat);

             if (SQLManager.OpenQueryWithResult('SELECT ' + sTabela + '_ID ' +
                                                'FROM %s ' +
                                                'WHERE ' + QuotedStr('|') + '||' + sTabela + '_SYMBOL' + '||' + QuotedStr('|')+ '=' + QuotedStr('|' + sSymbol + '|'),
                                                [sTabela])) = '' then begin
                {Dopisac symbol do slownika}
                 qSymb.ParamByName(sTabela + '_ID').DataType         := ftInteger;
                 qSymb.ParamByName(sTabela + '_SYMBOL').DataType     := ftString;
                 qSymb.ParamByName(sTabela + '_UZ_AU_ID').DataType   := ftInteger;
                 qSymb.ParamByName(sTabela + '_DATA_AU').DataType    := ftDateTime;

                 qSymb.ParamByName(sTabela + '_ID').AsInteger        := UniqueKey[sTabela];
                 qSymb.ParamByName(sTabela + '_SYMBOL').AsString     := sSymbol;
                 qSymb.ParamByName(sTabela + '_UZ_AU_ID').AsInteger  := SecurityManager.UserId;
                 qSymb.ParamByName(sTabela + '_DATA_AU').AsDateTime  := UNINow();

                 SQLManager.InsertQueryStep2(qSymb, ''{sTabela + '_ID'});
             end;

             IQuery.ParamByName(sZLEKRYTPOZ_ID).DataType         := ftInteger;
             IQuery.ParamByName(sUNIOKRES_ID).DataType           := ftInteger;
             IQuery.ParamByName(sUNIROK_ID).DataType             := ftInteger;
             IQuery.ParamByName(sZLEKRYTERIA_ID).DataType        := ftInteger;
             IQuery.ParamByName(sZLEKRYTPOZ_SYMBOL).DataType     := ftString;
             IQuery.ParamByName(sZLEKRYTPOZ_WARTOSC).DataType    := ftFloat;
             IQuery.ParamByName(sZLEKRYTPOZ_UZ_AU_ID).DataType   := ftInteger;
             IQuery.ParamByName(sZLEKRYTPOZ_DATA_AU).DataType    := ftDateTime;

             IQuery.ParamByName(sZLEKRYTPOZ_ID).AsInteger        := UniqueKey[sZLEKRYTPOZ];
             IQuery.ParamByName(sUNIOKRES_ID).AsInteger          := iOkresID;
             IQuery.ParamByName(sUNIROK_ID).AsInteger            := UNISYSDM.vAktywnyRokObrachunkowyID;
             IQuery.ParamByName(sZLEKRYTERIA_ID).AsInteger       := iID;
             IQuery.ParamByName(sZLEKRYTPOZ_SYMBOL).AsString     := sSymbol;
             IQuery.ParamByName(sZLEKRYTPOZ_WARTOSC).AsFloat     := fWartosc;
             IQuery.ParamByName(sZLEKRYTPOZ_UZ_AU_ID).AsInteger  := SecurityManager.UserId;
             IQuery.ParamByName(sZLEKRYTPOZ_DATA_AU).AsDateTime  := UNINow();

             SQLManager.InsertQueryStep2(IQuery, ''{sTabela + '_ID'});
             qSymbole.Next;
          end;
        finally
          if qSymbole <> nil then FreeAndNil(qSymbole);
          if qSymb <> nil then FreeAndNil(qSymb);
          if qMnem <> nil then FreeAndNil(qMnem);
          if IQuery <> nil then FreeAndNil(IQuery);
        end;

        if trans then SQLManager.Commit;
      end;
    except
      on E:Exception do
      begin
        if trans then SQLManager.Rollback;
        Komunikat(cError, 'Bd podczas dopisywania wartoci kryterium !'#13'Komunikat: '+E.Message);
        result := 1;
      end;
      else
        if Trans then SQLManager.Rollback;
    end;
  finally
    if Q <> nil then FreeAndNil(Q);
  end;
end;


function TZLEDataManager.ZLEPrzeliczKryteria(Kryteria, Okresy: array of Integer): Byte;

  function DajDatyOkresu(iOkres: integer; var dPocz, dKonc: TDate):boolean;
  var
    s: string;
    Q: TUNIQuery;
  begin
    try
      s:= UniSysDataManager.UNIOdpytajODaneSQL( sUNIOKRES,
                                                sUNISYSALIAS_Poczatek_Okresu_Obrachunkowego+';'+
                                                sUNISYSALIAS_Koniec_Okresu_Obrachunkowego,
                                                sUNIOkres_ID+'='+IntToStr(iOkres),
                                                true,
                                                0);
      Q := SQLManager.CreateQuery(s);
      Q.Open;
      if Q.isEmpty then
      begin
        result := false;
        Exit;
      end;
      dPocz := Q.Fields[0].asDateTime;
      dKonc := Q.Fields[1].asDateTime;
      result := true;
    except
      raise;
      result:=false;
    end;
  end;

var
  iO, iK:integer;
  dDP, dDK : TDate;
  r: Byte;
  bTrans: Boolean;
begin
  result := 0;
  Parser := nil;
  bTrans := not SQLManager.InTransaction;
  if bTrans then SQLManager.StartTransaction;
  try
    Parser := TZLEParser.Create( Self, True, True );

    {IZlecenieID bedzie ustawiane w ptli}
    //Parser.iZlecenieId := iZlecenieID;

    with Parser do begin
      bSymulacja      := False;
      iOkresNr        := -1;
      Parser.iFirmaID := UNISYSDM.vAktywnaFirma;
      sRok            := UNISysDM.vAktywnyRokObrachunkowy;
      sRokId          := inttostr(UNISysDM.vAktywnyRokObrachunkowyID);
    end;

    {Tu rozpoczynamy przeliczanie}
    {to do!!!: poprawic dla opcji kryterium rocznego}
    for iO := Low(Okresy) to High(Okresy) do
    begin
      if DajDatyOkresu(Okresy[iO], dDP, dDK) then
      begin
        for iK := Low(Kryteria) to High(Kryteria) do
        begin
          Parser.iKryteriaId := Kryteria[iK];
          r := ZLEZapiszPrzeliczoneKryterium(Kryteria[iK], Okresy[iO], DateToStr(dDP), DateToStr(dDK));
          if (r = 1) and not ((High(Okresy) > 1) or (High(Kryteria) > 1)) then
              Komunikat(cInformation, 'Nie znaleziono danych do przeliczenia !')
        end;
      end
      else result := 1;
    end;

    if Parser <> nil then FreeAndNil(Parser);
    if bTrans then SQLManager.Commit;
  except
    if Parser <> nil then FreeAndNil(Parser);
    if bTrans then SQLManager.Rollback;
    raise;
  end;
end;

function TZLEDataManager.ListaMnemonikow(var sListaSkl: String): TUNIQuery;
var
  sLista, sTmp: String;
  oSplit: TSplit;
  i: Integer;
  bDopisz: Boolean;

begin
  result := nil;
  if (sListaSkl = '') then Exit;

  sLista := '';
  bDopisz := False;
  sTmp := 'SELECT * FROM %s FM, '+
          '(SELECT IORDERID, SORDERKEY '+
           'FROM TABLE(' + SQLMANAGER.GETSPNAME('TORDER_CONV_LIST_STR') + '(';

  if Pos(',', sListaSkl) > 0 then begin
    oSplit:= TSplit.Create(sListaSkl, ',', '');
    try
      for i := 0 to oSplit.Count - 1 do begin
        if (copy(Trim(oSplit.Items[i]), 1, 1) = '''') then begin
           if (copy(Trim(oSplit.Items[i]), length(Trim(oSplit.Items[i])), 1) = '''') then Continue {Pomijamy stae tekstowe}
           else begin
              Komunikat(cWarning, 'Nieprawidowa ilo apostrofw');
              Exit;
           end;
        end;

        if bDopisz then sLista := sLista + ', ';

        sLista := sLista + QuotedStr(Copy(Trim(oSplit.Items[i]), 1, 3));

        if bDopisz then sTmp := sTmp + ', ';
        if not bDopisz then bDopisz := True;

        sTmp := sTmp +
           SQLManager.GetSPName('TOrder_Conv_Str')+'('+ IntToStr(i) + ',' + QuotedStr(Copy(Trim(oSplit.Items[i]), 1, 3)) + ')';
      end;

      sTmp := sTmp + '))) DICT ';
    finally
      oSplit.Free;
    end;
  end else begin
       {Pojedyczy skadnik}
     if (copy(Trim(sListaSkl), 1, 1) = '''') then begin
        if (copy(Trim(sListaSkl), length(Trim(sListaSkl)), 1) = '''') then begin
           {iDlugTxt := iDlugTxt + Length(Trim(sListaSkl)) - 2;
           Continue;}
           {NIC NIE ROBIMY}
        end else begin
          Komunikat(cWarning, 'Nieprawidowa ilo apostrofw');
          Exit;
        end;
     end else begin {pojedynczy mnemonik}
        sLista := QuotedStr(Copy(Trim(sListaSkl), 1, 3));
        sTmp := sTmp +
           SQLManager.GetSPName('TOrder_Conv_Str')+'('+ IntToStr(0) + ',' + QuotedStr(Copy(Trim(sListaSkl), 1, 3)) + ')';
        sTmp := sTmp + '))) DICT ';
     end;
  end;

  if sLista <> '' then begin
     result := SQLManager.CreateQuery(sTmp +
                  ' WHERE FM.' + sFKMNEMONIKI_MNEMONIK + ' IN (' + sLista + ')' +
                       ' AND ' + 'FM.' + sFKMNEMONIKI_INDEKS + ' = 0 ' +
                       ' AND ' + 'FM.' + sFKMNEMONIKI_MNEMONIK + ' = DICT.SORDERKEY '+
                  ' ORDER BY DICT.IORDERID',
                    [sFKMNEMONIKI]);
  end else begin
     result := nil;
  end;

  try
    if result <> nil then
       result.Open;
  finally
    //Tu nie zwalniamy pamieci .. Dopiero na koncu.
  end;
end;
{$endif}

function TZLEDataManager.ZLEDajWartoscKryterium(iFirmaID: integer;
            sKryteriaSymbol: string; iFKMnemonikiID: integer; sZakres,
            sKrytPozWartoscTyp, sKryteriaRodzaj: string;
            iOkresID:integer; bAnalizy:boolean = false): TUNIQuery;
var
  oQueryKrytPoz: TUNIQuery;
  sQueryTextKrytPoz: string;
  sWhere: string;
  sWhereZak: string;
  sWhereODDO: string;
  sWhereRodz: string;
  sZLEKryteriaSymbol: string;
  sUNIKrytPozWartoscSUM: string;
  sZakresSymbol: string;
  sMnemonik_Symbol: string;
  sMnemonik_Symbol_OD: string;
  sMnemonik_Symbol_DO: string;
  sSUBSTRFunctionName: string;
  iKrytID:integer;
  sTabela, sPole, sWhereZakTyp: string;
begin
  // Funkcja brutalnie cignita z InfDM

  case SQLManager.DataBaseDriver of
    dbdORACLE: sSUBSTRFunctionName:='substr';
    dbdINTERBASE: sSUBSTRFunctionName:='substr';
  else
    sSUBSTRFunctionName:='substr';
  end;

  // wczytuje ewentualne kryteria
{ try
    PRZWczytajKryteria(False);
  except
    Komunikat(cError,'Wystpi-y b-dy podczas importu');
  end;
}

{  if iFKMnemonikiID = 0 then
    raise EOF_INFException.Create(ciKryterium_NiePodanoMnemoniku, csKryterium_NiePodanoMnemoniku);
    }
  if iOkresID < 1  then
    raise EOF_ZLEException.Create('Nie podano okresu');

  if sKrytPozWartoscTyp = '' then
    raise EOF_ZLEException.Create(ciKryterium_NiePodanoTypu, csKryterium_NiePodanoTypu);

  if ((sKryteriaRodzaj <> sPrzeksiegRodzajWspolczynnik_ID) and
      (sKryteriaRodzaj <> sPrzeksiegRodzajWielkosc_ID) and
      (sKryteriaRodzaj <> '')) then
    raise EOF_ZLEException.Create(ciKryterium_BladRodzajuKryteria, csKryterium_BladRodzajuKryteria);

  // Kontrola sPRZKRYTERIA_SYMBOL
  {if vWielofirmowosc then
    sWhere := sUNIODDZIAL_ID+'='+''''+IntToStr(iFirmaID)+''''+' and '+
              'UPPER('+sINFKRYTERIA_SYMBOL+')'+'='+''''+UpperCase(sKryteriaSymbol)+''''
  else
    sWhere := 'UPPER('+sINFKRYTERIA_SYMBOL+')'+'='+''''+UpperCase(sKryteriaSymbol)+'''';

  sINFKryteriaSymbol := SQLManager.OpenQueryWithResult(
                        'select '+ sINFKRYTERIA_SYMBOL +
                        ' from %s '+
                        ' where ' + sWhere,
                        [sINFKRYTERIA]);}

  if vWielofirmowosc then
    sWhere := 'ZLEkr.'+sUNIODDZIAL_ID+'='+''''+IntToStr(iFirmaID)+''''+' and '+
              'ZLEkr.'+sZLEkryteria_id+' = unikr.'+sunikryteria_nr+' and '+
              'UPPER(unikr.'+sUNIKRYTERIA_SYMBOL+')'+'='+''''+UpperCase(sKryteriaSymbol)+''''
  else
    sWhere := 'ZLEkr.'+sZLEkryteria_id+' = unikr.'+sunikryteria_nr+' and '+
              'UPPER(unikr.'+sUNIKRYTERIA_SYMBOL+')'+'='+''''+UpperCase(sKryteriaSymbol)+'''';

  sZLEKryteriaSymbol := SQLManager.OpenQueryWithResult(
                        'select ZLEkr.'+ sZLEKRYTERIA_SYMBOL +
                        ' from %s ZLEkr, %s unikr'+
                        ' where ' + sWhere,
                        [sZLEKRYTERIA, sUNIKRYTERIA]);

  if sZLEKryteriaSymbol = '' then
    raise EOF_ZLEException.Create(ciKryterium_BladSymboluKryteria, csKryterium_BladSymboluKryteria);

  // Kontrola sFKMNEMONIKI_ID
{  sPRZMnemonikiID := SQLManager.OpenQueryWithResult(
                      'SELECT '+ sFKMNEMONIKI_ID +
                      ' FROM %s '+
                      ' WHERE ' + sWhere,
                      [sPRZKRYTERIA]);
  if sPRZMnemonikiID = '' then sPRZMnemonikiID := '0';
  if iFKMnemonikiID <> StrToInt(sPRZMnemonikiID) then
    raise EOF_PRZException.Create(ciKryterium_BladMnemoniku, csKryterium_BladMnemoniku);
}

  if vWielofirmowosc then
    sWhere := 'KR.'+sZLEKRYTERIA_ID+'='+'KRP.'+sZLEKRYTERIA_ID      +' and '+
              'KR.'+sUNIODDZIAL_ID +'='+''''+IntToStr(iFirmaID)+''''+' and '+
              'UPPER('+'KR.'+sZLEKRYTERIA_SYMBOL+')'+'='+''''+UpperCase(sZLEKryteriaSymbol)+''''
  else
    sWhere := 'KR.'+sZLEKRYTERIA_ID+'='+'KRP.'+sZLEKRYTERIA_ID      +' and '+
              'UPPER('+'KR.'+sZLEKRYTERIA_SYMBOL+')'+'='+''''+UpperCase(sZLEKryteriaSymbol)+'''';

  // sZakres
  sWhereZak := '';
  sZakresSymbol := sZakres;
  While Length(sZakresSymbol) > 0 do begin
    if Pos(',', sZakresSymbol) > 0 then begin // sZakres 021,031,040
      sMnemonik_Symbol := Copy(sZakresSymbol, 1, Pos(',', sZakresSymbol) - 1);
      if Length(sZakresSymbol) > Pos(',', sZakresSymbol) then
        sZakresSymbol := Copy(sZakresSymbol, Pos(',', sZakresSymbol) + 1,
                    Length(sZakresSymbol) - Pos(',', sZakresSymbol) + 1)
      else
        sZakresSymbol := '';
    end
    else begin
      sMnemonik_Symbol := sZakresSymbol;
      sZakresSymbol := '';
    end;
    if Pos('-', sMnemonik_Symbol) > 0 then begin // sZakres 021-031,040-050
       sMnemonik_Symbol_OD := Copy(sMnemonik_Symbol, 1, Pos('-', sMnemonik_Symbol) - 1);
       if Length(sMnemonik_Symbol) > Pos('-', sMnemonik_Symbol) then
         sMnemonik_Symbol_DO := Copy(sMnemonik_Symbol, Pos('-', sMnemonik_Symbol) + 1,
                                 Length(sMnemonik_Symbol) - Pos('-', sMnemonik_Symbol) + 1)
       else
         sMnemonik_Symbol_DO := '';
       sMnemonik_Symbol_OD := sysutils.Trim(sMnemonik_Symbol_OD);
       sMnemonik_Symbol_DO := sysutils.Trim(sMnemonik_Symbol_DO);
       if sMnemonik_Symbol_OD > sMnemonik_Symbol_DO then begin
         sMnemonik_Symbol := sMnemonik_Symbol_OD;
         sMnemonik_Symbol_OD := sMnemonik_Symbol_DO;
         sMnemonik_Symbol_DO := sMnemonik_Symbol;
       end;
       sWhereODDO := '';
       if sMnemonik_Symbol_OD <> '' then begin
         sWhereODDO := sWhereODDO +
                   '('+sSUBSTRFunctionName+'('+
                             'KRP.'+sZLEKRYTPOZ_SYMBOL+',1,'+
                             IntToStr(length(sMnemonik_Symbol_OD))+
                             ')>='+''''+sMnemonik_Symbol_OD+''''+')';
       end;
       if sMnemonik_Symbol_DO <> '' then begin
         if sWhereODDO <> '' then
           sWhereODDO := sWhereODDO + ' and ';
         sWhereODDO := sWhereODDO +
                   '('+sSUBSTRFunctionName+'('+
                             'KRP.'+sZLEKRYTPOZ_SYMBOL+',1,'+
                             IntToStr(length(sMnemonik_Symbol_DO))+
                             ')<='+''''+sMnemonik_Symbol_DO+''''+')';
       end;
       if sWhereODDO <> '' then begin
         sWhereODDO := '(' + sWhereODDO + ')';
         if sWhereZak = '' then
           sWhereZak := '('
         else
           sWhereZak := sWhereZak + ' or ';
         sWhereZak := sWhereZak + sWhereODDO;
       end;
    end // sZakres 021-031,040-050
    else begin // sZakres 021,031,040
       sMnemonik_Symbol := sysutils.Trim(sMnemonik_Symbol);
       if sWhereZak = '' then
         sWhereZak := '('
       else
         sWhereZak := sWhereZak + ' or ';
       sWhereZak := sWhereZak +
                    'KRP.'+sZLEKRYTPOZ_SYMBOL+'='+''''+sMnemonik_Symbol+'''';
    end; // sZakres 021,031,040
  end; // While Length(sZakresSymbol) > 0
  // dla sZakres = '' exit
  if Trim(sWhereZak) = '' then begin
    result := nil;
    exit;
  end
  else
    sWhere := sWhere + ' and ' + sWhereZak + ')';

  if iOkresID > 0 then
    sWhere := sWhere + Format(' and KRP.%s = %d ',[sUNIOKRES_ID, iOkresID]);

  oQueryKrytPoz := TUNIQuery.Create(nil);
  try
    oQueryKrytPoz.RequestLive := false;
    if sKrytPozWartoscTyp = '?' then begin // POWT
      if ((sKryteriaRodzaj <> sPrzeksiegRodzajWspolczynnik_ID) and
          (sKryteriaRodzaj <> sPrzeksiegRodzajWielkosc_ID)) then begin
        if vWielofirmowosc then
          //KN - dodanie aliasu na oddzial, bo kolumna byla niejednoznacznie zdefiniowana
          sWhereRodz := 'ZLEkr.' + sUNIODDZIAL_ID     +'='+''''+IntToStr(iFirmaID) +''''+' and '+
                        'UPPER(ZLEkr.'+sZLEKRYTERIA_SYMBOL+')'+'='+''''+UpperCase(sZLEKryteriaSymbol)+''''
        else
          sWhereRodz := 'UPPER(ZLEkr.'+sZLEKRYTERIA_SYMBOL+')'+'='+''''+UpperCase(sZLEKryteriaSymbol)+'''';

        sWhereRodz := sWhereRodz + ' and ZLEkr.'+sZLEkryteria_id+' = unikr.'+sUNIKRYTERIA_NR;
        sKryteriaRodzaj := SQLManager.OpenQueryWithResult(
                             'SELECT unikr.'+ sUNIKRYTERIA_RODZAJ +
                             ' FROM %s unikr, %s ZLEkr '+
                             ' WHERE ' + sWhereRodz,
                             [sUNIKRYTERIA, sZLEKRYTERIA]);
      end;

      sWhereZakTyp := sWhere;
      //Chris - Parametr dla analiz wielowymiarowych
      if bAnalizy = true then begin
        //Tabela na podstawie FKMnemoniki oraz nazwa pola dolczanego do dataseta
        sTabela := SQLMAnager.OpenQueryWithResult(
                     'select ' + sFKMNEMONIKI_TABELA +
                     ' from %s where '+
                     sFKMNEMONIKI_ID + '=' + IntToStr(iFKMnemonikiID),
                     [sFKMNEMONIKI]);
        sPole := sTabela + '_ID';

        //Dobudowanie warunku  w zalenosci od nazwy tabeli
        if sWhereZakTyp <> '' then sWhereZakTyp := sWhereZakTyp + ' and ';
        if sTabela = sFKUZ then
          sWhereZakTyp := sWhereZakTyp +
            'KRP.' + sZLEKRYTPOZ_SYMBOL + '=' + 'SL.' + sTabela + '_SYMBOL' + ' AND ' +
            'KR.' + sFKMNEMONIKI_ID + '=' + 'SL.' + sFKMNEMONIKI_ID
        else
          sWhereZakTyp := sWhereZakTyp +
            'KRP.' + sZLEKRYTPOZ_SYMBOL + '=' +  'SL.' + sTabela + '_SYMBOL';
      end;

      if sKryteriaRodzaj = sPrzeksiegRodzajWspolczynnik_ID then
      begin
        sUNIKrytPozWartoscSUM := SQLManager.OpenQueryWithResult(
                                   'SELECT SUM(KRP.' + sZLEKRYTPOZ_WARTOSC + ')' +
                                   ' FROM %s KR, %s KRP '+
                                   ' WHERE ' + sWhere,
                                   [sZLEKRYTERIA, sZLEKRYTPOZ]);
        // Convert ',' to '.'
        While Pos(',', sUNIKrytPozWartoscSUM) > 0 do
          sUNIKrytPozWartoscSUM[Pos(',', sUNIKrytPozWartoscSUM)] := '.';
        // Dzielenie przez zero
        if ((sUNIKrytPozWartoscSUM = '') OR (sUNIKrytPozWartoscSUM = '0')) then
          raise EOF_ZLEException.Create(ciParseErr_CalculateZeroDiv, csParseErr_CalculateZeroDiv);

        //Chris - rozdzial wywola dla analiz wielowymiarowych
        if bAnalizy = false then
          sQueryTextKrytPoz := 'SELECT (KRP.'+ sZLEKRYTPOZ_WARTOSC + '/' +
                               sUNIKrytPozWartoscSUM + ')' + ' as ' + sZLEKRYTPOZ_WARTOSC + ',' +
                               'KRP.' + sZLEKRYTPOZ_SYMBOL +
                               ' FROM %s KR, %s KRP '+
                               ' WHERE ' + sWhere +
                               ' ORDER BY ' + 'KRP.' + sZLEKRYTPOZ_SYMBOL
        else
          sQueryTextKrytPoz := 'SELECT (KRP.'+ sZLEKRYTPOZ_WARTOSC + '/' +
                               sUNIKrytPozWartoscSUM + ')' + ' as ' + sUNIKRYTPOZ_WARTOSC + ',' +
                               '(SL.' + sPole + ') as IDSLOW1' + ',' +
                               'KRP.' + sZLEKRYTPOZ_SYMBOL +
                               ' FROM %s KR, %s KRP, %s SL ' +
                               ' WHERE ' + sWhereZakTyp + //' and ' + sWhereOkres+
                               ' ORDER BY ' + 'KRP.' + sZLEKRYTPOZ_SYMBOL;
      end
      else begin
        //KN - rozdzial wywola dla analiz wielowymiarowych
        if bAnalizy = false then
          sQueryTextKrytPoz := 'SELECT KRP.'+ sZLEKRYTPOZ_WARTOSC + ',' + 'KRP.' + sZLEKRYTPOZ_SYMBOL +
                         ' FROM %s KR, %s KRP '+
                         ' WHERE ' + sWhere +
                         ' ORDER BY ' + 'KRP.' + sZLEKRYTPOZ_SYMBOL
        else
          sQueryTextKrytPoz := 'SELECT KRP.'+ sZLEKRYTPOZ_WARTOSC + ',' +
                               'SL.' + sPole + ' AS IDSLOW1' + ',' +
                               'KRP.' + sZLEKRYTPOZ_SYMBOL +
                               ' FROM %s KR, %s KRP, %s SL'+
                               ' WHERE ' + sWhereZakTyp + //' and ' + sWhereOkres+
                               ' ORDER BY ' + 'KRP.' + sZLEKRYTPOZ_SYMBOL;
      end;
    end
    else // SUM
      sQueryTextKrytPoz := 'SELECT SUM(KRP.' + sZLEKRYTPOZ_WARTOSC + ') as ' + sZLEKRYTPOZ_WARTOSC +
                           ' FROM %s KR, %s KRP '+
                           ' WHERE ' + sWhere +
                           ' ORDER BY ' + 'KRP.' + sZLEKRYTPOZ_WARTOSC;


   if bAnalizy = false then
     SQLManager.OpenQuery(oQueryKrytPoz,
                          sQueryTextKrytPoz,
                          [sZLEKRYTERIA, sZLEKRYTPOZ])
   else
     SQLManager.OpenQuery(oQueryKrytPoz,
                          sQueryTextKrytPoz,
                          [sZLEKRYTERIA, sZLEKRYTPOZ, sTabela]);

    {$ifndef build_zle}
    if oQueryKrytPoz.IsEmpty then
       if bAnalizy = false then
          result := nil
       else
          result := oQueryKrytPoz;
    {$endif}
    
    {$ifdef build_zle}
    if oQueryKrytPoz.IsEmpty
    // !Chris
    // jesli puste to proba przeliczenia kryterium
    // i pozniej jeszcze raz odczytanie, jesli teraz puste
    // to dopiero wyjsc z NIL
    then
    begin


      iKrytID := StrToInt(SQLManager.OpenQueryWithResult(
                        'select '+ sZLEKRYTERIA_ID +
                        ' from %s '+
                        ' where ' + sZLEKRYTERIA_SYMBOL +'='''+sZLEKryteriaSymbol+'''',
                        [sZLEKRYTERIA]));
      if ZLEPrzeliczKryteria([iKrytID], [iOkresID]) > 0 then
      begin
        result := nil;
        exit;
      end;

      //i jeszcze raz pobieranie wartosci
      SQLManager.OpenQuery(oQueryKrytPoz,
                         sQueryTextKrytPoz,
                         [sZLEKRYTERIA, sZLEKRYTPOZ]);
      if oQueryKrytPoz.IsEmpty then begin
        if bAnalizy = false then
          result := nil
        else
          result := oQueryKrytPoz;
      end
      else result := oQueryKrytPoz;

    end
    else result := oQueryKrytPoz;
    {$endif}

  except
    oQueryKrytPoz.Free;
    raise;
  end;
end;

{$ifdef build_zle}
function TZLEDataManager.AktualizujRealizacjeZleceniaKoszty( iZlecenieID, iTypZleceniaID, iOkresID: Integer;
                                                             bKosztyOkresowe: Boolean;
                                                             bZwrocDataSet: Boolean): TVirtualDataSet;

  procedure UaktualnijSkladniki( oSkladniki, oSkladnikiDoDodania: TVirtualDataSet );
  var bZnaleziony: Boolean;
  begin
    if oSkladnikiDoDodania <> nil then begin
      oSkladnikiDoDodania.First;
      while not oSkladnikiDoDodania.Eof do begin
        if oSkladnikiDoDodania.FieldByName(sUNIOKRES_ID).IsNull then
          bZnaleziony := oSkladniki.Locate( sZLESKLADWART_ID,
                                            oSkladnikiDoDodania.FieldByName(sZLESKLADWART_ID).AsInteger,
                                            [] )
        else
          bZnaleziony := oSkladniki.Locate( sUNIOKRES_ID+';'+sZLESKLADWART_ID,
                                                    VarArrayOf([ oSkladnikiDoDodania.FieldByName(sUNIOKRES_ID).AsInteger,
                                                                 oSkladnikiDoDodania.FieldByName(sZLESKLADWART_ID).AsInteger ]),
                                                    [] );
        try
          if bZnaleziony then begin
            oSkladniki.VState := vsVirtualPost;
            oSkladniki.Edit;
            with oSkladniki do begin
              FieldByName(sZLEZLECENIE_ID).AsInteger := iZlecenieID;
              FieldByName(sZLEWART_WARTOSC).AsFloat := FieldByName(sZLEWART_WARTOSC).AsFloat +
                                                       oSkladnikiDoDodania.FieldByName(sZLEWART_WARTOSC).AsFloat;
            end;
          end else begin
            oSkladniki.VState := vsInternalInsert;
            oSkladniki.Append;
            with oSkladniki do begin
              FieldByName(sZLEWART_ID).AsInteger := UniqueKey[sZLEWART];
              FieldByName(sZLEZLECENIE_ID).AsInteger := iZlecenieID;
              FieldByName(sZLESKLADWART_ID).AsInteger := oSkladnikiDoDodania.FieldByName(sZLESKLADWART_ID).AsInteger;
              FieldByName(sUNIOKRES_ID).AsString := oSkladnikiDoDodania.FieldByName(sUNIOKRES_ID).AsString;
              FieldByName(sZLEWART_WARTOSC).AsFloat := oSkladnikiDoDodania.FieldByName(sZLEWART_WARTOSC).AsFloat;
              FieldByName(sZLEWART_BLAD).AsFloat := oSkladnikiDoDodania.FieldByName(sZLEWART_BLAD).AsFloat;
            end;
            oSkladniki.UpdateModifiedRecordFlagsForAddedRecord();
          end;
          oSkladniki.Post;
        finally
          oSkladniki.VState := vsNormal;
        end;
        oSkladnikiDoDodania.Next;
      end;
    end;
  end;

var oQuery: TUNIQuery;
    oSkladnikiPodgrupy, oTempQ: TVirtualDataSet;
begin
  oQuery := nil;
  oTempQ := nil;
  oSkladnikiPodgrupy := nil;
  try
    try
      oQuery := TUNIQuery.Create(nil);
      SQLManager.OpenQuery( oQuery, ZLEOdpytajODaneSQL( sZLEWART,
                                                        sZLEALIAS_WART_ID+';'+
                                                        sZLEALIAS_WART_ZLECENIE_ID+';'+
                                                        sZLEALIAS_WART_SKLADWART_ID+';'+
                                                        sZLEALIAS_WART_OKRES_ID+';'+
                                                        sZLEALIAS_WART_WARTOSC+';' +
                                                        sZLEALIAS_WART_BLAD,
                                                        '@'+sZLEALIAS_WART_ID+'=-1', false ),
                                                        [] );

      oSkladnikiPodgrupy := TVirtualDataSet.Create( nil, oQuery, sZLEWART, omList,
                                                    TKeys.CreateWithKey(sZLEWART_ID),
                                                    true );
    finally
      if oQuery <> nil then FreeAndNil(oQuery);
    end;
    try

      {Przeliczenie zlece podrzdnych}
      oQuery := ZLEOdpytajODane( sZLEZLECENIE,
                                 sZLEALIAS_ZLECENIE_ID+';'+sZLEALIAS_ZLECENIE_TYP_ID+';'+
                                 sZLEALIAS_TYPZLECENIA_KOSZTY_OKRES,
                                 '@'+sZLEALIAS_ZLECENIE_GRUPA_ID+'='+IntToStr(iZlecenieID),
                                 true );
      if oQuery <> nil then while not oQuery.Eof do begin
        try
          oTempQ := AktualizujRealizacjeZleceniaKoszty( oQuery.FieldByName(sZLEZLECENIE_ID).AsInteger,
                                                        oQuery.FieldByName(sZLETYPZLEC_ID).AsInteger,
                                                        iOkresID,
                                                        oQuery.FieldByName(sZLETYPZLEC_KOSZTY_OKRES).AsString = sUNICONST_ALTERNATYWA_TAK,
                                                        True );
          //UaktualnijSkladniki( oSkladnikiPodgrupy, oTempQ );
        finally
          if oTempQ <> nil then FreeAndNil(oTempQ);
        end;
        oQuery.Next;
      end;
    finally
      if oQuery <> nil then FreeAndNil(oQuery);
    end;
    {Koniec przeliczania zlece podrzdnych}

    {Zaczynamy przelicza skadniki aktualnego zlecenia}
    try
      oTempQ := PrzeliczZlecenieKoszty( iZlecenieID, iTypZleceniaID, iOkresID, bKosztyOkresowe );
      {sWhere := 'where (wart.'+sZLEZLECENIE_ID+'='+IntToStr(iZlecenieID)+')';
      if iOkresID > 0 then
        sWhere := sWhere + 'and(wart.'+sUNIOKRES_ID+'='+IntToStr(iOkresID)+')';
      SQLManager.ExecuteQuery( 'delete from %s wart '+sWhere, [sZLEWART] );
      UaktualnijSkladniki( oSkladnikiPodgrupy, oTempQ );
      oSkladnikiPodgrupy.Post;}
    finally
      if oTempQ <> nil then FreeAndNil(oTempQ);
      if (not bZwrocDataSet)and(oSkladnikiPodgrupy <> nil) then
        FreeAndNil(oSkladnikiPodgrupy);
    end;
  except
    if oSkladnikiPodgrupy <> nil then FreeAndNil(oSkladnikiPodgrupy);
    raise;
  end;
  result := oSkladnikiPodgrupy;
end;

function TZLEDataManager.PrzeliczZlecenieKoszty( iZlecenieID, iTypZleceniaID, iOkresID: Integer;
                                                 bKosztyOkresowe: Boolean ): TVirtualDataSet;

  function AktualneDane( bKasuj: Boolean = true): TVirtualDataSet;
  var sSelectSQL, sDeleteSQL, sWhere, sSubSQL: String;
      oQuery: TUNIQuery;
  begin
    result := nil;

    oQuery := nil;

    sWhere := 'where (wart.%s=%d)';
    if iOkresID <> -1 then
      sWhere := sWhere + Format('and(wart.%s=%d)',[sUNIOKRES_ID,iOkresID])
    else if bKosztyOkresowe then begin
      sSubSQL := 'select ok.%s from %s ok where ok.%s=%d';
      sSubSQL := Format( sSubSQL, [ sUNIOKRES_ID, SQLManager.GetTableName(sUNIOKRES),
                                    sUNIROK_ID, vAktywnyRokObrachunkowyID] );
      sWhere := sWhere + 'and('+sUNIOKRES_ID+' in ('+sSubSQL+'))';
    end;
    sWhere := Format( sWhere, [ sZLEZLECENIE_ID, iZlecenieID ] );

    try
      //zapamitanie poprzednich informacji
      sSelectSQL := 'select * from %s wart ';
      oQuery := TUNIQuery.Create(nil);
      SQLManager.OpenQuery( oQuery, sSelectSQL+sWhere, [sZLEWART] );
      result := TVirtualDataSet.Create( nil, oQuery, sZLEWART, omList,
                                        TKeys.CreateWithKey(sZLEWART_ID), true );

      //usunicie starych informacji z bazy
      if bKasuj then begin
        sDeleteSQL := 'delete from %s wart ';
        SQLManager.ExecuteQuery( sDeleteSQL+sWhere, [sZLEWART] );
      end;
      if oQuery <> nil then oQuery.Free;
    except
      if oQuery <> nil then oQuery.Free;
      if result <> nil then result.Free;
      raise;
    end;
  end;

  function PobierzSymbolZlecenia: String;
  var oQuery: TUNIQuery;
  begin
    result := '';

    oQuery := nil;
    try
      oQuery := ZLEOdpytajODane( sZLEZLECENIE, sZLEALIAS_ZLECENIE_SYMBOL,
                                 '@'+sZLEALIAS_ZLECENIE_ID+'='+IntToStr(iZlecenieID),
                                 true );
      if oQuery <> nil then
        result := oQuery.FieldByName(sZLEZLECENIE_SYMBOL).AsString;
    finally
      if oQuery <> nil then oQuery.Free;
    end;
  end;

var oQuery: TUNIQuery;
    oInsertQuery: TUNIQuery;
    oOldQuery: TVirtualDataSet;
    iIndex, iPrzeliczoneTeraz: Integer;
    oListaOkresow: TConstStringList;
    bZnaleziony: Boolean;
    sSymbolZlecenia, sSQL, sParserBlad: String;
    oPrzeliczone: TStringList;
    fWynik: Currency;
    vPrzeliczoneItem: TZLEPrzeliczone;
begin
  result := nil;

  oQuery := nil;
  oInsertQuery := nil;
  oOldQuery := nil;
  oListaOkresow := nil;
  oPrzeliczone := nil;

  vPrzeliczoneItem := FPrzeliczoneKoszty.GetItemByValue(iZlecenieID);
  if vPrzeliczoneItem <> nil then begin
     if vPrzeliczoneItem.Przeliczone then Exit; {Zlecenie jest ju przeliczone}
  end else begin
     vPrzeliczoneItem := FPrzeliczoneKoszty.Add;
     vPrzeliczoneItem.ZleZlecenieID := iZlecenieID;
     vPrzeliczoneItem.Przeliczone := False;
  end;

  try
    oOldQuery := AktualneDane();

    oListaOkresow := WczytajOkresy();

    sSymbolZlecenia := PobierzSymbolZlecenia();

    //odwieenie informacji
    sSQL := ZLEDM.ZLEOdpytajODaneSQL( sZLETYPZLEC,
                                      sZLEALIAS_SKLADWART_ID+';'+
                                      sZLEALIAS_TYPSKLADW_ID+';'+//dodany dla prawidowego join'a
                                      sZLEALIAS_SKLADWART_RODZAJ+';'+
                                      sZLEALIAS_SKLADWART_REGULA+';'+
                                      sZLEALIAS_SKLADWART_SYMULACJA+';'+
                                      sZLEALIAS_SKLADWART_FORMAT{+';'+
                                      sZLEALIAS_SKLADWART_KOLEJNOSC},
                                      '@'+sZLEALIAS_TYPZLECENIA_ID+'='+IntToStr(iTypZleceniaID),
                                      false );
    { Zmiana kolejnoci sortowania Tomjen 2009-03-20:
      sSQL := sSQL+' order by INSTR('+sZLEALIAS_SKLADWART+'.'+sZLESKLADWART_REGULA+','+QuotedStr(cSKLAD_WART)+')';}


    sSQL := sSQL + ' order by ' + sZLEALIAS_SKLADWART+'.'+sZLESKLADWART_RODZAJ + ', ' +
                                  '(31 * INSTR(' + sZLEALIAS_SKLADWART+'.'+sZLESKLADWART_REGULA+','+QuotedStr(cSKLAD_WART)+') - 7 * INSTR(' + sZLEALIAS_SKLADWART+'.'+sZLESKLADWART_REGULA+','+QuotedStr(cSKLAD_WART + '_GRUPY')+')), ' +
                                  sZLEALIAS_SKLADWART+'.' + sZLESKLADWART_ID;

    oQuery := SQLManager.CreateQuery( sSQL );
    oQuery.Open;
    if oQuery <> nil then with oQuery do begin
      oPrzeliczone := TStringList.Create();
      oInsertQuery := SQLManager.InsertQueryStep1( sZLEWART, sZLEWART_ID+','+
                                                   sZLEZLECENIE_ID+','+
                                                   sUNIOKRES_ID+','+
                                                   sZLESKLADWART_ID+','+
                                                   sZLEWART_WARTOSC+','+
                                                   sZLEWART_BLAD+','+
                                                   sZLEWART_UZ_AU_ID+','+
                                                   sZLEWART_DATA_AU );
      with oInsertQuery do begin
        ParamByName(sZLEZLECENIE_ID).DataType := ftInteger;
        ParamByName(sUNIOKRES_ID).DataType := ftInteger;
        ParamByName(sZLESKLADWART_ID).DataType := ftInteger;
        ParamByName(sZLEWART_WARTOSC).DataType := ftFloat;
        ParamByName(sZLEWART_BLAD).DataType := ftString;
        ParamByName(sZLEWART_UZ_AU_ID).DataType := ftInteger;
        ParamByName(sZLEWART_DATA_AU).DataType := ftDate;
        ParamByName(sZLEWART_UZ_AU_ID).AsInteger := SecurityManager.UserId;
        ParamByName(sZLEWART_DATA_AU).AsDateTime := UNIDate;
      end;
      while true do begin
        iPrzeliczoneTeraz := 0;
        First;
        while not Eof do begin
          if oPrzeliczone.IndexOf(FieldByName(sZLESKLADWART_ID).AsString) = -1 then
          try
            oInsertQuery.ParamByName(sZLEZLECENIE_ID).AsInteger := iZlecenieID;

            if iOkresID = -1 then oInsertQuery.ParamByName(sUNIOKRES_ID).Clear
            else oInsertQuery.ParamByName(sUNIOKRES_ID).AsInteger := iOkresID;

            oInsertQuery.ParamByName(sZLESKLADWART_ID).AsInteger := FieldByName(sZLESKLADWART_ID).AsInteger;

            if (bKosztyOkresowe)and(iOkresID = -1) then begin

              //odwieenie informacji dla wszystkich okresw z aktywnego roku obrachunkowego
              for iIndex := 1 to oListaOkresow.Count-1 do begin
                oInsertQuery.ParamByName(sUNIOKRES_ID).AsString := oListaOkresow.ZwrocSkrot(iIndex);

                if FieldByName(sZLESKLADWART_RODZAJ).AsString = cZLERodzajSklad_RecznyID then begin
                  //pobranie jeeli bya wczeniej wpisana
                  if oOldQuery.Locate( sUNIOKRES_ID+';'+sZLESKLADWART_ID,
                                       VarArrayOf([ oInsertQuery.ParamByName(sUNIOKRES_ID).AsInteger,
                                                    oInsertQuery.ParamByName(sZLESKLADWART_ID).AsInteger ]), [] ) then begin
                    oInsertQuery.ParamByName(sZLEWART_WARTOSC).AsFloat := oOldQuery.FieldByName(sZLEWART_WARTOSC).AsFloat;
                    oInsertQuery.ParamByName(sZLEWART_BLAD).AsString := oOldQuery.FieldByName(sZLEWART_BLAD).AsString;
                  end else begin
                    oInsertQuery.ParamByName(sZLEWART_WARTOSC).AsFloat := 0.0;
                    oInsertQuery.ParamByName(sZLEWART_Blad).AsString := cZLEParserBlad_BrakID;
                  end;
                end else begin
                  //wyliczenie wartoci
                  try
                     fWynik := WyliczWartoscZRegulyKoszty( FieldByName(sZLESKLADWART_REGULA).AsString,
                                                oInsertQuery.ParamByName(sUNIOKRES_ID).AsInteger,
                                                iZlecenieID, sSymbolZlecenia,
                                                FieldByName(sZLESKLADWART_SYMULACJA).AsString = sUNICONST_ALTERNATYWA_TAK, sParserBlad);
                    {Jak nie mam bdu}


                    oInsertQuery.ParamByName(sZLEWART_WARTOSC).AsFloat := Zaokraglij(fWynik, UNIGetFracFromValueFormat(StrToFloat(FieldByName(sZLESKLADWART_FORMAT).AsString)));
                    oInsertQuery.ParamByName(sZLEWART_Blad).AsString := sParserBlad;
                  except
                    oInsertQuery.ParamByName(sZLEWART_WARTOSC).AsFloat := 0.0;
                    oInsertQuery.ParamByName(sZLEWART_Blad).AsString := sParserBlad;
                  end;
                end;
                SQLManager.InsertQueryStep2( oInsertQuery, sZLEWART_ID );
              end;
            end else begin
              //odwieenie informacji dla wybranego okresu obrachunkowego
              if FieldByName(sZLESKLADWART_RODZAJ).AsString = cZLERodzajSklad_RecznyID then begin
                if oInsertQuery.ParamByName(sUNIOKRES_ID).IsNull then
                  bZnaleziony := oOldQuery.Locate( sZLESKLADWART_ID, oInsertQuery.ParamByName(sZLESKLADWART_ID).AsInteger , [] )
                else
                  bZnaleziony := oOldQuery.Locate( sUNIOKRES_ID+';'+sZLESKLADWART_ID,
                                                   VarArrayOf([ oInsertQuery.ParamByName(sUNIOKRES_ID).AsInteger,
                                                   oInsertQuery.ParamByName(sZLESKLADWART_ID).AsInteger ]), [] );

                if bZnaleziony then begin
                    oInsertQuery.ParamByName(sZLEWART_WARTOSC).AsFloat := oOldQuery.FieldByName(sZLEWART_WARTOSC).AsFloat;
                    oInsertQuery.ParamByName(sZLEWART_BLAD).AsString := oOldQuery.FieldByName(sZLEWART_BLAD).AsString;
                end else begin
                    oInsertQuery.ParamByName(sZLEWART_WARTOSC).AsFloat := 0.0;
                    oInsertQuery.ParamByName(sZLEWART_Blad).AsString := cZLEParserBlad_BrakID;
                end;
              end else begin
                  //wyliczenie wartoci
                  try
                     fWynik := WyliczWartoscZRegulyKoszty( FieldByName(sZLESKLADWART_REGULA).AsString,
                                                oInsertQuery.ParamByName(sUNIOKRES_ID).AsInteger,
                                                iZlecenieID, sSymbolZlecenia,
                                                FieldByName(sZLESKLADWART_SYMULACJA).AsString = sUNICONST_ALTERNATYWA_TAK, sParserBlad);
                    {Jak nie mam bdu}
                    oInsertQuery.ParamByName(sZLEWART_WARTOSC).AsFloat := Zaokraglij(fWynik, UNIGetFracFromValueFormat(StrToFloat(FieldByName(sZLESKLADWART_FORMAT).AsString)));
                    oInsertQuery.ParamByName(sZLEWART_Blad).AsString := sParserBlad;
                  except
                    oInsertQuery.ParamByName(sZLEWART_WARTOSC).AsFloat := 0.0;
                    oInsertQuery.ParamByName(sZLEWART_Blad).AsString := sParserBlad;
                  end;
              end;
              SQLManager.InsertQueryStep2( oInsertQuery, sZLEWART_ID );
            end;

            Inc(iPrzeliczoneTeraz);
            oPrzeliczone.Add(FieldByName(sZLESKLADWART_ID).AsString);
          except
            on E:EOF_ZLEException do begin
              if E.ErrNo <> cError_SkladnikNiePrzeliczony then raise;
            end else raise;
          end;
          Next;
        end;  //while not Eof do
        if (oPrzeliczone.Count = oQuery.RecordCount) then break;
        if iPrzeliczoneTeraz = 0 then
          raise EOF_ZLEException.Create( 'Zlecenie nie moe by przeliczone ze wzgldu '+
                                         'na zaptlenie zalenoci pomidzy skladnikami' );
      end;  //while true do
    end;
    result := AktualneDane(false);
  finally
    if oListaOkresow <> nil then oListaOkresow.Free;
    if oQuery <> nil then oQuery.Free;
    if oInsertQuery <> nil then oInsertQuery.Free;
    if oOldQuery <> nil then oOldQuery.Free;
    if oPrzeliczone <> nil then oPrzeliczone.Free;
  end;

  vPrzeliczoneItem := FPrzeliczoneKoszty.GetItemByValue(iZlecenieID);
  if vPrzeliczoneItem <> nil then {nie powinno by w tym momencie = nil}
     vPrzeliczoneItem.Przeliczone := True; {Zaznaczamy, e Zlecenie jest ju przeliczone}

end;

procedure TZLEDataManager.ZLEPrzeliczStawki(aListaID: array of Integer);
var
  idx: Integer;
  bTrans: Boolean;
  oQuery, q: TUNIQuery;
  sRegula, sBlad: String;
  fWartosc: Double;
  oUpdateQuery: TUNIQuery;
begin
  Parser := TZLEParser.Create( Self, True, False );
  bTrans := not SQLManager.InTransaction;
  sRegula := ZLEDM.vZLEStawkaRegula;

  try
    if length(aListaID) > 0 then begin
      if Length(Trim(sRegula)) <= 0 then
         Raise EOF_ZLEException.Create('Brak reguy do wyliczenia stawki');

      if bTrans then SQLManager.StartTransaction;
      try
        for idx := 0 to Length(aListaID) - 1 do begin
          with Parser do begin
            bSymulacja      := False;
            iOkresNr        := -1;
            Parser.iFirmaID := UNISYSDM.vAktywnaFirma;
            sRok            := UNISysDM.vAktywnyRokObrachunkowy;
            sRokId          := inttostr(UNISysDM.vAktywnyRokObrachunkowyID);
          end;

          oQuery := SQLManager.CreateQuery('SELECT ZP.' + sKDOSOBA_ID + ', ' +
                                                  'ZP.' + sZLEZLECENIE_ID + ', ' +
                                                  'ZP.' + sZLEZASOBYPRACA_DATA + ', ' +
                                                  'ZP.' + sUNIOKRES_ID + ', ' +
                                                  'ZL.' + sUNIJEDNOSTKAORG_ID + ' ' +
                                           'FROM %s ZP, %s ZL ' +
                                           'WHERE ZP.' + sZLEZLECENIE_ID + '=ZL.' + sZLEZLECENIE_ID + ' AND ' +
                                                 'ZP.' + sZLEZASOBYPRACA_ID + '=' + IntToStr(aListaID[idx]),
                                           [sZLEZASOBYPRACA, sZLEZLECENIE]);
          try
            oQuery.Open();
            if not oQuery.IsEmpty then begin
               if oQuery.FieldByName(sKDOSOBA_ID).AsInteger > 0 then begin
                  with Parser do begin
                    iZlecenieID     := oQuery.FieldByName(sZLEZLECENIE_ID).AsInteger;
                    iOsobaID        := oQuery.FieldByName(sKDOSOBA_ID).AsInteger;
                    iJednostkaOrgID := oQuery.FieldByName(sUNIJEDNOSTKAORG_ID).AsInteger;
                  end;

                  q := UniSysDataManager.UNIPodajRokObrachunkowy(oQuery.FieldByName(sZLEZASOBYPRACA_DATA).AsDateTime, sUNISYSALIAS_Rok_ID+';'+sUNISYSALIAS_Rok_Rok);
                  try
                    if q = Nil then begin
                      Komunikat(cInformation, Format('Data "%d" jest niezgodna ze zdefiniowanymi latami obrachunkowymi' ,[oQuery.FieldByName(sZLEZASOBYPRACA_DATA).AsDateTime]));
                      Exit;
                    end else  begin
                      with parser do begin
                        sRok            := q.FieldByName(sUNIROK_ROK).AsString;
                        sRokId          := inttostr(q.FieldByName(sUNIROK_ID).AsInteger);
                      end;
                    end;
                  finally
                    FreeAndNil(q);
                  end;


                  try
                    fWartosc := WyliczWartoscZReguly(sRegula, oQuery.FieldByName(sUNIOkres_ID).AsInteger, sBlad);
                    fWartosc := Zaokraglij(fWartosc, 2);
                  except
                    fWartosc := 0.00;
                  end;

                  {Aktualizacja stawki wyliczona wartoscia}
                  if fWartosc <> 0.00 then begin
                    try
                       oUpdateQuery := SQLManager.UpdateQueryStep1(sZLEZASOBYPRACA,
                                                                   sZLEZASOBYPRACA_STAWKA,
                                                                   sZLEZASOBYPRACA_ID + ' = ' + IntToStr(aListaID[idx]));
                       oUpdateQuery.ParamByName(sZLEZASOBYPRACA_STAWKA).DataType := ftFloat;
                       oUpdateQuery.ParamByName(sZLEZASOBYPRACA_STAWKA).AsFloat := fWartosc;
                       SQLManager.UpdateQueryStep2(oUpdateQuery);
                    finally
                       FreeAndNil(oUpdateQuery);
                    end;
                  end;
               end;
            end;
          finally
            if oQuery <> nil then FreeAndNil(oQuery);
          end;
        end;

        if bTrans then SQLManager.Commit;
      except
        if bTrans then SQLManager.Rollback;
        Raise;
      end;
    end;
  finally
    if Parser <> nil then FreeAndNil(Parser);
  end;
end;

function TZLEDataManager.WyliczWartoscZReguly( sRegula: String; iOkresID: Integer; var sBladID: String): Extended;
var oSplit: TSplit;
    oRegula: TStringList;
    iIndex: Integer;
    s: String;
    sOkresNr: String;
    sOkresSQL: String;
begin
  result := 0.0;
  oSplit := nil;
  oRegula := nil;
  sOkresNr := '';
  sBladID := cZLEParserBlad_BrakID;

  try
    oSplit := TSplit.Create( StringReplace( Trim(sRegula),#10,'',[rfReplaceAll]), #13, '' );
    if oSplit.Count = 0 then Exit;
    oRegula := TStringList.Create();
    for iIndex := 0 to oSplit.Count-1 do begin
      oRegula.Add(oSplit[iIndex]);
    end;
    if oRegula.Count = 0 then begin
      raise EOF_ZLEException.Create( 'Brak reguy');
    end;

    sOkresSQL := UNISysDM.UNIOdpytajODaneSQL( sUNIOKRES,
                                              sUNISYSALIAS_Okres_Obrachunkowy_Numer,
                                              '@'+sUNISYSALIAS_Okres_Obrachunkowy_ID+'='+
                                              IntToStr(iOkresId), true,
                                              Parser.iFirmaID );

    sOkresNr := SQLManager.OpenQueryWithResult( sOkresSQL );
    Parser.iOkresNr := 0;
    if sOkresNr <> '' then Parser.iOkresNr := StrToInt(sOkresNr);

    if Parser.ScriptExecute( 'Kontrola realizacji zlecenia', oRegula, False) = 0 then begin
      s := '';
      case VarType(Parser.ResultOfScript) of
        varSmallint, varInteger: result := Parser.ResultOfScript;
        varSingle, varDouble, varCurrency: result := Parser.ResultOfScript;
        {varDate: s := DateToStr(Parser.ResultOfScript);
        varBoolean: if Parser.ResultOfScript = True then s := 'TRUE' else s := 'FALSE';
        varString: s := Parser.ResultOfScript;}
      end;
    end else begin
      //na razie wyszukiwanie w message'u, pniej powinno by sprawdzanie
      //Parser.Errors[Parser.Errors.Count - 1].ErrNo
      if Pos('nie zostaa jeszcze przeliczona', Parser.Errors[Parser.Errors.Count - 1].ErrorMessage) > 0 then
        raise EOF_ZLEException.Create( cError_SkladnikNiePrzeliczony, 'Skadnik nie przeliczony' )
      else begin
        if (Parser.Errors[Parser.Errors.Count - 1].ErrorMessage = cplDzieleniePrzezZero) then
             sBladID := cZLEParserBlad_DzielZeroID
        else sBladID := cZLEParserBlad_BladInnyID;

        raise EOF_ZLEException.Create( 'Linia: ' +
                                       IntToStr(Parser.Errors[Parser.Errors.Count - 1].Line) + '. ' +
                                       'Kolumna: ' + IntToStr(Parser.Errors[Parser.Errors.Count - 1].Column) + '. ' +
                                       Parser.Errors[Parser.Errors.Count - 1].ErrorMessage );
      end;
    end;
    //result := StrToFloat(s);
  finally
    if oSplit <> nil then oSplit.Free;
    if oRegula <> nil then oRegula.Free;
  end;
end;

// Zwraca pierwszy wolny mnemonik postaci XX?
function TZLEDataManager.ZlePodajNastepnyMnemonik(): String;
var
   q: TUNIQuery;
   Znak: Char;
   Napis, sPrefix: String;
begin
   result := 'XXA';
   q := SQLManager.CreateQuery(' SELECT MAX(' + sFKMNEMONIKI_MNEMONIK + ') AS ' + sFKMNEMONIKI_MNEMONIK +
                               ' FROM ' + SQLManager.GetTableName(sFKMNEMONIKI) +
                               ' WHERE (UPPER(' + sFKMNEMONIKI_MNEMONIK + ') LIKE ' + QuotedStr('XX%') + ') OR ' +
                                      '(UPPER(' + sFKMNEMONIKI_MNEMONIK + ') LIKE ' + QuotedStr('XY%') + ')'{ +
                               ' ORDER BY ' + sFKMNEMONIKI_MNEMONIK});
   try
     if q <> nil then begin
        q.Open;
        if not q.IsEmpty then begin
           Napis := q.Fields[0].AsString;

           if Napis = '' then begin
             result := 'XXA';  //Nie ma jeszcze nic w tabeli
           end else begin
             sPrefix := Copy(Napis, 1, 2);
             Znak := Napis[3];

             if Znak = 'Z' then begin
                if sPrefix = 'XX' then
                   result := 'XYA'
                else begin
                   result := '';
                   Komunikat(cWarning, 'Wyczerpano ju limit kryteriw w module'#13+
                                       'Dostpne tylko mnemoniki XXA - XYZ');
                end;
             end;

             Znak := Chr(Ord(Znak) + 1);
             if (Znak >= 'A') and (Znak <= 'Z') then
                result := sPrefix + Znak
             else begin
                result := '';
                Komunikat(cWarning, 'Wyczerpano ju limit kryteriw w module'#13+
                                    'Dostpne tylko mnemoniki XXA - XYZ');
             end;
           end;
        end else result := 'XXA';
     end;
   finally
     if q <> nil then FreeAndNil(q);
   end;
end;


//Zwraca id mnemonika
function TZLEDataManager.ZLEDopiszMnemonik(sMnemonik: String; sRegula: String; bPola: Boolean): Integer;
{procedure DopiszMnemonik( const ac_sMnemonik, ac_sNazwa, ac_sTabela,
                                ac_sLokalizacja: String;
                                a_bFirmowy: Boolean = False;
                                a_sOpis: String = '' );}
var
  sSQL: String;
  i, iDlugosc, iDlugTxt: Integer;
  oQuery, qMnemTmp: TUNIQuery;
  sTabela, sListaMnem: String;
  oSplit: TSplit;
begin
  result := -1;
  iDlugosc  := 0;
  sTabela := sZLEModulID + sMnemonik;
  sListaMnem := '';
  iDlugTxt := 0;
  if Pos(',', sRegula) > 0 then begin
    oSplit:= TSplit.Create(sRegula, ',', '');
    try
      for i := 0 to oSplit.Count - 1 do begin
        if (copy(Trim(oSplit.Items[i]), 1, 1) = '''') then begin
           if (copy(Trim(oSplit.Items[i]), length(Trim(oSplit.Items[i])), 1) = '''') then begin
              iDlugTxt := iDlugTxt + Length(Trim(oSplit.Items[i])) - 2;
              Continue; {Pomijamy stae tekstowe}
           end else begin
              Komunikat(cWarning, 'Nieprawidowa ilo apostrofw');
              Exit;
           end;
        end;

        sSQL := 'SELECT ' + sFKMNEMONIKI_DLUGOSC + ' ' +
                'FROM %s ' +
                'WHERE ' + sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr(Copy(Trim(oSplit.Items[i]), 1, 3));

        if Length(Trim(oSplit.Items[i])) > 3 then
             sSQL :=  sSQL + ' AND ' + sFKMNEMONIKI_INDEKS  + ' = ' +  Copy(Trim(oSplit.Items[i]), 4, 1)
        else sSQL :=  sSQL + ' AND ' + sFKMNEMONIKI_INDEKS  + ' = 0';

        qMnemTmp := SQLManager.CreateQuery(sSQL, [sFKMNEMONIKI]);

        try
           qMnemTmp.Open();
           if not qMnemTmp.IsEmpty then begin
              iDlugTxt := iDlugTxt + qMnemTmp.FieldByName(sFKMNEMONIKI_DLUGOSC).AsInteger;
           end;

        finally
           if qMnemTmp <> nil then FreeAndNil(qMnemTmp);
        end;
        (***********************************************
        if bDopisz then sListaMnem := sListaMnem + ', ';
        sListaMnem := sListaMnem + QuotedStr(Trim(oSplit.Items[i]));
        if not bDopisz then bDopisz := True;
        ***********************************************)
      end;
    finally
      oSplit.Free;
    end;
  end else begin
     {Pojedyczy skadnik}
     if (copy(Trim(sRegula), 1, 1) = '''') then begin
        if (copy(Trim(sRegula), length(Trim(sRegula)), 1) = '''') then begin
           iDlugTxt := iDlugTxt + Length(Trim(sRegula)) - 2;
        end else begin
          Komunikat(cWarning, 'Nieprawidowa ilo apostrofw');
          Exit;
        end;
     end else begin {pojedynczy mnemonik}
        sListaMnem := Trim(sRegula);

        sSQL := 'SELECT ' + sFKMNEMONIKI_DLUGOSC + ' ' +
                'FROM %s ' +
                'WHERE ' + sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr(Copy(sListaMnem, 1, 3));

        if Length(Trim(sListaMnem)) > 3 then
             sSQL :=  sSQL + ' AND ' + sFKMNEMONIKI_INDEKS  + ' = ' +  Copy(Trim(sListaMnem), 4, 1)
        else sSQL :=  sSQL + ' AND ' + sFKMNEMONIKI_INDEKS  + ' = 0';
        
        qMnemTmp := SQLManager.CreateQuery(sSQL, [sFKMNEMONIKI]);

        try
           qMnemTmp.Open();
           if not qMnemTmp.IsEmpty then begin
              iDlugTxt := iDlugTxt + qMnemTmp.FieldByName(sFKMNEMONIKI_DLUGOSC).AsInteger;
           end;

        finally
           if qMnemTmp <> nil then FreeAndNil(qMnemTmp);
        end;

     end;
  end;

  (************************
  iDlugosc := 0;
  try
     if sListaMnem <> '' then begin
        iDlugosc := StrToInt(SQLManager.OpenQueryWithResult('SELECT SUM(' + sFKMNEMONIKI_DLUGOSC + ') AS ' + sFKMNEMONIKI_DLUGOSC + ' ' +
                                                            'FROM %s ' +
                                                            'WHERE ' + sFKMNEMONIKI_MNEMONIK + ' IN (' + sListaMnem + ') AND ' +
                                                                       sFKMNEMONIKI_INDEKS + ' = 0',
                                                            [sFKMNEMONIKI]));
     end;
  except
    iDlugosc := 0;
    Komunikat(cError, 'Bd podczas ustalania dugoci mnemonika');
    Raise;
  end;
  *****************************)

  if iDlugTxt = 0 then begin
     Komunikat(cError, 'Bdna definicja skadnikw');
     Exit;
  end;

  {1. Utworzenie tabeli dla mnemonika}
  try
     sSQL := 'CREATE TABLE ' +
                    SQLManager.GetTableName(sTabela) + ' (' +
                       sTabela + cSuffixPola_ID + ' NUMBER(10,1) NOT NULL, ' +
                       sTabela + cSuffixPola_Symbol + ' VARCHAR2(' + IntToStr(iDlugTxt) + ') NOT NULL, ' +
                       sTabela + cSuffixPola_Nazwa + ' VARCHAR2(' + IntToStr(cZLEDlugoscPola_Nazwa) + ') NULL, ';

     if bPola then
        sSQL := sSQL + sTabela + '_POLE1 VARCHAR2(20) NULL, ' +
                       sTabela + '_POLE2 VARCHAR2(20) NULL, ' +
                       sTabela + '_POLE3 VARCHAR2(20) NULL, ';

    { sSQL := sSQL +    sTabela + '_WARTOSC' + ' NUMBER(20,6) NULL, ' +
                       sUNIOKRES_ID + ' NUMBER(10,1) NULL, ' +
                       sUNIROK_ID + ' NUMBER(10,1) NULL, ' +
                       sZLEKRYTERIA_ID + ' NUMBER(10,1) NULL, ' +
                       sTabela + '_UZ_AU_ID NUMBER(10,1) NOT NULL, ' +
                       sTabela + '_DATA_AU DATE NOT NULL, ' +
                       sTabela + '_UZ_ZM_ID NUMBER(10,1) NULL, ' +
                       sTabela + '_DATA_ZM DATE NULL' + ')';}

     sSQL := sSQL +    sTabela + '_UZ_AU_ID NUMBER(10,1) NOT NULL, ' +
                       sTabela + '_DATA_AU DATE NOT NULL, ' +
                       sTabela + '_UZ_ZM_ID NUMBER(10,1) NULL, ' +
                       sTabela + '_DATA_ZM DATE NULL' + ')';

     SQLManager.ExecuteQuery(sSQL);

     SQLManager.ExecuteQuery('ALTER TABLE ' + SQLManager.GetTableName(sTabela) +
                    ' ADD CONSTRAINT ' + sTabela + '_PRK PRIMARY KEY(' + sTabela + cSuffixPola_ID + ')');

     SQLManager.ExecuteQuery('CREATE UNIQUE INDEX ' + SQLManager.GetTableName(sTabela + '_UNK') +
                    ' ON ' + SQLManager.GetTableName(sTabela) + ' (' + sTabela + cSuffixPola_Symbol{+ ', ' +
                                                                       sUNIOKRES_ID + ', ' +
                                                                       sUNIROK_ID + ', '}
                                                                   +')');

  except
     Komunikat(cError, 'Bd podczas tworzenia tabeli dla mnemonika ' + sMnemonik);
     Raise;
  end;

  {2. Dopisanie mnemonika}
  oQuery := SQLManager.InsertQueryStep1( sFKMNEMONIKI,
                                         sFKMNEMONIKI_ID+','+
                                         sFKMNEMONIKI_MNEMONIK+','+
                                         sFKMNEMONIKI_INDEKS+','+
                                         sFKMNEMONIKI_NAZWA+','+
                                         sFKMNEMONIKI_WSKAZNIK+','+
                                         sFKMNEMONIKI_TABELA+','+
                                         sFKMNEMONIKI_LOKALIZACJA+','+
                                         sFKMNEMONIKI_DLUGOSC+','+
                                         sFKMNEMONIKI_OPIS+','+
                                         sFKMNEMONIKI_CZY_FIRM+','+
                                         sFKMNEMONIKI_UZ_AU_ID+','+
                                         sFKMNEMONIKI_DATA_AU );
  try
    if oQuery <> nil then
    with oQuery do begin
      ParamByName(sFKMNEMONIKI_MNEMONIK).AsString := sMnemonik;
      ParamByName(sFKMNEMONIKI_INDEKS).AsInteger := 0;
      ParamByName(sFKMNEMONIKI_NAZWA).AsString := 'Mnemonik kryterium ' + sMnemonik;
      ParamByName(sFKMNEMONIKI_WSKAZNIK).AsString := 'P';
      ParamByName(sFKMNEMONIKI_TABELA).AsString := sTabela;
      ParamByName(sFKMNEMONIKI_LOKALIZACJA).AsString := sZLEModulID;
      ParamByName(sFKMNEMONIKI_DLUGOSC).AsInteger := (iDlugosc + iDlugTxt);
      ParamByName(sFKMNEMONIKI_OPIS).AsString := '';
      if vWielofirmowosc then
        ParamByName(sFKMNEMONIKI_CZY_FIRM).AsString := sTak
      else
        ParamByName(sFKMNEMONIKI_CZY_FIRM).AsString := sNie;

      ParamByName(sFKMNEMONIKI_UZ_AU_ID).AsInteger := SecurityManager.UserId;
      ParamByName(sFKMNEMONIKI_DATA_AU).AsDateTime := UNINow;
      SQLManager.InsertQueryStep2( oQuery, sFKMNEMONIKI_ID );
      result := ParamByName(sFKMNEMONIKI_ID).AsInteger;

      if bPola then begin
        //<mnemonik>1
        ParamByName(sFKMNEMONIKI_INDEKS).AsInteger := 1;
        ParamByName(sFKMNEMONIKI_NAZWA).AsString := 'Mnemonik kryterium ' + sMnemonik + '-1';
        ParamByName(sFKMNEMONIKI_DLUGOSC).AsInteger := 0;
        SQLManager.InsertQueryStep2( oQuery, sFKMNEMONIKI_ID );
        //<mnemonik>2
        ParamByName(sFKMNEMONIKI_INDEKS).AsInteger := 2;
        ParamByName(sFKMNEMONIKI_NAZWA).AsString := 'Mnemonik kryterium ' + sMnemonik + '-2';
        ParamByName(sFKMNEMONIKI_DLUGOSC).AsInteger := 0;
        SQLManager.InsertQueryStep2( oQuery, sFKMNEMONIKI_ID );
        //<mnemonik>3
        ParamByName(sFKMNEMONIKI_INDEKS).AsInteger := 3;
        ParamByName(sFKMNEMONIKI_NAZWA).AsString := 'Mnemonik kryterium ' + sMnemonik + '-3';
        ParamByName(sFKMNEMONIKI_DLUGOSC).AsInteger := 0;
        SQLManager.InsertQueryStep2( oQuery, sFKMNEMONIKI_ID );
      end;
    end;
  finally
    if oQuery <> nil then FreeAndNil(oQuery);
  end;
end;

function TZLEDataManager.AktualizujRealizacjeZleceniaExt( iZlecenieID, iTypZleceniaID,
                                                          iOkresID, iAsortID, iFirmaID: Integer;
                                                          bKoszty, bOkresowa: Boolean): TVirtualDataSet;
var bTrans: Boolean;
begin
  Parser  := nil;
  result  := nil;
  bTrans  := not SQLManager.InTransaction;
  if bTrans then SQLManager.StartTransaction;
  try
    Parser := TZLEParser.Create( Self, bKoszty );
    Parser.iZlecenieId := iZlecenieID;
    Parser.iFirmaID := iFirmaID;
    with Parser do begin
      bSymulacja := False;
      iOkresNr:= 1;
      sRok:= UNISysDM.vAktywnyRokObrachunkowy;
      sRokId:= inttostr(UNISysDM.vAktywnyRokObrachunkowyID);
    end;

    if ZLEDM.vZLEPrzeliczanie and bOkresowa and (ZLEDM.vZLEPrzeliczOkresID > 0) then
       if iOkresID <= 0 then
          iOkresID := ZLEDM.vZLEPrzeliczOkresID;

    if bKoszty then
      AktualizujRealizacjeZleceniaKoszty( iZlecenieID, iTypZleceniaID,
                                          iOkresID, bOkresowa )
    else
      AktualizujRealizacjeZleceniaIlosci( iZlecenieID, iTypZleceniaID,
                                          iOkresID, iAsortID, bOkresowa );
    if Parser <> nil then FreeAndNil(Parser);
    if bTrans then SQLManager.Commit;
  except
    if Parser <> nil then FreeAndNil(Parser);
    if bTrans then SQLManager.Rollback;
    raise;
  end;
end;

function TZLEDataManager.WyliczWartoscZRegulyIlosci(sRegula: String;
  iOkresID, iZlecenieID: Integer; sSymbolZlecenia, sIndeksAsortymentu: String;
  iAsortId: Integer; var sBladID: String): Extended;
begin
  sRegula := StringReplace( sRegula, #32, '', [rfReplaceAll] );
  sRegula := StringReplace( sRegula, #13#10, '', [rfReplaceAll] );
  sRegula := StringReplace( sRegula, cZLEParamSymbolZlec,
                            sSymbolZlecenia, [rfReplaceAll, rfIgnoreCase] );
  sRegula := StringReplace( sRegula, cZLEParamIndeksAsort,
                            sIndeksAsortymentu, [rfReplaceAll, rfIgnoreCase] );
  Parser.iAsortId := iAsortId;
  Parser.iZlecenieId := iZlecenieID;
  result := WyliczWartoscZReguly( sRegula, iOkresID, sBladID );
end;

function TZLEDataManager.WyliczWartoscZRegulyKoszty(sRegula: String;
  iOkresID, iZlecenieID: Integer; sSymbolZlecenia: String; bSymulacja: Boolean; var sBladID: String): Extended;
var
  bOldSymulacja: Boolean;
begin
  bOldSymulacja := Parser.bSymulacja;

  sRegula := StringReplace( sRegula, #32, '', [rfReplaceAll] );
  sRegula := StringReplace( sRegula, #13#10, '', [rfReplaceAll] );
  sRegula := StringReplace( sRegula, cZLEParamSymbolZlec, sSymbolZlecenia, [rfReplaceAll,rfIgnoreCase] );
  Parser.iZlecenieId := iZlecenieID;
  Parser.bSymulacja := bSymulacja;
  try
    result := WyliczWartoscZReguly( sRegula, iOkresID, sBladID );
  finally
    Parser.bSymulacja := bOldSymulacja;
  end;
end;

function TZLEDataManager.PrzeliczZlecenieIlosci( iZlecenieID, iTypZleceniaID,
                                                 iOkresID, iAsortID: Integer;
                                                 bIlosciOkresowe: Boolean): TVirtualDataSet;
  function AktualneDane( iZleceniePozID: Integer; bKasuj: Boolean = true): TVirtualDataSet;
  var sSelectSQL, sDeleteSQL, sWhere, sSubSQL: String;
      oQuery: TUNIQuery;
  begin
    result := nil;

    oQuery := nil;

    sWhere := 'where (il.%s=%d)';
    if iOkresID <> -1 then
      sWhere := sWhere + Format('and(il.%s=%d)',[sUNIOKRES_ID,iOkresID])
    else if bIlosciOkresowe then begin
      sSubSQL := 'select ok.%s from %s ok where ok.%s=%d';
      sSubSQL := Format( sSubSQL, [ sUNIOKRES_ID, SQLManager.GetTableName(sUNIOKRES),
                                    sUNIROK_ID, vAktywnyRokObrachunkowyID] );
      sWhere := sWhere+
                'and('+sUNIOKRES_ID+' in ('+sSubSQL+'))'
    end;
    sWhere := Format( sWhere, [ sZLEZLECENIEPOZ_ID, iZleceniePozID ] );

    try
      //zapamitanie poprzednich informacji
      sSelectSQL := 'select * from %s il ';
      oQuery := TUNIQuery.Create(nil);
      SQLManager.OpenQuery( oQuery, sSelectSQL+sWhere, [sZLEIL] );
      result := TVirtualDataSet.Create( nil, oQuery, sZLEIL, omList,
                                        TKeys.CreateWithKey(sZLEIL_ID), true );

      //usunicie starych informacji z bazy
      if bKasuj then begin
        sDeleteSQL := 'delete from %s il ';
        SQLManager.ExecuteQuery( sDeleteSQL+sWhere, [sZLEIL] );
      end;
      if oQuery <> nil then oQuery.Free;
    except
      if oQuery <> nil then oQuery.Free;
      if result <> nil then result.Free;
      raise;
    end;
  end;

  function PobierzSymbolZlecenia: String;
  var oQuery: TUNIQuery;
  begin
    result := '';

    oQuery := nil;
    try
      oQuery := ZLEOdpytajODane( sZLEZLECENIE, sZLEALIAS_ZLECENIE_SYMBOL,
                                 '@'+sZLEALIAS_ZLECENIE_ID+'='+IntToStr(iZlecenieID),
                                 true );
      if oQuery <> nil then
        result := oQuery.FieldByName(sZLEZLECENIE_SYMBOL).AsString;
    finally
      if oQuery <> nil then oQuery.Free;
    end;
  end;

  procedure AppendData( oFrom, oTo: TVirtualDataSet; bFreeFrom: Boolean = True );
  var iIndex: Integer;
  begin
    if (oFrom <> nil)and(oTo <> nil) then begin
      oFrom.First;
      while not oFrom.Eof do begin
        try
          oTo.VState := vsInternalInsert;
          oTo.Append;
          for iIndex := 0 to oFrom.Fields.Count-1 do begin
            oTo.Fields[iIndex].AsString := oFrom.Fields[iIndex].AsString;
          end;
          oTo.UpdateModifiedRecordFlagsForAddedRecord;
          oTo.Post;
          oTo.VState := vsNormal;
        except
          oTo.Cancel;
          raise;
        end;
        oFrom.Next;
      end;
    end;
    if bFreeFrom then oFrom.Free;
  end;

var oQuery: TUNIQuery;
    oPozQuery: TUNIQuery;
    oInsertQuery: TUNIQuery;
    oOldQuery: TVirtualDataSet;
    sWhere: String;
    iIndex, iPrzeliczoneTeraz: Integer;
    oListaOkresow: TConstStringList;
    sSymbolZlecenia, sSQL, sBladParserID: String;
    bZnaleziony, bPomin: Boolean;
    oPrzeliczone: TStringList;
    fWynik: Currency;
    vPrzeliczoneItem : TZLEPrzeliczone;
begin
  result := nil;

  oQuery := nil;
  oPozQuery := nil;
  oInsertQuery := nil;
  oOldQuery := nil;
  oPrzeliczone := nil;
  sBladParserID := cZLEParserBlad_BrakID;

  vPrzeliczoneItem := FPrzeliczoneIlosci.GetItemByValue(iZlecenieID);
  if vPrzeliczoneItem <> nil then begin
     if vPrzeliczoneItem.Przeliczone then Exit; {Zlecenie jest ju przeliczone}
  end else begin
     vPrzeliczoneItem := FPrzeliczoneIlosci.Add;
     vPrzeliczoneItem.ZleZlecenieID := iZlecenieID;
     vPrzeliczoneItem.Przeliczone := False;
  end;

  try
    try
      oListaOkresow := WczytajOkresy();
      sSymbolZlecenia := PobierzSymbolZlecenia();

      sWhere := '(@'+sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID+'='+IntToStr(iZlecenieID)+')';
      if iAsortID <> -1 then
        sWhere := sWhere+
                  'and(@'+sZLEALIAS_ZLECENIEPOZ_ASORT_ID+'='+IntToStr(iAsortID)+')';

      {function TZLEDataManager.DopiszPozycjeZlecenia( iZlecenieID, iTypZleceniaID,
                                                iOkresID: Integer; bIlosciOkresowe: Boolean): Integer;}


      {Ignorujemy wynik z funkcji - typu integer}
      DopiszPozycjeZlecenia( iZlecenieID, iTypZleceniaID, iOkresID, bIlosciOkresowe);

      oPozQuery := ZLEDM.ZLEOdpytajODane( sZLEZLECENIEPOZ,
                                          sZLEALIAS_ZLECENIEPOZ_ID+';'+
                                          sZLEALIAS_ASORT_INDEKS+';'+
                                          sZLEALIAS_ZLECENIEPOZ_ASORT_ID,
                                          sWhere, true );
      if oPozQuery <> nil then while not oPozQuery.Eof do begin
        try
          oOldQuery := AktualneDane( oPozQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger );

          //odswierzenie informacji
          sSQL := ZLEDM.ZLEOdpytajODaneSQL( sZLETYPZLEC,
                                            sZLEALIAS_SKLADIL_ID+';'+
                                            sZLEALIAS_TYPSKLADIL_ID+';'+//dodany dla prawidowego join'a
                                            sZLEALIAS_SKLADIL_RODZAJ+';'+
                                            sZLEALIAS_SKLADIL_REGULA,
                                            '@'+sZLEALIAS_TYPZLECENIA_ID+'='+IntToStr(iTypZleceniaID),
                                            false );
          sSQL := sSQL+' order by INSTR('+sZLEALIAS_SKLADIL+'.'+sZLESKLADIL_REGULA+','+QuotedStr(cSKLAD_IL)+')';
          oQuery := SQLManager.CreateQuery(sSQL);
          oQuery.Open;
          if oQuery <> nil then with oQuery do begin
            oPrzeliczone := TStringList.Create();
            oInsertQuery := SQLManager.InsertQueryStep1( sZLEIL, sZLEIL_ID+','+
                                                         sZLEZLECENIEPOZ_ID+','+
                                                         sUNIOKRES_ID+','+
                                                         sZLESKLADIL_ID+','+
                                                         sZLEIL_ILOSC+','+
                                                         sZLEIL_BLAD+','+
                                                         sZLEIL_UZ_AU_ID+','+
                                                         sZLEIL_DATA_AU );
            with oInsertQuery do begin
              ParamByName(sZLEZLECENIEPOZ_ID).DataType := ftInteger;
              ParamByName(sUNIOKRES_ID).DataType := ftInteger;
              ParamByName(sZLESKLADIL_ID).DataType := ftInteger;
              ParamByName(sZLEIL_ILOSC).DataType := ftFloat;
              ParamByName(sZLEIL_BLAD).DataType := ftString;
              ParamByName(sZLEIL_UZ_AU_ID).DataType := ftInteger;
              ParamByName(sZLEIL_DATA_AU).DataType := ftDate;
              ParamByName(sZLEIL_UZ_AU_ID).AsInteger := SecurityManager.UserId;
              ParamByName(sZLEIL_DATA_AU).AsDateTime := UNIDate;
            end;

            while true do begin
              iPrzeliczoneTeraz := 0;
              First;
              while not Eof do begin
                if oPrzeliczone.IndexOf(FieldByName(sZLESKLADIL_ID).AsString) = -1 then
                try
                  oInsertQuery.ParamByName(sZLEZLECENIEPOZ_ID).AsInteger := oPozQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger;

                  if iOkresID = -1 then oInsertQuery.ParamByName(sUNIOKRES_ID).Clear
                  else oInsertQuery.ParamByName(sUNIOKRES_ID).AsInteger := iOkresID;

                  oInsertQuery.ParamByName(sZLESKLADIL_ID).AsInteger := FieldByName(sZLESKLADIL_ID).AsInteger;

                  if bIlosciOkresowe and (iOkresID = -1) then begin

                    //odwieenie informacji dla wszystkich okresw z aktywnego roku obrachunkowego
                    for iIndex := 1 to oListaOkresow.Count-1 do begin
                      oInsertQuery.ParamByName(sUNIOKRES_ID).AsString := oListaOkresow.ZwrocSkrot(iIndex);

                      {Sprawdzamy tu czy w danym okresie istnieja dokumenty dla danego asortymenty}
                      if vZLEAsoZMag then begin
                         if not MAGDM.MAGSprawdzAsortDlaZlecWOkresie(iZlecenieID,
                                                                     oInsertQuery.ParamByName(sUNIOKRES_ID).AsInteger,
                                                                     oPozQuery.FieldByName(sASOASORT_ID).AsInteger) then begin
                            {Nie ma dokumentw - pomijamy dopisywanie pozycji}
                            Continue;
                         end;
                      end;

                      if FieldByName(sZLESKLADIL_RODZAJ).AsString = cZLERodzajSklad_RecznyID then begin
                        //pobranie jeeli bya wczeniej wpisana
                        if oOldQuery.Locate( sUNIOKRES_ID+';'+sZLESKLADIL_ID,
                                             VarArrayOf([ oInsertQuery.ParamByName(sUNIOKRES_ID).AsInteger,
                                                          oInsertQuery.ParamByName(sZLESKLADIL_ID).AsInteger ]), [] ) then begin
                          oInsertQuery.ParamByName(sZLEIL_ILOSC).AsFloat := oOldQuery.FieldByName(sZLEIL_ILOSC).AsFloat;
                          oInsertQuery.ParamByName(sZLEIL_BLAD).AsString := oOldQuery.FieldByName(sZLEIL_BLAD).AsString;

                        end else begin
                          oInsertQuery.ParamByName(sZLEIL_ILOSC).AsFloat := 0.0;
                          oInsertQuery.ParamByName(sZLEIL_BLAD).AsString := cZLEParserBlad_BrakID;
                        end;
                      end else begin
                        //wyliczenie wartoci
                        {1. Proba wyliczenia ilosci}
                        {2. Jesli blad, to wpisujemy wartosc 0 i zaznaczamy BLAD}
                        try
                           fWynik := WyliczWartoscZRegulyIlosci( FieldByName(sZLESKLADIL_REGULA).AsString,
                                                    oInsertQuery.ParamByName(sUNIOKRES_ID).AsInteger,
                                                    iZlecenieID, sSymbolZlecenia,
                                                    oPozQuery.FieldByName(sASOASORT_INDEKS).AsString,
                                                    oPozQuery.FieldByName(sASOASORT_ID).AsInteger, sBladParserID);
                           oInsertQuery.ParamByName(sZLEIL_ILOSC).AsFloat := fWynik; //jak nie ma bdu
                           oInsertQuery.ParamByName(sZLEIL_BLAD).AsString := cZLEParserBlad_BrakID;
                         except
                           {jak jest bd}
                           oInsertQuery.ParamByName(sZLEIL_ILOSC).AsFloat := 0.0;
                           oInsertQuery.ParamByName(sZLEIL_BLAD).AsString := sBladParserID;
                         end;
                      end;
                      SQLManager.InsertQueryStep2( oInsertQuery, sZLEIL_ID );
                    end;
                  end else begin
                    bPomin := False;
                    {Sprawdzamy tu czy w danym okresie istnieja dokumenty dla danego asortymenty}
                    if vZLEAsoZMag then begin
                       if not MAGDM.MAGSprawdzAsortDlaZlecWOkresie(iZlecenieID,
                                                                   oInsertQuery.ParamByName(sUNIOKRES_ID).AsInteger,
                                                                   oPozQuery.FieldByName(sASOASORT_ID).AsInteger) then begin
                          {Nie ma dokumentw - pomijamy dopisywanie pozycji}
                          bPomin := True;
                       end;
                    end;

                    if not bPomin then begin

                       if FieldByName(sZLESKLADIL_RODZAJ).AsString = cZLERodzajSklad_RecznyID then begin
                         //pobranie jeeli bya wczeniej wpisana
                         if (oInsertQuery.ParamByName(sUNIOKRES_ID).IsNull) then
                           bZnaleziony := oOldQuery.Locate( sZLESKLADIL_ID, oInsertQuery.ParamByName(sZLESKLADIL_ID).AsInteger, [] )
                         else
                           bZnaleziony := oOldQuery.Locate( sUNIOKRES_ID+';'+sZLESKLADIL_ID,
                                                            VarArrayOf([ oInsertQuery.ParamByName(sUNIOKRES_ID).AsString,
                                                                         oInsertQuery.ParamByName(sZLESKLADIL_ID).AsInteger ]), [] );
                         if bZnaleziony then begin
                           oInsertQuery.ParamByName(sZLEIL_ILOSC).AsFloat := oOldQuery.FieldByName(sZLEIL_ILOSC).AsFloat;
                           oInsertQuery.ParamByName(sZLEIL_BLAD).AsString := oOldQuery.FieldByName(sZLEIL_BLAD).AsString;
                         end else begin
                           oInsertQuery.ParamByName(sZLEIL_ILOSC).AsFloat := 0.0;
                           oInsertQuery.ParamByName(sZLEIL_BLAD).AsString := cZLEParserBlad_BrakID;
                         end;
                       end else begin
                           //wyliczenie wartoci
                           {1. Proba wyliczenia ilosci}
                           {2. Jesli blad, to wpisujemy wartosc 0 i zaznaczamy BLAD}
                           try
                              fWynik := WyliczWartoscZRegulyIlosci( FieldByName(sZLESKLADIL_REGULA).AsString,
                                                       oInsertQuery.ParamByName(sUNIOKRES_ID).AsInteger,
                                                       iZlecenieID, sSymbolZlecenia,
                                                       oPozQuery.FieldByName(sASOASORT_INDEKS).AsString,
                                                       oPozQuery.FieldByName(sASOASORT_ID).AsInteger, sBladParserID);
                              oInsertQuery.ParamByName(sZLEIL_ILOSC).AsFloat := fWynik; //jak nie ma bdu
                              oInsertQuery.ParamByName(sZLEIL_BLAD).AsString := cZLEParserBlad_BrakID;
                           except
                              {jak jest bd}
                              oInsertQuery.ParamByName(sZLEIL_ILOSC).AsFloat := 0.0;
                              oInsertQuery.ParamByName(sZLEIL_BLAD).AsString := sBladParserID;
                            end;
                       end;
                       SQLManager.InsertQueryStep2( oInsertQuery, sZLEIL_ID );
                    end;
                  end;
                  Inc(iPrzeliczoneTeraz);
                  oPrzeliczone.Add(FieldByName(sZLESKLADIL_ID).AsString);
                except
                  on E:EOF_ZLEException do begin
                    if E.ErrNo <> cError_BrakSkladnika then raise;
                  end else raise;
                end;
                Next;
              end;  //while not Eof do
              if (oPrzeliczone.Count = oQuery.RecordCount) then break;
              if iPrzeliczoneTeraz = 0 then
                raise EOF_ZLEException.Create( 'Zlecenie nie moe by przeliczone ze wzgldu '+
                                               'na zaptlenie zalenoci pomidzy skladnikami' );
            end;  //while true do
          end;
        finally
          if oQuery <> nil then FreeAndNil(oQuery);
          if oInsertQuery <> nil then oInsertQuery.Free;
          if oOldQuery <> nil then oOldQuery.Free;
          if oPrzeliczone <> nil then oPrzeliczone.Free;
        end;
        if result = nil then
          result := AktualneDane( oPozQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger, false )
        else
          AppendData( AktualneDane( oPozQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger, false ), result );
        oPozQuery.Next;
      end;
    finally
      if oPozQuery <> nil then oPozQuery.Free;
    end;
  except
    if result <> nil then FreeAndNil(result);
    raise;
  end;

  vPrzeliczoneItem := FPrzeliczoneIlosci.GetItemByValue(iZlecenieID);
  if vPrzeliczoneItem <> nil then {nie powinno by w tym momencie = nil}
     vPrzeliczoneItem.Przeliczone := True; {Zaznaczamy, e Zlecenie jest ju przeliczone}

end;

{$ifdef build_zle}
function TZLEDataManager.DopiszPozycjeZlecenia( iZlecenieID, iTypZleceniaID,
                                                iOkresID: Integer; bIlosciOkresowe: Boolean): Integer;
var
  sSQL: String;
  q, qSelectQuery, oInsertQuery, q2, q3: TUNIQuery;
  iLicznikLP: Integer;
begin
   result := 0;
   vZLEAsoZMag := False; 
   {Sprawdzamy czy jest wlaczony parametr pozyje zlecenia na podstawie dokumentw magazynowych}
   sSQL := 'SELECT ' + sZLETYPZLEC_ILOSCI_ASOMAG + ' FROM %s WHERE ' + sZLETYPZLEC_ID + ' = ' + IntToStr(iTypZleceniaID);
   q := SQLManager.CreateQuery(sSQL, [sZLETYPZLEC]);
   try
      q.Open;
      if not q.IsEmpty then begin
         if q.FieldByName(sZLETYPZLEC_ILOSCI_ASOMAG).AsString = sTak then begin
            {wlaczony parametr pozycje zlecenia na podstawie dokumentw magazynowych}
            vZLEAsoZMag := True;

            {Generowanie pozycji zlecenia}
            qSelectQuery := MAGDM.MAGAsortDlaZlecenia(iZlecenieID, iOkresID);
            q3 := SQLManager.CreateQuery('SELECT MAX(' + sZLEZLECENIEPOZ_LP + ') AS ' + sZLEZLECENIEPOZ_LP +
                                        ' FROM %s WHERE ' +
                                          sZLEZLECENIE_ID + '=' + IntToStr(iZlecenieID),
                                          [sZLEZLECENIEPOZ] );

            iLicznikLP := 0;
            try
                try
                  q3.Open;
                  if not q3.IsEmpty then
                     iLicznikLP := q3.FieldByName(sZLEZLECENIEPOZ_LP).AsInteger;
                  q3.Close();
                except
                  iLicznikLP := 0;
                end;
            finally
              if q3 <> nil then FreeAndNil(q3);
            end;

            while not qSelectQuery.Eof do begin
              {1. Sprawdzamy czy istnieje pozycja zlecenia o takim ASOASORT_ID}
              try
                q2 := ZLEOdpytajODane( sZLEZLECENIEPOZ,
                                       sZLEALIAS_ZLECENIEPOZ_ASORT_ID,
                                       '@'+sZLEALIAS_ZLECENIEPOZ_ASORT_ID+'='+qSelectQuery.FieldByName(sASOASORT_ID).AsString + ' AND ' +
                                       '@'+sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID+'='+IntToStr(iZlecenieID), false );


                if (q2 = nil) or (q2.IsEmpty) then begin
                  {Robimy insert do tabeli ZLEZLECENIEPOZ}
                  oInsertQuery := SQLManager.InsertQueryStep1( sZLEZLECENIEPOZ,
                                                               sZLEZLECENIEPOZ_ID+','+
                                                               sZLEZLECENIE_ID+','+
                                                               sASOASORT_ID+','+
                                                               sZLEZLECENIEPOZ_LP+','+
                                                               sZLEZLECENIEPOZ + '_UZ_AU_ID'+','+
                                                               sZLEZLECENIEPOZ + '_DATA_AU');

                  inc(iLicznikLP);
                  with oInsertQuery do begin
                    ParamByName(sZLEZLECENIEPOZ_ID).DataType := ftInteger;
                    ParamByName(sZLEZLECENIE_ID).DataType := ftInteger;
                    ParamByName(sASOASORT_ID).DataType := ftInteger;
                    ParamByName(sZLEZLECENIEPOZ_LP).DataType := ftInteger;
                    ParamByName(sZLEZLECENIEPOZ + '_UZ_AU_ID').DataType := ftInteger;
                    ParamByName(sZLEZLECENIEPOZ + '_DATA_AU').DataType := ftDate;

                    ParamByName(sZLEZLECENIEPOZ_ID).AsInteger := UniqueKey[sZLEZLECENIEPOZ];
                    ParamByName(sZLEZLECENIE_ID).AsInteger := iZlecenieID;
                    ParamByName(sASOASORT_ID).AsInteger := qSelectQuery.FieldByName(sASOASORT_ID).AsInteger;
                    ParamByName(sZLEZLECENIEPOZ_LP).AsInteger := iLicznikLP;
                    ParamByName(sZLEZLECENIEPOZ + '_UZ_AU_ID').AsInteger := SecurityManager.UserId;
                    ParamByName(sZLEZLECENIEPOZ + '_DATA_AU').AsDateTime := UNINow;
                  end;
                  SQLManager.InsertQueryStep2( oInsertQuery, '' );

                  if oInsertQuery <> nil then FreeAndNil(oInsertQuery);
                end;
              finally
                if q2 <> nil then FreeAndNil(q2);
              end;

              qSelectQuery.Next;
            end;
            if qSelectQuery <> nil then FreeAndNil(qSelectQuery);
         end;
      end;
   finally
     FreeAndNil(q);
   end;
end;
{$endif}

function TZLEDataManager.AktualizujRealizacjeZleceniaIlosci( iZlecenieID, iTypZleceniaID,
                                                             iOkresID, iAsortID: Integer; bIlosciOkresowe,
                                                             bZwrocDataSet: Boolean): TVirtualDataSet;

  procedure UaktualnijSkladniki( oSkladniki, oSkladnikiDoDodania: TVirtualDataSet );
  var bZnaleziony: Boolean;
  begin
    if oSkladnikiDoDodania <> nil then begin
      oSkladnikiDoDodania.First;
      while not oSkladnikiDoDodania.Eof do begin
        if oSkladnikiDoDodania.FieldByName(sUNIOKRES_ID).IsNull then
          bZnaleziony := oSkladniki.Locate( sZLESKLADIL_ID+';'+sZLEZLECENIEPOZ_ID,
                                            VarArrayOf([ oSkladnikiDoDodania.FieldByName(sZLESKLADIL_ID).AsInteger,
                                                         oSkladnikiDoDodania.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger ]),
                                            [] )
        else
          bZnaleziony := oSkladniki.Locate( sUNIOKRES_ID+';'+sZLESKLADIL_ID+';'+sZLEZLECENIEPOZ_ID,
                                                    VarArrayOf([ oSkladnikiDoDodania.FieldByName(sUNIOKRES_ID).AsInteger,
                                                                 oSkladnikiDoDodania.FieldByName(sZLESKLADIL_ID).AsInteger,
                                                                 oSkladnikiDoDodania.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger ]),
                                                    [] );
        try
          if bZnaleziony then begin
            oSkladniki.VState := vsVirtualPost;
            oSkladniki.Edit;
            with oSkladniki do begin
              FieldByName(sZLEZLECENIEPOZ_ID).AsInteger := oSkladnikiDoDodania.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger;
              FieldByName(sZLEIL_ILOSC).AsFloat := FieldByName(sZLEIL_ILOSC).AsFloat +
                                                     oSkladnikiDoDodania.FieldByName(sZLEIL_ILOSC).AsFloat;
            end;
          end else begin
            oSkladniki.VState := vsInternalInsert;
            oSkladniki.Append;
            with oSkladniki do begin
              FieldByName(sZLEIL_ID).AsInteger := UniqueKey[sZLEIL];
              FieldByName(sZLEZLECENIEPOZ_ID).AsInteger := oSkladnikiDoDodania.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger;
              FieldByName(sZLESKLADIL_ID).AsInteger := oSkladnikiDoDodania.FieldByName(sZLESKLADIL_ID).AsInteger;
              FieldByName(sUNIOKRES_ID).AsString := oSkladnikiDoDodania.FieldByName(sUNIOKRES_ID).AsString;
              FieldByName(sZLEIL_ILOSC).AsFloat := oSkladnikiDoDodania.FieldByName(sZLEIL_ILOSC).AsFloat;
            end;
            oSkladniki.UpdateModifiedRecordFlagsForAddedRecord();
          end;
          oSkladniki.Post;
        finally
          oSkladniki.VState := vsNormal;
        end;
        oSkladnikiDoDodania.Next;
      end;
    end;
  end;

var oQuery: TUNIQuery;
    oSkladnikiPodgrupy, oTempQ: TVirtualDataSet;
begin
  oQuery := nil;
  oTempQ := nil;
  oSkladnikiPodgrupy := nil;
  try
    try
      oQuery := TUNIQuery.Create(nil);
      SQLManager.OpenQuery( oQuery, ZLEOdpytajODaneSQL( sZLEIL,
                                                        sZLEALIAS_IL_ID+';'+
                                                        sZLEALIAS_IL_ZLECENIEPOZ_ID+';'+
//                                                        sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID+';'+
                                                        sZLEALIAS_IL_SKLADIL_ID+';'+
                                                        sZLEALIAS_IL_OKRES_ID+';'+
                                                        sZLEALIAS_IL_ILOSC,
                                                        '@'+sZLEALIAS_IL_ID+'=-1', false ),
                                                        [] );

      oSkladnikiPodgrupy := TVirtualDataSet.Create( nil, oQuery, sZLEIL, omList,
                                                    TKeys.CreateWithKey(sZLEIL_ID),
                                                    true );
    finally
      if oQuery <> nil then FreeAndNil(oQuery);
    end;
    try
      oQuery := ZLEOdpytajODane( sZLEZLECENIE,
                                 sZLEALIAS_ZLECENIE_ID+';'+sZLEALIAS_ZLECENIE_TYP_ID+';'+
                                 sZLEALIAS_TYPZLECENIA_ILOSCI_OKRES,
                                 '@'+sZLEALIAS_ZLECENIE_GRUPA_ID+'='+IntToStr(iZlecenieID),
                                 true );
      if oQuery <> nil then while not oQuery.Eof do begin
        try
          oTempQ := AktualizujRealizacjeZleceniaIlosci( oQuery.FieldByName(sZLEZLECENIE_ID).AsInteger,
                                                        oQuery.FieldByName(sZLETYPZLEC_ID).AsInteger,
                                                        iOkresID, iAsortID,
                                                        oQuery.FieldByName(sZLETYPZLEC_ILOSCI_OKRES).AsString = sUNICONST_ALTERNATYWA_TAK,
                                                        True );
          {Q := nil;
          oTempQ.First;
          while not oTempQ.Eof do begin
            try
              Q := ZLEOdpytajODane( sZLEZLECENIEPOZ, sZLEALIAS_ZLECENIEPOZ_ASORT_ID,
                                    '@'+sZLEALIAS_ZLECENIEPOZ_ID+'='+oTempQ.FieldByName(sZLEZLECENIEPOZ_ID).AsString, false );
              iID := 0;
              if Q <> nil then begin
                iID := Q.FieldByName(sASOASORT_ID).AsInteger;
                Q.Free;
                Q := ZLEOdpytajODane( sZLEZLECENIEPOZ, sZLEALIAS_ZLECENIEPOZ_ID,
                                      '(@'+sZLEALIAS_ZLECENIEPOZ_ASORT_ID+'='+IntToStr(iID)+')and'+
                                      '(@'+sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID+'='+IntToStr(iZlecenieID)+')',
                                      false );
                if Q <> nil then begin
                  oTempQ.VState := vsVirtualPost;
                  oTempQ.Edit;
                  oTempQ.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger := Q.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger;
                  oTempQ.Post;
                end else begin
                  //tu mona doda asortyment do zlecenia grupujcego
                end;
              end;
            finally
              if Q <> nil then FreeAndNil(Q);
              oTempQ.VState := vsNormal;
            end;
            oTempQ.Next;
          end;
          UaktualnijSkladniki( oSkladnikiPodgrupy, oTempQ );}
        finally
          if oTempQ <> nil then FreeAndNil(oTempQ);
        end;
        oQuery.Next;
      end;
    finally
      if oQuery <> nil then FreeAndNil(oQuery);
    end;
    try
      oTempQ := PrzeliczZlecenieIlosci( iZlecenieID, iTypZleceniaID, iOkresID, iAsortID, bIlosciOkresowe );
      {sWhere := '(@'+sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID+'='+IntToStr(iZlecenieID)+')';
      if iAsortID > 0 then
        sWhere := sWhere + '(@'+sZLEALIAS_ZLECENIEPOZ_ASORT_ID+'='+IntToStr(iAsortID)+')';
      sSubSQL := ZLEOdpytajODaneSQL( sZLEZLECENIEPOZ, sZLEALIAS_ZLECENIEPOZ_ID,
                                     sWhere, false );
      sWhere := 'where (il.'+sZLEZLECENIEPOZ_ID+' in ('+sSubSQL+'))';
      if iOkresID > 0 then
        sWhere := sWhere + 'and(il.'+sUNIOKRES_ID+'='+IntToStr(iOkresID)+')';
      SQLManager.ExecuteQuery( 'delete from %s il '+sWhere, [sZLEIL] );
      UaktualnijSkladniki( oSkladnikiPodgrupy, oTempQ );
      oSkladnikiPodgrupy.Post;}
    finally
      if oTempQ <> nil then FreeAndNil(oTempQ);
      if (not bZwrocDataSet)and(oSkladnikiPodgrupy <> nil) then
        FreeAndNil(oSkladnikiPodgrupy);
    end;
  except
    if oSkladnikiPodgrupy <> nil then FreeAndNil(oSkladnikiPodgrupy);
    raise;
  end;
  result := oSkladnikiPodgrupy;
end;
{$endif} //build_zle

procedure TZLEDataManager.DajListeSkladTypu1Click(Sender: TObject);
var oQuery: TUNIQuery;
begin
  oQuery := nil;
  try
    oQuery := ZLEDajListeSkladTypu( 125, 1);
  finally
    if oQuery <> nil then oQuery.Free;
  end;
end;

procedure TZLEDataManager.DajListeWartSklad1Click(Sender: TObject);
var oQuery: TUNIQuery;
begin
  oQuery := nil;
  try
    oQuery := ZLEDajListeWartSklad( 0, 42);
  finally
    if oQuery <> nil then oQuery.Free;
  end;
end;

procedure TZLEDataManager.ZapiszWartSklad1Click(Sender: TObject);
var oSkladniki: TZLEListaSkladnikow;
begin
  oSkladniki := nil;

  try
    oSkladniki := TZLEListaSkladnikow.Create(TZLESkladnik);
    with oSkladniki.Add() do begin
      ID := 61;
      Value := 1234.05;
      Table := sZLEWART;
    end;
    ZLEZapiszWartSklad( 0, 42, 1, oSkladniki);
  finally
    if oSkladniki <> nil then oSkladniki.Free;
  end;
end;

function TZLEDataManager.ZLEZlecenieOtwarte( sSymbol: String;
                                             dData: TDate): Boolean;
var oQuery: TUNIQuery;
begin
  oQuery := nil;
  try
    oQuery := ZLEOdpytajODane( sZLEZLECENIE, sZLEALIAS_ZLECENIE_ID,
                               '(@'+sZLEALIAS_ZLECENIE_SYMBOL+'='+QuotedStr(sSymbol)+')and'+
                               '(@'+sZLEALIAS_ZLECENIE_DATA_ZA+'>='+KonwertujDate2SQL(dData)+')',
                               false );
    result := oQuery <> nil;
  finally
    if oQuery <> nil then oQuery.Free;
  end;

end;

procedure TZLEDataManager.Wypenijdomeny1Click(Sender: TObject);
  procedure FillDomain( Nazwa: String; CSL: TConstStringList);
  var
    Q:   TUNIQuery;
    i:   integer;
  begin
    Q:= SQLManager.InsertQueryStep1( Nazwa,Nazwa+'_ID,'+Nazwa+'_V');
    try
      Q.prepare;
      for i:=0 to CSL.Count-1 do begin
        Q.Params[0].Value:= CSL.ZwrocSkrot(i);
        Q.Params[1].Value:= CSL[i];
        try
          SQLManager.InsertQueryStep2( Q,'');
        except
          on E:Exception do begin
            if Pos('Key violation',E.Message) = 0 then raise; 
          end;
        end;
      end;
    finally
      Q.free;
    end;
  end;
begin
  inherited;
  FillDomain( sZLECONST_SKLADNIK,  cslZLERodzajSklad );
  FillDomain( sZLECONST_STATUS,    cslZLEStatusZlecenia );
  FillDomain( sZLECONST_AKTYWNOSC, cslZLEAktywnosc );
end;

procedure TZLEDataManager.Createdomains1Click(Sender: TObject);
var oSplit: TSplit;
    iIndex: Integer;
begin
  inherited;
  oSplit := nil;
  try
    oSplit := TSplit.Create(Self.DajNazwyDomen(), ';','');
    for iIndex := 0 to oSplit.Count-1 do begin
      try
        SQLManager.ZalozTabliceZDataManagera( Self.Name, oSplit[iIndex], oSplit[iIndex] );
      except
        on E:Exception do begin
          if Komunikat( cError, 'Bd podczas zakadania domen dla '+oSplit[iIndex]+#13#10+E.Message+
                        #13#10+'Kontynuowa?', MB_YESNO ) = IDNO then
            raise;
        end;
      end;
    end;
  finally
    if oSplit <> nil then oSplit.Free;
  end;
end;

function TZLEDataManager.ZLEPokazIObsluzZleceniaGrid(const oOwner:TComponent; sAtrybuty,
  sWarunek: string; bBlok, bWyborWielu: Boolean; iOpenMode: TOpenMode; iModulZSIID, iLocateID,
  iFirmaID: Integer; oLocateContained: TStrings; oParams: TKeyValues;
  sSufiksKlasy: String): TUNIDBGridForm;
begin
  result := ZLEPokazIObsluzDaneGrid( oOwner, sZLEZLECENIE, sAtrybuty, sWarunek, bBlok,
                                     bWyborWielu, iOpenMode, iModulZSIID, iLocateID,
                                     iFirmaID, oLocateContained, oParams,
                                     sSufiksKlasy );
end;

function TZLEDataManager.ZLEPokazIObsluzDaneGrid(const oOwner:TComponent; sTabela, sAtrybuty,
  sWarunek: string; bBlok, bWyborWielu: Boolean; iOpenMode: TOpenMode; iModulZSIID, iLocateID,
  iFirmaID: Integer; oLocateContained: TStrings; oParams: TKeyValues;
  sSufiksKlasy: String): TUNIDBGridForm;
var sKlasa, sFormCaption: String;
//    bCreatedParams: Boolean;
begin
//  bCreatedParams := False;

  try
    if oParams = nil then
      oParams:= TKeyValues.CreateEmpty;
    if sTabela = sZLETYPZLEC then begin
      sKlasa := cKlasaTypZlecenia;
      sFormCaption := 'Typ zlecenia';
    end else if sTabela = sZLEZLECENIE then begin          //Wywoanie z moduu SAN
      if ((SecurityManager.SM_UserCanDo(sZLE_KART_ZLECEN) and (not ZLEDM.vZLEUproszczonySlownikZlecenWlaczony)) or (sSufiksKlasy <> '')) then begin
          sKlasa := cKlasaZlecenie;
          sFormCaption := 'Zlecenie';
          if oParams.IndexOfName(cZLELista_Optymalizacja) = -1 then
             if ZLEDM.vZLEWlaczAktywnePrzyciki then
                oParams.Add(cZLELista_Optymalizacja + '=')
             else
                oParams.Add(cZLELista_Optymalizacja + '=' + IntToStr(cZLELista_WylaczPrzyciski));
          oParams.Add(cZLEFuncRodzaj+'='+cZLEFuncZlecenie);
      end else begin
      //if SecurityManager.SM_UserCanDo(sZLE_KART_ZLECEN_UPR) then begin
        sKlasa := cKlasaZlecenieUpr;
        oParams.Add(cRangeClassName+'='+cKlasaZakresZlecenUpr+cSuffixKlasySelect);
        sFormCaption := 'Uproszczona lista zlece';
      end{ else Komunikat(cWarning, 'Brak uprawnien')};
    end else if sTabela = sZLEZASOB then begin
      sKlasa := cKlasaZasob;
      sFormCaption := 'Zasoby';
      oParams.Add(cRangeClassName+'=TZLEZasobyZakresForm');
    end else if sTabela = sZLEBRAKI then begin
      sKlasa := cKlasaBraki;
      sFormCaption := 'Braki';
    end else if sTabela = sZLEZLECENIEROZL then begin
      sKlasa := cKlasaZlecenieRozl;
      sFormCaption := 'Rozliczenie zasobw';
      oParams.Add( cFORM_ANALIZA+'='+sUNICONST_ALTERNATYWA_TAK );
      oParams.Add(cRangeClassName+'='+cKlasaZlecenieRozl+cSuffixKlasyRange);
    end else if sTabela = sZLEZLECENIEPOZ then begin
      sKlasa := cKlasaPozycje;
      sFormCaption := 'Pozycje zlecenia';
    end else if sTabela = sZLEPREFIX then begin
      sKlasa := cKlasaPrefix;
      sFormCaption := 'Prefiks';
    end else begin
      raise EOF_ZLEException.Create( cError_TabelaNieobslugiwana,
                                     ZLEPodajSlowneRozwiniecieKoduBledu(cError_TabelaNieobslugiwana)+sTabela,
                                     'ZLEPokazIObsluzDane' );
    end;
  except
    on EOF_ZLEException do begin
      oParams.Free;
      raise;
    end else raise;
  end;

  if bBlok then
    iOpenMode := iOpenMode or omReadOnly;
  if bWyborWielu then
    iOpenMode := iOpenMode or omMultiSelect;

  if iLocateID > 0 then
    oParams.Add( cConditionPosForGrid + '=' + IntToStr(iLocateID));
  oParams.Add(cFORM_CAPTION+'='+sFormCaption);

  if iModulZSIID <> 0 then
    oParams.Add(sUNIMODULZSI_ID+'='+IntToStr(iModulZSIID));

  if sTabela = sZLEZLECENIEPOZ then
    oParams.Add('ONLYREADONLY=T');

  if sWarunek <> '' then
    oParams.Add( cConditionForGrid + '=' + sWarunek);

  if oLocateContained <> nil then
    oParams.AddStrings(oLocateContained);

  if (iFirmaID > 0) and (oParams.Values['FIRMA_ID'] = '') then
     oParams.Values['FIRMA_ID'] := IntToStr(iFirmaID);

  result := FormManager.OpenDBGrid( oOwner, sKlasa+cSuffixKlasyDBGrid+sSufiksKlasy, iOpenMode,
                                   oParams );
end;

function TZLEDataManager.ZLEPokazIObsluzTypZleceniaGrid(const oOwner:TComponent; sAtrybuty,
  sWarunek: string; bBlok, bWyborWielu: Boolean; iOpenMode: TOpenMode; iModulZSIID, iLocateID,
  iFirmaID: Integer): TUNIDBGridForm;
begin
  result := ZLEPokazIObsluzDaneGrid( oOwner, sZLETYPZLEC, sAtrybuty, sWarunek, bBlok,
                                     bWyborWielu, iOpenMode, iModulZSIID, iLocateID, iFirmaID );
end;

function TZLEDataManager.ZLEKontrolaZleceniaGrid(const oOwner:TComponent; iZlecenieID: Integer;
         sAtrybuty: string; bBlok: Boolean; iOpenMode: TOpenMode;
         iModulZSIID, iFirmaID: Integer): TUNIDBDetailForm;
var sKlasa, sFormCaption: String;
    oParams: TKeyValues;
//    iOpenMode: TOpenMode;
    sSQL: String;
begin
  //sprawdzenie istnienia zlecenia
  sSQL := ZLEOdpytajODaneSQL( sZLEZLECENIE, sZLEALIAS_ZLECENIE_ID,
                              '@'+sZLEALIAS_ZLECENIE_ID+'='+IntToStr(iZlecenieID),
                              false );
  if SQLManager.OpenQueryWithResult( sSQL ) = '' then
    raise EOF_ZLEException.Create( cError_BrakZlecenia,
                                   ZLEPodajSlowneRozwiniecieKoduBledu(cError_BrakZlecenia),
                                   'ZLEKontrolaZlecenia' );

  //sprawdzenie istnienia moduu
  if iModulZSIID = 0 then
    raise EOF_ZLEException.Create( cError_BrakIDModulu,
                                   ZLEPodajSlowneRozwiniecieKoduBledu(cError_BrakIDModulu),
                                   'ZLEKontrolaZlecenia' );
  sSQL := UNISysDM.UNIOdpytajODaneSQL( sUNIMODULZSI, sUNISYSALIAS_ModulZSI_ID,
                                       '@'+sUNISYSALIAS_ModulZSI_ID+'='+IntToStr(iModulZSIID),
                                       false );
  if SQLManager.OpenQueryWithResult( sSQL ) = '' then
    raise EOF_ZLEException.Create( cError_BrakModulu,
                                   ZLEPodajSlowneRozwiniecieKoduBledu(cError_BrakModulu),
                                   'ZLEKontrolaZlecenia' );

  oParams:= TKeyValues.CreateEmpty;

  sKlasa := cKlasaKontrolaRealizacji;
  sFormCaption := 'Kontrola realizacji zlecenia';

  with oParams do begin
    Add(sZLEZLECENIE_ID+'='+IntToStr(iZlecenieID));
    Add(sUNIMODULZSI_ID+'='+IntToStr(iModulZSIID));
    Add(cZLEFuncRodzaj+'='+cZLEFuncKontrolaRealizacji);
    Add(cFORM_CAPTION+'='+sFormCaption);
  end;

  if bBlok then iOpenMode := iOpenMode or omView
  else iOpenMode := iOpenMode or omEdit;

  //if sAtrybuty <> '' then iOpenMode := iOpenMode or omShowModal;

  result := FormManager.OpenDBDetail( oOwner, sKlasa+cSuffixKlasyDBDetail, iOpenMode,
                                     oParams );
end;

{$ifdef build_zle}

function TZLEDataManager.UNIPokazIObsluzSlownik(sAtrybuty, sTabela, sPole, sWarunek: string;iMnemonikID:integer=0; iPozycjonowanie: Integer = 0;
                                    bWyborWielu:boolean = false;a_oSelectedId : TStringList = nil; oParams: TKeyValues = nil): TUNIQuery; 
{(sAtrybuty, sTabela, sPole, sWarunek: string;iMnemonikID:integer): TUNIQuery;}
//var
  //sTekst: string;
  //GridForm: TUNIDBGridForm;
  //oParams: TKeyValues;
begin
  //result:= nil;

  result := ZLEPokazIObsluzDane( sTabela,
                                 sAtrybuty,
                                 sWarunek,
                                 False {bBlok},
                                 bWyborWielu,
                                 0 {iMODULZSI_ID},
                                 iPozycjonowanie {iLocateID},
                                 vAktywnaFirma {iFirmaID},
                                 sPole );

end;
{$endif}

function TZLEDataManager.ZleDajWartoscPracy(iZLECENIE_ID, iUNIOKRES_ID: Integer;
                                            RODZAJECP: string = '';
                                            RODZAJZASOBU: string =''): Extended;
var
  q: TUNIQuery;
  sOkresWhere, sTmp: String;
begin
  if ZLEDM.vZLEFormatGodzinLiczba then
    sTmp := ',0))'
  else sTmp := ',0)/60)';


  if RODZAJECP <> '' then
       sOkresWhere := ' AND (ZP.' + sZLECONST_RODZAJECP_ID + ' IN (' + RODZAJECP + '))'
  else sOkresWhere := ' AND (ZP.' + sZLECONST_RODZAJECP_ID + '<>' + QuotedStr(cZLERodzajECP_ProdukcjaID)+')';  //Dla produkcji brak stawki!
  if RODZAJZASOBU <> '' then
     sOkresWhere := sOkresWhere + ' AND (ZS.' + sZLEZASOB_RODZAJ + ' IN (' + RODZAJZASOBU + '))';

  if iUNIOKRES_ID <> 0 then
    sOkresWhere := sOkresWhere + ' AND ' + sUNIOKRES_ID + '=' + IntToStr(iUNIOKRES_ID);
  try
    q := SQLManager.CreateQuery(
      'SELECT SUM(' + SQLManager.GetSPName('ZAOKRAGLIJ') + '((NVL(' + sZLEZASOBYPRACA_CZAS_PRACY + sTmp +' * NVL(' + sZLEZASOBYPRACA_STAWKA + ',0),2))' +
      ' FROM ' + SQLManager.GetTableName(sZLEZASOBYPRACA) + ' ZP ,' +
                 SQLManager.GetTableName(sZLEZASOB) + ' ZS ' +
      ' WHERE ' +
             'ZP.' + sZLEZASOB_ID + ' = ZS.' + sZLEZASOB_ID + '(+) '+
         'AND ZP.' + sZLEZLECENIE_ID + '=' + IntToStr(iZLECENIE_ID) + sOkresWhere
    );
    q.Open;
    Result := q.Fields[0].AsFloat;
  finally
    if q <> Nil then FreeAndNil(q);
  end;
end;

{$ifdef build_zle}

{Funkcja zwraca warunek na pozycje zlecenia dla podanego kryterium}
function TZLEDataManager.ZleDajListeSymboliDlaKryterium(iKryteriumID, iUNIOKRES_ID: Integer; var SELSQL: String;
                                                        oPar: TKeyValues; var bJestWhere, bINI_IBU: Boolean): TUNIQuery;
var
  oSplit: TSplit;
  sListaMnem, sLista, sObiekt: String;
  bTypZlec: boolean;
//  bKrytOkresowe:  boolean;
  qKryt, qZlec, qMnem, qWar: TUniQuery;
  i, iTypZlecID, iIdx, iMnemID, iWskID: Integer;
  sSQL, sTmp, sMnem, sSelectList, sFromList, sWhereList: String;
  sMnemTab, sListaGroupBy, sWarunekWhere, sMnemInf, sAktMnem: String;
//  iMnemDlug: Integer;
  vWarunkiMnem: TZLEWarunekLista;
  vWarItem: TZLEWarunek;
  iSymbol: Integer;

  bInfAll: Boolean;
  bINIandIBU: Boolean;
  sOgranicz: String;
  qMnemOgranicz, qListaDefPol: TUNIQuery;
begin
  bJestWhere := False;
  iMnemID   := 0;
  iIdx      := 0;
  iTypZlecID:= 0;
  bTypZlec  := false;
  sAktMnem := '';
  vWarunkiMnem := TZLEWarunekLista.Create();

  bINIandIBU := False;
  {Odczytujemy definicje kryterium}
  qKryt := SQLManager.CreateQuery('SELECT * FROM %s ' +
                                  'WHERE ' + sZLEKRYTERIA_ID + ' = ' + IntToStr(iKryteriumID),
                                  [sZLEKRYTERIA]);
  try
    if qKryt <> nil then begin
       qKryt.Open;
       if not qKryt.IsEmpty then begin
          sListaMnem    := qKryt.FieldByName(sZLEKRYTERIA_SKLADNIKI).AsString;
          bTypZlec      := (not qKryt.FieldByName(sZLETYPZLEC_ID).IsNull);
          iTypZlecID    := qKryt.FieldByName(sZLETYPZLEC_ID).AsInteger;
//          bKrytOkresowe := (qKryt.FieldByName(sZLEKRYTERIA_OKRESOWE).AsString = sTak);
          sObiekt       := qKryt.FieldByName(sINFCONST_OBIEKT_ID).AsString;
          sOgranicz     := qKryt.FieldByName(sZLEKRYTERIA_OGRANICZ).AsString;
       end;
    end;
  finally
    if qKryt <> nil then FreeAndNil(qKryt);
  end;

  if iKryteriumID > 0 then begin
      qWar := SQLManager.CreateQuery('SELECT * FROM %s ' +
                                     'WHERE ' + sZLEKRYTERIA_ID + '=' + IntToStr(iKryteriumID),
                                     [sZLEKRYTERIAWAR]);

      try
        qWar.Open;
        while not qWar.Eof do begin
          vWarItem := vWarunkiMnem.Add;
          vWarItem.FKMnemonikiID := qWar.FieldByName(sFKMNEMONIKI_ID).AsInteger;
          vWarItem.ListaID := qWar.FieldByName(sZLEKRYTERIAWAR_LISTA_ID).AsString;
          if vWarItem.ListaID <> '' then bJestWhere := True;
          qWar.Next;
        end;

      finally
        if qWar <> nil then FreeAndNil(qWar);
      end;
  end;

  {Dokadamy mnemoniki infrastruktury}
  bInfAll       := False;

  {Odczytujemy definicje typu zlecenia}
  sTmp := 'SELECT * FROM %s';
  if bTypZlec then
     sTmp := sTmp + ' WHERE ' + sZLETYPZLEC_ID + ' = ' + IntToStr(iTypZlecID);

  qZlec := SQLManager.CreateQuery(sTmp, [sZLETYPZLEC]);
  try
    if qZlec <> nil then begin
       qZlec.Open;
       while not qZlec.Eof do begin
          if qZlec.FieldByName(sZLETYPZLEC_ELEMENTINF).AsString = sTak then begin
             iIdx := qZlec.FieldByName(sZLETYPZLEC_POZIOMINF).AsInteger;
             bInfAll := True;
          end else
          if qZlec.FieldByName(sZLETYPZLEC_LOKAL_A).AsString <> 'A' then iIdx := 0
          else
          if qZlec.FieldByName(sZLETYPZLEC_ZASOB_A).AsString <> 'A' then iIdx := 1
          else
          if qZlec.FieldByName(sZLETYPZLEC_KLATKA_A).AsString <> 'A' then iIdx := 2
          else
          //Brama     - 3
          if qZlec.FieldByName(sZLETYPZLEC_BUDYNEK_A).AsString <> 'A' then iIdx := 4
          else
          if qZlec.FieldByName(sZLETYPZLEC_NIERUCHOMOSC_A).AsString <> 'A' then iIdx := 5
          else
          //Wspolnota - 6
          //Rejon     - 7
          if qZlec.FieldByName(sZLETYPZLEC_ULICA_A).AsString <> 'A' then iIdx := 8
          else
          if qZlec.FieldByName(sZLETYPZLEC_SIECELEMENT_A).AsString <> 'A' then iIdx := 9;

          sMnem := cslZLE_INFMnemoniki[iIdx];
          if sMnemInf <> '' then sMnemInf := sMnemInf  + ',';
          sMnemInf := sMnemInf  + cslZLE_INFMnemoniki[iIdx];
          qZlec.Next;
       end;
    end;
  finally
    if qZlec <> nil then FreeAndNil(qZlec);
  end;

  qListaDefPol := nil;
  if bTypZlec then begin
     //Przygotowanie listy definicji pl uytkownika dla typu zlecenia
    qListaDefPol := SQLManager.CreateQuery('SELECT ' +
                                             'FM.' + sFKMNEMONIKI_MNEMONIK + ', ' +
                                             'WSK.' + sUNIPOLAUZWSK_ID + ', ' +
                                             'ZD.' + sUNIPOLAUZDEF_ID + ', ' +
                                             'WSK.' + sUNIPOLAUZWSK_FUNK + ', ' +
                                             'ZD.' + sFKMNEMONIKI_ID + ', ' +
                                             'WSK.' + sUNIPOLAUZWSK_FUNKID + ' ' +
                                           'FROM %s ZD, %s WSK, %s FM ' +
                                           'WHERE ' +
                                                 'WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' ' +
                                            ' AND FM.'  + sFKMNEMONIKI_ID  + ' = ZD.' + sFKMNEMONIKI_ID + ' ' +
                                            ' AND WSK.' + sUNIPOLAUZWSK_FUNK + ' IN (' + QuotedStr(cPolaUZ_ZLEZlecenie) + ', ' + QuotedStr(cPolaUZ_ZLEPozycja) + ') ' +
                                            ' AND WSK.' + sUNIPOLAUZWSK_FUNKID + ' = ' + IntToStr(iTypZlecID),
                                          [sUNIPOLAUZDEF, sUNIPOLAUZWSK, sFKMNEMONIKI]);
     try
       qListaDefPol.Open();  // Query zostaje aktywne !
     except
       if qListaDefPol <> nil then FreeAndNil(qListaDefPol);
       Komunikat(cError, 'Bd tworzenia listy pl uytkownika dla typu zlecenia');
       Raise;
     end;
  end;

  sSQL := 'SELECT SEL.* '#13 +
          'FROM ( '#13 + ' ' +
             'SELECT ';
  SELSQL := '(SELECT ZP1.ZLEZLECENIEPOZ_ID, ';
  {sSQL := sSQL +
                 sSelectList +
             ' FROM ' +
                 sFromList +
             ' WHERE ' +
                 sWhereList + ') SEL ' +
           ' WHERE ' +
               sWarunekWhere +
           ' GROUP BY ' +
               sListaGroupBy;

   SELSQL := SELSQL +
                 sSelectList +
             ' FROM ' +
                 sFromList +
             ' WHERE ' +
                 sWhereList + ') SEL ' +
           ' WHERE ' +
               sWarunekWhere +

               + Dodatkowe warunki w Where
   }

  sWarunekWhere := '';
  sListaGroupBy := '';
  sSelectList := '';
  sFromList   :=  SQLManager.GetTableName(sZLEZLECENIEPOZ) + ' ZP1, ' +
                  SQLManager.GetTableName(sZLEZLECENIE) + ' ZL';
  sWhereList  := 'ZL.' + sZLEZLECENIE_ID + ' = ZP1.' + sZLEZLECENIE_ID;

  iSymbol := 0;

  {Analiza sownikw kryterium}
  sLista := '';
  if Pos(',', sListaMnem) > 0 then begin
     {Specjalna obsuga nieruchomoci - pobierana z budynku}                      {Budynek}
     if (Pos('INI', sListaMnem) > 0) and ((Pos('IBU', sListaMnem) > 0) or (sObiekt = '4')) then begin
        bINIandIBU := True; {Jednoczenie nieruchomo i budynek w symbolu}
     end;

     oSplit:= TSplit.Create(sListaMnem, ',', '');
     try
        for i := 0 to oSplit.Count - 1 do begin
          sMnemTab := '';
//          iMnemDlug := 0;
          iMnemID := 0;
          if Copy(Trim(oSplit.Items[i]), 1, 1) = '''' then begin
             Continue;
          end else begin
             Inc(iSymbol); //Zakadamy,e uda nam si co dooy

              qMnem := SQLManager.CreateQuery('SELECT * ' +
                                              'FROM %s ' +
                                              'WHERE ' + sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr(Copy(Trim(oSplit.Items[i]), 1, 3)) + ' AND ' +
                                                         sFKMNEMONIKI_INDEKS + ' = 0',
                                              [sFKMNEMONIKI]);

              try
                qMnem.Open;
                if not qMnem.IsEmpty then begin
                   sMnemTab  := qMnem.FieldByName(sFKMNEMONIKI_TABELA).AsString;
//                   iMnemDlug := qMnem.FieldByName(sFKMNEMONIKI_DLUGOSC).AsInteger;
                   iMnemID   := qMnem.FieldByName(sFKMNEMONIKI_ID).AsInteger;
                end;
              finally
                if qMnem <> nil then FreeAndNil(qMnem);
              end;
          end;

          sAktMnem := Copy(Trim(oSplit.Items[i]), 1, 3);

          if (sAktMnem = 'ZLE') then begin
             if sSelectList <> '' then sSelectList := sSelectList + ', ';
             sSelectList := sSelectList + 'ZL.' + sZLEZLECENIE_SYMBOL;

             vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
             if vWarItem <> nil then
                if vWarItem.ListaID <> '' then begin
                   if sWarunekWhere <> '' then
                      sWarunekWhere := sWarunekWhere + ' AND ';
                   sWarunekWhere := sWarunekWhere +
                      'SEL.' + sZLEZLECENIE_SYMBOL + ' IN (SELECT ' + sZLEZLECENIE_SYMBOL +
                                                         ' FROM ' + SQLManager.GetTableName(sZLEZLECENIE) +
                                                         ' WHERE ' + sZLEZLECENIE_ID + ' IN (' + vWarItem.ListaID + ')) ';
                end;

             if sListaGroupBy <> '' then sListaGroupBy := sListaGroupBy + ', ';
             sListaGroupBy := sListaGroupBy + sZLEZLECENIE_SYMBOL;
             oPar.Add(sAktMnem + '=' + sZLEZLECENIE_SYMBOL);
          end else
          if (sAktMnem = 'ODZ') or (sAktMnem = 'FIR') then begin
             if sSelectList <> '' then sSelectList := sSelectList + ', ';
             sSelectList := sSelectList + 'ODDZ.' + sUNIODDZIAL_SYMBOL;
             sFromList   := sFromList + ', ' + SQLManager.GetTableName(sUNIODDZIAL) + ' ODDZ';

             sWhereList := sWhereList + ' AND ZL.' + sUNIODDZIAL_ID + ' = ODDZ.' + sUNIODDZIAL_ID + '(+)';

             vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
             if vWarItem <> nil then
                if vWarItem.ListaID <> '' then begin
                   if sWarunekWhere <> '' then
                      sWarunekWhere := sWarunekWhere + ' AND ';
                   sWarunekWhere := sWarunekWhere +
                      'SEL.' + sUNIODDZIAL_SYMBOL + ' IN (SELECT ' + sUNIODDZIAL_SYMBOL +
                                                        ' FROM ' + SQLManager.GetTableName(sUNIODDZIAL) +
                                                        ' WHERE ' + sUNIODDZIAL_ID + ' IN (' + vWarItem.ListaID + ')) ';
                end;

             if sListaGroupBy <> '' then sListaGroupBy := sListaGroupBy + ', ';
             sListaGroupBy := sListaGroupBy + sUNIODDZIAL_SYMBOL;
             oPar.Add(sAktMnem + '=' + sUNIODDZIAL_SYMBOL);
          end else {Jednostka org.}
          if (sAktMnem = 'JED') then begin
             if sSelectList <> '' then sSelectList := sSelectList + ', ';
             sSelectList := sSelectList + 'JO.' + sUNIJEDNOSTKAORG_SYMBOL;
             sFromList   := sFromList + ', ' + SQLManager.GetTableName(sUNIJEDNOSTKAORG) + ' JO';
             sWhereList := sWhereList + ' AND ZL.' + sUNIJEDNOSTKAORG_ID + ' = JO.' + sUNIJEDNOSTKAORG_ID + '(+)';

             vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
             if vWarItem <> nil then
                if vWarItem.ListaID <> '' then begin
                   if sWarunekWhere <> '' then
                      sWarunekWhere := sWarunekWhere + ' AND ';
                   sWarunekWhere := sWarunekWhere +
                      'SEL.' + sUNIJEDNOSTKAORG_SYMBOL + ' IN (SELECT ' + sUNIJEDNOSTKAORG_SYMBOL +
                                                             ' FROM ' + SQLManager.GetTableName(sUNIJEDNOSTKAORG) +
                                                             ' WHERE ' + sUNIJEDNOSTKAORG_ID + ' IN (' + vWarItem.ListaID + ')) ';
                end;

             if sListaGroupBy <> '' then sListaGroupBy := sListaGroupBy + ', ';
             sListaGroupBy := sListaGroupBy + sUNIJEDNOSTKAORG_SYMBOL;
             oPar.Add(sAktMnem + '=' + sUNIJEDNOSTKAORG_SYMBOL);
          end else {Infrastruktura}
          if (sAktMnem = sMnem) or (bInfAll and (cslZLE_INFMnemoniki.IndexOf(sAktMnem) > 0)) then begin
            if bINIandIBU then begin
               if (sAktMnem = 'INI') then begin
                  {A tu drobna zmiana - Nieruchomo na podstawie Budynku}
                  if (sObiekt = '4') then begin
                      if sSelectList <> '' then sSelectList := sSelectList + ', ';
                      sSelectList := sSelectList +  ' (SELECT NN.' + sINFNIERUCHOMOSC_SYMBOL + ' ' +
                                                      'FROM ' + SQLManager.GetTableName(sINFBUDYNEK) + ' NB, ' +
                                                                SQLManager.GetTableName(sINFNIERUCHOMOSC) + ' NN ' +
                                                      'WHERE  NN.' + sINFNIERUCHOMOSC_ID + ' = NB.' + sINFNIERUCHOMOSC_ID + ' AND ' +
                                                             'NB.' + sINFBUDYNEK_ID + ' = ZP1.' + sZLEZLECENIEPOZ_INF_ID + ') AS ' + sAktMnem + '_SYMBOL';

                      vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
                      if vWarItem <> nil then
                          if vWarItem.ListaID <> '' then begin
                             if sWarunekWhere <> '' then
                                sWarunekWhere := sWarunekWhere + ' AND ';
                             sWarunekWhere := sWarunekWhere +
                                'SEL.' + sAktMnem + '_SYMBOL' + ' IN (SELECT ' + sMnemTab + '_SYMBOL' +
                                                                                 ' FROM ' + SQLManager.GetTableName(sMnemTab) +
                                                                                 ' WHERE ' + sMnemTab + '_ID' + ' IN (' + vWarItem.ListaID + ')) ';
                          end;

                      if sListaGroupBy <> '' then sListaGroupBy := sListaGroupBy + ', ';
                      sListaGroupBy := sListaGroupBy + sAktMnem + '_SYMBOL';
                      oPar.Add(sAktMnem + '=' + sAktMnem + '_SYMBOL');
                  end else begin
                      if sSelectList <> '' then sSelectList := sSelectList + ', ';
                      sSelectList := sSelectList + SQLManager.GetTableName('INF_DAJSYMBOLOBIEKTU') + '(ZP1.' + sZLEZLECENIEPOZ_POZIOMINF + ', ZP1.' + sZLEZLECENIEPOZ_INF_ID + ') AS ' + sAktMnem + '_SYMBOL';

                      vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
                      if vWarItem <> nil then
                         if vWarItem.ListaID <> '' then begin
                            if sWarunekWhere <> '' then
                               sWarunekWhere := sWarunekWhere + ' AND ';
                            sWarunekWhere := sWarunekWhere +
                               'SEL.' + sAktMnem + '_SYMBOL' + ' IN (SELECT ' + sMnemTab + '_SYMBOL' +
                                                                                            ' FROM ' + SQLManager.GetTableName(sMnemTab) +
                                                                                            ' WHERE ' + sMnemTab + '_ID' + ' IN (' + vWarItem.ListaID + ')) ';
                         end;

                      if sListaGroupBy <> '' then sListaGroupBy := sListaGroupBy + ', ';
                      sListaGroupBy := sListaGroupBy + sAktMnem + '_SYMBOL';
                      oPar.Add(sAktMnem + '=' + sAktMnem + '_SYMBOL');
                  end;
               end else
               if sAktMnem = 'IBU' then begin
                   if sObiekt = '4' then begin //Poziom budynek
                      if sSelectList <> '' then sSelectList := sSelectList + ', ';
                      sSelectList := sSelectList + SQLManager.GetTableName('INF_DAJSYMBOLOBIEKTU') + '(ZP1.' + sZLEZLECENIEPOZ_POZIOMINF + ', ZP1.' + sZLEZLECENIEPOZ_INF_ID + ') AS ' + sAktMnem + '_SYMBOL';

                      vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
                      if vWarItem <> nil then
                         if vWarItem.ListaID <> '' then begin
                            if sWarunekWhere <> '' then
                               sWarunekWhere := sWarunekWhere + ' AND ';
                            sWarunekWhere := sWarunekWhere +
                               'SEL.' + sAktMnem + '_SYMBOL' + ' IN (SELECT ' + sMnemTab + '_SYMBOL' +
                                                                                            ' FROM ' + SQLManager.GetTableName(sMnemTab) +
                                                                                            ' WHERE ' + sMnemTab + '_ID' + ' IN (' + vWarItem.ListaID + ')) ';
                          end;

                      if sListaGroupBy <> '' then sListaGroupBy := sListaGroupBy + ', ';
                      sListaGroupBy := sListaGroupBy + sAktMnem + '_SYMBOL';
                      oPar.Add(sAktMnem + '=' + sAktMnem + '_SYMBOL');
                   end else begin
                       {Poziom infrastruktury <> 'Budynek' - szukamy budynku w polach uytkownika zlecenia}
                      if sSelectList <> '' then sSelectList := sSelectList + ', ';
                      sSelectList := sSelectList + 'SEL_' + IntToStr(iMnemID) + '.' + sMnemTab + '_SYMBOL';

                      if bTypZlec and (qListaDefPol <> nil) then begin
                        //Szukamy definicj pola uytkownika
                        if qListaDefPol.Locate(sFKMNEMONIKI_MNEMONIK+';'+sUNIPOLAUZWSK_FUNK,
                                               VarArrayOf([sAktMnem, cPolaUZ_ZLEPozycja]), []) then begin
                           {Znalezione pole pozycji}
                           iWskID := qListaDefPol.FieldByName(sUNIPOLAUZWSK_ID).AsInteger;
                           sFromList := sFromList + ', ' +
                                       '(SELECT ZM.' + sUNIPOLAUZ_WART + ' AS ' + sMnemTab + '_SYMBOL, '  +
                                               'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                                               'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                                        'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM ' +
                                        'WHERE ZM.' + sUNIPOLAUZWSK_ID + ' = ' + IntToStr(iWskID) +
                                        ') SEL_' + IntToStr(iMnemID);

                           sWhereList := sWhereList + ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' ' +
                                                      ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ' ' ;

                        end else
                        if qListaDefPol.Locate(sFKMNEMONIKI_MNEMONIK+';'+sUNIPOLAUZWSK_FUNK,
                                               VarArrayOf([sAktMnem, cPolaUZ_ZLEZlecenie]), []) then begin
                           {Znalezione pole zlecenia}
                           iWskID := qListaDefPol.FieldByName(sUNIPOLAUZWSK_ID).AsInteger;
                           sFromList := sFromList + ', ' +
                                       '(SELECT ZM.' + sUNIPOLAUZ_WART + ' AS ' + sMnemTab + '_SYMBOL, '  +
                                               'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                                               'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                                        'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM ' +
                                        'WHERE ZM.' + sUNIPOLAUZWSK_ID + ' = ' + IntToStr(iWskID) + ' ' +
                                        ') SEL_' + IntToStr(iMnemID);

                           sWhereList := sWhereList + ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' ' +
                                                      ' AND (SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' IS NULL) ';
                        end else begin
                          //Nie znaleziono pola
                           sFromList := sFromList + ', (SELECT NULL AS ' + sMnemTab + '_SYMBOL FROM DUAL) SEL_' + IntToStr(iMnemID);
                        end;
                      end else begin
                        sFromList := sFromList + ', ' +
                                       '(SELECT ZM.' + sUNIPOLAUZ_WART + ' AS ' + sMnemTab + '_SYMBOL, '  +
                                               'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                                               'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                                        'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                                                  SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                                                  SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                                        'WHERE WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                                              'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                                              'WSK.' + sUNIPOLAUZWSK_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEPozycja) + ' AND ' +
                                              'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemID) +
                                        ' UNION ALL ' +
                                        'SELECT ZM.' + sUNIPOLAUZ_WART + ' AS ' + sMnemTab + '_SYMBOL, '  +
                                               'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                                               'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                                        'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                                                  SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                                                  SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                                        'WHERE WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                                              'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                                              'WSK.' + sUNIPOLAUZWSK_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEZlecenie) + ' AND ' +
                                              'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemID) +
                                        ') SEL_' + IntToStr(iMnemID);

                        sWhereList := sWhereList + ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' ' +
                                                   ' AND ((SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ') OR (SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' IS NULL)) ';
                      end;

                      vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
                      if vWarItem <> nil then
                         if vWarItem.ListaID <> '' then begin
                            if sWarunekWhere <> '' then
                               sWarunekWhere := sWarunekWhere + ' AND ';
                            sWarunekWhere := sWarunekWhere +
                               'SEL.' + sAktMnem + '_SYMBOL' + ' IN (SELECT ' + sMnemTab + '_SYMBOL' +
                                                                                            ' FROM ' + SQLManager.GetTableName(sMnemTab) +
                                                                                            ' WHERE ' + sMnemTab + '_ID' + ' IN (' + vWarItem.ListaID + ')) ';
                         end;

                      if sListaGroupBy <> '' then sListaGroupBy := sListaGroupBy + ', ';
                      sListaGroupBy := sListaGroupBy + sMnemTab + '_SYMBOL';
                      oPar.Add(sAktMnem + '=' + sMnemTab + '_SYMBOL');
                   end;
               end;
            end else begin
               if sSelectList <> '' then sSelectList := sSelectList + ', ';
               sSelectList := sSelectList + SQLManager.GetTableName('INF_DAJSYMBOLOBIEKTU') + '(ZP1.' + sZLEZLECENIEPOZ_POZIOMINF + ', ZP1.' + sZLEZLECENIEPOZ_INF_ID + ') AS ' + sAktMnem + '_SYMBOL';

               vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
               if vWarItem <> nil then
                  if vWarItem.ListaID <> '' then begin
                     if sWarunekWhere <> '' then
                        sWarunekWhere := sWarunekWhere + ' AND ';
                     sWarunekWhere := sWarunekWhere +
                        'SEL.' + sAktMnem + '_SYMBOL' + ' IN (SELECT ' + sMnemTab + '_SYMBOL' +
                                                                         ' FROM ' + SQLManager.GetTableName(sMnemTab) +
                                                                         ' WHERE ' + sMnemTab + '_ID' + ' IN (' + vWarItem.ListaID + ')) ';
                  end;


               if sListaGroupBy <> '' then sListaGroupBy := sListaGroupBy + ', ';
               sListaGroupBy := sListaGroupBy + sAktMnem + '_SYMBOL';
               oPar.Add(sAktMnem + '=' + sAktMnem + '_SYMBOL');
            end;
          end else
          if sMnemTab = sFKUZ then begin
             if sSelectList <> '' then sSelectList := sSelectList + ', ';
             sSelectList := sSelectList + 'SEL_' + IntToStr(iMnemID) + '.' + sAktMnem + '_SYMBOL';

             if bTypZlec and (qListaDefPol <> nil) then begin
                //Szukamy definicj pola uytkownika
                {1. Pola pozycji}
                if qListaDefPol.Locate(sFKMNEMONIKI_MNEMONIK+';'+sUNIPOLAUZWSK_FUNK,
                                       VarArrayOf([sAktMnem, cPolaUZ_ZLEPozycja]), []) then begin
                   {Znalezione pole pozycji}
                   iWskID := qListaDefPol.FieldByName(sUNIPOLAUZWSK_ID).AsInteger;
                   sFromList := sFromList + ', ' +
                              ' (SELECT ' + SQLManager.GetTableName('FKDAJ_SYMBOL_MNEMONIKA') + '(' + IntToStr(iMnemID) + ', NVL(ZM.' + sFKUZ_ID + ', 0)) AS ' + sAktMnem + '_SYMBOL, ' +
                                       'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                                       'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                                'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM ' +
                                'WHERE ZM.' + sUNIPOLAUZWSK_ID + ' = ' + IntToStr(iWskID) +
                                ') SEL_' + IntToStr(iMnemID);

                   sWhereList := sWhereList + ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' ' +
                                              ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ' ' ;

                end else {2. Pole zlecenia}
                if qListaDefPol.Locate(sFKMNEMONIKI_MNEMONIK+';'+sUNIPOLAUZWSK_FUNK,
                                       VarArrayOf([sAktMnem, cPolaUZ_ZLEZlecenie]), []) then begin
                   {Znalezione pole zlecenia}
                   iWskID := qListaDefPol.FieldByName(sUNIPOLAUZWSK_ID).AsInteger;
                   sFromList := sFromList + ', ' +
                              ' (SELECT ' + SQLManager.GetTableName('FKDAJ_SYMBOL_MNEMONIKA') + '(' + IntToStr(iMnemID) + ', NVL(ZM.' + sFKUZ_ID + ', 0)) AS ' + sAktMnem + '_SYMBOL, ' +
                                       'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                                       'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                                'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM ' +
                                'WHERE ZM.' + sUNIPOLAUZWSK_ID + ' = ' + IntToStr(iWskID) + ' ' +
                                ') SEL_' + IntToStr(iMnemID);

                   sWhereList := sWhereList + ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' ' +
                                              ' AND (SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' IS NULL) ';
                end else begin
                  //Nie znaleziono pola
                   sFromList := sFromList + ', (SELECT NULL AS ' + sMnemTab + '_SYMBOL FROM DUAL) SEL_' + IntToStr(iMnemID);
                end;
             end else begin
                sFromList := sFromList + ', ' +
                              ' (SELECT ' + SQLManager.GetTableName('FKDAJ_SYMBOL_MNEMONIKA') + '(' + IntToStr(iMnemID) + ', NVL(ZM.' + sFKUZ_ID + ', 0)) AS ' + sAktMnem + '_SYMBOL, ' +
                                       'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                                       'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                                'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                                          SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                                          SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                                'WHERE WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                                      'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                                      'WSK.' + sUNIPOLAUZWSK_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEPozycja) + ' AND ' +
                                      'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemID) +
                                ' UNION ALL ' +
                              '  SELECT ' + SQLManager.GetTableName('FKDAJ_SYMBOL_MNEMONIKA') + '(' + IntToStr(iMnemID) + ', NVL(ZM.' + sFKUZ_ID + ', 0)) AS ' + sAktMnem + '_SYMBOL, ' +
                                       'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                                       'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                                'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                                          SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                                          SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                                'WHERE WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                                      'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                                      'WSK.' + sUNIPOLAUZWSK_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEZlecenie) + ' AND ' +
                                      'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemID) +
                                ') SEL_' + IntToStr(iMnemID);

                sWhereList := sWhereList + ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' ' +
                                           ' AND ((SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ') OR (SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' IS NULL)) ';
             end;


             vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
             if vWarItem <> nil then
                if vWarItem.ListaID <> '' then begin
                   if sWarunekWhere <> '' then
                      sWarunekWhere := sWarunekWhere + ' AND ';
                   sWarunekWhere := sWarunekWhere +
                      'SEL.' + sAktMnem + '_SYMBOL' + ' IN (SELECT ' + sFKUZ_SYMBOL +
                                                                                   ' FROM ' + SQLManager.GetTableName(sFKUZ) +
                                                                                   ' WHERE ' + sFKMNEMONIKI_ID + '=' + IntToStr(iMnemID) + ' AND ' +
                                                                                               sFKUZ_ID + ' IN (' + vWarItem.ListaID + ')) ';
                end;

             if sListaGroupBy <> '' then sListaGroupBy := sListaGroupBy + ', ';
             sListaGroupBy := sListaGroupBy + sAktMnem + '_SYMBOL';
             oPar.Add(sAktMnem + '=' + sAktMnem + '_SYMBOL');
          end else begin
             if sSelectList <> '' then sSelectList := sSelectList + ', ';
             sSelectList := sSelectList + 'SEL_' + IntToStr(iMnemID) + '.' + sMnemTab + '_SYMBOL';

             if bTypZlec and (qListaDefPol <> nil) then begin
                //Szukamy definicj pola uytkownika
                {1. Pola pozycji}
                if qListaDefPol.Locate(sFKMNEMONIKI_MNEMONIK+';'+sUNIPOLAUZWSK_FUNK,
                                       VarArrayOf([sAktMnem, cPolaUZ_ZLEPozycja]), []) then begin
                   {Znalezione pole pozycji}
                   iWskID := qListaDefPol.FieldByName(sUNIPOLAUZWSK_ID).AsInteger;
                   sFromList := sFromList + ', ' +
                               '(SELECT ZM.' + sUNIPOLAUZ_WART + ' AS ' + sMnemTab + '_SYMBOL, '  +
                                       'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                                       'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                                'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM ' +
                                'WHERE ZM.' + sUNIPOLAUZWSK_ID + ' = ' + IntToStr(iWskID) +
                                ') SEL_' + IntToStr(iMnemID);

                   sWhereList := sWhereList + ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' ' +
                                              ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ' ' ;

                end else {2. Pole zlecenia}
                if qListaDefPol.Locate(sFKMNEMONIKI_MNEMONIK+';'+sUNIPOLAUZWSK_FUNK,
                                       VarArrayOf([sAktMnem, cPolaUZ_ZLEZlecenie]), []) then begin
                   {Znalezione pole zlecenia}
                   iWskID := qListaDefPol.FieldByName(sUNIPOLAUZWSK_ID).AsInteger;
                   sFromList := sFromList + ', ' +
                               '(SELECT ZM.' + sUNIPOLAUZ_WART + ' AS ' + sMnemTab + '_SYMBOL, '  +
                                       'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                                       'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                                'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM ' +
                                'WHERE ZM.' + sUNIPOLAUZWSK_ID + ' = ' + IntToStr(iWskID) + ' ' +
                                ') SEL_' + IntToStr(iMnemID);

                   sWhereList := sWhereList + ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' ' +
                                              ' AND (SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' IS NULL) ';
                end else begin
                  //Nie znaleziono pola
                   sFromList := sFromList + ', (SELECT NULL AS ' + sMnemTab + '_SYMBOL FROM DUAL) SEL_' + IntToStr(iMnemID);
                end;
             end else begin
               sFromList := sFromList + ', ' +
                   '(SELECT ZM.' + sUNIPOLAUZ_WART + ' AS ' + sMnemTab + '_SYMBOL, '  +
                           'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                           'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                    'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                              SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                              SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                    'WHERE WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                          'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                          'WSK.' + sUNIPOLAUZWSK_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEPozycja) + ' AND ' +
                          'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemID) +
                    ' UNION ALL ' +
                    'SELECT ZM.' + sUNIPOLAUZ_WART + ' AS ' + sMnemTab + '_SYMBOL, '  +
                           'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                           'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                    'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                              SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                              SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                    'WHERE WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                          'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                          'WSK.' + sUNIPOLAUZWSK_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEZlecenie) + ' AND ' +
                          'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemID) +
                    ') SEL_' + IntToStr(iMnemID);

               sWhereList := sWhereList + ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' ' +
                                          ' AND ((SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ') OR (SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' IS NULL)) ';
             end;

             vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
             if vWarItem <> nil then
                if vWarItem.ListaID <> '' then begin
                   if sWarunekWhere <> '' then
                      sWarunekWhere := sWarunekWhere + ' AND ';
                   sWarunekWhere := sWarunekWhere +
                      'SEL.' + sMnemTab + '_SYMBOL' + ' IN (SELECT ' + sMnemTab + '_SYMBOL' +
                                                          ' FROM ' + SQLManager.GetTableName(sMnemTab) +
                                                          ' WHERE ' + sMnemTab + '_ID' + ' IN (' + vWarItem.ListaID + ')) ';
                end;

             if sListaGroupBy <> '' then sListaGroupBy := sListaGroupBy + ', ';
             sListaGroupBy := sListaGroupBy + sMnemTab + '_SYMBOL';
             oPar.Add(sAktMnem + '=' + sMnemTab + '_SYMBOL');
          end
        end;
     finally
        oSplit.Free;
     end;
  end else begin
      {Jeden mnemonik do budowy kryterium}
      sMnemTab  := '';
//      iMnemDlug := 0;
      iMnemID   := 0;
      if Copy(Trim(sListaMnem), 1, 1) <> '''' then begin
          iSymbol := 1;
          qMnem := SQLManager.CreateQuery('SELECT * ' +
                                          'FROM %s ' +
                                          'WHERE ' + sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr(Copy(Trim(sListaMnem), 1, 3)) + ' AND ' +
                                                     sFKMNEMONIKI_INDEKS + ' = 0',
                                          [sFKMNEMONIKI]);

          try
            qMnem.Open;
            if not qMnem.IsEmpty then begin
               sMnemTab  := qMnem.FieldByName(sFKMNEMONIKI_TABELA).AsString;
//               iMnemDlug := qMnem.FieldByName(sFKMNEMONIKI_DLUGOSC).AsInteger;
               iMnemID   := qMnem.FieldByName(sFKMNEMONIKI_ID).AsInteger;
            end;
          finally
            if qMnem <> nil then FreeAndNil(qMnem);
          end;

          if (Copy(Trim(sListaMnem), 1, 3) = 'ZLE') then begin
             if sSelectList <> '' then sSelectList := sSelectList + ', ';
             sSelectList := sSelectList + 'ZL.' + sZLEZLECENIE_SYMBOL;

             vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
             if vWarItem <> nil then
                if vWarItem.ListaID <> '' then begin
                   if sWarunekWhere <> '' then
                      sWarunekWhere := sWarunekWhere + ' AND ';
                   sWarunekWhere := sWarunekWhere +
                      'SEL.' + sZLEZLECENIE_SYMBOL + ' IN (SELECT ' + sZLEZLECENIE_SYMBOL +
                                                         ' FROM ' + SQLManager.GetTableName(sZLEZLECENIE) +
                                                         ' WHERE ' + sZLEZLECENIE_ID + ' IN (' + vWarItem.ListaID + ')) ';
                end;

             sListaGroupBy := sZLEZLECENIE_SYMBOL;
             oPar.Add(Copy(Trim(sListaMnem), 1, 3) + '=' + sZLEZLECENIE_SYMBOL);
          end else
          if (Copy(Trim(sListaMnem), 1, 3) = 'ODZ') or (Copy(Trim(sListaMnem), 1, 3) = 'FIR') then begin
             if sSelectList <> '' then sSelectList := sSelectList + ', ';
             sSelectList := sSelectList + 'ODDZ.' + sUNIODDZIAL_SYMBOL;
             sFromList   := sFromList + ', ' + SQLManager.GetTableName(sUNIODDZIAL) + ' ODDZ';

             sWhereList := sWhereList + ' AND ZL.' + sUNIODDZIAL_ID + ' = ODDZ.' + sUNIODDZIAL_ID + '(+)';

             vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
             if vWarItem <> nil then
                if vWarItem.ListaID <> '' then begin
                   if sWarunekWhere <> '' then
                      sWarunekWhere := sWarunekWhere + ' AND ';
                   sWarunekWhere := sWarunekWhere +
                      'SEL.' + sUNIODDZIAL_SYMBOL + ' IN (SELECT ' + sUNIODDZIAL_SYMBOL +
                                                        ' FROM ' + SQLManager.GetTableName(sUNIODDZIAL) +
                                                        ' WHERE ' + sUNIODDZIAL_ID + ' IN (' + vWarItem.ListaID + ')) ';
                end;

             sListaGroupBy := sUNIODDZIAL_SYMBOL;
             oPar.Add(Copy(Trim(sListaMnem), 1, 3) + '=' + sUNIODDZIAL_SYMBOL);
          end else {Jednostka Org.}
          if (Copy(Trim(sListaMnem), 1, 3) = 'JED') then begin
             if sSelectList <> '' then sSelectList := sSelectList + ', ';
             sSelectList := sSelectList + 'JO.' + sUNIJEDNOSTKAORG_SYMBOL;
             sFromList   := sFromList + ', ' + SQLManager.GetTableName(sUNIJEDNOSTKAORG) + ' JO';

             sWhereList := sWhereList + ' AND ZL.' + sUNIJEDNOSTKAORG_ID + ' = JO.' + sUNIJEDNOSTKAORG_ID + '(+)';

             vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
             if vWarItem <> nil then
                if vWarItem.ListaID <> '' then begin
                   if sWarunekWhere <> '' then
                      sWarunekWhere := sWarunekWhere + ' AND ';
                   sWarunekWhere := sWarunekWhere +
                      'SEL.' + sUNIJEDNOSTKAORG_SYMBOL + ' IN (SELECT ' + sUNIJEDNOSTKAORG_SYMBOL +
                                                             ' FROM ' + SQLManager.GetTableName(sUNIJEDNOSTKAORG) +
                                                             ' WHERE ' + sUNIJEDNOSTKAORG_ID + ' IN (' + vWarItem.ListaID + ')) ';
                end;

             sListaGroupBy := sUNIJEDNOSTKAORG_SYMBOL;
             oPar.Add(Copy(Trim(sListaMnem), 1, 3) + '=' + sUNIJEDNOSTKAORG_SYMBOL);
          end else {Infrastruktura}
          if Copy(Trim(sListaMnem), 1, 3) = sMnem then begin
             if sSelectList <> '' then sSelectList := sSelectList + ', ';
             sSelectList := sSelectList + SQLManager.GetTableName('INF_DAJSYMBOLOBIEKTU') + '(ZP1.' + sZLEZLECENIEPOZ_POZIOMINF + ', ZP1.' + sZLEZLECENIEPOZ_INF_ID + ') AS ' + Copy(Trim(sListaMnem), 1, 3) + '_SYMBOL';

             vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
             if vWarItem <> nil then
                if vWarItem.ListaID <> '' then begin
                   if sWarunekWhere <> '' then
                      sWarunekWhere := sWarunekWhere + ' AND ';
                   sWarunekWhere := sWarunekWhere +
                      'SEL.' + Trim(sListaMnem) + '_SYMBOL' + ' IN (SELECT ' + sMnemTab + '_SYMBOL' +
                                                  ' FROM ' + SQLManager.GetTableName(sMnemTab) +
                                                  ' WHERE ' + sMnemTab + '_ID' + ' IN (' + vWarItem.ListaID + ')) ';
                end;

             sListaGroupBy := Copy(Trim(sListaMnem), 1, 3) + '_SYMBOL';
             oPar.Add(Copy(Trim(sListaMnem), 1, 3) + '=' + Copy(Trim(sListaMnem), 1, 3) + '_SYMBOL');
          end else
          if sMnemTab = sFKUZ then begin
             if sSelectList <> '' then sSelectList := sSelectList + ', ';
             sSelectList := sSelectList + 'SEL_' + IntToStr(iMnemID) + '.' + Copy(Trim(sListaMnem), 1, 3) + '_SYMBOL';

             sFromList := sFromList + ', ' +
                            ' (SELECT ' + SQLManager.GetTableName('FKDAJ_SYMBOL_MNEMONIKA') + '(NVL(ZD.' + sFKMNEMONIKI_ID + ', 0), NVL(ZM.' + sFKUZ_ID + ', 0)) AS ' + Copy(Trim(sListaMnem), 1, 3) + '_SYMBOL, ' +
                                          'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                                          'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                              'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                                        SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                                        SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                              'WHERE WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                                    'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                                    'WSK.' + sUNIPOLAUZWSK_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEPozycja) + ' AND ' +
                                    'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemID) +
                              ' UNION ALL ' +
                              'SELECT ' + SQLManager.GetTableName('FKDAJ_SYMBOL_MNEMONIKA') + '(NVL(ZD.' + sFKMNEMONIKI_ID + ', 0), NVL(ZM.' + sFKUZ_ID + ', 0)) AS ' + Copy(Trim(sListaMnem), 1, 3) + '_SYMBOL, ' +
                                          'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                                          'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                              'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                                        SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                                        SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                              'WHERE WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                                    'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                                    'WSK.' + sUNIPOLAUZWSK_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEZlecenie) + ' AND ' +
                                    'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemID) +
                              ') SEL_' + IntToStr(iMnemID);

             sWhereList := sWhereList + ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' ' +
                                        ' AND ((SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ') OR (SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' IS NULL)) ';

             if bTypZlec and (qListaDefPol <> nil) then begin
                //Szukamy definicj pola uytkownika
                {1. Pola pozycji}
                if qListaDefPol.Locate(sFKMNEMONIKI_MNEMONIK+';'+sUNIPOLAUZWSK_FUNK,
                                       VarArrayOf([sAktMnem, cPolaUZ_ZLEPozycja]), []) then begin
                   {Znalezione pole pozycji}
                   iWskID := qListaDefPol.FieldByName(sUNIPOLAUZWSK_ID).AsInteger;
                   sFromList := sFromList + ', ' +
                               '(SELECT ZM.' + sUNIPOLAUZ_WART + ' AS ' + sMnemTab + '_SYMBOL, '  +
                                       'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                                       'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                                'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM ' +
                                'WHERE ZM.' + sUNIPOLAUZWSK_ID + ' = ' + IntToStr(iWskID) +
                                ') SEL_' + IntToStr(iMnemID);

                   sWhereList := sWhereList + ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' ' +
                                              ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ' ' ;

                end else {2. Pole zlecenia}
                if qListaDefPol.Locate(sFKMNEMONIKI_MNEMONIK+';'+sUNIPOLAUZWSK_FUNK,
                                       VarArrayOf([sAktMnem, cPolaUZ_ZLEZlecenie]), []) then begin
                   {Znalezione pole zlecenia}
                   iWskID := qListaDefPol.FieldByName(sUNIPOLAUZWSK_ID).AsInteger;
                   sFromList := sFromList + ', ' +
                               '(SELECT ZM.' + sUNIPOLAUZ_WART + ' AS ' + sMnemTab + '_SYMBOL, '  +
                                       'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                                       'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                                'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM ' +
                                'WHERE ZM.' + sUNIPOLAUZWSK_ID + ' = ' + IntToStr(iWskID) + ' ' +
                                ') SEL_' + IntToStr(iMnemID);

                   sWhereList := sWhereList + ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' ' +
                                              ' AND (SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' IS NULL) ';
                end else begin
                  //Nie znaleziono pola
                   sFromList := sFromList + ', (SELECT NULL AS ' + sMnemTab + '_SYMBOL FROM DUAL) SEL_' + IntToStr(iMnemID);
                   //Bez warunkw where
                   //sWhereList := sWhereList + ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' ' +
                   //                           ' AND (SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' IS NULL) ';
                end;
             end else begin
                sFromList := sFromList + ', ' +
                               '(SELECT ZM.' + sUNIPOLAUZ_WART + ' AS ' + sMnemTab + '_SYMBOL, '  +
                                       'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                                       'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                                'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                                          SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                                          SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                                'WHERE WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                                      'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                                      'WSK.' + sUNIPOLAUZWSK_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEPozycja) + ' AND ' +
                                      'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemID) +
                                ' UNION ALL ' +
                                'SELECT ZM.' + sUNIPOLAUZ_WART + ' AS ' + sMnemTab + '_SYMBOL, '  +
                                       'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                                       'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                                'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                                          SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                                          SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                                'WHERE WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                                      'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                                      'WSK.' + sUNIPOLAUZWSK_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEZlecenie) + ' AND ' +
                                      'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemID) +
                                ') SEL_' + IntToStr(iMnemID);

                sWhereList := sWhereList + ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' ' +
                                           ' AND ((SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ') OR (SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' IS NULL)) ';
             end;


             vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
             if vWarItem <> nil then
                if vWarItem.ListaID <> '' then begin
                   if sWarunekWhere <> '' then
                      sWarunekWhere := sWarunekWhere + ' AND ';
                   sWarunekWhere := sWarunekWhere +
                      'SEL.' + Trim(sListaMnem) + '_SYMBOL' + ' IN (SELECT ' + sFKUZ_SYMBOL +
                                                  ' FROM ' + SQLManager.GetTableName(sFKUZ) +
                                                  ' WHERE ' + sFKMNEMONIKI_ID + '=' + IntToStr(iMnemID) + ' AND ' +
                                                              sFKUZ_ID + ' IN (' + vWarItem.ListaID + ')) ';
                end;

             sListaGroupBy := Copy(Trim(sListaMnem), 1, 3) + '_SYMBOL';
             oPar.Add(Copy(Trim(sListaMnem), 1, 3) + '=' + Copy(Trim(sListaMnem), 1, 3) + '_SYMBOL');
          end else begin
             if sSelectList <> '' then sSelectList := sSelectList + ', ';
             sSelectList := sSelectList + 'SEL_' + IntToStr(iMnemID) + '.' + sMnemTab + '_SYMBOL';

             sFromList := sFromList + ', ' +
                 '(SELECT ZM.' + sUNIPOLAUZ_WART + ' AS ' + sMnemTab + '_SYMBOL, '  +
                         'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                         'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                  'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                            SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                            SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                  'WHERE WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                        'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                        'WSK.' + sUNIPOLAUZWSK_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEPozycja) + ' AND ' +
                        'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemID) +
                 ' UNION ALL ' +
                 'SELECT ZM.' + sUNIPOLAUZ_WART + ' AS ' + sMnemTab + '_SYMBOL, '  +
                         'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                         'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                  'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                            SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                            SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                  'WHERE WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                        'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                        'WSK.' + sUNIPOLAUZWSK_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEZlecenie) + ' AND ' +
                        'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemID) +
                  ') SEL_' + IntToStr(iMnemID);

             sWhereList := sWhereList + ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' ' +
                                        ' AND ((SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ') OR (SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' IS NULL)) ';

             if bTypZlec and (qListaDefPol <> nil) then begin
                //Szukamy definicj pola uytkownika
                {1. Pola pozycji}
                if qListaDefPol.Locate(sFKMNEMONIKI_MNEMONIK+';'+sUNIPOLAUZWSK_FUNK,
                                       VarArrayOf([sAktMnem, cPolaUZ_ZLEPozycja]), []) then begin
                   {Znalezione pole pozycji}
                   iWskID := qListaDefPol.FieldByName(sUNIPOLAUZWSK_ID).AsInteger;
                   sFromList := sFromList + ', ' +
                               '(SELECT ZM.' + sUNIPOLAUZ_WART + ' AS ' + sMnemTab + '_SYMBOL, '  +
                                       'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                                       'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                                'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM ' +
                                'WHERE ZM.' + sUNIPOLAUZWSK_ID + ' = ' + IntToStr(iWskID) +
                                ') SEL_' + IntToStr(iMnemID);

                   sWhereList := sWhereList + ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' ' +
                                              ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ' ' ;

                end else {2. Pole zlecenia}
                if qListaDefPol.Locate(sFKMNEMONIKI_MNEMONIK+';'+sUNIPOLAUZWSK_FUNK,
                                       VarArrayOf([sAktMnem, cPolaUZ_ZLEZlecenie]), []) then begin
                   {Znalezione pole zlecenia}
                   iWskID := qListaDefPol.FieldByName(sUNIPOLAUZWSK_ID).AsInteger;
                   sFromList := sFromList + ', ' +
                               '(SELECT ZM.' + sUNIPOLAUZ_WART + ' AS ' + sMnemTab + '_SYMBOL, '  +
                                       'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                                       'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                                'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM ' +
                                'WHERE ZM.' + sUNIPOLAUZWSK_ID + ' = ' + IntToStr(iWskID) + ' ' +
                                ') SEL_' + IntToStr(iMnemID);

                   sWhereList := sWhereList + ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' ' +
                                              ' AND (SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' IS NULL) ';
                end else begin
                  //Nie znaleziono pola
                   sFromList := sFromList + ', (SELECT NULL AS ' + sMnemTab + '_SYMBOL FROM DUAL) SEL_' + IntToStr(iMnemID);
                end;
             end else begin
                sFromList := sFromList + ', ' +
                               '(SELECT ZM.' + sUNIPOLAUZ_WART + ' AS ' + sMnemTab + '_SYMBOL, '  +
                                       'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                                       'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                                'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                                          SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                                          SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                                'WHERE WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                                      'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                                      'WSK.' + sUNIPOLAUZWSK_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEPozycja) + ' AND ' +
                                      'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemID) +
                                ' UNION ALL ' +
                                'SELECT ZM.' + sUNIPOLAUZ_WART + ' AS ' + sMnemTab + '_SYMBOL, '  +
                                       'ZM.' + sUNIPOLAUZ_FELEMENTID + ' AS ' + sZLEZLECENIE_ID + ', ' +
                                       'ZM.' + sUNIPOLAUZ_FSUBELEMID + ' AS ' + sZLEZLECENIEPOZ_ID + ' ' +
                                'FROM ' + SQLManager.GetTableName(sUNIPOLAUZ) + ' ZM, ' +
                                          SQLManager.GetTableName(sUNIPOLAUZDEF) + ' ZD, ' +
                                          SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK ' +
                                'WHERE WSK.' + sUNIPOLAUZDEF_ID + ' = ZD.' + sUNIPOLAUZDEF_ID + ' AND ' +
                                      'WSK.' + sUNIPOLAUZWSK_ID + ' = ZM.' + sUNIPOLAUZWSK_ID + ' AND ' +
                                      'WSK.' + sUNIPOLAUZWSK_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEZlecenie) + ' AND ' +
                                      'ZD.'  + sFKMNEMONIKI_ID + ' = ' + IntToStr(iMnemID) +
                                ') SEL_' + IntToStr(iMnemID);

                sWhereList := sWhereList + ' AND SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIE_ID + ' = ZL.' + sZLEZLECENIE_ID + ' ' +
                                           ' AND ((SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ') OR (SEL_' + IntToStr(iMnemID) + '.' + sZLEZLECENIEPOZ_ID + ' IS NULL)) ';
             end;

             vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
             if vWarItem <> nil then
                if vWarItem.ListaID <> '' then begin
                   if sWarunekWhere <> '' then
                      sWarunekWhere := sWarunekWhere + ' AND ';
                   sWarunekWhere := sWarunekWhere +
                      'SEL.' + sMnemTab + '_SYMBOL' + ' IN (SELECT ' + sMnemTab + '_SYMBOL' +
                                                          ' FROM ' + SQLManager.GetTableName(sMnemTab) +
                                                          ' WHERE ' + sMnemTab + '_ID' + ' IN (' + vWarItem.ListaID + ')) ';
                end;

             sListaGroupBy := sMnemTab + '_SYMBOL';
             oPar.Add(Copy(Trim(sListaMnem), 1, 3) + '=' + sMnemTab + '_SYMBOL');
          end;
      end else begin
         {Staa tekstowa!!}
         iSymbol := 0;
      end;

  end;

  if iSymbol = 0 then begin
     sSelectList := QuotedStr('') + ' AS PUSTY_SYMBOL ';

     {sSQL := sSQL + QuotedStr('') + ' AS PUSTY_SYMBOL ';
     SELSQL := SELSQL + QuotedStr('') + ' AS PUSTY_SYMBOL ';}
     sListaGroupBy := 'PUSTY_SYMBOL';
  end;

  //sSQL := sSQL + ' FROM ' + SQLManager.GetTableName(sZLEZLECENIEPOZ) + ' ZP1 ';

  //SELSQL := SELSQL + ' FROM ' + SQLManager.GetTableName(sZLEZLECENIEPOZ) + ' ZP1 ';

  if bTypZlec then
     sWhereList := sWhereList +
                     ' AND ZL.' + sZLETYPZLEC_ID + ' = ' + IntToStr(iTypZlecID);

  if sObiekt <> '' then begin
     sWhereList := sWhereList +
                     ' AND ZP1.' + sZLEZLECENIEPOZ_POZIOMINF + '=' + QuotedStr(sObiekt);

     {Na razie ograniczenie tylko dla slownika z INF}
     if sOgranicz <> '' then begin
        if Pos(',', sOgranicz) > 0 then begin
           // Tu nic nie robimy
        end else begin
           qMnemOgranicz := SQLManager.CreateQuery('SELECT * ' +
                                                    'FROM %s ' +
                                                    'WHERE ' + sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr(Trim(sOgranicz)) + ' AND ' +
                                                               sFKMNEMONIKI_INDEKS + ' = 0',
                                                    [sFKMNEMONIKI]);

           try
              qMnemOgranicz.Open;
              if not qMnemOgranicz.IsEmpty then begin
                 sMnemTab  := qMnemOgranicz.FieldByName(sFKMNEMONIKI_TABELA).AsString;
//                 iMnemDlug := qMnemOgranicz.FieldByName(sFKMNEMONIKI_DLUGOSC).AsInteger;
                 iMnemID   := qMnemOgranicz.FieldByName(sFKMNEMONIKI_ID).AsInteger;
              end;
           finally
              if qMnemOgranicz <> nil then FreeAndNil(qMnemOgranicz);
           end;

           vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
           if vWarItem <> nil then
              if vWarItem.ListaID <> '' then begin
                 sWhereList := sWhereList +
                                ' AND ZP1.' + sZLEZLECENIEPOZ_INF_ID + ' IN (' + vWarItem.ListaID + ')';
                 {if sWarunekWhere <> '' then
                    sWarunekWhere := sWarunekWhere + ' AND ';
                 sWarunekWhere := sWarunekWhere +
                    'SEL.' + Trim(sListaMnem) + '_SYMBOL' + ' IN (SELECT ' + sMnemTab + '_SYMBOL' +
                                                ' FROM ' + SQLManager.GetTableName(sMnemTab) +
                                                ' WHERE ' + sMnemTab + '_ID' + ' IN (' + vWarItem.ListaID + ')) ';}
              end;

        end;
     end;
  end;

  {sSQL := sSQL +
                ') SEL ';

  SELSQL := SELSQL +
                ') SEL ';}

  if bJestWhere then begin
     {Uzupenienie warunkw na podstawie ZLEKRYTERIA_OGRANICZ}
     if sOgranicz <> '' then begin
        if Pos(',', sOgranicz) > 0 then begin

        end else begin
(*****************************************************************
            sMnemTab  := '';
            iMnemDlug := 0;
            iMnemID   := 0;
            iSymbol := 1;
            qMnemOgranicz := SQLManager.CreateQuery('SELECT * ' +
                                                    'FROM %s ' +
                                                    'WHERE ' + sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr(Trim(sOgranicz)) + ' AND ' +
                                                               sFKMNEMONIKI_INDEKS + ' = 0',
                                                    [sFKMNEMONIKI]);

            try
              qMnemOgranicz.Open;
              if not qMnemOgranicz.IsEmpty then begin
                 sMnemTab  := qMnemOgranicz.FieldByName(sFKMNEMONIKI_TABELA).AsString;
                 iMnemDlug := qMnemOgranicz.FieldByName(sFKMNEMONIKI_DLUGOSC).AsInteger;
                 iMnemID   := qMnemOgranicz.FieldByName(sFKMNEMONIKI_ID).AsInteger;
              end;
            finally
              if qMnem <> nil then FreeAndNil(qMnem);
            end;

            if (Trim(sOgranicz) = 'ZLE') then begin
               sSQL := sSQL + ' (SELECT ' + sZLEZLECENIE_SYMBOL +
                               ' FROM ' + SQLManager.GetTableName(sZLEZLECENIE) +
                               ' WHERE ' + sZLEZLECENIE_ID + '=ZP1.' + sZLEZLECENIE_ID + ') AS ' + sZLEZLECENIE_SYMBOL;

               SELSQL := SELSQL + ' (SELECT ' + sZLEZLECENIE_SYMBOL +
                               ' FROM ' + SQLManager.GetTableName(sZLEZLECENIE) +
                               ' WHERE ' + sZLEZLECENIE_ID + '=ZP1.' + sZLEZLECENIE_ID + ') AS ' + sZLEZLECENIE_SYMBOL;

               vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
               if vWarItem <> nil then
                  if vWarItem.ListaID <> '' then begin
                     if sWarunekWhere <> '' then
                        sWarunekWhere := sWarunekWhere + ' AND ';
                     sWarunekWhere := sWarunekWhere +
                        'SEL.' + sZLEZLECENIE_SYMBOL + ' IN (SELECT ' + sZLEZLECENIE_SYMBOL +
                                                           ' FROM ' + SQLManager.GetTableName(sZLEZLECENIE) +
                                                           ' WHERE ' + sZLEZLECENIE_ID + ' IN (' + vWarItem.ListaID + ')) ';
                  end;

               sListaGroupBy := sZLEZLECENIE_SYMBOL;
               oPar.Add(Trim(sListaMnem) + '=' + sZLEZLECENIE_SYMBOL);
            end else
            if (Trim(sListaMnem) = 'ODZ') or (Trim(sListaMnem) = 'FIR') then begin
               sSQL := sSQL + ' (SELECT ODDZ.' + sUNIODDZIAL_SYMBOL +
                               ' FROM ' + SQLManager.GetTableName(sZLEZLECENIE) + ' ZZ, ' +
                                          SQLManager.GetTableName(sUNIODDZIAL) + ' ODDZ ' +
                               ' WHERE ZZ.' + sUNIODDZIAL_ID + ' = ODDZ.' + sUNIODDZIAL_ID + ' AND ' +
                                      'ZZ.' + sZLEZLECENIE_ID + ' = ZP1.' + sZLEZLECENIE_ID + ') AS ' + sUNIODDZIAL_SYMBOL;

               SELSQL := SELSQL + ' (SELECT ODDZ.' + sUNIODDZIAL_SYMBOL +
                               ' FROM ' + SQLManager.GetTableName(sZLEZLECENIE) + ' ZZ, ' +
                                          SQLManager.GetTableName(sUNIODDZIAL) + ' ODDZ ' +
                               ' WHERE ZZ.' + sUNIODDZIAL_ID + ' = ODDZ.' + sUNIODDZIAL_ID + ' AND ' +
                                      'ZZ.' + sZLEZLECENIE_ID + ' = ZP1.' + sZLEZLECENIE_ID + ') AS ' + sUNIODDZIAL_SYMBOL;

               vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
               if vWarItem <> nil then
                  if vWarItem.ListaID <> '' then begin
                     if sWarunekWhere <> '' then
                        sWarunekWhere := sWarunekWhere + ' AND ';
                     sWarunekWhere := sWarunekWhere +
                        'SEL.' + sUNIODDZIAL_SYMBOL + ' IN (SELECT ' + sUNIODDZIAL_SYMBOL +
                                                          ' FROM ' + SQLManager.GetTableName(sUNIODDZIAL) +
                                                          ' WHERE ' + sUNIODDZIAL_ID + ' IN (' + vWarItem.ListaID + ')) ';
                  end;

               sListaGroupBy := sUNIODDZIAL_SYMBOL;
               oPar.Add(Trim(sListaMnem) + '=' + sUNIODDZIAL_SYMBOL);
            end else {Infrastruktura}
            if Trim(sListaMnem) = sMnem then begin
               sSQL := sSQL + ' ' + SQLManager.GetTableName('INF_DAJSYMBOLOBIEKTU') + '(ZP1.' + sZLEZLECENIEPOZ_POZIOMINF + ', ZP1.' + sZLEZLECENIEPOZ_INF_ID + ') AS ' + Trim(sListaMnem) + '_SYMBOL';

               SELSQL := SELSQL + ' ' + SQLManager.GetTableName('INF_DAJSYMBOLOBIEKTU') + '(ZP1.' + sZLEZLECENIEPOZ_POZIOMINF + ', ZP1.' + sZLEZLECENIEPOZ_INF_ID + ') AS ' + Trim(sListaMnem) + '_SYMBOL';

               vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
               if vWarItem <> nil then
                  if vWarItem.ListaID <> '' then begin
                     if sWarunekWhere <> '' then
                        sWarunekWhere := sWarunekWhere + ' AND ';
                     sWarunekWhere := sWarunekWhere +
                        'SEL.' + Trim(sListaMnem) + '_SYMBOL' + ' IN (SELECT ' + sMnemTab + '_SYMBOL' +
                                                    ' FROM ' + SQLManager.GetTableName(sMnemTab) +
                                                    ' WHERE ' + sMnemTab + '_ID' + ' IN (' + vWarItem.ListaID + ')) ';
                  end;

               sListaGroupBy := Trim(sListaMnem) + '_SYMBOL';
               oPar.Add(Trim(sListaMnem) + '=' + Trim(sListaMnem) + '_SYMBOL');
            end else
            if sMnemTab = sFKUZ then begin
               sSQL := sSQL + ' (SELECT ' + SQLManager.GetTableName('FKDAJ_SYMBOL_MNEMONIKA') + '(NVL(ZD.' + sFKMNEMONIKI_ID + ', 0), NVL(ZM.' + sFKUZ_ID + ', 0)) ' +
                               ' FROM ' + SQLManager.GetTableName(sZLEPOLAZM) + ' ZM, ' +
                                          SQLManager.GetTableName(sZLEPOLAZMDEF) + ' ZD, ' +
                                          SQLManager.GetTableName(sFKMNEMONIKI) + ' FM ' +
                               ' WHERE ZM.' + sZLEZLECENIEPOZ_ID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ' AND ' +
                                      'ZM.' + sZLEPOLAZMDEF_ID + ' = ZD.' + sZLEPOLAZMDEF_ID + ' AND ' +
                                      'FM.' + sFKMNEMONIKI_ID + ' = ZD.' + sFKMNEMONIKI_ID + ' AND ' +
                                      'FM.' + sFKMNEMONIKI_TABELA + ' = ' + QuotedStr(sMnemTab) + ' AND ' +
                                      'FM.' + sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr(Trim(sListaMnem)) + ') AS ' + Trim(sListaMnem) + '_SYMBOL';

               SELSQL := SELSQL + ' (SELECT ' + SQLManager.GetTableName('FKDAJ_SYMBOL_MNEMONIKA') + '(NVL(ZD.' + sFKMNEMONIKI_ID + ', 0), NVL(ZM.' + sFKUZ_ID + ', 0)) ' +
                               ' FROM ' + SQLManager.GetTableName(sZLEPOLAZM) + ' ZM, ' +
                                          SQLManager.GetTableName(sZLEPOLAZMDEF) + ' ZD, ' +
                                          SQLManager.GetTableName(sFKMNEMONIKI) + ' FM ' +
                               ' WHERE ZM.' + sZLEZLECENIEPOZ_ID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ' AND ' +
                                      'ZM.' + sZLEPOLAZMDEF_ID + ' = ZD.' + sZLEPOLAZMDEF_ID + ' AND ' +
                                      'FM.' + sFKMNEMONIKI_ID + ' = ZD.' + sFKMNEMONIKI_ID + ' AND ' +
                                      'FM.' + sFKMNEMONIKI_TABELA + ' = ' + QuotedStr(sMnemTab) + ' AND ' +
                                      'FM.' + sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr(Trim(sListaMnem)) + ') AS ' + Trim(sListaMnem) + '_SYMBOL';

               vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
               if vWarItem <> nil then
                  if vWarItem.ListaID <> '' then begin
                     if sWarunekWhere <> '' then
                        sWarunekWhere := sWarunekWhere + ' AND ';
                     sWarunekWhere := sWarunekWhere +
                        'SEL.' + Trim(sListaMnem) + '_SYMBOL' + ' IN (SELECT ' + sFKUZ_SYMBOL +
                                                    ' FROM ' + SQLManager.GetTableName(sFKUZ) +
                                                    ' WHERE ' + sFKMNEMONIKI_ID + '=' + IntToStr(iMnemID) + ' AND ' +
                                                                sFKUZ_ID + ' IN (' + vWarItem.ListaID + ')) ';
                  end;

               sListaGroupBy := Trim(sListaMnem) + '_SYMBOL';
               oPar.Add(Trim(sListaMnem) + '=' + Trim(sListaMnem) + '_SYMBOL');
            end else begin
               sSQL := sSQL + ' (SELECT ZM.' + sZLEPOLAZM_WART +
                               ' FROM ' + SQLManager.GetTableName(sZLEPOLAZM) + ' ZM, ' +
                                          SQLManager.GetTableName(sZLEPOLAZMDEF) + ' ZD, ' +
                                          SQLManager.GetTableName(sFKMNEMONIKI) + ' FM ' +
                               ' WHERE ZM.' + sZLEZLECENIEPOZ_ID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ' AND ' +
                                      'ZM.' + sZLEPOLAZMDEF_ID + ' = ZD.' + sZLEPOLAZMDEF_ID + ' AND ' +
                                      'FM.' + sFKMNEMONIKI_ID + ' = ZD.' + sFKMNEMONIKI_ID + ' AND ' +
                                      'FM.' + sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr(Trim(sListaMnem)) + ' ) AS ' + sMnemTab + '_SYMBOL';

               SELSQL := SELSQL + ' (SELECT ZM.' + sZLEPOLAZM_WART +
                               ' FROM ' + SQLManager.GetTableName(sZLEPOLAZM) + ' ZM, ' +
                                          SQLManager.GetTableName(sZLEPOLAZMDEF) + ' ZD, ' +
                                          SQLManager.GetTableName(sFKMNEMONIKI) + ' FM ' +
                               ' WHERE ZM.' + sZLEZLECENIEPOZ_ID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ' AND ' +
                                      'ZM.' + sZLEPOLAZMDEF_ID + ' = ZD.' + sZLEPOLAZMDEF_ID + ' AND ' +
                                      'FM.' + sFKMNEMONIKI_ID + ' = ZD.' + sFKMNEMONIKI_ID + ' AND ' +
                                      'FM.' + sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr(Trim(sListaMnem)) + ' ) AS ' + sMnemTab + '_SYMBOL';

               vWarItem := vWarunkiMnem.GetItemByValue(iMnemID);
               if vWarItem <> nil then
                  if vWarItem.ListaID <> '' then begin
                     if sWarunekWhere <> '' then
                        sWarunekWhere := sWarunekWhere + ' AND ';
                     sWarunekWhere := sWarunekWhere +
                        'SEL.' + sMnemTab + '_SYMBOL' + ' IN (SELECT ' + sMnemTab + '_SYMBOL' +
                                                            ' FROM ' + SQLManager.GetTableName(sMnemTab) +
                                                            ' WHERE ' + sMnemTab + '_ID' + ' IN (' + vWarItem.ListaID + ')) ';
                  end;

               sListaGroupBy := sMnemTab + '_SYMBOL';
               oPar.Add(Trim(sListaMnem) + '=' + sMnemTab + '_SYMBOL');
            end;
*****************************************************************)
        end;
     end;
  end;

      // SELSQL := '(SELECT ZP1.ZLEZLECENIEPOZ_ID, ';
  sSQL := sSQL +
              sSelectList +
          ' FROM ' +
              sFromList +
          ' WHERE ' +
                 sWhereList + ') SEL';



  SELSQL := SELSQL +
                 sSelectList +
             ' FROM ' +
                 sFromList +
             ' WHERE ' +
                 sWhereList + ') SEL';

  if sWarunekWhere <> '' then begin
     sSQL   := sSQL + ' WHERE ' + sWarunekWhere;
     SELSQL := SELSQL + ' WHERE ' + sWarunekWhere;
     bJestWhere := True;
  end else begin
     bJestWhere := False;
  end;

  if sListaGroupBy <> '' then
     sSQL := sSQL + ' GROUP BY ' + sListaGroupBy;

  if vWarunkiMnem <> nil then vWarunkiMnem.Free;
  if qListaDefPol <> nil then FreeAndNil(qListaDefPol);

  result := SQLManager.CreateQuery(sSQL);
  if result <> nil then
     result.Open;
end;


(*********************************
{Funkcja zwraca warunek na pozycje zlecenia dla podanego kryterium}
function TZLEDataManager.ZleDajListePozycjiDlaKryterium(iKryteriumID, iUNIOKRES_ID: Integer): String;
var
  oSplit: TSplit;
  sListaMnem, sLista: String;
  bTypZlec,
//  bKrytOkresowe,
  bPierwszy: Boolean;
  qKryt, qZlec: TUniQuery;
  i, iTypZlecID, iIdx: Integer;
  sSQL, sTmp, sMnem: String;

begin
  iIdx      := 0;
  bTypZlec  := false;
  iTypZlecID:= 0;
  result := '';
  {Odczytujemy definicje kryterium}
  qKryt := SQLManager.CreateQuery('SELECT * FROM %s ' +
                                  'WHERE ' + sZLEKRYTERIA_ID + ' = ' + IntToStr(iKryteriumID),
                                  [sZLEKRYTERIA]);
  try
    if qKryt <> nil then begin
       qKryt.Open;
       if not qKryt.IsEmpty then begin
          sListaMnem    := qKryt.FieldByName(sZLEKRYTERIA_SKLADNIKI).AsString;
          bTypZlec      := (not qKryt.FieldByName(sZLETYPZLEC_ID).IsNull);
          iTypZlecID    := qKryt.FieldByName(sZLETYPZLEC_ID).AsInteger;
//          bKrytOkresowe := (qKryt.FieldByName(sZLEKRYTERIA_OKRESOWE).AsString = sTak);
       end;
    end;
  finally
    if qKryt <> nil then FreeAndNil(qKryt);
  end;


  {Dokadamy mnemoniki infrastruktury}
  bPierwszy     := True;

  {Odczytujemy definicje typu zlecenia}
  sTmp := 'SELECT * FROM %s';
  if bTypZlec then
     sTmp := sTmp + ' WHERE ' + sZLETYPZLEC_ID + ' = ' + IntToStr(iTypZlecID);

  qZlec := SQLManager.CreateQuery(sTmp, [sZLETYPZLEC]);
  try
    if qZlec <> nil then begin
       qZlec.Open;
       if not qZlec.IsEmpty then begin
          if qZlec.FieldByName(sZLETYPZLEC_ELEMENTINF).AsString = sTak then
             iIdx := qZlec.FieldByName(sZLETYPZLEC_POZIOMINF).AsInteger
          else
          if qZlec.FieldByName(sZLETYPZLEC_LOKAL_A).AsString <> 'A' then iIdx := 0
          else
          if qZlec.FieldByName(sZLETYPZLEC_ZASOB_A).AsString <> 'A' then iIdx := 1
          else
          if qZlec.FieldByName(sZLETYPZLEC_KLATKA_A).AsString <> 'A' then iIdx := 2
          else
          //Brama     - 3
          if qZlec.FieldByName(sZLETYPZLEC_BUDYNEK_A).AsString <> 'A' then iIdx := 4
          else
          if qZlec.FieldByName(sZLETYPZLEC_NIERUCHOMOSC_A).AsString <> 'A' then iIdx := 5
          else
          //Wspolnota - 6
          //Rejon     - 7
          if qZlec.FieldByName(sZLETYPZLEC_ULICA_A).AsString <> 'A' then iIdx := 8
          else
          if qZlec.FieldByName(sZLETYPZLEC_SIECELEMENT_A).AsString <> 'A' then iIdx := 9;

          sMnem := cslZLE_INFMnemoniki[iIdx];
       end;
    end;
  finally
    if qZlec <> nil then FreeAndNil(qZlec);
  end;

  sSQL := 'SELECT ZP1.' + sZLEZLECENIEPOZ_ID + ' ' +
          'FROM ' + SQLManager.GetTableName(sZLEZLECENIEPOZ) + ' ZP1 ' +
          'WHERE ';

  {Analiza sownikw kryterium}
  sLista := '';
  if Pos(',', sListaMnem) > 0 then begin
     oSplit:= TSplit.Create(sListaMnem, ',', '');
     try
        for i := 0 to oSplit.Count - 1 do begin
          if (Trim(oSplit.Items[i]) = 'ZLE') or (Trim(oSplit.Items[i]) = 'ODZ') then begin
             {Sownik zlece lub sownik oddziaw - czyli nic nie dokadamy}
             Continue;
          end;

          {if i > 0 then sLista := sLista + ', ';
          sLista := sLista + QuotedStr(Trim(oSplit.Items[i]));}
          if not bPierwszy then sSQL := sSQL + ' AND ';
          if bPierwszy then bPierwszy := False;

          if Trim(oSplit.Items[i]) = sMnem then begin
              sSQL := sSQL + #13 +
                'EXISTS (SELECT ZLP.' + sZLEZLECENIEPOZ_ID + ' ' +
                        'FROM ' + SQLManager.GetTableName(sZLEZLECENIEPOZ) + ' ZLP ' +
                        'WHERE ZLP.' + sZLEZLECENIEPOZ_POZIOMINF + ' = ' + IntToStr(iIdx) + ' AND ' +
                              'ZLP.' + sZLEZLECENIEPOZ_ID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ') ';
          end else begin
              sSQL := sSQL +
                 ' EXISTS (SELECT ZLP.' + sZLEZLECENIEPOZ_ID + ' ' +
                          'FROM ' + SQLManager.GetTableName(sZLEZLECENIEPOZ) + ' ZLP, ' +
                                    SQLManager.GetTableName(sZLEZLECENIE) + ' ZZ, ' +
                                    SQLManager.GetTableName(sZLEPOLAZM) + ' ZM, ' +
                                    SQLManager.GetTableName(sZLEPOLAZMDEF) + ' ZD, ' +
                                    SQLManager.GetTableName(sFKMNEMONIKI) + ' FK, ' +
                                    SQLManager.GetTableName(sZLEPOLAZMWSK) + ' ZW, ' +
                                    SQLManager.GetTableName(sZLETYPZLEC) + ' ZT ' +
                          'WHERE (ZLP.' + sZLEZLECENIE_ID + ' = ZZ.' + sZLEZLECENIE_ID + ') AND ' +
                                 'ZT.' + sZLETYPZLEC_ID + ' = ZZ.' + sZLETYPZLEC_ID + ' AND ' +
                                 '( ((ZZ.' + sZLEZLECENIE_ID + ' = ZM.' + sZLEZLECENIE_ID + ') AND ' +
                                    '(ZW.' + sZLEPOLAZMWSK_POZYCJA + ' = ' + QuotedStr('N') + ')) OR ' +
                                   '((ZLP.' + sZLEZLECENIEPOZ_ID + ' = ZM.' + sZLEZLECENIEPOZ_ID + ') AND ' +
                                    '(ZW.' + sZLEPOLAZMWSK_POZYCJA + ' = ' + QuotedStr('T') + ')) ) AND ' +
                                 'ZD.' + sZLEPOLAZMDEF_ID + ' = ZM.' + sZLEPOLAZMDEF_ID + ' AND ' +
                                 'ZW.' + sZLEPOLAZMDEF_ID + ' = ZD.' + sZLEPOLAZMDEF_ID + ' AND ' +
                                 'ZW.' + sZLETYPZLEC_ID + ' = ZT.' + sZLETYPZLEC_ID  + ' AND ' +
                                 'ZLP.' + sZLEZLECENIEPOZ_ID + ' = ZP1.' + sZLEZLECENIEPOZ_ID + ' AND ' +
                                 'ZD.' + sFKMNEMONIKI_ID + ' = FK.' + sFKMNEMONIKI_ID + ' AND ' +
                                 'FK.' + sFKMNEMONIKI_MNEMONIK + ' = ' + QuotedStr(Trim(oSplit.Items[i])) + ') ';
          end;
        end;
     finally
        oSplit.Free;
     end;
  end;

   //sSQL := sSQL + ')';
   result := sSQL;
end;
********************************)
function TZLEDataManager.ZleDajKrytWartoscPracy(iKryteria_ID, iUNIOKRES_ID: Integer; bNarzut: Boolean): Extended;
var
  q: TUNIQuery;
  sOkresWhere, sTmp, sTmp2: String;
begin
  sOkresWhere := '';
  if iUNIOKRES_ID <> 0 then
    sOkresWhere := ' AND ' + sUNIOKRES_ID + '=' + IntToStr(iUNIOKRES_ID);

  if ZLEDM.vZLEFormatGodzinLiczba then
    sTmp2 := ',0))'
  else sTmp2 := ',0)/60)';

  try
    sTmp := 'SELECT SUM(';
    sTmp := sTmp + '(' + SQLManager.GetSPName('ZAOKRAGLIJ') + '((NVL(' + sZLEZASOBYPRACA_CZAS_PRACY + sTmp2 + ' * NVL(' + sZLEZASOBYPRACA_STAWKA + ',0),2))';

    if ZLEDM.vZLENarzuty and bNarzut then begin
       sTmp := sTmp + ' * ' + SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuRob') + '(' + sZLEZLECENIEPOZ_ID + ', ' + sUNIOKRES_ID + ')';
    end;

    sTmp := sTmp + ') ';

    q := SQLManager.CreateQuery( sTmp +
      {'SELECT SUM(' + SQLManager.GetSPName('ZAOKRAGLIJ') + '((NVL(' + sZLEOSOBYGODZ_ILOSC + ',0)/60) * NVL(' + sZLEOSOBYGODZ_CENA + ',0),2))' +}
      ' FROM ' + SQLManager.GetTableName(sZLEZASOBYPRACA) +
      ' WHERE ' +
      sZLEZLECENIEPOZ_ID + ' IN (' + sWarPoz {sTmp} + ')' + sOkresWhere
    );
    q.Open;
    Result := Zaokraglij(q.Fields[0].AsFloat, 2);;
  finally
    if q <> Nil then FreeAndNil(q);
  end;
end;


function TZLEDataManager.ZleDajKrytWartoscMat(iKryteria_ID, iUNIOKRES_ID: Integer; bNarzut: Boolean): Extended;
var
  q: TUNIQuery;
  sOkresWhere, sTmp: String;
begin
  sOkresWhere := '';

  if iUNIOKRES_ID <> 0 then
    sOkresWhere := ' AND ' + sUNIOKRES_ID + '=' + IntToStr(iUNIOKRES_ID);

  try

    sTmp := 'SELECT SUM(';
    sTmp := sTmp + '(' +
                 SQLmanager.GetTableName('IIF_NUMBER') + '(' + SQLManager.GetTableName('IIF_NUMBER_TO_BOOLEAN') + '(MGTD.' + sMAGTYPDOK_PRZYCHROZCH + ', -1, ' + QuotedStr('=') + '), OBRPOZ.' + sMAGOBRPOZ_WARTOSC + ', 0) * OBRPOZ.' + sMAGOBRPOZ_ZNAK + '- ' +
                 SQLmanager.GetTableName('IIF_NUMBER') + '(' + SQLmanager.GetTableName('IIF_NUMBER_TO_BOOLEAN') + '(MGTD.' + sMAGTYPDOK_PRZYCHROZCH + ', 1, ' + QuotedStr('=') + '), OBRPOZ.' + sMAGOBRPOZ_WARTOSC + ', 0) * OBRPOZ.' + sMAGOBRPOZ_ZNAK + ')';

    if ZLEDM.vZLENarzuty and bNarzut then begin
       sTmp := sTmp + ' * ' + SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuMat') + '(' + 'OBRPOZ.' + sZLEZLECENIEPOZ_ID + ', ' + 'OBR.' + sUNIOKRES_ID + ')';
    end;

    sTmp := sTmp + ') AS RAZEM ';

    q := SQLManager.CreateQuery( sTmp +
      {'SELECT SUM(' + SQLmanager.GetTableName('IIF_NUMBER') + '(' + SQLManager.GetTableName('IIF_NUMBER_TO_BOOLEAN') + '(MGTD.' + sMAGTYPDOK_PRZYCHROZCH + ', -1, ' + QuotedStr('=') + '), OBRPOZ.' + sMAGOBRPOZ_WARTOSC + ', 0) * OBRPOZ.' + sMAGOBRPOZ_ZNAK + '- ' +
                      SQLmanager.GetTableName('IIF_NUMBER') + '(' + SQLmanager.GetTableName('IIF_NUMBER_TO_BOOLEAN') + '(MGTD.' + sMAGTYPDOK_PRZYCHROZCH + ', 1, ' + QuotedStr('=') + '), OBRPOZ.' + sMAGOBRPOZ_WARTOSC + ', 0) * OBRPOZ.' + sMAGOBRPOZ_ZNAK + ') AS RAZEM ' +}
      'FROM ' + SQLManager.GetTableName(sMAG_OBR) + ' OBR, ' + SQLmanager.GetTableName(sMAG_OBRPOZ) + ' OBRPOZ, ' + SQLmanager.GetTableName(sMAGTYPDOK) + ' MGTD ' +
      'WHERE OBR.' + sMAGTYPDOK_ID + ' = MGTD.' + sMAGTYPDOK_ID + ' and OBR.' + sMAGOBR_ID + ' = OBRPOZ.' + sMAGOBR_ID + ' and ' +
            'OBRPOZ.' + sZLEZLECENIEPOZ_ID + ' IN (' + sWarPoz {sTmp} + ')' + sOkresWhere
    );
    q.Open;
    Result := Zaokraglij(q.Fields[0].AsFloat, 2);
  finally
    if q <> Nil then FreeAndNil(q);
  end;
end;

function TZLEDataManager.ZleDajKrytIloscPracy(iKryteria_ID, iUNIOKRES_ID: Integer; bNarzut: Boolean): Extended;
var
  q: TUNIQuery;
  sOkresWhere, sTmp, sTmp2: String;
begin
  sOkresWhere := '';
  if iUNIOKRES_ID <> 0 then
    sOkresWhere := ' AND ' + sUNIOKRES_ID + '=' + IntToStr(iUNIOKRES_ID);

  if ZLEDM.vZLEFormatGodzinLiczba then
    sTmp2 := ',0))'
  else sTmp2 := ',0)/60)';

  try
    sTmp := 'SELECT SUM(';
    sTmp := sTmp + '(' + SQLManager.GetSPName('ZAOKRAGLIJ') + '((NVL(' + sZLEZASOBYPRACA_CZAS_PRACY + sTmp2 + ' ,2))';

    if ZLEDM.vZLENarzuty and bNarzut then begin
       sTmp := sTmp + ' * ' + SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuRob') + '(' + sZLEZLECENIEPOZ_ID + ', ' + sUNIOKRES_ID + ')';
    end;

    sTmp := sTmp + ') ';

    q := SQLManager.CreateQuery( sTmp +
      {'SELECT SUM(' + SQLManager.GetSPName('ZAOKRAGLIJ') + '((NVL(' + sZLEOSOBYGODZ_ILOSC + ',0)/60) * NVL(' + sZLEOSOBYGODZ_CENA + ',0),2))' +}
      ' FROM ' + SQLManager.GetTableName(sZLEZASOBYPRACA) +
      ' WHERE ' +
      sZLEZLECENIEPOZ_ID + ' IN (' + sWarPoz {sTmp} + ')' + sOkresWhere
    );
    q.Open;
    Result := Zaokraglij(q.Fields[0].AsFloat, 2);;
  finally
    if q <> Nil then FreeAndNil(q);
  end;
end;
(********************************************************
function TZLEDataManager.ZleDajKrytWspPracy(iKryteria_ID, iUNIOKRES_ID: Integer): Extended;
var
  q: TUNIQuery;
  sOkresWhere: String;
begin
  Result := 1;
  sOkresWhere := '';
  if iUNIOKRES_ID <> 0 then
    sOkresWhere := ' AND ' + sUNIOKRES_ID + '=' + IntToStr(iUNIOKRES_ID);

  try
    q := SQLManager.CreateQuery(
            'SELECT ZN.' + sZLEWSPNARZUTY_ROB + ' ' +
            'FROM %s ZN ' +
            'WHERE ZN.' + sZLETYPZLEC_ID + ' = (SELECT ZK.' + sZLETYPZLEC_ID + ' ' +
                                               'FROM %s ZK ' +
                                               'WHERE ZK.' + sZLEKRYTERIA_ID + ' = ' + IntToStr(iKryteria_ID) + ') ' +
                   sOkresWhere,
             [sZLEWSPNARZUTY, sZLEKRYTERIA]
      //sZLEZLECENIEPOZ_ID + ' IN (' + sWarPoz {sTmp} + ')' + sOkresWhere
            );
    q.Open;
    Result := q.Fields[0].AsFloat;
  finally
    if q <> Nil then FreeAndNil(q);
  end;
end;

function TZLEDataManager.ZleDajKrytWspMat(iKryteria_ID, iUNIOKRES_ID: Integer): Extended;
var
  q: TUNIQuery;
  sOkresWhere, sTmp: String;
begin
  Result := 1;
  sOkresWhere := '';
  if iUNIOKRES_ID <> 0 then
    sOkresWhere := ' AND ' + sUNIOKRES_ID + '=' + IntToStr(iUNIOKRES_ID);

  try
    q := SQLManager.CreateQuery(
            'SELECT ZN.' + sZLEWSPNARZUTY_MAT + ' ' +
            'FROM %s ZN ' +
            'WHERE ZN.' + sZLETYPZLEC_ID + ' = (SELECT ZK.' + sZLETYPZLEC_ID + ' ' +
                                               'FROM %s ZK ' +
                                               'WHERE ZK.' + sZLEKRYTERIA_ID + ' = ' + IntToStr(iKryteria_ID) + ') ' +
                   sOkresWhere,
             [sZLEWSPNARZUTY, sZLEKRYTERIA]
             //sZLEZLECENIEPOZ_ID + ' IN (' + sWarPoz {sTmp} + ')' + sOkresWhere
            );
    q.Open;
    Result := q.Fields[0].AsFloat;
  finally
    if q <> Nil then FreeAndNil(q);
  end;
end;
********************************************************)
{$endif}

function TZLEDataManager.ZleDajWartoscRozliczenia(iZLECENIE_ID, iUNIOKRES_ID: Integer): Extended;
var
  q: TUNIQuery;
  sOkresWhere, sWhere: String;
begin
  sOkresWhere := '';
  sWhere := ' AND ' + sZLECONST_RODZAJECP_ID + ' = ' +  QuotedStr(cZLERodzajECP_RozliczID);
  {if iUNIOKRES_ID <> 0 then
    sOkresWhere := ' AND ' + sUNIOKRES_ID + '=' + IntToStr(iUNIOKRES_ID);}
  try
    q := SQLManager.CreateQuery(
      'SELECT SUM(' + SQLManager.GetSPName('ZAOKRAGLIJ') + '(NVL(' + sZLEZASOBYPRACA_CZAS_PRACY + ',0) * NVL(' + sZLEZASOBYPRACA_STAWKA + ',0),2))' +
      ' FROM ' + SQLManager.GetTableName(sZLEZASOBYPRACA) +
      ' WHERE ' +
          sZLEZLECENIEPOZ_ID + ' IN (SELECT ' + sZLEZLECENIEPOZ_ID +
                               ' FROM ' + SQLManager.GetTableName(sZLEZLECENIEPOZ) +
                               ' WHERE ' + sZLEZLECENIE_ID + '=' + IntToStr(iZLECENIE_ID) + ')'
          + sWhere{ +sOkresWhere}
    );
    q.Open;
    Result := q.Fields[0].AsFloat;
  finally
    if q <> Nil then FreeAndNil(q);
  end;
end;

function TZLEDataManager.ZleDajIloscPaliwa(iZLECENIE_ID, iUNIOKRES_ID: Integer): Extended;
var
  q: TUNIQuery;
  sOkresWhere, sWhere: String;
begin
  sOkresWhere := '';
  sWhere := ' AND (ZP.' + sZLECONST_RODZAJECP_ID + '=' + QuotedStr(cZLERodzajECP_RozliczID)+')';
{  if iUNIOKRES_ID <> 0 then
    sOkresWhere := ' AND ' + sUNIOKRES_ID + '=' + IntToStr(iUNIOKRES_ID);}
  try
    q := SQLManager.CreateQuery(
      'SELECT SUM(ZP.' + sZLEZASOBYPRACA_ZUZ_PALIWA + ')' +
      ' FROM ' + SQLManager.GetTableName(sZLEZASOBYPRACA) + ' ZP '+
      ' WHERE ' +
          'ZP.' + sZLEZLECENIE_ID + '=' + IntToStr(iZLECENIE_ID) 
          + sWhere {+sOkresWhere}
    );
    q.Open;
    Result := q.Fields[0].AsFloat;
  finally
    if q <> Nil then FreeAndNil(q);
  end;
end;

function TZLEDataManager.ZleDajIloscPracy(iZLECENIE_ID, iUNIOKRES_ID: Integer;
                                           RODZAJECP: string = '';
                                           RODZAJZASOBU: string =''): Extended;
var
  q: TUNIQuery;
  sOkresWhere: String;
begin
  sOkresWhere := '';
  if RODZAJECP <> '' then
       sOkresWhere := ' AND (ZP.' + sZLECONST_RODZAJECP_ID + ' IN (' + RODZAJECP + '))'
  else sOkresWhere := ' AND (ZP.' + sZLECONST_RODZAJECP_ID + '<>' + QuotedStr(cZLERodzajECP_ProdukcjaID)+')';  //Dla produkcji brak stawki!
  if RODZAJZASOBU <> '' then
     sOkresWhere := ' AND (ZS.' + sZLEZASOB_RODZAJ + ' IN (' + RODZAJZASOBU + '))';

  if iUNIOKRES_ID <> 0 then
    sOkresWhere := ' AND ' + sUNIOKRES_ID + '=' + IntToStr(iUNIOKRES_ID);
  try
    q := SQLManager.CreateQuery(
      'SELECT SUM(' + sZLEZASOBYPRACA_IL_PRACY + ')' +
      ' FROM ' + SQLManager.GetTableName(sZLEZASOBYPRACA) + ' ZP, ' +
                 SQLManager.GetTableName(sZLEZASOB) + ' ZS ' +
      ' WHERE ' +
               'ZP.' + sZLEZASOB_ID + ' = ZS.' + sZLEZASOB_ID + '(+) ' +
          ' AND ZP.' + sZLEZLECENIE_ID + '=' + IntToStr(iZLECENIE_ID) +
          sOkresWhere
    );
    q.Open;
    Result := q.Fields[0].AsFloat;
  finally
    if q <> Nil then FreeAndNil(q);
  end;
end;

function TZLEDataManager.ZleDajIloscGodzin(iZLECENIE_ID, iUNIOKRES_ID: Integer;
                                           RODZAJECP: string = '';
                                           RODZAJZASOBU: string =''): Extended;
var
  q: TUNIQuery;
  sOkresWhere, sSQL: String;
begin
  sOkresWhere := '';
  if RODZAJECP <> '' then
       sOkresWhere := ' AND (ZP.' + sZLECONST_RODZAJECP_ID + ' IN (' + RODZAJECP + '))'
  else sOkresWhere := ' AND (ZP.' + sZLECONST_RODZAJECP_ID + '<>' + QuotedStr(cZLERodzajECP_ProdukcjaID)+')';  //Dla produkcji brak stawki!
  if RODZAJZASOBU <> '' then
     sOkresWhere := ' AND (ZS.' + sZLEZASOB_RODZAJ + ' IN (' + RODZAJZASOBU + '))';
  if iUNIOKRES_ID <> 0 then
    sOkresWhere := sOkresWhere + ' AND (ZP.' + sUNIOKRES_ID + '=' + IntToStr(iUNIOKRES_ID)+')';

  sSQL := 'SELECT SUM(' + sZLEZASOBYPRACA_CZAS_PRACY;

  if ZLEDM.vZLEFormatGodzinLiczba then
    sSQL := sSQL + ')'
  else sSQL := sSQL + '/60)';

  sSQL := sSQL  +
      ' FROM ' + SQLManager.GetTableName(sZLEZASOBYPRACA) + ' ZP, ' +
                 SQLManager.GetTableName(sZLEZASOB) + ' ZS ' +
      ' WHERE ' +
               'ZP.' + sZLEZASOB_ID + ' = ZS.' + sZLEZASOB_ID + '(+) ' +
           'AND ZP.' + sZLEZLECENIE_ID + '=' + IntToStr(iZLECENIE_ID)
           + sOkresWhere;

  try
    q := SQLManager.CreateQuery(sSQL);
    q.Open;
    Result := q.Fields[0].AsFloat;
  finally
    if q <> Nil then FreeAndNil(q);
  end;
end;

function TZLEDataManager.ZLEDajKosztyZleceniaSzczegolowoSuma(iZLECENIE_ID, iUNIOKRES_ID: Integer;
                                                             a_oParams: TKeyValues  = nil): Extended;
var
  i: integer;
  sRokSymbol: string;
  q: TUNIQuery;
  sSQL, sTmp, sTypDokSpecWhere, sOkresWhereRob, sOkresWhereMat: string;
  bKosztyZlecAll,      bKosztyZlecAllNarzut,
  bKosztyZlecenie_Rob, bKosztyZlecenie_RobNarzut,
  bKosztyZlecenie_Mat, bKosztyZlecenie_MatNarzut: Boolean;
  sListaPozycji: String;
  sPozWhereRob, sPozWhereMat: String;
begin
  Result := 0.00;

  {Analiza parametrw}
  if a_oParams <> nil then begin
     bKosztyZlecAll             := (a_oParams.Values[sMFSTypDok_KosztyZlecAll] = sTak);
     bKosztyZlecAllNarzut       := (a_oParams.Values[sMFSTypDok_KosztyZlecAllNarzut] = sTak);
     bKosztyZlecenie_Rob        := (a_oParams.Values[sMFSTypDok_ZLERob] = sTak);
     bKosztyZlecenie_RobNarzut  := (a_oParams.Values[sMFSTypDok_ZLERobNarzut] = sTak);
     bKosztyZlecenie_Mat        := (a_oParams.Values[sMFSTypDok_ZLEMat] = sTak);
     bKosztyZlecenie_MatNarzut  := (a_oParams.Values[sMFSTypDok_ZLEMatNarzut] = sTak);
     sListaPozycji              :=  a_oParams.Values[sZLEZLECENIEPOZ_ID];
  end else begin
    bKosztyZlecAll             := false;
    bKosztyZlecAllNarzut       := false;
    bKosztyZlecenie_Rob        := false;
    bKosztyZlecenie_RobNarzut  := false;
    bKosztyZlecenie_Mat        := false;
    bKosztyZlecenie_MatNarzut  := false;
    sListaPozycji              := '';
  end;

  if not (bKosztyZlecAll or
          bKosztyZlecAllNarzut or
          bKosztyZlecenie_Rob or
          bKosztyZlecenie_RobNarzut or
          bKosztyZlecenie_Mat or
          bKosztyZlecenie_MatNarzut) then begin
     {Nie chcesz adnych kosztw - result = 0.00}
     Exit;
  end;

  if bKosztyZlecAll and not (bKosztyZlecenie_Rob or
                             bKosztyZlecenie_RobNarzut or
                             bKosztyZlecenie_Mat or
                             bKosztyZlecenie_MatNarzut) then begin
     if bKosztyZlecAllNarzut then begin
        bKosztyZlecenie_Rob        := True;
        bKosztyZlecenie_RobNarzut  := True;
        bKosztyZlecenie_Mat        := True;
        bKosztyZlecenie_MatNarzut  := True;
     end else begin
        bKosztyZlecenie_Rob        := True;
        bKosztyZlecenie_RobNarzut  := False;
        bKosztyZlecenie_Mat        := True;
        bKosztyZlecenie_MatNarzut  := False;
     end;
  end;

  sTmp := '';
  if ZLEDM.vZLEFormatGodzinLiczba then
     sTmp := ',0)) AS '
  else sTmp := ',0)/60) AS ';

  if iUNIOKRES_ID > 0 then begin
    sOkresWhereMat := ' AND (OBR.'+sUNIOKRES_ID+'='+IntToStr(iUNIOKRES_ID)+')';
    sOkresWhereRob := ' AND (OSOBYGODZ.' + sUNIOKRES_ID + ' = ' + IntToStr(iUNIOKRES_ID) + ')';
    i := UNISysDM.UNIPodajSymbolRokuDlaIDOkresu(sRokSymbol, iUNIOKRES_ID);
    if i <> 0 then Raise Exception.Create('Nie znaleziono definicji roku dla podanego okresu');
  end else begin
    sOkresWhereRob := '';
    sOkresWhereMat := '';
  end;
  sTypDokSpecWhere := ' AND (MGTD.'+sMAGTYPDOK_SPEC+' IN ('+ QuotedStr(cMAGTypDokSpec_ZwyklyID)+'))';

  sPozWhereRob := '';
  sPozWhereMat := '';
  if sListaPozycji <> '' then begin
     sPozWhereRob := ' AND (OSOBYGODZ.' + sZLEZLECENIEPOZ_ID + ' IN (' + sListaPozycji + '))';
     sPozWhereMat := ' AND (OBRPOZ.' + sZLEZLECENIEPOZ_ID + ' IN (' + sListaPozycji + '))';
  end;

  sSQL := 'SELECT SUM(' + sZLESZCZEGOLY_WARTOSC + ') AS ' + sZLESZCZEGOLY_WARTOSC + ' ' +
          'FROM ('+
          '  SELECT ';

  {Koszty materiaowe}
  if bKosztyZlecenie_Mat or bKosztyZlecenie_MatNarzut then begin
      if ZLEDM.vZLENarzuty and bKosztyZlecenie_MatNarzut then begin
         {koszty materiaowe z narzutami}
         sSQL := sSQL + SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuMat') + '(OBRPOZ.' + sZLEZLECENIEPOZ_ID + ', OBR.' + sUNIOKRES_ID + ') * OBRPOZ.' + sMAGOBRPOZ_WARTOSC + ' AS ' + sZLESZCZEGOLY_WARTOSC + ' ';
      end else begin
         sSQL := sSQL + ' OBRPOZ.' + sMAGOBRPOZ_WARTOSC + ' AS ' + sZLESZCZEGOLY_WARTOSC + ' ';
      end;

      sSQL := sSQL +
              '  FROM %s OBR, %s OBRPOZ, %s MGTD ' +
              '  WHERE '+
                   'OBR.' + sMAGTYPDOK_ID + ' = MGTD.' + sMAGTYPDOK_ID + ' AND ' +
                   'OBR.' + sMAGOBR_ID + ' = OBRPOZ.' + sMAGOBR_ID + ' AND ' +
                   'OBRPOZ.' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZLECENIE_ID) +
                   sTypDokSpecWhere +
                   sPozWhereMat +
                   sOkresWhereMat;

      if bKosztyZlecenie_Rob or bKosztyZlecenie_RobNarzut then begin
          sSQL := sSQL +
                  '  UNION ALL ' +
                  '  SELECT ';
      end;
  end;

  if bKosztyZlecenie_Rob or bKosztyZlecenie_RobNarzut then begin
      if ZLEDM.vZLENarzuty and bKosztyZlecenie_RobNarzut then begin
         {Robocizna z narzutami}
         sSQL := sSQL + SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuRob') + '(OSOBYGODZ.' + sZLEZLECENIEPOZ_ID + ', OSOBYGODZ.' + sUNIOKRES_ID + ') * (NVL(OSOBYGODZ.' + sZLEZASOBYPRACA_STAWKA + ' * OSOBYGODZ.' + sZLEZASOBYPRACA_CZAS_PRACY + sTmp + sZLESZCZEGOLY_WARTOSC + ' ';
      end else begin
         sSQL := sSQL + '(NVL(OSOBYGODZ.' + sZLEZASOBYPRACA_STAWKA + ' * OSOBYGODZ.' + sZLEZASOBYPRACA_CZAS_PRACY + sTmp + sZLESZCZEGOLY_WARTOSC + ' ';
      end;

      sSQL := sSQL +
              '  FROM %s OSOBYGODZ ' +
              '  WHERE ' +
                   'OSOBYGODZ.' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZLECENIE_ID) +
                   ' AND (OSOBYGODZ.' + sZLECONST_RODZAJECP_ID + ' <> ' + QuotedStr(cZLERodzajECP_ProdukcjaID) + ') ' +
                   sPozWhereRob +
                   sOkresWhereRob;
  end;

  sSQL := sSQL + ')';

  if (bKosztyZlecenie_Mat or bKosztyZlecenie_MatNarzut) and (bKosztyZlecenie_Rob or bKosztyZlecenie_RobNarzut) then begin
     q := SQLManager.CreateQuery(sSQL, [sMAG_OBR, sMAG_OBRPOZ, sMAGTYPDOK, sZLEZASOBYPRACA]);
  end else if bKosztyZlecenie_Mat or bKosztyZlecenie_MatNarzut then begin
     q := SQLManager.CreateQuery(sSQL, [sMAG_OBR, sMAG_OBRPOZ, sMAGTYPDOK]);
  end else if (bKosztyZlecenie_Rob or bKosztyZlecenie_RobNarzut) then begin
     q := SQLManager.CreateQuery(sSQL, [sZLEZASOBYPRACA]);
  end;

  try
    q.Open;
    if not q.IsEmpty then
       Result := q.FieldByName(sZLESZCZEGOLY_WARTOSC).AsFloat;
  finally
    if q <> nil then FreeAndNil(q);
  end;


(***********************************************************************************************
SELECT Sum(ZLESzczegolyWartosc), Sum(ZLESzczegolyWartosc_Narzut)
from

(select
   OBRPOZ.MAGOBRPOZ_WARTOSC as ZLESzczegolyWartosc,
   ZYR.ZLE_PACKAGE.ZLEWspNarzutuMat(OBRPOZ.ZLEZLECENIEPOZ_ID, OBR.UNIOKRES_ID) * OBRPOZ.MAGOBRPOZ_WARTOSC as ZLESzczegolyWartosc_Narzut
from
   ZYR.MAG20080OBR OBR,
   ZYR.MAG20080OBRPOZ OBRPOZ,
   ZYR.MAGTYPDOK MGTD
where
   OBR.MAGTYPDOK_ID=MGTD.MAGTYPDOK_ID
   and OBR.MAGOBR_ID=OBRPOZ.MAGOBR_ID
   and (OBRPOZ.ZLEZLECENIE_ID=161)
   AND(MGTD.MAGTYPDOK_SPEC in ('ZW'))
   AND(OBR.UNIOKRES_ID=126)
UNION ALL
select
   (NVL(OSOBYGODZ.ZLEOSOBYGODZ_CENA * OSOBYGODZ.ZLEOSOBYGODZ_ILOSC,0)/60) AS ZLESzczegolyWartosc,
   ZYR.ZLE_PACKAGE.ZLEWspNarzutuRob(OSOBYGODZ.ZLEZLECENIEPOZ_ID, OSOBYGODZ.UNIOKRES_ID) * (NVL(OSOBYGODZ.ZLEOSOBYGODZ_CENA * OSOBYGODZ.ZLEOSOBYGODZ_ILOSC,0)/60) as ZLESzczegolyWartosc_Narzut
from
   ZYR.ZLEOSOBYGODZ OSOBYGODZ
where
   (OSOBYGODZ.ZLEZLECENIE_ID=161)
   AND(OSOBYGODZ.UNIOKRES_ID=126))
************************************************************************************************)


  (***************************************************************
  sTmp := '';

  if iUNIOKRES_ID > 0 then begin
    sOkresWhereMat  := 'AND(@'+sMAGALIAS_MAGOBR_OKRES_ID+'='+IntToStr(iUNIOKRES_ID)+')';
    sOkresWhereRob  := 'AND(@'+sZLEALIAS_OSOBYGODZ_OKRES_ID+'='+IntToStr(iUNIOKRES_ID)+')';
    sOkresWhereRob2 := ' AND (OSOBYGODZ.' + sUNIOKRES_ID + ' = ' + IntToStr(iUNIOKRES_ID) + ')';
    i := UNISysDM.UNIPodajSymbolRokuDlaIDOkresu(sRokSymbol, iUNIOKRES_ID);
    if i <> 0 then Raise Exception.Create('Nie znaleziono definicji roku dla podanego okresu');
  end else begin
    sOkresWhereRob := '';
    sOkresWhereMat := '';
  end;
  sTypDokSpecWhere := 'AND(@'+sMAGALIAS_MAGTYPDOK_SPEC+' in ('+ QuotedStr(cMAGTypDokSpec_ZwyklyID)+'))';

  sSQL := '';

  case aRodzajKosztow of
    rkMaterialy: begin
      sText := '#ROWNUM;'+
               '#@'+sMAGALIAS_MAGOBR_DATA_DOK+' as '+sZLESZCZEGOLY_DATA+';'+
               '#@'+sMAGALIAS_MAGOBRPOZ_ZLECENIE_ID+';'+
               '#@'+sMAGALIAS_MAGOBR_OKRES_ID+';'+
               '#@'+sMAGALIAS_MAGOBRPOZ_ASORT_ID+';'+
               '#@'+sMAGALIAS_ZLECENIEPOZ_LP+';'+
               '#@'+sMAGALIAS_ASORT_SYMBOL+';'+
               '#@'+sMAGALIAS_ASORT_NAZWA+';'+
               '#@'+sMAGALIAS_ASORT2_NAZWA + ' AS ZLECENIEPOZ_ASORT_NAZWA'+';'+
               '#@'+sMAGALIAS_ASORT2_SYMBOL + ' AS ZLECENIEPOZ_ASORT_SYMBOL'+';'+
               '#@'+sMAGALIAS_JM_SYMBOL+';';


       if DataManagers.Available(sBOKModulID) then begin
         sText := sText +
               '#@'+sMAGALIAS_BOKSPRAWA_NUMER+';'+
               '#@'+sMAGALIAS_BOKSPRAWA_OPIS+';';
       end;

       sText := sText +
               '#@'+sMAGALIAS_MAGAZYN_SYMBOL+';'+
               '#@'+sMAGALIAS_MAGTYPDOK_SYMBOL+';'+
               '#@'+sMAGALIAS_MAGOBR_NUMER+';'+
               '#@'+sMAGALIAS_MAGOBRPOZ_LP+';';

      if DataManagers.Available(sINFModulID) then begin
         sText := sText + '#@'+sMAGALIAS_OBIEKTINF_NAZWA+';'+
                          '#CAST('+SQLManager.GetSPName(sINF_DAJSYMBOLOBIEKTU)+'('+
                          sMAGALIAS_ZLECENIEPOZ+'.'+sZLEZLECENIEPOZ_POZIOMINF+','+
                          sMAGALIAS_ZLECENIEPOZ+'.'+sZLEZLECENIEPOZ_INF_ID+') AS VARCHAR(50)) AS OBIEKT_SYMBOL'+';';
       end;

       {TAK BYO - 2007-04-02}
      { sText := sText + '#CASE @'+sMAGALIAS_MAGOBRPOZ_ZNAK+' WHEN -1 THEN ''-'' WHEN 1 THEN ''+'' END as '+sMAGOBRPOZ_ZNAK+';'+
                        '#@'+sMAGALIAS_MAGOBRPOZ_CENA+' as '+sZLESZCZEGOLY_CENA+';'+
                        '#@'+sMAGALIAS_MAGOBRPOZ_ILOSC+' as '+sZLESZCZEGOLY_ILOSC+';'+
                        '#@'+sMAGALIAS_MAGOBRPOZ_WARTOSC+' as '+sZLESZCZEGOLY_WARTOSC;}

      sFieldValueNaPlus      :='-1';
      sFieldValueNaMinus     :='1';

      sText := sText + '#CASE @'+sMAGALIAS_MAGOBRPOZ_ZNAK+' WHEN -1 THEN ''-'' WHEN 1 THEN ''+'' END as '+sMAGOBRPOZ_ZNAK+';';

      sText := sText + '#@'+sMAGALIAS_MAGOBRPOZ_CENA+' as '+sZLESZCZEGOLY_CENA+';';
      sText := sText + '#' + SQLManager.GetSPName( 'IIF_NUMBER')+'('+
                             SQLManager.GetSPName( 'IIF_NUMBER_TO_BOOLEAN')+'(@'+
                                 sMAGALIAS_MAGTYPDOK_PRZYCHROZCH+',-1,'+QuotedStr('=')+'),@'+
                                 sMAGALIAS_MAGOBRPOZ_WARTOSC+',0)*@'+sMAGALIAS_MAGOBRPOZ_ZNAK+' AS PRZYCHOD;';

      sText := sText + '#' + SQLManager.GetSPName( 'IIF_NUMBER')+'('+
                             SQLManager.GetSPName( 'IIF_NUMBER_TO_BOOLEAN')+'(@'+
                                 sMAGALIAS_MAGTYPDOK_PRZYCHROZCH+',1,'+QuotedStr('=')+'),@'+
                                 sMAGALIAS_MAGOBRPOZ_WARTOSC+',0)*@'+sMAGALIAS_MAGOBRPOZ_ZNAK+' AS ROZCHOD;';

      sText := sText + '#(' + SQLManager.GetSPName( 'IIF_NUMBER')+'('+
                             SQLManager.GetSPName( 'IIF_NUMBER_TO_BOOLEAN')+'(@'+
                                 sMAGALIAS_MAGTYPDOK_PRZYCHROZCH+',-1,'+QuotedStr('=')+'),@'+
                                 sMAGALIAS_MAGOBRPOZ_WARTOSC+',0)*@'+sMAGALIAS_MAGOBRPOZ_ZNAK+
                        ' - ' +
                             SQLManager.GetSPName( 'IIF_NUMBER')+'('+
                             SQLManager.GetSPName( 'IIF_NUMBER_TO_BOOLEAN')+'(@'+
                                 sMAGALIAS_MAGTYPDOK_PRZYCHROZCH+',1,'+QuotedStr('=')+'),@'+
                                 sMAGALIAS_MAGOBRPOZ_WARTOSC+',0)*@'+sMAGALIAS_MAGOBRPOZ_ZNAK+') AS SALDO;';

      sText := sText + '#' + SQLManager.GetSPName( 'IIF_NUMBER')+'('+
                             SQLManager.GetSPName( 'IIF_NUMBER_TO_BOOLEAN')+'(@'+
                                 sMAGALIAS_MAGTYPDOK_PRZYCHROZCH+',-1,'+QuotedStr('=')+'),@'+
                                 sMAGALIAS_MAGOBRPOZ_ILOSC+',0)*@'+sMAGALIAS_MAGOBRPOZ_ZNAK+' AS PRZYCHOD_IL;';

      sText := sText + '#' + SQLManager.GetSPName( 'IIF_NUMBER')+'('+
                             SQLManager.GetSPName( 'IIF_NUMBER_TO_BOOLEAN')+'(@'+
                                 sMAGALIAS_MAGTYPDOK_PRZYCHROZCH+',1,'+QuotedStr('=')+'),@'+
                                 sMAGALIAS_MAGOBRPOZ_ILOSC+',0)*@'+sMAGALIAS_MAGOBRPOZ_ZNAK+' AS ROZCHOD_IL;';

      sText := sText + '#(' + SQLManager.GetSPName( 'IIF_NUMBER')+'('+
                             SQLManager.GetSPName( 'IIF_NUMBER_TO_BOOLEAN')+'(@'+
                                 sMAGALIAS_MAGTYPDOK_PRZYCHROZCH+',-1,'+QuotedStr('=')+'),@'+
                                 sMAGALIAS_MAGOBRPOZ_ILOSC+',0)*@'+sMAGALIAS_MAGOBRPOZ_ZNAK+
                        ' - ' +
                             SQLManager.GetSPName( 'IIF_NUMBER')+'('+
                             SQLManager.GetSPName( 'IIF_NUMBER_TO_BOOLEAN')+'(@'+
                                 sMAGALIAS_MAGTYPDOK_PRZYCHROZCH+',1,'+QuotedStr('=')+'),@'+
                                 sMAGALIAS_MAGOBRPOZ_ILOSC+',0)*@'+sMAGALIAS_MAGOBRPOZ_ZNAK+') AS SALDO_IL';

      if ZLEDM.vZLENarzuty then begin
         sText := sText + ';' +
                    '#(' + SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuMat') + '(@' + sMAGALIAS_MAGOBRPOZ_ZLECENIEPOZ_ID + ', @' + sMAGALIAS_MAGOBR_OKRES_ID + ')) AS ZLEWSPNARZUTMAT';

         sText := sText + ';' +
                    '#((' + SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuMat') + '(@' + sMAGALIAS_MAGOBRPOZ_ZLECENIEPOZ_ID + ', @' + sMAGALIAS_MAGOBR_OKRES_ID + ')) * ' +
                        '(' + SQLManager.GetSPName( 'IIF_NUMBER')+'('+
                             SQLManager.GetSPName( 'IIF_NUMBER_TO_BOOLEAN')+'(@'+
                                 sMAGALIAS_MAGTYPDOK_PRZYCHROZCH+',-1,'+QuotedStr('=')+'),@'+
                                 sMAGALIAS_MAGOBRPOZ_WARTOSC+',0)*@'+sMAGALIAS_MAGOBRPOZ_ZNAK+
                        ' - ' +
                             SQLManager.GetSPName( 'IIF_NUMBER')+'('+
                             SQLManager.GetSPName( 'IIF_NUMBER_TO_BOOLEAN')+'(@'+
                                 sMAGALIAS_MAGTYPDOK_PRZYCHROZCH+',1,'+QuotedStr('=')+'),@'+
                                 sMAGALIAS_MAGOBRPOZ_WARTOSC+',0)*@'+sMAGALIAS_MAGOBRPOZ_ZNAK+')) AS SALDO_NARZUTMAT';
      end;
      sSQL := MAGDM.OdpytajODaneSQL( cMAGOBRPOZ, sText,
                                     '(@'+sMAGALIAS_MAGOBRPOZ_ZLECENIE_ID+'='+IntToStr(iZLECENIE_ID)+')'+
                                     sTypDokSpecWhere+sOkresWhereMat,
                                     False, vAktywnaFirma );

    end;

    rkRobocizna: begin
      if ZLEDM.vZLEFormatGodzinLiczba then
           sTmp := ',0)'
      else sTmp := ',0)/60';

     sSQL := 'SELECT OSOBYGODZ.' + sZLEOSOBYGODZ_DATA + ' AS ' + sZLESZCZEGOLY_DATA + ', ' +
                    'OSOBYGODZ.' + sZLEZLECENIE_ID + ', ' +
                    'OSOBYGODZ.' + sZLEOSOBYGODZ_ID + ', ' +
                    'OSOBYGODZ.' + sUNIOKRES_ID + ', ' +
                    'OSOBYGODZ.' + sASOASORT_ID + ', ' +
                    'OSOBYGODZ.' + sZLEZLECENIEPOZ_ID + ', ' +
                    'ZLEPOZ.' + sZLEZLECENIEPOZ_LP + ', ' +
                    'ZLEPOZ.' + sZLEZLECENIEPOZ_OPIS + ', ' +
                    'ZLEPOZ.' + sBOKSPRAWA_ID + ', ' +
                    'ASORT.' + sASOASORT_SYMBOL + ', ' +
                    'ASORT.' + sASOASORT_NAZWA + ', ' +
                    'JM.' + sUNIJM_SYMBOL + ', ' +
                    'OSOBA.' + sKDOSOBA_IMIE + ', ' +
                    'OSOBA.' + sKDOSOBA_NAZWISKO + ', ' +
                    'OSOBYGODZ.' + sZLEZASOB_ID + ', ' +
                    'ZLEZASOB.' + sZLEZASOB_NAZWA + ', ' +
                    'NVL(OSOBYGODZ.' + sZLEOSOBYGODZ_CENA + ',0) AS ' + sZLESZCZEGOLY_CENA + ', ' +
                    'NVL(OSOBYGODZ.' + sZLEOSOBYGODZ_ILOSC + sTmp + ' AS ' + sZLESZCZEGOLY_ILOSC;

     if ZLEDM.vZLENarzuty then begin
        sSQL := sSQL + ', ' +
                    SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuRob') + '(' + 'OSOBYGODZ.' + sZLEZLECENIEPOZ_ID + ', ' + 'OSOBYGODZ.' + sUNIOKRES_ID + ') AS ZLEWSPNARZUTROB';

        sSQL := sSQL + ', ' +
                    SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuRob') + '(' + 'OSOBYGODZ.' + sZLEZLECENIEPOZ_ID + ', ' + 'OSOBYGODZ.' + sUNIOKRES_ID + ') * ' +
                    '(NVL(OSOBYGODZ.' + sZLEOSOBYGODZ_CENA + ' * OSOBYGODZ.' + sZLEOSOBYGODZ_ILOSC + sTmp + ') AS SALDO_NARZUTROB';
     end;

     sSQL := sSQL + ', ' +
                    'NVL(OSOBYGODZ.' + sZLEOSOBYGODZ_CENA + ' * OSOBYGODZ.' + sZLEOSOBYGODZ_ILOSC + sTmp + ' AS ' + sZLESZCZEGOLY_WARTOSC + ' ' +
             'FROM ' + SQLManager.GetTableName(sZLEOSOBYGODZ) + ' OSOBYGODZ, ' +
                       SQLManager.GetTableName(sZLEZLECENIEPOZ) + ' ZLEPOZ, ' +
                       SQLManager.GetTableName(sASOASORT) + ' ASORT, ' +
                       SQLManager.GetTableName(sUNIJM) + ' JM, ' +
                       SQLManager.GetTableName(sKDOSOBA) + ' OSOBA, ' +
                       SQLManager.GetTableName(sZLEZASOB) + ' ZLEZASOB ' +
             'WHERE OSOBYGODZ.' + sASOASORT_ID + ' = ASORT.' + sASOASORT_ID + ' (+) AND ' +
                   'OSOBYGODZ.' + sKDOSOBA_ID + ' = OSOBA.' + sKDOSOBA_ID + ' (+) AND ' +
                   'OSOBYGODZ.' + sZLEZASOB_ID + ' = ZLEZASOB.' + sZLEZASOB_ID + ' (+) AND ' +
                   'OSOBYGODZ.' + sZLEZLECENIEPOZ_ID + ' = ZLEPOZ.' + sZLEZLECENIEPOZ_ID + ' (+) AND ' +
                   'ASORT.' + sUNIJM_ID1 + ' = JM.' + sUNIJM_ID + ' (+) AND ' +
                   '(OSOBYGODZ.' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZLECENIE_ID) + ')' + sOkresWhereRob2;

    end;

    { -------- Dla sprzeday tylko to jest uywane ------- }
    rkWszystkie: begin
      { Tu na razie bez narzutw - wykorzystywane do FV w sprzeday }
      if ZLEDM.vZLEFormatGodzinLiczba then
           sTmp := ',0) as '
      else sTmp := ',0)/60 as ';

      sSQL := MAGDM.OdpytajODaneSQL( sMAG_OBRPOZ,
                                     '#@'+sMAGALIAS_MAGOBR_DATA_DOK+' as '+sZLESZCZEGOLY_DATA+';'+
                                     '#@'+sMAGALIAS_MAGOBRPOZ_ZLECENIE_ID+';'+
                                     '#@'+sMAGALIAS_MAGOBR_OKRES_ID+';'+
                                     '#@'+sMAGALIAS_MAGOBRPOZ_ASORT_ID+';'+
                                     '#@'+sMAGALIAS_ASORT_SYMBOL+';'+
                                     '#@'+sMAGALIAS_ASORT_NAZWA+';'+
                                     '#@'+sMAGALIAS_JM_SYMBOL+';'+
                                     '#@'+sMAGALIAS_MAGAZYN_SYMBOL+';'+
                                     '#@'+sMAGALIAS_MAGTYPDOK_SYMBOL+';'+
                                     '#@'+sMAGALIAS_MAGOBR_NUMER+';'+
                                     '#@'+sMAGALIAS_MAGOBRPOZ_LP+';'+
                                     '#CASE @'+sMAGALIAS_MAGOBRPOZ_ZNAK+' WHEN -1 THEN ''-'' WHEN 1 THEN ''+'' END as '+sMAGOBRPOZ_ZNAK+';'+
                                     '#null as '+sKDOSOBA_IMIE+';'+
                                     '#null as '+sKDOSOBA_NAZWISKO+';'+
                                     '#@'+sMAGALIAS_MAGOBRPOZ_CENA+' as '+sZLESZCZEGOLY_CENA+';'+
                                     '#@'+sMAGALIAS_MAGOBRPOZ_ILOSC+' as '+sZLESZCZEGOLY_ILOSC+';'+
                                     '#@'+sMAGALIAS_MAGOBRPOZ_WARTOSC+' as '+sZLESZCZEGOLY_WARTOSC,
                                     '(@'+sMAGALIAS_MAGOBRPOZ_ZLECENIE_ID+'='+IntToStr(iZLECENIE_ID)+')'+
                                     sTypDokSpecWhere+sOkresWhereMat,
                                     False, vAktywnaFirma );
      sSQL := sSQL+' UNION ALL ';
      sSQL := sSQL + ZLEDM.ZLEOdpytajODaneSQL( sZLEOSOBYGODZ,
                                               '#@'+sZLEALIAS_OSOBYGODZ_DATA+' as '+sZLESZCZEGOLY_DATA+';'+
                                               '#@'+sZLEALIAS_OSOBYGODZ_ZLECENIE_ID+';'+
                                               '#@'+sZLEALIAS_OSOBYGODZ_OKRES_ID+';'+
                                               '#@'+sZLEALIAS_OSOBYGODZ_ASORT_ID+';'+
                                               '#@'+sZLEALIAS_ASORT_SYMBOL+';'+
                                               '#@'+sZLEALIAS_ASORT_NAZWA+';'+
                                               '#@'+sZLEALIAS_JM_SYMBOL+';'+
                                               '#null as '+sUNIMAGAZYN_SYMBOL+';'+
                                               '#null as '+sMAGTYPDOK_SYMBOL+';'+
                                               '#null as '+sMAGOBR_NR_DOK+';'+
                                               '#null as '+sMAGALIAS_MAGOBRPOZ_LP+';'+
                                               '#null as '+sMAGOBRPOZ_ZNAK+';'+
                                               '#@'+sZLEALIAS_OSOBA_IMIE+';'+
                                               '#@'+sZLEALIAS_OSOBA_NAZWISKO+';'+
                                               '#NVL(@'+sZLEALIAS_OSOBYGODZ_CENA+',0) as '+sZLESZCZEGOLY_CENA+';'+
                                               '#NVL(@'+sZLEALIAS_OSOBYGODZ_ILOSC + sTmp + sZLESZCZEGOLY_ILOSC+';'+
                                               '#NVL(@'+sZLEALIAS_OSOBYGODZ_CENA+'*@'+sZLEALIAS_OSOBYGODZ_ILOSC + sTmp + sZLESZCZEGOLY_WARTOSC,
                                               '(@'+sZLEALIAS_OSOBYGODZ_ZLECENIE_ID+'='+IntToStr(iZLECENIE_ID)+')'+
                                               sOkresWhereRob, False );

    end;
  end;
  if sSQL <> '' then begin
    sSQL := sSQL + ' ORDER BY 1';
    result := SQLManager.CreateQuery( sSQL );
  end;
  ***************************************************************)

end;

procedure TZLEDataManager.WzorceImportuMenuItemClick(Sender: TObject);
begin
  inherited;
  UNISysDM.UNIPokazIObsluzDane(sUNIIMP,
    '@' + sUNISYSAlias_ImpModulZSIID + ' = ' + IntToStr(cZLEMODULZSI_ID),
    false, false, '', vAktywnaFirma
  );
end;

function TZLEDataManager.ZLEDajKosztyZleceniaSzczegolowo(iZLECENIE_ID, iUNIOKRES_ID: Integer;
                                                         aRodzajKosztow: TZleRodzajKosztow;
                                                         a_oParams: TKeyValues  = nil): TUNIQuery;
const
  cMAGOBRPOZ = sMAGModulID+cMAGOBRPOZ_SUFFIX;
var
  i: integer;
  sRokSymbol: string;
  sText: string;
  sSQL, sTmp, sTypDokSpecWhere, sOkresWhereRob, sOkresWhereMat, sOkresWhereRob2: string;
  bKosztyZlecAll,      bKosztyZlecAllNarzut,
  bKosztyZlecenie_Rob, bKosztyZlecenie_RobNarzut,
  bKosztyZlecenie_Mat, bKosztyZlecenie_MatNarzut: Boolean;
  sListaPozycji: String;
  sPozWhereRob, sPozWhereMat, sCenaStr, sWartStr: String;
begin
(*******************************************
begin

  sTmp := '';
  if ZLEDM.vZLEFormatGodzinLiczba then
     sTmp := ',0)) AS '
  else sTmp := ',0)/60) AS ';

  if iUNIOKRES_ID > 0 then begin
    sOkresWhereMat := ' AND (OBR.'+sUNIOKRES_ID+'='+IntToStr(iUNIOKRES_ID)+')';
    sOkresWhereRob := ' AND (OSOBYGODZ.' + sUNIOKRES_ID + ' = ' + IntToStr(iUNIOKRES_ID) + ')';
    i := UNISysDM.UNIPodajSymbolRokuDlaIDOkresu(sRokSymbol, iUNIOKRES_ID);
    if i <> 0 then Raise Exception.Create('Nie znaleziono definicji roku dla podanego okresu');
  end else begin
    sOkresWhereRob := '';
    sOkresWhereMat := '';
  end;
  sTypDokSpecWhere := ' AND (MGTD.'+sMAGTYPDOK_SPEC+' IN ('+ QuotedStr(cMAGTypDokSpec_ZwyklyID)+'))';

  sPozWhereRob := '';
  sPozWhereMat := '';
  if sListaPozycji <> '' then begin
     sPozWhereRob := ' AND (OSOBYGODZ.' + sZLEZLECENIEPOZ_ID + ' IN (' + sListaPozycji + '))';
     sPozWhereMat := ' AND (OBRPOZ.' + sZLEZLECENIEPOZ_ID + ' IN (' + sListaPozycji + '))';
  end;

  sSQL := 'SELECT SUM(' + sZLESZCZEGOLY_WARTOSC + ') AS ' + sZLESZCZEGOLY_WARTOSC + ' ' +
          'FROM ('+
          '  SELECT ';

  {Koszty materiaowe}
  if bKosztyZlecenie_Mat or bKosztyZlecenie_MatNarzut then begin
      if ZLEDM.vZLENarzuty and bKosztyZlecenie_MatNarzut then begin
         {koszty materiaowe z narzutami}
         sSQL := sSQL + SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuMat') + '(OBRPOZ.' + sZLEZLECENIEPOZ_ID + ', OBR.' + sUNIOKRES_ID + ') * OBRPOZ.' + sMAGOBRPOZ_WARTOSC + ' AS ' + sZLESZCZEGOLY_WARTOSC + ' ';
      end else begin
         sSQL := sSQL + ' OBRPOZ.' + sMAGOBRPOZ_WARTOSC + ' AS ' + sZLESZCZEGOLY_WARTOSC + ' ';
      end;

      sSQL := sSQL +
              '  FROM %s OBR, %s OBRPOZ, %s MGTD ' +
              '  WHERE '+
                   'OBR.' + sMAGTYPDOK_ID + ' = MGTD.' + sMAGTYPDOK_ID + ' AND ' +
                   'OBR.' + sMAGOBR_ID + ' = OBRPOZ.' + sMAGOBR_ID + ' AND ' +
                   'OBRPOZ.' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZLECENIE_ID) +
                   sTypDokSpecWhere +
                   sPozWhereMat +
                   sOkresWhereMat;

      if bKosztyZlecenie_Rob or bKosztyZlecenie_RobNarzut then begin
          sSQL := sSQL +
                  '  UNION ALL ' +
                  '  SELECT ';
      end;
  end;

  if bKosztyZlecenie_Rob or bKosztyZlecenie_RobNarzut then begin
      if ZLEDM.vZLENarzuty and bKosztyZlecenie_RobNarzut then begin
         {Robocizna z narzutami}
         sSQL := sSQL + SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuRob') + '(OSOBYGODZ.' + sZLEZLECENIEPOZ_ID + ', OSOBYGODZ.' + sUNIOKRES_ID + ') * (NVL(OSOBYGODZ.' + sZLEOSOBYGODZ_CENA + ' * OSOBYGODZ.' + sZLEOSOBYGODZ_ILOSC + sTmp + sZLESZCZEGOLY_WARTOSC + ' ';
      end else begin
         sSQL := sSQL + '(NVL(OSOBYGODZ.' + sZLEOSOBYGODZ_CENA + ' * OSOBYGODZ.' + sZLEOSOBYGODZ_ILOSC + sTmp + sZLESZCZEGOLY_WARTOSC + ' ';
      end;

      sSQL := sSQL +
              '  FROM %s OSOBYGODZ ' +
              '  WHERE ' +
                   'OSOBYGODZ.' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZLECENIE_ID) +
                   sPozWhereRob +
                   sOkresWhereRob;
  end;

  sSQL := sSQL + ')';

  if (bKosztyZlecenie_Mat or bKosztyZlecenie_MatNarzut) and (bKosztyZlecenie_Rob or bKosztyZlecenie_RobNarzut) then begin
     q := SQLManager.CreateQuery(sSQL, [sMAG_OBR, sMAG_OBRPOZ, sMAGTYPDOK, sZLEOSOBYGODZ]);
  end else if bKosztyZlecenie_Mat or bKosztyZlecenie_MatNarzut then begin
     q := SQLManager.CreateQuery(sSQL, [sMAG_OBR, sMAG_OBRPOZ, sMAGTYPDOK]);
  end else if (bKosztyZlecenie_Rob or bKosztyZlecenie_RobNarzut) then begin
     q := SQLManager.CreateQuery(sSQL, [sZLEOSOBYGODZ]);
  end;

  try
    q.Open;
    if not q.IsEmpty then
       Result := q.FieldByName(sZLESZCZEGOLY_WARTOSC).AsFloat;
  finally
    if q <> nil then FreeAndNil(q);
  end;
********************************************)

  Result := Nil;
  sTmp := '';
  sCenaStr := '';
  sWartStr := '';
  if iUNIOKRES_ID > 0 then begin
    sOkresWhereMat  := 'AND(@'+sMAGALIAS_MAGOBR_OKRES_ID+'='+IntToStr(iUNIOKRES_ID)+')';
    sOkresWhereRob  := 'AND(@'+sZLEALIAS_OSOBYGODZ_OKRES_ID+'='+IntToStr(iUNIOKRES_ID)+')';
    sOkresWhereRob2 := ' AND (OSOBYGODZ.' + sUNIOKRES_ID + ' = ' + IntToStr(iUNIOKRES_ID) + ')';
    i := UNISysDM.UNIPodajSymbolRokuDlaIDOkresu(sRokSymbol, iUNIOKRES_ID);
    if i <> 0 then Raise Exception.Create('Nie znaleziono definicji roku dla podanego okresu');
  end else begin
    sOkresWhereRob := '';
    sOkresWhereMat := '';
  end;
  sTypDokSpecWhere := 'AND(@'+sMAGALIAS_MAGTYPDOK_SPEC+' in ('+
                      QuotedStr(cMAGTypDokSpec_ZwyklyID)+'))';

{ TODO -ogdeyk -czlecenia : Uzgodni czy przenoszone pozycje maj by rozgraniczone na rne lpp }
  sSQL := '';

  case aRodzajKosztow of
    rkMaterialy: begin
(*****************************************************************
    SELECT     ROWNUM,
           fz.mfzzakup_data AS zleszczegolydata,
           2284 AS zlezlecenie_id,
           fz.uniokres_id,
           mzp.asoasort_id,
           NULL AS zlezleceniepoz_lp,
           aso.asoasort_symbol,
           aso.asoasort_nazwa,
           NULL AS zleceniepoz_asort_nazwa,
           NULL AS zleceniepoz_asort_symbol,
           jm.unijm_symbol,
           NULL AS unimagazyn_symbol,
           mfztd.mfztypdok_symbol AS magtypdok_symbol,
           fz.mfzzakup_nr_dok AS magobr_nr_dok,
           mzp.MFZPOZYCJA_LP AS magobrpoz_lp,
           '+' AS magobrpoz_znak,
           mzp.MFZPOZYCJA_CENA_JEDN_BRUTTO AS zleszczegolycena,
           mzp.MFZPOZYCJA_WART_BRUTTO AS przychod,
           0 AS rozchod,
           mzp.MFZPOZYCJA_WART_BRUTTO AS saldo,
           mzp.MFZPOZYCJA_ILOSC AS przychod_il,
           0 AS rozchod_il,
           mzp.MFZPOZYCJA_ILOSC AS saldo_il,
           1 AS zlewspnarzutmat,
           mzp.MFZPOZYCJA_WART_BRUTTO AS saldo_narzutmat
    FROM   ostrada.mfztypdok mfztd,
           ostrada.mfzpozycja mzp,
           ostrada.asoasort aso,
           ostrada.asoasortreg reg,
           ostrada.mfzzakup fz,
           ostrada.unijm jm,
           ostrada.unirok unio_r,
           ostrada.uniokres unio
    WHERE  mzp.asoasort_id = aso.asoasort_id
           AND reg.asoasort_id=aso.asoasort_id
           AND reg.asoreg_id=22
           AND fz.mfztypdok_id = mfztd.mfztypdok_id(+)
           AND aso.unijm_id1 = jm.unijm_id(+)
           AND fz.uniokres_id = unio.uniokres_id(+)
           AND unio.unirok_id = unio_r.unirok_id(+)
           AND mzp.MFZZAKUP_ID = fz.MFZZAKUP_ID
           AND fz.mfzzakup_id IN(SELECT p.mfzzakup_id
                                 FROM   ostrada.mfzzakup p,
                                        ostrada.unipolauz uz,
                                        ostrada.unipolauzdef def,
                                        ostrada.unipolauzwsk wsk,
                                        ostrada.fkmnemoniki mn
                                 WHERE  p.mfzzakup_id = uz.unipolauz_felementid
                                        AND uz.unipolauzwsk_id = wsk.unipolauzwsk_id
                                        AND def.unipolauzdef_id = wsk.unipolauzdef_id
                                        AND unipolauzwsk_funk = 31
                                        AND mn.fkmnemoniki_id = def.fkmnemoniki_id
                                        AND mn.fkmnemoniki_tabela = 'ZLEZLECENIE'
                                        AND uz.unipolauz_wartid = 24 --zlezlecenie_id
                                 GROUP  BY p.mfzzakup_id
                                        )
*****************************************************************)



      sText := 'SELECT  ' +
                    'ROWNUM, ' +
                    'OBR.' + sMAGOBR_DATA_DOK + ' as ZLESzczegolyData, ' +
                    'OBRPOZ.' + sZLEZLECENIE_ID + ', ' +
                    'OBR.' + sUNIOKRES_ID + ', ' +
                    'OBRPOZ.' + sASOASORT_ID + ', ' +
                    'ZLEPOZ.' + sZLEZLECENIEPOZ_LP + ', ' +
                    'ASORT.' + sASOASORT_SYMBOL + ', ' +
                    'ASORT.' + sASOASORT_NAZWA + ', ' +
                    'ASORT2.' + sASOASORT_NAZWA + ' AS ZLECENIEPOZ_ASORT_NAZWA, ' +
                    'ASORT2.' + sASOASORT_SYMBOL + ' AS ZLECENIEPOZ_ASORT_SYMBOL, ' +
                    'JM.' + sUNIJM_SYMBOL + ', ';

      if DataManagers.Available(sBOKModulID) then begin
         sText := sText  +
                    'BOKSPRAWA.' + sBOKSPRAWA_NUMER + ', ' +
                    'BOKSPRAWA.' + sBOKSPRAWA_OBIEKTOPIS + ', ';
      end;

      sText := sText  +
                    'MAGAZYN.' + sUNIMAGAZYN_SYMBOL + ', ' +
                    'MGTD.' + sMAGTYPDOK_SYMBOL + ', ' +
                    'OBR.' + sMAGOBR_NR_DOK + ', ' +
                    'OBRPOZ.' + sMAGOBRPOZ_LP + ', ';

      if DataManagers.Available(sINFModulID) then begin
         sText := sText +
                    'OBIEKTINF.' + sINFCONST_OBIEKT_V + ', ' +
                    'CAST(' + SQLManager.GetSPName('INF_DAJSYMBOLOBIEKTU') + '(ZLEPOZ.' + sZLEZLECENIEPOZ_POZIOMINF + ', ZLEPOZ.' + sZLEZLECENIEPOZ_INF_ID + ') AS VARCHAR(50)) AS OBIEKT_SYMBOL, ';
      end;

      sText := sText +
                    'CASE OBRPOZ.' + sMAGOBRPOZ_ZNAK + ' WHEN -1 THEN ' + QuotedStr('-') + ' WHEN 1 THEN ' + QuotedStr('+') + ' END as ' + sMAGOBRPOZ_ZNAK + ', ' +
                    'OBRPOZ.' + sMAGOBRPOZ_CENA + ' AS ZLESzczegolyCena, ' +
                    SQLManager.GetSPName('IIF_NUMBER') + '(' + SQLManager.GetSPName('IIF_NUMBER_TO_BOOLEAN') + '(MGTD.' + sMAGTYPDOK_PRZYCHROZCH + ',-1,''=''),OBRPOZ.' + sMAGOBRPOZ_WARTOSC + ',0)*OBRPOZ.' + sMAGOBRPOZ_ZNAK + ' AS PRZYCHOD, ' +
                    SQLManager.GetSPName('IIF_NUMBER') + '(' + SQLManager.GetSPName('IIF_NUMBER_TO_BOOLEAN') + '(MGTD.' + sMAGTYPDOK_PRZYCHROZCH + ',1,''=''),OBRPOZ.' + sMAGOBRPOZ_WARTOSC + ',0)*OBRPOZ.' + sMAGOBRPOZ_ZNAK + ' AS ROZCHOD, ' +
                    '(' +SQLManager.GetSPName('IIF_NUMBER') + '(' + SQLManager.GetSPName('IIF_NUMBER_TO_BOOLEAN') + '(MGTD.' + sMAGTYPDOK_PRZYCHROZCH + ',-1,''=''),OBRPOZ.' + sMAGOBRPOZ_WARTOSC + ',0)*OBRPOZ.' + sMAGOBRPOZ_ZNAK + ' - ' + SQLManager.GetSPName('IIF_NUMBER') + '(' + SQLManager.GetSPName('IIF_NUMBER_TO_BOOLEAN') + '(MGTD.' + sMAGTYPDOK_PRZYCHROZCH + ',1,''=''),OBRPOZ.' + sMAGOBRPOZ_WARTOSC + ',0)*OBRPOZ.' + sMAGOBRPOZ_ZNAK + ') AS SALDO, ' +
                    SQLManager.GetSPName('IIF_NUMBER') + '(' + SQLManager.GetSPName('IIF_NUMBER_TO_BOOLEAN') + '(MGTD.' + sMAGTYPDOK_PRZYCHROZCH + ',-1,''=''),OBRPOZ.' + sMAGOBRPOZ_ILOSC + ',0)*OBRPOZ.' + sMAGOBRPOZ_ZNAK + ' AS PRZYCHOD_IL, ' +
                    SQLManager.GetSPName('IIF_NUMBER') + '(' + SQLManager.GetSPName('IIF_NUMBER_TO_BOOLEAN') + '(MGTD.' + sMAGTYPDOK_PRZYCHROZCH + ',1,''=''),OBRPOZ.' + sMAGOBRPOZ_ILOSC + ',0)*OBRPOZ.' + sMAGOBRPOZ_ZNAK + ' AS ROZCHOD_IL, ' +
                    '(' + SQLManager.GetSPName('IIF_NUMBER') + '(' + SQLManager.GetSPName('IIF_NUMBER_TO_BOOLEAN') + '(MGTD.' + sMAGTYPDOK_PRZYCHROZCH + ',-1,''=''),OBRPOZ.' + sMAGOBRPOZ_ILOSC + ',0)*OBRPOZ.' + sMAGOBRPOZ_ZNAK + ' - ' + SQLManager.GetSPName('IIF_NUMBER') + '(' + SQLManager.GetSPName('IIF_NUMBER_TO_BOOLEAN') + '(MGTD.' + sMAGTYPDOK_PRZYCHROZCH + ',1,''=''),OBRPOZ.' + sMAGOBRPOZ_ILOSC + ',0)*OBRPOZ.' + sMAGOBRPOZ_ZNAK + ') AS SALDO_IL ';

      if ZLEDM.vZLENarzuty then begin
         sText := sText + ', ' +
                    '(' + SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuMat') + '(OBRPOZ.' + sZLEZLECENIEPOZ_ID + ', OBR.' + sUNIOKRES_ID + ')) AS ZLEWSPNARZUTMAT';

         sText := sText + ', ' +
                    '((' + SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuMat') + '(OBRPOZ.' + sZLEZLECENIEPOZ_ID + ', OBR.' + sUNIOKRES_ID + ')) * ' +
                        '(' + SQLManager.GetSPName('IIF_NUMBER')+'('+
                              SQLManager.GetSPName('IIF_NUMBER_TO_BOOLEAN')+'('+
                                 'MGTD.' + sMAGTYPDOK_PRZYCHROZCH+',-1,'+QuotedStr('=')+'),'+
                                 'OBRPOZ.' + sMAGOBRPOZ_WARTOSC+',0) * OBRPOZ.' + sMAGOBRPOZ_ZNAK +
                        ' - ' +
                              SQLManager.GetSPName('IIF_NUMBER')+'('+
                              SQLManager.GetSPName('IIF_NUMBER_TO_BOOLEAN')+'('+
                                 'MGTD.' + sMAGTYPDOK_PRZYCHROZCH+',1,'+QuotedStr('=')+'),'+
                                 'OBRPOZ.' + sMAGOBRPOZ_WARTOSC+',0) * OBRPOZ.' + sMAGOBRPOZ_ZNAK+')) AS SALDO_NARZUTMAT';
      end;

      sText := sText + ' ' +
               'FROM ' +
                    SQLManager.GetTableName(sMAG_OBR) + ' OBR, ' +
                    SQLManager.GetTableName(sMAG_OBRPOZ) + ' OBRPOZ, ' +
                    SQLManager.GetTableName(sZLEZLECENIEPOZ) + ' ZLEPOZ, ' +
                    SQLManager.GetTableName(sASOASORT) + ' ASORT, ' +
                    SQLManager.GetTableName(sASOASORT) + ' ASORT2, ' +
                    SQLManager.GetTableName(sUNIJM) + ' JM, ';

      if DataManagers.Available(sBOKModulID) then begin
         sText := sText +
                    SQLManager.GetSPName(sBOKSPRAWA) + ' BOKSPRAWA, ';
      end;

      sText := sText +
                    SQLManager.GetSPName(sUNIMAGAZYN) + ' MAGAZYN, ' +
                    SQLManager.GetSPName(sMAGTYPDOK) + ' MGTD ';

      if DataManagers.Available(sINFModulID) then begin
         sText := sText + ', ' +
                    SQLManager.GetTableName(sINFCONST_OBIEKT) + ' OBIEKTINF ';
      end;

      sText := sText +
                  'WHERE OBR.' + sMAGTYPDOK_ID + ' = MGTD.' + sMAGTYPDOK_ID + ' ' +
                    'AND OBR.' + sMAGOBR_ID + ' = OBRPOZ.' + sMAGOBR_ID + ' ' +
                    'AND OBR.' + sUNIMAGAZYN_ID + ' = MAGAZYN.' + sUNIMAGAZYN_ID +'(+) ' +
                    'AND OBRPOZ.' + sZLEZLECENIEPOZ_ID + ' = ZLEPOZ.' + sZLEZLECENIEPOZ_ID + '(+) ' +
                    'AND ZLEPOZ.' + sASOASORT_ID + ' = ASORT2.' + sASOASORT_ID + '(+) ' +
                    'AND ASORT.' + sASOASORT_ID + ' = OBRPOZ.' + sASOASORT_ID + ' ' +
                    'AND ASORT.' + sUNIJM_ID1 + ' = JM.' + sUNIJM_ID + '(+) ';

      if DataManagers.Available(sBOKModulID) then begin
         sText := sText +
                    'AND ZLEPOZ.' + sBOKSPRAWA_ID + ' = BOKSPRAWA.' + sBOKSPRAWA_ID + '(+) ';
      end;

      if DataManagers.Available(sINFModulID) then begin
         sText := sText +
                    'AND ZLEPOZ.' + sZLEZLECENIEPOZ_POZIOMINF + ' = OBIEKTINF.' + sINFCONST_OBIEKT_ID + '(+) ';
      end;

      sText := sText +
                    'AND OBRPOZ.' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZLECENIE_ID) + ' ' +
                    'AND MGTD.' + sMAGTYPDOK_SPEC + ' in (' + QuotedStr('ZW') + ') ';

     if iUNIOKRES_ID > 0 then begin
         sText := sText +
                     'AND OBR.' + sUNIOKRES_ID + ' = ' + IntToStr(iUNIOKRES_ID);
     end;

     {sText := sText +
                  'ORDER BY 1';}


     if ZLEDM.vZLEKosztyMatZakupWlaczone then begin
       sText := sText + ' ' +
         'UNION ALL ' +
         'SELECT   1000000 + ROWNUM, ' +
                   'fz.' + sMFZZAKUP_DATA + ' AS ZLESZCZEGOLYDATA, ' +
                   IntToStr(iZlecenie_ID) + ' AS ' + sZLEZLECENIE_ID + ', ' +
                   'FZ.' + sUNIOKRES_ID + ', ' +
                   'MZP.' + sASOASORT_ID + ', ' +
                   'NULL AS ' + sZLEZLECENIEPOZ_LP + ', ' +
                   'ASO.' + sASOASORT_SYMBOL + ', ' +
                   'ASO.' + sASOASORT_NAZWA + ', ' +
                   'NULL AS ZLECENIEPOZ_ASORT_NAZWA, ' +
                   'NULL AS ZLECENIEPOZ_ASORT_SYMBOL, ' +
                   'JM.' + sUNIJM_SYMBOL + ', ';

        if DataManagers.Available(sBOKModulID) then begin
           sText := sText +
                      'NULL AS ' + sBOKSPRAWA_NUMER + ', ' +
                      'NULL AS ' + sBOKSPRAWA_OBIEKTOPIS + ', ';
        end;

        sText := sText +
                   'NULL AS ' + sUNIMAGAZYN_SYMBOL + ', ' +
                   'MFZTD.' + sMFZTYPDOK_SYMBOL + ' AS ' + sMAGTYPDOK_SYMBOL + ', ' +
                   'FZ.' + sMFZZAKUP_NR_DOK + ' AS ' + sMAGOBR_NR_DOK + ', ' +
                   'MZP.' + sMFZPOZYCJA_LP + ' AS ' + sMAGOBRPOZ_LP + ', ';

        if DataManagers.Available(sINFModulID) then begin
           sText := sText +
                      'NULL AS ' + sINFCONST_OBIEKT_V + ', ' +
                      'NULL AS OBIEKT_SYMBOL, ';
        end;

        sText := sText + ' ' +
                   QuotedStr('+') + ' AS ' + sMAGOBRPOZ_ZNAK + ', ' +
                   'MZP.' + sMFZPOZYCJA_CENA_JEDN_NETTO + ' AS ZLESZCZEGOLYCENA, ' +
                   'MZP.' + sMFZPOZYCJA_WART_NETTO + ' AS PRZYCHOD, ' +
                   '0 AS ROZCHOD, ' +
                   'MZP.' + sMFZPOZYCJA_WART_NETTO + ' AS SALDO, ' +
                   'MZP.' + sMFZPOZYCJA_ILOSC + ' AS PRZYCHOD_IL, ' +
                   '0 AS ROZCHOD_IL, ' +
                   'MZP.' + sMFZPOZYCJA_ILOSC + ' AS SALDO_IL ';

        if ZLEDM.vZLENarzuty then begin
          sText := sText + ', ' +
                   '1 AS ZLEWSPNARZUTMAT, ' +
                   'MZP.' +sMFZPOZYCJA_WART_NETTO + ' AS SALDO_NARZUTMAT ';
        end;

        sText := sText + ' ' +
            'FROM  ' + SQLManager.GetTableName(sMFZTYPDOK) + '  MFZTD, ' +
                       SQLManager.GetTableName(sMFZPOZYCJA ) + ' MZP, ' +
                       SQLManager.GetTableName(sASOASORT) + '  ASO, ' +
                       SQLManager.GetTableName(sASOASORTREG) + '  REG, ' +
                       SQLManager.GetTableName(sMFZZAKUP) + '  FZ, ' +
                       SQLManager.GetTableName(sUNIJM) + '  JM, ' +
                       SQLManager.GetTableName(sUNIPOLAUZ) + ' UZ, ' +
                       SQLManager.GetTableName(sUNIPOLAUZDEF) + ' DEF, ' +
                       SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK, ' +
                       SQLManager.GetTableName(sFKMNEMONIKI) + ' MN ' +
                       {+
                       SQLManager.GetTableName(sUNIROK) + '  UNIO_R, ' +
                       SQLManager.GetTableName(sUNIOKRES) + ' UNIO ' +}
            'WHERE  MZP.' + sASOASORT_ID + '= ASO.' +sASOASORT_ID +
              ' AND REG.' + sASOASORT_ID + '=ASO.' +sASOASORT_ID +
              ' AND REG.' + sASOREG_ID + '= 22 ' +
              ' AND FZ.' + sMFZTYPDOK_ID + '= MFZTD.' +sMFZTYPDOK_ID + '(+) ' +
              ' AND ASO.' + sUNIJM_ID1 + '= JM.' +sUNIJM_ID + '(+) ';
              { +
              ' AND FZ.' +sUNIOKRES_ID + '= UNIO.' +sUNIOKRES_ID + '(+) ' +
              ' AND UNIO.' +sUNIROK_ID + '= UNIO_R.' +sUNIROK_ID + '(+) ';}

        if iUNIOKRES_ID > 0 then begin
          sText := sText +
                      ' AND FZ.' + sUNIOKRES_ID + ' = ' + IntToStr(iUNIOKRES_ID);
        end;

        sText := sText +
              ' AND MZP.' +sMFZZAKUP_ID + '= FZ.' +sMFZZAKUP_ID  +
              ' AND MZP.' + sMFZPOZYCJA_ID + '= UZ.' + sUNIPOLAUZ_FSUBELEMID +
              ' AND UZ.' +sUNIPOLAUZWSK_ID + '= WSK.' + sUNIPOLAUZWSK_ID +
              ' AND DEF.' +sUNIPOLAUZDEF_ID + '= WSK.' + sUNIPOLAUZDEF_ID +
              ' AND WSK.' +sUNIPOLAUZWSK_FUNK + '= 31 ' +
              ' AND MN.' +sFKMNEMONIKI_ID + '= DEF.' +sFKMNEMONIKI_ID +
              ' AND MN.' +sFKMNEMONIKI_TABELA + '=' + QuotedStr(sZLEZLECENIE) +
              ' AND UZ.' +sUNIPOLAUZ_WARTID + '=' + IntToStr(iZLecenie_ID) +
              ' AND NOT EXISTS (SELECT MP.' + sMAGOBRPOZ_ID + ' ' +
                               'FROM ' +
                                   SQLManager.GetTableName(sMAG_OBRPOZ) + ' MP ' +
                               'WHERE MP.' + sMFZPOZYCJA_ID + ' = MZP.' + sMFZPOZYCJA_ID + ')';


              {' AND FZ.' +sMFZZAKUP_ID + ' IN(SELECT P.' +sMFZZAKUP_ID + ' '+
                                         'FROM  ' + SQLManager.GetTableName(sMFZZAKUP) + ' P, ' +
                                                    SQLManager.GetTableName(sUNIPOLAUZ) + ' UZ, ' +
                                                    SQLManager.GetTableName(sUNIPOLAUZDEF) + ' DEF, ' +
                                                    SQLManager.GetTableName(sUNIPOLAUZWSK) + ' WSK, ' +
                                                    SQLManager.GetTableName(sFKMNEMONIKI) + ' MN ' +
                                         'WHERE  P.' +sMFZZAKUP_ID + '= UZ.' + sUNIPOLAUZ_FELEMENTID +
                                               ' AND UZ.' +sUNIPOLAUZWSK_ID + '= WSK.' + sUNIPOLAUZWSK_ID +
                                               ' AND DEF.' +sUNIPOLAUZDEF_ID + '= WSK.' + sUNIPOLAUZDEF_ID +
                                               ' AND WSK.' +sUNIPOLAUZWSK_FUNK + '= 31 ' +
                                               ' AND MN.' +sFKMNEMONIKI_ID + '= DEF.' +sFKMNEMONIKI_ID +
                                               ' AND MN.' +sFKMNEMONIKI_TABELA + '=' + QuotedStr(sZLEZLECENIE) +
                                               ' AND UZ.' +sUNIPOLAUZ_WARTID + '=' + IntToStr(iZLecenie_ID) + ' ' +
                                         'GROUP  BY P.' + sMFZZAKUP_ID + ' ' +
                                                ')';}
     end;

     sSQL := sText;
(***************************************************************************
      sText := '#ROWNUM;'+
               '#@'+sMAGALIAS_MAGOBR_DATA_DOK+' as '+sZLESZCZEGOLY_DATA+';'+
               '#@'+sMAGALIAS_MAGOBRPOZ_ZLECENIE_ID+';'+
               '#@'+sMAGALIAS_MAGOBR_OKRES_ID+';'+
               '#@'+sMAGALIAS_MAGOBRPOZ_ASORT_ID+';'+
               '#@'+sMAGALIAS_ZLECENIEPOZ_LP+';'+
               '#@'+sMAGALIAS_ASORT_SYMBOL+';'+
               '#@'+sMAGALIAS_ASORT_NAZWA+';'+
               '#@'+sMAGALIAS_ASORT2_NAZWA + ' AS ZLECENIEPOZ_ASORT_NAZWA'+';'+
               '#@'+sMAGALIAS_ASORT2_SYMBOL + ' AS ZLECENIEPOZ_ASORT_SYMBOL'+';'+
               '#@'+sMAGALIAS_JM_SYMBOL+';';


       if DataManagers.Available(sBOKModulID) then begin
         sText := sText +
               '#@'+sMAGALIAS_BOKSPRAWA_NUMER+';'+
               '#@'+sMAGALIAS_BOKSPRAWA_OPIS+';';
       end;

       sText := sText +
               '#@'+sMAGALIAS_MAGAZYN_SYMBOL+';'+
               '#@'+sMAGALIAS_MAGTYPDOK_SYMBOL+';'+
               '#@'+sMAGALIAS_MAGOBR_NUMER+';'+
               '#@'+sMAGALIAS_MAGOBRPOZ_LP+';';

      if DataManagers.Available(sINFModulID) then begin
         sText := sText + '#@'+sMAGALIAS_OBIEKTINF_NAZWA+';'+
                          '#CAST('+SQLManager.GetSPName(sINF_DAJSYMBOLOBIEKTU)+'('+
                          sMAGALIAS_ZLECENIEPOZ+'.'+sZLEZLECENIEPOZ_POZIOMINF+','+
                          sMAGALIAS_ZLECENIEPOZ+'.'+sZLEZLECENIEPOZ_INF_ID+') AS VARCHAR(50)) AS OBIEKT_SYMBOL'+';';
       end;

       {TAK BYO - 2007-04-02}
      { sText := sText + '#CASE @'+sMAGALIAS_MAGOBRPOZ_ZNAK+' WHEN -1 THEN ''-'' WHEN 1 THEN ''+'' END as '+sMAGOBRPOZ_ZNAK+';'+
                        '#@'+sMAGALIAS_MAGOBRPOZ_CENA+' as '+sZLESZCZEGOLY_CENA+';'+
                        '#@'+sMAGALIAS_MAGOBRPOZ_ILOSC+' as '+sZLESZCZEGOLY_ILOSC+';'+
                        '#@'+sMAGALIAS_MAGOBRPOZ_WARTOSC+' as '+sZLESZCZEGOLY_WARTOSC;}

      sFieldValueNaPlus      :='-1';
      sFieldValueNaMinus     :='1';

      sText := sText + '#CASE @'+sMAGALIAS_MAGOBRPOZ_ZNAK+' WHEN -1 THEN ''-'' WHEN 1 THEN ''+'' END as '+sMAGOBRPOZ_ZNAK+';';

      sText := sText + '#@'+sMAGALIAS_MAGOBRPOZ_CENA+' as '+sZLESZCZEGOLY_CENA+';';
      sText := sText + '#' + SQLManager.GetSPName( 'IIF_NUMBER')+'('+
                             SQLManager.GetSPName( 'IIF_NUMBER_TO_BOOLEAN')+'(@'+
                                 sMAGALIAS_MAGTYPDOK_PRZYCHROZCH+',-1,'+QuotedStr('=')+'),@'+
                                 sMAGALIAS_MAGOBRPOZ_WARTOSC+',0)*@'+sMAGALIAS_MAGOBRPOZ_ZNAK+' AS PRZYCHOD;';

      sText := sText + '#' + SQLManager.GetSPName( 'IIF_NUMBER')+'('+
                             SQLManager.GetSPName( 'IIF_NUMBER_TO_BOOLEAN')+'(@'+
                                 sMAGALIAS_MAGTYPDOK_PRZYCHROZCH+',1,'+QuotedStr('=')+'),@'+
                                 sMAGALIAS_MAGOBRPOZ_WARTOSC+',0)*@'+sMAGALIAS_MAGOBRPOZ_ZNAK+' AS ROZCHOD;';

      sText := sText + '#(' + SQLManager.GetSPName( 'IIF_NUMBER')+'('+
                             SQLManager.GetSPName( 'IIF_NUMBER_TO_BOOLEAN')+'(@'+
                                 sMAGALIAS_MAGTYPDOK_PRZYCHROZCH+',-1,'+QuotedStr('=')+'),@'+
                                 sMAGALIAS_MAGOBRPOZ_WARTOSC+',0)*@'+sMAGALIAS_MAGOBRPOZ_ZNAK+
                        ' - ' +
                             SQLManager.GetSPName( 'IIF_NUMBER')+'('+
                             SQLManager.GetSPName( 'IIF_NUMBER_TO_BOOLEAN')+'(@'+
                                 sMAGALIAS_MAGTYPDOK_PRZYCHROZCH+',1,'+QuotedStr('=')+'),@'+
                                 sMAGALIAS_MAGOBRPOZ_WARTOSC+',0)*@'+sMAGALIAS_MAGOBRPOZ_ZNAK+') AS SALDO;';

      sText := sText + '#' + SQLManager.GetSPName( 'IIF_NUMBER')+'('+
                             SQLManager.GetSPName( 'IIF_NUMBER_TO_BOOLEAN')+'(@'+
                                 sMAGALIAS_MAGTYPDOK_PRZYCHROZCH+',-1,'+QuotedStr('=')+'),@'+
                                 sMAGALIAS_MAGOBRPOZ_ILOSC+',0)*@'+sMAGALIAS_MAGOBRPOZ_ZNAK+' AS PRZYCHOD_IL;';

      sText := sText + '#' + SQLManager.GetSPName( 'IIF_NUMBER')+'('+
                             SQLManager.GetSPName( 'IIF_NUMBER_TO_BOOLEAN')+'(@'+
                                 sMAGALIAS_MAGTYPDOK_PRZYCHROZCH+',1,'+QuotedStr('=')+'),@'+
                                 sMAGALIAS_MAGOBRPOZ_ILOSC+',0)*@'+sMAGALIAS_MAGOBRPOZ_ZNAK+' AS ROZCHOD_IL;';

      sText := sText + '#(' + SQLManager.GetSPName( 'IIF_NUMBER')+'('+
                             SQLManager.GetSPName( 'IIF_NUMBER_TO_BOOLEAN')+'(@'+
                                 sMAGALIAS_MAGTYPDOK_PRZYCHROZCH+',-1,'+QuotedStr('=')+'),@'+
                                 sMAGALIAS_MAGOBRPOZ_ILOSC+',0)*@'+sMAGALIAS_MAGOBRPOZ_ZNAK+
                        ' - ' +
                             SQLManager.GetSPName( 'IIF_NUMBER')+'('+
                             SQLManager.GetSPName( 'IIF_NUMBER_TO_BOOLEAN')+'(@'+
                                 sMAGALIAS_MAGTYPDOK_PRZYCHROZCH+',1,'+QuotedStr('=')+'),@'+
                                 sMAGALIAS_MAGOBRPOZ_ILOSC+',0)*@'+sMAGALIAS_MAGOBRPOZ_ZNAK+') AS SALDO_IL';

      if ZLEDM.vZLENarzuty then begin
         sText := sText + ';' +
                    '#(' + SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuMat') + '(@' + sMAGALIAS_MAGOBRPOZ_ZLECENIEPOZ_ID + ', @' + sMAGALIAS_MAGOBR_OKRES_ID + ')) AS ZLEWSPNARZUTMAT';

         sText := sText + ';' +
                    '#((' + SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuMat') + '(@' + sMAGALIAS_MAGOBRPOZ_ZLECENIEPOZ_ID + ', @' + sMAGALIAS_MAGOBR_OKRES_ID + ')) * ' +
                        '(' + SQLManager.GetSPName( 'IIF_NUMBER')+'('+
                             SQLManager.GetSPName( 'IIF_NUMBER_TO_BOOLEAN')+'(@'+
                                 sMAGALIAS_MAGTYPDOK_PRZYCHROZCH+',-1,'+QuotedStr('=')+'),@'+
                                 sMAGALIAS_MAGOBRPOZ_WARTOSC+',0)*@'+sMAGALIAS_MAGOBRPOZ_ZNAK+
                        ' - ' +
                             SQLManager.GetSPName( 'IIF_NUMBER')+'('+
                             SQLManager.GetSPName( 'IIF_NUMBER_TO_BOOLEAN')+'(@'+
                                 sMAGALIAS_MAGTYPDOK_PRZYCHROZCH+',1,'+QuotedStr('=')+'),@'+
                                 sMAGALIAS_MAGOBRPOZ_WARTOSC+',0)*@'+sMAGALIAS_MAGOBRPOZ_ZNAK+')) AS SALDO_NARZUTMAT';
      end;
      sSQL := MAGDM.OdpytajODaneSQL( cMAGOBRPOZ, sText,
                                     '(@'+sMAGALIAS_MAGOBRPOZ_ZLECENIE_ID+'='+IntToStr(iZLECENIE_ID)+')'+
                                     sTypDokSpecWhere+sOkresWhereMat,
                                     False, vAktywnaFirma );
***********************************************************************)
    end;

    rkRobocizna: begin
      if ZLEDM.vZLEFormatGodzinLiczba then
           sTmp := ',0)'
      else sTmp := ',0)/60';

      //sTmp := ',0) as ';
      {sSQL := ZLEDM.ZLEOdpytajODaneSQL( sZLEOSOBYGODZ,
                                        '#@'+sZLEALIAS_OSOBYGODZ_DATA+' as '+sZLESZCZEGOLY_DATA+';'+
                                        '#@'+sZLEALIAS_OSOBYGODZ_ZLECENIE_ID+';'+
                                        '#@'+sZLEALIAS_OSOBYGODZ_ID+';'+
                                        '#@'+sZLEALIAS_OSOBYGODZ_OKRES_ID+';'+
                                        '#@'+sZLEALIAS_OSOBYGODZ_ASORT_ID+';'+
                                        '#@'+sZLEALIAS_OSOBYGODZ_ZLECENIEPOZ_ID+';'+
                                        '#@'+sZLEALIAS_ZLECENIEPOZ_LP+';'+
                                        //sZLEALIAS_ZLECENIEPOZ_ASORT_ID    = 'ZLECENIEPOZ_ASORT_ID';
                                        '#@'+sZLEALIAS_ZLECENIEPOZ_OPIS+';'+
                                        '#@'+sZLEALIAS_ZLECENIEPOZ_SPRAWA_ID+';'+
                                        '#@'+sZLEALIAS_ASORT_SYMBOL+';'+
                                        '#@'+sZLEALIAS_ASORT_NAZWA+';'+
                                        '#@'+sZLEALIAS_JM_SYMBOL+';'+
                                        '#@'+sZLEALIAS_OSOBA_IMIE+';'+
                                        '#@'+sZLEALIAS_OSOBA_NAZWISKO+';'+
                                        '#@'+sZLEALIAS_OSOBYGODZ_ZASOB_ID+';'+
                                        '#@'+sZLEALIAS_OSOBYGODZ_ZASOB_NAZWA+';'+
                                        '#NVL(@'+sZLEALIAS_OSOBYGODZ_CENA+',0) as '+sZLESZCZEGOLY_CENA+';'+
                                        '#NVL(@'+sZLEALIAS_OSOBYGODZ_ILOSC + sTmp + sZLESZCZEGOLY_ILOSC+';'+
                                        '#NVL(@'+sZLEALIAS_OSOBYGODZ_CENA+'*@'+sZLEALIAS_OSOBYGODZ_ILOSC + sTmp + sZLESZCZEGOLY_WARTOSC,
                                        '(@'+sZLEALIAS_OSOBYGODZ_ZLECENIE_ID+'='+IntToStr(iZLECENIE_ID)+')'+
                                        sOkresWhereRob, False );}

     sSQL := 'SELECT OSOBYGODZ.' + sZLEZASOBYPRACA_DATA + ' AS ' + sZLESZCZEGOLY_DATA + ', ' +
                    'OSOBYGODZ.' + sZLEZLECENIE_ID + ', ' +
                    'OSOBYGODZ.' + sZLEZASOBYPRACA_ID + ', ' +
                    'OSOBYGODZ.' + sUNIOKRES_ID + ', ' +
                    'OSOBYGODZ.' + sASOASORT_ID + ', ' +
                    'OSOBYGODZ.' + sZLEZLECENIEPOZ_ID + ', ' +
                    'ZLEPOZ.' + sZLEZLECENIEPOZ_LP + ', ' +
                    'ZLEPOZ.' + sZLEZLECENIEPOZ_OPIS + ', ' +
                    'ZLEPOZ.' + sBOKSPRAWA_ID;
    if DataManagers.Available(sASOModulID) then
       sSQL := sSQL + ', ' +
                    'ASORT.' + sASOASORT_SYMBOL + ', ' +
                    'ASORT.' + sASOASORT_NAZWA + ', ' +
                    'JM.' + sUNIJM_SYMBOL;

    sSQL := sSQL    + ', ' +
                    'OSOBA.' + sKDOSOBA_IMIE + ', ' +
                    'OSOBA.' + sKDOSOBA_NAZWISKO + ', ' +
                    'OSOBYGODZ.' + sZLEZASOB_ID + ', ' +
                    'ZLEZASOB.' + sZLEZASOB_NAZWA + ', ' +
                    'NVL(OSOBYGODZ.' + sZLEZASOBYPRACA_STAWKA + ',0) AS ' + sZLESZCZEGOLY_CENA + ', ' +
                    'NVL(OSOBYGODZ.' + sZLEZASOBYPRACA_CZAS_PRACY + sTmp + ' AS ' + sZLESZCZEGOLY_ILOSC;

     if ZLEDM.vZLENarzuty then begin
        sSQL := sSQL + ', ' +
                    SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuRob') + '(' + 'OSOBYGODZ.' + sZLEZLECENIEPOZ_ID + ', ' + 'OSOBYGODZ.' + sUNIOKRES_ID + ') AS ZLEWSPNARZUTROB';

        sSQL := sSQL + ', ' +
                    SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuRob') + '(' + 'OSOBYGODZ.' + sZLEZLECENIEPOZ_ID + ', ' + 'OSOBYGODZ.' + sUNIOKRES_ID + ') * ' +
                    '(NVL(OSOBYGODZ.' + sZLEZASOBYPRACA_STAWKA + ' * OSOBYGODZ.' + sZLEZASOBYPRACA_CZAS_PRACY + sTmp + ') AS SALDO_NARZUTROB';
     end;

     sSQL := sSQL + ', ' +
                    'NVL(OSOBYGODZ.' + sZLEZASOBYPRACA_STAWKA + ' * OSOBYGODZ.' + sZLEZASOBYPRACA_CZAS_PRACY + sTmp + ' AS ' + sZLESZCZEGOLY_WARTOSC + ' ' +
             'FROM ' + SQLManager.GetTableName(sZLEZASOBYPRACA) + ' OSOBYGODZ, ' +
                       SQLManager.GetTableName(sZLEZLECENIEPOZ) + ' ZLEPOZ, ';

    if DataManagers.Available(sASOModulID) then
       sSQL := sSQL +  SQLManager.GetTableName(sASOASORT) + ' ASORT, ' +
                       SQLManager.GetTableName(sUNIJM) + ' JM, ';

    sSQL := sSQL     +
                       SQLManager.GetTableName(sKDOSOBA) + ' OSOBA, ' +
                       SQLManager.GetTableName(sZLEZASOB) + ' ZLEZASOB ' +
             'WHERE ';

    if DataManagers.Available(sASOModulID) then
       sSQL := sSQL +  'OSOBYGODZ.' + sASOASORT_ID + ' = ASORT.' + sASOASORT_ID + ' (+) AND ';

    sSQL := sSQL + 'OSOBYGODZ.' + sKDOSOBA_ID + ' = OSOBA.' + sKDOSOBA_ID + ' (+) AND ' +
                   'OSOBYGODZ.' + sZLEZASOB_ID + ' = ZLEZASOB.' + sZLEZASOB_ID + ' (+) AND ' +
                   'OSOBYGODZ.' + sZLEZLECENIEPOZ_ID + ' = ZLEPOZ.' + sZLEZLECENIEPOZ_ID + ' (+) AND ';

    if DataManagers.Available(sASOModulID) then
       sSQL := sSQL + 'ASORT.' + sUNIJM_ID1 + ' = JM.' + sUNIJM_ID + ' (+) AND ';
    sSQL := sSQL + 'OSOBYGODZ.' + sZLECONST_RODZAJECP_ID + ' IN (' + QuotedStr(cZLERodzajECP_OsobaID) + ', ' + QuotedStr(cZLERodzajECP_ZasobID) + ') AND ' +
                   '(OSOBYGODZ.' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZLECENIE_ID) + ')' + sOkresWhereRob2;

    end;
    rkWszystkie: begin

      {a_oParam s analizowane tylko dla rkWszystkie}
      bKosztyZlecAll             := False;
      bKosztyZlecAllNarzut       := False;
      bKosztyZlecenie_Rob        := False;
      bKosztyZlecenie_RobNarzut  := False;
      bKosztyZlecenie_Mat        := False;
      bKosztyZlecenie_MatNarzut  := False;
      sListaPozycji              := '';
      sCenaStr := '';
      sWartStr := '';

      if a_oParams <> nil then begin
         {Analiza parametrw}
         bKosztyZlecAll             := (a_oParams.Values[sMFSTypDok_KosztyZlecAll] = sTak);
         bKosztyZlecAllNarzut       := (a_oParams.Values[sMFSTypDok_KosztyZlecAllNarzut] = sTak);
         bKosztyZlecenie_Rob        := (a_oParams.Values[sMFSTypDok_ZLERob] = sTak);
         bKosztyZlecenie_RobNarzut  := (a_oParams.Values[sMFSTypDok_ZLERobNarzut] = sTak);
         bKosztyZlecenie_Mat        := (a_oParams.Values[sMFSTypDok_ZLEMat] = sTak);
         bKosztyZlecenie_MatNarzut  := (a_oParams.Values[sMFSTypDok_ZLEMatNarzut] = sTak);
         sListaPozycji              :=  a_oParams.Values[sZLEZLECENIEPOZ_ID];
      end;

      if not  (bKosztyZlecAll or
               bKosztyZlecAllNarzut or
               bKosztyZlecenie_Rob or
               bKosztyZlecenie_RobNarzut or
               bKosztyZlecenie_Mat or
               bKosztyZlecenie_MatNarzut) then begin
         {Nie chcesz adnych kosztw - ustawiamy koszty robocizny i materiaowe}
         bKosztyZlecenie_Rob := True;
         bKosztyZlecenie_Mat := True;
      end;

      if bKosztyZlecAll and not (bKosztyZlecenie_Rob or
                                bKosztyZlecenie_RobNarzut or
                                bKosztyZlecenie_Mat or
                                bKosztyZlecenie_MatNarzut) then begin
         if bKosztyZlecAllNarzut then begin
            bKosztyZlecenie_Rob        := True;
            bKosztyZlecenie_RobNarzut  := True;
            bKosztyZlecenie_Mat        := True;
            bKosztyZlecenie_MatNarzut  := True;
         end else begin
            bKosztyZlecenie_Rob        := True;
            bKosztyZlecenie_RobNarzut  := False;
            bKosztyZlecenie_Mat        := True;
            bKosztyZlecenie_MatNarzut  := False;
         end;
      end;

      sTmp := '';
      if ZLEDM.vZLEFormatGodzinLiczba then
           sTmp := ',0)) '
      else sTmp := ',0)/60) ';

      sPozWhereRob := '';
      sPozWhereMat := '';
      if sListaPozycji <> '' then begin
         sPozWhereRob := ' AND (OSOBYGODZ.' + sZLEZLECENIEPOZ_ID + ' IN (' + sListaPozycji + '))';
         sPozWhereMat := ' AND (OBRPOZ.' + sZLEZLECENIEPOZ_ID + ' IN (' + sListaPozycji + '))';
      end;

  (*
  {Koszty materiaowe}
  if bKosztyZlecenie_Mat or bKosztyZlecenie_MatNarzut then begin
      if ZLEDM.vZLENarzuty and bKosztyZlecenie_MatNarzut then begin
         {koszty materiaowe z narzutami}
         sSQL := sSQL + SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuMat') + '(OBRPOZ.' + sZLEZLECENIEPOZ_ID + ', OBR.' + sUNIOKRES_ID + ') * OBRPOZ.' + sMAGOBRPOZ_WARTOSC + ' AS ' + sZLESZCZEGOLY_WARTOSC + ' ';
      end else begin
         sSQL := sSQL + ' OBRPOZ.' + sMAGOBRPOZ_WARTOSC + ' AS ' + sZLESZCZEGOLY_WARTOSC + ' ';
      end;

      sSQL := sSQL +
              '  FROM %s OBR, %s OBRPOZ, %s MGTD ' +
              '  WHERE '+
                   'OBR.' + sMAGTYPDOK_ID + ' = MGTD.' + sMAGTYPDOK_ID + ' AND ' +
                   'OBR.' + sMAGOBR_ID + ' = OBRPOZ.' + sMAGOBR_ID + ' AND ' +
                   'OBRPOZ.' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZLECENIE_ID) +
                   sTypDokSpecWhere +
                   sPozWhereMat +
                   sOkresWhereMat;

      if bKosztyZlecenie_Rob or bKosztyZlecenie_RobNarzut then begin
          sSQL := sSQL +
                  '  UNION ALL ' +
                  '  SELECT ';
      end;
  end;

  if bKosztyZlecenie_Rob or bKosztyZlecenie_RobNarzut then begin
      if ZLEDM.vZLENarzuty and bKosztyZlecenie_RobNarzut then begin
         {Robocizna z narzutami}
         sSQL := sSQL + SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuRob') + '(OSOBYGODZ.' + sZLEZLECENIEPOZ_ID + ', OSOBYGODZ.' + sUNIOKRES_ID + ') * (NVL(OSOBYGODZ.' + sZLEOSOBYGODZ_CENA + ' * OSOBYGODZ.' + sZLEOSOBYGODZ_ILOSC + sTmp + sZLESZCZEGOLY_WARTOSC + ' ';
      end else begin
         sSQL := sSQL + '(NVL(OSOBYGODZ.' + sZLEOSOBYGODZ_CENA + ' * OSOBYGODZ.' + sZLEOSOBYGODZ_ILOSC + sTmp + sZLESZCZEGOLY_WARTOSC + ' ';
      end;

      sSQL := sSQL +
              '  FROM %s OSOBYGODZ ' +
              '  WHERE ' +
                   'OSOBYGODZ.' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZLECENIE_ID) +
                   sPozWhereRob +
                   sOkresWhereRob;
  end;

  sSQL := sSQL + ')';

  if (bKosztyZlecenie_Mat or bKosztyZlecenie_MatNarzut) and (bKosztyZlecenie_Rob or bKosztyZlecenie_RobNarzut) then begin
     q := SQLManager.CreateQuery(sSQL, [sMAG_OBR, sMAG_OBRPOZ, sMAGTYPDOK, sZLEOSOBYGODZ]);
  end else if bKosztyZlecenie_Mat or bKosztyZlecenie_MatNarzut then begin
     q := SQLManager.CreateQuery(sSQL, [sMAG_OBR, sMAG_OBRPOZ, sMAGTYPDOK]);
  end else if (bKosztyZlecenie_Rob or bKosztyZlecenie_RobNarzut) then begin
     q := SQLManager.CreateQuery(sSQL, [sZLEOSOBYGODZ]);
  end;
  *)
      if bKosztyZlecenie_Mat or bKosztyZlecenie_MatNarzut then begin
          if ZLEDM.vZLENarzuty and bKosztyZlecenie_MatNarzut then begin
            sCenaStr := '#' + SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuMat') + '(OBRPOZ.' + sZLEZLECENIEPOZ_ID + ', OBR.' + sUNIOKRES_ID + ') * OBRPOZ.' + sMAGOBRPOZ_CENA;
            sWartStr := '#' + SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuMat') + '(OBRPOZ.' + sZLEZLECENIEPOZ_ID + ', OBR.' + sUNIOKRES_ID + ') * OBRPOZ.' + sMAGOBRPOZ_WARTOSC;
          end else begin
            sCenaStr := '#@'+sMAGALIAS_MAGOBRPOZ_CENA;
            sWartStr := '#@'+sMAGALIAS_MAGOBRPOZ_WARTOSC;
          end;

          sSQL := MAGDM.OdpytajODaneSQL( cMAGOBRPOZ,
                                         '#@'+sMAGALIAS_MAGOBR_DATA_DOK+' as '+sZLESZCZEGOLY_DATA+';'+
                                         '#@'+sMAGALIAS_MAGOBRPOZ_ZLECENIE_ID+';'+
                                         '#@'+sMAGALIAS_MAGOBR_OKRES_ID+';'+
                                         '#@'+sMAGALIAS_MAGOBRPOZ_ASORT_ID+';'+
                                         '#@'+sMAGALIAS_ASORT_SYMBOL+';'+
                                         '#@'+sMAGALIAS_ASORT_NAZWA+';'+
                                         '#@'+sMAGALIAS_JM_SYMBOL+';'+
                                         '#@'+sMAGALIAS_MAGAZYN_SYMBOL+';'+
                                         '#@'+sMAGALIAS_MAGTYPDOK_SYMBOL+';'+
                                         '#@'+sMAGALIAS_MAGOBR_NUMER+';'+
                                         '#@'+sMAGALIAS_MAGOBRPOZ_LP+';'+
                                         '#CASE @'+sMAGALIAS_MAGOBRPOZ_ZNAK+' WHEN -1 THEN ''-'' WHEN 1 THEN ''+'' END as '+sMAGOBRPOZ_ZNAK+';'+
                                         '#null as '+sKDOSOBA_IMIE+';'+
                                         '#null as '+sKDOSOBA_NAZWISKO+';'+
                                         sCenaStr + ' as '+sZLESZCZEGOLY_CENA+';'+
                                         '#@'+sMAGALIAS_MAGOBRPOZ_ILOSC+' as '+sZLESZCZEGOLY_ILOSC+';'+
                                         sWartStr + ' as '+sZLESZCZEGOLY_WARTOSC,
                                         '(@'+sMAGALIAS_MAGOBRPOZ_ZLECENIE_ID+'='+IntToStr(iZLECENIE_ID)+')'+
                                         sTypDokSpecWhere+sOkresWhereMat+sPozWhereMat,
                                         False, vAktywnaFirma );
          if bKosztyZlecenie_Rob or bKosztyZlecenie_RobNarzut then
             sSQL := sSQL+' UNION ALL ';
      end;

      if bKosztyZlecenie_Rob or bKosztyZlecenie_RobNarzut then begin
         if ZLEDM.vZLENarzuty and bKosztyZlecenie_RobNarzut then begin
            sCenaStr := SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuRob') + '(OSOBYGODZ.' + sZLEZLECENIEPOZ_ID + ', OSOBYGODZ.' + sUNIOKRES_ID + ') * (NVL(OSOBYGODZ.' + sZLEZASOBYPRACA_STAWKA + ', 0))';
            sWartStr := SQLManager.GetSPName(sZLE_PACKAGE + '.ZLEWspNarzutuRob') + '(OSOBYGODZ.' + sZLEZLECENIEPOZ_ID + ', OSOBYGODZ.' + sUNIOKRES_ID + ') * (NVL(OSOBYGODZ.' + sZLEZASOBYPRACA_STAWKA + ' * OSOBYGODZ.' + sZLEZASOBYPRACA_CZAS_PRACY + sTmp;
         end else begin
            sCenaStr := '(NVL(OSOBYGODZ.' + sZLEZASOBYPRACA_STAWKA + ', 0))';
            sWartStr := '(NVL(OSOBYGODZ.' + sZLEZASOBYPRACA_STAWKA + ' * OSOBYGODZ.' + sZLEZASOBYPRACA_CZAS_PRACY + sTmp;
         end;


         sSQL := sSQL +
              'SELECT   OSOBYGODZ.' + sZLEZASOBYPRACA_DATA  +  ' AS ' + sZLESZCZEGOLY_DATA + ', ' +
                       'OSOBYGODZ.' + sZLEZLECENIE_ID + ', ' +
                       'OSOBYGODZ.' + sUNIOKRES_ID + ', ' +
                       'OSOBYGODZ.' + sASOASORT_ID + ', ' +
                       'ASORT.' + sASOASORT_SYMBOL + ', ' +
                       'ASORT.' + sASOASORT_NAZWA + ', ' +
                       'JM.' + sUNIJM_SYMBOL + ', ' +
                       'NULL AS ' + sUNIMAGAZYN_SYMBOL + ', ' +
                       'NULL AS ' + sMAGTYPDOK_SYMBOL + ', ' +
                       'NULL AS ' + sMAGOBR_NR_DOK + ', ' +
                       'NULL AS ' + sMAGOBRPOZ_LP + ', ' +
                       'NULL AS ' + sMAGOBRPOZ_ZNAK + ', ' +
                       'OSOBA.' + sKDOSOBA_IMIE + ', ' +
                       'OSOBA.' + sKDOSOBA_NAZWISKO + ', ' +
                       sCenaStr + ' AS ' + sZLESZCZEGOLY_CENA + ', ' +
                       'SUM(NVL(OSOBYGODZ.' + sZLEZASOBYPRACA_CZAS_PRACY + sTmp + sZLESZCZEGOLY_ILOSC + ', ' +
                       'SUM(' + sWartStr + ') AS '+ sZLESZCZEGOLY_WARTOSC + ' ' +
              'FROM    ' + SQLManager.GetTableName(sZLEZASOBYPRACA) + ' OSOBYGODZ, ' +
                           SQLManager.GetTableName(sASOASORT) + ' ASORT, ' +
                           SQLManager.GetTableName(sUNIJM) + ' JM, ' +
                           SQLManager.GetTableName(sKDOSOBA) + ' OSOBA ' +
              'WHERE    OSOBYGODZ.' + sASOASORT_ID + ' = ASORT.' + sASOASORT_ID + ' (+) AND ' +
                       'OSOBYGODZ.' + sKDOSOBA_ID  + ' = OSOBA.' + sKDOSOBA_ID  + ' (+) AND ' +
                       'ASORT.'     + sUNIJM_ID1   + ' = JM.'    + sUNIJM_ID    + ' (+) AND ' +
                       '(OSOBYGODZ.' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZLECENIE_ID) + ') ' +
                       sOkresWhereRob2 +
                       sPozWhereRob +
              'GROUP BY OSOBYGODZ.' + sZLEZASOBYPRACA_DATA + ', ' +
                       'OSOBYGODZ.' + sZLEZLECENIE_ID + ', ' +
                       'OSOBYGODZ.' + sUNIOKRES_ID + ', ' +
                       'OSOBYGODZ.' + sASOASORT_ID + ', ' +
                       'ASORT.'     + sASOASORT_SYMBOL + ', ' +
                       'ASORT.'     + sASOASORT_NAZWA + ', ' +
                       'JM.'        + sUNIJM_SYMBOL + ', ' +
                       'OSOBA.'     + sKDOSOBA_IMIE + ', ' +
                       'OSOBA.'     + sKDOSOBA_NAZWISKO + ', ' +
                       sCenaStr;

         {sSQL := sSQL + ZLEDM.ZLEOdpytajODaneSQL( sZLEOSOBYGODZ,
                                               '#@'+sZLEALIAS_OSOBYGODZ_DATA+' as '+sZLESZCZEGOLY_DATA+';'+
                                               '#@'+sZLEALIAS_OSOBYGODZ_ZLECENIE_ID+';'+
                                               '#@'+sZLEALIAS_OSOBYGODZ_OKRES_ID+';'+
                                               '#@'+sZLEALIAS_OSOBYGODZ_ASORT_ID+';'+
                                               '#@'+sZLEALIAS_ASORT_SYMBOL+';'+
                                               '#@'+sZLEALIAS_ASORT_NAZWA+';'+
                                               '#@'+sZLEALIAS_JM_SYMBOL+';'+
                                               '#null as '+sUNIMAGAZYN_SYMBOL+';'+
                                               '#null as '+sMAGTYPDOK_SYMBOL+';'+
                                               '#null as '+sMAGOBR_NR_DOK+';'+
                                               '#null as '+sMAGALIAS_MAGOBRPOZ_LP+';'+
                                               '#null as '+sMAGOBRPOZ_ZNAK+';'+
                                               '#@'+sZLEALIAS_OSOBA_IMIE+';'+
                                               '#@'+sZLEALIAS_OSOBA_NAZWISKO+';'+
                                               sCenaStr + sZLESZCZEGOLY_CENA+';'+
                                               '#(NVL(@'+sZLEALIAS_OSOBYGODZ_ILOSC + sTmp + ' AS ' + sZLESZCZEGOLY_ILOSC+';'+
                                               sWartStr + sZLESZCZEGOLY_WARTOSC,
                                               '(@'+sZLEALIAS_OSOBYGODZ_ZLECENIE_ID+'='+IntToStr(iZLECENIE_ID)+')'+
                                               sOkresWhereRob+sPozWhereRob, False );}
      end;

    end;
  end;
  if sSQL <> '' then begin
    if aRodzajKosztow = rkMaterialy then
         sSQL := sSQL + ' ORDER BY 2'  //Data, 1 = ROWNUM
    else sSQL := sSQL + ' ORDER BY 1'; //Data
    result := SQLManager.CreateQuery( sSQL );
  end;
end;

procedure TZLEDataManager.ZLEPokazZasob(
  const ac_iZasobId:  integer
);
begin
  FormManager.OpenDBDetail(
    Self,
    'TZLEZasobDBDetailForm',
    omView + omShowModal,
    TKeyValues.CreateAs([
      cFORM_CAPTION + '=Zasb',
      sZLEZASOB_ID + '=' + IntToStr(ac_iZasobId)
    ])
  );
end;

procedure TZLEDataManager.AktualizujWyceneZlecen(
  const ac_sZleceniaId: string
);
begin
  if(not SQLManager.SprawdzIstnienieSekwencera(sZLEZLECENIEWYC)) then
    UniqueKey[sZLEZLECENIEWYC];
  SQLManager.ExecuteQuery(
    'INSERT INTO ' +
      '%s W' +
    '(' +
      sZLEZLECENIEWYC_ID      + ', ' + sZLEZLECENIE_ID        + ', ' +
      sZLEZASOB_ID            + ', ' + sLWPRECEPPOZ_ID        + ', ' +
      sZLEZLECENIEWYC_KOSZT   + ', ' + sZLEZLECENIEWYC_STATUS + ', ' +
      sZLEZLECENIEWYC_UZ_AU_ID+ ', ' + sZLEZLECENIEWYC_DATA_AU+
    ') ( ' +
    'SELECT ' +
      SQLManager.GetGeneratorName(sZLEZLECENIEWYC)  + '.NextVal, ' +
      'PR.*, 0, ''' + cZLEConstZleWycenaStatus_WprowadzonyID + ''', ' +
      IntToStr(SecurityManager.UserId)  + ', SysDate' +
    ' from '  +
      '(' +
        'select distinct ' +
          'PR.' + sZLEZLECENIE_ID + ', PR.' + sZLEZASOB_ID    + ', ' +
          'PR.' + sLWPRECEPPOZ_ID +
        ' FROM ' +
          '%s PR' +
            ' left outer join %s WYC' +
              ' ON (' +
                'PR.' + sZLEZLECENIE_ID + ' = WYC.' + sZLEZLECENIE_ID + ' AND ' +
                'PR.' + sZLEZASOB_ID    + ' = WYC.' + sZLEZASOB_ID    + ' AND ' +
                'PR.' + sLWPRECEPPOZ_ID + ' = WYC.' + sLWPRECEPPOZ_ID +
              ')' +
        ' where ' +
          'WYC.'  + sZLEZLECENIEWYC_ID  + ' IS NULL AND ' +
          'PR.'   + sZLEZASOBYPRACA_STATUS  + ' = ''' + cZLEConstZasobPracaStatus_ZaakceptowanyID + ''' and ' +
          'PR.'   + sLWPRECEPPOZ_ID     + ' IS NOT null and '  +
          'PR.'   + sZLEZLECENIE_ID     + ' in(' + ac_sZleceniaId + ')' +
      ') PR'  +
    ')',
    [
      sZLEZLECENIEWYC,  sZLEZASOBYPRACA , sZLEZLECENIEWYC
    ]
  );
end;

procedure TZLEDataManager.AkceptujWyceneZlecen(
  const ac_aZleceniaWycIds: array of integer
);
var
  oIds: TStringList;
  i:    integer;
begin
  oIds  := TStringList.Create();
  try
    for i := Low(ac_aZleceniaWycIds) to High(ac_aZleceniaWycIds) do
      oIds.Add(IntToStr(ac_aZleceniaWycIds[i]));
    ADMID_Save(cADMIDFunZLEZlecWycenaAkceptacja, 0, SecurityManager.UserId, '', nil, oIds);
    SQLManager.ExecuteQuery(
      'update %s W' +
      ' set W.' + sZLEZLECENIEWYC_STATUS + ' = ''' + cZLEConstZleWycenaStatus_ZaakceptowanyID + '''' +
      ' where ' +
        'W.' + sZLEZLECENIEWYC_STATUS + ' <> ''' + cZLEConstZleWycenaStatus_ZaakceptowanyID + ''' and ' +
        'W.' + sZLEZLECENIEWYC_ID + ' in(' +
          ADMID_SelectSQL(cADMIDFunZLEZlecWycenaAkceptacja, 0, SecurityManager.UserId, '')  +
        ')',
      [sZLEZLECENIEWYC]
    );
  finally
    oIds.Free();
    ADMID_DelAll(cADMIDFunZLEZlecWycenaAkceptacja, 0, SecurityManager.UserId, '');
  end;
end;

procedure TZLEDataManager.CofnijAkceptacjeWycenyZlecen(
  const ac_aZleceniaWycIds: array of integer
);
var
  oIds: TStringList;
  i:    integer;
begin
  oIds  := TStringList.Create();
  try
    for i := Low(ac_aZleceniaWycIds) to High(ac_aZleceniaWycIds) do
      oIds.Add(IntToStr(ac_aZleceniaWycIds[i]));
    ADMID_Save(cADMIDFunZLEZlecWycenaCofAkceptacje, 0, SecurityManager.UserId, '', nil, oIds);
    SQLManager.ExecuteQuery(
      'update %s W' +
      ' set W.' + sZLEZLECENIEWYC_STATUS + ' = ''' + cZLEConstZleWycenaStatus_WprowadzonyID + '''' +
      ' where ' +
        'W.' + sZLEZLECENIEWYC_STATUS + ' = ''' + cZLEConstZleWycenaStatus_ZaakceptowanyID + ''' and ' +
        'W.' + sZLEZLECENIEWYC_ID + ' in(' +
          ADMID_SelectSQL(cADMIDFunZLEZlecWycenaCofAkceptacje, 0, SecurityManager.UserId, '')  +
        ')',
      [sZLEZLECENIEWYC]
    );
  finally
    oIds.Free();
    ADMID_DelAll(cADMIDFunZLEZlecWycenaCofAkceptacje, 0, SecurityManager.UserId, '');
  end;
end;

procedure TZLEDataManager.AkceptujPraceZasobow(
  const ac_aZasobyPracaIds: array of integer
);
var
  sWhere: string;
begin
  sWhere  := UNIArray2Where(ac_aZasobyPracaIds, 'PR.' + sZLEZASOBYPRACA_ID);
  SQLManager.ExecuteQuery(
    'update %s PR set PR.' + sZLEZASOBYPRACA_STATUS + ' = ''' + cZLEConstZasobPracaStatus_ZaakceptowanyID + '''' +
    ' where ' + sWhere,
    [sZLEZASOBYPRACA]
  );
end;

function  TZLEDataManager.MoznaEdytowacZlecenieProdukcyjne(
  const ac_iZlecenieId:       integer
):  string;
begin
  result  := SQLManager.OpenQueryWithResult(
    'select %s(' + IntToStr(ac_iZlecenieId) + ') from dual',
    [sZLE_PACKAGE + '.' + sMoznaEdytowacZlecenieProd]
  );
end;

  {
    Funkcja sprawdza czy podane zlecenie zostao umieszczone na planie produkcji.
  }
function  TZLEDataManager.ZlecenieNaPlanieProdukcji(
  const ac_iZlecenieId:       integer
):  boolean;
begin
  if(DataManagers.Available(sLWPModulID)) then begin
    result  := (SQLManager.OpenQueryWithResult(
      'select %s(' + IntToStr(ac_iZlecenieId) + ') from dual',
      [sLWP_PACKAGE + '.' + sLWPZlecenieUzyteWPlanowaniu]
    ) = sTak);
  end else
    result  := false;
end;

{
  Funkcja sprawdza czy dla podanych parametrw jest ju utworzony rekord wyceny
  zlecenia. Jeeli tak to nie mona usun adnego rekordu czasu pracy zasobu
  powizanego z podanym zleceniem, zasobem i pozycj receptury.
  @param  ac_iZlecenieId
  @param  ac_iZasobId
  @param  ac_iRecepturaPozId
  @returns  True jeeli nie ma adnego rekordu wyceny dla podanego kompletu danych
}
function  TZLEDataManager.UtworzonyRekordWyceny(
  const ac_iZlecenieId:     integer;
  const ac_iZasobId:        integer;
  const ac_iRecepturaPozId: integer
):  boolean;
var
  oQuery: TUNIQuery;
  sWhere: string;
begin
  if(ac_iZlecenieId <> 0) then
    sWhere  := 'W.'  + sZLEZLECENIE_ID + ' = ' + IntToStr(ac_iZlecenieId) + ' and '
  else begin
      // zlecenie jest wymagane w wycenie ale nie jest wymagane w pracy zasobw
    sWhere  := 'W.'  + sZLEZLECENIE_ID + ' is null and ';
  end;
  sWhere  := sWhere + 'W.'  + sZLEZASOB_ID    + ' = ' + IntToStr(ac_iZasobId) + ' and ';
  if(ac_iRecepturaPozId <> 0) then
    sWhere  := sWhere + 'W.'  + sLWPRECEPPOZ_ID + ' = ' + IntToStr(ac_iRecepturaPozId)
  else begin
    sWhere  := sWhere + 'W.'  + sLWPRECEPPOZ_ID + ' is null';
  end;
  oQuery  := SQLManager.CreateQuery(
    'select W.' + sZLEZLECENIEWYC_ID  +
    ' from %s W' +
    ' where ' +
      sWhere,
    [sZLEZLECENIEWYC]
  );
  try
    oQuery.Open();
    result  := (not oQuery.IsEmpty());
  finally
    oQuery.Free();
  end;
end;

{
  Funkcja ustawia podanemu zleceniu status na ac_sNowyStatus
  @param  ac_iZlecenieId  - id zlecenia, ktremu ma by zmieniony status
  @param  ac_sNowyStatus  - nowy status ktry ma mie zlecenie
}
procedure TZLEDataManager.ZmienStatusZlecenia(
  const ac_iZlecenieId:     integer;
  const ac_sNowyStatus:     string
);
begin
  SQLManager.ExecuteQuery(
    'update %s Z set Z.' + sZLEZLECENIE_STATUS + ' = ''' + ac_sNowyStatus + '''' +
    ' where Z.' + sZLEZLECENIE_ID + ' = ' + IntToStr(ac_iZlecenieId),
    [sZLEZLECENIE]
  );
end;

{
  Funkcja sprawdza czy podane zlecenie zostao wysane do partnera (istnieje zapis w ZLEZLECENIEOBCY).
  @param  ac_iZlecenieId  - id zlecenia
}
function  TZLEDataManager.ZlecenieWyslaneDoPartnera(
  const ac_iZlecenieId:     integer
):  boolean;
{$ifndef build_all}
var
  oQuery: TUNIQuery;
{$endif}
begin
{$ifndef build_all}
  oQuery  := SQLManager.CreateQuery(
    'select 1 from dual where exists(' +
      'select * from %s ZO where ZO.' + sZLEZLECENIE_ID + ' = :' + sZLEZLECENIE_ID +
    ')',
    [sZLEZLECENIEOBCY]
  );
  oQuery.Params[0].AsInteger  := ac_iZlecenieId;
  oQuery.Open();
  result  := (oQuery.Fields[0].AsInteger = 1);
  oQuery.Free();
{$else}
  result  := false;
{$endif}
end;

{
  Funkcja sprawdza czy podana receptura zostaa wysana do partnera (istnieje zapis w ZLEZLECENIEOBCY).
  @param  ac_iRecepturaId - id receptury
}
function  TZLEDataManager.RecepturaWyslanaDoPartnera(
  const ac_iRecepturaId:    integer
):  boolean;
{$ifndef build_all}
var
  oQuery: TUNIQuery;
{$endif}
begin
{$ifndef build_all}
  oQuery  := SQLManager.CreateQuery(
    'select 1 from dual where exists(' +
      'select * from %s ZO, %s RP' +
      ' where ' +
        'ZO.' + sLWPRECEPPOZ_ID + ' = RP.' + sLWPRECEPPOZ_ID +
        ' and RP.' + sLWPRECEPTURA_ID + ' = :' + sLWPRECEPTURA_ID +
    ')',
    [sZLEZLECENIEOBCY, sLWPRECEPPOZ]
  );
  oQuery.Params[0].AsInteger  := ac_iRecepturaId;
  oQuery.Open();
  result  := (oQuery.Fields[0].AsInteger = 1);
  oQuery.Free();
{$else}
  result  := false;
{$endif}
end;

{
  Funkcja sprawdza czy podana pozycja receptury zostaa wysana do partnera (istnieje zapis w ZLEZLECENIEOBCY).
  @param  ac_iRecepturaPozId - id pozycji receptury
}
function  TZLEDataManager.RecepturaPozWyslanaDoPartnera(
  const ac_iRecepturaPozId: integer
):  boolean;
{$ifndef build_all}
var
  oQuery: TUNIQuery;
{$endif}
begin
{$ifndef build_all}
  oQuery  := SQLManager.CreateQuery(
    'select 1 from dual where exists(' +
      'select * from %s ZO where ZO.' + sLWPRECEPPOZ_ID + ' = :' + sLWPRECEPPOZ_ID +
    ')',
    [sZLEZLECENIEOBCY]
  );
  oQuery.Params[0].AsInteger  := ac_iRecepturaPozId;
  oQuery.Open();
  result  := (oQuery.Fields[0].AsInteger = 1);
  oQuery.Free();
{$else}
  result  := false;
{$endif}
end;

{
  Funkcja sprawdza czy podany element planu zosta wysana do partnera (istnieje zapis w ZLEZLECENIEOBCY).
  @param  ac_iPlanProdElId  - id elementu planu produkcji
}
function  TZLEDataManager.PlanProdElWyslanyDoPartnera(
  const ac_iPlanProdElId:   integer
):  boolean;
{$ifndef build_all}
var
  oQuery: TUNIQuery;
{$endif}
begin
{$ifndef build_all}
  oQuery  := SQLManager.CreateQuery(
    'select 1 from dual where exists(' +
      'select * from %s ZO where ZO.' + sLWPPLANPRODEL_ID + ' = :' + sLWPPLANPRODEL_ID +
    ')',
    [sZLEZLECENIEOBCY]
  );
  oQuery.Params[0].AsInteger  := ac_iPlanProdElId;
  oQuery.Open();
  result  := (oQuery.Fields[0].AsInteger = 1);
  oQuery.Free();
{$else}
  result  := false;
{$endif}
end;

function TZLEDataManager.DajListeAktualizacji: TStringList;
begin
  result:= inherited DajListeAktualizacji;
  ZLEUpdateUnit.DajListeAktualizacji( result );
end;

function TZLEDataManager.UruchomAktualizacje(nr: string): boolean;
begin
  result := ZLEUpdateUnit.UruchomAktualizacje( nr );
end;

procedure TZLEDataManager.ZasobyMenuItemClick(Sender: TObject);
var
  oParams: TKeyValues;
  AOpenMode: TOpenMode;
begin
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add(cRangeClassName+'=TZLEZasobyZakresForm');
    Add(cFORM_CAPTION+'='+'Zasoby');
  end;
  AOpenMode := omList or omMultiSelect;
  FormManager.OpenDBGrid( Self, cZLEZasobDBGridFormClass, AOpenMode, oParams );
end;

procedure TZLEDataManager.AnalizaRozliczenieZasobowMenuItemClick(
  Sender: TObject);
begin
  ZLEPokazIObsluzDane( sZLEZLECENIEROZL, '', '', True, False, cZLEModulZSI_ID );
end;

procedure TZLEDataManager.GetFunctionality(FC: TFunkCollection);
begin
  with FC do begin
    Add( sSPM, sZLE, 'Zlecenia' );
    Add(   sZLE, sZLE_USTAW,                                                          'Ustawienia' );
    Add(     sZLE_USTAW, sZLE_USTAW_PARAM,                                            'Parametry' );
    Add(     sZLE_USTAW, sZLE_USTAW_DEF,                                              'Definicje' );
    Add(       sZLE_USTAW_DEF, sZLE_USTAW_DEF_SKL_KONTR_WART,                         'Skadniki kontroli wartociowej' );
    Add(         sZLE_USTAW_DEF_SKL_KONTR_WART, sZLE_USTAW_DEF_SKL_KONTR_WART_POKAZ,  'Skladniki kontroli wartociowej - poka' );
    Add(         sZLE_USTAW_DEF_SKL_KONTR_WART, sZLE_USTAW_DEF_SKL_KONTR_WART_DOPISZ, 'Skladniki kontroli wartociowej - dopisz' );
    Add(         sZLE_USTAW_DEF_SKL_KONTR_WART, sZLE_USTAW_DEF_SKL_KONTR_WART_ZMIEN,  'Skladniki kontroli wartociowej - zmie' );
    Add(         sZLE_USTAW_DEF_SKL_KONTR_WART, sZLE_USTAW_DEF_SKL_KONTR_WART_USUN,   'Skladniki kontroli wartociowej - usu' );
    Add(       sZLE_USTAW_DEF, sZLE_USTAW_DEF_SKL_KONTR_IL,                           'Skladniki kontroli ilociowej' );
    Add(         sZLE_USTAW_DEF_SKL_KONTR_IL, sZLE_USTAW_DEF_SKL_KONTR_IL_POKAZ,      'Skladniki kontroli ilociowej - poka' );
    Add(         sZLE_USTAW_DEF_SKL_KONTR_IL, sZLE_USTAW_DEF_SKL_KONTR_IL_DOPISZ,     'Skladniki kontroli ilociowej - dopisz' );
    Add(         sZLE_USTAW_DEF_SKL_KONTR_IL, sZLE_USTAW_DEF_SKL_KONTR_IL_ZMIEN,      'Skladniki kontroli ilociowej - zmie' );
    Add(         sZLE_USTAW_DEF_SKL_KONTR_IL, sZLE_USTAW_DEF_SKL_KONTR_IL_USUN,       'Skladniki kontroli ilociowej - usu' );
    Add(       sZLE_USTAW_DEF, sZLE_USTAW_DEF_TYP_ZLEC,                               'Typy zlece' );
    Add(         sZLE_USTAW_DEF_TYP_ZLEC, sZLE_USTAW_DEF_TYP_ZLEC_POKAZ,              'Typy zlece - poka' );
    Add(         sZLE_USTAW_DEF_TYP_ZLEC, sZLE_USTAW_DEF_TYP_ZLEC_DOPISZ,             'Typy zlece - dopisz' );
    Add(         sZLE_USTAW_DEF_TYP_ZLEC, sZLE_USTAW_DEF_TYP_ZLEC_ZMIEN,              'Typy zlece - zmie' );
    Add(         sZLE_USTAW_DEF_TYP_ZLEC, sZLE_USTAW_DEF_TYP_ZLEC_ZMIEN_UPR,          'Typy zlece - modyfikacja zakadki uprawnieni uytkownicy' );
    Add(         sZLE_USTAW_DEF_TYP_ZLEC, sZLE_USTAW_DEF_TYP_ZLEC_USUN,               'Typy zlece - usu' );
    Add(       sZLE_USTAW_DEF, sZLE_USTAW_DEF_NUM_ZLEC,                               'Numeratory zlece' );
    Add(         sZLE_USTAW_DEF_NUM_ZLEC, sZLE_USTAW_DEF_NUM_ZLEC_POKAZ,              'Numeratory zlece - poka' );
    Add(         sZLE_USTAW_DEF_NUM_ZLEC, sZLE_USTAW_DEF_NUM_ZLEC_DOPISZ,             'Numeratory zlece - dopisz' );
    Add(         sZLE_USTAW_DEF_NUM_ZLEC, sZLE_USTAW_DEF_NUM_ZLEC_ZMIEN,              'Numeratory zlece - zmie' );
    Add(         sZLE_USTAW_DEF_NUM_ZLEC, sZLE_USTAW_DEF_NUM_ZLEC_USUN,               'Numeratory zlece - usu' );
    Add(       sZLE_USTAW_DEF, sZLE_USTAW_DEF_NUM_ZASOBOW,                            'Numeratory zasobw' );
    Add(         sZLE_USTAW_DEF_NUM_ZASOBOW, sZLE_USTAW_DEF_NUM_ZASOBOW_POKAZ,        'Numeratory zasobw - poka' );
    Add(         sZLE_USTAW_DEF_NUM_ZASOBOW, sZLE_USTAW_DEF_NUM_ZASOBOW_DOPISZ,       'Numeratory zasobw - dopisz' );
    Add(         sZLE_USTAW_DEF_NUM_ZASOBOW, sZLE_USTAW_DEF_NUM_ZASOBOW_ZMIEN,        'Numeratory zasobw - zmie' );
    Add(         sZLE_USTAW_DEF_NUM_ZASOBOW, sZLE_USTAW_DEF_NUM_ZASOBOW_USUN,         'Numeratory zasobw - usu' );
    Add(       sZLE_USTAW_DEF, sZLE_USTAW_KRYTERIA,                                   'Kryteria' );
    Add(         sZLE_USTAW_KRYTERIA, sZLE_USTAW_KRYTERIA_POKAZ,                      'Kryteria - poka' );
    Add(         sZLE_USTAW_KRYTERIA, sZLE_USTAW_KRYTERIA_DOPISZ,                     'Kryteria - dopisz' );
    Add(         sZLE_USTAW_KRYTERIA, sZLE_USTAW_KRYTERIA_ZMIEN,                      'Kryteria - zmie' );
    Add(         sZLE_USTAW_KRYTERIA, sZLE_USTAW_KRYTERIA_USUN,                       'Kryteria - usu' );
    Add(         sZLE_USTAW_KRYTERIA, sZLE_USTAW_KRYTERIA_PRZELICZ,                   'Kryteria - Przelicz' );
    Add(         sZLE_USTAW_KRYTERIA, sZLE_USTAW_KRYTERIA_POZYCJE,                    'Kryteria - Pozycje' );
    Add(       sZLE_USTAW_DEF, sZLE_USTAW_DEF_NARZUTY,                                'Narzuty' );
    Add(         sZLE_USTAW_DEF_NARZUTY, sZLE_USTAW_DEF_NARZUTY_POKAZ,                'Narzuty - poka' );
    Add(         sZLE_USTAW_DEF_NARZUTY, sZLE_USTAW_DEF_NARZUTY_DOPISZ,               'Narzuty - dopisz' );
    Add(         sZLE_USTAW_DEF_NARZUTY, sZLE_USTAW_DEF_NARZUTY_ZMIEN,                'Narzuty - zmie' );
    Add(         sZLE_USTAW_DEF_NARZUTY, sZLE_USTAW_DEF_NARZUTY_USUN,                 'Narzuty - usu' );
    Add(       sZLE_USTAW_DEF, sZLE_USTAW_DEF_POLAUZ,                                 'Pola uytkownika' );
    Add(     sZLE_USTAW, sZLE_USTAW_SLOW,                                             'Sowniki' );
    Add(       sZLE_USTAW_SLOW, sZLE_USTAW_SLOW_ZASOBY,                               'Zasoby' );
    Add(         sZLE_USTAW_SLOW_ZASOBY, sZLE_USTAW_SLOW_ZASOBY_POKAZ,                'Zasoby - poka' );
    Add(         sZLE_USTAW_SLOW_ZASOBY, sZLE_USTAW_SLOW_ZASOBY_DOPISZ,               'Zasoby - dopisz' );
    Add(         sZLE_USTAW_SLOW_ZASOBY, sZLE_USTAW_SLOW_ZASOBY_ZMIEN,                'Zasoby - zmie' );
    Add(         sZLE_USTAW_SLOW_ZASOBY, sZLE_USTAW_SLOW_ZASOBY_USUN,                 'Zasoby - usu' );
    Add(       sZLE_USTAW_SLOW, sZLE_USTAW_SLOW_BRAKI,                                'Braki');
    Add(         sZLE_USTAW_SLOW_BRAKI, sZLE_USTAW_SLOW_BRAKI_POKAZ,                  'Braki - poka' );
    Add(         sZLE_USTAW_SLOW_BRAKI, sZLE_USTAW_SLOW_BRAKI_DOPISZ,                 'Braki - dopisz' );
    Add(         sZLE_USTAW_SLOW_BRAKI, sZLE_USTAW_SLOW_BRAKI_ZMIEN,                  'Braki - zmie' );
    Add(         sZLE_USTAW_SLOW_BRAKI, sZLE_USTAW_SLOW_BRAKI_USUN,                   'Braki - usun' );
    Add(       sZLE_USTAW_SLOW, sZLE_USTAW_SLOW_PREFIX,                               'Prefiksy' );
    Add(         sZLE_USTAW_SLOW_PREFIX, sZLE_USTAW_SLOW_PREFIX_POKAZ,                'Prefiksy - poka' );
    Add(         sZLE_USTAW_SLOW_PREFIX, sZLE_USTAW_SLOW_PREFIX_DOPISZ,               'Prefiksy - dopisz' );
    Add(         sZLE_USTAW_SLOW_PREFIX, sZLE_USTAW_SLOW_PREFIX_ZMIEN,                'Prefiksy - zmie' );
    Add(         sZLE_USTAW_SLOW_PREFIX, sZLE_USTAW_SLOW_PREFIX_USUN,                 'Prefiksy - usu' );

    Add(       sZLE_USTAW_SLOW, sZLE_USTAW_SLOW_GRUPYKALEND, 'Grupy kalendarzowe');
    Add(         sZLE_USTAW_SLOW_GRUPYKALEND, sZLE_USTAW_SLOW_GRUPYKALEND_POKAZ  , 'Wywietlenie grupy kalendarzowej');
    Add(         sZLE_USTAW_SLOW_GRUPYKALEND, sZLE_USTAW_SLOW_GRUPYKALEND_DOPISZ , 'Dopisanie grupy kalendarzowej');
    Add(         sZLE_USTAW_SLOW_GRUPYKALEND, sZLE_USTAW_SLOW_GRUPYKALEND_ZMIEN  , 'Modyfikacja grupy kalendarzowej');
    Add(         sZLE_USTAW_SLOW_GRUPYKALEND, sZLE_USTAW_SLOW_GRUPYKALEND_USUN   , 'Usunicie grupy kalendarzowej');
    Add(         sZLE_USTAW_SLOW_GRUPYKALEND, sZLE_USTAW_SLOW_GRUPYKALEND_PRZYWROC,'Przywrcenie nieaktywnej grupy kalendarzowej');
    Add(       sZLE_USTAW_SLOW, sZLE_USTAW_SLOW_SYSTEMYZMIANOWE, 'Systemy zmianowe');
    Add(         sZLE_USTAW_SLOW_SYSTEMYZMIANOWE, sZLE_USTAW_SLOW_SYSTEMYZMIANOWE_POKAZ  , 'Wywietlenie systemu zmianowego');
    Add(         sZLE_USTAW_SLOW_SYSTEMYZMIANOWE, sZLE_USTAW_SLOW_SYSTEMYZMIANOWE_DOPISZ , 'Dopisanie systemu zmianowego');
    Add(         sZLE_USTAW_SLOW_SYSTEMYZMIANOWE, sZLE_USTAW_SLOW_SYSTEMYZMIANOWE_ZMIEN  , 'Modyfikacja systemu zmianowego');
    Add(         sZLE_USTAW_SLOW_SYSTEMYZMIANOWE, sZLE_USTAW_SLOW_SYSTEMYZMIANOWE_USUN   , 'Usunicie systemu zmianowego');
    Add(       sZLE_USTAW_SLOW, sZLE_USTAW_SLOW_KALENDARZ, 'Kalendarz czasu pracy zasobw');
    Add(         sZLE_USTAW_SLOW_KALENDARZ, sZLE_USTAW_SLOW_KALENDARZ_POKAZ  , 'Wywietlenie kalendarza czasu pracy zasobw');
    Add(         sZLE_USTAW_SLOW_KALENDARZ, sZLE_USTAW_SLOW_KALENDARZ_ZMIEN  , 'Modyfikacja kalendarza czasu pracy zasobw');
    Add(         sZLE_USTAW_SLOW_KALENDARZ, sZLE_USTAW_SLOW_KALENDARZ_KOPIUJ , 'Kopiowanie kalendarza czasu pracy zasobw');
    Add(         sZLE_USTAW_SLOW_KALENDARZ, sZLE_USTAW_SLOW_KALENDARZ_GENERUJ, 'Generowanie kalendarza czasu pracy zasobw');
    Add(         sZLE_USTAW_SLOW_KALENDARZ, sZLE_USTAW_SLOW_KALENDARZ_IMPORT, 'Import kalendarza czasu pracy zasobw z pliku tekstowego');

    Add(   sZLE, sZLE_KART_ZLECEN,                                                    'Kartoteka zlece' );
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_POKAZ,                                'Kartoteka zlece - poka' );
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_DOPISZ,                               'Kartoteka zlece - dopisz' );
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_ZMIEN,                                'Kartoteka zlece - zmie' );
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_ZMIEN_ZAKONCZ,                        'Kartoteka zlece - zmie dla zakoczonego zlecenia' );
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_USUN,                                 'Kartoteka zlece - usu' );
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_POZYCJE,                              'Kartoteka zlece - pozycje');
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_KONTR_KOSZTOW,                        'Kartoteka zlece - kontrola kosztw');
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_KONTR_ILOSCI,                         'Kartoteka zlece - kontrola iloci');
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_KOSZTY_MAT,                           'Kartoteka zlece - koszty materiaowe');
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_KOSZTY_ROB,                           'Kartoteka zlece - koszty robocizny');
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_FAKTURY,                              'Kartoteka zlece - wystawione faktury');
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_ZASOBY,                               'Kartoteka zlece - zasoby');
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_KOSZTZAKUPU,                          'Kartoteka zlece - koszty zakupu');
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_ROZL_ZASOBOW,                         'Kartoteka zlece - rozliczenie zasobw');
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_POTW_EXT_ZLEC,                        'Kartoteka zlece - potwierdzanie nie swoich etapw zlece');
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_SRODKITRWALE,                         'Kartoteka zlece - rodki trwae');
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_CZASPRACYECP,                         'Kartoteka zlece - czas pracy z ECP');
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_TRANSPORT,                            'Kartoteka zlece - transport i sprzt');
    Add(       sZLE_KART_ZLECEN_ROZL_ZASOBOW, sZLE_KART_ZLECEN_ROZL_ZASOBOW_DOPISZ,   'Kartoteka zlece - rozliczenie zasobw - dopisz aut.');
    Add(       sZLE_KART_ZLECEN_ROZL_ZASOBOW, sZLE_KART_ZLECEN_ROZL_ZASOBOW_ROZL,     'Kartoteka zlece - rozliczenie zasobw - rozlicz aut.');
    Add(       sZLE_KART_ZLECEN_ROZL_ZASOBOW, sZLE_KART_ZLECEN_ROZL_ZASOBOW_ZMIEN,    'Kartoteka zlece - rozliczenie zasobw - zmie');
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_UTWORZ_ZAPOTRZ,                       'Kartoteka zlece - utwrz zapotrzebowanie');
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_WYCENA,                               'Kartoteka zlece - wycena pracy zasobw', fgNoRights);
    Add(       sZLE_KART_ZLECEN_WYCENA, sZLE_KART_ZLECEN_WYCENA_ZMIEN,                'Wycena pracy zasobw - zmie', fgNoRights);
    Add(       sZLE_KART_ZLECEN_WYCENA, sZLE_KART_ZLECEN_WYCENA_POKAZ,                'Wycena pracy zasobw - poka');
    Add(       sZLE_KART_ZLECEN_WYCENA, sZLE_KART_ZLECEN_WYCENA_AKTUALIZUJ,           'Wycena pracy zasobw - aktualizuj', fgNoRights);
    Add(       sZLE_KART_ZLECEN_WYCENA, sZLE_KART_ZLECEN_WYCENA_AKCEPTUJ,             'Wycena pracy zasobw - akceptuj', fgNoRights);
    Add(       sZLE_KART_ZLECEN_WYCENA, sZLE_KART_ZLECEN_WYCENA_COFNIJ_AKCEPT,        'Wycena pracy zasobw - cofnij akceptacj', fgNoRights);
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_WYSLIJ,                               'Kartoteka zlece - wysanie zlecenia do aplikacji partnera', fgNoRights);
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_WYCOFAJ,                              'Kartoteka zlece - wycofanie zlece z aplikacji partnera', fgNoRights);
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_WYSLIJ_PLAN,                          'Kartoteka zlece - wysanie planu produkcji zlece do aplikacji partnera', fgNoRights);
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_PLAN_WYCOFAJ,                         'Kartoteka zlece - wycofanie planu produkcji zlece z aplikacji partnera', fgNoRights);
    Add(     sZLE_KART_ZLECEN, sZLE_KART_ZLECEN_ZMIEN_STATUS,                         'Kartoteka zlece - zmiana statusu zlecenia', fgNoRights);
    Add(   sZLE, sZLE_KART_ZLECEN_UPR,                                                'Kartoteka zlece - wersja uproszczona');
    Add(     sZLE_KART_ZLECEN_UPR, sZLE_KART_ZLECEN_UPR_POKAZ,                        'Kartoteka zlece - wersja uproszczona - poka');
    Add(   sZLE, sZLE_REJ_CZASU_PRACY,                                                'Rejestracja czasu pracy' );
    Add(     sZLE_REJ_CZASU_PRACY, sZLE_REJ_CZASU_PRACY_POKAZ,                        'Rejestracja czasu pracy - poka' );
    Add(     sZLE_REJ_CZASU_PRACY, sZLE_REJ_CZASU_PRACY_DOPISZ,                       'Rejestracja czasu pracy - dopisz' );
    Add(     sZLE_REJ_CZASU_PRACY, sZLE_REJ_CZASU_PRACY_ZMIEN,                        'Rejestracja czasu pracy - zmie' );
    Add(     sZLE_REJ_CZASU_PRACY, sZLE_REJ_CZASU_PRACY_USUN,                         'Rejestracja czasu pracy - usu' );
    Add(     sZLE_REJ_CZASU_PRACY, sZLE_REJ_CZASU_PRACY_AKCEPTACJA,                   'Rejestracja czasu pracy - akceptacja' );
    Add(     sZLE_REJ_CZASU_PRACY, sZLE_REJ_CZASU_PRACY_UTWORZ_Z_MAG,                 'Rejestracja czasu pracy - utwrz z magazynu' );
    Add(     sZLE_REJ_CZASU_PRACY, sZLE_REJ_CZASU_PRACY_DATA_BLOKADY,                 'Rejestracja czasu pracy - modyfikacja daty blokady RCP' );
    Add(   sZLE, sZLE_ANALIZY,                                                        'Analizy' );
    Add(     sZLE_ANALIZY, sZLE_ANALIZY_ROZL_ZASOBOW,                                 'Rozliczenia zasobw' );
    Add(     sZLE_ANALIZY, sZLE_STOPIEN_REALIZACJI_ZLECEN,                            'Stopie realizacji zlece' );
    {Add(       sZLE_ANALIZY_ROZL_ZASOBOW, sZLE_ANALIZY_ROZL_ZASOBOW_POKAZ,            'Rozliczenia zasobw - poka' );
    Add(       sZLE_ANALIZY_ROZL_ZASOBOW, sZLE_ANALIZY_ROZL_ZASOBOW_DOPISZ,           'Rozliczenia zasobw - dopisz' );
    Add(       sZLE_ANALIZY_ROZL_ZASOBOW, sZLE_ANALIZY_ROZL_ZASOBOW_ZMIEN,            'Rozliczenia zasobw - zmie' );
    Add(       sZLE_ANALIZY_ROZL_ZASOBOW, sZLE_ANALIZY_ROZL_ZASOBOW_USUN,             'Rozliczenia zasobw - usu' );}
    Add(   sZLE, sZLE_PARAM,                                                          'Parametry pracy' );
  end;
end;

procedure TZLEDataManager.PolaUzMenuItemClick(Sender: TObject);
begin
  inherited;
   FormManager.OpenDBGrid( self, 'TZLEPoleZmDefDBGridForm', omList);
end;

procedure TZLEDataManager.PLLIKosztyClick(Sender: TObject);
var
  qKoszt: TUNIQuery;
  slListaKosztow: TStringList;
begin
//  inherited;
{  function PLPodajWartoscKosztow(iFirma,nRok,nMies:integer;slDefRozdzListaIDs:TStringList):Currency;
  function PokazIWybierzRodzajeKosztowRozdzielnika:TUNIQuery;}
  {$ifndef build_all}
  if DataManagers.Available(sPLLIModulID) then begin
     qKoszt := PLLIDM.PokazIWybierzRodzajeKosztowRozdzielnika;
     if qKoszt <> nil then begin
        slListaKosztow := TStringList.Create;
        while not qKoszt.Eof do begin
           slListaKosztow.Add(qKoszt.FieldByName(sPLROZDEF_ID).AsString);
           qKoszt.Next;
        end;
        PLLIDM.PLPodajWartoscKosztow(UNISYSDM.vAktywnaFirma, 1 {iZlecID}, 2006 {nRok}, 8{nMies},
                                     slListaKosztow {slDefRozdzListaIDs:TStringList});
     end;
  end;
  {$endif}
end;

function TZLEDataManager.PobierzTekst(var sText: String): Integer;
var
 oForm   : TUniForm;
 oParams : TKeyValues;
begin
  Result := -1; //Bd
  oParams := TKeyValues.CreateEmpty;
  if sText <> '' then begin
     oParams.Add('TEKST=' + sText);
  end;

  oForm := FormManager.OpenForm( self, 'TZLEPobierzTekstForm', omHidden, oParams);
  try
    if oForm.ShowModal = mrOK then begin
      {Zakomentowane - zwraca -1 gdy zatwierdzono ''}
      {if oForm.Parameters.Values['TEKST'] <> '' then begin}
         sText := oForm.Parameters.Values['TEKST'];
         Result := 0;
      {end;}
    end;
  finally
    if oForm <> nil then oForm.Free;
  end;
end;

procedure TZLEDataManager.PrzeliczanieTimerTimer(Sender: TObject);
var
  sDataStr: String;
  hh,mm,ss,ms: Word;
begin
  inherited;
  {$ifdef build_zle}
  PrzeliczanieTimer.Enabled := vZLEPrzeliczanieWlaczone;
  if vZLEPrzeliczanieWlaczone then begin

     DecodeTime(UniNow(),hh,mm,ss,ms);
     sDataStr := ZZBPadL(inttostr(hh),2,'0') + ':' + ZZBPadL(inttostr(mm),2,'0');
     if sDataStr = vZLEPrzeliczanieGodzina then begin
       // Komunikat(cInformation, 'Rozpoczynam przeliczanie zlece');
       try
         PrzeliczanieTimer.Enabled := False;
         ZLEDM.vZLEPrzeliczanie := True;
         PrzeliczZlecenia();
       finally
         PrzeliczanieTimer.Enabled := vZLEPrzeliczanieWlaczone;
         ZLEDM.vZLEPrzeliczanie := False;
       end;
     end;
  end;
  {$endif}
end;

{$ifdef build_zle}
procedure TZLEDataManager.PrzeliczZlecenia();
var
  oParams: TKeyValues;
  Form : TUNIDBGridForm;
begin
  if not SecurityManager.SM_UserCanDo(sZLE_KART_ZLECEN) then Exit;

  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add(cFORM_CAPTION+'='+'Zlecenia');
    Add(sUNIMODULZSI_ID+'='+IntToStr(cZLEModulZSI_ID));
    Add(cZLEFuncRodzaj+'='+cZLEFuncZlecenie);
    Add(sParam_ZLEPrzeliczanie + '=');
    Add(cZLELista_Optymalizacja + '=');
   end;
  try
    Form := ZLEPokazIObsluzDaneGrid( Self, sZLEZLECENIE, '', '', False,
                                     True, omList or omHidden,
                                     cZLEModulZSI_ID, 0,
                                     vAktywnaFirma,  nil, oParams );

    if Form <> nil then (Form as TZLEZlecenieDBGridForm).PrzeliczWszystkie(nil);

  finally
    if Form <> nil then FreeAndNil(Form);
  end;
end;
{$endif}

procedure TZLEDataManager.PracaZasobowMenuItemClick(Sender: TObject);
var
  oParams: TKeyValues;
begin
  inherited;
  oParams := TKeyValues.CreateEmpty();
  with oParams do begin
    Add(cFORM_CAPTION+'='+'Rejestracja czasu pracy zasobw(Produkcja)');
    Add(sUNIMODULZSI_ID+'='+IntToStr(cZLEModulZSI_ID));
    Add(cRangeClassName+'=TZleZasobyPracaRangeForm');
    Add(sZLECONST_RODZAJECP_ID+'='+cZLERodzajECP_ProdukcjaID);
  end;
  FormManager.OpenDBGrid(Self, 'TZleZasobyPracaDBGridForm', omList, oParams);
end;

procedure TZLEDataManager.RejestracjaCzasuPracyMenuItemClick(Sender: TObject);
var
  oParams: TKeyValues;
begin
  inherited;
  oParams := TKeyValues.CreateEmpty();
  {Tu maa zmiana - wywoanie okienka z RCP Zasobw}
  with oParams do begin
    Add(cFORM_CAPTION+'='+'Rejestracja czasu pracy osb/zasobw');
    Add(sUNIMODULZSI_ID+'='+IntToStr(cZLEModulZSI_ID));
    Add(cRangeClassName+'=TZleZasobyPracaRangeForm');
    Add(sZLECONST_RODZAJECP_ID+'='+cZLERodzajECP_OsobaID);
  end;
  FormManager.OpenDBGrid(Self, 'TZleZasobyPracaDBGridForm', omList, oParams);

  (***************************
  with oParams do begin
    Add(cFORM_CAPTION+'='+'Rejestracja czasu pracy');
    Add(cRangeClassName+'='+cKlasaOsobyGodz+cSuffixKlasySelect);
    Add(sUNIMODULZSI_ID+'='+IntToStr(cZLEModulZSI_ID));
  end;
  FormManager.OpenDBGrid(Self, 'TZleOsobyGodzDBGridForm', omList, oParams);
  *****************************)
end;

procedure TZLEDataManager.ZLEBrakiMenuItemClick(Sender: TObject);
begin
  FormManager.OpenDBGrid( self, 'TZLEBrakiDBGridForm', omList);
end;

procedure TZLEDataManager.GrupyKalendarzoweMenuItemClick(Sender: TObject);
begin
  UNISysDM.KDPokazIObsluzKalendarz(sKDGRUPAKAL,
                                   '', '', false, false, false,
                                   0, nil, nil, True, False,
                                   sZLEModulID);
end;

procedure TZLEDataManager.SystemyZmianoweMenuItemClick(Sender: TObject);
begin
  UNISysDM.KDPokazIObsluzKalendarz(sKDSYSTEMZMIAN,
                                   '', '', false, false, false,
                                   0, nil, nil, True, False,
                                   sZLEModulID);
end;

procedure TZLEDataManager.KalendarzMenuItemClick(Sender: TObject);
begin
  UNISysDM.KDPokazIObsluzKalendarz(sKDKALCZAS,
                                   '', '', false, false, false, 0,
                                   TKeyValues.CreateAs([cRangeClassName + '=' + sTUNISysKDKalCzasRangeForm]),
                                   nil, True, False,
                                   sZLEModulID);
end;

procedure TZLEDataManager.NumeratoryZasobowMenuItemClick(
  Sender: TObject);
var
    oQuery:TUNIQuery;
begin
   try
    {function  UNIPokazIObsluzAutomatyNum( sKodAutomatu: string; iMaxDlugosc: integer; sBlokada, sAtrybuty, sWarunek: string; bBlok: boolean;
                                          iPozycjonowanieID: integer = 0; bNieFirmowy:boolean = false ;
                                          bUnikalnoscWzorca:boolean=true;iMnemonikID:integer = 0;
                                          sMnemonikiTryb:string = ''): TUNIQuery;}
     oQuery := UNISysDM.UNIPokazIObsluzAutomatyNum( sUNINUMERATORModuluZlecenWielofirmowe,
                                       UNISysDM.vMaxDLSymboluZle,
                                       sUNICONST_ALTERNATYWA_TAK,
                                       '', '', False, 0, True {NieFirmowy - false}{,
                                       0,
                                       False,
                                       False,
                                       StrToInt(sID),
                                       sUNISysAutomatyNumerowaniaMnemonikTryb_BrakCheckboxa} );
   finally
     if oQuery<> nil then FreeAndNil(oQuery);
   end;
end;

//procedure TZLEDataManager.KryteriaMenuItemClick(Sender: TObject);

procedure TZLEDataManager.CreateSPs;
begin
  ZLEGIS_ZLECViewDef.CreateView;
  ZLEZLECENIEROZLViewDef.CreateView;
  ZLEOSOBYGODZViewDef.CreateView;
  ZLEPolazmViewDef.CreateView;
  ZLEPolazmdefViewDef.CreateView;
  ZLEPolazmwskViewDef.CreateView;
  UtworzSP(sZLE_PACKAGE);
  UtworzSP(sZLE_ZAKLADKI);
  UtworzSP(sZLEPRZEPISZPOLAUZ);
  UtworzSP(sZLE_POBIERZ_ID_OBCY);
  UtworzSP(sZLEXML_PACKAGE);
  UtworzWyzwalacz(sZLEZLECENIE_INS_AFTER);
end;

procedure TZLEDataManager.UtworzWyzwalacz(sTriggerName: string);
begin
  if sTriggerName = sZLEZLECENIE_INS_AFTER then
    SQLManager.ZalozWyzwalacz(hInstance, sZLEZLECENIE_INS_AFTER, sZLEZLECENIE);
end;

procedure TZLEDataManager.KryteriaMenuItemClick(Sender: TObject);
begin
  inherited;
  FormManager.OpenDBGrid(self,'TZLEKryteriaDBGridForm', omList+omMultiSelect);
end;

procedure TZLEDataManager.LWPRealizacjaZlecenMenuItemClick(
  Sender: TObject);
begin
{$ifndef build_all}
  LWPDM.LWPPokazWizualizacjeZlecen();
{$endif}
end;

{$ifdef build_zle}
procedure TZLEDataManager.UNIDajDetalaObiektu(iObiektTypID: Integer;  iObiektID: Integer;
  iOpenMode: TOpenMode; var sKlasa: String; const oParams: TKeyValues);
var
  sRightName: String;
  sMessage: String;
begin
  sRightName := '';

  if iObiektTypID = iUNIDOCOBIEKTTYP_ZLEZLECENIE_ID then begin
    sKlasa := 'TZLEZlecenieDBDetailForm';
    case iOpenMode of
      omNew: sRightName := sZLE_KART_ZLECEN_DOPISZ;
      omEdit: sRightName := sZLE_KART_ZLECEN_ZMIEN;
      omDelete: sRightName := sZLE_KART_ZLECEN_USUN;
      omView: sRightName := sZLE_KART_ZLECEN_POKAZ;
    end;
    sMessage := 'Brak uprawnie do kartoteki zlece!';
  end else
    inherited;

  //sprawdzenie wymaganych uprawnie
  if not SecurityManager.SM_UserCanDo(sRightName) then begin
    sKlasa := '';
    Komunikat(cError, sMessage)
  end;
end;

procedure TZLEDataManager.UNIDajGridaObiektu(iObiektTypID: Integer; OpenModeFlags: Integer;
  var sKlasa, sPrimaryAlias: String; const oParams: TKeyValues);
begin
 if iObiektTypID = iUNIDOCOBIEKTTYP_ZLEZLECENIE_ID then begin
   sKlasa := 'TZLEZlecenieDBGridForm';
   sPrimaryAlias := sZLEALIAS_ZLECENIE_ID;
   oParams.Add(cFORM_CAPTION+'='+'Pozycje zlecenia');
 end else
   inherited;
end;

function TZLEDataManager.UNIDajOpisObiektu: String;
begin
  result := SQLManager.GetTableName(sZLE_PACKAGE + '.Daj_Opis_Obiektu');
end;

procedure TZLEDataManager.UNIObiektInicjujOkulary(iObiektTypID: Integer; oLookupAliasEdit: TUNILookupAliasEdit);
begin
  if iObiektTypID = iUNIDOCOBIEKTTYP_ZLEZLECENIE_ID then
    with oLookupAliasEdit do begin
      AliasManager := Self.AliasManager;
      Alias_ID := sZLEALIAS_ZLECENIE_ID;
      Alias_Name := sZLEALIAS_ZLECENIE_NAZWA;
    end
  else
    inherited;
end;

function TZLEDataManager.UNIPrawoDoObiektu: String;
begin
  result := '1';
end;



{obsuga wysyania danych zlece i planu produkcji do systemw partnerw}
  {
  Funkcja zapisuje podane idki zlece do wysania, do tabeli ADMID dla podanego usera i kontekstu
  Zwraca FALSE jeeli uytkownik anulowa wysyanie w komunikacie o ponownym wysyaniu.
  }
function  TZLEDataManager.ZapiszIdZlecDoWyslaniaWADMId(
  const ac_oZlecId:     TStringList;  // id asortymentw do wysania (same id bez nazwy pola itp)
  const ac_iUserId:     integer;
  const ac_sKontekst:   string;
  const ac_bUsuwanie:   boolean;      // czy zlecenia bd wycofywane (wtedy trzeba si upewni, e wszystkie byy wczeniej wysane)
  const ac_oPlanProdElId: TStringList = nil // identyfikatory elementw planu produkcji podawane jeeli maj by wysane tylko te elementy a nie cae zlecenia
):  boolean;
{$ifndef build_all}

    {
      Procedura sprawdza czy zaznaczone zlecenia nie zostay ju wczeniej wysane.
      Jeeli tak to wywietla odpowiedni komunikat i reaguje odpowiednio na odpowied uytkownika.
    }
  function  Wysylanie():  boolean;
  var
    sPole:      string;
    sRest:      string;
    oQuery:     TUNIQuery;
    sKomunikat: string;
    iResult:    integer;
    iPFunk:     integer;
    sWhere:     string;
  begin
    result  := true;
    iPFunk  := 0;
    if((ac_oPlanProdElId <> nil) and (ac_oPlanProdElId.Count > 0)) then begin
      sWhere  := ' and ZO.' + sLWPPLANPRODEL_ID + ' in(' +
        ADMID_SelectSQL(cADMIDFunZLEElemPlanDoWyslania, iPFunk, ac_iUserId, ac_sKontekst, vAktywnaFirma) +
      ')';
    end else
      sWhere  := '';
      // sprawdzenie czy ktre z zaznaczonych zlece nie zostao ju wczeniej wysane
    sPole := 'select Z.%s';
    sRest := 
      ' from %s Z' +
      ' where ' +
        'Z.'  + sZLEZLECENIE_ID + ' in (' +
          ADMID_SelectSQL(cADMIDFunZLEZlecDoWyslania, iPFunk, ac_iUserId, ac_sKontekst, vAktywnaFirma) +
        ') and exists(' +
          'select * from %s ZO' +
          ' where ' +
            'ZO.'  + sZLEZLECENIE_ID + ' = Z.'  + sZLEZLECENIE_ID +
            sWhere +
        ')'
      ;
    oQuery  := SQLManager.CreateQuery(
      Format(sPole, [sZLEZLECENIE_SYMBOL]) +
      sRest,
      [sZLEZLECENIE, sZLEZLECENIEOBCY]
    );
    try
      oQuery.Open();
      if(not oQuery.IsEmpty()) then begin
        if((ac_oPlanProdElId <> nil) and (ac_oPlanProdElId.Count > 0)) then
          sKomunikat  := 'Elementy planu produkcji nastpujcych zlece zostay ju wysane'
        else
          sKomunikat  := 'Nastpujce zlecenia zostay ju wysane';
        while(not oQuery.Eof) do begin
          sKomunikat  := sKomunikat + Chr(13) + oQuery.Fields[0].AsString;
          oQuery.Next();
        end;  // while(not oQuery.Eof)
        sKomunikat  := sKomunikat + Chr(13) + Chr(13) + 'Moliwe akcje:' + Chr(13) +
          'Tak - wylij ponownie' + Chr(13) +
          'Nie - pomi wczeniej wysane' + Chr(13) +
          'Anuluj - anuluj wysyanie';
        iResult := Komunikat(cConfirmation, sKomunikat, MB_YESNOCANCEL + MB_ICONQUESTION);
        case(iResult) of
          mrNo:  begin
              // usuwamy zaznaczenie z tych wczeniej wysanych
            SQLManager.ExecuteQuery(
              'delete from %s A' +
              ' where ' +
                'A.'  + sADMID_FUNK + ' = ' + IntToStr(cADMIDFunZLEZlecDoWyslania) + ' and ' +
                'A.'  + sADMID_PFUNK + ' = ' + IntToStr(iPFunk) + ' and ' +
                'A.'  + sADMID_KONTEKST + ' = ''' + ac_sKontekst + ''' and ' +
                'A.'  + sSMUSER_ID + ' = ' + IntToStr(ac_iUserId) + ' and ' +
                'A.'  + sUNIODDZIAL_ID  + ' = ' + IntToStr(vAktywnaFirma) + ' and ' +
                'A.'  + sADMID_V  + ' in('  +
                  Format(sPole, [sZLEZLECENIE_ID]) +
                  sRest +
                ')',
              [sADMID, sZLEZLECENIE, sZLEZLECENIEOBCY]
            );
          end;
          mrCancel: begin
              // usuwamy zaznaczenie ze wszystkich aby anulowa wysyanie
            result  := false;
            UsunIdZlecDoWyslaniaWADMId(ac_iUserId, ac_sKontekst);
          end;
          mrYes:  begin
              // user chce ponownie wysa te zlecenia wic nic nie robimy
          end;
        end;  // case(iResult)
      end;  // if(not oQuery.IsEmpty())
    finally
      oQuery.Free();
    end;
  end;  // function  Wysylanie

  function  Usuwanie(): boolean;
  var
    sPole:      string;
    sRest:      string;
    oQuery:     TUNIQuery;
    sKomunikat: string;
    iResult:    integer;
    iPFunk:     integer;
    sWhere:     string;
  begin
    result  := true;
    iPFunk  := 0;
    if((ac_oPlanProdElId <> nil) and (ac_oPlanProdElId.Count > 0)) then begin
      sWhere  := ' and ZO.' + sLWPPLANPRODEL_ID + ' in(' +
        ADMID_SelectSQL(cADMIDFunZLEElemPlanDoWyslania, iPFunk, ac_iUserId, ac_sKontekst, vAktywnaFirma) +
      ')';
    end else
      sWhere  := '';
      // sprawdzenie czy wszystkie z zaznaczonych zlece zostay wczeniej wysane
    sPole := 'select Z.%s';
    sRest := 
      ' from ' +
        '%s Z' +
          ' inner join (' +
            ADMID_SelectSQL(cADMIDFunZLEZlecDoWyslania, iPFunk, ac_iUserId, ac_sKontekst, vAktywnaFirma) +
          ') AID' +
            ' on Z.' + sZLEZLECENIE_ID + ' = AID.' + sADMID_V +
          ' left outer join %s ZO' +
            ' on ' +
              'Z.' + sZLEZLECENIE_ID + ' = ZO.' + sZLEZLECENIE_ID +
              sWhere +
      ' where ' +
        'ZO.' + sZLEZLECENIE_ID + ' is null';
    oQuery  := SQLManager.CreateQuery(
      Format(sPole, [sZLEZLECENIE_SYMBOL]) +
      sRest,
      [sZLEZLECENIE, sZLEZLECENIEOBCY]
    );
    try
      oQuery.Open();
      if(not oQuery.IsEmpty()) then begin
        if((ac_oPlanProdElId <> nil) and (ac_oPlanProdElId.Count > 0)) then
          sKomunikat  := 'Elementy planu produkcji nastpujcych zlece nie zostay jeszcze wysane'
        else
          sKomunikat  := 'Nastpujce zlecenia nie zostay jeszcze wysane';
        while(not oQuery.Eof) do begin
          sKomunikat  := sKomunikat + Chr(13) + oQuery.Fields[0].AsString;
          oQuery.Next();
        end;  // while(not oQuery.Eof)
        sKomunikat  := sKomunikat + Chr(13) + Chr(13) + 'Moliwe akcje:' + Chr(13) +
          'OK - pomi te zlecenia' + Chr(13) +
          'Anuluj - anuluj wysyanie';
        iResult := Komunikat(cConfirmation, sKomunikat, MB_OKCANCEL + MB_ICONQUESTION);
        case(iResult) of
          mrOk:  begin
              // usuwamy zaznaczenie z tych wczeniej nie wysanych
            SQLManager.ExecuteQuery(
              'delete from %s A' +
              ' where ' +
                'A.'  + sADMID_FUNK + ' = ' + IntToStr(cADMIDFunZLEZlecDoWyslania) + ' and ' +
                'A.'  + sADMID_PFUNK + ' = ' + IntToStr(iPFunk) + ' and ' +
                'A.'  + sADMID_KONTEKST + ' = ''' + ac_sKontekst + ''' and ' +
                'A.'  + sSMUSER_ID + ' = ' + IntToStr(ac_iUserId) + ' and ' +
                'A.'  + sUNIODDZIAL_ID  + ' = ' + IntToStr(vAktywnaFirma) + ' and ' +
                'A.'  + sADMID_V  + ' in('  +
                  Format(sPole, [sZLEZLECENIE_ID]) +
                  sRest +
                ')',
              [sADMID, sZLEZLECENIE, sZLEZLECENIEOBCY]
            );
          end;
          mrCancel: begin
              // usuwamy zaznaczenie ze wszystkich aby anulowa wysyanie
            result  := false;
            UsunIdZlecDoWyslaniaWADMId(ac_iUserId, ac_sKontekst);
          end;
          else
            raise EOF_ZLEException.Create('Nieoczekiwana odpowied!');
        end;  // case(iResult)
      end;  // if(not oQuery.IsEmpty())
    finally
      oQuery.Free();
    end;
  end;  // function  Usuwanie

var
  iPFunk:     integer;
{$endif}
begin
{$ifndef build_all}
  iPFunk  := 0;
  ADMID_DelAll(cADMIDFunZLEElemPlanDoWyslania, iPFunk, ac_iUserId, ac_sKontekst, vAktywnaFirma);
  ADMID_Save(cADMIDFunZLEZlecDoWyslania, iPFunk, ac_iUserId, ac_sKontekst, nil, ac_oZlecId, vAktywnaFirma);
  if((ac_oPlanProdElId <> nil) and (ac_oPlanProdElId.Count > 0)) then begin
    ADMID_Save(cADMIDFunZLEElemPlanDoWyslania, iPFunk, ac_iUserId, ac_sKontekst, nil, ac_oPlanProdElId, vAktywnaFirma);
  end;
  if(not ac_bUsuwanie) then
    result  := Wysylanie()
  else
    result  := Usuwanie();
{$else}
  result  := true;
{$endif}
end;

  {
  Procedura usuwa idki zlece do wysania, z tabeli ADMID dla podanego usera i kontekstu
  }
procedure TZLEDataManager.UsunIdZlecDoWyslaniaWADMId(
  const ac_iUserId:     integer;
  const ac_sKontekst:   string
);
begin
{$ifndef build_all}
  ADMID_DelAll(cADMIDFunZLEElemPlanDoWyslania, 0, ac_iUserId, ac_sKontekst, vAktywnaFirma);
  ADMID_DelAll(cADMIDFunZLEZlecDoWyslania, 0, ac_iUserId, ac_sKontekst, vAktywnaFirma);
{$endif}
end;

  {
  Funkcja buduje query zwracajce dane zlece, ktrych id zostay zapisane wczeniej do admid.
  Parametrami s wartoci pl tabeli admid.
  }
function  TZLEDataManager.DajQueryZlecDoWyslania(
  const ac_iUserId:   integer;
  const ac_sKontekst: string
):  TUNIQuery;
{$ifndef build_all}
var
  sWhere: String;
{$endif}
begin
{$ifndef build_all}
  sWhere  :=
      'ADMID.'  + sADMID_FUNK + ' = ' + IntToStr(cADMIDFunZLEZlecDoWyslania)  + ' and ' +
      'ADMID.'  + sADMID_PFUNK+ ' = 0 and ' +
      'ADMID.'  + sSMUSER_ID  + ' = ' + IntToStr(ac_iUserId);
  if(vAktywnaFirma > 0) then
    DopiszDoWhere('ADMID.'  + sUNIODDZIAL_ID + ' = ' + IntToStr(vAktywnaFirma), sWhere);
  if(Length(ac_sKontekst) > 0) then
    DopiszDoWhere('ADMID.'  + sADMID_KONTEKST + ' = ''' + ac_sKontekst + '''', sWhere);


  result  := SQLManager.CreateQuery(
    'select ' +
      'REC.'+ sLWPRECEPTURA_ID        + ', REC.'+ sLWPRECEPTURA_SYMBOL  + ', ' +
      'REC.'+ sLWPRECEPTURA_NAZWA     + ', REC.'+ sLWPRECEPTURA_ILOSC   + ', ' +
      'REC.'+ sLWPRECEPTURA_KOSZT     + ', '    +
      'Z.'  + sZLEZLECENIE_ID         + ', Z.'  + sZLEZLECENIE_SYMBOL   + ', ' +
      'Z.'  + sZLEZLECENIE_POLE1      + ', Z.'  + sZLEZLECENIE_POLE2    + ', ' +
      'Z.'  + sZLEZLECENIE_POLE3      + ', Z.'  + sZLEZLECENIE_NAZWA    + ', ' +
      'Z.'  + sZLEZLECENIE_DATA_OTW   + ', Z.'  + sZLEZLECENIE_DATA_ZAMK+ ', ' +
      'Z.'  + sZLEZLECENIE_STATUS     + ', ' +
      'Z.'  + sZLEZLECENIE_ILOSC      + ', T.'  + sZLETYPZLEC_ID        + ', ' +
      'T.'  + sZLETYPZLEC_SYMBOL      + ', T.'  + sZLETYPZLEC_NAZWA     + ', ' +
      'T.'  + sZLETYPZLEC_PRODUKCYJNE + ', Z.'  + sUNIROK_ID            + ', ' +
      'R.'  + sUNIROK_ROK             + ', R.'  + sUNIROK_ROK_TEXT      + ', ' +
      'Z.'  + sZLEZLECENIE_OSOBA_ODP  + ', O.'  + sKDOSOBA_SYMBOL       + ', ' +
      'O.'  + sKDOSOBA_NAZWA          + ', O.'  + sKDOSOBA_IMIE         + ', ' +
      'O.'  + sKDOSOBA_NAZWISKO       + ', A.'  + sASOASORT_ID          + ', ' +
      'A.'  + sASOASORT_SYMBOL        + ', A.'  + sASOASORT_PKWIU       + ', ' +
      'A.'  + sASOASORT_NAZWA         + ', A.'  + sASOASORT_INDEKS      + ', ' +
      'J.'  + sUNIJM_ID               + ', J.'  + sUNIJM_SYMBOL         + ', ' +
      'J.'  + sUNIJM_NAZWA            + ', Z.'  + sZLEZLECENIE_OPIS     + ', ' +
      'OD.' + sUNIODDZIAL_ID          + ', OD.' + sUNIODDZIAL_SYMBOL    + ', ' +
      'OD.' + sUNIODDZIAL_NAZWA       + ', KL.' + sBKKLIENT_ID          + ', ' +
      'KL.' + sBKKLIENT_SYMBOL        + ', KL.' + sBKKLIENT_NAZWA       + ', ' +
      'KL.' + sBKKLIENT_SKROT         +
    ' from '  +
      '%s Z'  +
        ' inner join %s T'  +
          ' on Z.'  + sZLETYPZLEC_ID+ ' = T.' + sZLETYPZLEC_ID+
        ' left outer join %s R' +
          ' on Z.'  + sUNIROK_ID    + ' = R.' + sUNIROK_ID    +
        ' left outer join %s O' +
          ' on Z.'  + sZLEZLECENIE_OSOBA_ODP  + ' = O.' + sKDOSOBA_ID +
        ' left outer join %s A' +
          ' on Z.'  + sASOASORT_ID  + ' = A.' + sASOASORT_ID  +
        ' left outer join %s J' +
          ' on A.'  + sUNIJM_ID1    + ' = J.' + sUNIJM_ID     +
        ' inner join %s REC'    +
          ' on Z.'  + sLWPRECEPTURA_ID  + ' = REC.' + sLWPRECEPTURA_ID  +
        ' left outer join %s OD' +
          ' on Z.'  + sUNIODDZIAL_ID+ ' = OD.'  + sUNIODDZIAL_ID+
        ' left outer join %s KL' +
          ' on Z.'  + sZLEZLECENIE_WYKONAWCA_ID  + ' = KL.'  + sBKKLIENT_ID  +
        ' inner join %s ADMID' +
          ' on Z.'  + sZLEZLECENIE_ID + ' = ADMID.' + sADMID_V +
    ' where ' +
      sWhere  +
    ' order by '  +
      'Z.'  + sZLEZLECENIE_ID,
    [
      sZLEZLECENIE  , sZLETYPZLEC , sUNIROK , sKDOSOBA  , sASOASORT , sUNIJM,
      sLWPRECEPTURA , sUNIODDZIAL , sBKKLIENT, sADMID
    ]
  );
  try
    result.Open();
    if(Result.IsEmpty()) then
      FreeAndNil(result);
  except
    result.Free();
    raise;
  end;
{$else}
  result  := nil;
{$endif}
end;

{
Funkcja buduje query zwracajce dane pozycji receptury zlece, ktrych id zostay zapisane wczeniej do admid.
Parametrami s wartoci pl tabeli admid.
}
function  TZLEDataManager.DajQueryReceppozZlecDoWyslania(
  const ac_iUserId:         integer;
  const ac_sKontekst:       string;
  const ac_bWysylanieElems: boolean = false // czy wysyane s tylko wybrane elementy planu produkcji (id zapisane s ju w admid)
):  TUNIQuery;
{$ifndef build_all}
var
  sWhere: String;
{$endif}
begin
{$ifndef build_all}
  sWhere  :=
      'ADMID.'  + sADMID_FUNK + ' = ' + IntToStr(cADMIDFunZLEZlecDoWyslania)  + ' and ' +
      'ADMID.'  + sADMID_PFUNK+ ' = 0 and ' +
      'ADMID.'  + sSMUSER_ID  + ' = ' + IntToStr(ac_iUserId);
  if(vAktywnaFirma > 0) then
    DopiszDoWhere('ADMID.'  + sUNIODDZIAL_ID + ' = ' + IntToStr(vAktywnaFirma), sWhere);
  if(Length(ac_sKontekst) > 0) then
    DopiszDoWhere('ADMID.'  + sADMID_KONTEKST + ' = ''' + ac_sKontekst + '''', sWhere);
  if(ac_bWysylanieElems) then begin
      // wysyane s tylko wybrane elementy planu produkcji
    DopiszDoWhere(
      'RP.' + sLWPRECEPPOZ_ID + ' in(' +
        'select EL.' + sLWPRECEPPOZ_ID +
        ' from ' + SQLManager.GetTableName(sLWPPLANPRODEL) + ' EL' +
        ' where ' +
          'EL.' + sLWPPLANPRODEL_ID + ' in(' + ADMID_SelectSQL(cADMIDFunZLEElemPlanDoWyslania, 0, ac_iUserId, ac_sKontekst, vAktywnaFirma) + ')' +
      ')',
      sWhere
    );
  end;  // if(ac_bWysylanieElems)

  result  := SQLManager.CreateQuery(
    'select ' +
      'REC.'+ sLWPRECEPTURA_ID      + ', RP.' + sLWPRECEPPOZ_ID     + ', ' +
      'RP.' + sLWPRECEPPOZ_KOLEJNOSC+ ', RP.' + sLWPRECEPPOZ_BRAKI  + ', ' +
      'F.'  + sLWPFAZAPROD_ID       + ', F.'  + sLWPFAZAPROD_SYMBOL + ', ' +
      'F.'  + sLWPFAZAPROD_NAZWA    + ', F.'  + sLWPFAZAPROD_OPIS   + ', ' +
      'RP.' + sLWPRECEPPOZ_OPIS     + ', '  +
      'P.'  + sASOASORT_ID    + ' as ' + cUNIINTPOLPRODUKT_ID     + ', ' +
      'P.'  + sASOASORT_SYMBOL+ ' as ' + cUNIINTPOLPRODUKT_SYMBOL + ', ' +
      'P.'  + sASOASORT_NAZWA + ' as ' + cUNIINTPOLPRODUKT_NAZWA  + ', ' +
      'KM.' + sASOKMAT_ID     + ' as ' + cUNIINTKONTOMAT_ID       + ', ' +
      'KM.' + sASOKMAT_SYMBOL + ' as ' + cUNIINTKONTOMAT_SYMBOL   + ', ' +
      'KM.' + sASOKMAT_NAZWA  + ' as ' + cUNIINTKONTOMAT_NAZWA    + ', ' +
      'JMP.'+ sUNIJM_ID       + ' as ' + cUNIINTPOLPRODUKT_JM_ID  + ', ' +
      'JMP.'+ sUNIJM_SYMBOL   + ' as ' + cUNIINTPOLPRODUKT_JM_SYMBOL  + ', ' +
      'JMP.'+ sUNIJM_NAZWA    + ' as ' + cUNIINTPOLPRODUKT_JM_NAZWA   + ', ' +
      'Z.'  + sZLEZLECENIE_ID     + ', ' +
      'A.'  + sASOASORT_ID          + ', A.'  + sASOASORT_SYMBOL    + ', ' +
      'A.'  + sASOASORT_NAZWA       + ', A.'  + sASOASORT_PKWIU     + ', ' +
      'A.'  + sASOASORT_INDEKS      + ', JM.' + sUNIJM_ID           + ', ' +
      'JM.' + sUNIJM_SYMBOL         + ', JM.' + sUNIJM_NAZWA        + ', ' +
      'ZM.' + sZLEZLECENIEMAT_ILOSC + ', KMM.'+ sASOKMAT_ID         + ', ' +
      'KMM.'+ sASOKMAT_SYMBOL       + ', KMM.'+ sASOKMAT_NAZWA      +
    ' from '  +
      '%s Z'  +
        ' inner join %s REC'    +
          ' on Z.'  + sLWPRECEPTURA_ID  + ' = REC.' + sLWPRECEPTURA_ID  +
        ' inner join %s RP'     +
          ' on REC.'+ sLWPRECEPTURA_ID  + ' = RP.'  + sLWPRECEPTURA_ID  +
        ' inner join %s F'      +
          ' on RP.' + sLWPFAZAPROD_ID   + ' = F.'   + sLWPFAZAPROD_ID   +
        ' inner join %s ADMID' +
          ' on Z.'  + sZLEZLECENIE_ID + ' = ADMID.' + sADMID_V +
        ' left outer join %s RPM' +
          ' on RP.' + sLWPRECEPPOZ_ID + ' = RPM.'   + sLWPRECEPPOZ_ID +
        ' left outer join %s ZM' +
          ' on ('  +
            'RPM.'+ sLWPRECEPPOZMATERIAL_ID + ' = ZM.'  + sLWPRECEPPOZMATERIAL_ID + ' and ' +
            'Z.'  + sZLEZLECENIE_ID         + ' = ZM.'  + sZLEZLECENIE_ID +
          ')' +
        ' left outer join %s A' +
          ' on ZM.' + sASOASORT_ID + ' = A.'   + sASOASORT_ID +
        ' left outer join %s JM' +
          ' on A.' + sUNIJM_ID1 + ' = JM.'   + sUNIJM_ID +
        ' left outer join %s PKM' +
          ' on RP.' + sASOASORTKMAT_ID  + ' = PKM.' + sASOASORTKMAT_ID  +
        ' left outer join %s P' +
          ' on PKM.'+ sASOASORT_ID  + ' = P.' + sASOASORT_ID  +
        ' left outer join %s JMP' +
          ' on P.'  + sUNIJM_ID1  + ' = JMP.' + sUNIJM_ID +
        ' left outer join %s KM' +
          ' on PKM.'+ sASOKMAT_ID  + ' = KM.' + sASOKMAT_ID  +
        ' left outer join %s AKMM' +
          ' on ZM.' + sASOASORTKMAT_ID  + ' = AKMM.'  + sASOASORTKMAT_ID  +
        ' left outer join %s KMM' +
          ' on AKMM.' + sASOKMAT_ID + ' = KMM.' + sASOKMAT_ID +
    ' where ' +
      sWhere  +
    ' order by '  +
      'Z.'  + sZLEZLECENIE_ID + ', RP.' + sLWPRECEPPOZ_KOLEJNOSC  + ', A.'  + sASOASORT_SYMBOL,
    [
      sZLEZLECENIE  , sLWPRECEPTURA , sLWPRECEPPOZ, sLWPFAZAPROD, sADMID,
      sLWPRECEPPOZMATERIAL, sZLEZLECENIEMAT, sASOASORT, sUNIJM,
      sASOASORTKMAT, sASOASORT, sUNIJM, sASOKMAT,
      sASOASORTKMAT, sASOKMAT
    ]
  );
  try
    result.Open();
    if(Result.IsEmpty()) then
      FreeAndNil(result);
  except
    result.Free();
    raise;
  end;
{$else}
  result  := nil;
{$endif}
end;

  {
    Funkcja buduje query zwracajce dane zasobw pozycji receptury zlece, ktrych id zostay zapisane wczeniej do admid.
    Parametrami s wartoci pl tabeli admid.
  }
function  TZLEDataManager.DajQueryZasobowReceppozZlecDoWyslania(
  const ac_iUserId:   integer;
  const ac_sKontekst: string
):  TUNIQuery;
{$ifndef build_all}
var
  sWhere: String;
{$endif}
begin
{$ifndef build_all}
  sWhere  :=
      'ADMID.'  + sADMID_FUNK + ' = ' + IntToStr(cADMIDFunZLEZlecDoWyslania)  + ' and ' +
      'ADMID.'  + sADMID_PFUNK+ ' = 0 and ' +
      'ADMID.'  + sSMUSER_ID  + ' = ' + IntToStr(ac_iUserId);
  if(vAktywnaFirma > 0) then
    DopiszDoWhere('ADMID.'  + sUNIODDZIAL_ID + ' = ' + IntToStr(vAktywnaFirma), sWhere);
  if(Length(ac_sKontekst) > 0) then
    DopiszDoWhere('ADMID.'  + sADMID_KONTEKST + ' = ''' + ac_sKontekst + '''', sWhere);

  result  := SQLManager.CreateQuery(
    'select ' +
      'Z.'  + sZLEZLECENIE_ID       + ', RP.' + sLWPRECEPPOZ_ID       + ', ' +
      'RP.' + sLWPRECEPPOZ_KOLEJNOSC+ ', ZAS.'+ sZLEZASOB_ID          + ', ' +
      'ZAS.'+ sZLEZASOB_SYMBOL      + ', ZAS.'+ sZLEZASOB_NAZWA       + ', ' +
      'ZAS.'+ sZLEZASOB_RODZAJ      + ', ZZAS.'+sZLEZLECENIEZASOB_PLAN+ ', ' +
      'ZZAS.'+sZLEZLECENIEZASOB_OBCIAZ+ ', ZZAS.'+sZLEZLECENIEZASOB_WYD +
    ' from '  +
      '%s Z'  +
        ' inner join %s ADMID' +
          ' on Z.'  + sZLEZLECENIE_ID + ' = ADMID.' + sADMID_V +
        ' inner join %s REC'    +
          ' on Z.'  + sLWPRECEPTURA_ID  + ' = REC.' + sLWPRECEPTURA_ID  +
        ' inner join %s RP'     +
          ' on REC.'+ sLWPRECEPTURA_ID  + ' = RP.'  + sLWPRECEPTURA_ID  +
        ' inner join %s RPZ' +
          ' on RP.' + sLWPRECEPPOZ_ID + ' = RPZ.' + sLWPRECEPPOZ_ID +
        ' inner join %s ZZAS' +
          ' on (' +
            'Z.'  + sZLEZLECENIE_ID + ' = ZZAS.' + sZLEZLECENIE_ID + ' and ' +
            'RPZ.'+ sLWPRECEPPOZZASOB_ID  + ' = ZZAS.'  + sLWPRECEPPOZZASOB_ID  +
          ')' +
        ' inner join %s ZAS' +
          ' on ZZAS.' + sZLEZASOB_ID  + ' = ZAS.'  + sZLEZASOB_ID +
    ' where ' +
      sWhere  +
    ' order by '  +
      'Z.'  + sZLEZLECENIE_ID + ', RP.' + sLWPRECEPPOZ_KOLEJNOSC  + ', ZAS.'  + sZLEZASOB_SYMBOL,
    [
      sZLEZLECENIE  , sADMID, sLWPRECEPTURA , sLWPRECEPPOZ,
      sLWPRECEPPOZZASOB, sZLEZLECENIEZASOB, sZLEZASOB
    ]
  );
  try
    result.Open();
    if(Result.IsEmpty()) then
      FreeAndNil(result);
  except
    result.Free();
    raise;
  end;
{$else}
  result  := nil;
{$endif}
end;

  {
    Procedura przepisuje dane z aktualnego rekordu ac_oZlecQuery oraz odpowiadajcym
    mu rekordw ac_oRecepPozQuery i ac_oZasobRecepPozQuery do dokumentu xml
    podpinajc elementy do elementu a_oParentNode
  }
procedure TZLEDataManager.PrzepiszDaneZlecDoXML(
        a_oXMLDoc:              TUNIXMLParser;
        a_oParentNode:          IXMLDOMElement;
  const ac_oZlecQuery:          TUNIQuery;
  const ac_oRecepPozQuery:      TUNIQuery;
  const ac_oZasobRecepPozQuery: TUNIQuery
);
{$ifndef build_all}
var
  oRecep:   IXMLDOMElement;
  oAsorts:  IXMLDOMElement;
  oAsort:   IXMLDOMElement;
  oElem:    IXMLDOMElement;
  oRPozZas: IXMLDOMElement; // element grupujcy zasoby pozycji
  oZasob:   IXMLDOMElement; // zasb pozycji
  i:        integer;
  iOstatnie:integer;
  iOrder:   integer;
  iZlecenie:integer;
  sDateFormat:  string;
{$endif}
begin
{$ifndef build_all}
  sDateFormat := ShortDateFormat;
  try
    ShortDateFormat := 'yyyy-mm-dd';  // 18.05.2010 by Adam - specjalnie dla Dekorglassu
    iZlecenie := ac_oZlecQuery.FieldByName(sZLEZLECENIE_ID).AsInteger;
      // odnalezienie pozycji receptury danego zlecenia
    if(ac_oRecepPozQuery.FieldByName(sZLEZLECENIE_ID).AsInteger > iZlecenie) then
      ac_oRecepPozQuery.First();
    while((not ac_oRecepPozQuery.Eof) and
    (ac_oRecepPozQuery.FieldByName(sZLEZLECENIE_ID).AsInteger < iZlecenie)) do
      ac_oRecepPozQuery.Next();
      // odnalezienie zasobw danego zlecenia
    if(ac_oZasobRecepPozQuery.FieldByName(sZLEZLECENIE_ID).AsInteger > iZlecenie) then
      ac_oZasobRecepPozQuery.First();
    while((not ac_oZasobRecepPozQuery.Eof) and
    (ac_oZasobRecepPozQuery.FieldByName(sZLEZLECENIE_ID).AsInteger < iZlecenie)) do
      ac_oZasobRecepPozQuery.Next();

      // przepisywanie danych danego zlecenia
    if(ac_oRecepPozQuery.FieldByName(sZLEZLECENIE_ID).AsInteger = iZlecenie) then begin
      oRecep:= a_oXMLDoc.DodajElementPodrzedny(a_oParentNode, sLWPRECEPTURA);
      for i := 0 to ac_oZlecQuery.Fields.Count-1 do begin
        if(i < 5) then begin
            // pola receptury
          a_oXMLDoc.DodajElementPodrzedny(oRecep, ac_oZlecQuery.Fields[i].FieldName, ac_oZlecQuery.Fields[i].AsString);
        end else begin
            // pozostale pola
          a_oXMLDoc.DodajElementPodrzedny(a_oParentNode, ac_oZlecQuery.Fields[i].FieldName, ac_oZlecQuery.Fields[i].AsString);
        end;
      end;
        // dodanie receptury
      iOstatnie := ac_oRecepPozQuery.FieldDefs.IndexOf(sZLEZLECENIE_ID) - 1;
      while((not ac_oRecepPozQuery.Eof) and
      (ac_oRecepPozQuery.FieldByName(sZLEZLECENIE_ID).AsInteger = iZlecenie)) do begin
        oElem := a_oXMLDoc.DodajElementPodrzedny(oRecep, sLWPRECEPPOZ);
        for i := 1 to iOstatnie do
          a_oXMLDoc.DodajElementPodrzedny(oElem, ac_oRecepPozQuery.Fields[i].FieldName, ac_oRecepPozQuery.Fields[i].AsString);
        iOrder  := ac_oRecepPozQuery.FieldByName(sLWPRECEPPOZ_KOLEJNOSC).AsInteger;
        if(not ac_oRecepPozQuery.FieldByName(sASOASORT_ID).IsNull) then begin
          oAsorts := a_oXMLDoc.DodajElementPodrzedny(oElem, sZLEZLECENIEMAT);
          while((not ac_oRecepPozQuery.Eof) and
          (ac_oRecepPozQuery.FieldByName(sZLEZLECENIE_ID).AsInteger = iZlecenie) and
          (ac_oRecepPozQuery.FieldByName(sLWPRECEPPOZ_KOLEJNOSC).AsInteger = iOrder)) do begin
            oAsort  := a_oXMLDoc.DodajElementPodrzedny(oAsorts, sASOASORT);
            a_oXMLDoc.DodajElementPodrzedny(oAsort, sASOASORT_ID, ac_oRecepPozQuery.FieldByName(sASOASORT_ID).AsString);
            a_oXMLDoc.DodajElementPodrzedny(oAsort, sASOASORT_SYMBOL, ac_oRecepPozQuery.FieldByName(sASOASORT_SYMBOL).AsString);
            a_oXMLDoc.DodajElementPodrzedny(oAsort, sASOASORT_NAZWA, ac_oRecepPozQuery.FieldByName(sASOASORT_NAZWA).AsString);
            a_oXMLDoc.DodajElementPodrzedny(oAsort, sASOASORT_PKWIU, ac_oRecepPozQuery.FieldByName(sASOASORT_PKWIU).AsString);
            a_oXMLDoc.DodajElementPodrzedny(oAsort, sASOASORT_INDEKS, ac_oRecepPozQuery.FieldByName(sASOASORT_INDEKS).AsString);
            a_oXMLDoc.DodajElementPodrzedny(oAsort, sZLEZLECENIEMAT_ILOSC, ac_oRecepPozQuery.FieldByName(sZLEZLECENIEMAT_ILOSC).AsString);
            a_oXMLDoc.DodajElementPodrzedny(oAsort, sUNIJM_ID, ac_oRecepPozQuery.FieldByName(sUNIJM_ID).AsString);
            a_oXMLDoc.DodajElementPodrzedny(oAsort, sUNIJM_SYMBOL, ac_oRecepPozQuery.FieldByName(sUNIJM_SYMBOL).AsString);
            a_oXMLDoc.DodajElementPodrzedny(oAsort, sUNIJM_NAZWA, ac_oRecepPozQuery.FieldByName(sUNIJM_NAZWA).AsString);
            a_oXMLDoc.DodajElementPodrzedny(oAsort, sASOKMAT_ID, ac_oRecepPozQuery.FieldByName(sASOKMAT_ID).AsString);
            a_oXMLDoc.DodajElementPodrzedny(oAsort, sASOKMAT_SYMBOL, ac_oRecepPozQuery.FieldByName(sASOKMAT_SYMBOL).AsString);
            a_oXMLDoc.DodajElementPodrzedny(oAsort, sASOKMAT_NAZWA, ac_oRecepPozQuery.FieldByName(sASOKMAT_NAZWA).AsString);
            ac_oRecepPozQuery.Next();
          end;  // while asortyment danej pozycji
        end else  // if s materiay
          ac_oRecepPozQuery.Next();

          // dodanie zasobw pozycji receptury
        while((not ac_oZasobRecepPozQuery.Eof) and
        (ac_oZasobRecepPozQuery.FieldByName(sZLEZLECENIE_ID).AsInteger = iZlecenie) and
        (ac_oZasobRecepPozQuery.FieldByName(sLWPRECEPPOZ_KOLEJNOSC).AsInteger < iOrder)) do
          ac_oZasobRecepPozQuery.Next();
        if(
        (ac_oZasobRecepPozQuery.FieldByName(sZLEZLECENIE_ID).AsInteger = iZlecenie) and
        (ac_oZasobRecepPozQuery.FieldByName(sLWPRECEPPOZ_KOLEJNOSC).AsInteger = iOrder) and
        (not ac_oZasobRecepPozQuery.FieldByName(sZLEZASOB_ID).IsNull)
        )then begin
          oRPozZas  := a_oXMLDoc.DodajElementPodrzedny(oElem, sZLEZLECENIEZASOB);
          while((not ac_oZasobRecepPozQuery.Eof) and
          (ac_oZasobRecepPozQuery.FieldByName(sZLEZLECENIE_ID).AsInteger = iZlecenie) and
          (ac_oZasobRecepPozQuery.FieldByName(sLWPRECEPPOZ_KOLEJNOSC).AsInteger = iOrder)
          ) do begin
            oZasob  := a_oXMLDoc.DodajElementPodrzedny(oRPozZas, sZLEZASOB);
            for i := ac_oZasobRecepPozQuery.FieldDefs.IndexOf(sZLEZASOB_ID) to ac_oZasobRecepPozQuery.Fields.Count-1 do
              a_oXMLDoc.DodajElementPodrzedny(oZasob, ac_oZasobRecepPozQuery.Fields[i].FieldName, ac_oZasobRecepPozQuery.Fields[i].AsString);
            ac_oZasobRecepPozQuery.Next();
          end;  // dopki to samo zlecenie i pozycja receptury
        end;  // if jest chocia jeden zasb podpity do danej pozycji zlecenia
      end;  // while dane receptury zlecenia
    end;  // if znalaz receptur zlecenia
  finally
    ShortDateFormat := sDateFormat;
  end;
{$endif}
end;

  {
    Procedura wysya dane zlece do partnera i zapisuje id otrzymane z obcego systemu
    @param  ac_sDokumentXML     - dokument xml
    @param  ac_iOperacjaId      - operacja
    @param  ac_iUserId:         - user na ktrym zapisane s idki elementw planu do wysania
    @param  ac_sKontekst:       - kontekst na ktrym zapisane s idki elementw planu do wysania
    @param  ac_bWysylanieElems  - czy wysyane s tylko wybrane elementy planu produkcji (id zapisane s ju w admid)
                                  Przy wysyaniu caego zlecenia trzeba usun stare zapisy a przy wysyaniu poszczeglnych elementw planu nie mona
                                  tego robi
  }
procedure TZLEDataManager.WyslijDaneZlec(
  const ac_sDokumentXML:      string;
  const ac_iOperacjaId:       integer;
  const ac_iUserId:           integer;
  const ac_sKontekst:         string;
  const ac_bWysylanieElems:   boolean = false // czy wysyane s tylko wybrane elementy planu produkcji (id zapisane s ju w admid)
);

{$ifndef build_all}
  procedure AktualizujIdObcy(
    const ac_sRezultXML:  string;
    const ac_bBlad:       boolean
  );
  var
    i:        integer;
    oQuery:   TUNIQuery;
    sMsg:     string;
    aSuccess: TXMLSuccessDataArray;
    aFailure: TXMLFailureDataArray;
    sData:    string;
    sRecepPozId:  string;
    sPlanProdElId:string;
    sZlecenieId:  string;
    sBlad:        string;
  begin
    if(ac_bBlad) then
      sBlad := '1'
    else
      sBlad := 'null';
    SetLength(aSuccess, 0);
    SetLength(aFailure, 0);
    if(UNIINTDM.CzyXMLResultSuccess(ac_sRezultXML, sMsg, aSuccess, aFailure)) then begin
      if(Length(aSuccess) = 0) then
        raise EOF_ZLEException.Create(csUNIINTErrorOdpowiedzBrak_Partnera);
      sData := KonwertujDateCzas2SQL(UNINow());
      if(not SQLManager.SprawdzIstnienieSekwencera('SEQ_' + sZLEZLECENIEOBCY)) then
        UniqueKey[sZLEZLECENIEOBCY];
      sData :=
        'merge INTO ' + SQLManager.GetTableName(sZLEZLECENIEOBCY) + ' O ' +
        ' USING (' +
          'SELECT ' +
            '%s AS ' + sZLEZLECENIE_ID  + ', ' +
            '%s AS ' + sLWPRECEPPOZ_ID  + ', ' +
            '%s AS ' + sLWPPLANPRODEL_ID +
          ' FROM dual'  +
        ') O1 ' +
        ' ON (' +
          'O.'  + sZLEZLECENIE_ID + ' = O1.'  + sZLEZLECENIE_ID +
          ' AND (' +
            '(' +
              'O1.' + sLWPRECEPPOZ_ID + ' IS NULL' +
              ' AND O.' + sLWPRECEPPOZ_ID + ' IS NULL' +
            ') OR (' +
              'O.' + sLWPRECEPPOZ_ID + ' = O1.' + sLWPRECEPPOZ_ID +
            ')' +
          ') AND (' +
            '(' +
              'O1.' + sLWPPLANPRODEL_ID + ' IS NULL' +
              ' AND O.' + sLWPPLANPRODEL_ID + ' IS NULL' +
            ') OR (' +
              'O.' + sLWPPLANPRODEL_ID + ' = O1.' + sLWPPLANPRODEL_ID +
            ')' +
          ')' +
        ')' +
        ' WHEN matched THEN' +
        '  UPDATE SET ' +
          'O.' + sZLEZLECENIE_OBCY_ID     + ' = ''%s'', ' +
          'O.' + sZLEZLECENIEOBCY_UZ_ZM_ID+ ' = ' + IntToStr(SecurityManager.UserId) + ', ' +
          'O.' + sZLEZLECENIEOBCY_DATA_ZM + ' = ' + sData + ', ' +
          'O.' + sZLEZLECENIEOBCY_BLAD    + ' = ' + sBlad +
        ' WHEN NOT matched THEN' +
        '  INSERT ('  +
          'O.'  + sZLEZLECENIEOBCY_ID + ', O.' + sZLEZLECENIE_ID      + ', ' +
          'O.'  + sLWPRECEPPOZ_ID     + ', O.' + sZLEZLECENIE_OBCY_ID + ', ' +
          'O.'  + sZLEZLECENIEOBCY_UZ_AU_ID + ', O.' + sZLEZLECENIEOBCY_DATA_AU + ', ' +
          'O.'  + sLWPPLANPRODEL_ID   + ', ' + sZLEZLECENIEOBCY_BLAD  +
        ') VALUES ('  +
          SQLManager.GetGeneratorName(sZLEZLECENIEOBCY) + '.NEXTVAL, %s, ' +
          '%s, ''%s'', ' +
          IntToStr(SecurityManager.UserId) + ', ' + sData  + ', ' +
          '%s, ' + sBlad +
        ')';
      oQuery  := SQLManager.CreateQuery('');
      try
        for i := Low(aSuccess) to High(aSuccess) do begin
          if(aSuccess[i].m_sEntity = sZLEZLECENIE) then begin
            if(aSuccess[i].m_iReferenceId = 0) then
              raise EOF_ZLEException.Create(csUNIINTErrorOdpowiedzBrak_Wlasnego);
            if(Length(aSuccess[i].m_sPartnerId) = 0) then
              raise EOF_ZLEException.Create(csUNIINTErrorOdpowiedzBrak_Partnera);
            if((Length(aSuccess[i].m_sDataMessage) > 0) and (Copy(aSuccess[i].m_sDataMessage, 1, 2) = 'PL')) then begin
              sRecepPozId   := 'NULL';
              sPlanProdElId := IntToStr(aSuccess[i].m_iReferenceId);
              sZlecenieId   := Copy(aSuccess[i].m_sDataMessage, 3, Length(aSuccess[i].m_sDataMessage) - 2);
            end else begin
              sRecepPozId   := IntToStr(aSuccess[i].m_iReferenceId);
              sPlanProdElId := 'NULL';
              sZlecenieId   := aSuccess[i].m_sDataMessage;
            end;
            if((not ac_bWysylanieElems) and (i = 0)) then begin
                // usunicie dotychczasowych wpisw dla tego zlecenia
              SQLManager.ExecuteQuery(
                'delete from ' + SQLManager.GetTableName(sZLEZLECENIEOBCY) + ' O ' +
                ' where ' +
                  'O.' + sZLEZLECENIE_ID + ' = ' + sZlecenieId
              );
            end;
            oQuery.SQL.Text := Format(
              sData,
              [
                sZlecenieId, sRecepPozId, sPlanProdElId, aSuccess[i].m_sPartnerId,
                sZlecenieId, sRecepPozId, aSuccess[i].m_sPartnerId, sPlanProdElId
              ]
            );
            oQuery.ExecSQL(false);
          end;  // if(aSuccess[i].m_sEntity = sZLEZLECENIE)
        end;  // for i := Low(aSuccess) to High(aSuccess)
      finally
        oQuery.Free();
      end;
    end;  // if rezult success
  end;  // procedure AktualizujIdObcy

  procedure UsunIdObcyPlanuProd(
    const ac_iZlecenieId: integer
  );
  var
    sWhere: string;
  begin
    if(ac_bWysylanieElems) then begin
        // usuwane s tylko wybrane elementy planu produkcji
      sWhere  :=
        'and O.' + sLWPPLANPRODEL_ID + ' in(' + ADMID_SelectSQL(cADMIDFunZLEElemPlanDoWyslania, 0, ac_iUserId, ac_sKontekst, vAktywnaFirma) + ')';
    end else  // if(ac_bWysylanieElems)
      sWhere  := '';

    SQLManager.ExecuteQuery(
      'delete from ' + SQLManager.GetTableName(sZLEZLECENIEOBCY) + ' O ' +
      ' where ' +
        'O.' + sZLEZLECENIE_ID + ' = ' + IntToStr(ac_iZlecenieId) +
        sWhere
    );
  end;

  procedure UsunIdObcyZleceniaProd(
    const ac_iZlecenieId: integer
  );
  begin
    SQLManager.ExecuteQuery(
      'delete from ' + SQLManager.GetTableName(sZLEZLECENIEOBCY) + ' O ' +
      ' where ' +
        'O.' + sZLEZLECENIE_ID + ' = ' + IntToStr(ac_iZlecenieId)
    );
  end;

  function  DajIdWysylanegoZlecenia():  integer;
  var
    oXMLSrcDoc:   TUNIXMLParser;
    oSrcRootElem: IXMLDOMElement;
    oElem:        IXMLDOMElement;
  begin
    oXMLSrcDoc := TUNIXMLParser.Create();
    try
      if(oXMLSrcDoc.ZaladujDokumentZeStringa(ac_sDokumentXML) = 0) then begin
        oSrcRootElem  := oXMLSrcDoc.DajElementGlowny();
        oElem := (oSrcRootElem.selectSingleNode(sZLEZLECENIE_ID) as IXMLDOMElement);
        if((oElem <> nil) and (oElem.Get_text() <> '')) then
          result  := StrToInt(oElem.Get_text())
        else
          result  := 0;
      end else
        result  := 0;
    finally
      oXMLSrcDoc.Free();
    end;
  end;  // function  DajIdWysylanegoZlecenia

var
  sKomunikat:     string;
  sResultXml:     string;
  oResultDataSet: TDataSet;
  enumReakcja:    TenumOperacjaReakcja;
  aSuccessData:   TXMLSuccessDataArray;
  aFailureData:   TXMLFailureDataArray;
  i:              integer;
{$endif}
begin
{$ifndef build_all}
  sResultXml    := '';
  oResultDataSet:= nil;
  if((ac_iOperacjaId > 0) and UNIINTDM.CzyOperacjaAktywna(ac_iOperacjaId)) then begin
    if(UNIINTDM.Wykonaj(ac_iOperacjaId, ac_sDokumentXML, sResultXml, oResultDataSet)) then begin
      if(ac_iOperacjaId = cUNIINTOperacja_PlanProdUsun_Id) then
        UsunIdObcyPlanuProd(DajIdWysylanegoZlecenia())
      else if(ac_iOperacjaId = cUNIINTOperacja_ZlecenieProdUsun_Id) then
        UsunIdObcyZleceniaProd(DajIdWysylanegoZlecenia())
      else
        AktualizujIdObcy(sResultXml, false);
    end else begin  // if operacja wykonana poprawnie
        // bd wykonania operacji
      UNIINTDM.CzyXMLResultSuccess(sResultXml, sKomunikat, aSuccessData, aFailureData);
        // odczytanie komunikatw bdw
      sKomunikat  := '';
      for i := 0 to High(aFailureData) do begin
        if(Length(aFailureData[i].m_sReason) > 0) then begin
            // w reason znajduj si rezultaty wysania fragmentw zlecenia przed wystpieniem bdu
          AktualizujIdObcy(aFailureData[i].m_sReason, true);
        end;
        if(Length(aFailureData[i].m_sErrorCode) > 0) then begin
            // sprawdzamy czy to zlecenie nie powinno by pominite przy wysyaniu ze wzgldu na swj status
          if(aFailureData[i].m_sErrorCode <> csUNIINTOperacjaBlad_BCS_Zlecenie_Status_Pomin_Id) then
            sKomunikat  := sKomunikat + Chr(13) + aFailureData[i].m_sErrorCode + ' - ' + aFailureData[i].m_sErrorMessage;
        end else
          sKomunikat  := sKomunikat + Chr(13) + aFailureData[i].m_sErrorMessage;
      end;
      if(Length(sKomunikat) > 0) then begin
        sKomunikat  := 'Nie udao si wykona operacji u Partnera. Przyczyna:' + sKomunikat;
        if(UNIINTDM.DajReakcjeNaBladOperacji(ac_iOperacjaId, enumReakcja)) then begin
          case enumReakcja of
            reIgnoruj:  begin
              Komunikat(cWarning, sKomunikat, MB_OK + MB_ICONEXCLAMATION);
            end;
            reAnuluj: begin
              raise EOF_ZLEException.Create(
                'Operacja anulowana.' + Chr(13) + sKomunikat
              );
            end;
          end;  // case enumReakcja
        end;  // if(UNIINTDM.DajReakcjeNaBladOperacji(iOperacjaId, enumReakcja))
      end;  // if(Length(sKomunikat) > 0)
    end;  // else - if(UNIINTDM.Wykonaj
  end;  // if operacja aktywna
{$endif}
end;

{
  Funkcja sprzawdza czy zlecenia, ktrych id zostay zapisane wczeniej do admid s w peni zaplanowane.
  Parametrami s wartoci pl tabeli admid.
}
function  TZLEDataManager.CzyWysylaneZleceniaSaWPelniZaplanowane(
  const ac_iUserId:   integer;
  const ac_sKontekst: string
):  boolean;
{$ifndef build_all}
var
  oQuery: TUNIQuery;
{$endif}
begin
{$ifndef build_all}
  result  := true;
  oQuery  := SQLManager.CreateQuery(
    'SELECT ' +
      'Z.' + sZLEZLECENIE_ID    + ', Z.' + sZLEZLECENIE_SYMBOL  + ', ' +
      'Z.' + sZLEZLECENIE_ILOSC + ', PL.'+ sLWPPLANPRODEL_ILOSC_PLAN  +
    ' FROM ' +
      '%s Z' +
        ' inner join %s RP' +
          ' on Z.' + sLWPRECEPTURA_ID + ' = RP.' + sLWPRECEPTURA_ID +
        ' inner join (' +
          ADMID_SelectSQL(cADMIDFunZLEZlecDoWyslania, 0, ac_iUserId, ac_sKontekst, vAktywnaFirma) +
        ') ADMID2' +
          ' on Z.' + sZLEZLECENIE_ID + ' = ADMID2.' + sADMID_V +
        ' left outer join (' +
          'SELECT ' +
            'EL.' + sZLEZLECENIE_ID + ', EL.' + sLWPRECEPPOZ_ID + ', ' +
            'Sum(EL.' + sLWPPLANPRODEL_ILOSC_PLAN + ') AS ' + sLWPPLANPRODEL_ILOSC_PLAN +
          ' FROM ' +
            '%s EL' +
              ' inner join %s RP' +
                ' ON EL.' + sLWPRECEPPOZ_ID + ' = RP.' + sLWPRECEPPOZ_ID +
          ' GROUP BY ' +
            'EL.' + sZLEZLECENIE_ID + ', EL.' + sLWPRECEPPOZ_ID +
        ') PL' +
          ' ON ' +
            'Z.' + sZLEZLECENIE_ID + ' = PL.' + sZLEZLECENIE_ID +
            ' and RP.' + sLWPRECEPPOZ_ID + ' = PL.' + sLWPRECEPPOZ_ID +
    ' WHERE ' +
      'PL.' + sZLEZLECENIE_ID + ' IS NULL' +
      ' OR Z.' + sZLEZLECENIE_ILOSC + ' > PL.' + sLWPPLANPRODEL_ILOSC_PLAN,
    [
      sZLEZLECENIE, sLWPRECEPPOZ, sLWPPLANPRODEL, sLWPRECEPPOZ
    ]
  );
  try
    oQuery.Open();
    if(not oQuery.IsEmpty) then begin
      result  := (Komunikat(
        cConfirmation,
        'Cz zlece nie jest w peni zaplanowana. Kontynuowa wysyanie?',
        MB_YESNO + MB_ICONQUESTION
      ) = mrYes);
    end;  // if(not oQuery.IsEmpty)
  finally
    oQuery.Free();
  end;
{$endif}
end;

{
  Funkcja buduje query zwracajce dane zasobw pozycji receptury zlece, ktrych id zostay zapisane wczeniej do admid.
  Parametrami s wartoci pl tabeli admid.
}
function  TZLEDataManager.DajQueryZasobowReceppozPlanuProdukcjiDoWyslania(
  const ac_iUserId:         integer;
  const ac_sKontekst:       string;
  const ac_bWysylanieElems: boolean = false // czy wysyane s tylko wybrane elementy planu produkcji (id zapisane s ju w admid)
):  TUNIQuery;
{$ifndef build_all}
var
  sWhere: String;
{$endif}
begin
{$ifndef build_all}
  sWhere  :=
      'ADMID.'  + sADMID_FUNK + ' = ' + IntToStr(cADMIDFunZLEZlecDoWyslania)  + ' and ' +
      'ADMID.'  + sADMID_PFUNK+ ' = 0 and ' +
      'ADMID.'  + sSMUSER_ID  + ' = ' + IntToStr(ac_iUserId);
  if(vAktywnaFirma > 0) then
    DopiszDoWhere('ADMID.'  + sUNIODDZIAL_ID + ' = ' + IntToStr(vAktywnaFirma), sWhere);
  if(Length(ac_sKontekst) > 0) then
    DopiszDoWhere('ADMID.'  + sADMID_KONTEKST + ' = ''' + ac_sKontekst + '''', sWhere);
  if(ac_bWysylanieElems) then begin
      // wysyane s tylko wybrane elementy planu produkcji
    DopiszDoWhere(
      'EL.' + sLWPPLANPRODEL_ID + ' in(' +
        ADMID_SelectSQL(cADMIDFunZLEElemPlanDoWyslania, 0, ac_iUserId, ac_sKontekst, vAktywnaFirma) +
      ')',
      sWhere
    );
  end;  // if(ac_bWysylanieElems)

  result  := SQLManager.CreateQuery(
    'select ' +
      'EL.' + sLWPPLANPRODEL_ID     + ', ZAS.'+ sZLEZASOB_ID          + ', ' +
      'ZAS.'+ sZLEZASOB_SYMBOL      + ', ZAS.'+ sZLEZASOB_NAZWA       +
    ' from '  +
      '%s EL'  +
        ' inner join %s ADMID' +
          ' on EL.'  + sZLEZLECENIE_ID + ' = ADMID.' + sADMID_V +
        ' inner join %s PL'     +
          ' on EL.'+ sLWPPLANPROD_ID + ' = PL.' + sLWPPLANPROD_ID +
        ' inner join %s ZAS' +
          ' on PL.' + sZLEZASOB_ID  + ' = ZAS.'  + sZLEZASOB_ID +
    ' where ' +
      sWhere  +
    ' order by '  +
      'EL.'  + sZLEZLECENIE_ID + ', EL.' + sLWPPLANPRODEL_ID,
    [
      sLWPPLANPRODEL, sADMID, sLWPPLANPROD, sZLEZASOB
    ]
  );
  try
    result.Open();
    if(Result.IsEmpty()) then
      FreeAndNil(result);
  except
    result.Free();
    raise;
  end;
{$else}
  result  := nil;
{$endif}
end;

{
  Funkcja buduje query zwracajce dane planu produkcji zlece, ktrych id zostay zapisane wczeniej do admid.
  Parametrami s wartoci pl tabeli admid.
}
function  TZLEDataManager.DajQueryPlanuProdukcjiZlecDoWyslania(
  const ac_iUserId:         integer;
  const ac_sKontekst:       string;
  const ac_bWysylanieElems: boolean = false // czy wysyane s tylko wybrane elementy planu produkcji (id zapisane s ju w admid)
):  TUNIQuery;
{$ifndef build_all}
var
  sWhere: String;
{$endif}
begin
{$ifndef build_all}
  sWhere  :=
      'ADMID.'  + sADMID_FUNK + ' = ' + IntToStr(cADMIDFunZLEZlecDoWyslania)  + ' and ' +
      'ADMID.'  + sADMID_PFUNK+ ' = 0 and ' +
      'ADMID.'  + sSMUSER_ID  + ' = ' + IntToStr(ac_iUserId);
  if(vAktywnaFirma > 0) then
    DopiszDoWhere('ADMID.'  + sUNIODDZIAL_ID + ' = ' + IntToStr(vAktywnaFirma), sWhere);
  if(Length(ac_sKontekst) > 0) then
    DopiszDoWhere('ADMID.'  + sADMID_KONTEKST + ' = ''' + ac_sKontekst + '''', sWhere);
  if(ac_bWysylanieElems) then begin
      // wysyane s tylko wybrane elementy planu produkcji
    DopiszDoWhere(
      'EL.' + sLWPPLANPRODEL_ID + ' in(' +
        ADMID_SelectSQL(cADMIDFunZLEElemPlanDoWyslania, 0, ac_iUserId, ac_sKontekst, vAktywnaFirma) +
      ')',
      sWhere
    );
  end;  // if(ac_bWysylanieElems)

  result  := SQLManager.CreateQuery(
    'select ' +
      'EL.' + sZLEZLECENIE_ID         + ', EL.' + sLWPPLANPRODEL_ID       + ', ' +
      'EL.' + sLWPPLANPRODEL_CZAS_POCZ+ ', EL.' + sLWPPLANPRODEL_CZAS_KONC+ ', ' +
      'EL.' + sLWPPLANPRODEL_ILOSC_PLAN + ', EL.' + sLWPRECEPPOZ_ID       + ', ' +
      'PL.' + sZLEZASOB_ID            + ', RP.' + sLWPRECEPPOZ_KOLEJNOSC  +
    ' from '  +
      '%s Z'  +
        ' inner join %s ADMID' +
          ' on Z.'  + sZLEZLECENIE_ID + ' = ADMID.' + sADMID_V +
        ' inner join %s EL' +
          ' on Z.' + sZLEZLECENIE_ID + ' = EL.' + sZLEZLECENIE_ID +
        ' inner join %s PL' +
          ' on EL.' + sLWPPLANPROD_ID + ' = PL.' + sLWPPLANPROD_ID +
        ' inner join %s RP'     +
          ' on EL.'+ sLWPRECEPPOZ_ID  + ' = RP.'  + sLWPRECEPPOZ_ID  +
    ' where ' +
      sWhere  +
      ' and EL.' + sLWPPLANPRODEL_TYP + ' = ''' + sLWPCONST_PLANPRODEL_TYP_PARTIA_ID + '''' +
    ' order by '  +
      'Z.'  + sZLEZLECENIE_ID + ', EL.' + sLWPPLANPRODEL_CZAS_POCZ + ', RP.' + sLWPRECEPPOZ_KOLEJNOSC + ', ' +
      'PL.'  + sZLEZASOB_ID + ', EL.' + sLWPPLANPRODEL_ID,
    [
      sZLEZLECENIE  , sADMID, sLWPPLANPRODEL, sLWPPLANPROD,
      sLWPRECEPPOZ
    ]
  );
  try
    result.Open();
    if(Result.IsEmpty()) then
      FreeAndNil(result);
  except
    result.Free();
    raise;
  end;
{$else}
  result  := nil;
{$endif}
end;

{
  Procedura przepisuje dane z aktualnego rekordu ac_oZlecQuery oraz odpowiadajcym
  mu rekordw ac_oRecepPozQuery i ac_oZasobRecepPozQuery do dokumentu xml
  podpinajc elementy do elementu a_oParentNode
}
procedure TZLEDataManager.PrzepiszDanePlanuProdukcjiDoXML(
        a_oXMLDoc:              TUNIXMLParser;
        a_oParentNode:          IXMLDOMElement;
  const ac_oZlecQuery:          TUNIQuery;
  const ac_oRecepPozQuery:      TUNIQuery;
  const ac_oZasobRecepPozQuery: TUNIQuery;
  const ac_oPlanProdQuery:      TUNIQuery
);
{$ifndef build_all}
var
  oRecep:   IXMLDOMElement;
  oAsorts:  IXMLDOMElement;
  oAsort:   IXMLDOMElement;
  oElem:    IXMLDOMElement;
  i:        integer;
  iZlecenie:integer;
  iRecepPoz:integer;
  sDateFormat:  string;
{$endif}
begin
{$ifndef build_all}
  sDateFormat := ShortDateFormat;
  try
    ShortDateFormat := 'yyyy-mm-dd';  // 18.05.2010 by Adam - specjalnie dla Dekorglassu
    iZlecenie := ac_oZlecQuery.FieldByName(sZLEZLECENIE_ID).AsInteger;
      // odnalezienie planu produkcji danego zlecenia
    if(ac_oPlanProdQuery.FieldByName(sZLEZLECENIE_ID).AsInteger > iZlecenie) then
      ac_oPlanProdQuery.First();
    while((not ac_oPlanProdQuery.Eof) and
    (ac_oPlanProdQuery.FieldByName(sZLEZLECENIE_ID).AsInteger < iZlecenie)) do
      ac_oPlanProdQuery.Next();
      // przepisywanie danych danego zlecenia
    if(ac_oPlanProdQuery.FieldByName(sZLEZLECENIE_ID).AsInteger = iZlecenie) then begin
      oRecep:= a_oXMLDoc.DodajElementPodrzedny(a_oParentNode, sLWPRECEPTURA);
      for i := 0 to ac_oZlecQuery.Fields.Count-1 do begin
        if(i < 5) then begin
            // pola receptury
          a_oXMLDoc.DodajElementPodrzedny(oRecep, ac_oZlecQuery.Fields[i].FieldName, ac_oZlecQuery.Fields[i].AsString);
        end else begin
            // pozostale pola
          a_oXMLDoc.DodajElementPodrzedny(a_oParentNode, ac_oZlecQuery.Fields[i].FieldName, ac_oZlecQuery.Fields[i].AsString);
        end;
      end;
      while((not ac_oPlanProdQuery.Eof) and
      (ac_oPlanProdQuery.FieldByName(sZLEZLECENIE_ID).AsInteger = iZlecenie)) do begin
        iRecepPoz := ac_oPlanProdQuery.FieldByName(sLWPRECEPPOZ_KOLEJNOSC).AsInteger;

          // odnalezienie odpowiedniej pozycji receptury
        if(ac_oRecepPozQuery.Eof or (ac_oRecepPozQuery.FieldByName(sZLEZLECENIE_ID).AsInteger > iZlecenie) or
        (
          (ac_oRecepPozQuery.FieldByName(sZLEZLECENIE_ID).AsInteger = iZlecenie) and
          (ac_oRecepPozQuery.FieldByName(sLWPRECEPPOZ_KOLEJNOSC).AsInteger > iRecepPoz)
        )) then
          ac_oRecepPozQuery.First();
        while((not ac_oRecepPozQuery.Eof) and
        (
          (ac_oRecepPozQuery.FieldByName(sZLEZLECENIE_ID).AsInteger < iZlecenie) or
          (
            (ac_oRecepPozQuery.FieldByName(sZLEZLECENIE_ID).AsInteger = iZlecenie) and
            (ac_oRecepPozQuery.FieldByName(sLWPRECEPPOZ_KOLEJNOSC).AsInteger < iRecepPoz)
          )
        )) do
          ac_oRecepPozQuery.Next();

          // odnalezienie zasobw danej partii produkcji
        if(ac_oZasobRecepPozQuery.Eof or
          (ac_oZasobRecepPozQuery.FieldByName(sLWPPLANPRODEL_ID).AsInteger > ac_oPlanProdQuery.FieldByName(sLWPPLANPRODEL_ID).AsInteger)
        ) then
          ac_oZasobRecepPozQuery.First();
        while((not ac_oZasobRecepPozQuery.Eof) and
          (ac_oZasobRecepPozQuery.FieldByName(sLWPPLANPRODEL_ID).AsInteger < ac_oPlanProdQuery.FieldByName(sLWPPLANPRODEL_ID).AsInteger)
        ) do
          ac_oZasobRecepPozQuery.Next();

          // dodanie elementu planu produkcji
        if(
          (ac_oRecepPozQuery.FieldByName(sZLEZLECENIE_ID).AsInteger = iZlecenie) and
          (ac_oRecepPozQuery.FieldByName(sLWPRECEPPOZ_KOLEJNOSC).AsInteger = iRecepPoz) and
          (ac_oZasobRecepPozQuery.FieldByName(sLWPPLANPRODEL_ID).AsInteger = ac_oPlanProdQuery.FieldByName(sLWPPLANPRODEL_ID).AsInteger)
        ) then begin
          oElem := a_oXMLDoc.DodajElementPodrzedny(oRecep, sLWPPLANPRODEL);
          a_oXMLDoc.DodajElementPodrzedny(oElem, sLWPPLANPRODEL_ID, ac_oPlanProdQuery.FieldByName(sLWPPLANPRODEL_ID).AsString);
          a_oXMLDoc.DodajElementPodrzedny(oElem, sLWPPLANPRODEL_DATA_POCZ, DateToStr(Trunc(ac_oPlanProdQuery.FieldByName(sLWPPLANPRODEL_CZAS_POCZ).AsDateTime)));
          a_oXMLDoc.DodajElementPodrzedny(oElem, sLWPPLANPRODEL_CZAS_POCZ, Copy(TimeToStr(ac_oPlanProdQuery.FieldByName(sLWPPLANPRODEL_CZAS_POCZ).AsDateTime), 1, 5));
          a_oXMLDoc.DodajElementPodrzedny(oElem, sLWPPLANPRODEL_DATA_KONC, DateToStr(Trunc(ac_oPlanProdQuery.FieldByName(sLWPPLANPRODEL_CZAS_KONC).AsDateTime)));
          a_oXMLDoc.DodajElementPodrzedny(oElem, sLWPPLANPRODEL_CZAS_KONC, Copy(TimeToStr(ac_oPlanProdQuery.FieldByName(sLWPPLANPRODEL_CZAS_KONC).AsDateTime), 1, 5));
          a_oXMLDoc.DodajElementPodrzedny(oElem, sLWPPLANPRODEL_ILOSC_PLAN, ac_oPlanProdQuery.FieldByName(sLWPPLANPRODEL_ILOSC_PLAN).AsString);
            // dane pproduktu
          a_oXMLDoc.DodajElementPodrzedny(oElem, cUNIINTPOLPRODUKT_ID, ac_oRecepPozQuery.FieldByName(cUNIINTPOLPRODUKT_ID).AsString);
          a_oXMLDoc.DodajElementPodrzedny(oElem, cUNIINTPOLPRODUKT_SYMBOL, ac_oRecepPozQuery.FieldByName(cUNIINTPOLPRODUKT_SYMBOL).AsString);
          a_oXMLDoc.DodajElementPodrzedny(oElem, cUNIINTPOLPRODUKT_NAZWA, ac_oRecepPozQuery.FieldByName(cUNIINTPOLPRODUKT_NAZWA).AsString);
          a_oXMLDoc.DodajElementPodrzedny(oElem, cUNIINTKONTOMAT_ID, ac_oRecepPozQuery.FieldByName(cUNIINTKONTOMAT_ID).AsString);
          a_oXMLDoc.DodajElementPodrzedny(oElem, cUNIINTKONTOMAT_SYMBOL, ac_oRecepPozQuery.FieldByName(cUNIINTKONTOMAT_SYMBOL).AsString);
          a_oXMLDoc.DodajElementPodrzedny(oElem, cUNIINTKONTOMAT_NAZWA, ac_oRecepPozQuery.FieldByName(cUNIINTKONTOMAT_NAZWA).AsString);
          a_oXMLDoc.DodajElementPodrzedny(oElem, cUNIINTPOLPRODUKT_JM_ID, ac_oRecepPozQuery.FieldByName(cUNIINTPOLPRODUKT_JM_ID).AsString);
          a_oXMLDoc.DodajElementPodrzedny(oElem, cUNIINTPOLPRODUKT_JM_SYMBOL, ac_oRecepPozQuery.FieldByName(cUNIINTPOLPRODUKT_JM_SYMBOL).AsString);
          a_oXMLDoc.DodajElementPodrzedny(oElem, cUNIINTPOLPRODUKT_JM_NAZWA, ac_oRecepPozQuery.FieldByName(cUNIINTPOLPRODUKT_JM_NAZWA).AsString);
            // dane zasobu
          a_oXMLDoc.DodajElementPodrzedny(oElem, sZLEZASOB_ID, ac_oZasobRecepPozQuery.FieldByName(sZLEZASOB_ID).AsString);
          a_oXMLDoc.DodajElementPodrzedny(oElem, sZLEZASOB_SYMBOL, ac_oZasobRecepPozQuery.FieldByName(sZLEZASOB_SYMBOL).AsString);
          a_oXMLDoc.DodajElementPodrzedny(oElem, sZLEZASOB_NAZWA, ac_oZasobRecepPozQuery.FieldByName(sZLEZASOB_NAZWA).AsString);
            // materiay
          if(not ac_oRecepPozQuery.FieldByName(sASOASORT_ID).IsNull) then begin
            oAsorts := a_oXMLDoc.DodajElementPodrzedny(oElem, sZLEZLECENIEMAT);
            while((not ac_oRecepPozQuery.Eof) and
            (ac_oRecepPozQuery.FieldByName(sZLEZLECENIE_ID).AsInteger = iZlecenie) and
            (ac_oRecepPozQuery.FieldByName(sLWPRECEPPOZ_KOLEJNOSC).AsInteger = iRecepPoz)) do begin
              oAsort  := a_oXMLDoc.DodajElementPodrzedny(oAsorts, sASOASORT);
              a_oXMLDoc.DodajElementPodrzedny(oAsort, sASOASORT_ID, ac_oRecepPozQuery.FieldByName(sASOASORT_ID).AsString);
              a_oXMLDoc.DodajElementPodrzedny(oAsort, sASOASORT_SYMBOL, ac_oRecepPozQuery.FieldByName(sASOASORT_SYMBOL).AsString);
              a_oXMLDoc.DodajElementPodrzedny(oAsort, sASOASORT_NAZWA, ac_oRecepPozQuery.FieldByName(sASOASORT_NAZWA).AsString);
              a_oXMLDoc.DodajElementPodrzedny(oAsort, sASOASORT_PKWIU, ac_oRecepPozQuery.FieldByName(sASOASORT_PKWIU).AsString);
              a_oXMLDoc.DodajElementPodrzedny(oAsort, sASOASORT_INDEKS, ac_oRecepPozQuery.FieldByName(sASOASORT_INDEKS).AsString);
              a_oXMLDoc.DodajElementPodrzedny(oAsort, sZLEZLECENIEMAT_ILOSC, ac_oRecepPozQuery.FieldByName(sZLEZLECENIEMAT_ILOSC).AsString);
              a_oXMLDoc.DodajElementPodrzedny(oAsort, sUNIJM_ID, ac_oRecepPozQuery.FieldByName(sUNIJM_ID).AsString);
              a_oXMLDoc.DodajElementPodrzedny(oAsort, sUNIJM_SYMBOL, ac_oRecepPozQuery.FieldByName(sUNIJM_SYMBOL).AsString);
              a_oXMLDoc.DodajElementPodrzedny(oAsort, sUNIJM_NAZWA, ac_oRecepPozQuery.FieldByName(sUNIJM_NAZWA).AsString);
              a_oXMLDoc.DodajElementPodrzedny(oAsort, sASOKMAT_ID, ac_oRecepPozQuery.FieldByName(sASOKMAT_ID).AsString);
              a_oXMLDoc.DodajElementPodrzedny(oAsort, sASOKMAT_SYMBOL, ac_oRecepPozQuery.FieldByName(sASOKMAT_SYMBOL).AsString);
              a_oXMLDoc.DodajElementPodrzedny(oAsort, sASOKMAT_NAZWA, ac_oRecepPozQuery.FieldByName(sASOKMAT_NAZWA).AsString);
              ac_oRecepPozQuery.Next();
            end;  // while asortyment danej pozycji
          end;  // if s materiay
        end;  // if odnalaz wszystkie dane


        ac_oPlanProdQuery.Next();
      end;
    end;  // if(ac_oPlanProdQuery.FieldByName(sZLEZLECENIE_ID).AsInteger = iZlecenie)
  finally
    ShortDateFormat := sDateFormat;
  end;
{$endif}
end;

  {
    Procedura zewntrzna moduu ZLE
  }
procedure TZLEDataManager.WyslijPlanProdukcjiZlec(
  const ac_oZlecIds:            TStringList;
  const ac_sKontekst:           string;
  const ac_oPlanProdElId:       TStringList = nil // identyfikatory elementw planu produkcji podawane jeeli maj by wysane tylko te elementy a nie cae zlecenia
);
{$ifndef build_all}
var
  oXMLDoc:    TUNIXMLParser;
  oElem:      IXMLDOMElement;
  oQueryZlec: TUNIQuery;
  oQueryRecep:TUNIQuery;
  oQueryZasob:TUNIQuery;
  oQueryPlan: TUNIQuery;
  sXML:       string;
  OutProgForm: TProgressForm;
  bWybraneEl: boolean;  // czy wysyane s tylko wybrane elementy planu produkcji
{$endif}
begin
{$ifndef build_all}
  if((ac_oZlecIds.Count = 0) or (not UNIINTDM.CzyOperacjaAktywna(cUNIINTOperacja_PlanProdWyslij_Id))) then
    exit;
  if(not ZLEDM.ZapiszIdZlecDoWyslaniaWADMId(ac_oZlecIds, SecurityManager.UserId, ac_sKontekst, false, ac_oPlanProdElId)) then
    exit;
  oQueryZlec  := nil;
  oQueryRecep := nil;
  oQueryZasob := nil;
  oQueryPlan  := nil;
  oXMLDoc     := nil;
  try
    bWybraneEl  := ((ac_oPlanProdElId <> nil) and (ac_oPlanProdElId.Count > 0));
    if((ac_oPlanProdElId = nil) or (ac_oPlanProdElId.Count = 0) or ZLEDM.CzyWysylaneZleceniaSaWPelniZaplanowane(SecurityManager.UserId, ac_sKontekst)) then begin
      oQueryZlec  := ZLEDM.DajQueryZlecDoWyslania(
        SecurityManager.UserId,
        ac_sKontekst
      );
      oQueryRecep := ZLEDM.DajQueryReceppozZlecDoWyslania(
        SecurityManager.UserId,
        ac_sKontekst,
        bWybraneEl
      );
      oQueryZasob := ZLEDM.DajQueryZasobowReceppozPlanuProdukcjiDoWyslania(
        SecurityManager.UserId,
        ac_sKontekst,
        bWybraneEl
      );
      oQueryPlan  := ZLEDM.DajQueryPlanuProdukcjiZlecDoWyslania(
        SecurityManager.UserId,
        ac_sKontekst,
        bWybraneEl
      );
      if(oQueryPlan = nil) then begin
        Komunikat(cWarning, 'Wybrane zlecenia nie zostay umieszczone na planie produkcji', MB_OK);
      end else if(oQueryZlec <> nil) then begin
        oQueryZlec.FetchAll();
        ProgressStart(self, oQueryZlec.RecordCount, 'Wysyanie planu produkcji zaznaczonych zlece', True);
        OutProgForm := ProgressForm;
        try
          while(not oQueryZlec.Eof) do begin
            oXMLDoc := TUNIXMLParser.Create();
            oElem := oXMLDoc.DodajElementGlowny(sZLEZLECENIE);
            ZLEDM.PrzepiszDanePlanuProdukcjiDoXML(
              oXMLDoc,
              oElem,
              oQueryZlec,
              oQueryRecep,
              oQueryZasob,
              oQueryPlan
            );
            sXML  := oXMLDoc.ZapiszDokumentDoStringa();
            FreeAndNil(oXMLDoc);
            ProgressForm := OutProgForm;
            ProgressForm.ProgressInc();
            Application.ProcessMessages();
            if(ProgressForm.aborted) then
              break;
            ZLEDM.WyslijDaneZlec(sXML, cUNIINTOperacja_PlanProdWyslij_Id, SecurityManager.UserId, ac_sKontekst, bWybraneEl);
            oQueryZlec.Next();
          end;  // while(not oQueryZlec.Eof)
        finally
          ProgressForm := OutProgForm;
          ProgressEnd();
        end;
      end;  // if(oQueryZlec <> nil)
    end;  // if zlecenia zaplanowane lub uytkownik chce je koniecznie wysa
  finally
    oXMLDoc.Free();
    oQueryZlec.Free();
    oQueryRecep.Free();
    oQueryZasob.Free();
    oQueryPlan.Free();
    ZLEDM.UsunIdZlecDoWyslaniaWADMId(SecurityManager.UserId, ac_sKontekst);
  end;
{$endif}
end;

{
    Procedura zewntrzna moduu ZLE
  }
procedure TZLEDataManager.WycofajPlanProdukcjiZlec(
  const ac_oZlecIds:            TStringList;
  const ac_sKontekst:           string;
  const ac_oPlanProdElId:       TStringList = nil // identyfikatory elementw planu produkcji podawane jeeli maj by wysane tylko te elementy a nie cae zlecenia
);
{$ifndef build_all}
var
  oXMLDoc:    TUNIXMLParser;
  oElem:      IXMLDOMElement;
  oQueryZlec: TUNIQuery;
  oQueryRecep:TUNIQuery;
  oQueryZasob:TUNIQuery;
  oQueryPlan: TUNIQuery;
  sXML:       string;
  OutProgForm: TProgressForm;
  bWybraneEl: boolean;  // czy wysyane s tylko wybrane elementy planu produkcji
{$endif}
begin
{$ifndef build_all}
  if((ac_oZlecIds.Count = 0) or (not UNIINTDM.CzyOperacjaAktywna(cUNIINTOperacja_PlanProdUsun_Id))) then
    exit;
  if(not ZLEDM.ZapiszIdZlecDoWyslaniaWADMId(ac_oZlecIds, SecurityManager.UserId, ac_sKontekst, true, ac_oPlanProdElId)) then
    exit;
  oQueryZlec  := nil;
  oQueryRecep := nil;
  oQueryZasob := nil;
  oQueryPlan  := nil;
  oXMLDoc     := nil;
  try
    bWybraneEl  := ((ac_oPlanProdElId <> nil) and (ac_oPlanProdElId.Count > 0));
    oQueryZlec  := ZLEDM.DajQueryZlecDoWyslania(
      SecurityManager.UserId,
      ac_sKontekst
    );
    oQueryRecep := ZLEDM.DajQueryReceppozZlecDoWyslania(
      SecurityManager.UserId,
      ac_sKontekst,
      bWybraneEl
    );
    oQueryZasob := ZLEDM.DajQueryZasobowReceppozPlanuProdukcjiDoWyslania(
      SecurityManager.UserId,
      ac_sKontekst,
      bWybraneEl
    );
    oQueryPlan  := ZLEDM.DajQueryPlanuProdukcjiZlecDoWyslania(
      SecurityManager.UserId,
      ac_sKontekst,
      bWybraneEl
    );
    if(oQueryPlan = nil) then begin
      Komunikat(cWarning, 'Wybrane zlecenia nie zostay umieszczone na planie produkcji', MB_OK);
    end else if(oQueryZlec <> nil) then begin
      oQueryZlec.FetchAll();
      ProgressStart(self, oQueryZlec.RecordCount, 'Wycofywanie planu produkcji zaznaczonych zlece', True);
      OutProgForm := ProgressForm;
      try
        while(not oQueryZlec.Eof) do begin
          oXMLDoc := TUNIXMLParser.Create();
          oElem := oXMLDoc.DodajElementGlowny(sZLEZLECENIE);
          ZLEDM.PrzepiszDanePlanuProdukcjiDoXML(
            oXMLDoc,
            oElem,
            oQueryZlec,
            oQueryRecep,
            oQueryZasob,
            oQueryPlan
          );
          sXML  := oXMLDoc.ZapiszDokumentDoStringa();
          FreeAndNil(oXMLDoc);
          ProgressForm := OutProgForm;
          ProgressForm.ProgressInc();
          Application.ProcessMessages();
          if(ProgressForm.aborted) then
            break;
          ZLEDM.WyslijDaneZlec(sXML, cUNIINTOperacja_PlanProdUsun_Id, SecurityManager.UserId, ac_sKontekst, bWybraneEl);
          oQueryZlec.Next();
        end;  // while(not oQueryZlec.Eof)
      finally
        ProgressForm := OutProgForm;
        ProgressEnd();
      end;
    end;  // if(oQueryZlec <> nil)
  finally
    oXMLDoc.Free();
    oQueryZlec.Free();
    oQueryRecep.Free();
    oQueryZasob.Free();
    oQueryPlan.Free();
    ZLEDM.UsunIdZlecDoWyslaniaWADMId(SecurityManager.UserId, ac_sKontekst);
  end;
{$endif}
end;

{koniec obsugi wysyania danych zlecenia do systemw partnerw}

{$endif}


procedure TZLEDataManager.UtworzSP(sSPName: string);
begin
  if (sSPName = sZLE_PACKAGE) then begin
    ZLEPackageSPDef.ProcedureName := sZLE_PACKAGE;
    GetResourceTxt( hInstance,'SQL','ZLE_PACKAGE', ZLEPackageSPDef.TextORCL);
    ZLEPackageSPDef.CreateSP;
    ZLEPackageBodySPDef.ProcedureName := sZLE_PACKAGE;
    GetResourceTxt( hInstance,'SQL','ZLE_PACKAGE_B', ZLEPackageBodySPDef.TextORCL);
    ZLEPackageBodySPDef.CreateSP;
  end else
  if (sSPName = sZLEXML_PACKAGE) then begin
      // sprawdzenie czy jest zaoony sekwencer dla tabeli ZLEZASOBYPRACA. Jest on wykorzystywany przez ZLEXML_PACKAGE
    if(not SQLManager.SprawdzIstnienieSekwencera('SEQ_' + sZLEZASOBYPRACA)) then
      UniqueKey[sZLEZASOBYPRACA];
    ZLEXMLPackageSPDef.ProcedureName := sZLEXML_PACKAGE;
    GetResourceTxt( hInstance,'SQL','ZLEXML_PACKAGE', ZLEXMLPackageSPDef.TextORCL);
    ZLEXMLPackageSPDef.CreateSP;
    ZLEXMLPackageBodySPDef.ProcedureName := sZLEXML_PACKAGE;
    GetResourceTxt( hInstance,'SQL','ZLEXML_PACKAGE_B', ZLEXMLPackageBodySPDef.TextORCL);
    ZLEXMLPackageBodySPDef.CreateSP;
  end else
  if sSPName = sZLE_ZAKLADKI then begin
    //zakladki wymagane do obsugi pl uzytkownika zlecenia i pozycji
    try
      if SQLManager.OpenQueryWithResult('SELECT CASE WHEN EXISTS (SELECT ' + sUNIPOLAUZZAK_ID + ' ' +
                                                                 'FROM %s ' +
                                                                 'WHERE ' + sUNIPOLAUZZAK_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEZlecenie) + ') '+
                                                    'THEN 1 ' +
                                                    'ELSE 0 ' +
                                               'END AS WYNIK ' +
                                        'FROM DUAL',
                                        [sUNIPOLAUZZAK]) = '0' then
      begin
        //dodanie sekwencera jesli jeszcze nie istnieje;
        UniqueKey[sUNIPolaUZZak];
        SQLManager.ExecuteQuery('INSERT INTO '+SQLManager.GetTableName(sUNIPolaUZZak)+'( '+
                                    sUNIPolaUZZak_id+', '+
                                    sUNIPolaUZZak_Nazwa+', '+
                                    sUNIPolaUZZak_Nr+', '+
                                    sUNIPolaUZZak_Funk+', '+
                                    sUNIPolaUZZak_Predef+', '+
                                    sUNIPolaUZZak_UZ_AU_ID+', '+
                                    sUNIPolaUZZak_Data_Au+') '+
                                'VALUES('+
                                    SQLManager.GetGeneratorName(sUNIPolaUZZak)+'.NEXTVAL, '+
                                    QuotedStr(cPolaUZ_ZLEZlecenieTekst)+', ' +
                                    '1, '+
                                    QuotedStr(cPolaUZ_ZLEZlecenie)+', '+
                                    QuotedStr(sTAK)+', '+
                                    IntToStr(SecurityManager.UserId)+', ' +
                                    'sysdate)');
      end;

      if SQLManager.OpenQueryWithResult('SELECT CASE WHEN EXISTS (SELECT ' + sUNIPOLAUZZAK_ID + ' ' +
                                                                 'FROM %s ' +
                                                                 'WHERE ' + sUNIPOLAUZZAK_FUNK + ' = ' + QuotedStr(cPolaUZ_ZLEPozycja) + ') '+
                                                    'THEN 1 ' +
                                                    'ELSE 0 ' +
                                               'END AS WYNIK ' +
                                        'FROM DUAL',
                                        [sUNIPOLAUZZAK]) = '0' then
      begin
        //dodanie sekwencera jesli jeszcze nie istnieje;
        UniqueKey[sUNIPolaUZZak];
        SQLManager.ExecuteQuery('INSERT INTO '+ SQLManager.GetTableName(sUNIPolaUZZak)+'( '+
                                    sUNIPolaUZZak_id+', '+
                                    sUNIPolaUZZak_Nazwa+', '+
                                    sUNIPolaUZZak_Nr+', '+
                                    sUNIPolaUZZak_Funk+', '+
                                    sUNIPolaUZZak_Predef+', '+
                                    sUNIPolaUZZak_UZ_AU_ID+', '+
                                    sUNIPolaUZZak_Data_Au+') '+
                                'VALUES('+
                                    SQLManager.GetGeneratorName(sUNIPolaUZZak)+'.NEXTVAL, '+
                                    QuotedStr(cPolaUZ_ZLEPozycjaTekst)+', '+
                                    '1, '+
                                    QuotedStr(cPolaUZ_ZLEPozycja)+', '+
                                    QuotedStr(sTAK)+', '+
                                    IntToStr(SecurityManager.UserId)+', '+
                                    'sysdate)');
      end;
    except
    end;
  end
  else if sSPName = sZLEPRZEPISZPOLAUZ then begin
      SQLManager.ZalozObiektPLSQL( hInstance,sZLEPRZEPISZPOLAUZ,sZLEPRZEPISZPOLAUZ);
  end
  else if sSPName = sZLE_POBIERZ_ID_OBCY then begin
      SQLManager.ZalozObiektPLSQL( hInstance,sZLE_POBIERZ_ID_OBCY,sZLE_POBIERZ_ID_OBCY);
  end;
end;

{$ifndef build_all}
function  TZLEDataManager.UtworzPraceNaPodstawieMagazynu(): boolean;

  function  DopiszPrace(
          a_oPracaQuery:    TUNIQuery;
    const ac_iZlecenieId:   integer;
    const ac_iZasobId:      integer;
    const ac_iZmianaId:     integer;
    const ac_iPlanProdElId: integer;
    const ac_datData:       TDateTime;
    const ac_iRecepPozId:   integer;
    const ac_iIloscCzas:    integer;
    const ac_dIlosc:        double
  ):  integer;
  begin
    a_oPracaQuery.ParamByName(sZLEZLECENIE_ID).AsInteger  := ac_iZlecenieId;
    a_oPracaQuery.ParamByName(sZLEZASOB_ID).AsInteger     := ac_iZasobId;
    a_oPracaQuery.ParamByName(sKDZMIANYDEF_ID).AsInteger  := ac_iZmianaId;
    if(ac_iPlanProdElId <> 0) then
      a_oPracaQuery.ParamByName(sLWPPLANPRODEL_ID).AsInteger:= ac_iPlanProdElId
    else begin
      a_oPracaQuery.ParamByName(sLWPPLANPRODEL_ID).Clear();
      a_oPracaQuery.ParamByName(sLWPPLANPRODEL_ID).DataType := ftInteger;
      a_oPracaQuery.ParamByName(sLWPPLANPRODEL_ID).Bound    := true;
    end;
    a_oPracaQuery.ParamByName(sLWPRECEPPOZ_ID).AsInteger  := ac_iRecepPozId;
    a_oPracaQuery.ParamByName(sZLEZASOBYPRACA_DATA).AsDateTime  := ac_datData;
    a_oPracaQuery.ParamByName(sZLEZASOBYPRACA_IL_PRACY).AsFloat := ac_dIlosc;
    a_oPracaQuery.ParamByName(sZLEZASOBYPRACA_CZAS_PRACY).AsInteger := ac_iIloscCzas;
    result  := SQLManager.InsertQueryStep2(a_oPracaQuery, sZLEZASOBYPRACA_ID);
  end;  // function  DopiszPrace

  procedure DopiszLaczniki(
          a_oLaczQuery:     TUNIQuery;
    const ac_iZasPracaid:   integer;
    const ac_oObrPozId:     TStringList
  );
  var
    i:  integer;
  begin
    for i := 0 to ac_oObrPozId.Count-1 do begin
      a_oLaczQuery.ParamByName(sZLEZASOBYPRACA_ID).AsInteger:= ac_iZasPracaid;
      a_oLaczQuery.ParamByName(sMAGOBRPOZ_ID).AsString      := ac_oObrPozId[i];
      SQLManager.InsertQueryStep2(a_oLaczQuery, sZLEZASOBYPRACAMAGP_ID);
    end;  // for i := 0 to ac_oObrPozId.Count-1
  end;  // procedure DopiszLaczniki

  procedure DopiszBraki(
    const ac_iZasPracaId:     integer;
    const ac_iCurrZlecId:     integer;
    const ac_iCurrRecPozId:   integer;
    const ac_datCurrData:     TDateTime;
    const ac_iCurrZmianaId:   integer;
    const ac_iCurrZasobId:    integer;
    const ac_iCurrPlanProdEl: integer;
          a_oDataQuery:       TUNIQuery;
          a_oBrakiQuery:      TUNIQuery;
          a_oObrPozId:        TStringList
  );
  begin
    a_oBrakiQuery.ParamByName(sZLEZASOBYPRACA_ID).AsInteger := ac_iZasPracaId;
    while(
      (not a_oDataQuery.Eof) and
      (ac_iCurrZlecId = a_oDataQuery.FieldByName(sZLEZLECENIE_ID).AsInteger) and
      (ac_iCurrRecPozId = a_oDataQuery.FieldByName(sLWPRECEPPOZ_ID).AsInteger) and
      (ac_datCurrData = a_oDataQuery.FieldByName(sMAGOBR_DATA_DOK).AsDateTime) and
      (ac_iCurrZmianaId = a_oDataQuery.FieldByName(sKDZMIANYDEF_ID).AsInteger) and
      (ac_iCurrZasobId = a_oDataQuery.FieldByName(sZLEZASOB_ID).AsInteger) and
      (ac_iCurrPlanProdEl = a_oDataQuery.FieldByName(sLWPPLANPRODEL_ID).AsInteger) and
      (not a_oDataQuery.FieldByName(sZLEBRAKI_ID).IsNull)
    ) do begin
      a_oObrPozId.Add(a_oDataQuery.FieldByName(sMAGOBRPOZ_ID).AsString);
      a_oBrakiQuery.ParamByName(sZLEBRAKI_ID).AsInteger := a_oDataQuery.FieldByName(sZLEBRAKI_ID).AsInteger;
      a_oBrakiQuery.ParamByName(sZLEZASOBYBRAKI_IL).AsFloat := a_oDataQuery.FieldByName(sMAGOBRPOZ_ILOSC).AsFloat;
      SQLManager.InsertQueryStep2(a_oBrakiQuery, sZLEZASOBYBRAKI_ID);
      a_oDataQuery.Next();
    end;  // while(not a_oDataQuery.Eof)
  end;  // procedure DopiszBraki

  procedure ZapiszWADMID();
  var
    bTrans:     boolean;
    oPracaUpdate: TUNIQuery;
    oQuery:     TUNIQuery;
    oPracaQuery:TUNIQuery;
    oLaczQuery: TUNIQuery;
    oBrakiQuery:TUNIQuery;
    iPlanProdEl:integer;
    iZlecId:    integer;
    iRecPozId:  integer;
    datData:    TDateTime;
    iZmianaId:  integer;
    iZasobId:   integer;
    iIloscCzas: integer;
    iZasPracaId:integer;
    dIlosc:     double;
    oObrPozId:  TStringList;
    iLiczbaRek: integer;      // ilo utworzonych rekordw
    oPracaIds:  TStringList;  // tutaj przechowuje id nowo utworzonych rekordw pracy
  begin
    bTrans  := (not SQLManager.InTransaction());
    if(bTrans) then SQLManager.StartTransaction();
    try
      oObrPozId   := TStringList.Create();
      oPracaIds   := TStringList.Create();
      oPracaQuery := SQLManager.InsertQueryStep1(sZLEZASOBYPRACA,
        sZLEZASOBYPRACA_ID      + ', ' + sZLEZLECENIE_ID      + ', ' +
        sZLEZASOB_ID            + ', ' + sKDZMIANYDEF_ID      + ', ' +
        sLWPPLANPRODEL_ID       + ', ' + sZLEZASOBYPRACA_DATA + ', ' +
        sLWPRECEPPOZ_ID         + ', ' + sZLEZASOBYPRACA_IL_PRACY+ ', ' +
        sZLEZASOBYPRACA_CZAS_PRACY + ', ' + sZLEZASOBYPRACA_UZ_AU_ID  + ', ' +
        sZLEZASOBYPRACA_DATA_AU
      );
      oLaczQuery  := SQLManager.InsertQueryStep1(sZLEZASOBYPRACAMAGP,
        sZLEZASOBYPRACAMAGP_ID+ ', ' + sZLEZASOBYPRACA_ID + ', ' +
        sMAGOBRPOZ_ID         + ', ' + sZLEZASOBYPRACAMAGP_UZ_AU_ID + ', ' +
        sZLEZASOBYPRACAMAGP_DATA_AU
      );
      oBrakiQuery := SQLManager.InsertQueryStep1(sZLEZASOBYBRAKI,
        sZLEZASOBYBRAKI_ID  + ', ' + sZLEZASOBYBRAKI_IL + ', ' +
        sZLEBRAKI_ID        + ', ' + sZLEZASOBYPRACA_ID + ', ' +
        sZLEZASOBYBRAKI_UZ_AU_ID  + ', ' + sZLEZASOBYBRAKI_DATA_AU
      );
      oPracaUpdate := SQLManager.UpdateQueryStep1(sZLEZASOBYPRACA,
        sZLEZASOBYPRACA_IL_PRACY,
        sZLEZASOBYPRACA_ID + ' = :' + sZLEZASOBYPRACA_ID
      );
      oQuery  := SQLManager.CreateQuery(
        'SELECT ' +
{1}     '  obr.' + sMAGOBR_DATA_DOK + ', ' +
{2}     '  obrp.' + sMAGOBRPOZ_ID + ', ' +
{3}     '  obrp.' + sKDZMIANYDEF_ID + ', ' +
{4}     '  obrp.' + sZLEZASOB_ID + ', ' +
{5}     '  obrp.' + sZLEZLECENIE_ID + ', ' +
{6}     '  obrp.' + sLWPRECEPPOZ_ID + ', ' +
{7}     '  obrp.' + sZLEBRAKI_ID + ', ' +
{8}     '  obrp.' + sMAGOBRPOZ_ILOSC + ', ' +
        '  (' +
        '     select EL.' + sLWPPLANPRODEL_ID + ' from %s EL WHERE ' + 
        '       EL.'  + sZLEZLECENIE_ID + ' = OBRP.'  + sZLEZLECENIE_ID + ' and ' +
        '       EL.'  + sLWPRECEPPOZ_ID + ' = OBRP.'  + sLWPRECEPPOZ_ID + ' and ' +
        '       (' +
        '         (' +
        '           zm.' + sKDZMIANYDEF_GODZ_POCZATEK + ' < zm.' + sKDZMIANYDEF_GODZ_KONIEC + ' AND ' +
        '           (' +
        '             (obr.' + sMAGOBR_DATA_DOK + ' + (zm.' + sKDZMIANYDEF_GODZ_POCZATEK + ' / 1440)) < el.' + sLWPPLANPRODEL_CZAS_KONC + ' and ' +
        '             (obr.' + sMAGOBR_DATA_DOK + ' + (zm.' + sKDZMIANYDEF_GODZ_KONIEC + ' / 1440)) > el.' + sLWPPLANPRODEL_CZAS_POCZ +
        '           )' +
        '         ) OR ' +
        '         (' +
        '           zm.' + sKDZMIANYDEF_GODZ_POCZATEK + ' > zm.' + sKDZMIANYDEF_GODZ_KONIEC + ' and ' +
        '           (' +
        '             (obr.' + sMAGOBR_DATA_DOK + ' + (zm.' + sKDZMIANYDEF_GODZ_POCZATEK + ' / 1440)) < el.' + sLWPPLANPRODEL_CZAS_KONC + ' and ' +
        '             (obr.' + sMAGOBR_DATA_DOK + ' + 1 + (zm.' + sKDZMIANYDEF_GODZ_KONIEC + ' / 1440)) > el.' + sLWPPLANPRODEL_CZAS_POCZ +
        '           )' +
        '         )' +
        '       ) and ' +
        '       ROWNUM = 1' +
{9}     '  ) as ' + sLWPPLANPRODEL_ID + ', ' +
        '  CASE ' +
        '    WHEN ZM.' + sKDZMIANYDEF_GODZ_POCZATEK  + ' > ZM.' + sKDZMIANYDEF_GODZ_KONIEC + ' THEN (1440 - ZM.' + sKDZMIANYDEF_GODZ_POCZATEK + ') + ZM.' + sKDZMIANYDEF_GODZ_KONIEC  +
        '    ELSE ZM.' + sKDZMIANYDEF_GODZ_KONIEC + ' - ZM.' + sKDZMIANYDEF_GODZ_POCZATEK +
{10}    '  END as ' + sZLEZASOBYPRACA_CZAS_PRACY  +
        ' FROM ' +
        '  %s obr ' +
        '    inner join %s obrp ' +
        '      ON obr.' + sMAGOBR_ID  + ' = obrp.' + sMAGOBR_ID + ' ' +
        '    inner join %s zm ' +
        '      ON obrp.' + sKDZMIANYDEF_ID  + ' = zm.' + sKDZMIANYDEF_ID  + ' ' +
        '    inner join %s za ' +
        '      ON obrp.' + sZLEZASOB_ID + ' = za.' + sZLEZASOB_ID + ' ' +
        '    inner join %s rp ' +
        '      ON obrp.' + sLWPRECEPPOZ_ID  + ' = rp.' + sLWPRECEPPOZ_ID  + ' ' +
        '    left outer join %s zl ' +
        '      ON obrp.' + sZLEZLECENIE_ID  + ' = zl.' + sZLEZLECENIE_ID  + ' ' +
        '    left outer join %s br ' +
        '      ON obrp.' + sZLEBRAKI_ID + ' = br.' + sZLEBRAKI_ID +
        ' WHERE ' +
        '   OBR.' + sMAGOBR_ID  + ' in('  + ADMID_SelectSQL(cADMIDFunZLEZlecPracaZMag_Dok, 0, SecurityManager.UserId, '') + ') and ' +
        '   OBRP.'+ sLWPPLANPRODEL_ID + ' is null and ' +
        '   NOT EXISTS (' +
        '     SELECT * FROM %s PRM WHERE PRM.' + sMAGOBRPOZ_ID + ' = obrp.' + sMAGOBRPOZ_ID +
        '   )' +
        ' union all SELECT ' +
{1}     '  obr.' + sMAGOBR_DATA_DOK + ', ' +
{2}     '  obrp.' + sMAGOBRPOZ_ID + ', ' +
{3}     '  obrp.' + sKDZMIANYDEF_ID + ', ' +
{4}     '  obrp.' + sZLEZASOB_ID + ', ' +
{5}     '  obrp.' + sZLEZLECENIE_ID + ', ' +
{6}     '  rp.' + sLWPRECEPPOZ_ID + ', ' +
{7}     '  obrp.' + sZLEBRAKI_ID + ', ' +
{8}     '  obrp.' + sMAGOBRPOZ_ILOSC + ', ' +
{9}     '  obrp.' + sLWPPLANPRODEL_ID + ', ' +
        '  CASE ' +
        '    WHEN ZM.' + sKDZMIANYDEF_GODZ_POCZATEK  + ' > ZM.' + sKDZMIANYDEF_GODZ_KONIEC + ' THEN (1440 - ZM.' + sKDZMIANYDEF_GODZ_POCZATEK + ') + ZM.' + sKDZMIANYDEF_GODZ_KONIEC  +
        '    ELSE ZM.' + sKDZMIANYDEF_GODZ_KONIEC + ' - ZM.' + sKDZMIANYDEF_GODZ_POCZATEK +
{10}    '  END as ' + sZLEZASOBYPRACA_CZAS_PRACY  +
        ' FROM ' +
        '  %s obr ' +
        '    inner join %s obrp ' +
        '      ON obr.' + sMAGOBR_ID  + ' = obrp.' + sMAGOBR_ID + ' ' +
        '    inner join %s zm ' +
        '      ON obrp.' + sKDZMIANYDEF_ID  + ' = zm.' + sKDZMIANYDEF_ID  + ' ' +
        '    inner join %s za ' +
        '      ON obrp.' + sZLEZASOB_ID + ' = za.' + sZLEZASOB_ID + ' ' +
        '    inner join %s PLEL ' +
        '      ON obrp.' + sLWPPLANPRODEL_ID + ' = PLEL.' + sLWPPLANPRODEL_ID +
        '    inner join %s rp ' +
        '      ON PLEL.' + sLWPRECEPPOZ_ID  + ' = rp.' + sLWPRECEPPOZ_ID  + ' ' +
        '    left outer join %s zl ' +
        '      ON obrp.' + sZLEZLECENIE_ID  + ' = zl.' + sZLEZLECENIE_ID  + ' ' +
        '    left outer join %s br ' +
        '      ON obrp.' + sZLEBRAKI_ID + ' = br.' + sZLEBRAKI_ID +
        ' WHERE ' +
        '   OBR.' + sMAGOBR_ID  + ' in('  + ADMID_SelectSQL(cADMIDFunZLEZlecPracaZMag_Dok, 0, SecurityManager.UserId, '') + ') and ' +
        '   NOT EXISTS (' +
        '     SELECT * FROM %s PRM WHERE PRM.' + sMAGOBRPOZ_ID + ' = obrp.' + sMAGOBRPOZ_ID +
        '   )' +
        ' ORDER BY ' +
        '  5, ' + // sZLEZLECENIE_ID + ', ' +
        '  6, ' + // sLWPRECEPPOZ_ID + ', ' +
        '  1, ' + // sMAGOBR_DATA_DOK + ', ' +
        '  3, ' + // sKDZMIANYDEF_ID + ', ' +
        '  4, ' + // sZLEZASOB_ID + ', ' +
        '  7', // sZLEBRAKI_ID,
        [
          sLWPPLANPRODEL,
          sMAGModulID + cMAGOBR_SUFFIX,
          sMAGModulID + cMAGOBRPOZ_SUFFIX,
          sKDZMIANYDEF,
          sZLEZASOB,
          sLWPRECEPPOZ,
          sZLEZLECENIE,
          sZLEBRAKI,
          sZLEZASOBYPRACAMAGP,

          sMAGModulID + cMAGOBR_SUFFIX,
          sMAGModulID + cMAGOBRPOZ_SUFFIX,
          sKDZMIANYDEF,
          sZLEZASOB,
          sLWPPLANPRODEL,
          sLWPRECEPPOZ,
          sZLEZLECENIE,
          sZLEBRAKI,
          sZLEZASOBYPRACAMAGP
        ]
      );
      try
        oQuery.Open();
        oPracaQuery.ParamByName(sZLEZASOBYPRACA_UZ_AU_ID).AsInteger := SecurityManager.UserId;
        oPracaQuery.ParamByName(sZLEZASOBYPRACA_DATA_AU).AsDateTime := UNINow();
        oLaczQuery.ParamByName(sZLEZASOBYPRACAMAGP_UZ_AU_ID).AsInteger:= SecurityManager.UserId;
        oLaczQuery.ParamByName(sZLEZASOBYPRACAMAGP_DATA_AU).AsDateTime:= UNINow();
        oBrakiQuery.ParamByName(sZLEZASOBYBRAKI_UZ_AU_ID).AsInteger := SecurityManager.UserId;
        oBrakiQuery.ParamByName(sZLEZASOBYBRAKI_DATA_AU).AsDateTime := UNINow();
        iPlanProdEl := 0;
        iZlecId     := 0;
        iRecPozId   := 0;
        datData     := 0;
        iZmianaId   := 0;
        iZasobId    := 0;
        iZasPracaId := 0;
        dIlosc      := 0;
        iLiczbaRek  := 0;
        oQuery.FetchAll();
        ProgressStart(nil, oQuery.RecordCount, 'Trwa generowanie czasu pracy zasobw', true);
        try
          while(not oQuery.Eof) do begin
            if(
              (iZlecId <> oQuery.FieldByName(sZLEZLECENIE_ID).AsInteger) or
              (iRecPozId <> oQuery.FieldByName(sLWPRECEPPOZ_ID).AsInteger) or
              (datData <> oQuery.FieldByName(sMAGOBR_DATA_DOK).AsDateTime) or
              (iZmianaId <> oQuery.FieldByName(sKDZMIANYDEF_ID).AsInteger) or
              (iZasobId <> oQuery.FieldByName(sZLEZASOB_ID).AsInteger) or
              (iPlanProdEl <> oQuery.FieldByName(sLWPPLANPRODEL_ID).AsInteger)
            ) then begin
              iPlanProdEl := oQuery.FieldByName(sLWPPLANPRODEL_ID).AsInteger;
              iZlecId     := oQuery.FieldByName(sZLEZLECENIE_ID).AsInteger;
              iRecPozId   := oQuery.FieldByName(sLWPRECEPPOZ_ID).AsInteger;
              datData     := oQuery.FieldByName(sMAGOBR_DATA_DOK).AsDateTime;
              iZmianaId   := oQuery.FieldByName(sKDZMIANYDEF_ID).AsInteger;
              iZasobId    := oQuery.FieldByName(sZLEZASOB_ID).AsInteger;
              iIloscCzas  := oQuery.FieldByName(sZLEZASOBYPRACA_CZAS_PRACY).AsInteger;
              if(iZasPracaId <> 0) then begin
                oPracaUpdate.ParamByName(sZLEZASOBYPRACA_ID).AsInteger  := iZasPracaId;
                oPracaUpdate.ParamByName(sZLEZASOBYPRACA_IL_PRACY).AsFloat  := dIlosc;
                SQLManager.UpdateQueryStep2(oPracaUpdate);
                DopiszLaczniki(
                  oLaczQuery,
                  iZasPracaId,
                  oObrPozId
                );
              end;
              iZasPracaId := DopiszPrace(
                oPracaQuery,
                iZlecId,
                iZasobId,
                iZmianaId,
                iPlanProdEl,
                datData,
                iRecPozId,
                iIloscCzas,
                0
              );
              oPracaIds.Add(IntToStr(iZasPracaId));
              dIlosc  := 0;
              oObrPozId.Clear();
              Inc(iLiczbaRek);
            end;  // if nowy rekord pracy
            if(oQuery.FieldByName(sZLEBRAKI_ID).IsNull) then begin
              dIlosc  := dIlosc + oQuery.FieldByName(sMAGOBRPOZ_ILOSC).AsFloat;
              oObrPozId.Add(oQuery.FieldByName(sMAGOBRPOZ_ID).AsString);
              oQuery.Next();
            end else begin
              DopiszBraki(
                iZasPracaId,
                iZlecId,
                iRecPozId,
                datData,
                iZmianaId,
                iZasobId,
                iPlanProdEl,
                oQuery,
                oBrakiQuery,
                oObrPozId
              );
            end;
            ProgressForm.Progress(1);
          end;  // while(not oQuery.Eof)
          if((not oQuery.IsEmpty()) and (iZasPracaId <> 0)) then begin
            oPracaUpdate.ParamByName(sZLEZASOBYPRACA_ID).AsInteger  := iZasPracaId;
            oPracaUpdate.ParamByName(sZLEZASOBYPRACA_IL_PRACY).AsFloat  := dIlosc;
            SQLManager.UpdateQueryStep2(oPracaUpdate);
            DopiszLaczniki(
              oLaczQuery,
              iZasPracaId,
              oObrPozId
            );
          end;  // if((not oQuery.IsEmpty()) and (iZasPracaId <> 0))
        finally
          ProgressEnd();
        end;
        Komunikat(cInformation, 'Liczba utworzonych rekordw: ' + IntToStr(iLiczbaRek), MB_OK + MB_ICONINFORMATION);
          // usuwanie tych zapisw jest na gridzie
        DopiszPraceZasobowDoADMID(oPracaIds);
      finally
        oQuery.Free();
        oPracaQuery.Free();
        oLaczQuery.Free();
        oBrakiQuery.Free();
        oPracaUpdate.Free();
        oObrPozId.Free();
        oPracaIds.Free();
      end;
      if(bTrans) then SQLManager.Commit();
    except
      if(bTrans) then SQLManager.Rollback();
      raise;
    end;
  end;  // procedure ZapiszWADMID()

var
  oForm:    TUNIForm;
begin
  result := false;
  ADMID_DelAll(cADMIDFunZLEZlecPracaZMag_Dok, 0, SecurityManager.UserId, '');
  try
    oForm   := FormManager.OpenForm(
      self,
      'TZLEZasobyPracaZMagazynuSelectForm',
      omDefault + omHidden
    );
    if(oForm.ShowModal() = mrOk) then begin
      result  := true;
      ZapiszWADMID();
    end;  // if(oForm.ShowModal() = mrOk)
    oForm.Free();
  finally
    ADMID_DelAll(cADMIDFunZLEZlecPracaZMag_Dok, 0, SecurityManager.UserId, '');
  end;
end;
{$endif}

{$ifndef build_all}
procedure TZLEDataManager.UtworzStringListePracyZasobow();
begin
  if(m_oZasobyPracaNoweId = nil) then begin
    m_oZasobyPracaNoweId  := TStringList.Create();
    m_oZasobyPracaNoweId.Sorted := true;
    m_oZasobyPracaNoweId.Duplicates := dupIgnore;
  end;  // if(m_oZasobyPracaNoweId = nil)
end;
{$endif}

{$ifndef build_all}
procedure TZLEDataManager.DopiszPraceZasobowDoADMID(
  const ac_oZasobyPracaIds: TStringList
);
begin
  UtworzStringListePracyZasobow();
  m_oZasobyPracaNoweId.AddStrings(ac_oZasobyPracaIds);
  ADMID_Save(cADMIDFunZLEZlecPracaZMag_Utworzone, 0, SecurityManager.UserId, '', nil, m_oZasobyPracaNoweId, vAktywnaFirma);
end;
{$endif}

{$ifndef build_all}
procedure TZLEDataManager.DopiszPraceZasobowDoADMID(
  const ac_sZasobyPracaId:  string
);
begin
  UtworzStringListePracyZasobow();
  m_oZasobyPracaNoweId.Add(ac_sZasobyPracaId);
  ADMID_Save(cADMIDFunZLEZlecPracaZMag_Utworzone, 0, SecurityManager.UserId, '', nil, m_oZasobyPracaNoweId, vAktywnaFirma);
end;
{$endif}

{$ifndef build_all}
procedure TZLEDataManager.UsunPraceZasobowZADMID();
begin
  UtworzStringListePracyZasobow();
  m_oZasobyPracaNoweId.Clear();
  ADMID_DelAll(cADMIDFunZLEZlecPracaZMag_Utworzone, 0, SecurityManager.UserId, '', vAktywnaFirma);
end;
{$endif}

procedure TZLEDataManager.PrefiksMenuItemClick(Sender: TObject);
var
  oParams: TKeyValues;
begin
  inherited;
  oParams := TKeyValues.CreateEmpty();

  FormManager.OpenDBGrid(self,'TZLEPrefixDBGridForm', omList+omMultiSelect, oParams);
end;

{procedure TZLEDataManager.ZLEPolaUzZleceniaMenuItemClick(Sender: TObject);
begin
  UNISysDM.UNIPokazIObsluzDefinicjePolUzytkownika(self, cPolaUZ_ZLEZlecenie, omList);
end;

procedure TZLEDataManager.ZLEPolaUzPozycjaMenuItemClick(Sender: TObject);
begin
  UNISysDM.UNIPokazIObsluzDefinicjePolUzytkownika(self, cPolaUZ_ZLEPozycja, omList);
end;}

procedure TZLEDataManager.NarzutyMenuItemClick(Sender: TObject);
var
  oParams: TKeyValues;
begin
  inherited;
  oParams := TKeyValues.CreateEmpty();
  FormManager.OpenDBGrid( self, 'TZLEWSPNarzutyDBGridForm', omList+omMultiSelect, oParams);
end;

procedure TZLEDataManager.TestListZlecen1Click(Sender: TObject);
//var
  {oParams : TKeyValues;
  sIds, sWarunek : string;
  i : integer;
  sTypZlecenia : string;}

  //slMnem: TStringList;
begin
   {test funkcji UNIUstawStatusZlecenia}
   {UNISYSDM.UNIUstawStatusZlecenia( 7719,
                            'Z',
                            UNIDate(),
                            42,
                            'Potwierdzenie wykonania zlecenia',
                            'Nowy opis dla zlecenie'+
                            'Kontynuacja opisu');}

   {slMnem := TStringList.Create;
   ZLEListaMnemonikow(slMnem, vAktywnaFirma);}

   { oParams := TKeyValues.CreateEmpty();
    sWarunek := '(@' + sZLEALIAS_ZLECENIEPOZ_POZIOMINF+'=' + QuotedStr('4') + ') AND ' +
                '(@' + sZLEALIAS_ZLECENIEPOZ_INF_ID + ' IN (382, 402))';

    ZLEDM.ZLEPokazIObsluzZleceniaGrid(self,
      sZLEAlias_Zleceniepoz_id,
      sWarunek,
      false,false, omList+omShowModal, cBOKMODULZSI_ID,0,vAktywnaFirma,nil,oParams);}
end;

//Funkcja dla analiz zwracajca Wartosc pozycji dla okreslonego opisu parametrw
function TZLEDataManager.ZLEFunAnalizy_ZLEDanePozycji(
                                       iFirmaID: integer;
                                       sRok, sOpisParametrow: string;
                                       var iLiczbaSlownikow:integer;
                                       bSymulacja:boolean=false;
                                       iAktywnyOkresNr:integer=0;
                                       bTylkoNiezerowe:boolean=false;
                                       bZestawienieZDokumentami:boolean=false): TUNIQuery;
{$ifdef build_zle}
begin
  result := ZLEFunAnalizy_Internal(cAgregateFunction_ZLEDanePozycji+'('+sOpisParametrow+')',
                                   iFirmaID, sRok, bSymulacja, iLiczbaSlownikow,
                                   iAktywnyOkresNr, bTylkoNiezerowe, bZestawieniezDokumentami);
end;
{$else}
var
  p: function (iFirmaID: integer;
               sRok, sOpisParametrow: string;
               var iLiczbaSlownikow:integer;
               bSymulacja:boolean=false;
               iAktywnyOkresNr:integer=0;
               bTylkoNiezerowe:boolean=false;
               bZestawienieZDokumentami:boolean=false): TUNIQuery;
begin
  result:=NIL;
  @p:= GetProcAddress( DataManagers.GetHandle(sZLEModulID),'DLL_ZLEFunAnalizy_ZLEDanePozycji');
  if @p<>nil then
    result:= p(iFirmaID, sRok, sOpisParametrow, iLiczbaSlownikow, bSymulacja,
               iAktywnyOkresNr, bTylkoNiezerowe, bZestawienieZDokumentami);
end;
{$endif}


//funkcja uruchamiajca wskazan funkcje dla analiz
{$ifdef build_zle}
function TZLEDataManager.ZLEFunAnalizy_Internal(
           sScript: string;
           iFirmaID: integer;
           sRok: string;
           bSymulacja: boolean;
           var iLiczbaSlownikow: integer;
           iAktywnyOkresNr: integer = 0;
           bTylkoNiezerowe: boolean = false;
           bZestawienieZDokumentami: boolean = false): TUNIQuery;
var
  oQuery               :TUNIQuery;
  sSQL                 :string;
  sErrorMessage        :string;
  sFileCoreName        :string;
  iHandle              :integer;
begin
  //Zaloenie pocztkowe - brak danych do zwrotu
  result := nil;

  //Przygotowanie tresci zapytania
  if ZLEFunkcjeAnalizy_SQLPrepare(
       sScript, iAktywnyOkresNr, iFirmaID,
       sRok, bSymulacja, bZestawienieZDokumentami,
       sSQL, sErrorMessage, iLiczbaSlownikow) then begin
    //Utworzenie zapytania na podstawie tresci
    oQuery := TUNIQuery.Create(nil);
    if oQuery <> NIL then
      try
        //Uzupelnienie zapytania o odrzucenie danych z zerow wartosci kwoty
        if bTylkoNiezerowe then
          sSQL  := 'select * from (' + sSQL + ') where SUMA <> 0';

        //Uruchomienie zapytania i zwrot wartosci
        SQLManager.OpenQuery(oQuery,sSQL,['']);

        //Tymczasowy zapis do pliku tekstowego (na prb)
        if EnvironmentManager.ifTest then begin
          sFileCoreName := 'c:\EKSPORT_AN_'+DateToStr(UNINow())+'_SQL.TXT';
          iHandle       := FileCreate(sFileCoreName);
          ExportSQLToTXT(sSQL,iHandle);
          FileClose(iHandle);
        end;

        if (not oQuery.IsEmpty) and (not oQuery.Fields[0].IsNull) then
          result:=oQuery      //Gdy s dane zwracany jest DataSet
        else
          FreeAndNil(oQuery); //dla braku danych zwraca NIL
      except
        sErrorMessage:='Funkcje analiz. Bd utworzenia dataseta';
        if oQuery <> NIL then
          FreeAndNil(oQuery);
      end
    else begin
      //Tu wrzucic blad tworzenia dataseta
    end;
  end;

  if sErrorMessage <> '' then
  begin
    raise EOF_ZLEException.Create(sErrorMessage);
  end;
end;
{$endif}

procedure TZLEDataManager.PolazleceniaMenuItemClick(Sender: TObject);
begin
  UNISysDM.UNIPokazIObsluzDefinicjePolUzytkownika(self, cPolaUZ_ZLEZlecenie , omList);
end;

procedure TZLEDataManager.PolapozycjiMenuItemClick(Sender: TObject);
begin
  UNISysDM.UNIPokazIObsluzDefinicjePolUzytkownika(self, cPolaUZ_ZLEPozycja , omList);
end;

procedure TZLEDataManager.RaportraportowdopoprawyMenuItemClick(
  Sender: TObject);
var
  StrStream: TStringStream;
  ReportsDataSet: TDataSet;
  iPoz, i, k: Integer;
  iRepOK, iRepNotValid: Integer;
  sErrors: String;
  s, s2: string;
  bJestID: Boolean;
  oInsertQuery, oListaRaportowQuery: TUNIQuery;
begin
  //Usuwamy wszystkie wczesniejsze raporty
  SQLManager.ExecuteQuery('DELETE FROM %s WHERE 1 = 1', [sZLERAPORTEDIT]);

  //Tworzymy nowa liste raportow do poprawy
  ReportsDataSet := nil;
  oListaRaportowQuery := nil;
  try
    oListaRaportowQuery := SQLManager.CreateQuery(
      'SELECT RP.' + sUNIREP_ID + ', RP.' + sUNIREP_NAME  + ' ' +
      'FROM %s RP ' +
      'WHERE RP.' + sUNIMODULZSI_ID + ' = ' + IntToStr(cZLEModulZSI_ID),
       [sUNIREP]
    );

    oListaRaportowQuery.Open();
    ProgressStart(Nil, 0, 'Przetwarzanie wzorcw raportw', True, 0);
    try
      ProgressForm.L1.Caption := 'Trwa przetwarzanie wzorcw raportw...';
      ProgressForm.L2.Caption := '';
      ProgressForm.L3.Caption := '';
      ProgressForm.Position := poScreenCenter;
      ProgressForm.l1.Font.Size := 9;
      ProgressForm.l1.Font.Style := [];
      ProgressForm.l2.Font.Size := 9;
      ProgressForm.l2.Font.Style := [];
      ProgressForm.l3.Font.Size := 9;
      ProgressForm.l3.Font.Style := [];
      ProgressForm.Height := ProgressForm.l3.Top + (2 * ProgressForm.l3.Height);
      ProgressForm.PB.Visible := True;
      ProgressForm.Update;
      iPoz := 0;
      iRepOK := 0;
      iRepNotValid := 0;
      sErrors := '';
      while not oListaRaportowQuery.EoF do begin
        StrStream := TStringStream.Create('');
        try
          {Wczytanie Raportu}
          ReportsDataSet := SQLManager.CreateQuery(
           'SELECT RPB.' + sUNIREPBLOB_BLOB + ' ' +
           'FROM %s RPB ' +
           'WHERE RPB.' + sUNIREP_ID + ' = ' + IntToStr(oListaRaportowQuery.FieldByName(sUNIREP_ID).AsInteger),
           [sUNIREPBLOB]
          );
          TUNIQuery(ReportsDataSet).RequestLive := True;
          ReportsDataSet.Open;
          TUNIQuery(ReportsDataSet).FetchAll;

          (ReportsDataSet.FieldByName(sUNIREPBLOB_BLOB) as TBlobField).SaveToStream(StrStream);
          s := StrStream.DataString;
          bJestID := False;
          if Pos(sZLEPOLAZM, s) > 0 then begin
            {Inne testy
            i := Pos(sZLEPOLAZM, s);}
            s := StringReplace(upperCase(s), ' ', '', [rfReplaceAll]);

            while ((not bJestID) and (Pos(sZLEPOLAZMDEF_ID+'=', s) > 0)) do begin
              i := Pos(sZLEPOLAZMDEF_ID+'=', s);
               s2 := Copy(s, i+length(sZLEPOLAZMDEF_ID+'='), 1);
               try
                  k := StrToInt(s2);
               except
                  k := -1;
               end;
               if k > 0 then
                 bJestID := True
               else
                 s := StringReplace(s, sZLEPOLAZMDEF_ID+'=', '                ', [rfIgnoreCase]); //Tylko pierwsze wystpienie
            end;
            oInsertQuery := SQLManager.InsertQueryStep1(sZLERAPORTEDIT,
                                     sZLERAPORTEDIT_ID+','+
                                     sUNIREP_ID+','+
                                     sZLERAPORTEDIT_KOMUNIKAT + ',' +
                                     sZLERAPORTEDIT_UZ_AU_ID+','+
                                     sZLERAPORTEDIT_DATA_AU );

            try
               with oInsertQuery do begin
                 ParamByName(sZLERAPORTEDIT_ID).DataType := ftInteger;
                 ParamByName(sUNIREP_ID).DataType := ftInteger;
                 ParamByName(sZLERAPORTEDIT_KOMUNIKAT).DataType := ftString;
                 ParamByName(sZLERAPORTEDIT_UZ_AU_ID).DataType := ftInteger;
                 ParamByName(sZLERAPORTEDIT_DATA_AU).DataType := ftDate;

                 ParamByName(sUNIREP_ID).AsInteger := oListaRaportowQuery.FieldByName(sUNIREP_ID).AsInteger;
                 if bJestID then
                    ParamByName(sZLERAPORTEDIT_KOMUNIKAT).AsString := 'Konieczna modyfikacja raportu - zawiera ZLEPOLAZMDEF_ID = xx'
                 else
                    ParamByName(sZLERAPORTEDIT_KOMUNIKAT).AsString := 'Raport zawiera odwoania do widokw z polami uytkownika';
                 ParamByName(sZLERAPORTEDIT_UZ_AU_ID).AsInteger := SecurityManager.UserId;
                 ParamByName(sZLERAPORTEDIT_DATA_AU).AsDateTime := UNIDate;
               end;

              SQLManager.InsertQueryStep2( oInsertQuery, sZLERAPORTEDIT_ID );
              Inc(iRepNotValid);
            finally
              if oInsertQuery <> nil then FreeAndNil(oInsertQuery);
            end;
          end else begin
            Inc(iRepOK);
          end;
        finally
          FreeAndNil(StrStream);
          if ReportsDataSet <> nil then
             ReportsDataSet.Free;
        end;
        Inc(iPoz);
        ProgressForm.ProgressUpdate(
          'Nie wymagajcych korekty: ' + IntToStr(iRepOK) + '. Do poprawy: ' + IntToStr(iRepNotValid),
          'Trwa przetwarzanie wzorca: ' + IntToStr(iPoz) + '/' + IntToStr(oListaRaportowQuery.RecordCount),
          '',
          iifn(1> Trunc(((iPoz + 1) * 100) / oListaRaportowQuery.RecordCount), 1, Trunc(((iPoz + 1) * 100) / oListaRaportowQuery.RecordCount))
        );
        oListaRaportowQuery.Next;
      end;
    finally
      ProgressEnd;
    end;
  finally
    FreeAndNil(oListaRaportowQuery);
  end;

  //Na koniec wyswietlamy zawartosc tabeli
  FormManager.OpenDBGrid( self, 'TZLERaportEditDBGridForm', omList);
end;

procedure TZLEDataManager.miWzorceImportuKalCzasClick(Sender: TObject);
begin
 UNISysDM.UNIPokazIObsluzDane(sUNIIMP, '@' + sUNISYSAlias_ImpModulZSIID + '=' +
   IntToStr(cLWPModulZSI_ID), false, false, '', vAktywnaFirma, '', nil, cLWPModulZSI_ID)
end;

initialization
  ZLEDataManager:= RegisterDataManager( sZLEModulID,cZLEMODULZSI_ID,TZLEDataManager ) as TZLEDataManager;
  ZLEDM:= ZLEDataManager;
end.
