unit ZLEZlecenieDBDetailFormUnit;
{
 Copyright Unisoft Sp. z o.o.

Changes
---------------------------------------------------------------------------------------------
When       Who      What
---------------------------------------------------------------------------------------------
2004-03-24 gdeyk    Utworzone
2005-12-20 Tomjen   Pola uzytkownika
2006-08-22 Krz      Zmiana w WykonawcaDBLookupAliasEditInitAliasInfo - poprawka bdu
                    wystpujcego podczas inicjowania AliasDBLookup'a: 'Niepoprawna liczba'
2007-07-25 Adam     Przystosowanie do wsppracy z zapotrzebowaniami
2007-07-26 Adam     Przystosowanie do wsppracy z zamwieniami
2007-09-07 Adam     Poprawione ustawianie asortymentu receptury
2007-09-12 Adam     Dodana zakadka wymaganych materiaw dla zlece produkcyjnych
2007-11-14 Adam     Kopiowanie zasobow i materiaw podczas tworzenia zlecenia z zamwienia
2008-01-11 Adam     Moliwo dopisania zlecenia produkcyjnego bez podania receptury (dla potrzeb Dekorglass)
2008-01-18 Adam     Dodane kopiowanie zlecenia
2008-03-14 Adam     Dodane tworzenie zlecenia z pozycji zapyta
2008-03-28 Adam     Wypenianie osoby odpowiedzialnej na gridzie zamwie
2008-03-31 Adam     Wypenianie osoby odpowiedzialnej na gridzie zapyta
2008-05-14 Adam     Dodane property ZlecenieProdukcyjne
2008-06-20 Adam     Dodana kontrola czy zlecenie nie zostao ju wysane do aplikacji partnera
2008-08-28 Adam     Wypenianie kontrahenta podczas kopiowania danych z zamwienia lub zapytania
2008-09-10 Adam     Dodana obsuga innych jednostek miar ni podstawowa
2008-12-17 Adam     Kopiowanie osoby odpowiedzialnej z Zapyta, Zamwie i Zapotrzebowa
2009-02-23 KK       Implementacja drukowania
2009-04-21 Adam     Dodana kontrola czy wypeniono konto materiaowe w materiaach zlece produkcyjnych
2011-01-25 Adam     Obsuga wielu klientw na wejciowym zapytaniu ofertowym
2011-03-04 Adam     Dodane tworzenie zlecenia nieprodukcyjnego z zapotrzebowania
2011-03-07 Adam     Dodane tworzenie zlecenia nieprodukcyjnego z zapytania ofertowego
2012-03-23 Adam     Moliwo dopisywania materiaw do zlece nieprodukcyjnych
2012-03-26 Adam     Moliwo tworzenia zapotrzebowa ze zlece nieprodukcyjnych
2012-06-12 Adam     Obsuga automatycznego tworzenia zapotrzebowania
}
interface

uses
  UNIFormUnit, KeyManagerUnit, UNIDBGridFormUnit,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UNIDBDetailFormUnit, Menus, UNIComponentsUnit, Db, ToolWin, ComCtrls,
  StdCtrls, ExtCtrls, UNIStaleUnit, UNIDataModuleUnit, Mask, DBCtrls,
  UNIDBConstComboBoxUnit, UNIDBDateEditUnit, UNIDateEditUnit, URDataSet,
  UniDesigner, URSheet;

type

  TZLEZlecenieDBDetailOsadzone = set of (frmNone, frmPozycje, frmPolaUz,
                                         frmPolaUzPoz, frmObrazy);

  TZLEZlecenieDBDetailForm = class(TUNIDBDetailForm)
    ZleceniePageControl: TUNIPageControl;
    PozycjeTabSheet: TTabSheet;
    OgolneTabSheet: TTabSheet;
    PozycjeZleceniaPanel: TUNIPanel;
    InformacjeOgolnePanel: TUNIPanel;
    TypZleceniaLabel: TUNILabel;
    SymbolLabel: TUNILabel;
    NazwaLabel: TUNILabel;
    TypZleceniaDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    SymbolDBEdit: TUNIDBEdit;
    NazwaDBEdit: TUNIDBEdit;
    ZlecenieGrupujacePanel: TUNIPanel;
    ZlecenieGrupujaceLabel: TUNILabel;
    ZlecenieGrupujaceNazwaLabel: TUNILabel;
    ZlecenieGrupujaceDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    Pole1Panel: TUNIPanel;
    Pole1Label: TUNILabel;
    Pole1DBEdit: TUNIDBEdit;
    Pole2Panel: TUNIPanel;
    Pole2Label: TUNILabel;
    Pole2DBEdit: TUNIDBEdit;
    Pole3Panel: TUNIPanel;
    Pole3Label: TUNILabel;
    Pole3DBEdit: TUNIDBEdit;
    StatusZleceniaPanel: TUNIPanel;
    StatusLabel: TUNILabel;
    DataOtwarciaLabel: TUNILabel;
    DataZakonczeniaLabel: TUNILabel;
    OsobaOdpowiedzialnaLabel: TUNILabel;
    ModulZSILabel: TUNILabel;
    OsobaPotwierdzajacaLabel: TUNILabel;
    PodstawaPotwierdzeniaLabel: TUNILabel;
    ModulZSINazwaLabel: TUNILabel;
    StatusZleceniaDBConstComboBox: TUNIDBConstComboBox;
    DataOtwarciaDBDateEdit: TUNIDBDateEdit;
    DataZakonczeniaDBDateEdit: TUNIDBDateEdit;
    OsobaOdpowiedzialnaDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    ModulZSIDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    OsobaPotwierdzajacaDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    PodstawaPotwierdzeniaDBEdit: TUNIDBEdit;
    WykonawcaPanel: TUNIPanel;
    WykonawcaLabel: TUNILabel;
    WykonawcaNazwaLabel: TUNILabel;
    WykonawcaDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    WydzialPanel: TUNIPanel;
    OpisPanel: TUNIPanel;
    OpisLabel: TUNILabel;
    WydzialLabel: TUNILabel;
    WydzialDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    WydzialNazwaLabel: TUNILabel;
    OpisDBMemo: TUNIDBMemo;
    ZasobyTabSheet: TTabSheet;
    ZasobyPanel: TUNIPanel;
    OddzialPanel: TUNIPanel;
    OddzialLabel: TUNILabel;
    OddzialNazwaLabel: TUNILabel;
    OddzialDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    ZapotrzebowaniaPierwTabSheet: TTabSheet;
    ZapotrzebowaniePierwPanel: TUNIPanel;
    PozButtonsPanel: TUNIPanel;
    ZapotrzebowaniePierwPokazButton: TUNIButton;
    ZapotrzebowaniePierwDopiszButton: TUNIButton;
    ZapotrzebowaniePierwUsunButton: TUNIButton;
    ZapotrzebowaniaWtorneTabSheet: TTabSheet;
    ZapotrzebowanieWtornePanel: TUNIPanel;
    UNIPanel2: TUNIPanel;
    ZapotrzebowanieWtornePokazButton: TUNIButton;
    ZapotrzebowanieWtorneDopiszButton: TUNIButton;
    ZapotrzebowanieWtorneUsunButton: TUNIButton;
    ZamowienieTabSheet: TTabSheet;
    ZamNaglPanel: TUNIPanel;
    ZamowieniePanel: TUNIPanel;
    UNIPanel3: TUNIPanel;
    ZamowieniePokazButton: TUNIButton;
    ZamowienieDopiszButton: TUNIButton;
    ZamowienieUsunButton: TUNIButton;
    AsortymentPanel: TUNIPanel;
    UNILabel1: TUNILabel;
    UNILabel2: TUNILabel;
    IloscDBEdit: TUNIDBEdit;
    AsortymentLookupAliasEdit: TUNILookupAliasEdit;
    LRecepturaLabel: TUNILabel;
    RecepturaLookupAliasEdit: TUNILookupAliasEdit;
    MaterialTabSheet: TTabSheet;
    MaterialPanel: TUNIPanel;
    UNIPanel4: TUNIPanel;
    MatPokazButton: TUNIButton;
    MatDopiszButton: TUNIButton;
    MatUsunButton: TUNIButton;
    MatZmienButton: TUNIButton;
    MatKopiujButton: TUNIButton;
    MatZamiennikButton: TUNIButton;
    MatOryginalButton: TUNIButton;
    ZapytanieTabSheet: TTabSheet;
    ZapytaniePanel: TUNIPanel;
    UNIPanel5: TUNIPanel;
    ZapytaniePokazButton: TUNIButton;
    ZapytanieDopiszButton: TUNIButton;
    ZapytanieUsunButton: TUNIButton;
    PrzeliczDBCheckBox: TUNIDBCheckBox;
    PrefixLabel: TUNILabel;
    PrefixDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    GridyPozycjiPanel: TUNIPanel;
    UniDesigner: TUniDesigner;
    PodstawowyZestawDanych: TURDataSet;
    DrukujButton: TUNIButton;
    GeneratorButton: TUNIButton;
    btnUzytkownicyZaangazowaniButton: TUNIButton;
    PojazdPanel: TUNIPanel;
    PojazdLabel: TUNILabel;
    PojazdNazwaLabel: TUNILabel;
    PojazdDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    ProcentUEPanel: TUNIPanel;
    ProcentUELabel: TUNILabel;
    ProcentUEDBEdit: TUNIDBEdit;
    ObrazyButton: TUNIButton;
    PoziomINFPanel: TUNIPanel;
    PoziomINFLabel: TUNILabel;
    ElementINFLabel: TUNILabel;
    ElementINFNazwaLabel: TUNILabel;
    PoziomNazwaLabel: TUNILabel;
    ElementINFDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    PunktPanel: TUNIPanel;
    UNILabel3: TUNILabel;
    PunktOpisLabel: TUNILabel;
    PunktDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    SprawaPanel: TUNIPanel;
    SprawaLabel: TUNILabel;
    SprawaOpisLabel: TUNILabel;
    SprawaDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    UmowaPanel: TUNIPanel;
    UmowaLabel: TUNILabel;
    UmowaOpisLabel: TUNILabel;
    UmowaDBLookupAliasEdit: TUNIDBLookupAliasEdit;
    function TypZleceniaDBLookupAliasEditGetDataField: String;
    function ModulZSIDBLookupAliasEditGetDataField: String;
    function OsobaOdpowiedzialnaDBLookupAliasEditGetDataField: String;
    function OsobaPotwierdzajacaDBLookupAliasEditGetDataField: String;
    function ModulZSIDBLookupAliasEditGetQuery: TUNIQuery;
    procedure ModulZSIDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function OsobaOdpowiedzialnaDBLookupAliasEditGetQuery: TUNIQuery;
    procedure OsobaOdpowiedzialnaDBLookupAliasEditInitAliasInfo(
      Sender: TObject);
    function OsobaPotwierdzajacaDBLookupAliasEditGetQuery: TUNIQuery;
    procedure OsobaPotwierdzajacaDBLookupAliasEditInitAliasInfo(
      Sender: TObject);
    function TypZleceniaDBLookupAliasEditGetQuery: TUNIQuery;
    procedure TypZleceniaDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function TypZleceniaDBLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    procedure StatusZleceniaDBConstComboBoxExit(Sender: TObject);
    procedure OsobaOdpowiedzialnaDBLookupAliasEditDelKey(Sender: TObject);
    procedure OsobaPotwierdzajacaDBLookupAliasEditDelKey(Sender: TObject);
    procedure DataZakonczeniaDBDateEditDateChange(Sender: TObject);
    function ZlecenieGrupujaceDBLookupAliasEditGetDataField: String;
    function ZlecenieGrupujaceDBLookupAliasEditGetQuery: TUNIQuery;
    procedure ZlecenieGrupujaceDBLookupAliasEditInitAliasInfo(
      Sender: TObject);
    function WydzialDBLookupAliasEditGetDataField: String;
    function WydzialDBLookupAliasEditGetQuery: TUNIQuery;
    procedure WydzialDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function WydzialDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure WydzialDBLookupAliasEditDelKey(Sender: TObject);
    function ZlecenieGrupujaceDBLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    function ModulZSIDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure ZlecenieGrupujaceDBLookupAliasEditDelKey(Sender: TObject);
    procedure ModulZSIDBLookupAliasEditDelKey(Sender: TObject);
    function WykonawcaDBLookupAliasEditGetDataField: String;
    function WykonawcaDBLookupAliasEditGetQuery: TUNIQuery;
    procedure WykonawcaDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function WykonawcaDBLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    procedure WykonawcaDBLookupAliasEditDelKey(Sender: TObject);
    procedure DataOtwarciaDBDateEditDateChange(Sender: TObject);
    procedure SelectButtonClick(Sender: TObject);
    procedure OddzialDBLookupAliasEditDelKey(Sender: TObject);
    function OddzialDBLookupAliasEditGetDataField: String;
    function OddzialDBLookupAliasEditGetQuery: TUNIQuery;
    procedure OddzialDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function OddzialDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure ZapotrzebowaniePierwPokazButtonClick(Sender: TObject);
    procedure ZapotrzebowaniePierwDopiszButtonClick(Sender: TObject);
    procedure ZapotrzebowaniePierwUsunButtonClick(Sender: TObject);
    procedure ZapotrzebowanieWtornePokazButtonClick(Sender: TObject);
    procedure ZapotrzebowanieWtorneDopiszButtonClick(Sender: TObject);
    procedure ZapotrzebowanieWtorneUsunButtonClick(Sender: TObject);
    procedure ZamowieniePokazButtonClick(Sender: TObject);
    procedure ZamowienieDopiszButtonClick(Sender: TObject);
    procedure ZamowienieUsunButtonClick(Sender: TObject);
    procedure AsortymentLookupAliasEditDelKey(Sender: TObject);
    procedure AsortymentLookupAliasEditButtonClick(Sender: TObject);
    function AsortymentLookupAliasEditSetData(
      AliasSrc: TDataSet): Boolean;
    procedure RecepturaLookupAliasEditButtonClick(Sender: TObject);
    procedure RecepturaLookupAliasEditDelKey(Sender: TObject);
    function RecepturaLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure MatPokazButtonClick(Sender: TObject);
    procedure MatDopiszButtonClick(Sender: TObject);
    procedure MatZmienButtonClick(Sender: TObject);
    procedure MatUsunButtonClick(Sender: TObject);
    procedure MatKopiujButtonClick(Sender: TObject);
    procedure MatZamiennikButtonClick(Sender: TObject);
    procedure MatOryginalButtonClick(Sender: TObject);
    procedure ZapytaniePokazButtonClick(Sender: TObject);
    procedure ZapytanieDopiszButtonClick(Sender: TObject);
    procedure ZapytanieUsunButtonClick(Sender: TObject);
    function PrefixDBLookupAliasEditGetDataField: String;
    function PrefixDBLookupAliasEditGetQuery: TUNIQuery;
    procedure PrefixDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function PrefixDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure GeneratorButtonClick(Sender: TObject);
    procedure DrukujButtonClick(Sender: TObject);
    procedure btnUzytkownicyZaangazowaniButtonClick(Sender: TObject);
    procedure PojazdDBLookupAliasEditDelKey(Sender: TObject);
    function PojazdDBLookupAliasEditGetDataField: String;
    function PojazdDBLookupAliasEditGetQuery: TUNIQuery;
    procedure PojazdDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function PojazdDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure ObrazyButtonClick(Sender: TObject);
    function ElementINFDBLookupAliasEditGetDataField: string;
    function ElementINFDBLookupAliasEditGetQuery: TUNIQuery;
    procedure ElementINFDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function ElementINFDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure PunktDBLookupAliasEditDelKey(Sender: TObject);
    function PunktDBLookupAliasEditGetDataField: string;
    function PunktDBLookupAliasEditGetQuery: TUNIQuery;
    procedure PunktDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function PunktDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    function SprawaDBLookupAliasEditGetDataField: string;
    function SprawaDBLookupAliasEditGetQuery: TUNIQuery;
    procedure SprawaDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function SprawaDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
    procedure SprawaDBLookupAliasEditDelKey(Sender: TObject);
    procedure UmowaDBLookupAliasEditDelKey(Sender: TObject);
    function UmowaDBLookupAliasEditGetDataField: string;
    function UmowaDBLookupAliasEditGetQuery: TUNIQuery;
    procedure UmowaDBLookupAliasEditInitAliasInfo(Sender: TObject);
    function UmowaDBLookupAliasEditSetData(AliasSrc: TDataSet): Boolean;
  private
    FTabelaPowiazana: String;
    FElementINF: String;
    FTabelaINF: String;
    FElementINFZlec: String;
    sPoziomAkt: String;
    iInfID: Integer;
    FASORegID: Integer;
    FPozycjeZleceniaFormIndex: Integer;
    FZasobyFormIndex: Integer;
    //FPolaUzFormIndex: Integer;
    FPodpowiedzDaneSprawy: Boolean;
    FDomyslnaNazwa: String;
    FDomyslnaData: Boolean;
    iNumeratorID: Integer;
    iOkresID: Integer;
    iOddzialOld: Integer;
    iPrefixOld: Integer;
    sTypSuffix: String;
    bSuffix, bSelectButton: Boolean;
    bKopiuj: Boolean;
    //iElementDomID: Integer;

    {Zapamietane wartosci dla symbolu}
    iNumeratorStartID: Integer;
    iOkresStartID: Integer;
    iOddzialStart: Integer;
    iPrefixStartID: Integer;
    iLicznikStart: Integer;
    iRokStartID: Integer;
    sSymbolStart: String;
    sSuffixStart: String;
    bZmianaDaty: Boolean;
    bZmianaOddzialu: Boolean;
    bNumMiesieczny: Boolean;
    bNumMiesiecznyStart: Boolean;
    bNumOpis: Boolean;
    bNumOpisStart: Boolean;
    bNumOpis2: Boolean;
    bNumOpis2Start: Boolean;
    bNumKod: Boolean;
    bNumKodStart: Boolean;

    iTypGrupujacy: Integer;
    bKontrolaIlosciowa: Boolean;
    bKontrolaIlosciowaAsoMag: Boolean;
    //sParametrField: String;
    FZamowienieFormIndex:   integer;
    FZapytanieFormIndex:    integer;
    FZapotrzPierwFormIndex: integer;
    FZapotrzWtorneFormIndex:integer;
    FMaterialFormIndex:     integer;
    m_oOrygMaterialDataChange:  TDataChangeEvent;
    m_iCurrTypZlecId:           integer;
    m_evntOldPozycjeAfterScroll:TDataSetNotifyEvent;
    m_bProdukcyjne:             boolean;
    m_bZlecenieNaPlanie:        boolean;  // wskazuje czy dane zlecenie zostao ju umieszczone na planie produkcji

    {Nowe pola UZ}
    m_iPolaUzNr:          integer;
    m_oZakladkiParents:   TStringList;
    m_iTworzonaFormatka:  TZLEZlecenieDBDetailOsadzone;
    m_iZAOZapotrzTypId:   integer;

    (***
// pocztek sekcji kopiowania pl uz
    m_sNaglowekFunkcja:   string;
    m_sPozycjaFunkcja:    string;
    m_iNaglowekFunkcjaId: integer;
    m_iNaglowekElementId: integer;
    m_oPozycjeId:         TStringList;
// koniec sekcji kopiowania pl uz
    ***)

    procedure InitializeControls();
    procedure InitializeObjectFields();
    procedure pPozycjeAfterScroll(aDataSet: TDataSet);
    procedure AddContainedForms();
    procedure SetDefaults();
    procedure SetSymbol( iNewNumeratorID: Integer; var iBlad: Integer);
    procedure FieldChange( Sender: TField );
    procedure StatusChanged();
    procedure ShowLookups();
    procedure UstawAsortymentReceptury(
                      const ac_iAsortId:  integer
              );
    procedure MaterialGridDataChange(
                            a_oSender:    TObject;
                            a_oField:     TField
              );
    procedure SkopiujPowiazaniaReceptury(
                  const ac_bProsOPotwierdzenie: boolean
              );
    procedure DajTypNumeratora;
    procedure UstawAsortymentIIlosc(
                  const ac_iAsortId:        integer;
                  const ac_sAsortSymbol:    string  = '';
                  const ac_dIlosc:          double  = 0
              );
    procedure ShowReceptura(
                  const ac_oDataSet:        TDataSet
              );
      {
        Funkcja sprawdza czy materiay maj przypisane konto materiaowe. Jeeli ktry materia
        nie ma przypisanego konta to informuje o tym uytkownika i pozwala mu je wybra.
        Zwraca TRUE jeeli wszystkie maj przypisane konto.
      }
    function  SprawdzKontoMaterialoweWMaterialach():  boolean;
    procedure UtworzGridObrazow();

    {PolaUZNew}
    procedure WyswietlPolaUzytkownikaNew();
    procedure PrzebudujPolaUzytkownikaNew();
    procedure UtworzPolaUZPozNew();
    procedure PrzebudujPolaUZPozNew();


  protected
    procedure BeforeShow; override;
    function CreateDataModule(const AOpenMode: TOpenMode): TUNIDataModule; override;
    procedure InternalOpen; override;
    procedure GetPositionAndParentForContainedForm(
               const nr:integer;
               var APosition: TRect;
               var AParent: TWinControl;
               var AAlign:TAlign); override;
  public
    m_oPolaUZGridy:       TStringList;
    m_oZakladkiPozGridy:  TStringList;
    m_oZakladkiPozId:     TStringList;

    m_oPozycjaGrid,
    m_oZasobyGrid,
    m_oMaterialGrid,
    m_oZamowienieGrid,
    m_oZapytanieGrid,
    m_oZapotrzWtorneGrid,
    m_oZapotrzPierwGrid:  TUNIDBGridForm;

    m_oObrazy:            TUNIForm;

    destructor Destroy(); override;
    function Validate(): Boolean; override;
    function DopiszPozycjeDlaSprawy( sSprawy: String = '' ): Boolean;
    //procedure pNewPozPolaUz;
    //procedure pReReadOthersPoz;
    procedure ReOpen; override;
    //procedure OdswiezPolaUz();
    procedure WydrukZlecenia();
    procedure PostPictureChanges();
    procedure SelectButtonPressed; override;
    procedure CancelButtonPressed; override;

    {Funkcja generuje opis dla numeratora rozszerzonego,
     zwaraca 0 jak zakoczyo si to powodzeniem
     oraz <> 0 gdy bd}
    function  GenerujSuffix(var sOpis: String): Integer;

    procedure GetParametersForForm(
                  a_oForm:              TUNIForm;
                  a_oParameters:        TKeyValues
              ); override;
    procedure UstawDanePozycjiZapotrzebowania(
                  const ac_iAsortId:      integer;
                  const ac_aZapotrzPozId: array of integer;
                  const ac_dIlosc:        double;
                  const ac_iOdpowiedzialny: Integer;
                  const ac_sAsortSymbol:  string  = '';
                  const ac_sAsortNazwa:   string  = ''
              );
    procedure UstawDanePozycjiZamowienia(
                  const ac_iAsortId:        integer;
                  const ac_aZamowieniePozId:array of integer;
                  const ac_dIlosc:          double;
                  const ac_iOdpowiedzialny: Integer;
                  const ac_sAsortSymbol:    string  = '';
                  const ac_sAsortNazwa:     string  = '';
                  const ac_iRecepId:        integer = 0;
                  const ac_sRecepSymbol:    string  = ''
              );
    procedure DodajPozycjeZleceniaNieProd(
                  const ac_iAsortId:        integer;
                  const ac_dIlosc:          double;
                  const ac_iOdpowiedzialny: Integer;
                  const ac_sOpisPozycji:    string  = '';
                  const ac_sAsortSymbol:    string  = '';
                  const ac_sAsortNazwa:     string  = '';
                  const ac_sAsortIndeks:    string  = '';
                  const ac_iWykonawcaId:    integer = 0 // bkklient_id bdcy wykonawc zlecenia
              );
    procedure PowiazZlecenieNieProdZZamowieniem(
                  const ac_iZamowPozAdmFunk:integer
              );
    procedure PowiazZlecenieNieProdZZapotrzebowaniem(
                  const ac_iZapotrzPozAdmFunk:  integer
              );
    procedure PowiazZlecenieNieProdZZapytaniem(
                  const ac_iZapytPozAdmFunk:    integer
              );
    procedure UstawDanePozycjiZapytania(
                  const ac_iAsortId:        integer;
                  const ac_aZapytPozId:     array of integer;
                  const ac_iOdpowiedzialny: Integer;
                  const ac_dIlosc:          double  = 0;
                  const ac_sAsortSymbol:    string  = '';
                  const ac_sAsortNazwa:     string  = '';
                  const ac_iRecepId:        integer = 0;
                  const ac_sRecepSymbol:    string  = ''
              );
    procedure SkopiujDaneZeZlecenia(
                  const ac_iZlecenieId:     integer
              );

    property TabelaPowiazana: String read FTabelaPowiazana;
    property ElementINF: String read FElementINF;
    property ElementINFZlec: String read FElementINFZlec;
    property ASORegID: Integer read FASORegID;
    property PozycjeZleceniaFormIndex: Integer read FPozycjeZleceniaFormIndex;
    property ZasobyFormIndex: Integer read FZasobyFormIndex;
    property PodpowiedzDaneSprawy: Boolean read FPodpowiedzDaneSprawy;
    //property PolaUzFormIndex: Integer read FPolaUzFormIndex;
    property ZapotrzPierwFormIndex: integer read FZapotrzPierwFormIndex;
    property ZapotrzWtorneFormIndex:integer read FZapotrzWtorneFormIndex;
    property ZamowienieFormIndex: integer read FZamowienieFormIndex;
    property ZapytanieFormIndex:  integer read FZapytanieFormIndex;
    property MaterialFormIndex: integer read FMaterialFormIndex;
    property ZlecenieProdukcyjne: boolean read m_bProdukcyjne;
    property KontrolaIlosciowa: Boolean read bKontrolaIlosciowa;
    property KontrolaIlosciowaAsoMag: Boolean read bKontrolaIlosciowaAsoMag;
    property  ZAOZapotrzTypId:  integer read  m_iZAOZapotrzTypId;
  end;

implementation

{$R *.DFM}

uses
  variants,
  Dodatki,
  FormManagerUnit,
  SQLManagerUnit,
  SecurityManagerUnit,
  UniqueKeyUnit,
  UNIRepTypes,
  UNIDataManagerUnit,
  UNISysDefUnit,
  UNISysDataManagerUnit,
  ASODefUnit,
  BKDefUnit,
  BKDataManagerUnit,
  BOKDefUnit,
  BOKDataManagerExtUnit,
  FKDefUnit,
  INFDefUnit,
  INFDataManagerExtUnit,
  KDDefUnit,
  KDDataManagerExtUnit,
  ZLEDefUnit,
  ZLEDataManagerUnit,
  ZLEZlecenieUnit,
  ZLEPozycjeUnit,
  ZLEPoleZmGridFormUnit,
  ZLEZlecenieDBGridFormUnit,
  SystemDefUnit,
  ZLEZlecenieMaterialDBGridFormUnit,
  ZLEZlecenieZasobDBGridFormUnit,
  LFKDefUnit, UNIDBFormUnit,
  ZAODataManagerExtUnit,
  ZAODefUnit,
  ZAMDataManagerExtUnit,
  ASODataManagerExtUnit,
  LWPDataManagerExtUnit,
  UNIINTDefUnit,
  SANDefUnit,
  ZAMToolsUnit,
  {$ifdef build_all}
  SANDataManagerUnit,
  {$else}
  SANDataManagerExtUnit,
  {$endif}
  MAGDefUnit,
  ZAMDefUnit,
  LWPDefUnit;

{ TZLEZlecenieDBDetailForm }

procedure TZLEZlecenieDBDetailForm.WydrukZlecenia();
begin
  if Komunikat(cInformation, 'Wydrukowa zlecenie?', MB_YESNO) = idYes then begin
      PodstawowyZestawDanych.DataSet.DisableControls;
      try
        UniDesigner.ShowPreviewForForm(SQLManager.GetDataBaseName,
                                       SQLManager.GetTableName(sUNIREP),
                                       SQLManager.GetTableName(sUNIREPUSERRIGHTS),
                                       'TZLEZlecenieDBDetailForm',
                                       False,
                                       SecurityManager.UserId,
                                       DataManagers[sZLEModulID].ModulZSI_ID);
      finally
        PodstawowyZestawDanych.DataSet.EnableControls;
      end;
  end;
end;

procedure TZLEZlecenieDBDetailForm.DajTypNumeratora;
var
  KV : TKeyValues;
  s: string;
begin
  bNumMiesieczny := false;
  bNumKod        := False;
  bNumOpis       := False;
  bNumOpis2      := False;

  KV := TKeyValues.CreateAs([sUNISysAutomatyNumerowaniaROdzaj,
                             sUNISysAutomatyNumerowaniaExistKod,
                             sUNISysAutomatyNumerowaniaExistOpis,
                             sUNISysAutomatyNumerowaniaExistOpis2]);

  UNISYSDM.UNIPodajParametryNumeratora(iNumeratorID, KV);

  s := KV.Values[sUNISysAutomatyNumerowaniaROdzaj];
  if (s = sUNICONST_RODZ_NUMERACJI_MIESIECZNA_ID ){ or
     (s = sUNICONST_RODZ_NUMERACJI_ROCZNA_ID)} then
    bNumMiesieczny := True;

  s := KV.Values[sUNISysAutomatyNumerowaniaExistKod];
  if s = sTak then bNumKod   := True;

  s := KV.Values[sUNISysAutomatyNumerowaniaExistOpis];
  if s = sTak then bNumOpis  := True;

  s := KV.Values[sUNISysAutomatyNumerowaniaExistOpis2];
  if s = sTak then bNumOpis2 := True;

  KV.Free;
end;

procedure TZLEZlecenieDBDetailForm.UmowaDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  if OpenMode in [omNew, omEdit] then begin
     UmowaDBLookupAliasEdit.Text := '';
     UmowaOpisLabel.Caption := '';
     DMAQFbN(sBOKUMOWA_ID).Clear;
  end;
end;

function TZLEZlecenieDBDetailForm.UmowaDBLookupAliasEditGetDataField: string;
begin
  result := sBOKUMOWA_ID;
end;

function TZLEZlecenieDBDetailForm.UmowaDBLookupAliasEditGetQuery: TUNIQuery;
var
  sLocate: String;
  sWhere: String;
begin
  sLocate := '';
  result := nil;
  if not DataManagers.Available(sBOKModulID) then Exit;

  if not DMAQFbN(sBOKUMOWA_ID).IsNull then
    sLocate := sBOKUMOWA_ID+'='+DMAQFbN(sBOKUMOWA_ID).AsString;
  if {PodpowiedzDaneSprawy and} (Parameters.Values[sBOKUMOWA_ID] <> '') then
    sWhere := '@'+sBOKAlias_Umowa_ID+' in ('+Parameters.Values[sBOKUMOWA_ID]+')'
  else
    sWhere := '';
  result := BOKDM.PokazIObsluzDane( sBOKUmowa,
                                    sBOKAlias_Umowa_ID+';'+
                                    sBOKAlias_Umowa_Symbol+';'+
                                    sBOKAlias_Umowa_Nazwa,
                                    sWhere, False, False, sLocate );
end;

procedure TZLEZlecenieDBDetailForm.UmowaDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  if not DataManagers.Available(sBOKModulID) then Exit;

  with UmowaDBLookupAliasEdit do begin
    if DataManagers.Available(sBOKModulID) then
      AliasManager := BOKDM.AliasManager
    else
      AliasManager := nil;
    Alias_ID := sBOKAlias_Umowa_ID;
    Alias_Name := sBOKAlias_Umowa_Symbol;
    AdditionalAliases := sBOKAlias_Umowa_Nazwa;
    if {PodpowiedzDaneSprawy and} (Parameters.Values[sBOKUMOWA_ID] <> '') then
      AdditionalCondition := '@'+sBOKAlias_Umowa_ID+' in ('+Parameters.Values[sBOKUMOWA_ID]+')'
    else
      AdditionalCondition := '';
  end;
end;

function TZLEZlecenieDBDetailForm.UmowaDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
      UmowaOpisLabel.Caption := AliasSrc.FieldByName(sBOKUMOWA_NAZWA).AsString;
  end;
  result := True;
end;

procedure TZLEZlecenieDBDetailForm.UstawAsortymentIIlosc(
  const ac_iAsortId:        integer;
  const ac_sAsortSymbol:    string  = '';
  const ac_dIlosc:          double  = 0
);
var
  oQuery: TUNIQuery;
begin
  DMAQFbN(sASOASORT_ID).AsInteger     := ac_iAsortId;
  if(ac_dIlosc > 0) then
    DMAQFbN(sZLEZLECENIE_ILOSC).AsFloat := ac_dIlosc;
  if(Length(ac_sAsortSymbol) > 0) then begin
    AsortymentLookupAliasEdit.Text  := ac_sAsortSymbol;
  end else begin
    oQuery  := ASODM.OdpytajODane(sASOASORT_ID,
      sASOAlias_Asort_Symbol,
      '@' + sASOAlias_Asort_ID + ' = ' + IntToStr(ac_iAsortId),
      false
    );
    if(oQuery <> nil) then begin
      AsortymentLookupAliasEdit.Text  := oQuery.Fields[0].AsString;
      oQuery.Free();
    end else
      DMAQFbN(sASOASORT_ID).Clear();
  end;
  UstawAsortymentReceptury(DMAQFbN(sASOASORT_ID).AsInteger);
end;

procedure TZLEZlecenieDBDetailForm.ShowReceptura(
  const ac_oDataSet:        TDataSet
);
begin
  RecepturaLookupAliasEdit.Text := ac_oDataSet.Fields[1].AsString;
end;

{
  Funkcja sprawdza czy materiay maj przypisane konto materiaowe. Jeeli ktry materia
  nie ma przypisanego konta to informuje o tym uytkownika i pozwala mu je wybra.
  Zwraca TRUE jeeli wszystkie maj przypisane konto.
}
procedure TZLEZlecenieDBDetailForm.SprawaDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  if OpenMode in [omNew, omEdit] then begin
     SprawaDBLookupAliasEdit.Text := '';
     SprawaOpisLabel.Caption := '';
     DMAQFbN(sBOKSPRAWA_ID).Clear;
  end;
end;

function TZLEZlecenieDBDetailForm.SprawaDBLookupAliasEditGetDataField: string;
begin
  result := sBOKSPRAWA_ID;
end;

function TZLEZlecenieDBDetailForm.SprawaDBLookupAliasEditGetQuery: TUNIQuery;
var
  sLocate: String;
  sWhere: String;
begin
  sLocate := '';
  result := nil;
  if not DataManagers.Available(sBOKModulID) then Exit;

  if not DMAQFbN(sBOKSPRAWA_ID).IsNull then
    sLocate := sBOKSPRAWA_ID+'='+DMAQFbN(sBOKSPRAWA_ID).AsString;
  if PodpowiedzDaneSprawy and (Parameters.Values[sBOKSPRAWA_ID] <> '') then
    sWhere := '@'+sBOKAlias_Sprawa_ID+' in ('+Parameters.Values[sBOKSPRAWA_ID]+')'
  else
    sWhere := '';
  result := BOKDM.PokazIObsluzDane( sBOKSPRAWA,
                                    sBOKAlias_Sprawa_ID+';'+
                                    sBOKAlias_Sprawa_Numer+';'+
                                    sBOKAlias_Sprawa_ObiektINF+';'+
                                    sBOKAlias_Sprawa_ObiektINF_ID+';'+
                                    sBOKAlias_Sprawa_Asort_ID+';'+
                                    sBOKAlias_Sprawa_Problem+';'+
                                    sBOKAlias_Sprawa_Umowione+';'+
                                    sBOKAlias_Sprawa_Data_Umow,
                                    sWhere, False, False, sLocate );
end;

procedure TZLEZlecenieDBDetailForm.SprawaDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  if not DataManagers.Available(sBOKModulID) then Exit;

  with SprawaDBLookupAliasEdit do begin
    if DataManagers.Available(sBOKModulID) then
      AliasManager := BOKDM.AliasManager
    else
      AliasManager := nil;
    Alias_ID := sBOKAlias_Sprawa_ID;
    Alias_Name := sBOKAlias_Sprawa_Numer;
    AdditionalAliases := sBOKAlias_Sprawa_ObiektINF+';'+
                         sBOKAlias_Sprawa_ObiektINF_ID+';'+
                         sBOKAlias_Sprawa_Asort_ID+';'+
                         sBOKAlias_Sprawa_Problem+';'+
                         sBOKAlias_Sprawa_Umowione+';'+
                         sBOKAlias_Sprawa_Data_Umow;
    if PodpowiedzDaneSprawy and (Parameters.Values[sBOKSPRAWA_ID] <> '') then
      AdditionalCondition := '@'+sBOKAlias_Sprawa_ID+' in ('+Parameters.Values[sBOKSPRAWA_ID]+')'
    else
      AdditionalCondition := '';
  end;
end;

function TZLEZlecenieDBDetailForm.SprawaDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
    if (OpenMode in [omNew,omEdit]) then begin
      if (PoziomINFPanel.Visible)and
         ((SprawaDBLookupAliasEdit.Initialized)or(DMAQFbN(sZLEZLECENIE_INF_ID).IsNull)) then begin
        DMAQFbN(sZLEZLECENIE_POZIOMINF).AsString := AliasSrc.FieldByName(sBOKSPRAWA_OBIEKTJAKI).AsString;
        DMAQFbN(sZLEZLECENIE_INF_ID).AsInteger := AliasSrc.FieldByName(sBOKSPRAWA_OBIEKTID).AsInteger;
        //FSprawaUmowione := AliasSrc.FieldByName(sBOKSPRAWA_UMOWIONE).AsString;
        //FSprawaDataUmow := AliasSrc.FieldByName(sBOKSPRAWA_DATA_UMOW).AsDateTime;
        ElementINFDBLookupAliasEdit.Refresh();
      end;
      {if DMAQFbN(sASOASORT_ID).IsNull then begin
        SymbolAsortymentuDBLookupAliasEdit.InitiateData(AliasSrc.FieldByName(sASOASORT_ID));
      end; }
      if DMAQFbN(sZLEZLECENIE_OPIS).IsNull then
        DMAQFbN(sZLEZLECENIE_OPIS).AsString := AliasSrc.FieldByName(sBOKSPRAWA_PROBLEM).AsString;
      SprawaOpisLabel.Caption := AliasSrc.FieldByName(sBOKSPRAWA_PROBLEM).AsString;
    end;
  end;
  result := True;
end;

function  TZLEZlecenieDBDetailForm.SprawdzKontoMaterialoweWMaterialach():  boolean;
var
  iOdpowiedz: integer;
begin
  result  := true;
  m_oMaterialGrid.DataModule.ActiveQuery.DisableControls();
  try
    m_oMaterialGrid.DataModule.ActiveQuery.First();
    while(not m_oMaterialGrid.DataModule.ActiveQuery.Eof) do begin
      if(m_oMaterialGrid.DMAQFbN(sASOASORTKMAT_ID).IsNull) then begin
        iOdpowiedz  := Komunikat(
          cWarning,
          'Materia ' + m_oMaterialGrid.DMAQFbN(sASOASORT_SYMBOL).AsString + ' nie ma przypisanego konta materiaowego.' + Chr(13) +
          'Czy chcesz przypisa konto?' + Chr(13) +
          Chr(13) +
          'TAK - aby uzupeni konto materiaowe i kontynuowa' + Chr(13) +
          'NIE - aby pozostawi puste konto materiaowe i kontynuowa' + Chr(13) +
          'Anuluj - aby przerwa zatwierdzanie danych',
          MB_YESNOCANCEL + MB_ICONEXCLAMATION
        );
        case(iOdpowiedz) of
          mrYes:  begin
            ZleceniePageControl.ActivePage  := MaterialTabSheet;
            if(not (m_oMaterialGrid as TZLEZlecenieMaterialDBGridForm).EdytujMaterial()) then begin
              result  := false;
              break;
            end;
          end;
          mrNo:   begin
          end;
          else begin
            result  := false;
            break;
          end;
        end;  // case(iOdpowiedz)
      end;  // if(m_oMaterialGrid.DMAQFbN(sASOASORTKMAT_ID).IsNull)
      m_oMaterialGrid.DataModule.ActiveQuery.Next();
    end;  // while(not m_oMaterialGrid.DataModule.ActiveQuery.Eof)
  finally
    m_oMaterialGrid.DataModule.ActiveQuery.EnableControls();
  end;
end;

procedure TZLEZlecenieDBDetailForm.ReOpen;
{var
  iFormIndex: Integer;}
begin
  inherited;
  BeforeShow;

  if m_oPozycjaGrid <> nil then begin
    m_oPozycjaGrid.DataModule.ActiveQuery.AfterScroll := pPozycjeAfterScroll;
    pPozycjeAfterScroll(m_oPozycjaGrid.DataModule.ActiveQuery);
  end;
  {iFormIndex := FContainedForms.IndexOf(cFormPozycjeZlecenia);
  if(iFormIndex > -1) then begin
    TUNIDBGridForm(FContainedForms.Objects[iFormIndex]).DataModule.ActiveQuery.AfterScroll := pPozycjeAfterScroll;
    pPozycjeAfterScroll(TUNIDBGridForm(FContainedForms.Objects[iFormIndex]).DataModule.ActiveQuery);
  end;}
end;

procedure TZLEZlecenieDBDetailForm.pPozycjeAfterScroll(aDataSet: TDataSet);
begin
(*******************POLA UZ***************************
  TZleZlecenieDataModule(DataModule).aZleZleceniePoleZmDataSet.Filtered := False;
  TZleZlecenieDataModule(DataModule).aZleZleceniePoleZmDataSet.Filter := sZLEZLECENIEPOZ_ID + ' = ' + IntToStr(TUNIDBGridForm(FContainedForms.Objects[FPozycjeZleceniaFormIndex]).DataModule.ActiveQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger);
  TZleZlecenieDataModule(DataModule).aZleZleceniePoleZmDataSet.Filtered := True;
*******************POLA UZ***************************)

  if(Assigned(m_evntOldPozycjeAfterScroll)) then
    m_evntOldPozycjeAfterScroll(aDataSet);
end;

(*******************POLA UZ***************************
procedure TZLEZlecenieDBDetailForm.pNewPozPolaUz;
var
  sFrom, sWhere: String;
  iZleTypZlec_ID: Integer;
  oQuery: TUniQuery;
begin
  iZleTypZlec_ID := DMAQFbN(sZLETYPZLEC_ID).AsInteger;
  if iZLETypZlec_ID <= 0 then Exit;

  oQuery := nil;
  sFrom :=  sZLEAlias_PolaZMDefID+';'+
            sZLEAlias_PolaZMDefNazwa+';'+
            sZLEAlias_PolaZMDefTyp+';'+
            sZLEAlias_PolaZMDefMnemonikiID+';'+
            sZLEAlias_MnemonikiMnemonik+';'+
            sZLEAlias_MnemonikiTabela+';'+
            sZLEAlias_PolaZMDefDomenyID+';'+
            sZLEAlias_DomenyDomena+';'+
            sZLEAlias_PolaZMDefDlugosc+';'+
            sZLEAlias_PolaZMDefTypDanych+';'+
            sZLEAlias_PolaZMDefZnaki+';'+
            sZLEAlias_PolaZMDefFormat;

  sWhere := '(@'+sZLEAlias_PolaZMWskZLETypZlecID+'='+IntToStr(iZLETypZlec_ID)+')AND'+
            '(@'+sZLEAlias_PolaZMDefTyp+'<>'+QuotedStr(cZLEPolaUzState_IDOfUnUsed)+')';
  sWhere := sWhere + 'AND (@'+sZLEAlias_PolaZMWsk_Pozycja+'='+QuotedStr(sUNICONST_ALTERNATYWA_TAK) + ')';
  //dodanie order by
  sWhere := sWhere + ' order by @'+sZLEAlias_PolaZMWskID;
  oQuery := ZLEDM.ZLEOdpytajODane( sZLEPolaZMDef, sFrom, sWhere, False );

  if oQuery <> nil then begin
     try
        oQuery.First;
        while not oQuery.Eof do begin
           with TZleZlecenieDataModule(DataModule).aZleZleceniePoleZmDataSet do
           begin
              Append;
              FieldByName( sZLEPolaZM_ID ).AsInteger := UniqueKey[sZLEPolaZM];
              FieldByName( sZLEZLECENIE_ID ).Asinteger  := DMAQFbN(sZLEZLECENIE_ID).AsInteger;
              FieldByName( sZLEZLECENIEPOZ_ID ).AsInteger := DataModule.ContainedDataModules[PozycjeZleceniaFormIndex].ActiveQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger;
              FieldByName( sZLEPolaZMDef_ID ).AsInteger := oQuery.FieldByName(sZLEPolaZMDef_ID).AsInteger;
             // SetTechnicalFieldsOnInsert();
             // UpdateModifiedRecordFlagsForAddedRecord();
              FieldByName( sZLEPolaZMDef_Nazwa ).AsString := oQuery.FieldByName(sZLEPolaZMDef_Nazwa).AsString;
              FieldByName( sZLEPolaZMDef_Typ ).AsString := oQuery.FieldByName(sZLEPolaZMDef_Typ).AsString;

              if oQuery.FieldByName(sFKMNEMONIKI_ID).IsNull then
                   FieldByName( sFKMNEMONIKI_ID ).Value := oQuery.FieldByName(sFKMNEMONIKI_ID).Value
              else FieldByName( sFKMNEMONIKI_ID ).AsInteger := oQuery.FieldByName(sFKMNEMONIKI_ID).AsInteger;

              FieldByName( sFKMNEMONIKI_MNEMONIK ).AsString := oQuery.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString;
              FieldByName( sFKMNEMONIKI_TABELA ).AsString := oQuery.FieldByName(sFKMNEMONIKI_TABELA).AsString;

              if oQuery.FieldByName(sUNICONSTDEF_ID).IsNull then
                   FieldByName( sUNICONSTDEF_ID ).Value := oQuery.FieldByName(sUNICONSTDEF_ID).Value
              else FieldByName( sUNICONSTDEF_ID ).AsInteger := oQuery.FieldByName(sUNICONSTDEF_ID).AsInteger;

              FieldByName( sUNICONSTDEF_DOMENA ).AsString := oQuery.FieldByName(sUNICONSTDEF_DOMENA).AsString;
              FieldByName( sZLEPolaZMDef_Dlug ).AsInteger := oQuery.FieldByName(sZLEPolaZMDef_Dlug).AsInteger;
              FieldByName( sZLEPolaZMDef_TypDanych ).AsString := oQuery.FieldByName(sZLEPolaZMDef_TypDanych).AsString;
              FieldByName( sZLEPolaZMDef_Znaki ).AsString := oQuery.FieldByName(sZLEPolaZMDef_Znaki).AsString;
              FieldByName( sZLEPolaZMDef_Format ).AsFloat := oQuery.FieldByName(sZLEPolaZMDef_Format).AsFloat;
              Post;
           end;
           oQuery.Next;
        end;
        oQuery.Close;
     finally
        FreeAndNil(oQuery);
     end;
  end;
end;

procedure TZLEZlecenieDBDetailForm.pReReadOthersPoz;
var
  oQuery: TUNIQuery;
  sSQL:   String;
  iZLEZlecenie_ID: Integer;
begin
  while not TZLEZlecenieDataModule(DataModule).aZleZleceniePoleZmDataSet.IsEmpty do
    TZLEZlecenieDataModule(DataModule).aZLEZleceniePoleZmDataSet.Delete;

  TUNIDBGridForm(FContainedForms.Objects[FPozycjeZleceniaFormIndex]).DataModule.ActiveQuery.AfterScroll := Nil;

  iZLEZlecenie_ID := DMAQFbN(sZLEZLECENIE_ID).AsInteger;

  if iZLEZlecenie_ID <=0 then Exit;

  if oQuery <> nil then
      FreeAndNil(oQuery);

{SELECT ZMNEW.ZLEPOLAZM_ID, ZMNEW.ZLEZLECENIE_ID, ZMNEW.ZLEZLECENIEPOZ_ID,
                 DEF.ZLEPOLAZMDEF_ID, ZMNEW.FKUZ_ID, ZMNEW.ZLEPOLAZM_DOMENAWART_ID,
                 ZMNEW.ZLEPOLAZM_WART, DEF.ZLEPOLAZMDEF_NAZWA, DEF.ZLEPOLAZMDEF_TYP,
                 DEF.FKMNEMONIKI_ID, MNEM.FKMNEMONIKI_MNEMONIK, MNEM.FKMNEMONIKI_TABELA,
                 DEF.UNICONSTDEF_ID, DOMENY.UNICONSTDEF_DOMENA, DEF.ZLEPOLAZMDEF_DLUG,
                 DEF.ZLEPOLAZMDEF_TYPDANYCH, DEF.ZLEPOLAZMDEF_ZNAKI, DEF.ZLEPOLAZMDEF_FORMAT
          FROM  ZLEPOLAZMDEF DEF, ZLEPOLAZMWSK WSK, ZLETYPZLEC TYP, FKMNEMONIKI MNEM, UNICONSTDEF DOMENY,
                (SELECT * FROM ZLEPOLAZM WHERE ZLEZLECENIE_ID = 1444 AND ZLEZLECENIEPOZ_ID IS NOT NULL) ZMNEW
          WHERE DEF.ZLEPOLAZMDEF_ID = WSK.ZLEPOLAZMDEF_ID AND
                WSK.ZLEPOLAZMDEF_ID = ZMNEW.ZLEPOLAZMDEF_ID (+) AND
                WSK.ZLETYPZLEC_ID IN (SELECT ZLETYPZLEC_ID FROM ZLEZLECENIE WHERE ZLEZLECENIE_ID = 1444) AND
                DEF.UNICONSTDEF_ID = DOMENY.UNICONSTDEF_ID (+) AND
                DEF.FKMNEMONIKI_ID = MNEM.FKMNEMONIKI_ID (+) AND
                TYP.ZLETYPZLEC_ID= WSK.ZLETYPZLEC_ID AND
                (DEF.ZLEPOLAZMDEF_TYP <>'0') AND
                (WSK.ZLEPOLAZMWSK_POZYCJA='T')}


  sSQL := 'SELECT ZMNEW.' + sZLEPOLAZM_ID + ', ZMNEW.' + sZLEZLECENIE_ID + ', ZMNEW.' + sZLEZLECENIEPOZ_ID + ', ' +
                 'DEF.' + sZLEPOLAZMDEF_ID + ', ZMNEW.' + sFKUZ_ID + ', ZMNEW.' + sZLEPOLAZM_DOMENAWART_ID + ', ' +
                 'ZMNEW.' + sZLEPOLAZM_WART + ', DEF.' + sZLEPOLAZMDEF_NAZWA + ', DEF.' + sZLEPOLAZMDEF_TYP + ', ' +
                 'DEF.' + sFKMNEMONIKI_ID + ', MNEM.' + sFKMNEMONIKI_MNEMONIK + ', MNEM.' + sFKMNEMONIKI_TABELA + ', ' +
                 'DEF.' + sUNICONSTDEF_ID + ', DOMENY.' + sUNICONSTDEF_DOMENA + ', DEF.' + sZLEPOLAZMDEF_DLUG + ', ' +
                 'DEF.' + sZLEPOLAZMDEF_TYPDANYCH + ', DEF.' + sZLEPOLAZMDEF_ZNAKI + ', DEF.' + sZLEPOLAZMDEF_FORMAT + ' ' +
          'FROM  %s DEF, %s WSK, %s TYP, %s MNEM, %s DOMENY, ' +
                '(SELECT * FROM  %s WHERE ' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZLEZlecenie_ID) + ' AND ' +
                                             sZLEZLECENIEPOZ_ID + ' IS NOT NULL' + ') ZMNEW ' +
          'WHERE DEF.' + sZLEPOLAZMDEF_ID + ' = WSK.' + sZLEPOLAZMDEF_ID + ' AND ' +
                'DEF.' + sZLEPOLAZMDEF_ID + ' = ZMNEW.' + sZLEPOLAZMDEF_ID + ' (+) AND ' +
                  {20080122 - po ustaleniach z Tomkiem J. zapytanie zastpione konkretnym id typu zlecenia}
                'WSK.' + sZLETYPZLEC_ID + ' = ' + DMAQFbN(sZLETYPZLEC_ID).AsString + ' and ' +
                'DEF.' + sUNICONSTDEF_ID + ' = DOMENY.' + sUNICONSTDEF_ID + ' (+) AND ' +
                'DEF.' + sFKMNEMONIKI_ID + ' = MNEM.' + sFKMNEMONIKI_ID + ' (+) AND ' +
                'TYP.' + sZLETYPZLEC_ID + ' = WSK.' + sZLETYPZLEC_ID + ' AND ' +
                '(DEF.' + sZLEPOLAZMDEF_TYP + '<>' + QuotedStr(cZLEPolaUzState_IDOfUnUsed) + ') AND ' +
                '(WSK.' + sZLEPOLAZMWSK_POZYCJA + ' = ' + QuotedStr(sUNICONST_ALTERNATYWA_TAK) + ')';


  oQuery := SQLManager.CreateQuery(sSQL, [sZLEPOLAZMDEF, sZLEPOLAZMWSK, sZLETYPZLEC, sFKMNEMONIKI,
                                          sUNICONSTDEF, sZLEPOLAZM, sZLEZLECENIE]);

  {
  sSQL := 'SELECT ZM.' + sZLEPOLAZM_ID + ', ZM.' + sZLEZLECENIE_ID + ', ZM.' + sZLEZLECENIEPOZ_ID + ', ' +
                 'ZM.' + sZLEPOLAZMDEF_ID + ', ZM.' + sFKUZ_ID + ', ZM.' + sZLEPOLAZM_DOMENAWART_ID + ', ' +
                 'ZM.' + sZLEPOLAZM_WART + ', ZMDEF.' + sZLEPOLAZMDEF_NAZWA + ', ZMDEF.' + sZLEPOLAZMDEF_TYP + ', ' +
                 'ZMDEF.' + sFKMNEMONIKI_ID + ', MNEM.' + sFKMNEMONIKI_MNEMONIK + ', MNEM.' + sFKMNEMONIKI_TABELA + ', '+
                 'ZMDEF.' + sUNICONSTDEF_ID + ', DOMENY.' + sUNICONSTDEF_DOMENA + ', ZMDEF.' + sZLEPOLAZMDEF_DLUG + ', '+
                 'ZMDEF.' + sZLEPOLAZMDEF_TYPDANYCH + ', ZMDEF.' + sZLEPOLAZMDEF_ZNAKI + ', ' +
                 'ZMDEF.' + sZLEPOLAZMDEF_FORMAT + ' ' +
          'FROM %s ZMDEF, %s MNEM, %s DOMENY, %s ZMWSK, %s ZM, %s ZLETYP, %s ZLEZLEC ' +
          'WHERE ZLEZLEC.' + sZLEZLECENIE_ID + ' = ZM.' + sZLEZLECENIE_ID + ' AND ' +
                'ZMDEF.' + sFKMNEMONIKI_ID + ' = MNEM.' + sFKMNEMONIKI_ID + ' (+) AND ' +
                'ZM.' + sZLEPOLAZMDEF_ID + ' = ZMDEF.' + sZLEPOLAZMDEF_ID + ' AND ' +
                'ZLEZLEC.' + sZLETYPZLEC_ID + ' = ZLETYP.' + sZLETYPZLEC_ID + ' AND ' +
                'ZMDEF.' + sUNICONSTDEF_ID + ' = DOMENY.' + sUNICONSTDEF_ID + ' (+) AND ' +
                'ZMWSK.' + sZLEPOLAZMDEF_ID + ' = ZMDEF.' + sZLEPOLAZMDEF_ID + ' AND ' +
                '(ZMDEF.' + sZLEPOLAZMDEF_TYP + '<>' + QuotedStr(cZLEPolaUzState_IDOfUnUsed) + ') AND ' +
                '(ZMWSK.' + sZLEPOLAZMWSK_POZYCJA + ' = ' + QuotedStr(sUNICONST_ALTERNATYWA_TAK) + ') AND ' +
                'ZM.' + sZLEZLECENIE_ID + ' = ' + IntToStr(iZLEZlecenie_ID) + ' ' +
          'ORDER BY ZMWSK.' + sZLEPOLAZMWSK_ID;

  oQuery := SQLManager.CreateQuery(sSQL, [sZLEPOLAZMDEF, sFKMNEMONIKI, sUNICONSTDEF, sZLEPOLAZMWSK,
                                          sZLEPOLAZM, sZLETYPZLEC, sZLEZLECENIE]);
  }

  if oQuery <> nil then begin
     try
        oQuery.Open;
        oQuery.First;

        while not oQuery.Eof do begin
           with TZleZlecenieDataModule(DataModule).aZleZleceniePoleZmDataSet do begin
              if TZleZlecenieDataModule(DataModule).aZleZleceniePoleZmDataSet.Locate(sZLEZLECENIEPOZ_ID + ';' + sZLEPolaZMDef_ID,
                                                VarArrayOf([oQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger,
                                                            oQuery.FieldByName(sZLEPolaZMDef_ID).AsInteger]), []) then begin
                 {Edycja rekordu}
                 Edit; {??}
              end else begin
                 Append;
                 {Tabela POLAZM}
                 if oQuery.FieldByName(sZLEPolaZM_ID).IsNull then begin
                    FieldByName(sZLEPolaZM_ID).AsInteger := UniqueKey[sZLEPolaZM];
                    FieldByName(sZLEZLECENIE_ID).AsInteger  := iZLEZlecenie_ID;
                    FieldByName(sZLEZLECENIEPOZ_ID).Value := TUNIDBGridForm(FContainedForms.Objects[FPozycjeZleceniaFormIndex]).DataModule.ActiveQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger;
                    FieldByName(sZLEPolaZMDef_ID).Value := oQuery.FieldByName(sZLEPolaZMDef_ID).Value;
                    {FieldByName(sFKUZ_ID).Clear;
                    FieldByName(sZLEPOLAZM_DOMENAWART_ID).Clear;
                    FieldByName(sZLEPOLAZM_WART).Clear;}

                    // SetTechnicalFieldsOnInsert();
                    // UpdateModifiedRecordFlagsForAddedRecord();
                    {Inne Tabele}
                    FieldByName( sZLEPolaZMDef_Nazwa ).AsString := oQuery.FieldByName(sZLEPolaZMDef_Nazwa).AsString;
                    FieldByName( sZLEPolaZMDef_Typ ).AsString := oQuery.FieldByName(sZLEPolaZMDef_Typ).AsString;
                    FieldByName( sFKMNEMONIKI_ID ).Value := oQuery.FieldByName(sFKMNEMONIKI_ID).Value;
                    FieldByName( sFKMNEMONIKI_MNEMONIK ).AsString := oQuery.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString;
                    FieldByName( sFKMNEMONIKI_TABELA ).AsString := oQuery.FieldByName(sFKMNEMONIKI_TABELA).AsString;
                    FieldByName( sUNICONSTDEF_ID ).Value := oQuery.FieldByName(sUNICONSTDEF_ID).Value;
                    FieldByName( sUNICONSTDEF_DOMENA ).AsString := oQuery.FieldByName(sUNICONSTDEF_DOMENA).AsString;
                    FieldByName( sZLEPolaZMDef_Dlug ).AsInteger := oQuery.FieldByName(sZLEPolaZMDef_Dlug).AsInteger;
                    FieldByName( sZLEPolaZMDef_TypDanych ).AsString := oQuery.FieldByName(sZLEPolaZMDef_TypDanych).AsString;
                    FieldByName( sZLEPolaZMDef_Znaki ).AsString := oQuery.FieldByName(sZLEPolaZMDef_Znaki).AsString;
                    FieldByName( sZLEPolaZMDef_Format ).AsFloat := oQuery.FieldByName(sZLEPolaZMDef_Format).AsFloat;
                 end else begin
                    FieldByName(sZLEPolaZM_ID).AsInteger := oQuery.FieldByName(sZLEPolaZM_ID).AsInteger;
                    FieldByName(sZLEZLECENIE_ID).Value  := oQuery.FieldByName(sZLEZlecenie_ID).Value;
                    FieldByName(sZLEZLECENIEPOZ_ID).Value := oQuery.FieldByName(sZLEZleceniePoz_ID).Value;
                    FieldByName(sZLEPolaZMDef_ID).Value := oQuery.FieldByName(sZLEPolaZMDef_ID).Value;
                    FieldByName(sFKUZ_ID).Value := oQuery.FieldByName(sFKUZ_ID).Value;
                    FieldByName(sZLEPOLAZM_DOMENAWART_ID).Value := oQuery.FieldByName(sZLEPOLAZM_DOMENAWART_ID).Value;
                    FieldByName(sZLEPOLAZM_WART).Value := oQuery.FieldByName(sZLEPOLAZM_WART).Value;


                    FieldByName('ORYG_' + sFKUZ_ID).Value := oQuery.FieldByName(sFKUZ_ID).Value;
                    FieldByName('ORYG_' + sZLEPOLAZM_DOMENAWART_ID).Value := oQuery.FieldByName(sZLEPOLAZM_DOMENAWART_ID).Value;
                    FieldByName('ORYG_' + sZLEPOLAZM_WART).Value := oQuery.FieldByName(sZLEPOLAZM_WART).Value;

                    // SetTechnicalFieldsOnInsert();
                    // UpdateModifiedRecordFlagsForAddedRecord();
                    {Inne Tabele}
                    FieldByName( sZLEPolaZMDef_Nazwa ).AsString := oQuery.FieldByName(sZLEPolaZMDef_Nazwa).AsString;
                    FieldByName( sZLEPolaZMDef_Typ ).AsString := oQuery.FieldByName(sZLEPolaZMDef_Typ).AsString;
                    FieldByName( sFKMNEMONIKI_ID ).Value := oQuery.FieldByName(sFKMNEMONIKI_ID).Value;
                    FieldByName( sFKMNEMONIKI_MNEMONIK ).AsString := oQuery.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString;
                    FieldByName( sFKMNEMONIKI_TABELA ).AsString := oQuery.FieldByName(sFKMNEMONIKI_TABELA).AsString;
                    FieldByName( sUNICONSTDEF_ID ).Value := oQuery.FieldByName(sUNICONSTDEF_ID).Value;
                    FieldByName( sUNICONSTDEF_DOMENA ).AsString := oQuery.FieldByName(sUNICONSTDEF_DOMENA).AsString;
                    FieldByName( sZLEPolaZMDef_Dlug ).AsInteger := oQuery.FieldByName(sZLEPolaZMDef_Dlug).AsInteger;
                    FieldByName( sZLEPolaZMDef_TypDanych ).AsString := oQuery.FieldByName(sZLEPolaZMDef_TypDanych).AsString;
                    FieldByName( sZLEPolaZMDef_Znaki ).AsString := oQuery.FieldByName(sZLEPolaZMDef_Znaki).AsString;
                    FieldByName( sZLEPolaZMDef_Format ).AsFloat := oQuery.FieldByName(sZLEPolaZMDef_Format).AsFloat;
                 end;
              end;
              Post;
           end;
           oQuery.Next;
        end;

        oQuery.Close;

     finally
        FreeAndNil(oQuery);
     end;
  end;
end;
*******************POLA UZ***************************)

procedure TZLEZlecenieDBDetailForm.AddContainedForms;
var
  oParamsPozycje, oParamsZasoby{, oParamsPolaUz}: TKeyValues;
  omOpenMode:   TOpenMode;
  omOpenMode2:  TOpenMode;  // dla ZAM i LWP
  omOpenMode3:  TOpenMode;  // dla zasobw
begin
  //oParamsPozycje := nil;
  //oParamsZasoby := nil;
  {oParamsPolaUz := nil;}

  omOpenMode := omList or omContained or omVirtual;
  if OpenMode = omView then
    omOpenMode := omOpenMode or omReadOnly;

  if(OpenMode = omDelete) then
    omOpenMode2 := omOpenMode or omReadOnly
  else
    omOpenMode2 := omOpenMode;

  ZapotrzebowaniePierwPokazButton.Visible   := SecurityManager.SM_UserCanDo(sZAO_ZAPOTRZEBOWANIA_KARTOTEKA_POKAZ);
  ZapotrzebowaniePierwDopiszButton.Visible  := SecurityManager.SM_UserCanDo(sZAO_ZAPOTRZEBOWANIA_KARTOTEKA_DOPISZ) and (OpenMode in [omNew, omEdit]);
  ZapotrzebowaniePierwUsunButton.Visible    := SecurityManager.SM_UserCanDo(sZAO_ZAPOTRZEBOWANIA_KARTOTEKA_USUN) and (OpenMode in [omNew, omEdit]);
  ZapotrzebowanieWtornePokazButton.Visible  := SecurityManager.SM_UserCanDo(sZAO_ZAPOTRZEBOWANIA_KARTOTEKA_POKAZ);
  ZapotrzebowanieWtorneDopiszButton.Visible := SecurityManager.SM_UserCanDo(sZAO_ZAPOTRZEBOWANIA_KARTOTEKA_DOPISZ) and (OpenMode in [omNew, omEdit]);
  ZapotrzebowanieWtorneUsunButton.Visible   := SecurityManager.SM_UserCanDo(sZAO_ZAPOTRZEBOWANIA_KARTOTEKA_USUN) and (OpenMode in [omNew, omEdit]);
  ZamowieniePokazButton.Visible             := SecurityManager.SM_UserCanDo(sZAM_ZAMOWIENIA_KARTOTEKA_POKAZ);
  ZamowienieDopiszButton.Visible            := SecurityManager.SM_UserCanDo(sZAM_ZAMOWIENIA_KARTOTEKA_DOPISZ) and (OpenMode in [omNew, omEdit]);
  ZamowienieUsunButton.Visible              := SecurityManager.SM_UserCanDo(sZAM_ZAMOWIENIA_KARTOTEKA_USUN) and (OpenMode in [omNew, omEdit]);

  ZapytaniePokazButton.Visible              := SecurityManager.SM_UserCanDo(sZAM_ZAPYTANIA_KARTOTEKA_POKAZ);
  ZapytanieDopiszButton.Visible             := SecurityManager.SM_UserCanDo(sZAM_ZAPYTANIA_KARTOTEKA_DOPISZ) and (OpenMode in [omNew, omEdit]);
  ZapytanieUsunButton.Visible               := SecurityManager.SM_UserCanDo(sZAM_ZAPYTANIA_KARTOTEKA_USUN) and (OpenMode in [omNew, omEdit]);
  if(OpenMode in [omView, omDelete]) then begin
    MatDopiszButton.Enabled                   := false;
    MatZmienButton.Enabled                    := false;
    MatUsunButton.Enabled                     := false;
    MatKopiujButton.Enabled                   := false;
    MatZamiennikButton.Enabled                := false;
    MatOryginalButton.Enabled                 := false;
  end else if(not DataManagers.Available(sLWPModulID) or (not m_bProdukcyjne)) then begin
    MatKopiujButton.Enabled                   := false;
    MatZamiennikButton.Enabled                := false;
    MatOryginalButton.Enabled                 := false;
  end;

  {Musi by przed zakdk z pozycjami}
  UtworzPolaUZPozNew();

  with FContainedForms do begin
    //pozycje zlecenia
    oParamsPozycje := TKeyValues.CreateEmpty();
    with oParamsPozycje do begin
      Add(cFORM_CAPTION+'='+'Skadniki kontroli wartociowej');
      Add(sZLEZLECENIE_ID+'='+DMAQFbN(sZLEZLECENIE_ID).AsString);
      Add(sBOKSPRAWA_ID+'='+Self.Parameters.Values[sBOKSPRAWA_ID]);
      Add(sUNIMODULZSI_ID+'='+Self.Parameters.Values[sUNIMODULZSI_ID]);
    end;

    {Formy osadzone zlecenia
    cFormPozycjeZlecenia   = 'PozycjeZlecenia';
    cFormZasobyPowiazane   = 'ZasobyPowiazane';
    cFormZapotrzebPierw    = 'ZapotrzebPierw';
    cFormZapotrzebWtorne   = 'ZapotrzebWtorne';
    cFormZamowienia        = 'Zamowienia';
    cFormZapytania         = 'Zapytania';
    cFormMaterialy         = 'Materiay';}

    FPozycjeZleceniaFormIndex := FContainedForms.Count;
    m_oPozycjaGrid  := FormManager.OpenDBGrid(
      Self,
      cKlasaPozycje+cSuffixKlasyDBGrid,
      omOpenMode,
      oParamsPozycje
    );
    AddObject(cFormPozycjeZlecenia, m_oPozycjaGrid );
    m_evntOldPozycjeAfterScroll := m_oPozycjaGrid.DataModule.ActiveQuery.AfterScroll;

    //zasoby powizane
    if(m_bZlecenieNaPlanie) then
      omOpenMode3 := omOpenMode or omReadOnly
    else
      omOpenMode3 := omOpenMode;
    oParamsZasoby := TKeyValues.CreateEmpty();
    FZasobyFormIndex := FContainedForms.Count;
    with oParamsZasoby do begin
      Add(sZLEZLECENIE_ID+'='+DMAQFbN(sZLEZLECENIE_ID).AsString);
    end;
    m_oZasobyGrid := FormManager.OpenDBGrid( Self,
       cKlasaZlecenieZasob+cSuffixKlasyDBGrid,
       omOpenMode3,
       oParamsZasoby
    );
    AddObject(cFormZasobyPowiazane, m_oZasobyGrid);

    (*******************POLA UZ***************************
    // Pola uzytkownika
    oParamsPolaUz := TKeyValues.CreateEmpty();
    FPolaUzFormIndex := FContainedForms.Count;
    with oParamsPolaUz do begin
      Add(sZLEZLECENIE_ID+'='+DMAQFbN(sZLEZLECENIE_ID).AsString);
    end;
    AddObject( 'PolaUz',
               FormManager.OpenDBGrid(self,
                                      TZLEPoleZmGridForm.ClassName,
                                      omOpenMode,
                                      oParamsPolaUz)
              );
    *******************POLA UZ***************************)

    if(DataManagers.Available(sZAOModulID)) then begin
      DataManagers.Load(sZAOModulID);
      FZapotrzPierwFormIndex := Count;
      m_oZapotrzPierwGrid := FormManager.OpenDBGrid(
        self,
        'TZAOZapotrzebowaniePozZlecenieDBGridForm',
        omOpenMode2 or omMultiSelect,
        TKeyValues.CreateAs(
          [
            sZAOZAPOTRZPOZZLEC_KIERUNEK+ '=' + IntToStr(cZAPOTRZ_KIERUNEK_ZAPOTRZZLEC),
            sZLEZLECENIE_ID         + '=' + DMAQFbN(sZLEZLECENIE_ID).AsString
          ]
        )
      );
      AddObject(cFormZapotrzebPierw, m_oZapotrzPierwGrid);

      FZapotrzWtorneFormIndex := Count;
      m_oZapotrzWtorneGrid:= FormManager.OpenDBGrid(
        self,
        'TZAOZapotrzebowaniePozZlecenieDBGridForm',
        omOpenMode2 or omMultiSelect,
        TKeyValues.CreateAs(
          [
            sZAOZAPOTRZPOZZLEC_KIERUNEK+ '=' + IntToStr(cZAPOTRZ_KIERUNEK_ZLECZAPOTRZ),
            sZLEZLECENIE_ID         + '=' + DMAQFbN(sZLEZLECENIE_ID).AsString
          ]
        )
      );
      AddObject(cFormZapotrzebWtorne, m_oZapotrzWtorneGrid);
    end else begin  // if(DataManagers.Available(sZAOModulID))
      FZapotrzPierwFormIndex := -1;
      FZapotrzWtorneFormIndex := -1;
    end;
    if(DataManagers.Available(sZAMModulID)) then begin
      DataManagers.Load(sZAMModulID);
      FZamowienieFormIndex := Count;
      m_oZamowienieGrid := FormManager.OpenDBGrid(
        self,
        'TZAMZamowieniePozZlecenieDBGridForm',
        omOpenMode2,
        TKeyValues.CreateAs(
          [
            sZLEZLECENIE_ID         + '=' + DMAQFbN(sZLEZLECENIE_ID).AsString
          ]
        )
      );
      AddObject(cFormZamowienia, m_oZamowienieGrid);

      FZapytanieFormIndex := Count;
      m_oZapytanieGrid  := FormManager.OpenDBGrid(
        self,
        'TZAMZapytaniePozZlecenieDBGridForm',
        omOpenMode2,
        TKeyValues.CreateAs(
          [
            sZLEZLECENIE_ID         + '=' + DMAQFbN(sZLEZLECENIE_ID).AsString
          ]
        )
      );
      AddObject(cFormZapytania, m_oZapytanieGrid);
    end else begin
      FZamowienieFormIndex  := -1;
      FZapytanieFormIndex   := -1;
    end;
    if(DataManagers.Available(sMAGModulID) and DataManagers.Available(sASOModulID)) then begin
      FMaterialFormIndex := Count;
      m_oMaterialGrid := FormManager.OpenDBGrid(
        self,
        'TZLEZlecenieMaterialDBGridForm',
        omOpenMode2,
        TKeyValues.CreateAs(
          [
            sZLEZLECENIE_ID         + '=' + DMAQFbN(sZLEZLECENIE_ID).AsString
          ]
        )
      );
      AddObject(cFormMaterialy, m_oMaterialGrid);
      m_oOrygMaterialDataChange := m_oMaterialGrid.DataSource.OnDataChange;
      m_oMaterialGrid.DataSource.OnDataChange := MaterialGridDataChange;
    end else
      FMaterialFormIndex  := -1;
  end;

  WyswietlPolaUzytkownikaNew();
end;

function TZLEZlecenieDBDetailForm.CreateDataModule(
  const AOpenMode: TOpenMode): TUNIDataModule;
begin
  result := TZLEZlecenieDataModule.CreateOpen( Self, InheritedMasterKeyValues, AOpenMode );
end;

destructor TZLEZlecenieDBDetailForm.Destroy;
begin
  if(m_oObrazy <> nil)           then FreeAndNil(m_oObrazy);
  if(m_oPolaUZGridy <> nil)      then FreeAndNil(m_oPolaUZGridy);
  if(m_oZakladkiPozGridy <> nil) then FreeAndNil(m_oZakladkiPozGridy);
  if(m_oZakladkiPozId <> nil)    then FreeAndNil(m_oZakladkiPozId);

(**// pocztek sekcji kopiowania pl uz
  m_oPozycjeId.Free();
// koniec sekcji kopiowania pl uz**)
  inherited;
end;

procedure TZLEZlecenieDBDetailForm.GetPositionAndParentForContainedForm(
  const nr: integer; var APosition: TRect; var AParent: TWinControl;
  var AAlign: TAlign);
begin
  if(frmPolaUz in m_iTworzonaFormatka) then begin
    if(m_iPolaUzNr > 0) then begin
      AParent   := (m_oZakladkiParents.Objects[m_iPolaUzNr - 1] as TWinControl);
      APosition := AParent.ClientRect;;
      AAlign    := alClient;
    end;
  end else
  if(frmPolaUzPoz in m_iTworzonaFormatka) then begin
      // najpierw tworzone s pola uytkownika dla pozycji
      // musz by utworzone przed pozycjami aby mona je byo przekaza do grida
      // pozycji
    AParent   := GridyPozycjiPanel;
    APosition := GridyPozycjiPanel.ClientRect;
    AAlign    := alClient;
  end
  {else if(frmObrazy in m_iTworzonaFormatka) then begin
      // wszystkie dodatkowe gridy osadzone s na jednym panelu
    AParent   := DodatkoweGridyPanel;
    APosition := DodatkoweGridyPanel.ClientRect;
    AAlign    := alClient;
  end}
  else begin
    if nr = FPozycjeZleceniaFormIndex then begin  //pozycje zlecenia
      AParent := PozycjeZleceniaPanel;
      APosition := PozycjeZleceniaPanel.ClientRect;
      AAlign := alClient;
    end else if nr = FZasobyFormIndex then begin
      AParent := ZasobyPanel;
      APosition := ZasobyPanel.ClientRect;
      AAlign := alClient;
  (*******************POLA UZ***************************
    end else if nr = FPolaUzFormIndex then begin
      AParent := PolaUzPanel;
      APosition := PolaUzPanel.ClientRect;
      AAlign := alClient;
  *******************POLA UZ***************************)
    end else if nr = FZapotrzPierwFormIndex then begin
      AParent := ZapotrzebowaniePierwPanel;
      APosition := ZapotrzebowaniePierwPanel.ClientRect;
      AAlign := alClient;
    end else if nr = FZapotrzWtorneFormIndex then begin
      AParent := ZapotrzebowanieWtornePanel;
      APosition := ZapotrzebowanieWtornePanel.ClientRect;
      AAlign := alClient;
    end else if nr = FZamowienieFormIndex then begin
      AParent := ZamowieniePanel;
      APosition := ZamowieniePanel.ClientRect;
      AAlign := alClient;
    end else if nr = FZapytanieFormIndex then begin
      AParent   := ZapytaniePanel;
      APosition := ZapytaniePanel.ClientRect;
      AAlign    := alClient;
    end else if(nr = FMaterialFormIndex) then begin
      AParent   := MaterialPanel;
      APosition := MaterialPanel.ClientRect;
      AAlign    := alClient;
    end;
  end;
end;

(*******************POLA UZ***************************
procedure TZLEZlecenieDBDetailForm.OdswiezPolaUz;
begin
    if (PolaUzFormIndex > -1) and (OpenMode in [omNew, omEdit]) then begin
      TZLEPoleZmGridForm(ContainedForms[PolaUzFormIndex]).DodajPolaZM(DMAQFbN(sZLETYPZLEC_ID).AsInteger);
    end;
    TZLEPoleZmGridForm(ContainedForms[PolaUzFormIndex]).OwnGrid.Init();
end;
*******************POLA UZ***************************)

procedure TZLEZlecenieDBDetailForm.GetParametersForForm(
  a_oForm:              TUNIForm;
  a_oParameters:        TKeyValues
);
begin
  if ((m_oZakladkiPozGridy <> nil) and (a_oForm.ClassName = 'TZLEPozycjeDBGridForm')) then  begin
    a_oParameters.Values[sZLEZLECENIEPOZ_ID] := IntToStr(TUNIDBGridForm(m_oPozycjaGrid).DataModule.ActiveQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger);
    //a_oParameters.Values[sZLEZLECENIEPOZ_ID] := IntToStr(TUNIDBGridForm(FContainedForms.Objects[FPozycjeZleceniaFormIndex]).DataModule.ActiveQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger);
    a_oParameters.AddObject(sZLEParam_PolaUZGrid, m_oZakladkiPozGridy);
  end;

  if((LowerCase(a_oForm.ClassName) = 'tzaozapotrzebowaniepozzleceniedbgridform') or
    (LowerCase(a_oForm.ClassName) = 'tzamzamowieniepozzleceniedbgridform') or
    (LowerCase(a_oForm.ClassName) = 'tzamzapytaniepozzleceniedbgridform') or
    (LowerCase(a_oForm.ClassName) = 'tzlezleceniematerialdbgridform')) then
    a_oParameters.Values[sZLEZLECENIE_ID] := DMAQFbN(sZLEZLECENIE_ID).AsString
  else
    inherited;
end;

procedure TZLEZlecenieDBDetailForm.UstawDanePozycjiZapotrzebowania(
  const ac_iAsortId:      integer;
  const ac_aZapotrzPozId: array of integer;
  const ac_dIlosc:        double;
  const ac_iOdpowiedzialny: Integer;
  const ac_sAsortSymbol:  string  = '';
  const ac_sAsortNazwa:   string  = ''
);

  procedure DopiszPozycjeZapotrzebowaniaPierwotnego(
    const ac_sZapotrzPozId: string;
    const ac_oStatusy:      TConstStringList
  );
  var
    oQuery:     TUNIQuery;
    bOldFilter: boolean;
    i:          integer;
  begin
    oQuery  := ZAODM.ZAOOdpytajODane(sZAOZAPOTRZPOZ,
        // pola pozycji
      sZAOAlias_ZapotrzebowaniePoz_Id   + ';' + sZAOAlias_ZapotrzebowaniePoz_Ilosc  + ';' +
      sZAOAlias_ZapotrzebowaniePoz_Data + ';' +
      sZAOAlias_ASOAsort_Id             + ';' + sZAOAlias_ASOAsort_Symbol           + ';' +
      sZAOAlias_ASOAsort_Nazwa          + ';' + sZAOAlias_ASOAsort_Indeks           + ';' +
      sZAOAlias_ASOAsort_RodzRozch      + ';' + sZAOAlias_KDOsoba_Id                + ';' +
      sZAOAlias_KDOsoba_Symbol          + ';' + sZAOAlias_KDOsoba_Imie              + ';' +
      sZAOAlias_KDOsoba_Nazwisko        + ';' +
        // pola zapotrzebowania
      sZAOAlias_Zapotrzebowanie_Id      + ';' + sZAOAlias_Zapotrzebowanie_Symbol    + ';' +
      sZAOAlias_Zapotrzebowanie_Data    + ';' + sZAOAlias_Zapotrzebowanie_Status    + ';' +
      sZAOAlias_Zapotrzebowanie_OpisSta   + ';' +
      sZAOAlias_ZapotrzebowanieTyp_Id   + ';' + sZAOAlias_ZapotrzebowanieTyp_Symbol + ';' +
      sZAOAlias_ZapotrzebowanieTyp_Nazwa+ ';' +
      '#@' + sZAOAlias_KDOdpow_Symbol + ' as ' + sZAOAlias_KDOdpow_Symbol + ';' +
      '#@' + sZAOAlias_KDOdpow_Imie + ' as ' + sZAOAlias_KDOdpow_Imie + ';' +
      '#@' + sZAOAlias_KDOdpow_Nazwisko + ' as ' + sZAOAlias_KDOdpow_Nazwisko + ';' +
      sZAOAlias_ZapotrzebowaniePoz_Opis + ';' + sZAOAlias_Zapotrzebowanie_Opis,
      '@' + sZAOAlias_ZapotrzebowaniePoz_Id + ' in(' + ac_sZapotrzPozId + ')',
      false
    );
    if(oQuery <> nil) then begin
      bOldFilter  := m_oZapotrzPierwGrid.DataModule.ActiveQuery.Filtered;
      m_oZapotrzPierwGrid.DataModule.ActiveQuery.DisableControls();
      try
        m_oZapotrzPierwGrid.DataModule.ActiveQuery.Filtered := false;
        while(not oQuery.Eof) do begin
          with(m_oZapotrzPierwGrid.DataModule.ActiveQuery as TVirtualDataSet) do begin
            VState  := vsInternalInsert;
            try
              Insert();
              FieldByName(sZAOZAPOTRZPOZZLEC_ID).AsInteger:= UniqueKey[sZAOZAPOTRZPOZZLEC];
              FieldByName(sZAOZAPOTRZPOZZLEC_KIERUNEK).AsInteger  := cZAPOTRZ_KIERUNEK_ZAPOTRZZLEC;
              FieldByName(sZAOZAPOTRZPOZ_ID).AsInteger    := oQuery.Fields[0].AsInteger;
              FieldByName(sZLEZLECENIE_ID).AsInteger      := DMAQFbN(sZLEZLECENIE_ID).AsInteger;
              SetTechnicalFieldsOnInsert();
              UpdateModifiedRecordFlagsForAddedRecord();
              for i := 1 to oQuery.Fields.Count-1 do begin
                if(FindField(oQuery.Fields[i].FullName) <> nil) then
                  FieldByName(oQuery.Fields[i].FullName).AsString := oQuery.Fields[i].AsString;
              end;  // for i := 1 to oQuery.Fields.Count-1
              if(FindField(sZAOCONST_ZAPOTRZ_STATUS_V) <> nil) then
                FieldByName(sZAOCONST_ZAPOTRZ_STATUS_V).AsString := ac_oStatusy[ac_oStatusy.IndexOfSkrot(oQuery.FieldByName(sZAOZAPOTRZ_STATUS).AsString)];
              Post();
            finally
              VState := vsNormal;
            end;
          end;  // with(m_oZapotrzPierwGrid.DataModule.ActiveQuery as TVirtualDataSet)
          oQuery.Next();
        end;  // while(not oQuery.Eof)
      finally
        oQuery.Free();
        m_oZapotrzPierwGrid.DataModule.ActiveQuery.Filtered := bOldFilter;
        m_oZapotrzPierwGrid.DataModule.ActiveQuery.First();
        m_oZapotrzPierwGrid.DataModule.ActiveQuery.EnableControls();
      end;
    end;  // if(oQuery <> nil)
  end;  // procedure DopiszPozycjeZapotrzebowaniaPierwotnego

var
  oQuery:   TUNIQuery;
  i:        integer;
  oStatusy: TConstStringList;
begin
  oStatusy  := TConstStringList.Create();
  try
    UNISysDM.UNIStatDajStatusyWszystkie(sZAOCONST_ZAPOTRZ_STATUS, oStatusy);
    for i := Low(ac_aZapotrzPozId) to High(ac_aZapotrzPozId) do
      DopiszPozycjeZapotrzebowaniaPierwotnego(IntToStr(ac_aZapotrzPozId[i]), oStatusy);
  finally
    FreeAndNil(oStatusy);
  end;
  DMAQFbN(sASOASORT_ID).AsInteger     := ac_iAsortId;
  DMAQFbN(sZLEZLECENIE_ILOSC).AsFloat := ac_dIlosc;
  if(ac_iOdpowiedzialny <> 0) then begin
    DMAQFbN(sZLEZLECENIE_OSOBA_ODP).AsInteger := ac_iOdpowiedzialny;
    OsobaOdpowiedzialnaDBLookupAliasEdit.Refresh();
  end;  // if(ac_iOdpowiedzialny <> 0)
  if(Length(ac_sAsortSymbol) > 0) then begin
    AsortymentLookupAliasEdit.Text  := ac_sAsortSymbol;
  end else begin
    oQuery  := ASODM.OdpytajODane(sASOASORT_ID,
      sASOAlias_Asort_Symbol,
      '@' + sASOAlias_Asort_ID + ' = ' + IntToStr(ac_iAsortId),
      false
    );
    if(oQuery <> nil) then begin
      AsortymentLookupAliasEdit.Text  := oQuery.Fields[0].AsString;
      oQuery.Free();
    end else
      DMAQFbN(sASOASORT_ID).Clear();
  end;
  UstawAsortymentReceptury(DMAQFbN(sASOASORT_ID).AsInteger);
end;

procedure TZLEZlecenieDBDetailForm.UstawDanePozycjiZamowienia(
  const ac_iAsortId:        integer;
  const ac_aZamowieniePozId:array of integer;
  const ac_dIlosc:          double;
  const ac_iOdpowiedzialny: Integer;
  const ac_sAsortSymbol:    string  = '';
  const ac_sAsortNazwa:     string  = '';
  const ac_iRecepId:        integer = 0;
  const ac_sRecepSymbol:    string  = ''
);

  procedure DopiszPozycjeZamowienia(
    const ac_sZamowieniePozId:  string;
    const ac_oStatusy:          TConstStringList
  );
  var
    oQuery:     TUNIQuery;
    i:          integer;
  begin
    oQuery  := ZAMDM.ZAMOdpytajODane(sZAMZAMOWIENIEPOZ,
        // pola pozycji
      sZAMAlias_ZamowieniePoz_Id      + ';' + sZAMAlias_ZamowieniePoz_Ilosc + ';' +
      sZAMAlias_ZamowieniePoz_DataReal+ ';' + sZAMAlias_ZamowieniePoz_Cena  + ';' +
      sZAMAlias_ASOAsort_Id           + ';' +
      sZAMAlias_ASOAsort_Symbol       + ';' + sZAMAlias_ASOAsort_Nazwa      + ';' +
      sZAMAlias_ASOAsort_Indeks       + ';' + sZAMAlias_ASOAsort_RodzRozch  + ';' +
      sZAMAlias_LWPRecept_Id          + ';' + sZAMAlias_LWPRecept_Symbol    + ';' +
      sZAMAlias_LWPRecept_Nazwa       + ';' +
        // pola nagwka
      sZAMAlias_BKKlient_Id           + ';' + sZAMAlias_BKKlient_Symbol     + ';' +
      sZAMAlias_BKKlient_Nazwa        + ';' + sZAMAlias_BKKlient_Skrot      + ';' +
      sZAMAlias_BKKlient_NIP          + ';' + sZAMAlias_BKKlient_REGON      + ';' +
      sZAMAlias_BKKlient_PESEL        + ';' + sZAMAlias_BKKlient_KodPocz    + ';' +
      sZAMAlias_BKKlient_NrPoses      + ';' + sZAMAlias_BKKlient_NrLok      + ';' +
      sZAMAlias_BKKlient_AdrKoresp    + ';' + sZAMAlias_BKKlient_Tel1       + ';' +
      sZAMAlias_BKKlient_Fax          + ';' + sZAMAlias_BKUlica_Id          + ';' +
      sZAMAlias_BKUlica_Nazwa         + ';' + sZAMAlias_BKDzielnica_Id      + ';' +
      sZAMAlias_BKDzielnica_Nazwa     + ';' + sZAMAlias_BKMiasto_Id         + ';' +
      sZAMAlias_BKMiasto_Nazwa        + ';' + sZAMAlias_BKKraj_Id           + ';' +
      sZAMAlias_BKKraj_Nazwa          + ';' + sZAMAlias_BKKraj_Kod          + ';' +
      sZAMAlias_Zamowienie_Id         + ';' + sZAMAlias_Zamowienie_Data     + ';' +
      sZAMAlias_Zamowienie_Symbol     + ';' + sZAMAlias_Zamowienie_Priorytet+ ';' +
      sZAMAlias_Zamowienie_Status     + ';' +
      sZAMAlias_Zamowienie_OpisSta    + ';' + sZAMAlias_ZamowienieTyp_Id    + ';' +
      sZAMAlias_ZamowienieTyp_Symbol  + ';' + sZAMAlias_ZamowienieTyp_Nazwa + ';' +
      sZAMAlias_KDOsoba_Symbol        + ';' + sZAMAlias_KDOsoba_Imie        + ';' +
      sZAMAlias_KDOsoba_Nazwisko      + ';' + sZAMAlias_Zamowienie_OpisZam  + ';' +
      sZAMAlias_LWPRecept_Opis        + ';' + sZAMAlias_ZamowieniePoz_Opis,
      '@' + sZAMAlias_ZamowieniePoz_Id + ' in(' + ac_sZamowieniePozId + ')',
      false
    );
    if(oQuery <> nil) then begin
        // wypenienie kontrahenta
      if(not oQuery.FieldByName(sBKKLIENT_ID).IsNull) then
        DMAQFbN(sZLEZLECENIE_WYKONAWCA_ID).AsInteger  := oQuery.FieldByName(sBKKLIENT_ID).AsInteger;
      m_oZamowienieGrid.DataModule.ActiveQuery.DisableControls();
      try
        while(not oQuery.Eof) do begin
          with(m_oZamowienieGrid.DataModule.ActiveQuery as TVirtualDataSet) do begin
            VState  := vsInternalInsert;
            try
              Insert();
              FieldByName(sZAMZAMOWPOZZLEC_ID).AsInteger  := UniqueKey[sZAMZAMOWPOZZLEC];
              FieldByName(sZAMZAMOWIENIEPOZ_ID).AsInteger := oQuery.Fields[0].AsInteger;
              FieldByName(sZLEZLECENIE_ID).AsInteger      := DMAQFbN(sZLEZLECENIE_ID).AsInteger;
              SetTechnicalFieldsOnInsert();
              UpdateModifiedRecordFlagsForAddedRecord();
              for i := 1 to oQuery.Fields.Count-1 do begin
                if(FindField(oQuery.Fields[i].FullName) <> nil) then
                  FieldByName(oQuery.Fields[i].FullName).AsString := oQuery.Fields[i].AsString;
              end;  // for i := 1 to oQuery.Fields.Count-1
              if(FindField(sZAMCONST_ZAMOW_STATUS_V) <> nil) then
                FieldByName(sZAMCONST_ZAMOW_STATUS_V).AsString := ac_oStatusy[ac_oStatusy.IndexOfSkrot(oQuery.FieldByName(sZAMZAMOWIENIE_STATUS).AsString)];
              Post();
            finally
              VState := vsNormal;
            end;
          end;  // with(m_oZamowienieGrid.DataModule.ActiveQuery as TVirtualDataSet)
          oQuery.Next();
        end;  // while(not oQuery.Eof)
      finally
        oQuery.Free();
        m_oZamowienieGrid.DataModule.ActiveQuery.EnableControls();
      end;
    end;  // if(oQuery <> nil)
  end;  // procedure DopiszPozycjeZamowienia

var
  oQuery:   TUNIQuery;
  i:        integer;
  oStatusy: TConstStringList;
begin
  oStatusy  := TConstStringList.Create();
  try
    UNISysDM.UNIStatDajStatusyWszystkie(sZAMCONST_ZAMOW_STATUS, oStatusy);
    for i := Low(ac_aZamowieniePozId) to High(ac_aZamowieniePozId) do
      DopiszPozycjeZamowienia(IntToStr(ac_aZamowieniePozId[i]), oStatusy);
  finally
    FreeAndNil(oStatusy);
  end;
  DMAQFbN(sASOASORT_ID).AsInteger     := ac_iAsortId;
  DMAQFbN(sZLEZLECENIE_ILOSC).AsFloat := ac_dIlosc;
  if(ac_iRecepId <> 0) then begin
    DMAQFbN(sLWPRECEPTURA_ID).AsInteger := ac_iRecepId;
    RecepturaLookupAliasEdit.Text       := ac_sRecepSymbol;
  end;  // if(ac_iRecepId <> 0)
  if(ac_iOdpowiedzialny <> 0) then begin
    DMAQFbN(sZLEZLECENIE_OSOBA_ODP).AsInteger := ac_iOdpowiedzialny;
    OsobaOdpowiedzialnaDBLookupAliasEdit.Refresh();
  end;  // if(ac_iOdpowiedzialny <> 0)
  if(Length(ac_sAsortSymbol) > 0) then begin
    AsortymentLookupAliasEdit.Text  := ac_sAsortSymbol;
  end else begin
    oQuery  := ASODM.OdpytajODane(sASOASORT_ID,
      sASOAlias_Asort_Symbol,
      '@' + sASOAlias_Asort_ID + ' = ' + IntToStr(ac_iAsortId),
      false
    );
    if(oQuery <> nil) then begin
      AsortymentLookupAliasEdit.Text  := oQuery.Fields[0].AsString;
      oQuery.Free();
    end else
      DMAQFbN(sASOASORT_ID).Clear();
  end;
  UstawAsortymentReceptury(DMAQFbN(sASOASORT_ID).AsInteger);
  if(ac_iRecepId <> 0) then
    SkopiujPowiazaniaReceptury(false);
end;

procedure TZLEZlecenieDBDetailForm.DodajPozycjeZleceniaNieProd(
  const ac_iAsortId:        integer;
  const ac_dIlosc:          double;
  const ac_iOdpowiedzialny: Integer;
  const ac_sOpisPozycji:    string  = '';
  const ac_sAsortSymbol:    string  = '';
  const ac_sAsortNazwa:     string  = '';
  const ac_sAsortIndeks:    string  = '';
  const ac_iWykonawcaId:    integer = 0 // bkklient_id bdcy wykonawc zlecenia
);

  procedure DopiszPozycje();
  var
    oQuery: TUNIQuery;
  begin
    if(m_oPozycjaGrid <> nil) then begin
      {Tu obsuga podpowiadania danych z nagwka}
      with(m_oPozycjaGrid.DataModule.ActiveQuery as TVirtualDataSet) do begin
        try
          VState := vsInternalInsert;
          Append();
          FieldByName(sZLEZLECENIEPOZ_ID).AsInteger := UniqueKey[sZLEZLECENIEPOZ];
          FieldByName(sZLEZLECENIE_ID).AsInteger := DMAQFbN(sZLEZLECENIE_ID).AsInteger;
          if(Length(ac_sOpisPozycji) > 0) then
            FieldByName(sZLEZLECENIEPOZ_OPIS).AsString := ac_sOpisPozycji;
          FieldByName(sZLEZLECENIEPOZ_ILOSC).AsFloat := ac_dIlosc;
          if(ac_iAsortId <> 0) then
            FieldByName(sASOASORT_ID).AsInteger := ac_iAsortId;
          SetTechnicalFieldsOnInsert();
          UpdateModifiedRecordFlagsForAddedRecord();

          if(Length(ac_sAsortSymbol) > 0) then begin
            FieldByName(sASOASORT_SYMBOL).AsString:= ac_sAsortSymbol;
            FieldByName(sASOASORT_NAZWA).AsString := ac_sAsortNazwa;
            FieldByName(sASOASORT_INDEKS).AsString:= ac_sAsortIndeks;
          end else begin
            oQuery  := ASODM.OdpytajODane(sASOASORT_ID,
              sASOAlias_Asort_Symbol + ';' + sASOAlias_Asort_Nazwa + ';' + sASOAlias_Asort_Indeks,
              '@' + sASOAlias_Asort_ID + ' = ' + IntToStr(ac_iAsortId),
              false
            );
            if(oQuery <> nil) then begin
              FieldByName(sASOASORT_SYMBOL).AsString:= oQuery.Fields[0].AsString;
              FieldByName(sASOASORT_NAZWA).AsString := oQuery.Fields[1].AsString;
              FieldByName(sASOASORT_INDEKS).AsString:= oQuery.Fields[2].AsString;
              FreeAndNil(oQuery);
            end;
          end;
          Post();
        finally
          VState := vsNormal;
        end;
      end;
      (m_oPozycjaGrid.DataModule as TZLEPozycjeDataModule).RefreshLp();
    end;
  end;  // procedure DopiszPozycje

begin
  if(ac_iWykonawcaId <> 0) then
    DMAQFbN(sZLEZLECENIE_WYKONAWCA_ID).AsInteger  := ac_iWykonawcaId;
  if(ac_iOdpowiedzialny <> 0) then begin
    DMAQFbN(sZLEZLECENIE_OSOBA_ODP).AsInteger := ac_iOdpowiedzialny;
    OsobaOdpowiedzialnaDBLookupAliasEdit.Refresh();
  end;  // if(ac_iOdpowiedzialny <> 0)
  DopiszPozycje();
end;

procedure TZLEZlecenieDBDetailForm.PowiazZlecenieNieProdZZamowieniem(
  const ac_iZamowPozAdmFunk:integer
);
var
  oQuery:     TUNIQuery;
  i:          integer;
  oStatusy:   TConstStringList;
begin
  oQuery  := ZAMDM.ZAMOdpytajODane(sZAMZAMOWIENIEPOZ,
      // pola pozycji
    sZAMAlias_ZamowieniePoz_Id      + ';' + sZAMAlias_ZamowieniePoz_Ilosc + ';' +
    sZAMAlias_ZamowieniePoz_DataReal+ ';' + sZAMAlias_ZamowieniePoz_Cena  + ';' +
    sZAMAlias_ASOAsort_Id           + ';' +
    sZAMAlias_ASOAsort_Symbol       + ';' + sZAMAlias_ASOAsort_Nazwa      + ';' +
    sZAMAlias_ASOAsort_Indeks       + ';' + sZAMAlias_ASOAsort_RodzRozch  + ';' +
      // pola nagwka
    sZAMAlias_BKKlient_Id           + ';' + sZAMAlias_BKKlient_Symbol     + ';' +
    sZAMAlias_BKKlient_Nazwa        + ';' + sZAMAlias_BKKlient_Skrot      + ';' +
    sZAMAlias_BKKlient_NIP          + ';' + sZAMAlias_BKKlient_REGON      + ';' +
    sZAMAlias_BKKlient_PESEL        + ';' + sZAMAlias_BKKlient_KodPocz    + ';' +
    sZAMAlias_BKKlient_NrPoses      + ';' + sZAMAlias_BKKlient_NrLok      + ';' +
    sZAMAlias_BKKlient_AdrKoresp    + ';' + sZAMAlias_BKKlient_Tel1       + ';' +
    sZAMAlias_BKKlient_Fax          + ';' + sZAMAlias_BKUlica_Id          + ';' +
    sZAMAlias_BKUlica_Nazwa         + ';' + sZAMAlias_BKDzielnica_Id      + ';' +
    sZAMAlias_BKDzielnica_Nazwa     + ';' + sZAMAlias_BKMiasto_Id         + ';' +
    sZAMAlias_BKMiasto_Nazwa        + ';' + sZAMAlias_BKKraj_Id           + ';' +
    sZAMAlias_BKKraj_Nazwa          + ';' + sZAMAlias_BKKraj_Kod          + ';' +
    sZAMAlias_Zamowienie_Id         + ';' + sZAMAlias_Zamowienie_Data     + ';' +
    sZAMAlias_Zamowienie_Symbol     + ';' + sZAMAlias_Zamowienie_Priorytet+ ';' +
    sZAMAlias_Zamowienie_Status     + ';' +
    sZAMAlias_Zamowienie_OpisSta    + ';' + sZAMAlias_ZamowienieTyp_Id    + ';' +
    sZAMAlias_ZamowienieTyp_Symbol  + ';' + sZAMAlias_ZamowienieTyp_Nazwa + ';' +
    sZAMAlias_KDOsoba_Symbol        + ';' + sZAMAlias_KDOsoba_Imie        + ';' +
    sZAMAlias_KDOsoba_Nazwisko      + ';' + sZAMAlias_Zamowienie_OpisZam  + ';' +
    sZAMAlias_ZamowieniePoz_Opis,
    '@' + sZAMAlias_ZamowieniePoz_Id + ' in(' + ADMID_SelectSQL(ac_iZamowPozAdmFunk, 0, SecurityManager.UserId, '') + ')',
    false
  );
  if(oQuery <> nil) then begin
      // wypenienie kontrahenta
    oStatusy  := TConstStringList.Create();
    m_oZamowienieGrid.DataModule.ActiveQuery.DisableControls();
    try
      UNISysDM.UNIStatDajStatusyWszystkie(sZAMCONST_ZAMOW_STATUS, oStatusy);
      while(not oQuery.Eof) do begin
        with(m_oZamowienieGrid.DataModule.ActiveQuery as TVirtualDataSet) do begin
          VState  := vsInternalInsert;
          try
            Insert();
            FieldByName(sZAMZAMOWPOZZLEC_ID).AsInteger  := UniqueKey[sZAMZAMOWPOZZLEC];
            FieldByName(sZAMZAMOWIENIEPOZ_ID).AsInteger := oQuery.Fields[0].AsInteger;
            FieldByName(sZLEZLECENIE_ID).AsInteger      := DMAQFbN(sZLEZLECENIE_ID).AsInteger;
            SetTechnicalFieldsOnInsert();
            UpdateModifiedRecordFlagsForAddedRecord();
            for i := 1 to oQuery.Fields.Count-1 do begin
              if(FindField(oQuery.Fields[i].FullName) <> nil) then
                FieldByName(oQuery.Fields[i].FullName).AsString := oQuery.Fields[i].AsString;
            end;  // for i := 1 to oQuery.Fields.Count-1
            if(FindField(sZAMCONST_ZAMOW_STATUS_V) <> nil) then
              FieldByName(sZAMCONST_ZAMOW_STATUS_V).AsString := oStatusy[oStatusy.IndexOfSkrot(oQuery.FieldByName(sZAMZAMOWIENIE_STATUS).AsString)];
            Post();
          finally
            VState := vsNormal;
          end;
        end;  // with(m_oZamowienieGrid.DataModule.ActiveQuery as TVirtualDataSet)
        oQuery.Next();
      end;  // while(not oQuery.Eof)
    finally
      FreeAndNil(oStatusy);
      oQuery.Free();
      m_oZamowienieGrid.DataModule.ActiveQuery.EnableControls();
    end;
  end;  // if(oQuery <> nil)
end;

procedure TZLEZlecenieDBDetailForm.PowiazZlecenieNieProdZZapotrzebowaniem(
  const ac_iZapotrzPozAdmFunk:  integer
);
var
  oQuery:     TUNIQuery;
  bOldFilter: boolean;
  i:          integer;
  oStatusy:   TConstStringList;
begin
  oQuery  := ZAODM.ZAOOdpytajODane(sZAOZAPOTRZPOZ,
      // pola pozycji
    sZAOAlias_ZapotrzebowaniePoz_Id   + ';' + sZAOAlias_ZapotrzebowaniePoz_Ilosc  + ';' +
    sZAOAlias_ZapotrzebowaniePoz_Data + ';' +
    sZAOAlias_ASOAsort_Id             + ';' + sZAOAlias_ASOAsort_Symbol           + ';' +
    sZAOAlias_ASOAsort_Nazwa          + ';' + sZAOAlias_ASOAsort_Indeks           + ';' +
    sZAOAlias_ASOAsort_RodzRozch      + ';' + sZAOAlias_KDOsoba_Id                + ';' +
    sZAOAlias_KDOsoba_Symbol          + ';' + sZAOAlias_KDOsoba_Imie              + ';' +
    sZAOAlias_KDOsoba_Nazwisko        + ';' +
      // pola zapotrzebowania
    sZAOAlias_Zapotrzebowanie_Id      + ';' + sZAOAlias_Zapotrzebowanie_Symbol    + ';' +
    sZAOAlias_Zapotrzebowanie_Data    + ';' + sZAOAlias_Zapotrzebowanie_Status    + ';' +
    sZAOAlias_Zapotrzebowanie_OpisSta   + ';' +
    sZAOAlias_ZapotrzebowanieTyp_Id   + ';' + sZAOAlias_ZapotrzebowanieTyp_Symbol + ';' +
    sZAOAlias_ZapotrzebowanieTyp_Nazwa+ ';' +
    '#@' + sZAOAlias_KDOdpow_Symbol + ' as ' + sZAOAlias_KDOdpow_Symbol + ';' +
    '#@' + sZAOAlias_KDOdpow_Imie + ' as ' + sZAOAlias_KDOdpow_Imie + ';' +
    '#@' + sZAOAlias_KDOdpow_Nazwisko + ' as ' + sZAOAlias_KDOdpow_Nazwisko + ';' +
    sZAOAlias_ZapotrzebowaniePoz_Opis + ';' + sZAOAlias_Zapotrzebowanie_Opis,
    '@' + sZAOAlias_ZapotrzebowaniePoz_Id + ' in(' + ADMID_SelectSQL(ac_iZapotrzPozAdmFunk, 0, SecurityManager.UserId, '') + ')',
    false
  );
  if(oQuery <> nil) then begin
    oStatusy    := TConstStringList.Create();
    bOldFilter  := m_oZapotrzPierwGrid.DataModule.ActiveQuery.Filtered;
    m_oZapotrzPierwGrid.DataModule.ActiveQuery.DisableControls();
    try
      UNISysDM.UNIStatDajStatusyWszystkie(sZAOCONST_ZAPOTRZ_STATUS, oStatusy);
      m_oZapotrzPierwGrid.DataModule.ActiveQuery.Filtered := false;
      while(not oQuery.Eof) do begin
        with(m_oZapotrzPierwGrid.DataModule.ActiveQuery as TVirtualDataSet) do begin
          VState  := vsInternalInsert;
          try
            Insert();
            FieldByName(sZAOZAPOTRZPOZZLEC_ID).AsInteger:= UniqueKey[sZAOZAPOTRZPOZZLEC];
            FieldByName(sZAOZAPOTRZPOZZLEC_KIERUNEK).AsInteger  := cZAPOTRZ_KIERUNEK_ZAPOTRZZLEC;
            FieldByName(sZAOZAPOTRZPOZ_ID).AsInteger    := oQuery.Fields[0].AsInteger;
            FieldByName(sZLEZLECENIE_ID).AsInteger      := DMAQFbN(sZLEZLECENIE_ID).AsInteger;
            SetTechnicalFieldsOnInsert();
            UpdateModifiedRecordFlagsForAddedRecord();
            for i := 1 to oQuery.Fields.Count-1 do begin
              if(FindField(oQuery.Fields[i].FullName) <> nil) then
                FieldByName(oQuery.Fields[i].FullName).AsString := oQuery.Fields[i].AsString;
            end;  // for i := 1 to oQuery.Fields.Count-1
            if(FindField(sZAOCONST_ZAPOTRZ_STATUS_V) <> nil) then
              FieldByName(sZAOCONST_ZAPOTRZ_STATUS_V).AsString := oStatusy[oStatusy.IndexOfSkrot(oQuery.FieldByName(sZAOZAPOTRZ_STATUS).AsString)];
            Post();
          finally
            VState := vsNormal;
          end;
        end;  // with(m_oZapotrzPierwGrid.DataModule.ActiveQuery as TVirtualDataSet)
        oQuery.Next();
      end;  // while(not oQuery.Eof)
    finally
      FreeAndNil(oStatusy);
      oQuery.Free();
      m_oZapotrzPierwGrid.DataModule.ActiveQuery.Filtered := bOldFilter;
      m_oZapotrzPierwGrid.DataModule.ActiveQuery.First();
      m_oZapotrzPierwGrid.DataModule.ActiveQuery.EnableControls();
    end;
  end;  // if(oQuery <> nil)
end;

procedure TZLEZlecenieDBDetailForm.PowiazZlecenieNieProdZZapytaniem(
  const ac_iZapytPozAdmFunk:    integer
);
var
  oQuery:       TUNIQuery;
  bOldFilter:   boolean;
  i:            integer;
  oStatusy:     TConstStringList;
begin
  oQuery  := ZAMDM.ZAMOdpytajODane(sZAMZAPYTANIEPOZ,
      // pola pozycji
    sZAMAlias_LWPRecept_Id      + ';' + sZAMAlias_LWPRecept_Symbol    + ';' +
    sZAMAlias_LWPRecept_Nazwa   + ';' + sZAMAlias_ZapytaniePoz_Id     + ';' +
    sZAMAlias_ZapytaniePoz_Ilosc+ ';' + sZAMAlias_ZapytaniePoz_DataReal+ ';' +
    sZAMAlias_ASOAsort_Id       + ';' +
    sZAMAlias_ASOAsort_Symbol   + ';' + sZAMAlias_ASOAsort_Nazwa      + ';' +
      // pola nagwka
    sZAMAlias_Zapytanie_Id      + ';' + sZAMAlias_Zapytanie_Symbol    + ';' +
    sZAMAlias_Zapytanie_Data    + ';' + sZAMAlias_Zapytanie_Status    + ';' +
    sZAMAlias_Zapytanie_OpisSta + ';' +
    sZAMAlias_ZapytanieTyp_Id   + ';' + sZAMAlias_ZapytanieTyp_Symbol + ';' +
    sZAMAlias_ZapytanieTyp_Nazwa+ ';' + sZAMAlias_KDOsoba_Symbol      + ';' +
    sZAMAlias_KDOsoba_Imie      + ';' + sZAMAlias_KDOsoba_Nazwisko    + ';' +
    sZAMAlias_Zapytanie_Opis    + ';' + sZAMAlias_ZapytaniePoz_Opis,
    '@' + sZAMAlias_ZapytaniePoz_Id + ' in(' + ADMID_SelectSQL(ac_iZapytPozAdmFunk, 0, SecurityManager.UserId, '') + ')',
    false
  );
  if(oQuery <> nil) then begin
    oStatusy    := TConstStringList.Create();
      // wypenienie kontrahenta
    bOldFilter  := m_oZapytanieGrid.DataModule.ActiveQuery.Filtered;
    m_oZapytanieGrid.DataModule.ActiveQuery.DisableControls();
    try
      UNISysDM.UNIStatDajStatusyWszystkie(sZAMCONST_ZAPYT_STATUS, oStatusy);
      m_oZapytanieGrid.DataModule.ActiveQuery.Filtered := false;
      while(not oQuery.Eof) do begin
        with(m_oZapytanieGrid.DataModule.ActiveQuery as TVirtualDataSet) do begin
          VState  := vsInternalInsert;
          try
            Insert();
            FieldByName(sZAMZAPYTANIEPOZZLEC_ID).AsInteger:= UniqueKey[sZAMZAPYTANIEPOZZLEC];
            FieldByName(sZAMZAPYTANIEPOZ_ID).AsInteger    := oQuery.Fields[3].AsInteger;
            FieldByName(sZLEZLECENIE_ID).AsInteger        := DMAQFbN(sZLEZLECENIE_ID).AsInteger;
            SetTechnicalFieldsOnInsert();
            UpdateModifiedRecordFlagsForAddedRecord();
            for i := 1 to oQuery.Fields.Count-1 do begin
              if(FindField(oQuery.Fields[i].FullName) <> nil) then
                FieldByName(oQuery.Fields[i].FullName).AsString := oQuery.Fields[i].AsString;
            end;  // for i := 1 to oQuery.Fields.Count-1
            if(FindField(sZAMCONST_ZAPYT_STATUS_V) <> nil) then
              FieldByName(sZAMCONST_ZAPYT_STATUS_V).AsString := oStatusy[oStatusy.IndexOfSkrot(oQuery.FieldByName(sZAMZAPYTANIE_STATUS).AsString)];
            Post();
          finally
            VState := vsNormal;
          end;
        end;  // with(m_oZapytanieGrid.DataModule.ActiveQuery as TVirtualDataSet)
        oQuery.Next();
      end;  // while(not oQuery.Eof)
    finally
      FreeAndNil(oStatusy);
      oQuery.Free();
      m_oZapytanieGrid.DataModule.ActiveQuery.Filtered := bOldFilter;
      m_oZapytanieGrid.DataModule.ActiveQuery.First();
      m_oZapytanieGrid.DataModule.ActiveQuery.EnableControls();
    end;
  end;  // if(oQuery <> nil)
end;

procedure TZLEZlecenieDBDetailForm.UstawDanePozycjiZapytania(
  const ac_iAsortId:        integer;
  const ac_aZapytPozId:     array of integer;
  const ac_iOdpowiedzialny: Integer;
  const ac_dIlosc:          double  = 0;
  const ac_sAsortSymbol:    string  = '';
  const ac_sAsortNazwa:     string  = '';
  const ac_iRecepId:        integer = 0;
  const ac_sRecepSymbol:    string  = ''
);

  procedure DopiszPozycjeZapytania(
    const ac_sZapytPozId:   string;
    const ac_oStatusy:      TConstStringList
  );
  var
    oQuery:       TUNIQuery;
    bOldFilter:   boolean;
    i:            integer;
  begin
    oQuery  := ZAMDM.ZAMOdpytajODane(sZAMZAPYTANIEPOZ,
        // pola pozycji
      sZAMAlias_LWPRecept_Id      + ';' + sZAMAlias_LWPRecept_Symbol    + ';' +
      sZAMAlias_LWPRecept_Nazwa   + ';' + sZAMAlias_ZapytaniePoz_Id     + ';' +
      sZAMAlias_ZapytaniePoz_Ilosc+ ';' + sZAMAlias_ZapytaniePoz_DataReal+ ';' +
      sZAMAlias_ASOAsort_Id       + ';' +
      sZAMAlias_ASOAsort_Symbol   + ';' + sZAMAlias_ASOAsort_Nazwa      + ';' + 
        // pola nagwka
      sZAMAlias_Zapytanie_Id      + ';' + sZAMAlias_Zapytanie_Symbol    + ';' +
      sZAMAlias_Zapytanie_Data    + ';' + sZAMAlias_Zapytanie_Status    + ';' +
      sZAMAlias_Zapytanie_OpisSta + ';' +
      sZAMAlias_ZapytanieTyp_Id   + ';' + sZAMAlias_ZapytanieTyp_Symbol + ';' +
      sZAMAlias_ZapytanieTyp_Nazwa+ ';' + sZAMAlias_KDOsoba_Symbol      + ';' +
      sZAMAlias_KDOsoba_Imie      + ';' + sZAMAlias_KDOsoba_Nazwisko    + ';' +
      sZAMAlias_Zapytanie_Opis    + ';' + sZAMAlias_ZapytaniePoz_Opis,
      '@' + sZAMAlias_ZapytaniePoz_Id + ' = ' + ac_sZapytPozId,
      false
    );
    if(oQuery <> nil) then begin
        // wypenienie kontrahenta
      bOldFilter  := m_oZapytanieGrid.DataModule.ActiveQuery.Filtered;
      m_oZapytanieGrid.DataModule.ActiveQuery.DisableControls();
      try
        m_oZapytanieGrid.DataModule.ActiveQuery.Filtered := false;
        with(m_oZapytanieGrid.DataModule.ActiveQuery as TVirtualDataSet) do begin
          VState  := vsInternalInsert;
          try
            Insert();
            FieldByName(sZAMZAPYTANIEPOZZLEC_ID).AsInteger:= UniqueKey[sZAMZAPYTANIEPOZZLEC];
            FieldByName(sZAMZAPYTANIEPOZ_ID).AsInteger    := oQuery.Fields[3].AsInteger;
            FieldByName(sZLEZLECENIE_ID).AsInteger        := DMAQFbN(sZLEZLECENIE_ID).AsInteger;
            SetTechnicalFieldsOnInsert();
            UpdateModifiedRecordFlagsForAddedRecord();
            for i := 1 to oQuery.Fields.Count-1 do begin
              if(FindField(oQuery.Fields[i].FullName) <> nil) then
                FieldByName(oQuery.Fields[i].FullName).AsString := oQuery.Fields[i].AsString;
            end;  // for i := 1 to oQuery.Fields.Count-1
            if(FindField(sZAMCONST_ZAPYT_STATUS_V) <> nil) then
              FieldByName(sZAMCONST_ZAPYT_STATUS_V).AsString  := ac_oStatusy[ac_oStatusy.IndexOfSkrot(oQuery.FieldByName(sZAMZAPYTANIE_STATUS).AsString)];
            Post();
          finally
            VState := vsNormal;
          end;
        end;  // with(m_oZapytanieGrid.DataModule.ActiveQuery as TVirtualDataSet)
      finally
        oQuery.Free();
        m_oZapytanieGrid.DataModule.ActiveQuery.Filtered := bOldFilter;
        m_oZapytanieGrid.DataModule.ActiveQuery.First();
        m_oZapytanieGrid.DataModule.ActiveQuery.EnableControls();
      end;
    end;  // if(oQuery <> nil)
  end;  // procedure DopiszPozycjeZapytania

var
  i:            integer;
  sAliasy:      string;
  sWarunek:     string;
  oQuery:       TUNIQuery;
  oQueryKlient: TUNIQuery;
  oStatusy:     TConstStringList;
begin
  if(ac_iOdpowiedzialny <> 0) then begin
    DMAQFbN(sZLEZLECENIE_OSOBA_ODP).AsInteger := ac_iOdpowiedzialny;
    OsobaOdpowiedzialnaDBLookupAliasEdit.Refresh();
  end;  // if(ac_iOdpowiedzialny <> 0)
  oQueryKlient  := ZAMDM.ZAMOdpytajODane(sZAMZAPYTANIE,
      // pola nagwka
    sZAMAlias_ZapytanieKlient_KlientId,
    '@' + sZAMAlias_ZapytanieKlient_ZapytId + ' in(' +
      ZAMDM.ZAMOdpytajODaneSQL(sZAMZAPYTANIE,
        sZAMAlias_ZapytaniePoz_ZapytId,
        '@' + sZAMAlias_ZapytaniePoz_Id + ' = ' + IntToStr(ac_aZapytPozId[0]),
        false
      ) +
    ')',
    true
  );
  if(oQueryKlient <> nil) then begin
    DMAQFbN(sZLEZLECENIE_WYKONAWCA_ID).AsInteger  := oQueryKlient.FieldByName(sBKKLIENT_ID).AsInteger;
    FreeAndNil(oQueryKlient);
  end;
  oStatusy  := TConstStringList.Create();
  try
    UNISysDM.UNIStatDajStatusyWszystkie(sZAMCONST_ZAPYT_STATUS, oStatusy);
    for i := Low(ac_aZapytPozId) to High(ac_aZapytPozId) do
      DopiszPozycjeZapytania(IntToStr(ac_aZapytPozId[i]), oStatusy);
  finally
    FreeAndNil(oStatusy);
  end;
  UstawAsortymentIIlosc(ac_iAsortId, ac_sAsortSymbol, ac_dIlosc);

  UNIDajAliasyZLookupa(RecepturaLookupAliasEdit, sAliasy, sWarunek);
  oQuery  := LWPDM.LWPOdpytajODane(sLWPRECEPTURA,
    sAliasy,
    '@' + sLWPAlias_Receptura_Id + ' = ' + IntToStr(ac_iRecepId),
    false
  );
  if(oQuery <> nil) then begin
    RecepturaLookupAliasEditSetData(oQuery);
    oQuery.Free();
  end;  // if(oQueryTemp <> nil)
end;

procedure TZLEZlecenieDBDetailForm.SkopiujDaneZeZlecenia(
  const ac_iZlecenieId:     integer
);

  procedure SkopiujNaglowek();
  var
    oQuery:     TUNIQuery;
    oQueryTemp: TUNIQuery;
    sAliasy:    string;
    sWarunek, sSQL:   string;
  begin
    sSQL := 'select ' +
          // typ zlecenia
{0}     'T.'  + sZLETYPZLEC_ID            + ', T.'  + sZLETYPZLEC_SYMBOL        + ', ' +
{2}     'T.'  + sUNIAUTNUM_ID             + ', T.'  + sZLETYPZLEC_ILOSCI        + ', ' +
{4}     'T.'  + sZLETYPZLEC_TYP_GRUPY_ID  + ', T.'  + sZLETYPZLEC_WYKONAWCA_A   + ', ' +
{6}     'T.'  + sZLETYPZLEC_WYDZIAL_A     + ', T.'  + sZLETYPZLEC_OPIS_A        + ', ' +
{8}     'T.'  + sZLETYPZLEC_ILOSCI_ASOMAG + ', T.'  + sZLETYPZLEC_NIERUCHOMOSC_A+ ', ' +
{10}    'T.'  + sZLETYPZLEC_BUDYNEK_A     + ', T.'  + sZLETYPZLEC_LOKAL_A       + ', ' +
{12}    'T.'  + sZLETYPZLEC_KLATKA_A      + ', T.'  + sZLETYPZLEC_ULICA_A       + ', ' +
{14}    'T.'  + sZLETYPZLEC_ZASOB_A       + ', T.'  + sZLETYPZLEC_SIECELEMENT_A + ', ' +
{16}    'T.'  + sZLETYPZLEC_TABPOWIAZANA  + ', T.'  + sZLETYPZLEC_ZASOBY        + ', ' +
{18}    'T.'  + sZLETYPZLEC_ELEMENTINF    + ', T.'  + sZLETYPZLEC_POZIOMINF     + ', ' +
{20}    'T.'  + sASOREG_ID                + ', T.'  + sZLETYPZLEC_DOM_NAZWA     + ', ' +
{22}    'T.'  + sZLETYPZLEC_DOM_DATA_OTW  + ', T.'  + sZLETYPZLEC_PRODUKCYJNE   + ', ' +
          // zlecenie
{24}    'Z.'  + sZLEZLECENIE_POLE1        + ', Z.'  + sZLEZLECENIE_POLE2        + ', ' +
{26}    'Z.'  + sZLEZLECENIE_POLE3        + ', Z.'  + sZLEZLECENIE_NAZWA        + ', ' +
{28}    'Z.'  + sZLEZLECENIE_GRUPA_ID     + ', Z.'  + sZLEZLECENIE_DATA_OTW     + ', ' +
{30}    'Z.'  + sZLEZLECENIE_DATA_ZAMK    + ', Z.'  + sZLEZLECENIE_OSOBA_ODP    + ', ' +
{32}    'Z.'  + sZLEZLECENIE_STATUS       + ', Z.'  + sZLEZLECENIE_STATUS_OSOBA + ', ' +
{34}    'Z.'  + sZLEZLECENIE_STATUS_PODST + ', Z.'  + sZLEZLECENIE_OPIS         + ', ' +
{36}    'Z.'  + sZLEZLECENIE_WYKONAWCA_ID + ', Z.'  + sZLEZLECENIE_ILOSC        + ', ' +
{38}    'Z.'  + sZLEZLECENIE_LICZNIK      + ', Z.'  + sZLEZLECENIE_KOLOR        + ', ' +
{40}    'Z.'  + sASOASORT_ID              + ', Z.'  + sLWPRECEPTURA_ID          + ', ' +
{42}    'Z.'  + sUNIJEDNOSTKAORG_ID       + ', T.'  + sZLETYPZLEC_WYMAG_RECEP   + ', ' +
{44}    'T.'  + sZLETYPZLEC_SUFFIX        + ', Z.'  + sZLEZLECENIE_PREFIX_ID    + ', ' +
{46}    'T.'  + sZLETYPZLEC_POJAZD_A      + ', Z.'  + sUNIPOJSP_ID              + ', ' +
{48}    'T.'  + sZLETYPZLEC_PROCENT_UE_A  + ', T.'  + sZLETYPZLEC_SKLADELEMSIECI_A+', '+
{50}    'T.'  + sZLETYPZLEC_ZLEC_ELEMINF  + ', T.'  + sZLETYPZLEC_ZLEC_POZINF   + ', ' +
{52}    'T.'  + sZLETYPZLEC_PUNKT_A       + ', T.'  + sZLETYPZLEC_UMOWA_A       + ', ' +
{54}    'T.'  + sZAOZAPOTRZTYP_ID;

    if vWieloodzialowosc or vWielofirmowosc then
       sSQL := sSQL + ', Z.' + sUNIODDZIAL_ID;

    sSQL := sSQL +
      ' from %s Z, %s T'  +
      ' where ' +
        'Z.'  + sZLETYPZLEC_ID  + ' = T.' + sZLETYPZLEC_ID  + ' and ' +
        'Z.'  + sZLEZLECENIE_ID + ' = ' + IntToStr(ac_iZlecenieId);

    oQuery  := SQLManager.CreateQuery(sSQL,[sZLEZLECENIE, sZLETYPZLEC]);
    try
      oQuery.Open();
      if(not oQuery.IsEmpty()) then begin
        DMAQFbN(sZLETYPZLEC_ID).AsInteger := oQuery.Fields[0].AsInteger;
        TypZleceniaDBLookupAliasEdit.Text := oQuery.Fields[1].AsString;
        TypZleceniaDBLookupAliasEditSetData(oQuery);
        if(not oQuery.Fields[24].IsNull) then
          DMAQFbN(sZLEZLECENIE_POLE1).AsString  := oQuery.Fields[24].AsString;
        if(not oQuery.Fields[25].IsNull) then
          DMAQFbN(sZLEZLECENIE_POLE2).AsString  := oQuery.Fields[25].AsString;
        if(not oQuery.Fields[26].IsNull) then
          DMAQFbN(sZLEZLECENIE_POLE3).AsString  := oQuery.Fields[26].AsString;
        if(not oQuery.Fields[27].IsNull) then
          DMAQFbN(sZLEZLECENIE_NAZWA).AsString  := oQuery.Fields[27].AsString;
        if(not oQuery.Fields[28].IsNull) then
          DMAQFbN(sZLEZLECENIE_GRUPA_ID).AsInteger:= oQuery.Fields[28].AsInteger;
        if(DMAQFbN(sZLEZLECENIE_DATA_OTW).IsNull and (not oQuery.Fields[29].IsNull)) then
          DMAQFbN(sZLEZLECENIE_DATA_OTW).AsDateTime := oQuery.Fields[29].AsDateTime;
        if(not oQuery.Fields[30].IsNull) then
          DMAQFbN(sZLEZLECENIE_DATA_ZAMK).AsDateTime := oQuery.Fields[30].AsDateTime;
        if(not oQuery.Fields[31].IsNull) then
          DMAQFbN(sZLEZLECENIE_OSOBA_ODP).AsString  := oQuery.Fields[31].AsString;
        if(not oQuery.Fields[32].IsNull) then
          DMAQFbN(sZLEZLECENIE_STATUS).AsString := oQuery.Fields[32].AsString;
        if(not oQuery.Fields[33].IsNull) then
          DMAQFbN(sZLEZLECENIE_STATUS_OSOBA).AsString := oQuery.Fields[33].AsString;
        if(not oQuery.Fields[34].IsNull) then
          DMAQFbN(sZLEZLECENIE_STATUS_PODST).AsString := oQuery.Fields[34].AsString;
        if(not oQuery.Fields[35].IsNull) then
          DMAQFbN(sZLEZLECENIE_OPIS).AsString := oQuery.Fields[35].AsString;
        if(not oQuery.Fields[36].IsNull) then
          DMAQFbN(sZLEZLECENIE_WYKONAWCA_ID).AsInteger:= oQuery.Fields[36].AsInteger;
        if(not oQuery.Fields[37].IsNull) then
          DMAQFbN(sZLEZLECENIE_ILOSC).AsFloat := oQuery.Fields[37].AsFloat;
        if(not oQuery.Fields[39].IsNull) then
          DMAQFbN(sZLEZLECENIE_KOLOR).AsInteger := oQuery.Fields[39].AsInteger;

        if(not oQuery.Fields[40].IsNull) then begin
          UNIDajAliasyZLookupa(AsortymentLookupAliasEdit, sAliasy, sWarunek);
          oQueryTemp  := ASODM.OdpytajODane(sASOASORT,
            sAliasy,
            '@' + sASOAlias_Asort_ID + ' = ' + oQuery.Fields[40].AsString,
            false
          );
          AsortymentLookupAliasEditSetData(oQueryTemp);
          oQueryTemp.Free();
        end;  // if(not oQuery.Fields[40].IsNull)
        if(not oQuery.Fields[41].IsNull) then begin
          UNIDajAliasyZLookupa(RecepturaLookupAliasEdit, sAliasy, sWarunek);
          oQueryTemp  := LWPDM.LWPOdpytajODane(sLWPRECEPTURA,
            sAliasy,
            '@' + sLWPAlias_Receptura_Id + ' = ' + oQuery.Fields[41].AsString,
            false
          );
          if(oQueryTemp <> nil) then begin
            DMAQFbN(sLWPRECEPTURA_ID).AsInteger := oQueryTemp.Fields[0].AsInteger;
            ShowReceptura(oQueryTemp);
            oQueryTemp.Free();
          end;  // if(oQueryTemp <> nil)
        end;  // if(not oQuery.Fields[41].IsNull)
        if(not oQuery.Fields[42].IsNull) then begin
          UNIDajAliasyZLookupa(WydzialDBLookupAliasEdit, sAliasy, sWarunek);
          oQueryTemp  := UNISysDM.UNIOdpytajODane(sUNIJEDNOSTKAORG,
            sAliasy,
            '@' + sUNISysAlias_JednostkaOrg_ID + ' = ' + oQuery.Fields[42].AsString,
            false
          );
          if(oQueryTemp <> nil) then begin
            DMAQFbN(sUNIJEDNOSTKAORG_ID).AsInteger:= oQueryTemp.Fields[0].AsInteger;
            WydzialDBLookupAliasEdit.Text         := oQueryTemp.Fields[1].AsString;
            WydzialDBLookupAliasEditSetData(oQueryTemp);
            oQueryTemp.Free();
          end;  // if(oQueryTemp <> nil)
        end;  // if(not oQuery.Fields[42].IsNull)
        if(not oQuery.FieldByName(sZLEZLECENIE_PREFIX_ID).IsNull) then begin
          DMAQFbN(sZLEZLECENIE_PREFIX_ID).AsInteger:= oQuery.FieldByName(sZLEZLECENIE_PREFIX_ID).AsInteger;
          PrefixDBLookupAliasEdit.InitiateData(DMAQFbN(sZLEZLECENIE_PREFIX_ID).AsInteger);
        end;

        if vWieloodzialowosc or vWielofirmowosc then begin
           if (not oQuery.FieldByName(sUNIODDZIAL_ID).IsNull) then begin

              if (not DMAQFbN(sUNIODDZIAL_ID).IsNull) then
                 iOddzialOld := DMAQFbN(sUNIODDZIAL_ID).AsInteger;

              DMAQFbN(sUNIODDZIAL_ID).AsInteger:= oQuery.FieldByName(sUNIODDZIAL_ID).AsInteger;
              OddzialDBLookupAliasEdit.InitiateData(DMAQFbN(sUNIODDZIAL_ID).AsInteger);
           end;
        end;
        RecepturaLookupAliasEdit.aAllowEmpty  := (oQuery.Fields[43].AsString = sNie);
      end;  // if(not oQuery.IsEmpty())
    finally
      oQuery.Free();
    end;
  end;  // procedure SkopiujNaglowek

  procedure SkopiujZasoby();
  var
    oQuery:   TUNIQuery;
    sPola:    string;
    sTabele:  string;
    sWhere:   string;
    i:        integer;
  begin
    sPola :=
        // pola tabeli zlezleceniezasob
{0}   'ZZ.' + sZLEZASOB_ID            + ', ZZ.' + sLWPRECEPPOZZASOB_ID    + ', ' +
{2}   'ZZ.' + sZLEZLECENIEZASOB_PLAN  + ', ZZ.' + sZLEZLECENIEZASOB_OBCIAZ+ ', ' +
{4}   'ZZ.' + sLWPJEDNCZAS_ID         + ', ZZ.' + sZLEZLECENIEZASOB_WYD   + ', ' +
{6}   'ZZ.' + sZLEZLECENIEZASOB_WYDJED+ ', ' +
        // pola tabel 'obcych'
{7}   'ZA.' + sZLEZASOB_SYMBOL        + ', ZA.' + sZLEZASOB_NAZWA         + ', ' +
{9}   'ZA.' + sZLEZASOB_STAWKA        + ', ZA.' + sZLEZASOB_RODZAJ        + ', ' +
{11}  'OS.' + sKDOSOBA_SYMBOL         + ', RZ.' + sZLECONST_RODZAJZASOBU_V
    ;
    sTabele :=
      '%s ' + sZLEALIAS_ZLECENIE  +
        ' inner join %s ZZ' +
          ' on ' + sZLEALIAS_ZLECENIE + '.' + sZLEZLECENIE_ID + ' = ZZ.' + sZLEZLECENIE_ID  +
        ' inner join %s ZA' +
          ' on ZZ.' + sZLEZASOB_ID  + ' = ZA.'  + sZLEZASOB_ID  +
        ' left outer join %s OS' +
          ' on ZA.' + sKDOSOBA_ID + ' = OS.'  + sKDOSOBA_ID +
        ' inner join %s RZ' +
          ' on ZA.' + sZLEZASOB_RODZAJ  + ' = RZ.'  + sZLECONST_RODZAJZASOBU_ID
    ;
    sWhere  := sZLEALIAS_ZLECENIE + '.' + sZLEZLECENIE_ID + ' = ' + IntToStr(ac_iZlecenieId);
    if(DataManagers.Available(sLWPModulID)) then begin
      sPola := sPola + ', ' +
{13}    sLWPAlias_RecepturaPoz    + '.' + sLWPRECEPPOZ_KOLEJNOSC  + ', ' +
{14}    sLWPAlias_ZasobWydJednCzas+ '.' + sLWPJEDNCZAS_SYMBOL + ' as ' + sLWPAlias_ZasobWydJednCzas_Symbol+ ', ' +
{15}    sLWPAlias_ZasobWydJednCzas+ '.' + sLWPJEDNCZAS_NAZWA  + ' as ' + sLWPAlias_ZasobWydJednCzas_Nazwa + ', ' +
{16}    sLWPAlias_Jednostka       + '.' + sLWPJEDNCZAS_SYMBOL + ', ' +
{17}    sLWPAlias_Jednostka       + '.' + sLWPJEDNCZAS_NAZWA  + ', ' +
{18}    '(CASE WHEN ' +
          'ZZ.'  + sZLEZLECENIEZASOB_WYD + ' = 0 or ' +
          'ZZ.'  + sZLEZLECENIEZASOB_PLAN + ' is null or ' +
          'ZZ.'  + sZLEZLECENIEZASOB_PLAN + ' <> ''' + sTak + '''' +
          ' THEN NULL' +
          ' ELSE ' +
            sZLEALIAS_ZLECENIE  + '.' + sZLEZLECENIE_ILOSC + ' / ' +
              'ZZ.'  + sZLEZLECENIEZASOB_WYD +
          ' END' +
        ') as CzasZaj, '  +
{19}    sLWPAlias_Jednostka       + '.' + sLWPJEDNCZAS_SYMBOL + ' as ZajJednSymb, ' +
{20}    sLWPAlias_Jednostka       + '.' + sLWPJEDNCZAS_NAZWA  + ' as ZajJednNazwa'
      ;
      sTabele := sTabele +
        ' left outer join %s ' + sLWPAlias_RecepturaPozZasob  +
          ' on ZZ.' + sLWPRECEPPOZZASOB_ID + ' = ' + sLWPAlias_RecepturaPozZasob + '.' + sLWPRECEPPOZZASOB_ID +
        ' left outer join %s ' + sLWPAlias_Jednostka  +
          ' on ZZ.'  + sLWPJEDNCZAS_ID + ' = ' + sLWPAlias_Jednostka + '.' + sLWPJEDNCZAS_ID  +
        ' left outer join %s ' + sLWPAlias_ZasobWydJednCzas  +
          ' on ZZ.'  + sZLEZLECENIEZASOB_WYDJED + ' = ' + sLWPAlias_ZasobWydJednCzas + '.' + sLWPJEDNCZAS_ID  +
        ' left outer join %s '  + sLWPAlias_RecepturaPoz  +
          ' on ' + sLWPAlias_RecepturaPozZasob + '.' + sLWPRECEPPOZ_ID  + ' = ' + sLWPAlias_RecepturaPoz + '.' + sLWPRECEPPOZ_ID
      ;
      oQuery  := SQLManager.CreateQuery(
        'select ' + sPola +
        ' from ' + sTabele+
        ' where ' + sWhere+
        ' order by ' +
          sLWPAlias_RecepturaPoz    + '.' + sLWPRECEPPOZ_KOLEJNOSC,
        [
          sZLEZLECENIE          , sZLEZLECENIEZASOB , sZLEZASOB   , sKDOSOBA    ,
          sZLECONST_RODZAJZASOBU, sLWPRECEPPOZZASOB , sLWPJEDNCZAS, sLWPJEDNCZAS,
          sLWPRECEPPOZ
        ]
      );
    end else begin  // if(DataManagers.Available(sLWPModulID))
      oQuery  := SQLManager.CreateQuery(
        'select ' + sPola +
        ' from ' + sTabele+
        ' where ' + sWhere,
        [
          sZLEZLECENIE          , sZLEZLECENIEZASOB , sZLEZASOB   , sKDOSOBA    ,
          sZLECONST_RODZAJZASOBU
        ]
      );
    end;
    try
        // usunicie istniejcych zasobw dodanych podczas wyboru receptury
      m_oZasobyGrid.DataModule.ActiveQuery.First();
      while(not m_oZasobyGrid.DataModule.ActiveQuery.IsEmpty()) do
        m_oZasobyGrid.DataModule.ActiveQuery.Delete();
      oQuery.Open();
      while(not oQuery.Eof) do begin
        with(m_oZasobyGrid.DataModule.ActiveQuery as TVirtualDataSet) do begin
          VState  := vsInternalInsert;
          try
            Insert();
            FieldByName(sZLEZLECENIEZASOB_ID).AsInteger := UniqueKey[sZLEZLECENIEZASOB];
            FieldByName(sZLEZLECENIE_ID).AsInteger      := DMAQFbN(sZLEZLECENIE_ID).AsInteger;
            FieldByName(sZLEZASOB_ID).AsInteger         := oQuery.Fields[0].AsInteger;
            if(not oQuery.Fields[1].IsNull) then
              FieldByName(sLWPRECEPPOZZASOB_ID).AsInteger  := oQuery.Fields[1].AsInteger;
            if(not oQuery.Fields[2].IsNull) then
              FieldByName(sZLEZLECENIEZASOB_PLAN).AsString  := oQuery.Fields[2].AsString;
            if(not oQuery.Fields[3].IsNull) then
              FieldByName(sZLEZLECENIEZASOB_OBCIAZ).AsFloat := oQuery.Fields[3].AsFloat;
            if(not oQuery.Fields[4].IsNull) then
              FieldByName(sLWPJEDNCZAS_ID).AsInteger  := oQuery.Fields[4].AsInteger;
            if(not oQuery.Fields[5].IsNull) then
              FieldByName(sZLEZLECENIEZASOB_WYD).AsFloat  := oQuery.Fields[5].AsFloat;
            if(not oQuery.Fields[6].IsNull) then
              FieldByName(sZLEZLECENIEZASOB_WYDJED).AsInteger := oQuery.Fields[6].AsInteger;
            SetTechnicalFieldsOnInsert();
            UpdateModifiedRecordFlagsForAddedRecord();
            for i := 7 to oQuery.Fields.Count-1 do begin
              if(FindField(oQuery.Fields[i].FieldName) <> nil) then
                FindField(oQuery.Fields[i].FieldName).AsString  := oQuery.Fields[i].AsString;
            end;  // for i := 7 to oQuery.Fields.Count-1
            Post();
          finally
            VState := vsNormal;
          end;
        end;  // with(m_oZasobyGrid.DataModule.ActiveQuery as TVirtualDataSet)
        oQuery.Next();
      end;  // while(not oQuery.Eof)
      m_oZasobyGrid.DataModule.ActiveQuery.First();
    finally
      oQuery.Free();
    end;
  end;  // procedure SkopiujZasoby

  procedure SkopiujMaterialy();
  var
    oQuery:   TUNIQuery;
    sPola:    string;
    sTabele:  string;
    sWhere:   string;
    i:        integer;
  begin
    //Jak nie ma moduu ASO, to nie ma materiaw
    if (DataManagers.Available(sASOModulID)) then Exit;

    sPola :=
        // pola tabeli zlezleceniemat
{0}   sZLEALIAS_ZlecenieMaterial  + '.' + sLWPRECEPPOZMATERIAL_ID + ', ' +
{1}   sZLEALIAS_ZlecenieMaterial  + '.' + sASOASORT_ID            + ', ' +
{2}   sZLEALIAS_ZlecenieMaterial  + '.' + sZLEZLECENIEMAT_ILOSC   + ', ' +
{3}   sZLEALIAS_ZlecenieMaterial  + '.' + sLWPRECEPPOZOPER_ID     + ', ' +
{4}   sZLEALIAS_ZlecenieMaterial  + '.' + sLWPRECEPPOZOPERZAM_ID  + ', ' +
{5}   sZLEALIAS_ZlecenieMaterial  + '.' + sASOASORTKMAT_ID        + ', ' +
        // pola tabel 'obcych'
{6}   sLWPAlias_ASOAsort  + '.' + sASOASORT_SYMBOL  + ', ' +
{7}   sLWPAlias_ASOAsort  + '.' + sASOASORT_NAZWA   + ', ' +
{8}   sLWPAlias_ASOAsort  + '.' + sASOASORT_INDEKS  + ', ' +
{9}   sLWPAlias_ASOAsort  + '.' + sASOASORT_PKWIU   + ', ' +
{10}  sLWPAlias_ASOGras   + '.' + sASOGRAS_SYMBOL   + ', ' +
{11}  sLWPAlias_ASOGras   + '.' + sASOGRAS_NAZWA    + ', ' +
{12}  'J.'  + sUNIJM_SYMBOL + ', ' +
{13}  SQLManager.GetTableName(sMAG_SP_MAGZWROCSTANDYSP) + '(' + sLWPAlias_ASOAsort + '.' + sASOASORT_ID + ') as STANDYSP, ' +
{14}  SQLManager.GetTableName(sMAG_SP_MAGZWROCSTANIL) + '(' + sLWPAlias_ASOAsort + '.' + sASOASORT_ID + ') as STANMAG, ' +
{15}  sZLEALIAS_ZLECENIE  + '.' + sZLEZLECENIE_ILOSC  + ', ' +
{16}  'KM.' + sASOKMAT_SYMBOL + ', KM.' + sASOKMAT_NAZWA
    ;
    sTabele :=
      '%s ' + sZLEALIAS_ZLECENIE  +
        ' inner join %s ' + sZLEALIAS_ZlecenieMaterial +
          ' on ' + sZLEALIAS_ZLECENIE + '.' + sZLEZLECENIE_ID + ' = ' + sZLEALIAS_ZlecenieMaterial + '.' + sZLEZLECENIE_ID  +
        ' inner join %s ' + sLWPAlias_ASOAsort  +
          ' on ' + sZLEALIAS_ZlecenieMaterial + '.' + sASOASORT_ID  + ' = ' + sLWPAlias_ASOAsort + '.'  + sASOASORT_ID  +
        ' left outer join %s ' + sLWPAlias_ASOGras  +
          ' on ' + sLWPAlias_ASOAsort + '.' + sASOGRAS_ID + ' = ' + sLWPAlias_ASOGras + '.'  + sASOGRAS_ID +
        ' inner join %s J' +
          ' on ' + sLWPAlias_ASOAsort + '.' + sUNIJM_ID1  + ' = J.' + sUNIJM_ID +
        ' left outer join %s AKM' +
          ' on ' + sZLEALIAS_ZlecenieMaterial + '.' + sASOASORTKMAT_ID + ' = AKM.' + sASOASORTKMAT_ID +
        ' left outer join %s KM'  +
          ' on AKM.' + sASOKMAT_ID + ' = KM.' + sASOKMAT_ID
    ;
    sWhere  := sZLEALIAS_ZLECENIE + '.' + sZLEZLECENIE_ID + ' = ' + IntToStr(ac_iZlecenieId);
    if(DataManagers.Available(sLWPModulID)) then begin
      sPola := sPola + ', ' +
{18}    sLWPAlias_RecepturaPoz  + '.' + sLWPRECEPPOZ_ID + ', ' +
{19}    sLWPAlias_RecepturaPoz  + '.' + sLWPRECEPTURA_ID
      ;
      sTabele := sTabele +
        ' left outer join %s ' + sLWPAlias_RecepturaPozMaterial +
          ' on ' + sZLEALIAS_ZlecenieMaterial + '.' + sLWPRECEPPOZMATERIAL_ID + ' = ' + sLWPAlias_RecepturaPozMaterial + '.' + sLWPRECEPPOZMATERIAL_ID  +
        ' left outer join %s ' + sLWPAlias_RecepturaPoz +
          ' on ' + sLWPAlias_RecepturaPozMaterial + '.' + sLWPRECEPPOZ_ID + ' = ' + sLWPAlias_RecepturaPoz + '.' + sLWPRECEPPOZ_ID
      ;
      oQuery  := SQLManager.CreateQuery(
        'select ' + sPola +
        ' from ' + sTabele+
        ' where ' + sWhere+
        ' order by ' +
          sLWPAlias_RecepturaPoz    + '.' + sLWPRECEPPOZ_KOLEJNOSC,
        [
          sZLEZLECENIE, sZLEZLECENIEMAT     , sASOASORT   , sASOGRAS,
          sUNIJM      , sASOASORTKMAT, sASOKMAT, sLWPRECEPPOZMATERIAL, sLWPRECEPPOZ
        ]
      );
    end else begin  // if(DataManagers.Available(sLWPModulID))
      oQuery  := SQLManager.CreateQuery(
        'select ' + sPola +
        ' from ' + sTabele+
        ' where ' + sWhere,
        [
          sZLEZLECENIE, sZLEZLECENIEMAT     , sASOASORT   , sASOGRAS,
          sUNIJM, sASOASORTKMAT, sASOKMAT
        ]
      );
    end;
    try
        // usunicie istniejcych zasobw dodanych podczas wyboru receptury
      m_oMaterialGrid.DataModule.ActiveQuery.First();
      while(not m_oMaterialGrid.DataModule.ActiveQuery.IsEmpty()) do
        m_oMaterialGrid.DataModule.ActiveQuery.Delete();
      oQuery.Open();
      while(not oQuery.Eof) do begin
        with(m_oMaterialGrid.DataModule.ActiveQuery as TVirtualDataSet) do begin
          VState  := vsInternalInsert;
          try
            Insert();
            FieldByName(sZLEZLECENIEMAT_ID).AsInteger := UniqueKey[sZLEZLECENIEMAT];
            FieldByName(sZLEZLECENIE_ID).AsInteger    := DMAQFbN(sZLEZLECENIE_ID).AsInteger;
            FieldByName(sASOASORT_ID).AsInteger       := oQuery.Fields[1].AsInteger;
            if(not oQuery.Fields[0].IsNull) then
              FieldByName(sLWPRECEPPOZMATERIAL_ID).AsInteger  := oQuery.Fields[0].AsInteger;
            if(not oQuery.Fields[2].IsNull) then
              FieldByName(sZLEZLECENIEMAT_ILOSC).AsFloat  := oQuery.Fields[2].AsFloat;
            if(not oQuery.Fields[3].IsNull) then
              FieldByName(sLWPRECEPPOZOPER_ID).AsInteger  := oQuery.Fields[3].AsInteger;
            if(not oQuery.Fields[4].IsNull) then
              FieldByName(sLWPRECEPPOZOPERZAM_ID).AsInteger  := oQuery.Fields[4].AsInteger;
            if(not oQuery.Fields[5].IsNull) then
              FieldByName(sASOASORTKMAT_ID).AsInteger  := oQuery.Fields[5].AsInteger;
            SetTechnicalFieldsOnInsert();
            UpdateModifiedRecordFlagsForAddedRecord();
            for i := 6 to oQuery.Fields.Count-1 do begin
              if(FindField(oQuery.Fields[i].FieldName) <> nil) then
                FindField(oQuery.Fields[i].FieldName).AsString  := oQuery.Fields[i].AsString;
            end;  // for i := 6 to oQuery.Fields.Count-1
            Post();
          finally
            VState := vsNormal;
          end;
        end;  // with(m_oMaterialGrid.DataModule.ActiveQuery as TVirtualDataSet)
        oQuery.Next();
      end;  // while(not oQuery.Eof)
      m_oMaterialGrid.DataModule.ActiveQuery.First();
    finally
      oQuery.Free();
    end;
  end;  // procedure SkopiujMaterialy

  procedure SkopiujPozycje(
    a_oPozycjeId: TStringList
  );
  var
    oQuery:   TUNIQuery;
    sPola:    string;
    sTabele:  string;
    sWhere:   string;
    i:        integer;
  begin
    sPola :=
        // pola tabeli zlezleceniepoz
{0}   'P.'  + sZLEZLECENIEPOZ_LP    + ', P.'  + sZLEZLECENIEPOZ_OPIS      + ', ' +
{2}   'P.'  + sZLEZLECENIEPOZ_ILOSC + ', P.'  + sZLEZLECENIEPOZ_POZIOMINF + ', ' +
{4}   'P.'  + sZLEZLECENIEPOZ_INF_ID+ ', P.'  + sLFKWZORDEKR_ID           + ', ' +
{6}   'P.'  + sASOASORT_ID          + ', P.'  + sBOKSPRAWA_ID             + ', ' +
{8}   'P.'  + sZLEZLECENIEPOZ_ID    + ', P.'  + sZLEZLECENIEPOZ_WARTOSC   + ', ' +
        // pola tabel 'obcych'
{10}   'Z.'  + sZLETYPZLEC_ID;
    if (DataManagers.Available(sLFKModulID)) then
{11}    sPola := sPola  + ', W.'  + sLFKWZORDEKR_NR_DEKR;

    if (DataManagers.Available(sASOModulID)) then
      sPola := sPola  + ', ' +
{12}  'A.'  + sASOASORT_INDEKS      + ', A.'  + sASOASORT_SYMBOL          + ', ' +
{14}  'A.'  + sASOASORT_NAZWA;

    sTabele :=
      SQLManager.GetTableName(sZLEZLECENIE) + ' Z' +
        ' inner join ' + SQLManager.GetTableName(sZLEZLECENIEPOZ) + ' P' +
          ' on Z.'  + sZLEZLECENIE_ID + ' = P.' + sZLEZLECENIE_ID;

    if (DataManagers.Available(sLFKModulID)) then
      sTabele := sTabele  + ' left outer join ' + SQLManager.GetTableName(sLFKWZORDEKR) + ' W' +
          ' on P.'  + sLFKWZORDEKR_ID + ' = W.' + sLFKWZORDEKR_ID;

    if (DataManagers.Available(sASOModulID)) then
      sTabele := sTabele  + ' left outer join ' + SQLManager.GetTableName(sASOASORT) +' A' +
          ' on P.'  + sASOASORT_ID  + ' = A.' + sASOASORT_ID;

    sWhere  := 'Z.' + sZLEZLECENIE_ID + ' = ' + IntToStr(ac_iZlecenieId);

    if(DataManagers.Available(sBOKModulID)) then begin
      sPola := sPola + ', ' +
{15}    'S.'  + sBOKSPRAWA_NUMER  + ', S.'  + sBOKSPRAWA_OBIEKTOPIS;

      if(DataManagers.Available(sINFModulID)) then begin
        sPola := sPola + ', ' +
{16}      'CAST(' + SQLManager.GetSPName(sINF_DAJSYMBOLOBIEKTU) + '(S.' + sBOKSPRAWA_OBIEKTJAKI + ', S.' + sBOKSPRAWA_OBIEKTID + ') AS VARCHAR2(100)) as OBIEKT_SYMBOL'
        ;
      end;  // if(DataManagers.Available(sINFModulID))
      sTabele := sTabele  +
        ' left outer join ' + SQLManager.GetTableName(sBOKSPRAWA) + ' S' +
          ' on P.'  + sBOKSPRAWA_ID + ' = S.' + sBOKSPRAWA_ID
      ;
    end;

    oQuery  := SQLManager.CreateQuery(
        'select ' + sPola   +
        ' from '  + sTabele +
        ' where ' + sWhere
      );

    try
      oQuery.Open();
      while(not oQuery.Eof) do begin
        with(m_oPozycjaGrid.DataModule.ActiveQuery as TVirtualDataSet) do begin
          VState  := vsInternalInsert;
          try
            Insert();
            FieldByName(sZLEZLECENIEPOZ_ID).AsInteger := UniqueKey[sZLEZLECENIEPOZ];
            a_oPozycjeId.Add(oQuery.Fields[8].AsString + '=' + FieldByName(sZLEZLECENIEPOZ_ID).AsString);
            FieldByName(sZLEZLECENIE_ID).AsInteger    := DMAQFbN(sZLEZLECENIE_ID).AsInteger;
            if(not oQuery.Fields[0].IsNull) then
              FieldByName(sZLEZLECENIEPOZ_LP).AsInteger := oQuery.Fields[0].AsInteger;
            if(not oQuery.Fields[1].IsNull) then
              FieldByName(sZLEZLECENIEPOZ_OPIS).AsString:= oQuery.Fields[1].AsString;
            if(not oQuery.Fields[2].IsNull) then
              FieldByName(sZLEZLECENIEPOZ_ILOSC).AsFloat:= oQuery.Fields[2].AsFloat;
            if(not oQuery.Fields[3].IsNull) then
              FieldByName(sZLEZLECENIEPOZ_POZIOMINF).AsString := oQuery.Fields[3].AsString;
            if(not oQuery.Fields[4].IsNull) then
              FieldByName(sZLEZLECENIEPOZ_INF_ID).AsInteger   := oQuery.Fields[4].AsInteger;
            if(not oQuery.Fields[5].IsNull) then
              FieldByName(sLFKWZORDEKR_ID).AsInteger:= oQuery.Fields[5].AsInteger;
            if(not oQuery.Fields[6].IsNull) then
              FieldByName(sASOASORT_ID).AsInteger   := oQuery.Fields[6].AsInteger;
            if(not oQuery.Fields[7].IsNull) then
              FieldByName(sBOKSPRAWA_ID).AsInteger  := oQuery.Fields[7].AsInteger;
            if(not oQuery.Fields[9].IsNull) then
              FieldByName(sZLEZLECENIEPOZ_WARTOSC).AsFloat:= oQuery.Fields[9].AsFloat;
            SetTechnicalFieldsOnInsert();
            UpdateModifiedRecordFlagsForAddedRecord();
            for i := 10 to oQuery.Fields.Count-1 do begin
              if(FindField(oQuery.Fields[i].FieldName) <> nil) then
                FindField(oQuery.Fields[i].FieldName).AsString  := oQuery.Fields[i].AsString;
            end;  // for i := 3 to oQuery.Fields.Count-1
            Post();
          finally
            VState := vsNormal;
          end;
        end;  // with(m_oPozycjaGrid.DataModule.ActiveQuery as TVirtualDataSet)
        oQuery.Next();
      end;  // while(not oQuery.Eof)
      m_oPozycjaGrid.DataModule.ActiveQuery.First();
      a_oPozycjeId.Sort();
    finally
      oQuery.Free();
    end;
  end;  // procedure SkopiujPozycje


(*******************POLA UZ***************************
  function  ZnajdzPoleUZ(
    const ac_iDefId:    integer;
    const ac_iZlePozId: integer;
          a_oDataSet:   TDataSet
  ):  boolean;
  begin
      {
        UWAGA
          rekordy w a_oDataSet MUSZ by posortowane po sZLEPOLAZMDEF_ID
      }
    result  := UNILocate(a_oDataSet, sZLEPOLAZMDEF_ID, IntToStr(ac_iDefId));
    if(ac_iZlePozId > 0) then begin
      while(
        (not a_oDataSet.Eof) and
        (a_oDataSet.FieldByName(sZLEPOLAZMDEF_ID).AsInteger = ac_iDefId) and
        (a_oDataSet.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger <> ac_iZlePozId)
      ) do
        a_oDataSet.Next();
      result  := (
        (a_oDataSet.FieldByName(sZLEPOLAZMDEF_ID).AsInteger = ac_iDefId) and
        (a_oDataSet.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger = ac_iZlePozId)
      );
    end;  // if(ac_iZlePozId > 0)
  end;  // function  ZnajdzPoleUZ

  procedure SkopiujPolaUZNaglowka();
  var
    oQuery: TUNIQuery;
    oGrid:  TZLEPoleZmGridForm;
    i:      integer;
  begin
    oQuery  := SQLManager.CreateQuery(
      'select ' +
{0}     'WA.' + sZLEPOLAZMDEF_ID      + ', WA.' + sFKUZ_ID              + ', ' +
{2}     'WA.' + sZLEPOLAZM_WART       + ', WA.' + sZLEPOLAZM_DOMENAWART_ID  + ', ' +
{4}     'WS.' + sZLEPOLAZMWSK_POZYCJA + ', DE.' + sUNICONSTDEF_ID       + ', ' +
{6}     'DE.' + sZLEPOLAZMDEF_NAZWA   + ', DE.' + sZLEPOLAZMDEF_TYP     + ', ' +
{8}     'DE.' + sZLEPOLAZMDEF_DLUG    + ', DE.' + sZLEPOLAZMDEF_TYPDANYCH + ', ' +
{10}    'DE.' + sZLEPOLAZMDEF_ZNAKI   + ', DE.' + sZLEPOLAZMDEF_FORMAT  + ', ' +
{12}    'DE.' + sFKMNEMONIKI_ID       + ', FK.' + sFKUZ_SYMBOL          + ', ' +
{14}    'MN.' + sFKMNEMONIKI_MNEMONIK + ', MN.' + sFKMNEMONIKI_TABELA   + ', ' +
{16}    'CO.' + sUNICONSTDEF_DOMENA   +
      ' from ' +
        '%s WA'  +
          ' inner join %s DE' +
            ' on WA.' + sZLEPOLAZMDEF_ID  + ' = DE.'  + sZLEPOLAZMDEF_ID  +
          ' inner join %s WS' +
            ' on WA.' + sZLEPOLAZMDEF_ID  + ' = WS.'  + sZLEPOLAZMDEF_ID  +
          ' left outer join %s FK'  +
            ' on WA.' + sFKUZ_ID  + ' = FK.'  + sFKUZ_ID  +
          ' left outer join %s MN'  +
            ' on DE.' + sFKMNEMONIKI_ID + ' = MN.'  + sFKMNEMONIKI_ID +
          ' left outer join %s CO' +
            ' on DE.' + sUNICONSTDEF_ID + ' = CO.'  + sUNICONSTDEF_ID +
      ' where ' +
        'WA.' + sZLEZLECENIE_ID + ' = ' + IntToStr(ac_iZlecenieId)  + ' and ' +
        'WS.' + sZLEPOLAZMWSK_POZYCJA + ' = ''' + sNie + ''' and ' +
        'WS.' + sZLETYPZLEC_ID  + ' = ' + DMAQFbN(sZLETYPZLEC_ID).AsString  +
      ' order by '  +
        'DE.' + sZLEPOLAZMDEF_ID
      ,
      [
        sZLEPOLAZM  , sZLEPOLAZMDEF , sZLEPOLAZMWSK , sFKUZ ,
        sFKMNEMONIKI, sUNICONSTDEF
      ]
    );
    try
      oQuery.Open();
      oGrid := (ContainedForms[PolaUzFormIndex] as TZLEPoleZmGridForm);
      if(oGrid.DataModule.ActiveQuery.IsEmpty()) then
        oGrid.DodajPolaZM(DMAQFbN(sZLETYPZLEC_ID).AsInteger);
      oGrid.DataModule.ActiveQuery.First();
      while(not oGrid.DataModule.ActiveQuery.Eof) do begin
        if(
          ZnajdzPoleUZ(
            oGrid.DMAQFbN(sZLEPOLAZMDEF_ID).AsInteger,
            0,
            oQuery
          )
        ) then begin
          with(oGrid.DataModule.ActiveQuery as TVirtualDataSet) do begin
            VState  := vsInternalInsert;
            try
              Edit();
              if(not oQuery.Fields[1].IsNull) then begin
                oGrid.DMAQFbN(sFKUZ_ID).AsInteger := oQuery.Fields[1].AsInteger;
                ModifiedRecordsFlagsList.SetFieldIsModified(oGrid.DMAQFbN(sFKUZ_ID));
              end;
              if(not oQuery.Fields[2].IsNull) then begin
                oGrid.DMAQFbN(sZLEPOLAZM_WART).AsString := oQuery.Fields[2].AsString;
                ModifiedRecordsFlagsList.SetFieldIsModified(oGrid.DMAQFbN(sZLEPOLAZM_WART));
              end;
              if(not oQuery.Fields[3].IsNull) then begin
                oGrid.DMAQFbN(sZLEPOLAZM_DOMENAWART_ID).AsString := oQuery.Fields[3].AsString;
                ModifiedRecordsFlagsList.SetFieldIsModified(oGrid.DMAQFbN(sZLEPOLAZM_DOMENAWART_ID));
              end;
              for i := 4 to oQuery.Fields.Count-1 do begin
                if(FindField(oQuery.Fields[i].FieldName) <> nil) then
                  FindField(oQuery.Fields[i].FieldName).AsString  := oQuery.Fields[i].AsString;
              end;  // for i := 4 to oQuery.Fields.Count-1
              Post();
            finally
              VState := vsNormal;
            end;
          end;  // with(oGrid.DataModule.ActiveQuery as TVirtualDataSet)
        end;  // if(ZnajdzPoleUZ)
        oGrid.DataModule.ActiveQuery.Next();
      end;  // while(not oGrid.DataModule.ActiveQuery.Eof)
      oGrid.OwnGrid.Init();
    finally
      oQuery.Free();
    end;
  end;  // procedure SkopiujPolaUZNaglowka

  procedure SkopiujPolaUZPozycji(
    const ac_oPozycjeId:  TStringList
  );
  var
    oQuery:   TUNIQuery;
    oDataSet: TDataSet;
    i:        integer;
    bFiltered:boolean;
    sFilter:  string;
    sPozId:   string;
  begin
    bFiltered := false;
    sFilter   := '';
    oDataSet  := (DataModule as TZLEZlecenieDataModule).aZLEZleceniePoleZmDataSet;
    oQuery  := SQLManager.CreateQuery(
      'select ' +
{0}     'WA.' + sZLEPOLAZMDEF_ID      + ', WA.' + sFKUZ_ID              + ', ' +
{2}     'WA.' + sZLEPOLAZM_WART       + ', WA.' + sZLEPOLAZM_DOMENAWART_ID  + ', ' +
{4}     'WA.' + sZLEZLECENIEPOZ_ID    + ', ' +
{5}     'WS.' + sZLEPOLAZMWSK_POZYCJA + ', DE.' + sUNICONSTDEF_ID       + ', ' +
{7}     'DE.' + sZLEPOLAZMDEF_NAZWA   + ', DE.' + sZLEPOLAZMDEF_TYP     + ', ' +
{9}     'DE.' + sZLEPOLAZMDEF_DLUG    + ', DE.' + sZLEPOLAZMDEF_TYPDANYCH + ', ' +
{11}    'DE.' + sZLEPOLAZMDEF_ZNAKI   + ', DE.' + sZLEPOLAZMDEF_FORMAT  + ', ' +
{13}    'DE.' + sFKMNEMONIKI_ID       + ', FK.' + sFKUZ_SYMBOL          + ', ' +
{15}    'MN.' + sFKMNEMONIKI_MNEMONIK + ', MN.' + sFKMNEMONIKI_TABELA   + ', ' +
{17}    'CO.' + sUNICONSTDEF_DOMENA   +
      ' from ' +
        '%s WA'  +
          ' inner join %s DE' +
            ' on WA.' + sZLEPOLAZMDEF_ID  + ' = DE.'  + sZLEPOLAZMDEF_ID  +
          ' inner join %s WS' +
            ' on WA.' + sZLEPOLAZMDEF_ID  + ' = WS.'  + sZLEPOLAZMDEF_ID  +
          ' left outer join %s FK'  +
            ' on WA.' + sFKUZ_ID  + ' = FK.'  + sFKUZ_ID  +
          ' left outer join %s MN'  +
            ' on DE.' + sFKMNEMONIKI_ID + ' = MN.'  + sFKMNEMONIKI_ID +
          ' left outer join %s CO' +
            ' on DE.' + sUNICONSTDEF_ID + ' = CO.'  + sUNICONSTDEF_ID +
      ' where ' +
        'WA.' + sZLEZLECENIE_ID + ' = ' + IntToStr(ac_iZlecenieId)  + ' and ' +
        'WS.' + sZLEPOLAZMWSK_POZYCJA + ' = ''' + sTak + ''' and ' +
        'WS.' + sZLETYPZLEC_ID  + ' = ' + DMAQFbN(sZLETYPZLEC_ID).AsString  +
      ' order by '  +
        'DE.' + sZLEPOLAZMDEF_ID
      ,
      [
        sZLEPOLAZM  , sZLEPOLAZMDEF , sZLEPOLAZMWSK , sFKUZ ,
        sFKMNEMONIKI, sUNICONSTDEF
      ]
    );
    try
      oQuery.Open();
      sFilter   := oDataSet.Filter;
      bFiltered := oDataSet.Filtered;
      m_oPozycjaGrid.DataModule.ActiveQuery.First();
      while(not m_oPozycjaGrid.DataModule.ActiveQuery.Eof) do begin
        oDataSet.Filter := sZLEZLECENIEPOZ_ID + '=' + m_oPozycjaGrid.DMAQFbN(sZLEZLECENIEPOZ_ID).AsString;
        oDataSet.Filtered := true;
        pReReadOthersPoz();
        m_oPozycjaGrid.DataModule.ActiveQuery.Next();
      end;  // while(not m_oPozycjaGrid.DataModule.ActiveQuery.Eof)
      m_oPozycjaGrid.DataModule.ActiveQuery.First();
      oDataSet.Filtered := false;
      oDataSet.Filter   := '';
      oDataSet.First();
      while(not oDataSet.Eof) do begin
        sPozId  := ac_oPozycjeId.Values[oDataSet.FieldByName(sZLEZLECENIEPOZ_ID).AsString];
        if(Length(sPozId) > 0) then begin
          if(
            ZnajdzPoleUZ(
              oDataSet.FieldByName(sZLEPOLAZMDEF_ID).AsInteger,
              StrToInt(sPozId),
              oQuery
            )
          ) then begin
            oDataSet.Edit();
            try
              if(not oQuery.Fields[1].IsNull) then
                oDataSet.FieldByName(sFKUZ_ID).AsInteger := oQuery.Fields[1].AsInteger;
              if(not oQuery.Fields[2].IsNull) then
                oDataSet.FieldByName(sZLEPOLAZM_WART).AsString := oQuery.Fields[2].AsString;
              if(not oQuery.Fields[3].IsNull) then
                oDataSet.FieldByName(sZLEPOLAZM_DOMENAWART_ID).AsString := oQuery.Fields[3].AsString;
              for i := 5 to oQuery.Fields.Count-1 do begin
                if(oDataSet.FindField(oQuery.Fields[i].FieldName) <> nil) then
                  oDataSet.FindField(oQuery.Fields[i].FieldName).AsString  := oQuery.Fields[i].AsString;
              end;  // for i := 5 to oQuery.Fields.Count-1
              oDataSet.Post();
            except
              oDataSet.Cancel();
              raise;
            end;
          end;  // if(ZnajdzPoleUZ)
        end;  // if(Length(sPozId) > 0)
        oDataSet.Next();
      end;  // while(not oDataSet.Eof)
    finally
      oQuery.Free();
      oDataSet.Filter   := sFilter;
      oDataSet.Filtered := bFiltered;
    end;
  end;  // procedure SkopiujPolaUZPozycji
*******************POLA UZ***************************)

var
  oPozycje: TStringList;
begin
  oPozycje  := TStringList.Create();
  try
    bKopiuj := True;
    //iElementDomID := ac_iZlecenieId;
    SkopiujNaglowek();
    if(m_oZasobyGrid <> nil) then
      SkopiujZasoby();
    if(m_oMaterialGrid <> nil) then
      SkopiujMaterialy();

(*******************POLA UZ***************************
    if(PolaUzFormIndex > -1) then
      SkopiujPolaUZNaglowka();
*******************POLA UZ***************************)
    PrzebudujPolaUzytkownikaNew();

    SkopiujPolaUZNaglowkaTejSamejFunkcji(
      ac_iZlecenieId,
      cPolaUZ_ZLEZlecenie,
      DMAQFBN(sZLETYPZLEC_ID).AsInteger,
      m_oZakladkiParents,
      m_oPolaUZGridy
    );



    if not ZLEDM.vZLEKopiujZlecenieBezPozycji then begin
       SkopiujPozycje(oPozycje);
       SkopiujPolaUZPozycjiTejSamejFunkcji(
          ac_iZlecenieId,
          DMAQFbN(sZLEZLECENIE_ID).AsInteger,
          oPozycje,
          cPolaUZ_ZLEPozycja,
          DMAQFBN(sZLETYPZLEC_ID).AsInteger,
          m_oZakladkiPozId,
          m_oZakladkiPozGridy
        );
      m_oPozycjaGrid.DataModule.ActiveQuery.AfterScroll := pPozycjeAfterScroll;
      pPozycjeAfterScroll(m_oPozycjaGrid.DataModule.ActiveQuery);
    end;

(*******************POLA UZ***************************
    if not ZLEDM.vZLEKopiujZlecenieBezPozycji then begin
      SkopiujPolaUZPozycji(oPozycje);
      //m_oPozycjaGrid.DataModule.ActiveQuery.AfterScroll := pPozycjeAfterScroll;
      //pPozycjeAfterScroll(m_oPozycjaGrid.DataModule.ActiveQuery);
    end;
*******************POLA UZ***************************)
  finally
    bKopiuj := False;
    oPozycje.Free();
  end;
  {Ustawic pola ze wzgledu na aktualny status po skopiowaniu}
  StatusChanged();
end;

procedure TZLEZlecenieDBDetailForm.InitializeControls;
var oQuery: TUNIQuery;
    sSQL: String;
begin
  //ustawienia pl dla kontrolek
  OddzialDBLookupAliasEdit.Hint := '';
  OddzialDBLookupAliasEdit.ShowHint := True;

  SymbolDBEdit.DataField := sZLEZLECENIE_SYMBOL;
  NazwaDBEdit.DataField := sZLEZLECENIE_NAZWA;
  Pole1DBEdit.DataField := sZLEZLECENIE_POLE1;
  Pole2DBEdit.DataField := sZLEZLECENIE_POLE2;
  Pole3DBEdit.DataField := sZLEZLECENIE_POLE3;
  DataOtwarciaDBDateEdit.DataField := sZLEZLECENIE_DATA_OTW;
  DataZakonczeniaDBDateEdit.DataField := sZLEZLECENIE_DATA_ZAMK;
  StatusZleceniaDBConstComboBox.Items.AddStrings( cslZLEStatusZlecenia );
  StatusZleceniaDBConstComboBox.DataField := sZLEZLECENIE_STATUS;
  PodstawaPotwierdzeniaDBEdit.DataField := sZLEZLECENIE_STATUS_PODST;
  OpisDBMemo.DataField := sZLEZLECENIE_OPIS;

  SprawaOpisLabel.Caption := '';
  UmowaOpisLabel.Caption := '';

  ModulZSIDBLookupAliasEdit.aReadOnly := True;

  StatusZleceniaDBConstComboBox.Enabled := (OpenMode in [omNew,omEdit]);

  TypZleceniaDBLookupAliasEdit.aReadOnly := (not (OpenMode = OmNew));

  oQuery := nil;
  sSQL := UNISysDM.UNIOdpytajODaneSQL( sFKMNEMONIKI, sFKAlias_Mnemoniki_Indeks + ';' + sFKAlias_Mnemoniki_Dlugosc,
                                       '(@'+sFKAlias_Mnemoniki_Mnemonik+'='+QuotedStr(sMnemonikZlecenie)+')and'+
                                       '(@'+sFKAlias_Mnemoniki_Dlugosc+'>0)',
                                       False, UNISysDM.vAktywnaFirma );
  try
    oQuery := SQLManager.CreateQuery( sSQL );
    oQuery.Open;
    Pole1Panel.Visible := oQuery.Locate( sFKMNEMONIKI_INDEKS, 1, [] );
    Pole1DBEdit.MaxLength := oQuery.Fields[1].AsInteger;
    Pole2Panel.Visible := oQuery.Locate( sFKMNEMONIKI_INDEKS, 2, [] );
    Pole2DBEdit.MaxLength := oQuery.Fields[1].AsInteger;
    Pole3Panel.Visible := oQuery.Locate( sFKMNEMONIKI_INDEKS, 3, [] );
    Pole3DBEdit.MaxLength := oQuery.Fields[1].AsInteger;
  finally
    if oQuery <> nil then oQuery.Free
  end;

  ZlecenieGrupujaceNazwaLabel.Caption := '';
  ModulZSINazwaLabel.Caption := '';
  WydzialNazwaLabel.Caption := '';
  WykonawcaNazwaLabel.Caption := '';
  OddzialNazwaLabel.Caption := '';
  ElementINFNazwaLabel.Caption := '';
  PoziomNazwaLabel.Caption := '';

  OddzialPanel.Visible := vWieloodzialowosc or (vWielofirmowosc and UNISYSDM.vWielofirmowoscWieleFirm);
  if (vWielofirmowosc and UNISYSDM.vWielofirmowoscWieleFirm) then
     OddzialLabel.Caption := 'Firma';

  ZleceniePageControl.ActivePage := OgolneTabSheet;
  if(not DataManagers.Available(sZAOModulID)) then begin
    ZapotrzebowaniaPierwTabSheet.TabVisible := false;
    ZapotrzebowaniaWtorneTabSheet.TabVisible:= false;
  end;
  if(not DataManagers.Available(sZAMModulID)) then begin
    ZamowienieTabSheet.TabVisible := false;
    ZapytanieTabSheet.TabVisible  := false;
  end;
  if DataManagers.Available(sASOModulID) then begin
    with AsortymentLookupAliasEdit do begin
      AliasManager  := ASODM.AliasManager;
      Alias_ID      := sASOAlias_Asort_ID;
      Alias_Name    := sASOAlias_Asort_Symbol;
    end;  // with AsortymentLookupAliasEdit
  end else begin
    AsortymentLookupAliasEdit.Visible := False;
  end;
  with RecepturaLookupAliasEdit do begin
    if(not DataManagers.Available(sLWPModulID)) then begin
      Visible                     := false;
      LRecepturaLabel.Visible     := false;
    end else begin
      AliasManager  := LWPDM.AliasManager;
      Alias_ID      := sLWPAlias_Receptura_Id;
      Alias_Name    := sLWPAlias_Receptura_Symbol;
    end;
  end;  // with RecepturaLookupAliasEdit
  MaterialTabSheet.TabVisible := (DataManagers.Available(sMAGModulID) and DataManagers.Available(sASOModulID));
  IloscDBEdit.DataField := sZLEZLECENIE_ILOSC;
  ProcentUEDBEdit.DataField := sZLEZLECENIE_PROCENT_UE;

  PrzeliczDBCheckBox.DataField := sZLEZLECENIE_PRZELICZ;
  PrzeliczDBCheckBox.Enabled := (OpenMode in [omNew, omEdit]);

  PrefixLabel.Visible := False;
  PrefixDBLookupAliasEdit.Visible := False;

  PoziomINFPanel.Visible := False;

  SprawaPanel.Visible := DataManagers.Available(sBOKModulID) and ZLEDM.vZLEZleceniaBezPozycjiZeSpraw;

  DrukujButton.Visible := (OpenMode in [omView, omEdit]) and ZLEDM.vZLEWydrukZlecenia;
  GeneratorButton.Visible := (OpenMode in [omNew, omEdit, omView]) and ZLEDM.vZLEWydrukZlecenia;
  //PrefixDBLookupAliasEdit.Enabled := (OpenMode in [omNew, omEdit]);
end;

procedure TZLEZlecenieDBDetailForm.InternalOpen;
var
  //oOpenMode:  TOpenMode;
  //oKeys:      TKeyValues;
  q: TUNIQuery;
begin
  //bWlaczEdytor := True;

  FPozycjeZleceniaFormIndex := -1;
  FZasobyFormIndex := -1;

  iOkresID := -1;
  iOddzialOld := -1;
  iPrefixOld  := -1;
  bZmianaDaty := False;
  bZmianaOddzialu := False;
  m_bProdukcyjne  := false;
  bSelectButton := False;
  bKopiuj := False;
  //iElementDomID := 0;

  (***
// pocztek sekcji kopiowania pl uz
  m_oPozycjeId        := TStringList.Create();
// koniec sekcji kopiowania pl uz
  ***)

  //inicjalizacja kontrolek
  InitializeControls();
  //inicjalizacja pl obiektu
  InitializeObjectFields();

  if Parameters.Values[cFORM_CAPTION] <> '' then begin
    Caption := Parameters.Values[cFORM_CAPTION];
  end else
    Caption := 'Zlecenie';

  m_iTworzonaFormatka := [frmNone];
  UniDesigner.ModuleID := DataManagers[sZLEModulID].ModulZSI_ID;
  UniDesigner.ModuleSymbol := sZLEModulID;
  DataManagers.ReLoadDesignerFromEnvironment(UNIDesigner);

  inherited;

  m_bZlecenieNaPlanie  := (Parameters.Values[sLWPPLANPROD] = sTak) or ZLEDM.ZlecenieNaPlanieProdukcji(DMAQFbN(sZLEZLECENIE_ID).AsInteger);
  if(m_bZlecenieNaPlanie) then begin
      // wyczamy moliwo zmiany receptury
    AsortymentLookupAliasEdit.Enabled := false;
    RecepturaLookupAliasEdit.Enabled  := false;
  end;  // if(m_bZlecenieNaPlanie)

  //ustawienia oddziau
  OddzialDBLookupAliasEdit.initialize := vWieloodzialowosc or vWielofirmowosc;

  DMAQFbN(sZLEZLECENIE_POZIOMINF).OnChange := FieldChange;
  if OpenMode = omNew then begin
    //ustawienie wartoci domylnych
    SetDefaults();
  end else
  if not DMAQFbN(sZLEZLECENIE_POZIOMINF).IsNull then
     FieldChange(DMAQFbN(sZLEZLECENIE_POZIOMINF));


  {oOpenMode := omList or omContained or omVirtual or omMultiSelect;
  if(OpenMode in [omView, omDelete]) then begin
    oOpenMode := oOpenMode or omReadOnly;
  end;}

//  UtworzPolaUZPozNew();

  //dodanie form osadzonych
  AddContainedForms();

//  WyswietlPolaUzytkownikaNew();

  {Zainicjowanie Typu zlecenia - eby aktywowa odpowiednie panele}
  if (not DMAQFbN(sZLETYPZLEC_ID).IsNull) and (DMAQFbN(sZLETYPZLEC_ID).AsInteger > 0) and (OpenMode in [omNew,omEdit]) and (not TypZleceniaDBLookupAliasEdit.Initialized) then
     TypZleceniaDBLookupAliasEdit.InitiateData(DMAQFbN(sZLETYPZLEC_ID).AsInteger);

  if (OpenMode in [omNew,omEdit]) and (DMAQFbN(sUNIMODULZSI_ID).AsInteger = cBOKModulZSI_ID) then begin
     if (Parameters <> nil) and (Parameters.Values[sBOKUMOWA_ID] <> '') then begin
        //Zlecenie z umowy
        try
          //DMAQFbN(sBOKUMOWA_ID).AsInteger := StrToInt(Parameters.Values[sBOKUMOWA_ID]);
          q := SQLManager.CreateQuery('SELECT UM.' + sBOKUMOWA_ID + ', ' +
                                             '(SELECT BUM.' + sBKKLIENT_ID + ' ' +
                                              'FROM %s BUM ' +
                                              'WHERE BUM.' + sBOKUMOWA_ID + ' = UM.' + sBOKUMOWA_ID + ' ' +
                                               ' AND ROWNUM = 1) AS ' + sBKKLIENT_ID + ', ' +
                                             'UM.' + sBOKUMOWA_OPIS + ', ' +
                                             'UM.' + sBOKUMOWA_NUMER + ', ' +
                                             'UM.' + sBOKUMOWA_DATA_REJ + ', ' +
                                             'UM.' + sUNIODDZIAL_ID + ' ' +
                                      'FROM  %s UM ' +
                                      'WHERE UM.' + sBOKUMOWA_ID + ' = ' + Parameters.Values[sBOKUMOWA_ID],
                                      [sBOKUMOWAKLIENT, sBOKUMOWA]);
           q.Open();
           if not q.IsEmpty then begin
              if q.FieldByName(sBOKUMOWA_ID).AsInteger > 0 then
                 DMAQFbN(sBOKUMOWA_ID).AsInteger := q.FieldByName(sBOKUMOWA_ID).AsInteger;
              if WykonawcaPanel.Visible and (q.FieldByName(sBKKLIENT_ID).AsInteger > 0) then
                 DMAQFbN(sZLEZLECENIE_WYKONAWCA_ID).AsInteger := q.FieldByName(sBKKLIENT_ID).AsInteger;
              if OpisPanel.Visible and (q.FieldByName(sBOKUMOWA_OPIS).AsString <> '') then
                 DMAQFbN(sZLEZLECENIE_OPIS).AsString := q.FieldByName(sBOKUMOWA_OPIS).AsString;
              if not q.FieldByName(sBOKUMOWA_DATA_REJ).IsNull then
                 DMAQFbN(sZLEZLECENIE_DATA_OTW).AsDateTime := q.FieldByName(sBOKUMOWA_DATA_REJ).AsDateTime;
              if OddzialDBLookupAliasEdit.Visible and (q.FieldByName(sUNIODDZIAL_ID).AsInteger > 0) then begin
                 DMAQFbN(sUNIODDZIAL_ID).AsInteger := q.FieldByName(sUNIODDZIAL_ID).AsInteger;
                 OddzialDBLookupAliasEdit.InitiateData(DMAQFbN(sUNIODDZIAL_ID).AsInteger);
              end;
           end;


        except
          // Bez komunikatu??
        end;


     end else begin
       FPodpowiedzDaneSprawy := DopiszPozycjeDlaSprawy();
     end;
  end;

  //domylnie wymuszamy zmian statusu
  StatusChanged();

    //ustawienie wymagalnoci oddziau
  OddzialDBLookupAliasEdit.aAllowEmpty := not (vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial);

  PodstawowyZestawDanych.DataSet := SymbolDBEdit.DataSource.DataSet;

  FMinWidth := 300;
  FMinHeight := 300;
end;


procedure TZLEZlecenieDBDetailForm.WyswietlPolaUzytkownikaNew();
var
  iOpenMode:      TOpenMode;
  i, j:           Integer;
  oZakladkiId,
  oZakladkiNazwy: TStringList;
  oZakladka:      TTabSheet;
  oTabSheet:      TTabSheet;

begin
  oTabSheet := ZleceniePageControl.ActivePage;
  try
    if (m_oPolaUZGridy <> nil) {and (m_oPolaUZGridy.Count > 0)} then begin
      for i := 0 to m_oPolaUZGridy.Count-1 do begin
          // usunicie formatki
        j := FContainedForms.IndexOf(cPolaUzPrefiksZakladki + IntToStr(i));
        if(j > -1) then
          FContainedForms.Delete(j);
        m_oPolaUZGridy.Objects[i].Free();
          // usunicie zakadki
        if(oTabSheet = m_oZakladkiParents.Objects[i]) then
          oTabSheet := nil;
        m_oZakladkiParents.Objects[i].Free();
      end;  // for i := 0 to ContainedFormCount-1

      FreeAndNil(m_oPolaUZGridy);
      //FreeAndNil(m_oZakladkiParents);
    end;  // if(m_oPolaUZGridy <> nil)
    FreeAndNil(m_oZakladkiParents);
  finally
    if(oTabSheet <> nil) then
      ZleceniePageControl.ActivePage  := oTabSheet
    else
      ZleceniePageControl.ActivePageIndex := 0;
  end;

  m_oZakladkiParents  := TStringList.Create();
  m_oPolaUZGridy      := TStringList.Create();
  oZakladkiId         := TStringList.Create();
  oZakladkiNazwy      := TStringList.Create();
  m_iTworzonaFormatka := [frmPolaUz];
  try
    iOpenMode     := omList or omContained or omVirtual;
    if(((OpenModeFlags and omReadOnly) = omReadOnly) or (OpenMode in [omView, omDelete])) then
      iOpenMode := iOpenMode or omReadOnly;

    UNISysDM.UNIPolaUzytkownikaDajZakladki(
      oZakladkiId,
      oZakladkiNazwy,
      cPolaUZ_ZLEZlecenie,
      DMAQFBN(sZLETYPZLEC_ID).AsInteger
    );
    for i := 0 to oZakladkiId.Count-1 do begin
      oZakladka := TTabSheet.Create(Self);
      oZakladka.PageControl := ZleceniePageControl;
      oZakladka.Name        := cPolaUzPrefiksZakladki + IntToStr(i);
      oZakladka.Caption     := oZakladkiNazwy[i];
      oZakladka.PageIndex   := ZleceniePageControl.PageCount - 1;
      oZakladka.TabVisible  := true;

      m_oZakladkiParents.AddObject(
        oZakladkiId[i],
        oZakladka
      );
      m_iPolaUzNr := m_oZakladkiParents.Count;
      m_oPolaUZGridy.AddObject(
        oZakladkiNazwy[i],
        UNISYSDM.UNIPokazIObsluzPolaUzytkownika(
           Self,
           DMAQFBN(sZLEZLECENIE_ID).AsInteger,
           cPolaUZ_ZLEZlecenie,
           DMAQFBN(sZLETYPZLEC_ID).AsInteger,
           StrToInt(oZakladkiId[i]),
           iOpenMode{,
           False,
           '',
           iElementDomID}
        )
      );
      FContainedForms.AddObject(
        cPolaUzPrefiksZakladki + IntToStr(i),
        m_oPolaUZGridy.Objects[i]
      );
    end;  // for i := 0 to oZakladkId.Count-1
  finally
    m_iPolaUzNr := 0;
    oZakladkiId.Free();
    oZakladkiNazwy.Free();
    m_iTworzonaFormatka := [frmNone];
  end;
  for i:=0 to m_oPolaUZGridy.Count-1 do
    (m_oPolaUZGridy.Objects[i] as TUNIForm).Visible:= true;
end;

procedure TZLEZlecenieDBDetailForm.PrzebudujPolaUzytkownikaNew();
var
  i, j:       integer;
  oTabSheet:  TTabSheet;
begin
  oTabSheet     := ZleceniePageControl.ActivePage;
  try
    if (m_oPolaUZGridy <> nil) {and (m_oPolaUZGridy.Count > 0))} then begin
      for i := 0 to m_oPolaUZGridy.Count-1 do begin
          // usunicie formatki
        j := FContainedForms.IndexOf(cPolaUzPrefiksZakladki + IntToStr(i));
        if(j > -1) then
          FContainedForms.Delete(j);
        m_oPolaUZGridy.Objects[i].Free();
          // usunicie zakadki
        if(oTabSheet = m_oZakladkiParents.Objects[i]) then
          oTabSheet := nil;
        m_oZakladkiParents.Objects[i].Free();
      end;  // for i := 0 to ContainedFormCount-1
      FreeAndNil(m_oPolaUZGridy);
    end;  // if((m_oPolaUZGridy <> nil) and (m_oPolaUZGridy.Count > 0))
    if m_oZakladkiParents <> nil then
       FreeAndNil(m_oZakladkiParents);
    WyswietlPolaUzytkownikaNew();
  finally
    if(oTabSheet <> nil) then
      ZleceniePageControl.ActivePage  := oTabSheet
    else
      ZleceniePageControl.ActivePageIndex := 0;
  end;
  PrzebudujPolaUZPozNew();
end;

procedure TZLEZlecenieDBDetailForm.PunktDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  if OpenMode in [omNew, omEdit] then begin
     PunktDBLookupAliasEdit.Text := '';
     PunktOpisLabel.Caption := '';
     DMAQFbN(sINFPUNKT_ID).Clear;
  end;
end;

function TZLEZlecenieDBDetailForm.PunktDBLookupAliasEditGetDataField: string;
begin
  result := sINFPUNKT_ID;
end;

function TZLEZlecenieDBDetailForm.PunktDBLookupAliasEditGetQuery: TUNIQuery;
var
  sWar: String;
begin
  sWar := '';
  inherited;
  if not DMAQFbN(sZLEZLECENIE_WYKONAWCA_ID).IsNull then
     sWar := '(PU.' + sBKKLIENT_ID + ' = ' + DMAQFbN(sZLEZLECENIE_WYKONAWCA_ID).AsString + ')';

  Result := INFDataManager.INFPokazIObsluzDane(sINFPUNKT,
                                               sINFAlias_Punkt_ID  + ';' +
                                               sINFAlias_Punkt_Symbol + ';' +
                                               sINFAlias_Punkt_Nazwa + ';' +
                                               sINFAlias_Punkt_Klient_ID,
                                               sWar,
                                               false,
                                               false,
                                               [],
                                               true,
                                               0,
                                               DMAQFbN(sINFPUNKT_ID).AsString);
end;

procedure TZLEZlecenieDBDetailForm.PunktDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  inherited;
  if DataManagers.Available(sINFModulID) then begin
    with PunktDBLookupAliasEdit do begin
      AliasManager      := INFDM.AliasManager;
      Alias_ID          := sINFAlias_Punkt_ID;
      Alias_Name        := sINFAlias_Punkt_Symbol;
      AdditionalAliases := sINFAlias_Punkt_Nazwa + ';' +
                           sINFAlias_Punkt_Klient_ID;
    end;
  end;
end;

function TZLEZlecenieDBDetailForm.PunktDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  result := True;
  inherited;
  if AliasSrc <> nil then begin
     PunktOpisLabel.Caption := AliasSrc.FieldByName(sINFPUNKT_NAZWA).AsString;
     if (OpenMode in [omNew, omEdit]) and
        (AliasSrc.FieldByName(sBKKLIENT_ID).AsInteger > 0) and
        DMAQFbN(sZLEZLECENIE_WYKONAWCA_ID).IsNull and
        WykonawcaDBLookupAliasEdit.Visible and
        WykonawcaDBLookupAliasEdit.Enabled then begin
        DMAQFbN(sZLEZLECENIE_WYKONAWCA_ID).AsInteger := AliasSrc.FieldByName(sBKKLIENT_ID).AsInteger;
        WykonawcaDBLookupAliasEdit.InitiateData(DMAQFbN(sZLEZLECENIE_WYKONAWCA_ID).AsInteger);
     end;
  end;
end;

procedure TZLEZlecenieDBDetailForm.UtworzPolaUZPozNew();
var
  iOpenMode:          TOpenMode;
  i, j:               integer;
  oZakladkiPozNazwy,
  oZakladkiPozId:     TStringList;
begin
  iOpenMode     := omList or omContained or omVirtual;
  if(((OpenModeFlags and omReadOnly) = omReadOnly) or (OpenMode in [omView, omDelete])) then
    iOpenMode := iOpenMode or omReadOnly;

  if(m_oZakladkiPozGridy <> nil) then begin
     for i := 0 to m_oZakladkiPozGridy.Count-1 do begin
       j := FContainedForms.IndexOf(cPolaUzPrefiksZakladki + IntToStr(gciZLEPolaUZPozIndeks + i));
       if(j > -1) then
          FContainedForms.Delete(j);
       m_oZakladkiPozGridy.Objects[i].Free();
     end;  // for i := 0 to m_oZakladkiPozGridy.Count-1
     FreeAndNil(m_oZakladkiPozGridy);
     FreeAndNil(m_oZakladkiPozId);
  end;

  oZakladkiPozId      := TStringList.Create();
  oZakladkiPozNazwy   := TStringList.Create();
  m_oZakladkiPozGridy := TStringList.Create();
  m_oZakladkiPozId    := TStringList.Create();
  m_iTworzonaFormatka := [frmPolaUzPoz];
  try
    UNISysDM.UNIPolaUzytkownikaDajZakladki(
      oZakladkiPozId,
      oZakladkiPozNazwy,
      cPolaUZ_ZLEPozycja,
      DMAQFBN(sZLETYPZLEC_ID).AsInteger
    );

    for i := 0 to oZakladkiPozId.Count-1 do begin
      m_oZakladkiPozId.Add(oZakladkiPozId[i]);
      m_oZakladkiPozGridy.AddObject(
        oZakladkiPozNazwy[i],
        UNISYSDM.UNIPokazIObsluzPolaUzytkownika(
           Self,
           DMAQFBN(sZLEZLECENIE_ID).AsInteger,
           cPolaUZ_ZLEPozycja,
           DMAQFBN(sZLETYPZLEC_ID).AsInteger,
           StrToInt(oZakladkiPozId[i]),
           iOpenMode{,
           False,
           '',
           iElementDomID}
        )
      );
      FContainedForms.AddObject(
        cPolaUzPrefiksZakladki + IntToStr(gciZLEPolaUZPozIndeks + i),
        m_oZakladkiPozGridy.Objects[i]
      );
    end;  // for i := 0 to oZakladkiPozId.Count-1
  finally
    oZakladkiPozId.Free();
    oZakladkiPozNazwy.Free();
    m_iTworzonaFormatka := [frmNone];
  end;
end;

procedure TZLEZlecenieDBDetailForm.PrzebudujPolaUZPozNew();
var
  i,
  j:            integer;
begin
    // usunicie dotychczasowych pl uytkownika
  if(m_oZakladkiPozGridy <> nil) then begin
    for i := 0 to m_oZakladkiPozGridy.Count-1 do begin
      j := FContainedForms.IndexOf(cPolaUzPrefiksZakladki + IntToStr(gciZLEPolaUZPozIndeks + i));
      if(j > -1) then
        FContainedForms.Delete(j);
      m_oZakladkiPozGridy.Objects[i].Free();
    end;  // for i := 0 to oZakladkiPozId.Count-1
    FreeAndNil(m_oZakladkiPozGridy);
    FreeAndNil(m_oZakladkiPozId);
  end;  // if(m_oZakladkiPozGridy <> nil)
  UtworzPolaUZPozNew();
end;

procedure TZLEZlecenieDBDetailForm.BeforeShow;
var
  sSQL: String;
  q: TUNIQuery;
begin

  inherited;
  {Przeniesione do ZleZlecenieUnit - CreateDataModule}
//  TZLEZlecenieDataModule(DataModule).PrepareaZleZleceniePoleZmDataSet;

  TUNIDBGridForm(FContainedForms.Objects[FPozycjeZleceniaFormIndex]).DataModule.ActiveQuery.AfterScroll := pPozycjeAfterScroll;
  pPozycjeAfterScroll(TUNIDBGridForm(FContainedForms.Objects[FPozycjeZleceniaFormIndex]).DataModule.ActiveQuery);

(*******************POLA UZ***************************
  pReReadOthersPoz;
*******************POLA UZ***************************)
  ShowLookups();

  if (OpenMode = omEdit) or (OpenMode = omDelete) then begin
      {Zapamietane wartosci dla symbolu} //Dla omDelete nie wykonujemy inicjacji??
    if not DMAQFbN(sZLETYPZLEC_ID).IsNull and (OpenMode = omEdit) then
       TypZleceniaDBLookupAliasEdit.InitiateData(DMAQFbN(sZLETYPZLEC_ID).AsInteger);

    iNumeratorStartID := iNumeratorID; //DMAQFbN(sUNIAUTNUM_ID).AsInteger;
    iOkresId := 0;
    if DMAQFbN(sZLEZLECENIE_DATA_OTW).AsDateTime > 0 then begin
       sSQL := 'SELECT ' + sUNIOKRES_ID + ' FROM %s o WHERE ' +
            sUNIOKRES_DATA_POCZ + '<=' + KonwertujDate2SQL(DMAQFbN(sZLEZLECENIE_DATA_OTW).AsDateTime) + ' AND ' +
            sUNIOKRES_DATA_KONCA + '>=' + KonwertujDate2SQL(DMAQFbN(sZLEZLECENIE_DATA_OTW).AsDateTime);

       try
         q := SQLManager.CreateQuery(sSQL, [sUNIOKRES]);
         q.Open;
         if not q.IsEmpty then
            iOkresID := q.FieldByName(sUNIOKRES_ID).AsInteger;
         q.Close;
       finally
         if q <> nil then FreeAndNil(q);
       end;
    end;


    DajTypNumeratora;
    bNumMiesiecznyStart := bNumMiesieczny;
    bNumKodStart        := bNumKod;
    bNumOpisStart       := bNumOpis;
    bNumOpis2Start      := bNumOpis2;

    iOddzialOld         := DMAQFbN(sUNIODDZIAL_ID).AsInteger;
    iOkresStartID       := iOkresID;
    iOddzialStart       := DMAQFbN(sUNIODDZIAL_ID).AsInteger;
    iLicznikStart       := DMAQFbN(sZLEZLECENIE_LICZNIK).AsInteger;
    iPrefixStartID      := DMAQFbN(sZLEZLECENIE_PREFIX_ID).AsInteger;
    sSuffixStart        := DMAQFbN(sZLEZLECENIE_SUFFIX).AsString;
    iRokStartID         := DMAQFbN(sUNIROK_ID).AsInteger; //Rok nie ulega juz zmianie
    sSymbolStart        := DMAQFbN(sZLEZLECENIE_SYMBOL).AsString;
  end;
end;


procedure TZLEZlecenieDBDetailForm.SetDefaults;
var
  oQuery : TUNIQuery;
  oParams: TKeyValues;
  sTekst:   string;
begin
  //ustawienia domylne
  try
    (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := true;

    //ustawienie moduu rdowego
    //Assert(Parameters.Values[sUNIMODULZSI_ID] <> '','Naley poda modu rdowy');
    if Parameters.Values[sUNIMODULZSI_ID] = '' then
      Parameters.Values[sUNIMODULZSI_ID] := IntToStr(cZLEModulZSI_ID);
    DMAQFbN(sUNIMODULZSI_ID).AsString := Parameters.Values[sUNIMODULZSI_ID];

    {Wypenienie pola rok}
    DMAQFbN(sUNIROK_ID).AsInteger := UNISYSDM.vAktywnyRokObrachunkowyID;

    //ustawienie domylnego statusu zlecenia
    DMAQFbN(sZLEZLECENIE_STATUS).AsString := ZLEDM.vZLEDomyslnyStatusZlecenia;

    //ustawienie domylnego typu zlecenia
    oParams := TKeyValues.CreateEmpty();
    try
      if(Owner is TUNIDBForm) then begin
        (Owner as TUNIDBForm).GetParametersForForm( (Owner as TUNIDBForm), oParams );
        if (oParams.Values[sBOKSPRAWA_ID] <> '') then begin
          oQuery := SQLManager.CreateQuery(
                      'SELECT TZ.' + sZLETYPZLEC_ID +
                      '     FROM ' + SQLManager.GetTableName(sBOKSPRAWAGRUPA) + ' TZ, ' + SQLManager.GetTableName(sBOKSPRAWA) + ' S ' +
                      '  WHERE S.' + sBOKSPRAWAGRUPA_ID + ' = TZ.' + sBOKSPRAWAGRUPA_ID   +   ' AND ' +
                      '        S.' + sBOKSPRAWA_ID      + ' IN ('    +  oParams.Values[sBOKSPRAWA_ID] + ')'
                      );
          try
            oQuery.Open;
            if not oQuery.IsEmpty then
              ZLEDM.vZLEDomyslnyTypZlecenia := oQuery.FieldByName(sZLETYPZLEC_ID).asInteger;
          finally
            FreeAndNil(oQuery);
          end;
        end;
        if oParams.KeyExists(sZLEZLECENIE_WYKONAWCA_ID) then
          DMAQFbN(sZLEZLECENIE_WYKONAWCA_ID).AsInteger := StrToInt(oParams.Values[sZLEZLECENIE_WYKONAWCA_ID]);
      end;  // if(Owner is TUNIDBForm)
    finally
      FreeAndNil(oParams);
    end;

    {-1 tez podstawiamy}
    //if ZLEDM.vZLEDomyslnyTypZlecenia > 0 then
       DMAQFbN(sZLETYPZLEC_ID).AsInteger := iifn(ZLEDM.vZLEDomyslnyTypZlecenia = -1, 0, ZLEDM.vZLEDomyslnyTypZlecenia);

       // moduy ZAO i ZAM mog mie swj wasny domylny typ zaleny od miejsca wywoania
    if((Parameters <> nil) and (
      (Parameters.Values[sUNIMODULZSI_ID] = IntToStr(cZAOMODULZSI_ID)) or
      (Parameters.Values[sUNIMODULZSI_ID] = IntToStr(cBOKMODULZSI_ID)) or //Z BOK tez jest przekazywany w parametrach
      (Parameters.Values[sUNIMODULZSI_ID] = IntToStr(cZAMMODULZSI_ID))
    ) and ParamIsNotEmptyOrZero(Parameters, sZLETYPZLEC_ID, sTekst)) then
       DMAQFbN(sZLETYPZLEC_ID).AsString := sTekst
    else
    if (StrToIntDef(Parameters.Values[sUNIMODULZSI_ID],0) = cSANMODULZSI_ID)and
       (SANDM.vSANZleceniaTypId > 0) then
       DMAQFbN(sZLETYPZLEC_ID).AsInteger := SANDM.vSANZleceniaTypId;


    if DMAQFbN(sZLEZLECENIE_PRZELICZ).IsNull then
       DMAQFbN(sZLEZLECENIE_PRZELICZ).AsString := sTak;

    //ustawienie elementu grupujcego
    DMAQFbN(sZLEZLECENIE_GRUPA_ID).AsString := Parameters.Values[sZLEZLECENIE_GRUPA_ID];
    if not DMAQFbN(sZLEZLECENIE_GRUPA_ID).IsNull then begin
      {Jeli pole jest wypenione to ju nie ma moliwoci edycji - omEdit}
      {if not ZLEDM.vZLEZleceniaNadrzedne then begin}
         ZlecenieGrupujaceDBLookupAliasEdit.Enabled := false;
         ZlecenieGrupujaceDBLookupAliasEdit.aReadOnly := true;
      {end;}
    end;

{ TODO -ogdeyk -czlecenia : Rozwiza dla wersji wielooddzialowej }
    if vWielofirmowosc then begin
       if Parameters.Values[sUNIODDZIAL_ID] <> '' then begin
          DMAQFbN(sUNIODDZIAL_ID).AsInteger := StrToInt(Parameters.Values[sUNIODDZIAL_ID]);
       end else
       if Parameters.Values['FIRMA_ID'] <> '' then begin
          DMAQFbN(sUNIODDZIAL_ID).AsInteger := StrToInt(Parameters.Values['FIRMA_ID']);
       end else DMAQFbN(sUNIODDZIAL_ID).AsInteger := vAktywnaFirma;
    end;

    if DMAQFbN(sUNIODDZIAL_ID).IsNull and vWieloodzialowosc then begin
       if ZLEDM.vZLEDomyslnyOddzialID > 0 then
          DMAQFbN(sUNIODDZIAL_ID).AsInteger := ZLEDM.vZLEDomyslnyOddzialID;
    end;

    {Zainicjowanie Typu zlecenia - eby aktywowa odpowiednie panele}
    if (not DMAQFbN(sZLETYPZLEC_ID).IsNull) and (OpenMode in [omNew,omEdit]) then
       TypZleceniaDBLookupAliasEdit.InitiateData(DMAQFbN(sZLETYPZLEC_ID).AsInteger);

  finally
    (DataModule.ActiveQuery as TVirtualDataSet).MarkModificationMode := false;
  end;
end;

function TZLEZlecenieDBDetailForm.Validate: Boolean;
var
  i, j : Integer;
begin
    // jeeli jest widoczny panel asortymentu (czyli zlecenie produkcyjne) to asortyment, receptura i ilo s wymagane
  IloscDBEdit.aAllowEmpty   := not (
    DataManagers.Available(sLWPModulID) and
    AsortymentPanel.Visible
  );
{
    Adam - 20080111 - dla potrzeb Dekorglass mona doda zlecenie bez receptury
  RecepturaLookupAliasEdit.aAllowEmpty  := IloscDBEdit.aAllowEmpty;
}
  AsortymentLookupAliasEdit.aAllowEmpty := IloscDBEdit.aAllowEmpty;

  result := inherited Validate();

  if not result then Exit;
  if bKontrolaIlosciowa and (not bKontrolaIlosciowaAsoMag) and
     DataModule.ContainedDataModules[FPozycjeZleceniaFormIndex].ActiveQuery.IsEmpty then begin
    Komunikat( cWarning, 'Naley dopisa przynajmniej jedn pozycj' );
    result := false;
  end;
  if(result and DataManagers.Available(sLWPModulID)) then begin
    if(not m_bProdukcyjne) then begin
      DMAQFbN(sASOASORT_ID).Clear();
      DMAQFbN(sZLEZLECENIE_ILOSC).Clear();
    end else begin  // if(not m_bProdukcyjne)
        // sprawdzenie czy materiay maj przypisane konto materiaowe
      result  := SprawdzKontoMaterialoweWMaterialach();
    end;
  end;  // if(result and DataManagers.Available(sLWPModulID))
  if result then begin
      // walidacja pol uzytkownika
      for i := 0 to ContainedFormCount-1 do begin
        if(Pos(cPolaUzPrefiksZakladki, FContainedForms[i]) > 0) then begin
          result  := UNISysDM.UNIPolaUzytkownikaValidate((FContainedForms.Objects[i] as TUNIForm));
          if(result = false) then begin
              // przelcznie na waciw zakadk
            for j := 0 to ZleceniePageControl.PageCount-1 do begin
              if(ZleceniePageControl.Pages[j].name = FContainedForms[i]) then begin
                ZleceniePageControl.ActivePage := ZleceniePageControl.Pages[j];
                break;
              end;  // if(DanePageControl.Pages[j].name = FContainedForms[i])
            end;  // for j:=0 to DanePageControl.PageCount-1
            break;
          end;  // if(result = false)
        end;  // if(Pos(cPolaUzPrefiksZakladki, FContainedForms[i]) > 0)
      end;  // for i := 0 to ContainedFormCount-1
  end;
end;

function TZLEZlecenieDBDetailForm.TypZleceniaDBLookupAliasEditGetDataField: String;
begin
  result := sZLETYPZLEC_ID;
end;

function TZLEZlecenieDBDetailForm.ModulZSIDBLookupAliasEditGetDataField: String;
begin
  result := sUNIMODULZSI_ID;
end;

function TZLEZlecenieDBDetailForm.OsobaOdpowiedzialnaDBLookupAliasEditGetDataField: String;
begin
  result := sZLEZLECENIE_OSOBA_ODP;
end;

function TZLEZlecenieDBDetailForm.OsobaPotwierdzajacaDBLookupAliasEditGetDataField: String;
begin
  result := sZLEZLECENIE_STATUS_OSOBA
end;

function TZLEZlecenieDBDetailForm.ModulZSIDBLookupAliasEditGetQuery: TUNIQuery;
begin
  result := UNISysDM.UNIPokazIObsluzDane( sUNIMODULZSI, '', false, false,
                                          sUNISYSALIAS_ModulZSI_ID+';'+
                                          sUNISYSALIAS_ModulZSI_Kod+';'+
                                          sUNISYSALIAS_ModulZSI_Nazwa,
                                          vAktywnaFirma );
end;

procedure TZLEZlecenieDBDetailForm.ModulZSIDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with ModulZSIDBLookupAliasEdit do begin
    AliasManager := UNISysDM.AliasManager;
    Alias_ID := sUNISYSALIAS_ModulZSI_ID;
    Alias_Name := sUNISYSALIAS_ModulZSI_Kod;
    AdditionalAliases := sUNISYSALIAS_ModulZSI_Nazwa;
  end;
end;

function TZLEZlecenieDBDetailForm.OsobaOdpowiedzialnaDBLookupAliasEditGetQuery: TUNIQuery;
begin
  {if DataManagers.Available(sKDModulID)
  then
    result := KDDM.KDPokazIObsluzPracownika( '', sKDAlias_OsobaID+';'+
                                             sKDAlias_OsobaNazwa,
                                             false, false,
                                             DMAQFbN(sZLEZLECENIE_OSOBA_ODP).AsInteger,
                                             vAktywnaFirma)
  else}
  result:= UNISysDM.KDPokazIObsluzPracownika(self, '', sKDAlias_OsobaID+';'+
                                           sKDAlias_OsobaNazwa,
                                           false, false,
                                           DMAQFbN(sZLEZLECENIE_OSOBA_ODP).AsInteger,
                                           vAktywnaFirma);
end;

procedure TZLEZlecenieDBDetailForm.OsobaOdpowiedzialnaDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with OsobaOdpowiedzialnaDBLookupAliasEdit do begin
    AliasManager:= UNISysDM.AliasManager;
    Alias_ID := sKDAlias_OsobaID;
    Alias_Name := sKDAlias_OsobaNazwa;
  end;
end;

function TZLEZlecenieDBDetailForm.OsobaPotwierdzajacaDBLookupAliasEditGetQuery: TUNIQuery;
begin
  {if DataManagers.Available(sKDModulID)
  then
    result := KDDM.KDPokazIObsluzPracownika( '', sKDAlias_OsobaID+';'+
                                             sKDAlias_OsobaNazwa,
                                             false, false,
                                             DMAQFbN(sZLEZLECENIE_STATUS_OSOBA).AsInteger,
                                             vAktywnaFirma)
  else}
  result:= UNISysDM.KDPokazIObsluzPracownika(self, '', sKDAlias_OsobaID+';'+
                                         sKDAlias_OsobaNazwa,
                                         false, false,
                                         DMAQFbN(sZLEZLECENIE_STATUS_OSOBA).AsInteger,
                                         vAktywnaFirma);

end;

procedure TZLEZlecenieDBDetailForm.OsobaPotwierdzajacaDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with OsobaPotwierdzajacaDBLookupAliasEdit do begin
{    if DataManagers.Available(sKDModulID)
    then AliasManager := KDDM.AliasManager;
    else}
    AliasManager:= UNISysDM.AliasManager;
    Alias_ID := sKDAlias_OsobaID;
    Alias_Name := sKDAlias_OsobaNazwa;
  end;
end;

function TZLEZlecenieDBDetailForm.TypZleceniaDBLookupAliasEditGetQuery: TUNIQuery;
begin
  result := ZLEDM.ZLEPokazIObsluzTypZlecenia( sZLEALIAS_TYPZLECENIA_ID+';'+
                                              sZLEALIAS_TYPZLECENIA_SYMBOL+';'+
                                              sZLEALIAS_TYPZLECENIA_NUM_ID+';'+
                                              sZLEALIAS_TYPZLECENIA_ILOSCI+';'+
                                              sZLEALIAS_TYPZLECENIA_TYP_GRUPY_ID+';'+
                                              sZLEALIAS_TYPZLECENIA_WYKONAWCA+';'+
                                              sZLEALIAS_TYPZLECENIA_WYDZIAL+';'+
                                              sZLEALIAS_TYPZLECENIA_OPIS+';'+
                                              sZLEALIAS_TYPZLECENIA_ILOSCI_ASOMAG+';'+
                                              sZLEALIAS_TYPZLECENIA_NIERUCHOMOSC+';'+
                                              sZLEALIAS_TYPZLECENIA_BUDYNEK+';'+
                                              sZLEALIAS_TYPZLECENIA_LOKAL+';'+
                                              sZLEALIAS_TYPZLECENIA_KLATKA+';'+
                                              sZLEALIAS_TYPZLECENIA_ULICA+';'+
                                              sZLEALIAS_TYPZLECENIA_POJAZD+';'+
                                              sZLEALIAS_TYPZLECENIA_ZASOB+';'+
                                              sZLEALIAS_TYPZLECENIA_BRAMA+';'+
                                              sZLEALIAS_TYPZLECENIA_REJON+';'+
                                              sZLEALIAS_TYPZLECENIA_SIECELEMENT+';'+
                                              sZLEALIAS_TYPZLECENIA_SKLADELSIECI+';'+
                                              sZLEALIAS_TYPZLECENIA_PUNKT+';'+
                                              sZLEALIAS_TYPZLECENIA_UMOWA+';'+
                                              sZLEALIAS_TYPZLECENIA_TABPOWIAZANA+';'+
                                              sZLEALIAS_TYPZLECENIA_ZASOBY+';'+
                                              sZLEALIAS_TYPZLECENIA_PROCENT_UE+';'+
                                              sZLEALIAS_TYPZLECENIA_ELEMENTINF+';'+
                                              sZLEALIAS_TYPZLECENIA_POZIOMINF+';'+
                                              sZLEALIAS_TYPZLECENIA_ZLEC_ELEMINF+';'+
                                              sZLEALIAS_TYPZLECENIA_ZLEC_POZINF+';'+
                                              sZLEALIAS_TYPZLECENIA_REG_ID+';'+
                                              sZLEALIAS_TYPZLECENIA_DOM_NAZWA+';'+
                                              sZLEALIAS_TYPZLECENIA_DOM_DATA_OTW + ';' +
                                              sZLEALIAS_TYPZLECENIA_PRODUKCYJNE + ';' +
                                              sZLEALIAS_TYPZLECENIA_WYMAG_RECEP + ';' +
                                              sZLEALIAS_TYPZLECENIA_SUFFIX + ';' +
                                              sZLEALIAS_TYPZLECENIA_ZAPOTRZTYP_ID,
                                              iifs(OpenMode = omNew, '((TYPZLE.' + sZLETYPZLEC_WLACZUPRAWNIENIA + ' = ' + QuotedStr('N') + ') OR ' +
                                                                      '(TYPZLE.' + sZLETYPZLEC_ID + ' IN (SELECT X.' + sZLETYPZLEC_ID + ' ' +
                                                                                                    'FROM ' + SQLManager.GetTableName(sZLETYPZLECUSERS) + ' X ' +
                                                                                                    'WHERE X.' + sSMUSER_ID + '=' + IntToStr(SecurityManager.UserID) + '))) ', ''),
                                              false, false,
                                              DMAQFbN(sUNIMODULZSI_ID).AsInteger,
                                              DMAQFbN(sZLETYPZLEC_ID).AsInteger,
                                              vAktywnaFirma );
end;

procedure TZLEZlecenieDBDetailForm.TypZleceniaDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with TypZleceniaDBLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_ID := sZLEALIAS_TYPZLECENIA_ID;
    Alias_Name := sZLEALIAS_TYPZLECENIA_SYMBOL;
    AdditionalAliases := sZLEALIAS_TYPZLECENIA_NUM_ID+';'+
                         sZLEALIAS_TYPZLECENIA_ILOSCI+';'+
                         sZLEALIAS_TYPZLECENIA_TYP_GRUPY_ID+';'+
                         sZLEALIAS_TYPZLECENIA_WYKONAWCA+';'+
                         sZLEALIAS_TYPZLECENIA_WYDZIAL+';'+
                         sZLEALIAS_TYPZLECENIA_OPIS+';'+
                         sZLEALIAS_TYPZLECENIA_ILOSCI_ASOMAG+';'+
                         sZLEALIAS_TYPZLECENIA_NIERUCHOMOSC+';'+
                         sZLEALIAS_TYPZLECENIA_BUDYNEK+';'+
                         sZLEALIAS_TYPZLECENIA_LOKAL+';'+
                         sZLEALIAS_TYPZLECENIA_KLATKA+';'+
                         sZLEALIAS_TYPZLECENIA_ULICA+';'+
                         sZLEALIAS_TYPZLECENIA_POJAZD+';'+
                         sZLEALIAS_TYPZLECENIA_ZASOB+';'+
                         sZLEALIAS_TYPZLECENIA_BRAMA+';'+
                         sZLEALIAS_TYPZLECENIA_REJON+';'+
                         sZLEALIAS_TYPZLECENIA_PROCENT_UE+';'+
                         sZLEALIAS_TYPZLECENIA_SIECELEMENT+';'+
                         sZLEALIAS_TYPZLECENIA_SKLADELSIECI+';'+
                         sZLEALIAS_TYPZLECENIA_PUNKT+';'+
                         sZLEALIAS_TYPZLECENIA_UMOWA+';'+
                         sZLEALIAS_TYPZLECENIA_TABPOWIAZANA+';'+
                         sZLEALIAS_TYPZLECENIA_ZASOBY+';'+
                         sZLEALIAS_TYPZLECENIA_ELEMENTINF+';'+
                         sZLEALIAS_TYPZLECENIA_POZIOMINF+';'+
                         sZLEALIAS_TYPZLECENIA_ZLEC_ELEMINF+';'+
                         sZLEALIAS_TYPZLECENIA_ZLEC_POZINF+';'+
                         sZLEALIAS_TYPZLECENIA_REG_ID+';'+
                         sZLEALIAS_TYPZLECENIA_DOM_NAZWA+';'+
                         sZLEALIAS_TYPZLECENIA_DOM_DATA_OTW + ';' +
                         sZLEALIAS_TYPZLECENIA_PRODUKCYJNE + ';' +
                         sZLEALIAS_TYPZLECENIA_WYMAG_RECEP + ';' +
                         sZLEALIAS_TYPZLECENIA_SUFFIX + ';' +
                         sZLEALIAS_TYPZLECENIA_ZAPOTRZTYP_ID;

     AdditionalCondition := iifs(OpenMode = omNew, '((TYPZLE.' + sZLETYPZLEC_WLACZUPRAWNIENIA + ' = ' + QuotedStr('N') + ') OR ' +
                                                    '(TYPZLE.' + sZLETYPZLEC_ID + ' IN (SELECT X.' + sZLETYPZLEC_ID + ' ' +
                                                                                  'FROM ' + SQLManager.GetTableName(sZLETYPZLECUSERS) + ' X ' +
                                                                                  'WHERE X.' + sSMUSER_ID + '=' + IntToStr(SecurityManager.UserID) + '))) ', '');
  end;
end;


function  TZLEZlecenieDBDetailForm.GenerujSuffix(var sOpis: String): Integer;
var
  sZnaki: String;
  oSplit: TSplit;
  iIndex, idx, jdx: Integer;
  oDS: TDataSet;
  sSymb: String;
  OldVState: TVirtualDataSetState;
begin
  result := 0;
  sOpis := '';
  if not bSuffix then Exit;

  sZnaki := sTypSuffix;
  try
    {Przeszukujemy pola uytkownika zeby zbudowa opis}
    oSplit := TSplit.Create(sZnaki, ',', '');
    for iIndex := 0 to oSplit.Count - 1 do
    begin
      if copy(Trim(oSplit[iIndex]), 1, 1) = '''' then begin
         sOpis := sOpis + Copy(Trim(oSplit[iIndex]), 2, length(Trim(oSplit[iIndex])) - 2); {ODEJMUJEMY DWA APOSTROFY}
         Continue;
      end else begin
         {Oddzia}
         {if (vWieloodzialowosc or vWielofirmowosc) and (Trim(oSplit[iIndex]) = 'ODZ') then begin
            if DMAQFbN(sUNIODDZIAL_ID).IsNull then begin
               Komunikat(cWarning, 'Nie wypenione pole oddzia');
               result := 1;
               Exit;
            end else sOpis := sOpis + Trim(OddzialDBLookupAliasEdit.Text);}
         if WydzialPanel.Visible and
            (WydzialDBLookupAliasEdit.aAllowEmpty = False) and
            (Trim(oSplit[iIndex]) = 'JED') then begin
            if DMAQFbN(sUNIJEDNOSTKAORG_ID).IsNull then begin
               Komunikat(cWarning, 'Nie wypenione pole jednostka organizacyjna');
               result := 1;
               Exit;
            end else sOpis := sOpis + Trim(WydzialDBLookupAliasEdit.Text);
         end else begin
             {Szukamy w polach uytkownika odpowiedniego mnemonika}
              if (m_oPolaUZGridy <> nil) then
                 for idx := 0 to m_oPolaUZGridy.Count-1 do
                 begin
                   jdx := FContainedForms.IndexOf(cPolaUzPrefiksZakladki + IntToStr(idx));
                   if (jdx > -1) then begin
                      oDS := TZLEZlecenieDataModule(DataModule).ContainedDataModules[jdx].ActiveQuery;
                      OldVState := (oDS as TVirtualDataSet).VState;
                      try
                         (oDS as TVirtualDataSet).VState := vsVirtualPost;
                         //oDS.DisableControls;
                         if UNILocate(oDS, sFKMNEMONIKI_MNEMONIK, Trim(oSplit[iIndex])) then begin
                            if oDS.FieldByName(sFKMNEMONIKI_TABELA).AsString = sFKUZ then begin
                                if oDS.FieldByName(sFKUZ_ID).AsInteger <= 0 then begin
                                   Komunikat(cError, 'Nie wypenione pole uytkownika : ' + oDS.FieldByName(sUNIPOLAUZDEF_NAZWA).AsString);
                                   result := 1;
                                   ModalResult := mrNone;
                                   Exit;
                                end;

                                //W oDS nie jest aktualizowane pole FKUZ_SYMBOL tylko FKUZ_ID
                                {if oDS.FindField(sFKUZ_SYMBOL) <> nil then
                                   sSymb := oDS.FieldByName(sFKUZ_SYMBOL).AsString
                                else begin}
                                  sSymb := SQLManager.OpenQueryWithResult('SELECT ' + sFKUZ_SYMBOL + ' ' +
                                                                          'FROM %s ' +
                                                                          'WHERE ' + sFKUZ_ID + '=' + oDS.FieldByName(sFKUZ_ID).AsString + ' AND ' +
                                                                                     sFKMNEMONIKI_ID + '=' + oDS.FieldByName(sFKMNEMONIKI_ID).AsString,
                                                                          [sFKUZ]);
                                //end;
                                sOpis := sOpis + sSymb;

                            end else begin
                                {sFKMNEMONIKI_TABELA <> sFKUZ
                                 - tu mamy symbol w polu UNIPOLAUZ_WART}
                                if oDS.FieldByName(sUNIPOLAUZ_WART).AsString = '' then begin
                                   Komunikat(cError, 'Nie wypenione pole uytkownika : ' + oDS.FieldByName(sUNIPOLAUZDEF_NAZWA).AsString);
                                   result := 1;
                                   ModalResult := mrNone;
                                   Exit;
                                end;

                                sOpis := sOpis + oDS.FieldByName(sUNIPOLAUZ_WART).AsString;
                            end;

                         end;
                      //TZLEZlecenieDataModule(DataModule).ContainedDataModules[PolaUzFormIndex].ActiveQuery.FieldByName(sFKMNEMONIKI_MNEMONIK).AsString;
                      finally
                        (oDS as TVirtualDataSet).VState := OldVState;
                        //oDS.EnableControls;
                      end;
                   end;
                 end;  // for idx := 0 to m_oPolaUZGridy.Count-1
         end;
      end;
    end;
  finally
     FreeAndNil(oSplit);
  end;
end;

procedure TZLEZlecenieDBDetailForm.SetSymbol(iNewNumeratorID: Integer; var iBlad: Integer);
var
  sSQL, sNewOpis, sOpis2: String;
  q: TUniQuery;
  iLicznik: Integer;
  iKodID: Integer;
  iLocNewNumID: Integer;
begin
  iBlad := 0;
  iLocNewNumID := iNewNumeratorID;
  if (not bSelectButton) and (bSuffix and ZLEDM.vZLENumeratorExt) then begin
     if (iLocNewNumID <> 0) then
          SymbolDBEdit.Enabled := False
     else SymbolDBEdit.Enabled := True;
     Exit;
  end;

  if iLocNewNumID <> 0 then begin
    if OpenMode = omNew then begin
       if ZLEDM.vZLEBlokadaZmianySymbolu and
          ZLEDM.vZLEReczneWprowadzanieSymbolu and
          (Parameters.Values[sBOKSPRAWA_ID] = '') and
          (Parameters.Values[sBOKUMOWA_ID]  = '') then
       begin
          //iLocNewNumID := 0;
          SymbolDBEdit.Enabled := True;
          Exit;
       end;
    end else begin
      if ZLEDM.vZLEBlokadaZmianySymbolu and
         ZLEDM.vZLEReczneWprowadzanieSymbolu and
         DMAQFbN(sZLEZLECENIE_LICZNIK).IsNull then
      begin
        {Zakadam, e symbol nie pochodzi z numeratora, zatem nie ustawiamy iNumeratorID}
        iLocNewNumID := 0; //!!
        SymbolDBEdit.Enabled := False; //Blokujemy edycje symbolu
      end;
    end;
  end;

  if bSelectButton and bSuffix and ZLEDM.vZLENumeratorExt then begin
     {tu wersja z Suffixem po SelectButtonPressed}
     sNewOpis := '';
     if GenerujSuffix(sNewOpis) <> 0 then begin
       // Komunikat(cWarning, 'Bd podczas generowania opisu dla numeratora');
        ModalResult := mrNone; //Formatka nie powinna si zamkn
        iBlad := 1;
        Exit;
     end else begin

        if (iLocNewNumID <> 0) and (DMAQFbN(sZLEZLECENIE_SYMBOL).IsNull) then begin
            {BRAK DATY}
            if DMAQFbN(sZLEZLECENIE_DATA_OTW).IsNull then begin
               Komunikat(cWarning, 'Brak wypenionej daty otwarcia zlecenia');
               CheckVisibilityAndSetFocus(DataOtwarciaDBDateEdit);
               ModalResult := mrNone;
               iBlad := 2;
               Exit;
            end;

            iOkresId := 0;
            //if sRodzaj = sUNICONST_RODZ_NUMERACJI_MIESIECZNA_ID then begin
               {W tym przypadku wymagany jest okres_id dla ustalenia symbolu z numeratora}
               if DMAQFbN(sZLEZLECENIE_DATA_OTW).AsDateTime > 0 then begin
                  sSQL := 'SELECT ' + sUNIOKRES_ID + ' FROM %s o WHERE ' +
                       sUNIOKRES_DATA_POCZ + '<=' + KonwertujDate2SQL(DMAQFbN(sZLEZLECENIE_DATA_OTW).AsDateTime) + ' AND ' +
                       sUNIOKRES_DATA_KONCA + '>=' + KonwertujDate2SQL(DMAQFbN(sZLEZLECENIE_DATA_OTW).AsDateTime);

                  try
                     q := SQLManager.CreateQuery(sSQL, [sUNIOKRES]);
                     q.Open;
                     if not q.IsEmpty then
                        iOkresID := q.FieldByName(sUNIOKRES_ID).AsInteger;

                     q.Close;
                  finally
                     if q <> nil then FreeAndNil(q);
                  end;
               end;
            //end;

            {Brakuje nam jeszcze wypenionej daty otwarcia lub bedny okres??}
            if (iOkresID = 0) {and (sRodzaj = sUNICONST_RODZ_NUMERACJI_MIESIECZNA_ID)} then begin
               Komunikat(cWarning, 'Bdny okres dla podanej daty otwarcia');
               CheckVisibilityAndSetFocus(DataOtwarciaDBDateEdit);
               iBlad := 3;
               ModalResult := mrNone;
               Exit;
            end;

            iKodID := 0;
            sOpis2 := '';
            if ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0) then begin
               if DMAQFbN(sZLEZLECENIE_PREFIX_ID).IsNull then begin
                  Komunikat(cWarning, 'Nie wypeniony prefiks');
                  CheckVisibilityAndSetFocus(PrefixDBLookupAliasEdit);
                  iBlad := 4;
                  ModalResult := mrNone;
                  Exit;
               end;
               sOpis2 := PrefixDBLookupAliasEdit.Text;
               iKodID := DMAQFbN(sZLEZLECENIE_PREFIX_ID).AsInteger;
            end else
            if (ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 1)) or
               (vWieloodzialowosc and ZLEDM.VZLEWymaganyOddzial) then begin
               if DMAQFbN(sUNIODDZIAL_ID).IsNull then begin
                  Komunikat(cWarning, 'Nie wypeniony oddzia');
                  CheckVisibilityAndSetFocus(OddzialDBLookupAliasEdit);
                  iBlad := 5;
                  ModalResult := mrNone;
                  Exit;
               end;
               sOpis2 := OddzialDBLookupAliasEdit.Text;
               iKodID := DMAQFbN(sUNIODDZIAL_ID).AsInteger;
            end;

            if ZLEDM.vZLENumeratorExt and (not ZLEDM.vZLEOsobnaNum) then
                 iKodID := 0
            else sOpis2 := '';

            DMAQFbN(sZLEZLECENIE_SYMBOL).AsString := UNISysDM.UNIPodajNumerExt( iLocNewNumID,
                                                        DMAQFbN(sUNIODDZIAL_ID).AsInteger,
                                                        DMAQFbN(sUNIROK_ID).AsInteger,
                                                        iOkresId, iKodID, sNewOpis, iLicznik,
                                                        False {z podbijaniem}, sOpis2);

            DMAQFbN(sZLEZLECENIE_LICZNIK).AsInteger := iLicznik;
            DMAQFbN(sZLEZLECENIE_SUFFIX).AsString := sNewOpis;
            //SymbolDBEdit.Validate();
         //end;
       end;
     end;
  end else begin
    if (iLocNewNumID <> iNumeratorID) and
       (iNumeratorID <> 0) and
       (not DMAQFbN(sZLEZLECENIE_SYMBOL).IsNull) then begin

      iKodID := 0;
      sOpis2 := '';
      if ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0) then begin
         iKodID := DMAQFbN(sZLEZLECENIE_PREFIX_ID).AsInteger;
         sOpis2 := PrefixDBLookupAliasEdit.Text;
      end else
      if (ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 1)) or
         (vWieloodzialowosc and ZLEDM.VZLEWymaganyOddzial) then begin
         iKodID := DMAQFbN(sUNIODDZIAL_ID).AsInteger;
         sOpis2 := OddzialDBLookupAliasEdit.Text;
      end;

      if ZLEDM.vZLENumeratorExt and (not ZLEDM.vZLEOsobnaNum) then
           iKodID := 0
      else sOpis2 := '';

      iLicznik := DMAQFbN(sZLEZLECENIE_LICZNIK).AsInteger;
      UNISysDM.UNIZwrocNumer( DMAQFbN(sZLEZLECENIE_SYMBOL).AsString,
                              iNumeratorID, DMAQFbN(sUNIODDZIAL_ID).AsInteger,
                              DMAQFbN(sUNIROK_ID).AsInteger,
                              iOkresID, iKodID, iLicznik);
      DMAQFbN(sZLEZLECENIE_SYMBOL).Clear;
      DMAQFbN(sZLEZLECENIE_LICZNIK).Clear;
    end;

    if (iLocNewNumID <> 0) then
       SymbolDBEdit.Enabled := False
    else begin
      if (OpenMode <> omNew) and ZLEDM.vZLEBlokadaZmianySymbolu then
           SymbolDBEdit.Enabled := False //Blokujemy edycje symbolu
      else SymbolDBEdit.Enabled := True;
    end;

    if (iLocNewNumID <> 0) and (DMAQFbN(sZLEZLECENIE_SYMBOL).IsNull) then begin
        {Sprawdzam rodzaj numeratora}
        {sSQL:= SQLManager.GetSelectWithInnerJoins(sUNIAUTNUM_RODZAJ, [sUNIAUTNUM], [''], [''],
                                                  sUNIAUTNUM_ID+'='+IntToStr(iNewNumeratorID));

        sRodzaj := SQLManager.OpenQueryWithResult( sSQL ,['']);}

        {BRAK DATY}
        if DMAQFbN(sZLEZLECENIE_DATA_OTW).IsNull then begin
           if bSelectButton then begin
              Komunikat(cWarning, 'Brak wypenionej daty otwarcia zlecenia');
              CheckVisibilityAndSetFocus(DataOtwarciaDBDateEdit);
              iBlad := 6;
              ModalResult := mrNone;
           end;
           Exit;
        end;

        iOkresId := 0;
        //if sRodzaj = sUNICONST_RODZ_NUMERACJI_MIESIECZNA_ID then begin
           {W tym przypadku wymagany jest okres_id dla ustalenia symbolu z numeratora}
           if DMAQFbN(sZLEZLECENIE_DATA_OTW).AsDateTime > 0 then begin
              sSQL := 'SELECT ' + sUNIOKRES_ID + ' FROM %s o WHERE ' +
                   sUNIOKRES_DATA_POCZ + '<=' + KonwertujDate2SQL(DMAQFbN(sZLEZLECENIE_DATA_OTW).AsDateTime) + ' AND ' +
                   sUNIOKRES_DATA_KONCA + '>=' + KonwertujDate2SQL(DMAQFbN(sZLEZLECENIE_DATA_OTW).AsDateTime);

              try
                 q := SQLManager.CreateQuery(sSQL, [sUNIOKRES]);
                 q.Open;
                 if not q.IsEmpty then
                    iOkresID := q.FieldByName(sUNIOKRES_ID).AsInteger;

                 q.Close;
              finally
                 if q <> nil then FreeAndNil(q);
              end;
           end;
        //end;

        {Brakuje nam jeszcze wypenionej daty otwarcia lub bedny okres??}
        if (iOkresID = 0) {and (sRodzaj = sUNICONST_RODZ_NUMERACJI_MIESIECZNA_ID)} then begin
           if bSelectButton then Komunikat(cWarning, 'Bdny okres dla podanej daty otwarcia');
           CheckVisibilityAndSetFocus(DataOtwarciaDBDateEdit);
           iBlad := 3;
           ModalResult := mrNone;
           Exit;
        end;

        iKodID := 0;
        sOpis2 := '';
        if ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0) then begin
           if DMAQFbN(sZLEZLECENIE_PREFIX_ID).IsNull then begin
              if bSelectButton then Komunikat(cWarning, 'Nie wypeniony prefiks');
              CheckVisibilityAndSetFocus(PrefixDBLookupAliasEdit);
              iBlad := 4;
              ModalResult := mrNone;
              Exit;
           end;
           sOpis2 := PrefixDBLookupAliasEdit.Text;
           iKodID := DMAQFbN(sZLEZLECENIE_PREFIX_ID).AsInteger;
        end else
        if (ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 1)) or
           (vWieloodzialowosc and ZLEDM.VZLEWymaganyOddzial) then begin
           if DMAQFbN(sUNIODDZIAL_ID).IsNull then begin
              if bSelectButton then Komunikat(cWarning, 'Nie wypeniony oddzia');
              CheckVisibilityAndSetFocus(OddzialDBLookupAliasEdit);
              iBlad := 5;
              ModalResult := mrNone;
              Exit;
           end;
           sOpis2 := OddzialDBLookupAliasEdit.Text;
           iKodID := DMAQFbN(sUNIODDZIAL_ID).AsInteger;
        end;

        if ZLEDM.vZLENumeratorExt and (not ZLEDM.vZLEOsobnaNum) then
           iKodID := 0
        else sOpis2 := '';

        DMAQFbN(sZLEZLECENIE_SYMBOL).AsString := UNISysDM.UNIPodajNumerExt( iLocNewNumID,
                                                    DMAQFbN(sUNIODDZIAL_ID).AsInteger,
                                                    DMAQFbN(sUNIROK_ID).AsInteger,
                                                    iOkresId, iKodID, '', iLicznik,
                                                    False {z podbijaniem}, sOpis2);

        DMAQFbN(sZLEZLECENIE_LICZNIK).AsInteger := iLicznik;
        //SymbolDBEdit.Validate();
    end;
  end;
end;

function TZLEZlecenieDBDetailForm.TypZleceniaDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
  (*
  procedure UstawWGParametru( Field: TField );
  begin
    with ParametrDBLookupAliasEdit do begin
      AliasManager := INFDM.AliasManager;
      if Field.FieldName = sZLETYPZLEC_NIERUCHOMOSC_A then begin
        Alias_ID := sINFAlias_Nieruchomosc_ID;
        Alias_Name := sINFAlias_Nieruchomosc_Symbol;
        AdditionalAliases := sINFAlias_Nieruchomosc_Nazwa; // Tu byo sINFAlias_Ulica_Nazwa;
        DataField := sINFNIERUCHOMOSC_ID;
      end else
      if Field.FieldName = sZLETYPZLEC_BUDYNEK_A then begin
        Alias_ID := sINFAlias_Budynek_ID;
        Alias_Name := sINFAlias_Budynek_Symbol;
        AdditionalAliases := sINFAlias_Budynek_Nazwa; {+';'+sINFAlias_Budynek_Numer}
        DataField := sINFBUDYNEK_ID;
      end else
      if Field.FieldName = sZLETYPZLEC_LOKAL_A then begin
        Alias_ID := sINFAlias_Lokal_ID;
        Alias_Name := sINFAlias_Lokal_Symbol;
        AdditionalAliases := sINFAlias_Lokal_Nazwa+';'+sINFAlias_Budynek_Numer;{+';'+
                             sINFAlias_Lokal_Numer;}
        DataField := sINFLOKAL_ID;
      end else
      if Field.FieldName = sZLETYPZLEC_KLATKA_A then begin
        Alias_ID := sINFAlias_Klatka_ID;
        Alias_Name := sINFAlias_Klatka_Symbol;
        AdditionalAliases := {sINFAlias_Ulica_Nazwa+';'+}sINFAlias_Klatka_Nazwa + ';' +sINFAlias_Budynek_Numer;
        DataField := sINFKLATKA_ID;
      end else
      if Field.FieldName = sZLETYPZLEC_ULICA_A then begin
        Alias_ID := sINFAlias_Ulica_ID;
        Alias_Name := sINFAlias_Ulica_Symbol;
        AdditionalAliases := sINFAlias_Ulica_Nazwa;
        DataField := sINFULICA_ID;
      end else
      if Field.FieldName = sZLETYPZLEC_ZASOB_A then begin
        Alias_ID := sINFAlias_Zasob_ID;
        Alias_Name := sINFAlias_Zasob_Symbol;
        AdditionalAliases := sINFAlias_Zasob_Nazwa;
        DataField := sINFZASOB_ID;
      end else
      if Field.FieldName = sZLETYPZLEC_SIECELEMENT_A then begin
        Alias_ID := sINFAlias_SiecElement_ID;
        Alias_Name := sINFAlias_SiecElement_Symbol;
        AdditionalAliases := sINFAlias_SiecElement_Opis;
        DataField := sINFSIECELEMENT_ID;
      end else
      if Field.FieldName = sZLETYPZLEC_SKLADELEMSIECI_A then begin
        Alias_ID := sINFAlias_Skladnik_ID;
        Alias_Name := sINFAlias_Skladnik_Symbol;
        AdditionalAliases := sINFAlias_Skladnik_Typ;
        //AdditionalAliases := sINFAlias_Skladnik_Element_ID; // Tu byo sINFAlias_Ulica_Nazwa;
        DataField := sINFSIECSKLADNIK_ID;
      end;
    end;
    ParametryPanel.Visible := True;
    ParametrDBLookupAliasEdit.aAllowEmpty := Field.AsString = cZLEAktywnosc_OpcjonalnyID;
    ParametrDBLookupAliasEdit.Initialize := True;
    NazwaWartosciParametruLabel.Caption := '';
    ParametrDBLookupAliasEdit.aAllowText := NazwaParametruLabel.Caption;
  end;
  *)
var
    iBlad1, iOldNumeratorID: Integer;
begin
  if(m_iCurrTypZlecId <> DMAQFbN(sZLETYPZLEC_ID).AsInteger) then begin
    m_iCurrTypZlecId  := DMAQFbN(sZLETYPZLEC_ID).AsInteger;
    result := false;
    if AliasSrc <> nil then with AliasSrc do begin

      //ustawienie wymagalnoci kontroli ilociowej
      bKontrolaIlosciowa := FieldByName(sZLETYPZLEC_ILOSCI).AsString = sUNICONST_ALTERNATYWA_TAK;
      bKontrolaIlosciowaAsoMag := FieldByName(sZLETYPZLEC_ILOSCI_ASOMAG).AsString = sUNICONST_ALTERNATYWA_TAK;
      m_iZAOZapotrzTypId  := FieldByName(sZAOZAPOTRZTYP_ID).AsInteger;

      iTypGrupujacy := FieldByName(sZLETYPZLEC_TYP_GRUPY_ID).AsInteger;
      if iTypGrupujacy = 0 then begin
        if (Parameters.Values[sZLEZLECENIE_GRUPA_ID] = '') then begin
           if (not ZLEDM.vZLEZleceniaNadrzedne) then begin
               ZlecenieGrupujaceDBLookupAliasEdit.Clear;
               ZlecenieGrupujaceDBLookupAliasEdit.aReadOnly := True;
               ZlecenieGrupujacePanel.Visible := False;
           end else begin
               ZlecenieGrupujaceLabel.Caption := 'Zlecenie nadrzdne';
               ZlecenieGrupujaceDBLookupAliasEdit.AdditionalCondition := '(@'+sZLEALIAS_ZLECENIE_ID+'<>'+DMAQFbN(sZLEZLECENIE_ID).AsString+')';
               ZlecenieGrupujaceDBLookupAliasEdit.aReadOnly := False;
               ZlecenieGrupujacePanel.Visible := True;
           end;
        end;
      end else begin
        if (Parameters.Values[sZLEZLECENIE_GRUPA_ID] = '') then begin
          {Tu zawsze jest zlecenie grupujce}
          ZlecenieGrupujaceLabel.Caption := 'Zlecenie grupujce';
          ZlecenieGrupujaceDBLookupAliasEdit.AdditionalCondition := '(@'+sZLEALIAS_ZLECENIE_TYP_ID+'='+IntToStr(iTypGrupujacy)+')and'+
                                                                    '(@'+sZLEALIAS_ZLECENIE_ID+'<>'+DMAQFbN(sZLEZLECENIE_ID).AsString+')';
          ZlecenieGrupujaceDBLookupAliasEdit.aReadOnly := False;
          ZlecenieGrupujacePanel.Visible := True;
        end;
      end;

      //parametry dodatkowe
      //wykonawca
      WykonawcaPanel.Visible := FieldByName(sZLETYPZLEC_WYKONAWCA_A).AsString <> cZLEAktywnosc_NieAktywnyID;
      WykonawcaDBLookupAliasEdit.aAllowEmpty := FieldByName(sZLETYPZLEC_WYKONAWCA_A).AsString <> cZLEAktywnosc_WymaganyID;
      //wydzia
      WydzialPanel.Visible := FieldByName(sZLETYPZLEC_WYDZIAL_A).AsString <> cZLEAktywnosc_NieAktywnyID;
      WydzialDBLookupAliasEdit.aAllowEmpty := FieldByName(sZLETYPZLEC_WYDZIAL_A).AsString <> cZLEAktywnosc_WymaganyID;
      //opis
      OpisPanel.Visible := FieldByName(sZLETYPZLEC_OPIS_A).AsString <> cZLEAktywnosc_NieAktywnyID;
      OpisDBMemo.aAllowEmpty := FieldByName(sZLETYPZLEC_OPIS_A).AsString <> cZLEAktywnosc_WymaganyID;
      //Pojazd
      PojazdPanel.Visible := FieldByName(sZLETYPZLEC_Pojazd_A).AsString <> cZLEAktywnosc_NieAktywnyID;
      PojazdDBLookupAliasEdit.aAllowEmpty := FieldByName(sZLETYPZLEC_Pojazd_A).AsString <> cZLEAktywnosc_WymaganyID;
      //Procent UE
      ProcentUEPanel.Visible := FieldByName(sZLETYPZLEC_Procent_UE_A).AsString <> cZLEAktywnosc_NieAktywnyID;
      ProcentUEDBEdit.aAllowEmpty := FieldByName(sZLETYPZLEC_Procent_UE_A).AsString <> cZLEAktywnosc_WymaganyID;
      //parametry infrastruktury
      if DataManagers.Available(sBOKModulID) then begin
        UmowaPanel.Visible := FieldByName(sZLETYPZLEC_UMOWA_A).AsString <> cZLEAktywnosc_NieAktywnyID;
        UmowaDBLookupAliasEdit.aAllowEmpty := FieldByName(sZLETYPZLEC_UMOWA_A).AsString <> cZLEAktywnosc_WymaganyID;
      end else begin
        UmowaPanel.Visible := False;
        UmowaDBLookupAliasEdit.aAllowEmpty := True;
      end;

      //parametry infrastruktury
      if DataManagers.Available(sINFModulID) then begin
        PunktPanel.Visible := FieldByName(sZLETYPZLEC_PUNKT_A).AsString <> cZLEAktywnosc_NieAktywnyID;
        PunktDBLookupAliasEdit.aAllowEmpty := FieldByName(sZLETYPZLEC_PUNKT_A).AsString <> cZLEAktywnosc_WymaganyID;

        if FieldByName(sZLETYPZLEC_ZLEC_ELEMINF).AsString = sTak then
          FElementINFZlec := FieldByName(sZLETYPZLEC_ZLEC_POZINF).AsString;

        FTabelaINF := ElementINFZlec;
        PoziomINFPanel.Visible := ElementINFZlec <> '';
        ElementINFDBLookupAliasEdit.Visible := PoziomINFPanel.Visible;
        ElementINFDBLookupAliasEdit.Enabled := (OpenMode in [omNew, omEdit]);

        if (Self.Owner <> nil) and (Self.Owner is TZLEZlecenieDBGridForm) then begin

          if (TZLEZlecenieDBGridForm(Self.Owner).Parameters.Values[sZLEZLECENIE_POZIOMINF] <> '') and (TUNIDBGridForm(Self.Owner).Parameters.Values[sZLEZLECENIE_INF_ID] <> '') then begin
            if (DMAQFbN(sZLEZLECENIE_INF_ID).IsNull) and (OpenMode = omNew) then begin
              if FieldByName(sZLETYPZLEC_ZLEC_ELEMINF).AsString = sTak then begin
                 FElementINFZlec := TZLEZlecenieDBGridForm(Self.Owner).Parameters.Values[sZLEZLECENIE_POZIOMINF];
                 FTabelaINF := ElementINFZlec;
                 DMAQFbN(sZLEZLECENIE_POZIOMINF).AsString := FElementINFZlec;
                 ElementINFDBLookupAliasEditInitAliasInfo(nil);
                 PoziomINFPanel.Visible := ElementINFZlec <> '';
                 ElementINFDBLookupAliasEdit.Visible := PoziomINFPanel.Visible;
                 ElementINFDBLookupAliasEdit.InitiateData(StrToInt(TZLEZlecenieDBGridForm(Self.Owner).Parameters.Values[sZLEZLECENIE_INF_ID]));
                 ElementINFDBLookupAliasEdit.Enabled := False;
              end;
            end else begin
              if FieldByName(sZLETYPZLEC_ZLEC_ELEMINF).AsString = sTak then
                 ElementINFDBLookupAliasEdit.Enabled := False;
            end;
          end;

          if (TZLEZlecenieDBGridForm(Self.Owner).Parameters.Values[sINFPUNKT_ID] <> '') then
          begin
            if (OpenMode = omNew) and DMAQFBN(sINFPUNKT_ID).IsNull then
            begin
              PunktDBLookupAliasEdit.InitiateData(StrToInt(TZLEZlecenieDBGridForm(Self.Owner).Parameters.Values[sINFPUNKT_ID]));
            end;
          end;

        end;

        (**************
        if FieldByName(sZLETYPZLEC_NIERUCHOMOSC_A).AsString <> cZLEAktywnosc_NieAktywnyID then begin
          NazwaParametruLabel.Caption := 'Nieruchomo';
          UstawWGParametru(FieldByName(sZLETYPZLEC_NIERUCHOMOSC_A));
        end else
        if FieldByName(sZLETYPZLEC_BUDYNEK_A).AsString <> cZLEAktywnosc_NieAktywnyID then begin
          NazwaParametruLabel.Caption := 'Budynek';
          UstawWGParametru(FieldByName(sZLETYPZLEC_BUDYNEK_A));
        end else
        if FieldByName(sZLETYPZLEC_LOKAL_A).AsString <> cZLEAktywnosc_NieAktywnyID then begin
          NazwaParametruLabel.Caption := 'Lokal';
          UstawWGParametru(FieldByName(sZLETYPZLEC_LOKAL_A));
        end else
        if FieldByName(sZLETYPZLEC_KLATKA_A).AsString <> cZLEAktywnosc_NieAktywnyID then begin
          NazwaParametruLabel.Caption := 'Klatka';
          UstawWGParametru(FieldByName(sZLETYPZLEC_KLATKA_A));
        end else
        if FieldByName(sZLETYPZLEC_ULICA_A).AsString <> cZLEAktywnosc_NieAktywnyID then begin
          NazwaParametruLabel.Caption := 'Ulica';
          UstawWGParametru(FieldByName(sZLETYPZLEC_ULICA_A));
        end else
        if FieldByName(sZLETYPZLEC_ZASOB_A).AsString <> cZLEAktywnosc_NieAktywnyID then begin
          NazwaParametruLabel.Caption := 'Zasb';
          UstawWGParametru(FieldByName(sZLETYPZLEC_ZASOB_A));
        end else
        if FieldByName(sZLETYPZLEC_SIECELEMENT_A).AsString <> cZLEAktywnosc_NieAktywnyID then begin
          NazwaParametruLabel.Caption := 'Element sieci';
          UstawWGParametru(FieldByName(sZLETYPZLEC_SIECELEMENT_A));
        end else
        if FieldByName(sZLETYPZLEC_SKLADELEMSIECI_A).AsString <> cZLEAktywnosc_NieAktywnyID then begin
          NazwaParametruLabel.Caption := 'Skadnik elem.sieci';
          UstawWGParametru(FieldByName(sZLETYPZLEC_SKLADELEMSIECI_A));
        end else begin
          ParametryPanel.Visible := False;
          ParametrDBLookupAliasEdit.aAllowEmpty := True;
        end;
        *)
      end else begin
        FTabelaINF := '';
        PoziomINFPanel.Visible := False;
        ElementINFDBLookupAliasEdit.Visible := False;
      end;

      ZasobyTabSheet.TabVisible := (FieldByName(sZLETYPZLEC_ZASOBY).AsString = sUNICONST_ALTERNATYWA_TAK);

      //ustawienia parametrw pozycji
      FASORegID := FieldByName(sASOREG_ID).AsInteger;
      if DataManagers.Available(sINFModulID) then begin
        if FieldByName(sZLETYPZLEC_ELEMENTINF).AsString = sUNICONST_ALTERNATYWA_TAK then
          FElementINF := FieldByName(sZLETYPZLEC_POZIOMINF).AsString;
      end;
      FTabelaPowiazana := FieldByName(sZLETYPZLEC_TABPOWIAZANA).AsString;

      //wartoci domylne
      FDomyslnaNazwa := FieldByName(sZLETYPZLEC_DOM_NAZWA).AsString;
      if (FDomyslnaNazwa <> '') and (DMAQFbN(sZLEZLECENIE_NAZWA).IsNull) and (OpenMode = omNew) then
        DMAQFbN(sZLEZLECENIE_NAZWA).AsString := FDomyslnaNazwa;

      FDomyslnaData := FieldByName(sZLETYPZLEC_DOM_DATA_OTW).AsString = sUNICONST_ALTERNATYWA_TAK;
      if FDomyslnaData and (OpenMode = omNew) then
        DMAQFbN(sZLEZLECENIE_DATA_OTW).AsDateTime := UNIDate;


      { ******************  Pocztek - Parametry numeratora ***************** }
      sTypSuffix := '';
      bSuffix := False;
      if ZLEDM.vZLENumeratorExt then begin
         sTypSuffix := FieldByName(sZLETYPZLEC_SUFFIX).AsString;
         bSuffix := (sTypSuffix <> '');
         PrefixLabel.Visible := False;
         PrefixDBLookupAliasEdit.Visible := False;

         if ZLEDM.vZLEPrefixSlownikID = 0 then begin
            {Tabela ZLEPREFIX}
            PrefixDBLookupAliasEdit.Visible := True;
            PrefixLabel.Visible := True;
            if OpenMode in [omNew,omEdit] then
                 PrefixDBLookupAliasEdit.Enabled := True
            else PrefixDBLookupAliasEdit.Enabled := False;
         end;
         { else
         if ZLEDM.vZLEPrefixSlownikID = 1 then begin
            //Tabela UNIODDZIAL
         end;}
      end;

      iOldNumeratorID := iNumeratorID;
      if OpenMode = omNew then begin
         if (not ZLEDM.vZLENumeratorExt) or
            (not ZLEDM.vZLEBlokadaZmianySymbolu) or
            (not ZLEDM.vZLEReczneWprowadzanieSymbolu) or
            (Parameters.Values[sBOKSPRAWA_ID] <> '') or
            (Parameters.Values[sBOKUMOWA_ID]  <> '') then
         begin
            if FieldByName(sUNIAUTNUM_ID).IsNull then iNumeratorID := 0
            else iNumeratorID := FieldByName(sUNIAUTNUM_ID).AsInteger;
         end else iNumeratorID := 0;
      end else begin
        if DMAQFbN(sZLEZLECENIE_LICZNIK).IsNull then begin
          {Zakadam, e symbol nie pochodzi z numeratora, zatem nie ustawiamy iNumeratorID}
          iNumeratorID := 0; //!!
        end else begin
          if FieldByName(sUNIAUTNUM_ID).IsNull then iNumeratorID := 0
          else iNumeratorID := FieldByName(sUNIAUTNUM_ID).AsInteger;
        end;
      end;

      //Wyczyszczenie symbolu, gdy nie byl wpisany z rki  a obecnie jest numerator
      if (iOldNumeratorID = 0) and
         (iNumeratorID > 0) and
         (not DMAQFbN(sZLEZLECENIE_SYMBOL).IsNull) and
         (OpenMode = omNew) then
      begin
        DMAQFbN(sZLEZLECENIE_SYMBOL).Clear();
        DMAQFbN(sZLEZLECENIE_SYMBOL).EditMask := '';
      end;

      if (OpenMode in [omNew, omEdit]) and
         DMAQFbN(sZLEZLECENIE_SYMBOL).IsNull and
         (SymbolDBEdit.Color = clInvalid) then
      begin
         SymbolDBEdit.ValidateEdit();
         SymbolDBEdit.Color := clInactive;
      end;

      DajTypNumeratora;

      if bNumKod and bNumOpis2 then begin
         Komunikat(cWarning, 'Nieobsugiwana definicja szablonu numeratora.'#13+
                           'Nie mona jednoczenie uywa mnemonika [K] i [OD]');
         Exit;
      end;

      if bNumKod and (not ZLEDM.vZLEOsobnaNum) then begin
         Komunikat(cWarning, 'Nieobsugiwana definicja szablonu numeratora.'#13+
                           'Po wyczeniu parametru "Osobna numeracja pozycji sownika"'#13+
                           'nie mona uywa mnemonika [K]');
         Exit;
      end;

      if bNumOpis2 and ZLEDM.vZLEOsobnaNum then begin
         Komunikat(cWarning, 'Nieobsugiwana definicja szablonu numeratora.'#13+
                           'Przy wczonym parametrze "Osobna numeracja pozycji sownika"'#13+
                           'nie mona uywa mnemonika [OD]');
         Exit;
      end;

      {if ZLEDM.vZLENumeratorExt then begin
         if (not ZLEDM.vZLEOsobnaNum) and (not bNumKod) and (ZLEDM.vZLEPrefixSlownikID = 0) then begin
            PrefixDBLookupAliasEdit.Visible := False;
            PrefixLabel.Visible := False;
         end;
      end;}
      { ******************  Koniec - Parametry numeratora ***************** }
      {Przywracamy sta przed wywoaniem SetSymbol}
      iNumeratorID := iOldNumeratorID;
      if OpenMode in [omNew,omEdit] then SetSymbol(FieldByName(sUNIAUTNUM_ID).AsInteger, iBlad1);

      if OpenMode = omNew then begin
         if (not ZLEDM.vZLENumeratorExt) or
            (not ZLEDM.vZLEBlokadaZmianySymbolu) or
            (not ZLEDM.vZLEReczneWprowadzanieSymbolu) or
            (Parameters.Values[sBOKSPRAWA_ID] <> '') or
            (Parameters.Values[sBOKUMOWA_ID]  <> '') then
         begin
            if FieldByName(sUNIAUTNUM_ID).IsNull then iNumeratorID := 0
            else iNumeratorID := FieldByName(sUNIAUTNUM_ID).AsInteger;
         end else iNumeratorID := 0;
      end else begin
        if DMAQFbN(sZLEZLECENIE_LICZNIK).IsNull then begin
          {Zakadam, e symbol nie pochodzi z numeratora, zatem nie ustawiamy iNumeratorID}
          iNumeratorID := 0; //!!
        end else begin
          if FieldByName(sUNIAUTNUM_ID).IsNull then iNumeratorID := 0
          else iNumeratorID := FieldByName(sUNIAUTNUM_ID).AsInteger;
        end;
      end;

      if     ZLEDM.vZLEMaskaSymboluWlaczona
         and (ZLEDM.vZLEMaskaSymbolu <> '')
         and SymbolDBEdit.Enabled
         and ((iNumeratorID = 0) or
              (ZLEDM.vZLEReczneWprowadzanieSymbolu and (OpenMode = omNew)))
      then begin
        DMAQFbN(sZLEZLECENIE_SYMBOL).EditMask := ZLEDM.vZLEMaskaSymbolu+';0;_';
      end else begin
        // bez maski
        DMAQFbN(sZLEZLECENIE_SYMBOL).EditMask := '';
      end;

      if (OpenMode in [omNew, omEdit]) and (SymbolDBEdit.Color = clInvalid) then
      begin
         SymbolDBEdit.ValidateEdit();
         SymbolDBEdit.Color := clInactive;
      end;
(*******************POLA UZ***************************
      if (not DMAQFbN(sZLETYPZLEC_ID).IsNull) then begin
         if OpenMode = omNew then
            TZLEPoleZmGridForm(ContainedForms[PolaUzFormIndex]).WyczyscPolaZm();
         OdswiezPolaUz();
      end;
*******************POLA UZ***************************)

  //       TZLEPoleZmGridForm(ContainedForms[PolaUzFormIndex]).DodajPolaZM(DMAQFbN(sZLETYPZLEC_ID).AsInteger);

      if(DataManagers.Available(sLWPModulID)) then begin
        m_bProdukcyjne  := (FieldByName(sZLETYPZLEC_PRODUKCYJNE).AsString = sTak);
        AsortymentPanel.Visible := m_bProdukcyjne;
        PozycjeTabSheet.TabVisible    := (not AsortymentPanel.Visible);
        ZapotrzebowaniaPierwTabSheet.TabVisible := (ZAODM.Available and (OpenMode <> omNew)); // and AsortymentPanel.Visible;
        ZapotrzebowaniaWtorneTabSheet.TabVisible:= ZAODM.Available; // AsortymentPanel.Visible;
//        ZamowienieTabSheet.TabVisible := AsortymentPanel.Visible; // powizanie z zamwieniami moliwe jest te dla zlece nieprodukcyjnych
//        ZapytanieTabSheet.TabVisible  := AsortymentPanel.Visible;
        RecepturaLookupAliasEdit.aAllowEmpty  := (FieldByName(sZLETYPZLEC_WYMAG_RECEP).AsString = sNie);
      end;
//      MaterialTabSheet.TabVisible   := AsortymentPanel.Visible;
      if(DMAQFbN(sUNIMODULZSI_ID).AsInteger in [cZAMModulZSI_ID, cZAOModulZSI_ID]) then begin  // if(DataManagers.Available(sLWPModulID))
          // jeeli wywoano z ZAM lub ZAO to dla zlece produkcyjnych nie zapisujemy pozycji natomiast dla pozostaych zapisujemy
        if(m_bProdukcyjne) then
          Parameters.Values[cZLEFuncRodzaj] := ''
        else
          Parameters.Values[cZLEFuncRodzaj] := cZLEFuncZlecenie;  // aby detal zapisywa pozycje
      end;

      {Obsluga pol uytkownika}
      if OpenMode = omNew then
         PrzebudujPolaUzytkownikaNew();

      (***
      // pocztek sekcji kopiowania pl uz
      // skopiowanie pl uytkownika dla nagwka
      if(Length(m_sNaglowekFunkcja) > 0) then begin
        SkopiujPolaUZJednejFunkcjiDoInnej(m_sNaglowekFunkcja, m_iNaglowekFunkcjaId, m_oPolaUZGridy, m_iNaglowekElementId);
        SkopiujPolaUZPozycjiJednejFunkcjiDoInnej(
          m_sPozycjaFunkcja,
          m_iNaglowekFunkcjaId,
          m_iNaglowekElementId,
          cPolaUZ_ZLEPozycja,
          DMAQFBN(sZLETYPZLEC_ID).AsInteger,
          DMAQFBN(sZLEZLECENIE_ID).AsInteger,
          m_oZakladkiPozGridy,
          m_oPozycjeId
        );
      end;
      ***)
    end;
  end;  // if(m_iCurrTypZlecId <> DMAQFbN(sZLETYPZLEC_ID).AsInteger)
  result := true;
end;

procedure TZLEZlecenieDBDetailForm.InitializeObjectFields;
begin
  iNumeratorID := 0;
  iOkresID := 0;
  iOddzialOld := 0;
  iPrefixOld := 0;
  bKontrolaIlosciowa := false;
  bKontrolaIlosciowaAsoMag := false;
  iTypGrupujacy := 0;
  //sParametrField := '';
  FPodpowiedzDaneSprawy := False;
end;

procedure TZLEZlecenieDBDetailForm.StatusChanged;
begin
  //data otwarcia jest wymagana dla statusu "w realizacji"
  DataOtwarciaDBDateEdit.aAllowEmpty :=
    cslZLEStatusZlecenia.IndexOfSkrot(DMAQFbN(sZLEZLECENIE_STATUS).AsString)<
    cslZLEStatusZlecenia.IndexOfSkrot(cZLEStatusZlecenia_WRealizacjiID);

  //data zakoczenia jest wymagana przy statusie "zakoczone"
  DataZakonczeniaDBDateEdit.aAllowEmpty :=
    (not (DMAQFbN(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_ZakonczoneID));

  //Gdy jest wypeniony operator odpowiedzialny, to nie mona modyfikowac osoby odpowiedzialnej
  OsobaOdpowiedzialnaDBLookupAliasEdit.aReadOnly := not DMAQFbN(sZLEZLECENIE_OPER_ODP).IsNull;

  //osoba potwierdzajca realizacj jest dostpna tylko dla statusu "zakoczone" lub gdy w polu jest ju wartosc, aby mozna ja bylo wykasowac
  if not DMAQFbN(sZLEZLECENIE_OPER_POTW_REAL).IsNull then
     OsobaPotwierdzajacaDBLookupAliasEdit.aReadOnly := True
  else OsobaPotwierdzajacaDBLookupAliasEdit.aReadOnly := not ( (not DMAQFbN(sZLEZLECENIE_STATUS_OSOBA).IsNull) or
                                                               ZLEDM.vZLEKontrolaUprawnionych or
                                                               (DMAQFbN(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_ZakonczoneID));

  //osoba potwierdzajca realizacj jest wymagana w zalenoci od
  //parametru vZLEWymaganaOsobaZamykajacaZlecenie
  OsobaPotwierdzajacaDBLookupAliasEdit.aAllowEmpty :=
    (not (ZLEDM.vZLEWymaganaOsobaZamykajacaZlecenie and (DMAQFbN(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_ZakonczoneID)));

  //podstawa potwierdzenia jest dostpna tylko dla statusu "zakoczone"
  PodstawaPotwierdzeniaDBEdit.Enabled :=
    (DMAQFbN(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_ZakonczoneID);
end;

procedure TZLEZlecenieDBDetailForm.ShowLookups();
var
  oQuery:   TUNIQuery;
  sAliasy,
  sWarunek: string;
begin
  if(not DMAQFbN(sASOASORT_ID).IsNull) then begin
    UNIDajAliasyZLookupa(AsortymentLookupAliasEdit, sAliasy, sWarunek);
    oQuery  := ASODM.OdpytajODane(sASOASORT,
      sAliasy,
      '@' + sASOAlias_Asort_ID + ' = ' + DMAQFbN(sASOASORT_ID).AsString,
      false
    );
    if(oQuery <> nil) then begin
      AsortymentLookupAliasEdit.Text  := oQuery.Fields[1].AsString;
      oQuery.Free();
    end;  // if(oQuery <> nil)
    UstawAsortymentReceptury(DMAQFbN(sASOASORT_ID).AsInteger);
  end else begin  // if(not DMAQFbN(sASOASORT_ID).IsNull)
    RecepturaLookupAliasEdit.Enabled:= false;
    LRecepturaLabel.Enabled         := false;
  end;
  if(not DMAQFbN(sLWPRECEPTURA_ID).IsNull) then begin
    UNIDajAliasyZLookupa(RecepturaLookupAliasEdit, sAliasy, sWarunek);
    oQuery  := LWPDM.LWPOdpytajODane(sLWPRECEPTURA,
      sAliasy,
      '@' + sLWPAlias_Receptura_Id + ' = ' + DMAQFbN(sLWPRECEPTURA_ID).AsString,
      false
    );
    if(oQuery <> nil) then begin
      RecepturaLookupAliasEdit.Text := oQuery.Fields[1].AsString;
      oQuery.Free();
    end;
  end;  // if(not DMAQFbN(sLWPRECEPTURA_ID).IsNull)
end;

procedure TZLEZlecenieDBDetailForm.UstawAsortymentReceptury(
  const ac_iAsortId:  integer
);
var
  oQuery: TUNIQuery;
begin
  if((OpenMode in [omNew, omEdit]) and (not DMAQFbN(sLWPRECEPTURA_ID).IsNull)) then begin
      // sprawdzenie czy asortyment zamwienia i receptury s zgodne
    oQuery  := LWPDM.LWPOdpytajODane(sLWPRECEPTURA,
      sLWPAlias_Receptura_AsortId,
      '@' + sLWPAlias_Receptura_Id  + ' = ' + DMAQFbN(sLWPRECEPTURA_ID).AsString,
      false
    );
    if(oQuery <> nil) then begin
        // jeeli asortyment receptury jest inny ni asortyment zamwienia
        // to zerujemy receptur w zamwieniu
      if(ac_iAsortId <> oQuery.Fields[0].AsInteger) then
        RecepturaLookupAliasEditDelKey(self);
      oQuery.Free();
    end else  // if(oQuery <> nil)
      RecepturaLookupAliasEditDelKey(self);
  end;  // if((OpenMode in [omNew, omEdit]) and (not DMAQFbN(sLWPRECEPTURA_ID).IsNull))
  RecepturaLookupAliasEdit.AdditionalCondition  :=
    '@' + sLWPAlias_Receptura_AsortId + ' = ' + IntToStr(ac_iAsortId);
  RecepturaLookupAliasEdit.Enabled:= (not m_bZlecenieNaPlanie) and (ac_iAsortId <> 0);
  LRecepturaLabel.Enabled         := RecepturaLookupAliasEdit.Enabled;
end;

procedure TZLEZlecenieDBDetailForm.MaterialGridDataChange(
  a_oSender:    TObject;
  a_oField:     TField
);
begin
  if(Assigned(m_oOrygMaterialDataChange)) then
    m_oOrygMaterialDataChange(a_oSender, a_oField);

  if(DataManagers.Available(sLWPModulID) and m_bProdukcyjne) then begin
    MatZamiennikButton.Enabled:= (m_oMaterialGrid as TZLEZlecenieMaterialDBGridForm).MoznaWybracZamiennik();
    MatOryginalButton.Enabled := (m_oMaterialGrid as TZLEZlecenieMaterialDBGridForm).MoznaPrzywrocicMaterial();
  end else begin
    MatZamiennikButton.Enabled:= false;
    MatOryginalButton.Enabled := false;
  end;
end;

procedure TZLEZlecenieDBDetailForm.SkopiujPowiazaniaReceptury(
  const ac_bProsOPotwierdzenie: boolean
);
begin
  (m_oZasobyGrid as TZLEZlecenieZasobDBGridForm).PrzepiszZasobyZReceptury(ac_bProsOPotwierdzenie);
  (m_oMaterialGrid as TZLEZlecenieMaterialDBGridForm).KopiujMaterialyZReceptury(
    DMAQFbN(sZLEZLECENIE_ID).AsInteger,
    DMAQFbN(sLWPRECEPTURA_ID).AsInteger,
    DMAQFbN(sZLEZLECENIE_ILOSC).AsFloat,
    ac_bProsOPotwierdzenie
  );
end;

procedure TZLEZlecenieDBDetailForm.StatusZleceniaDBConstComboBoxExit(
  Sender: TObject);
begin
  inherited;
  //reakcja na zmian statusu
  StatusChanged();
end;

procedure TZLEZlecenieDBDetailForm.CancelButtonPressed;
var sSymbol, sOpis2: String;
    iKodID, iOddzialID, iRokId, iLicznik: Integer;
begin
  sSymbol := DMAQFbN(sZLEZLECENIE_SYMBOL).AsString;
  iOddzialID := DMAQFbN(sUNIODDZIAL_ID).AsInteger;
  iRokId := DMAQFbN(sUNIROK_ID).AsInteger;
  iLicznik := DMAQFbN(sZLEZLECENIE_LICZNIK).AsInteger;
  iKodID := 0;
  sOpis2 := '';

  if ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0) then begin
     iKodID := DMAQFbN(sZLEZLECENIE_PREFIX_ID).AsInteger;
     sOpis2 := PrefixDBLookupAliasEdit.Text;
  end else
  if (ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 1)) or
     (vWieloodzialowosc and ZLEDM.VZLEWymaganyOddzial) then begin
     iKodID := DMAQFbN(sUNIODDZIAL_ID).AsInteger;
     sOpis2 := OddzialDBLookupAliasEdit.Text;
  end;

  if ZLEDM.vZLENumeratorExt and (not ZLEDM.vZLEOsobnaNum) then
        iKodID := 0
  else  sOpis2 := '';

  inherited;
  {Dla wersji rozszerzonej z ZLETYPZLEC_SUFFIX <> ''
   nie ma jeszcze symbolu, wic nie trzeba go zwracac,
   ale wtedy sSymbol = ''}
  if (ModalResult = mrCancel)and(OpenMode = omNew)and
     (iNumeratorID <> 0)and(sSymbol <> '') then begin
    UNISysDM.UNIZwrocNumer( sSymbol,
                            iNumeratorID, iOddzialID,
                            {vAktywnyRokObrachunkowyID} iRokId, iOkresId,
                            iKodID, iLicznik);
  end;
end;

procedure TZLEZlecenieDBDetailForm.SelectButtonPressed;
var sSymbol, sOpis2St, sTmpOpis: String;
    iKodID, iOddzialID, iRokId, iLicznik, iKodSt, iBlad1: Integer;
    bPrefixSt: Boolean;
    bOddzialSt: Boolean;
    iZleZlecenieID: Integer;
begin
  bSelectButton := True;

  if ZLEDM.vZLEUnikalnoscElemInf and
     (OpenMode in [omNew, omEdit]) and
     (DMAQFbN(sZLEZLECENIE_INF_ID).AsInteger > 0) and
     ((DMAQFbN(sZLEZLECENIE_STATUS).AsString <> 'Z') and
      (DMAQFbN(sZLEZLECENIE_STATUS).AsString <> 'A')) then begin
      if OpenMode = omNew then
           iZleZlecenieID := 0
      else iZleZlecenieID := DMAQFbN(sZLEZLECENIE_ID).AsInteger;

      if ZLEDM.ZLEKontrolaUnikalnosciElemInf(DMAQFbN(sZLETYPZLEC_ID).AsInteger,
                                             DMAQFbN(sZLEZLECENIE_INF_ID).AsInteger,
                                             DMAQFbN(sZLEZLECENIE_POZIOMINF).AsString,
                                             iZleZlecenieID) then begin
        //Istnieje juz aktywne zlecenie. Komunikat
        Komunikat(cInformation, 'Dla wybranego typu zlecenia istnieje juz aktywne zlecenie dla elementu infrastruktury'#13+
                                'Mona zapisa zlecenie o statusie anulowanym albo zakoczonym');
        ModalResult := mrNone;
        Exit;
      end;
  end;

  iBlad1 := 0;
  if ((iNumeratorID <> 0) and (OpenMode = omNew)) then
     SetSymbol(iNumeratorID, iBlad1);

  if iBlad1 <> 0 then begin
     ModalResult := mrNone;
     Exit;
  end;

  sSymbol := DMAQFbN(sZLEZLECENIE_SYMBOL).AsString;
  iOddzialID := DMAQFbN(sUNIODDZIAL_ID).AsInteger;
  iRokId := DMAQFbN(sUNIROK_ID).AsInteger;
  iLicznik := DMAQFbN(sZLEZLECENIE_LICZNIK).AsInteger;
  sOpis2St := '';

  if ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0) then begin
     bPrefixSt := True;
     bOddzialSt := False;
     iKodID := DMAQFbN(sZLEZLECENIE_PREFIX_ID).AsInteger;
     iKodSt := iPrefixStartID;
  end else
  if (ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 1)) or
     (vWieloodzialowosc and ZLEDM.VZLEWymaganyOddzial) then begin
     bPrefixSt := False;
     bOddzialSt := True;
     iKodID := DMAQFbN(sUNIODDZIAL_ID).AsInteger;
     iKodSt := iOddzialStart;
  end else begin
     bPrefixSt := False;
     bOddzialSt := False;
     iKodID := 0;
     iKodSt := 0;
     sOpis2St := '';
  end;

  if ZLEDM.vZLENumeratorExt and (not ZLEDM.vZLEOsobnaNum) then
       iKodSt := 0
  else sOpis2St := '';

  if OpenMode = omEdit then begin
     if ZLEDM.vZLENumeratorExt and bSuffix then begin
        {Wygenerowanie nowego Suffixu i porownanie z istniejacym o ile istnieje}
        sTmpOpis := '';
        if GenerujSuffix(sTmpOpis) <> 0 then begin
           Komunikat(cWarning, 'Bd podczas generowania opisu dla numeratora');
           ModalResult := mrNone; //Formatka nie powinna si zamkn
           Exit;
        end;
     end;


     if (iNumeratorStartID <> 0) and
        (
          (iNumeratorStartID <> iNumeratorID) or
          ((iOkresStartID <> iOkresID) and (bNumMiesiecznyStart or bNumMiesieczny)) or
          //Rok nie ulega zmianie !
          (bPrefixSt  and (iPrefixStartID <> iKodID)) or
          (bOddzialSt and (iOddzialStart <> iKodID) ) or
          (ZLEDM.vZLENumeratorExt and bSuffix and (sTmpOpis <> DMAQFbN(sZLEZLECENIE_SUFFIX).AsString))
        ) then begin
            {Zwracamy pierwotny numer}
            UNISysDM.UNIZwrocNumer( sSymbolStart,
                                    iNumeratorStartID,
                                    iOddzialStart,
                                    iRokId,
                                    iOkresStartID,
                                    iKodSt {iOddzialStart},
                                    iLicznikStart);

     end else
     if (iNumeratorStartID <> 0) then begin
        {Przywracam symbol zlecenia i licznik}
        if bOddzialSt and (DMAQFbN(sUNIODDZIAL_ID).AsInteger <> iOddzialStart) then
           DMAQFbN(sUNIODDZIAL_ID).AsInteger := iOddzialStart;

        DMAQFbN(sZLEZLECENIE_LICZNIK).AsInteger := iLicznikStart;

        if bPrefixSt and (DMAQFbN(sZLEZLECENIE_PREFIX_ID).AsInteger <> iPrefixStartID) then
           DMAQFbN(sZLEZLECENIE_PREFIX_ID).AsInteger := iPrefixStartID;

        if (sSuffixStart <> '') and (DMAQFbN(sZLEZLECENIE_SUFFIX).AsString <> sSuffixStart) then
           DMAQFbN(sZLEZLECENIE_SUFFIX).AsString := sSuffixStart;

        if DMAQFbN(sZLEZLECENIE_SYMBOL).AsString <> sSymbolStart then
          DMAQFbN(sZLEZLECENIE_SYMBOL).AsString := sSymbolStart;
     end;

      {Pobieramy nowy numer}
      if (iNumeratorID <> 0) and
         ((iNumeratorStartID <> iNumeratorID) or
          ((iOkresStartID <> iOkresID) and (bNumMiesiecznyStart or bNumMiesieczny)) or
           //Rok nie ulega zmianie !
          (bPrefixSt  and (iPrefixStartID <> iKodID)) or
          (bOddzialSt and (iOddzialStart <> iKodID))or
          (ZLEDM.vZLENumeratorExt and bSuffix and (sTmpOpis <> DMAQFbN(sZLEZLECENIE_SUFFIX).AsString))
          ) then begin

            if ZLEDM.vZLENumeratorExt then begin
               if ZLEDM.vZLEOsobnaNum then
                  sOpis2St := '';
            end;
            {if not ZLEDM.vZLEOsobnaNum then
                  iKodID := 0
            else  sOpis2 := '';}

            DMAQFbN(sZLEZLECENIE_SYMBOL).Clear();
            DMAQFbN(sZLEZLECENIE_LICZNIK).Clear();
            DMAQFbN(sZLEZLECENIE_SUFFIX).Clear();

            SetSymbol(iNumeratorID, iBlad1);

            if iBlad1 <> 0 then begin
               ModalResult := mrNone;
               Exit;
            end;

            (********************
            {W tym przypadku wymagany jest okres_id dla ustalenia symbolu z numeratora}
            DMAQFbN(sZLEZLECENIE_SYMBOL).AsString := UNISysDM.UNIPodajNumerExt( iNumeratorID,
                                DMAQFbN(sUNIODDZIAL_ID).AsInteger,
                                DMAQFbN(sUNIROK_ID).AsInteger,
                                iOkresId,
                                iKodID,
                                '',
                                iLicznik {Tu z podbijaniem},
                                False,
                                sOpis2);

            DMAQFbN(sZLEZLECENIE_LICZNIK).AsInteger := iLicznik;
            *************)
      end;
  end;

  inherited;

  if (ModalResult = mrOK) and (OpenMode in [omNew,omEdit]) then begin
    {Wydruk zlecenia}
    if ZLEDM.vZLEWydrukZlecenia then WydrukZlecenia();
  end;

  if (ModalResult = mrOK) and (OpenMode = omDelete) and
     (iNumeratorID <> 0)  and (sSymbol <> '') then begin
    UNISysDM.UNIZwrocNumer( sSymbol,
                            iNumeratorID, iOddzialID,
                            iRokId, iOkresId,
                            iKodID, iLicznik);
  end;
  if (ModalResult = mrOK) and (OpenMode in [omNew,omEdit]) then begin
    //{Wydruk zlecenia}
    //if ZLEDM.vZLEWydrukZlecenia then WydrukZlecenia();

    if (Owner is TZLEZlecenieDBGridForm) then
      (Owner as TZLEZlecenieDBGridForm).RefreshDetail();
  end;
end;

procedure TZLEZlecenieDBDetailForm.PostPictureChanges();
begin
  if m_oObrazy = nil then UtworzGridObrazow();

  UNISysDM.UNIZapiszZmianyDokumentow(m_oObrazy, TUNIDocObjectCols.CreateWithData(
            [iUNIDOCOBIEKTTYP_ZLEZLECENIE_ID{, iUNIDOCOBIEKTTYP_BKKLIENT_ID}],
            [DMAQFbN(sZLEZLECENIE_ID).AsInteger{, DMAQFbN(sZLEZLECENIE_WYKONAWCA_ID).AsInteger}]));
end;

procedure TZLEZlecenieDBDetailForm.UtworzGridObrazow();
begin
  if(m_oObrazy = nil) then begin
    m_iTworzonaFormatka := [frmObrazy];
    try
      m_oObrazy := UNISysDM.UNIDajGridaRepozytoriumDokumentow(
        self,
        [iUNIDOCOKOLICZNOSC_ZLECENIE],
        TUNIDocObjectCols.CreateWithData([iUNIDOCOBIEKTTYP_ZLEZLECENIE_ID],
                                         [DMAQFbN(sZLEZLECENIE_ID).AsInteger])
      );
    finally
      m_iTworzonaFormatka := [frmNone];
    end;
  end;  // if(m_oObrazy = nil)
end;


procedure TZLEZlecenieDBDetailForm.OsobaOdpowiedzialnaDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  if OpenMode in [omNew, omEdit] then
     DMAQFbN(sZLEZLECENIE_OSOBA_ODP).Clear;
  OsobaOdpowiedzialnaDBLookupAliasEdit.Clear;
end;

procedure TZLEZlecenieDBDetailForm.OsobaPotwierdzajacaDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  if OpenMode in [omNew, omEdit] then
     DMAQFbN(sZLEZLECENIE_STATUS_OSOBA).Clear;
  OsobaPotwierdzajacaDBLookupAliasEdit.Clear;
end;

procedure TZLEZlecenieDBDetailForm.DataZakonczeniaDBDateEditDateChange(
  Sender: TObject);
begin
  inherited;
  if not DMAQFbN(sZLEZLECENIE_DATA_ZAMK).IsNull then
    DMAQFbN(sZLEZLECENIE_STATUS).AsString := cZLEStatusZlecenia_ZakonczoneID;

  StatusChanged();
end;

function TZLEZlecenieDBDetailForm.ZlecenieGrupujaceDBLookupAliasEditGetDataField: String;
begin
  result := sZLEZLECENIE_GRUPA_ID;
end;

function TZLEZlecenieDBDetailForm.ZlecenieGrupujaceDBLookupAliasEditGetQuery: TUNIQuery;
var iFirmaID: Integer;
    sWarunek: String;
begin
  iFirmaID := 0;
  sWarunek := '';
  if vWieloodzialowosc then iFirmaID := DMAQFbN(sUNIODDZIAL_ID).AsInteger
  else if vWielofirmowosc then iFirmaID := vAktywnaFirma;

  if iTypGrupujacy <> 0 then
    sWarunek := '(@'+sZLEALIAS_ZLECENIE_TYP_ID+'='+IntToStr(iTypGrupujacy)+')and'+
                '(@'+sZLEALIAS_ZLECENIE_ID+'<>'+DMAQFbN(sZLEZLECENIE_ID).AsString+')'
  else
    sWarunek := '(@'+sZLEALIAS_ZLECENIE_ID+'<>'+DMAQFbN(sZLEZLECENIE_ID).AsString+')';


  result := ZLEDM.ZLEPokazIObsluzZlecenia( sZLEALIAS_ZLECENIE_ID+';'+
                                           sZLEALIAS_ZLECENIE_SYMBOL+';'+
                                           sZLEALIAS_ZLECENIE_NAZWA,
                                           sWarunek, False, False, cZLEModulZSI_ID,
                                           DMAQFbN(sZLEZLECENIE_GRUPA_ID).AsInteger,
                                           iFirmaID );
end;

procedure TZLEZlecenieDBDetailForm.ZlecenieGrupujaceDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with ZlecenieGrupujaceDBLookupAliasEdit do begin
    AliasManager := ZLEDM.AliasManager;
    Alias_ID := sZLEALIAS_ZLECENIE_ID;
    Alias_Name := sZLEALIAS_ZLECENIE_SYMBOL;
    AdditionalAliases := sZLEALIAS_ZLECENIE_NAZWA;
  end;
end;

function TZLEZlecenieDBDetailForm.WydzialDBLookupAliasEditGetDataField: String;
begin
  result := sUNIJEDNOSTKAORG_ID;
end;

function TZLEZlecenieDBDetailForm.WydzialDBLookupAliasEditGetQuery: TUNIQuery;
var iFirmaID: Integer;
begin
  iFirmaID := 0;

  if vWieloodzialowosc then iFirmaID := DMAQFbN(sUNIODDZIAL_ID).AsInteger
  else if vWielofirmowosc then iFirmaID := vAktywnaFirma;

  result := UNISysDM.UNIPokazIObsluzDane( sUNIJEDNOSTKAORG, '', false, false,
                                          sUNISysAlias_JednostkaOrg_ID+';'+
                                          sUNISysAlias_JednostkaOrg_Symbol+';'+
                                          sUNISysAlias_JednostkaOrg_Nazwa,
                                          iFirmaID,
                                          DMAQFbN(sUNIJEDNOSTKAORG_ID).AsString );
end;

procedure TZLEZlecenieDBDetailForm.WydzialDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  inherited;
  with WydzialDBLookupAliasEdit do begin
    AliasManager := UNISYSDM.AliasManager;
    Alias_ID := sUNISysAlias_JednostkaOrg_ID;
    Alias_Name := sUNISysAlias_JednostkaOrg_Symbol;
    AdditionalAliases := sUNISysAlias_JednostkaOrg_Nazwa;
  end;
end;

function TZLEZlecenieDBDetailForm.WydzialDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
    WydzialNazwaLabel.Caption := AliasSrc.FieldByName(sUNIJEDNOSTKAORG_NAZWA).AsString;
  end;
  result := True;
end;

procedure TZLEZlecenieDBDetailForm.WydzialDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  WydzialDBLookupAliasEdit.Clear;
  if OpenMode in [omNew, omEdit] then
     DMAQFbN(sUNIJEDNOSTKAORG_ID).Clear;
  WydzialNazwaLabel.Caption := '';
end;

function TZLEZlecenieDBDetailForm.ZlecenieGrupujaceDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  result := True;
  if AliasSrc <> nil then begin
    ZlecenieGrupujaceNazwaLabel.Caption := AliasSrc.FieldByName(sZLEZLECENIE_NAZWA).AsString;
  end;
end;

function TZLEZlecenieDBDetailForm.ModulZSIDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  result := True;
  if AliasSrc <> nil then begin
    ModulZSINazwaLabel.Caption := AliasSrc.FieldByName(sUNIMODULZSI_NAZWA).AsString;
  end;
end;

procedure TZLEZlecenieDBDetailForm.ZlecenieGrupujaceDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  ZlecenieGrupujaceDBLookupAliasEdit.Clear;
  if OpenMode in [omNew, omEdit] then
     DMAQFbN(sZLEZLECENIE_GRUPA_ID).Clear;
  ZlecenieGrupujaceNazwaLabel.Caption := '';
end;

procedure TZLEZlecenieDBDetailForm.ModulZSIDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  ModulZSIDBLookupAliasEdit.Clear;
  if OpenMode in [omNew, omEdit] then
     DMAQFbN(sUNIMODULZSI_ID).Clear;
  ModulZSINazwaLabel.Caption := '';
end;

function TZLEZlecenieDBDetailForm.WykonawcaDBLookupAliasEditGetDataField: String;
begin
  result := sZLEZLECENIE_WYKONAWCA_ID;
end;

function TZLEZlecenieDBDetailForm.WykonawcaDBLookupAliasEditGetQuery: TUNIQuery;
begin
  result := BKDM.PokazIObsluzDaneKlienta( sBKAlias_KlientID+';'+
                                          sBKAlias_KlientSymbol+';'+
                                          sBKAlias_KlientNazwa, '',
                                          false, false, cZLEModulZSI_ID,
                                          DMAQFbN(sZLEZLECENIE_DATA_OTW).AsDateTime,
                                          DMAQFbN(sZLEZLECENIE_WYKONAWCA_ID).AsString);

end;

procedure TZLEZlecenieDBDetailForm.WykonawcaDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  with WykonawcaDBLookupAliasEdit do begin
    AliasManager := BKDM.AliasManager;
    Alias_ID := sBKAlias_KlientID;
    Alias_Name := sBKAlias_KlientSymbol;
    AdditionalAliases := sBKAlias_KlientNazwa;
    //AdditionalCondition := '(@'+sBKAlias_Klient_Aktywny+'='+QuotedStr(sUNICONST_ALTERNATYWA_TAK)+')';
    //zmieniamy poniewa obecnie (nie wiem jak byo do tej pory) pole BKKLIENT_CZY_AKT jest typu Integer:
    AdditionalCondition := '(@'+sBKAlias_Klient_Aktywny+'=1)';
  end;
end;

(*******************
function TZLEZlecenieDBDetailForm.ParametrDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
var iIndex: Integer;
    cSeparator: String;
begin
  if AliasSrc <> nil then begin
    NazwaWartosciParametruLabel.Caption := '';
    iIndex := 2;
    while iIndex < AliasSrc.Fields.Count do begin
      if NazwaWartosciParametruLabel.Caption = '' then
        cSeparator := ''
      else if AliasSrc.Fields[iIndex].FieldName = INFDefUnit.sINFLOKAL_NUMER then
        cSeparator := '/'
      else if AliasSrc.Fields[iIndex].FieldName = INFDefUnit.sINFKLATKA_NAZWA then
        cSeparator := ''
      else cSeparator := #32;
      NazwaWartosciParametruLabel.Caption := NazwaWartosciParametruLabel.Caption+cSeparator+
                                             AliasSrc.Fields[iIndex].AsString;
      Inc(iIndex);
    end;
  end;
  result := True;
  inherited;
end;

function TZLEZlecenieDBDetailForm.ParametrDBLookupAliasEditGetQuery: TUNIQuery;
var sTabela: String;
begin
  result := nil;
  if DataManagers.Available(sINFModulID) then
    with ParametrDBLookupAliasEdit do begin
      sTabela := Copy( DataField, 1, Length(DataField)-3 );
      result := INFDM.INFPokazIObsluzDane( sTabela,
                                         Alias_ID+';'+Alias_Name+';'+
                                         AdditionalAliases,
                                         AdditionalCondition,
                                         False, False, [] );
    end;
end;

procedure TZLEZlecenieDBDetailForm.ParametrDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  if DataManagers.Available(sINFModulID) then
    with ParametrDBLookupAliasEdit do begin
      AliasManager := INFDM.AliasManager;
    end;
end;

function TZLEZlecenieDBDetailForm.ParametrDBLookupAliasEditGetDataField: String;
begin
  if sParametrField <> '' then
    result := sParametrField
  else
    result := sINFNIERUCHOMOSC_ID;
end;
*****************)

function TZLEZlecenieDBDetailForm.WykonawcaDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
    WykonawcaNazwaLabel.Caption := AliasSrc.FieldByName(sBKKlient_Nazwa).AsString;
  end;
  result := True;
  inherited;
end;

procedure TZLEZlecenieDBDetailForm.WykonawcaDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  with WykonawcaDBLookupAliasEdit do begin
    Clear;
    if OpenMode in [omNew, omEdit] then
       DMAQFbN(DataField).Clear;
    WykonawcaNazwaLabel.Caption := '';
  end;
end;

(**
procedure TZLEZlecenieDBDetailForm.ParametrDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  with ParametrDBLookupAliasEdit do begin
    Clear;
    if OpenMode in [omNew, omEdit] then
       DMAQFbN(DataField).Clear;
    NazwaWartosciParametruLabel.Caption := '';
  end;
end;
**)

function TZLEZlecenieDBDetailForm.DopiszPozycjeDlaSprawy;
var
  oQuery: TUNIQuery;
  oZlePozQuery: TVirtualDataSet;
  sSQL, sSQL2: String;
  oSplit: TSplit;
  iIdx: Integer;
  iFormIndex: Integer;
  bDopisac: Boolean;
begin
  result := False;
  oQuery := nil;
  if sSprawy = '' then
    sSprawy := Parameters.Values[sBOKSPRAWA_ID];

  if sSprawy = '' then Exit;

  if ZLEDM.vZLEZleceniaBezPozycjiZeSpraw and (Pos(',', sSprawy) > 0) then begin
     Komunikat(cWarning, 'Ustawiona jest opcja generowania zlece bez pozycji ze spraw.'#13+
                         'Wybrano wicej ni jedn spraw.'#13+
                         'Dopisanie zlecenia nie jest moliwe.');
     Abort();
  end;


  if ZLEDM.vZLEZleceniaBezPozycjiZeSpraw then begin
    sSQL := ZLEDM.ZLEOdpytajODaneSQL( sZLEZLECENIE,
                                      sZLEALIAS_ZLECENIE_SPRAWA_ID,
                                      '(@'+sZLEALIAS_ZLECENIE_ID+'='+DMAQFbN(sZLEZLECENIE_ID).AsString+')and'+
                                      '(@'+sZLEALIAS_ZLECENIE_SPRAWA_ID+' is not null)',
                                      False );

    sSQL2 := 'SELECT SPR.' + sBOKSPRAWA_ID + ', SPR.' + sBOKSPRAWA_NUMER + ', ' +
                    'SPR.' + sBOKSPRAWA_OBIEKTJAKI + ', SPR.' + sBOKSPRAWA_OBIEKTID + ', ' +
                    'SPR.' + sBOKSPRAWA_PROBLEM + ', SPR.' + sASOASORT_ID + ', ' +
                    'ASO.' + sASOASORT_INDEKS + ', ASO.' + sASOASORT_SYMBOL + ', ' +
                    'ASO.' + sASOASORT_NAZWA + ', ASO.' + sLFKWZORDEKR_ID + ', ' +
                    'WZDE.' + sLFKWZORDEKR_NR_DEKR + ' ' +
             'FROM ' + SQLManager.GetTableName(sBOKSPRAWA) + ' SPR, ' +
                       SQLManager.GetTableName(sASOASORT) + ' ASO, ' +
                       SQLManager.GetTableName(sLFKWZORDEKR) + ' WZDE, ';

    sSQL2 := sSQL2 +
                   '(SELECT IORDERID,IORDERKEY ' +
                    'FROM TABLE(' + SQLManager.GetTableName('TORDER_CONV_LIST') + '(';

    oSplit := TSplit.Create(sSprawy, ',', '');
    for iIdx := 0 to oSplit.Count - 1 do begin
        if iIdx > 0 then sSQL2 := sSQL2 + ', ';
        sSQL2 := sSQL2 + SQLManager.GetTableName('TORDER_CONV') + '(' + IntToStr(iIdx) + ',' + oSplit[iIdx] + ')';
    end;

    sSQL2 := sSQL2 + ' ))) DICT ' +
             'WHERE SPR.' + sASOASORT_ID + ' = ASO.' + sASOASORT_ID + '(+) AND ' +
                   'ASO.' + sLFKWZORDEKR_ID + ' = WZDE.' + sLFKWZORDEKR_ID + '(+) AND ' +
                   'SPR.' + sBOKSPRAWA_ID + ' = DICT.IORDERKEY AND ' +
                   '(SPR.' + sBOKSPRAWA_ID + ' IN (' + sSprawy + ')) AND ' +
                   '(SPR.' + sBOKSPRAWA_ID + ' NOT IN (' + sSQL + ')) ' +
             'ORDER BY DICT.IORDERID';

    oQuery := SQLManager.CreateQuery(sSQL2);
      try

        if (oQuery <> nil) then begin
          bDopisac := True;
          if Parameters.Values[cFunkcjaBOKDopiszZlecenie] <> sTak then
             bDopisac := (Komunikat( cConfirmation, 'Czy uzupeni zlecenie danymi ze sprawy?', MB_YESNO ) = IDYES);

          if bDopisac then begin
            result := True;
            oQuery.Open;

            {Tu obsuga podpowiadania danych z nagwka}
            if ZLEDM.vZLESprawyPodpowiadanie then begin
               if vWielofirmowosc and (Parameters.Values[sUNIODDZIAL_ID] <> '') then begin
                  DMAQFbN(sUNIODDZIAL_ID).AsInteger := StrToInt(Parameters.Values[sUNIODDZIAL_ID]);
               end;

               if (ZLEDM.vZLESprawyKontrahent <> '') and (Parameters.Values[ZLEDM.vZLESprawyKontrahent] <> '') then begin
                  if WykonawcaDBLookupAliasEdit.Enabled and WykonawcaPanel.Visible then begin
                     try
                        DMAQFbN(sZLEZLECENIE_WYKONAWCA_ID).AsInteger := StrToInt(Parameters.Values[ZLEDM.vZLESprawyKontrahent]);
                     except
                        DMAQFbN(sZLEZLECENIE_WYKONAWCA_ID).Clear();
                     end;
                  end;
               end;
               if (ZLEDM.vZLESprawyWydzial <> '') and (Parameters.Values[ZLEDM.vZLESprawyWydzial] <> '') then begin
                  if WydzialDBLookupAliasEdit.Enabled and WydzialPanel.Visible then begin
                     try
                       DMAQFbN(sUNIJEDNOSTKAORG_ID).AsInteger := StrToInt(Parameters.Values[ZLEDM.vZLESprawyWydzial]);
                     except
                       DMAQFbN(sUNIJEDNOSTKAORG_ID).Clear();
                     end;
                  end;
               end;
               if (ZLEDM.vZLESprawyPrefix <> '') and (Parameters.Values[ZLEDM.vZLESprawyPrefix] <> '') then begin
                  if ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0) then begin
                     try
                       DMAQFbN(sZLEZLECENIE_PREFIX_ID).AsInteger := StrToInt(Parameters.Values[ZLEDM.vZLESprawyPrefix]);
                     except
                       DMAQFbN(sZLEZLECENIE_PREFIX_ID).Clear();
                     end;
                  end;
               end;
            end;

            DMAQFbN(sBOKSPRAWA_ID).AsInteger := oQuery.FieldByName(sBOKSPRAWA_ID).AsInteger;
            DMAQFbN(sZLEZLECENIE_OPIS).AsString := oQuery.FieldByName(sBOKSPRAWA_PROBLEM).AsString;

            if ElementINFDBLookupAliasEdit.Enabled  and PoziomINFPanel.Visible then begin
              DMAQFbN(sZLEZLECENIE_POZIOMINF).AsString := oQuery.FieldByName(sBOKSPRAWA_OBIEKTJAKI).AsString;
              if not oQuery.FieldByName(sBOKSPRAWA_OBIEKTID).IsNull then
                DMAQFbN(sZLEZLECENIE_INF_ID).AsInteger := oQuery.FieldByName(sBOKSPRAWA_OBIEKTID).AsInteger;
            end;
          end;
        end;
      finally
        if oQuery <> nil then FreeAndNil(oQuery);
      end;
  end else begin
    sSQL := ZLEDM.ZLEOdpytajODaneSQL( sZLEZLECENIEPOZ,
                                      sZLEALIAS_ZLECENIEPOZ_SPRAWA_ID,
                                      '(@'+sZLEALIAS_ZLECENIEPOZ_ZLECENIE_ID+'='+DMAQFbN(sZLEZLECENIE_ID).AsString+')and'+
                                      '(@'+sZLEALIAS_ZLECENIEPOZ_SPRAWA_ID+' is not null)',
                                      False );

    sSQL2 := 'SELECT SPR.' + sBOKSPRAWA_ID + ', SPR.' + sBOKSPRAWA_NUMER + ', ' +
                    'SPR.' + sBOKSPRAWA_OBIEKTJAKI + ', SPR.' + sBOKSPRAWA_OBIEKTID + ', ' +
                    'SPR.' + sBOKSPRAWA_PROBLEM + ', SPR.' + sASOASORT_ID + ', ' +
                    'ASO.' + sASOASORT_INDEKS + ', ASO.' + sASOASORT_SYMBOL + ', ' +
                    'ASO.' + sASOASORT_NAZWA + ', ASO.' + sLFKWZORDEKR_ID + ', ' +
                    'WZDE.' + sLFKWZORDEKR_NR_DEKR + ' ' +
             'FROM ' + SQLManager.GetTableName(sBOKSPRAWA) + ' SPR, ' +
                       SQLManager.GetTableName(sASOASORT) + ' ASO, ' +
                       SQLManager.GetTableName(sLFKWZORDEKR) + ' WZDE, ';

    sSQL2 := sSQL2 +
                   '(SELECT IORDERID,IORDERKEY ' +
                    'FROM TABLE(' + SQLManager.GetTableName('TORDER_CONV_LIST') + '(';

    oSplit := TSplit.Create(sSprawy, ',', '');
    for iIdx := 0 to oSplit.Count - 1 do begin
        if iIdx > 0 then sSQL2 := sSQL2 + ', ';
        sSQL2 := sSQL2 + SQLManager.GetTableName('TORDER_CONV') + '(' + IntToStr(iIdx) + ',' + oSplit[iIdx] + ')';
    end;

    sSQL2 := sSQL2 + ' ))) DICT ' +
             'WHERE SPR.' + sASOASORT_ID + ' = ASO.' + sASOASORT_ID + '(+) AND ' +
                   'ASO.' + sLFKWZORDEKR_ID + ' = WZDE.' + sLFKWZORDEKR_ID + '(+) AND ' +
                   'SPR.' + sBOKSPRAWA_ID + ' = DICT.IORDERKEY AND ' +
                   '(SPR.' + sBOKSPRAWA_ID + ' IN (' + sSprawy + ')) AND ' +
                   '(SPR.' + sBOKSPRAWA_ID + ' NOT IN (' + sSQL + ')) ' +
             'ORDER BY DICT.IORDERID';

    oQuery := SQLManager.CreateQuery(sSQL2);
      try

        if (oQuery <> nil) then begin
          bDopisac := True;
          if Parameters.Values[cFunkcjaBOKDopiszZlecenie] <> sTak then
             bDopisac := (Komunikat( cConfirmation, 'Czy dopisa pozycje dla wybranych spraw?', MB_YESNO ) = IDYES);

          if bDopisac then begin
            result := True;
            oQuery.Open;

            iFormIndex := FContainedForms.IndexOf(cFormPozycjeZlecenia);
            if(iFormIndex > -1) then begin
              oZlePozQuery := DataModule.ContainedDataModules[iFormIndex].ActiveQuery as TVirtualDataSet;

              {Tu obsuga podpowiadania danych z nagwka}
              if ZLEDM.vZLESprawyPodpowiadanie then begin
                 if vWielofirmowosc and (Parameters.Values[sUNIODDZIAL_ID] <> '') then begin
                    DMAQFbN(sUNIODDZIAL_ID).AsInteger := StrToInt(Parameters.Values[sUNIODDZIAL_ID]);
                 end;

                 if (ZLEDM.vZLESprawyKontrahent <> '') and (Parameters.Values[ZLEDM.vZLESprawyKontrahent] <> '') then begin
                    if WykonawcaDBLookupAliasEdit.Enabled and WykonawcaPanel.Visible then begin
                       try//Parameters.Values[ZLEDM.vZLESprawyKontrahent];
                          DMAQFbN(sZLEZLECENIE_WYKONAWCA_ID).AsInteger := StrToInt(Parameters.Values[ZLEDM.vZLESprawyKontrahent]);
                       except
                          DMAQFbN(sZLEZLECENIE_WYKONAWCA_ID).Clear();
                       end;
                    end;
                 end;
                 if (ZLEDM.vZLESprawyWydzial <> '') and (Parameters.Values[ZLEDM.vZLESprawyWydzial] <> '') then begin
                    if WydzialDBLookupAliasEdit.Enabled and WydzialPanel.Visible then begin
                       try //Parameters.Values[ZLEDM.vZLESprawyKontrahent];
                         DMAQFbN(sUNIJEDNOSTKAORG_ID).AsInteger := StrToInt(Parameters.Values[ZLEDM.vZLESprawyWydzial]);
                       except
                         DMAQFbN(sUNIJEDNOSTKAORG_ID).Clear();
                       end;
                    end;
                 end;
                 if (ZLEDM.vZLESprawyPrefix <> '') and (Parameters.Values[ZLEDM.vZLESprawyPrefix] <> '') then begin
                    if ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0) then begin
                       try//Parameters.Values[ZLEDM.vZLESprawyKontrahent];
                         DMAQFbN(sZLEZLECENIE_PREFIX_ID).AsInteger := StrToInt(Parameters.Values[ZLEDM.vZLESprawyPrefix]);
                       except
                         DMAQFbN(sZLEZLECENIE_PREFIX_ID).Clear();
                       end;
                    end;
                 end;
              end;


              while not oQuery.Eof do begin
                try
                  oZlePozQuery.VState := vsInternalInsert;
                  oZlePozQuery.Append;
                  oZlePozQuery.FieldByName(sZLEZLECENIEPOZ_ID).AsInteger := UniqueKey[sZLEZLECENIEPOZ];
                  oZlePozQuery.FieldByName(sZLEZLECENIE_ID).AsInteger := DMAQFbN(sZLEZLECENIE_ID).AsInteger;
                  oZlePozQuery.FieldByName(sBOKSPRAWA_ID).AsInteger := oQuery.FieldByName(sBOKSPRAWA_ID).AsInteger;
                  oZlePozQuery.FieldByName(sZLEZLECENIEPOZ_OPIS).AsString := oQuery.FieldByName(sBOKSPRAWA_PROBLEM).AsString;
                  oZlePozQuery.FieldByName(sZLEZLECENIEPOZ_POZIOMINF).AsString := oQuery.FieldByName(sBOKSPRAWA_OBIEKTJAKI).AsString;
                  if not oQuery.FieldByName(sBOKSPRAWA_OBIEKTID).IsNull then
                    oZlePozQuery.FieldByName(sZLEZLECENIEPOZ_INF_ID).AsInteger := oQuery.FieldByName(sBOKSPRAWA_OBIEKTID).AsInteger;
                  if not oQuery.FieldByName(sASOASORT_ID).IsNull then begin
                    oZlePozQuery.FieldByName(sASOASORT_ID).AsInteger := oQuery.FieldByName(sASOASORT_ID).AsInteger;
                    if not oQuery.FieldByName(sLFKWZORDEKR_ID).IsNull then
                       oZlePozQuery.FieldByName(sLFKWZORDEKR_ID).AsInteger := oQuery.FieldByName(sLFKWZORDEKR_ID).AsInteger;
                  end;
                  oZlePozQuery.SetTechnicalFieldsOnInsert();
                  oZlePozQuery.UpdateModifiedRecordFlagsForAddedRecord();
                  oZlePozQuery.FieldByName(sBOKSPRAWA_NUMER).AsString := oQuery.FieldByName(sBOKSPRAWA_NUMER).AsString;
                  oZlePozQuery.FieldByName(sASOASORT_INDEKS).AsString := oQuery.FieldByName(sASOASORT_INDEKS).AsString;
                  oZlePozQuery.FieldByName(sASOASORT_SYMBOL).AsString := oQuery.FieldByName(sASOASORT_SYMBOL).AsString;
                  oZlePozQuery.FieldByName(sASOASORT_NAZWA).AsString := oQuery.FieldByName(sASOASORT_NAZWA).AsString;
                  oZlePozQuery.FieldByName(sLFKWZORDEKR_NR_DEKR).AsString := oQuery.FieldByName(sLFKWZORDEKR_NR_DEKR).AsString;
                  oZlePozQuery.Post;
                finally
                  oZlePozQuery.VState := vsNormal;
                end;
  (*******************POLA UZ***************************
                pNewPozPolaUz;
  *******************POLA UZ***************************)
                oQuery.Next;
              end;
             (DataModule.ContainedDataModules[iFormIndex] as TZLEPozycjeDataModule).RefreshLp();
            end;
          end;
        end;
      finally
        if oQuery <> nil then FreeAndNil(oQuery);
      end;
  end;
end;

procedure TZLEZlecenieDBDetailForm.DataOtwarciaDBDateEditDateChange(
  Sender: TObject);
var
  sSQL, sOpis2: String;
  q: TUniQuery;
  iOkresNewID, iLicznik: Integer;
  iKodID: Integer;

begin
  inherited;
  if (iNumeratorID = 0) or
     (not (OpenMode in [omNew, omEdit])) or
     (ZLEDM.vZLENumeratorExt and bSuffix) or
     (ZLEDM.vZLEBlokadaZmianySymbolu and (OpenMode <> omNew)) or
     (ZLEDM.vZLEBlokadaZmianySymbolu and (OpenMode = omNew) and ZLEDM.vZLEReczneWprowadzanieSymbolu)
  then Exit;

  {Sprawdzamy czy numerator jest miesiczny
   - jesli tak, to zmieniamy Symbol, ale tylko wtedy gdy OpenMode = omNew}
  if (OpenMode = omEdit) and (not bNumMiesieczny) then Exit;
  {Zmiana numeru bez wzgledu na rodzaj numeratora}
  {sSQL:= SQLManager.GetSelectWithInnerJoins(sUNIAUTNUM_RODZAJ, [sUNIAUTNUM], [''], [''],
                                                sUNIAUTNUM_ID+'='+IntToStr(iNumeratorID));

  sRodzaj := SQLManager.OpenQueryWithResult( sSQL ,['']);
  if sRodzaj <> sUNICONST_RODZ_NUMERACJI_MIESIECZNA_ID then Exit;}

  {Tu ju wiadomo, ze jest to numerator miesiczny, teraz porownanie okresw}
  iOkresNewID := 0;
  if not DMAQFbN(sZLEZLECENIE_DATA_OTW).IsNull then begin

     sSQL := 'SELECT ' + sUNIOKRES_ID + ' FROM %s o WHERE ' +
               sUNIOKRES_DATA_POCZ + '<=' + KonwertujDate2SQL(DMAQFbN(sZLEZLECENIE_DATA_OTW).AsDateTime) + ' AND ' +
               sUNIOKRES_DATA_KONCA + '>=' + KonwertujDate2SQL(DMAQFbN(sZLEZLECENIE_DATA_OTW).AsDateTime);

     try
        q := SQLManager.CreateQuery(sSQL, [sUNIOKRES]);
        q.Open;
        if not q.IsEmpty then
          iOkresNewID := q.FieldByName(sUNIOKRES_ID).AsInteger;

          q.Close;
     finally
       if q <> nil then FreeAndNil(q);
     end;
  end;

  {Jeli ten sam okresID to koniec sprawdzania i wyjcie}
  if (iOkresID = iOkresNewID)  then begin
     Exit; {Wyjscie zawsze, bo wczeniej by ju okres wybrany}
     (**********************
     if not (vWieloodzialowosc and (ZLEDM.vZLEWymaganyOddzial) and (not DMAQFbN(sUNIODDZIAL_ID).IsNull) and
             (iOddzialOld <> DMAQFbN(sUNIODDZIAL_ID).AsInteger)) then
             Exit; {Wychodzimy}
     ***********************)
  end;

  {iOkresID <> iOkresNewID}
  {Zwracamy Symbol}
  iKodID := 0;
  if (not DMAQFbN(sZLEZLECENIE_SYMBOL).IsNull) and (OpenMode = omNew) then begin
     iLicznik := DMAQFbN(sZLEZLECENIE_LICZNIK).AsInteger;

     if (ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0)) then begin
        if DMAQFbN(sZLEZLECENIE_PREFIX_ID).IsNull then Exit;
        iKodID := DMAQFbN(sZLEZLECENIE_PREFIX_ID).AsInteger;
     end else
     if (vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial) or
        (ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 1)) then begin
        if DMAQFbN(sUNIODDZIAL_ID).IsNull then Exit;
        iKodID := DMAQFbN(sUNIODDZIAL_ID).AsInteger;
     end;

     if ZLEDM.vZLENumeratorExt and (not ZLEDM.vZLEOsobnaNum) then
        iKodID := 0; //bez podziau na mnemonik

     UNISysDM.UNIZwrocNumer( DMAQFbN(sZLEZLECENIE_SYMBOL).AsString,
                             iNumeratorID, DMAQFbN(sUNIODDZIAL_ID).AsInteger,
                             DMAQFbN(sUNIROK_ID).AsInteger, iOkresID,
                             iKodID, iLicznik);
     DMAQFbN(sZLEZLECENIE_SYMBOL).Clear;
     DMAQFbN(sZLEZLECENIE_LICZNIK).Clear;
  end;

  if (ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0)) then begin
      if DMAQFbN(sZLEZLECENIE_PREFIX_ID).IsNull then begin
        iOkresID := IOkresNewID;
        Exit;
      end;
      iKodID := DMAQFbN(sZLEZLECENIE_PREFIX_ID).AsInteger;
      sOpis2 := PrefixDBLookupAliasEdit.Text;
  end else
  if (vWieloodzialowosc and ZLEDM.vZLEWymaganyOddzial) or
      (ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 1)) then begin
      if DMAQFbN(sUNIODDZIAL_ID).IsNull then begin
         iOkresID := IOkresNewID;
         Exit;
       end;
      iKodID := DMAQFbN(sUNIODDZIAL_ID).AsInteger;
      sOpis2 := OddzialDBLookupAliasEdit.Text;
  end;

  if ZLEDM.vZLENumeratorExt and (not ZLEDM.vZLEOsobnaNum) then
       iKodID := 0
  else sOpis2 := '';

  {W tym przypadku wymagany jest okres_id dla ustalenia symbolu z numeratora}
  DMAQFbN(sZLEZLECENIE_SYMBOL).AsString := UNISysDM.UNIPodajNumerExt( iNumeratorID,
                                                  DMAQFbN(sUNIODDZIAL_ID).AsInteger,
                                                  {vAktywnyRokObrachunkowyID} DMAQFbN(sUNIROK_ID).AsInteger,
                                                  iOkresNewId, iKodID, '', iLicznik, (OpenMode = omEdit), sOpis2);
  DMAQFbN(sZLEZLECENIE_LICZNIK).AsInteger := iLicznik;
  //SymbolDBEdit.Validate();
  {Zmieniamy aktualn warto okresuID}
  iOkresID := IOkresNewID;
end;


procedure TZLEZlecenieDBDetailForm.SelectButtonClick(Sender: TObject);
begin
(*******************POLA UZ***************************
  ZleceniePageControl.ActivePage := ZLEPolaUzTabSheet;
  if not TZLEPoleZmGridForm(ContainedForms[PolaUzFormIndex]).Apply then begin
   //    ZleceniePageControl.ActivePage := ZLEPolaUzTabSheet;
      { Komunikat(CWarning, 'Nie wypenione pola obowizkowe');}
       Abort;
       Exit;
  end;
*******************POLA UZ***************************)

  inherited;
end;

procedure TZLEZlecenieDBDetailForm.ObrazyButtonClick(Sender: TObject);
begin
  UtworzGridObrazow();
  m_oObrazy.ShowModal();
  m_oObrazy.Hide();
end;

procedure TZLEZlecenieDBDetailForm.OddzialDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  inherited;
  { ---- -}
end;

function TZLEZlecenieDBDetailForm.OddzialDBLookupAliasEditGetDataField: String;
begin
  result := sUNIODDZIAL_ID;
end;

function TZLEZlecenieDBDetailForm.OddzialDBLookupAliasEditGetQuery: TUNIQuery;
var
  sWar: String;
begin
  result  := nil;
  if not OpenMode in [omNew,omEdit] then exit;

  iOddzialOld := DMAQFbN(sUNIODDZIAL_ID).AsInteger;
  if not DMAQFbN(sUNIODDZIAL_ID).IsNull then
    sWar:=sUNIODDZIAL_ID+'='+DMAQFbN(sUNIODDZIAL_ID).AsString
  else
    sWar:='';
  Result:=UNISysDM.UNIPokazIObsluzDane( sUNIODDZIAL, '', True, False,
                                        sUNISYSALIAS_Oddzial_ID+';'+
                                        sUNISYSALIAS_Oddzial_Symbol+';'+
                                        sUNISYSALIAS_Oddzial_Nazwa,
                                        vAktywnaFirma, sWar);
end;

procedure TZLEZlecenieDBDetailForm.OddzialDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  inherited;
  if vWieloodzialowosc or vWielofirmowosc then begin
    with OddzialDBLookupAliasEdit do begin
      AliasManager := UNISysDM.AliasManager;
      Alias_ID := sUNISYSALIAS_Oddzial_ID;
      Alias_Name := sUNISYSALIAS_Oddzial_Symbol;
      AdditionalAliases := sUNISYSALIAS_Oddzial_Nazwa;
    end;
  end;
end;

function TZLEZlecenieDBDetailForm.OddzialDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
var
  sOpis2: String;
  iLicznik: Integer;
  iKodID: Integer;

begin
  result := True;
  if AliasSrc <> nil then begin
    OddzialDBLookupAliasEdit.Hint := AliasSrc.FieldByName(sUNIODDZIAL_NAZWA).AsString;
    OddzialNazwaLabel.Caption := AliasSrc.FieldByName(sUNIODDZIAL_NAZWA).AsString;

    if (ZLEDM.vZLENumeratorExt and (bSuffix or (ZLEDM.vZLEPrefixSlownikID = 0))) or
       (ZLEDM.vZLEBlokadaZmianySymbolu and (OpenMode <> omNew)) or
       (ZLEDM.vZLEBlokadaZmianySymbolu and (OpenMode = omNew) and ZLEDM.vZLEReczneWprowadzanieSymbolu)
    then begin
       //Nic nie rb
    end else
    if (OddzialDBLookupAliasEdit.Initialized or ((OpenMode = omNew) and bKopiuj)) and
       (iNumeratorID > 0) and
       ((ZLEDM.vZLEWymaganyOddzial and vWieloodzialowosc) or
        (ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 1))) and
       (OpenMode in [omNew, omEdit]) and
       (iOddzialOld <> DMAQFbN(sUNIODDZIAL_ID).AsInteger) then begin

        {Zwracamy Symbol}
        sOpis2 := '';
  //    {Zmiana numeru z numeratora - inny oddzial}
        if (not DMAQFbN(sZLEZLECENIE_SYMBOL).IsNull) and (OpenMode = omNew) then begin
           iLicznik := DMAQFbN(sZLEZLECENIE_LICZNIK).AsInteger;
           iKodID := iOddzialOld;

           if ZLEDM.vZLENumeratorExt and (not ZLEDM.vZLEOsobnaNum) then
              iKodID := 0;

           UNISysDM.UNIZwrocNumer( DMAQFbN(sZLEZLECENIE_SYMBOL).AsString,
                                   iNumeratorID, iOddzialOld,
                                   {vAktywnyRokObrachunkowyID} DMAQFbN(sUNIROK_ID).AsInteger, iOkresID,
                                   iKodID, iLicznik);
           DMAQFbN(sZLEZLECENIE_SYMBOL).Clear;
           DMAQFbN(sZLEZLECENIE_LICZNIK).Clear;
        end;

        {Pobranie nowego numeru}
        sOpis2 := '';

        {Brak wymaganego oddzialu}
        if DMAQFbN(sUNIODDZIAL_ID).IsNull then Exit;
        iKodID := DMAQFbN(sUNIODDZIAL_ID).AsInteger;
        sOpis2 := OddzialDBLookupAliasEdit.Text;
        if ZLEDM.vZLENumeratorExt and (not ZLEDM.vZLEOsobnaNum) then
             iKodID := 0
        else sOpis2 := '';

        {W tym przypadku wymagany jest okres_id dla ustalenia symbolu z numeratora}
        DMAQFbN(sZLEZLECENIE_SYMBOL).AsString := UNISysDM.UNIPodajNumerExt( iNumeratorID,
                                                        DMAQFbN(sUNIODDZIAL_ID).AsInteger,
                                                        DMAQFbN(sUNIROK_ID).AsInteger,
                                                        iOkresId, iKodID, '', iLicznik,
                                                        (OpenMode = omEdit) {dla omEdit - bez podbijania},
                                                        sOpis2);
        DMAQFbN(sZLEZLECENIE_LICZNIK).AsInteger := iLicznik;
        //SymbolDBEdit.Validate();
    end;
  end;
end;

procedure TZLEZlecenieDBDetailForm.ZapotrzebowaniePierwPokazButtonClick(
  Sender: TObject);
begin
  m_oZapotrzPierwGrid.ViewMenuItemClick(self);
end;

procedure TZLEZlecenieDBDetailForm.ZapotrzebowaniePierwDopiszButtonClick(
  Sender: TObject);
begin
  m_oZapotrzPierwGrid.NewMenuItemClick(self);
end;

procedure TZLEZlecenieDBDetailForm.ZapotrzebowaniePierwUsunButtonClick(
  Sender: TObject);
begin
  m_oZapotrzPierwGrid.DeleteMenuItemClick(self);
end;

procedure TZLEZlecenieDBDetailForm.ZapotrzebowanieWtornePokazButtonClick(
  Sender: TObject);
begin
  m_oZapotrzWtorneGrid.ViewMenuItemClick(self);
end;

procedure TZLEZlecenieDBDetailForm.ZapotrzebowanieWtorneDopiszButtonClick(
  Sender: TObject);
begin
  m_oZapotrzWtorneGrid.NewMenuItemClick(self);
end;

procedure TZLEZlecenieDBDetailForm.ZapotrzebowanieWtorneUsunButtonClick(
  Sender: TObject);
begin
  m_oZapotrzWtorneGrid.DeleteMenuItemClick(self);
end;

procedure TZLEZlecenieDBDetailForm.ZamowieniePokazButtonClick(
  Sender: TObject);
begin
  m_oZamowienieGrid.ViewMenuItemClick(self);
end;

procedure TZLEZlecenieDBDetailForm.ZamowienieDopiszButtonClick(
  Sender: TObject);
begin
  m_oZamowienieGrid.NewMenuItemClick(self);
end;

procedure TZLEZlecenieDBDetailForm.ZamowienieUsunButtonClick(
  Sender: TObject);
begin
  m_oZamowienieGrid.DeleteMenuItemClick(self);
end;

procedure TZLEZlecenieDBDetailForm.AsortymentLookupAliasEditDelKey(
  Sender: TObject);
begin
  DMAQFbN(sASOASORT_ID).Clear();
  AsortymentLookupAliasEdit.Clear();
  RecepturaLookupAliasEditDelKey(self);
  RecepturaLookupAliasEdit.Enabled:= false;
  LRecepturaLabel.Enabled         := false;
end;

procedure TZLEZlecenieDBDetailForm.AsortymentLookupAliasEditButtonClick(
  Sender: TObject);
var
  oQuery:   TUNIQuery;
  sAliasy,
  sWarunek: string;
begin
  if not DataManagers.Available(sASOModulID) then Exit;

  UNIDajAliasyZLookupa(AsortymentLookupAliasEdit, sAliasy, sWarunek);
  oQuery  := ASODM.PokazIObsluzAsortyment(
    sAliasy, sWarunek, false, false,
    DMAQFbN(sASOASORT_ID).AsString
  );
  if(oQuery <> nil) then begin
    AsortymentLookupAliasEditSetData(oQuery);
    oQuery.Free();
  end;  // if(oQuery <> nil)
end;

function TZLEZlecenieDBDetailForm.AsortymentLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if(DMAQFbN(sASOASORT_ID).AsInteger <> AliasSrc.Fields[0].AsInteger) then
    UstawAsortymentReceptury(AliasSrc.Fields[0].AsInteger);

  DMAQFbN(sASOASORT_ID).AsInteger := AliasSrc.Fields[0].AsInteger;
  AsortymentLookupAliasEdit.Text  := AliasSrc.Fields[1].AsString;
  result  := true;
end;

procedure TZLEZlecenieDBDetailForm.RecepturaLookupAliasEditButtonClick(
  Sender: TObject);
var
  oQuery:   TUNIQuery;
  sAliasy,
  sWarunek: string;
begin
  UNIDajAliasyZLookupa(RecepturaLookupAliasEdit, sAliasy, sWarunek);
  oQuery  := LWPDM.LWPPokazIObsluzDane(sLWPRECEPTURA,
    sAliasy, sWarunek, false, true, false,
    DMAQFbN(sLWPRECEPTURA_ID).AsString
  );
  if(oQuery <> nil) then begin
    RecepturaLookupAliasEditSetData(oQuery);
    oQuery.Free();
  end;  // if(oQuery <> nil)
end;

procedure TZLEZlecenieDBDetailForm.RecepturaLookupAliasEditDelKey(
  Sender: TObject);
begin
  DMAQFbN(sLWPRECEPTURA_ID).Clear();
  RecepturaLookupAliasEdit.Clear();
end;

function TZLEZlecenieDBDetailForm.RecepturaLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  DMAQFbN(sLWPRECEPTURA_ID).AsInteger := AliasSrc.Fields[0].AsInteger;
  ShowReceptura(AliasSrc);
  SkopiujPowiazaniaReceptury(false);
  result  := true;
end;

procedure TZLEZlecenieDBDetailForm.MatPokazButtonClick(Sender: TObject);
begin
  m_oMaterialGrid.ViewMenuItemClick(self);
end;

procedure TZLEZlecenieDBDetailForm.MatDopiszButtonClick(Sender: TObject);
begin
  m_oMaterialGrid.NewMenuItemClick(self);
end;

procedure TZLEZlecenieDBDetailForm.MatZmienButtonClick(Sender: TObject);
begin
  m_oMaterialGrid.EditMenuItemClick(self);
end;

procedure TZLEZlecenieDBDetailForm.MatUsunButtonClick(Sender: TObject);
begin
  m_oMaterialGrid.DeleteMenuItemClick(self);
end;

procedure TZLEZlecenieDBDetailForm.MatKopiujButtonClick(Sender: TObject);
begin
  if(DMAQFbN(sLWPRECEPTURA_ID).IsNull) then
    Komunikat(cWarning, 'Nie wybrano receptury', MB_OK)
  else if(DMAQFbN(sZLEZLECENIE_ILOSC).IsNull) then
    Komunikat(cWarning, 'Nie podano iloci zlecenia', MB_OK)
  else begin
    (m_oMaterialGrid as TZLEZlecenieMaterialDBGridForm).KopiujMaterialyZReceptury(
      DMAQFbN(sZLEZLECENIE_ID).AsInteger,
      DMAQFbN(sLWPRECEPTURA_ID).AsInteger,
      DMAQFbN(sZLEZLECENIE_ILOSC).AsFloat,
      true
    );
  end;
end;

procedure TZLEZlecenieDBDetailForm.MatZamiennikButtonClick(
  Sender: TObject);
begin
  (m_oMaterialGrid as TZLEZlecenieMaterialDBGridForm).WybierzZamiennik();
end;

procedure TZLEZlecenieDBDetailForm.MatOryginalButtonClick(Sender: TObject);
begin
  (m_oMaterialGrid as TZLEZlecenieMaterialDBGridForm).PrzywrocMaterialZReceptury();
end;

procedure TZLEZlecenieDBDetailForm.ZapytaniePokazButtonClick(
  Sender: TObject);
begin
  m_oZapytanieGrid.ViewMenuItemClick(self);
end;

procedure TZLEZlecenieDBDetailForm.ZapytanieDopiszButtonClick(
  Sender: TObject);
begin
  m_oZapytanieGrid.NewMenuItemClick(self);
end;

procedure TZLEZlecenieDBDetailForm.ZapytanieUsunButtonClick(
  Sender: TObject);
begin
  m_oZapytanieGrid.DeleteMenuItemClick(self);
end;

function TZLEZlecenieDBDetailForm.PrefixDBLookupAliasEditGetDataField: String;
begin
  result := sZLEZLECENIE_PREFIX_ID;
end;

function TZLEZlecenieDBDetailForm.PrefixDBLookupAliasEditGetQuery: TUNIQuery;
var
  sWar: String;
begin
  result  := nil;
  if not (OpenMode in [omNew,omEdit]) then exit;
  if not (ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0)) then Exit;

  iPrefixOld := DMAQFbN(sZLEZLECENIE_PREFIX_ID).AsInteger;
  if not DMAQFbN(sZLEZLECENIE_PREFIX_ID).IsNull then
    sWar:='@' + sZLEAlias_PrefixID + '=' + DMAQFbN(sZLEZLECENIE_PREFIX_ID).AsString
  else
    sWar:='';
  Result:=ZLEDM.ZLEPokazIObsluzDane( sZLEPREFIX, sZLEAlias_PrefixID+';'+
                                        sZLEAlias_PrefixSymbol+';'+
                                        sZLEAlias_PrefixNazwa,
                                        '', False, False,
                                        cZLEModulZSI_ID, 0, vAktywnaFirma,
                                        '' {sZLEAlias_PrefixID+';'+
                                        sZLEAlias_PrefixSymbol+';'+
                                        sZLEAlias_PrefixNazwa});

end;

procedure TZLEZlecenieDBDetailForm.PrefixDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  if ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0) then begin
    with PrefixDBLookupAliasEdit do begin
      AliasManager := ZLEDM.AliasManager;
      Alias_ID := sZLEAlias_PrefixID;
      Alias_Name := sZLEAlias_PrefixSymbol;
      AdditionalAliases := sZLEAlias_PrefixNazwa;
    end;
  end;
end;

function TZLEZlecenieDBDetailForm.PrefixDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
var
  sOpis2: String;
  iLicznik: Integer;
  iKodID: Integer;

begin
  if AliasSrc <> nil then begin
    if (ZLEDM.vZLENumeratorExt and (bSuffix or (ZLEDM.vZLEPrefixSlownikID = 1))) or
       (ZLEDM.vZLEBlokadaZmianySymbolu and (OpenMode <> omNew)) or
       (ZLEDM.vZLEBlokadaZmianySymbolu and (OpenMode = omNew) and ZLEDM.vZLEReczneWprowadzanieSymbolu)
    then begin
       //Nic nie rb
    end else
    if PrefixDBLookupAliasEdit.Initialized and
       (iNumeratorID > 0) and
       //(bNumKod or bNumOpis2) and {Numerator zawiera [K] lub [OD]}
       (ZLEDM.vZLENumeratorExt and (ZLEDM.vZLEPrefixSlownikID = 0)) and
       (OpenMode in [omNew, omEdit]) and
       (iPrefixOld <> DMAQFbN(sZLEZLECENIE_PREFIX_ID).AsInteger) then begin

        {Zwracamy Symbol}
  //    {Zmiana numeru z numeratora - inny oddzial}
        if (not DMAQFbN(sZLEZLECENIE_SYMBOL).IsNull) and (OpenMode = omNew) then begin
           iLicznik := DMAQFbN(sZLEZLECENIE_LICZNIK).AsInteger;
           iKodID := iPrefixOld;
           if ZLEDM.vZLENumeratorExt and (not ZLEDM.vZLEOsobnaNum) then
              iKodID := 0;

           UNISysDM.UNIZwrocNumer( DMAQFbN(sZLEZLECENIE_SYMBOL).AsString,
                                   iNumeratorID, DMAQFbN(sUNIODDZIAL_ID).AsInteger {iOddzialOld},
                                   DMAQFbN(sUNIROK_ID).AsInteger, iOkresID,
                                   iKodID, iLicznik);
           DMAQFbN(sZLEZLECENIE_SYMBOL).Clear;
           DMAQFbN(sZLEZLECENIE_LICZNIK).Clear;
        end;

        {Pobranie nowego numeru}
        sOpis2 := '';

        {Brak wymaganego prefixu}
        if DMAQFbN(sZLEZLECENIE_PREFIX_ID).IsNull or (iOkresId < 0) then begin
           Result := True;
           Exit;
        end;
        iKodID := DMAQFbN(sZLEZLECENIE_PREFIX_ID).AsInteger;
        sOpis2 := PrefixDBLookupAliasEdit.Text;

        if ZLEDM.vZLENumeratorExt and (not ZLEDM.vZLEOsobnaNum) then
             iKodID := 0
        else sOpis2 := '';

        {W tym przypadku wymagany jest okres_id dla ustalenia symbolu z numeratora}
        DMAQFbN(sZLEZLECENIE_SYMBOL).AsString := UNISysDM.UNIPodajNumerExt( iNumeratorID,
                                                        DMAQFbN(sUNIODDZIAL_ID).AsInteger,
                                                        DMAQFbN(sUNIROK_ID).AsInteger,
                                                        iOkresId, iKodID, '', iLicznik,
                                                        (OpenMode = omEdit) {dla omEdit - bez podbijania},
                                                        sOpis2);
        DMAQFbN(sZLEZLECENIE_LICZNIK).AsInteger := iLicznik;
        //SymbolDBEdit.Validate();
    end;
  end;
  result := True;
end;

procedure TZLEZlecenieDBDetailForm.GeneratorButtonClick(Sender: TObject);
begin
  //Pokazanie generatora wydrukw
  UniDesigner.ShowDesignerForForm(SQLManager.GetDataBaseName,
                                    SQLManager.GetTableName(sUNIREP),
                                    SQLManager.GetTableName(sUNIREPUSERRIGHTS),
                                    'TZLEZlecenieDBDetailForm',
                                    DataManagers[sZLEModulID].ModulZSI_ID,
                                    sZLEModulID,
                                    SecurityManager.UserId);
end;

procedure TZLEZlecenieDBDetailForm.DrukujButtonClick(Sender: TObject);
begin
  DataModule.ListQuery.DisableControls;
  try
    UniDesigner.ShowPreviewForForm(SQLManager.GetDataBaseName,
                                   SQLManager.GetTableName(sUNIREP),
                                   SQLManager.GetTableName(sUNIREPUSERRIGHTS),
                                   'TZLEZlecenieDBDetailForm',
                                   False,
                                   SecurityManager.UserId,
                                   DataManagers[sZLEModulID].ModulZSI_ID);
  finally
    DataModule.ListQuery.EnableControls;
  end;
end;

(***
procedure TZLEPozycjeDBDetailForm.ElementINFDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
var
  sPoziom: String;
begin
  with ElementINFDBLookupAliasEdit do begin
    if DataManagers.Available(sINFModulID)and
       (DataModule <> nil) then begin
      AliasManager := INFDM.AliasManager;
      sPoziom := DMAQFbN(sZLEZLECENIEPOZ_POZIOMINF).AsString;
      if sPoziom = sINFCONST_OBIEKT_LOKAL then begin
        Alias_ID := sINFAlias_Lokal_ID;
        Alias_Name := sINFAlias_Lokal_Symbol;
        AdditionalAliases := sINFAlias_LokalOpis_Opis;
      end else if sPoziom = sINFCONST_OBIEKT_ZASOB then begin
        Alias_ID := sINFAlias_Zasob_ID;
        Alias_Name := sINFAlias_Zasob_Symbol;
        AdditionalAliases := sINFAlias_Zasob_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_KLATKA then begin
        Alias_ID := sINFAlias_Klatka_ID;
        Alias_Name := sINFAlias_Klatka_Symbol;
        AdditionalAliases := sINFAlias_Klatka_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_BRAMA then begin
        Alias_ID := sINFAlias_Brama_ID;
        Alias_Name := sINFAlias_Brama_Symbol;
        AdditionalAliases := sINFAlias_Brama_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_BUDYNEK then begin
        Alias_ID := sINFAlias_Budynek_ID;
        Alias_Name := sINFAlias_Budynek_Symbol;
        AdditionalAliases := sINFAlias_Budynek_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_NIERUCHOMOSC then begin
        Alias_ID := sINFAlias_Nieruchomosc_ID;
        Alias_Name := sINFAlias_Nieruchomosc_Symbol;
        AdditionalAliases := sINFAlias_Nieruchomosc_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_WSPOLNOTA then begin
        Alias_ID := sINFAlias_Wspolnota_ID;
        Alias_Name := sINFAlias_Wspolnota_Symbol;
        AdditionalAliases := sINFAlias_Wspolnota_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_REJON then begin
        Alias_ID := sINFAlias_Rejon_ID;
        Alias_Name := sINFAlias_Rejon_Symbol;
        AdditionalAliases := sINFAlias_Rejon_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_ULICA then begin
        Alias_ID := sINFAlias_Ulica_ID;
        Alias_Name := sINFAlias_Ulica_Symbol;
        AdditionalAliases := sINFAlias_Ulica_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_ELEMENTSIECI then begin
        Alias_ID := sINFAlias_SiecElement_ID;
        Alias_Name := sINFAlias_SiecElement_Symbol;
        AdditionalAliases := sINFAlias_SiecElement_Opis;
      end else if sPoziom = sINFCONST_OBIEKT_SKLADNIKELSIECI then begin
        Alias_ID := sINFAlias_Skladnik_ID;
        Alias_Name := sINFAlias_Skladnik_Symbol;
        //AdditionalAliases := sINFAlias_SiecSkladnik_Opis;
      end else if sPoziom = sINFCONST_OBIEKT_POZIOM then begin
        Alias_ID := sINFAlias_Poziom_ID;
        Alias_Name := sINFAlias_Poziom_Nazwa;
      end else begin
        AliasManager := nil;
      end;
    end else
      AliasManager := nil;
  end;
end;

function TZLEPozycjeDBDetailForm.ElementINFDBLookupAliasEditGetDataField: String;
begin
  result := sZLEZLECENIEPOZ_INF_ID;
end;

function TZLEPozycjeDBDetailForm.ElementINFDBLookupAliasEditGetQuery: TUNIQuery;
var
  iPoziomID: Integer;
  sPoziom: String;
  sObiekt, sObiektTmp: String;
  iZleTypZlec_ID: Integer;
begin
  sObiektTmp := '';
  if (OpenMode = omNew) and (DMAQFbN(sZLEZLECENIEPOZ_POZIOMINF).AsString = '') and (Owner.Owner is TZLEZlecenieDBDetailForm) then begin
     iZleTypZlec_ID := TZLEZlecenieDBDetailForm(Owner.Owner).DMAQFBN(sZLETYPZLEC_ID).AsInteger;
     {Pobrac Dla zletypzlec_id domyslny poziom inf dla OmNew}
     if iZleTypZlec_ID > 0 then
        sObiektTmp := SQLManager.GetField(sZLETYPZLEC, sZLETYPZLEC_POZIOMINF, IntToStr(iZleTypZlec_ID));
  end;

  sObiekt := DMAQFbN(sZLEZLECENIEPOZ_POZIOMINF).AsString;
  if (sObiekt = '') and (sObiektTmp <> '') then sObiekt := sObiektTmp;

  iPoziomID := 0;
  sPoziom := '';
  result := INFDM.INFPokazIObsluzObiekt( sObiekt, iPoziomID, sPoziom, False, nil );
  if (OpenMode in [omNew,omEdit])and
     (result <> nil)and
     (sObiekt <> DMAQFbN(sZLEZLECENIEPOZ_POZIOMINF).AsString) then
    DMAQFbN(sZLEZLECENIEPOZ_POZIOMINF).AsString := sObiekt;
end;

function TZLEPozycjeDBDetailForm.ElementINFDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
    if AliasSrc.Fields.Count > 2 then
      ElementINFNazwaLabel.Caption := AliasSrc.Fields[2].AsString;
  end;
  result := True;
end;

***)
procedure TZLEZlecenieDBDetailForm.FieldChange(Sender: TField);
var
  iIndex: Integer;
begin
  iIndex := cslINFRodzajObiektu.IndexOfSkrot( Sender.AsString );
  if iIndex <> -1 then
    PoziomNazwaLabel.Caption := cslINFRodzajObiektu[iIndex];

  sPoziomAkt := DMAQFbN(sZLEZLECENIE_POZIOMINF).AsString;
  iInfID := DMAQFbN(sZLEZLECENIE_INF_ID).AsInteger;
end;


function TZLEZlecenieDBDetailForm.ElementINFDBLookupAliasEditGetDataField: string;
begin
  result := sZLEZLECENIE_INF_ID;
end;

function TZLEZlecenieDBDetailForm.ElementINFDBLookupAliasEditGetQuery: TUNIQuery;
var
  iPoziomID: Integer;
  sPoziom: String;
  sObiekt, sObiektTmp: String;
  iZleTypZlec_ID: Integer;
begin
  sObiektTmp := '';
  if (OpenMode = omNew) and (DMAQFbN(sZLEZLECENIE_POZIOMINF).AsString = '') then begin
     iZleTypZlec_ID := DMAQFBN(sZLETYPZLEC_ID).AsInteger;
     {Pobrac Dla zletypzlec_id domyslny poziom inf dla OmNew}
     if iZleTypZlec_ID > 0 then
        sObiektTmp := SQLManager.GetField(sZLETYPZLEC, sZLETYPZLEC_ZLEC_POZINF, IntToStr(iZleTypZlec_ID));
  end;

  sObiekt := DMAQFbN(sZLEZLECENIE_POZIOMINF).AsString;
  if (sObiekt = '') and (sObiektTmp <> '') then sObiekt := sObiektTmp;

  iPoziomID := 0;
  sPoziom := '';
  result := INFDM.INFPokazIObsluzObiekt(sObiekt, iPoziomID, sPoziom, False, nil);
  if (OpenMode in [omNew,omEdit])and
     (result <> nil)and
     (sObiekt <> DMAQFbN(sZLEZLECENIE_POZIOMINF).AsString) then
    DMAQFbN(sZLEZLECENIE_POZIOMINF).AsString := sObiekt;
end;

procedure TZLEZlecenieDBDetailForm.ElementINFDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
var
  sPoziom: String;
begin
  with ElementINFDBLookupAliasEdit do begin
    if DataManagers.Available(sINFModulID)and
       (DataModule <> nil) then begin
      AliasManager := INFDM.AliasManager;
      sPoziom := DMAQFbN(sZLEZLECENIE_POZIOMINF).AsString;
      if sPoziom = sINFCONST_OBIEKT_LOKAL then begin
        Alias_ID := sINFAlias_Lokal_ID;
        Alias_Name := sINFAlias_Lokal_Symbol;
        AdditionalAliases := sINFAlias_LokalOpis_Opis;
      end else if sPoziom = sINFCONST_OBIEKT_ZASOB then begin
        Alias_ID := sINFAlias_Zasob_ID;
        Alias_Name := sINFAlias_Zasob_Symbol;
        AdditionalAliases := sINFAlias_Zasob_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_KLATKA then begin
        Alias_ID := sINFAlias_Klatka_ID;
        Alias_Name := sINFAlias_Klatka_Symbol;
        AdditionalAliases := sINFAlias_Klatka_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_BRAMA then begin
        Alias_ID := sINFAlias_Brama_ID;
        Alias_Name := sINFAlias_Brama_Symbol;
        AdditionalAliases := sINFAlias_Brama_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_BUDYNEK then begin
        Alias_ID := sINFAlias_Budynek_ID;
        Alias_Name := sINFAlias_Budynek_Symbol;
        AdditionalAliases := sINFAlias_Budynek_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_NIERUCHOMOSC then begin
        Alias_ID := sINFAlias_Nieruchomosc_ID;
        Alias_Name := sINFAlias_Nieruchomosc_Symbol;
        AdditionalAliases := sINFAlias_Nieruchomosc_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_WSPOLNOTA then begin
        Alias_ID := sINFAlias_Wspolnota_ID;
        Alias_Name := sINFAlias_Wspolnota_Symbol;
        AdditionalAliases := sINFAlias_Wspolnota_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_REJON then begin
        Alias_ID := sINFAlias_Rejon_ID;
        Alias_Name := sINFAlias_Rejon_Symbol;
        AdditionalAliases := sINFAlias_Rejon_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_ULICA then begin
        Alias_ID := sINFAlias_Ulica_ID;
        Alias_Name := sINFAlias_Ulica_Symbol;
        AdditionalAliases := sINFAlias_Ulica_Nazwa;
      end else if sPoziom = sINFCONST_OBIEKT_ELEMENTSIECI then begin
        Alias_ID := sINFAlias_SiecElement_ID;
        Alias_Name := sINFAlias_SiecElement_Symbol;
        AdditionalAliases := sINFAlias_SiecElement_Opis;
      end else if sPoziom = sINFCONST_OBIEKT_SKLADNIKELSIECI then begin
        Alias_ID := sINFAlias_Skladnik_ID;
        Alias_Name := sINFAlias_Skladnik_Symbol;
        //AdditionalAliases := sINFAlias_SiecSkladnik_Opis;
      end else if sPoziom = sINFCONST_OBIEKT_POZIOM then begin
        Alias_ID := sINFAlias_Poziom_ID;
        Alias_Name := sINFAlias_Poziom_Nazwa;
      end else begin
        AliasManager := nil;
      end;
    end else
      AliasManager := nil;
  end;
end;

function TZLEZlecenieDBDetailForm.ElementINFDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
    if AliasSrc.Fields.Count > 2 then
      ElementINFNazwaLabel.Caption := AliasSrc.Fields[2].AsString;

      if OpenMode in [omNew, omEdit] then begin
         if DataModule.ActiveQuery.FindField(AliasSrc.Fields[0].FieldName) <> nil then begin
            {Czyszczenie wszystkich pl zwizanych z infrastruktur}
            if ElementINFDBLookupAliasEdit.Initialized then begin
              if DataModule.ActiveQuery.FindField(sINFLOKAL_ID) <> nil then
                 DMAQFbN(sINFLOKAL_ID).Clear();
              if DataModule.ActiveQuery.FindField(sINFZASOB_ID) <> nil then
                 DMAQFbN(sINFZASOB_ID).Clear();
              if DataModule.ActiveQuery.FindField(sINFKLATKA_ID) <> nil then
                 DMAQFbN(sINFKLATKA_ID).Clear();
              if DataModule.ActiveQuery.FindField(sINFBRAMA_ID) <> nil then
                 DMAQFbN(sINFBRAMA_ID).Clear();
              if DataModule.ActiveQuery.FindField(sINFBUDYNEK_ID) <> nil then
                 DMAQFbN(sINFBUDYNEK_ID).Clear();
              if DataModule.ActiveQuery.FindField(sINFNIERUCHOMOSC_ID) <> nil then
                 DMAQFbN(sINFNIERUCHOMOSC_ID).Clear();
              if DataModule.ActiveQuery.FindField(sINFREJON_ID) <> nil then
                 DMAQFbN(sINFREJON_ID).Clear();
              if DataModule.ActiveQuery.FindField(sINFULICA_ID) <> nil then
                 DMAQFbN(sINFULICA_ID).Clear();
              if DataModule.ActiveQuery.FindField(sINFSIECELEMENT_ID) <> nil then
                 DMAQFbN(sINFSIECELEMENT_ID).Clear();
              if DataModule.ActiveQuery.FindField(sINFSIECSKLADNIK_ID) <> nil then
                 DMAQFbN(sINFSIECSKLADNIK_ID).Clear();

              //A teraz wypeniamy aktualne pole -- czy to nie powinno by poza end?
              DMAQFbN(AliasSrc.Fields[0].FieldName).AsInteger := AliasSrc.Fields[0].AsInteger;
            end;

         end;
      end;
  end;
  result := True;
end;

procedure TZLEZlecenieDBDetailForm.btnUzytkownicyZaangazowaniButtonClick(
  Sender: TObject);
var
  AOpenMode: TOpenMode;
  f: TUNIForm;
begin
  //btnUzytkownicyZaangazowaniButton.SetFocus;
  inherited;
  if OpenMode in [omNew,omEdit] then
    AOpenMode := {OpenMode} omEdit or omHidden or omOverVirtual
  else
    AOpenMode := omView or omReadOnly or omHidden or omVirtual; { omShowModal or omVirtual;}
  f := FormManager.OpenDBDetail( Self, 'TZLEZaangazowaniDBDetailForm', AOpenMode );
  if f <> nil then begin
     if f.ShowModal = mrOK then begin
        if OpenMode in [omNew,omEdit] then begin
           DataModule.ActiveQuery.Edit;  //Czy to jest potrzebne?
           if not DMAQFbN(sZLEZLECENIE_OSOBA_ODP).IsNull then
              OsobaOdpowiedzialnaDBLookupAliasEdit.InitiateData(DMAQFbN(sZLEZLECENIE_OSOBA_ODP).AsInteger);

           if not DMAQFbN(sZLEZLECENIE_STATUS_OSOBA).IsNull then
              OsobaPotwierdzajacaDBLookupAliasEdit.InitiateData(DMAQFbN(sZLEZLECENIE_STATUS_OSOBA).AsInteger);

           OsobaOdpowiedzialnaDBLookupAliasEdit.aReadOnly := not DMAQFbN(sZLEZLECENIE_OPER_ODP).IsNull;

           //OsobaPotwierdzajacaDBLookupAliasEdit.Enabled := (ZLEDM.vZLEKontrolaUprawnionych or (DMAQFbN(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_ZakonczoneID)) and DMAQFbN(sZLEZLECENIE_OPER_POTW_REAL).IsNull;

           if not DMAQFbN(sZLEZLECENIE_OPER_POTW_REAL).IsNull then
              OsobaPotwierdzajacaDBLookupAliasEdit.aReadOnly := True
           else OsobaPotwierdzajacaDBLookupAliasEdit.aReadOnly := not ( (not DMAQFbN(sZLEZLECENIE_STATUS_OSOBA).IsNull) or
                                                                        ZLEDM.vZLEKontrolaUprawnionych or
                                                                        (DMAQFbN(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_ZakonczoneID));

           OsobaPotwierdzajacaDBLookupAliasEdit.aAllowEmpty :=
               (not (ZLEDM.vZLEWymaganaOsobaZamykajacaZlecenie and (DMAQFbN(sZLEZLECENIE_STATUS).AsString = cZLEStatusZlecenia_ZakonczoneID)));
        end;
     end;
     if f <> nil then FreeAndNil(f);
  end;
end;

procedure TZLEZlecenieDBDetailForm.PojazdDBLookupAliasEditDelKey(
  Sender: TObject);
begin
  with PojazdDBLookupAliasEdit do begin
    Clear;
    if OpenMode in [omNew, omEdit] then
       DMAQFbN(DataField).Clear;
    PojazdNazwaLabel.Caption := '';
  end;
end;

function TZLEZlecenieDBDetailForm.PojazdDBLookupAliasEditGetDataField: String;
begin
  result := sUNIPOJSP_ID;
end;

function TZLEZlecenieDBDetailForm.PojazdDBLookupAliasEditGetQuery: TUNIQuery;
var
  oSelId:TStringList;
begin
  oSelId := nil;
  if not DMAQFbN(sUNIPOJSP_ID).IsNull then begin
     oSelId := TStringList.Create();
     oSelId.Add(DMAQFbN(sUNIPOJSP_ID).AsString);
  end;
  result := UNISYSDM.UNIPokazIObsluzDane( sUNIPOJSP,
                                       '',
                                       False,
                                       False,
                                       sUNISysAlias_PojSp_ID+';'+
                                       sUNISysAlias_PojSp_Symbol+';'+
                                       sUNISysAlias_PojSp_Nazwa,
                                       vAktywnaFirma,
                                       ''{DMAQFbN(sUNIPOJSP_ID).AsString}, //WarunekPoz
                                       oSelId
                                       );
end;

procedure TZLEZlecenieDBDetailForm.PojazdDBLookupAliasEditInitAliasInfo(
  Sender: TObject);
begin
  inherited;
  with PojazdDBLookupAliasEdit do begin
    AliasManager := UNISYSDM.AliasManager;
    Alias_ID     := sUNISysAlias_PojSp_ID;
    Alias_Name   := sUNISysAlias_PojSp_Symbol;
    AdditionalAliases := sUNISysAlias_PojSp_Nazwa;
  end;
end;

function TZLEZlecenieDBDetailForm.PojazdDBLookupAliasEditSetData(
  AliasSrc: TDataSet): Boolean;
begin
  if AliasSrc <> nil then begin
    PojazdNazwaLabel.Caption := AliasSrc.FieldByName(sUNIPOJSP_Nazwa).AsString;
  end;
  result := True;
  inherited;
end;

initialization
  FormManager.RegisterForm( TZLEZlecenieDBDetailForm, 'Zlecenie', sZLEModulID );

end.
